/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 98;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 69,
  Feature_HasRCPC_IMMOBit = 89,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 68,
  Feature_HasSHA3Bit = 67,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 32,
  Feature_HasLSEBit = 33,
  Feature_HasNoLSEBit = 97,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 86,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 81,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 46,
  Feature_HasSVEAESBit = 29,
  Feature_HasSVE2SM4Bit = 30,
  Feature_HasSVE2SHA3Bit = 96,
  Feature_HasSVEBitPermBit = 40,
  Feature_HasSMEandIsNonStreamingSafeBit = 59,
  Feature_HasSMEBit = 52,
  Feature_HasSMEF64F64Bit = 54,
  Feature_HasSMEF16F16Bit = 62,
  Feature_HasSMEI16I64Bit = 57,
  Feature_HasSME2andIsNonStreamingSafeBit = 64,
  Feature_HasSME2Bit = 61,
  Feature_HasSME2p1Bit = 66,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 49,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 44,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 50,
  Feature_HasLUTBit = 51,
  Feature_HasSME_LUTv2Bit = 65,
  Feature_HasSMEF8F16Bit = 55,
  Feature_HasSMEF8F32Bit = 53,
  Feature_HasSME_MOP4Bit = 58,
  Feature_HasSME_TMOPBit = 63,
  Feature_HasCMPBRBit = 87,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 34,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 41,
  Feature_HasSVE2_or_SMEBit = 36,
  Feature_HasSVE2_or_SME2Bit = 48,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 28,
  Feature_HasSVE2p1_or_SMEBit = 60,
  Feature_HasSVE2p1_or_SME2Bit = 31,
  Feature_HasSVE2p1_or_SME2p1Bit = 47,
  Feature_HasSVE2p2_or_SME2p2Bit = 35,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 56,
  Feature_HasNonStreamingSVE2p2_or_SME2p2Bit = 42,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 39,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 43,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 77,
  Feature_HasRCPCBit = 88,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 95,
  Feature_HasMatMulFP64Bit = 45,
  Feature_HasLS64Bit = 84,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 85,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 75,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 38,
  Feature_UseAlternateSExtLoadCVTF32Bit = 79,
  Feature_UseScalarIncVLBit = 37,
  Feature_NoUseScalarIncVLBit = 92,
  Feature_HasFastIncVLBit = 93,
  Feature_UseSVEFPLD1RBit = 91,
  Feature_UseLDAPURBit = 90,
  Feature_AllowMisalignedMemAccessesBit = 94,
  Feature_NotForCodeSizeBit = 78,
  Feature_UseSTRQroBit = 76,
  Feature_TailCallX16X17Bit = 71,
  Feature_TailCallX17Bit = 82,
  Feature_TailCallNotX16Bit = 83,
  Feature_TailCallAnyBit = 70,
  Feature_SLSBLRMitigationBit = 74,
  Feature_NoSLSBLRMitigationBit = 73,
  Feature_OptimizedGISelOrOtherSelectorBit = 72,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2p2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE2p2_or_SME2p2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasFailedISel() || !MF->getProperties().hasLegalized())
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE2p2_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE2p2_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_MO_Predicate_top16Zero = GICXXPred_Invalid + 1,
  GICXXPred_MO_Predicate_top32Zero,
  GICXXPred_MO_Predicate_topbitsallzero32,
  GICXXPred_MO_Predicate_topbitsallzero64,
};
bool AArch64InstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  switch (PredicateID) {
  case GICXXPred_MO_Predicate_top16Zero: {
    
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 16)); 
  }
  case GICXXPred_MO_Predicate_top32Zero: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 32)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero32: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 31)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero64: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 63)); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 154*/ GIMT_Encode4(440587),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(37017),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(51869),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(54634),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(54716), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(54798),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(62544),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(87659), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(98627), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(106151), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(116233),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(116724),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(117215),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(117483),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(117633),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(118124), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(118157),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(127095),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(128145), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(131194), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(144720),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(146071),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(147063),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(148055),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(149547), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(151039),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(152031),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(153023),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(154015),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(155007),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(155999),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(156991), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(157696),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(158401),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(159106),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(159811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(160516), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(160567),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(265754), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(277270),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(277560),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(278997),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(279117), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(279358),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(281256),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(282910),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(285689),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(286514),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(287058), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(287883),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(288013), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(288555), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(296332), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(297377),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(297861),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(298345),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(298817),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(301193),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(301665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(303055),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(304853),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(305591),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(309687), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(325960), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(326576),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(330083),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(330331),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(330519),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(331496),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(332473),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(337101),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(341107),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(341427),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(341747), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(342604),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(342886),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(343264),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(343642),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(343992),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(344342),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(345045), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(345748),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(346152),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(346556),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(346960),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(347364),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(348179),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(348345),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(348444), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(348460),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(353832),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(386754), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(389672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(391992), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(392144), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(392818),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(392978),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(393292),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(393446), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(393937),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(394237),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(394728),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(395219), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(395710),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(396836),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(397452),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(401174), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(401790),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(417397), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(417697),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(417711),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(417732), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(417757), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(418067),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(418238),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(418409),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(418580),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(418751), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(419880),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(420083),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(420286),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(420489), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(420692), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(420832),
     /*   3290 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(421820),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(423803),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(424058),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(424313),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(424459),
     /*   3310 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(424638),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(426288),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(426847),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(427939),
     /*   3326 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(429031),
     /*   3330 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(429185),
     /*   3334 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(429361),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(429635),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(429841),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(430240),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(430610),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(430727),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(431960),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(432740),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(433520),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(433726),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(434593),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(434963),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(435080),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(436313),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(437093),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(437873),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(438571),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(439027),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(439807),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(37016),
     /*   3421 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(12228),
     /*   3437 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15836),
     /*   3441 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21738),
     /*   3445 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(25236),
     /*   3449 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(31414),
     /*   3453 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(32264),
     /*   3457 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35842), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(36566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36938), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36964), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36990),
     /*   3509 */ // Label 155: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3553), // Rule ID 13293 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13293,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 170: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3705), // Rule ID 13730 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13730,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 171: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3857), // Rule ID 15584 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15584,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 172: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4009), // Rule ID 15596 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15596,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 173: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4161), // Rule ID 15608 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15608,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 174: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 175: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4346), // Rule ID 2652 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2652,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 176: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4498), // Rule ID 10008 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 10008,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 177: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4650), // Rule ID 10020 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 10020,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 178: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4802), // Rule ID 10032 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 10032,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 179: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4959), // Rule ID 15627 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15627,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 180: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5116), // Rule ID 15628 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15628,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 181: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5273), // Rule ID 15629 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15629,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 182: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5430), // Rule ID 15630 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15630,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 183: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5587), // Rule ID 10124 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10124,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 184: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5744), // Rule ID 10125 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10125,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 185: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5901), // Rule ID 10126 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10126,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 186: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6058), // Rule ID 10127 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10127,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 187: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6091), // Rule ID 13297 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13297,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 188: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6127), // Rule ID 13870 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13870,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 189: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 190: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6196), // Rule ID 3925 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3925,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 191: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6229), // Rule ID 13295 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13295,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 192: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 193: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 194: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 169: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 156: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(12227),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6435), // Rule ID 5396 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5396,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 196: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6571), // Rule ID 5395 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5395,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 197: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6707), // Rule ID 5405 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5405,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 198: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6843), // Rule ID 5394 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5394,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 199: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6979), // Rule ID 5393 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5393,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 200: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7047), // Rule ID 6960 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6960,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 201: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7115), // Rule ID 14028 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 14028,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 202: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7148), // Rule ID 13294 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13294,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 203: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7281), // Rule ID 3977 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3977,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 204: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7376), // Rule ID 3975 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3975,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 205: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7471), // Rule ID 3976 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3976,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 206: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 207: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7637), // Rule ID 13880 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13880,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 208: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7732), // Rule ID 13878 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13878,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 209: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7827), // Rule ID 13879 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13879,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 210: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7909), // Rule ID 13305 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13305,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 211: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7991), // Rule ID 13306 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13306,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 212: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 213: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 214: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8213), // Rule ID 13725 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13725,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 215: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8271), // Rule ID 15579 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15579,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 216: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8329), // Rule ID 15591 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15591,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 217: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8387), // Rule ID 15603 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15603,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 218: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8484), // Rule ID 3992 //
     /*   8392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8412 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8440 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8482 */     GIR_RootConstrainSelectedInstOperands,
     /*   8483 */     // GIR_Coverage, 3992,
     /*   8483 */     GIR_EraseRootFromParent_Done,
     /*   8484 */   // Label 219: @8484
     /*   8484 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8581), // Rule ID 13890 //
     /*   8489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8526 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8537 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8549 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8579 */     GIR_RootConstrainSelectedInstOperands,
     /*   8580 */     // GIR_Coverage, 13890,
     /*   8580 */     GIR_EraseRootFromParent_Done,
     /*   8581 */   // Label 220: @8581
     /*   8581 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8639), // Rule ID 2649 //
     /*   8586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8605 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8608 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8613 */     // MIs[1] pattern
     /*   8613 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8616 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8623 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8637 */     GIR_RootConstrainSelectedInstOperands,
     /*   8638 */     // GIR_Coverage, 2649,
     /*   8638 */     GIR_EraseRootFromParent_Done,
     /*   8639 */   // Label 221: @8639
     /*   8639 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8697), // Rule ID 10005 //
     /*   8644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8663 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8666 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8671 */     // MIs[1] pattern
     /*   8671 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8674 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8681 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8695 */     GIR_RootConstrainSelectedInstOperands,
     /*   8696 */     // GIR_Coverage, 10005,
     /*   8696 */     GIR_EraseRootFromParent_Done,
     /*   8697 */   // Label 222: @8697
     /*   8697 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8755), // Rule ID 10017 //
     /*   8702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8721 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8724 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8729 */     // MIs[1] pattern
     /*   8729 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8732 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8739 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8753 */     GIR_RootConstrainSelectedInstOperands,
     /*   8754 */     // GIR_Coverage, 10017,
     /*   8754 */     GIR_EraseRootFromParent_Done,
     /*   8755 */   // Label 223: @8755
     /*   8755 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8813), // Rule ID 10029 //
     /*   8760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8779 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8782 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8787 */     // MIs[1] pattern
     /*   8787 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8790 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8797 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8811 */     GIR_RootConstrainSelectedInstOperands,
     /*   8812 */     // GIR_Coverage, 10029,
     /*   8812 */     GIR_EraseRootFromParent_Done,
     /*   8813 */   // Label 224: @8813
     /*   8813 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8910), // Rule ID 13891 //
     /*   8818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8842 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8878 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8908 */     GIR_RootConstrainSelectedInstOperands,
     /*   8909 */     // GIR_Coverage, 13891,
     /*   8909 */     GIR_EraseRootFromParent_Done,
     /*   8910 */   // Label 225: @8910
     /*   8910 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9007), // Rule ID 13892 //
     /*   8915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8956 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8963 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8975 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   9005 */     GIR_RootConstrainSelectedInstOperands,
     /*   9006 */     // GIR_Coverage, 13892,
     /*   9006 */     GIR_EraseRootFromParent_Done,
     /*   9007 */   // Label 226: @9007
     /*   9007 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9170), // Rule ID 14000 //
     /*   9012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9054 */     // MIs[1] Operand 2
     /*   9054 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9071 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9071 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9074 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9078 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9097 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9100 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9104 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9107 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9152 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9169 */     // GIR_Coverage, 14000,
     /*   9169 */     GIR_EraseRootFromParent_Done,
     /*   9170 */   // Label 227: @9170
     /*   9170 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9333), // Rule ID 13997 //
     /*   9175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9217 */     // MIs[1] Operand 2
     /*   9217 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9234 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9234 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9237 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9241 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9260 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9267 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9315 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9332 */     // GIR_Coverage, 13997,
     /*   9332 */     GIR_EraseRootFromParent_Done,
     /*   9333 */   // Label 228: @9333
     /*   9333 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9483), // Rule ID 14006 //
     /*   9338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9371 */     // MIs[1] Operand 2
     /*   9371 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9388 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9414 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9482 */     // GIR_Coverage, 14006,
     /*   9482 */     GIR_EraseRootFromParent_Done,
     /*   9483 */   // Label 229: @9483
     /*   9483 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9633), // Rule ID 14009 //
     /*   9488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9521 */     // MIs[1] Operand 2
     /*   9521 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9538 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9564 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9615 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9632 */     // GIR_Coverage, 14009,
     /*   9632 */     GIR_EraseRootFromParent_Done,
     /*   9633 */   // Label 230: @9633
     /*   9633 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9783), // Rule ID 14005 //
     /*   9638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9671 */     // MIs[1] Operand 2
     /*   9671 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9688 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9714 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9782 */     // GIR_Coverage, 14005,
     /*   9782 */     GIR_EraseRootFromParent_Done,
     /*   9783 */   // Label 231: @9783
     /*   9783 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9946), // Rule ID 5378 //
     /*   9788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9834 */     // MIs[1] Operand 2
     /*   9834 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9847 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9847 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9850 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9854 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9873 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9880 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9945 */     // GIR_Coverage, 5378,
     /*   9945 */     GIR_EraseRootFromParent_Done,
     /*   9946 */   // Label 232: @9946
     /*   9946 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10109), // Rule ID 5375 //
     /*   9951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9997 */     // MIs[1] Operand 2
     /*   9997 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10010 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10010 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10013 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10017 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10036 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10039 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  10043 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  10068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  10084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10091 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10108 */     // GIR_Coverage, 5375,
     /*  10108 */     GIR_EraseRootFromParent_Done,
     /*  10109 */   // Label 233: @10109
     /*  10109 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10259), // Rule ID 5402 //
     /*  10114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10151 */     // MIs[1] Operand 2
     /*  10151 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10164 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10164 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10167 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10171 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10190 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10197 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10227 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10258 */     // GIR_Coverage, 5402,
     /*  10258 */     GIR_EraseRootFromParent_Done,
     /*  10259 */   // Label 234: @10259
     /*  10259 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10409), // Rule ID 5408 //
     /*  10264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10301 */     // MIs[1] Operand 2
     /*  10301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10314 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10340 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10347 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  10372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10408 */     // GIR_Coverage, 5408,
     /*  10408 */     GIR_EraseRootFromParent_Done,
     /*  10409 */   // Label 235: @10409
     /*  10409 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10559), // Rule ID 5401 //
     /*  10414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10451 */     // MIs[1] Operand 2
     /*  10451 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10464 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10558 */     // GIR_Coverage, 5401,
     /*  10558 */     GIR_EraseRootFromParent_Done,
     /*  10559 */   // Label 236: @10559
     /*  10559 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10592), // Rule ID 13298 //
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10579 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10590 */     GIR_RootConstrainSelectedInstOperands,
     /*  10591 */     // GIR_Coverage, 13298,
     /*  10591 */     GIR_EraseRootFromParent_Done,
     /*  10592 */   // Label 237: @10592
     /*  10592 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10628), // Rule ID 13871 //
     /*  10597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10612 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10626 */     GIR_RootConstrainSelectedInstOperands,
     /*  10627 */     // GIR_Coverage, 13871,
     /*  10627 */     GIR_EraseRootFromParent_Done,
     /*  10628 */   // Label 238: @10628
     /*  10628 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10740), // Rule ID 3991 //
     /*  10633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10653 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10658 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10669 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10681 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10709 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*  10738 */     GIR_RootConstrainSelectedInstOperands,
     /*  10739 */     // GIR_Coverage, 3991,
     /*  10739 */     GIR_EraseRootFromParent_Done,
     /*  10740 */   // Label 239: @10740
     /*  10740 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10773), // Rule ID 98 //
     /*  10745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10760 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10771 */     GIR_RootConstrainSelectedInstOperands,
     /*  10772 */     // GIR_Coverage, 98,
     /*  10772 */     GIR_EraseRootFromParent_Done,
     /*  10773 */   // Label 240: @10773
     /*  10773 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10809), // Rule ID 3926 //
     /*  10778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10793 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10807 */     GIR_RootConstrainSelectedInstOperands,
     /*  10808 */     // GIR_Coverage, 3926,
     /*  10808 */     GIR_EraseRootFromParent_Done,
     /*  10809 */   // Label 241: @10809
     /*  10809 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10921), // Rule ID 13889 //
     /*  10814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10838 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10843 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10850 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10862 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10890 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10919 */     GIR_RootConstrainSelectedInstOperands,
     /*  10920 */     // GIR_Coverage, 13889,
     /*  10920 */     GIR_EraseRootFromParent_Done,
     /*  10921 */   // Label 242: @10921
     /*  10921 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10954), // Rule ID 13296 //
     /*  10926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10941 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10952 */     GIR_RootConstrainSelectedInstOperands,
     /*  10953 */     // GIR_Coverage, 13296,
     /*  10953 */     GIR_EraseRootFromParent_Done,
     /*  10954 */   // Label 243: @10954
     /*  10954 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11017), // Rule ID 15619 //
     /*  10959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10974 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10977 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10993 */     // MIs[1] pred
     /*  10993 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11004 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11015 */     GIR_RootConstrainSelectedInstOperands,
     /*  11016 */     // GIR_Coverage, 15619,
     /*  11016 */     GIR_EraseRootFromParent_Done,
     /*  11017 */   // Label 244: @11017
     /*  11017 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11080), // Rule ID 15620 //
     /*  11022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11037 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11040 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11056 */     // MIs[1] pred
     /*  11056 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11067 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11078 */     GIR_RootConstrainSelectedInstOperands,
     /*  11079 */     // GIR_Coverage, 15620,
     /*  11079 */     GIR_EraseRootFromParent_Done,
     /*  11080 */   // Label 245: @11080
     /*  11080 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11143), // Rule ID 15621 //
     /*  11085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11100 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11103 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11112 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11119 */     // MIs[1] pred
     /*  11119 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11130 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11141 */     GIR_RootConstrainSelectedInstOperands,
     /*  11142 */     // GIR_Coverage, 15621,
     /*  11142 */     GIR_EraseRootFromParent_Done,
     /*  11143 */   // Label 246: @11143
     /*  11143 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11206), // Rule ID 15622 //
     /*  11148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11163 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11166 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11182 */     // MIs[1] pred
     /*  11182 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11193 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11204 */     GIR_RootConstrainSelectedInstOperands,
     /*  11205 */     // GIR_Coverage, 15622,
     /*  11205 */     GIR_EraseRootFromParent_Done,
     /*  11206 */   // Label 247: @11206
     /*  11206 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11239), // Rule ID 96 //
     /*  11211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  11226 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  11226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  11237 */     GIR_RootConstrainSelectedInstOperands,
     /*  11238 */     // GIR_Coverage, 96,
     /*  11238 */     GIR_EraseRootFromParent_Done,
     /*  11239 */   // Label 248: @11239
     /*  11239 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11302), // Rule ID 10116 //
     /*  11244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11263 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11266 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  11275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11282 */     // MIs[1] pred
     /*  11282 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11289 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11300 */     GIR_RootConstrainSelectedInstOperands,
     /*  11301 */     // GIR_Coverage, 10116,
     /*  11301 */     GIR_EraseRootFromParent_Done,
     /*  11302 */   // Label 249: @11302
     /*  11302 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11365), // Rule ID 10117 //
     /*  11307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11326 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11329 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11345 */     // MIs[1] pred
     /*  11345 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11352 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11363 */     GIR_RootConstrainSelectedInstOperands,
     /*  11364 */     // GIR_Coverage, 10117,
     /*  11364 */     GIR_EraseRootFromParent_Done,
     /*  11365 */   // Label 250: @11365
     /*  11365 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11428), // Rule ID 10118 //
     /*  11370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11389 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11392 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11408 */     // MIs[1] pred
     /*  11408 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11415 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11426 */     GIR_RootConstrainSelectedInstOperands,
     /*  11427 */     // GIR_Coverage, 10118,
     /*  11427 */     GIR_EraseRootFromParent_Done,
     /*  11428 */   // Label 251: @11428
     /*  11428 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11491), // Rule ID 10119 //
     /*  11433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11471 */     // MIs[1] pred
     /*  11471 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11478 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 10119,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 252: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11547), // Rule ID 13404 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11511 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11514 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11534 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11545 */     GIR_RootConstrainSelectedInstOperands,
     /*  11546 */     // GIR_Coverage, 13404,
     /*  11546 */     GIR_EraseRootFromParent_Done,
     /*  11547 */   // Label 253: @11547
     /*  11547 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11603), // Rule ID 13416 //
     /*  11552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11567 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11570 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11601 */     GIR_RootConstrainSelectedInstOperands,
     /*  11602 */     // GIR_Coverage, 13416,
     /*  11602 */     GIR_EraseRootFromParent_Done,
     /*  11603 */   // Label 254: @11603
     /*  11603 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11670), // Rule ID 13632 //
     /*  11608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11632 */     // MIs[1] imm
     /*  11632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11640 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11644 */     // MIs[2] Operand 1
     /*  11644 */     // No operand predicates
     /*  11644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11654 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11668 */     GIR_RootConstrainSelectedInstOperands,
     /*  11669 */     // GIR_Coverage, 13632,
     /*  11669 */     GIR_EraseRootFromParent_Done,
     /*  11670 */   // Label 255: @11670
     /*  11670 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11737), // Rule ID 13635 //
     /*  11675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11699 */     // MIs[1] imm
     /*  11699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11711 */     // MIs[2] Operand 1
     /*  11711 */     // No operand predicates
     /*  11711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11721 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11735 */     GIR_RootConstrainSelectedInstOperands,
     /*  11736 */     // GIR_Coverage, 13635,
     /*  11736 */     GIR_EraseRootFromParent_Done,
     /*  11737 */   // Label 256: @11737
     /*  11737 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11793), // Rule ID 997 //
     /*  11742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11761 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11764 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11780 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11791 */     GIR_RootConstrainSelectedInstOperands,
     /*  11792 */     // GIR_Coverage, 997,
     /*  11792 */     GIR_EraseRootFromParent_Done,
     /*  11793 */   // Label 257: @11793
     /*  11793 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11849), // Rule ID 1058 //
     /*  11798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11817 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11820 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11836 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11847 */     GIR_RootConstrainSelectedInstOperands,
     /*  11848 */     // GIR_Coverage, 1058,
     /*  11848 */     GIR_EraseRootFromParent_Done,
     /*  11849 */   // Label 258: @11849
     /*  11849 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11916), // Rule ID 2121 //
     /*  11854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11882 */     // MIs[1] imm
     /*  11882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11894 */     // MIs[2] Operand 1
     /*  11894 */     // No operand predicates
     /*  11894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11900 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11914 */     GIR_RootConstrainSelectedInstOperands,
     /*  11915 */     // GIR_Coverage, 2121,
     /*  11915 */     GIR_EraseRootFromParent_Done,
     /*  11916 */   // Label 259: @11916
     /*  11916 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11983), // Rule ID 2130 //
     /*  11921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11949 */     // MIs[1] imm
     /*  11949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11961 */     // MIs[2] Operand 1
     /*  11961 */     // No operand predicates
     /*  11961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11967 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11981 */     GIR_RootConstrainSelectedInstOperands,
     /*  11982 */     // GIR_Coverage, 2130,
     /*  11982 */     GIR_EraseRootFromParent_Done,
     /*  11983 */   // Label 260: @11983
     /*  11983 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(12031), // Rule ID 13403 //
     /*  11988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12018 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12029 */     GIR_RootConstrainSelectedInstOperands,
     /*  12030 */     // GIR_Coverage, 13403,
     /*  12030 */     GIR_EraseRootFromParent_Done,
     /*  12031 */   // Label 261: @12031
     /*  12031 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12079), // Rule ID 13415 //
     /*  12036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12066 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12077 */     GIR_RootConstrainSelectedInstOperands,
     /*  12078 */     // GIR_Coverage, 13415,
     /*  12078 */     GIR_EraseRootFromParent_Done,
     /*  12079 */   // Label 262: @12079
     /*  12079 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12127), // Rule ID 996 //
     /*  12084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12114 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12125 */     GIR_RootConstrainSelectedInstOperands,
     /*  12126 */     // GIR_Coverage, 996,
     /*  12126 */     GIR_EraseRootFromParent_Done,
     /*  12127 */   // Label 263: @12127
     /*  12127 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12175), // Rule ID 1057 //
     /*  12132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12162 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12173 */     GIR_RootConstrainSelectedInstOperands,
     /*  12174 */     // GIR_Coverage, 1057,
     /*  12174 */     GIR_EraseRootFromParent_Done,
     /*  12175 */   // Label 264: @12175
     /*  12175 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12199), // Rule ID 94 //
     /*  12180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12192 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  12192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  12197 */     GIR_RootConstrainSelectedInstOperands,
     /*  12198 */     // GIR_Coverage, 94,
     /*  12198 */     GIR_Done,
     /*  12199 */   // Label 265: @12199
     /*  12199 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12226), // Rule ID 1607 //
     /*  12204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12219 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  12219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  12224 */     GIR_RootConstrainSelectedInstOperands,
     /*  12225 */     // GIR_Coverage, 1607,
     /*  12225 */     GIR_Done,
     /*  12226 */   // Label 266: @12226
     /*  12226 */   GIM_Reject,
     /*  12227 */ // Label 195: @12227
     /*  12227 */ GIM_Reject,
     /*  12228 */ // Label 157: @12228
     /*  12228 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(15835),
     /*  12233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12239 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12427), // Rule ID 6981 //
     /*  12244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12281 */     // MIs[2] Operand 2
     /*  12281 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12300 */     // MIs[3] Rn
     /*  12300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12305 */     // MIs[3] Operand 2
     /*  12305 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12320 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12324 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12332 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12336 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12340 */     // MIs[5] Rn
     /*  12340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12345 */     // MIs[5] Operand 2
     /*  12345 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12356 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12360 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12364 */     // MIs[6] Rn
     /*  12364 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12369 */     // MIs[6] Operand 2
     /*  12369 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12380 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12382 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12426 */     // GIR_Coverage, 6981,
     /*  12426 */     GIR_EraseRootFromParent_Done,
     /*  12427 */   // Label 268: @12427
     /*  12427 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12615), // Rule ID 14039 //
     /*  12432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12469 */     // MIs[2] Operand 2
     /*  12469 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12488 */     // MIs[3] Rn
     /*  12488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12493 */     // MIs[3] Operand 2
     /*  12493 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12508 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12512 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12516 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12520 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12524 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12528 */     // MIs[5] Rn
     /*  12528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12533 */     // MIs[5] Operand 2
     /*  12533 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12544 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12548 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12552 */     // MIs[6] Rn
     /*  12552 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12557 */     // MIs[6] Operand 2
     /*  12557 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12568 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12570 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12597 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12614 */     // GIR_Coverage, 14039,
     /*  12614 */     GIR_EraseRootFromParent_Done,
     /*  12615 */   // Label 269: @12615
     /*  12615 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12751), // Rule ID 5392 //
     /*  12620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12653 */     // MIs[1] Operand 2
     /*  12653 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12684 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12688 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12693 */     // MIs[3] Operand 2
     /*  12693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12706 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12750 */     // GIR_Coverage, 5392,
     /*  12750 */     GIR_EraseRootFromParent_Done,
     /*  12751 */   // Label 270: @12751
     /*  12751 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12887), // Rule ID 5391 //
     /*  12756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12789 */     // MIs[1] Operand 2
     /*  12789 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12820 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12824 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12829 */     // MIs[3] Operand 2
     /*  12829 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12840 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12842 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12886 */     // GIR_Coverage, 5391,
     /*  12886 */     GIR_EraseRootFromParent_Done,
     /*  12887 */   // Label 271: @12887
     /*  12887 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13023), // Rule ID 5404 //
     /*  12892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12925 */     // MIs[1] Operand 2
     /*  12925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12952 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12956 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12960 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12965 */     // MIs[3] Operand 2
     /*  12965 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12978 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13022 */     // GIR_Coverage, 5404,
     /*  13022 */     GIR_EraseRootFromParent_Done,
     /*  13023 */   // Label 272: @13023
     /*  13023 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13159), // Rule ID 5390 //
     /*  13028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13061 */     // MIs[1] Operand 2
     /*  13061 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13088 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13092 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13096 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13101 */     // MIs[3] Operand 2
     /*  13101 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13112 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13114 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 5390,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 273: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13295), // Rule ID 5389 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13224 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13228 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13232 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13237 */     // MIs[3] Operand 2
     /*  13237 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13248 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13250 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13294 */     // GIR_Coverage, 5389,
     /*  13294 */     GIR_EraseRootFromParent_Done,
     /*  13295 */   // Label 274: @13295
     /*  13295 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13458), // Rule ID 13999 //
     /*  13300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13342 */     // MIs[1] Operand 2
     /*  13342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13359 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13440 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13457 */     // GIR_Coverage, 13999,
     /*  13457 */     GIR_EraseRootFromParent_Done,
     /*  13458 */   // Label 275: @13458
     /*  13458 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13621), // Rule ID 13996 //
     /*  13463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     // MIs[1] Operand 2
     /*  13505 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13522 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13522 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13525 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13529 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13548 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13555 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13620 */     // GIR_Coverage, 13996,
     /*  13620 */     GIR_EraseRootFromParent_Done,
     /*  13621 */   // Label 276: @13621
     /*  13621 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13771), // Rule ID 14004 //
     /*  13626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13659 */     // MIs[1] Operand 2
     /*  13659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13676 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13770 */     // GIR_Coverage, 14004,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 277: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13921), // Rule ID 14008 //
     /*  13776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13809 */     // MIs[1] Operand 2
     /*  13809 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13826 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13903 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13920 */     // GIR_Coverage, 14008,
     /*  13920 */     GIR_EraseRootFromParent_Done,
     /*  13921 */   // Label 278: @13921
     /*  13921 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14071), // Rule ID 14003 //
     /*  13926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13959 */     // MIs[1] Operand 2
     /*  13959 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13976 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13976 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13979 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13983 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14005 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  14009 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14070 */     // GIR_Coverage, 14003,
     /*  14070 */     GIR_EraseRootFromParent_Done,
     /*  14071 */   // Label 279: @14071
     /*  14071 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14234), // Rule ID 5377 //
     /*  14076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  14104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14122 */     // MIs[1] Operand 2
     /*  14122 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14135 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14135 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14138 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14142 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14161 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14168 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  14193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14233 */     // GIR_Coverage, 5377,
     /*  14233 */     GIR_EraseRootFromParent_Done,
     /*  14234 */   // Label 280: @14234
     /*  14234 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14397), // Rule ID 5374 //
     /*  14239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  14267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     // MIs[1] Operand 2
     /*  14285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14298 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  14356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14396 */     // GIR_Coverage, 5374,
     /*  14396 */     GIR_EraseRootFromParent_Done,
     /*  14397 */   // Label 281: @14397
     /*  14397 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14547), // Rule ID 5400 //
     /*  14402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  14430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14439 */     // MIs[1] Operand 2
     /*  14439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14452 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14452 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14455 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14459 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14478 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14546 */     // GIR_Coverage, 5400,
     /*  14546 */     GIR_EraseRootFromParent_Done,
     /*  14547 */   // Label 282: @14547
     /*  14547 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14697), // Rule ID 5407 //
     /*  14552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  14580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14589 */     // MIs[1] Operand 2
     /*  14589 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14602 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14602 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14605 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14609 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14628 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14638 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14696 */     // GIR_Coverage, 5407,
     /*  14696 */     GIR_EraseRootFromParent_Done,
     /*  14697 */   // Label 283: @14697
     /*  14697 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14847), // Rule ID 5399 //
     /*  14702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14739 */     // MIs[1] Operand 2
     /*  14739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14752 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14781 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14785 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14846 */     // GIR_Coverage, 5399,
     /*  14846 */     GIR_EraseRootFromParent_Done,
     /*  14847 */   // Label 284: @14847
     /*  14847 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14916), // Rule ID 13438 //
     /*  14852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14867 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14870 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14899 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14914 */     GIR_RootConstrainSelectedInstOperands,
     /*  14915 */     // GIR_Coverage, 13438,
     /*  14915 */     GIR_EraseRootFromParent_Done,
     /*  14916 */   // Label 285: @14916
     /*  14916 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14985), // Rule ID 13450 //
     /*  14921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14936 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14939 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14968 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14983 */     GIR_RootConstrainSelectedInstOperands,
     /*  14984 */     // GIR_Coverage, 13450,
     /*  14984 */     GIR_EraseRootFromParent_Done,
     /*  14985 */   // Label 286: @14985
     /*  14985 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(15041), // Rule ID 13400 //
     /*  14990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15005 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15008 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15028 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15039 */     GIR_RootConstrainSelectedInstOperands,
     /*  15040 */     // GIR_Coverage, 13400,
     /*  15040 */     GIR_EraseRootFromParent_Done,
     /*  15041 */   // Label 287: @15041
     /*  15041 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(15097), // Rule ID 13412 //
     /*  15046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15061 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15064 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15084 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15095 */     GIR_RootConstrainSelectedInstOperands,
     /*  15096 */     // GIR_Coverage, 13412,
     /*  15096 */     GIR_EraseRootFromParent_Done,
     /*  15097 */   // Label 288: @15097
     /*  15097 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(15164), // Rule ID 13652 //
     /*  15102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15126 */     // MIs[1] imm
     /*  15126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15138 */     // MIs[2] Operand 1
     /*  15138 */     // No operand predicates
     /*  15138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15148 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15162 */     GIR_RootConstrainSelectedInstOperands,
     /*  15163 */     // GIR_Coverage, 13652,
     /*  15163 */     GIR_EraseRootFromParent_Done,
     /*  15164 */   // Label 289: @15164
     /*  15164 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15231), // Rule ID 13673 //
     /*  15169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15193 */     // MIs[1] imm
     /*  15193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15205 */     // MIs[2] Operand 1
     /*  15205 */     // No operand predicates
     /*  15205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15215 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15229 */     GIR_RootConstrainSelectedInstOperands,
     /*  15230 */     // GIR_Coverage, 13673,
     /*  15230 */     GIR_EraseRootFromParent_Done,
     /*  15231 */   // Label 290: @15231
     /*  15231 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15300), // Rule ID 1365 //
     /*  15236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  15263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15283 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  15286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15298 */     GIR_RootConstrainSelectedInstOperands,
     /*  15299 */     // GIR_Coverage, 1365,
     /*  15299 */     GIR_EraseRootFromParent_Done,
     /*  15300 */   // Label 291: @15300
     /*  15300 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15369), // Rule ID 1488 //
     /*  15305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  15332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15352 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  15355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15367 */     GIR_RootConstrainSelectedInstOperands,
     /*  15368 */     // GIR_Coverage, 1488,
     /*  15368 */     GIR_EraseRootFromParent_Done,
     /*  15369 */   // Label 292: @15369
     /*  15369 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15425), // Rule ID 993 //
     /*  15374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15412 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15423 */     GIR_RootConstrainSelectedInstOperands,
     /*  15424 */     // GIR_Coverage, 993,
     /*  15424 */     GIR_EraseRootFromParent_Done,
     /*  15425 */   // Label 293: @15425
     /*  15425 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15481), // Rule ID 1054 //
     /*  15430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15468 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15479 */     GIR_RootConstrainSelectedInstOperands,
     /*  15480 */     // GIR_Coverage, 1054,
     /*  15480 */     GIR_EraseRootFromParent_Done,
     /*  15481 */   // Label 294: @15481
     /*  15481 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15548), // Rule ID 2238 //
     /*  15486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15514 */     // MIs[1] imm
     /*  15514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15526 */     // MIs[2] Operand 1
     /*  15526 */     // No operand predicates
     /*  15526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15532 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15546 */     GIR_RootConstrainSelectedInstOperands,
     /*  15547 */     // GIR_Coverage, 2238,
     /*  15547 */     GIR_EraseRootFromParent_Done,
     /*  15548 */   // Label 295: @15548
     /*  15548 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15615), // Rule ID 2297 //
     /*  15553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15581 */     // MIs[1] imm
     /*  15581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15593 */     // MIs[2] Operand 1
     /*  15593 */     // No operand predicates
     /*  15593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15599 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15613 */     GIR_RootConstrainSelectedInstOperands,
     /*  15614 */     // GIR_Coverage, 2297,
     /*  15614 */     GIR_EraseRootFromParent_Done,
     /*  15615 */   // Label 296: @15615
     /*  15615 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15663), // Rule ID 13399 //
     /*  15620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15650 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15661 */     GIR_RootConstrainSelectedInstOperands,
     /*  15662 */     // GIR_Coverage, 13399,
     /*  15662 */     GIR_EraseRootFromParent_Done,
     /*  15663 */   // Label 297: @15663
     /*  15663 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15711), // Rule ID 13411 //
     /*  15668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15698 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15709 */     GIR_RootConstrainSelectedInstOperands,
     /*  15710 */     // GIR_Coverage, 13411,
     /*  15710 */     GIR_EraseRootFromParent_Done,
     /*  15711 */   // Label 298: @15711
     /*  15711 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15759), // Rule ID 992 //
     /*  15716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15746 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15757 */     GIR_RootConstrainSelectedInstOperands,
     /*  15758 */     // GIR_Coverage, 992,
     /*  15758 */     GIR_EraseRootFromParent_Done,
     /*  15759 */   // Label 299: @15759
     /*  15759 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15807), // Rule ID 1053 //
     /*  15764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15794 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15805 */     GIR_RootConstrainSelectedInstOperands,
     /*  15806 */     // GIR_Coverage, 1053,
     /*  15806 */     GIR_EraseRootFromParent_Done,
     /*  15807 */   // Label 300: @15807
     /*  15807 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15834), // Rule ID 1104 //
     /*  15812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15827 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15832 */     GIR_RootConstrainSelectedInstOperands,
     /*  15833 */     // GIR_Coverage, 1104,
     /*  15833 */     GIR_Done,
     /*  15834 */   // Label 301: @15834
     /*  15834 */   GIM_Reject,
     /*  15835 */ // Label 267: @15835
     /*  15835 */ GIM_Reject,
     /*  15836 */ // Label 158: @15836
     /*  15836 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(21737),
     /*  15841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15847 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15965), // Rule ID 13581 //
     /*  15852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15916 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15920 */     // MIs[4] Operand 1
     /*  15920 */     // No operand predicates
     /*  15920 */     // MIs[2] Operand 2
     /*  15920 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15944 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 13581,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 303: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16083), // Rule ID 13582 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16034 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16038 */     // MIs[4] Operand 1
     /*  16038 */     // No operand predicates
     /*  16038 */     // MIs[2] Operand 2
     /*  16038 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16062 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16081 */     GIR_RootConstrainSelectedInstOperands,
     /*  16082 */     // GIR_Coverage, 13582,
     /*  16082 */     GIR_EraseRootFromParent_Done,
     /*  16083 */   // Label 304: @16083
     /*  16083 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16201), // Rule ID 13617 //
     /*  16088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16139 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16152 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16156 */     // MIs[4] Operand 1
     /*  16156 */     // No operand predicates
     /*  16156 */     // MIs[2] Operand 2
     /*  16156 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16171 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16180 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16199 */     GIR_RootConstrainSelectedInstOperands,
     /*  16200 */     // GIR_Coverage, 13617,
     /*  16200 */     GIR_EraseRootFromParent_Done,
     /*  16201 */   // Label 305: @16201
     /*  16201 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16319), // Rule ID 13618 //
     /*  16206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16253 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16266 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16270 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16274 */     // MIs[4] Operand 1
     /*  16274 */     // No operand predicates
     /*  16274 */     // MIs[2] Operand 2
     /*  16274 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16289 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16298 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16317 */     GIR_RootConstrainSelectedInstOperands,
     /*  16318 */     // GIR_Coverage, 13618,
     /*  16318 */     GIR_EraseRootFromParent_Done,
     /*  16319 */   // Label 306: @16319
     /*  16319 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16437), // Rule ID 2042 //
     /*  16324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16375 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16392 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16396 */     // MIs[4] Operand 1
     /*  16396 */     // No operand predicates
     /*  16396 */     // MIs[2] Operand 2
     /*  16396 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16416 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16435 */     GIR_RootConstrainSelectedInstOperands,
     /*  16436 */     // GIR_Coverage, 2042,
     /*  16436 */     GIR_EraseRootFromParent_Done,
     /*  16437 */   // Label 307: @16437
     /*  16437 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16555), // Rule ID 13580 //
     /*  16442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16493 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16510 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16514 */     // MIs[4] Operand 1
     /*  16514 */     // No operand predicates
     /*  16514 */     // MIs[2] Operand 2
     /*  16514 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16525 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16534 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16553 */     GIR_RootConstrainSelectedInstOperands,
     /*  16554 */     // GIR_Coverage, 13580,
     /*  16554 */     GIR_EraseRootFromParent_Done,
     /*  16555 */   // Label 308: @16555
     /*  16555 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16673), // Rule ID 2094 //
     /*  16560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16607 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16611 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16628 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16632 */     // MIs[4] Operand 1
     /*  16632 */     // No operand predicates
     /*  16632 */     // MIs[2] Operand 2
     /*  16632 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16652 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16671 */     GIR_RootConstrainSelectedInstOperands,
     /*  16672 */     // GIR_Coverage, 2094,
     /*  16672 */     GIR_EraseRootFromParent_Done,
     /*  16673 */   // Label 309: @16673
     /*  16673 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16791), // Rule ID 13616 //
     /*  16678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16746 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16750 */     // MIs[4] Operand 1
     /*  16750 */     // No operand predicates
     /*  16750 */     // MIs[2] Operand 2
     /*  16750 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16770 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16789 */     GIR_RootConstrainSelectedInstOperands,
     /*  16790 */     // GIR_Coverage, 13616,
     /*  16790 */     GIR_EraseRootFromParent_Done,
     /*  16791 */   // Label 310: @16791
     /*  16791 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16878), // Rule ID 13482 //
     /*  16796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16823 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16826 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16835 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16859 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16876 */     GIR_RootConstrainSelectedInstOperands,
     /*  16877 */     // GIR_Coverage, 13482,
     /*  16877 */     GIR_EraseRootFromParent_Done,
     /*  16878 */   // Label 311: @16878
     /*  16878 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16965), // Rule ID 13510 //
     /*  16883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16910 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16913 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16922 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16946 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16963 */     GIR_RootConstrainSelectedInstOperands,
     /*  16964 */     // GIR_Coverage, 13510,
     /*  16964 */     GIR_EraseRootFromParent_Done,
     /*  16965 */   // Label 312: @16965
     /*  16965 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17052), // Rule ID 1699 //
     /*  16970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17001 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17004 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  17009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17013 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17033 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  17036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17050 */     GIR_RootConstrainSelectedInstOperands,
     /*  17051 */     // GIR_Coverage, 1699,
     /*  17051 */     GIR_EraseRootFromParent_Done,
     /*  17052 */   // Label 313: @17052
     /*  17052 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17139), // Rule ID 1777 //
     /*  17057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17088 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17091 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  17096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17100 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17120 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  17123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17137 */     GIR_RootConstrainSelectedInstOperands,
     /*  17138 */     // GIR_Coverage, 1777,
     /*  17138 */     GIR_EraseRootFromParent_Done,
     /*  17139 */   // Label 314: @17139
     /*  17139 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17254), // Rule ID 13576 //
     /*  17144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17208 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17212 */     // MIs[4] Operand 1
     /*  17212 */     // No operand predicates
     /*  17212 */     // MIs[2] Operand 2
     /*  17212 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17234 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17252 */     GIR_RootConstrainSelectedInstOperands,
     /*  17253 */     // GIR_Coverage, 13576,
     /*  17253 */     GIR_EraseRootFromParent_Done,
     /*  17254 */   // Label 315: @17254
     /*  17254 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17369), // Rule ID 13575 //
     /*  17259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17328 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17332 */     // MIs[4] Operand 1
     /*  17332 */     // No operand predicates
     /*  17332 */     // MIs[2] Operand 2
     /*  17332 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17349 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 13575,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 316: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17484), // Rule ID 13612 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17421 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17434 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17438 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17442 */     // MIs[4] Operand 1
     /*  17442 */     // No operand predicates
     /*  17442 */     // MIs[2] Operand 2
     /*  17442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17464 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17482 */     GIR_RootConstrainSelectedInstOperands,
     /*  17483 */     // GIR_Coverage, 13612,
     /*  17483 */     GIR_EraseRootFromParent_Done,
     /*  17484 */   // Label 317: @17484
     /*  17484 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17599), // Rule ID 13611 //
     /*  17489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17562 */     // MIs[4] Operand 1
     /*  17562 */     // No operand predicates
     /*  17562 */     // MIs[2] Operand 2
     /*  17562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17577 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17579 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17597 */     GIR_RootConstrainSelectedInstOperands,
     /*  17598 */     // GIR_Coverage, 13611,
     /*  17598 */     GIR_EraseRootFromParent_Done,
     /*  17599 */   // Label 318: @17599
     /*  17599 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17668), // Rule ID 1801 //
     /*  17604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17651 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17666 */     GIR_RootConstrainSelectedInstOperands,
     /*  17667 */     // GIR_Coverage, 1801,
     /*  17667 */     GIR_EraseRootFromParent_Done,
     /*  17668 */   // Label 319: @17668
     /*  17668 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17737), // Rule ID 1800 //
     /*  17673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17720 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17735 */     GIR_RootConstrainSelectedInstOperands,
     /*  17736 */     // GIR_Coverage, 1800,
     /*  17736 */     GIR_EraseRootFromParent_Done,
     /*  17737 */   // Label 320: @17737
     /*  17737 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17806), // Rule ID 1717 //
     /*  17742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17789 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17804 */     GIR_RootConstrainSelectedInstOperands,
     /*  17805 */     // GIR_Coverage, 1717,
     /*  17805 */     GIR_EraseRootFromParent_Done,
     /*  17806 */   // Label 321: @17806
     /*  17806 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17875), // Rule ID 1799 //
     /*  17811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17858 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17873 */     GIR_RootConstrainSelectedInstOperands,
     /*  17874 */     // GIR_Coverage, 1799,
     /*  17874 */     GIR_EraseRootFromParent_Done,
     /*  17875 */   // Label 322: @17875
     /*  17875 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17944), // Rule ID 1798 //
     /*  17880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17927 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17942 */     GIR_RootConstrainSelectedInstOperands,
     /*  17943 */     // GIR_Coverage, 1798,
     /*  17943 */     GIR_EraseRootFromParent_Done,
     /*  17944 */   // Label 323: @17944
     /*  17944 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(18059), // Rule ID 13574 //
     /*  17949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18004 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18017 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18021 */     // MIs[4] Operand 1
     /*  18021 */     // No operand predicates
     /*  18021 */     // MIs[2] Operand 2
     /*  18021 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18039 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18057 */     GIR_RootConstrainSelectedInstOperands,
     /*  18058 */     // GIR_Coverage, 13574,
     /*  18058 */     GIR_EraseRootFromParent_Done,
     /*  18059 */   // Label 324: @18059
     /*  18059 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18174), // Rule ID 2040 //
     /*  18064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18129 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18133 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18137 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18141 */     // MIs[4] Operand 1
     /*  18141 */     // No operand predicates
     /*  18141 */     // MIs[2] Operand 2
     /*  18141 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18152 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18154 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18172 */     GIR_RootConstrainSelectedInstOperands,
     /*  18173 */     // GIR_Coverage, 2040,
     /*  18173 */     GIR_EraseRootFromParent_Done,
     /*  18174 */   // Label 325: @18174
     /*  18174 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18289), // Rule ID 13610 //
     /*  18179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18234 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18247 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18251 */     // MIs[4] Operand 1
     /*  18251 */     // No operand predicates
     /*  18251 */     // MIs[2] Operand 2
     /*  18251 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18269 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18287 */     GIR_RootConstrainSelectedInstOperands,
     /*  18288 */     // GIR_Coverage, 13610,
     /*  18288 */     GIR_EraseRootFromParent_Done,
     /*  18289 */   // Label 326: @18289
     /*  18289 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18404), // Rule ID 2092 //
     /*  18294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18354 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18367 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18371 */     // MIs[4] Operand 1
     /*  18371 */     // No operand predicates
     /*  18371 */     // MIs[2] Operand 2
     /*  18371 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18384 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18402 */     GIR_RootConstrainSelectedInstOperands,
     /*  18403 */     // GIR_Coverage, 2092,
     /*  18403 */     GIR_EraseRootFromParent_Done,
     /*  18404 */   // Label 327: @18404
     /*  18404 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18471), // Rule ID 13494 //
     /*  18409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18452 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18469 */     GIR_RootConstrainSelectedInstOperands,
     /*  18470 */     // GIR_Coverage, 13494,
     /*  18470 */     GIR_EraseRootFromParent_Done,
     /*  18471 */   // Label 328: @18471
     /*  18471 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18538), // Rule ID 13528 //
     /*  18476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18519 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18536 */     GIR_RootConstrainSelectedInstOperands,
     /*  18537 */     // GIR_Coverage, 13528,
     /*  18537 */     GIR_EraseRootFromParent_Done,
     /*  18538 */   // Label 329: @18538
     /*  18538 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18605), // Rule ID 1729 //
     /*  18543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18586 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18603 */     GIR_RootConstrainSelectedInstOperands,
     /*  18604 */     // GIR_Coverage, 1729,
     /*  18604 */     GIR_EraseRootFromParent_Done,
     /*  18605 */   // Label 330: @18605
     /*  18605 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18672), // Rule ID 1819 //
     /*  18610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18653 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18670 */     GIR_RootConstrainSelectedInstOperands,
     /*  18671 */     // GIR_Coverage, 1819,
     /*  18671 */     GIR_EraseRootFromParent_Done,
     /*  18672 */   // Label 331: @18672
     /*  18672 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18753), // Rule ID 13480 //
     /*  18677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18704 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18707 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18716 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18736 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18751 */     GIR_RootConstrainSelectedInstOperands,
     /*  18752 */     // GIR_Coverage, 13480,
     /*  18752 */     GIR_EraseRootFromParent_Done,
     /*  18753 */   // Label 332: @18753
     /*  18753 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18834), // Rule ID 13508 //
     /*  18758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18785 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18788 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18797 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18817 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18832 */     GIR_RootConstrainSelectedInstOperands,
     /*  18833 */     // GIR_Coverage, 13508,
     /*  18833 */     GIR_EraseRootFromParent_Done,
     /*  18834 */   // Label 333: @18834
     /*  18834 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18915), // Rule ID 1697 //
     /*  18839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18870 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18873 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18882 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18898 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18913 */     GIR_RootConstrainSelectedInstOperands,
     /*  18914 */     // GIR_Coverage, 1697,
     /*  18914 */     GIR_EraseRootFromParent_Done,
     /*  18915 */   // Label 334: @18915
     /*  18915 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18996), // Rule ID 1775 //
     /*  18920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18951 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18954 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18963 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18979 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18994 */     GIR_RootConstrainSelectedInstOperands,
     /*  18995 */     // GIR_Coverage, 1775,
     /*  18995 */     GIR_EraseRootFromParent_Done,
     /*  18996 */   // Label 335: @18996
     /*  18996 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19088), // Rule ID 13579 //
     /*  19001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19057 */     // MIs[3] Operand 1
     /*  19057 */     // No operand predicates
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19068 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19086 */     GIR_RootConstrainSelectedInstOperands,
     /*  19087 */     // GIR_Coverage, 13579,
     /*  19087 */     GIR_EraseRootFromParent_Done,
     /*  19088 */   // Label 336: @19088
     /*  19088 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19180), // Rule ID 13578 //
     /*  19093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19150 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19154 */     // MIs[3] Operand 1
     /*  19154 */     // No operand predicates
     /*  19154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19160 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19178 */     GIR_RootConstrainSelectedInstOperands,
     /*  19179 */     // GIR_Coverage, 13578,
     /*  19179 */     GIR_EraseRootFromParent_Done,
     /*  19180 */   // Label 337: @19180
     /*  19180 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19272), // Rule ID 13615 //
     /*  19185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19241 */     // MIs[3] Operand 1
     /*  19241 */     // No operand predicates
     /*  19241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19252 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19270 */     GIR_RootConstrainSelectedInstOperands,
     /*  19271 */     // GIR_Coverage, 13615,
     /*  19271 */     GIR_EraseRootFromParent_Done,
     /*  19272 */   // Label 338: @19272
     /*  19272 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19364), // Rule ID 13614 //
     /*  19277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19338 */     // MIs[3] Operand 1
     /*  19338 */     // No operand predicates
     /*  19338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19344 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19362 */     GIR_RootConstrainSelectedInstOperands,
     /*  19363 */     // GIR_Coverage, 13614,
     /*  19363 */     GIR_EraseRootFromParent_Done,
     /*  19364 */   // Label 339: @19364
     /*  19364 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19456), // Rule ID 13577 //
     /*  19369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19429 */     // MIs[3] Operand 1
     /*  19429 */     // No operand predicates
     /*  19429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19436 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19454 */     GIR_RootConstrainSelectedInstOperands,
     /*  19455 */     // GIR_Coverage, 13577,
     /*  19455 */     GIR_EraseRootFromParent_Done,
     /*  19456 */   // Label 340: @19456
     /*  19456 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19548), // Rule ID 2041 //
     /*  19461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19526 */     // MIs[3] Operand 1
     /*  19526 */     // No operand predicates
     /*  19526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19528 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19546 */     GIR_RootConstrainSelectedInstOperands,
     /*  19547 */     // GIR_Coverage, 2041,
     /*  19547 */     GIR_EraseRootFromParent_Done,
     /*  19548 */   // Label 341: @19548
     /*  19548 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19640), // Rule ID 13613 //
     /*  19553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19613 */     // MIs[3] Operand 1
     /*  19613 */     // No operand predicates
     /*  19613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19620 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19638 */     GIR_RootConstrainSelectedInstOperands,
     /*  19639 */     // GIR_Coverage, 13613,
     /*  19639 */     GIR_EraseRootFromParent_Done,
     /*  19640 */   // Label 342: @19640
     /*  19640 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19732), // Rule ID 2093 //
     /*  19645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19710 */     // MIs[3] Operand 1
     /*  19710 */     // No operand predicates
     /*  19710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19712 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19730 */     GIR_RootConstrainSelectedInstOperands,
     /*  19731 */     // GIR_Coverage, 2093,
     /*  19731 */     GIR_EraseRootFromParent_Done,
     /*  19732 */   // Label 343: @19732
     /*  19732 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19783), // Rule ID 13522 //
     /*  19737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19769 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19781 */     GIR_RootConstrainSelectedInstOperands,
     /*  19782 */     // GIR_Coverage, 13522,
     /*  19782 */     GIR_EraseRootFromParent_Done,
     /*  19783 */   // Label 344: @19783
     /*  19783 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19834), // Rule ID 13488 //
     /*  19788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19820 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19832 */     GIR_RootConstrainSelectedInstOperands,
     /*  19833 */     // GIR_Coverage, 13488,
     /*  19833 */     GIR_EraseRootFromParent_Done,
     /*  19834 */   // Label 345: @19834
     /*  19834 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19885), // Rule ID 13521 //
     /*  19839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19871 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19883 */     GIR_RootConstrainSelectedInstOperands,
     /*  19884 */     // GIR_Coverage, 13521,
     /*  19884 */     GIR_EraseRootFromParent_Done,
     /*  19885 */   // Label 346: @19885
     /*  19885 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19936), // Rule ID 1813 //
     /*  19890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19934 */     GIR_RootConstrainSelectedInstOperands,
     /*  19935 */     // GIR_Coverage, 1813,
     /*  19935 */     GIR_EraseRootFromParent_Done,
     /*  19936 */   // Label 347: @19936
     /*  19936 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19987), // Rule ID 1723 //
     /*  19941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19973 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19985 */     GIR_RootConstrainSelectedInstOperands,
     /*  19986 */     // GIR_Coverage, 1723,
     /*  19986 */     GIR_EraseRootFromParent_Done,
     /*  19987 */   // Label 348: @19987
     /*  19987 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(20038), // Rule ID 1812 //
     /*  19992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  20024 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  20024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  20027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  20036 */     GIR_RootConstrainSelectedInstOperands,
     /*  20037 */     // GIR_Coverage, 1812,
     /*  20037 */     GIR_EraseRootFromParent_Done,
     /*  20038 */   // Label 349: @20038
     /*  20038 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(20094), // Rule ID 13406 //
     /*  20043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20058 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20061 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20081 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20092 */     GIR_RootConstrainSelectedInstOperands,
     /*  20093 */     // GIR_Coverage, 13406,
     /*  20093 */     GIR_EraseRootFromParent_Done,
     /*  20094 */   // Label 350: @20094
     /*  20094 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(20150), // Rule ID 13418 //
     /*  20099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20114 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20117 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20137 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20148 */     GIR_RootConstrainSelectedInstOperands,
     /*  20149 */     // GIR_Coverage, 13418,
     /*  20149 */     GIR_EraseRootFromParent_Done,
     /*  20150 */   // Label 351: @20150
     /*  20150 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(20217), // Rule ID 13656 //
     /*  20155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20179 */     // MIs[1] imm
     /*  20179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20187 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20191 */     // MIs[2] Operand 1
     /*  20191 */     // No operand predicates
     /*  20191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20201 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20215 */     GIR_RootConstrainSelectedInstOperands,
     /*  20216 */     // GIR_Coverage, 13656,
     /*  20216 */     GIR_EraseRootFromParent_Done,
     /*  20217 */   // Label 352: @20217
     /*  20217 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20284), // Rule ID 13677 //
     /*  20222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20246 */     // MIs[1] imm
     /*  20246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20258 */     // MIs[2] Operand 1
     /*  20258 */     // No operand predicates
     /*  20258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20268 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20282 */     GIR_RootConstrainSelectedInstOperands,
     /*  20283 */     // GIR_Coverage, 13677,
     /*  20283 */     GIR_EraseRootFromParent_Done,
     /*  20284 */   // Label 353: @20284
     /*  20284 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20340), // Rule ID 999 //
     /*  20289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20327 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20338 */     GIR_RootConstrainSelectedInstOperands,
     /*  20339 */     // GIR_Coverage, 999,
     /*  20339 */     GIR_EraseRootFromParent_Done,
     /*  20340 */   // Label 354: @20340
     /*  20340 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20396), // Rule ID 1060 //
     /*  20345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20383 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20394 */     GIR_RootConstrainSelectedInstOperands,
     /*  20395 */     // GIR_Coverage, 1060,
     /*  20395 */     GIR_EraseRootFromParent_Done,
     /*  20396 */   // Label 355: @20396
     /*  20396 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20463), // Rule ID 2242 //
     /*  20401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20429 */     // MIs[1] imm
     /*  20429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20441 */     // MIs[2] Operand 1
     /*  20441 */     // No operand predicates
     /*  20441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20447 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20461 */     GIR_RootConstrainSelectedInstOperands,
     /*  20462 */     // GIR_Coverage, 2242,
     /*  20462 */     GIR_EraseRootFromParent_Done,
     /*  20463 */   // Label 356: @20463
     /*  20463 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20530), // Rule ID 2301 //
     /*  20468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20496 */     // MIs[1] imm
     /*  20496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20508 */     // MIs[2] Operand 1
     /*  20508 */     // No operand predicates
     /*  20508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20514 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20528 */     GIR_RootConstrainSelectedInstOperands,
     /*  20529 */     // GIR_Coverage, 2301,
     /*  20529 */     GIR_EraseRootFromParent_Done,
     /*  20530 */   // Label 357: @20530
     /*  20530 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20600), // Rule ID 6977 //
     /*  20535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20573 */     // MIs[2] Rn
     /*  20573 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20578 */     // MIs[2] Rm
     /*  20578 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20585 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20598 */     GIR_RootConstrainSelectedInstOperands,
     /*  20599 */     // GIR_Coverage, 6977,
     /*  20599 */     GIR_EraseRootFromParent_Done,
     /*  20600 */   // Label 358: @20600
     /*  20600 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20670), // Rule ID 14035 //
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20643 */     // MIs[2] Rn
     /*  20643 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20648 */     // MIs[2] Rm
     /*  20648 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20655 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20668 */     GIR_RootConstrainSelectedInstOperands,
     /*  20669 */     // GIR_Coverage, 14035,
     /*  20669 */     GIR_EraseRootFromParent_Done,
     /*  20670 */   // Label 359: @20670
     /*  20670 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20733), // Rule ID 1797 //
     /*  20675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20718 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20731 */     GIR_RootConstrainSelectedInstOperands,
     /*  20732 */     // GIR_Coverage, 1797,
     /*  20732 */     GIR_EraseRootFromParent_Done,
     /*  20733 */   // Label 360: @20733
     /*  20733 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20796), // Rule ID 1796 //
     /*  20738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20781 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1796,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 361: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20859), // Rule ID 1716 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20844 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20857 */     GIR_RootConstrainSelectedInstOperands,
     /*  20858 */     // GIR_Coverage, 1716,
     /*  20858 */     GIR_EraseRootFromParent_Done,
     /*  20859 */   // Label 362: @20859
     /*  20859 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20922), // Rule ID 1795 //
     /*  20864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20907 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20920 */     GIR_RootConstrainSelectedInstOperands,
     /*  20921 */     // GIR_Coverage, 1795,
     /*  20921 */     GIR_EraseRootFromParent_Done,
     /*  20922 */   // Label 363: @20922
     /*  20922 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20985), // Rule ID 1794 //
     /*  20927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20970 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20983 */     GIR_RootConstrainSelectedInstOperands,
     /*  20984 */     // GIR_Coverage, 1794,
     /*  20984 */     GIR_EraseRootFromParent_Done,
     /*  20985 */   // Label 364: @20985
     /*  20985 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(21046), // Rule ID 13493 //
     /*  20990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21029 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21044 */     GIR_RootConstrainSelectedInstOperands,
     /*  21045 */     // GIR_Coverage, 13493,
     /*  21045 */     GIR_EraseRootFromParent_Done,
     /*  21046 */   // Label 365: @21046
     /*  21046 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(21107), // Rule ID 13527 //
     /*  21051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21090 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21105 */     GIR_RootConstrainSelectedInstOperands,
     /*  21106 */     // GIR_Coverage, 13527,
     /*  21106 */     GIR_EraseRootFromParent_Done,
     /*  21107 */   // Label 366: @21107
     /*  21107 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(21155), // Rule ID 13520 //
     /*  21112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21142 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21153 */     GIR_RootConstrainSelectedInstOperands,
     /*  21154 */     // GIR_Coverage, 13520,
     /*  21154 */     GIR_EraseRootFromParent_Done,
     /*  21155 */   // Label 367: @21155
     /*  21155 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(21203), // Rule ID 13405 //
     /*  21160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21190 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21201 */     GIR_RootConstrainSelectedInstOperands,
     /*  21202 */     // GIR_Coverage, 13405,
     /*  21202 */     GIR_EraseRootFromParent_Done,
     /*  21203 */   // Label 368: @21203
     /*  21203 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(21251), // Rule ID 13487 //
     /*  21208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21238 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21249 */     GIR_RootConstrainSelectedInstOperands,
     /*  21250 */     // GIR_Coverage, 13487,
     /*  21250 */     GIR_EraseRootFromParent_Done,
     /*  21251 */   // Label 369: @21251
     /*  21251 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21299), // Rule ID 13417 //
     /*  21256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21286 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21297 */     GIR_RootConstrainSelectedInstOperands,
     /*  21298 */     // GIR_Coverage, 13417,
     /*  21298 */     GIR_EraseRootFromParent_Done,
     /*  21299 */   // Label 370: @21299
     /*  21299 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21347), // Rule ID 13519 //
     /*  21304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21345 */     GIR_RootConstrainSelectedInstOperands,
     /*  21346 */     // GIR_Coverage, 13519,
     /*  21346 */     GIR_EraseRootFromParent_Done,
     /*  21347 */   // Label 371: @21347
     /*  21347 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21408), // Rule ID 1728 //
     /*  21352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21391 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21406 */     GIR_RootConstrainSelectedInstOperands,
     /*  21407 */     // GIR_Coverage, 1728,
     /*  21407 */     GIR_EraseRootFromParent_Done,
     /*  21408 */   // Label 372: @21408
     /*  21408 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21469), // Rule ID 1818 //
     /*  21413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21452 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21467 */     GIR_RootConstrainSelectedInstOperands,
     /*  21468 */     // GIR_Coverage, 1818,
     /*  21468 */     GIR_EraseRootFromParent_Done,
     /*  21469 */   // Label 373: @21469
     /*  21469 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21517), // Rule ID 1811 //
     /*  21474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21504 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21515 */     GIR_RootConstrainSelectedInstOperands,
     /*  21516 */     // GIR_Coverage, 1811,
     /*  21516 */     GIR_EraseRootFromParent_Done,
     /*  21517 */   // Label 374: @21517
     /*  21517 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21565), // Rule ID 998 //
     /*  21522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21552 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21563 */     GIR_RootConstrainSelectedInstOperands,
     /*  21564 */     // GIR_Coverage, 998,
     /*  21564 */     GIR_EraseRootFromParent_Done,
     /*  21565 */   // Label 375: @21565
     /*  21565 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21613), // Rule ID 1722 //
     /*  21570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21600 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21611 */     GIR_RootConstrainSelectedInstOperands,
     /*  21612 */     // GIR_Coverage, 1722,
     /*  21612 */     GIR_EraseRootFromParent_Done,
     /*  21613 */   // Label 376: @21613
     /*  21613 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21661), // Rule ID 1059 //
     /*  21618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21648 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21659 */     GIR_RootConstrainSelectedInstOperands,
     /*  21660 */     // GIR_Coverage, 1059,
     /*  21660 */     GIR_EraseRootFromParent_Done,
     /*  21661 */   // Label 377: @21661
     /*  21661 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21709), // Rule ID 1810 //
     /*  21666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21696 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21707 */     GIR_RootConstrainSelectedInstOperands,
     /*  21708 */     // GIR_Coverage, 1810,
     /*  21708 */     GIR_EraseRootFromParent_Done,
     /*  21709 */   // Label 378: @21709
     /*  21709 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21736), // Rule ID 1106 //
     /*  21714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21729 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21734 */     GIR_RootConstrainSelectedInstOperands,
     /*  21735 */     // GIR_Coverage, 1106,
     /*  21735 */     GIR_Done,
     /*  21736 */   // Label 379: @21736
     /*  21736 */   GIM_Reject,
     /*  21737 */ // Label 302: @21737
     /*  21737 */ GIM_Reject,
     /*  21738 */ // Label 159: @21738
     /*  21738 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(25235),
     /*  21743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21749 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21885), // Rule ID 5388 //
     /*  21754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21787 */     // MIs[1] Operand 2
     /*  21787 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21818 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21822 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21827 */     // MIs[3] Operand 2
     /*  21827 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21838 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21840 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21867 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21884 */     // GIR_Coverage, 5388,
     /*  21884 */     GIR_EraseRootFromParent_Done,
     /*  21885 */   // Label 381: @21885
     /*  21885 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22021), // Rule ID 5387 //
     /*  21890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21923 */     // MIs[1] Operand 2
     /*  21923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21954 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21958 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21963 */     // MIs[3] Operand 2
     /*  21963 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21976 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22020 */     // GIR_Coverage, 5387,
     /*  22020 */     GIR_EraseRootFromParent_Done,
     /*  22021 */   // Label 382: @22021
     /*  22021 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22157), // Rule ID 5403 //
     /*  22026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22059 */     // MIs[1] Operand 2
     /*  22059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22082 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22086 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22090 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22094 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22099 */     // MIs[3] Operand 2
     /*  22099 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22112 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  22119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22139 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22156 */     // GIR_Coverage, 5403,
     /*  22156 */     GIR_EraseRootFromParent_Done,
     /*  22157 */   // Label 383: @22157
     /*  22157 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22293), // Rule ID 5386 //
     /*  22162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22195 */     // MIs[1] Operand 2
     /*  22195 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22226 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22230 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22235 */     // MIs[3] Operand 2
     /*  22235 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22248 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22275 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22292 */     // GIR_Coverage, 5386,
     /*  22292 */     GIR_EraseRootFromParent_Done,
     /*  22293 */   // Label 384: @22293
     /*  22293 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22429), // Rule ID 5385 //
     /*  22298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22331 */     // MIs[1] Operand 2
     /*  22331 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22358 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22362 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22366 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22371 */     // MIs[3] Operand 2
     /*  22371 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22384 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22428 */     // GIR_Coverage, 5385,
     /*  22428 */     GIR_EraseRootFromParent_Done,
     /*  22429 */   // Label 385: @22429
     /*  22429 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22562), // Rule ID 14040 //
     /*  22434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  22458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  22475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22479 */     // MIs[1] Operand 2
     /*  22479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22490 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  22494 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22498 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22502 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22506 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22510 */     // MIs[5] Rn
     /*  22510 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22515 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22517 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22544 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22561 */     // GIR_Coverage, 14040,
     /*  22561 */     GIR_EraseRootFromParent_Done,
     /*  22562 */   // Label 386: @22562
     /*  22562 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22695), // Rule ID 6982 //
     /*  22567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22620 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22624 */     // MIs[4] Rn
     /*  22624 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22629 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22633 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22637 */     // MIs[3] Operand 2
     /*  22637 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22648 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22650 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22677 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22694 */     // GIR_Coverage, 6982,
     /*  22694 */     GIR_EraseRootFromParent_Done,
     /*  22695 */   // Label 387: @22695
     /*  22695 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22858), // Rule ID 13998 //
     /*  22700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22742 */     // MIs[1] Operand 2
     /*  22742 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22840 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22857 */     // GIR_Coverage, 13998,
     /*  22857 */     GIR_EraseRootFromParent_Done,
     /*  22858 */   // Label 388: @22858
     /*  22858 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23021), // Rule ID 13995 //
     /*  22863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     // MIs[1] Operand 2
     /*  22905 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22922 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22922 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22925 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22929 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22948 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22955 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22968 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22985 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23020 */     // GIR_Coverage, 13995,
     /*  23020 */     GIR_EraseRootFromParent_Done,
     /*  23021 */   // Label 389: @23021
     /*  23021 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23171), // Rule ID 14002 //
     /*  23026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23059 */     // MIs[1] Operand 2
     /*  23059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23076 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23170 */     // GIR_Coverage, 14002,
     /*  23170 */     GIR_EraseRootFromParent_Done,
     /*  23171 */   // Label 390: @23171
     /*  23171 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23321), // Rule ID 14007 //
     /*  23176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23209 */     // MIs[1] Operand 2
     /*  23209 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23226 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23226 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23229 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23233 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23259 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23303 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23320 */     // GIR_Coverage, 14007,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 391: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23471), // Rule ID 14001 //
     /*  23326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23359 */     // MIs[1] Operand 2
     /*  23359 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23376 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23376 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23379 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23383 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23409 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23470 */     // GIR_Coverage, 14001,
     /*  23470 */     GIR_EraseRootFromParent_Done,
     /*  23471 */   // Label 392: @23471
     /*  23471 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23634), // Rule ID 5376 //
     /*  23476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  23504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23522 */     // MIs[1] Operand 2
     /*  23522 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23535 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23561 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23564 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23568 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23571 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  23593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23616 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23633 */     // GIR_Coverage, 5376,
     /*  23633 */     GIR_EraseRootFromParent_Done,
     /*  23634 */   // Label 393: @23634
     /*  23634 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23797), // Rule ID 5373 //
     /*  23639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     // MIs[1] Operand 2
     /*  23685 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23698 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23698 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23701 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23705 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23724 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23731 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23761 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23779 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23796 */     // GIR_Coverage, 5373,
     /*  23796 */     GIR_EraseRootFromParent_Done,
     /*  23797 */   // Label 394: @23797
     /*  23797 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23947), // Rule ID 5398 //
     /*  23802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23839 */     // MIs[1] Operand 2
     /*  23839 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23852 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23852 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23855 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23859 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23878 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23881 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23885 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23929 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23946 */     // GIR_Coverage, 5398,
     /*  23946 */     GIR_EraseRootFromParent_Done,
     /*  23947 */   // Label 395: @23947
     /*  23947 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(24097), // Rule ID 5406 //
     /*  23952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23989 */     // MIs[1] Operand 2
     /*  23989 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24002 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24002 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24005 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24009 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24028 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24035 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  24060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24079 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24096 */     // GIR_Coverage, 5406,
     /*  24096 */     GIR_EraseRootFromParent_Done,
     /*  24097 */   // Label 396: @24097
     /*  24097 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24247), // Rule ID 5397 //
     /*  24102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24139 */     // MIs[1] Operand 2
     /*  24139 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24152 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  24210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24246 */     // GIR_Coverage, 5397,
     /*  24246 */     GIR_EraseRootFromParent_Done,
     /*  24247 */   // Label 397: @24247
     /*  24247 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24316), // Rule ID 13434 //
     /*  24252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24267 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24270 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24299 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24314 */     GIR_RootConstrainSelectedInstOperands,
     /*  24315 */     // GIR_Coverage, 13434,
     /*  24315 */     GIR_EraseRootFromParent_Done,
     /*  24316 */   // Label 398: @24316
     /*  24316 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24385), // Rule ID 13446 //
     /*  24321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24336 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24339 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24368 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24383 */     GIR_RootConstrainSelectedInstOperands,
     /*  24384 */     // GIR_Coverage, 13446,
     /*  24384 */     GIR_EraseRootFromParent_Done,
     /*  24385 */   // Label 399: @24385
     /*  24385 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24441), // Rule ID 13396 //
     /*  24390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24405 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24408 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24428 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24439 */     GIR_RootConstrainSelectedInstOperands,
     /*  24440 */     // GIR_Coverage, 13396,
     /*  24440 */     GIR_EraseRootFromParent_Done,
     /*  24441 */   // Label 400: @24441
     /*  24441 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24497), // Rule ID 13408 //
     /*  24446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24461 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24464 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24484 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24495 */     GIR_RootConstrainSelectedInstOperands,
     /*  24496 */     // GIR_Coverage, 13408,
     /*  24496 */     GIR_EraseRootFromParent_Done,
     /*  24497 */   // Label 401: @24497
     /*  24497 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24564), // Rule ID 13648 //
     /*  24502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24526 */     // MIs[1] imm
     /*  24526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24534 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24538 */     // MIs[2] Operand 1
     /*  24538 */     // No operand predicates
     /*  24538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24548 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24562 */     GIR_RootConstrainSelectedInstOperands,
     /*  24563 */     // GIR_Coverage, 13648,
     /*  24563 */     GIR_EraseRootFromParent_Done,
     /*  24564 */   // Label 402: @24564
     /*  24564 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24631), // Rule ID 13669 //
     /*  24569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24593 */     // MIs[1] imm
     /*  24593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24605 */     // MIs[2] Operand 1
     /*  24605 */     // No operand predicates
     /*  24605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24615 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24629 */     GIR_RootConstrainSelectedInstOperands,
     /*  24630 */     // GIR_Coverage, 13669,
     /*  24630 */     GIR_EraseRootFromParent_Done,
     /*  24631 */   // Label 403: @24631
     /*  24631 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24700), // Rule ID 1361 //
     /*  24636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24683 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24698 */     GIR_RootConstrainSelectedInstOperands,
     /*  24699 */     // GIR_Coverage, 1361,
     /*  24699 */     GIR_EraseRootFromParent_Done,
     /*  24700 */   // Label 404: @24700
     /*  24700 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24769), // Rule ID 1484 //
     /*  24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24752 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24767 */     GIR_RootConstrainSelectedInstOperands,
     /*  24768 */     // GIR_Coverage, 1484,
     /*  24768 */     GIR_EraseRootFromParent_Done,
     /*  24769 */   // Label 405: @24769
     /*  24769 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24825), // Rule ID 989 //
     /*  24774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24812 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24823 */     GIR_RootConstrainSelectedInstOperands,
     /*  24824 */     // GIR_Coverage, 989,
     /*  24824 */     GIR_EraseRootFromParent_Done,
     /*  24825 */   // Label 406: @24825
     /*  24825 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24881), // Rule ID 1050 //
     /*  24830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24868 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24879 */     GIR_RootConstrainSelectedInstOperands,
     /*  24880 */     // GIR_Coverage, 1050,
     /*  24880 */     GIR_EraseRootFromParent_Done,
     /*  24881 */   // Label 407: @24881
     /*  24881 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24948), // Rule ID 2234 //
     /*  24886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24914 */     // MIs[1] imm
     /*  24914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24926 */     // MIs[2] Operand 1
     /*  24926 */     // No operand predicates
     /*  24926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24932 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24946 */     GIR_RootConstrainSelectedInstOperands,
     /*  24947 */     // GIR_Coverage, 2234,
     /*  24947 */     GIR_EraseRootFromParent_Done,
     /*  24948 */   // Label 408: @24948
     /*  24948 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(25015), // Rule ID 2293 //
     /*  24953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24981 */     // MIs[1] imm
     /*  24981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24993 */     // MIs[2] Operand 1
     /*  24993 */     // No operand predicates
     /*  24993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24999 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  25002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  25013 */     GIR_RootConstrainSelectedInstOperands,
     /*  25014 */     // GIR_Coverage, 2293,
     /*  25014 */     GIR_EraseRootFromParent_Done,
     /*  25015 */   // Label 409: @25015
     /*  25015 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25063), // Rule ID 13395 //
     /*  25020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25050 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25061 */     GIR_RootConstrainSelectedInstOperands,
     /*  25062 */     // GIR_Coverage, 13395,
     /*  25062 */     GIR_EraseRootFromParent_Done,
     /*  25063 */   // Label 410: @25063
     /*  25063 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25111), // Rule ID 13407 //
     /*  25068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25098 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25109 */     GIR_RootConstrainSelectedInstOperands,
     /*  25110 */     // GIR_Coverage, 13407,
     /*  25110 */     GIR_EraseRootFromParent_Done,
     /*  25111 */   // Label 411: @25111
     /*  25111 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(25159), // Rule ID 988 //
     /*  25116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25146 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25157 */     GIR_RootConstrainSelectedInstOperands,
     /*  25158 */     // GIR_Coverage, 988,
     /*  25158 */     GIR_EraseRootFromParent_Done,
     /*  25159 */   // Label 412: @25159
     /*  25159 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25207), // Rule ID 1049 //
     /*  25164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25194 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25205 */     GIR_RootConstrainSelectedInstOperands,
     /*  25206 */     // GIR_Coverage, 1049,
     /*  25206 */     GIR_EraseRootFromParent_Done,
     /*  25207 */   // Label 413: @25207
     /*  25207 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25234), // Rule ID 1102 //
     /*  25212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25227 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  25232 */     GIR_RootConstrainSelectedInstOperands,
     /*  25233 */     // GIR_Coverage, 1102,
     /*  25233 */     GIR_Done,
     /*  25234 */   // Label 414: @25234
     /*  25234 */   GIM_Reject,
     /*  25235 */ // Label 380: @25235
     /*  25235 */ GIM_Reject,
     /*  25236 */ // Label 160: @25236
     /*  25236 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(31413),
     /*  25241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25247 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25365), // Rule ID 13572 //
     /*  25252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25295 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25299 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25303 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25316 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25320 */     // MIs[4] Operand 1
     /*  25320 */     // No operand predicates
     /*  25320 */     // MIs[2] Operand 2
     /*  25320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25335 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25344 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25363 */     GIR_RootConstrainSelectedInstOperands,
     /*  25364 */     // GIR_Coverage, 13572,
     /*  25364 */     GIR_EraseRootFromParent_Done,
     /*  25365 */   // Label 416: @25365
     /*  25365 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25483), // Rule ID 13573 //
     /*  25370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25421 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25434 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25438 */     // MIs[4] Operand 1
     /*  25438 */     // No operand predicates
     /*  25438 */     // MIs[2] Operand 2
     /*  25438 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25462 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25481 */     GIR_RootConstrainSelectedInstOperands,
     /*  25482 */     // GIR_Coverage, 13573,
     /*  25482 */     GIR_EraseRootFromParent_Done,
     /*  25483 */   // Label 417: @25483
     /*  25483 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25601), // Rule ID 13608 //
     /*  25488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25535 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25552 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25556 */     // MIs[4] Operand 1
     /*  25556 */     // No operand predicates
     /*  25556 */     // MIs[2] Operand 2
     /*  25556 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25571 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25580 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25599 */     GIR_RootConstrainSelectedInstOperands,
     /*  25600 */     // GIR_Coverage, 13608,
     /*  25600 */     GIR_EraseRootFromParent_Done,
     /*  25601 */   // Label 418: @25601
     /*  25601 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25719), // Rule ID 13609 //
     /*  25606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25653 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25657 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25666 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25670 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25674 */     // MIs[4] Operand 1
     /*  25674 */     // No operand predicates
     /*  25674 */     // MIs[2] Operand 2
     /*  25674 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25689 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25698 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25717 */     GIR_RootConstrainSelectedInstOperands,
     /*  25718 */     // GIR_Coverage, 13609,
     /*  25718 */     GIR_EraseRootFromParent_Done,
     /*  25719 */   // Label 419: @25719
     /*  25719 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25837), // Rule ID 2039 //
     /*  25724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25771 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25775 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25788 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25792 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25796 */     // MIs[4] Operand 1
     /*  25796 */     // No operand predicates
     /*  25796 */     // MIs[2] Operand 2
     /*  25796 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25807 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25816 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25835 */     GIR_RootConstrainSelectedInstOperands,
     /*  25836 */     // GIR_Coverage, 2039,
     /*  25836 */     GIR_EraseRootFromParent_Done,
     /*  25837 */   // Label 420: @25837
     /*  25837 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25955), // Rule ID 13571 //
     /*  25842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25893 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25902 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25906 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25910 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25914 */     // MIs[4] Operand 1
     /*  25914 */     // No operand predicates
     /*  25914 */     // MIs[2] Operand 2
     /*  25914 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25934 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25953 */     GIR_RootConstrainSelectedInstOperands,
     /*  25954 */     // GIR_Coverage, 13571,
     /*  25954 */     GIR_EraseRootFromParent_Done,
     /*  25955 */   // Label 421: @25955
     /*  25955 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26073), // Rule ID 2091 //
     /*  25960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26007 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26011 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26020 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26024 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26028 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26032 */     // MIs[4] Operand 1
     /*  26032 */     // No operand predicates
     /*  26032 */     // MIs[2] Operand 2
     /*  26032 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26043 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26052 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26071 */     GIR_RootConstrainSelectedInstOperands,
     /*  26072 */     // GIR_Coverage, 2091,
     /*  26072 */     GIR_EraseRootFromParent_Done,
     /*  26073 */   // Label 422: @26073
     /*  26073 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26191), // Rule ID 13607 //
     /*  26078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26146 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26150 */     // MIs[4] Operand 1
     /*  26150 */     // No operand predicates
     /*  26150 */     // MIs[2] Operand 2
     /*  26150 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26161 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26170 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26189 */     GIR_RootConstrainSelectedInstOperands,
     /*  26190 */     // GIR_Coverage, 13607,
     /*  26190 */     GIR_EraseRootFromParent_Done,
     /*  26191 */   // Label 423: @26191
     /*  26191 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26278), // Rule ID 13478 //
     /*  26196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26223 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26226 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26235 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26259 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26276 */     GIR_RootConstrainSelectedInstOperands,
     /*  26277 */     // GIR_Coverage, 13478,
     /*  26277 */     GIR_EraseRootFromParent_Done,
     /*  26278 */   // Label 424: @26278
     /*  26278 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26365), // Rule ID 13506 //
     /*  26283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26310 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26313 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26322 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26346 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26363 */     GIR_RootConstrainSelectedInstOperands,
     /*  26364 */     // GIR_Coverage, 13506,
     /*  26364 */     GIR_EraseRootFromParent_Done,
     /*  26365 */   // Label 425: @26365
     /*  26365 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26452), // Rule ID 1695 //
     /*  26370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26401 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26404 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26433 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26450 */     GIR_RootConstrainSelectedInstOperands,
     /*  26451 */     // GIR_Coverage, 1695,
     /*  26451 */     GIR_EraseRootFromParent_Done,
     /*  26452 */   // Label 426: @26452
     /*  26452 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26539), // Rule ID 1773 //
     /*  26457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26488 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26491 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26500 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26520 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26537 */     GIR_RootConstrainSelectedInstOperands,
     /*  26538 */     // GIR_Coverage, 1773,
     /*  26538 */     GIR_EraseRootFromParent_Done,
     /*  26539 */   // Label 427: @26539
     /*  26539 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26654), // Rule ID 13567 //
     /*  26544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26608 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26612 */     // MIs[4] Operand 1
     /*  26612 */     // No operand predicates
     /*  26612 */     // MIs[2] Operand 2
     /*  26612 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26634 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26652 */     GIR_RootConstrainSelectedInstOperands,
     /*  26653 */     // GIR_Coverage, 13567,
     /*  26653 */     GIR_EraseRootFromParent_Done,
     /*  26654 */   // Label 428: @26654
     /*  26654 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26769), // Rule ID 13566 //
     /*  26659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26707 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26711 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26715 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26728 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26732 */     // MIs[4] Operand 1
     /*  26732 */     // No operand predicates
     /*  26732 */     // MIs[2] Operand 2
     /*  26732 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26749 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26767 */     GIR_RootConstrainSelectedInstOperands,
     /*  26768 */     // GIR_Coverage, 13566,
     /*  26768 */     GIR_EraseRootFromParent_Done,
     /*  26769 */   // Label 429: @26769
     /*  26769 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26884), // Rule ID 13603 //
     /*  26774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26830 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26834 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26838 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26842 */     // MIs[4] Operand 1
     /*  26842 */     // No operand predicates
     /*  26842 */     // MIs[2] Operand 2
     /*  26842 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26864 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26882 */     GIR_RootConstrainSelectedInstOperands,
     /*  26883 */     // GIR_Coverage, 13603,
     /*  26883 */     GIR_EraseRootFromParent_Done,
     /*  26884 */   // Label 430: @26884
     /*  26884 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26999), // Rule ID 13602 //
     /*  26889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26941 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26945 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26954 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26958 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26962 */     // MIs[4] Operand 1
     /*  26962 */     // No operand predicates
     /*  26962 */     // MIs[2] Operand 2
     /*  26962 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26979 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26997 */     GIR_RootConstrainSelectedInstOperands,
     /*  26998 */     // GIR_Coverage, 13602,
     /*  26998 */     GIR_EraseRootFromParent_Done,
     /*  26999 */   // Label 431: @26999
     /*  26999 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(27068), // Rule ID 1793 //
     /*  27004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27051 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27066 */     GIR_RootConstrainSelectedInstOperands,
     /*  27067 */     // GIR_Coverage, 1793,
     /*  27067 */     GIR_EraseRootFromParent_Done,
     /*  27068 */   // Label 432: @27068
     /*  27068 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27137), // Rule ID 1792 //
     /*  27073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27120 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27135 */     GIR_RootConstrainSelectedInstOperands,
     /*  27136 */     // GIR_Coverage, 1792,
     /*  27136 */     GIR_EraseRootFromParent_Done,
     /*  27137 */   // Label 433: @27137
     /*  27137 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27206), // Rule ID 1715 //
     /*  27142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27189 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  27192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27204 */     GIR_RootConstrainSelectedInstOperands,
     /*  27205 */     // GIR_Coverage, 1715,
     /*  27205 */     GIR_EraseRootFromParent_Done,
     /*  27206 */   // Label 434: @27206
     /*  27206 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27275), // Rule ID 1791 //
     /*  27211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27258 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27273 */     GIR_RootConstrainSelectedInstOperands,
     /*  27274 */     // GIR_Coverage, 1791,
     /*  27274 */     GIR_EraseRootFromParent_Done,
     /*  27275 */   // Label 435: @27275
     /*  27275 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27344), // Rule ID 1790 //
     /*  27280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27327 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27342 */     GIR_RootConstrainSelectedInstOperands,
     /*  27343 */     // GIR_Coverage, 1790,
     /*  27343 */     GIR_EraseRootFromParent_Done,
     /*  27344 */   // Label 436: @27344
     /*  27344 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27459), // Rule ID 13565 //
     /*  27349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27413 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27417 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27421 */     // MIs[4] Operand 1
     /*  27421 */     // No operand predicates
     /*  27421 */     // MIs[2] Operand 2
     /*  27421 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27439 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27457 */     GIR_RootConstrainSelectedInstOperands,
     /*  27458 */     // GIR_Coverage, 13565,
     /*  27458 */     GIR_EraseRootFromParent_Done,
     /*  27459 */   // Label 437: @27459
     /*  27459 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27574), // Rule ID 2037 //
     /*  27464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27524 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27533 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27537 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27541 */     // MIs[4] Operand 1
     /*  27541 */     // No operand predicates
     /*  27541 */     // MIs[2] Operand 2
     /*  27541 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27552 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27554 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27572 */     GIR_RootConstrainSelectedInstOperands,
     /*  27573 */     // GIR_Coverage, 2037,
     /*  27573 */     GIR_EraseRootFromParent_Done,
     /*  27574 */   // Label 438: @27574
     /*  27574 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27689), // Rule ID 13601 //
     /*  27579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27626 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27630 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27634 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27647 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27651 */     // MIs[4] Operand 1
     /*  27651 */     // No operand predicates
     /*  27651 */     // MIs[2] Operand 2
     /*  27651 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27667 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27669 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27687 */     GIR_RootConstrainSelectedInstOperands,
     /*  27688 */     // GIR_Coverage, 13601,
     /*  27688 */     GIR_EraseRootFromParent_Done,
     /*  27689 */   // Label 439: @27689
     /*  27689 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27804), // Rule ID 2089 //
     /*  27694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27746 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27750 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27754 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27759 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27763 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27767 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27771 */     // MIs[4] Operand 1
     /*  27771 */     // No operand predicates
     /*  27771 */     // MIs[2] Operand 2
     /*  27771 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27782 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27784 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27802 */     GIR_RootConstrainSelectedInstOperands,
     /*  27803 */     // GIR_Coverage, 2089,
     /*  27803 */     GIR_EraseRootFromParent_Done,
     /*  27804 */   // Label 440: @27804
     /*  27804 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27871), // Rule ID 13492 //
     /*  27809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27852 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27869 */     GIR_RootConstrainSelectedInstOperands,
     /*  27870 */     // GIR_Coverage, 13492,
     /*  27870 */     GIR_EraseRootFromParent_Done,
     /*  27871 */   // Label 441: @27871
     /*  27871 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27938), // Rule ID 13526 //
     /*  27876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27919 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27936 */     GIR_RootConstrainSelectedInstOperands,
     /*  27937 */     // GIR_Coverage, 13526,
     /*  27937 */     GIR_EraseRootFromParent_Done,
     /*  27938 */   // Label 442: @27938
     /*  27938 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(28005), // Rule ID 1727 //
     /*  27943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27986 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28003 */     GIR_RootConstrainSelectedInstOperands,
     /*  28004 */     // GIR_Coverage, 1727,
     /*  28004 */     GIR_EraseRootFromParent_Done,
     /*  28005 */   // Label 443: @28005
     /*  28005 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(28072), // Rule ID 1817 //
     /*  28010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28053 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  28056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  28065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28070 */     GIR_RootConstrainSelectedInstOperands,
     /*  28071 */     // GIR_Coverage, 1817,
     /*  28071 */     GIR_EraseRootFromParent_Done,
     /*  28072 */   // Label 444: @28072
     /*  28072 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28153), // Rule ID 13476 //
     /*  28077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28104 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28107 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28116 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28136 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28151 */     GIR_RootConstrainSelectedInstOperands,
     /*  28152 */     // GIR_Coverage, 13476,
     /*  28152 */     GIR_EraseRootFromParent_Done,
     /*  28153 */   // Label 445: @28153
     /*  28153 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28234), // Rule ID 13504 //
     /*  28158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28185 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28188 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28197 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28217 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28232 */     GIR_RootConstrainSelectedInstOperands,
     /*  28233 */     // GIR_Coverage, 13504,
     /*  28233 */     GIR_EraseRootFromParent_Done,
     /*  28234 */   // Label 446: @28234
     /*  28234 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28315), // Rule ID 1693 //
     /*  28239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28270 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28273 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28282 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28298 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28313 */     GIR_RootConstrainSelectedInstOperands,
     /*  28314 */     // GIR_Coverage, 1693,
     /*  28314 */     GIR_EraseRootFromParent_Done,
     /*  28315 */   // Label 447: @28315
     /*  28315 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28396), // Rule ID 1771 //
     /*  28320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28351 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28354 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28363 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28379 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28394 */     GIR_RootConstrainSelectedInstOperands,
     /*  28395 */     // GIR_Coverage, 1771,
     /*  28395 */     GIR_EraseRootFromParent_Done,
     /*  28396 */   // Label 448: @28396
     /*  28396 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28488), // Rule ID 13570 //
     /*  28401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28453 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28457 */     // MIs[3] Operand 1
     /*  28457 */     // No operand predicates
     /*  28457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28468 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28486 */     GIR_RootConstrainSelectedInstOperands,
     /*  28487 */     // GIR_Coverage, 13570,
     /*  28487 */     GIR_EraseRootFromParent_Done,
     /*  28488 */   // Label 449: @28488
     /*  28488 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28580), // Rule ID 13569 //
     /*  28493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28554 */     // MIs[3] Operand 1
     /*  28554 */     // No operand predicates
     /*  28554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28560 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28578 */     GIR_RootConstrainSelectedInstOperands,
     /*  28579 */     // GIR_Coverage, 13569,
     /*  28579 */     GIR_EraseRootFromParent_Done,
     /*  28580 */   // Label 450: @28580
     /*  28580 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28672), // Rule ID 13606 //
     /*  28585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28637 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28641 */     // MIs[3] Operand 1
     /*  28641 */     // No operand predicates
     /*  28641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28652 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28670 */     GIR_RootConstrainSelectedInstOperands,
     /*  28671 */     // GIR_Coverage, 13606,
     /*  28671 */     GIR_EraseRootFromParent_Done,
     /*  28672 */   // Label 451: @28672
     /*  28672 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28764), // Rule ID 13605 //
     /*  28677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28738 */     // MIs[3] Operand 1
     /*  28738 */     // No operand predicates
     /*  28738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28744 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28762 */     GIR_RootConstrainSelectedInstOperands,
     /*  28763 */     // GIR_Coverage, 13605,
     /*  28763 */     GIR_EraseRootFromParent_Done,
     /*  28764 */   // Label 452: @28764
     /*  28764 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28856), // Rule ID 13568 //
     /*  28769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28829 */     // MIs[3] Operand 1
     /*  28829 */     // No operand predicates
     /*  28829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28836 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28854 */     GIR_RootConstrainSelectedInstOperands,
     /*  28855 */     // GIR_Coverage, 13568,
     /*  28855 */     GIR_EraseRootFromParent_Done,
     /*  28856 */   // Label 453: @28856
     /*  28856 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28948), // Rule ID 2038 //
     /*  28861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28926 */     // MIs[3] Operand 1
     /*  28926 */     // No operand predicates
     /*  28926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28928 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28946 */     GIR_RootConstrainSelectedInstOperands,
     /*  28947 */     // GIR_Coverage, 2038,
     /*  28947 */     GIR_EraseRootFromParent_Done,
     /*  28948 */   // Label 454: @28948
     /*  28948 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(29040), // Rule ID 13604 //
     /*  28953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29013 */     // MIs[3] Operand 1
     /*  29013 */     // No operand predicates
     /*  29013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29020 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29038 */     GIR_RootConstrainSelectedInstOperands,
     /*  29039 */     // GIR_Coverage, 13604,
     /*  29039 */     GIR_EraseRootFromParent_Done,
     /*  29040 */   // Label 455: @29040
     /*  29040 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(29132), // Rule ID 2090 //
     /*  29045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  29064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  29072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  29085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  29093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29110 */     // MIs[3] Operand 1
     /*  29110 */     // No operand predicates
     /*  29110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29112 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29130 */     GIR_RootConstrainSelectedInstOperands,
     /*  29131 */     // GIR_Coverage, 2090,
     /*  29131 */     GIR_EraseRootFromParent_Done,
     /*  29132 */   // Label 456: @29132
     /*  29132 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(29183), // Rule ID 13518 //
     /*  29137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29169 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29181 */     GIR_RootConstrainSelectedInstOperands,
     /*  29182 */     // GIR_Coverage, 13518,
     /*  29182 */     GIR_EraseRootFromParent_Done,
     /*  29183 */   // Label 457: @29183
     /*  29183 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(29234), // Rule ID 13486 //
     /*  29188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29220 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29232 */     GIR_RootConstrainSelectedInstOperands,
     /*  29233 */     // GIR_Coverage, 13486,
     /*  29233 */     GIR_EraseRootFromParent_Done,
     /*  29234 */   // Label 458: @29234
     /*  29234 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29285), // Rule ID 13517 //
     /*  29239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29271 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29283 */     GIR_RootConstrainSelectedInstOperands,
     /*  29284 */     // GIR_Coverage, 13517,
     /*  29284 */     GIR_EraseRootFromParent_Done,
     /*  29285 */   // Label 459: @29285
     /*  29285 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29336), // Rule ID 1809 //
     /*  29290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29334 */     GIR_RootConstrainSelectedInstOperands,
     /*  29335 */     // GIR_Coverage, 1809,
     /*  29335 */     GIR_EraseRootFromParent_Done,
     /*  29336 */   // Label 460: @29336
     /*  29336 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29387), // Rule ID 1721 //
     /*  29341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29373 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29385 */     GIR_RootConstrainSelectedInstOperands,
     /*  29386 */     // GIR_Coverage, 1721,
     /*  29386 */     GIR_EraseRootFromParent_Done,
     /*  29387 */   // Label 461: @29387
     /*  29387 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29438), // Rule ID 1808 //
     /*  29392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29424 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29436 */     GIR_RootConstrainSelectedInstOperands,
     /*  29437 */     // GIR_Coverage, 1808,
     /*  29437 */     GIR_EraseRootFromParent_Done,
     /*  29438 */   // Label 462: @29438
     /*  29438 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29507), // Rule ID 13440 //
     /*  29443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29458 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29461 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29470 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29490 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29505 */     GIR_RootConstrainSelectedInstOperands,
     /*  29506 */     // GIR_Coverage, 13440,
     /*  29506 */     GIR_EraseRootFromParent_Done,
     /*  29507 */   // Label 463: @29507
     /*  29507 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29576), // Rule ID 13452 //
     /*  29512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29559 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29574 */     GIR_RootConstrainSelectedInstOperands,
     /*  29575 */     // GIR_Coverage, 13452,
     /*  29575 */     GIR_EraseRootFromParent_Done,
     /*  29576 */   // Label 464: @29576
     /*  29576 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29632), // Rule ID 13402 //
     /*  29581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29596 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29599 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29619 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29630 */     GIR_RootConstrainSelectedInstOperands,
     /*  29631 */     // GIR_Coverage, 13402,
     /*  29631 */     GIR_EraseRootFromParent_Done,
     /*  29632 */   // Label 465: @29632
     /*  29632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29688), // Rule ID 13414 //
     /*  29637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29652 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29655 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29675 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29686 */     GIR_RootConstrainSelectedInstOperands,
     /*  29687 */     // GIR_Coverage, 13414,
     /*  29687 */     GIR_EraseRootFromParent_Done,
     /*  29688 */   // Label 466: @29688
     /*  29688 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29755), // Rule ID 13654 //
     /*  29693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29717 */     // MIs[1] imm
     /*  29717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29725 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29729 */     // MIs[2] Operand 1
     /*  29729 */     // No operand predicates
     /*  29729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29739 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29753 */     GIR_RootConstrainSelectedInstOperands,
     /*  29754 */     // GIR_Coverage, 13654,
     /*  29754 */     GIR_EraseRootFromParent_Done,
     /*  29755 */   // Label 467: @29755
     /*  29755 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29822), // Rule ID 13675 //
     /*  29760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29784 */     // MIs[1] imm
     /*  29784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29792 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29796 */     // MIs[2] Operand 1
     /*  29796 */     // No operand predicates
     /*  29796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29806 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29820 */     GIR_RootConstrainSelectedInstOperands,
     /*  29821 */     // GIR_Coverage, 13675,
     /*  29821 */     GIR_EraseRootFromParent_Done,
     /*  29822 */   // Label 468: @29822
     /*  29822 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29891), // Rule ID 1367 //
     /*  29827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29874 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29889 */     GIR_RootConstrainSelectedInstOperands,
     /*  29890 */     // GIR_Coverage, 1367,
     /*  29890 */     GIR_EraseRootFromParent_Done,
     /*  29891 */   // Label 469: @29891
     /*  29891 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29960), // Rule ID 1490 //
     /*  29896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29943 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29958 */     GIR_RootConstrainSelectedInstOperands,
     /*  29959 */     // GIR_Coverage, 1490,
     /*  29959 */     GIR_EraseRootFromParent_Done,
     /*  29960 */   // Label 470: @29960
     /*  29960 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(30016), // Rule ID 995 //
     /*  29965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30003 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30014 */     GIR_RootConstrainSelectedInstOperands,
     /*  30015 */     // GIR_Coverage, 995,
     /*  30015 */     GIR_EraseRootFromParent_Done,
     /*  30016 */   // Label 471: @30016
     /*  30016 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(30072), // Rule ID 1056 //
     /*  30021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  30043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  30048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30059 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30070 */     GIR_RootConstrainSelectedInstOperands,
     /*  30071 */     // GIR_Coverage, 1056,
     /*  30071 */     GIR_EraseRootFromParent_Done,
     /*  30072 */   // Label 472: @30072
     /*  30072 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(30139), // Rule ID 2240 //
     /*  30077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  30096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30105 */     // MIs[1] imm
     /*  30105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30117 */     // MIs[2] Operand 1
     /*  30117 */     // No operand predicates
     /*  30117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30123 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  30126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30137 */     GIR_RootConstrainSelectedInstOperands,
     /*  30138 */     // GIR_Coverage, 2240,
     /*  30138 */     GIR_EraseRootFromParent_Done,
     /*  30139 */   // Label 473: @30139
     /*  30139 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(30206), // Rule ID 2299 //
     /*  30144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  30163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30172 */     // MIs[1] imm
     /*  30172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30184 */     // MIs[2] Operand 1
     /*  30184 */     // No operand predicates
     /*  30184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30190 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  30193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30204 */     GIR_RootConstrainSelectedInstOperands,
     /*  30205 */     // GIR_Coverage, 2299,
     /*  30205 */     GIR_EraseRootFromParent_Done,
     /*  30206 */   // Label 474: @30206
     /*  30206 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30276), // Rule ID 6978 //
     /*  30211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  30223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30249 */     // MIs[2] Rn
     /*  30249 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30254 */     // MIs[2] Rm
     /*  30254 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30261 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30274 */     GIR_RootConstrainSelectedInstOperands,
     /*  30275 */     // GIR_Coverage, 6978,
     /*  30275 */     GIR_EraseRootFromParent_Done,
     /*  30276 */   // Label 475: @30276
     /*  30276 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30346), // Rule ID 14036 //
     /*  30281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  30293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  30319 */     // MIs[2] Rn
     /*  30319 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30324 */     // MIs[2] Rm
     /*  30324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30331 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30344 */     GIR_RootConstrainSelectedInstOperands,
     /*  30345 */     // GIR_Coverage, 14036,
     /*  30345 */     GIR_EraseRootFromParent_Done,
     /*  30346 */   // Label 476: @30346
     /*  30346 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30409), // Rule ID 1789 //
     /*  30351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30394 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30407 */     GIR_RootConstrainSelectedInstOperands,
     /*  30408 */     // GIR_Coverage, 1789,
     /*  30408 */     GIR_EraseRootFromParent_Done,
     /*  30409 */   // Label 477: @30409
     /*  30409 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30472), // Rule ID 1788 //
     /*  30414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30457 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1788,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 478: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30535), // Rule ID 1714 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30520 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  30523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30533 */     GIR_RootConstrainSelectedInstOperands,
     /*  30534 */     // GIR_Coverage, 1714,
     /*  30534 */     GIR_EraseRootFromParent_Done,
     /*  30535 */   // Label 479: @30535
     /*  30535 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30598), // Rule ID 1787 //
     /*  30540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30583 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30596 */     GIR_RootConstrainSelectedInstOperands,
     /*  30597 */     // GIR_Coverage, 1787,
     /*  30597 */     GIR_EraseRootFromParent_Done,
     /*  30598 */   // Label 480: @30598
     /*  30598 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30661), // Rule ID 1786 //
     /*  30603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30659 */     GIR_RootConstrainSelectedInstOperands,
     /*  30660 */     // GIR_Coverage, 1786,
     /*  30660 */     GIR_EraseRootFromParent_Done,
     /*  30661 */   // Label 481: @30661
     /*  30661 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30722), // Rule ID 13491 //
     /*  30666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30705 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30720 */     GIR_RootConstrainSelectedInstOperands,
     /*  30721 */     // GIR_Coverage, 13491,
     /*  30721 */     GIR_EraseRootFromParent_Done,
     /*  30722 */   // Label 482: @30722
     /*  30722 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30783), // Rule ID 13525 //
     /*  30727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30766 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30781 */     GIR_RootConstrainSelectedInstOperands,
     /*  30782 */     // GIR_Coverage, 13525,
     /*  30782 */     GIR_EraseRootFromParent_Done,
     /*  30783 */   // Label 483: @30783
     /*  30783 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30831), // Rule ID 13516 //
     /*  30788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30818 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30829 */     GIR_RootConstrainSelectedInstOperands,
     /*  30830 */     // GIR_Coverage, 13516,
     /*  30830 */     GIR_EraseRootFromParent_Done,
     /*  30831 */   // Label 484: @30831
     /*  30831 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30879), // Rule ID 13401 //
     /*  30836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30866 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30877 */     GIR_RootConstrainSelectedInstOperands,
     /*  30878 */     // GIR_Coverage, 13401,
     /*  30878 */     GIR_EraseRootFromParent_Done,
     /*  30879 */   // Label 485: @30879
     /*  30879 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30927), // Rule ID 13485 //
     /*  30884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30914 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30925 */     GIR_RootConstrainSelectedInstOperands,
     /*  30926 */     // GIR_Coverage, 13485,
     /*  30926 */     GIR_EraseRootFromParent_Done,
     /*  30927 */   // Label 486: @30927
     /*  30927 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30975), // Rule ID 13413 //
     /*  30932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30962 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30973 */     GIR_RootConstrainSelectedInstOperands,
     /*  30974 */     // GIR_Coverage, 13413,
     /*  30974 */     GIR_EraseRootFromParent_Done,
     /*  30975 */   // Label 487: @30975
     /*  30975 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(31023), // Rule ID 13515 //
     /*  30980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31010 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31021 */     GIR_RootConstrainSelectedInstOperands,
     /*  31022 */     // GIR_Coverage, 13515,
     /*  31022 */     GIR_EraseRootFromParent_Done,
     /*  31023 */   // Label 488: @31023
     /*  31023 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(31084), // Rule ID 1726 //
     /*  31028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  31047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31067 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  31070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31082 */     GIR_RootConstrainSelectedInstOperands,
     /*  31083 */     // GIR_Coverage, 1726,
     /*  31083 */     GIR_EraseRootFromParent_Done,
     /*  31084 */   // Label 489: @31084
     /*  31084 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(31145), // Rule ID 1816 //
     /*  31089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  31108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31128 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  31131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31143 */     GIR_RootConstrainSelectedInstOperands,
     /*  31144 */     // GIR_Coverage, 1816,
     /*  31144 */     GIR_EraseRootFromParent_Done,
     /*  31145 */   // Label 490: @31145
     /*  31145 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31193), // Rule ID 1807 //
     /*  31150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31180 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31191 */     GIR_RootConstrainSelectedInstOperands,
     /*  31192 */     // GIR_Coverage, 1807,
     /*  31192 */     GIR_EraseRootFromParent_Done,
     /*  31193 */   // Label 491: @31193
     /*  31193 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(31241), // Rule ID 994 //
     /*  31198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  31217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31228 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  31231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31239 */     GIR_RootConstrainSelectedInstOperands,
     /*  31240 */     // GIR_Coverage, 994,
     /*  31240 */     GIR_EraseRootFromParent_Done,
     /*  31241 */   // Label 492: @31241
     /*  31241 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31289), // Rule ID 1720 //
     /*  31246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31276 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  31279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31287 */     GIR_RootConstrainSelectedInstOperands,
     /*  31288 */     // GIR_Coverage, 1720,
     /*  31288 */     GIR_EraseRootFromParent_Done,
     /*  31289 */   // Label 493: @31289
     /*  31289 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31337), // Rule ID 1055 //
     /*  31294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  31313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31324 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  31327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31335 */     GIR_RootConstrainSelectedInstOperands,
     /*  31336 */     // GIR_Coverage, 1055,
     /*  31336 */     GIR_EraseRootFromParent_Done,
     /*  31337 */   // Label 494: @31337
     /*  31337 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31385), // Rule ID 1806 //
     /*  31342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31372 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31383 */     GIR_RootConstrainSelectedInstOperands,
     /*  31384 */     // GIR_Coverage, 1806,
     /*  31384 */     GIR_EraseRootFromParent_Done,
     /*  31385 */   // Label 495: @31385
     /*  31385 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31412), // Rule ID 1105 //
     /*  31390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31405 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  31405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  31410 */     GIR_RootConstrainSelectedInstOperands,
     /*  31411 */     // GIR_Coverage, 1105,
     /*  31411 */     GIR_Done,
     /*  31412 */   // Label 496: @31412
     /*  31412 */   GIM_Reject,
     /*  31413 */ // Label 415: @31413
     /*  31413 */ GIM_Reject,
     /*  31414 */ // Label 161: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(32263),
     /*  31419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31425 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31558), // Rule ID 14041 //
     /*  31430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  31454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  31471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31475 */     // MIs[1] Operand 2
     /*  31475 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  31486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31494 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31498 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31502 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31506 */     // MIs[5] Rn
     /*  31506 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31511 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31513 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31557 */     // GIR_Coverage, 14041,
     /*  31557 */     GIR_EraseRootFromParent_Done,
     /*  31558 */   // Label 498: @31558
     /*  31558 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31691), // Rule ID 6983 //
     /*  31563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  31600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31620 */     // MIs[4] Rn
     /*  31620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31625 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31629 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31633 */     // MIs[3] Operand 2
     /*  31633 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31644 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31646 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31673 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31690 */     // GIR_Coverage, 6983,
     /*  31690 */     GIR_EraseRootFromParent_Done,
     /*  31691 */   // Label 499: @31691
     /*  31691 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31760), // Rule ID 13430 //
     /*  31696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31711 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31714 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31723 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31743 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31758 */     GIR_RootConstrainSelectedInstOperands,
     /*  31759 */     // GIR_Coverage, 13430,
     /*  31759 */     GIR_EraseRootFromParent_Done,
     /*  31760 */   // Label 500: @31760
     /*  31760 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31829), // Rule ID 13442 //
     /*  31765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31780 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31783 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31792 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31812 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31827 */     GIR_RootConstrainSelectedInstOperands,
     /*  31828 */     // GIR_Coverage, 13442,
     /*  31828 */     GIR_EraseRootFromParent_Done,
     /*  31829 */   // Label 501: @31829
     /*  31829 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31896), // Rule ID 13644 //
     /*  31834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31858 */     // MIs[1] imm
     /*  31858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31870 */     // MIs[2] Operand 1
     /*  31870 */     // No operand predicates
     /*  31870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31880 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31894 */     GIR_RootConstrainSelectedInstOperands,
     /*  31895 */     // GIR_Coverage, 13644,
     /*  31895 */     GIR_EraseRootFromParent_Done,
     /*  31896 */   // Label 502: @31896
     /*  31896 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31963), // Rule ID 13665 //
     /*  31901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31925 */     // MIs[1] imm
     /*  31925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31937 */     // MIs[2] Operand 1
     /*  31937 */     // No operand predicates
     /*  31937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31947 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31961 */     GIR_RootConstrainSelectedInstOperands,
     /*  31962 */     // GIR_Coverage, 13665,
     /*  31962 */     GIR_EraseRootFromParent_Done,
     /*  31963 */   // Label 503: @31963
     /*  31963 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(32032), // Rule ID 1357 //
     /*  31968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31987 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31990 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32015 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  32018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32030 */     GIR_RootConstrainSelectedInstOperands,
     /*  32031 */     // GIR_Coverage, 1357,
     /*  32031 */     GIR_EraseRootFromParent_Done,
     /*  32032 */   // Label 504: @32032
     /*  32032 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(32101), // Rule ID 1480 //
     /*  32037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32084 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  32087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32099 */     GIR_RootConstrainSelectedInstOperands,
     /*  32100 */     // GIR_Coverage, 1480,
     /*  32100 */     GIR_EraseRootFromParent_Done,
     /*  32101 */   // Label 505: @32101
     /*  32101 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(32168), // Rule ID 2230 //
     /*  32106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32134 */     // MIs[1] imm
     /*  32134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32146 */     // MIs[2] Operand 1
     /*  32146 */     // No operand predicates
     /*  32146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32152 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  32155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32166 */     GIR_RootConstrainSelectedInstOperands,
     /*  32167 */     // GIR_Coverage, 2230,
     /*  32167 */     GIR_EraseRootFromParent_Done,
     /*  32168 */   // Label 506: @32168
     /*  32168 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32235), // Rule ID 2289 //
     /*  32173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32201 */     // MIs[1] imm
     /*  32201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32213 */     // MIs[2] Operand 1
     /*  32213 */     // No operand predicates
     /*  32213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32219 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  32222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32233 */     GIR_RootConstrainSelectedInstOperands,
     /*  32234 */     // GIR_Coverage, 2289,
     /*  32234 */     GIR_EraseRootFromParent_Done,
     /*  32235 */   // Label 507: @32235
     /*  32235 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32262), // Rule ID 1100 //
     /*  32240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32255 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  32260 */     GIR_RootConstrainSelectedInstOperands,
     /*  32261 */     // GIR_Coverage, 1100,
     /*  32261 */     GIR_Done,
     /*  32262 */   // Label 508: @32262
     /*  32262 */   GIM_Reject,
     /*  32263 */ // Label 497: @32263
     /*  32263 */ GIM_Reject,
     /*  32264 */ // Label 162: @32264
     /*  32264 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(35841),
     /*  32269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32275 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32362), // Rule ID 13474 //
     /*  32280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32307 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32310 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32343 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32360 */     GIR_RootConstrainSelectedInstOperands,
     /*  32361 */     // GIR_Coverage, 13474,
     /*  32361 */     GIR_EraseRootFromParent_Done,
     /*  32362 */   // Label 510: @32362
     /*  32362 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32449), // Rule ID 13502 //
     /*  32367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32394 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32397 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32406 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32430 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32447 */     GIR_RootConstrainSelectedInstOperands,
     /*  32448 */     // GIR_Coverage, 13502,
     /*  32448 */     GIR_EraseRootFromParent_Done,
     /*  32449 */   // Label 511: @32449
     /*  32449 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32536), // Rule ID 1691 //
     /*  32454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32485 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32488 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32497 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32517 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32534 */     GIR_RootConstrainSelectedInstOperands,
     /*  32535 */     // GIR_Coverage, 1691,
     /*  32535 */     GIR_EraseRootFromParent_Done,
     /*  32536 */   // Label 512: @32536
     /*  32536 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32623), // Rule ID 1769 //
     /*  32541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32572 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32575 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32584 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32604 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32621 */     GIR_RootConstrainSelectedInstOperands,
     /*  32622 */     // GIR_Coverage, 1769,
     /*  32622 */     GIR_EraseRootFromParent_Done,
     /*  32623 */   // Label 513: @32623
     /*  32623 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32692), // Rule ID 1785 //
     /*  32628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32675 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32690 */     GIR_RootConstrainSelectedInstOperands,
     /*  32691 */     // GIR_Coverage, 1785,
     /*  32691 */     GIR_EraseRootFromParent_Done,
     /*  32692 */   // Label 514: @32692
     /*  32692 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32761), // Rule ID 1784 //
     /*  32697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32744 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32759 */     GIR_RootConstrainSelectedInstOperands,
     /*  32760 */     // GIR_Coverage, 1784,
     /*  32760 */     GIR_EraseRootFromParent_Done,
     /*  32761 */   // Label 515: @32761
     /*  32761 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32830), // Rule ID 1713 //
     /*  32766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32813 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32828 */     GIR_RootConstrainSelectedInstOperands,
     /*  32829 */     // GIR_Coverage, 1713,
     /*  32829 */     GIR_EraseRootFromParent_Done,
     /*  32830 */   // Label 516: @32830
     /*  32830 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32899), // Rule ID 1783 //
     /*  32835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32882 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32897 */     GIR_RootConstrainSelectedInstOperands,
     /*  32898 */     // GIR_Coverage, 1783,
     /*  32898 */     GIR_EraseRootFromParent_Done,
     /*  32899 */   // Label 517: @32899
     /*  32899 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32968), // Rule ID 1782 //
     /*  32904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32951 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32966 */     GIR_RootConstrainSelectedInstOperands,
     /*  32967 */     // GIR_Coverage, 1782,
     /*  32967 */     GIR_EraseRootFromParent_Done,
     /*  32968 */   // Label 518: @32968
     /*  32968 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(33035), // Rule ID 13490 //
     /*  32973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33016 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33033 */     GIR_RootConstrainSelectedInstOperands,
     /*  33034 */     // GIR_Coverage, 13490,
     /*  33034 */     GIR_EraseRootFromParent_Done,
     /*  33035 */   // Label 519: @33035
     /*  33035 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(33102), // Rule ID 13524 //
     /*  33040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33083 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33100 */     GIR_RootConstrainSelectedInstOperands,
     /*  33101 */     // GIR_Coverage, 13524,
     /*  33101 */     GIR_EraseRootFromParent_Done,
     /*  33102 */   // Label 520: @33102
     /*  33102 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(33169), // Rule ID 1725 //
     /*  33107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33150 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33167 */     GIR_RootConstrainSelectedInstOperands,
     /*  33168 */     // GIR_Coverage, 1725,
     /*  33168 */     GIR_EraseRootFromParent_Done,
     /*  33169 */   // Label 521: @33169
     /*  33169 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33236), // Rule ID 1815 //
     /*  33174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33217 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33234 */     GIR_RootConstrainSelectedInstOperands,
     /*  33235 */     // GIR_Coverage, 1815,
     /*  33235 */     GIR_EraseRootFromParent_Done,
     /*  33236 */   // Label 522: @33236
     /*  33236 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33317), // Rule ID 13472 //
     /*  33241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33268 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33271 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33280 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33300 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33315 */     GIR_RootConstrainSelectedInstOperands,
     /*  33316 */     // GIR_Coverage, 13472,
     /*  33316 */     GIR_EraseRootFromParent_Done,
     /*  33317 */   // Label 523: @33317
     /*  33317 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33398), // Rule ID 13500 //
     /*  33322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33349 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33352 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33361 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33381 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33396 */     GIR_RootConstrainSelectedInstOperands,
     /*  33397 */     // GIR_Coverage, 13500,
     /*  33397 */     GIR_EraseRootFromParent_Done,
     /*  33398 */   // Label 524: @33398
     /*  33398 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33479), // Rule ID 1689 //
     /*  33403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33434 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33437 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33446 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33462 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33477 */     GIR_RootConstrainSelectedInstOperands,
     /*  33478 */     // GIR_Coverage, 1689,
     /*  33478 */     GIR_EraseRootFromParent_Done,
     /*  33479 */   // Label 525: @33479
     /*  33479 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33560), // Rule ID 1767 //
     /*  33484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33515 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33518 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33527 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33543 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33558 */     GIR_RootConstrainSelectedInstOperands,
     /*  33559 */     // GIR_Coverage, 1767,
     /*  33559 */     GIR_EraseRootFromParent_Done,
     /*  33560 */   // Label 526: @33560
     /*  33560 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33611), // Rule ID 13514 //
     /*  33565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33597 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33609 */     GIR_RootConstrainSelectedInstOperands,
     /*  33610 */     // GIR_Coverage, 13514,
     /*  33610 */     GIR_EraseRootFromParent_Done,
     /*  33611 */   // Label 527: @33611
     /*  33611 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33662), // Rule ID 13484 //
     /*  33616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33648 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33660 */     GIR_RootConstrainSelectedInstOperands,
     /*  33661 */     // GIR_Coverage, 13484,
     /*  33661 */     GIR_EraseRootFromParent_Done,
     /*  33662 */   // Label 528: @33662
     /*  33662 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33713), // Rule ID 13513 //
     /*  33667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33699 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33711 */     GIR_RootConstrainSelectedInstOperands,
     /*  33712 */     // GIR_Coverage, 13513,
     /*  33712 */     GIR_EraseRootFromParent_Done,
     /*  33713 */   // Label 529: @33713
     /*  33713 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33764), // Rule ID 1805 //
     /*  33718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33750 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33762 */     GIR_RootConstrainSelectedInstOperands,
     /*  33763 */     // GIR_Coverage, 1805,
     /*  33763 */     GIR_EraseRootFromParent_Done,
     /*  33764 */   // Label 530: @33764
     /*  33764 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33815), // Rule ID 1719 //
     /*  33769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33801 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33813 */     GIR_RootConstrainSelectedInstOperands,
     /*  33814 */     // GIR_Coverage, 1719,
     /*  33814 */     GIR_EraseRootFromParent_Done,
     /*  33815 */   // Label 531: @33815
     /*  33815 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33866), // Rule ID 1804 //
     /*  33820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33852 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33864 */     GIR_RootConstrainSelectedInstOperands,
     /*  33865 */     // GIR_Coverage, 1804,
     /*  33865 */     GIR_EraseRootFromParent_Done,
     /*  33866 */   // Label 532: @33866
     /*  33866 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33935), // Rule ID 13436 //
     /*  33871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33886 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33889 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33898 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33918 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33933 */     GIR_RootConstrainSelectedInstOperands,
     /*  33934 */     // GIR_Coverage, 13436,
     /*  33934 */     GIR_EraseRootFromParent_Done,
     /*  33935 */   // Label 533: @33935
     /*  33935 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(34004), // Rule ID 13448 //
     /*  33940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33967 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33987 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34002 */     GIR_RootConstrainSelectedInstOperands,
     /*  34003 */     // GIR_Coverage, 13448,
     /*  34003 */     GIR_EraseRootFromParent_Done,
     /*  34004 */   // Label 534: @34004
     /*  34004 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(34060), // Rule ID 13398 //
     /*  34009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34024 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34027 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34047 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34058 */     GIR_RootConstrainSelectedInstOperands,
     /*  34059 */     // GIR_Coverage, 13398,
     /*  34059 */     GIR_EraseRootFromParent_Done,
     /*  34060 */   // Label 535: @34060
     /*  34060 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(34116), // Rule ID 13410 //
     /*  34065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34080 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34083 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34103 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34114 */     GIR_RootConstrainSelectedInstOperands,
     /*  34115 */     // GIR_Coverage, 13410,
     /*  34115 */     GIR_EraseRootFromParent_Done,
     /*  34116 */   // Label 536: @34116
     /*  34116 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(34183), // Rule ID 13650 //
     /*  34121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34145 */     // MIs[1] imm
     /*  34145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34157 */     // MIs[2] Operand 1
     /*  34157 */     // No operand predicates
     /*  34157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34167 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34181 */     GIR_RootConstrainSelectedInstOperands,
     /*  34182 */     // GIR_Coverage, 13650,
     /*  34182 */     GIR_EraseRootFromParent_Done,
     /*  34183 */   // Label 537: @34183
     /*  34183 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34250), // Rule ID 13671 //
     /*  34188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34212 */     // MIs[1] imm
     /*  34212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34224 */     // MIs[2] Operand 1
     /*  34224 */     // No operand predicates
     /*  34224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34234 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34248 */     GIR_RootConstrainSelectedInstOperands,
     /*  34249 */     // GIR_Coverage, 13671,
     /*  34249 */     GIR_EraseRootFromParent_Done,
     /*  34250 */   // Label 538: @34250
     /*  34250 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34319), // Rule ID 1363 //
     /*  34255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  34282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34302 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  34305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34317 */     GIR_RootConstrainSelectedInstOperands,
     /*  34318 */     // GIR_Coverage, 1363,
     /*  34318 */     GIR_EraseRootFromParent_Done,
     /*  34319 */   // Label 539: @34319
     /*  34319 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34388), // Rule ID 1486 //
     /*  34324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  34351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34371 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  34374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34386 */     GIR_RootConstrainSelectedInstOperands,
     /*  34387 */     // GIR_Coverage, 1486,
     /*  34387 */     GIR_EraseRootFromParent_Done,
     /*  34388 */   // Label 540: @34388
     /*  34388 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34444), // Rule ID 991 //
     /*  34393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34431 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34442 */     GIR_RootConstrainSelectedInstOperands,
     /*  34443 */     // GIR_Coverage, 991,
     /*  34443 */     GIR_EraseRootFromParent_Done,
     /*  34444 */   // Label 541: @34444
     /*  34444 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34500), // Rule ID 1052 //
     /*  34449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34487 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34498 */     GIR_RootConstrainSelectedInstOperands,
     /*  34499 */     // GIR_Coverage, 1052,
     /*  34499 */     GIR_EraseRootFromParent_Done,
     /*  34500 */   // Label 542: @34500
     /*  34500 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34567), // Rule ID 2236 //
     /*  34505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34533 */     // MIs[1] imm
     /*  34533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34545 */     // MIs[2] Operand 1
     /*  34545 */     // No operand predicates
     /*  34545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34551 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34565 */     GIR_RootConstrainSelectedInstOperands,
     /*  34566 */     // GIR_Coverage, 2236,
     /*  34566 */     GIR_EraseRootFromParent_Done,
     /*  34567 */   // Label 543: @34567
     /*  34567 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34634), // Rule ID 2295 //
     /*  34572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34600 */     // MIs[1] imm
     /*  34600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34612 */     // MIs[2] Operand 1
     /*  34612 */     // No operand predicates
     /*  34612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34618 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34632 */     GIR_RootConstrainSelectedInstOperands,
     /*  34633 */     // GIR_Coverage, 2295,
     /*  34633 */     GIR_EraseRootFromParent_Done,
     /*  34634 */   // Label 544: @34634
     /*  34634 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34704), // Rule ID 6979 //
     /*  34639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34677 */     // MIs[2] Rn
     /*  34677 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34682 */     // MIs[2] Rm
     /*  34682 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34689 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34702 */     GIR_RootConstrainSelectedInstOperands,
     /*  34703 */     // GIR_Coverage, 6979,
     /*  34703 */     GIR_EraseRootFromParent_Done,
     /*  34704 */   // Label 545: @34704
     /*  34704 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34774), // Rule ID 14037 //
     /*  34709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34747 */     // MIs[2] Rn
     /*  34747 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34752 */     // MIs[2] Rm
     /*  34752 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34759 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34772 */     GIR_RootConstrainSelectedInstOperands,
     /*  34773 */     // GIR_Coverage, 14037,
     /*  34773 */     GIR_EraseRootFromParent_Done,
     /*  34774 */   // Label 546: @34774
     /*  34774 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34837), // Rule ID 1781 //
     /*  34779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34822 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34835 */     GIR_RootConstrainSelectedInstOperands,
     /*  34836 */     // GIR_Coverage, 1781,
     /*  34836 */     GIR_EraseRootFromParent_Done,
     /*  34837 */   // Label 547: @34837
     /*  34837 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34900), // Rule ID 1780 //
     /*  34842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34885 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1780,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 548: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34963), // Rule ID 1712 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34948 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34961 */     GIR_RootConstrainSelectedInstOperands,
     /*  34962 */     // GIR_Coverage, 1712,
     /*  34962 */     GIR_EraseRootFromParent_Done,
     /*  34963 */   // Label 549: @34963
     /*  34963 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(35026), // Rule ID 1779 //
     /*  34968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35011 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35024 */     GIR_RootConstrainSelectedInstOperands,
     /*  35025 */     // GIR_Coverage, 1779,
     /*  35025 */     GIR_EraseRootFromParent_Done,
     /*  35026 */   // Label 550: @35026
     /*  35026 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(35089), // Rule ID 1778 //
     /*  35031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35074 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35087 */     GIR_RootConstrainSelectedInstOperands,
     /*  35088 */     // GIR_Coverage, 1778,
     /*  35088 */     GIR_EraseRootFromParent_Done,
     /*  35089 */   // Label 551: @35089
     /*  35089 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(35150), // Rule ID 13489 //
     /*  35094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35133 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35148 */     GIR_RootConstrainSelectedInstOperands,
     /*  35149 */     // GIR_Coverage, 13489,
     /*  35149 */     GIR_EraseRootFromParent_Done,
     /*  35150 */   // Label 552: @35150
     /*  35150 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(35211), // Rule ID 13523 //
     /*  35155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35194 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35209 */     GIR_RootConstrainSelectedInstOperands,
     /*  35210 */     // GIR_Coverage, 13523,
     /*  35210 */     GIR_EraseRootFromParent_Done,
     /*  35211 */   // Label 553: @35211
     /*  35211 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(35259), // Rule ID 13512 //
     /*  35216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35246 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35257 */     GIR_RootConstrainSelectedInstOperands,
     /*  35258 */     // GIR_Coverage, 13512,
     /*  35258 */     GIR_EraseRootFromParent_Done,
     /*  35259 */   // Label 554: @35259
     /*  35259 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35307), // Rule ID 13397 //
     /*  35264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35294 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35305 */     GIR_RootConstrainSelectedInstOperands,
     /*  35306 */     // GIR_Coverage, 13397,
     /*  35306 */     GIR_EraseRootFromParent_Done,
     /*  35307 */   // Label 555: @35307
     /*  35307 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35355), // Rule ID 13483 //
     /*  35312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35342 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35353 */     GIR_RootConstrainSelectedInstOperands,
     /*  35354 */     // GIR_Coverage, 13483,
     /*  35354 */     GIR_EraseRootFromParent_Done,
     /*  35355 */   // Label 556: @35355
     /*  35355 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35403), // Rule ID 13409 //
     /*  35360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35390 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35401 */     GIR_RootConstrainSelectedInstOperands,
     /*  35402 */     // GIR_Coverage, 13409,
     /*  35402 */     GIR_EraseRootFromParent_Done,
     /*  35403 */   // Label 557: @35403
     /*  35403 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35451), // Rule ID 13511 //
     /*  35408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35438 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35449 */     GIR_RootConstrainSelectedInstOperands,
     /*  35450 */     // GIR_Coverage, 13511,
     /*  35450 */     GIR_EraseRootFromParent_Done,
     /*  35451 */   // Label 558: @35451
     /*  35451 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35512), // Rule ID 1724 //
     /*  35456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35495 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35510 */     GIR_RootConstrainSelectedInstOperands,
     /*  35511 */     // GIR_Coverage, 1724,
     /*  35511 */     GIR_EraseRootFromParent_Done,
     /*  35512 */   // Label 559: @35512
     /*  35512 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35573), // Rule ID 1814 //
     /*  35517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35556 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35571 */     GIR_RootConstrainSelectedInstOperands,
     /*  35572 */     // GIR_Coverage, 1814,
     /*  35572 */     GIR_EraseRootFromParent_Done,
     /*  35573 */   // Label 560: @35573
     /*  35573 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35621), // Rule ID 1803 //
     /*  35578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35608 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35619 */     GIR_RootConstrainSelectedInstOperands,
     /*  35620 */     // GIR_Coverage, 1803,
     /*  35620 */     GIR_EraseRootFromParent_Done,
     /*  35621 */   // Label 561: @35621
     /*  35621 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35669), // Rule ID 990 //
     /*  35626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35656 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35667 */     GIR_RootConstrainSelectedInstOperands,
     /*  35668 */     // GIR_Coverage, 990,
     /*  35668 */     GIR_EraseRootFromParent_Done,
     /*  35669 */   // Label 562: @35669
     /*  35669 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35717), // Rule ID 1718 //
     /*  35674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35704 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35715 */     GIR_RootConstrainSelectedInstOperands,
     /*  35716 */     // GIR_Coverage, 1718,
     /*  35716 */     GIR_EraseRootFromParent_Done,
     /*  35717 */   // Label 563: @35717
     /*  35717 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35765), // Rule ID 1051 //
     /*  35722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35752 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35763 */     GIR_RootConstrainSelectedInstOperands,
     /*  35764 */     // GIR_Coverage, 1051,
     /*  35764 */     GIR_EraseRootFromParent_Done,
     /*  35765 */   // Label 564: @35765
     /*  35765 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35813), // Rule ID 1802 //
     /*  35770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35800 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35811 */     GIR_RootConstrainSelectedInstOperands,
     /*  35812 */     // GIR_Coverage, 1802,
     /*  35812 */     GIR_EraseRootFromParent_Done,
     /*  35813 */   // Label 565: @35813
     /*  35813 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35840), // Rule ID 1103 //
     /*  35818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35833 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35838 */     GIR_RootConstrainSelectedInstOperands,
     /*  35839 */     // GIR_Coverage, 1103,
     /*  35839 */     GIR_Done,
     /*  35840 */   // Label 566: @35840
     /*  35840 */   GIM_Reject,
     /*  35841 */ // Label 509: @35841
     /*  35841 */ GIM_Reject,
     /*  35842 */ // Label 163: @35842
     /*  35842 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(36565),
     /*  35847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35853 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35922), // Rule ID 13432 //
     /*  35858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35885 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35905 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35920 */     GIR_RootConstrainSelectedInstOperands,
     /*  35921 */     // GIR_Coverage, 13432,
     /*  35921 */     GIR_EraseRootFromParent_Done,
     /*  35922 */   // Label 568: @35922
     /*  35922 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35991), // Rule ID 13444 //
     /*  35927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35942 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35945 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35954 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35974 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35989 */     GIR_RootConstrainSelectedInstOperands,
     /*  35990 */     // GIR_Coverage, 13444,
     /*  35990 */     GIR_EraseRootFromParent_Done,
     /*  35991 */   // Label 569: @35991
     /*  35991 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(36058), // Rule ID 13646 //
     /*  35996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36020 */     // MIs[1] imm
     /*  36020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36032 */     // MIs[2] Operand 1
     /*  36032 */     // No operand predicates
     /*  36032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36042 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36056 */     GIR_RootConstrainSelectedInstOperands,
     /*  36057 */     // GIR_Coverage, 13646,
     /*  36057 */     GIR_EraseRootFromParent_Done,
     /*  36058 */   // Label 570: @36058
     /*  36058 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(36125), // Rule ID 13667 //
     /*  36063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36087 */     // MIs[1] imm
     /*  36087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36099 */     // MIs[2] Operand 1
     /*  36099 */     // No operand predicates
     /*  36099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36109 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36123 */     GIR_RootConstrainSelectedInstOperands,
     /*  36124 */     // GIR_Coverage, 13667,
     /*  36124 */     GIR_EraseRootFromParent_Done,
     /*  36125 */   // Label 571: @36125
     /*  36125 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(36194), // Rule ID 1359 //
     /*  36130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  36157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36161 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36177 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  36180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36192 */     GIR_RootConstrainSelectedInstOperands,
     /*  36193 */     // GIR_Coverage, 1359,
     /*  36193 */     GIR_EraseRootFromParent_Done,
     /*  36194 */   // Label 572: @36194
     /*  36194 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36263), // Rule ID 1482 //
     /*  36199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36218 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36221 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  36226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36246 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  36249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 1482,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 573: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36330), // Rule ID 2232 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36296 */     // MIs[1] imm
     /*  36296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36304 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36308 */     // MIs[2] Operand 1
     /*  36308 */     // No operand predicates
     /*  36308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36314 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36328 */     GIR_RootConstrainSelectedInstOperands,
     /*  36329 */     // GIR_Coverage, 2232,
     /*  36329 */     GIR_EraseRootFromParent_Done,
     /*  36330 */   // Label 574: @36330
     /*  36330 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36397), // Rule ID 2291 //
     /*  36335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36363 */     // MIs[1] imm
     /*  36363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36371 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36375 */     // MIs[2] Operand 1
     /*  36375 */     // No operand predicates
     /*  36375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36381 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36395 */     GIR_RootConstrainSelectedInstOperands,
     /*  36396 */     // GIR_Coverage, 2291,
     /*  36396 */     GIR_EraseRootFromParent_Done,
     /*  36397 */   // Label 575: @36397
     /*  36397 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36467), // Rule ID 6980 //
     /*  36402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  36414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  36440 */     // MIs[2] Rn
     /*  36440 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36445 */     // MIs[2] Rm
     /*  36445 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36452 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36465 */     GIR_RootConstrainSelectedInstOperands,
     /*  36466 */     // GIR_Coverage, 6980,
     /*  36466 */     GIR_EraseRootFromParent_Done,
     /*  36467 */   // Label 576: @36467
     /*  36467 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36537), // Rule ID 14038 //
     /*  36472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  36484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  36510 */     // MIs[2] Rn
     /*  36510 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36515 */     // MIs[2] Rm
     /*  36515 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36522 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36535 */     GIR_RootConstrainSelectedInstOperands,
     /*  36536 */     // GIR_Coverage, 14038,
     /*  36536 */     GIR_EraseRootFromParent_Done,
     /*  36537 */   // Label 577: @36537
     /*  36537 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36564), // Rule ID 1101 //
     /*  36542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36557 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  36562 */     GIR_RootConstrainSelectedInstOperands,
     /*  36563 */     // GIR_Coverage, 1101,
     /*  36563 */     GIR_Done,
     /*  36564 */   // Label 578: @36564
     /*  36564 */   GIM_Reject,
     /*  36565 */ // Label 567: @36565
     /*  36565 */ GIM_Reject,
     /*  36566 */ // Label 164: @36566
     /*  36566 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36937),
     /*  36571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36581 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36643), // Rule ID 15222 //
     /*  36586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36617 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36630 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36641 */     GIR_RootConstrainSelectedInstOperands,
     /*  36642 */     // GIR_Coverage, 15222,
     /*  36642 */     GIR_EraseRootFromParent_Done,
     /*  36643 */   // Label 580: @36643
     /*  36643 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36705), // Rule ID 15221 //
     /*  36648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36679 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36692 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36703 */     GIR_RootConstrainSelectedInstOperands,
     /*  36704 */     // GIR_Coverage, 15221,
     /*  36704 */     GIR_EraseRootFromParent_Done,
     /*  36705 */   // Label 581: @36705
     /*  36705 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36767), // Rule ID 15220 //
     /*  36710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36741 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36754 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36765 */     GIR_RootConstrainSelectedInstOperands,
     /*  36766 */     // GIR_Coverage, 15220,
     /*  36766 */     GIR_EraseRootFromParent_Done,
     /*  36767 */   // Label 582: @36767
     /*  36767 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36829), // Rule ID 8955 //
     /*  36772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36803 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36816 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36827 */     GIR_RootConstrainSelectedInstOperands,
     /*  36828 */     // GIR_Coverage, 8955,
     /*  36828 */     GIR_EraseRootFromParent_Done,
     /*  36829 */   // Label 583: @36829
     /*  36829 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36875), // Rule ID 15223 //
     /*  36834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36849 */     // MIs[1] Operand 2
     /*  36849 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36862 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36873 */     GIR_RootConstrainSelectedInstOperands,
     /*  36874 */     // GIR_Coverage, 15223,
     /*  36874 */     GIR_EraseRootFromParent_Done,
     /*  36875 */   // Label 584: @36875
     /*  36875 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36921), // Rule ID 8956 //
     /*  36880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36895 */     // MIs[1] Operand 2
     /*  36895 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36908 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36919 */     GIR_RootConstrainSelectedInstOperands,
     /*  36920 */     // GIR_Coverage, 8956,
     /*  36920 */     GIR_EraseRootFromParent_Done,
     /*  36921 */   // Label 585: @36921
     /*  36921 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36936), // Rule ID 2776 //
     /*  36926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36929 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36934 */     GIR_RootConstrainSelectedInstOperands,
     /*  36935 */     // GIR_Coverage, 2776,
     /*  36935 */     GIR_Done,
     /*  36936 */   // Label 586: @36936
     /*  36936 */   GIM_Reject,
     /*  36937 */ // Label 579: @36937
     /*  36937 */ GIM_Reject,
     /*  36938 */ // Label 165: @36938
     /*  36938 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(36963), // Rule ID 2775 //
     /*  36943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36956 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36961 */   GIR_RootConstrainSelectedInstOperands,
     /*  36962 */   // GIR_Coverage, 2775,
     /*  36962 */   GIR_Done,
     /*  36963 */ // Label 587: @36963
     /*  36963 */ GIM_Reject,
     /*  36964 */ // Label 166: @36964
     /*  36964 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(36989), // Rule ID 2774 //
     /*  36969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36982 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36987 */   GIR_RootConstrainSelectedInstOperands,
     /*  36988 */   // GIR_Coverage, 2774,
     /*  36988 */   GIR_Done,
     /*  36989 */ // Label 588: @36989
     /*  36989 */ GIM_Reject,
     /*  36990 */ // Label 167: @36990
     /*  36990 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(37015), // Rule ID 2773 //
     /*  36995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  37001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  37004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  37008 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  37008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  37013 */   GIR_RootConstrainSelectedInstOperands,
     /*  37014 */   // GIR_Coverage, 2773,
     /*  37014 */   GIR_Done,
     /*  37015 */ // Label 589: @37015
     /*  37015 */ GIM_Reject,
     /*  37016 */ // Label 168: @37016
     /*  37016 */ GIM_Reject,
     /*  37017 */ // Label 1: @37017
     /*  37017 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 603*/ GIMT_Encode4(51868),
     /*  37028 */ /*GILLT_s32*//*Label 590*/ GIMT_Encode4(37116),
     /*  37032 */ /*GILLT_s64*//*Label 591*/ GIMT_Encode4(38598), GIMT_Encode4(0),
     /*  37040 */ /*GILLT_v2s32*//*Label 592*/ GIMT_Encode4(42504),
     /*  37044 */ /*GILLT_v2s64*//*Label 593*/ GIMT_Encode4(43995),
     /*  37048 */ /*GILLT_v4s16*//*Label 594*/ GIMT_Encode4(46455),
     /*  37052 */ /*GILLT_v4s32*//*Label 595*/ GIMT_Encode4(47946),
     /*  37056 */ /*GILLT_v8s8*//*Label 596*/ GIMT_Encode4(50406),
     /*  37060 */ /*GILLT_v8s16*//*Label 597*/ GIMT_Encode4(50481),
     /*  37064 */ /*GILLT_v16s8*//*Label 598*/ GIMT_Encode4(51689), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37084 */ /*GILLT_nxv2s64*//*Label 599*/ GIMT_Encode4(51764), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37096 */ /*GILLT_nxv4s32*//*Label 600*/ GIMT_Encode4(51790), GIMT_Encode4(0),
     /*  37104 */ /*GILLT_nxv8s16*//*Label 601*/ GIMT_Encode4(51816), GIMT_Encode4(0),
     /*  37112 */ /*GILLT_nxv16s8*//*Label 602*/ GIMT_Encode4(51842),
     /*  37116 */ // Label 590: @37116
     /*  37116 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(38597),
     /*  37121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  37124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37127 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37279), // Rule ID 10002 //
     /*  37132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37166 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37171 */     // MIs[2] pattern
     /*  37171 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37174 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37181 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37181 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37184 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37188 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37207 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37214 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37222 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37278 */     // GIR_Coverage, 10002,
     /*  37278 */     GIR_EraseRootFromParent_Done,
     /*  37279 */   // Label 605: @37279
     /*  37279 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37431), // Rule ID 10014 //
     /*  37284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37315 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37318 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37323 */     // MIs[2] pattern
     /*  37323 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37326 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37333 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37333 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37336 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37340 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37359 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37430 */     // GIR_Coverage, 10014,
     /*  37430 */     GIR_EraseRootFromParent_Done,
     /*  37431 */   // Label 606: @37431
     /*  37431 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37583), // Rule ID 10026 //
     /*  37436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37467 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37470 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37475 */     // MIs[2] pattern
     /*  37475 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37478 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37485 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37485 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37488 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37492 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37511 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37518 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37565 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37582 */     // GIR_Coverage, 10026,
     /*  37582 */     GIR_EraseRootFromParent_Done,
     /*  37583 */   // Label 607: @37583
     /*  37583 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37735), // Rule ID 10038 //
     /*  37588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37619 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37622 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37627 */     // MIs[2] pattern
     /*  37627 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37630 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37637 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37637 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37640 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37644 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37663 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37670 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37717 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37734 */     // GIR_Coverage, 10038,
     /*  37734 */     GIR_EraseRootFromParent_Done,
     /*  37735 */   // Label 608: @37735
     /*  37735 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37797), // Rule ID 3957 //
     /*  37740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37776 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37795 */     GIR_RootConstrainSelectedInstOperands,
     /*  37796 */     // GIR_Coverage, 3957,
     /*  37796 */     GIR_EraseRootFromParent_Done,
     /*  37797 */   // Label 609: @37797
     /*  37797 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37954), // Rule ID 10140 //
     /*  37802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37845 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37852 */     // MIs[2] pred
     /*  37852 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37859 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37859 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37862 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37866 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37885 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37888 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37936 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37953 */     // GIR_Coverage, 10140,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 610: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(38111), // Rule ID 10141 //
     /*  37959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37990 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37993 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  38002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38009 */     // MIs[2] pred
     /*  38009 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38016 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38016 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38019 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38023 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38030 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38033 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38037 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38042 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38049 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38052 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  38074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38110 */     // GIR_Coverage, 10141,
     /*  38110 */     GIR_EraseRootFromParent_Done,
     /*  38111 */   // Label 611: @38111
     /*  38111 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(38268), // Rule ID 10142 //
     /*  38116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38147 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38150 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  38159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38166 */     // MIs[2] pred
     /*  38166 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38173 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38173 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38176 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38180 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38199 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38206 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38240 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38250 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38267 */     // GIR_Coverage, 10142,
     /*  38267 */     GIR_EraseRootFromParent_Done,
     /*  38268 */   // Label 612: @38268
     /*  38268 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(38425), // Rule ID 10143 //
     /*  38273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38304 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38307 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  38316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38323 */     // MIs[2] pred
     /*  38323 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38330 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38356 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38363 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  38388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38424 */     // GIR_Coverage, 10143,
     /*  38424 */     GIR_EraseRootFromParent_Done,
     /*  38425 */   // Label 613: @38425
     /*  38425 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38461), // Rule ID 3922 //
     /*  38430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  38445 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  38445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  38448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38450 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38459 */     GIR_RootConstrainSelectedInstOperands,
     /*  38460 */     // GIR_Coverage, 3922,
     /*  38460 */     GIR_EraseRootFromParent_Done,
     /*  38461 */   // Label 614: @38461
     /*  38461 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38494), // Rule ID 3927 //
     /*  38466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  38481 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  38484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38492 */     GIR_RootConstrainSelectedInstOperands,
     /*  38493 */     // GIR_Coverage, 3927,
     /*  38493 */     GIR_EraseRootFromParent_Done,
     /*  38494 */   // Label 615: @38494
     /*  38494 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38530), // Rule ID 3916 //
     /*  38499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  38514 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  38517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38528 */     GIR_RootConstrainSelectedInstOperands,
     /*  38529 */     // GIR_Coverage, 3916,
     /*  38529 */     GIR_EraseRootFromParent_Done,
     /*  38530 */   // Label 616: @38530
     /*  38530 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38566), // Rule ID 3920 //
     /*  38535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  38550 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  38550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  38553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38564 */     GIR_RootConstrainSelectedInstOperands,
     /*  38565 */     // GIR_Coverage, 3920,
     /*  38565 */     GIR_EraseRootFromParent_Done,
     /*  38566 */   // Label 617: @38566
     /*  38566 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38596), // Rule ID 3918 //
     /*  38571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38583 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  38583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  38588 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38594 */     GIR_RootConstrainSelectedInstOperands,
     /*  38595 */     // GIR_Coverage, 3918,
     /*  38595 */     GIR_Done,
     /*  38596 */   // Label 618: @38596
     /*  38596 */   GIM_Reject,
     /*  38597 */ // Label 604: @38597
     /*  38597 */ GIM_Reject,
     /*  38598 */ // Label 591: @38598
     /*  38598 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(42503),
     /*  38603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38609 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38745), // Rule ID 5420 //
     /*  38614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38647 */     // MIs[1] Operand 2
     /*  38647 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38674 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38678 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38682 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38687 */     // MIs[3] Operand 2
     /*  38687 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38698 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38700 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38744 */     // GIR_Coverage, 5420,
     /*  38744 */     GIR_EraseRootFromParent_Done,
     /*  38745 */   // Label 620: @38745
     /*  38745 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38881), // Rule ID 5419 //
     /*  38750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38783 */     // MIs[1] Operand 2
     /*  38783 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38814 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38818 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38823 */     // MIs[3] Operand 2
     /*  38823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38836 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38863 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38880 */     // GIR_Coverage, 5419,
     /*  38880 */     GIR_EraseRootFromParent_Done,
     /*  38881 */   // Label 621: @38881
     /*  38881 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39017), // Rule ID 5429 //
     /*  38886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38919 */     // MIs[1] Operand 2
     /*  38919 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38946 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38950 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38959 */     // MIs[3] Operand 2
     /*  38959 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38972 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38999 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39016 */     // GIR_Coverage, 5429,
     /*  39016 */     GIR_EraseRootFromParent_Done,
     /*  39017 */   // Label 622: @39017
     /*  39017 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39153), // Rule ID 5418 //
     /*  39022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39055 */     // MIs[1] Operand 2
     /*  39055 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39086 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39090 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39095 */     // MIs[3] Operand 2
     /*  39095 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39106 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39108 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39135 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39152 */     // GIR_Coverage, 5418,
     /*  39152 */     GIR_EraseRootFromParent_Done,
     /*  39153 */   // Label 623: @39153
     /*  39153 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39289), // Rule ID 5417 //
     /*  39158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39191 */     // MIs[1] Operand 2
     /*  39191 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39214 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39218 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39222 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39226 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39231 */     // MIs[3] Operand 2
     /*  39231 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39242 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39244 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39288 */     // GIR_Coverage, 5417,
     /*  39288 */     GIR_EraseRootFromParent_Done,
     /*  39289 */   // Label 624: @39289
     /*  39289 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39426), // Rule ID 3974 //
     /*  39294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39335 */     // MIs[2] Operand 2
     /*  39335 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39358 */     // MIs[3] Operand 1
     /*  39358 */     // No operand predicates
     /*  39358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39360 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39372 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39391 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39424 */     GIR_RootConstrainSelectedInstOperands,
     /*  39425 */     // GIR_Coverage, 3974,
     /*  39425 */     GIR_EraseRootFromParent_Done,
     /*  39426 */   // Label 625: @39426
     /*  39426 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39525), // Rule ID 3972 //
     /*  39431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39480 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39484 */     // MIs[3] Operand 1
     /*  39484 */     // No operand predicates
     /*  39484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39486 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39498 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39523 */     GIR_RootConstrainSelectedInstOperands,
     /*  39524 */     // GIR_Coverage, 3972,
     /*  39524 */     GIR_EraseRootFromParent_Done,
     /*  39525 */   // Label 626: @39525
     /*  39525 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39624), // Rule ID 3973 //
     /*  39530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39583 */     // MIs[3] Operand 1
     /*  39583 */     // No operand predicates
     /*  39583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39585 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39597 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39622 */     GIR_RootConstrainSelectedInstOperands,
     /*  39623 */     // GIR_Coverage, 3973,
     /*  39623 */     GIR_EraseRootFromParent_Done,
     /*  39624 */   // Label 627: @39624
     /*  39624 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39710), // Rule ID 3967 //
     /*  39629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39689 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39708 */     GIR_RootConstrainSelectedInstOperands,
     /*  39709 */     // GIR_Coverage, 3967,
     /*  39709 */     GIR_EraseRootFromParent_Done,
     /*  39710 */   // Label 628: @39710
     /*  39710 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39796), // Rule ID 3968 //
     /*  39715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39775 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39794 */     GIR_RootConstrainSelectedInstOperands,
     /*  39795 */     // GIR_Coverage, 3968,
     /*  39795 */     GIR_EraseRootFromParent_Done,
     /*  39796 */   // Label 629: @39796
     /*  39796 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39897), // Rule ID 3994 //
     /*  39801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39825 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  39834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39849 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39895 */     GIR_RootConstrainSelectedInstOperands,
     /*  39896 */     // GIR_Coverage, 3994,
     /*  39896 */     GIR_EraseRootFromParent_Done,
     /*  39897 */   // Label 630: @39897
     /*  39897 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39998), // Rule ID 13893 //
     /*  39902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39943 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39950 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39962 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39996 */     GIR_RootConstrainSelectedInstOperands,
     /*  39997 */     // GIR_Coverage, 13893,
     /*  39997 */     GIR_EraseRootFromParent_Done,
     /*  39998 */   // Label 631: @39998
     /*  39998 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(40114), // Rule ID 3993 //
     /*  40003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40027 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40032 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40039 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  40039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40051 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  40057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40079 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40112 */     GIR_RootConstrainSelectedInstOperands,
     /*  40113 */     // GIR_Coverage, 3993,
     /*  40113 */     GIR_EraseRootFromParent_Done,
     /*  40114 */   // Label 632: @40114
     /*  40114 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(40247), // Rule ID 3980 //
     /*  40119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  40151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  40155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40160 */     // MIs[2] Operand 2
     /*  40160 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  40171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40183 */     // MIs[3] Operand 1
     /*  40183 */     // No operand predicates
     /*  40183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40185 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40197 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  40204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40216 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40245 */     GIR_RootConstrainSelectedInstOperands,
     /*  40246 */     // GIR_Coverage, 3980,
     /*  40246 */     GIR_EraseRootFromParent_Done,
     /*  40247 */   // Label 633: @40247
     /*  40247 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40342), // Rule ID 3978 //
     /*  40252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40305 */     // MIs[3] Operand 1
     /*  40305 */     // No operand predicates
     /*  40305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40307 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40319 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40340 */     GIR_RootConstrainSelectedInstOperands,
     /*  40341 */     // GIR_Coverage, 3978,
     /*  40341 */     GIR_EraseRootFromParent_Done,
     /*  40342 */   // Label 634: @40342
     /*  40342 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40437), // Rule ID 3979 //
     /*  40347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40396 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  40400 */     // MIs[3] Operand 1
     /*  40400 */     // No operand predicates
     /*  40400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40402 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40414 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40435 */     GIR_RootConstrainSelectedInstOperands,
     /*  40436 */     // GIR_Coverage, 3979,
     /*  40436 */     GIR_EraseRootFromParent_Done,
     /*  40437 */   // Label 635: @40437
     /*  40437 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40519), // Rule ID 124 //
     /*  40442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40495 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40502 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40517 */     GIR_RootConstrainSelectedInstOperands,
     /*  40518 */     // GIR_Coverage, 124,
     /*  40518 */     GIR_EraseRootFromParent_Done,
     /*  40519 */   // Label 636: @40519
     /*  40519 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40601), // Rule ID 126 //
     /*  40524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40584 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40599 */     GIR_RootConstrainSelectedInstOperands,
     /*  40600 */     // GIR_Coverage, 126,
     /*  40600 */     GIR_EraseRootFromParent_Done,
     /*  40601 */   // Label 637: @40601
     /*  40601 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40663), // Rule ID 3958 //
     /*  40606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40642 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  40642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  40645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  40651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  40655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40661 */     GIR_RootConstrainSelectedInstOperands,
     /*  40662 */     // GIR_Coverage, 3958,
     /*  40662 */     GIR_EraseRootFromParent_Done,
     /*  40663 */   // Label 638: @40663
     /*  40663 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40721), // Rule ID 9999 //
     /*  40668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40687 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40690 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  40695 */     // MIs[1] pattern
     /*  40695 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40698 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40705 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  40708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40719 */     GIR_RootConstrainSelectedInstOperands,
     /*  40720 */     // GIR_Coverage, 9999,
     /*  40720 */     GIR_EraseRootFromParent_Done,
     /*  40721 */   // Label 639: @40721
     /*  40721 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40779), // Rule ID 10011 //
     /*  40726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40745 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40748 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  40753 */     // MIs[1] pattern
     /*  40753 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40756 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40763 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40777 */     GIR_RootConstrainSelectedInstOperands,
     /*  40778 */     // GIR_Coverage, 10011,
     /*  40778 */     GIR_EraseRootFromParent_Done,
     /*  40779 */   // Label 640: @40779
     /*  40779 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40837), // Rule ID 10023 //
     /*  40784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40803 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40806 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  40811 */     // MIs[1] pattern
     /*  40811 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40814 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40821 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  40824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40835 */     GIR_RootConstrainSelectedInstOperands,
     /*  40836 */     // GIR_Coverage, 10023,
     /*  40836 */     GIR_EraseRootFromParent_Done,
     /*  40837 */   // Label 641: @40837
     /*  40837 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40895), // Rule ID 10035 //
     /*  40842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40861 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40864 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  40869 */     // MIs[1] pattern
     /*  40869 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40872 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40879 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  40882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40893 */     GIR_RootConstrainSelectedInstOperands,
     /*  40894 */     // GIR_Coverage, 10035,
     /*  40894 */     GIR_EraseRootFromParent_Done,
     /*  40895 */   // Label 642: @40895
     /*  40895 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40992), // Rule ID 3996 //
     /*  40900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40924 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40948 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40990 */     GIR_RootConstrainSelectedInstOperands,
     /*  40991 */     // GIR_Coverage, 3996,
     /*  40991 */     GIR_EraseRootFromParent_Done,
     /*  40992 */   // Label 643: @40992
     /*  40992 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41089), // Rule ID 13894 //
     /*  40997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41038 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41045 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  41045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41057 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  41063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  41076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  41087 */     GIR_RootConstrainSelectedInstOperands,
     /*  41088 */     // GIR_Coverage, 13894,
     /*  41088 */     GIR_EraseRootFromParent_Done,
     /*  41089 */   // Label 644: @41089
     /*  41089 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41252), // Rule ID 5384 //
     /*  41094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41140 */     // MIs[1] Operand 2
     /*  41140 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41153 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41153 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41156 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41160 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41179 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41186 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  41211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41234 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41251 */     // GIR_Coverage, 5384,
     /*  41251 */     GIR_EraseRootFromParent_Done,
     /*  41252 */   // Label 645: @41252
     /*  41252 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41415), // Rule ID 5381 //
     /*  41257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  41285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41303 */     // MIs[1] Operand 2
     /*  41303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41316 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41342 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41345 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41349 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  41374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5381,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 646: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41565), // Rule ID 5426 //
     /*  41420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41457 */     // MIs[1] Operand 2
     /*  41457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41470 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41470 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41473 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41477 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41496 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41503 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41533 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41547 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41564 */     // GIR_Coverage, 5426,
     /*  41564 */     GIR_EraseRootFromParent_Done,
     /*  41565 */   // Label 647: @41565
     /*  41565 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41715), // Rule ID 5432 //
     /*  41570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41607 */     // MIs[1] Operand 2
     /*  41607 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41620 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41620 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41623 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41627 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41653 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  41678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41697 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41714 */     // GIR_Coverage, 5432,
     /*  41714 */     GIR_EraseRootFromParent_Done,
     /*  41715 */   // Label 648: @41715
     /*  41715 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41865), // Rule ID 5425 //
     /*  41720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41757 */     // MIs[1] Operand 2
     /*  41757 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41770 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41796 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41803 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41833 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41847 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41864 */     // GIR_Coverage, 5425,
     /*  41864 */     GIR_EraseRootFromParent_Done,
     /*  41865 */   // Label 649: @41865
     /*  41865 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41901), // Rule ID 3923 //
     /*  41870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  41885 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  41885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  41888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41890 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  41892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  41896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41899 */     GIR_RootConstrainSelectedInstOperands,
     /*  41900 */     // GIR_Coverage, 3923,
     /*  41900 */     GIR_EraseRootFromParent_Done,
     /*  41901 */   // Label 650: @41901
     /*  41901 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41934), // Rule ID 3928 //
     /*  41906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  41921 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  41924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41932 */     GIR_RootConstrainSelectedInstOperands,
     /*  41933 */     // GIR_Coverage, 3928,
     /*  41933 */     GIR_EraseRootFromParent_Done,
     /*  41934 */   // Label 651: @41934
     /*  41934 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(42046), // Rule ID 3995 //
     /*  41939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41963 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41968 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41975 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  41975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  41978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41987 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  41993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  42021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  42026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  42034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  42044 */     GIR_RootConstrainSelectedInstOperands,
     /*  42045 */     // GIR_Coverage, 3995,
     /*  42045 */     GIR_EraseRootFromParent_Done,
     /*  42046 */   // Label 652: @42046
     /*  42046 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(42082), // Rule ID 3917 //
     /*  42051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  42059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  42066 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  42066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  42069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  42077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42080 */     GIR_RootConstrainSelectedInstOperands,
     /*  42081 */     // GIR_Coverage, 3917,
     /*  42081 */     GIR_EraseRootFromParent_Done,
     /*  42082 */   // Label 653: @42082
     /*  42082 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(42118), // Rule ID 3921 //
     /*  42087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  42102 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  42102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  42105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  42113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42116 */     GIR_RootConstrainSelectedInstOperands,
     /*  42117 */     // GIR_Coverage, 3921,
     /*  42117 */     GIR_EraseRootFromParent_Done,
     /*  42118 */   // Label 654: @42118
     /*  42118 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(42181), // Rule ID 10132 //
     /*  42123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42142 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42145 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  42154 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42161 */     // MIs[1] pred
     /*  42161 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42168 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  42171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42179 */     GIR_RootConstrainSelectedInstOperands,
     /*  42180 */     // GIR_Coverage, 10132,
     /*  42180 */     GIR_EraseRootFromParent_Done,
     /*  42181 */   // Label 655: @42181
     /*  42181 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(42244), // Rule ID 10133 //
     /*  42186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  42217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42224 */     // MIs[1] pred
     /*  42224 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42231 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  42234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42242 */     GIR_RootConstrainSelectedInstOperands,
     /*  42243 */     // GIR_Coverage, 10133,
     /*  42243 */     GIR_EraseRootFromParent_Done,
     /*  42244 */   // Label 656: @42244
     /*  42244 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42307), // Rule ID 10134 //
     /*  42249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42268 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42271 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  42280 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42287 */     // MIs[1] pred
     /*  42287 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42294 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  42297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42305 */     GIR_RootConstrainSelectedInstOperands,
     /*  42306 */     // GIR_Coverage, 10134,
     /*  42306 */     GIR_EraseRootFromParent_Done,
     /*  42307 */   // Label 657: @42307
     /*  42307 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42370), // Rule ID 10135 //
     /*  42312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42331 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42334 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  42343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42350 */     // MIs[1] pred
     /*  42350 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42357 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  42360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42368 */     GIR_RootConstrainSelectedInstOperands,
     /*  42369 */     // GIR_Coverage, 10135,
     /*  42369 */     GIR_EraseRootFromParent_Done,
     /*  42370 */   // Label 658: @42370
     /*  42370 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42409), // Rule ID 1655 //
     /*  42375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42400 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  42400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42407 */     GIR_RootConstrainSelectedInstOperands,
     /*  42408 */     // GIR_Coverage, 1655,
     /*  42408 */     GIR_EraseRootFromParent_Done,
     /*  42409 */   // Label 659: @42409
     /*  42409 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42445), // Rule ID 5267 //
     /*  42414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42422 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42436 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  42436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42443 */     GIR_RootConstrainSelectedInstOperands,
     /*  42444 */     // GIR_Coverage, 5267,
     /*  42444 */     GIR_EraseRootFromParent_Done,
     /*  42445 */   // Label 660: @42445
     /*  42445 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42472), // Rule ID 1644 //
     /*  42450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42465 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  42465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  42470 */     GIR_RootConstrainSelectedInstOperands,
     /*  42471 */     // GIR_Coverage, 1644,
     /*  42471 */     GIR_Done,
     /*  42472 */   // Label 661: @42472
     /*  42472 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42502), // Rule ID 3919 //
     /*  42477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42489 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  42489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  42494 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  42500 */     GIR_RootConstrainSelectedInstOperands,
     /*  42501 */     // GIR_Coverage, 3919,
     /*  42501 */     GIR_Done,
     /*  42502 */   // Label 662: @42502
     /*  42502 */   GIM_Reject,
     /*  42503 */ // Label 619: @42503
     /*  42503 */ GIM_Reject,
     /*  42504 */ // Label 592: @42504
     /*  42504 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(43994),
     /*  42509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42519 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42651), // Rule ID 5416 //
     /*  42524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42553 */     // MIs[1] Operand 2
     /*  42553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42588 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42593 */     // MIs[3] Operand 2
     /*  42593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42606 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     // GIR_Coverage, 5416,
     /*  42650 */     GIR_EraseRootFromParent_Done,
     /*  42651 */   // Label 664: @42651
     /*  42651 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42783), // Rule ID 5415 //
     /*  42656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42685 */     // MIs[1] Operand 2
     /*  42685 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42716 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42720 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42725 */     // MIs[3] Operand 2
     /*  42725 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42736 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42738 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42782 */     // GIR_Coverage, 5415,
     /*  42782 */     GIR_EraseRootFromParent_Done,
     /*  42783 */   // Label 665: @42783
     /*  42783 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42915), // Rule ID 5428 //
     /*  42788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42817 */     // MIs[1] Operand 2
     /*  42817 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42848 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42852 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42857 */     // MIs[3] Operand 2
     /*  42857 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42870 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  42877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42914 */     // GIR_Coverage, 5428,
     /*  42914 */     GIR_EraseRootFromParent_Done,
     /*  42915 */   // Label 666: @42915
     /*  42915 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43047), // Rule ID 5414 //
     /*  42920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42949 */     // MIs[1] Operand 2
     /*  42949 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42980 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42984 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42989 */     // MIs[3] Operand 2
     /*  42989 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43000 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43002 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43046 */     // GIR_Coverage, 5414,
     /*  43046 */     GIR_EraseRootFromParent_Done,
     /*  43047 */   // Label 667: @43047
     /*  43047 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43179), // Rule ID 5413 //
     /*  43052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43081 */     // MIs[1] Operand 2
     /*  43081 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43112 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43116 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43121 */     // MIs[3] Operand 2
     /*  43121 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43134 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43178 */     // GIR_Coverage, 5413,
     /*  43178 */     GIR_EraseRootFromParent_Done,
     /*  43179 */   // Label 668: @43179
     /*  43179 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43338), // Rule ID 5383 //
     /*  43184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43226 */     // MIs[1] Operand 2
     /*  43226 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43239 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43239 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43242 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43246 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43265 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43272 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  43297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43302 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43337 */     // GIR_Coverage, 5383,
     /*  43337 */     GIR_EraseRootFromParent_Done,
     /*  43338 */   // Label 669: @43338
     /*  43338 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43497), // Rule ID 5380 //
     /*  43343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43385 */     // MIs[1] Operand 2
     /*  43385 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43398 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43398 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43401 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43405 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43424 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43431 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  43456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43479 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43496 */     // GIR_Coverage, 5380,
     /*  43496 */     GIR_EraseRootFromParent_Done,
     /*  43497 */   // Label 670: @43497
     /*  43497 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43643), // Rule ID 5424 //
     /*  43502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43535 */     // MIs[1] Operand 2
     /*  43535 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43548 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43548 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43551 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43555 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43574 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43577 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43581 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43611 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43625 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43642 */     // GIR_Coverage, 5424,
     /*  43642 */     GIR_EraseRootFromParent_Done,
     /*  43643 */   // Label 671: @43643
     /*  43643 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43789), // Rule ID 5431 //
     /*  43648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43681 */     // MIs[1] Operand 2
     /*  43681 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43694 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43708 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43711 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43715 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43720 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43727 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43730 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43735 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  43752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43757 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43771 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43788 */     // GIR_Coverage, 5431,
     /*  43788 */     GIR_EraseRootFromParent_Done,
     /*  43789 */   // Label 672: @43789
     /*  43789 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43935), // Rule ID 5423 //
     /*  43794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43827 */     // MIs[1] Operand 2
     /*  43827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43840 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43934 */     // GIR_Coverage, 5423,
     /*  43934 */     GIR_EraseRootFromParent_Done,
     /*  43935 */   // Label 673: @43935
     /*  43935 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43970), // Rule ID 969 //
     /*  43940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43947 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43953 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  43955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43961 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  43961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  43964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  43968 */     GIR_RootConstrainSelectedInstOperands,
     /*  43969 */     // GIR_Coverage, 969,
     /*  43969 */     GIR_EraseRootFromParent_Done,
     /*  43970 */   // Label 674: @43970
     /*  43970 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43993), // Rule ID 1476 //
     /*  43975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43986 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  43986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  43991 */     GIR_RootConstrainSelectedInstOperands,
     /*  43992 */     // GIR_Coverage, 1476,
     /*  43992 */     GIR_Done,
     /*  43993 */   // Label 675: @43993
     /*  43993 */   GIM_Reject,
     /*  43994 */ // Label 663: @43994
     /*  43994 */ GIM_Reject,
     /*  43995 */ // Label 593: @43995
     /*  43995 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(46454),
     /*  44000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  44003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  44006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44010 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(44124), // Rule ID 2048 //
     /*  44015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44079 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44083 */     // MIs[4] Operand 1
     /*  44083 */     // No operand predicates
     /*  44083 */     // MIs[2] Operand 2
     /*  44083 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44103 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44122 */     GIR_RootConstrainSelectedInstOperands,
     /*  44123 */     // GIR_Coverage, 2048,
     /*  44123 */     GIR_EraseRootFromParent_Done,
     /*  44124 */   // Label 677: @44124
     /*  44124 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44238), // Rule ID 13588 //
     /*  44129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44180 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44185 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44189 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44193 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44197 */     // MIs[4] Operand 1
     /*  44197 */     // No operand predicates
     /*  44197 */     // MIs[2] Operand 2
     /*  44197 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44217 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44236 */     GIR_RootConstrainSelectedInstOperands,
     /*  44237 */     // GIR_Coverage, 13588,
     /*  44237 */     GIR_EraseRootFromParent_Done,
     /*  44238 */   // Label 678: @44238
     /*  44238 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44352), // Rule ID 2100 //
     /*  44243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44286 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44290 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44294 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44307 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44311 */     // MIs[4] Operand 1
     /*  44311 */     // No operand predicates
     /*  44311 */     // MIs[2] Operand 2
     /*  44311 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44322 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44331 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44350 */     GIR_RootConstrainSelectedInstOperands,
     /*  44351 */     // GIR_Coverage, 2100,
     /*  44351 */     GIR_EraseRootFromParent_Done,
     /*  44352 */   // Label 679: @44352
     /*  44352 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44466), // Rule ID 13624 //
     /*  44357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44413 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44417 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44421 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44425 */     // MIs[4] Operand 1
     /*  44425 */     // No operand predicates
     /*  44425 */     // MIs[2] Operand 2
     /*  44425 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44436 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44445 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44464 */     GIR_RootConstrainSelectedInstOperands,
     /*  44465 */     // GIR_Coverage, 13624,
     /*  44465 */     GIR_EraseRootFromParent_Done,
     /*  44466 */   // Label 680: @44466
     /*  44466 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44531), // Rule ID 1855 //
     /*  44471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44514 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44529 */     GIR_RootConstrainSelectedInstOperands,
     /*  44530 */     // GIR_Coverage, 1855,
     /*  44530 */     GIR_EraseRootFromParent_Done,
     /*  44531 */   // Label 681: @44531
     /*  44531 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44596), // Rule ID 1854 //
     /*  44536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44579 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44594 */     GIR_RootConstrainSelectedInstOperands,
     /*  44595 */     // GIR_Coverage, 1854,
     /*  44595 */     GIR_EraseRootFromParent_Done,
     /*  44596 */   // Label 682: @44596
     /*  44596 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44661), // Rule ID 1759 //
     /*  44601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44644 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  44647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44659 */     GIR_RootConstrainSelectedInstOperands,
     /*  44660 */     // GIR_Coverage, 1759,
     /*  44660 */     GIR_EraseRootFromParent_Done,
     /*  44661 */   // Label 683: @44661
     /*  44661 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44726), // Rule ID 1853 //
     /*  44666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44709 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44724 */     GIR_RootConstrainSelectedInstOperands,
     /*  44725 */     // GIR_Coverage, 1853,
     /*  44725 */     GIR_EraseRootFromParent_Done,
     /*  44726 */   // Label 684: @44726
     /*  44726 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44791), // Rule ID 1852 //
     /*  44731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44774 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44789 */     GIR_RootConstrainSelectedInstOperands,
     /*  44790 */     // GIR_Coverage, 1852,
     /*  44790 */     GIR_EraseRootFromParent_Done,
     /*  44791 */   // Label 685: @44791
     /*  44791 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44902), // Rule ID 13586 //
     /*  44796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44843 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44860 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44864 */     // MIs[4] Operand 1
     /*  44864 */     // No operand predicates
     /*  44864 */     // MIs[2] Operand 2
     /*  44864 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44882 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44900 */     GIR_RootConstrainSelectedInstOperands,
     /*  44901 */     // GIR_Coverage, 13586,
     /*  44901 */     GIR_EraseRootFromParent_Done,
     /*  44902 */   // Label 686: @44902
     /*  44902 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(45013), // Rule ID 2046 //
     /*  44907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44980 */     // MIs[4] Operand 1
     /*  44980 */     // No operand predicates
     /*  44980 */     // MIs[2] Operand 2
     /*  44980 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44993 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45011 */     GIR_RootConstrainSelectedInstOperands,
     /*  45012 */     // GIR_Coverage, 2046,
     /*  45012 */     GIR_EraseRootFromParent_Done,
     /*  45013 */   // Label 687: @45013
     /*  45013 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(45124), // Rule ID 13622 //
     /*  45018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45082 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45086 */     // MIs[4] Operand 1
     /*  45086 */     // No operand predicates
     /*  45086 */     // MIs[2] Operand 2
     /*  45086 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45102 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45104 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45122 */     GIR_RootConstrainSelectedInstOperands,
     /*  45123 */     // GIR_Coverage, 13622,
     /*  45123 */     GIR_EraseRootFromParent_Done,
     /*  45124 */   // Label 688: @45124
     /*  45124 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(45235), // Rule ID 2098 //
     /*  45129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45181 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45194 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45198 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45202 */     // MIs[4] Operand 1
     /*  45202 */     // No operand predicates
     /*  45202 */     // MIs[2] Operand 2
     /*  45202 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45213 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45215 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45233 */     GIR_RootConstrainSelectedInstOperands,
     /*  45234 */     // GIR_Coverage, 2098,
     /*  45234 */     GIR_EraseRootFromParent_Done,
     /*  45235 */   // Label 689: @45235
     /*  45235 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(45298), // Rule ID 1735 //
     /*  45240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45279 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  45282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45296 */     GIR_RootConstrainSelectedInstOperands,
     /*  45297 */     // GIR_Coverage, 1735,
     /*  45297 */     GIR_EraseRootFromParent_Done,
     /*  45298 */   // Label 690: @45298
     /*  45298 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(45361), // Rule ID 1825 //
     /*  45303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45342 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  45345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45359 */     GIR_RootConstrainSelectedInstOperands,
     /*  45360 */     // GIR_Coverage, 1825,
     /*  45360 */     GIR_EraseRootFromParent_Done,
     /*  45361 */   // Label 691: @45361
     /*  45361 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(45449), // Rule ID 13587 //
     /*  45366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45418 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45422 */     // MIs[3] Operand 1
     /*  45422 */     // No operand predicates
     /*  45422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45429 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45447 */     GIR_RootConstrainSelectedInstOperands,
     /*  45448 */     // GIR_Coverage, 13587,
     /*  45448 */     GIR_EraseRootFromParent_Done,
     /*  45449 */   // Label 692: @45449
     /*  45449 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45537), // Rule ID 2047 //
     /*  45454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45511 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45515 */     // MIs[3] Operand 1
     /*  45515 */     // No operand predicates
     /*  45515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45517 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45535 */     GIR_RootConstrainSelectedInstOperands,
     /*  45536 */     // GIR_Coverage, 2047,
     /*  45536 */     GIR_EraseRootFromParent_Done,
     /*  45537 */   // Label 693: @45537
     /*  45537 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45625), // Rule ID 13623 //
     /*  45542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45594 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45598 */     // MIs[3] Operand 1
     /*  45598 */     // No operand predicates
     /*  45598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45605 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45623 */     GIR_RootConstrainSelectedInstOperands,
     /*  45624 */     // GIR_Coverage, 13623,
     /*  45624 */     GIR_EraseRootFromParent_Done,
     /*  45625 */   // Label 694: @45625
     /*  45625 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45713), // Rule ID 2099 //
     /*  45630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45691 */     // MIs[3] Operand 1
     /*  45691 */     // No operand predicates
     /*  45691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45693 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45711 */     GIR_RootConstrainSelectedInstOperands,
     /*  45712 */     // GIR_Coverage, 2099,
     /*  45712 */     GIR_EraseRootFromParent_Done,
     /*  45713 */   // Label 695: @45713
     /*  45713 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45760), // Rule ID 1867 //
     /*  45718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45746 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45758 */     GIR_RootConstrainSelectedInstOperands,
     /*  45759 */     // GIR_Coverage, 1867,
     /*  45759 */     GIR_EraseRootFromParent_Done,
     /*  45760 */   // Label 696: @45760
     /*  45760 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45807), // Rule ID 1765 //
     /*  45765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45793 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  45796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45805 */     GIR_RootConstrainSelectedInstOperands,
     /*  45806 */     // GIR_Coverage, 1765,
     /*  45806 */     GIR_EraseRootFromParent_Done,
     /*  45807 */   // Label 697: @45807
     /*  45807 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45854), // Rule ID 1866 //
     /*  45812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45840 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45852 */     GIR_RootConstrainSelectedInstOperands,
     /*  45853 */     // GIR_Coverage, 1866,
     /*  45853 */     GIR_EraseRootFromParent_Done,
     /*  45854 */   // Label 698: @45854
     /*  45854 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45913), // Rule ID 1851 //
     /*  45859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45898 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45911 */     GIR_RootConstrainSelectedInstOperands,
     /*  45912 */     // GIR_Coverage, 1851,
     /*  45912 */     GIR_EraseRootFromParent_Done,
     /*  45913 */   // Label 699: @45913
     /*  45913 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45972), // Rule ID 1850 //
     /*  45918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45957 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45970 */     GIR_RootConstrainSelectedInstOperands,
     /*  45971 */     // GIR_Coverage, 1850,
     /*  45971 */     GIR_EraseRootFromParent_Done,
     /*  45972 */   // Label 700: @45972
     /*  45972 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(46031), // Rule ID 1758 //
     /*  45977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46016 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  46019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46029 */     GIR_RootConstrainSelectedInstOperands,
     /*  46030 */     // GIR_Coverage, 1758,
     /*  46030 */     GIR_EraseRootFromParent_Done,
     /*  46031 */   // Label 701: @46031
     /*  46031 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(46090), // Rule ID 1849 //
     /*  46036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46075 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46088 */     GIR_RootConstrainSelectedInstOperands,
     /*  46089 */     // GIR_Coverage, 1849,
     /*  46089 */     GIR_EraseRootFromParent_Done,
     /*  46090 */   // Label 702: @46090
     /*  46090 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(46149), // Rule ID 1848 //
     /*  46095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46134 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46147 */     GIR_RootConstrainSelectedInstOperands,
     /*  46148 */     // GIR_Coverage, 1848,
     /*  46148 */     GIR_EraseRootFromParent_Done,
     /*  46149 */   // Label 703: @46149
     /*  46149 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(46184), // Rule ID 971 //
     /*  46154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46167 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46175 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  46175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  46178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46182 */     GIR_RootConstrainSelectedInstOperands,
     /*  46183 */     // GIR_Coverage, 971,
     /*  46183 */     GIR_EraseRootFromParent_Done,
     /*  46184 */   // Label 704: @46184
     /*  46184 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46241), // Rule ID 1734 //
     /*  46189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46224 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  46227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46239 */     GIR_RootConstrainSelectedInstOperands,
     /*  46240 */     // GIR_Coverage, 1734,
     /*  46240 */     GIR_EraseRootFromParent_Done,
     /*  46241 */   // Label 705: @46241
     /*  46241 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46298), // Rule ID 1824 //
     /*  46246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  46284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46296 */     GIR_RootConstrainSelectedInstOperands,
     /*  46297 */     // GIR_Coverage, 1824,
     /*  46297 */     GIR_EraseRootFromParent_Done,
     /*  46298 */   // Label 706: @46298
     /*  46298 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46342), // Rule ID 1865 //
     /*  46303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46329 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46340 */     GIR_RootConstrainSelectedInstOperands,
     /*  46341 */     // GIR_Coverage, 1865,
     /*  46341 */     GIR_EraseRootFromParent_Done,
     /*  46342 */   // Label 707: @46342
     /*  46342 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46386), // Rule ID 1764 //
     /*  46347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46373 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  46376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46384 */     GIR_RootConstrainSelectedInstOperands,
     /*  46385 */     // GIR_Coverage, 1764,
     /*  46385 */     GIR_EraseRootFromParent_Done,
     /*  46386 */   // Label 708: @46386
     /*  46386 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46430), // Rule ID 1864 //
     /*  46391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46417 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46428 */     GIR_RootConstrainSelectedInstOperands,
     /*  46429 */     // GIR_Coverage, 1864,
     /*  46429 */     GIR_EraseRootFromParent_Done,
     /*  46430 */   // Label 709: @46430
     /*  46430 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46453), // Rule ID 1478 //
     /*  46435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46446 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  46446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  46451 */     GIR_RootConstrainSelectedInstOperands,
     /*  46452 */     // GIR_Coverage, 1478,
     /*  46452 */     GIR_Done,
     /*  46453 */   // Label 710: @46453
     /*  46453 */   GIM_Reject,
     /*  46454 */ // Label 676: @46454
     /*  46454 */ GIM_Reject,
     /*  46455 */ // Label 594: @46455
     /*  46455 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(47945),
     /*  46460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46470 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46602), // Rule ID 5412 //
     /*  46475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46504 */     // MIs[1] Operand 2
     /*  46504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46527 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46531 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46535 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46539 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46544 */     // MIs[3] Operand 2
     /*  46544 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46555 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46557 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46584 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     // GIR_Coverage, 5412,
     /*  46601 */     GIR_EraseRootFromParent_Done,
     /*  46602 */   // Label 712: @46602
     /*  46602 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46734), // Rule ID 5411 //
     /*  46607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46636 */     // MIs[1] Operand 2
     /*  46636 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46667 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46671 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46676 */     // MIs[3] Operand 2
     /*  46676 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46687 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46689 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46716 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46733 */     // GIR_Coverage, 5411,
     /*  46733 */     GIR_EraseRootFromParent_Done,
     /*  46734 */   // Label 713: @46734
     /*  46734 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46866), // Rule ID 5427 //
     /*  46739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46768 */     // MIs[1] Operand 2
     /*  46768 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46803 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46808 */     // MIs[3] Operand 2
     /*  46808 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46821 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  46828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46865 */     // GIR_Coverage, 5427,
     /*  46865 */     GIR_EraseRootFromParent_Done,
     /*  46866 */   // Label 714: @46866
     /*  46866 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46998), // Rule ID 5410 //
     /*  46871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46900 */     // MIs[1] Operand 2
     /*  46900 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46923 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46927 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46931 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46935 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46940 */     // MIs[3] Operand 2
     /*  46940 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46951 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46953 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46997 */     // GIR_Coverage, 5410,
     /*  46997 */     GIR_EraseRootFromParent_Done,
     /*  46998 */   // Label 715: @46998
     /*  46998 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47130), // Rule ID 5409 //
     /*  47003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47032 */     // MIs[1] Operand 2
     /*  47032 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47055 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  47059 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47063 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47067 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47072 */     // MIs[3] Operand 2
     /*  47072 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  47083 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47085 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  47105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47112 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47129 */     // GIR_Coverage, 5409,
     /*  47129 */     GIR_EraseRootFromParent_Done,
     /*  47130 */   // Label 716: @47130
     /*  47130 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47289), // Rule ID 5382 //
     /*  47135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  47159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47177 */     // MIs[1] Operand 2
     /*  47177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47190 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47204 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47207 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47211 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47216 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47223 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47226 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47288 */     // GIR_Coverage, 5382,
     /*  47288 */     GIR_EraseRootFromParent_Done,
     /*  47289 */   // Label 717: @47289
     /*  47289 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47448), // Rule ID 5379 //
     /*  47294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  47318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47336 */     // MIs[1] Operand 2
     /*  47336 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47349 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47349 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47352 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47356 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47375 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47382 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47412 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47430 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47447 */     // GIR_Coverage, 5379,
     /*  47447 */     GIR_EraseRootFromParent_Done,
     /*  47448 */   // Label 718: @47448
     /*  47448 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47594), // Rule ID 5422 //
     /*  47453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47486 */     // MIs[1] Operand 2
     /*  47486 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47499 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47525 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47532 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47535 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47540 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47545 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47593 */     // GIR_Coverage, 5422,
     /*  47593 */     GIR_EraseRootFromParent_Done,
     /*  47594 */   // Label 719: @47594
     /*  47594 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47740), // Rule ID 5430 //
     /*  47599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47632 */     // MIs[1] Operand 2
     /*  47632 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47645 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47645 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47648 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47652 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47671 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47678 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47722 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47739 */     // GIR_Coverage, 5430,
     /*  47739 */     GIR_EraseRootFromParent_Done,
     /*  47740 */   // Label 720: @47740
     /*  47740 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47886), // Rule ID 5421 //
     /*  47745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47778 */     // MIs[1] Operand 2
     /*  47778 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47791 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47791 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47794 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47798 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47817 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47820 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47824 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47854 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47868 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47885 */     // GIR_Coverage, 5421,
     /*  47885 */     GIR_EraseRootFromParent_Done,
     /*  47886 */   // Label 721: @47886
     /*  47886 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47921), // Rule ID 967 //
     /*  47891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47912 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  47912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  47915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47919 */     GIR_RootConstrainSelectedInstOperands,
     /*  47920 */     // GIR_Coverage, 967,
     /*  47920 */     GIR_EraseRootFromParent_Done,
     /*  47921 */   // Label 722: @47921
     /*  47921 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47944), // Rule ID 1474 //
     /*  47926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47937 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  47937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  47942 */     GIR_RootConstrainSelectedInstOperands,
     /*  47943 */     // GIR_Coverage, 1474,
     /*  47943 */     GIR_Done,
     /*  47944 */   // Label 723: @47944
     /*  47944 */   GIM_Reject,
     /*  47945 */ // Label 711: @47945
     /*  47945 */ GIM_Reject,
     /*  47946 */ // Label 595: @47946
     /*  47946 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(50405),
     /*  47951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47961 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(48075), // Rule ID 2045 //
     /*  47966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48026 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48030 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48034 */     // MIs[4] Operand 1
     /*  48034 */     // No operand predicates
     /*  48034 */     // MIs[2] Operand 2
     /*  48034 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48045 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48054 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48073 */     GIR_RootConstrainSelectedInstOperands,
     /*  48074 */     // GIR_Coverage, 2045,
     /*  48074 */     GIR_EraseRootFromParent_Done,
     /*  48075 */   // Label 725: @48075
     /*  48075 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48189), // Rule ID 13585 //
     /*  48080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48123 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48140 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48144 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48148 */     // MIs[4] Operand 1
     /*  48148 */     // No operand predicates
     /*  48148 */     // MIs[2] Operand 2
     /*  48148 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48159 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48168 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48187 */     GIR_RootConstrainSelectedInstOperands,
     /*  48188 */     // GIR_Coverage, 13585,
     /*  48188 */     GIR_EraseRootFromParent_Done,
     /*  48189 */   // Label 726: @48189
     /*  48189 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48303), // Rule ID 2097 //
     /*  48194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48237 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48241 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48254 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48258 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48262 */     // MIs[4] Operand 1
     /*  48262 */     // No operand predicates
     /*  48262 */     // MIs[2] Operand 2
     /*  48262 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48273 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48282 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48301 */     GIR_RootConstrainSelectedInstOperands,
     /*  48302 */     // GIR_Coverage, 2097,
     /*  48302 */     GIR_EraseRootFromParent_Done,
     /*  48303 */   // Label 727: @48303
     /*  48303 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48417), // Rule ID 13621 //
     /*  48308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48351 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48355 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48359 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48364 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48368 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48372 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48376 */     // MIs[4] Operand 1
     /*  48376 */     // No operand predicates
     /*  48376 */     // MIs[2] Operand 2
     /*  48376 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48387 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48396 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48415 */     GIR_RootConstrainSelectedInstOperands,
     /*  48416 */     // GIR_Coverage, 13621,
     /*  48416 */     GIR_EraseRootFromParent_Done,
     /*  48417 */   // Label 728: @48417
     /*  48417 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48482), // Rule ID 1847 //
     /*  48422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48465 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48480 */     GIR_RootConstrainSelectedInstOperands,
     /*  48481 */     // GIR_Coverage, 1847,
     /*  48481 */     GIR_EraseRootFromParent_Done,
     /*  48482 */   // Label 729: @48482
     /*  48482 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48547), // Rule ID 1846 //
     /*  48487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48530 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48545 */     GIR_RootConstrainSelectedInstOperands,
     /*  48546 */     // GIR_Coverage, 1846,
     /*  48546 */     GIR_EraseRootFromParent_Done,
     /*  48547 */   // Label 730: @48547
     /*  48547 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48612), // Rule ID 1757 //
     /*  48552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48595 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  48598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48610 */     GIR_RootConstrainSelectedInstOperands,
     /*  48611 */     // GIR_Coverage, 1757,
     /*  48611 */     GIR_EraseRootFromParent_Done,
     /*  48612 */   // Label 731: @48612
     /*  48612 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48677), // Rule ID 1845 //
     /*  48617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48660 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48675 */     GIR_RootConstrainSelectedInstOperands,
     /*  48676 */     // GIR_Coverage, 1845,
     /*  48676 */     GIR_EraseRootFromParent_Done,
     /*  48677 */   // Label 732: @48677
     /*  48677 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48742), // Rule ID 1844 //
     /*  48682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48725 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48740 */     GIR_RootConstrainSelectedInstOperands,
     /*  48741 */     // GIR_Coverage, 1844,
     /*  48741 */     GIR_EraseRootFromParent_Done,
     /*  48742 */   // Label 733: @48742
     /*  48742 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48853), // Rule ID 13583 //
     /*  48747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48798 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48811 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48815 */     // MIs[4] Operand 1
     /*  48815 */     // No operand predicates
     /*  48815 */     // MIs[2] Operand 2
     /*  48815 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48833 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48851 */     GIR_RootConstrainSelectedInstOperands,
     /*  48852 */     // GIR_Coverage, 13583,
     /*  48852 */     GIR_EraseRootFromParent_Done,
     /*  48853 */   // Label 734: @48853
     /*  48853 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48964), // Rule ID 2043 //
     /*  48858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48910 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48914 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48923 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48927 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48931 */     // MIs[4] Operand 1
     /*  48931 */     // No operand predicates
     /*  48931 */     // MIs[2] Operand 2
     /*  48931 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48942 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48944 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48962 */     GIR_RootConstrainSelectedInstOperands,
     /*  48963 */     // GIR_Coverage, 2043,
     /*  48963 */     GIR_EraseRootFromParent_Done,
     /*  48964 */   // Label 735: @48964
     /*  48964 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(49075), // Rule ID 13619 //
     /*  48969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49033 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49037 */     // MIs[4] Operand 1
     /*  49037 */     // No operand predicates
     /*  49037 */     // MIs[2] Operand 2
     /*  49037 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49055 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49073 */     GIR_RootConstrainSelectedInstOperands,
     /*  49074 */     // GIR_Coverage, 13619,
     /*  49074 */     GIR_EraseRootFromParent_Done,
     /*  49075 */   // Label 736: @49075
     /*  49075 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(49186), // Rule ID 2095 //
     /*  49080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49132 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49136 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49141 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49145 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49149 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49153 */     // MIs[4] Operand 1
     /*  49153 */     // No operand predicates
     /*  49153 */     // MIs[2] Operand 2
     /*  49153 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49166 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49184 */     GIR_RootConstrainSelectedInstOperands,
     /*  49185 */     // GIR_Coverage, 2095,
     /*  49185 */     GIR_EraseRootFromParent_Done,
     /*  49186 */   // Label 737: @49186
     /*  49186 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(49249), // Rule ID 1733 //
     /*  49191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49230 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  49233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49247 */     GIR_RootConstrainSelectedInstOperands,
     /*  49248 */     // GIR_Coverage, 1733,
     /*  49248 */     GIR_EraseRootFromParent_Done,
     /*  49249 */   // Label 738: @49249
     /*  49249 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(49312), // Rule ID 1823 //
     /*  49254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49293 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  49296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49310 */     GIR_RootConstrainSelectedInstOperands,
     /*  49311 */     // GIR_Coverage, 1823,
     /*  49311 */     GIR_EraseRootFromParent_Done,
     /*  49312 */   // Label 739: @49312
     /*  49312 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(49400), // Rule ID 13584 //
     /*  49317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49373 */     // MIs[3] Operand 1
     /*  49373 */     // No operand predicates
     /*  49373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49380 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49398 */     GIR_RootConstrainSelectedInstOperands,
     /*  49399 */     // GIR_Coverage, 13584,
     /*  49399 */     GIR_EraseRootFromParent_Done,
     /*  49400 */   // Label 740: @49400
     /*  49400 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(49488), // Rule ID 2044 //
     /*  49405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49466 */     // MIs[3] Operand 1
     /*  49466 */     // No operand predicates
     /*  49466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49468 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49486 */     GIR_RootConstrainSelectedInstOperands,
     /*  49487 */     // GIR_Coverage, 2044,
     /*  49487 */     GIR_EraseRootFromParent_Done,
     /*  49488 */   // Label 741: @49488
     /*  49488 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49576), // Rule ID 13620 //
     /*  49493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49549 */     // MIs[3] Operand 1
     /*  49549 */     // No operand predicates
     /*  49549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49556 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49574 */     GIR_RootConstrainSelectedInstOperands,
     /*  49575 */     // GIR_Coverage, 13620,
     /*  49575 */     GIR_EraseRootFromParent_Done,
     /*  49576 */   // Label 742: @49576
     /*  49576 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49664), // Rule ID 2096 //
     /*  49581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49638 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49642 */     // MIs[3] Operand 1
     /*  49642 */     // No operand predicates
     /*  49642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49644 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49662 */     GIR_RootConstrainSelectedInstOperands,
     /*  49663 */     // GIR_Coverage, 2096,
     /*  49663 */     GIR_EraseRootFromParent_Done,
     /*  49664 */   // Label 743: @49664
     /*  49664 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49711), // Rule ID 1863 //
     /*  49669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49697 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1863,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 744: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49758), // Rule ID 1763 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49744 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1763,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 745: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49805), // Rule ID 1862 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49791 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1862,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 746: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49864), // Rule ID 1843 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49849 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49862 */     GIR_RootConstrainSelectedInstOperands,
     /*  49863 */     // GIR_Coverage, 1843,
     /*  49863 */     GIR_EraseRootFromParent_Done,
     /*  49864 */   // Label 747: @49864
     /*  49864 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49923), // Rule ID 1842 //
     /*  49869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49908 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49921 */     GIR_RootConstrainSelectedInstOperands,
     /*  49922 */     // GIR_Coverage, 1842,
     /*  49922 */     GIR_EraseRootFromParent_Done,
     /*  49923 */   // Label 748: @49923
     /*  49923 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49982), // Rule ID 1756 //
     /*  49928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49967 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  49970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49980 */     GIR_RootConstrainSelectedInstOperands,
     /*  49981 */     // GIR_Coverage, 1756,
     /*  49981 */     GIR_EraseRootFromParent_Done,
     /*  49982 */   // Label 749: @49982
     /*  49982 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50041), // Rule ID 1841 //
     /*  49987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50026 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50039 */     GIR_RootConstrainSelectedInstOperands,
     /*  50040 */     // GIR_Coverage, 1841,
     /*  50040 */     GIR_EraseRootFromParent_Done,
     /*  50041 */   // Label 750: @50041
     /*  50041 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(50100), // Rule ID 1840 //
     /*  50046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50085 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50098 */     GIR_RootConstrainSelectedInstOperands,
     /*  50099 */     // GIR_Coverage, 1840,
     /*  50099 */     GIR_EraseRootFromParent_Done,
     /*  50100 */   // Label 751: @50100
     /*  50100 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(50135), // Rule ID 970 //
     /*  50105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50118 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50126 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  50126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  50129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50133 */     GIR_RootConstrainSelectedInstOperands,
     /*  50134 */     // GIR_Coverage, 970,
     /*  50134 */     GIR_EraseRootFromParent_Done,
     /*  50135 */   // Label 752: @50135
     /*  50135 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(50192), // Rule ID 1732 //
     /*  50140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50175 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50190 */     GIR_RootConstrainSelectedInstOperands,
     /*  50191 */     // GIR_Coverage, 1732,
     /*  50191 */     GIR_EraseRootFromParent_Done,
     /*  50192 */   // Label 753: @50192
     /*  50192 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(50249), // Rule ID 1822 //
     /*  50197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  50235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50247 */     GIR_RootConstrainSelectedInstOperands,
     /*  50248 */     // GIR_Coverage, 1822,
     /*  50248 */     GIR_EraseRootFromParent_Done,
     /*  50249 */   // Label 754: @50249
     /*  50249 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(50293), // Rule ID 1861 //
     /*  50254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50280 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50291 */     GIR_RootConstrainSelectedInstOperands,
     /*  50292 */     // GIR_Coverage, 1861,
     /*  50292 */     GIR_EraseRootFromParent_Done,
     /*  50293 */   // Label 755: @50293
     /*  50293 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(50337), // Rule ID 1762 //
     /*  50298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50324 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  50327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50335 */     GIR_RootConstrainSelectedInstOperands,
     /*  50336 */     // GIR_Coverage, 1762,
     /*  50336 */     GIR_EraseRootFromParent_Done,
     /*  50337 */   // Label 756: @50337
     /*  50337 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(50381), // Rule ID 1860 //
     /*  50342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50368 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50379 */     GIR_RootConstrainSelectedInstOperands,
     /*  50380 */     // GIR_Coverage, 1860,
     /*  50380 */     GIR_EraseRootFromParent_Done,
     /*  50381 */   // Label 757: @50381
     /*  50381 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(50404), // Rule ID 1477 //
     /*  50386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50397 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  50397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  50402 */     GIR_RootConstrainSelectedInstOperands,
     /*  50403 */     // GIR_Coverage, 1477,
     /*  50403 */     GIR_Done,
     /*  50404 */   // Label 758: @50404
     /*  50404 */   GIM_Reject,
     /*  50405 */ // Label 724: @50405
     /*  50405 */ GIM_Reject,
     /*  50406 */ // Label 596: @50406
     /*  50406 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(50480),
     /*  50411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50421 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(50456), // Rule ID 965 //
     /*  50426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50433 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50439 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50447 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  50447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  50450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50454 */     GIR_RootConstrainSelectedInstOperands,
     /*  50455 */     // GIR_Coverage, 965,
     /*  50455 */     GIR_EraseRootFromParent_Done,
     /*  50456 */   // Label 760: @50456
     /*  50456 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(50479), // Rule ID 1472 //
     /*  50461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50472 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  50477 */     GIR_RootConstrainSelectedInstOperands,
     /*  50478 */     // GIR_Coverage, 1472,
     /*  50478 */     GIR_Done,
     /*  50479 */   // Label 761: @50479
     /*  50479 */   GIM_Reject,
     /*  50480 */ // Label 759: @50480
     /*  50480 */ GIM_Reject,
     /*  50481 */ // Label 597: @50481
     /*  50481 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(51688),
     /*  50486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50496 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50561), // Rule ID 1839 //
     /*  50501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50544 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50559 */     GIR_RootConstrainSelectedInstOperands,
     /*  50560 */     // GIR_Coverage, 1839,
     /*  50560 */     GIR_EraseRootFromParent_Done,
     /*  50561 */   // Label 763: @50561
     /*  50561 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50626), // Rule ID 1838 //
     /*  50566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50609 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50624 */     GIR_RootConstrainSelectedInstOperands,
     /*  50625 */     // GIR_Coverage, 1838,
     /*  50625 */     GIR_EraseRootFromParent_Done,
     /*  50626 */   // Label 764: @50626
     /*  50626 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50691), // Rule ID 1755 //
     /*  50631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50674 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  50677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50689 */     GIR_RootConstrainSelectedInstOperands,
     /*  50690 */     // GIR_Coverage, 1755,
     /*  50690 */     GIR_EraseRootFromParent_Done,
     /*  50691 */   // Label 765: @50691
     /*  50691 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50756), // Rule ID 1837 //
     /*  50696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50739 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50754 */     GIR_RootConstrainSelectedInstOperands,
     /*  50755 */     // GIR_Coverage, 1837,
     /*  50755 */     GIR_EraseRootFromParent_Done,
     /*  50756 */   // Label 766: @50756
     /*  50756 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50821), // Rule ID 1836 //
     /*  50761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50804 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50819 */     GIR_RootConstrainSelectedInstOperands,
     /*  50820 */     // GIR_Coverage, 1836,
     /*  50820 */     GIR_EraseRootFromParent_Done,
     /*  50821 */   // Label 767: @50821
     /*  50821 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50884), // Rule ID 1731 //
     /*  50826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50865 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  50868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50882 */     GIR_RootConstrainSelectedInstOperands,
     /*  50883 */     // GIR_Coverage, 1731,
     /*  50883 */     GIR_EraseRootFromParent_Done,
     /*  50884 */   // Label 768: @50884
     /*  50884 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50947), // Rule ID 1821 //
     /*  50889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50928 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  50931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50945 */     GIR_RootConstrainSelectedInstOperands,
     /*  50946 */     // GIR_Coverage, 1821,
     /*  50946 */     GIR_EraseRootFromParent_Done,
     /*  50947 */   // Label 769: @50947
     /*  50947 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50994), // Rule ID 1859 //
     /*  50952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50980 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  50983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  50992 */     GIR_RootConstrainSelectedInstOperands,
     /*  50993 */     // GIR_Coverage, 1859,
     /*  50993 */     GIR_EraseRootFromParent_Done,
     /*  50994 */   // Label 770: @50994
     /*  50994 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(51041), // Rule ID 1761 //
     /*  50999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51027 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  51030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51039 */     GIR_RootConstrainSelectedInstOperands,
     /*  51040 */     // GIR_Coverage, 1761,
     /*  51040 */     GIR_EraseRootFromParent_Done,
     /*  51041 */   // Label 771: @51041
     /*  51041 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(51088), // Rule ID 1858 //
     /*  51046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51074 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  51077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51086 */     GIR_RootConstrainSelectedInstOperands,
     /*  51087 */     // GIR_Coverage, 1858,
     /*  51087 */     GIR_EraseRootFromParent_Done,
     /*  51088 */   // Label 772: @51088
     /*  51088 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(51147), // Rule ID 1835 //
     /*  51093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51132 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51145 */     GIR_RootConstrainSelectedInstOperands,
     /*  51146 */     // GIR_Coverage, 1835,
     /*  51146 */     GIR_EraseRootFromParent_Done,
     /*  51147 */   // Label 773: @51147
     /*  51147 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(51206), // Rule ID 1834 //
     /*  51152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51191 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51204 */     GIR_RootConstrainSelectedInstOperands,
     /*  51205 */     // GIR_Coverage, 1834,
     /*  51205 */     GIR_EraseRootFromParent_Done,
     /*  51206 */   // Label 774: @51206
     /*  51206 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(51265), // Rule ID 1754 //
     /*  51211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51250 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  51253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 1754,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 775: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(51324), // Rule ID 1833 //
     /*  51270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51309 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51322 */     GIR_RootConstrainSelectedInstOperands,
     /*  51323 */     // GIR_Coverage, 1833,
     /*  51323 */     GIR_EraseRootFromParent_Done,
     /*  51324 */   // Label 776: @51324
     /*  51324 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(51383), // Rule ID 1832 //
     /*  51329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51368 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51381 */     GIR_RootConstrainSelectedInstOperands,
     /*  51382 */     // GIR_Coverage, 1832,
     /*  51382 */     GIR_EraseRootFromParent_Done,
     /*  51383 */   // Label 777: @51383
     /*  51383 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(51418), // Rule ID 968 //
     /*  51388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51409 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  51409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  51412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51416 */     GIR_RootConstrainSelectedInstOperands,
     /*  51417 */     // GIR_Coverage, 968,
     /*  51417 */     GIR_EraseRootFromParent_Done,
     /*  51418 */   // Label 778: @51418
     /*  51418 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(51475), // Rule ID 1730 //
     /*  51423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  51438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51458 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  51461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51473 */     GIR_RootConstrainSelectedInstOperands,
     /*  51474 */     // GIR_Coverage, 1730,
     /*  51474 */     GIR_EraseRootFromParent_Done,
     /*  51475 */   // Label 779: @51475
     /*  51475 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(51532), // Rule ID 1820 //
     /*  51480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  51495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51515 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  51518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51530 */     GIR_RootConstrainSelectedInstOperands,
     /*  51531 */     // GIR_Coverage, 1820,
     /*  51531 */     GIR_EraseRootFromParent_Done,
     /*  51532 */   // Label 780: @51532
     /*  51532 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(51576), // Rule ID 1857 //
     /*  51537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51563 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51574 */     GIR_RootConstrainSelectedInstOperands,
     /*  51575 */     // GIR_Coverage, 1857,
     /*  51575 */     GIR_EraseRootFromParent_Done,
     /*  51576 */   // Label 781: @51576
     /*  51576 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(51620), // Rule ID 1760 //
     /*  51581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51607 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  51610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51618 */     GIR_RootConstrainSelectedInstOperands,
     /*  51619 */     // GIR_Coverage, 1760,
     /*  51619 */     GIR_EraseRootFromParent_Done,
     /*  51620 */   // Label 782: @51620
     /*  51620 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(51664), // Rule ID 1856 //
     /*  51625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51651 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51662 */     GIR_RootConstrainSelectedInstOperands,
     /*  51663 */     // GIR_Coverage, 1856,
     /*  51663 */     GIR_EraseRootFromParent_Done,
     /*  51664 */   // Label 783: @51664
     /*  51664 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(51687), // Rule ID 1475 //
     /*  51669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51680 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  51680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  51685 */     GIR_RootConstrainSelectedInstOperands,
     /*  51686 */     // GIR_Coverage, 1475,
     /*  51686 */     GIR_Done,
     /*  51687 */   // Label 784: @51687
     /*  51687 */   GIM_Reject,
     /*  51688 */ // Label 762: @51688
     /*  51688 */ GIM_Reject,
     /*  51689 */ // Label 598: @51689
     /*  51689 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(51763),
     /*  51694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  51697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51704 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(51739), // Rule ID 966 //
     /*  51709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51730 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  51730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  51733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51737 */     GIR_RootConstrainSelectedInstOperands,
     /*  51738 */     // GIR_Coverage, 966,
     /*  51738 */     GIR_EraseRootFromParent_Done,
     /*  51739 */   // Label 786: @51739
     /*  51739 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(51762), // Rule ID 1473 //
     /*  51744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51755 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  51760 */     GIR_RootConstrainSelectedInstOperands,
     /*  51761 */     // GIR_Coverage, 1473,
     /*  51761 */     GIR_Done,
     /*  51762 */   // Label 787: @51762
     /*  51762 */   GIM_Reject,
     /*  51763 */ // Label 785: @51763
     /*  51763 */ GIM_Reject,
     /*  51764 */ // Label 599: @51764
     /*  51764 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(51789), // Rule ID 7502 //
     /*  51769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  51775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  51778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51782 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  51782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  51787 */   GIR_RootConstrainSelectedInstOperands,
     /*  51788 */   // GIR_Coverage, 7502,
     /*  51788 */   GIR_Done,
     /*  51789 */ // Label 788: @51789
     /*  51789 */ GIM_Reject,
     /*  51790 */ // Label 600: @51790
     /*  51790 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(51815), // Rule ID 7501 //
     /*  51795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  51801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  51804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51808 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  51808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  51813 */   GIR_RootConstrainSelectedInstOperands,
     /*  51814 */   // GIR_Coverage, 7501,
     /*  51814 */   GIR_Done,
     /*  51815 */ // Label 789: @51815
     /*  51815 */ GIM_Reject,
     /*  51816 */ // Label 601: @51816
     /*  51816 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(51841), // Rule ID 7500 //
     /*  51821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  51827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  51830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51834 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  51834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  51839 */   GIR_RootConstrainSelectedInstOperands,
     /*  51840 */   // GIR_Coverage, 7500,
     /*  51840 */   GIR_Done,
     /*  51841 */ // Label 790: @51841
     /*  51841 */ GIM_Reject,
     /*  51842 */ // Label 602: @51842
     /*  51842 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(51867), // Rule ID 7499 //
     /*  51847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  51853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  51856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51860 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  51860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  51865 */   GIR_RootConstrainSelectedInstOperands,
     /*  51866 */   // GIR_Coverage, 7499,
     /*  51866 */   GIR_Done,
     /*  51867 */ // Label 791: @51867
     /*  51867 */ GIM_Reject,
     /*  51868 */ // Label 603: @51868
     /*  51868 */ GIM_Reject,
     /*  51869 */ // Label 2: @51869
     /*  51869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 800*/ GIMT_Encode4(54633),
     /*  51880 */ /*GILLT_s32*//*Label 792*/ GIMT_Encode4(51920),
     /*  51884 */ /*GILLT_s64*//*Label 793*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  51892 */ /*GILLT_v2s32*//*Label 794*/ GIMT_Encode4(53557), GIMT_Encode4(0),
     /*  51900 */ /*GILLT_v4s16*//*Label 795*/ GIMT_Encode4(53895),
     /*  51904 */ /*GILLT_v4s32*//*Label 796*/ GIMT_Encode4(54233),
     /*  51908 */ /*GILLT_v8s8*//*Label 797*/ GIMT_Encode4(54399),
     /*  51912 */ /*GILLT_v8s16*//*Label 798*/ GIMT_Encode4(54433),
     /*  51916 */ /*GILLT_v16s8*//*Label 799*/ GIMT_Encode4(54599),
     /*  51920 */ // Label 792: @51920
     /*  51920 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(52076),
     /*  51925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  51931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51935 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51990), // Rule ID 3959 //
     /*  51940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51971 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  51974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51988 */     GIR_RootConstrainSelectedInstOperands,
     /*  51989 */     // GIR_Coverage, 3959,
     /*  51989 */     GIR_EraseRootFromParent_Done,
     /*  51990 */   // Label 802: @51990
     /*  51990 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(52045), // Rule ID 13874 //
     /*  51995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52026 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  52029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 13874,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 803: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(52075), // Rule ID 3955 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52058 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3955,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 804: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 801: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 793: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(53556),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52238), // Rule ID 3964 //
     /*  52097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52118 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52150 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52163 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52175 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52236 */     GIR_RootConstrainSelectedInstOperands,
     /*  52237 */     // GIR_Coverage, 3964,
     /*  52237 */     GIR_EraseRootFromParent_Done,
     /*  52238 */   // Label 806: @52238
     /*  52238 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52342), // Rule ID 3965 //
     /*  52243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52264 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52294 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52340 */     GIR_RootConstrainSelectedInstOperands,
     /*  52341 */     // GIR_Coverage, 3965,
     /*  52341 */     GIR_EraseRootFromParent_Done,
     /*  52342 */   // Label 807: @52342
     /*  52342 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52446), // Rule ID 13877 //
     /*  52347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52385 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52398 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52410 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52444 */     GIR_RootConstrainSelectedInstOperands,
     /*  52445 */     // GIR_Coverage, 13877,
     /*  52445 */     GIR_EraseRootFromParent_Done,
     /*  52446 */   // Label 808: @52446
     /*  52446 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52501), // Rule ID 3960 //
     /*  52451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52482 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52499 */     GIR_RootConstrainSelectedInstOperands,
     /*  52500 */     // GIR_Coverage, 3960,
     /*  52500 */     GIR_EraseRootFromParent_Done,
     /*  52501 */   // Label 809: @52501
     /*  52501 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52556), // Rule ID 13875 //
     /*  52506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52526 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52537 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52554 */     GIR_RootConstrainSelectedInstOperands,
     /*  52555 */     // GIR_Coverage, 13875,
     /*  52555 */     GIR_EraseRootFromParent_Done,
     /*  52556 */   // Label 810: @52556
     /*  52556 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52669), // Rule ID 3971 //
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52578 */     // MIs[1] Operand 2
     /*  52578 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52601 */     // MIs[2] Operand 1
     /*  52601 */     // No operand predicates
     /*  52601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52603 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52615 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52634 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52667 */     GIR_RootConstrainSelectedInstOperands,
     /*  52668 */     // GIR_Coverage, 3971,
     /*  52668 */     GIR_EraseRootFromParent_Done,
     /*  52669 */   // Label 811: @52669
     /*  52669 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52744), // Rule ID 3969 //
     /*  52674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  52682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52703 */     // MIs[2] Operand 1
     /*  52703 */     // No operand predicates
     /*  52703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52705 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52717 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52742 */     GIR_RootConstrainSelectedInstOperands,
     /*  52743 */     // GIR_Coverage, 3969,
     /*  52743 */     GIR_EraseRootFromParent_Done,
     /*  52744 */   // Label 812: @52744
     /*  52744 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52819), // Rule ID 3970 //
     /*  52749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  52778 */     // MIs[2] Operand 1
     /*  52778 */     // No operand predicates
     /*  52778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52780 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52792 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52817 */     GIR_RootConstrainSelectedInstOperands,
     /*  52818 */     // GIR_Coverage, 3970,
     /*  52818 */     GIR_EraseRootFromParent_Done,
     /*  52819 */   // Label 813: @52819
     /*  52819 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52957), // Rule ID 3961 //
     /*  52824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52841 */     // MIs[1] Operand 2
     /*  52841 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52869 */     // MIs[2] Operand 2
     /*  52869 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  52880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52882 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52894 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52922 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52955 */     GIR_RootConstrainSelectedInstOperands,
     /*  52956 */     // GIR_Coverage, 3961,
     /*  52956 */     GIR_EraseRootFromParent_Done,
     /*  52957 */   // Label 814: @52957
     /*  52957 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(53057), // Rule ID 3962 //
     /*  52962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52979 */     // MIs[1] Operand 2
     /*  52979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  52998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53009 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53021 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53055 */     GIR_RootConstrainSelectedInstOperands,
     /*  53056 */     // GIR_Coverage, 3962,
     /*  53056 */     GIR_EraseRootFromParent_Done,
     /*  53057 */   // Label 815: @53057
     /*  53057 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(53157), // Rule ID 13876 //
     /*  53062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  53087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53096 */     // MIs[2] Operand 2
     /*  53096 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  53107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53109 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53121 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53155 */     GIR_RootConstrainSelectedInstOperands,
     /*  53156 */     // GIR_Coverage, 13876,
     /*  53156 */     GIR_EraseRootFromParent_Done,
     /*  53157 */   // Label 816: @53157
     /*  53157 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(53219), // Rule ID 3963 //
     /*  53162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53198 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53217 */     GIR_RootConstrainSelectedInstOperands,
     /*  53218 */     // GIR_Coverage, 3963,
     /*  53218 */     GIR_EraseRootFromParent_Done,
     /*  53219 */   // Label 817: @53219
     /*  53219 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(53281), // Rule ID 3966 //
     /*  53224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53260 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53279 */     GIR_RootConstrainSelectedInstOperands,
     /*  53280 */     // GIR_Coverage, 3966,
     /*  53280 */     GIR_EraseRootFromParent_Done,
     /*  53281 */   // Label 818: @53281
     /*  53281 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(53358), // Rule ID 3990 //
     /*  53286 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53310 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53356 */     GIR_RootConstrainSelectedInstOperands,
     /*  53357 */     // GIR_Coverage, 3990,
     /*  53357 */     GIR_EraseRootFromParent_Done,
     /*  53358 */   // Label 819: @53358
     /*  53358 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(53435), // Rule ID 13888 //
     /*  53363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53380 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53387 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53399 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53433 */     GIR_RootConstrainSelectedInstOperands,
     /*  53434 */     // GIR_Coverage, 13888,
     /*  53434 */     GIR_EraseRootFromParent_Done,
     /*  53435 */   // Label 820: @53435
     /*  53435 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(53525), // Rule ID 3989 //
     /*  53440 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53445 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53450 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  53450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  53453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53462 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  53468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53490 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  53517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53523 */     GIR_RootConstrainSelectedInstOperands,
     /*  53524 */     // GIR_Coverage, 3989,
     /*  53524 */     GIR_EraseRootFromParent_Done,
     /*  53525 */   // Label 821: @53525
     /*  53525 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(53555), // Rule ID 3956 //
     /*  53530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53538 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  53538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  53541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  53547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53553 */     GIR_RootConstrainSelectedInstOperands,
     /*  53554 */     // GIR_Coverage, 3956,
     /*  53554 */     GIR_EraseRootFromParent_Done,
     /*  53555 */   // Label 822: @53555
     /*  53555 */   GIM_Reject,
     /*  53556 */ // Label 805: @53556
     /*  53556 */ GIM_Reject,
     /*  53557 */ // Label 794: @53557
     /*  53557 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(53894),
     /*  53562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  53565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53572 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(53658), // Rule ID 13562 //
     /*  53577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53621 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53625 */     // MIs[3] Operand 1
     /*  53625 */     // No operand predicates
     /*  53625 */     // MIs[1] Operand 2
     /*  53625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53642 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53656 */     GIR_RootConstrainSelectedInstOperands,
     /*  53657 */     // GIR_Coverage, 13562,
     /*  53657 */     GIR_EraseRootFromParent_Done,
     /*  53658 */   // Label 824: @53658
     /*  53658 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53744), // Rule ID 2034 //
     /*  53663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53715 */     // MIs[3] Operand 1
     /*  53715 */     // No operand predicates
     /*  53715 */     // MIs[1] Operand 2
     /*  53715 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53728 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53742 */     GIR_RootConstrainSelectedInstOperands,
     /*  53743 */     // GIR_Coverage, 2034,
     /*  53743 */     GIR_EraseRootFromParent_Done,
     /*  53744 */   // Label 825: @53744
     /*  53744 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53807), // Rule ID 13563 //
     /*  53749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53785 */     // MIs[2] Operand 1
     /*  53785 */     // No operand predicates
     /*  53785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53791 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53805 */     GIR_RootConstrainSelectedInstOperands,
     /*  53806 */     // GIR_Coverage, 13563,
     /*  53806 */     GIR_EraseRootFromParent_Done,
     /*  53807 */   // Label 826: @53807
     /*  53807 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53870), // Rule ID 2035 //
     /*  53812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53852 */     // MIs[2] Operand 1
     /*  53852 */     // No operand predicates
     /*  53852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53854 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53868 */     GIR_RootConstrainSelectedInstOperands,
     /*  53869 */     // GIR_Coverage, 2035,
     /*  53869 */     GIR_EraseRootFromParent_Done,
     /*  53870 */   // Label 827: @53870
     /*  53870 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53893), // Rule ID 1352 //
     /*  53875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53886 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  53886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  53891 */     GIR_RootConstrainSelectedInstOperands,
     /*  53892 */     // GIR_Coverage, 1352,
     /*  53892 */     GIR_Done,
     /*  53893 */   // Label 828: @53893
     /*  53893 */   GIM_Reject,
     /*  53894 */ // Label 823: @53894
     /*  53894 */ GIM_Reject,
     /*  53895 */ // Label 795: @53895
     /*  53895 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(54232),
     /*  53900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  53903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53910 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(53996), // Rule ID 13559 //
     /*  53915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53963 */     // MIs[3] Operand 1
     /*  53963 */     // No operand predicates
     /*  53963 */     // MIs[1] Operand 2
     /*  53963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53980 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  53983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53994 */     GIR_RootConstrainSelectedInstOperands,
     /*  53995 */     // GIR_Coverage, 13559,
     /*  53995 */     GIR_EraseRootFromParent_Done,
     /*  53996 */   // Label 830: @53996
     /*  53996 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(54082), // Rule ID 2031 //
     /*  54001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  54016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54049 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54053 */     // MIs[3] Operand 1
     /*  54053 */     // No operand predicates
     /*  54053 */     // MIs[1] Operand 2
     /*  54053 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  54064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54066 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  54077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  54080 */     GIR_RootConstrainSelectedInstOperands,
     /*  54081 */     // GIR_Coverage, 2031,
     /*  54081 */     GIR_EraseRootFromParent_Done,
     /*  54082 */   // Label 831: @54082
     /*  54082 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(54145), // Rule ID 13560 //
     /*  54087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54123 */     // MIs[2] Operand 1
     /*  54123 */     // No operand predicates
     /*  54123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54129 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54143 */     GIR_RootConstrainSelectedInstOperands,
     /*  54144 */     // GIR_Coverage, 13560,
     /*  54144 */     GIR_EraseRootFromParent_Done,
     /*  54145 */   // Label 832: @54145
     /*  54145 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(54208), // Rule ID 2032 //
     /*  54150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54186 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54190 */     // MIs[2] Operand 1
     /*  54190 */     // No operand predicates
     /*  54190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54192 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54206 */     GIR_RootConstrainSelectedInstOperands,
     /*  54207 */     // GIR_Coverage, 2032,
     /*  54207 */     GIR_EraseRootFromParent_Done,
     /*  54208 */   // Label 833: @54208
     /*  54208 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(54231), // Rule ID 1350 //
     /*  54213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54224 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  54224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  54229 */     GIR_RootConstrainSelectedInstOperands,
     /*  54230 */     // GIR_Coverage, 1350,
     /*  54230 */     GIR_Done,
     /*  54231 */   // Label 834: @54231
     /*  54231 */   GIM_Reject,
     /*  54232 */ // Label 829: @54232
     /*  54232 */ GIM_Reject,
     /*  54233 */ // Label 796: @54233
     /*  54233 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(54398),
     /*  54238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54248 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(54311), // Rule ID 13564 //
     /*  54253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54289 */     // MIs[2] Operand 1
     /*  54289 */     // No operand predicates
     /*  54289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54295 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54309 */     GIR_RootConstrainSelectedInstOperands,
     /*  54310 */     // GIR_Coverage, 13564,
     /*  54310 */     GIR_EraseRootFromParent_Done,
     /*  54311 */   // Label 836: @54311
     /*  54311 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(54374), // Rule ID 2036 //
     /*  54316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54352 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54356 */     // MIs[2] Operand 1
     /*  54356 */     // No operand predicates
     /*  54356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54358 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54372 */     GIR_RootConstrainSelectedInstOperands,
     /*  54373 */     // GIR_Coverage, 2036,
     /*  54373 */     GIR_EraseRootFromParent_Done,
     /*  54374 */   // Label 837: @54374
     /*  54374 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(54397), // Rule ID 1353 //
     /*  54379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54390 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  54390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  54395 */     GIR_RootConstrainSelectedInstOperands,
     /*  54396 */     // GIR_Coverage, 1353,
     /*  54396 */     GIR_Done,
     /*  54397 */   // Label 838: @54397
     /*  54397 */   GIM_Reject,
     /*  54398 */ // Label 835: @54398
     /*  54398 */ GIM_Reject,
     /*  54399 */ // Label 797: @54399
     /*  54399 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(54432), // Rule ID 1348 //
     /*  54404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  54410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54425 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  54425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  54430 */   GIR_RootConstrainSelectedInstOperands,
     /*  54431 */   // GIR_Coverage, 1348,
     /*  54431 */   GIR_Done,
     /*  54432 */ // Label 839: @54432
     /*  54432 */ GIM_Reject,
     /*  54433 */ // Label 798: @54433
     /*  54433 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(54598),
     /*  54438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54448 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(54511), // Rule ID 13561 //
     /*  54453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54489 */     // MIs[2] Operand 1
     /*  54489 */     // No operand predicates
     /*  54489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54495 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54509 */     GIR_RootConstrainSelectedInstOperands,
     /*  54510 */     // GIR_Coverage, 13561,
     /*  54510 */     GIR_EraseRootFromParent_Done,
     /*  54511 */   // Label 841: @54511
     /*  54511 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(54574), // Rule ID 2033 //
     /*  54516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54556 */     // MIs[2] Operand 1
     /*  54556 */     // No operand predicates
     /*  54556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54558 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54572 */     GIR_RootConstrainSelectedInstOperands,
     /*  54573 */     // GIR_Coverage, 2033,
     /*  54573 */     GIR_EraseRootFromParent_Done,
     /*  54574 */   // Label 842: @54574
     /*  54574 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(54597), // Rule ID 1351 //
     /*  54579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54590 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  54590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  54595 */     GIR_RootConstrainSelectedInstOperands,
     /*  54596 */     // GIR_Coverage, 1351,
     /*  54596 */     GIR_Done,
     /*  54597 */   // Label 843: @54597
     /*  54597 */   GIM_Reject,
     /*  54598 */ // Label 840: @54598
     /*  54598 */ GIM_Reject,
     /*  54599 */ // Label 799: @54599
     /*  54599 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(54632), // Rule ID 1349 //
     /*  54604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  54613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54625 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  54625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  54630 */   GIR_RootConstrainSelectedInstOperands,
     /*  54631 */   // GIR_Coverage, 1349,
     /*  54631 */   GIR_Done,
     /*  54632 */ // Label 844: @54632
     /*  54632 */ GIM_Reject,
     /*  54633 */ // Label 800: @54633
     /*  54633 */ GIM_Reject,
     /*  54634 */ // Label 3: @54634
     /*  54634 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 847*/ GIMT_Encode4(54715),
     /*  54645 */ /*GILLT_s32*//*Label 845*/ GIMT_Encode4(54653),
     /*  54649 */ /*GILLT_s64*//*Label 846*/ GIMT_Encode4(54684),
     /*  54653 */ // Label 845: @54653
     /*  54653 */ GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(54683), // Rule ID 117 //
     /*  54658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54676 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  54681 */   GIR_RootConstrainSelectedInstOperands,
     /*  54682 */   // GIR_Coverage, 117,
     /*  54682 */   GIR_Done,
     /*  54683 */ // Label 848: @54683
     /*  54683 */ GIM_Reject,
     /*  54684 */ // Label 846: @54684
     /*  54684 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(54714), // Rule ID 118 //
     /*  54689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54707 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  54712 */   GIR_RootConstrainSelectedInstOperands,
     /*  54713 */   // GIR_Coverage, 118,
     /*  54713 */   GIR_Done,
     /*  54714 */ // Label 849: @54714
     /*  54714 */ GIM_Reject,
     /*  54715 */ // Label 847: @54715
     /*  54715 */ GIM_Reject,
     /*  54716 */ // Label 4: @54716
     /*  54716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 852*/ GIMT_Encode4(54797),
     /*  54727 */ /*GILLT_s32*//*Label 850*/ GIMT_Encode4(54735),
     /*  54731 */ /*GILLT_s64*//*Label 851*/ GIMT_Encode4(54766),
     /*  54735 */ // Label 850: @54735
     /*  54735 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(54765), // Rule ID 115 //
     /*  54740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54758 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  54763 */   GIR_RootConstrainSelectedInstOperands,
     /*  54764 */   // GIR_Coverage, 115,
     /*  54764 */   GIR_Done,
     /*  54765 */ // Label 853: @54765
     /*  54765 */ GIM_Reject,
     /*  54766 */ // Label 851: @54766
     /*  54766 */ GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(54796), // Rule ID 116 //
     /*  54771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54789 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  54794 */   GIR_RootConstrainSelectedInstOperands,
     /*  54795 */   // GIR_Coverage, 116,
     /*  54795 */   GIR_Done,
     /*  54796 */ // Label 854: @54796
     /*  54796 */ GIM_Reject,
     /*  54797 */ // Label 852: @54797
     /*  54797 */ GIM_Reject,
     /*  54798 */ // Label 5: @54798
     /*  54798 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 873*/ GIMT_Encode4(62543),
     /*  54809 */ /*GILLT_s32*//*Label 855*/ GIMT_Encode4(54897),
     /*  54813 */ /*GILLT_s64*//*Label 856*/ GIMT_Encode4(55395), GIMT_Encode4(0),
     /*  54821 */ /*GILLT_v2s32*//*Label 857*/ GIMT_Encode4(56830),
     /*  54825 */ /*GILLT_v2s64*//*Label 858*/ GIMT_Encode4(56990),
     /*  54829 */ /*GILLT_v4s16*//*Label 859*/ GIMT_Encode4(57150),
     /*  54833 */ /*GILLT_v4s32*//*Label 860*/ GIMT_Encode4(57310),
     /*  54837 */ /*GILLT_v8s8*//*Label 861*/ GIMT_Encode4(57470),
     /*  54841 */ /*GILLT_v8s16*//*Label 862*/ GIMT_Encode4(57630),
     /*  54845 */ /*GILLT_v16s8*//*Label 863*/ GIMT_Encode4(57790),
     /*  54849 */ /*GILLT_nxv1s1*//*Label 864*/ GIMT_Encode4(57950),
     /*  54853 */ /*GILLT_nxv2s1*//*Label 865*/ GIMT_Encode4(58491), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  54865 */ /*GILLT_nxv2s64*//*Label 866*/ GIMT_Encode4(59032),
     /*  54869 */ /*GILLT_nxv4s1*//*Label 867*/ GIMT_Encode4(59504), GIMT_Encode4(0),
     /*  54877 */ /*GILLT_nxv4s32*//*Label 868*/ GIMT_Encode4(60045),
     /*  54881 */ /*GILLT_nxv8s1*//*Label 869*/ GIMT_Encode4(60517),
     /*  54885 */ /*GILLT_nxv8s16*//*Label 870*/ GIMT_Encode4(61058),
     /*  54889 */ /*GILLT_nxv16s1*//*Label 871*/ GIMT_Encode4(61530),
     /*  54893 */ /*GILLT_nxv16s8*//*Label 872*/ GIMT_Encode4(62071),
     /*  54897 */ // Label 855: @54897
     /*  54897 */ GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(55394),
     /*  54902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54908 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54963), // Rule ID 13317 //
     /*  54913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  54950 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  54950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  54953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54961 */     GIR_RootConstrainSelectedInstOperands,
     /*  54962 */     // GIR_Coverage, 13317,
     /*  54962 */     GIR_EraseRootFromParent_Done,
     /*  54963 */   // Label 875: @54963
     /*  54963 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(55018), // Rule ID 162 //
     /*  54968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55005 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  55008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55016 */     GIR_RootConstrainSelectedInstOperands,
     /*  55017 */     // GIR_Coverage, 162,
     /*  55017 */     GIR_EraseRootFromParent_Done,
     /*  55018 */   // Label 876: @55018
     /*  55018 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(55087), // Rule ID 5681 //
     /*  55023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55060 */     // MIs[2] Operand 1
     /*  55060 */     // No operand predicates
     /*  55060 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55073 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  55073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55085 */     GIR_RootConstrainSelectedInstOperands,
     /*  55086 */     // GIR_Coverage, 5681,
     /*  55086 */     GIR_EraseRootFromParent_Done,
     /*  55087 */   // Label 877: @55087
     /*  55087 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55156), // Rule ID 5682 //
     /*  55092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55129 */     // MIs[2] Operand 1
     /*  55129 */     // No operand predicates
     /*  55129 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55142 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  55142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55154 */     GIR_RootConstrainSelectedInstOperands,
     /*  55155 */     // GIR_Coverage, 5682,
     /*  55155 */     GIR_EraseRootFromParent_Done,
     /*  55156 */   // Label 878: @55156
     /*  55156 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55209), // Rule ID 13315 //
     /*  55161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55186 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55196 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55207 */     GIR_RootConstrainSelectedInstOperands,
     /*  55208 */     // GIR_Coverage, 13315,
     /*  55208 */     GIR_EraseRootFromParent_Done,
     /*  55209 */   // Label 879: @55209
     /*  55209 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55262), // Rule ID 160 //
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55249 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55260 */     GIR_RootConstrainSelectedInstOperands,
     /*  55261 */     // GIR_Coverage, 160,
     /*  55261 */     GIR_EraseRootFromParent_Done,
     /*  55262 */   // Label 880: @55262
     /*  55262 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55303), // Rule ID 142 //
     /*  55267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  55271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55283 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  55287 */     // MIs[1] Operand 1
     /*  55287 */     // No operand predicates
     /*  55287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55289 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  55289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  55292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55296 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  55301 */     GIR_RootConstrainSelectedInstOperands,
     /*  55302 */     // GIR_Coverage, 142,
     /*  55302 */     GIR_EraseRootFromParent_Done,
     /*  55303 */   // Label 881: @55303
     /*  55303 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55336), // Rule ID 13313 //
     /*  55308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55323 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55334 */     GIR_RootConstrainSelectedInstOperands,
     /*  55335 */     // GIR_Coverage, 13313,
     /*  55335 */     GIR_EraseRootFromParent_Done,
     /*  55336 */   // Label 882: @55336
     /*  55336 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55369), // Rule ID 158 //
     /*  55341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55356 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55367 */     GIR_RootConstrainSelectedInstOperands,
     /*  55368 */     // GIR_Coverage, 158,
     /*  55368 */     GIR_EraseRootFromParent_Done,
     /*  55369 */   // Label 883: @55369
     /*  55369 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55393), // Rule ID 156 //
     /*  55374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55386 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  55391 */     GIR_RootConstrainSelectedInstOperands,
     /*  55392 */     // GIR_Coverage, 156,
     /*  55392 */     GIR_Done,
     /*  55393 */   // Label 884: @55393
     /*  55393 */   GIM_Reject,
     /*  55394 */ // Label 874: @55394
     /*  55394 */ GIM_Reject,
     /*  55395 */ // Label 856: @55395
     /*  55395 */ GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(56829),
     /*  55400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  55403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55406 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55461), // Rule ID 13318 //
     /*  55411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55431 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55448 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55459 */     GIR_RootConstrainSelectedInstOperands,
     /*  55460 */     // GIR_Coverage, 13318,
     /*  55460 */     GIR_EraseRootFromParent_Done,
     /*  55461 */   // Label 886: @55461
     /*  55461 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55516), // Rule ID 163 //
     /*  55466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55490 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55503 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55514 */     GIR_RootConstrainSelectedInstOperands,
     /*  55515 */     // GIR_Coverage, 163,
     /*  55515 */     GIR_EraseRootFromParent_Done,
     /*  55516 */   // Label 887: @55516
     /*  55516 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55629), // Rule ID 5683 //
     /*  55521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55570 */     // MIs[3] Operand 1
     /*  55570 */     // No operand predicates
     /*  55570 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55583 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  55583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55628 */     // GIR_Coverage, 5683,
     /*  55628 */     GIR_EraseRootFromParent_Done,
     /*  55629 */   // Label 888: @55629
     /*  55629 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55742), // Rule ID 5684 //
     /*  55634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55683 */     // MIs[3] Operand 1
     /*  55683 */     // No operand predicates
     /*  55683 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55696 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  55696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55741 */     // GIR_Coverage, 5684,
     /*  55741 */     GIR_EraseRootFromParent_Done,
     /*  55742 */   // Label 889: @55742
     /*  55742 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55841), // Rule ID 7151 //
     /*  55747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55759 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55762 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55767 */     // MIs[1] addr
     /*  55767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55776 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  55780 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55793 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  55800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55809 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55840 */     // GIR_Coverage, 7151,
     /*  55840 */     GIR_EraseRootFromParent_Done,
     /*  55841 */   // Label 890: @55841
     /*  55841 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55940), // Rule ID 7152 //
     /*  55846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55858 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55861 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55866 */     // MIs[1] addr
     /*  55866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55875 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  55879 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55892 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  55899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55908 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55939 */     // GIR_Coverage, 7152,
     /*  55939 */     GIR_EraseRootFromParent_Done,
     /*  55940 */   // Label 891: @55940
     /*  55940 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56039), // Rule ID 7153 //
     /*  55945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55957 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55960 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55965 */     // MIs[1] addr
     /*  55965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55974 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  55978 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  55989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55991 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  55998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56038 */     // GIR_Coverage, 7153,
     /*  56038 */     GIR_EraseRootFromParent_Done,
     /*  56039 */   // Label 892: @56039
     /*  56039 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56138), // Rule ID 7158 //
     /*  56044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56064 */     // MIs[1] addr
     /*  56064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56073 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  56077 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  56088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56090 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  56097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56106 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56137 */     // GIR_Coverage, 7158,
     /*  56137 */     GIR_EraseRootFromParent_Done,
     /*  56138 */   // Label 893: @56138
     /*  56138 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56237), // Rule ID 7159 //
     /*  56143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56155 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56158 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56163 */     // MIs[1] addr
     /*  56163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56172 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  56176 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  56187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56189 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  56196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56236 */     // GIR_Coverage, 7159,
     /*  56236 */     GIR_EraseRootFromParent_Done,
     /*  56237 */   // Label 894: @56237
     /*  56237 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56336), // Rule ID 7160 //
     /*  56242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56254 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56257 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56262 */     // MIs[1] addr
     /*  56262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56271 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  56275 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56288 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  56295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56335 */     // GIR_Coverage, 7160,
     /*  56335 */     GIR_EraseRootFromParent_Done,
     /*  56336 */   // Label 895: @56336
     /*  56336 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56389), // Rule ID 13316 //
     /*  56341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56376 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56387 */     GIR_RootConstrainSelectedInstOperands,
     /*  56388 */     // GIR_Coverage, 13316,
     /*  56388 */     GIR_EraseRootFromParent_Done,
     /*  56389 */   // Label 896: @56389
     /*  56389 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56442), // Rule ID 161 //
     /*  56394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56423 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56429 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56440 */     GIR_RootConstrainSelectedInstOperands,
     /*  56441 */     // GIR_Coverage, 161,
     /*  56441 */     GIR_EraseRootFromParent_Done,
     /*  56442 */   // Label 897: @56442
     /*  56442 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56542), // Rule ID 4008 //
     /*  56447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56455 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56466 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  56466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  56469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56478 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  56484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  56501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56506 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  56515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56541 */     // GIR_Coverage, 4008,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 898: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56583), // Rule ID 143 //
     /*  56547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  56563 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  56567 */     // MIs[1] Operand 1
     /*  56567 */     // No operand predicates
     /*  56567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56569 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  56569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  56572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56576 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  56581 */     GIR_RootConstrainSelectedInstOperands,
     /*  56582 */     // GIR_Coverage, 143,
     /*  56582 */     GIR_EraseRootFromParent_Done,
     /*  56583 */   // Label 899: @56583
     /*  56583 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56616), // Rule ID 13314 //
     /*  56588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56603 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56614 */     GIR_RootConstrainSelectedInstOperands,
     /*  56615 */     // GIR_Coverage, 13314,
     /*  56615 */     GIR_EraseRootFromParent_Done,
     /*  56616 */   // Label 900: @56616
     /*  56616 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56649), // Rule ID 159 //
     /*  56621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56636 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56647 */     GIR_RootConstrainSelectedInstOperands,
     /*  56648 */     // GIR_Coverage, 159,
     /*  56648 */     GIR_EraseRootFromParent_Done,
     /*  56649 */   // Label 901: @56649
     /*  56649 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56713), // Rule ID 13982 //
     /*  56654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56686 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56692 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56700 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 13982,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 902: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56777), // Rule ID 5063 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56764 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56769 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56775 */     GIR_RootConstrainSelectedInstOperands,
     /*  56776 */     // GIR_Coverage, 5063,
     /*  56776 */     GIR_EraseRootFromParent_Done,
     /*  56777 */   // Label 903: @56777
     /*  56777 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56801), // Rule ID 157 //
     /*  56782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56794 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  56799 */     GIR_RootConstrainSelectedInstOperands,
     /*  56800 */     // GIR_Coverage, 157,
     /*  56800 */     GIR_Done,
     /*  56801 */   // Label 904: @56801
     /*  56801 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56828), // Rule ID 2480 //
     /*  56806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56821 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56826 */     GIR_RootConstrainSelectedInstOperands,
     /*  56827 */     // GIR_Coverage, 2480,
     /*  56827 */     GIR_Done,
     /*  56828 */   // Label 905: @56828
     /*  56828 */   GIM_Reject,
     /*  56829 */ // Label 885: @56829
     /*  56829 */ GIM_Reject,
     /*  56830 */ // Label 857: @56830
     /*  56830 */ GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(56989),
     /*  56835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56845 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56905), // Rule ID 13981 //
     /*  56850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56892 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56903 */     GIR_RootConstrainSelectedInstOperands,
     /*  56904 */     // GIR_Coverage, 13981,
     /*  56904 */     GIR_EraseRootFromParent_Done,
     /*  56905 */   // Label 907: @56905
     /*  56905 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56965), // Rule ID 5062 //
     /*  56910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56952 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56963 */     GIR_RootConstrainSelectedInstOperands,
     /*  56964 */     // GIR_Coverage, 5062,
     /*  56964 */     GIR_EraseRootFromParent_Done,
     /*  56965 */   // Label 908: @56965
     /*  56965 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56988), // Rule ID 2479 //
     /*  56970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56981 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 2479,
     /*  56987 */     GIR_Done,
     /*  56988 */   // Label 909: @56988
     /*  56988 */   GIM_Reject,
     /*  56989 */ // Label 906: @56989
     /*  56989 */ GIM_Reject,
     /*  56990 */ // Label 858: @56990
     /*  56990 */ GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57149),
     /*  56995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  56998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57005 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57065), // Rule ID 13985 //
     /*  57010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57052 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57057 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57063 */     GIR_RootConstrainSelectedInstOperands,
     /*  57064 */     // GIR_Coverage, 13985,
     /*  57064 */     GIR_EraseRootFromParent_Done,
     /*  57065 */   // Label 911: @57065
     /*  57065 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57125), // Rule ID 5066 //
     /*  57070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57112 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57117 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57123 */     GIR_RootConstrainSelectedInstOperands,
     /*  57124 */     // GIR_Coverage, 5066,
     /*  57124 */     GIR_EraseRootFromParent_Done,
     /*  57125 */   // Label 912: @57125
     /*  57125 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57148), // Rule ID 2483 //
     /*  57130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57141 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57146 */     GIR_RootConstrainSelectedInstOperands,
     /*  57147 */     // GIR_Coverage, 2483,
     /*  57147 */     GIR_Done,
     /*  57148 */   // Label 913: @57148
     /*  57148 */   GIM_Reject,
     /*  57149 */ // Label 910: @57149
     /*  57149 */ GIM_Reject,
     /*  57150 */ // Label 859: @57150
     /*  57150 */ GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57309),
     /*  57155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57165 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57225), // Rule ID 13980 //
     /*  57170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57212 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57223 */     GIR_RootConstrainSelectedInstOperands,
     /*  57224 */     // GIR_Coverage, 13980,
     /*  57224 */     GIR_EraseRootFromParent_Done,
     /*  57225 */   // Label 915: @57225
     /*  57225 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(57285), // Rule ID 5061 //
     /*  57230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57272 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57283 */     GIR_RootConstrainSelectedInstOperands,
     /*  57284 */     // GIR_Coverage, 5061,
     /*  57284 */     GIR_EraseRootFromParent_Done,
     /*  57285 */   // Label 916: @57285
     /*  57285 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57308), // Rule ID 2478 //
     /*  57290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57301 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57306 */     GIR_RootConstrainSelectedInstOperands,
     /*  57307 */     // GIR_Coverage, 2478,
     /*  57307 */     GIR_Done,
     /*  57308 */   // Label 917: @57308
     /*  57308 */   GIM_Reject,
     /*  57309 */ // Label 914: @57309
     /*  57309 */ GIM_Reject,
     /*  57310 */ // Label 860: @57310
     /*  57310 */ GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57469),
     /*  57315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57325 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57385), // Rule ID 13984 //
     /*  57330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57372 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57377 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57383 */     GIR_RootConstrainSelectedInstOperands,
     /*  57384 */     // GIR_Coverage, 13984,
     /*  57384 */     GIR_EraseRootFromParent_Done,
     /*  57385 */   // Label 919: @57385
     /*  57385 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57445), // Rule ID 5065 //
     /*  57390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57432 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57437 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57443 */     GIR_RootConstrainSelectedInstOperands,
     /*  57444 */     // GIR_Coverage, 5065,
     /*  57444 */     GIR_EraseRootFromParent_Done,
     /*  57445 */   // Label 920: @57445
     /*  57445 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(57468), // Rule ID 2482 //
     /*  57450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57461 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57466 */     GIR_RootConstrainSelectedInstOperands,
     /*  57467 */     // GIR_Coverage, 2482,
     /*  57467 */     GIR_Done,
     /*  57468 */   // Label 921: @57468
     /*  57468 */   GIM_Reject,
     /*  57469 */ // Label 918: @57469
     /*  57469 */ GIM_Reject,
     /*  57470 */ // Label 861: @57470
     /*  57470 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(57629),
     /*  57475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57485 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(57545), // Rule ID 13453 //
     /*  57490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57518 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57524 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57532 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57543 */     GIR_RootConstrainSelectedInstOperands,
     /*  57544 */     // GIR_Coverage, 13453,
     /*  57544 */     GIR_EraseRootFromParent_Done,
     /*  57545 */   // Label 923: @57545
     /*  57545 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(57605), // Rule ID 1597 //
     /*  57550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57582 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57592 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57603 */     GIR_RootConstrainSelectedInstOperands,
     /*  57604 */     // GIR_Coverage, 1597,
     /*  57604 */     GIR_EraseRootFromParent_Done,
     /*  57605 */   // Label 924: @57605
     /*  57605 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(57628), // Rule ID 1595 //
     /*  57610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57621 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57626 */     GIR_RootConstrainSelectedInstOperands,
     /*  57627 */     // GIR_Coverage, 1595,
     /*  57627 */     GIR_Done,
     /*  57628 */   // Label 925: @57628
     /*  57628 */   GIM_Reject,
     /*  57629 */ // Label 922: @57629
     /*  57629 */ GIM_Reject,
     /*  57630 */ // Label 862: @57630
     /*  57630 */ GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(57789),
     /*  57635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57645 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(57705), // Rule ID 13983 //
     /*  57650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57692 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57697 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57703 */     GIR_RootConstrainSelectedInstOperands,
     /*  57704 */     // GIR_Coverage, 13983,
     /*  57704 */     GIR_EraseRootFromParent_Done,
     /*  57705 */   // Label 927: @57705
     /*  57705 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(57765), // Rule ID 5064 //
     /*  57710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57742 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57752 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57757 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57763 */     GIR_RootConstrainSelectedInstOperands,
     /*  57764 */     // GIR_Coverage, 5064,
     /*  57764 */     GIR_EraseRootFromParent_Done,
     /*  57765 */   // Label 928: @57765
     /*  57765 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57788), // Rule ID 2481 //
     /*  57770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57781 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57786 */     GIR_RootConstrainSelectedInstOperands,
     /*  57787 */     // GIR_Coverage, 2481,
     /*  57787 */     GIR_Done,
     /*  57788 */   // Label 929: @57788
     /*  57788 */   GIM_Reject,
     /*  57789 */ // Label 926: @57789
     /*  57789 */ GIM_Reject,
     /*  57790 */ // Label 863: @57790
     /*  57790 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57949),
     /*  57795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57805 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57865), // Rule ID 13454 //
     /*  57810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57838 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57852 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57863 */     GIR_RootConstrainSelectedInstOperands,
     /*  57864 */     // GIR_Coverage, 13454,
     /*  57864 */     GIR_EraseRootFromParent_Done,
     /*  57865 */   // Label 931: @57865
     /*  57865 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57925), // Rule ID 1598 //
     /*  57870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57912 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57923 */     GIR_RootConstrainSelectedInstOperands,
     /*  57924 */     // GIR_Coverage, 1598,
     /*  57924 */     GIR_EraseRootFromParent_Done,
     /*  57925 */   // Label 932: @57925
     /*  57925 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57948), // Rule ID 1596 //
     /*  57930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57941 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57946 */     GIR_RootConstrainSelectedInstOperands,
     /*  57947 */     // GIR_Coverage, 1596,
     /*  57947 */     GIR_Done,
     /*  57948 */   // Label 933: @57948
     /*  57948 */   GIM_Reject,
     /*  57949 */ // Label 930: @57949
     /*  57949 */ GIM_Reject,
     /*  57950 */ // Label 864: @57950
     /*  57950 */ GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(58490),
     /*  57955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  57958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  57961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57965 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(58022), // Rule ID 15177 //
     /*  57970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  57985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  57989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58007 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 15177,
     /*  58021 */     GIR_EraseRootFromParent_Done,
     /*  58022 */   // Label 935: @58022
     /*  58022 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(58079), // Rule ID 15180 //
     /*  58027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58064 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58077 */     GIR_RootConstrainSelectedInstOperands,
     /*  58078 */     // GIR_Coverage, 15180,
     /*  58078 */     GIR_EraseRootFromParent_Done,
     /*  58079 */   // Label 936: @58079
     /*  58079 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(58136), // Rule ID 15176 //
     /*  58084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58121 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58134 */     GIR_RootConstrainSelectedInstOperands,
     /*  58135 */     // GIR_Coverage, 15176,
     /*  58135 */     GIR_EraseRootFromParent_Done,
     /*  58136 */   // Label 937: @58136
     /*  58136 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(58193), // Rule ID 15179 //
     /*  58141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58178 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58191 */     GIR_RootConstrainSelectedInstOperands,
     /*  58192 */     // GIR_Coverage, 15179,
     /*  58192 */     GIR_EraseRootFromParent_Done,
     /*  58193 */   // Label 938: @58193
     /*  58193 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(58250), // Rule ID 15175 //
     /*  58198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58229 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58235 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58248 */     GIR_RootConstrainSelectedInstOperands,
     /*  58249 */     // GIR_Coverage, 15175,
     /*  58249 */     GIR_EraseRootFromParent_Done,
     /*  58250 */   // Label 939: @58250
     /*  58250 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(58307), // Rule ID 15178 //
     /*  58255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58286 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58292 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58305 */     GIR_RootConstrainSelectedInstOperands,
     /*  58306 */     // GIR_Coverage, 15178,
     /*  58306 */     GIR_EraseRootFromParent_Done,
     /*  58307 */   // Label 940: @58307
     /*  58307 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58364), // Rule ID 8494 //
     /*  58312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58349 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58362 */     GIR_RootConstrainSelectedInstOperands,
     /*  58363 */     // GIR_Coverage, 8494,
     /*  58363 */     GIR_EraseRootFromParent_Done,
     /*  58364 */   // Label 941: @58364
     /*  58364 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(58421), // Rule ID 8495 //
     /*  58369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58400 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58406 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58419 */     GIR_RootConstrainSelectedInstOperands,
     /*  58420 */     // GIR_Coverage, 8495,
     /*  58420 */     GIR_EraseRootFromParent_Done,
     /*  58421 */   // Label 942: @58421
     /*  58421 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(58468), // Rule ID 10758 //
     /*  58426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58437 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  58437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  58444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58466 */     GIR_RootConstrainSelectedInstOperands,
     /*  58467 */     // GIR_Coverage, 10758,
     /*  58467 */     GIR_EraseRootFromParent_Done,
     /*  58468 */   // Label 943: @58468
     /*  58468 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(58489), // Rule ID 2749 //
     /*  58473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58476 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58487 */     GIR_RootConstrainSelectedInstOperands,
     /*  58488 */     // GIR_Coverage, 2749,
     /*  58488 */     GIR_EraseRootFromParent_Done,
     /*  58489 */   // Label 944: @58489
     /*  58489 */   GIM_Reject,
     /*  58490 */ // Label 934: @58490
     /*  58490 */ GIM_Reject,
     /*  58491 */ // Label 865: @58491
     /*  58491 */ GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(59031),
     /*  58496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58506 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(58563), // Rule ID 15168 //
     /*  58511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58542 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58548 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 15168,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 946: @58563
     /*  58563 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(58620), // Rule ID 15171 //
     /*  58568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58599 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58605 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58618 */     GIR_RootConstrainSelectedInstOperands,
     /*  58619 */     // GIR_Coverage, 15171,
     /*  58619 */     GIR_EraseRootFromParent_Done,
     /*  58620 */   // Label 947: @58620
     /*  58620 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(58677), // Rule ID 15167 //
     /*  58625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58656 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58662 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58675 */     GIR_RootConstrainSelectedInstOperands,
     /*  58676 */     // GIR_Coverage, 15167,
     /*  58676 */     GIR_EraseRootFromParent_Done,
     /*  58677 */   // Label 948: @58677
     /*  58677 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58734), // Rule ID 15170 //
     /*  58682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58719 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58732 */     GIR_RootConstrainSelectedInstOperands,
     /*  58733 */     // GIR_Coverage, 15170,
     /*  58733 */     GIR_EraseRootFromParent_Done,
     /*  58734 */   // Label 949: @58734
     /*  58734 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58791), // Rule ID 15166 //
     /*  58739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58770 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58776 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58789 */     GIR_RootConstrainSelectedInstOperands,
     /*  58790 */     // GIR_Coverage, 15166,
     /*  58790 */     GIR_EraseRootFromParent_Done,
     /*  58791 */   // Label 950: @58791
     /*  58791 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58848), // Rule ID 15169 //
     /*  58796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58827 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58833 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58846 */     GIR_RootConstrainSelectedInstOperands,
     /*  58847 */     // GIR_Coverage, 15169,
     /*  58847 */     GIR_EraseRootFromParent_Done,
     /*  58848 */   // Label 951: @58848
     /*  58848 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58905), // Rule ID 8490 //
     /*  58853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58884 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58890 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58903 */     GIR_RootConstrainSelectedInstOperands,
     /*  58904 */     // GIR_Coverage, 8490,
     /*  58904 */     GIR_EraseRootFromParent_Done,
     /*  58905 */   // Label 952: @58905
     /*  58905 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58962), // Rule ID 8491 //
     /*  58910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58941 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58947 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58960 */     GIR_RootConstrainSelectedInstOperands,
     /*  58961 */     // GIR_Coverage, 8491,
     /*  58961 */     GIR_EraseRootFromParent_Done,
     /*  58962 */   // Label 953: @58962
     /*  58962 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(59009), // Rule ID 10757 //
     /*  58967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58978 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  58978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  58985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59007 */     GIR_RootConstrainSelectedInstOperands,
     /*  59008 */     // GIR_Coverage, 10757,
     /*  59008 */     GIR_EraseRootFromParent_Done,
     /*  59009 */   // Label 954: @59009
     /*  59009 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(59030), // Rule ID 2748 //
     /*  59014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59017 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  59017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59028 */     GIR_RootConstrainSelectedInstOperands,
     /*  59029 */     // GIR_Coverage, 2748,
     /*  59029 */     GIR_EraseRootFromParent_Done,
     /*  59030 */   // Label 955: @59030
     /*  59030 */   GIM_Reject,
     /*  59031 */ // Label 945: @59031
     /*  59031 */ GIM_Reject,
     /*  59032 */ // Label 866: @59032
     /*  59032 */ GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(59503),
     /*  59037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59047 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(59102), // Rule ID 15108 //
     /*  59052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59083 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59089 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59100 */     GIR_RootConstrainSelectedInstOperands,
     /*  59101 */     // GIR_Coverage, 15108,
     /*  59101 */     GIR_EraseRootFromParent_Done,
     /*  59102 */   // Label 957: @59102
     /*  59102 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(59157), // Rule ID 15111 //
     /*  59107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59138 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59144 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59155 */     GIR_RootConstrainSelectedInstOperands,
     /*  59156 */     // GIR_Coverage, 15111,
     /*  59156 */     GIR_EraseRootFromParent_Done,
     /*  59157 */   // Label 958: @59157
     /*  59157 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(59212), // Rule ID 15107 //
     /*  59162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59199 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59210 */     GIR_RootConstrainSelectedInstOperands,
     /*  59211 */     // GIR_Coverage, 15107,
     /*  59211 */     GIR_EraseRootFromParent_Done,
     /*  59212 */   // Label 959: @59212
     /*  59212 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(59267), // Rule ID 15110 //
     /*  59217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59248 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59254 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59265 */     GIR_RootConstrainSelectedInstOperands,
     /*  59266 */     // GIR_Coverage, 15110,
     /*  59266 */     GIR_EraseRootFromParent_Done,
     /*  59267 */   // Label 960: @59267
     /*  59267 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(59322), // Rule ID 15106 //
     /*  59272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59309 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59320 */     GIR_RootConstrainSelectedInstOperands,
     /*  59321 */     // GIR_Coverage, 15106,
     /*  59321 */     GIR_EraseRootFromParent_Done,
     /*  59322 */   // Label 961: @59322
     /*  59322 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59377), // Rule ID 15109 //
     /*  59327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59358 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59364 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59375 */     GIR_RootConstrainSelectedInstOperands,
     /*  59376 */     // GIR_Coverage, 15109,
     /*  59376 */     GIR_EraseRootFromParent_Done,
     /*  59377 */   // Label 962: @59377
     /*  59377 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(59432), // Rule ID 7539 //
     /*  59382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59413 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59419 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59430 */     GIR_RootConstrainSelectedInstOperands,
     /*  59431 */     // GIR_Coverage, 7539,
     /*  59431 */     GIR_EraseRootFromParent_Done,
     /*  59432 */   // Label 963: @59432
     /*  59432 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(59487), // Rule ID 7540 //
     /*  59437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59468 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59474 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59485 */     GIR_RootConstrainSelectedInstOperands,
     /*  59486 */     // GIR_Coverage, 7540,
     /*  59486 */     GIR_EraseRootFromParent_Done,
     /*  59487 */   // Label 964: @59487
     /*  59487 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(59502), // Rule ID 3142 //
     /*  59492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59495 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59500 */     GIR_RootConstrainSelectedInstOperands,
     /*  59501 */     // GIR_Coverage, 3142,
     /*  59501 */     GIR_Done,
     /*  59502 */   // Label 965: @59502
     /*  59502 */   GIM_Reject,
     /*  59503 */ // Label 956: @59503
     /*  59503 */ GIM_Reject,
     /*  59504 */ // Label 867: @59504
     /*  59504 */ GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(60044),
     /*  59509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59519 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(59576), // Rule ID 15159 //
     /*  59524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59555 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59561 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 15159,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 967: @59576
     /*  59576 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(59633), // Rule ID 15162 //
     /*  59581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59612 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59618 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59631 */     GIR_RootConstrainSelectedInstOperands,
     /*  59632 */     // GIR_Coverage, 15162,
     /*  59632 */     GIR_EraseRootFromParent_Done,
     /*  59633 */   // Label 968: @59633
     /*  59633 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(59690), // Rule ID 15158 //
     /*  59638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59669 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59675 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59688 */     GIR_RootConstrainSelectedInstOperands,
     /*  59689 */     // GIR_Coverage, 15158,
     /*  59689 */     GIR_EraseRootFromParent_Done,
     /*  59690 */   // Label 969: @59690
     /*  59690 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59747), // Rule ID 15161 //
     /*  59695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59732 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59745 */     GIR_RootConstrainSelectedInstOperands,
     /*  59746 */     // GIR_Coverage, 15161,
     /*  59746 */     GIR_EraseRootFromParent_Done,
     /*  59747 */   // Label 970: @59747
     /*  59747 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59804), // Rule ID 15157 //
     /*  59752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59783 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59789 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59802 */     GIR_RootConstrainSelectedInstOperands,
     /*  59803 */     // GIR_Coverage, 15157,
     /*  59803 */     GIR_EraseRootFromParent_Done,
     /*  59804 */   // Label 971: @59804
     /*  59804 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59861), // Rule ID 15160 //
     /*  59809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59840 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59846 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59859 */     GIR_RootConstrainSelectedInstOperands,
     /*  59860 */     // GIR_Coverage, 15160,
     /*  59860 */     GIR_EraseRootFromParent_Done,
     /*  59861 */   // Label 972: @59861
     /*  59861 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59918), // Rule ID 8486 //
     /*  59866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59903 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59916 */     GIR_RootConstrainSelectedInstOperands,
     /*  59917 */     // GIR_Coverage, 8486,
     /*  59917 */     GIR_EraseRootFromParent_Done,
     /*  59918 */   // Label 973: @59918
     /*  59918 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59975), // Rule ID 8487 //
     /*  59923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59954 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59960 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59973 */     GIR_RootConstrainSelectedInstOperands,
     /*  59974 */     // GIR_Coverage, 8487,
     /*  59974 */     GIR_EraseRootFromParent_Done,
     /*  59975 */   // Label 974: @59975
     /*  59975 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(60022), // Rule ID 10756 //
     /*  59980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59991 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  59991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  59998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60020 */     GIR_RootConstrainSelectedInstOperands,
     /*  60021 */     // GIR_Coverage, 10756,
     /*  60021 */     GIR_EraseRootFromParent_Done,
     /*  60022 */   // Label 975: @60022
     /*  60022 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(60043), // Rule ID 2747 //
     /*  60027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60030 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  60030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60041 */     GIR_RootConstrainSelectedInstOperands,
     /*  60042 */     // GIR_Coverage, 2747,
     /*  60042 */     GIR_EraseRootFromParent_Done,
     /*  60043 */   // Label 976: @60043
     /*  60043 */   GIM_Reject,
     /*  60044 */ // Label 966: @60044
     /*  60044 */ GIM_Reject,
     /*  60045 */ // Label 868: @60045
     /*  60045 */ GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(60516),
     /*  60050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60060 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(60115), // Rule ID 15099 //
     /*  60065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60096 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60102 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60113 */     GIR_RootConstrainSelectedInstOperands,
     /*  60114 */     // GIR_Coverage, 15099,
     /*  60114 */     GIR_EraseRootFromParent_Done,
     /*  60115 */   // Label 978: @60115
     /*  60115 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(60170), // Rule ID 15102 //
     /*  60120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60151 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60157 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60168 */     GIR_RootConstrainSelectedInstOperands,
     /*  60169 */     // GIR_Coverage, 15102,
     /*  60169 */     GIR_EraseRootFromParent_Done,
     /*  60170 */   // Label 979: @60170
     /*  60170 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(60225), // Rule ID 15098 //
     /*  60175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60206 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60212 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60223 */     GIR_RootConstrainSelectedInstOperands,
     /*  60224 */     // GIR_Coverage, 15098,
     /*  60224 */     GIR_EraseRootFromParent_Done,
     /*  60225 */   // Label 980: @60225
     /*  60225 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(60280), // Rule ID 15101 //
     /*  60230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60261 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60267 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60278 */     GIR_RootConstrainSelectedInstOperands,
     /*  60279 */     // GIR_Coverage, 15101,
     /*  60279 */     GIR_EraseRootFromParent_Done,
     /*  60280 */   // Label 981: @60280
     /*  60280 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(60335), // Rule ID 15097 //
     /*  60285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60322 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60333 */     GIR_RootConstrainSelectedInstOperands,
     /*  60334 */     // GIR_Coverage, 15097,
     /*  60334 */     GIR_EraseRootFromParent_Done,
     /*  60335 */   // Label 982: @60335
     /*  60335 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60390), // Rule ID 15100 //
     /*  60340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60371 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60377 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60388 */     GIR_RootConstrainSelectedInstOperands,
     /*  60389 */     // GIR_Coverage, 15100,
     /*  60389 */     GIR_EraseRootFromParent_Done,
     /*  60390 */   // Label 983: @60390
     /*  60390 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(60445), // Rule ID 7535 //
     /*  60395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60426 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60432 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60443 */     GIR_RootConstrainSelectedInstOperands,
     /*  60444 */     // GIR_Coverage, 7535,
     /*  60444 */     GIR_EraseRootFromParent_Done,
     /*  60445 */   // Label 984: @60445
     /*  60445 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(60500), // Rule ID 7536 //
     /*  60450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60487 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60498 */     GIR_RootConstrainSelectedInstOperands,
     /*  60499 */     // GIR_Coverage, 7536,
     /*  60499 */     GIR_EraseRootFromParent_Done,
     /*  60500 */   // Label 985: @60500
     /*  60500 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(60515), // Rule ID 3141 //
     /*  60505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60508 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60513 */     GIR_RootConstrainSelectedInstOperands,
     /*  60514 */     // GIR_Coverage, 3141,
     /*  60514 */     GIR_Done,
     /*  60515 */   // Label 986: @60515
     /*  60515 */   GIM_Reject,
     /*  60516 */ // Label 977: @60516
     /*  60516 */ GIM_Reject,
     /*  60517 */ // Label 869: @60517
     /*  60517 */ GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(61057),
     /*  60522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60532 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(60589), // Rule ID 15150 //
     /*  60537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60568 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60574 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 15150,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 988: @60589
     /*  60589 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(60646), // Rule ID 15153 //
     /*  60594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60631 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60644 */     GIR_RootConstrainSelectedInstOperands,
     /*  60645 */     // GIR_Coverage, 15153,
     /*  60645 */     GIR_EraseRootFromParent_Done,
     /*  60646 */   // Label 989: @60646
     /*  60646 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(60703), // Rule ID 15149 //
     /*  60651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60682 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60688 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60701 */     GIR_RootConstrainSelectedInstOperands,
     /*  60702 */     // GIR_Coverage, 15149,
     /*  60702 */     GIR_EraseRootFromParent_Done,
     /*  60703 */   // Label 990: @60703
     /*  60703 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60760), // Rule ID 15152 //
     /*  60708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60745 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60758 */     GIR_RootConstrainSelectedInstOperands,
     /*  60759 */     // GIR_Coverage, 15152,
     /*  60759 */     GIR_EraseRootFromParent_Done,
     /*  60760 */   // Label 991: @60760
     /*  60760 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60817), // Rule ID 15148 //
     /*  60765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60796 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60802 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60815 */     GIR_RootConstrainSelectedInstOperands,
     /*  60816 */     // GIR_Coverage, 15148,
     /*  60816 */     GIR_EraseRootFromParent_Done,
     /*  60817 */   // Label 992: @60817
     /*  60817 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60874), // Rule ID 15151 //
     /*  60822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60853 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60859 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60872 */     GIR_RootConstrainSelectedInstOperands,
     /*  60873 */     // GIR_Coverage, 15151,
     /*  60873 */     GIR_EraseRootFromParent_Done,
     /*  60874 */   // Label 993: @60874
     /*  60874 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60931), // Rule ID 8482 //
     /*  60879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60910 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60916 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60929 */     GIR_RootConstrainSelectedInstOperands,
     /*  60930 */     // GIR_Coverage, 8482,
     /*  60930 */     GIR_EraseRootFromParent_Done,
     /*  60931 */   // Label 994: @60931
     /*  60931 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60988), // Rule ID 8483 //
     /*  60936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60967 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60973 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60986 */     GIR_RootConstrainSelectedInstOperands,
     /*  60987 */     // GIR_Coverage, 8483,
     /*  60987 */     GIR_EraseRootFromParent_Done,
     /*  60988 */   // Label 995: @60988
     /*  60988 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61035), // Rule ID 10755 //
     /*  60993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61004 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  61004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  61007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  61011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  61019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  61031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  61033 */     GIR_RootConstrainSelectedInstOperands,
     /*  61034 */     // GIR_Coverage, 10755,
     /*  61034 */     GIR_EraseRootFromParent_Done,
     /*  61035 */   // Label 996: @61035
     /*  61035 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61056), // Rule ID 2746 //
     /*  61040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61043 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  61043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  61054 */     GIR_RootConstrainSelectedInstOperands,
     /*  61055 */     // GIR_Coverage, 2746,
     /*  61055 */     GIR_EraseRootFromParent_Done,
     /*  61056 */   // Label 997: @61056
     /*  61056 */   GIM_Reject,
     /*  61057 */ // Label 987: @61057
     /*  61057 */ GIM_Reject,
     /*  61058 */ // Label 870: @61058
     /*  61058 */ GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61529),
     /*  61063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  61073 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61128), // Rule ID 15090 //
     /*  61078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61109 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61115 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61126 */     GIR_RootConstrainSelectedInstOperands,
     /*  61127 */     // GIR_Coverage, 15090,
     /*  61127 */     GIR_EraseRootFromParent_Done,
     /*  61128 */   // Label 999: @61128
     /*  61128 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61183), // Rule ID 15093 //
     /*  61133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61164 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61170 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61181 */     GIR_RootConstrainSelectedInstOperands,
     /*  61182 */     // GIR_Coverage, 15093,
     /*  61182 */     GIR_EraseRootFromParent_Done,
     /*  61183 */   // Label 1000: @61183
     /*  61183 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61238), // Rule ID 15089 //
     /*  61188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61219 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61225 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61236 */     GIR_RootConstrainSelectedInstOperands,
     /*  61237 */     // GIR_Coverage, 15089,
     /*  61237 */     GIR_EraseRootFromParent_Done,
     /*  61238 */   // Label 1001: @61238
     /*  61238 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61293), // Rule ID 15092 //
     /*  61243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61274 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61280 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61291 */     GIR_RootConstrainSelectedInstOperands,
     /*  61292 */     // GIR_Coverage, 15092,
     /*  61292 */     GIR_EraseRootFromParent_Done,
     /*  61293 */   // Label 1002: @61293
     /*  61293 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61348), // Rule ID 15088 //
     /*  61298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61335 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61346 */     GIR_RootConstrainSelectedInstOperands,
     /*  61347 */     // GIR_Coverage, 15088,
     /*  61347 */     GIR_EraseRootFromParent_Done,
     /*  61348 */   // Label 1003: @61348
     /*  61348 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61403), // Rule ID 15091 //
     /*  61353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61384 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61390 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61401 */     GIR_RootConstrainSelectedInstOperands,
     /*  61402 */     // GIR_Coverage, 15091,
     /*  61402 */     GIR_EraseRootFromParent_Done,
     /*  61403 */   // Label 1004: @61403
     /*  61403 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(61458), // Rule ID 7531 //
     /*  61408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61439 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61445 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61456 */     GIR_RootConstrainSelectedInstOperands,
     /*  61457 */     // GIR_Coverage, 7531,
     /*  61457 */     GIR_EraseRootFromParent_Done,
     /*  61458 */   // Label 1005: @61458
     /*  61458 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(61513), // Rule ID 7532 //
     /*  61463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61500 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61511 */     GIR_RootConstrainSelectedInstOperands,
     /*  61512 */     // GIR_Coverage, 7532,
     /*  61512 */     GIR_EraseRootFromParent_Done,
     /*  61513 */   // Label 1006: @61513
     /*  61513 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(61528), // Rule ID 3140 //
     /*  61518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61521 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61526 */     GIR_RootConstrainSelectedInstOperands,
     /*  61527 */     // GIR_Coverage, 3140,
     /*  61527 */     GIR_Done,
     /*  61528 */   // Label 1007: @61528
     /*  61528 */   GIM_Reject,
     /*  61529 */ // Label 998: @61529
     /*  61529 */ GIM_Reject,
     /*  61530 */ // Label 871: @61530
     /*  61530 */ GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62070),
     /*  61535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  61545 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(61602), // Rule ID 15141 //
     /*  61550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61581 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61587 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61600 */     GIR_RootConstrainSelectedInstOperands,
     /*  61601 */     // GIR_Coverage, 15141,
     /*  61601 */     GIR_EraseRootFromParent_Done,
     /*  61602 */   // Label 1009: @61602
     /*  61602 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(61659), // Rule ID 15144 //
     /*  61607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61638 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61644 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61657 */     GIR_RootConstrainSelectedInstOperands,
     /*  61658 */     // GIR_Coverage, 15144,
     /*  61658 */     GIR_EraseRootFromParent_Done,
     /*  61659 */   // Label 1010: @61659
     /*  61659 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(61716), // Rule ID 15140 //
     /*  61664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61695 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61701 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61714 */     GIR_RootConstrainSelectedInstOperands,
     /*  61715 */     // GIR_Coverage, 15140,
     /*  61715 */     GIR_EraseRootFromParent_Done,
     /*  61716 */   // Label 1011: @61716
     /*  61716 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61773), // Rule ID 15143 //
     /*  61721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61758 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61771 */     GIR_RootConstrainSelectedInstOperands,
     /*  61772 */     // GIR_Coverage, 15143,
     /*  61772 */     GIR_EraseRootFromParent_Done,
     /*  61773 */   // Label 1012: @61773
     /*  61773 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61830), // Rule ID 15139 //
     /*  61778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61809 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61815 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61828 */     GIR_RootConstrainSelectedInstOperands,
     /*  61829 */     // GIR_Coverage, 15139,
     /*  61829 */     GIR_EraseRootFromParent_Done,
     /*  61830 */   // Label 1013: @61830
     /*  61830 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(61887), // Rule ID 15142 //
     /*  61835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61866 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61872 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61885 */     GIR_RootConstrainSelectedInstOperands,
     /*  61886 */     // GIR_Coverage, 15142,
     /*  61886 */     GIR_EraseRootFromParent_Done,
     /*  61887 */   // Label 1014: @61887
     /*  61887 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(61944), // Rule ID 8478 //
     /*  61892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61923 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61929 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61942 */     GIR_RootConstrainSelectedInstOperands,
     /*  61943 */     // GIR_Coverage, 8478,
     /*  61943 */     GIR_EraseRootFromParent_Done,
     /*  61944 */   // Label 1015: @61944
     /*  61944 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62001), // Rule ID 8479 //
     /*  61949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61980 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61986 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61999 */     GIR_RootConstrainSelectedInstOperands,
     /*  62000 */     // GIR_Coverage, 8479,
     /*  62000 */     GIR_EraseRootFromParent_Done,
     /*  62001 */   // Label 1016: @62001
     /*  62001 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62048), // Rule ID 10754 //
     /*  62006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62017 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  62017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  62020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  62024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  62032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  62044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  62046 */     GIR_RootConstrainSelectedInstOperands,
     /*  62047 */     // GIR_Coverage, 10754,
     /*  62047 */     GIR_EraseRootFromParent_Done,
     /*  62048 */   // Label 1017: @62048
     /*  62048 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62069), // Rule ID 2745 //
     /*  62053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62056 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  62056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  62067 */     GIR_RootConstrainSelectedInstOperands,
     /*  62068 */     // GIR_Coverage, 2745,
     /*  62068 */     GIR_EraseRootFromParent_Done,
     /*  62069 */   // Label 1018: @62069
     /*  62069 */   GIM_Reject,
     /*  62070 */ // Label 1008: @62070
     /*  62070 */ GIM_Reject,
     /*  62071 */ // Label 872: @62071
     /*  62071 */ GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62542),
     /*  62076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  62086 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(62141), // Rule ID 15081 //
     /*  62091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62122 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62128 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62139 */     GIR_RootConstrainSelectedInstOperands,
     /*  62140 */     // GIR_Coverage, 15081,
     /*  62140 */     GIR_EraseRootFromParent_Done,
     /*  62141 */   // Label 1020: @62141
     /*  62141 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(62196), // Rule ID 15084 //
     /*  62146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62177 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62183 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62194 */     GIR_RootConstrainSelectedInstOperands,
     /*  62195 */     // GIR_Coverage, 15084,
     /*  62195 */     GIR_EraseRootFromParent_Done,
     /*  62196 */   // Label 1021: @62196
     /*  62196 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(62251), // Rule ID 15080 //
     /*  62201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62232 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62238 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62249 */     GIR_RootConstrainSelectedInstOperands,
     /*  62250 */     // GIR_Coverage, 15080,
     /*  62250 */     GIR_EraseRootFromParent_Done,
     /*  62251 */   // Label 1022: @62251
     /*  62251 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(62306), // Rule ID 15083 //
     /*  62256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62287 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62293 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62304 */     GIR_RootConstrainSelectedInstOperands,
     /*  62305 */     // GIR_Coverage, 15083,
     /*  62305 */     GIR_EraseRootFromParent_Done,
     /*  62306 */   // Label 1023: @62306
     /*  62306 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(62361), // Rule ID 15079 //
     /*  62311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62342 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62348 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62359 */     GIR_RootConstrainSelectedInstOperands,
     /*  62360 */     // GIR_Coverage, 15079,
     /*  62360 */     GIR_EraseRootFromParent_Done,
     /*  62361 */   // Label 1024: @62361
     /*  62361 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(62416), // Rule ID 15082 //
     /*  62366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62397 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62403 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62414 */     GIR_RootConstrainSelectedInstOperands,
     /*  62415 */     // GIR_Coverage, 15082,
     /*  62415 */     GIR_EraseRootFromParent_Done,
     /*  62416 */   // Label 1025: @62416
     /*  62416 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(62471), // Rule ID 7527 //
     /*  62421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62452 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62458 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62469 */     GIR_RootConstrainSelectedInstOperands,
     /*  62470 */     // GIR_Coverage, 7527,
     /*  62470 */     GIR_EraseRootFromParent_Done,
     /*  62471 */   // Label 1026: @62471
     /*  62471 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(62526), // Rule ID 7528 //
     /*  62476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62507 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62513 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62524 */     GIR_RootConstrainSelectedInstOperands,
     /*  62525 */     // GIR_Coverage, 7528,
     /*  62525 */     GIR_EraseRootFromParent_Done,
     /*  62526 */   // Label 1027: @62526
     /*  62526 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(62541), // Rule ID 3139 //
     /*  62531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62534 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  62539 */     GIR_RootConstrainSelectedInstOperands,
     /*  62540 */     // GIR_Coverage, 3139,
     /*  62540 */     GIR_Done,
     /*  62541 */   // Label 1028: @62541
     /*  62541 */   GIM_Reject,
     /*  62542 */ // Label 1019: @62542
     /*  62542 */ GIM_Reject,
     /*  62543 */ // Label 873: @62543
     /*  62543 */ GIM_Reject,
     /*  62544 */ // Label 6: @62544
     /*  62544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1047*/ GIMT_Encode4(87658),
     /*  62555 */ /*GILLT_s32*//*Label 1029*/ GIMT_Encode4(62643),
     /*  62559 */ /*GILLT_s64*//*Label 1030*/ GIMT_Encode4(63003), GIMT_Encode4(0),
     /*  62567 */ /*GILLT_v2s32*//*Label 1031*/ GIMT_Encode4(64902),
     /*  62571 */ /*GILLT_v2s64*//*Label 1032*/ GIMT_Encode4(66210),
     /*  62575 */ /*GILLT_v4s16*//*Label 1033*/ GIMT_Encode4(67518),
     /*  62579 */ /*GILLT_v4s32*//*Label 1034*/ GIMT_Encode4(68826),
     /*  62583 */ /*GILLT_v8s8*//*Label 1035*/ GIMT_Encode4(70134),
     /*  62587 */ /*GILLT_v8s16*//*Label 1036*/ GIMT_Encode4(71442),
     /*  62591 */ /*GILLT_v16s8*//*Label 1037*/ GIMT_Encode4(72750),
     /*  62595 */ /*GILLT_nxv1s1*//*Label 1038*/ GIMT_Encode4(74058),
     /*  62599 */ /*GILLT_nxv2s1*//*Label 1039*/ GIMT_Encode4(74090), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  62611 */ /*GILLT_nxv2s64*//*Label 1040*/ GIMT_Encode4(74122),
     /*  62615 */ /*GILLT_nxv4s1*//*Label 1041*/ GIMT_Encode4(77482), GIMT_Encode4(0),
     /*  62623 */ /*GILLT_nxv4s32*//*Label 1042*/ GIMT_Encode4(77514),
     /*  62627 */ /*GILLT_nxv8s1*//*Label 1043*/ GIMT_Encode4(80874),
     /*  62631 */ /*GILLT_nxv8s16*//*Label 1044*/ GIMT_Encode4(80906),
     /*  62635 */ /*GILLT_nxv16s1*//*Label 1045*/ GIMT_Encode4(84266),
     /*  62639 */ /*GILLT_nxv16s8*//*Label 1046*/ GIMT_Encode4(84298),
     /*  62643 */ // Label 1029: @62643
     /*  62643 */ GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(63002),
     /*  62648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  62651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62654 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62709), // Rule ID 13337 //
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62696 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62707 */     GIR_RootConstrainSelectedInstOperands,
     /*  62708 */     // GIR_Coverage, 13337,
     /*  62708 */     GIR_EraseRootFromParent_Done,
     /*  62709 */   // Label 1049: @62709
     /*  62709 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62764), // Rule ID 174 //
     /*  62714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62751 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62762 */     GIR_RootConstrainSelectedInstOperands,
     /*  62763 */     // GIR_Coverage, 174,
     /*  62763 */     GIR_EraseRootFromParent_Done,
     /*  62764 */   // Label 1050: @62764
     /*  62764 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62805), // Rule ID 146 //
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  62773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62785 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  62789 */     // MIs[1] Operand 1
     /*  62789 */     // No operand predicates
     /*  62789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62791 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  62791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  62794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62798 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  62803 */     GIR_RootConstrainSelectedInstOperands,
     /*  62804 */     // GIR_Coverage, 146,
     /*  62804 */     GIR_EraseRootFromParent_Done,
     /*  62805 */   // Label 1051: @62805
     /*  62805 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62838), // Rule ID 13339 //
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62825 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62836 */     GIR_RootConstrainSelectedInstOperands,
     /*  62837 */     // GIR_Coverage, 13339,
     /*  62837 */     GIR_EraseRootFromParent_Done,
     /*  62838 */   // Label 1052: @62838
     /*  62838 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62871), // Rule ID 178 //
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62858 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62869 */     GIR_RootConstrainSelectedInstOperands,
     /*  62870 */     // GIR_Coverage, 178,
     /*  62870 */     GIR_EraseRootFromParent_Done,
     /*  62871 */   // Label 1053: @62871
     /*  62871 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62924), // Rule ID 13335 //
     /*  62876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62901 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62911 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62922 */     GIR_RootConstrainSelectedInstOperands,
     /*  62923 */     // GIR_Coverage, 13335,
     /*  62923 */     GIR_EraseRootFromParent_Done,
     /*  62924 */   // Label 1054: @62924
     /*  62924 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62977), // Rule ID 172 //
     /*  62929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62964 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62975 */     GIR_RootConstrainSelectedInstOperands,
     /*  62976 */     // GIR_Coverage, 172,
     /*  62976 */     GIR_EraseRootFromParent_Done,
     /*  62977 */   // Label 1055: @62977
     /*  62977 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(63001), // Rule ID 176 //
     /*  62982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62994 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 176,
     /*  63000 */     GIR_Done,
     /*  63001 */   // Label 1056: @63001
     /*  63001 */   GIM_Reject,
     /*  63002 */ // Label 1048: @63002
     /*  63002 */ GIM_Reject,
     /*  63003 */ // Label 1030: @63003
     /*  63003 */ GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(64901),
     /*  63008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  63011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63014 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(63136), // Rule ID 4021 //
     /*  63019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63060 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63064 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63087 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63091 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63095 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63099 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63103 */     // MIs[4] Rn
     /*  63103 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63108 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63112 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63123 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63125 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63134 */     GIR_RootConstrainSelectedInstOperands,
     /*  63135 */     // GIR_Coverage, 4021,
     /*  63135 */     GIR_EraseRootFromParent_Done,
     /*  63136 */   // Label 1058: @63136
     /*  63136 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63258), // Rule ID 13897 //
     /*  63141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63182 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63186 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63225 */     // MIs[4] Rn
     /*  63225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63247 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63256 */     GIR_RootConstrainSelectedInstOperands,
     /*  63257 */     // GIR_Coverage, 13897,
     /*  63257 */     GIR_EraseRootFromParent_Done,
     /*  63258 */   // Label 1059: @63258
     /*  63258 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63313), // Rule ID 13338 //
     /*  63263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63300 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63311 */     GIR_RootConstrainSelectedInstOperands,
     /*  63312 */     // GIR_Coverage, 13338,
     /*  63312 */     GIR_EraseRootFromParent_Done,
     /*  63313 */   // Label 1060: @63313
     /*  63313 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63368), // Rule ID 175 //
     /*  63318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63355 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63366 */     GIR_RootConstrainSelectedInstOperands,
     /*  63367 */     // GIR_Coverage, 175,
     /*  63367 */     GIR_EraseRootFromParent_Done,
     /*  63368 */   // Label 1061: @63368
     /*  63368 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63477), // Rule ID 13697 //
     /*  63373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63442 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63446 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63451 */     // MIs[4] LHS
     /*  63451 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63458 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63475 */     GIR_RootConstrainSelectedInstOperands,
     /*  63476 */     // GIR_Coverage, 13697,
     /*  63476 */     GIR_EraseRootFromParent_Done,
     /*  63477 */   // Label 1062: @63477
     /*  63477 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63586), // Rule ID 13696 //
     /*  63482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63551 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63555 */     // MIs[4] LHS
     /*  63555 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63565 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63567 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63584 */     GIR_RootConstrainSelectedInstOperands,
     /*  63585 */     // GIR_Coverage, 13696,
     /*  63585 */     GIR_EraseRootFromParent_Done,
     /*  63586 */   // Label 1063: @63586
     /*  63586 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63695), // Rule ID 13699 //
     /*  63591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63644 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63656 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63660 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63664 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63669 */     // MIs[4] LHS
     /*  63669 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63674 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63676 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63693 */     GIR_RootConstrainSelectedInstOperands,
     /*  63694 */     // GIR_Coverage, 13699,
     /*  63694 */     GIR_EraseRootFromParent_Done,
     /*  63695 */   // Label 1064: @63695
     /*  63695 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63804), // Rule ID 13698 //
     /*  63700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63753 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63773 */     // MIs[4] LHS
     /*  63773 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63778 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63783 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63785 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63802 */     GIR_RootConstrainSelectedInstOperands,
     /*  63803 */     // GIR_Coverage, 13698,
     /*  63803 */     GIR_EraseRootFromParent_Done,
     /*  63804 */   // Label 1065: @63804
     /*  63804 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63913), // Rule ID 2474 //
     /*  63809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63870 */     // MIs[3] LHS
     /*  63870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63892 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63894 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63911 */     GIR_RootConstrainSelectedInstOperands,
     /*  63912 */     // GIR_Coverage, 2474,
     /*  63912 */     GIR_EraseRootFromParent_Done,
     /*  63913 */   // Label 1066: @63913
     /*  63913 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(64022), // Rule ID 13694 //
     /*  63918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63979 */     // MIs[3] LHS
     /*  63979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64003 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64020 */     GIR_RootConstrainSelectedInstOperands,
     /*  64021 */     // GIR_Coverage, 13694,
     /*  64021 */     GIR_EraseRootFromParent_Done,
     /*  64022 */   // Label 1067: @64022
     /*  64022 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64131), // Rule ID 13693 //
     /*  64027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64089 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64093 */     // MIs[3] LHS
     /*  64093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64102 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64112 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64129 */     GIR_RootConstrainSelectedInstOperands,
     /*  64130 */     // GIR_Coverage, 13693,
     /*  64130 */     GIR_EraseRootFromParent_Done,
     /*  64131 */   // Label 1068: @64131
     /*  64131 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(64240), // Rule ID 13695 //
     /*  64136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64202 */     // MIs[3] LHS
     /*  64202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64207 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64211 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64221 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64238 */     GIR_RootConstrainSelectedInstOperands,
     /*  64239 */     // GIR_Coverage, 13695,
     /*  64239 */     GIR_EraseRootFromParent_Done,
     /*  64240 */   // Label 1069: @64240
     /*  64240 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(64281), // Rule ID 147 //
     /*  64245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  64249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64261 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  64265 */     // MIs[1] Operand 1
     /*  64265 */     // No operand predicates
     /*  64265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64267 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  64267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  64270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64274 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  64279 */     GIR_RootConstrainSelectedInstOperands,
     /*  64280 */     // GIR_Coverage, 147,
     /*  64280 */     GIR_EraseRootFromParent_Done,
     /*  64281 */   // Label 1070: @64281
     /*  64281 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(64314), // Rule ID 13340 //
     /*  64286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64301 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64312 */     GIR_RootConstrainSelectedInstOperands,
     /*  64313 */     // GIR_Coverage, 13340,
     /*  64313 */     GIR_EraseRootFromParent_Done,
     /*  64314 */   // Label 1071: @64314
     /*  64314 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(64347), // Rule ID 179 //
     /*  64319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64334 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64345 */     GIR_RootConstrainSelectedInstOperands,
     /*  64346 */     // GIR_Coverage, 179,
     /*  64346 */     GIR_EraseRootFromParent_Done,
     /*  64347 */   // Label 1072: @64347
     /*  64347 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(64414), // Rule ID 13633 //
     /*  64352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64376 */     // MIs[1] imm
     /*  64376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64388 */     // MIs[2] Operand 1
     /*  64388 */     // No operand predicates
     /*  64388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64398 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64412 */     GIR_RootConstrainSelectedInstOperands,
     /*  64413 */     // GIR_Coverage, 13633,
     /*  64413 */     GIR_EraseRootFromParent_Done,
     /*  64414 */   // Label 1073: @64414
     /*  64414 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64481), // Rule ID 13636 //
     /*  64419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64443 */     // MIs[1] imm
     /*  64443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64451 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64455 */     // MIs[2] Operand 1
     /*  64455 */     // No operand predicates
     /*  64455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64465 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64479 */     GIR_RootConstrainSelectedInstOperands,
     /*  64480 */     // GIR_Coverage, 13636,
     /*  64480 */     GIR_EraseRootFromParent_Done,
     /*  64481 */   // Label 1074: @64481
     /*  64481 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64534), // Rule ID 13336 //
     /*  64486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64521 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64532 */     GIR_RootConstrainSelectedInstOperands,
     /*  64533 */     // GIR_Coverage, 13336,
     /*  64533 */     GIR_EraseRootFromParent_Done,
     /*  64534 */   // Label 1075: @64534
     /*  64534 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64601), // Rule ID 2122 //
     /*  64539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64567 */     // MIs[1] imm
     /*  64567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64579 */     // MIs[2] Operand 1
     /*  64579 */     // No operand predicates
     /*  64579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64585 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64599 */     GIR_RootConstrainSelectedInstOperands,
     /*  64600 */     // GIR_Coverage, 2122,
     /*  64600 */     GIR_EraseRootFromParent_Done,
     /*  64601 */   // Label 1076: @64601
     /*  64601 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64668), // Rule ID 2131 //
     /*  64606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64634 */     // MIs[1] imm
     /*  64634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64646 */     // MIs[2] Operand 1
     /*  64646 */     // No operand predicates
     /*  64646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64652 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64666 */     GIR_RootConstrainSelectedInstOperands,
     /*  64667 */     // GIR_Coverage, 2131,
     /*  64667 */     GIR_EraseRootFromParent_Done,
     /*  64668 */   // Label 1077: @64668
     /*  64668 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64721), // Rule ID 173 //
     /*  64673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64708 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64719 */     GIR_RootConstrainSelectedInstOperands,
     /*  64720 */     // GIR_Coverage, 173,
     /*  64720 */     GIR_EraseRootFromParent_Done,
     /*  64721 */   // Label 1078: @64721
     /*  64721 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64785), // Rule ID 13988 //
     /*  64726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64758 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64772 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64777 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64783 */     GIR_RootConstrainSelectedInstOperands,
     /*  64784 */     // GIR_Coverage, 13988,
     /*  64784 */     GIR_EraseRootFromParent_Done,
     /*  64785 */   // Label 1079: @64785
     /*  64785 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64849), // Rule ID 5075 //
     /*  64790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64826 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64836 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64841 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64847 */     GIR_RootConstrainSelectedInstOperands,
     /*  64848 */     // GIR_Coverage, 5075,
     /*  64848 */     GIR_EraseRootFromParent_Done,
     /*  64849 */   // Label 1080: @64849
     /*  64849 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64873), // Rule ID 177 //
     /*  64854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64866 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  64871 */     GIR_RootConstrainSelectedInstOperands,
     /*  64872 */     // GIR_Coverage, 177,
     /*  64872 */     GIR_Done,
     /*  64873 */   // Label 1081: @64873
     /*  64873 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64900), // Rule ID 5081 //
     /*  64878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64893 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64898 */     GIR_RootConstrainSelectedInstOperands,
     /*  64899 */     // GIR_Coverage, 5081,
     /*  64899 */     GIR_Done,
     /*  64900 */   // Label 1082: @64900
     /*  64900 */   GIM_Reject,
     /*  64901 */ // Label 1057: @64901
     /*  64901 */ GIM_Reject,
     /*  64902 */ // Label 1031: @64902
     /*  64902 */ GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(66209),
     /*  64907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64913 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(65022), // Rule ID 13690 //
     /*  64918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64966 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64983 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64987 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64991 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64996 */     // MIs[4] LHS
     /*  64996 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65003 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65020 */     GIR_RootConstrainSelectedInstOperands,
     /*  65021 */     // GIR_Coverage, 13690,
     /*  65021 */     GIR_EraseRootFromParent_Done,
     /*  65022 */   // Label 1084: @65022
     /*  65022 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(65131), // Rule ID 13689 //
     /*  65027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65092 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65096 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65100 */     // MIs[4] LHS
     /*  65100 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65105 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65112 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65129 */     GIR_RootConstrainSelectedInstOperands,
     /*  65130 */     // GIR_Coverage, 13689,
     /*  65130 */     GIR_EraseRootFromParent_Done,
     /*  65131 */   // Label 1085: @65131
     /*  65131 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(65240), // Rule ID 13692 //
     /*  65136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65197 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65201 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65205 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65209 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65214 */     // MIs[4] LHS
     /*  65214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65221 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65238 */     GIR_RootConstrainSelectedInstOperands,
     /*  65239 */     // GIR_Coverage, 13692,
     /*  65239 */     GIR_EraseRootFromParent_Done,
     /*  65240 */   // Label 1086: @65240
     /*  65240 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65349), // Rule ID 13691 //
     /*  65245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65298 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65310 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65314 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65318 */     // MIs[4] LHS
     /*  65318 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65323 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65328 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65330 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65347 */     GIR_RootConstrainSelectedInstOperands,
     /*  65348 */     // GIR_Coverage, 13691,
     /*  65348 */     GIR_EraseRootFromParent_Done,
     /*  65349 */   // Label 1087: @65349
     /*  65349 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65458), // Rule ID 2473 //
     /*  65354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65411 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65415 */     // MIs[3] LHS
     /*  65415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65420 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65424 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65439 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65456 */     GIR_RootConstrainSelectedInstOperands,
     /*  65457 */     // GIR_Coverage, 2473,
     /*  65457 */     GIR_EraseRootFromParent_Done,
     /*  65458 */   // Label 1088: @65458
     /*  65458 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65567), // Rule ID 13687 //
     /*  65463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65524 */     // MIs[3] LHS
     /*  65524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65533 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65548 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65565 */     GIR_RootConstrainSelectedInstOperands,
     /*  65566 */     // GIR_Coverage, 13687,
     /*  65566 */     GIR_EraseRootFromParent_Done,
     /*  65567 */   // Label 1089: @65567
     /*  65567 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65676), // Rule ID 13686 //
     /*  65572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65634 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65638 */     // MIs[3] LHS
     /*  65638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65643 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65647 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65657 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65674 */     GIR_RootConstrainSelectedInstOperands,
     /*  65675 */     // GIR_Coverage, 13686,
     /*  65675 */     GIR_EraseRootFromParent_Done,
     /*  65676 */   // Label 1090: @65676
     /*  65676 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65785), // Rule ID 13688 //
     /*  65681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65743 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65747 */     // MIs[3] LHS
     /*  65747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65756 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65766 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65783 */     GIR_RootConstrainSelectedInstOperands,
     /*  65784 */     // GIR_Coverage, 13688,
     /*  65784 */     GIR_EraseRootFromParent_Done,
     /*  65785 */   // Label 1091: @65785
     /*  65785 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65852), // Rule ID 13653 //
     /*  65790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65814 */     // MIs[1] imm
     /*  65814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65826 */     // MIs[2] Operand 1
     /*  65826 */     // No operand predicates
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65836 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65850 */     GIR_RootConstrainSelectedInstOperands,
     /*  65851 */     // GIR_Coverage, 13653,
     /*  65851 */     GIR_EraseRootFromParent_Done,
     /*  65852 */   // Label 1092: @65852
     /*  65852 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65919), // Rule ID 13674 //
     /*  65857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65881 */     // MIs[1] imm
     /*  65881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65893 */     // MIs[2] Operand 1
     /*  65893 */     // No operand predicates
     /*  65893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65903 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  65906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65917 */     GIR_RootConstrainSelectedInstOperands,
     /*  65918 */     // GIR_Coverage, 13674,
     /*  65918 */     GIR_EraseRootFromParent_Done,
     /*  65919 */   // Label 1093: @65919
     /*  65919 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65986), // Rule ID 2239 //
     /*  65924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65952 */     // MIs[1] imm
     /*  65952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65964 */     // MIs[2] Operand 1
     /*  65964 */     // No operand predicates
     /*  65964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65970 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65984 */     GIR_RootConstrainSelectedInstOperands,
     /*  65985 */     // GIR_Coverage, 2239,
     /*  65985 */     GIR_EraseRootFromParent_Done,
     /*  65986 */   // Label 1094: @65986
     /*  65986 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(66053), // Rule ID 2298 //
     /*  65991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66019 */     // MIs[1] imm
     /*  66019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  66031 */     // MIs[2] Operand 1
     /*  66031 */     // No operand predicates
     /*  66031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66037 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  66040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66051 */     GIR_RootConstrainSelectedInstOperands,
     /*  66052 */     // GIR_Coverage, 2298,
     /*  66052 */     GIR_EraseRootFromParent_Done,
     /*  66053 */   // Label 1095: @66053
     /*  66053 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(66117), // Rule ID 13987 //
     /*  66058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66090 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66104 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66109 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  66111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66115 */     GIR_RootConstrainSelectedInstOperands,
     /*  66116 */     // GIR_Coverage, 13987,
     /*  66116 */     GIR_EraseRootFromParent_Done,
     /*  66117 */   // Label 1096: @66117
     /*  66117 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(66181), // Rule ID 5074 //
     /*  66122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66158 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66168 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66173 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66179 */     GIR_RootConstrainSelectedInstOperands,
     /*  66180 */     // GIR_Coverage, 5074,
     /*  66180 */     GIR_EraseRootFromParent_Done,
     /*  66181 */   // Label 1097: @66181
     /*  66181 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66208), // Rule ID 5080 //
     /*  66186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66201 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66206 */     GIR_RootConstrainSelectedInstOperands,
     /*  66207 */     // GIR_Coverage, 5080,
     /*  66207 */     GIR_Done,
     /*  66208 */   // Label 1098: @66208
     /*  66208 */   GIM_Reject,
     /*  66209 */ // Label 1083: @66209
     /*  66209 */ GIM_Reject,
     /*  66210 */ // Label 1032: @66210
     /*  66210 */ GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(67517),
     /*  66215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66221 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(66330), // Rule ID 13718 //
     /*  66226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66274 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66295 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66299 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66304 */     // MIs[4] LHS
     /*  66304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66309 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66311 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66328 */     GIR_RootConstrainSelectedInstOperands,
     /*  66329 */     // GIR_Coverage, 13718,
     /*  66329 */     GIR_EraseRootFromParent_Done,
     /*  66330 */   // Label 1100: @66330
     /*  66330 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66439), // Rule ID 13717 //
     /*  66335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66383 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66404 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66408 */     // MIs[4] LHS
     /*  66408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66413 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66420 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66437 */     GIR_RootConstrainSelectedInstOperands,
     /*  66438 */     // GIR_Coverage, 13717,
     /*  66438 */     GIR_EraseRootFromParent_Done,
     /*  66439 */   // Label 1101: @66439
     /*  66439 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66548), // Rule ID 13720 //
     /*  66444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66497 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66505 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66509 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66513 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66517 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66522 */     // MIs[4] LHS
     /*  66522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66527 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66529 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66546 */     GIR_RootConstrainSelectedInstOperands,
     /*  66547 */     // GIR_Coverage, 13720,
     /*  66547 */     GIR_EraseRootFromParent_Done,
     /*  66548 */   // Label 1102: @66548
     /*  66548 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66657), // Rule ID 13719 //
     /*  66553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66622 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66626 */     // MIs[4] LHS
     /*  66626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66631 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66638 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66655 */     GIR_RootConstrainSelectedInstOperands,
     /*  66656 */     // GIR_Coverage, 13719,
     /*  66656 */     GIR_EraseRootFromParent_Done,
     /*  66657 */   // Label 1103: @66657
     /*  66657 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66766), // Rule ID 2477 //
     /*  66662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66723 */     // MIs[3] LHS
     /*  66723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66745 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66747 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66764 */     GIR_RootConstrainSelectedInstOperands,
     /*  66765 */     // GIR_Coverage, 2477,
     /*  66765 */     GIR_EraseRootFromParent_Done,
     /*  66766 */   // Label 1104: @66766
     /*  66766 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66875), // Rule ID 13715 //
     /*  66771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66832 */     // MIs[3] LHS
     /*  66832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66856 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66873 */     GIR_RootConstrainSelectedInstOperands,
     /*  66874 */     // GIR_Coverage, 13715,
     /*  66874 */     GIR_EraseRootFromParent_Done,
     /*  66875 */   // Label 1105: @66875
     /*  66875 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66984), // Rule ID 13714 //
     /*  66880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66946 */     // MIs[3] LHS
     /*  66946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66965 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66982 */     GIR_RootConstrainSelectedInstOperands,
     /*  66983 */     // GIR_Coverage, 13714,
     /*  66983 */     GIR_EraseRootFromParent_Done,
     /*  66984 */   // Label 1106: @66984
     /*  66984 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(67093), // Rule ID 13716 //
     /*  66989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67055 */     // MIs[3] LHS
     /*  67055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67064 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67074 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  67074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67091 */     GIR_RootConstrainSelectedInstOperands,
     /*  67092 */     // GIR_Coverage, 13716,
     /*  67092 */     GIR_EraseRootFromParent_Done,
     /*  67093 */   // Label 1107: @67093
     /*  67093 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(67160), // Rule ID 13657 //
     /*  67098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67122 */     // MIs[1] imm
     /*  67122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67134 */     // MIs[2] Operand 1
     /*  67134 */     // No operand predicates
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67144 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67158 */     GIR_RootConstrainSelectedInstOperands,
     /*  67159 */     // GIR_Coverage, 13657,
     /*  67159 */     GIR_EraseRootFromParent_Done,
     /*  67160 */   // Label 1108: @67160
     /*  67160 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(67227), // Rule ID 13678 //
     /*  67165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67189 */     // MIs[1] imm
     /*  67189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67201 */     // MIs[2] Operand 1
     /*  67201 */     // No operand predicates
     /*  67201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67211 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67225 */     GIR_RootConstrainSelectedInstOperands,
     /*  67226 */     // GIR_Coverage, 13678,
     /*  67226 */     GIR_EraseRootFromParent_Done,
     /*  67227 */   // Label 1109: @67227
     /*  67227 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67294), // Rule ID 2243 //
     /*  67232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67260 */     // MIs[1] imm
     /*  67260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67272 */     // MIs[2] Operand 1
     /*  67272 */     // No operand predicates
     /*  67272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67278 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67292 */     GIR_RootConstrainSelectedInstOperands,
     /*  67293 */     // GIR_Coverage, 2243,
     /*  67293 */     GIR_EraseRootFromParent_Done,
     /*  67294 */   // Label 1110: @67294
     /*  67294 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67361), // Rule ID 2302 //
     /*  67299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67327 */     // MIs[1] imm
     /*  67327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67339 */     // MIs[2] Operand 1
     /*  67339 */     // No operand predicates
     /*  67339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67345 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67359 */     GIR_RootConstrainSelectedInstOperands,
     /*  67360 */     // GIR_Coverage, 2302,
     /*  67360 */     GIR_EraseRootFromParent_Done,
     /*  67361 */   // Label 1111: @67361
     /*  67361 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67425), // Rule ID 13991 //
     /*  67366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67412 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67423 */     GIR_RootConstrainSelectedInstOperands,
     /*  67424 */     // GIR_Coverage, 13991,
     /*  67424 */     GIR_EraseRootFromParent_Done,
     /*  67425 */   // Label 1112: @67425
     /*  67425 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67489), // Rule ID 5078 //
     /*  67430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67466 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67476 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67481 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67487 */     GIR_RootConstrainSelectedInstOperands,
     /*  67488 */     // GIR_Coverage, 5078,
     /*  67488 */     GIR_EraseRootFromParent_Done,
     /*  67489 */   // Label 1113: @67489
     /*  67489 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67516), // Rule ID 5084 //
     /*  67494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67509 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  67514 */     GIR_RootConstrainSelectedInstOperands,
     /*  67515 */     // GIR_Coverage, 5084,
     /*  67515 */     GIR_Done,
     /*  67516 */   // Label 1114: @67516
     /*  67516 */   GIM_Reject,
     /*  67517 */ // Label 1099: @67517
     /*  67517 */ GIM_Reject,
     /*  67518 */ // Label 1033: @67518
     /*  67518 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(68825),
     /*  67523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67529 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(67638), // Rule ID 13683 //
     /*  67534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67582 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67603 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67607 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67612 */     // MIs[4] LHS
     /*  67612 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67617 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67619 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67636 */     GIR_RootConstrainSelectedInstOperands,
     /*  67637 */     // GIR_Coverage, 13683,
     /*  67637 */     GIR_EraseRootFromParent_Done,
     /*  67638 */   // Label 1116: @67638
     /*  67638 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67747), // Rule ID 13682 //
     /*  67643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67712 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67716 */     // MIs[4] LHS
     /*  67716 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67721 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67728 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67745 */     GIR_RootConstrainSelectedInstOperands,
     /*  67746 */     // GIR_Coverage, 13682,
     /*  67746 */     GIR_EraseRootFromParent_Done,
     /*  67747 */   // Label 1117: @67747
     /*  67747 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67856), // Rule ID 13685 //
     /*  67752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67805 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67813 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67817 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67821 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67825 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67830 */     // MIs[4] LHS
     /*  67830 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67837 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67854 */     GIR_RootConstrainSelectedInstOperands,
     /*  67855 */     // GIR_Coverage, 13685,
     /*  67855 */     GIR_EraseRootFromParent_Done,
     /*  67856 */   // Label 1118: @67856
     /*  67856 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67965), // Rule ID 13684 //
     /*  67861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67914 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67930 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67934 */     // MIs[4] LHS
     /*  67934 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67939 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67944 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67946 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67963 */     GIR_RootConstrainSelectedInstOperands,
     /*  67964 */     // GIR_Coverage, 13684,
     /*  67964 */     GIR_EraseRootFromParent_Done,
     /*  67965 */   // Label 1119: @67965
     /*  67965 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(68074), // Rule ID 2472 //
     /*  67970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68031 */     // MIs[3] LHS
     /*  68031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68040 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68055 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68072 */     GIR_RootConstrainSelectedInstOperands,
     /*  68073 */     // GIR_Coverage, 2472,
     /*  68073 */     GIR_EraseRootFromParent_Done,
     /*  68074 */   // Label 1120: @68074
     /*  68074 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(68183), // Rule ID 13680 //
     /*  68079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68140 */     // MIs[3] LHS
     /*  68140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68149 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68164 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68181 */     GIR_RootConstrainSelectedInstOperands,
     /*  68182 */     // GIR_Coverage, 13680,
     /*  68182 */     GIR_EraseRootFromParent_Done,
     /*  68183 */   // Label 1121: @68183
     /*  68183 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68292), // Rule ID 13679 //
     /*  68188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68250 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68254 */     // MIs[3] LHS
     /*  68254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68263 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68273 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68290 */     GIR_RootConstrainSelectedInstOperands,
     /*  68291 */     // GIR_Coverage, 13679,
     /*  68291 */     GIR_EraseRootFromParent_Done,
     /*  68292 */   // Label 1122: @68292
     /*  68292 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68401), // Rule ID 13681 //
     /*  68297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68363 */     // MIs[3] LHS
     /*  68363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68372 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68382 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68399 */     GIR_RootConstrainSelectedInstOperands,
     /*  68400 */     // GIR_Coverage, 13681,
     /*  68400 */     GIR_EraseRootFromParent_Done,
     /*  68401 */   // Label 1123: @68401
     /*  68401 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68468), // Rule ID 13649 //
     /*  68406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68430 */     // MIs[1] imm
     /*  68430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68442 */     // MIs[2] Operand 1
     /*  68442 */     // No operand predicates
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68452 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68466 */     GIR_RootConstrainSelectedInstOperands,
     /*  68467 */     // GIR_Coverage, 13649,
     /*  68467 */     GIR_EraseRootFromParent_Done,
     /*  68468 */   // Label 1124: @68468
     /*  68468 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68535), // Rule ID 13670 //
     /*  68473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68497 */     // MIs[1] imm
     /*  68497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68509 */     // MIs[2] Operand 1
     /*  68509 */     // No operand predicates
     /*  68509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68519 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68533 */     GIR_RootConstrainSelectedInstOperands,
     /*  68534 */     // GIR_Coverage, 13670,
     /*  68534 */     GIR_EraseRootFromParent_Done,
     /*  68535 */   // Label 1125: @68535
     /*  68535 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68602), // Rule ID 2235 //
     /*  68540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68568 */     // MIs[1] imm
     /*  68568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68580 */     // MIs[2] Operand 1
     /*  68580 */     // No operand predicates
     /*  68580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68586 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68600 */     GIR_RootConstrainSelectedInstOperands,
     /*  68601 */     // GIR_Coverage, 2235,
     /*  68601 */     GIR_EraseRootFromParent_Done,
     /*  68602 */   // Label 1126: @68602
     /*  68602 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68669), // Rule ID 2294 //
     /*  68607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68635 */     // MIs[1] imm
     /*  68635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68647 */     // MIs[2] Operand 1
     /*  68647 */     // No operand predicates
     /*  68647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68653 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68667 */     GIR_RootConstrainSelectedInstOperands,
     /*  68668 */     // GIR_Coverage, 2294,
     /*  68668 */     GIR_EraseRootFromParent_Done,
     /*  68669 */   // Label 1127: @68669
     /*  68669 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68733), // Rule ID 13986 //
     /*  68674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68706 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68712 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68720 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68725 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68731 */     GIR_RootConstrainSelectedInstOperands,
     /*  68732 */     // GIR_Coverage, 13986,
     /*  68732 */     GIR_EraseRootFromParent_Done,
     /*  68733 */   // Label 1128: @68733
     /*  68733 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68797), // Rule ID 5073 //
     /*  68738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68784 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68789 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68795 */     GIR_RootConstrainSelectedInstOperands,
     /*  68796 */     // GIR_Coverage, 5073,
     /*  68796 */     GIR_EraseRootFromParent_Done,
     /*  68797 */   // Label 1129: @68797
     /*  68797 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68824), // Rule ID 5079 //
     /*  68802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68817 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  68822 */     GIR_RootConstrainSelectedInstOperands,
     /*  68823 */     // GIR_Coverage, 5079,
     /*  68823 */     GIR_Done,
     /*  68824 */   // Label 1130: @68824
     /*  68824 */   GIM_Reject,
     /*  68825 */ // Label 1115: @68825
     /*  68825 */ GIM_Reject,
     /*  68826 */ // Label 1034: @68826
     /*  68826 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70133),
     /*  68831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68837 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68946), // Rule ID 13711 //
     /*  68842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68890 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68903 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68907 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68911 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68915 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68920 */     // MIs[4] LHS
     /*  68920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68927 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  68936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  68940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  68944 */     GIR_RootConstrainSelectedInstOperands,
     /*  68945 */     // GIR_Coverage, 13711,
     /*  68945 */     GIR_EraseRootFromParent_Done,
     /*  68946 */   // Label 1132: @68946
     /*  68946 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(69055), // Rule ID 13710 //
     /*  68951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69012 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69016 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69020 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69024 */     // MIs[4] LHS
     /*  69024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69029 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69034 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69036 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69053 */     GIR_RootConstrainSelectedInstOperands,
     /*  69054 */     // GIR_Coverage, 13710,
     /*  69054 */     GIR_EraseRootFromParent_Done,
     /*  69055 */   // Label 1133: @69055
     /*  69055 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(69164), // Rule ID 13713 //
     /*  69060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69133 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69138 */     // MIs[4] LHS
     /*  69138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69143 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69145 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69162 */     GIR_RootConstrainSelectedInstOperands,
     /*  69163 */     // GIR_Coverage, 13713,
     /*  69163 */     GIR_EraseRootFromParent_Done,
     /*  69164 */   // Label 1134: @69164
     /*  69164 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(69273), // Rule ID 13712 //
     /*  69169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69242 */     // MIs[4] LHS
     /*  69242 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69247 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69252 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69254 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69271 */     GIR_RootConstrainSelectedInstOperands,
     /*  69272 */     // GIR_Coverage, 13712,
     /*  69272 */     GIR_EraseRootFromParent_Done,
     /*  69273 */   // Label 1135: @69273
     /*  69273 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69382), // Rule ID 2476 //
     /*  69278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69335 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69339 */     // MIs[3] LHS
     /*  69339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69348 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69363 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69380 */     GIR_RootConstrainSelectedInstOperands,
     /*  69381 */     // GIR_Coverage, 2476,
     /*  69381 */     GIR_EraseRootFromParent_Done,
     /*  69382 */   // Label 1136: @69382
     /*  69382 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69491), // Rule ID 13708 //
     /*  69387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69448 */     // MIs[3] LHS
     /*  69448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69457 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69472 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69489 */     GIR_RootConstrainSelectedInstOperands,
     /*  69490 */     // GIR_Coverage, 13708,
     /*  69490 */     GIR_EraseRootFromParent_Done,
     /*  69491 */   // Label 1137: @69491
     /*  69491 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69600), // Rule ID 13707 //
     /*  69496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69562 */     // MIs[3] LHS
     /*  69562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69571 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69581 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69598 */     GIR_RootConstrainSelectedInstOperands,
     /*  69599 */     // GIR_Coverage, 13707,
     /*  69599 */     GIR_EraseRootFromParent_Done,
     /*  69600 */   // Label 1138: @69600
     /*  69600 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69709), // Rule ID 13709 //
     /*  69605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69671 */     // MIs[3] LHS
     /*  69671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69690 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69707 */     GIR_RootConstrainSelectedInstOperands,
     /*  69708 */     // GIR_Coverage, 13709,
     /*  69708 */     GIR_EraseRootFromParent_Done,
     /*  69709 */   // Label 1139: @69709
     /*  69709 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69776), // Rule ID 13655 //
     /*  69714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69738 */     // MIs[1] imm
     /*  69738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69750 */     // MIs[2] Operand 1
     /*  69750 */     // No operand predicates
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69760 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69774 */     GIR_RootConstrainSelectedInstOperands,
     /*  69775 */     // GIR_Coverage, 13655,
     /*  69775 */     GIR_EraseRootFromParent_Done,
     /*  69776 */   // Label 1140: @69776
     /*  69776 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69843), // Rule ID 13676 //
     /*  69781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69805 */     // MIs[1] imm
     /*  69805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69813 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69817 */     // MIs[2] Operand 1
     /*  69817 */     // No operand predicates
     /*  69817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69827 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69841 */     GIR_RootConstrainSelectedInstOperands,
     /*  69842 */     // GIR_Coverage, 13676,
     /*  69842 */     GIR_EraseRootFromParent_Done,
     /*  69843 */   // Label 1141: @69843
     /*  69843 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69910), // Rule ID 2241 //
     /*  69848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69876 */     // MIs[1] imm
     /*  69876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69888 */     // MIs[2] Operand 1
     /*  69888 */     // No operand predicates
     /*  69888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69894 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69908 */     GIR_RootConstrainSelectedInstOperands,
     /*  69909 */     // GIR_Coverage, 2241,
     /*  69909 */     GIR_EraseRootFromParent_Done,
     /*  69910 */   // Label 1142: @69910
     /*  69910 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69977), // Rule ID 2300 //
     /*  69915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69943 */     // MIs[1] imm
     /*  69943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69955 */     // MIs[2] Operand 1
     /*  69955 */     // No operand predicates
     /*  69955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69961 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69975 */     GIR_RootConstrainSelectedInstOperands,
     /*  69976 */     // GIR_Coverage, 2300,
     /*  69976 */     GIR_EraseRootFromParent_Done,
     /*  69977 */   // Label 1143: @69977
     /*  69977 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(70041), // Rule ID 13990 //
     /*  69982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70028 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70033 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70039 */     GIR_RootConstrainSelectedInstOperands,
     /*  70040 */     // GIR_Coverage, 13990,
     /*  70040 */     GIR_EraseRootFromParent_Done,
     /*  70041 */   // Label 1144: @70041
     /*  70041 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(70105), // Rule ID 5077 //
     /*  70046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70082 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70092 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70097 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  70099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70103 */     GIR_RootConstrainSelectedInstOperands,
     /*  70104 */     // GIR_Coverage, 5077,
     /*  70104 */     GIR_EraseRootFromParent_Done,
     /*  70105 */   // Label 1145: @70105
     /*  70105 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(70132), // Rule ID 5083 //
     /*  70110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70125 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  70130 */     GIR_RootConstrainSelectedInstOperands,
     /*  70131 */     // GIR_Coverage, 5083,
     /*  70131 */     GIR_Done,
     /*  70132 */   // Label 1146: @70132
     /*  70132 */   GIM_Reject,
     /*  70133 */ // Label 1131: @70133
     /*  70133 */ GIM_Reject,
     /*  70134 */ // Label 1035: @70134
     /*  70134 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71441),
     /*  70139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70145 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(70254), // Rule ID 13461 //
     /*  70150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70198 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70223 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70228 */     // MIs[4] Rd
     /*  70228 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70233 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70235 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70252 */     GIR_RootConstrainSelectedInstOperands,
     /*  70253 */     // GIR_Coverage, 13461,
     /*  70253 */     GIR_EraseRootFromParent_Done,
     /*  70254 */   // Label 1148: @70254
     /*  70254 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70363), // Rule ID 13460 //
     /*  70259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70332 */     // MIs[4] Rd
     /*  70332 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70337 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70342 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70344 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70361 */     GIR_RootConstrainSelectedInstOperands,
     /*  70362 */     // GIR_Coverage, 13460,
     /*  70362 */     GIR_EraseRootFromParent_Done,
     /*  70363 */   // Label 1149: @70363
     /*  70363 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70472), // Rule ID 13463 //
     /*  70368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70429 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70433 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70437 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70441 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70446 */     // MIs[4] Rd
     /*  70446 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70453 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70470 */     GIR_RootConstrainSelectedInstOperands,
     /*  70471 */     // GIR_Coverage, 13463,
     /*  70471 */     GIR_EraseRootFromParent_Done,
     /*  70472 */   // Label 1150: @70472
     /*  70472 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70581), // Rule ID 13462 //
     /*  70477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70542 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70546 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70550 */     // MIs[4] Rd
     /*  70550 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70555 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70562 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70579 */     GIR_RootConstrainSelectedInstOperands,
     /*  70580 */     // GIR_Coverage, 13462,
     /*  70580 */     GIR_EraseRootFromParent_Done,
     /*  70581 */   // Label 1151: @70581
     /*  70581 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70690), // Rule ID 1605 //
     /*  70586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70643 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70647 */     // MIs[3] Rd
     /*  70647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70656 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70669 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70671 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70688 */     GIR_RootConstrainSelectedInstOperands,
     /*  70689 */     // GIR_Coverage, 1605,
     /*  70689 */     GIR_EraseRootFromParent_Done,
     /*  70690 */   // Label 1152: @70690
     /*  70690 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70799), // Rule ID 13458 //
     /*  70695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70756 */     // MIs[3] Rd
     /*  70756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70765 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70780 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  70789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70797 */     GIR_RootConstrainSelectedInstOperands,
     /*  70798 */     // GIR_Coverage, 13458,
     /*  70798 */     GIR_EraseRootFromParent_Done,
     /*  70799 */   // Label 1153: @70799
     /*  70799 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70908), // Rule ID 13457 //
     /*  70804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70870 */     // MIs[3] Rd
     /*  70870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70887 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70889 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  70906 */     GIR_RootConstrainSelectedInstOperands,
     /*  70907 */     // GIR_Coverage, 13457,
     /*  70907 */     GIR_EraseRootFromParent_Done,
     /*  70908 */   // Label 1154: @70908
     /*  70908 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71017), // Rule ID 13459 //
     /*  70913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70979 */     // MIs[3] Rd
     /*  70979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70998 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  71001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71015 */     GIR_RootConstrainSelectedInstOperands,
     /*  71016 */     // GIR_Coverage, 13459,
     /*  71016 */     GIR_EraseRootFromParent_Done,
     /*  71017 */   // Label 1155: @71017
     /*  71017 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71084), // Rule ID 13645 //
     /*  71022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71046 */     // MIs[1] imm
     /*  71046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71058 */     // MIs[2] Operand 1
     /*  71058 */     // No operand predicates
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71068 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71082 */     GIR_RootConstrainSelectedInstOperands,
     /*  71083 */     // GIR_Coverage, 13645,
     /*  71083 */     GIR_EraseRootFromParent_Done,
     /*  71084 */   // Label 1156: @71084
     /*  71084 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(71151), // Rule ID 13666 //
     /*  71089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71113 */     // MIs[1] imm
     /*  71113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71121 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71125 */     // MIs[2] Operand 1
     /*  71125 */     // No operand predicates
     /*  71125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71135 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71149 */     GIR_RootConstrainSelectedInstOperands,
     /*  71150 */     // GIR_Coverage, 13666,
     /*  71150 */     GIR_EraseRootFromParent_Done,
     /*  71151 */   // Label 1157: @71151
     /*  71151 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(71218), // Rule ID 2231 //
     /*  71156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71184 */     // MIs[1] imm
     /*  71184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71196 */     // MIs[2] Operand 1
     /*  71196 */     // No operand predicates
     /*  71196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71202 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71216 */     GIR_RootConstrainSelectedInstOperands,
     /*  71217 */     // GIR_Coverage, 2231,
     /*  71217 */     GIR_EraseRootFromParent_Done,
     /*  71218 */   // Label 1158: @71218
     /*  71218 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71285), // Rule ID 2290 //
     /*  71223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71251 */     // MIs[1] imm
     /*  71251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71259 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71263 */     // MIs[2] Operand 1
     /*  71263 */     // No operand predicates
     /*  71263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71269 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71283 */     GIR_RootConstrainSelectedInstOperands,
     /*  71284 */     // GIR_Coverage, 2290,
     /*  71284 */     GIR_EraseRootFromParent_Done,
     /*  71285 */   // Label 1159: @71285
     /*  71285 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71349), // Rule ID 13455 //
     /*  71290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71322 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71336 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71347 */     GIR_RootConstrainSelectedInstOperands,
     /*  71348 */     // GIR_Coverage, 13455,
     /*  71348 */     GIR_EraseRootFromParent_Done,
     /*  71349 */   // Label 1160: @71349
     /*  71349 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71413), // Rule ID 1601 //
     /*  71354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71390 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71400 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71411 */     GIR_RootConstrainSelectedInstOperands,
     /*  71412 */     // GIR_Coverage, 1601,
     /*  71412 */     GIR_EraseRootFromParent_Done,
     /*  71413 */   // Label 1161: @71413
     /*  71413 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71440), // Rule ID 1603 //
     /*  71418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71433 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  71438 */     GIR_RootConstrainSelectedInstOperands,
     /*  71439 */     // GIR_Coverage, 1603,
     /*  71439 */     GIR_Done,
     /*  71440 */   // Label 1162: @71440
     /*  71440 */   GIM_Reject,
     /*  71441 */ // Label 1147: @71441
     /*  71441 */ GIM_Reject,
     /*  71442 */ // Label 1036: @71442
     /*  71442 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72749),
     /*  71447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71453 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(71562), // Rule ID 13704 //
     /*  71458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71506 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71519 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71523 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71527 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71531 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71536 */     // MIs[4] LHS
     /*  71536 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71541 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71543 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71560 */     GIR_RootConstrainSelectedInstOperands,
     /*  71561 */     // GIR_Coverage, 13704,
     /*  71561 */     GIR_EraseRootFromParent_Done,
     /*  71562 */   // Label 1164: @71562
     /*  71562 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71671), // Rule ID 13703 //
     /*  71567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71615 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71640 */     // MIs[4] LHS
     /*  71640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71645 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71652 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71669 */     GIR_RootConstrainSelectedInstOperands,
     /*  71670 */     // GIR_Coverage, 13703,
     /*  71670 */     GIR_EraseRootFromParent_Done,
     /*  71671 */   // Label 1165: @71671
     /*  71671 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71780), // Rule ID 13706 //
     /*  71676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71737 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71741 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71745 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71749 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71754 */     // MIs[4] LHS
     /*  71754 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71761 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71778 */     GIR_RootConstrainSelectedInstOperands,
     /*  71779 */     // GIR_Coverage, 13706,
     /*  71779 */     GIR_EraseRootFromParent_Done,
     /*  71780 */   // Label 1166: @71780
     /*  71780 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71889), // Rule ID 13705 //
     /*  71785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71838 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71854 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71858 */     // MIs[4] LHS
     /*  71858 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71863 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71870 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71887 */     GIR_RootConstrainSelectedInstOperands,
     /*  71888 */     // GIR_Coverage, 13705,
     /*  71888 */     GIR_EraseRootFromParent_Done,
     /*  71889 */   // Label 1167: @71889
     /*  71889 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71998), // Rule ID 2475 //
     /*  71894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71951 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71955 */     // MIs[3] LHS
     /*  71955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71964 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71979 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  71988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  71992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  71996 */     GIR_RootConstrainSelectedInstOperands,
     /*  71997 */     // GIR_Coverage, 2475,
     /*  71997 */     GIR_EraseRootFromParent_Done,
     /*  71998 */   // Label 1168: @71998
     /*  71998 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72107), // Rule ID 13701 //
     /*  72003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  72056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72064 */     // MIs[3] LHS
     /*  72064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72088 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  72105 */     GIR_RootConstrainSelectedInstOperands,
     /*  72106 */     // GIR_Coverage, 13701,
     /*  72106 */     GIR_EraseRootFromParent_Done,
     /*  72107 */   // Label 1169: @72107
     /*  72107 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72216), // Rule ID 13700 //
     /*  72112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72178 */     // MIs[3] LHS
     /*  72178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72187 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72197 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  72206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  72210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72214 */     GIR_RootConstrainSelectedInstOperands,
     /*  72215 */     // GIR_Coverage, 13700,
     /*  72215 */     GIR_EraseRootFromParent_Done,
     /*  72216 */   // Label 1170: @72216
     /*  72216 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72325), // Rule ID 13702 //
     /*  72221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72283 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72287 */     // MIs[3] LHS
     /*  72287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72296 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72304 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72306 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72323 */     GIR_RootConstrainSelectedInstOperands,
     /*  72324 */     // GIR_Coverage, 13702,
     /*  72324 */     GIR_EraseRootFromParent_Done,
     /*  72325 */   // Label 1171: @72325
     /*  72325 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72392), // Rule ID 13651 //
     /*  72330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72354 */     // MIs[1] imm
     /*  72354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72366 */     // MIs[2] Operand 1
     /*  72366 */     // No operand predicates
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72376 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72390 */     GIR_RootConstrainSelectedInstOperands,
     /*  72391 */     // GIR_Coverage, 13651,
     /*  72391 */     GIR_EraseRootFromParent_Done,
     /*  72392 */   // Label 1172: @72392
     /*  72392 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72459), // Rule ID 13672 //
     /*  72397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72421 */     // MIs[1] imm
     /*  72421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72433 */     // MIs[2] Operand 1
     /*  72433 */     // No operand predicates
     /*  72433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72443 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72457 */     GIR_RootConstrainSelectedInstOperands,
     /*  72458 */     // GIR_Coverage, 13672,
     /*  72458 */     GIR_EraseRootFromParent_Done,
     /*  72459 */   // Label 1173: @72459
     /*  72459 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72526), // Rule ID 2237 //
     /*  72464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72492 */     // MIs[1] imm
     /*  72492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72500 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72504 */     // MIs[2] Operand 1
     /*  72504 */     // No operand predicates
     /*  72504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72510 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72524 */     GIR_RootConstrainSelectedInstOperands,
     /*  72525 */     // GIR_Coverage, 2237,
     /*  72525 */     GIR_EraseRootFromParent_Done,
     /*  72526 */   // Label 1174: @72526
     /*  72526 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72593), // Rule ID 2296 //
     /*  72531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72559 */     // MIs[1] imm
     /*  72559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72571 */     // MIs[2] Operand 1
     /*  72571 */     // No operand predicates
     /*  72571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72577 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72591 */     GIR_RootConstrainSelectedInstOperands,
     /*  72592 */     // GIR_Coverage, 2296,
     /*  72592 */     GIR_EraseRootFromParent_Done,
     /*  72593 */   // Label 1175: @72593
     /*  72593 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72657), // Rule ID 13989 //
     /*  72598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72644 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72649 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  72651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72655 */     GIR_RootConstrainSelectedInstOperands,
     /*  72656 */     // GIR_Coverage, 13989,
     /*  72656 */     GIR_EraseRootFromParent_Done,
     /*  72657 */   // Label 1176: @72657
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72721), // Rule ID 5076 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72698 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72708 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72713 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  72715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72719 */     GIR_RootConstrainSelectedInstOperands,
     /*  72720 */     // GIR_Coverage, 5076,
     /*  72720 */     GIR_EraseRootFromParent_Done,
     /*  72721 */   // Label 1177: @72721
     /*  72721 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72748), // Rule ID 5082 //
     /*  72726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72741 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72746 */     GIR_RootConstrainSelectedInstOperands,
     /*  72747 */     // GIR_Coverage, 5082,
     /*  72747 */     GIR_Done,
     /*  72748 */   // Label 1178: @72748
     /*  72748 */   GIM_Reject,
     /*  72749 */ // Label 1163: @72749
     /*  72749 */ GIM_Reject,
     /*  72750 */ // Label 1037: @72750
     /*  72750 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(74057),
     /*  72755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72761 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72870), // Rule ID 13468 //
     /*  72766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72814 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72839 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72844 */     // MIs[4] Rd
     /*  72844 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72851 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  72864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72868 */     GIR_RootConstrainSelectedInstOperands,
     /*  72869 */     // GIR_Coverage, 13468,
     /*  72869 */     GIR_EraseRootFromParent_Done,
     /*  72870 */   // Label 1180: @72870
     /*  72870 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72979), // Rule ID 13467 //
     /*  72875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72923 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72940 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72944 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72948 */     // MIs[4] Rd
     /*  72948 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72953 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72960 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  72973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72977 */     GIR_RootConstrainSelectedInstOperands,
     /*  72978 */     // GIR_Coverage, 13467,
     /*  72978 */     GIR_EraseRootFromParent_Done,
     /*  72979 */   // Label 1181: @72979
     /*  72979 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73088), // Rule ID 13470 //
     /*  72984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73057 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73062 */     // MIs[4] Rd
     /*  73062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73067 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73069 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  73082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73086 */     GIR_RootConstrainSelectedInstOperands,
     /*  73087 */     // GIR_Coverage, 13470,
     /*  73087 */     GIR_EraseRootFromParent_Done,
     /*  73088 */   // Label 1182: @73088
     /*  73088 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73197), // Rule ID 13469 //
     /*  73093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73146 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73158 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73162 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73166 */     // MIs[4] Rd
     /*  73166 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73171 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73178 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  73191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73195 */     GIR_RootConstrainSelectedInstOperands,
     /*  73196 */     // GIR_Coverage, 13469,
     /*  73196 */     GIR_EraseRootFromParent_Done,
     /*  73197 */   // Label 1183: @73197
     /*  73197 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73306), // Rule ID 1606 //
     /*  73202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73263 */     // MIs[3] Rd
     /*  73263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73272 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73287 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73304 */     GIR_RootConstrainSelectedInstOperands,
     /*  73305 */     // GIR_Coverage, 1606,
     /*  73305 */     GIR_EraseRootFromParent_Done,
     /*  73306 */   // Label 1184: @73306
     /*  73306 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73415), // Rule ID 13465 //
     /*  73311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73372 */     // MIs[3] Rd
     /*  73372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73377 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73381 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73396 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73413 */     GIR_RootConstrainSelectedInstOperands,
     /*  73414 */     // GIR_Coverage, 13465,
     /*  73414 */     GIR_EraseRootFromParent_Done,
     /*  73415 */   // Label 1185: @73415
     /*  73415 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73524), // Rule ID 13464 //
     /*  73420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73486 */     // MIs[3] Rd
     /*  73486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73491 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73495 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73503 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73505 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73522 */     GIR_RootConstrainSelectedInstOperands,
     /*  73523 */     // GIR_Coverage, 13464,
     /*  73523 */     GIR_EraseRootFromParent_Done,
     /*  73524 */   // Label 1186: @73524
     /*  73524 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73633), // Rule ID 13466 //
     /*  73529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73595 */     // MIs[3] Rd
     /*  73595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73604 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73612 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73614 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73631 */     GIR_RootConstrainSelectedInstOperands,
     /*  73632 */     // GIR_Coverage, 13466,
     /*  73632 */     GIR_EraseRootFromParent_Done,
     /*  73633 */   // Label 1187: @73633
     /*  73633 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73700), // Rule ID 13647 //
     /*  73638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73662 */     // MIs[1] imm
     /*  73662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73674 */     // MIs[2] Operand 1
     /*  73674 */     // No operand predicates
     /*  73674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73684 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73698 */     GIR_RootConstrainSelectedInstOperands,
     /*  73699 */     // GIR_Coverage, 13647,
     /*  73699 */     GIR_EraseRootFromParent_Done,
     /*  73700 */   // Label 1188: @73700
     /*  73700 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73767), // Rule ID 13668 //
     /*  73705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73729 */     // MIs[1] imm
     /*  73729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73741 */     // MIs[2] Operand 1
     /*  73741 */     // No operand predicates
     /*  73741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73751 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73765 */     GIR_RootConstrainSelectedInstOperands,
     /*  73766 */     // GIR_Coverage, 13668,
     /*  73766 */     GIR_EraseRootFromParent_Done,
     /*  73767 */   // Label 1189: @73767
     /*  73767 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73834), // Rule ID 2233 //
     /*  73772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73800 */     // MIs[1] imm
     /*  73800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73812 */     // MIs[2] Operand 1
     /*  73812 */     // No operand predicates
     /*  73812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73818 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73832 */     GIR_RootConstrainSelectedInstOperands,
     /*  73833 */     // GIR_Coverage, 2233,
     /*  73833 */     GIR_EraseRootFromParent_Done,
     /*  73834 */   // Label 1190: @73834
     /*  73834 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73901), // Rule ID 2292 //
     /*  73839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73867 */     // MIs[1] imm
     /*  73867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73879 */     // MIs[2] Operand 1
     /*  73879 */     // No operand predicates
     /*  73879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73885 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73899 */     GIR_RootConstrainSelectedInstOperands,
     /*  73900 */     // GIR_Coverage, 2292,
     /*  73900 */     GIR_EraseRootFromParent_Done,
     /*  73901 */   // Label 1191: @73901
     /*  73901 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73965), // Rule ID 13456 //
     /*  73906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73938 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  73946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73952 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  73955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73963 */     GIR_RootConstrainSelectedInstOperands,
     /*  73964 */     // GIR_Coverage, 13456,
     /*  73964 */     GIR_EraseRootFromParent_Done,
     /*  73965 */   // Label 1192: @73965
     /*  73965 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74029), // Rule ID 1602 //
     /*  73970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74006 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74016 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  74019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  74027 */     GIR_RootConstrainSelectedInstOperands,
     /*  74028 */     // GIR_Coverage, 1602,
     /*  74028 */     GIR_EraseRootFromParent_Done,
     /*  74029 */   // Label 1193: @74029
     /*  74029 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74056), // Rule ID 1604 //
     /*  74034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74049 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  74054 */     GIR_RootConstrainSelectedInstOperands,
     /*  74055 */     // GIR_Coverage, 1604,
     /*  74055 */     GIR_Done,
     /*  74056 */   // Label 1194: @74056
     /*  74056 */   GIM_Reject,
     /*  74057 */ // Label 1179: @74057
     /*  74057 */ GIM_Reject,
     /*  74058 */ // Label 1038: @74058
     /*  74058 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74089), // Rule ID 8517 //
     /*  74063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  74069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  74072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74076 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  74076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74081 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74085 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74087 */   GIR_RootConstrainSelectedInstOperands,
     /*  74088 */   // GIR_Coverage, 8517,
     /*  74088 */   GIR_EraseRootFromParent_Done,
     /*  74089 */ // Label 1195: @74089
     /*  74089 */ GIM_Reject,
     /*  74090 */ // Label 1039: @74090
     /*  74090 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74121), // Rule ID 8516 //
     /*  74095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  74101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  74104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74108 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  74108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74113 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74115 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74117 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74119 */   GIR_RootConstrainSelectedInstOperands,
     /*  74120 */   // GIR_Coverage, 8516,
     /*  74120 */   GIR_EraseRootFromParent_Done,
     /*  74121 */ // Label 1196: @74121
     /*  74121 */ GIM_Reject,
     /*  74122 */ // Label 1040: @74122
     /*  74122 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(77481),
     /*  74127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74137 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74255), // Rule ID 15821 //
     /*  74142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74181 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74205 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74209 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74217 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74221 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74225 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74229 */     // MIs[6] Op3
     /*  74229 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74234 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74236 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74253 */     GIR_RootConstrainSelectedInstOperands,
     /*  74254 */     // GIR_Coverage, 15821,
     /*  74254 */     GIR_EraseRootFromParent_Done,
     /*  74255 */   // Label 1198: @74255
     /*  74255 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74373), // Rule ID 15823 //
     /*  74260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74299 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74307 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74311 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74315 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74319 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74323 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74327 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74333 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74335 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74339 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74343 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74347 */     // MIs[6] Op3
     /*  74347 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74352 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74354 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74371 */     GIR_RootConstrainSelectedInstOperands,
     /*  74372 */     // GIR_Coverage, 15823,
     /*  74372 */     GIR_EraseRootFromParent_Done,
     /*  74373 */   // Label 1199: @74373
     /*  74373 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74491), // Rule ID 15820 //
     /*  74378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74417 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74423 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74425 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74429 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74433 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74437 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74441 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74445 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74451 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74453 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74457 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74461 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74465 */     // MIs[6] Op3
     /*  74465 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74470 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74472 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74489 */     GIR_RootConstrainSelectedInstOperands,
     /*  74490 */     // GIR_Coverage, 15820,
     /*  74490 */     GIR_EraseRootFromParent_Done,
     /*  74491 */   // Label 1200: @74491
     /*  74491 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74609), // Rule ID 15822 //
     /*  74496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74535 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74541 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74551 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74555 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74559 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74563 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74569 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74571 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74575 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74579 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74583 */     // MIs[6] Op3
     /*  74583 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74588 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74590 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74607 */     GIR_RootConstrainSelectedInstOperands,
     /*  74608 */     // GIR_Coverage, 15822,
     /*  74608 */     GIR_EraseRootFromParent_Done,
     /*  74609 */   // Label 1201: @74609
     /*  74609 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74727), // Rule ID 15768 //
     /*  74614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74653 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74661 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74665 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74669 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74673 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74677 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74681 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74685 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74689 */     // MIs[5] Op3
     /*  74689 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74694 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74698 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74706 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74708 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  74721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74725 */     GIR_RootConstrainSelectedInstOperands,
     /*  74726 */     // GIR_Coverage, 15768,
     /*  74726 */     GIR_EraseRootFromParent_Done,
     /*  74727 */   // Label 1202: @74727
     /*  74727 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74845), // Rule ID 15773 //
     /*  74732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74771 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74787 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74791 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74795 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74799 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74803 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74807 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74811 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74819 */     // MIs[4] Op3
     /*  74819 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74824 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74826 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74843 */     GIR_RootConstrainSelectedInstOperands,
     /*  74844 */     // GIR_Coverage, 15773,
     /*  74844 */     GIR_EraseRootFromParent_Done,
     /*  74845 */   // Label 1203: @74845
     /*  74845 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74963), // Rule ID 15774 //
     /*  74850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74889 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74895 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74901 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74905 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74909 */     // MIs[4] Op3
     /*  74909 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74922 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74926 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74930 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74934 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74940 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74942 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74944 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74961 */     GIR_RootConstrainSelectedInstOperands,
     /*  74962 */     // GIR_Coverage, 15774,
     /*  74962 */     GIR_EraseRootFromParent_Done,
     /*  74963 */   // Label 1204: @74963
     /*  74963 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75081), // Rule ID 11965 //
     /*  74968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75015 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75019 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75023 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75027 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75031 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75035 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75039 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75043 */     // MIs[5] Op3
     /*  75043 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75048 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75052 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75058 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75060 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75062 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75079 */     GIR_RootConstrainSelectedInstOperands,
     /*  75080 */     // GIR_Coverage, 11965,
     /*  75080 */     GIR_EraseRootFromParent_Done,
     /*  75081 */   // Label 1205: @75081
     /*  75081 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75199), // Rule ID 15770 //
     /*  75086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75125 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75131 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75133 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75137 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75141 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75145 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75149 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75153 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75157 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75161 */     // MIs[5] Op3
     /*  75161 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75166 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75170 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75178 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75180 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  75193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75197 */     GIR_RootConstrainSelectedInstOperands,
     /*  75198 */     // GIR_Coverage, 15770,
     /*  75198 */     GIR_EraseRootFromParent_Done,
     /*  75199 */   // Label 1206: @75199
     /*  75199 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75317), // Rule ID 15771 //
     /*  75204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75243 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75249 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75251 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75255 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75259 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75263 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75267 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75271 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75275 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75283 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75291 */     // MIs[4] Op3
     /*  75291 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75296 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75298 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75315 */     GIR_RootConstrainSelectedInstOperands,
     /*  75316 */     // GIR_Coverage, 15771,
     /*  75316 */     GIR_EraseRootFromParent_Done,
     /*  75317 */   // Label 1207: @75317
     /*  75317 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75435), // Rule ID 15772 //
     /*  75322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75361 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75369 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75373 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75377 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75381 */     // MIs[4] Op3
     /*  75381 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75386 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75390 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75394 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75398 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75402 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75406 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75414 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75416 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75433 */     GIR_RootConstrainSelectedInstOperands,
     /*  75434 */     // GIR_Coverage, 15772,
     /*  75434 */     GIR_EraseRootFromParent_Done,
     /*  75435 */   // Label 1208: @75435
     /*  75435 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75553), // Rule ID 15769 //
     /*  75440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75479 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75485 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75487 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75491 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75495 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75499 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75507 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75511 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75515 */     // MIs[5] Op3
     /*  75515 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75520 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75524 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75532 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75534 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75551 */     GIR_RootConstrainSelectedInstOperands,
     /*  75552 */     // GIR_Coverage, 15769,
     /*  75552 */     GIR_EraseRootFromParent_Done,
     /*  75553 */   // Label 1209: @75553
     /*  75553 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75671), // Rule ID 15817 //
     /*  75558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75601 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75605 */     // MIs[3] Op3
     /*  75605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75610 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75614 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75622 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75626 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75630 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75634 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75638 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75642 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75648 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75650 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75652 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75669 */     GIR_RootConstrainSelectedInstOperands,
     /*  75670 */     // GIR_Coverage, 15817,
     /*  75670 */     GIR_EraseRootFromParent_Done,
     /*  75671 */   // Label 1210: @75671
     /*  75671 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75789), // Rule ID 15819 //
     /*  75676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75723 */     // MIs[3] Op3
     /*  75723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75740 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75744 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75748 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75752 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75756 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75760 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75770 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75787 */     GIR_RootConstrainSelectedInstOperands,
     /*  75788 */     // GIR_Coverage, 15819,
     /*  75788 */     GIR_EraseRootFromParent_Done,
     /*  75789 */   // Label 1211: @75789
     /*  75789 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75907), // Rule ID 11976 //
     /*  75794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75849 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75861 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75865 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75869 */     // MIs[5] Op3
     /*  75869 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75874 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75878 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75886 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75888 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75905 */     GIR_RootConstrainSelectedInstOperands,
     /*  75906 */     // GIR_Coverage, 11976,
     /*  75906 */     GIR_EraseRootFromParent_Done,
     /*  75907 */   // Label 1212: @75907
     /*  75907 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(76025), // Rule ID 15818 //
     /*  75912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75963 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75967 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75973 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75975 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75979 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75983 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75987 */     // MIs[5] Op3
     /*  75987 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75992 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75996 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76002 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76004 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76006 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  76019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76023 */     GIR_RootConstrainSelectedInstOperands,
     /*  76024 */     // GIR_Coverage, 15818,
     /*  76024 */     GIR_EraseRootFromParent_Done,
     /*  76025 */   // Label 1213: @76025
     /*  76025 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(76115), // Rule ID 15746 //
     /*  76030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76069 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76077 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76081 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76085 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76089 */     // MIs[4] Op3
     /*  76089 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76096 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76113 */     GIR_RootConstrainSelectedInstOperands,
     /*  76114 */     // GIR_Coverage, 15746,
     /*  76114 */     GIR_EraseRootFromParent_Done,
     /*  76115 */   // Label 1214: @76115
     /*  76115 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76205), // Rule ID 15745 //
     /*  76120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76159 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76167 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76171 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76175 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76179 */     // MIs[4] Op3
     /*  76179 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76186 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76203 */     GIR_RootConstrainSelectedInstOperands,
     /*  76204 */     // GIR_Coverage, 15745,
     /*  76204 */     GIR_EraseRootFromParent_Done,
     /*  76205 */   // Label 1215: @76205
     /*  76205 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76295), // Rule ID 15744 //
     /*  76210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76265 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76269 */     // MIs[4] Op3
     /*  76269 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76274 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76276 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76293 */     GIR_RootConstrainSelectedInstOperands,
     /*  76294 */     // GIR_Coverage, 15744,
     /*  76294 */     GIR_EraseRootFromParent_Done,
     /*  76295 */   // Label 1216: @76295
     /*  76295 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(76385), // Rule ID 15743 //
     /*  76300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76339 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76359 */     // MIs[4] Op3
     /*  76359 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76366 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76383 */     GIR_RootConstrainSelectedInstOperands,
     /*  76384 */     // GIR_Coverage, 15743,
     /*  76384 */     GIR_EraseRootFromParent_Done,
     /*  76385 */   // Label 1217: @76385
     /*  76385 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76475), // Rule ID 15740 //
     /*  76390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76433 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76437 */     // MIs[3] Op3
     /*  76437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76446 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76452 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76454 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76456 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76473 */     GIR_RootConstrainSelectedInstOperands,
     /*  76474 */     // GIR_Coverage, 15740,
     /*  76474 */     GIR_EraseRootFromParent_Done,
     /*  76475 */   // Label 1218: @76475
     /*  76475 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76565), // Rule ID 15742 //
     /*  76480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76527 */     // MIs[3] Op3
     /*  76527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76536 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76542 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76544 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76546 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76563 */     GIR_RootConstrainSelectedInstOperands,
     /*  76564 */     // GIR_Coverage, 15742,
     /*  76564 */     GIR_EraseRootFromParent_Done,
     /*  76565 */   // Label 1219: @76565
     /*  76565 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76655), // Rule ID 11957 //
     /*  76570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76613 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76617 */     // MIs[3] Op3
     /*  76617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76622 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76626 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76636 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76653 */     GIR_RootConstrainSelectedInstOperands,
     /*  76654 */     // GIR_Coverage, 11957,
     /*  76654 */     GIR_EraseRootFromParent_Done,
     /*  76655 */   // Label 1220: @76655
     /*  76655 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76745), // Rule ID 15741 //
     /*  76660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76707 */     // MIs[3] Op3
     /*  76707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76716 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76724 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76726 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76743 */     GIR_RootConstrainSelectedInstOperands,
     /*  76744 */     // GIR_Coverage, 15741,
     /*  76744 */     GIR_EraseRootFromParent_Done,
     /*  76745 */   // Label 1221: @76745
     /*  76745 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76835), // Rule ID 15824 //
     /*  76750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76793 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76797 */     // MIs[3] Op3
     /*  76797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76806 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76814 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76816 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76833 */     GIR_RootConstrainSelectedInstOperands,
     /*  76834 */     // GIR_Coverage, 15824,
     /*  76834 */     GIR_EraseRootFromParent_Done,
     /*  76835 */   // Label 1222: @76835
     /*  76835 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76925), // Rule ID 15826 //
     /*  76840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76883 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76887 */     // MIs[3] Op3
     /*  76887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76896 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76904 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76906 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76923 */     GIR_RootConstrainSelectedInstOperands,
     /*  76924 */     // GIR_Coverage, 15826,
     /*  76924 */     GIR_EraseRootFromParent_Done,
     /*  76925 */   // Label 1223: @76925
     /*  76925 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(77015), // Rule ID 11977 //
     /*  76930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76977 */     // MIs[3] Op3
     /*  76977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76982 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76986 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76994 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76996 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77013 */     GIR_RootConstrainSelectedInstOperands,
     /*  77014 */     // GIR_Coverage, 11977,
     /*  77014 */     GIR_EraseRootFromParent_Done,
     /*  77015 */   // Label 1224: @77015
     /*  77015 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(77105), // Rule ID 15825 //
     /*  77020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77067 */     // MIs[3] Op3
     /*  77067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  77076 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77084 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77086 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77103 */     GIR_RootConstrainSelectedInstOperands,
     /*  77104 */     // GIR_Coverage, 15825,
     /*  77104 */     GIR_EraseRootFromParent_Done,
     /*  77105 */   // Label 1225: @77105
     /*  77105 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77195), // Rule ID 15828 //
     /*  77110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77149 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77157 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77161 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77165 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77169 */     // MIs[4] Op3
     /*  77169 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77174 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77176 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77193 */     GIR_RootConstrainSelectedInstOperands,
     /*  77194 */     // GIR_Coverage, 15828,
     /*  77194 */     GIR_EraseRootFromParent_Done,
     /*  77195 */   // Label 1226: @77195
     /*  77195 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77285), // Rule ID 15830 //
     /*  77200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77239 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77251 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77255 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77259 */     // MIs[4] Op3
     /*  77259 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77266 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77283 */     GIR_RootConstrainSelectedInstOperands,
     /*  77284 */     // GIR_Coverage, 15830,
     /*  77284 */     GIR_EraseRootFromParent_Done,
     /*  77285 */   // Label 1227: @77285
     /*  77285 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77375), // Rule ID 15827 //
     /*  77290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77345 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77349 */     // MIs[4] Op3
     /*  77349 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77354 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77356 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77373 */     GIR_RootConstrainSelectedInstOperands,
     /*  77374 */     // GIR_Coverage, 15827,
     /*  77374 */     GIR_EraseRootFromParent_Done,
     /*  77375 */   // Label 1228: @77375
     /*  77375 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77465), // Rule ID 15829 //
     /*  77380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77419 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77435 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77439 */     // MIs[4] Op3
     /*  77439 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77444 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77446 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77463 */     GIR_RootConstrainSelectedInstOperands,
     /*  77464 */     // GIR_Coverage, 15829,
     /*  77464 */     GIR_EraseRootFromParent_Done,
     /*  77465 */   // Label 1229: @77465
     /*  77465 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77480), // Rule ID 7522 //
     /*  77470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77473 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  77478 */     GIR_RootConstrainSelectedInstOperands,
     /*  77479 */     // GIR_Coverage, 7522,
     /*  77479 */     GIR_Done,
     /*  77480 */   // Label 1230: @77480
     /*  77480 */   GIM_Reject,
     /*  77481 */ // Label 1197: @77481
     /*  77481 */ GIM_Reject,
     /*  77482 */ // Label 1041: @77482
     /*  77482 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77513), // Rule ID 8515 //
     /*  77487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77500 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  77503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77505 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77507 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77509 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77511 */   GIR_RootConstrainSelectedInstOperands,
     /*  77512 */   // GIR_Coverage, 8515,
     /*  77512 */   GIR_EraseRootFromParent_Done,
     /*  77513 */ // Label 1231: @77513
     /*  77513 */ GIM_Reject,
     /*  77514 */ // Label 1042: @77514
     /*  77514 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(80873),
     /*  77519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77529 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(77647), // Rule ID 15807 //
     /*  77534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77573 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77579 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77581 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77585 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77589 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77593 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77597 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77601 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77607 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77609 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77613 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77617 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77621 */     // MIs[6] Op3
     /*  77621 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77626 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77628 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77645 */     GIR_RootConstrainSelectedInstOperands,
     /*  77646 */     // GIR_Coverage, 15807,
     /*  77646 */     GIR_EraseRootFromParent_Done,
     /*  77647 */   // Label 1233: @77647
     /*  77647 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(77765), // Rule ID 15809 //
     /*  77652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77699 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77703 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77707 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77711 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77715 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77719 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77725 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77727 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77731 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77735 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77739 */     // MIs[6] Op3
     /*  77739 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77744 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77746 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77763 */     GIR_RootConstrainSelectedInstOperands,
     /*  77764 */     // GIR_Coverage, 15809,
     /*  77764 */     GIR_EraseRootFromParent_Done,
     /*  77765 */   // Label 1234: @77765
     /*  77765 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(77883), // Rule ID 15806 //
     /*  77770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77809 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77817 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77821 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77825 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77829 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77833 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77837 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77849 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77853 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77857 */     // MIs[6] Op3
     /*  77857 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77862 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77864 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  77873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77881 */     GIR_RootConstrainSelectedInstOperands,
     /*  77882 */     // GIR_Coverage, 15806,
     /*  77882 */     GIR_EraseRootFromParent_Done,
     /*  77883 */   // Label 1235: @77883
     /*  77883 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(78001), // Rule ID 15808 //
     /*  77888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77927 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77947 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77951 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77955 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77963 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77967 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77971 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77975 */     // MIs[6] Op3
     /*  77975 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77980 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77982 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  77991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77999 */     GIR_RootConstrainSelectedInstOperands,
     /*  78000 */     // GIR_Coverage, 15808,
     /*  78000 */     GIR_EraseRootFromParent_Done,
     /*  78001 */   // Label 1236: @78001
     /*  78001 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78119), // Rule ID 15761 //
     /*  78006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78045 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78051 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78053 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78057 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78061 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78065 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78069 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78073 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78077 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78081 */     // MIs[5] Op3
     /*  78081 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78086 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78090 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78098 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78100 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78117 */     GIR_RootConstrainSelectedInstOperands,
     /*  78118 */     // GIR_Coverage, 15761,
     /*  78118 */     GIR_EraseRootFromParent_Done,
     /*  78119 */   // Label 1237: @78119
     /*  78119 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78237), // Rule ID 15766 //
     /*  78124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78163 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78169 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78171 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78175 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78179 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78183 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78187 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78191 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78195 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78199 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78203 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78211 */     // MIs[4] Op3
     /*  78211 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78216 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78218 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78235 */     GIR_RootConstrainSelectedInstOperands,
     /*  78236 */     // GIR_Coverage, 15766,
     /*  78236 */     GIR_EraseRootFromParent_Done,
     /*  78237 */   // Label 1238: @78237
     /*  78237 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78355), // Rule ID 15767 //
     /*  78242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78281 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78289 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78293 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78297 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78301 */     // MIs[4] Op3
     /*  78301 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78306 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78310 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78314 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78318 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78322 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78326 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78334 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78336 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78353 */     GIR_RootConstrainSelectedInstOperands,
     /*  78354 */     // GIR_Coverage, 15767,
     /*  78354 */     GIR_EraseRootFromParent_Done,
     /*  78355 */   // Label 1239: @78355
     /*  78355 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78473), // Rule ID 11963 //
     /*  78360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78399 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78415 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78419 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78423 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78427 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78431 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78435 */     // MIs[5] Op3
     /*  78435 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78440 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78444 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78452 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78454 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78471 */     GIR_RootConstrainSelectedInstOperands,
     /*  78472 */     // GIR_Coverage, 11963,
     /*  78472 */     GIR_EraseRootFromParent_Done,
     /*  78473 */   // Label 1240: @78473
     /*  78473 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78591), // Rule ID 15763 //
     /*  78478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78517 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78523 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78525 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78529 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78533 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78537 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78541 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78545 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78549 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78553 */     // MIs[5] Op3
     /*  78553 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78558 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78562 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78570 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78572 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78589 */     GIR_RootConstrainSelectedInstOperands,
     /*  78590 */     // GIR_Coverage, 15763,
     /*  78590 */     GIR_EraseRootFromParent_Done,
     /*  78591 */   // Label 1241: @78591
     /*  78591 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78709), // Rule ID 15764 //
     /*  78596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78635 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78641 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78643 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78647 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78651 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78655 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78659 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78663 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78667 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78671 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78675 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78683 */     // MIs[4] Op3
     /*  78683 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78688 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78690 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78707 */     GIR_RootConstrainSelectedInstOperands,
     /*  78708 */     // GIR_Coverage, 15764,
     /*  78708 */     GIR_EraseRootFromParent_Done,
     /*  78709 */   // Label 1242: @78709
     /*  78709 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78827), // Rule ID 15765 //
     /*  78714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78753 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78773 */     // MIs[4] Op3
     /*  78773 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78778 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78782 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78786 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78790 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78794 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78798 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78806 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78808 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78825 */     GIR_RootConstrainSelectedInstOperands,
     /*  78826 */     // GIR_Coverage, 15765,
     /*  78826 */     GIR_EraseRootFromParent_Done,
     /*  78827 */   // Label 1243: @78827
     /*  78827 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78945), // Rule ID 15762 //
     /*  78832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78871 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78877 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78879 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78883 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78887 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78891 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78895 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78899 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78903 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78907 */     // MIs[5] Op3
     /*  78907 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78912 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78916 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78924 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78926 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78943 */     GIR_RootConstrainSelectedInstOperands,
     /*  78944 */     // GIR_Coverage, 15762,
     /*  78944 */     GIR_EraseRootFromParent_Done,
     /*  78945 */   // Label 1244: @78945
     /*  78945 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(79063), // Rule ID 15803 //
     /*  78950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78993 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78997 */     // MIs[3] Op3
     /*  78997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79006 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79014 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79018 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79022 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79026 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79030 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79034 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79042 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79044 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79061 */     GIR_RootConstrainSelectedInstOperands,
     /*  79062 */     // GIR_Coverage, 15803,
     /*  79062 */     GIR_EraseRootFromParent_Done,
     /*  79063 */   // Label 1245: @79063
     /*  79063 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79181), // Rule ID 15805 //
     /*  79068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79115 */     // MIs[3] Op3
     /*  79115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79132 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79136 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79140 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79144 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79148 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79152 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79158 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79160 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79162 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79179 */     GIR_RootConstrainSelectedInstOperands,
     /*  79180 */     // GIR_Coverage, 15805,
     /*  79180 */     GIR_EraseRootFromParent_Done,
     /*  79181 */   // Label 1246: @79181
     /*  79181 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79299), // Rule ID 11973 //
     /*  79186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79229 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79241 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79249 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79253 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79257 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79261 */     // MIs[5] Op3
     /*  79261 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79266 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79270 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79276 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79278 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79280 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79297 */     GIR_RootConstrainSelectedInstOperands,
     /*  79298 */     // GIR_Coverage, 11973,
     /*  79298 */     GIR_EraseRootFromParent_Done,
     /*  79299 */   // Label 1247: @79299
     /*  79299 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79417), // Rule ID 15804 //
     /*  79304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79347 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79355 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79359 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79365 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79367 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79371 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79375 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79379 */     // MIs[5] Op3
     /*  79379 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79384 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79388 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79396 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79398 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79415 */     GIR_RootConstrainSelectedInstOperands,
     /*  79416 */     // GIR_Coverage, 15804,
     /*  79416 */     GIR_EraseRootFromParent_Done,
     /*  79417 */   // Label 1248: @79417
     /*  79417 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79507), // Rule ID 15739 //
     /*  79422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79461 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79469 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79473 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79477 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79481 */     // MIs[4] Op3
     /*  79481 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79488 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79505 */     GIR_RootConstrainSelectedInstOperands,
     /*  79506 */     // GIR_Coverage, 15739,
     /*  79506 */     GIR_EraseRootFromParent_Done,
     /*  79507 */   // Label 1249: @79507
     /*  79507 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79597), // Rule ID 15738 //
     /*  79512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79559 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79563 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79567 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79571 */     // MIs[4] Op3
     /*  79571 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79578 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79595 */     GIR_RootConstrainSelectedInstOperands,
     /*  79596 */     // GIR_Coverage, 15738,
     /*  79596 */     GIR_EraseRootFromParent_Done,
     /*  79597 */   // Label 1250: @79597
     /*  79597 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79687), // Rule ID 15737 //
     /*  79602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79641 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79649 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79653 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79657 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79661 */     // MIs[4] Op3
     /*  79661 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79666 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79668 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79685 */     GIR_RootConstrainSelectedInstOperands,
     /*  79686 */     // GIR_Coverage, 15737,
     /*  79686 */     GIR_EraseRootFromParent_Done,
     /*  79687 */   // Label 1251: @79687
     /*  79687 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(79777), // Rule ID 15736 //
     /*  79692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79731 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79739 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79743 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79747 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79751 */     // MIs[4] Op3
     /*  79751 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79756 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79758 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79775 */     GIR_RootConstrainSelectedInstOperands,
     /*  79776 */     // GIR_Coverage, 15736,
     /*  79776 */     GIR_EraseRootFromParent_Done,
     /*  79777 */   // Label 1252: @79777
     /*  79777 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79867), // Rule ID 15733 //
     /*  79782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79825 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79829 */     // MIs[3] Op3
     /*  79829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79838 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79848 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79865 */     GIR_RootConstrainSelectedInstOperands,
     /*  79866 */     // GIR_Coverage, 15733,
     /*  79866 */     GIR_EraseRootFromParent_Done,
     /*  79867 */   // Label 1253: @79867
     /*  79867 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79957), // Rule ID 15735 //
     /*  79872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79919 */     // MIs[3] Op3
     /*  79919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79928 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79934 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79936 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79938 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79955 */     GIR_RootConstrainSelectedInstOperands,
     /*  79956 */     // GIR_Coverage, 15735,
     /*  79956 */     GIR_EraseRootFromParent_Done,
     /*  79957 */   // Label 1254: @79957
     /*  79957 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(80047), // Rule ID 11955 //
     /*  79962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80009 */     // MIs[3] Op3
     /*  80009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80026 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80028 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80045 */     GIR_RootConstrainSelectedInstOperands,
     /*  80046 */     // GIR_Coverage, 11955,
     /*  80046 */     GIR_EraseRootFromParent_Done,
     /*  80047 */   // Label 1255: @80047
     /*  80047 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(80137), // Rule ID 15734 //
     /*  80052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80095 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80099 */     // MIs[3] Op3
     /*  80099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80108 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80114 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80116 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80118 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80135 */     GIR_RootConstrainSelectedInstOperands,
     /*  80136 */     // GIR_Coverage, 15734,
     /*  80136 */     GIR_EraseRootFromParent_Done,
     /*  80137 */   // Label 1256: @80137
     /*  80137 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80227), // Rule ID 15810 //
     /*  80142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80185 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80189 */     // MIs[3] Op3
     /*  80189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80198 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80206 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80208 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80225 */     GIR_RootConstrainSelectedInstOperands,
     /*  80226 */     // GIR_Coverage, 15810,
     /*  80226 */     GIR_EraseRootFromParent_Done,
     /*  80227 */   // Label 1257: @80227
     /*  80227 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80317), // Rule ID 15812 //
     /*  80232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80275 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80279 */     // MIs[3] Op3
     /*  80279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80288 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80296 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80298 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80315 */     GIR_RootConstrainSelectedInstOperands,
     /*  80316 */     // GIR_Coverage, 15812,
     /*  80316 */     GIR_EraseRootFromParent_Done,
     /*  80317 */   // Label 1258: @80317
     /*  80317 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80407), // Rule ID 11974 //
     /*  80322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80365 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80369 */     // MIs[3] Op3
     /*  80369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80374 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80378 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80386 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80388 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80405 */     GIR_RootConstrainSelectedInstOperands,
     /*  80406 */     // GIR_Coverage, 11974,
     /*  80406 */     GIR_EraseRootFromParent_Done,
     /*  80407 */   // Label 1259: @80407
     /*  80407 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80497), // Rule ID 15811 //
     /*  80412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80459 */     // MIs[3] Op3
     /*  80459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80468 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80476 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80478 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80495 */     GIR_RootConstrainSelectedInstOperands,
     /*  80496 */     // GIR_Coverage, 15811,
     /*  80496 */     GIR_EraseRootFromParent_Done,
     /*  80497 */   // Label 1260: @80497
     /*  80497 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80587), // Rule ID 15814 //
     /*  80502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80541 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80549 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80553 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80557 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80561 */     // MIs[4] Op3
     /*  80561 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80566 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80568 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80585 */     GIR_RootConstrainSelectedInstOperands,
     /*  80586 */     // GIR_Coverage, 15814,
     /*  80586 */     GIR_EraseRootFromParent_Done,
     /*  80587 */   // Label 1261: @80587
     /*  80587 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80677), // Rule ID 15816 //
     /*  80592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80631 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80647 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80651 */     // MIs[4] Op3
     /*  80651 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80656 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80658 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80675 */     GIR_RootConstrainSelectedInstOperands,
     /*  80676 */     // GIR_Coverage, 15816,
     /*  80676 */     GIR_EraseRootFromParent_Done,
     /*  80677 */   // Label 1262: @80677
     /*  80677 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80767), // Rule ID 15813 //
     /*  80682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80721 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80737 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80741 */     // MIs[4] Op3
     /*  80741 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80746 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80748 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80765 */     GIR_RootConstrainSelectedInstOperands,
     /*  80766 */     // GIR_Coverage, 15813,
     /*  80766 */     GIR_EraseRootFromParent_Done,
     /*  80767 */   // Label 1263: @80767
     /*  80767 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80857), // Rule ID 15815 //
     /*  80772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80811 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80831 */     // MIs[4] Op3
     /*  80831 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80836 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80838 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80855 */     GIR_RootConstrainSelectedInstOperands,
     /*  80856 */     // GIR_Coverage, 15815,
     /*  80856 */     GIR_EraseRootFromParent_Done,
     /*  80857 */   // Label 1264: @80857
     /*  80857 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80872), // Rule ID 7521 //
     /*  80862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80865 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  80865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  80870 */     GIR_RootConstrainSelectedInstOperands,
     /*  80871 */     // GIR_Coverage, 7521,
     /*  80871 */     GIR_Done,
     /*  80872 */   // Label 1265: @80872
     /*  80872 */   GIM_Reject,
     /*  80873 */ // Label 1232: @80873
     /*  80873 */ GIM_Reject,
     /*  80874 */ // Label 1043: @80874
     /*  80874 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(80905), // Rule ID 8514 //
     /*  80879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  80885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  80888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  80892 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  80892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  80895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  80897 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80899 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80901 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  80903 */   GIR_RootConstrainSelectedInstOperands,
     /*  80904 */   // GIR_Coverage, 8514,
     /*  80904 */   GIR_EraseRootFromParent_Done,
     /*  80905 */ // Label 1266: @80905
     /*  80905 */ GIM_Reject,
     /*  80906 */ // Label 1044: @80906
     /*  80906 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(84265),
     /*  80911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  80921 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(81039), // Rule ID 15793 //
     /*  80926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80965 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  80977 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80981 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80985 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80989 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80993 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81001 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81005 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81009 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81013 */     // MIs[6] Op3
     /*  81013 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81018 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81020 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81037 */     GIR_RootConstrainSelectedInstOperands,
     /*  81038 */     // GIR_Coverage, 15793,
     /*  81038 */     GIR_EraseRootFromParent_Done,
     /*  81039 */   // Label 1268: @81039
     /*  81039 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81157), // Rule ID 15795 //
     /*  81044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81083 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81091 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81095 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81099 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81103 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81107 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81111 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81117 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81119 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81123 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81127 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81131 */     // MIs[6] Op3
     /*  81131 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81136 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81138 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81155 */     GIR_RootConstrainSelectedInstOperands,
     /*  81156 */     // GIR_Coverage, 15795,
     /*  81156 */     GIR_EraseRootFromParent_Done,
     /*  81157 */   // Label 1269: @81157
     /*  81157 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81275), // Rule ID 15792 //
     /*  81162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81201 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81207 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81209 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81213 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81217 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81225 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81229 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81235 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81237 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81241 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81245 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81249 */     // MIs[6] Op3
     /*  81249 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81254 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81256 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81273 */     GIR_RootConstrainSelectedInstOperands,
     /*  81274 */     // GIR_Coverage, 15792,
     /*  81274 */     GIR_EraseRootFromParent_Done,
     /*  81275 */   // Label 1270: @81275
     /*  81275 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81393), // Rule ID 15794 //
     /*  81280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81319 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81325 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81327 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81331 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81335 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81339 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81343 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81347 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81355 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81359 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81363 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81367 */     // MIs[6] Op3
     /*  81367 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81372 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81374 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81391 */     GIR_RootConstrainSelectedInstOperands,
     /*  81392 */     // GIR_Coverage, 15794,
     /*  81392 */     GIR_EraseRootFromParent_Done,
     /*  81393 */   // Label 1271: @81393
     /*  81393 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81511), // Rule ID 15754 //
     /*  81398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81445 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81449 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81453 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81457 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81461 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81465 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81469 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81473 */     // MIs[5] Op3
     /*  81473 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81478 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81482 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81490 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81492 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81509 */     GIR_RootConstrainSelectedInstOperands,
     /*  81510 */     // GIR_Coverage, 15754,
     /*  81510 */     GIR_EraseRootFromParent_Done,
     /*  81511 */   // Label 1272: @81511
     /*  81511 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81629), // Rule ID 15759 //
     /*  81516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81555 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81561 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81563 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81567 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81571 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81575 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81579 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81583 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81587 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81591 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81595 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81603 */     // MIs[4] Op3
     /*  81603 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81608 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81610 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81627 */     GIR_RootConstrainSelectedInstOperands,
     /*  81628 */     // GIR_Coverage, 15759,
     /*  81628 */     GIR_EraseRootFromParent_Done,
     /*  81629 */   // Label 1273: @81629
     /*  81629 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81747), // Rule ID 15760 //
     /*  81634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81673 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81681 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81685 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81689 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81693 */     // MIs[4] Op3
     /*  81693 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81698 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81702 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81706 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81710 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81714 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81718 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81726 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81728 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81745 */     GIR_RootConstrainSelectedInstOperands,
     /*  81746 */     // GIR_Coverage, 15760,
     /*  81746 */     GIR_EraseRootFromParent_Done,
     /*  81747 */   // Label 1274: @81747
     /*  81747 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81865), // Rule ID 11961 //
     /*  81752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81791 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81803 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81807 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81811 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81815 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81819 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81823 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81827 */     // MIs[5] Op3
     /*  81827 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81832 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81836 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81844 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81846 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81863 */     GIR_RootConstrainSelectedInstOperands,
     /*  81864 */     // GIR_Coverage, 11961,
     /*  81864 */     GIR_EraseRootFromParent_Done,
     /*  81865 */   // Label 1275: @81865
     /*  81865 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(81983), // Rule ID 15756 //
     /*  81870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81909 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81915 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81925 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81929 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81933 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81937 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81941 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81945 */     // MIs[5] Op3
     /*  81945 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81950 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81954 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81962 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81964 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81981 */     GIR_RootConstrainSelectedInstOperands,
     /*  81982 */     // GIR_Coverage, 15756,
     /*  81982 */     GIR_EraseRootFromParent_Done,
     /*  81983 */   // Label 1276: @81983
     /*  81983 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(82101), // Rule ID 15757 //
     /*  81988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82027 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82033 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82035 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82039 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82043 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82047 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  82051 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82055 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82059 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82063 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82067 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82075 */     // MIs[4] Op3
     /*  82075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82080 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82082 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82099 */     GIR_RootConstrainSelectedInstOperands,
     /*  82100 */     // GIR_Coverage, 15757,
     /*  82100 */     GIR_EraseRootFromParent_Done,
     /*  82101 */   // Label 1277: @82101
     /*  82101 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82219), // Rule ID 15758 //
     /*  82106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82145 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82151 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82153 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82157 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82161 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82165 */     // MIs[4] Op3
     /*  82165 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82170 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82174 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82178 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82182 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82186 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82190 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82196 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82198 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82200 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82217 */     GIR_RootConstrainSelectedInstOperands,
     /*  82218 */     // GIR_Coverage, 15758,
     /*  82218 */     GIR_EraseRootFromParent_Done,
     /*  82219 */   // Label 1278: @82219
     /*  82219 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82337), // Rule ID 15755 //
     /*  82224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82263 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82271 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82275 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82279 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82283 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82287 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82291 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82295 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82299 */     // MIs[5] Op3
     /*  82299 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82304 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82308 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82314 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82316 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82318 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  82327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  82331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82335 */     GIR_RootConstrainSelectedInstOperands,
     /*  82336 */     // GIR_Coverage, 15755,
     /*  82336 */     GIR_EraseRootFromParent_Done,
     /*  82337 */   // Label 1279: @82337
     /*  82337 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82455), // Rule ID 15789 //
     /*  82342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82385 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82389 */     // MIs[3] Op3
     /*  82389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82398 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82406 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82410 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82414 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82418 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82422 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82426 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82434 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82436 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82453 */     GIR_RootConstrainSelectedInstOperands,
     /*  82454 */     // GIR_Coverage, 15789,
     /*  82454 */     GIR_EraseRootFromParent_Done,
     /*  82455 */   // Label 1280: @82455
     /*  82455 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82573), // Rule ID 15791 //
     /*  82460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82507 */     // MIs[3] Op3
     /*  82507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82524 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82528 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82532 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82536 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82540 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82544 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82552 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82554 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82571 */     GIR_RootConstrainSelectedInstOperands,
     /*  82572 */     // GIR_Coverage, 15791,
     /*  82572 */     GIR_EraseRootFromParent_Done,
     /*  82573 */   // Label 1281: @82573
     /*  82573 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82691), // Rule ID 11970 //
     /*  82578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82633 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82641 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82645 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82649 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82653 */     // MIs[5] Op3
     /*  82653 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82658 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82662 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82670 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82672 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82689 */     GIR_RootConstrainSelectedInstOperands,
     /*  82690 */     // GIR_Coverage, 11970,
     /*  82690 */     GIR_EraseRootFromParent_Done,
     /*  82691 */   // Label 1282: @82691
     /*  82691 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82809), // Rule ID 15790 //
     /*  82696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82739 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82751 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82757 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82759 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82763 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82767 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82771 */     // MIs[5] Op3
     /*  82771 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82776 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82780 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82786 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82788 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82790 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82807 */     GIR_RootConstrainSelectedInstOperands,
     /*  82808 */     // GIR_Coverage, 15790,
     /*  82808 */     GIR_EraseRootFromParent_Done,
     /*  82809 */   // Label 1283: @82809
     /*  82809 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82899), // Rule ID 15732 //
     /*  82814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82853 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82861 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82865 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82869 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82873 */     // MIs[4] Op3
     /*  82873 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82878 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82880 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82897 */     GIR_RootConstrainSelectedInstOperands,
     /*  82898 */     // GIR_Coverage, 15732,
     /*  82898 */     GIR_EraseRootFromParent_Done,
     /*  82899 */   // Label 1284: @82899
     /*  82899 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82989), // Rule ID 15731 //
     /*  82904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82943 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82955 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82959 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82963 */     // MIs[4] Op3
     /*  82963 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82968 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82970 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82987 */     GIR_RootConstrainSelectedInstOperands,
     /*  82988 */     // GIR_Coverage, 15731,
     /*  82988 */     GIR_EraseRootFromParent_Done,
     /*  82989 */   // Label 1285: @82989
     /*  82989 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(83079), // Rule ID 15730 //
     /*  82994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83033 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83041 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83045 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83049 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83053 */     // MIs[4] Op3
     /*  83053 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83060 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83077 */     GIR_RootConstrainSelectedInstOperands,
     /*  83078 */     // GIR_Coverage, 15730,
     /*  83078 */     GIR_EraseRootFromParent_Done,
     /*  83079 */   // Label 1286: @83079
     /*  83079 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(83169), // Rule ID 15729 //
     /*  83084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83123 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83139 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83143 */     // MIs[4] Op3
     /*  83143 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83148 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83150 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  83159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83167 */     GIR_RootConstrainSelectedInstOperands,
     /*  83168 */     // GIR_Coverage, 15729,
     /*  83168 */     GIR_EraseRootFromParent_Done,
     /*  83169 */   // Label 1287: @83169
     /*  83169 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(83259), // Rule ID 15726 //
     /*  83174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83217 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83221 */     // MIs[3] Op3
     /*  83221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83230 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83240 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83257 */     GIR_RootConstrainSelectedInstOperands,
     /*  83258 */     // GIR_Coverage, 15726,
     /*  83258 */     GIR_EraseRootFromParent_Done,
     /*  83259 */   // Label 1288: @83259
     /*  83259 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83349), // Rule ID 15728 //
     /*  83264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83307 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83311 */     // MIs[3] Op3
     /*  83311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83320 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83326 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83328 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83330 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83347 */     GIR_RootConstrainSelectedInstOperands,
     /*  83348 */     // GIR_Coverage, 15728,
     /*  83348 */     GIR_EraseRootFromParent_Done,
     /*  83349 */   // Label 1289: @83349
     /*  83349 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83439), // Rule ID 11953 //
     /*  83354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83397 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83401 */     // MIs[3] Op3
     /*  83401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83410 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83420 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83437 */     GIR_RootConstrainSelectedInstOperands,
     /*  83438 */     // GIR_Coverage, 11953,
     /*  83438 */     GIR_EraseRootFromParent_Done,
     /*  83439 */   // Label 1290: @83439
     /*  83439 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83529), // Rule ID 15727 //
     /*  83444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83491 */     // MIs[3] Op3
     /*  83491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83500 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83506 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83508 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83510 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83527 */     GIR_RootConstrainSelectedInstOperands,
     /*  83528 */     // GIR_Coverage, 15727,
     /*  83528 */     GIR_EraseRootFromParent_Done,
     /*  83529 */   // Label 1291: @83529
     /*  83529 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83619), // Rule ID 15796 //
     /*  83534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83577 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83581 */     // MIs[3] Op3
     /*  83581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83590 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83598 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83600 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83617 */     GIR_RootConstrainSelectedInstOperands,
     /*  83618 */     // GIR_Coverage, 15796,
     /*  83618 */     GIR_EraseRootFromParent_Done,
     /*  83619 */   // Label 1292: @83619
     /*  83619 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83709), // Rule ID 15798 //
     /*  83624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83671 */     // MIs[3] Op3
     /*  83671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83690 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83707 */     GIR_RootConstrainSelectedInstOperands,
     /*  83708 */     // GIR_Coverage, 15798,
     /*  83708 */     GIR_EraseRootFromParent_Done,
     /*  83709 */   // Label 1293: @83709
     /*  83709 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83799), // Rule ID 11971 //
     /*  83714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83761 */     // MIs[3] Op3
     /*  83761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83770 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83780 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83797 */     GIR_RootConstrainSelectedInstOperands,
     /*  83798 */     // GIR_Coverage, 11971,
     /*  83798 */     GIR_EraseRootFromParent_Done,
     /*  83799 */   // Label 1294: @83799
     /*  83799 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83889), // Rule ID 15797 //
     /*  83804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83847 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83851 */     // MIs[3] Op3
     /*  83851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83860 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83870 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83887 */     GIR_RootConstrainSelectedInstOperands,
     /*  83888 */     // GIR_Coverage, 15797,
     /*  83888 */     GIR_EraseRootFromParent_Done,
     /*  83889 */   // Label 1295: @83889
     /*  83889 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83979), // Rule ID 15800 //
     /*  83894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  83933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83941 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83945 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83949 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83953 */     // MIs[4] Op3
     /*  83953 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  83958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83960 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  83977 */     GIR_RootConstrainSelectedInstOperands,
     /*  83978 */     // GIR_Coverage, 15800,
     /*  83978 */     GIR_EraseRootFromParent_Done,
     /*  83979 */   // Label 1296: @83979
     /*  83979 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(84069), // Rule ID 15802 //
     /*  83984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84023 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84039 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84043 */     // MIs[4] Op3
     /*  84043 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84048 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84050 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84067 */     GIR_RootConstrainSelectedInstOperands,
     /*  84068 */     // GIR_Coverage, 15802,
     /*  84068 */     GIR_EraseRootFromParent_Done,
     /*  84069 */   // Label 1297: @84069
     /*  84069 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84159), // Rule ID 15799 //
     /*  84074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84133 */     // MIs[4] Op3
     /*  84133 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  84138 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84140 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  84157 */     GIR_RootConstrainSelectedInstOperands,
     /*  84158 */     // GIR_Coverage, 15799,
     /*  84158 */     GIR_EraseRootFromParent_Done,
     /*  84159 */   // Label 1298: @84159
     /*  84159 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84249), // Rule ID 15801 //
     /*  84164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84203 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84223 */     // MIs[4] Op3
     /*  84223 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84230 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 15801,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1299: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84264), // Rule ID 7520 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84257 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  84257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  84262 */     GIR_RootConstrainSelectedInstOperands,
     /*  84263 */     // GIR_Coverage, 7520,
     /*  84263 */     GIR_Done,
     /*  84264 */   // Label 1300: @84264
     /*  84264 */   GIM_Reject,
     /*  84265 */ // Label 1267: @84265
     /*  84265 */ GIM_Reject,
     /*  84266 */ // Label 1045: @84266
     /*  84266 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84297), // Rule ID 8513 //
     /*  84271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  84277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  84280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  84284 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  84284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  84287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  84289 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84291 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84293 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  84295 */   GIR_RootConstrainSelectedInstOperands,
     /*  84296 */   // GIR_Coverage, 8513,
     /*  84296 */   GIR_EraseRootFromParent_Done,
     /*  84297 */ // Label 1301: @84297
     /*  84297 */ GIM_Reject,
     /*  84298 */ // Label 1046: @84298
     /*  84298 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(87657),
     /*  84303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  84313 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(84431), // Rule ID 15779 //
     /*  84318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84357 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84369 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84373 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84377 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84381 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84385 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84393 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84397 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84401 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84405 */     // MIs[6] Op3
     /*  84405 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84410 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84412 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84429 */     GIR_RootConstrainSelectedInstOperands,
     /*  84430 */     // GIR_Coverage, 15779,
     /*  84430 */     GIR_EraseRootFromParent_Done,
     /*  84431 */   // Label 1303: @84431
     /*  84431 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84549), // Rule ID 15781 //
     /*  84436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84487 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84491 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84495 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84499 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84503 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84511 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84515 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84519 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84523 */     // MIs[6] Op3
     /*  84523 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84528 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84530 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84547 */     GIR_RootConstrainSelectedInstOperands,
     /*  84548 */     // GIR_Coverage, 15781,
     /*  84548 */     GIR_EraseRootFromParent_Done,
     /*  84549 */   // Label 1304: @84549
     /*  84549 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84667), // Rule ID 15778 //
     /*  84554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84593 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84601 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84605 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84609 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84613 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84617 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84621 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84629 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84633 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84637 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84641 */     // MIs[6] Op3
     /*  84641 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84646 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84648 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84665 */     GIR_RootConstrainSelectedInstOperands,
     /*  84666 */     // GIR_Coverage, 15778,
     /*  84666 */     GIR_EraseRootFromParent_Done,
     /*  84667 */   // Label 1305: @84667
     /*  84667 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84785), // Rule ID 15780 //
     /*  84672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84711 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84719 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84723 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84727 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84731 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84735 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84739 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84747 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84751 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84755 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84759 */     // MIs[6] Op3
     /*  84759 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84764 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84766 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84783 */     GIR_RootConstrainSelectedInstOperands,
     /*  84784 */     // GIR_Coverage, 15780,
     /*  84784 */     GIR_EraseRootFromParent_Done,
     /*  84785 */   // Label 1306: @84785
     /*  84785 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(84903), // Rule ID 15747 //
     /*  84790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84829 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84835 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84841 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84845 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84849 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84853 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84857 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84861 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84865 */     // MIs[5] Op3
     /*  84865 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84870 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84874 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84882 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84884 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  84897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84901 */     GIR_RootConstrainSelectedInstOperands,
     /*  84902 */     // GIR_Coverage, 15747,
     /*  84902 */     GIR_EraseRootFromParent_Done,
     /*  84903 */   // Label 1307: @84903
     /*  84903 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(85021), // Rule ID 15752 //
     /*  84908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84947 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84953 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84955 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84959 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84963 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84967 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84971 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84975 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84979 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84983 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84987 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84995 */     // MIs[4] Op3
     /*  84995 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85000 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85002 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85019 */     GIR_RootConstrainSelectedInstOperands,
     /*  85020 */     // GIR_Coverage, 15752,
     /*  85020 */     GIR_EraseRootFromParent_Done,
     /*  85021 */   // Label 1308: @85021
     /*  85021 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85139), // Rule ID 15753 //
     /*  85026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85065 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85071 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85073 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85077 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85081 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85085 */     // MIs[4] Op3
     /*  85085 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85090 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85094 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85098 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85102 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85106 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85110 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85118 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85120 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85137 */     GIR_RootConstrainSelectedInstOperands,
     /*  85138 */     // GIR_Coverage, 15753,
     /*  85138 */     GIR_EraseRootFromParent_Done,
     /*  85139 */   // Label 1309: @85139
     /*  85139 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85257), // Rule ID 11959 //
     /*  85144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85183 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85191 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85195 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85199 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85203 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85207 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85211 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85215 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85219 */     // MIs[5] Op3
     /*  85219 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85224 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85228 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85234 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85236 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85238 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85255 */     GIR_RootConstrainSelectedInstOperands,
     /*  85256 */     // GIR_Coverage, 11959,
     /*  85256 */     GIR_EraseRootFromParent_Done,
     /*  85257 */   // Label 1310: @85257
     /*  85257 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85375), // Rule ID 15749 //
     /*  85262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85301 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85307 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85309 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85313 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85317 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85321 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85325 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85329 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85333 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85337 */     // MIs[5] Op3
     /*  85337 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85342 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85346 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85354 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85356 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  85369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85373 */     GIR_RootConstrainSelectedInstOperands,
     /*  85374 */     // GIR_Coverage, 15749,
     /*  85374 */     GIR_EraseRootFromParent_Done,
     /*  85375 */   // Label 1311: @85375
     /*  85375 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85493), // Rule ID 15750 //
     /*  85380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85419 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85435 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85439 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85443 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85447 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85451 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85455 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85459 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85467 */     // MIs[4] Op3
     /*  85467 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85472 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85474 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85491 */     GIR_RootConstrainSelectedInstOperands,
     /*  85492 */     // GIR_Coverage, 15750,
     /*  85492 */     GIR_EraseRootFromParent_Done,
     /*  85493 */   // Label 1312: @85493
     /*  85493 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85611), // Rule ID 15751 //
     /*  85498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85537 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85553 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85557 */     // MIs[4] Op3
     /*  85557 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85562 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85566 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85570 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85574 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85578 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85582 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85590 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85592 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85609 */     GIR_RootConstrainSelectedInstOperands,
     /*  85610 */     // GIR_Coverage, 15751,
     /*  85610 */     GIR_EraseRootFromParent_Done,
     /*  85611 */   // Label 1313: @85611
     /*  85611 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85729), // Rule ID 15748 //
     /*  85616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85655 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85663 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85667 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85671 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85675 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85679 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85683 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85687 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85691 */     // MIs[5] Op3
     /*  85691 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85696 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85700 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85706 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85708 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85710 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85727 */     GIR_RootConstrainSelectedInstOperands,
     /*  85728 */     // GIR_Coverage, 15748,
     /*  85728 */     GIR_EraseRootFromParent_Done,
     /*  85729 */   // Label 1314: @85729
     /*  85729 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85847), // Rule ID 15775 //
     /*  85734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85781 */     // MIs[3] Op3
     /*  85781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85790 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85798 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85802 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85806 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85810 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85814 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85818 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85826 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85828 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85845 */     GIR_RootConstrainSelectedInstOperands,
     /*  85846 */     // GIR_Coverage, 15775,
     /*  85846 */     GIR_EraseRootFromParent_Done,
     /*  85847 */   // Label 1315: @85847
     /*  85847 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85965), // Rule ID 15777 //
     /*  85852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85895 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85899 */     // MIs[3] Op3
     /*  85899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85908 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85916 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85920 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85924 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85928 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85936 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85944 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85946 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85963 */     GIR_RootConstrainSelectedInstOperands,
     /*  85964 */     // GIR_Coverage, 15777,
     /*  85964 */     GIR_EraseRootFromParent_Done,
     /*  85965 */   // Label 1316: @85965
     /*  85965 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(86083), // Rule ID 11967 //
     /*  85970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86025 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86033 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86037 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86041 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86045 */     // MIs[5] Op3
     /*  86045 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86050 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86054 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86060 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86062 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86064 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86081 */     GIR_RootConstrainSelectedInstOperands,
     /*  86082 */     // GIR_Coverage, 11967,
     /*  86082 */     GIR_EraseRootFromParent_Done,
     /*  86083 */   // Label 1317: @86083
     /*  86083 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86201), // Rule ID 15776 //
     /*  86088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86139 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86143 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86151 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86155 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86159 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86163 */     // MIs[5] Op3
     /*  86163 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86168 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86172 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86178 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86180 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86182 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86199 */     GIR_RootConstrainSelectedInstOperands,
     /*  86200 */     // GIR_Coverage, 15776,
     /*  86200 */     GIR_EraseRootFromParent_Done,
     /*  86201 */   // Label 1318: @86201
     /*  86201 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86291), // Rule ID 15725 //
     /*  86206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86245 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86251 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86253 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86257 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86261 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86265 */     // MIs[4] Op3
     /*  86265 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86270 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86272 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86289 */     GIR_RootConstrainSelectedInstOperands,
     /*  86290 */     // GIR_Coverage, 15725,
     /*  86290 */     GIR_EraseRootFromParent_Done,
     /*  86291 */   // Label 1319: @86291
     /*  86291 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86381), // Rule ID 15724 //
     /*  86296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86335 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86343 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86347 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86351 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86355 */     // MIs[4] Op3
     /*  86355 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86362 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86379 */     GIR_RootConstrainSelectedInstOperands,
     /*  86380 */     // GIR_Coverage, 15724,
     /*  86380 */     GIR_EraseRootFromParent_Done,
     /*  86381 */   // Label 1320: @86381
     /*  86381 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(86471), // Rule ID 15723 //
     /*  86386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86425 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86431 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86433 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86437 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86441 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86445 */     // MIs[4] Op3
     /*  86445 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86450 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86452 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86469 */     GIR_RootConstrainSelectedInstOperands,
     /*  86470 */     // GIR_Coverage, 15723,
     /*  86470 */     GIR_EraseRootFromParent_Done,
     /*  86471 */   // Label 1321: @86471
     /*  86471 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(86561), // Rule ID 15722 //
     /*  86476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86515 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86521 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86523 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86527 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86531 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86535 */     // MIs[4] Op3
     /*  86535 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86542 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86559 */     GIR_RootConstrainSelectedInstOperands,
     /*  86560 */     // GIR_Coverage, 15722,
     /*  86560 */     GIR_EraseRootFromParent_Done,
     /*  86561 */   // Label 1322: @86561
     /*  86561 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(86651), // Rule ID 15719 //
     /*  86566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86613 */     // MIs[3] Op3
     /*  86613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86632 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86649 */     GIR_RootConstrainSelectedInstOperands,
     /*  86650 */     // GIR_Coverage, 15719,
     /*  86650 */     GIR_EraseRootFromParent_Done,
     /*  86651 */   // Label 1323: @86651
     /*  86651 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(86741), // Rule ID 15721 //
     /*  86656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86703 */     // MIs[3] Op3
     /*  86703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86712 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86718 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86720 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86722 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86739 */     GIR_RootConstrainSelectedInstOperands,
     /*  86740 */     // GIR_Coverage, 15721,
     /*  86740 */     GIR_EraseRootFromParent_Done,
     /*  86741 */   // Label 1324: @86741
     /*  86741 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(86831), // Rule ID 11951 //
     /*  86746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86793 */     // MIs[3] Op3
     /*  86793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86802 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86810 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86812 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86829 */     GIR_RootConstrainSelectedInstOperands,
     /*  86830 */     // GIR_Coverage, 11951,
     /*  86830 */     GIR_EraseRootFromParent_Done,
     /*  86831 */   // Label 1325: @86831
     /*  86831 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(86921), // Rule ID 15720 //
     /*  86836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86883 */     // MIs[3] Op3
     /*  86883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86902 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86919 */     GIR_RootConstrainSelectedInstOperands,
     /*  86920 */     // GIR_Coverage, 15720,
     /*  86920 */     GIR_EraseRootFromParent_Done,
     /*  86921 */   // Label 1326: @86921
     /*  86921 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(87011), // Rule ID 15782 //
     /*  86926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86969 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86973 */     // MIs[3] Op3
     /*  86973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  86982 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86992 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87009 */     GIR_RootConstrainSelectedInstOperands,
     /*  87010 */     // GIR_Coverage, 15782,
     /*  87010 */     GIR_EraseRootFromParent_Done,
     /*  87011 */   // Label 1327: @87011
     /*  87011 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(87101), // Rule ID 15784 //
     /*  87016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87059 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87063 */     // MIs[3] Op3
     /*  87063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87068 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87072 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87078 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87082 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87099 */     GIR_RootConstrainSelectedInstOperands,
     /*  87100 */     // GIR_Coverage, 15784,
     /*  87100 */     GIR_EraseRootFromParent_Done,
     /*  87101 */   // Label 1328: @87101
     /*  87101 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(87191), // Rule ID 11968 //
     /*  87106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87153 */     // MIs[3] Op3
     /*  87153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  87158 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87162 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87172 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87189 */     GIR_RootConstrainSelectedInstOperands,
     /*  87190 */     // GIR_Coverage, 11968,
     /*  87190 */     GIR_EraseRootFromParent_Done,
     /*  87191 */   // Label 1329: @87191
     /*  87191 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(87281), // Rule ID 15783 //
     /*  87196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87243 */     // MIs[3] Op3
     /*  87243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87260 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87262 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87279 */     GIR_RootConstrainSelectedInstOperands,
     /*  87280 */     // GIR_Coverage, 15783,
     /*  87280 */     GIR_EraseRootFromParent_Done,
     /*  87281 */   // Label 1330: @87281
     /*  87281 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(87371), // Rule ID 15786 //
     /*  87286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87341 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87345 */     // MIs[4] Op3
     /*  87345 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87350 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87352 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87369 */     GIR_RootConstrainSelectedInstOperands,
     /*  87370 */     // GIR_Coverage, 15786,
     /*  87370 */     GIR_EraseRootFromParent_Done,
     /*  87371 */   // Label 1331: @87371
     /*  87371 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(87461), // Rule ID 15788 //
     /*  87376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87415 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87431 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87435 */     // MIs[4] Op3
     /*  87435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87442 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87459 */     GIR_RootConstrainSelectedInstOperands,
     /*  87460 */     // GIR_Coverage, 15788,
     /*  87460 */     GIR_EraseRootFromParent_Done,
     /*  87461 */   // Label 1332: @87461
     /*  87461 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(87551), // Rule ID 15785 //
     /*  87466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87505 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87511 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87513 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87517 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87521 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87525 */     // MIs[4] Op3
     /*  87525 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87530 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87532 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87549 */     GIR_RootConstrainSelectedInstOperands,
     /*  87550 */     // GIR_Coverage, 15785,
     /*  87550 */     GIR_EraseRootFromParent_Done,
     /*  87551 */   // Label 1333: @87551
     /*  87551 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(87641), // Rule ID 15787 //
     /*  87556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87603 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87607 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87611 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87615 */     // MIs[4] Op3
     /*  87615 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87622 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87639 */     GIR_RootConstrainSelectedInstOperands,
     /*  87640 */     // GIR_Coverage, 15787,
     /*  87640 */     GIR_EraseRootFromParent_Done,
     /*  87641 */   // Label 1334: @87641
     /*  87641 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(87656), // Rule ID 7519 //
     /*  87646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87649 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  87649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  87654 */     GIR_RootConstrainSelectedInstOperands,
     /*  87655 */     // GIR_Coverage, 7519,
     /*  87655 */     GIR_Done,
     /*  87656 */   // Label 1335: @87656
     /*  87656 */   GIM_Reject,
     /*  87657 */ // Label 1302: @87657
     /*  87657 */ GIM_Reject,
     /*  87658 */ // Label 1047: @87658
     /*  87658 */ GIM_Reject,
     /*  87659 */ // Label 7: @87659
     /*  87659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1354*/ GIMT_Encode4(98626),
     /*  87670 */ /*GILLT_s32*//*Label 1336*/ GIMT_Encode4(87758),
     /*  87674 */ /*GILLT_s64*//*Label 1337*/ GIMT_Encode4(88438), GIMT_Encode4(0),
     /*  87682 */ /*GILLT_v2s32*//*Label 1338*/ GIMT_Encode4(89281),
     /*  87686 */ /*GILLT_v2s64*//*Label 1339*/ GIMT_Encode4(89516),
     /*  87690 */ /*GILLT_v4s16*//*Label 1340*/ GIMT_Encode4(90205),
     /*  87694 */ /*GILLT_v4s32*//*Label 1341*/ GIMT_Encode4(90440),
     /*  87698 */ /*GILLT_v8s8*//*Label 1342*/ GIMT_Encode4(91129),
     /*  87702 */ /*GILLT_v8s16*//*Label 1343*/ GIMT_Encode4(91367),
     /*  87706 */ /*GILLT_v16s8*//*Label 1344*/ GIMT_Encode4(92056),
     /*  87710 */ /*GILLT_nxv1s1*//*Label 1345*/ GIMT_Encode4(92748),
     /*  87714 */ /*GILLT_nxv2s1*//*Label 1346*/ GIMT_Encode4(92798), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87726 */ /*GILLT_nxv2s64*//*Label 1347*/ GIMT_Encode4(92848),
     /*  87730 */ /*GILLT_nxv4s1*//*Label 1348*/ GIMT_Encode4(94255), GIMT_Encode4(0),
     /*  87738 */ /*GILLT_nxv4s32*//*Label 1349*/ GIMT_Encode4(94305),
     /*  87742 */ /*GILLT_nxv8s1*//*Label 1350*/ GIMT_Encode4(95712),
     /*  87746 */ /*GILLT_nxv8s16*//*Label 1351*/ GIMT_Encode4(95762),
     /*  87750 */ /*GILLT_nxv16s1*//*Label 1352*/ GIMT_Encode4(97169),
     /*  87754 */ /*GILLT_nxv16s8*//*Label 1353*/ GIMT_Encode4(97219),
     /*  87758 */ // Label 1336: @87758
     /*  87758 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(88437),
     /*  87763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  87769 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(87827), // Rule ID 13326 //
     /*  87774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87799 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87812 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87825 */     GIR_RootConstrainSelectedInstOperands,
     /*  87826 */     // GIR_Coverage, 13326,
     /*  87826 */     GIR_EraseRootFromParent_Done,
     /*  87827 */   // Label 1356: @87827
     /*  87827 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87882), // Rule ID 13325 //
     /*  87832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87852 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87869 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87880 */     GIR_RootConstrainSelectedInstOperands,
     /*  87881 */     // GIR_Coverage, 13325,
     /*  87881 */     GIR_EraseRootFromParent_Done,
     /*  87882 */   // Label 1357: @87882
     /*  87882 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87940), // Rule ID 13323 //
     /*  87887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87925 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87938 */     GIR_RootConstrainSelectedInstOperands,
     /*  87939 */     // GIR_Coverage, 13323,
     /*  87939 */     GIR_EraseRootFromParent_Done,
     /*  87940 */   // Label 1358: @87940
     /*  87940 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87998), // Rule ID 166 //
     /*  87945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87983 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87996 */     GIR_RootConstrainSelectedInstOperands,
     /*  87997 */     // GIR_Coverage, 166,
     /*  87997 */     GIR_EraseRootFromParent_Done,
     /*  87998 */   // Label 1359: @87998
     /*  87998 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(88056), // Rule ID 13324 //
     /*  88003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88041 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88054 */     GIR_RootConstrainSelectedInstOperands,
     /*  88055 */     // GIR_Coverage, 13324,
     /*  88055 */     GIR_EraseRootFromParent_Done,
     /*  88056 */   // Label 1360: @88056
     /*  88056 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(88111), // Rule ID 13327 //
     /*  88061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88098 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88109 */     GIR_RootConstrainSelectedInstOperands,
     /*  88110 */     // GIR_Coverage, 13327,
     /*  88110 */     GIR_EraseRootFromParent_Done,
     /*  88111 */   // Label 1361: @88111
     /*  88111 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(88152), // Rule ID 144 //
     /*  88116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  88120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88132 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  88136 */     // MIs[1] Operand 1
     /*  88136 */     // No operand predicates
     /*  88136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88138 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  88138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  88141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  88150 */     GIR_RootConstrainSelectedInstOperands,
     /*  88151 */     // GIR_Coverage, 144,
     /*  88151 */     GIR_EraseRootFromParent_Done,
     /*  88152 */   // Label 1362: @88152
     /*  88152 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(88185), // Rule ID 13333 //
     /*  88157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88172 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88183 */     GIR_RootConstrainSelectedInstOperands,
     /*  88184 */     // GIR_Coverage, 13333,
     /*  88184 */     GIR_EraseRootFromParent_Done,
     /*  88185 */   // Label 1363: @88185
     /*  88185 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(88218), // Rule ID 170 //
     /*  88190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88205 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88216 */     GIR_RootConstrainSelectedInstOperands,
     /*  88217 */     // GIR_Coverage, 170,
     /*  88217 */     GIR_EraseRootFromParent_Done,
     /*  88218 */   // Label 1364: @88218
     /*  88218 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(88271), // Rule ID 13319 //
     /*  88223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88248 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88258 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  88269 */     GIR_RootConstrainSelectedInstOperands,
     /*  88270 */     // GIR_Coverage, 13319,
     /*  88270 */     GIR_EraseRootFromParent_Done,
     /*  88271 */   // Label 1365: @88271
     /*  88271 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(88327), // Rule ID 164 //
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88312 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  88325 */     GIR_RootConstrainSelectedInstOperands,
     /*  88326 */     // GIR_Coverage, 164,
     /*  88326 */     GIR_EraseRootFromParent_Done,
     /*  88327 */   // Label 1366: @88327
     /*  88327 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(88380), // Rule ID 13320 //
     /*  88332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88367 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  88378 */     GIR_RootConstrainSelectedInstOperands,
     /*  88379 */     // GIR_Coverage, 13320,
     /*  88379 */     GIR_EraseRootFromParent_Done,
     /*  88380 */   // Label 1367: @88380
     /*  88380 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(88412), // Rule ID 4006 //
     /*  88385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88397 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  88397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  88400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  88410 */     GIR_RootConstrainSelectedInstOperands,
     /*  88411 */     // GIR_Coverage, 4006,
     /*  88411 */     GIR_EraseRootFromParent_Done,
     /*  88412 */   // Label 1368: @88412
     /*  88412 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(88436), // Rule ID 168 //
     /*  88417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88429 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  88434 */     GIR_RootConstrainSelectedInstOperands,
     /*  88435 */     // GIR_Coverage, 168,
     /*  88435 */     GIR_Done,
     /*  88436 */   // Label 1369: @88436
     /*  88436 */   GIM_Reject,
     /*  88437 */ // Label 1355: @88437
     /*  88437 */ GIM_Reject,
     /*  88438 */ // Label 1337: @88438
     /*  88438 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(89280),
     /*  88443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  88449 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(88507), // Rule ID 13331 //
     /*  88454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88492 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88505 */     GIR_RootConstrainSelectedInstOperands,
     /*  88506 */     // GIR_Coverage, 13331,
     /*  88506 */     GIR_EraseRootFromParent_Done,
     /*  88507 */   // Label 1371: @88507
     /*  88507 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(88562), // Rule ID 13330 //
     /*  88512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88549 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88560 */     GIR_RootConstrainSelectedInstOperands,
     /*  88561 */     // GIR_Coverage, 13330,
     /*  88561 */     GIR_EraseRootFromParent_Done,
     /*  88562 */   // Label 1372: @88562
     /*  88562 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88620), // Rule ID 13328 //
     /*  88567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88605 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88618 */     GIR_RootConstrainSelectedInstOperands,
     /*  88619 */     // GIR_Coverage, 13328,
     /*  88619 */     GIR_EraseRootFromParent_Done,
     /*  88620 */   // Label 1373: @88620
     /*  88620 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(88678), // Rule ID 167 //
     /*  88625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88663 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88676 */     GIR_RootConstrainSelectedInstOperands,
     /*  88677 */     // GIR_Coverage, 167,
     /*  88677 */     GIR_EraseRootFromParent_Done,
     /*  88678 */   // Label 1374: @88678
     /*  88678 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(88736), // Rule ID 13329 //
     /*  88683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88708 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88721 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88734 */     GIR_RootConstrainSelectedInstOperands,
     /*  88735 */     // GIR_Coverage, 13329,
     /*  88735 */     GIR_EraseRootFromParent_Done,
     /*  88736 */   // Label 1375: @88736
     /*  88736 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88791), // Rule ID 13332 //
     /*  88741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88765 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88778 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88789 */     GIR_RootConstrainSelectedInstOperands,
     /*  88790 */     // GIR_Coverage, 13332,
     /*  88790 */     GIR_EraseRootFromParent_Done,
     /*  88791 */   // Label 1376: @88791
     /*  88791 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88891), // Rule ID 1613 //
     /*  88796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88815 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  88819 */     // MIs[1] Operand 1
     /*  88819 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  88836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  88840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88854 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88866 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88876 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  88876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  88879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88889 */     GIR_RootConstrainSelectedInstOperands,
     /*  88890 */     // GIR_Coverage, 1613,
     /*  88890 */     GIR_EraseRootFromParent_Done,
     /*  88891 */   // Label 1377: @88891
     /*  88891 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88932), // Rule ID 145 //
     /*  88896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  88900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88912 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  88916 */     // MIs[1] Operand 1
     /*  88916 */     // No operand predicates
     /*  88916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88918 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  88918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  88921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88925 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  88930 */     GIR_RootConstrainSelectedInstOperands,
     /*  88931 */     // GIR_Coverage, 145,
     /*  88931 */     GIR_EraseRootFromParent_Done,
     /*  88932 */   // Label 1378: @88932
     /*  88932 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88965), // Rule ID 13334 //
     /*  88937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88952 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  88955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88963 */     GIR_RootConstrainSelectedInstOperands,
     /*  88964 */     // GIR_Coverage, 13334,
     /*  88964 */     GIR_EraseRootFromParent_Done,
     /*  88965 */   // Label 1379: @88965
     /*  88965 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88998), // Rule ID 171 //
     /*  88970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88985 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  88988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88996 */     GIR_RootConstrainSelectedInstOperands,
     /*  88997 */     // GIR_Coverage, 171,
     /*  88997 */     GIR_EraseRootFromParent_Done,
     /*  88998 */   // Label 1380: @88998
     /*  88998 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(89051), // Rule ID 13321 //
     /*  89003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89038 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  89049 */     GIR_RootConstrainSelectedInstOperands,
     /*  89050 */     // GIR_Coverage, 13321,
     /*  89050 */     GIR_EraseRootFromParent_Done,
     /*  89051 */   // Label 1381: @89051
     /*  89051 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(89107), // Rule ID 165 //
     /*  89056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89092 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  89105 */     GIR_RootConstrainSelectedInstOperands,
     /*  89106 */     // GIR_Coverage, 165,
     /*  89106 */     GIR_EraseRootFromParent_Done,
     /*  89107 */   // Label 1382: @89107
     /*  89107 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(89160), // Rule ID 13322 //
     /*  89112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89147 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  89158 */     GIR_RootConstrainSelectedInstOperands,
     /*  89159 */     // GIR_Coverage, 13322,
     /*  89159 */     GIR_EraseRootFromParent_Done,
     /*  89160 */   // Label 1383: @89160
     /*  89160 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(89192), // Rule ID 4007 //
     /*  89165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89177 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  89177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  89180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  89190 */     GIR_RootConstrainSelectedInstOperands,
     /*  89191 */     // GIR_Coverage, 4007,
     /*  89191 */     GIR_EraseRootFromParent_Done,
     /*  89192 */   // Label 1384: @89192
     /*  89192 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89228), // Rule ID 4991 //
     /*  89197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89219 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  89219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89226 */     GIR_RootConstrainSelectedInstOperands,
     /*  89227 */     // GIR_Coverage, 4991,
     /*  89227 */     GIR_EraseRootFromParent_Done,
     /*  89228 */   // Label 1385: @89228
     /*  89228 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89252), // Rule ID 169 //
     /*  89233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89245 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  89250 */     GIR_RootConstrainSelectedInstOperands,
     /*  89251 */     // GIR_Coverage, 169,
     /*  89251 */     GIR_Done,
     /*  89252 */   // Label 1386: @89252
     /*  89252 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(89279), // Rule ID 5069 //
     /*  89257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89272 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  89272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89277 */     GIR_RootConstrainSelectedInstOperands,
     /*  89278 */     // GIR_Coverage, 5069,
     /*  89278 */     GIR_Done,
     /*  89279 */   // Label 1387: @89279
     /*  89279 */   GIM_Reject,
     /*  89280 */ // Label 1370: @89280
     /*  89280 */ GIM_Reject,
     /*  89281 */ // Label 1338: @89281
     /*  89281 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(89515),
     /*  89286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89296 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(89392), // Rule ID 1160 //
     /*  89301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89320 */     // MIs[1] Operand 1
     /*  89320 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89355 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89363 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89367 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89373 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89377 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  89377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89390 */     GIR_RootConstrainSelectedInstOperands,
     /*  89391 */     // GIR_Coverage, 1160,
     /*  89391 */     GIR_EraseRootFromParent_Done,
     /*  89392 */   // Label 1389: @89392
     /*  89392 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(89459), // Rule ID 5038 //
     /*  89397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89409 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89413 */     // MIs[1] Operand 1
     /*  89413 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89444 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  89444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89457 */     GIR_RootConstrainSelectedInstOperands,
     /*  89458 */     // GIR_Coverage, 5038,
     /*  89458 */     GIR_EraseRootFromParent_Done,
     /*  89459 */   // Label 1390: @89459
     /*  89459 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(89491), // Rule ID 4989 //
     /*  89464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89482 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  89482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89489 */     GIR_RootConstrainSelectedInstOperands,
     /*  89490 */     // GIR_Coverage, 4989,
     /*  89490 */     GIR_EraseRootFromParent_Done,
     /*  89491 */   // Label 1391: @89491
     /*  89491 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(89514), // Rule ID 5068 //
     /*  89496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89507 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  89507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89512 */     GIR_RootConstrainSelectedInstOperands,
     /*  89513 */     // GIR_Coverage, 5068,
     /*  89513 */     GIR_Done,
     /*  89514 */   // Label 1392: @89514
     /*  89514 */   GIM_Reject,
     /*  89515 */ // Label 1388: @89515
     /*  89515 */ GIM_Reject,
     /*  89516 */ // Label 1339: @89516
     /*  89516 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(90204),
     /*  89521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89531 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89627), // Rule ID 1162 //
     /*  89536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  89555 */     // MIs[1] Operand 1
     /*  89555 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89590 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89596 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89602 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89610 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89612 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  89612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  89615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89625 */     GIR_RootConstrainSelectedInstOperands,
     /*  89626 */     // GIR_Coverage, 1162,
     /*  89626 */     GIR_EraseRootFromParent_Done,
     /*  89627 */   // Label 1394: @89627
     /*  89627 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89694), // Rule ID 5040 //
     /*  89632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  89648 */     // MIs[1] Operand 1
     /*  89648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89657 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89663 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89679 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  89679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  89682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89692 */     GIR_RootConstrainSelectedInstOperands,
     /*  89693 */     // GIR_Coverage, 5040,
     /*  89693 */     GIR_EraseRootFromParent_Done,
     /*  89694 */   // Label 1395: @89694
     /*  89694 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89779), // Rule ID 13866 //
     /*  89699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89743 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89762 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89777 */     GIR_RootConstrainSelectedInstOperands,
     /*  89778 */     // GIR_Coverage, 13866,
     /*  89778 */     GIR_EraseRootFromParent_Done,
     /*  89779 */   // Label 1396: @89779
     /*  89779 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89864), // Rule ID 13865 //
     /*  89784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89833 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89847 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89862 */     GIR_RootConstrainSelectedInstOperands,
     /*  89863 */     // GIR_Coverage, 13865,
     /*  89863 */     GIR_EraseRootFromParent_Done,
     /*  89864 */   // Label 1397: @89864
     /*  89864 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89949), // Rule ID 13864 //
     /*  89869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89917 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89923 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89932 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89947 */     GIR_RootConstrainSelectedInstOperands,
     /*  89948 */     // GIR_Coverage, 13864,
     /*  89948 */     GIR_EraseRootFromParent_Done,
     /*  89949 */   // Label 1398: @89949
     /*  89949 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(90034), // Rule ID 3834 //
     /*  89954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90017 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90032 */     GIR_RootConstrainSelectedInstOperands,
     /*  90033 */     // GIR_Coverage, 3834,
     /*  90033 */     GIR_EraseRootFromParent_Done,
     /*  90034 */   // Label 1399: @90034
     /*  90034 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(90066), // Rule ID 4992 //
     /*  90039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90047 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90057 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  90057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90064 */     GIR_RootConstrainSelectedInstOperands,
     /*  90065 */     // GIR_Coverage, 4992,
     /*  90065 */     GIR_EraseRootFromParent_Done,
     /*  90066 */   // Label 1400: @90066
     /*  90066 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(90123), // Rule ID 3830 //
     /*  90071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90106 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90121 */     GIR_RootConstrainSelectedInstOperands,
     /*  90122 */     // GIR_Coverage, 3830,
     /*  90122 */     GIR_EraseRootFromParent_Done,
     /*  90123 */   // Label 1401: @90123
     /*  90123 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(90180), // Rule ID 13854 //
     /*  90128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90163 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90178 */     GIR_RootConstrainSelectedInstOperands,
     /*  90179 */     // GIR_Coverage, 13854,
     /*  90179 */     GIR_EraseRootFromParent_Done,
     /*  90180 */   // Label 1402: @90180
     /*  90180 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(90203), // Rule ID 5072 //
     /*  90185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90196 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  90196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90201 */     GIR_RootConstrainSelectedInstOperands,
     /*  90202 */     // GIR_Coverage, 5072,
     /*  90202 */     GIR_Done,
     /*  90203 */   // Label 1403: @90203
     /*  90203 */   GIM_Reject,
     /*  90204 */ // Label 1393: @90204
     /*  90204 */ GIM_Reject,
     /*  90205 */ // Label 1340: @90205
     /*  90205 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(90439),
     /*  90210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90220 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(90316), // Rule ID 1158 //
     /*  90225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90240 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90244 */     // MIs[1] Operand 1
     /*  90244 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90279 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90285 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90291 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90299 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90301 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  90301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90314 */     GIR_RootConstrainSelectedInstOperands,
     /*  90315 */     // GIR_Coverage, 1158,
     /*  90315 */     GIR_EraseRootFromParent_Done,
     /*  90316 */   // Label 1405: @90316
     /*  90316 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(90383), // Rule ID 5036 //
     /*  90321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90333 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90337 */     // MIs[1] Operand 1
     /*  90337 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90368 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  90368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90381 */     GIR_RootConstrainSelectedInstOperands,
     /*  90382 */     // GIR_Coverage, 5036,
     /*  90382 */     GIR_EraseRootFromParent_Done,
     /*  90383 */   // Label 1406: @90383
     /*  90383 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(90415), // Rule ID 4987 //
     /*  90388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90402 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90406 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  90406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  90409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90413 */     GIR_RootConstrainSelectedInstOperands,
     /*  90414 */     // GIR_Coverage, 4987,
     /*  90414 */     GIR_EraseRootFromParent_Done,
     /*  90415 */   // Label 1407: @90415
     /*  90415 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(90438), // Rule ID 5067 //
     /*  90420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90431 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  90431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  90436 */     GIR_RootConstrainSelectedInstOperands,
     /*  90437 */     // GIR_Coverage, 5067,
     /*  90437 */     GIR_Done,
     /*  90438 */   // Label 1408: @90438
     /*  90438 */   GIM_Reject,
     /*  90439 */ // Label 1404: @90439
     /*  90439 */ GIM_Reject,
     /*  90440 */ // Label 1341: @90440
     /*  90440 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(91128),
     /*  90445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90455 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90551), // Rule ID 1161 //
     /*  90460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90479 */     // MIs[1] Operand 1
     /*  90479 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90514 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90534 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90536 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  90536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90549 */     GIR_RootConstrainSelectedInstOperands,
     /*  90550 */     // GIR_Coverage, 1161,
     /*  90550 */     GIR_EraseRootFromParent_Done,
     /*  90551 */   // Label 1410: @90551
     /*  90551 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(90618), // Rule ID 5039 //
     /*  90556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90572 */     // MIs[1] Operand 1
     /*  90572 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90581 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90587 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90593 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90603 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  90603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90616 */     GIR_RootConstrainSelectedInstOperands,
     /*  90617 */     // GIR_Coverage, 5039,
     /*  90617 */     GIR_EraseRootFromParent_Done,
     /*  90618 */   // Label 1411: @90618
     /*  90618 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90703), // Rule ID 13863 //
     /*  90623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90667 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90686 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90701 */     GIR_RootConstrainSelectedInstOperands,
     /*  90702 */     // GIR_Coverage, 13863,
     /*  90702 */     GIR_EraseRootFromParent_Done,
     /*  90703 */   // Label 1412: @90703
     /*  90703 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90788), // Rule ID 13862 //
     /*  90708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90757 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90771 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90786 */     GIR_RootConstrainSelectedInstOperands,
     /*  90787 */     // GIR_Coverage, 13862,
     /*  90787 */     GIR_EraseRootFromParent_Done,
     /*  90788 */   // Label 1413: @90788
     /*  90788 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90873), // Rule ID 13861 //
     /*  90793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90841 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90856 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90871 */     GIR_RootConstrainSelectedInstOperands,
     /*  90872 */     // GIR_Coverage, 13861,
     /*  90872 */     GIR_EraseRootFromParent_Done,
     /*  90873 */   // Label 1414: @90873
     /*  90873 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90958), // Rule ID 3833 //
     /*  90878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90931 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90941 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90956 */     GIR_RootConstrainSelectedInstOperands,
     /*  90957 */     // GIR_Coverage, 3833,
     /*  90957 */     GIR_EraseRootFromParent_Done,
     /*  90958 */   // Label 1415: @90958
     /*  90958 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90990), // Rule ID 4990 //
     /*  90963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90971 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90981 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  90981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90988 */     GIR_RootConstrainSelectedInstOperands,
     /*  90989 */     // GIR_Coverage, 4990,
     /*  90989 */     GIR_EraseRootFromParent_Done,
     /*  90990 */   // Label 1416: @90990
     /*  90990 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(91047), // Rule ID 3829 //
     /*  90995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91030 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91045 */     GIR_RootConstrainSelectedInstOperands,
     /*  91046 */     // GIR_Coverage, 3829,
     /*  91046 */     GIR_EraseRootFromParent_Done,
     /*  91047 */   // Label 1417: @91047
     /*  91047 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91104), // Rule ID 13853 //
     /*  91052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91087 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91102 */     GIR_RootConstrainSelectedInstOperands,
     /*  91103 */     // GIR_Coverage, 13853,
     /*  91103 */     GIR_EraseRootFromParent_Done,
     /*  91104 */   // Label 1418: @91104
     /*  91104 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91127), // Rule ID 5071 //
     /*  91109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91120 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  91120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91125 */     GIR_RootConstrainSelectedInstOperands,
     /*  91126 */     // GIR_Coverage, 5071,
     /*  91126 */     GIR_Done,
     /*  91127 */   // Label 1419: @91127
     /*  91127 */   GIM_Reject,
     /*  91128 */ // Label 1409: @91128
     /*  91128 */ GIM_Reject,
     /*  91129 */ // Label 1342: @91129
     /*  91129 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91366),
     /*  91134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91144 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91240), // Rule ID 1156 //
     /*  91149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91168 */     // MIs[1] Operand 1
     /*  91168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91203 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91215 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91221 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91223 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91225 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91238 */     GIR_RootConstrainSelectedInstOperands,
     /*  91239 */     // GIR_Coverage, 1156,
     /*  91239 */     GIR_EraseRootFromParent_Done,
     /*  91240 */   // Label 1421: @91240
     /*  91240 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91307), // Rule ID 5034 //
     /*  91245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91261 */     // MIs[1] Operand 1
     /*  91261 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91270 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91282 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91288 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91292 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  91292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91305 */     GIR_RootConstrainSelectedInstOperands,
     /*  91306 */     // GIR_Coverage, 5034,
     /*  91306 */     GIR_EraseRootFromParent_Done,
     /*  91307 */   // Label 1422: @91307
     /*  91307 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91342), // Rule ID 972 //
     /*  91312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91333 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  91333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  91336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91340 */     GIR_RootConstrainSelectedInstOperands,
     /*  91341 */     // GIR_Coverage, 972,
     /*  91341 */     GIR_EraseRootFromParent_Done,
     /*  91342 */   // Label 1423: @91342
     /*  91342 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91365), // Rule ID 1599 //
     /*  91347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91358 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  91363 */     GIR_RootConstrainSelectedInstOperands,
     /*  91364 */     // GIR_Coverage, 1599,
     /*  91364 */     GIR_Done,
     /*  91365 */   // Label 1424: @91365
     /*  91365 */   GIM_Reject,
     /*  91366 */ // Label 1420: @91366
     /*  91366 */ GIM_Reject,
     /*  91367 */ // Label 1343: @91367
     /*  91367 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(92055),
     /*  91372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91382 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91478), // Rule ID 1159 //
     /*  91387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91406 */     // MIs[1] Operand 1
     /*  91406 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91441 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91447 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91449 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91453 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91461 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91463 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  91463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91476 */     GIR_RootConstrainSelectedInstOperands,
     /*  91477 */     // GIR_Coverage, 1159,
     /*  91477 */     GIR_EraseRootFromParent_Done,
     /*  91478 */   // Label 1426: @91478
     /*  91478 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91545), // Rule ID 5037 //
     /*  91483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91499 */     // MIs[1] Operand 1
     /*  91499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91508 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91514 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91520 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91530 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  91530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91543 */     GIR_RootConstrainSelectedInstOperands,
     /*  91544 */     // GIR_Coverage, 5037,
     /*  91544 */     GIR_EraseRootFromParent_Done,
     /*  91545 */   // Label 1427: @91545
     /*  91545 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91630), // Rule ID 13860 //
     /*  91550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91594 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91613 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91628 */     GIR_RootConstrainSelectedInstOperands,
     /*  91629 */     // GIR_Coverage, 13860,
     /*  91629 */     GIR_EraseRootFromParent_Done,
     /*  91630 */   // Label 1428: @91630
     /*  91630 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91715), // Rule ID 13859 //
     /*  91635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91684 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91698 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91713 */     GIR_RootConstrainSelectedInstOperands,
     /*  91714 */     // GIR_Coverage, 13859,
     /*  91714 */     GIR_EraseRootFromParent_Done,
     /*  91715 */   // Label 1429: @91715
     /*  91715 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91800), // Rule ID 13858 //
     /*  91720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91768 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91783 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91798 */     GIR_RootConstrainSelectedInstOperands,
     /*  91799 */     // GIR_Coverage, 13858,
     /*  91799 */     GIR_EraseRootFromParent_Done,
     /*  91800 */   // Label 1430: @91800
     /*  91800 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91885), // Rule ID 3832 //
     /*  91805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91858 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91868 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91883 */     GIR_RootConstrainSelectedInstOperands,
     /*  91884 */     // GIR_Coverage, 3832,
     /*  91884 */     GIR_EraseRootFromParent_Done,
     /*  91885 */   // Label 1431: @91885
     /*  91885 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91917), // Rule ID 4988 //
     /*  91890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91908 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  91908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91915 */     GIR_RootConstrainSelectedInstOperands,
     /*  91916 */     // GIR_Coverage, 4988,
     /*  91916 */     GIR_EraseRootFromParent_Done,
     /*  91917 */   // Label 1432: @91917
     /*  91917 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91974), // Rule ID 3828 //
     /*  91922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91957 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91972 */     GIR_RootConstrainSelectedInstOperands,
     /*  91973 */     // GIR_Coverage, 3828,
     /*  91973 */     GIR_EraseRootFromParent_Done,
     /*  91974 */   // Label 1433: @91974
     /*  91974 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92031), // Rule ID 13852 //
     /*  91979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92014 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  92029 */     GIR_RootConstrainSelectedInstOperands,
     /*  92030 */     // GIR_Coverage, 13852,
     /*  92030 */     GIR_EraseRootFromParent_Done,
     /*  92031 */   // Label 1434: @92031
     /*  92031 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92054), // Rule ID 5070 //
     /*  92036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92047 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  92047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  92052 */     GIR_RootConstrainSelectedInstOperands,
     /*  92053 */     // GIR_Coverage, 5070,
     /*  92053 */     GIR_Done,
     /*  92054 */   // Label 1435: @92054
     /*  92054 */   GIM_Reject,
     /*  92055 */ // Label 1425: @92055
     /*  92055 */ GIM_Reject,
     /*  92056 */ // Label 1344: @92056
     /*  92056 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92747),
     /*  92061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92071 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92167), // Rule ID 1157 //
     /*  92076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92095 */     // MIs[1] Operand 1
     /*  92095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  92130 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  92138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  92142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  92152 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  92152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  92161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  92165 */     GIR_RootConstrainSelectedInstOperands,
     /*  92166 */     // GIR_Coverage, 1157,
     /*  92166 */     GIR_EraseRootFromParent_Done,
     /*  92167 */   // Label 1437: @92167
     /*  92167 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92234), // Rule ID 5035 //
     /*  92172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92188 */     // MIs[1] Operand 1
     /*  92188 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  92197 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  92205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  92209 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92219 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  92219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92232 */     GIR_RootConstrainSelectedInstOperands,
     /*  92233 */     // GIR_Coverage, 5035,
     /*  92233 */     GIR_EraseRootFromParent_Done,
     /*  92234 */   // Label 1438: @92234
     /*  92234 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92319), // Rule ID 13857 //
     /*  92239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92283 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92302 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92317 */     GIR_RootConstrainSelectedInstOperands,
     /*  92318 */     // GIR_Coverage, 13857,
     /*  92318 */     GIR_EraseRootFromParent_Done,
     /*  92319 */   // Label 1439: @92319
     /*  92319 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92404), // Rule ID 13856 //
     /*  92324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92387 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92402 */     GIR_RootConstrainSelectedInstOperands,
     /*  92403 */     // GIR_Coverage, 13856,
     /*  92403 */     GIR_EraseRootFromParent_Done,
     /*  92404 */   // Label 1440: @92404
     /*  92404 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92489), // Rule ID 13855 //
     /*  92409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92457 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92472 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92487 */     GIR_RootConstrainSelectedInstOperands,
     /*  92488 */     // GIR_Coverage, 13855,
     /*  92488 */     GIR_EraseRootFromParent_Done,
     /*  92489 */   // Label 1441: @92489
     /*  92489 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92574), // Rule ID 3831 //
     /*  92494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92557 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92572 */     GIR_RootConstrainSelectedInstOperands,
     /*  92573 */     // GIR_Coverage, 3831,
     /*  92573 */     GIR_EraseRootFromParent_Done,
     /*  92574 */   // Label 1442: @92574
     /*  92574 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92609), // Rule ID 973 //
     /*  92579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92590 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  92598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92600 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  92600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  92603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  92607 */     GIR_RootConstrainSelectedInstOperands,
     /*  92608 */     // GIR_Coverage, 973,
     /*  92608 */     GIR_EraseRootFromParent_Done,
     /*  92609 */   // Label 1443: @92609
     /*  92609 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92666), // Rule ID 3827 //
     /*  92614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92649 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  92664 */     GIR_RootConstrainSelectedInstOperands,
     /*  92665 */     // GIR_Coverage, 3827,
     /*  92665 */     GIR_EraseRootFromParent_Done,
     /*  92666 */   // Label 1444: @92666
     /*  92666 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92723), // Rule ID 13851 //
     /*  92671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92706 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  92721 */     GIR_RootConstrainSelectedInstOperands,
     /*  92722 */     // GIR_Coverage, 13851,
     /*  92722 */     GIR_EraseRootFromParent_Done,
     /*  92723 */   // Label 1445: @92723
     /*  92723 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92746), // Rule ID 1600 //
     /*  92728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92739 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  92739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  92744 */     GIR_RootConstrainSelectedInstOperands,
     /*  92745 */     // GIR_Coverage, 1600,
     /*  92745 */     GIR_Done,
     /*  92746 */   // Label 1446: @92746
     /*  92746 */   GIM_Reject,
     /*  92747 */ // Label 1436: @92747
     /*  92747 */ GIM_Reject,
     /*  92748 */ // Label 1345: @92748
     /*  92748 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92797), // Rule ID 8507 //
     /*  92753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  92759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  92762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92766 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  92766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  92773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92778 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92791 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92793 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92795 */   GIR_RootConstrainSelectedInstOperands,
     /*  92796 */   // GIR_Coverage, 8507,
     /*  92796 */   GIR_EraseRootFromParent_Done,
     /*  92797 */ // Label 1447: @92797
     /*  92797 */ GIM_Reject,
     /*  92798 */ // Label 1346: @92798
     /*  92798 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92847), // Rule ID 8506 //
     /*  92803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  92809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  92812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92816 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  92816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  92823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92828 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92841 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92843 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92845 */   GIR_RootConstrainSelectedInstOperands,
     /*  92846 */   // GIR_Coverage, 8506,
     /*  92846 */   GIR_EraseRootFromParent_Done,
     /*  92847 */ // Label 1448: @92847
     /*  92847 */ GIM_Reject,
     /*  92848 */ // Label 1347: @92848
     /*  92848 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(94254),
     /*  92853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92863 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92981), // Rule ID 15858 //
     /*  92868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  92907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92923 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92931 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  92935 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92939 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92943 */     // MIs[5] Op3
     /*  92943 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  92948 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92952 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92960 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92962 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  92971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  92975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  92979 */     GIR_RootConstrainSelectedInstOperands,
     /*  92980 */     // GIR_Coverage, 15858,
     /*  92980 */     GIR_EraseRootFromParent_Done,
     /*  92981 */   // Label 1450: @92981
     /*  92981 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(93099), // Rule ID 15857 //
     /*  92986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93033 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93041 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93049 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93053 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93057 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93061 */     // MIs[5] Op3
     /*  93061 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93066 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93070 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93078 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93080 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93097 */     GIR_RootConstrainSelectedInstOperands,
     /*  93098 */     // GIR_Coverage, 15857,
     /*  93098 */     GIR_EraseRootFromParent_Done,
     /*  93099 */   // Label 1451: @93099
     /*  93099 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(93217), // Rule ID 15856 //
     /*  93104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93155 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93159 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93167 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93171 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93175 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93179 */     // MIs[5] Op3
     /*  93179 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93184 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93188 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93196 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93198 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93215 */     GIR_RootConstrainSelectedInstOperands,
     /*  93216 */     // GIR_Coverage, 15856,
     /*  93216 */     GIR_EraseRootFromParent_Done,
     /*  93217 */   // Label 1452: @93217
     /*  93217 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(93335), // Rule ID 15855 //
     /*  93222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93269 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93277 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93285 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93289 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93293 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93297 */     // MIs[5] Op3
     /*  93297 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93302 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93306 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93312 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93314 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93316 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93333 */     GIR_RootConstrainSelectedInstOperands,
     /*  93334 */     // GIR_Coverage, 15855,
     /*  93334 */     GIR_EraseRootFromParent_Done,
     /*  93335 */   // Label 1453: @93335
     /*  93335 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93453), // Rule ID 15852 //
     /*  93340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93383 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93387 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93391 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93395 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93399 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93403 */     // MIs[4] Op3
     /*  93403 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93408 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93412 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93420 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93424 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93432 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93434 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93451 */     GIR_RootConstrainSelectedInstOperands,
     /*  93452 */     // GIR_Coverage, 15852,
     /*  93452 */     GIR_EraseRootFromParent_Done,
     /*  93453 */   // Label 1454: @93453
     /*  93453 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93571), // Rule ID 15854 //
     /*  93458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93501 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93505 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93517 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93521 */     // MIs[4] Op3
     /*  93521 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93526 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93530 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93538 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93542 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93550 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93552 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93569 */     GIR_RootConstrainSelectedInstOperands,
     /*  93570 */     // GIR_Coverage, 15854,
     /*  93570 */     GIR_EraseRootFromParent_Done,
     /*  93571 */   // Label 1455: @93571
     /*  93571 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(93689), // Rule ID 11985 //
     /*  93576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93635 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93639 */     // MIs[4] Op3
     /*  93639 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93644 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93648 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93656 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93660 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93666 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93668 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93670 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93687 */     GIR_RootConstrainSelectedInstOperands,
     /*  93688 */     // GIR_Coverage, 11985,
     /*  93688 */     GIR_EraseRootFromParent_Done,
     /*  93689 */   // Label 1456: @93689
     /*  93689 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93807), // Rule ID 15853 //
     /*  93694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93741 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93745 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93749 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93753 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93757 */     // MIs[4] Op3
     /*  93757 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93762 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93766 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93774 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93778 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93786 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93788 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93805 */     GIR_RootConstrainSelectedInstOperands,
     /*  93806 */     // GIR_Coverage, 15853,
     /*  93806 */     GIR_EraseRootFromParent_Done,
     /*  93807 */   // Label 1457: @93807
     /*  93807 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93878), // Rule ID 15718 //
     /*  93812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93851 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93857 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93861 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93876 */     GIR_RootConstrainSelectedInstOperands,
     /*  93877 */     // GIR_Coverage, 15718,
     /*  93877 */     GIR_EraseRootFromParent_Done,
     /*  93878 */   // Label 1458: @93878
     /*  93878 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93949), // Rule ID 15717 //
     /*  93883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93922 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93928 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93932 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  93943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93947 */     GIR_RootConstrainSelectedInstOperands,
     /*  93948 */     // GIR_Coverage, 15717,
     /*  93948 */     GIR_EraseRootFromParent_Done,
     /*  93949 */   // Label 1459: @93949
     /*  93949 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(94020), // Rule ID 15716 //
     /*  93954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93993 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94003 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94018 */     GIR_RootConstrainSelectedInstOperands,
     /*  94019 */     // GIR_Coverage, 15716,
     /*  94019 */     GIR_EraseRootFromParent_Done,
     /*  94020 */   // Label 1460: @94020
     /*  94020 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(94091), // Rule ID 11949 //
     /*  94025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94064 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94074 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94089 */     GIR_RootConstrainSelectedInstOperands,
     /*  94090 */     // GIR_Coverage, 11949,
     /*  94090 */     GIR_EraseRootFromParent_Done,
     /*  94091 */   // Label 1461: @94091
     /*  94091 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(94152), // Rule ID 11984 //
     /*  94096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94115 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  94119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94123 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94133 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94150 */     GIR_RootConstrainSelectedInstOperands,
     /*  94151 */     // GIR_Coverage, 11984,
     /*  94151 */     GIR_EraseRootFromParent_Done,
     /*  94152 */   // Label 1462: @94152
     /*  94152 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(94195), // Rule ID 13818 //
     /*  94157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94178 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94193 */     GIR_RootConstrainSelectedInstOperands,
     /*  94194 */     // GIR_Coverage, 13818,
     /*  94194 */     GIR_EraseRootFromParent_Done,
     /*  94195 */   // Label 1463: @94195
     /*  94195 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94238), // Rule ID 3150 //
     /*  94200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94221 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94236 */     GIR_RootConstrainSelectedInstOperands,
     /*  94237 */     // GIR_Coverage, 3150,
     /*  94237 */     GIR_EraseRootFromParent_Done,
     /*  94238 */   // Label 1464: @94238
     /*  94238 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94253), // Rule ID 7526 //
     /*  94243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94246 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  94246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94251 */     GIR_RootConstrainSelectedInstOperands,
     /*  94252 */     // GIR_Coverage, 7526,
     /*  94252 */     GIR_Done,
     /*  94253 */   // Label 1465: @94253
     /*  94253 */   GIM_Reject,
     /*  94254 */ // Label 1449: @94254
     /*  94254 */ GIM_Reject,
     /*  94255 */ // Label 1348: @94255
     /*  94255 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94304), // Rule ID 8505 //
     /*  94260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  94266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  94269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94273 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  94273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  94280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94285 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94298 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94300 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94302 */   GIR_RootConstrainSelectedInstOperands,
     /*  94303 */   // GIR_Coverage, 8505,
     /*  94303 */   GIR_EraseRootFromParent_Done,
     /*  94304 */ // Label 1466: @94304
     /*  94304 */ GIM_Reject,
     /*  94305 */ // Label 1349: @94305
     /*  94305 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(95711),
     /*  94310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94320 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(94438), // Rule ID 15851 //
     /*  94325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94388 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94392 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94396 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94400 */     // MIs[5] Op3
     /*  94400 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94405 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94409 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94417 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94419 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94436 */     GIR_RootConstrainSelectedInstOperands,
     /*  94437 */     // GIR_Coverage, 15851,
     /*  94437 */     GIR_EraseRootFromParent_Done,
     /*  94438 */   // Label 1468: @94438
     /*  94438 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94556), // Rule ID 15850 //
     /*  94443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94498 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94514 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94518 */     // MIs[5] Op3
     /*  94518 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94523 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94527 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94535 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94537 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94554 */     GIR_RootConstrainSelectedInstOperands,
     /*  94555 */     // GIR_Coverage, 15850,
     /*  94555 */     GIR_EraseRootFromParent_Done,
     /*  94556 */   // Label 1469: @94556
     /*  94556 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(94674), // Rule ID 15849 //
     /*  94561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94616 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94622 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94624 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94628 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94632 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94636 */     // MIs[5] Op3
     /*  94636 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94641 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94645 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94653 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94655 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94672 */     GIR_RootConstrainSelectedInstOperands,
     /*  94673 */     // GIR_Coverage, 15849,
     /*  94673 */     GIR_EraseRootFromParent_Done,
     /*  94674 */   // Label 1470: @94674
     /*  94674 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94792), // Rule ID 15848 //
     /*  94679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94734 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94742 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94746 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94750 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94754 */     // MIs[5] Op3
     /*  94754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94759 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94763 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94771 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94773 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94790 */     GIR_RootConstrainSelectedInstOperands,
     /*  94791 */     // GIR_Coverage, 15848,
     /*  94791 */     GIR_EraseRootFromParent_Done,
     /*  94792 */   // Label 1471: @94792
     /*  94792 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94910), // Rule ID 15845 //
     /*  94797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94856 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94860 */     // MIs[4] Op3
     /*  94860 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94865 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94869 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94875 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94877 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94881 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94889 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94891 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94908 */     GIR_RootConstrainSelectedInstOperands,
     /*  94909 */     // GIR_Coverage, 15845,
     /*  94909 */     GIR_EraseRootFromParent_Done,
     /*  94910 */   // Label 1472: @94910
     /*  94910 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(95028), // Rule ID 15847 //
     /*  94915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94978 */     // MIs[4] Op3
     /*  94978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94983 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94987 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94995 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94999 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95009 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  95022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95026 */     GIR_RootConstrainSelectedInstOperands,
     /*  95027 */     // GIR_Coverage, 15847,
     /*  95027 */     GIR_EraseRootFromParent_Done,
     /*  95028 */   // Label 1473: @95028
     /*  95028 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(95146), // Rule ID 11983 //
     /*  95033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95080 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95088 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95092 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95096 */     // MIs[4] Op3
     /*  95096 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95101 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95105 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95111 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95113 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95117 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95123 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95125 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95127 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95144 */     GIR_RootConstrainSelectedInstOperands,
     /*  95145 */     // GIR_Coverage, 11983,
     /*  95145 */     GIR_EraseRootFromParent_Done,
     /*  95146 */   // Label 1474: @95146
     /*  95146 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(95264), // Rule ID 15846 //
     /*  95151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95210 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95214 */     // MIs[4] Op3
     /*  95214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95219 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95223 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95229 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95231 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95235 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95241 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95243 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95245 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95262 */     GIR_RootConstrainSelectedInstOperands,
     /*  95263 */     // GIR_Coverage, 15846,
     /*  95263 */     GIR_EraseRootFromParent_Done,
     /*  95264 */   // Label 1475: @95264
     /*  95264 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(95335), // Rule ID 15715 //
     /*  95269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95308 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95314 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95318 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95333 */     GIR_RootConstrainSelectedInstOperands,
     /*  95334 */     // GIR_Coverage, 15715,
     /*  95334 */     GIR_EraseRootFromParent_Done,
     /*  95335 */   // Label 1476: @95335
     /*  95335 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95406), // Rule ID 15714 //
     /*  95340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95379 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95389 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95404 */     GIR_RootConstrainSelectedInstOperands,
     /*  95405 */     // GIR_Coverage, 15714,
     /*  95405 */     GIR_EraseRootFromParent_Done,
     /*  95406 */   // Label 1477: @95406
     /*  95406 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95477), // Rule ID 15713 //
     /*  95411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95450 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95460 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95475 */     GIR_RootConstrainSelectedInstOperands,
     /*  95476 */     // GIR_Coverage, 15713,
     /*  95476 */     GIR_EraseRootFromParent_Done,
     /*  95477 */   // Label 1478: @95477
     /*  95477 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95548), // Rule ID 11947 //
     /*  95482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95521 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95531 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95546 */     GIR_RootConstrainSelectedInstOperands,
     /*  95547 */     // GIR_Coverage, 11947,
     /*  95547 */     GIR_EraseRootFromParent_Done,
     /*  95548 */   // Label 1479: @95548
     /*  95548 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95609), // Rule ID 11982 //
     /*  95553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  95576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95580 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95590 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95607 */     GIR_RootConstrainSelectedInstOperands,
     /*  95608 */     // GIR_Coverage, 11982,
     /*  95608 */     GIR_EraseRootFromParent_Done,
     /*  95609 */   // Label 1480: @95609
     /*  95609 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95652), // Rule ID 13817 //
     /*  95614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95635 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  95644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  95650 */     GIR_RootConstrainSelectedInstOperands,
     /*  95651 */     // GIR_Coverage, 13817,
     /*  95651 */     GIR_EraseRootFromParent_Done,
     /*  95652 */   // Label 1481: @95652
     /*  95652 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95695), // Rule ID 3148 //
     /*  95657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95678 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  95693 */     GIR_RootConstrainSelectedInstOperands,
     /*  95694 */     // GIR_Coverage, 3148,
     /*  95694 */     GIR_EraseRootFromParent_Done,
     /*  95695 */   // Label 1482: @95695
     /*  95695 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95710), // Rule ID 7525 //
     /*  95700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95703 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  95703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  95708 */     GIR_RootConstrainSelectedInstOperands,
     /*  95709 */     // GIR_Coverage, 7525,
     /*  95709 */     GIR_Done,
     /*  95710 */   // Label 1483: @95710
     /*  95710 */   GIM_Reject,
     /*  95711 */ // Label 1467: @95711
     /*  95711 */ GIM_Reject,
     /*  95712 */ // Label 1350: @95712
     /*  95712 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95761), // Rule ID 8504 //
     /*  95717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  95723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  95726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  95730 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  95730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  95733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  95737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95742 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  95745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  95750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  95752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95755 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95757 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  95759 */   GIR_RootConstrainSelectedInstOperands,
     /*  95760 */   // GIR_Coverage, 8504,
     /*  95760 */   GIR_EraseRootFromParent_Done,
     /*  95761 */ // Label 1484: @95761
     /*  95761 */ GIM_Reject,
     /*  95762 */ // Label 1351: @95762
     /*  95762 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(97168),
     /*  95767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95777 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(95895), // Rule ID 15844 //
     /*  95782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95833 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95837 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95853 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95857 */     // MIs[5] Op3
     /*  95857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95862 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95866 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95874 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95876 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95893 */     GIR_RootConstrainSelectedInstOperands,
     /*  95894 */     // GIR_Coverage, 15844,
     /*  95894 */     GIR_EraseRootFromParent_Done,
     /*  95895 */   // Label 1486: @95895
     /*  95895 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(96013), // Rule ID 15843 //
     /*  95900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95963 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95967 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95971 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95975 */     // MIs[5] Op3
     /*  95975 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95980 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95984 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95990 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95992 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95994 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  96007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96011 */     GIR_RootConstrainSelectedInstOperands,
     /*  96012 */     // GIR_Coverage, 15843,
     /*  96012 */     GIR_EraseRootFromParent_Done,
     /*  96013 */   // Label 1487: @96013
     /*  96013 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(96131), // Rule ID 15842 //
     /*  96018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96081 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96085 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96089 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96093 */     // MIs[5] Op3
     /*  96093 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96098 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96102 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96110 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96112 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96129 */     GIR_RootConstrainSelectedInstOperands,
     /*  96130 */     // GIR_Coverage, 15842,
     /*  96130 */     GIR_EraseRootFromParent_Done,
     /*  96131 */   // Label 1488: @96131
     /*  96131 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(96249), // Rule ID 15841 //
     /*  96136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96187 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96191 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96197 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96207 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96211 */     // MIs[5] Op3
     /*  96211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96220 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96228 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96230 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96247 */     GIR_RootConstrainSelectedInstOperands,
     /*  96248 */     // GIR_Coverage, 15841,
     /*  96248 */     GIR_EraseRootFromParent_Done,
     /*  96249 */   // Label 1489: @96249
     /*  96249 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(96367), // Rule ID 15838 //
     /*  96254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96305 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96309 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96313 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96317 */     // MIs[4] Op3
     /*  96317 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96322 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96326 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96338 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96346 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96348 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96365 */     GIR_RootConstrainSelectedInstOperands,
     /*  96366 */     // GIR_Coverage, 15838,
     /*  96366 */     GIR_EraseRootFromParent_Done,
     /*  96367 */   // Label 1490: @96367
     /*  96367 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96485), // Rule ID 15840 //
     /*  96372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96415 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96419 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96431 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96435 */     // MIs[4] Op3
     /*  96435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96440 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96444 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96456 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96464 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96466 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96483 */     GIR_RootConstrainSelectedInstOperands,
     /*  96484 */     // GIR_Coverage, 15840,
     /*  96484 */     GIR_EraseRootFromParent_Done,
     /*  96485 */   // Label 1491: @96485
     /*  96485 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(96603), // Rule ID 11981 //
     /*  96490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96545 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96549 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96553 */     // MIs[4] Op3
     /*  96553 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96558 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96562 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96574 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96582 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96584 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96601 */     GIR_RootConstrainSelectedInstOperands,
     /*  96602 */     // GIR_Coverage, 11981,
     /*  96602 */     GIR_EraseRootFromParent_Done,
     /*  96603 */   // Label 1492: @96603
     /*  96603 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96721), // Rule ID 15839 //
     /*  96608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96667 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96671 */     // MIs[4] Op3
     /*  96671 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96676 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96680 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96692 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96700 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96702 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96719 */     GIR_RootConstrainSelectedInstOperands,
     /*  96720 */     // GIR_Coverage, 15839,
     /*  96720 */     GIR_EraseRootFromParent_Done,
     /*  96721 */   // Label 1493: @96721
     /*  96721 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96792), // Rule ID 15712 //
     /*  96726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96765 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96775 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96790 */     GIR_RootConstrainSelectedInstOperands,
     /*  96791 */     // GIR_Coverage, 15712,
     /*  96791 */     GIR_EraseRootFromParent_Done,
     /*  96792 */   // Label 1494: @96792
     /*  96792 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96863), // Rule ID 15711 //
     /*  96797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96836 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96846 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96861 */     GIR_RootConstrainSelectedInstOperands,
     /*  96862 */     // GIR_Coverage, 15711,
     /*  96862 */     GIR_EraseRootFromParent_Done,
     /*  96863 */   // Label 1495: @96863
     /*  96863 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96934), // Rule ID 15710 //
     /*  96868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96907 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96913 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96917 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96932 */     GIR_RootConstrainSelectedInstOperands,
     /*  96933 */     // GIR_Coverage, 15710,
     /*  96933 */     GIR_EraseRootFromParent_Done,
     /*  96934 */   // Label 1496: @96934
     /*  96934 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(97005), // Rule ID 11945 //
     /*  96939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96978 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96988 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97003 */     GIR_RootConstrainSelectedInstOperands,
     /*  97004 */     // GIR_Coverage, 11945,
     /*  97004 */     GIR_EraseRootFromParent_Done,
     /*  97005 */   // Label 1497: @97005
     /*  97005 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(97066), // Rule ID 11980 //
     /*  97010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  97021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97029 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  97033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97037 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97047 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97064 */     GIR_RootConstrainSelectedInstOperands,
     /*  97065 */     // GIR_Coverage, 11980,
     /*  97065 */     GIR_EraseRootFromParent_Done,
     /*  97066 */   // Label 1498: @97066
     /*  97066 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(97109), // Rule ID 13816 //
     /*  97071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97092 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97107 */     GIR_RootConstrainSelectedInstOperands,
     /*  97108 */     // GIR_Coverage, 13816,
     /*  97108 */     GIR_EraseRootFromParent_Done,
     /*  97109 */   // Label 1499: @97109
     /*  97109 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(97152), // Rule ID 3146 //
     /*  97114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97135 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97150 */     GIR_RootConstrainSelectedInstOperands,
     /*  97151 */     // GIR_Coverage, 3146,
     /*  97151 */     GIR_EraseRootFromParent_Done,
     /*  97152 */   // Label 1500: @97152
     /*  97152 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97167), // Rule ID 7524 //
     /*  97157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97160 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  97160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97165 */     GIR_RootConstrainSelectedInstOperands,
     /*  97166 */     // GIR_Coverage, 7524,
     /*  97166 */     GIR_Done,
     /*  97167 */   // Label 1501: @97167
     /*  97167 */   GIM_Reject,
     /*  97168 */ // Label 1485: @97168
     /*  97168 */ GIM_Reject,
     /*  97169 */ // Label 1352: @97169
     /*  97169 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97218), // Rule ID 8503 //
     /*  97174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  97180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  97183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  97187 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  97187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  97190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  97194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97199 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  97202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  97207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  97209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97212 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97214 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  97216 */   GIR_RootConstrainSelectedInstOperands,
     /*  97217 */   // GIR_Coverage, 8503,
     /*  97217 */   GIR_EraseRootFromParent_Done,
     /*  97218 */ // Label 1502: @97218
     /*  97218 */ GIM_Reject,
     /*  97219 */ // Label 1353: @97219
     /*  97219 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(98625),
     /*  97224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(97352), // Rule ID 15837 //
     /*  97239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97294 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97302 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97306 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97310 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97314 */     // MIs[5] Op3
     /*  97314 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97319 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97323 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97331 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97333 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97350 */     GIR_RootConstrainSelectedInstOperands,
     /*  97351 */     // GIR_Coverage, 15837,
     /*  97351 */     GIR_EraseRootFromParent_Done,
     /*  97352 */   // Label 1504: @97352
     /*  97352 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(97470), // Rule ID 15836 //
     /*  97357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97420 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97424 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97428 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97432 */     // MIs[5] Op3
     /*  97432 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97437 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97441 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97447 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97449 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97451 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  97460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97468 */     GIR_RootConstrainSelectedInstOperands,
     /*  97469 */     // GIR_Coverage, 15836,
     /*  97469 */     GIR_EraseRootFromParent_Done,
     /*  97470 */   // Label 1505: @97470
     /*  97470 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(97588), // Rule ID 15835 //
     /*  97475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97518 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97522 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97530 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97538 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97542 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97546 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97550 */     // MIs[5] Op3
     /*  97550 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97555 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97559 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97565 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97567 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97569 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  97582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97586 */     GIR_RootConstrainSelectedInstOperands,
     /*  97587 */     // GIR_Coverage, 15835,
     /*  97587 */     GIR_EraseRootFromParent_Done,
     /*  97588 */   // Label 1506: @97588
     /*  97588 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(97706), // Rule ID 15834 //
     /*  97593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97648 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97656 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97660 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97664 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97668 */     // MIs[5] Op3
     /*  97668 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97673 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97677 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97683 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97685 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97687 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  97696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  97700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97704 */     GIR_RootConstrainSelectedInstOperands,
     /*  97705 */     // GIR_Coverage, 15834,
     /*  97705 */     GIR_EraseRootFromParent_Done,
     /*  97706 */   // Label 1507: @97706
     /*  97706 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(97824), // Rule ID 15831 //
     /*  97711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97758 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  97766 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97770 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97774 */     // MIs[4] Op3
     /*  97774 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  97779 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  97783 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  97791 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97795 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97803 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97805 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  97814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  97818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  97822 */     GIR_RootConstrainSelectedInstOperands,
     /*  97823 */     // GIR_Coverage, 15831,
     /*  97823 */     GIR_EraseRootFromParent_Done,
     /*  97824 */   // Label 1508: @97824
     /*  97824 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(97942), // Rule ID 15833 //
     /*  97829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  97884 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97888 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97892 */     // MIs[4] Op3
     /*  97892 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  97897 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  97901 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  97909 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97913 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97921 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97923 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  97932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  97936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97940 */     GIR_RootConstrainSelectedInstOperands,
     /*  97941 */     // GIR_Coverage, 15833,
     /*  97941 */     GIR_EraseRootFromParent_Done,
     /*  97942 */   // Label 1509: @97942
     /*  97942 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(98060), // Rule ID 11979 //
     /*  97947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97994 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98006 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98010 */     // MIs[4] Op3
     /*  98010 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  98015 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98019 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98025 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98027 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98031 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98039 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98041 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  98050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  98058 */     GIR_RootConstrainSelectedInstOperands,
     /*  98059 */     // GIR_Coverage, 11979,
     /*  98059 */     GIR_EraseRootFromParent_Done,
     /*  98060 */   // Label 1510: @98060
     /*  98060 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(98178), // Rule ID 15832 //
     /*  98065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  98076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  98104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98124 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98128 */     // MIs[4] Op3
     /*  98128 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  98133 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98137 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98145 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98149 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98157 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98159 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  98168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98176 */     GIR_RootConstrainSelectedInstOperands,
     /*  98177 */     // GIR_Coverage, 15832,
     /*  98177 */     GIR_EraseRootFromParent_Done,
     /*  98178 */   // Label 1511: @98178
     /*  98178 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(98249), // Rule ID 15709 //
     /*  98183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98232 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98247 */     GIR_RootConstrainSelectedInstOperands,
     /*  98248 */     // GIR_Coverage, 15709,
     /*  98248 */     GIR_EraseRootFromParent_Done,
     /*  98249 */   // Label 1512: @98249
     /*  98249 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(98320), // Rule ID 15708 //
     /*  98254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98293 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98299 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98303 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98318 */     GIR_RootConstrainSelectedInstOperands,
     /*  98319 */     // GIR_Coverage, 15708,
     /*  98319 */     GIR_EraseRootFromParent_Done,
     /*  98320 */   // Label 1513: @98320
     /*  98320 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(98391), // Rule ID 15707 //
     /*  98325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98364 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98370 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98374 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98389 */     GIR_RootConstrainSelectedInstOperands,
     /*  98390 */     // GIR_Coverage, 15707,
     /*  98390 */     GIR_EraseRootFromParent_Done,
     /*  98391 */   // Label 1514: @98391
     /*  98391 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(98462), // Rule ID 11943 //
     /*  98396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98435 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98445 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98460 */     GIR_RootConstrainSelectedInstOperands,
     /*  98461 */     // GIR_Coverage, 11943,
     /*  98461 */     GIR_EraseRootFromParent_Done,
     /*  98462 */   // Label 1515: @98462
     /*  98462 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(98523), // Rule ID 11978 //
     /*  98467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  98478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98486 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  98490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  98494 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98500 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  98502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98504 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  98513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  98517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  98521 */     GIR_RootConstrainSelectedInstOperands,
     /*  98522 */     // GIR_Coverage, 11978,
     /*  98522 */     GIR_EraseRootFromParent_Done,
     /*  98523 */   // Label 1516: @98523
     /*  98523 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(98566), // Rule ID 13815 //
     /*  98528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98549 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  98558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  98564 */     GIR_RootConstrainSelectedInstOperands,
     /*  98565 */     // GIR_Coverage, 13815,
     /*  98565 */     GIR_EraseRootFromParent_Done,
     /*  98566 */   // Label 1517: @98566
     /*  98566 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(98609), // Rule ID 3144 //
     /*  98571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98592 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  98607 */     GIR_RootConstrainSelectedInstOperands,
     /*  98608 */     // GIR_Coverage, 3144,
     /*  98608 */     GIR_EraseRootFromParent_Done,
     /*  98609 */   // Label 1518: @98609
     /*  98609 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(98624), // Rule ID 7523 //
     /*  98614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  98617 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  98617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  98622 */     GIR_RootConstrainSelectedInstOperands,
     /*  98623 */     // GIR_Coverage, 7523,
     /*  98623 */     GIR_Done,
     /*  98624 */   // Label 1519: @98624
     /*  98624 */   GIM_Reject,
     /*  98625 */ // Label 1503: @98625
     /*  98625 */ GIM_Reject,
     /*  98626 */ // Label 1354: @98626
     /*  98626 */ GIM_Reject,
     /*  98627 */ // Label 8: @98627
     /*  98627 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(106150),
     /*  98632 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  98635 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1532*/ GIMT_Encode4(106149),
     /*  98646 */   /*GILLT_v2s64*//*Label 1521*/ GIMT_Encode4(98714), GIMT_Encode4(0),
     /*  98654 */   /*GILLT_v4s32*//*Label 1522*/ GIMT_Encode4(99235), GIMT_Encode4(0),
     /*  98662 */   /*GILLT_v8s16*//*Label 1523*/ GIMT_Encode4(101647),
     /*  98666 */   /*GILLT_v16s8*//*Label 1524*/ GIMT_Encode4(104056), GIMT_Encode4(0),
     /*  98674 */   /*GILLT_nxv2s1*//*Label 1525*/ GIMT_Encode4(105967), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98690 */   /*GILLT_nxv4s1*//*Label 1526*/ GIMT_Encode4(105993),
     /*  98694 */   /*GILLT_nxv4s16*//*Label 1527*/ GIMT_Encode4(106019),
     /*  98698 */   /*GILLT_nxv4s32*//*Label 1528*/ GIMT_Encode4(106045),
     /*  98702 */   /*GILLT_nxv8s1*//*Label 1529*/ GIMT_Encode4(106071),
     /*  98706 */   /*GILLT_nxv8s16*//*Label 1530*/ GIMT_Encode4(106097),
     /*  98710 */   /*GILLT_nxv16s1*//*Label 1531*/ GIMT_Encode4(106123),
     /*  98714 */   // Label 1521: @98714
     /*  98714 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(99234),
     /*  98719 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  98725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98733 */     GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98795), // Rule ID 5827 //
     /*  98738 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98742 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98748 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  98750 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98752 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  98752 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98755 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  98759 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98764 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98770 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98773 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98775 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98778 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98781 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98784 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98789 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98794 */       // GIR_Coverage, 5827,
     /*  98794 */       GIR_EraseRootFromParent_Done,
     /*  98795 */     // Label 1534: @98795
     /*  98795 */     GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98857), // Rule ID 5831 //
     /*  98800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98804 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98810 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  98812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98814 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  98814 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98817 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  98821 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98826 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98830 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98832 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98835 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98837 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98840 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98843 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98846 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98851 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98856 */       // GIR_Coverage, 5831,
     /*  98856 */       GIR_EraseRootFromParent_Done,
     /*  98857 */     // Label 1535: @98857
     /*  98857 */     GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98915), // Rule ID 5828 //
     /*  98862 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98866 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  98870 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  98872 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  98875 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98879 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98886 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98889 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98891 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98894 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  98896 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98899 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98904 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98909 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98914 */       // GIR_Coverage, 5828,
     /*  98914 */       GIR_EraseRootFromParent_Done,
     /*  98915 */     // Label 1536: @98915
     /*  98915 */     GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98973), // Rule ID 5832 //
     /*  98920 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98924 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  98928 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98930 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  98930 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  98933 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98937 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98942 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98944 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98947 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98949 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98952 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  98954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98957 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98962 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98967 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98972 */       // GIR_Coverage, 5832,
     /*  98972 */       GIR_EraseRootFromParent_Done,
     /*  98973 */     // Label 1537: @98973
     /*  98973 */     GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99103), // Rule ID 5826 //
     /*  98978 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98982 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  98982 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  98985 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98989 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98994 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98996 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  98999 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99003 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99008 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99011 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99015 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99018 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99023 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99028 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99033 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99036 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99040 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99045 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99047 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99050 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99054 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99059 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99062 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99066 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99069 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99074 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99079 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99084 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99087 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99089 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99092 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99095 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99098 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99101 */       GIR_RootConstrainSelectedInstOperands,
     /*  99102 */       // GIR_Coverage, 5826,
     /*  99102 */       GIR_EraseRootFromParent_Done,
     /*  99103 */     // Label 1538: @99103
     /*  99103 */     GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99233), // Rule ID 5830 //
     /*  99108 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99112 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99112 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99115 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99119 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99124 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99126 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99129 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99133 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99138 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99141 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99145 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99148 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99153 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99158 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99163 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99166 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99170 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99175 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99177 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99180 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99184 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99189 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99192 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99196 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99199 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99219 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99222 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99225 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99228 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99231 */       GIR_RootConstrainSelectedInstOperands,
     /*  99232 */       // GIR_Coverage, 5830,
     /*  99232 */       GIR_EraseRootFromParent_Done,
     /*  99233 */     // Label 1539: @99233
     /*  99233 */     GIM_Reject,
     /*  99234 */   // Label 1533: @99234
     /*  99234 */   GIM_Reject,
     /*  99235 */   // Label 1522: @99235
     /*  99235 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(101646),
     /*  99240 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  99246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99250 */     GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99379), // Rule ID 5450 //
     /*  99255 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99259 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99263 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99267 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99271 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99275 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99279 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99283 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99287 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  99291 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99295 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99299 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  99308 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99314 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  99316 */       // MIs[2] Operand 2
     /*  99316 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99327 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  99329 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  99329 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99332 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99336 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99341 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99344 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99348 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99351 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99356 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99361 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99364 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99366 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99369 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99373 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99377 */       GIR_RootConstrainSelectedInstOperands,
     /*  99378 */       // GIR_Coverage, 5450,
     /*  99378 */       GIR_EraseRootFromParent_Done,
     /*  99379 */     // Label 1541: @99379
     /*  99379 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99501), // Rule ID 5446 //
     /*  99384 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99388 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99392 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99396 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99400 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99404 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99408 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99412 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99416 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  99420 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99424 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99428 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99433 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99438 */       // MIs[2] Operand 2
     /*  99438 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99449 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99451 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99451 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99454 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99458 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99463 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99466 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99470 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99473 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99478 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  99486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99488 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99491 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99495 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99499 */       GIR_RootConstrainSelectedInstOperands,
     /*  99500 */       // GIR_Coverage, 5446,
     /*  99500 */       GIR_EraseRootFromParent_Done,
     /*  99501 */     // Label 1542: @99501
     /*  99501 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99623), // Rule ID 5448 //
     /*  99506 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99510 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99514 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99518 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99522 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99526 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99530 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99534 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99538 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  99542 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99546 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99550 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99555 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99560 */       // MIs[2] Operand 2
     /*  99560 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99571 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99573 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99573 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99576 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99580 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99585 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99588 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99592 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99595 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99600 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99605 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99608 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99610 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99613 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99617 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99621 */       GIR_RootConstrainSelectedInstOperands,
     /*  99622 */       // GIR_Coverage, 5448,
     /*  99622 */       GIR_EraseRootFromParent_Done,
     /*  99623 */     // Label 1543: @99623
     /*  99623 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99725), // Rule ID 5596 //
     /*  99628 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99632 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99636 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99640 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99644 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99648 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99652 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99657 */       // MIs[2] Operand 2
     /*  99657 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99668 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  99672 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99676 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99680 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  99684 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99688 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99692 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99697 */       // MIs[4] Operand 2
     /*  99697 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  99708 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  99710 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  99710 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  99713 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99715 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  99719 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  99723 */       GIR_RootConstrainSelectedInstOperands,
     /*  99724 */       // GIR_Coverage, 5596,
     /*  99724 */       GIR_EraseRootFromParent_Done,
     /*  99725 */     // Label 1544: @99725
     /*  99725 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99854), // Rule ID 6382 //
     /*  99730 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99734 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99738 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99742 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99745 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  99750 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99754 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99758 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99763 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  99767 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99769 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  99769 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  99772 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  99776 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99781 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99786 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99789 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99793 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99798 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99800 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99803 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99807 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99812 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99815 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  99819 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99822 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99827 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99832 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99837 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  99840 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99842 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99845 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  99849 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99852 */       GIR_RootConstrainSelectedInstOperands,
     /*  99853 */       // GIR_Coverage, 6382,
     /*  99853 */       GIR_EraseRootFromParent_Done,
     /*  99854 */     // Label 1545: @99854
     /*  99854 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99896), // Rule ID 5837 //
     /*  99859 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  99866 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  99873 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  99873 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99876 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99878 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  99883 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99886 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99891 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99894 */       GIR_RootConstrainSelectedInstOperands,
     /*  99895 */       // GIR_Coverage, 5837,
     /*  99895 */       GIR_EraseRootFromParent_Done,
     /*  99896 */     // Label 1546: @99896
     /*  99896 */     GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99938), // Rule ID 5841 //
     /*  99901 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  99908 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  99915 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  99915 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99918 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99920 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  99925 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99928 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99933 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99936 */       GIR_RootConstrainSelectedInstOperands,
     /*  99937 */       // GIR_Coverage, 5841,
     /*  99937 */       GIR_EraseRootFromParent_Done,
     /*  99938 */     // Label 1547: @99938
     /*  99938 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100061), // Rule ID 2574 //
     /*  99943 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99946 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99950 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99954 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99958 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99961 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  99966 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99970 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99974 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99979 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  99983 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  99987 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  99991 */       // MIs[2] Operand 1
     /*  99991 */       // No operand predicates
     /*  99991 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  99993 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  99993 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99996 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100000 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100005 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100007 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100010 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100014 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100019 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100022 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100026 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100029 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100034 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100044 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /* 100047 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100049 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100052 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100056 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100059 */       GIR_RootConstrainSelectedInstOperands,
     /* 100060 */       // GIR_Coverage, 2574,
     /* 100060 */       GIR_EraseRootFromParent_Done,
     /* 100061 */     // Label 1548: @100061
     /* 100061 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100184), // Rule ID 6352 //
     /* 100066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100081 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100085 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100089 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 100093 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100097 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100102 */       // MIs[2] imm
     /* 100102 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100106 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100110 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100114 */       // MIs[3] Operand 1
     /* 100114 */       // No operand predicates
     /* 100114 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100116 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 100116 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100119 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100123 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100128 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100130 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100133 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100137 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100142 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100145 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100149 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100157 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100162 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100167 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100170 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100172 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100175 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100179 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100182 */       GIR_RootConstrainSelectedInstOperands,
     /* 100183 */       // GIR_Coverage, 6352,
     /* 100183 */       GIR_EraseRootFromParent_Done,
     /* 100184 */     // Label 1549: @100184
     /* 100184 */     GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(100304), // Rule ID 6388 //
     /* 100189 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100193 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100197 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100201 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100205 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100209 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100213 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100217 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100222 */       // MIs[2] imm
     /* 100222 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100226 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100230 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100234 */       // MIs[3] Operand 1
     /* 100234 */       // No operand predicates
     /* 100234 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100236 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100236 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100239 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100243 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100248 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100250 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100253 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100257 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100262 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100265 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100269 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100277 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100282 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100287 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100290 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100292 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100295 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100299 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100302 */       GIR_RootConstrainSelectedInstOperands,
     /* 100303 */       // GIR_Coverage, 6388,
     /* 100303 */       GIR_EraseRootFromParent_Done,
     /* 100304 */     // Label 1550: @100304
     /* 100304 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100421), // Rule ID 2497 //
     /* 100309 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100312 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100316 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100320 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100324 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100327 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 100332 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100336 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100340 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100345 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100350 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100352 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100352 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100355 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100359 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100364 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100366 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100369 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100373 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100378 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100381 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100385 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100388 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100393 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100398 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100403 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /* 100406 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100408 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100411 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100415 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100419 */       GIR_RootConstrainSelectedInstOperands,
     /* 100420 */       // GIR_Coverage, 2497,
     /* 100420 */       GIR_EraseRootFromParent_Done,
     /* 100421 */     // Label 1551: @100421
     /* 100421 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100538), // Rule ID 5366 //
     /* 100426 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100429 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100433 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100437 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100441 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100444 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 100449 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100453 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100457 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100462 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100467 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100469 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100469 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100472 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100476 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100481 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100483 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100486 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100490 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100495 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100498 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100502 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100505 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100510 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100515 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100520 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /* 100523 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100525 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100528 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100532 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100536 */       GIR_RootConstrainSelectedInstOperands,
     /* 100537 */       // GIR_Coverage, 5366,
     /* 100537 */       GIR_EraseRootFromParent_Done,
     /* 100538 */     // Label 1552: @100538
     /* 100538 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100655), // Rule ID 5369 //
     /* 100543 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100546 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100550 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100554 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100558 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100561 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 100566 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100570 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100574 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100579 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100584 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100586 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100586 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100589 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100593 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100598 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100600 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100603 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100607 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100612 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100615 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100619 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100622 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100627 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100637 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /* 100640 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100642 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100645 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100649 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100653 */       GIR_RootConstrainSelectedInstOperands,
     /* 100654 */       // GIR_Coverage, 5369,
     /* 100654 */       GIR_EraseRootFromParent_Done,
     /* 100655 */     // Label 1553: @100655
     /* 100655 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100772), // Rule ID 5372 //
     /* 100660 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100663 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100671 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100675 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100678 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 100683 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100687 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100691 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100696 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100701 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100703 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 668:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100703 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100706 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100710 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100715 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100717 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100720 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100724 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100729 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100732 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100736 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100739 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100754 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /* 100757 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100759 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100762 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100766 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100770 */       GIR_RootConstrainSelectedInstOperands,
     /* 100771 */       // GIR_Coverage, 5372,
     /* 100771 */       GIR_EraseRootFromParent_Done,
     /* 100772 */     // Label 1554: @100772
     /* 100772 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100876), // Rule ID 2493 //
     /* 100777 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100780 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100784 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100788 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100792 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 100795 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 100800 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100804 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100809 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100811 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 100811 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100814 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100818 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100823 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100825 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100828 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100832 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100837 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100840 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100844 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100847 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100852 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100857 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100862 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /* 100865 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100867 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100870 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100874 */       GIR_RootConstrainSelectedInstOperands,
     /* 100875 */       // GIR_Coverage, 2493,
     /* 100875 */       GIR_EraseRootFromParent_Done,
     /* 100876 */     // Label 1555: @100876
     /* 100876 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100932), // Rule ID 5529 //
     /* 100881 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100885 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100889 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100893 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100898 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 100902 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100906 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100910 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100915 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100917 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 100917 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 100920 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100922 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 100926 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 100930 */       GIR_RootConstrainSelectedInstOperands,
     /* 100931 */       // GIR_Coverage, 5529,
     /* 100931 */       GIR_EraseRootFromParent_Done,
     /* 100932 */     // Label 1556: @100932
     /* 100932 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100998), // Rule ID 5835 //
     /* 100937 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100941 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100945 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 100951 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 100953 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100955 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 100955 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 100958 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 100962 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100967 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 100971 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100978 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100981 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100984 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 100987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100992 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100997 */       // GIR_Coverage, 5835,
     /* 100997 */       GIR_EraseRootFromParent_Done,
     /* 100998 */     // Label 1557: @100998
     /* 100998 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(101064), // Rule ID 5839 //
     /* 101003 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101007 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101011 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101017 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101019 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101021 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /* 101021 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101024 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101028 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101033 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101037 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101039 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101042 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101047 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101050 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101053 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101058 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101063 */       // GIR_Coverage, 5839,
     /* 101063 */       GIR_EraseRootFromParent_Done,
     /* 101064 */     // Label 1558: @101064
     /* 101064 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101157), // Rule ID 4954 //
     /* 101069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 101081 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101085 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101090 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101092 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 101092 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101095 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101099 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101104 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101118 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101121 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101125 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101128 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101133 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101138 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101143 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /* 101146 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101148 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101151 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101155 */       GIR_RootConstrainSelectedInstOperands,
     /* 101156 */       // GIR_Coverage, 4954,
     /* 101156 */       GIR_EraseRootFromParent_Done,
     /* 101157 */     // Label 1559: @101157
     /* 101157 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101253), // Rule ID 5001 //
     /* 101162 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101165 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101169 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101173 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101177 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101181 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101186 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101188 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /* 101188 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101191 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101195 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101200 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101202 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101205 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101209 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101214 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101217 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101221 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101224 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101229 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101234 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101239 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /* 101242 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101244 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101247 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101251 */       GIR_RootConstrainSelectedInstOperands,
     /* 101252 */       // GIR_Coverage, 5001,
     /* 101252 */       GIR_EraseRootFromParent_Done,
     /* 101253 */     // Label 1560: @101253
     /* 101253 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101315), // Rule ID 5836 //
     /* 101258 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101262 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101266 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101272 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /* 101272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101284 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101291 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101294 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101296 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101299 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101314 */       // GIR_Coverage, 5836,
     /* 101314 */       GIR_EraseRootFromParent_Done,
     /* 101315 */     // Label 1561: @101315
     /* 101315 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101377), // Rule ID 5840 //
     /* 101320 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101324 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101328 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101332 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101334 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /* 101334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101346 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101348 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101351 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101353 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101356 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101358 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101361 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101366 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101376 */       // GIR_Coverage, 5840,
     /* 101376 */       GIR_EraseRootFromParent_Done,
     /* 101377 */     // Label 1562: @101377
     /* 101377 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101511), // Rule ID 5834 //
     /* 101382 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101386 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101390 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101390 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101393 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101397 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101402 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101404 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101407 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101411 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101416 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101419 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101423 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101426 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101431 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101436 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101441 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101444 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101448 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101453 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101455 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101458 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101462 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101467 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101470 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101474 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101482 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101487 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101492 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 101495 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101497 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101500 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101503 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101506 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101509 */       GIR_RootConstrainSelectedInstOperands,
     /* 101510 */       // GIR_Coverage, 5834,
     /* 101510 */       GIR_EraseRootFromParent_Done,
     /* 101511 */     // Label 1563: @101511
     /* 101511 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101645), // Rule ID 5838 //
     /* 101516 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101520 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101524 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101524 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101527 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101531 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101536 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101538 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101541 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101545 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101550 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101553 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101557 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101560 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101565 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101570 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101575 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101578 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101582 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101587 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101589 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101592 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101596 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101601 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101604 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101608 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101611 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101616 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101621 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101626 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 101629 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101631 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101634 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101637 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101640 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101643 */       GIR_RootConstrainSelectedInstOperands,
     /* 101644 */       // GIR_Coverage, 5838,
     /* 101644 */       GIR_EraseRootFromParent_Done,
     /* 101645 */     // Label 1564: @101645
     /* 101645 */     GIM_Reject,
     /* 101646 */   // Label 1540: @101646
     /* 101646 */   GIM_Reject,
     /* 101647 */   // Label 1523: @101647
     /* 101647 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(104055),
     /* 101652 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 101655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 101658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101662 */     GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(101791), // Rule ID 5444 //
     /* 101667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101679 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101683 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101687 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101691 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101695 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101699 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 101703 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101707 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101711 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101716 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 101720 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101726 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 101728 */       // MIs[2] Operand 2
     /* 101728 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101739 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 101741 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 101741 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101744 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101748 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101753 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 101756 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101760 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101763 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101768 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101773 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 101776 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101778 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101781 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 101785 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 101789 */       GIR_RootConstrainSelectedInstOperands,
     /* 101790 */       // GIR_Coverage, 5444,
     /* 101790 */       GIR_EraseRootFromParent_Done,
     /* 101791 */     // Label 1566: @101791
     /* 101791 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101913), // Rule ID 5440 //
     /* 101796 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101804 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101808 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101812 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101816 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101820 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101824 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101828 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 101832 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101836 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101840 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101845 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101850 */       // MIs[2] Operand 2
     /* 101850 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101861 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101863 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101863 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101866 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101870 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101875 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 101878 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101882 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101885 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101890 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101895 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 101898 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101900 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101903 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 101907 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 101911 */       GIR_RootConstrainSelectedInstOperands,
     /* 101912 */       // GIR_Coverage, 5440,
     /* 101912 */       GIR_EraseRootFromParent_Done,
     /* 101913 */     // Label 1567: @101913
     /* 101913 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(102035), // Rule ID 5442 //
     /* 101918 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101922 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101926 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101930 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101934 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101938 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101942 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101946 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101950 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 101954 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101958 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101962 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101967 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101972 */       // MIs[2] Operand 2
     /* 101972 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101983 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101985 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101985 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101988 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101992 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101997 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102000 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102004 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102012 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102017 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102020 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102022 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102025 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102029 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102033 */       GIR_RootConstrainSelectedInstOperands,
     /* 102034 */       // GIR_Coverage, 5442,
     /* 102034 */       GIR_EraseRootFromParent_Done,
     /* 102035 */     // Label 1568: @102035
     /* 102035 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102137), // Rule ID 5595 //
     /* 102040 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102044 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102048 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102052 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102056 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102060 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102064 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102069 */       // MIs[2] Operand 2
     /* 102069 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 102080 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 102084 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102088 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102092 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 102096 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102100 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102104 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102109 */       // MIs[4] Operand 2
     /* 102109 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 102120 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102122 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 102122 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 102125 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102127 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 102131 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 102135 */       GIR_RootConstrainSelectedInstOperands,
     /* 102136 */       // GIR_Coverage, 5595,
     /* 102136 */       GIR_EraseRootFromParent_Done,
     /* 102137 */     // Label 1569: @102137
     /* 102137 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102266), // Rule ID 6381 //
     /* 102142 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102146 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102150 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102154 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102157 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102162 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102166 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102170 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102175 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 102179 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102181 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 102181 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 102184 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 102188 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102193 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102196 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102198 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102201 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102205 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102210 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102212 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102215 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102219 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102224 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102227 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 102231 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102234 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102239 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102244 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102249 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 102252 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102254 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102257 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 102261 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102264 */       GIR_RootConstrainSelectedInstOperands,
     /* 102265 */       // GIR_Coverage, 6381,
     /* 102265 */       GIR_EraseRootFromParent_Done,
     /* 102266 */     // Label 1570: @102266
     /* 102266 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102308), // Rule ID 5845 //
     /* 102271 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102278 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102285 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 102285 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102288 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102295 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102298 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102303 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102306 */       GIR_RootConstrainSelectedInstOperands,
     /* 102307 */       // GIR_Coverage, 5845,
     /* 102307 */       GIR_EraseRootFromParent_Done,
     /* 102308 */     // Label 1571: @102308
     /* 102308 */     GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(102350), // Rule ID 5849 //
     /* 102313 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102320 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102327 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 102327 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102330 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102332 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102337 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102340 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102345 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102348 */       GIR_RootConstrainSelectedInstOperands,
     /* 102349 */       // GIR_Coverage, 5849,
     /* 102349 */       GIR_EraseRootFromParent_Done,
     /* 102350 */     // Label 1572: @102350
     /* 102350 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102473), // Rule ID 2572 //
     /* 102355 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102358 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102362 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102366 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102370 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102373 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102378 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102382 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102386 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102391 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 102395 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102399 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102403 */       // MIs[2] Operand 1
     /* 102403 */       // No operand predicates
     /* 102403 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 102405 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102405 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102408 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102412 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102417 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102419 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102422 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102426 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102431 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102434 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102438 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102441 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102446 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102456 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 102459 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102461 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102468 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 102471 */       GIR_RootConstrainSelectedInstOperands,
     /* 102472 */       // GIR_Coverage, 2572,
     /* 102472 */       GIR_EraseRootFromParent_Done,
     /* 102473 */     // Label 1573: @102473
     /* 102473 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102596), // Rule ID 6351 //
     /* 102478 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102481 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102485 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102489 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102493 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102497 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102501 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 102505 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102509 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102514 */       // MIs[2] imm
     /* 102514 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102518 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102522 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102526 */       // MIs[3] Operand 1
     /* 102526 */       // No operand predicates
     /* 102526 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102528 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102528 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102531 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102535 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102540 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102542 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102545 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102549 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102554 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102557 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102561 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102574 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 102582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102584 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102587 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 102591 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 102594 */       GIR_RootConstrainSelectedInstOperands,
     /* 102595 */       // GIR_Coverage, 6351,
     /* 102595 */       GIR_EraseRootFromParent_Done,
     /* 102596 */     // Label 1574: @102596
     /* 102596 */     GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(102716), // Rule ID 6387 //
     /* 102601 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102605 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102609 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102613 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102617 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102621 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102625 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102629 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102634 */       // MIs[2] imm
     /* 102634 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102638 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102642 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102646 */       // MIs[3] Operand 1
     /* 102646 */       // No operand predicates
     /* 102646 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102648 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102648 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102651 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102655 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102660 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102662 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102665 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102669 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102674 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102677 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102681 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102684 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102689 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 102702 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102704 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102707 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 102711 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 102714 */       GIR_RootConstrainSelectedInstOperands,
     /* 102715 */       // GIR_Coverage, 6387,
     /* 102715 */       GIR_EraseRootFromParent_Done,
     /* 102716 */     // Label 1575: @102716
     /* 102716 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102833), // Rule ID 2496 //
     /* 102721 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102724 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102728 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102732 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102736 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102739 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 102744 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102748 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102752 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102757 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102762 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102764 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102764 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102767 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102771 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102776 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102778 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102781 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102785 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102790 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102793 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102797 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102810 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102815 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 102818 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102820 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102823 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 102831 */       GIR_RootConstrainSelectedInstOperands,
     /* 102832 */       // GIR_Coverage, 2496,
     /* 102832 */       GIR_EraseRootFromParent_Done,
     /* 102833 */     // Label 1576: @102833
     /* 102833 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102950), // Rule ID 5365 //
     /* 102838 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102841 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102845 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102849 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102853 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102856 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 102861 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102865 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102874 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102879 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102881 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102881 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102884 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102888 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102893 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102895 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102898 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102902 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102907 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102910 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102914 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102917 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102927 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102932 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102935 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102937 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102940 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 102948 */       GIR_RootConstrainSelectedInstOperands,
     /* 102949 */       // GIR_Coverage, 5365,
     /* 102949 */       GIR_EraseRootFromParent_Done,
     /* 102950 */     // Label 1577: @102950
     /* 102950 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(103067), // Rule ID 5368 //
     /* 102955 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102958 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102962 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102966 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102970 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102973 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 102978 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102982 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102986 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102991 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102996 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102998 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102998 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103001 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103005 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103010 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103012 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103015 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103019 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103024 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103027 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103031 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103034 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103044 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103049 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 103052 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103054 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103057 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103065 */       GIR_RootConstrainSelectedInstOperands,
     /* 103066 */       // GIR_Coverage, 5368,
     /* 103066 */       GIR_EraseRootFromParent_Done,
     /* 103067 */     // Label 1578: @103067
     /* 103067 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103184), // Rule ID 5371 //
     /* 103072 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103075 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103079 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103083 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103087 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103090 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103095 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103099 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 103103 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103108 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103113 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103115 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 668:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 103115 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103118 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103122 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103127 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103129 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103132 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103136 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103141 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103144 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103148 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103151 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103156 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103161 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103166 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 103169 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103171 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103174 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103178 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103182 */       GIR_RootConstrainSelectedInstOperands,
     /* 103183 */       // GIR_Coverage, 5371,
     /* 103183 */       GIR_EraseRootFromParent_Done,
     /* 103184 */     // Label 1579: @103184
     /* 103184 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(103285), // Rule ID 4948 //
     /* 103189 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103193 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103197 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103201 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 103204 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 103209 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103213 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103218 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103220 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 774:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103220 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103223 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103227 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103232 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103234 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103237 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103241 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103246 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103249 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103253 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103256 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103261 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103266 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103271 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103274 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103276 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103279 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103283 */       GIR_RootConstrainSelectedInstOperands,
     /* 103284 */       // GIR_Coverage, 4948,
     /* 103284 */       GIR_EraseRootFromParent_Done,
     /* 103285 */     // Label 1580: @103285
     /* 103285 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(103341), // Rule ID 5520 //
     /* 103290 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103294 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103298 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103302 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103307 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 103311 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103315 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103319 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103324 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103326 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 103326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 103329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103331 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 103335 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 103339 */       GIR_RootConstrainSelectedInstOperands,
     /* 103340 */       // GIR_Coverage, 5520,
     /* 103340 */       GIR_EraseRootFromParent_Done,
     /* 103341 */     // Label 1581: @103341
     /* 103341 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103407), // Rule ID 5843 //
     /* 103346 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103350 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103354 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103360 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103362 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103364 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 103364 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103367 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103371 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103376 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103380 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103387 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103390 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103393 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103396 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103401 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103406 */       // GIR_Coverage, 5843,
     /* 103406 */       GIR_EraseRootFromParent_Done,
     /* 103407 */     // Label 1582: @103407
     /* 103407 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103473), // Rule ID 5847 //
     /* 103412 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103416 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103420 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103426 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103428 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103430 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 103430 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103433 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103437 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103442 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103446 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103448 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103451 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103456 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103459 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103462 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103467 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103472 */       // GIR_Coverage, 5847,
     /* 103472 */       GIR_EraseRootFromParent_Done,
     /* 103473 */     // Label 1583: @103473
     /* 103473 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103566), // Rule ID 4956 //
     /* 103478 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 103490 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103494 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103499 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103501 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103501 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103504 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103508 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103513 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103515 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103518 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103522 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103527 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103530 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103534 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103537 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103542 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103547 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103552 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103555 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103557 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103560 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103564 */       GIR_RootConstrainSelectedInstOperands,
     /* 103565 */       // GIR_Coverage, 4956,
     /* 103565 */       GIR_EraseRootFromParent_Done,
     /* 103566 */     // Label 1584: @103566
     /* 103566 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103662), // Rule ID 5000 //
     /* 103571 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103574 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103578 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103582 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103586 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103590 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103595 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103597 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 103597 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103600 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103604 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103609 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103611 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103614 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103618 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103623 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103626 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103630 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103633 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103638 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103643 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 103651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103653 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103656 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103660 */       GIR_RootConstrainSelectedInstOperands,
     /* 103661 */       // GIR_Coverage, 5000,
     /* 103661 */       GIR_EraseRootFromParent_Done,
     /* 103662 */     // Label 1585: @103662
     /* 103662 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103724), // Rule ID 5844 //
     /* 103667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 103679 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103681 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 103681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 103684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103693 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103695 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103698 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103700 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103703 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 103705 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103708 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103713 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103718 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103723 */       // GIR_Coverage, 5844,
     /* 103723 */       GIR_EraseRootFromParent_Done,
     /* 103724 */     // Label 1586: @103724
     /* 103724 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103786), // Rule ID 5848 //
     /* 103729 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103733 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103737 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 103741 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103743 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 103743 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 103746 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103750 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103755 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103757 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103760 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103762 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103765 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 103767 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103770 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103775 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103780 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103785 */       // GIR_Coverage, 5848,
     /* 103785 */       GIR_EraseRootFromParent_Done,
     /* 103786 */     // Label 1587: @103786
     /* 103786 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(103920), // Rule ID 5842 //
     /* 103791 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103795 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103799 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 103799 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 103802 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103806 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103811 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103813 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 103816 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103820 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103825 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103828 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 103832 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 103835 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103840 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103845 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103850 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103853 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103857 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103862 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103864 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103867 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103871 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103876 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103879 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103883 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103886 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103891 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103896 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103901 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 103904 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103906 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103909 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103912 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103915 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103918 */       GIR_RootConstrainSelectedInstOperands,
     /* 103919 */       // GIR_Coverage, 5842,
     /* 103919 */       GIR_EraseRootFromParent_Done,
     /* 103920 */     // Label 1588: @103920
     /* 103920 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(104054), // Rule ID 5846 //
     /* 103925 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103929 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103933 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 103933 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 103936 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103940 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103945 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103947 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 103950 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103954 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103959 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103962 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 103966 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 103969 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103974 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103979 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103984 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103987 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103991 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103996 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103998 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104001 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104005 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104010 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104013 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104017 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104020 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104035 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104038 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104040 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104043 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104046 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104049 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104052 */       GIR_RootConstrainSelectedInstOperands,
     /* 104053 */       // GIR_Coverage, 5846,
     /* 104053 */       GIR_EraseRootFromParent_Done,
     /* 104054 */     // Label 1589: @104054
     /* 104054 */     GIM_Reject,
     /* 104055 */   // Label 1565: @104055
     /* 104055 */   GIM_Reject,
     /* 104056 */   // Label 1524: @104056
     /* 104056 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(105966),
     /* 104061 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104071 */     GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(104200), // Rule ID 5438 //
     /* 104076 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104080 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104084 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104088 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104092 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104096 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104100 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104104 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104108 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 104112 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104116 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104120 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104125 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 104129 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104135 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 104137 */       // MIs[2] Operand 2
     /* 104137 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104148 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104150 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 104150 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104153 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104157 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104162 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104165 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104169 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104187 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104194 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104198 */       GIR_RootConstrainSelectedInstOperands,
     /* 104199 */       // GIR_Coverage, 5438,
     /* 104199 */       GIR_EraseRootFromParent_Done,
     /* 104200 */     // Label 1591: @104200
     /* 104200 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104322), // Rule ID 5434 //
     /* 104205 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104209 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104213 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104217 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104221 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104225 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104229 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104233 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104237 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 104241 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104245 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104249 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104254 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104259 */       // MIs[2] Operand 2
     /* 104259 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104270 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104272 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104284 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104291 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104304 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 104307 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104309 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104312 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104316 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104320 */       GIR_RootConstrainSelectedInstOperands,
     /* 104321 */       // GIR_Coverage, 5434,
     /* 104321 */       GIR_EraseRootFromParent_Done,
     /* 104322 */     // Label 1592: @104322
     /* 104322 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104444), // Rule ID 5436 //
     /* 104327 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104331 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104335 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104339 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104343 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104347 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104351 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104355 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104359 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 104363 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104367 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104371 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104376 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104381 */       // MIs[2] Operand 2
     /* 104381 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104392 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104394 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104394 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104397 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104401 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104406 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104409 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104413 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104421 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104426 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104429 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104431 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104434 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104438 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104442 */       GIR_RootConstrainSelectedInstOperands,
     /* 104443 */       // GIR_Coverage, 5436,
     /* 104443 */       GIR_EraseRootFromParent_Done,
     /* 104444 */     // Label 1593: @104444
     /* 104444 */     GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104546), // Rule ID 5594 //
     /* 104449 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104453 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104457 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104461 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104465 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104469 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104473 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104478 */       // MIs[2] Operand 2
     /* 104478 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104489 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 104493 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104497 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104501 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 104505 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104509 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104513 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104518 */       // MIs[4] Operand 2
     /* 104518 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 104529 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104531 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104531 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 104534 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104536 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 104540 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 104544 */       GIR_RootConstrainSelectedInstOperands,
     /* 104545 */       // GIR_Coverage, 5594,
     /* 104545 */       GIR_EraseRootFromParent_Done,
     /* 104546 */     // Label 1594: @104546
     /* 104546 */     GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104675), // Rule ID 6380 //
     /* 104551 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104555 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104559 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104563 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104566 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 104571 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104575 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104579 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104584 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 104588 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104590 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 104590 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 104593 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 104597 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104602 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104607 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104610 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104614 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104619 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104621 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104624 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104628 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104633 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104636 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 104640 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104643 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104658 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 104661 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104663 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104666 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 104670 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104673 */       GIR_RootConstrainSelectedInstOperands,
     /* 104674 */       // GIR_Coverage, 6380,
     /* 104674 */       GIR_EraseRootFromParent_Done,
     /* 104675 */     // Label 1595: @104675
     /* 104675 */     GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104717), // Rule ID 5853 //
     /* 104680 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 104687 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 104694 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 104694 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104697 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104699 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 104704 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104707 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104712 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104715 */       GIR_RootConstrainSelectedInstOperands,
     /* 104716 */       // GIR_Coverage, 5853,
     /* 104716 */       GIR_EraseRootFromParent_Done,
     /* 104717 */     // Label 1596: @104717
     /* 104717 */     GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(104840), // Rule ID 2570 //
     /* 104722 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104737 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104740 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 104745 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104749 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104753 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104758 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 104762 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104766 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 104770 */       // MIs[2] Operand 1
     /* 104770 */       // No operand predicates
     /* 104770 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104772 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 104772 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104775 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104779 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104786 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104789 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104793 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104798 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104801 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104805 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104808 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104813 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104818 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104823 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 104826 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104828 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 104835 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 104838 */       GIR_RootConstrainSelectedInstOperands,
     /* 104839 */       // GIR_Coverage, 2570,
     /* 104839 */       GIR_EraseRootFromParent_Done,
     /* 104840 */     // Label 1597: @104840
     /* 104840 */     GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104963), // Rule ID 6350 //
     /* 104845 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104848 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104852 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104856 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104860 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104864 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104868 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 104872 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104876 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104881 */       // MIs[2] imm
     /* 104881 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104885 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104889 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 104893 */       // MIs[3] Operand 1
     /* 104893 */       // No operand predicates
     /* 104893 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104895 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 104895 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104898 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104902 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104921 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104924 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104928 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 104949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104954 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 104958 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 104961 */       GIR_RootConstrainSelectedInstOperands,
     /* 104962 */       // GIR_Coverage, 6350,
     /* 104962 */       GIR_EraseRootFromParent_Done,
     /* 104963 */     // Label 1598: @104963
     /* 104963 */     GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(105083), // Rule ID 6386 //
     /* 104968 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104972 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104976 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104980 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104984 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104988 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104992 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104996 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105001 */       // MIs[2] imm
     /* 105001 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105005 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105009 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 105013 */       // MIs[3] Operand 1
     /* 105013 */       // No operand predicates
     /* 105013 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105015 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 105015 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105018 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105022 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105027 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105029 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105032 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105036 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105041 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105044 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105048 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105061 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105066 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 105069 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105071 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105074 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 105078 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 105081 */       GIR_RootConstrainSelectedInstOperands,
     /* 105082 */       // GIR_Coverage, 6386,
     /* 105082 */       GIR_EraseRootFromParent_Done,
     /* 105083 */     // Label 1599: @105083
     /* 105083 */     GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(105200), // Rule ID 2495 //
     /* 105088 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105091 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105095 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105099 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105103 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105106 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 105111 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105115 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105119 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105124 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105129 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105131 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 579:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105131 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105134 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105138 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105143 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105145 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105148 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105152 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105157 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105160 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105164 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 105185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105187 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105194 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105198 */       GIR_RootConstrainSelectedInstOperands,
     /* 105199 */       // GIR_Coverage, 2495,
     /* 105199 */       GIR_EraseRootFromParent_Done,
     /* 105200 */     // Label 1600: @105200
     /* 105200 */     GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(105317), // Rule ID 5364 //
     /* 105205 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105208 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105212 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105216 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105220 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105223 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 105228 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105232 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105236 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105241 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105246 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105248 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105248 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105251 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105255 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105260 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105262 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105265 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105269 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105274 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105277 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105281 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105284 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105289 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 105302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105304 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105307 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105311 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105315 */       GIR_RootConstrainSelectedInstOperands,
     /* 105316 */       // GIR_Coverage, 5364,
     /* 105316 */       GIR_EraseRootFromParent_Done,
     /* 105317 */     // Label 1601: @105317
     /* 105317 */     GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(105434), // Rule ID 5367 //
     /* 105322 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105325 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105329 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105333 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105337 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105340 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 105345 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105349 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105353 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105358 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105363 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105365 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105365 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105368 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105372 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105377 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105379 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105382 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105386 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105391 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105394 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105398 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105401 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105406 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105411 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105416 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 105419 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105421 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105424 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105428 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105432 */       GIR_RootConstrainSelectedInstOperands,
     /* 105433 */       // GIR_Coverage, 5367,
     /* 105433 */       GIR_EraseRootFromParent_Done,
     /* 105434 */     // Label 1602: @105434
     /* 105434 */     GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(105551), // Rule ID 5370 //
     /* 105439 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105442 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105446 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105450 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105454 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105457 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 105462 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105466 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105470 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105475 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105480 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105482 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 668:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105482 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105485 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105489 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105494 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105496 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105499 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105503 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105508 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105511 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105515 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105518 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105523 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105528 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105533 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 105536 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105538 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105541 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105549 */       GIR_RootConstrainSelectedInstOperands,
     /* 105550 */       // GIR_Coverage, 5370,
     /* 105550 */       GIR_EraseRootFromParent_Done,
     /* 105551 */     // Label 1603: @105551
     /* 105551 */     GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(105607), // Rule ID 5511 //
     /* 105556 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105560 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105564 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105568 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105573 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 105577 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105581 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105585 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105590 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105592 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 105592 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 105595 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105597 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 105601 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 105605 */       GIR_RootConstrainSelectedInstOperands,
     /* 105606 */       // GIR_Coverage, 5511,
     /* 105606 */       GIR_EraseRootFromParent_Done,
     /* 105607 */     // Label 1604: @105607
     /* 105607 */     GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(105673), // Rule ID 5851 //
     /* 105612 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105616 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105620 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 105626 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 105628 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105630 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 105630 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105633 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 105637 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105642 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 105646 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105653 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105656 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105659 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 105662 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105667 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105672 */       // GIR_Coverage, 5851,
     /* 105672 */       GIR_EraseRootFromParent_Done,
     /* 105673 */     // Label 1605: @105673
     /* 105673 */     GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(105769), // Rule ID 4999 //
     /* 105678 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105681 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105685 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105689 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105693 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105697 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105702 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105704 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 105704 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105707 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105711 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105718 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105721 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105725 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105730 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105733 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105737 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105740 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105745 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105750 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105755 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 105758 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105760 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105763 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105767 */       GIR_RootConstrainSelectedInstOperands,
     /* 105768 */       // GIR_Coverage, 4999,
     /* 105768 */       GIR_EraseRootFromParent_Done,
     /* 105769 */     // Label 1606: @105769
     /* 105769 */     GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(105831), // Rule ID 5852 //
     /* 105774 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105778 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105782 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 105786 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105788 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 105788 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 105791 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105795 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105800 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105802 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105805 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105807 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105810 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 105812 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 105815 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105820 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105825 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105830 */       // GIR_Coverage, 5852,
     /* 105830 */       GIR_EraseRootFromParent_Done,
     /* 105831 */     // Label 1607: @105831
     /* 105831 */     GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105965), // Rule ID 5850 //
     /* 105836 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105840 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105844 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 105844 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 105847 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105851 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105856 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105858 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 105861 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105865 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105870 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105873 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 105877 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 105880 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105885 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105890 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105895 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105898 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105902 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105921 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105924 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105928 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 105949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105957 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 105960 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105963 */       GIR_RootConstrainSelectedInstOperands,
     /* 105964 */       // GIR_Coverage, 5850,
     /* 105964 */       GIR_EraseRootFromParent_Done,
     /* 105965 */     // Label 1608: @105965
     /* 105965 */     GIM_Reject,
     /* 105966 */   // Label 1590: @105966
     /* 105966 */   GIM_Reject,
     /* 105967 */   // Label 1525: @105967
     /* 105967 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(105992), // Rule ID 9134 //
     /* 105972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 105975 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 105978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 105981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 105985 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 105985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 105990 */     GIR_RootConstrainSelectedInstOperands,
     /* 105991 */     // GIR_Coverage, 9134,
     /* 105991 */     GIR_Done,
     /* 105992 */   // Label 1609: @105992
     /* 105992 */   GIM_Reject,
     /* 105993 */   // Label 1526: @105993
     /* 105993 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(106018), // Rule ID 9135 //
     /* 105998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106001 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 106004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 106007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106011 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 106011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 106016 */     GIR_RootConstrainSelectedInstOperands,
     /* 106017 */     // GIR_Coverage, 9135,
     /* 106017 */     GIR_Done,
     /* 106018 */   // Label 1610: @106018
     /* 106018 */   GIM_Reject,
     /* 106019 */   // Label 1527: @106019
     /* 106019 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(106044), // Rule ID 9138 //
     /* 106024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106027 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 106030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 106033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106037 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 106037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106042 */     GIR_RootConstrainSelectedInstOperands,
     /* 106043 */     // GIR_Coverage, 9138,
     /* 106043 */     GIR_Done,
     /* 106044 */   // Label 1611: @106044
     /* 106044 */   GIM_Reject,
     /* 106045 */   // Label 1528: @106045
     /* 106045 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(106070), // Rule ID 9140 //
     /* 106050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106053 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 106056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 106059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106063 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 106063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106068 */     GIR_RootConstrainSelectedInstOperands,
     /* 106069 */     // GIR_Coverage, 9140,
     /* 106069 */     GIR_Done,
     /* 106070 */   // Label 1612: @106070
     /* 106070 */   GIM_Reject,
     /* 106071 */   // Label 1529: @106071
     /* 106071 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(106096), // Rule ID 9136 //
     /* 106076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106079 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 106082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 106085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106089 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 106089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 106094 */     GIR_RootConstrainSelectedInstOperands,
     /* 106095 */     // GIR_Coverage, 9136,
     /* 106095 */     GIR_Done,
     /* 106096 */   // Label 1613: @106096
     /* 106096 */   GIM_Reject,
     /* 106097 */   // Label 1530: @106097
     /* 106097 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(106122), // Rule ID 9139 //
     /* 106102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106105 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 106108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 106111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106115 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 106115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 106120 */     GIR_RootConstrainSelectedInstOperands,
     /* 106121 */     // GIR_Coverage, 9139,
     /* 106121 */     GIR_Done,
     /* 106122 */   // Label 1614: @106122
     /* 106122 */   GIM_Reject,
     /* 106123 */   // Label 1531: @106123
     /* 106123 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(106148), // Rule ID 9137 //
     /* 106128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106131 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 106134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 106137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106141 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 106141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 106146 */     GIR_RootConstrainSelectedInstOperands,
     /* 106147 */     // GIR_Coverage, 9137,
     /* 106147 */     GIR_Done,
     /* 106148 */   // Label 1615: @106148
     /* 106148 */   GIM_Reject,
     /* 106149 */   // Label 1532: @106149
     /* 106149 */   GIM_Reject,
     /* 106150 */ // Label 1520: @106150
     /* 106150 */ GIM_Reject,
     /* 106151 */ // Label 9: @106151
     /* 106151 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1630*/ GIMT_Encode4(116232),
     /* 106162 */ /*GILLT_s32*//*Label 1616*/ GIMT_Encode4(106250),
     /* 106166 */ /*GILLT_s64*//*Label 1617*/ GIMT_Encode4(106753),
     /* 106170 */ /*GILLT_s128*//*Label 1618*/ GIMT_Encode4(108744),
     /* 106174 */ /*GILLT_v2s32*//*Label 1619*/ GIMT_Encode4(109390),
     /* 106178 */ /*GILLT_v2s64*//*Label 1620*/ GIMT_Encode4(110305),
     /* 106182 */ /*GILLT_v4s16*//*Label 1621*/ GIMT_Encode4(111074),
     /* 106186 */ /*GILLT_v4s32*//*Label 1622*/ GIMT_Encode4(111989),
     /* 106190 */ /*GILLT_v8s8*//*Label 1623*/ GIMT_Encode4(112834),
     /* 106194 */ /*GILLT_v8s16*//*Label 1624*/ GIMT_Encode4(113395),
     /* 106198 */ /*GILLT_v16s8*//*Label 1625*/ GIMT_Encode4(114240), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106218 */ /*GILLT_nxv2s64*//*Label 1626*/ GIMT_Encode4(114692), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106230 */ /*GILLT_nxv4s32*//*Label 1627*/ GIMT_Encode4(115141), GIMT_Encode4(0),
     /* 106238 */ /*GILLT_nxv8s16*//*Label 1628*/ GIMT_Encode4(115590), GIMT_Encode4(0),
     /* 106246 */ /*GILLT_nxv16s8*//*Label 1629*/ GIMT_Encode4(116039),
     /* 106250 */ // Label 1616: @106250
     /* 106250 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(106752),
     /* 106255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106258 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(106332), // Rule ID 7111 //
     /* 106263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106275 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106282 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106289 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106305 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 106305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 106308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106330 */     GIR_RootConstrainSelectedInstOperands,
     /* 106331 */     // GIR_Coverage, 7111,
     /* 106331 */     GIR_EraseRootFromParent_Done,
     /* 106332 */   // Label 1632: @106332
     /* 106332 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(106406), // Rule ID 7112 //
     /* 106337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106349 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106356 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106363 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106366 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106379 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 106379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 106382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106404 */     GIR_RootConstrainSelectedInstOperands,
     /* 106405 */     // GIR_Coverage, 7112,
     /* 106405 */     GIR_EraseRootFromParent_Done,
     /* 106406 */   // Label 1633: @106406
     /* 106406 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(106475), // Rule ID 7113 //
     /* 106411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106423 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106430 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106437 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 106453 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 106456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106473 */     GIR_RootConstrainSelectedInstOperands,
     /* 106474 */     // GIR_Coverage, 7113,
     /* 106474 */     GIR_EraseRootFromParent_Done,
     /* 106475 */   // Label 1634: @106475
     /* 106475 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(106544), // Rule ID 7114 //
     /* 106480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106492 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106499 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106506 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 106522 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 106525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106542 */     GIR_RootConstrainSelectedInstOperands,
     /* 106543 */     // GIR_Coverage, 7114,
     /* 106543 */     GIR_EraseRootFromParent_Done,
     /* 106544 */   // Label 1635: @106544
     /* 106544 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(106597), // Rule ID 5812 //
     /* 106549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 106565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106569 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106575 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v16i8:{ *:[v16i8] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v16i8] }:$src, bsub:{ *:[i32] })
     /* 106575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106580 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 106586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106596 */     // GIR_Coverage, 5812,
     /* 106596 */     GIR_EraseRootFromParent_Done,
     /* 106597 */   // Label 1636: @106597
     /* 106597 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(106650), // Rule ID 5813 //
     /* 106602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 106606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 106618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106628 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v8i16:{ *:[v8i16] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v8i16] }:$src, hsub:{ *:[i32] })
     /* 106628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106633 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // src
     /* 106639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 106644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106649 */     // GIR_Coverage, 5813,
     /* 106649 */     GIR_EraseRootFromParent_Done,
     /* 106650 */   // Label 1637: @106650
     /* 106650 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(106703), // Rule ID 5814 //
     /* 106655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 106671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106681 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 106681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106686 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 106692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106702 */     // GIR_Coverage, 5814,
     /* 106702 */     GIR_EraseRootFromParent_Done,
     /* 106703 */   // Label 1638: @106703
     /* 106703 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106727), // Rule ID 6722 //
     /* 106708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106716 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 106716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106726 */     // GIR_Coverage, 6722,
     /* 106726 */     GIR_Done,
     /* 106727 */   // Label 1639: @106727
     /* 106727 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106751), // Rule ID 6723 //
     /* 106732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106740 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 106740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106750 */     // GIR_Coverage, 6723,
     /* 106750 */     GIR_Done,
     /* 106751 */   // Label 1640: @106751
     /* 106751 */   GIM_Reject,
     /* 106752 */ // Label 1631: @106752
     /* 106752 */ GIM_Reject,
     /* 106753 */ // Label 1617: @106753
     /* 106753 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106830), // Rule ID 7115 //
     /* 106758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106773 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106780 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106790 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106796 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106803 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106828 */   GIR_RootConstrainSelectedInstOperands,
     /* 106829 */   // GIR_Coverage, 7115,
     /* 106829 */   GIR_EraseRootFromParent_Done,
     /* 106830 */ // Label 1641: @106830
     /* 106830 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106907), // Rule ID 7116 //
     /* 106835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106850 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106857 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106867 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106873 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106880 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106905 */   GIR_RootConstrainSelectedInstOperands,
     /* 106906 */   // GIR_Coverage, 7116,
     /* 106906 */   GIR_EraseRootFromParent_Done,
     /* 106907 */ // Label 1642: @106907
     /* 106907 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106979), // Rule ID 7117 //
     /* 106912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106934 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106941 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106944 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106950 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106957 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106977 */   GIR_RootConstrainSelectedInstOperands,
     /* 106978 */   // GIR_Coverage, 7117,
     /* 106978 */   GIR_EraseRootFromParent_Done,
     /* 106979 */ // Label 1643: @106979
     /* 106979 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(107051), // Rule ID 7118 //
     /* 106984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106999 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107002 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 107006 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107013 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 107016 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 107020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107022 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 107029 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 107032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 107049 */   GIR_RootConstrainSelectedInstOperands,
     /* 107050 */   // GIR_Coverage, 7118,
     /* 107050 */   GIR_EraseRootFromParent_Done,
     /* 107051 */ // Label 1644: @107051
     /* 107051 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(107107), // Rule ID 5815 //
     /* 107056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107079 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 107083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107085 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 107085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107090 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 107096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107106 */   // GIR_Coverage, 5815,
     /* 107106 */   GIR_EraseRootFromParent_Done,
     /* 107107 */ // Label 1645: @107107
     /* 107107 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(107137), // Rule ID 6697 //
     /* 107112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107126 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 107126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107136 */   // GIR_Coverage, 6697,
     /* 107136 */   GIR_Done,
     /* 107137 */ // Label 1646: @107137
     /* 107137 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(107167), // Rule ID 6698 //
     /* 107142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107156 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 107156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107166 */   // GIR_Coverage, 6698,
     /* 107166 */   GIR_Done,
     /* 107167 */ // Label 1647: @107167
     /* 107167 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(107197), // Rule ID 6699 //
     /* 107172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107186 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 107186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107196 */   // GIR_Coverage, 6699,
     /* 107196 */   GIR_Done,
     /* 107197 */ // Label 1648: @107197
     /* 107197 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107227), // Rule ID 6700 //
     /* 107202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107216 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 107216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107226 */   // GIR_Coverage, 6700,
     /* 107226 */   GIR_Done,
     /* 107227 */ // Label 1649: @107227
     /* 107227 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107257), // Rule ID 6701 //
     /* 107232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107246 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 107246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107256 */   // GIR_Coverage, 6701,
     /* 107256 */   GIR_Done,
     /* 107257 */ // Label 1650: @107257
     /* 107257 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107287), // Rule ID 6702 //
     /* 107262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107276 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 107276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107286 */   // GIR_Coverage, 6702,
     /* 107286 */   GIR_Done,
     /* 107287 */ // Label 1651: @107287
     /* 107287 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107337), // Rule ID 6708 //
     /* 107292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107306 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 107306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107335 */   GIR_RootConstrainSelectedInstOperands,
     /* 107336 */   // GIR_Coverage, 6708,
     /* 107336 */   GIR_EraseRootFromParent_Done,
     /* 107337 */ // Label 1652: @107337
     /* 107337 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107387), // Rule ID 6709 //
     /* 107342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107356 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107368 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107385 */   GIR_RootConstrainSelectedInstOperands,
     /* 107386 */   // GIR_Coverage, 6709,
     /* 107386 */   GIR_EraseRootFromParent_Done,
     /* 107387 */ // Label 1653: @107387
     /* 107387 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107437), // Rule ID 6710 //
     /* 107392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107406 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107418 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107435 */   GIR_RootConstrainSelectedInstOperands,
     /* 107436 */   // GIR_Coverage, 6710,
     /* 107436 */   GIR_EraseRootFromParent_Done,
     /* 107437 */ // Label 1654: @107437
     /* 107437 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107487), // Rule ID 6711 //
     /* 107442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107456 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107485 */   GIR_RootConstrainSelectedInstOperands,
     /* 107486 */   // GIR_Coverage, 6711,
     /* 107486 */   GIR_EraseRootFromParent_Done,
     /* 107487 */ // Label 1655: @107487
     /* 107487 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(107537), // Rule ID 6712 //
     /* 107492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107506 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107535 */   GIR_RootConstrainSelectedInstOperands,
     /* 107536 */   // GIR_Coverage, 6712,
     /* 107536 */   GIR_EraseRootFromParent_Done,
     /* 107537 */ // Label 1656: @107537
     /* 107537 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(107564), // Rule ID 6713 //
     /* 107542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107553 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107563 */   // GIR_Coverage, 6713,
     /* 107563 */   GIR_Done,
     /* 107564 */ // Label 1657: @107564
     /* 107564 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(107591), // Rule ID 6714 //
     /* 107569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107580 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107590 */   // GIR_Coverage, 6714,
     /* 107590 */   GIR_Done,
     /* 107591 */ // Label 1658: @107591
     /* 107591 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(107618), // Rule ID 6715 //
     /* 107596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107607 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 107607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107617 */   // GIR_Coverage, 6715,
     /* 107617 */   GIR_Done,
     /* 107618 */ // Label 1659: @107618
     /* 107618 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(107645), // Rule ID 6724 //
     /* 107623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107634 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107644 */   // GIR_Coverage, 6724,
     /* 107644 */   GIR_Done,
     /* 107645 */ // Label 1660: @107645
     /* 107645 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(107672), // Rule ID 6725 //
     /* 107650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107661 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 107661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107671 */   // GIR_Coverage, 6725,
     /* 107671 */   GIR_Done,
     /* 107672 */ // Label 1661: @107672
     /* 107672 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(107699), // Rule ID 6726 //
     /* 107677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107688 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 107688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107698 */   // GIR_Coverage, 6726,
     /* 107698 */   GIR_Done,
     /* 107699 */ // Label 1662: @107699
     /* 107699 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(107731), // Rule ID 6727 //
     /* 107704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107718 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107721 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107723 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107730 */   // GIR_Coverage, 6727,
     /* 107730 */   GIR_EraseRootFromParent_Done,
     /* 107731 */ // Label 1663: @107731
     /* 107731 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(107763), // Rule ID 6728 //
     /* 107736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107750 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107753 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107755 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107762 */   // GIR_Coverage, 6728,
     /* 107762 */   GIR_EraseRootFromParent_Done,
     /* 107763 */ // Label 1664: @107763
     /* 107763 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(107795), // Rule ID 6729 //
     /* 107768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107782 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107785 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107794 */   // GIR_Coverage, 6729,
     /* 107794 */   GIR_EraseRootFromParent_Done,
     /* 107795 */ // Label 1665: @107795
     /* 107795 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(107827), // Rule ID 6730 //
     /* 107800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107814 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107817 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107826 */   // GIR_Coverage, 6730,
     /* 107826 */   GIR_EraseRootFromParent_Done,
     /* 107827 */ // Label 1666: @107827
     /* 107827 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(107859), // Rule ID 6731 //
     /* 107832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107846 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107858 */   // GIR_Coverage, 6731,
     /* 107858 */   GIR_EraseRootFromParent_Done,
     /* 107859 */ // Label 1667: @107859
     /* 107859 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(107885), // Rule ID 6732 //
     /* 107864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107878 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 107878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107883 */   GIR_RootConstrainSelectedInstOperands,
     /* 107884 */   // GIR_Coverage, 6732,
     /* 107884 */   GIR_Done,
     /* 107885 */ // Label 1668: @107885
     /* 107885 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(107911), // Rule ID 6733 //
     /* 107890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107904 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 107904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107909 */   GIR_RootConstrainSelectedInstOperands,
     /* 107910 */   // GIR_Coverage, 6733,
     /* 107910 */   GIR_Done,
     /* 107911 */ // Label 1669: @107911
     /* 107911 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(107937), // Rule ID 6734 //
     /* 107916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107930 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 107930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107935 */   GIR_RootConstrainSelectedInstOperands,
     /* 107936 */   // GIR_Coverage, 6734,
     /* 107936 */   GIR_Done,
     /* 107937 */ // Label 1670: @107937
     /* 107937 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(107963), // Rule ID 6735 //
     /* 107942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107956 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 107956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107961 */   GIR_RootConstrainSelectedInstOperands,
     /* 107962 */   // GIR_Coverage, 6735,
     /* 107962 */   GIR_Done,
     /* 107963 */ // Label 1671: @107963
     /* 107963 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(107989), // Rule ID 6736 //
     /* 107968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107982 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 107982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107987 */   GIR_RootConstrainSelectedInstOperands,
     /* 107988 */   // GIR_Coverage, 6736,
     /* 107988 */   GIR_Done,
     /* 107989 */ // Label 1672: @107989
     /* 107989 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(108018), // Rule ID 6737 //
     /* 107994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108005 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108008 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108017 */   // GIR_Coverage, 6737,
     /* 108017 */   GIR_EraseRootFromParent_Done,
     /* 108018 */ // Label 1673: @108018
     /* 108018 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(108047), // Rule ID 6738 //
     /* 108023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108034 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108046 */   // GIR_Coverage, 6738,
     /* 108046 */   GIR_EraseRootFromParent_Done,
     /* 108047 */ // Label 1674: @108047
     /* 108047 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(108079), // Rule ID 6792 //
     /* 108052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108066 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108078 */   // GIR_Coverage, 6792,
     /* 108078 */   GIR_EraseRootFromParent_Done,
     /* 108079 */ // Label 1675: @108079
     /* 108079 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(108111), // Rule ID 6793 //
     /* 108084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108098 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108110 */   // GIR_Coverage, 6793,
     /* 108110 */   GIR_EraseRootFromParent_Done,
     /* 108111 */ // Label 1676: @108111
     /* 108111 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(108143), // Rule ID 6794 //
     /* 108116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108130 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108142 */   // GIR_Coverage, 6794,
     /* 108142 */   GIR_EraseRootFromParent_Done,
     /* 108143 */ // Label 1677: @108143
     /* 108143 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(108175), // Rule ID 6795 //
     /* 108148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108162 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108174 */   // GIR_Coverage, 6795,
     /* 108174 */   GIR_EraseRootFromParent_Done,
     /* 108175 */ // Label 1678: @108175
     /* 108175 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(108207), // Rule ID 6796 //
     /* 108180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108194 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108197 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108199 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108206 */   // GIR_Coverage, 6796,
     /* 108206 */   GIR_EraseRootFromParent_Done,
     /* 108207 */ // Label 1679: @108207
     /* 108207 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(108233), // Rule ID 6797 //
     /* 108212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108226 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108231 */   GIR_RootConstrainSelectedInstOperands,
     /* 108232 */   // GIR_Coverage, 6797,
     /* 108232 */   GIR_Done,
     /* 108233 */ // Label 1680: @108233
     /* 108233 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(108259), // Rule ID 6798 //
     /* 108238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108252 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108257 */   GIR_RootConstrainSelectedInstOperands,
     /* 108258 */   // GIR_Coverage, 6798,
     /* 108258 */   GIR_Done,
     /* 108259 */ // Label 1681: @108259
     /* 108259 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(108285), // Rule ID 6799 //
     /* 108264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108278 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 108278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108283 */   GIR_RootConstrainSelectedInstOperands,
     /* 108284 */   // GIR_Coverage, 6799,
     /* 108284 */   GIR_Done,
     /* 108285 */ // Label 1682: @108285
     /* 108285 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(108311), // Rule ID 6800 //
     /* 108290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108304 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 108304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108309 */   GIR_RootConstrainSelectedInstOperands,
     /* 108310 */   // GIR_Coverage, 6800,
     /* 108310 */   GIR_Done,
     /* 108311 */ // Label 1683: @108311
     /* 108311 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(108337), // Rule ID 6801 //
     /* 108316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108330 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 108330 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108335 */   GIR_RootConstrainSelectedInstOperands,
     /* 108336 */   // GIR_Coverage, 6801,
     /* 108336 */   GIR_Done,
     /* 108337 */ // Label 1684: @108337
     /* 108337 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(108366), // Rule ID 6802 //
     /* 108342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108353 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108365 */   // GIR_Coverage, 6802,
     /* 108365 */   GIR_EraseRootFromParent_Done,
     /* 108366 */ // Label 1685: @108366
     /* 108366 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(108395), // Rule ID 6803 //
     /* 108371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108382 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108394 */   // GIR_Coverage, 6803,
     /* 108394 */   GIR_EraseRootFromParent_Done,
     /* 108395 */ // Label 1686: @108395
     /* 108395 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(108427), // Rule ID 6804 //
     /* 108400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108414 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108426 */   // GIR_Coverage, 6804,
     /* 108426 */   GIR_EraseRootFromParent_Done,
     /* 108427 */ // Label 1687: @108427
     /* 108427 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(108459), // Rule ID 6805 //
     /* 108432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108446 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108458 */   // GIR_Coverage, 6805,
     /* 108458 */   GIR_EraseRootFromParent_Done,
     /* 108459 */ // Label 1688: @108459
     /* 108459 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(108491), // Rule ID 6806 //
     /* 108464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108478 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108490 */   // GIR_Coverage, 6806,
     /* 108490 */   GIR_EraseRootFromParent_Done,
     /* 108491 */ // Label 1689: @108491
     /* 108491 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(108523), // Rule ID 6807 //
     /* 108496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108510 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108522 */   // GIR_Coverage, 6807,
     /* 108522 */   GIR_EraseRootFromParent_Done,
     /* 108523 */ // Label 1690: @108523
     /* 108523 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(108555), // Rule ID 6808 //
     /* 108528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108542 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108554 */   // GIR_Coverage, 6808,
     /* 108554 */   GIR_EraseRootFromParent_Done,
     /* 108555 */ // Label 1691: @108555
     /* 108555 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108581), // Rule ID 6809 //
     /* 108560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108579 */   GIR_RootConstrainSelectedInstOperands,
     /* 108580 */   // GIR_Coverage, 6809,
     /* 108580 */   GIR_Done,
     /* 108581 */ // Label 1692: @108581
     /* 108581 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(108607), // Rule ID 6810 //
     /* 108586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108600 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108605 */   GIR_RootConstrainSelectedInstOperands,
     /* 108606 */   // GIR_Coverage, 6810,
     /* 108606 */   GIR_Done,
     /* 108607 */ // Label 1693: @108607
     /* 108607 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108633), // Rule ID 6811 //
     /* 108612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108626 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 108626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108631 */   GIR_RootConstrainSelectedInstOperands,
     /* 108632 */   // GIR_Coverage, 6811,
     /* 108632 */   GIR_Done,
     /* 108633 */ // Label 1694: @108633
     /* 108633 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108659), // Rule ID 6812 //
     /* 108638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108652 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 108652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108657 */   GIR_RootConstrainSelectedInstOperands,
     /* 108658 */   // GIR_Coverage, 6812,
     /* 108658 */   GIR_Done,
     /* 108659 */ // Label 1695: @108659
     /* 108659 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108685), // Rule ID 6813 //
     /* 108664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108678 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 108678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108683 */   GIR_RootConstrainSelectedInstOperands,
     /* 108684 */   // GIR_Coverage, 6813,
     /* 108684 */   GIR_Done,
     /* 108685 */ // Label 1696: @108685
     /* 108685 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108714), // Rule ID 6814 //
     /* 108690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108701 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108704 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108708 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108713 */   // GIR_Coverage, 6814,
     /* 108713 */   GIR_EraseRootFromParent_Done,
     /* 108714 */ // Label 1697: @108714
     /* 108714 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108743), // Rule ID 6815 //
     /* 108719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108730 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108742 */   // GIR_Coverage, 6815,
     /* 108742 */   GIR_EraseRootFromParent_Done,
     /* 108743 */ // Label 1698: @108743
     /* 108743 */ GIM_Reject,
     /* 108744 */ // Label 1618: @108744
     /* 108744 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108776), // Rule ID 6829 //
     /* 108749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108763 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108775 */   // GIR_Coverage, 6829,
     /* 108775 */   GIR_EraseRootFromParent_Done,
     /* 108776 */ // Label 1699: @108776
     /* 108776 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108808), // Rule ID 6830 //
     /* 108781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108795 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108798 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108807 */   // GIR_Coverage, 6830,
     /* 108807 */   GIR_EraseRootFromParent_Done,
     /* 108808 */ // Label 1700: @108808
     /* 108808 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108840), // Rule ID 6831 //
     /* 108813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108827 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108830 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108839 */   // GIR_Coverage, 6831,
     /* 108839 */   GIR_EraseRootFromParent_Done,
     /* 108840 */ // Label 1701: @108840
     /* 108840 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108872), // Rule ID 6832 //
     /* 108845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108859 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108862 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108864 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108871 */   // GIR_Coverage, 6832,
     /* 108871 */   GIR_EraseRootFromParent_Done,
     /* 108872 */ // Label 1702: @108872
     /* 108872 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108904), // Rule ID 6833 //
     /* 108877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108891 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108894 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108896 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108903 */   // GIR_Coverage, 6833,
     /* 108903 */   GIR_EraseRootFromParent_Done,
     /* 108904 */ // Label 1703: @108904
     /* 108904 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108936), // Rule ID 6834 //
     /* 108909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108923 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108926 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108928 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108935 */   // GIR_Coverage, 6834,
     /* 108935 */   GIR_EraseRootFromParent_Done,
     /* 108936 */ // Label 1704: @108936
     /* 108936 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108968), // Rule ID 6835 //
     /* 108941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108955 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108958 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108960 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108967 */   // GIR_Coverage, 6835,
     /* 108967 */   GIR_EraseRootFromParent_Done,
     /* 108968 */ // Label 1705: @108968
     /* 108968 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(109001), // Rule ID 6836 //
     /* 108973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108987 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 108987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 108990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108992 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108994 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 108999 */   GIR_RootConstrainSelectedInstOperands,
     /* 109000 */   // GIR_Coverage, 6836,
     /* 109000 */   GIR_EraseRootFromParent_Done,
     /* 109001 */ // Label 1706: @109001
     /* 109001 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(109072), // Rule ID 6837 //
     /* 109006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109020 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 109020 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109023 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109027 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109032 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109070 */   GIR_RootConstrainSelectedInstOperands,
     /* 109071 */   // GIR_Coverage, 6837,
     /* 109071 */   GIR_EraseRootFromParent_Done,
     /* 109072 */ // Label 1707: @109072
     /* 109072 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(109143), // Rule ID 6838 //
     /* 109077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109091 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 109091 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109094 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109098 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109103 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109141 */   GIR_RootConstrainSelectedInstOperands,
     /* 109142 */   // GIR_Coverage, 6838,
     /* 109142 */   GIR_EraseRootFromParent_Done,
     /* 109143 */ // Label 1708: @109143
     /* 109143 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(109214), // Rule ID 6839 //
     /* 109148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109162 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 109162 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109165 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109169 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109174 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109192 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109212 */   GIR_RootConstrainSelectedInstOperands,
     /* 109213 */   // GIR_Coverage, 6839,
     /* 109213 */   GIR_EraseRootFromParent_Done,
     /* 109214 */ // Label 1709: @109214
     /* 109214 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(109247), // Rule ID 6840 //
     /* 109219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109233 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 109233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109238 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109240 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109245 */   GIR_RootConstrainSelectedInstOperands,
     /* 109246 */   // GIR_Coverage, 6840,
     /* 109246 */   GIR_EraseRootFromParent_Done,
     /* 109247 */ // Label 1710: @109247
     /* 109247 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(109318), // Rule ID 6841 //
     /* 109252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109266 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 109266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109316 */   GIR_RootConstrainSelectedInstOperands,
     /* 109317 */   // GIR_Coverage, 6841,
     /* 109317 */   GIR_EraseRootFromParent_Done,
     /* 109318 */ // Label 1711: @109318
     /* 109318 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(109389), // Rule ID 6842 //
     /* 109323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109337 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 109337 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109340 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109344 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109349 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109387 */   GIR_RootConstrainSelectedInstOperands,
     /* 109388 */   // GIR_Coverage, 6842,
     /* 109388 */   GIR_EraseRootFromParent_Done,
     /* 109389 */ // Label 1712: @109389
     /* 109389 */ GIM_Reject,
     /* 109390 */ // Label 1619: @109390
     /* 109390 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(109420), // Rule ID 6694 //
     /* 109395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109409 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109419 */   // GIR_Coverage, 6694,
     /* 109419 */   GIR_Done,
     /* 109420 */ // Label 1713: @109420
     /* 109420 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(109450), // Rule ID 6696 //
     /* 109425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109439 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109449 */   // GIR_Coverage, 6696,
     /* 109449 */   GIR_Done,
     /* 109450 */ // Label 1714: @109450
     /* 109450 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(109500), // Rule ID 6705 //
     /* 109455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109469 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109498 */   GIR_RootConstrainSelectedInstOperands,
     /* 109499 */   // GIR_Coverage, 6705,
     /* 109499 */   GIR_EraseRootFromParent_Done,
     /* 109500 */ // Label 1715: @109500
     /* 109500 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(109550), // Rule ID 6707 //
     /* 109505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109519 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109531 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109548 */   GIR_RootConstrainSelectedInstOperands,
     /* 109549 */   // GIR_Coverage, 6707,
     /* 109549 */   GIR_EraseRootFromParent_Done,
     /* 109550 */ // Label 1716: @109550
     /* 109550 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(109582), // Rule ID 6739 //
     /* 109555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109569 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109572 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109574 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109581 */   // GIR_Coverage, 6739,
     /* 109581 */   GIR_EraseRootFromParent_Done,
     /* 109582 */ // Label 1717: @109582
     /* 109582 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(109614), // Rule ID 6740 //
     /* 109587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109601 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109604 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109606 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109613 */   // GIR_Coverage, 6740,
     /* 109613 */   GIR_EraseRootFromParent_Done,
     /* 109614 */ // Label 1718: @109614
     /* 109614 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109646), // Rule ID 6741 //
     /* 109619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109633 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109636 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109645 */   // GIR_Coverage, 6741,
     /* 109645 */   GIR_EraseRootFromParent_Done,
     /* 109646 */ // Label 1719: @109646
     /* 109646 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109678), // Rule ID 6742 //
     /* 109651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109665 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109668 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109670 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109677 */   // GIR_Coverage, 6742,
     /* 109677 */   GIR_EraseRootFromParent_Done,
     /* 109678 */ // Label 1720: @109678
     /* 109678 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109710), // Rule ID 6743 //
     /* 109683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109697 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109700 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109702 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109709 */   // GIR_Coverage, 6743,
     /* 109709 */   GIR_EraseRootFromParent_Done,
     /* 109710 */ // Label 1721: @109710
     /* 109710 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109742), // Rule ID 6744 //
     /* 109715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109729 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109732 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109741 */   // GIR_Coverage, 6744,
     /* 109741 */   GIR_EraseRootFromParent_Done,
     /* 109742 */ // Label 1722: @109742
     /* 109742 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109768), // Rule ID 6745 //
     /* 109747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109761 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 109761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109766 */   GIR_RootConstrainSelectedInstOperands,
     /* 109767 */   // GIR_Coverage, 6745,
     /* 109767 */   GIR_Done,
     /* 109768 */ // Label 1723: @109768
     /* 109768 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109794), // Rule ID 6746 //
     /* 109773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109787 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 109787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109792 */   GIR_RootConstrainSelectedInstOperands,
     /* 109793 */   // GIR_Coverage, 6746,
     /* 109793 */   GIR_Done,
     /* 109794 */ // Label 1724: @109794
     /* 109794 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109820), // Rule ID 6747 //
     /* 109799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109813 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 109813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 109818 */   GIR_RootConstrainSelectedInstOperands,
     /* 109819 */   // GIR_Coverage, 6747,
     /* 109819 */   GIR_Done,
     /* 109820 */ // Label 1725: @109820
     /* 109820 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109846), // Rule ID 6748 //
     /* 109825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109839 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 109839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109844 */   GIR_RootConstrainSelectedInstOperands,
     /* 109845 */   // GIR_Coverage, 6748,
     /* 109845 */   GIR_Done,
     /* 109846 */ // Label 1726: @109846
     /* 109846 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109872), // Rule ID 6749 //
     /* 109851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109865 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 109865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109870 */   GIR_RootConstrainSelectedInstOperands,
     /* 109871 */   // GIR_Coverage, 6749,
     /* 109871 */   GIR_Done,
     /* 109872 */ // Label 1727: @109872
     /* 109872 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109898), // Rule ID 6750 //
     /* 109877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109891 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 109891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109896 */   GIR_RootConstrainSelectedInstOperands,
     /* 109897 */   // GIR_Coverage, 6750,
     /* 109897 */   GIR_Done,
     /* 109898 */ // Label 1728: @109898
     /* 109898 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109927), // Rule ID 6751 //
     /* 109903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109914 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109917 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109926 */   // GIR_Coverage, 6751,
     /* 109926 */   GIR_EraseRootFromParent_Done,
     /* 109927 */ // Label 1729: @109927
     /* 109927 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109959), // Rule ID 6816 //
     /* 109932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109946 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 109946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109958 */   // GIR_Coverage, 6816,
     /* 109958 */   GIR_EraseRootFromParent_Done,
     /* 109959 */ // Label 1730: @109959
     /* 109959 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109991), // Rule ID 6817 //
     /* 109964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109978 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 109978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109990 */   // GIR_Coverage, 6817,
     /* 109990 */   GIR_EraseRootFromParent_Done,
     /* 109991 */ // Label 1731: @109991
     /* 109991 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(110023), // Rule ID 6818 //
     /* 109996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110010 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110013 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110022 */   // GIR_Coverage, 6818,
     /* 110022 */   GIR_EraseRootFromParent_Done,
     /* 110023 */ // Label 1732: @110023
     /* 110023 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(110055), // Rule ID 6819 //
     /* 110028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110042 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110045 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110054 */   // GIR_Coverage, 6819,
     /* 110054 */   GIR_EraseRootFromParent_Done,
     /* 110055 */ // Label 1733: @110055
     /* 110055 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(110087), // Rule ID 6820 //
     /* 110060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110074 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110086 */   // GIR_Coverage, 6820,
     /* 110086 */   GIR_EraseRootFromParent_Done,
     /* 110087 */ // Label 1734: @110087
     /* 110087 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(110119), // Rule ID 6821 //
     /* 110092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110106 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110118 */   // GIR_Coverage, 6821,
     /* 110118 */   GIR_EraseRootFromParent_Done,
     /* 110119 */ // Label 1735: @110119
     /* 110119 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(110145), // Rule ID 6822 //
     /* 110124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110138 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 110138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110143 */   GIR_RootConstrainSelectedInstOperands,
     /* 110144 */   // GIR_Coverage, 6822,
     /* 110144 */   GIR_Done,
     /* 110145 */ // Label 1736: @110145
     /* 110145 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(110171), // Rule ID 6823 //
     /* 110150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110164 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 110164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110169 */   GIR_RootConstrainSelectedInstOperands,
     /* 110170 */   // GIR_Coverage, 6823,
     /* 110170 */   GIR_Done,
     /* 110171 */ // Label 1737: @110171
     /* 110171 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(110197), // Rule ID 6824 //
     /* 110176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110190 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 110190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 110195 */   GIR_RootConstrainSelectedInstOperands,
     /* 110196 */   // GIR_Coverage, 6824,
     /* 110196 */   GIR_Done,
     /* 110197 */ // Label 1738: @110197
     /* 110197 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(110223), // Rule ID 6825 //
     /* 110202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110216 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 110216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110221 */   GIR_RootConstrainSelectedInstOperands,
     /* 110222 */   // GIR_Coverage, 6825,
     /* 110222 */   GIR_Done,
     /* 110223 */ // Label 1739: @110223
     /* 110223 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(110249), // Rule ID 6826 //
     /* 110228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110242 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 110242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110247 */   GIR_RootConstrainSelectedInstOperands,
     /* 110248 */   // GIR_Coverage, 6826,
     /* 110248 */   GIR_Done,
     /* 110249 */ // Label 1740: @110249
     /* 110249 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(110275), // Rule ID 6827 //
     /* 110254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110268 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 110268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110273 */   GIR_RootConstrainSelectedInstOperands,
     /* 110274 */   // GIR_Coverage, 6827,
     /* 110274 */   GIR_Done,
     /* 110275 */ // Label 1741: @110275
     /* 110275 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(110304), // Rule ID 6828 //
     /* 110280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110291 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110303 */   // GIR_Coverage, 6828,
     /* 110303 */   GIR_EraseRootFromParent_Done,
     /* 110304 */ // Label 1742: @110304
     /* 110304 */ GIM_Reject,
     /* 110305 */ // Label 1620: @110305
     /* 110305 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(110337), // Rule ID 6843 //
     /* 110310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110324 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110336 */   // GIR_Coverage, 6843,
     /* 110336 */   GIR_EraseRootFromParent_Done,
     /* 110337 */ // Label 1743: @110337
     /* 110337 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(110369), // Rule ID 6844 //
     /* 110342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110356 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110368 */   // GIR_Coverage, 6844,
     /* 110368 */   GIR_EraseRootFromParent_Done,
     /* 110369 */ // Label 1744: @110369
     /* 110369 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(110401), // Rule ID 6845 //
     /* 110374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110388 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110400 */   // GIR_Coverage, 6845,
     /* 110400 */   GIR_EraseRootFromParent_Done,
     /* 110401 */ // Label 1745: @110401
     /* 110401 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110433), // Rule ID 6846 //
     /* 110406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110420 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110423 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110432 */   // GIR_Coverage, 6846,
     /* 110432 */   GIR_EraseRootFromParent_Done,
     /* 110433 */ // Label 1746: @110433
     /* 110433 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110465), // Rule ID 6847 //
     /* 110438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110452 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110455 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110457 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110464 */   // GIR_Coverage, 6847,
     /* 110464 */   GIR_EraseRootFromParent_Done,
     /* 110465 */ // Label 1747: @110465
     /* 110465 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110497), // Rule ID 6848 //
     /* 110470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110484 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110496 */   // GIR_Coverage, 6848,
     /* 110496 */   GIR_EraseRootFromParent_Done,
     /* 110497 */ // Label 1748: @110497
     /* 110497 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(110530), // Rule ID 6849 //
     /* 110502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110516 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 110516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110523 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110528 */   GIR_RootConstrainSelectedInstOperands,
     /* 110529 */   // GIR_Coverage, 6849,
     /* 110529 */   GIR_EraseRootFromParent_Done,
     /* 110530 */ // Label 1749: @110530
     /* 110530 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(110556), // Rule ID 6850 //
     /* 110535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110549 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 110549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110554 */   GIR_RootConstrainSelectedInstOperands,
     /* 110555 */   // GIR_Coverage, 6850,
     /* 110555 */   GIR_Done,
     /* 110556 */ // Label 1750: @110556
     /* 110556 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(110582), // Rule ID 6851 //
     /* 110561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110575 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 110575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110580 */   GIR_RootConstrainSelectedInstOperands,
     /* 110581 */   // GIR_Coverage, 6851,
     /* 110581 */   GIR_Done,
     /* 110582 */ // Label 1751: @110582
     /* 110582 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(110608), // Rule ID 6852 //
     /* 110587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110601 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 110601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110606 */   GIR_RootConstrainSelectedInstOperands,
     /* 110607 */   // GIR_Coverage, 6852,
     /* 110607 */   GIR_Done,
     /* 110608 */ // Label 1752: @110608
     /* 110608 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(110634), // Rule ID 6853 //
     /* 110613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110627 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 110627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 110632 */   GIR_RootConstrainSelectedInstOperands,
     /* 110633 */   // GIR_Coverage, 6853,
     /* 110633 */   GIR_Done,
     /* 110634 */ // Label 1753: @110634
     /* 110634 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(110660), // Rule ID 6854 //
     /* 110639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110653 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 110653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110658 */   GIR_RootConstrainSelectedInstOperands,
     /* 110659 */   // GIR_Coverage, 6854,
     /* 110659 */   GIR_Done,
     /* 110660 */ // Label 1754: @110660
     /* 110660 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(110689), // Rule ID 6855 //
     /* 110665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110676 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110679 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110681 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110688 */   // GIR_Coverage, 6855,
     /* 110688 */   GIR_EraseRootFromParent_Done,
     /* 110689 */ // Label 1755: @110689
     /* 110689 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(110721), // Rule ID 6869 //
     /* 110694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110708 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110720 */   // GIR_Coverage, 6869,
     /* 110720 */   GIR_EraseRootFromParent_Done,
     /* 110721 */ // Label 1756: @110721
     /* 110721 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(110753), // Rule ID 6870 //
     /* 110726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110740 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110752 */   // GIR_Coverage, 6870,
     /* 110752 */   GIR_EraseRootFromParent_Done,
     /* 110753 */ // Label 1757: @110753
     /* 110753 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(110785), // Rule ID 6871 //
     /* 110758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110772 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110775 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110784 */   // GIR_Coverage, 6871,
     /* 110784 */   GIR_EraseRootFromParent_Done,
     /* 110785 */ // Label 1758: @110785
     /* 110785 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(110817), // Rule ID 6872 //
     /* 110790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110804 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110816 */   // GIR_Coverage, 6872,
     /* 110816 */   GIR_EraseRootFromParent_Done,
     /* 110817 */ // Label 1759: @110817
     /* 110817 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(110849), // Rule ID 6873 //
     /* 110822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110836 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110848 */   // GIR_Coverage, 6873,
     /* 110848 */   GIR_EraseRootFromParent_Done,
     /* 110849 */ // Label 1760: @110849
     /* 110849 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(110881), // Rule ID 6874 //
     /* 110854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110868 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110880 */   // GIR_Coverage, 6874,
     /* 110880 */   GIR_EraseRootFromParent_Done,
     /* 110881 */ // Label 1761: @110881
     /* 110881 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(110914), // Rule ID 6875 //
     /* 110886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110900 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 110900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110912 */   GIR_RootConstrainSelectedInstOperands,
     /* 110913 */   // GIR_Coverage, 6875,
     /* 110913 */   GIR_EraseRootFromParent_Done,
     /* 110914 */ // Label 1762: @110914
     /* 110914 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(110940), // Rule ID 6876 //
     /* 110919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110933 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 110933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110938 */   GIR_RootConstrainSelectedInstOperands,
     /* 110939 */   // GIR_Coverage, 6876,
     /* 110939 */   GIR_Done,
     /* 110940 */ // Label 1763: @110940
     /* 110940 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(110966), // Rule ID 6877 //
     /* 110945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110959 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 110959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110964 */   GIR_RootConstrainSelectedInstOperands,
     /* 110965 */   // GIR_Coverage, 6877,
     /* 110965 */   GIR_Done,
     /* 110966 */ // Label 1764: @110966
     /* 110966 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(110992), // Rule ID 6878 //
     /* 110971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110985 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 110985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 110990 */   GIR_RootConstrainSelectedInstOperands,
     /* 110991 */   // GIR_Coverage, 6878,
     /* 110991 */   GIR_Done,
     /* 110992 */ // Label 1765: @110992
     /* 110992 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(111018), // Rule ID 6879 //
     /* 110997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111011 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 111011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111016 */   GIR_RootConstrainSelectedInstOperands,
     /* 111017 */   // GIR_Coverage, 6879,
     /* 111017 */   GIR_Done,
     /* 111018 */ // Label 1766: @111018
     /* 111018 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(111044), // Rule ID 6880 //
     /* 111023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111037 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 111037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 111042 */   GIR_RootConstrainSelectedInstOperands,
     /* 111043 */   // GIR_Coverage, 6880,
     /* 111043 */   GIR_Done,
     /* 111044 */ // Label 1767: @111044
     /* 111044 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(111073), // Rule ID 6881 //
     /* 111049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111060 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111072 */   // GIR_Coverage, 6881,
     /* 111072 */   GIR_EraseRootFromParent_Done,
     /* 111073 */ // Label 1768: @111073
     /* 111073 */ GIM_Reject,
     /* 111074 */ // Label 1621: @111074
     /* 111074 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(111104), // Rule ID 6693 //
     /* 111079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111093 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111103 */   // GIR_Coverage, 6693,
     /* 111103 */   GIR_Done,
     /* 111104 */ // Label 1769: @111104
     /* 111104 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(111134), // Rule ID 6695 //
     /* 111109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111123 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111133 */   // GIR_Coverage, 6695,
     /* 111133 */   GIR_Done,
     /* 111134 */ // Label 1770: @111134
     /* 111134 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(111184), // Rule ID 6704 //
     /* 111139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111153 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111169 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111182 */   GIR_RootConstrainSelectedInstOperands,
     /* 111183 */   // GIR_Coverage, 6704,
     /* 111183 */   GIR_EraseRootFromParent_Done,
     /* 111184 */ // Label 1771: @111184
     /* 111184 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(111234), // Rule ID 6706 //
     /* 111189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111203 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111232 */   GIR_RootConstrainSelectedInstOperands,
     /* 111233 */   // GIR_Coverage, 6706,
     /* 111233 */   GIR_EraseRootFromParent_Done,
     /* 111234 */ // Label 1772: @111234
     /* 111234 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(111266), // Rule ID 6752 //
     /* 111239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111253 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111265 */   // GIR_Coverage, 6752,
     /* 111265 */   GIR_EraseRootFromParent_Done,
     /* 111266 */ // Label 1773: @111266
     /* 111266 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(111298), // Rule ID 6753 //
     /* 111271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111285 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111288 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111297 */   // GIR_Coverage, 6753,
     /* 111297 */   GIR_EraseRootFromParent_Done,
     /* 111298 */ // Label 1774: @111298
     /* 111298 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(111330), // Rule ID 6754 //
     /* 111303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111317 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111329 */   // GIR_Coverage, 6754,
     /* 111329 */   GIR_EraseRootFromParent_Done,
     /* 111330 */ // Label 1775: @111330
     /* 111330 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(111362), // Rule ID 6755 //
     /* 111335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111349 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111361 */   // GIR_Coverage, 6755,
     /* 111361 */   GIR_EraseRootFromParent_Done,
     /* 111362 */ // Label 1776: @111362
     /* 111362 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(111394), // Rule ID 6756 //
     /* 111367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111381 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111393 */   // GIR_Coverage, 6756,
     /* 111393 */   GIR_EraseRootFromParent_Done,
     /* 111394 */ // Label 1777: @111394
     /* 111394 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(111426), // Rule ID 6757 //
     /* 111399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111413 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111416 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111425 */   // GIR_Coverage, 6757,
     /* 111425 */   GIR_EraseRootFromParent_Done,
     /* 111426 */ // Label 1778: @111426
     /* 111426 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(111452), // Rule ID 6758 //
     /* 111431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111445 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 111445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111450 */   GIR_RootConstrainSelectedInstOperands,
     /* 111451 */   // GIR_Coverage, 6758,
     /* 111451 */   GIR_Done,
     /* 111452 */ // Label 1779: @111452
     /* 111452 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(111478), // Rule ID 6759 //
     /* 111457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111471 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 111471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111476 */   GIR_RootConstrainSelectedInstOperands,
     /* 111477 */   // GIR_Coverage, 6759,
     /* 111477 */   GIR_Done,
     /* 111478 */ // Label 1780: @111478
     /* 111478 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(111504), // Rule ID 6760 //
     /* 111483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111497 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 111497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111502 */   GIR_RootConstrainSelectedInstOperands,
     /* 111503 */   // GIR_Coverage, 6760,
     /* 111503 */   GIR_Done,
     /* 111504 */ // Label 1781: @111504
     /* 111504 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(111530), // Rule ID 6761 //
     /* 111509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111523 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 111523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111528 */   GIR_RootConstrainSelectedInstOperands,
     /* 111529 */   // GIR_Coverage, 6761,
     /* 111529 */   GIR_Done,
     /* 111530 */ // Label 1782: @111530
     /* 111530 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(111556), // Rule ID 6762 //
     /* 111535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111549 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 111549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111554 */   GIR_RootConstrainSelectedInstOperands,
     /* 111555 */   // GIR_Coverage, 6762,
     /* 111555 */   GIR_Done,
     /* 111556 */ // Label 1783: @111556
     /* 111556 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(111582), // Rule ID 6763 //
     /* 111561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111575 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 111575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111580 */   GIR_RootConstrainSelectedInstOperands,
     /* 111581 */   // GIR_Coverage, 6763,
     /* 111581 */   GIR_Done,
     /* 111582 */ // Label 1784: @111582
     /* 111582 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(111611), // Rule ID 6764 //
     /* 111587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111598 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111601 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111603 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111610 */   // GIR_Coverage, 6764,
     /* 111610 */   GIR_EraseRootFromParent_Done,
     /* 111611 */ // Label 1785: @111611
     /* 111611 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(111643), // Rule ID 6765 //
     /* 111616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111630 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111633 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111635 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111642 */   // GIR_Coverage, 6765,
     /* 111642 */   GIR_EraseRootFromParent_Done,
     /* 111643 */ // Label 1786: @111643
     /* 111643 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(111675), // Rule ID 6766 //
     /* 111648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111662 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111665 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111674 */   // GIR_Coverage, 6766,
     /* 111674 */   GIR_EraseRootFromParent_Done,
     /* 111675 */ // Label 1787: @111675
     /* 111675 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(111707), // Rule ID 6767 //
     /* 111680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111694 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111697 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111699 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111706 */   // GIR_Coverage, 6767,
     /* 111706 */   GIR_EraseRootFromParent_Done,
     /* 111707 */ // Label 1788: @111707
     /* 111707 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(111739), // Rule ID 6768 //
     /* 111712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111726 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111729 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111731 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111738 */   // GIR_Coverage, 6768,
     /* 111738 */   GIR_EraseRootFromParent_Done,
     /* 111739 */ // Label 1789: @111739
     /* 111739 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(111771), // Rule ID 6769 //
     /* 111744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111758 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111761 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111763 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111770 */   // GIR_Coverage, 6769,
     /* 111770 */   GIR_EraseRootFromParent_Done,
     /* 111771 */ // Label 1790: @111771
     /* 111771 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(111803), // Rule ID 6770 //
     /* 111776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111790 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111802 */   // GIR_Coverage, 6770,
     /* 111802 */   GIR_EraseRootFromParent_Done,
     /* 111803 */ // Label 1791: @111803
     /* 111803 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(111829), // Rule ID 6771 //
     /* 111808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111822 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 111822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111827 */   GIR_RootConstrainSelectedInstOperands,
     /* 111828 */   // GIR_Coverage, 6771,
     /* 111828 */   GIR_Done,
     /* 111829 */ // Label 1792: @111829
     /* 111829 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(111855), // Rule ID 6772 //
     /* 111834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111848 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 111848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111853 */   GIR_RootConstrainSelectedInstOperands,
     /* 111854 */   // GIR_Coverage, 6772,
     /* 111854 */   GIR_Done,
     /* 111855 */ // Label 1793: @111855
     /* 111855 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111881), // Rule ID 6773 //
     /* 111860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111874 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 111874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111879 */   GIR_RootConstrainSelectedInstOperands,
     /* 111880 */   // GIR_Coverage, 6773,
     /* 111880 */   GIR_Done,
     /* 111881 */ // Label 1794: @111881
     /* 111881 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111907), // Rule ID 6774 //
     /* 111886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111900 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 111900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111905 */   GIR_RootConstrainSelectedInstOperands,
     /* 111906 */   // GIR_Coverage, 6774,
     /* 111906 */   GIR_Done,
     /* 111907 */ // Label 1795: @111907
     /* 111907 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111933), // Rule ID 6775 //
     /* 111912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111926 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 111926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111931 */   GIR_RootConstrainSelectedInstOperands,
     /* 111932 */   // GIR_Coverage, 6775,
     /* 111932 */   GIR_Done,
     /* 111933 */ // Label 1796: @111933
     /* 111933 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111959), // Rule ID 6776 //
     /* 111938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111952 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 111952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111957 */   GIR_RootConstrainSelectedInstOperands,
     /* 111958 */   // GIR_Coverage, 6776,
     /* 111958 */   GIR_Done,
     /* 111959 */ // Label 1797: @111959
     /* 111959 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111988), // Rule ID 6777 //
     /* 111964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111975 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111978 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111987 */   // GIR_Coverage, 6777,
     /* 111987 */   GIR_EraseRootFromParent_Done,
     /* 111988 */ // Label 1798: @111988
     /* 111988 */ GIM_Reject,
     /* 111989 */ // Label 1622: @111989
     /* 111989 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(112021), // Rule ID 6856 //
     /* 111994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112008 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112011 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112013 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112020 */   // GIR_Coverage, 6856,
     /* 112020 */   GIR_EraseRootFromParent_Done,
     /* 112021 */ // Label 1799: @112021
     /* 112021 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(112053), // Rule ID 6857 //
     /* 112026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112040 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112043 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112052 */   // GIR_Coverage, 6857,
     /* 112052 */   GIR_EraseRootFromParent_Done,
     /* 112053 */ // Label 1800: @112053
     /* 112053 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(112085), // Rule ID 6858 //
     /* 112058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112072 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112075 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112077 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112084 */   // GIR_Coverage, 6858,
     /* 112084 */   GIR_EraseRootFromParent_Done,
     /* 112085 */ // Label 1801: @112085
     /* 112085 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(112117), // Rule ID 6859 //
     /* 112090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112104 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112107 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112109 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112116 */   // GIR_Coverage, 6859,
     /* 112116 */   GIR_EraseRootFromParent_Done,
     /* 112117 */ // Label 1802: @112117
     /* 112117 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(112149), // Rule ID 6860 //
     /* 112122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112136 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112139 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112141 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112148 */   // GIR_Coverage, 6860,
     /* 112148 */   GIR_EraseRootFromParent_Done,
     /* 112149 */ // Label 1803: @112149
     /* 112149 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(112181), // Rule ID 6861 //
     /* 112154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112168 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112171 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112173 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112175 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112180 */   // GIR_Coverage, 6861,
     /* 112180 */   GIR_EraseRootFromParent_Done,
     /* 112181 */ // Label 1804: @112181
     /* 112181 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(112252), // Rule ID 6862 //
     /* 112186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112200 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112200 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112203 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112207 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112212 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112250 */   GIR_RootConstrainSelectedInstOperands,
     /* 112251 */   // GIR_Coverage, 6862,
     /* 112251 */   GIR_EraseRootFromParent_Done,
     /* 112252 */ // Label 1805: @112252
     /* 112252 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(112278), // Rule ID 6863 //
     /* 112257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112271 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 112271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112276 */   GIR_RootConstrainSelectedInstOperands,
     /* 112277 */   // GIR_Coverage, 6863,
     /* 112277 */   GIR_Done,
     /* 112278 */ // Label 1806: @112278
     /* 112278 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(112304), // Rule ID 6864 //
     /* 112283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112297 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 112297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112302 */   GIR_RootConstrainSelectedInstOperands,
     /* 112303 */   // GIR_Coverage, 6864,
     /* 112303 */   GIR_Done,
     /* 112304 */ // Label 1807: @112304
     /* 112304 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(112330), // Rule ID 6865 //
     /* 112309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112323 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 112323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112328 */   GIR_RootConstrainSelectedInstOperands,
     /* 112329 */   // GIR_Coverage, 6865,
     /* 112329 */   GIR_Done,
     /* 112330 */ // Label 1808: @112330
     /* 112330 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(112356), // Rule ID 6866 //
     /* 112335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112349 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 112349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112354 */   GIR_RootConstrainSelectedInstOperands,
     /* 112355 */   // GIR_Coverage, 6866,
     /* 112355 */   GIR_Done,
     /* 112356 */ // Label 1809: @112356
     /* 112356 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(112382), // Rule ID 6867 //
     /* 112361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112375 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 112375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112380 */   GIR_RootConstrainSelectedInstOperands,
     /* 112381 */   // GIR_Coverage, 6867,
     /* 112381 */   GIR_Done,
     /* 112382 */ // Label 1810: @112382
     /* 112382 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(112411), // Rule ID 6868 //
     /* 112387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112398 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112401 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112403 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112410 */   // GIR_Coverage, 6868,
     /* 112410 */   GIR_EraseRootFromParent_Done,
     /* 112411 */ // Label 1811: @112411
     /* 112411 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(112443), // Rule ID 6882 //
     /* 112416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112430 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112433 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112442 */   // GIR_Coverage, 6882,
     /* 112442 */   GIR_EraseRootFromParent_Done,
     /* 112443 */ // Label 1812: @112443
     /* 112443 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(112475), // Rule ID 6883 //
     /* 112448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112462 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112465 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112474 */   // GIR_Coverage, 6883,
     /* 112474 */   GIR_EraseRootFromParent_Done,
     /* 112475 */ // Label 1813: @112475
     /* 112475 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(112507), // Rule ID 6884 //
     /* 112480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112494 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112497 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112499 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112506 */   // GIR_Coverage, 6884,
     /* 112506 */   GIR_EraseRootFromParent_Done,
     /* 112507 */ // Label 1814: @112507
     /* 112507 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(112539), // Rule ID 6885 //
     /* 112512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112526 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112538 */   // GIR_Coverage, 6885,
     /* 112538 */   GIR_EraseRootFromParent_Done,
     /* 112539 */ // Label 1815: @112539
     /* 112539 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(112571), // Rule ID 6886 //
     /* 112544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112558 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112570 */   // GIR_Coverage, 6886,
     /* 112570 */   GIR_EraseRootFromParent_Done,
     /* 112571 */ // Label 1816: @112571
     /* 112571 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(112603), // Rule ID 6887 //
     /* 112576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112590 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112593 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112595 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112602 */   // GIR_Coverage, 6887,
     /* 112602 */   GIR_EraseRootFromParent_Done,
     /* 112603 */ // Label 1817: @112603
     /* 112603 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112674), // Rule ID 6888 //
     /* 112608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112622 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112622 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112625 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112629 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112634 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112652 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112672 */   GIR_RootConstrainSelectedInstOperands,
     /* 112673 */   // GIR_Coverage, 6888,
     /* 112673 */   GIR_EraseRootFromParent_Done,
     /* 112674 */ // Label 1818: @112674
     /* 112674 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(112700), // Rule ID 6889 //
     /* 112679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112693 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 112693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112698 */   GIR_RootConstrainSelectedInstOperands,
     /* 112699 */   // GIR_Coverage, 6889,
     /* 112699 */   GIR_Done,
     /* 112700 */ // Label 1819: @112700
     /* 112700 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112726), // Rule ID 6890 //
     /* 112705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112719 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 112719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112724 */   GIR_RootConstrainSelectedInstOperands,
     /* 112725 */   // GIR_Coverage, 6890,
     /* 112725 */   GIR_Done,
     /* 112726 */ // Label 1820: @112726
     /* 112726 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112752), // Rule ID 6891 //
     /* 112731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112745 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 112745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112750 */   GIR_RootConstrainSelectedInstOperands,
     /* 112751 */   // GIR_Coverage, 6891,
     /* 112751 */   GIR_Done,
     /* 112752 */ // Label 1821: @112752
     /* 112752 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112778), // Rule ID 6892 //
     /* 112757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112771 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 112771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112776 */   GIR_RootConstrainSelectedInstOperands,
     /* 112777 */   // GIR_Coverage, 6892,
     /* 112777 */   GIR_Done,
     /* 112778 */ // Label 1822: @112778
     /* 112778 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112804), // Rule ID 6893 //
     /* 112783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112797 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 112797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112802 */   GIR_RootConstrainSelectedInstOperands,
     /* 112803 */   // GIR_Coverage, 6893,
     /* 112803 */   GIR_Done,
     /* 112804 */ // Label 1823: @112804
     /* 112804 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112833), // Rule ID 6894 //
     /* 112809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112820 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112823 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112825 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112832 */   // GIR_Coverage, 6894,
     /* 112832 */   GIR_EraseRootFromParent_Done,
     /* 112833 */ // Label 1824: @112833
     /* 112833 */ GIM_Reject,
     /* 112834 */ // Label 1623: @112834
     /* 112834 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112908), // Rule ID 5689 //
     /* 112839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112846 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112850 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 112854 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112858 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112865 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 112865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 112872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 112881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 112897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112907 */   // GIR_Coverage, 5689,
     /* 112907 */   GIR_EraseRootFromParent_Done,
     /* 112908 */ // Label 1825: @112908
     /* 112908 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112938), // Rule ID 6692 //
     /* 112913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 112927 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 112927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112937 */   // GIR_Coverage, 6692,
     /* 112937 */   GIR_Done,
     /* 112938 */ // Label 1826: @112938
     /* 112938 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112988), // Rule ID 6703 //
     /* 112943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 112957 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 112957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112969 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 112973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 112981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112986 */   GIR_RootConstrainSelectedInstOperands,
     /* 112987 */   // GIR_Coverage, 6703,
     /* 112987 */   GIR_EraseRootFromParent_Done,
     /* 112988 */ // Label 1827: @112988
     /* 112988 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(113020), // Rule ID 6778 //
     /* 112993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113007 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113010 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113012 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113019 */   // GIR_Coverage, 6778,
     /* 113019 */   GIR_EraseRootFromParent_Done,
     /* 113020 */ // Label 1828: @113020
     /* 113020 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(113052), // Rule ID 6779 //
     /* 113025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113039 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113042 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113051 */   // GIR_Coverage, 6779,
     /* 113051 */   GIR_EraseRootFromParent_Done,
     /* 113052 */ // Label 1829: @113052
     /* 113052 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(113084), // Rule ID 6780 //
     /* 113057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113071 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113074 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113083 */   // GIR_Coverage, 6780,
     /* 113083 */   GIR_EraseRootFromParent_Done,
     /* 113084 */ // Label 1830: @113084
     /* 113084 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(113116), // Rule ID 6781 //
     /* 113089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113103 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113115 */   // GIR_Coverage, 6781,
     /* 113115 */   GIR_EraseRootFromParent_Done,
     /* 113116 */ // Label 1831: @113116
     /* 113116 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(113148), // Rule ID 6782 //
     /* 113121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113135 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113147 */   // GIR_Coverage, 6782,
     /* 113147 */   GIR_EraseRootFromParent_Done,
     /* 113148 */ // Label 1832: @113148
     /* 113148 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(113180), // Rule ID 6783 //
     /* 113153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113167 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113170 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113179 */   // GIR_Coverage, 6783,
     /* 113179 */   GIR_EraseRootFromParent_Done,
     /* 113180 */ // Label 1833: @113180
     /* 113180 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(113212), // Rule ID 6784 //
     /* 113185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113199 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113202 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113204 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113211 */   // GIR_Coverage, 6784,
     /* 113211 */   GIR_EraseRootFromParent_Done,
     /* 113212 */ // Label 1834: @113212
     /* 113212 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(113238), // Rule ID 6785 //
     /* 113217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113231 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 113231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113236 */   GIR_RootConstrainSelectedInstOperands,
     /* 113237 */   // GIR_Coverage, 6785,
     /* 113237 */   GIR_Done,
     /* 113238 */ // Label 1835: @113238
     /* 113238 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(113264), // Rule ID 6786 //
     /* 113243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113257 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 113257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113262 */   GIR_RootConstrainSelectedInstOperands,
     /* 113263 */   // GIR_Coverage, 6786,
     /* 113263 */   GIR_Done,
     /* 113264 */ // Label 1836: @113264
     /* 113264 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(113290), // Rule ID 6787 //
     /* 113269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113283 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 113283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113288 */   GIR_RootConstrainSelectedInstOperands,
     /* 113289 */   // GIR_Coverage, 6787,
     /* 113289 */   GIR_Done,
     /* 113290 */ // Label 1837: @113290
     /* 113290 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(113316), // Rule ID 6788 //
     /* 113295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113309 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 113309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113314 */   GIR_RootConstrainSelectedInstOperands,
     /* 113315 */   // GIR_Coverage, 6788,
     /* 113315 */   GIR_Done,
     /* 113316 */ // Label 1838: @113316
     /* 113316 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(113342), // Rule ID 6789 //
     /* 113321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113335 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 113335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113340 */   GIR_RootConstrainSelectedInstOperands,
     /* 113341 */   // GIR_Coverage, 6789,
     /* 113341 */   GIR_Done,
     /* 113342 */ // Label 1839: @113342
     /* 113342 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(113368), // Rule ID 6790 //
     /* 113347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113361 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 113361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113366 */   GIR_RootConstrainSelectedInstOperands,
     /* 113367 */   // GIR_Coverage, 6790,
     /* 113367 */   GIR_Done,
     /* 113368 */ // Label 1840: @113368
     /* 113368 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(113394), // Rule ID 6791 //
     /* 113373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113387 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 113387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113392 */   GIR_RootConstrainSelectedInstOperands,
     /* 113393 */   // GIR_Coverage, 6791,
     /* 113393 */   GIR_Done,
     /* 113394 */ // Label 1841: @113394
     /* 113394 */ GIM_Reject,
     /* 113395 */ // Label 1624: @113395
     /* 113395 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(113427), // Rule ID 6895 //
     /* 113400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113414 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113426 */   // GIR_Coverage, 6895,
     /* 113426 */   GIR_EraseRootFromParent_Done,
     /* 113427 */ // Label 1842: @113427
     /* 113427 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(113459), // Rule ID 6896 //
     /* 113432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113446 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113458 */   // GIR_Coverage, 6896,
     /* 113458 */   GIR_EraseRootFromParent_Done,
     /* 113459 */ // Label 1843: @113459
     /* 113459 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(113491), // Rule ID 6897 //
     /* 113464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113478 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113490 */   // GIR_Coverage, 6897,
     /* 113490 */   GIR_EraseRootFromParent_Done,
     /* 113491 */ // Label 1844: @113491
     /* 113491 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(113523), // Rule ID 6898 //
     /* 113496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113510 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113522 */   // GIR_Coverage, 6898,
     /* 113522 */   GIR_EraseRootFromParent_Done,
     /* 113523 */ // Label 1845: @113523
     /* 113523 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(113555), // Rule ID 6899 //
     /* 113528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113542 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113554 */   // GIR_Coverage, 6899,
     /* 113554 */   GIR_EraseRootFromParent_Done,
     /* 113555 */ // Label 1846: @113555
     /* 113555 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(113587), // Rule ID 6900 //
     /* 113560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113574 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113586 */   // GIR_Coverage, 6900,
     /* 113586 */   GIR_EraseRootFromParent_Done,
     /* 113587 */ // Label 1847: @113587
     /* 113587 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(113658), // Rule ID 6901 //
     /* 113592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113606 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113606 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113609 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113613 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113636 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 113645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 113653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 113656 */   GIR_RootConstrainSelectedInstOperands,
     /* 113657 */   // GIR_Coverage, 6901,
     /* 113657 */   GIR_EraseRootFromParent_Done,
     /* 113658 */ // Label 1848: @113658
     /* 113658 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(113684), // Rule ID 6902 //
     /* 113663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113677 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 113677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113682 */   GIR_RootConstrainSelectedInstOperands,
     /* 113683 */   // GIR_Coverage, 6902,
     /* 113683 */   GIR_Done,
     /* 113684 */ // Label 1849: @113684
     /* 113684 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(113710), // Rule ID 6903 //
     /* 113689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113703 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 113703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113708 */   GIR_RootConstrainSelectedInstOperands,
     /* 113709 */   // GIR_Coverage, 6903,
     /* 113709 */   GIR_Done,
     /* 113710 */ // Label 1850: @113710
     /* 113710 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(113736), // Rule ID 6904 //
     /* 113715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113729 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 113729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113734 */   GIR_RootConstrainSelectedInstOperands,
     /* 113735 */   // GIR_Coverage, 6904,
     /* 113735 */   GIR_Done,
     /* 113736 */ // Label 1851: @113736
     /* 113736 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(113762), // Rule ID 6905 //
     /* 113741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113755 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 113755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113760 */   GIR_RootConstrainSelectedInstOperands,
     /* 113761 */   // GIR_Coverage, 6905,
     /* 113761 */   GIR_Done,
     /* 113762 */ // Label 1852: @113762
     /* 113762 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(113788), // Rule ID 6906 //
     /* 113767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113781 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 113781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113786 */   GIR_RootConstrainSelectedInstOperands,
     /* 113787 */   // GIR_Coverage, 6906,
     /* 113787 */   GIR_Done,
     /* 113788 */ // Label 1853: @113788
     /* 113788 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(113817), // Rule ID 6907 //
     /* 113793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113804 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113816 */   // GIR_Coverage, 6907,
     /* 113816 */   GIR_EraseRootFromParent_Done,
     /* 113817 */ // Label 1854: @113817
     /* 113817 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(113849), // Rule ID 6908 //
     /* 113822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113836 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113848 */   // GIR_Coverage, 6908,
     /* 113848 */   GIR_EraseRootFromParent_Done,
     /* 113849 */ // Label 1855: @113849
     /* 113849 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(113881), // Rule ID 6909 //
     /* 113854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113868 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113880 */   // GIR_Coverage, 6909,
     /* 113880 */   GIR_EraseRootFromParent_Done,
     /* 113881 */ // Label 1856: @113881
     /* 113881 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(113913), // Rule ID 6910 //
     /* 113886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113900 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113903 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113912 */   // GIR_Coverage, 6910,
     /* 113912 */   GIR_EraseRootFromParent_Done,
     /* 113913 */ // Label 1857: @113913
     /* 113913 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(113945), // Rule ID 6911 //
     /* 113918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113932 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113944 */   // GIR_Coverage, 6911,
     /* 113944 */   GIR_EraseRootFromParent_Done,
     /* 113945 */ // Label 1858: @113945
     /* 113945 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(113977), // Rule ID 6912 //
     /* 113950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113964 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113967 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113976 */   // GIR_Coverage, 6912,
     /* 113976 */   GIR_EraseRootFromParent_Done,
     /* 113977 */ // Label 1859: @113977
     /* 113977 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(114009), // Rule ID 6913 //
     /* 113982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113996 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113999 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114008 */   // GIR_Coverage, 6913,
     /* 114008 */   GIR_EraseRootFromParent_Done,
     /* 114009 */ // Label 1860: @114009
     /* 114009 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(114080), // Rule ID 6914 //
     /* 114014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114028 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114078 */   GIR_RootConstrainSelectedInstOperands,
     /* 114079 */   // GIR_Coverage, 6914,
     /* 114079 */   GIR_EraseRootFromParent_Done,
     /* 114080 */ // Label 1861: @114080
     /* 114080 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(114106), // Rule ID 6915 //
     /* 114085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114099 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 114099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114104 */   GIR_RootConstrainSelectedInstOperands,
     /* 114105 */   // GIR_Coverage, 6915,
     /* 114105 */   GIR_Done,
     /* 114106 */ // Label 1862: @114106
     /* 114106 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(114132), // Rule ID 6916 //
     /* 114111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114125 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 114125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114130 */   GIR_RootConstrainSelectedInstOperands,
     /* 114131 */   // GIR_Coverage, 6916,
     /* 114131 */   GIR_Done,
     /* 114132 */ // Label 1863: @114132
     /* 114132 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(114158), // Rule ID 6917 //
     /* 114137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114151 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 114151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114156 */   GIR_RootConstrainSelectedInstOperands,
     /* 114157 */   // GIR_Coverage, 6917,
     /* 114157 */   GIR_Done,
     /* 114158 */ // Label 1864: @114158
     /* 114158 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(114184), // Rule ID 6918 //
     /* 114163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114177 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 114177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114182 */   GIR_RootConstrainSelectedInstOperands,
     /* 114183 */   // GIR_Coverage, 6918,
     /* 114183 */   GIR_Done,
     /* 114184 */ // Label 1865: @114184
     /* 114184 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(114210), // Rule ID 6919 //
     /* 114189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114203 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 114203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114208 */   GIR_RootConstrainSelectedInstOperands,
     /* 114209 */   // GIR_Coverage, 6919,
     /* 114209 */   GIR_Done,
     /* 114210 */ // Label 1866: @114210
     /* 114210 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(114239), // Rule ID 6920 //
     /* 114215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114226 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114238 */   // GIR_Coverage, 6920,
     /* 114238 */   GIR_EraseRootFromParent_Done,
     /* 114239 */ // Label 1867: @114239
     /* 114239 */ GIM_Reject,
     /* 114240 */ // Label 1625: @114240
     /* 114240 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(114272), // Rule ID 6921 //
     /* 114245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114259 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114271 */   // GIR_Coverage, 6921,
     /* 114271 */   GIR_EraseRootFromParent_Done,
     /* 114272 */ // Label 1868: @114272
     /* 114272 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(114304), // Rule ID 6922 //
     /* 114277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114291 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114303 */   // GIR_Coverage, 6922,
     /* 114303 */   GIR_EraseRootFromParent_Done,
     /* 114304 */ // Label 1869: @114304
     /* 114304 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(114336), // Rule ID 6923 //
     /* 114309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114323 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114335 */   // GIR_Coverage, 6923,
     /* 114335 */   GIR_EraseRootFromParent_Done,
     /* 114336 */ // Label 1870: @114336
     /* 114336 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(114368), // Rule ID 6924 //
     /* 114341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114355 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114367 */   // GIR_Coverage, 6924,
     /* 114367 */   GIR_EraseRootFromParent_Done,
     /* 114368 */ // Label 1871: @114368
     /* 114368 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(114400), // Rule ID 6925 //
     /* 114373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114387 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114399 */   // GIR_Coverage, 6925,
     /* 114399 */   GIR_EraseRootFromParent_Done,
     /* 114400 */ // Label 1872: @114400
     /* 114400 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(114432), // Rule ID 6926 //
     /* 114405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114419 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114431 */   // GIR_Coverage, 6926,
     /* 114431 */   GIR_EraseRootFromParent_Done,
     /* 114432 */ // Label 1873: @114432
     /* 114432 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(114464), // Rule ID 6927 //
     /* 114437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114451 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114463 */   // GIR_Coverage, 6927,
     /* 114463 */   GIR_EraseRootFromParent_Done,
     /* 114464 */ // Label 1874: @114464
     /* 114464 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(114535), // Rule ID 6928 //
     /* 114469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114483 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114495 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114533 */   GIR_RootConstrainSelectedInstOperands,
     /* 114534 */   // GIR_Coverage, 6928,
     /* 114534 */   GIR_EraseRootFromParent_Done,
     /* 114535 */ // Label 1875: @114535
     /* 114535 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(114561), // Rule ID 6929 //
     /* 114540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114554 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 114554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114559 */   GIR_RootConstrainSelectedInstOperands,
     /* 114560 */   // GIR_Coverage, 6929,
     /* 114560 */   GIR_Done,
     /* 114561 */ // Label 1876: @114561
     /* 114561 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(114587), // Rule ID 6930 //
     /* 114566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114580 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 114580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 114585 */   GIR_RootConstrainSelectedInstOperands,
     /* 114586 */   // GIR_Coverage, 6930,
     /* 114586 */   GIR_Done,
     /* 114587 */ // Label 1877: @114587
     /* 114587 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(114613), // Rule ID 6931 //
     /* 114592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114606 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 114606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114611 */   GIR_RootConstrainSelectedInstOperands,
     /* 114612 */   // GIR_Coverage, 6931,
     /* 114612 */   GIR_Done,
     /* 114613 */ // Label 1878: @114613
     /* 114613 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(114639), // Rule ID 6932 //
     /* 114618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114632 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 114632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114637 */   GIR_RootConstrainSelectedInstOperands,
     /* 114638 */   // GIR_Coverage, 6932,
     /* 114638 */   GIR_Done,
     /* 114639 */ // Label 1879: @114639
     /* 114639 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(114665), // Rule ID 6933 //
     /* 114644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114658 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 114658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 114663 */   GIR_RootConstrainSelectedInstOperands,
     /* 114664 */   // GIR_Coverage, 6933,
     /* 114664 */   GIR_Done,
     /* 114665 */ // Label 1880: @114665
     /* 114665 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(114691), // Rule ID 6934 //
     /* 114670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114684 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 114684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114689 */   GIR_RootConstrainSelectedInstOperands,
     /* 114690 */   // GIR_Coverage, 6934,
     /* 114690 */   GIR_Done,
     /* 114691 */ // Label 1881: @114691
     /* 114691 */ GIM_Reject,
     /* 114692 */ // Label 1626: @114692
     /* 114692 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(114724), // Rule ID 10635 //
     /* 114697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114711 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114714 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114716 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114723 */   // GIR_Coverage, 10635,
     /* 114723 */   GIR_EraseRootFromParent_Done,
     /* 114724 */ // Label 1882: @114724
     /* 114724 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(114756), // Rule ID 10636 //
     /* 114729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114743 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114746 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114748 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114755 */   // GIR_Coverage, 10636,
     /* 114755 */   GIR_EraseRootFromParent_Done,
     /* 114756 */ // Label 1883: @114756
     /* 114756 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(114788), // Rule ID 10637 //
     /* 114761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114775 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114778 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114787 */   // GIR_Coverage, 10637,
     /* 114787 */   GIR_EraseRootFromParent_Done,
     /* 114788 */ // Label 1884: @114788
     /* 114788 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(114820), // Rule ID 10638 //
     /* 114793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114807 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114810 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114812 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114819 */   // GIR_Coverage, 10638,
     /* 114819 */   GIR_EraseRootFromParent_Done,
     /* 114820 */ // Label 1885: @114820
     /* 114820 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(114852), // Rule ID 10639 //
     /* 114825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114839 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114842 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114851 */   // GIR_Coverage, 10639,
     /* 114851 */   GIR_EraseRootFromParent_Done,
     /* 114852 */ // Label 1886: @114852
     /* 114852 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(114884), // Rule ID 10640 //
     /* 114857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114871 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114874 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114883 */   // GIR_Coverage, 10640,
     /* 114883 */   GIR_EraseRootFromParent_Done,
     /* 114884 */ // Label 1887: @114884
     /* 114884 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(114916), // Rule ID 10653 //
     /* 114889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114903 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114915 */   // GIR_Coverage, 10653,
     /* 114915 */   GIR_EraseRootFromParent_Done,
     /* 114916 */ // Label 1888: @114916
     /* 114916 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(114948), // Rule ID 10654 //
     /* 114921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114935 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114947 */   // GIR_Coverage, 10654,
     /* 114947 */   GIR_EraseRootFromParent_Done,
     /* 114948 */ // Label 1889: @114948
     /* 114948 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(114980), // Rule ID 10655 //
     /* 114953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114967 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114970 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114979 */   // GIR_Coverage, 10655,
     /* 114979 */   GIR_EraseRootFromParent_Done,
     /* 114980 */ // Label 1890: @114980
     /* 114980 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(115012), // Rule ID 10656 //
     /* 114985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114999 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115002 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115004 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115011 */   // GIR_Coverage, 10656,
     /* 115011 */   GIR_EraseRootFromParent_Done,
     /* 115012 */ // Label 1891: @115012
     /* 115012 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(115044), // Rule ID 10657 //
     /* 115017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115031 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115043 */   // GIR_Coverage, 10657,
     /* 115043 */   GIR_EraseRootFromParent_Done,
     /* 115044 */ // Label 1892: @115044
     /* 115044 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(115076), // Rule ID 10658 //
     /* 115049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115063 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115075 */   // GIR_Coverage, 10658,
     /* 115075 */   GIR_EraseRootFromParent_Done,
     /* 115076 */ // Label 1893: @115076
     /* 115076 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(115108), // Rule ID 10663 //
     /* 115081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115095 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115107 */   // GIR_Coverage, 10663,
     /* 115107 */   GIR_EraseRootFromParent_Done,
     /* 115108 */ // Label 1894: @115108
     /* 115108 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(115140), // Rule ID 10664 //
     /* 115113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115127 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115139 */   // GIR_Coverage, 10664,
     /* 115139 */   GIR_EraseRootFromParent_Done,
     /* 115140 */ // Label 1895: @115140
     /* 115140 */ GIM_Reject,
     /* 115141 */ // Label 1627: @115141
     /* 115141 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(115173), // Rule ID 10629 //
     /* 115146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115160 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115172 */   // GIR_Coverage, 10629,
     /* 115172 */   GIR_EraseRootFromParent_Done,
     /* 115173 */ // Label 1896: @115173
     /* 115173 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(115205), // Rule ID 10630 //
     /* 115178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115192 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115195 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115204 */   // GIR_Coverage, 10630,
     /* 115204 */   GIR_EraseRootFromParent_Done,
     /* 115205 */ // Label 1897: @115205
     /* 115205 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(115237), // Rule ID 10631 //
     /* 115210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115224 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115236 */   // GIR_Coverage, 10631,
     /* 115236 */   GIR_EraseRootFromParent_Done,
     /* 115237 */ // Label 1898: @115237
     /* 115237 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(115269), // Rule ID 10632 //
     /* 115242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115256 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115259 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115261 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115268 */   // GIR_Coverage, 10632,
     /* 115268 */   GIR_EraseRootFromParent_Done,
     /* 115269 */ // Label 1899: @115269
     /* 115269 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(115301), // Rule ID 10633 //
     /* 115274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115288 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115291 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115300 */   // GIR_Coverage, 10633,
     /* 115300 */   GIR_EraseRootFromParent_Done,
     /* 115301 */ // Label 1900: @115301
     /* 115301 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(115333), // Rule ID 10634 //
     /* 115306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115320 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115323 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115332 */   // GIR_Coverage, 10634,
     /* 115332 */   GIR_EraseRootFromParent_Done,
     /* 115333 */ // Label 1901: @115333
     /* 115333 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(115365), // Rule ID 10647 //
     /* 115338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115352 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115355 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115357 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115364 */   // GIR_Coverage, 10647,
     /* 115364 */   GIR_EraseRootFromParent_Done,
     /* 115365 */ // Label 1902: @115365
     /* 115365 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(115397), // Rule ID 10648 //
     /* 115370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115384 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115387 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115389 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115396 */   // GIR_Coverage, 10648,
     /* 115396 */   GIR_EraseRootFromParent_Done,
     /* 115397 */ // Label 1903: @115397
     /* 115397 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(115429), // Rule ID 10649 //
     /* 115402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115416 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115419 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115421 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115428 */   // GIR_Coverage, 10649,
     /* 115428 */   GIR_EraseRootFromParent_Done,
     /* 115429 */ // Label 1904: @115429
     /* 115429 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(115461), // Rule ID 10650 //
     /* 115434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115448 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115451 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115460 */   // GIR_Coverage, 10650,
     /* 115460 */   GIR_EraseRootFromParent_Done,
     /* 115461 */ // Label 1905: @115461
     /* 115461 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(115493), // Rule ID 10651 //
     /* 115466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115480 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115492 */   // GIR_Coverage, 10651,
     /* 115492 */   GIR_EraseRootFromParent_Done,
     /* 115493 */ // Label 1906: @115493
     /* 115493 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(115525), // Rule ID 10652 //
     /* 115498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115512 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115515 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115524 */   // GIR_Coverage, 10652,
     /* 115524 */   GIR_EraseRootFromParent_Done,
     /* 115525 */ // Label 1907: @115525
     /* 115525 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(115557), // Rule ID 10661 //
     /* 115530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115544 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115556 */   // GIR_Coverage, 10661,
     /* 115556 */   GIR_EraseRootFromParent_Done,
     /* 115557 */ // Label 1908: @115557
     /* 115557 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(115589), // Rule ID 10662 //
     /* 115562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115576 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115588 */   // GIR_Coverage, 10662,
     /* 115588 */   GIR_EraseRootFromParent_Done,
     /* 115589 */ // Label 1909: @115589
     /* 115589 */ GIM_Reject,
     /* 115590 */ // Label 1628: @115590
     /* 115590 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(115622), // Rule ID 10623 //
     /* 115595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115609 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115612 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115614 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115621 */   // GIR_Coverage, 10623,
     /* 115621 */   GIR_EraseRootFromParent_Done,
     /* 115622 */ // Label 1910: @115622
     /* 115622 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(115654), // Rule ID 10624 //
     /* 115627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115641 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115653 */   // GIR_Coverage, 10624,
     /* 115653 */   GIR_EraseRootFromParent_Done,
     /* 115654 */ // Label 1911: @115654
     /* 115654 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(115686), // Rule ID 10625 //
     /* 115659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115673 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115685 */   // GIR_Coverage, 10625,
     /* 115685 */   GIR_EraseRootFromParent_Done,
     /* 115686 */ // Label 1912: @115686
     /* 115686 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(115718), // Rule ID 10626 //
     /* 115691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115705 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115717 */   // GIR_Coverage, 10626,
     /* 115717 */   GIR_EraseRootFromParent_Done,
     /* 115718 */ // Label 1913: @115718
     /* 115718 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(115750), // Rule ID 10627 //
     /* 115723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115737 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115749 */   // GIR_Coverage, 10627,
     /* 115749 */   GIR_EraseRootFromParent_Done,
     /* 115750 */ // Label 1914: @115750
     /* 115750 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(115782), // Rule ID 10628 //
     /* 115755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115769 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115781 */   // GIR_Coverage, 10628,
     /* 115781 */   GIR_EraseRootFromParent_Done,
     /* 115782 */ // Label 1915: @115782
     /* 115782 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(115814), // Rule ID 10641 //
     /* 115787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115801 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115806 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115813 */   // GIR_Coverage, 10641,
     /* 115813 */   GIR_EraseRootFromParent_Done,
     /* 115814 */ // Label 1916: @115814
     /* 115814 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(115846), // Rule ID 10642 //
     /* 115819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115833 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115836 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115845 */   // GIR_Coverage, 10642,
     /* 115845 */   GIR_EraseRootFromParent_Done,
     /* 115846 */ // Label 1917: @115846
     /* 115846 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(115878), // Rule ID 10643 //
     /* 115851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115865 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115868 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115877 */   // GIR_Coverage, 10643,
     /* 115877 */   GIR_EraseRootFromParent_Done,
     /* 115878 */ // Label 1918: @115878
     /* 115878 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115910), // Rule ID 10644 //
     /* 115883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115897 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115900 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115902 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115909 */   // GIR_Coverage, 10644,
     /* 115909 */   GIR_EraseRootFromParent_Done,
     /* 115910 */ // Label 1919: @115910
     /* 115910 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(115942), // Rule ID 10645 //
     /* 115915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115929 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115932 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115934 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115941 */   // GIR_Coverage, 10645,
     /* 115941 */   GIR_EraseRootFromParent_Done,
     /* 115942 */ // Label 1920: @115942
     /* 115942 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115974), // Rule ID 10646 //
     /* 115947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115961 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115964 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115966 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115973 */   // GIR_Coverage, 10646,
     /* 115973 */   GIR_EraseRootFromParent_Done,
     /* 115974 */ // Label 1921: @115974
     /* 115974 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(116006), // Rule ID 10659 //
     /* 115979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115993 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115996 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115998 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116000 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116005 */   // GIR_Coverage, 10659,
     /* 116005 */   GIR_EraseRootFromParent_Done,
     /* 116006 */ // Label 1922: @116006
     /* 116006 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(116038), // Rule ID 10660 //
     /* 116011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 116014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116025 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116028 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116030 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116037 */   // GIR_Coverage, 10660,
     /* 116037 */   GIR_EraseRootFromParent_Done,
     /* 116038 */ // Label 1923: @116038
     /* 116038 */ GIM_Reject,
     /* 116039 */ // Label 1629: @116039
     /* 116039 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(116071), // Rule ID 10617 //
     /* 116044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116058 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116070 */   // GIR_Coverage, 10617,
     /* 116070 */   GIR_EraseRootFromParent_Done,
     /* 116071 */ // Label 1924: @116071
     /* 116071 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(116103), // Rule ID 10618 //
     /* 116076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116090 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116102 */   // GIR_Coverage, 10618,
     /* 116102 */   GIR_EraseRootFromParent_Done,
     /* 116103 */ // Label 1925: @116103
     /* 116103 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(116135), // Rule ID 10619 //
     /* 116108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116122 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116134 */   // GIR_Coverage, 10619,
     /* 116134 */   GIR_EraseRootFromParent_Done,
     /* 116135 */ // Label 1926: @116135
     /* 116135 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(116167), // Rule ID 10620 //
     /* 116140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116154 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116166 */   // GIR_Coverage, 10620,
     /* 116166 */   GIR_EraseRootFromParent_Done,
     /* 116167 */ // Label 1927: @116167
     /* 116167 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(116199), // Rule ID 10621 //
     /* 116172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116186 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116189 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116191 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116198 */   // GIR_Coverage, 10621,
     /* 116198 */   GIR_EraseRootFromParent_Done,
     /* 116199 */ // Label 1928: @116199
     /* 116199 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(116231), // Rule ID 10622 //
     /* 116204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116218 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116230 */   // GIR_Coverage, 10622,
     /* 116230 */   GIR_EraseRootFromParent_Done,
     /* 116231 */ // Label 1929: @116231
     /* 116231 */ GIM_Reject,
     /* 116232 */ // Label 1630: @116232
     /* 116232 */ GIM_Reject,
     /* 116233 */ // Label 10: @116233
     /* 116233 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1938*/ GIMT_Encode4(116723),
     /* 116244 */ /*GILLT_s16*//*Label 1930*/ GIMT_Encode4(116284),
     /* 116248 */ /*GILLT_s32*//*Label 1931*/ GIMT_Encode4(116315),
     /* 116252 */ /*GILLT_s64*//*Label 1932*/ GIMT_Encode4(116346), GIMT_Encode4(0),
     /* 116260 */ /*GILLT_v2s32*//*Label 1933*/ GIMT_Encode4(116377),
     /* 116264 */ /*GILLT_v2s64*//*Label 1934*/ GIMT_Encode4(116408),
     /* 116268 */ /*GILLT_v4s16*//*Label 1935*/ GIMT_Encode4(116439),
     /* 116272 */ /*GILLT_v4s32*//*Label 1936*/ GIMT_Encode4(116470), GIMT_Encode4(0),
     /* 116280 */ /*GILLT_v8s16*//*Label 1937*/ GIMT_Encode4(116501),
     /* 116284 */ // Label 1930: @116284
     /* 116284 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(116314), // Rule ID 564 //
     /* 116289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116303 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 116308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116312 */   GIR_RootConstrainSelectedInstOperands,
     /* 116313 */   // GIR_Coverage, 564,
     /* 116313 */   GIR_Done,
     /* 116314 */ // Label 1939: @116314
     /* 116314 */ GIM_Reject,
     /* 116315 */ // Label 1931: @116315
     /* 116315 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(116345), // Rule ID 566 //
     /* 116320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116334 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 116339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116343 */   GIR_RootConstrainSelectedInstOperands,
     /* 116344 */   // GIR_Coverage, 566,
     /* 116344 */   GIR_Done,
     /* 116345 */ // Label 1940: @116345
     /* 116345 */ GIM_Reject,
     /* 116346 */ // Label 1932: @116346
     /* 116346 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(116376), // Rule ID 568 //
     /* 116351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116365 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 116370 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116374 */   GIR_RootConstrainSelectedInstOperands,
     /* 116375 */   // GIR_Coverage, 568,
     /* 116375 */   GIR_Done,
     /* 116376 */ // Label 1941: @116376
     /* 116376 */ GIM_Reject,
     /* 116377 */ // Label 1933: @116377
     /* 116377 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(116407), // Rule ID 933 //
     /* 116382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116396 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 116401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116405 */   GIR_RootConstrainSelectedInstOperands,
     /* 116406 */   // GIR_Coverage, 933,
     /* 116406 */   GIR_Done,
     /* 116407 */ // Label 1942: @116407
     /* 116407 */ GIM_Reject,
     /* 116408 */ // Label 1934: @116408
     /* 116408 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(116438), // Rule ID 937 //
     /* 116413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116427 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 116432 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116436 */   GIR_RootConstrainSelectedInstOperands,
     /* 116437 */   // GIR_Coverage, 937,
     /* 116437 */   GIR_Done,
     /* 116438 */ // Label 1943: @116438
     /* 116438 */ GIM_Reject,
     /* 116439 */ // Label 1935: @116439
     /* 116439 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(116469), // Rule ID 929 //
     /* 116444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116458 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 116463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116467 */   GIR_RootConstrainSelectedInstOperands,
     /* 116468 */   // GIR_Coverage, 929,
     /* 116468 */   GIR_Done,
     /* 116469 */ // Label 1944: @116469
     /* 116469 */ GIM_Reject,
     /* 116470 */ // Label 1936: @116470
     /* 116470 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(116500), // Rule ID 935 //
     /* 116475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116489 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116498 */   GIR_RootConstrainSelectedInstOperands,
     /* 116499 */   // GIR_Coverage, 935,
     /* 116499 */   GIR_Done,
     /* 116500 */ // Label 1945: @116500
     /* 116500 */ GIM_Reject,
     /* 116501 */ // Label 1937: @116501
     /* 116501 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(116722),
     /* 116506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116517 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(116536), // Rule ID 931 //
     /* 116522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116525 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 116530 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116534 */     GIR_RootConstrainSelectedInstOperands,
     /* 116535 */     // GIR_Coverage, 931,
     /* 116535 */     GIR_Done,
     /* 116536 */   // Label 1947: @116536
     /* 116536 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(116721), // Rule ID 7053 //
     /* 116541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116544 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116544 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116547 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116551 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116556 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116562 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116565 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116569 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116574 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116579 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116582 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116586 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116591 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116597 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116602 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116607 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116610 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116614 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116619 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 116622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 116624 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 116627 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116631 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116636 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 116639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116641 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 116644 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 116648 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116653 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 116656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 116661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 116690 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 116711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 116719 */     GIR_RootConstrainSelectedInstOperands,
     /* 116720 */     // GIR_Coverage, 7053,
     /* 116720 */     GIR_EraseRootFromParent_Done,
     /* 116721 */   // Label 1948: @116721
     /* 116721 */   GIM_Reject,
     /* 116722 */ // Label 1946: @116722
     /* 116722 */ GIM_Reject,
     /* 116723 */ // Label 1938: @116723
     /* 116723 */ GIM_Reject,
     /* 116724 */ // Label 11: @116724
     /* 116724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1957*/ GIMT_Encode4(117214),
     /* 116735 */ /*GILLT_s16*//*Label 1949*/ GIMT_Encode4(116775),
     /* 116739 */ /*GILLT_s32*//*Label 1950*/ GIMT_Encode4(116806),
     /* 116743 */ /*GILLT_s64*//*Label 1951*/ GIMT_Encode4(116837), GIMT_Encode4(0),
     /* 116751 */ /*GILLT_v2s32*//*Label 1952*/ GIMT_Encode4(116868),
     /* 116755 */ /*GILLT_v2s64*//*Label 1953*/ GIMT_Encode4(116899),
     /* 116759 */ /*GILLT_v4s16*//*Label 1954*/ GIMT_Encode4(116930),
     /* 116763 */ /*GILLT_v4s32*//*Label 1955*/ GIMT_Encode4(116961), GIMT_Encode4(0),
     /* 116771 */ /*GILLT_v8s16*//*Label 1956*/ GIMT_Encode4(116992),
     /* 116775 */ // Label 1949: @116775
     /* 116775 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(116805), // Rule ID 528 //
     /* 116780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116794 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 116799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116803 */   GIR_RootConstrainSelectedInstOperands,
     /* 116804 */   // GIR_Coverage, 528,
     /* 116804 */   GIR_Done,
     /* 116805 */ // Label 1958: @116805
     /* 116805 */ GIM_Reject,
     /* 116806 */ // Label 1950: @116806
     /* 116806 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(116836), // Rule ID 530 //
     /* 116811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116825 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 116830 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116834 */   GIR_RootConstrainSelectedInstOperands,
     /* 116835 */   // GIR_Coverage, 530,
     /* 116835 */   GIR_Done,
     /* 116836 */ // Label 1959: @116836
     /* 116836 */ GIM_Reject,
     /* 116837 */ // Label 1951: @116837
     /* 116837 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(116867), // Rule ID 532 //
     /* 116842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116856 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 116861 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116865 */   GIR_RootConstrainSelectedInstOperands,
     /* 116866 */   // GIR_Coverage, 532,
     /* 116866 */   GIR_Done,
     /* 116867 */ // Label 1960: @116867
     /* 116867 */ GIM_Reject,
     /* 116868 */ // Label 1952: @116868
     /* 116868 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(116898), // Rule ID 873 //
     /* 116873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116887 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 116892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116896 */   GIR_RootConstrainSelectedInstOperands,
     /* 116897 */   // GIR_Coverage, 873,
     /* 116897 */   GIR_Done,
     /* 116898 */ // Label 1961: @116898
     /* 116898 */ GIM_Reject,
     /* 116899 */ // Label 1953: @116899
     /* 116899 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(116929), // Rule ID 877 //
     /* 116904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116918 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 116923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116927 */   GIR_RootConstrainSelectedInstOperands,
     /* 116928 */   // GIR_Coverage, 877,
     /* 116928 */   GIR_Done,
     /* 116929 */ // Label 1962: @116929
     /* 116929 */ GIM_Reject,
     /* 116930 */ // Label 1954: @116930
     /* 116930 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(116960), // Rule ID 869 //
     /* 116935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116949 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 116954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116958 */   GIR_RootConstrainSelectedInstOperands,
     /* 116959 */   // GIR_Coverage, 869,
     /* 116959 */   GIR_Done,
     /* 116960 */ // Label 1963: @116960
     /* 116960 */ GIM_Reject,
     /* 116961 */ // Label 1955: @116961
     /* 116961 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(116991), // Rule ID 875 //
     /* 116966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116980 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 116985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116989 */   GIR_RootConstrainSelectedInstOperands,
     /* 116990 */   // GIR_Coverage, 875,
     /* 116990 */   GIR_Done,
     /* 116991 */ // Label 1964: @116991
     /* 116991 */ GIM_Reject,
     /* 116992 */ // Label 1956: @116992
     /* 116992 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(117213),
     /* 116997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117008 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(117027), // Rule ID 871 //
     /* 117013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117016 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 117016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 117021 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117025 */     GIR_RootConstrainSelectedInstOperands,
     /* 117026 */     // GIR_Coverage, 871,
     /* 117026 */     GIR_Done,
     /* 117027 */   // Label 1966: @117027
     /* 117027 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(117212), // Rule ID 7047 //
     /* 117032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 117035 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 117035 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 117038 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 117042 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117047 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 117053 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 117056 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117060 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117065 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 117068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 117070 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 117073 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117077 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117082 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 117088 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117093 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117098 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 117101 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 117105 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117110 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 117113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 117115 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 117118 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117122 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117127 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 117130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 117135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 117139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117144 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 117147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 117152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 117181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 117202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 117210 */     GIR_RootConstrainSelectedInstOperands,
     /* 117211 */     // GIR_Coverage, 7047,
     /* 117211 */     GIR_EraseRootFromParent_Done,
     /* 117212 */   // Label 1967: @117212
     /* 117212 */   GIM_Reject,
     /* 117213 */ // Label 1965: @117213
     /* 117213 */ GIM_Reject,
     /* 117214 */ // Label 1957: @117214
     /* 117214 */ GIM_Reject,
     /* 117215 */ // Label 12: @117215
     /* 117215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1970*/ GIMT_Encode4(117482),
     /* 117226 */ /*GILLT_s32*//*Label 1968*/ GIMT_Encode4(117234),
     /* 117230 */ /*GILLT_s64*//*Label 1969*/ GIMT_Encode4(117358),
     /* 117234 */ // Label 1968: @117234
     /* 117234 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(117277), // Rule ID 4825 //
     /* 117239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117249 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 117270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117275 */   GIR_RootConstrainSelectedInstOperands,
     /* 117276 */   // GIR_Coverage, 4825,
     /* 117276 */   GIR_EraseRootFromParent_Done,
     /* 117277 */ // Label 1971: @117277
     /* 117277 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(117317), // Rule ID 4831 //
     /* 117282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117289 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117301 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 117310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117315 */   GIR_RootConstrainSelectedInstOperands,
     /* 117316 */   // GIR_Coverage, 4831,
     /* 117316 */   GIR_EraseRootFromParent_Done,
     /* 117317 */ // Label 1972: @117317
     /* 117317 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(117357), // Rule ID 4833 //
     /* 117322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117329 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 117350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117355 */   GIR_RootConstrainSelectedInstOperands,
     /* 117356 */   // GIR_Coverage, 4833,
     /* 117356 */   GIR_EraseRootFromParent_Done,
     /* 117357 */ // Label 1973: @117357
     /* 117357 */ GIM_Reject,
     /* 117358 */ // Label 1969: @117358
     /* 117358 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(117401), // Rule ID 4827 //
     /* 117363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117373 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117385 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117399 */   GIR_RootConstrainSelectedInstOperands,
     /* 117400 */   // GIR_Coverage, 4827,
     /* 117400 */   GIR_EraseRootFromParent_Done,
     /* 117401 */ // Label 1974: @117401
     /* 117401 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(117441), // Rule ID 4835 //
     /* 117406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117413 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117439 */   GIR_RootConstrainSelectedInstOperands,
     /* 117440 */   // GIR_Coverage, 4835,
     /* 117440 */   GIR_EraseRootFromParent_Done,
     /* 117441 */ // Label 1975: @117441
     /* 117441 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(117481), // Rule ID 4837 //
     /* 117446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117453 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117465 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 117474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117479 */   GIR_RootConstrainSelectedInstOperands,
     /* 117480 */   // GIR_Coverage, 4837,
     /* 117480 */   GIR_EraseRootFromParent_Done,
     /* 117481 */ // Label 1976: @117481
     /* 117481 */ GIM_Reject,
     /* 117482 */ // Label 1970: @117482
     /* 117482 */ GIM_Reject,
     /* 117483 */ // Label 13: @117483
     /* 117483 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(117632),
     /* 117488 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 117491 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1981*/ GIMT_Encode4(117631),
     /* 117502 */   /*GILLT_s16*//*Label 1978*/ GIMT_Encode4(117514),
     /* 117506 */   /*GILLT_s32*//*Label 1979*/ GIMT_Encode4(117555),
     /* 117510 */   /*GILLT_s64*//*Label 1980*/ GIMT_Encode4(117593),
     /* 117514 */   // Label 1978: @117514
     /* 117514 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(117554), // Rule ID 4829 //
     /* 117519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117526 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117552 */     GIR_RootConstrainSelectedInstOperands,
     /* 117553 */     // GIR_Coverage, 4829,
     /* 117553 */     GIR_EraseRootFromParent_Done,
     /* 117554 */   // Label 1982: @117554
     /* 117554 */   GIM_Reject,
     /* 117555 */   // Label 1979: @117555
     /* 117555 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(117592), // Rule ID 4839 //
     /* 117560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117564 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117590 */     GIR_RootConstrainSelectedInstOperands,
     /* 117591 */     // GIR_Coverage, 4839,
     /* 117591 */     GIR_EraseRootFromParent_Done,
     /* 117592 */   // Label 1983: @117592
     /* 117592 */   GIM_Reject,
     /* 117593 */   // Label 1980: @117593
     /* 117593 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(117630), // Rule ID 4841 //
     /* 117598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117602 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 117623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117628 */     GIR_RootConstrainSelectedInstOperands,
     /* 117629 */     // GIR_Coverage, 4841,
     /* 117629 */     GIR_EraseRootFromParent_Done,
     /* 117630 */   // Label 1984: @117630
     /* 117630 */   GIM_Reject,
     /* 117631 */   // Label 1981: @117631
     /* 117631 */   GIM_Reject,
     /* 117632 */ // Label 1977: @117632
     /* 117632 */ GIM_Reject,
     /* 117633 */ // Label 14: @117633
     /* 117633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1993*/ GIMT_Encode4(118123),
     /* 117644 */ /*GILLT_s16*//*Label 1985*/ GIMT_Encode4(117684),
     /* 117648 */ /*GILLT_s32*//*Label 1986*/ GIMT_Encode4(117715),
     /* 117652 */ /*GILLT_s64*//*Label 1987*/ GIMT_Encode4(117746), GIMT_Encode4(0),
     /* 117660 */ /*GILLT_v2s32*//*Label 1988*/ GIMT_Encode4(117777),
     /* 117664 */ /*GILLT_v2s64*//*Label 1989*/ GIMT_Encode4(117808),
     /* 117668 */ /*GILLT_v4s16*//*Label 1990*/ GIMT_Encode4(117839),
     /* 117672 */ /*GILLT_v4s32*//*Label 1991*/ GIMT_Encode4(117870), GIMT_Encode4(0),
     /* 117680 */ /*GILLT_v8s16*//*Label 1992*/ GIMT_Encode4(117901),
     /* 117684 */ // Label 1985: @117684
     /* 117684 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117714), // Rule ID 546 //
     /* 117689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117703 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 117703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 117708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117712 */   GIR_RootConstrainSelectedInstOperands,
     /* 117713 */   // GIR_Coverage, 546,
     /* 117713 */   GIR_Done,
     /* 117714 */ // Label 1994: @117714
     /* 117714 */ GIM_Reject,
     /* 117715 */ // Label 1986: @117715
     /* 117715 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117745), // Rule ID 548 //
     /* 117720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117734 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 117734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 117739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117743 */   GIR_RootConstrainSelectedInstOperands,
     /* 117744 */   // GIR_Coverage, 548,
     /* 117744 */   GIR_Done,
     /* 117745 */ // Label 1995: @117745
     /* 117745 */ GIM_Reject,
     /* 117746 */ // Label 1987: @117746
     /* 117746 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117776), // Rule ID 550 //
     /* 117751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117765 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 117765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 117770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117774 */   GIR_RootConstrainSelectedInstOperands,
     /* 117775 */   // GIR_Coverage, 550,
     /* 117775 */   GIR_Done,
     /* 117776 */ // Label 1996: @117776
     /* 117776 */ GIM_Reject,
     /* 117777 */ // Label 1988: @117777
     /* 117777 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117807), // Rule ID 903 //
     /* 117782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117796 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 117796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 117801 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117805 */   GIR_RootConstrainSelectedInstOperands,
     /* 117806 */   // GIR_Coverage, 903,
     /* 117806 */   GIR_Done,
     /* 117807 */ // Label 1997: @117807
     /* 117807 */ GIM_Reject,
     /* 117808 */ // Label 1989: @117808
     /* 117808 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117838), // Rule ID 907 //
     /* 117813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117827 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 117827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 117832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117836 */   GIR_RootConstrainSelectedInstOperands,
     /* 117837 */   // GIR_Coverage, 907,
     /* 117837 */   GIR_Done,
     /* 117838 */ // Label 1998: @117838
     /* 117838 */ GIM_Reject,
     /* 117839 */ // Label 1990: @117839
     /* 117839 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117869), // Rule ID 899 //
     /* 117844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117858 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 117858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 117863 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117867 */   GIR_RootConstrainSelectedInstOperands,
     /* 117868 */   // GIR_Coverage, 899,
     /* 117868 */   GIR_Done,
     /* 117869 */ // Label 1999: @117869
     /* 117869 */ GIM_Reject,
     /* 117870 */ // Label 1991: @117870
     /* 117870 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117900), // Rule ID 905 //
     /* 117875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117889 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 117889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 117894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117898 */   GIR_RootConstrainSelectedInstOperands,
     /* 117899 */   // GIR_Coverage, 905,
     /* 117899 */   GIR_Done,
     /* 117900 */ // Label 2000: @117900
     /* 117900 */ GIM_Reject,
     /* 117901 */ // Label 1992: @117901
     /* 117901 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(118122),
     /* 117906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117917 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117936), // Rule ID 901 //
     /* 117922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117925 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 117925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 117930 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117934 */     GIR_RootConstrainSelectedInstOperands,
     /* 117935 */     // GIR_Coverage, 901,
     /* 117935 */     GIR_Done,
     /* 117936 */   // Label 2002: @117936
     /* 117936 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(118121), // Rule ID 7049 //
     /* 117941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 117944 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 117944 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 117947 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 117951 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117956 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 117962 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 117965 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 117969 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117974 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 117977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 117979 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 117982 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117986 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117991 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 117997 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118002 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118007 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 118010 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 118014 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118019 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 118022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 118024 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 118027 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 118031 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118036 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 118039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 118044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 118048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118053 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 118056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118058 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 118061 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118065 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 118075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 118090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 118093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 118111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 118119 */     GIR_RootConstrainSelectedInstOperands,
     /* 118120 */     // GIR_Coverage, 7049,
     /* 118120 */     GIR_EraseRootFromParent_Done,
     /* 118121 */   // Label 2003: @118121
     /* 118121 */   GIM_Reject,
     /* 118122 */ // Label 2001: @118122
     /* 118122 */ GIM_Reject,
     /* 118123 */ // Label 1993: @118123
     /* 118123 */ GIM_Reject,
     /* 118124 */ // Label 15: @118124
     /* 118124 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(118156), // Rule ID 3908 //
     /* 118129 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 118132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118136 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 118136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 118139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118141 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 118151 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 118154 */   GIR_RootConstrainSelectedInstOperands,
     /* 118155 */   // GIR_Coverage, 3908,
     /* 118155 */   GIR_EraseRootFromParent_Done,
     /* 118156 */ // Label 2004: @118156
     /* 118156 */ GIM_Reject,
     /* 118157 */ // Label 16: @118157
     /* 118157 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2025*/ GIMT_Encode4(127094),
     /* 118168 */ /*GILLT_s8*//*Label 2005*/ GIMT_Encode4(118264),
     /* 118172 */ /*GILLT_s16*//*Label 2006*/ GIMT_Encode4(118440),
     /* 118176 */ /*GILLT_s32*//*Label 2007*/ GIMT_Encode4(118616),
     /* 118180 */ /*GILLT_s64*//*Label 2008*/ GIMT_Encode4(121010),
     /* 118184 */ /*GILLT_s128*//*Label 2009*/ GIMT_Encode4(123723),
     /* 118188 */ /*GILLT_v2s32*//*Label 2010*/ GIMT_Encode4(123932),
     /* 118192 */ /*GILLT_v2s64*//*Label 2011*/ GIMT_Encode4(124310),
     /* 118196 */ /*GILLT_v4s16*//*Label 2012*/ GIMT_Encode4(124688),
     /* 118200 */ /*GILLT_v4s32*//*Label 2013*/ GIMT_Encode4(125066),
     /* 118204 */ /*GILLT_v8s8*//*Label 2014*/ GIMT_Encode4(125444),
     /* 118208 */ /*GILLT_v8s16*//*Label 2015*/ GIMT_Encode4(125652),
     /* 118212 */ /*GILLT_v16s8*//*Label 2016*/ GIMT_Encode4(126030), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118224 */ /*GILLT_nxv2s16*//*Label 2017*/ GIMT_Encode4(126238),
     /* 118228 */ /*GILLT_nxv2s32*//*Label 2018*/ GIMT_Encode4(126302),
     /* 118232 */ /*GILLT_nxv2s64*//*Label 2019*/ GIMT_Encode4(126366), GIMT_Encode4(0),
     /* 118240 */ /*GILLT_nxv4s16*//*Label 2020*/ GIMT_Encode4(126540),
     /* 118244 */ /*GILLT_nxv4s32*//*Label 2021*/ GIMT_Encode4(126604), GIMT_Encode4(0),
     /* 118252 */ /*GILLT_nxv8s16*//*Label 2022*/ GIMT_Encode4(126778),
     /* 118256 */ /*GILLT_nxv16s1*//*Label 2023*/ GIMT_Encode4(126952),
     /* 118260 */ /*GILLT_nxv16s8*//*Label 2024*/ GIMT_Encode4(126996),
     /* 118264 */ // Label 2005: @118264
     /* 118264 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118439),
     /* 118269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 118280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118284 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118325), // Rule ID 237 //
     /* 118289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118299 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 118302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118323 */     GIR_RootConstrainSelectedInstOperands,
     /* 118324 */     // GIR_Coverage, 237,
     /* 118324 */     GIR_EraseRootFromParent_Done,
     /* 118325 */   // Label 2027: @118325
     /* 118325 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118366), // Rule ID 238 //
     /* 118330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118340 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 118343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118364 */     GIR_RootConstrainSelectedInstOperands,
     /* 118365 */     // GIR_Coverage, 238,
     /* 118365 */     GIR_EraseRootFromParent_Done,
     /* 118366 */   // Label 2028: @118366
     /* 118366 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118402), // Rule ID 261 //
     /* 118371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118381 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 118384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118400 */     GIR_RootConstrainSelectedInstOperands,
     /* 118401 */     // GIR_Coverage, 261,
     /* 118401 */     GIR_EraseRootFromParent_Done,
     /* 118402 */   // Label 2029: @118402
     /* 118402 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(118438), // Rule ID 282 //
     /* 118407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118417 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 118420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118436 */     GIR_RootConstrainSelectedInstOperands,
     /* 118437 */     // GIR_Coverage, 282,
     /* 118437 */     GIR_EraseRootFromParent_Done,
     /* 118438 */   // Label 2030: @118438
     /* 118438 */   GIM_Reject,
     /* 118439 */ // Label 2026: @118439
     /* 118439 */ GIM_Reject,
     /* 118440 */ // Label 2006: @118440
     /* 118440 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(118615),
     /* 118445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118448 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 118456 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118460 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(118501), // Rule ID 239 //
     /* 118465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118475 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 118478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118499 */     GIR_RootConstrainSelectedInstOperands,
     /* 118500 */     // GIR_Coverage, 239,
     /* 118500 */     GIR_EraseRootFromParent_Done,
     /* 118501 */   // Label 2032: @118501
     /* 118501 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(118542), // Rule ID 240 //
     /* 118506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118516 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 118519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118540 */     GIR_RootConstrainSelectedInstOperands,
     /* 118541 */     // GIR_Coverage, 240,
     /* 118541 */     GIR_EraseRootFromParent_Done,
     /* 118542 */   // Label 2033: @118542
     /* 118542 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(118578), // Rule ID 262 //
     /* 118547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118557 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 118560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118576 */     GIR_RootConstrainSelectedInstOperands,
     /* 118577 */     // GIR_Coverage, 262,
     /* 118577 */     GIR_EraseRootFromParent_Done,
     /* 118578 */   // Label 2034: @118578
     /* 118578 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118614), // Rule ID 283 //
     /* 118583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118593 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 118596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118612 */     GIR_RootConstrainSelectedInstOperands,
     /* 118613 */     // GIR_Coverage, 283,
     /* 118613 */     GIR_EraseRootFromParent_Done,
     /* 118614 */   // Label 2035: @118614
     /* 118614 */   GIM_Reject,
     /* 118615 */ // Label 2031: @118615
     /* 118615 */ GIM_Reject,
     /* 118616 */ // Label 2007: @118616
     /* 118616 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118669), // Rule ID 233 //
     /* 118621 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118624 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118643 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 118646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118667 */   GIR_RootConstrainSelectedInstOperands,
     /* 118668 */   // GIR_Coverage, 233,
     /* 118668 */   GIR_EraseRootFromParent_Done,
     /* 118669 */ // Label 2036: @118669
     /* 118669 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118722), // Rule ID 234 //
     /* 118674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118677 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118685 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118689 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118696 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 118699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118720 */   GIR_RootConstrainSelectedInstOperands,
     /* 118721 */   // GIR_Coverage, 234,
     /* 118721 */   GIR_EraseRootFromParent_Done,
     /* 118722 */ // Label 2037: @118722
     /* 118722 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118778), // Rule ID 241 //
     /* 118727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118733 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118752 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 118755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118776 */   GIR_RootConstrainSelectedInstOperands,
     /* 118777 */   // GIR_Coverage, 241,
     /* 118777 */   GIR_EraseRootFromParent_Done,
     /* 118778 */ // Label 2038: @118778
     /* 118778 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118834), // Rule ID 242 //
     /* 118783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118789 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118801 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118808 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 118811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118832 */   GIR_RootConstrainSelectedInstOperands,
     /* 118833 */   // GIR_Coverage, 242,
     /* 118833 */   GIR_EraseRootFromParent_Done,
     /* 118834 */ // Label 2039: @118834
     /* 118834 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118894), // Rule ID 4124 //
     /* 118839 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118842 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118868 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 118871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118892 */   GIR_RootConstrainSelectedInstOperands,
     /* 118893 */   // GIR_Coverage, 4124,
     /* 118893 */   GIR_EraseRootFromParent_Done,
     /* 118894 */ // Label 2040: @118894
     /* 118894 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118954), // Rule ID 4125 //
     /* 118899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118902 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118906 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118917 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118928 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 118931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118952 */   GIR_RootConstrainSelectedInstOperands,
     /* 118953 */   // GIR_Coverage, 4125,
     /* 118953 */   GIR_EraseRootFromParent_Done,
     /* 118954 */ // Label 2041: @118954
     /* 118954 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(119014), // Rule ID 4126 //
     /* 118959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118962 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118988 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 118991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119012 */   GIR_RootConstrainSelectedInstOperands,
     /* 119013 */   // GIR_Coverage, 4126,
     /* 119013 */   GIR_EraseRootFromParent_Done,
     /* 119014 */ // Label 2042: @119014
     /* 119014 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(119074), // Rule ID 4127 //
     /* 119019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119022 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119026 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119048 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119072 */   GIR_RootConstrainSelectedInstOperands,
     /* 119073 */   // GIR_Coverage, 4127,
     /* 119073 */   GIR_EraseRootFromParent_Done,
     /* 119074 */ // Label 2043: @119074
     /* 119074 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(119134), // Rule ID 4128 //
     /* 119079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119082 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119108 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119132 */   GIR_RootConstrainSelectedInstOperands,
     /* 119133 */   // GIR_Coverage, 4128,
     /* 119133 */   GIR_EraseRootFromParent_Done,
     /* 119134 */ // Label 2044: @119134
     /* 119134 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(119194), // Rule ID 4129 //
     /* 119139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119142 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119168 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119192 */   GIR_RootConstrainSelectedInstOperands,
     /* 119193 */   // GIR_Coverage, 4129,
     /* 119193 */   GIR_EraseRootFromParent_Done,
     /* 119194 */ // Label 2045: @119194
     /* 119194 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(119242), // Rule ID 260 //
     /* 119199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119202 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119221 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 119224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119240 */   GIR_RootConstrainSelectedInstOperands,
     /* 119241 */   // GIR_Coverage, 260,
     /* 119241 */   GIR_EraseRootFromParent_Done,
     /* 119242 */ // Label 2046: @119242
     /* 119242 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(119293), // Rule ID 263 //
     /* 119247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119272 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 119275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119291 */   GIR_RootConstrainSelectedInstOperands,
     /* 119292 */   // GIR_Coverage, 263,
     /* 119292 */   GIR_EraseRootFromParent_Done,
     /* 119293 */ // Label 2047: @119293
     /* 119293 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(119356), // Rule ID 7079 //
     /* 119298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119301 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119305 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119312 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119330 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15857>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 119330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 119333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119354 */   GIR_RootConstrainSelectedInstOperands,
     /* 119355 */   // GIR_Coverage, 7079,
     /* 119355 */   GIR_EraseRootFromParent_Done,
     /* 119356 */ // Label 2048: @119356
     /* 119356 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(119419), // Rule ID 7081 //
     /* 119361 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119364 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119375 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119393 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15857>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 119393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 119396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119417 */   GIR_RootConstrainSelectedInstOperands,
     /* 119418 */   // GIR_Coverage, 7081,
     /* 119418 */   GIR_EraseRootFromParent_Done,
     /* 119419 */ // Label 2049: @119419
     /* 119419 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(119482), // Rule ID 7091 //
     /* 119424 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119427 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119456 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15865>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 119459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119480 */   GIR_RootConstrainSelectedInstOperands,
     /* 119481 */   // GIR_Coverage, 7091,
     /* 119481 */   GIR_EraseRootFromParent_Done,
     /* 119482 */ // Label 2050: @119482
     /* 119482 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(119545), // Rule ID 7093 //
     /* 119487 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119490 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119494 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119501 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119519 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15865>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119543 */   GIR_RootConstrainSelectedInstOperands,
     /* 119544 */   // GIR_Coverage, 7093,
     /* 119544 */   GIR_EraseRootFromParent_Done,
     /* 119545 */ // Label 2051: @119545
     /* 119545 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(119608), // Rule ID 7101 //
     /* 119550 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119564 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119582 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119606 */   GIR_RootConstrainSelectedInstOperands,
     /* 119607 */   // GIR_Coverage, 7101,
     /* 119607 */   GIR_EraseRootFromParent_Done,
     /* 119608 */ // Label 2052: @119608
     /* 119608 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119671), // Rule ID 7102 //
     /* 119613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119620 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119627 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119638 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119645 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119669 */   GIR_RootConstrainSelectedInstOperands,
     /* 119670 */   // GIR_Coverage, 7102,
     /* 119670 */   GIR_EraseRootFromParent_Done,
     /* 119671 */ // Label 2053: @119671
     /* 119671 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119719), // Rule ID 281 //
     /* 119676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119698 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 119701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119717 */   GIR_RootConstrainSelectedInstOperands,
     /* 119718 */   // GIR_Coverage, 281,
     /* 119718 */   GIR_EraseRootFromParent_Done,
     /* 119719 */ // Label 2054: @119719
     /* 119719 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119770), // Rule ID 284 //
     /* 119724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119749 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 119752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119768 */   GIR_RootConstrainSelectedInstOperands,
     /* 119769 */   // GIR_Coverage, 284,
     /* 119769 */   GIR_EraseRootFromParent_Done,
     /* 119770 */ // Label 2055: @119770
     /* 119770 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119825), // Rule ID 4151 //
     /* 119775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 119804 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 119804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 119807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119823 */   GIR_RootConstrainSelectedInstOperands,
     /* 119824 */   // GIR_Coverage, 4151,
     /* 119824 */   GIR_EraseRootFromParent_Done,
     /* 119825 */ // Label 2056: @119825
     /* 119825 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119880), // Rule ID 4152 //
     /* 119830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119833 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 119859 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 119859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 119862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119878 */   GIR_RootConstrainSelectedInstOperands,
     /* 119879 */   // GIR_Coverage, 4152,
     /* 119879 */   GIR_EraseRootFromParent_Done,
     /* 119880 */ // Label 2057: @119880
     /* 119880 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119935), // Rule ID 4153 //
     /* 119885 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119888 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 119914 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 119914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 119917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119933 */   GIR_RootConstrainSelectedInstOperands,
     /* 119934 */   // GIR_Coverage, 4153,
     /* 119934 */   GIR_EraseRootFromParent_Done,
     /* 119935 */ // Label 2058: @119935
     /* 119935 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119990), // Rule ID 4174 //
     /* 119940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119943 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119947 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119958 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 119969 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 119972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119988 */   GIR_RootConstrainSelectedInstOperands,
     /* 119989 */   // GIR_Coverage, 4174,
     /* 119989 */   GIR_EraseRootFromParent_Done,
     /* 119990 */ // Label 2059: @119990
     /* 119990 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(120045), // Rule ID 4175 //
     /* 119995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119998 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120002 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120013 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120024 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120043 */   GIR_RootConstrainSelectedInstOperands,
     /* 120044 */   // GIR_Coverage, 4175,
     /* 120044 */   GIR_EraseRootFromParent_Done,
     /* 120045 */ // Label 2060: @120045
     /* 120045 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(120100), // Rule ID 4176 //
     /* 120050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120053 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120057 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120079 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120098 */   GIR_RootConstrainSelectedInstOperands,
     /* 120099 */   // GIR_Coverage, 4176,
     /* 120099 */   GIR_EraseRootFromParent_Done,
     /* 120100 */ // Label 2061: @120100
     /* 120100 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(120158), // Rule ID 7083 //
     /* 120105 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120108 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120119 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120137 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15857>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 120140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120156 */   GIR_RootConstrainSelectedInstOperands,
     /* 120157 */   // GIR_Coverage, 7083,
     /* 120157 */   GIR_EraseRootFromParent_Done,
     /* 120158 */ // Label 2062: @120158
     /* 120158 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(120216), // Rule ID 7085 //
     /* 120163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120166 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120177 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120195 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15857>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120214 */   GIR_RootConstrainSelectedInstOperands,
     /* 120215 */   // GIR_Coverage, 7085,
     /* 120215 */   GIR_EraseRootFromParent_Done,
     /* 120216 */ // Label 2063: @120216
     /* 120216 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(120274), // Rule ID 7095 //
     /* 120221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120224 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120235 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120253 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15865>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 120256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120268 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120272 */   GIR_RootConstrainSelectedInstOperands,
     /* 120273 */   // GIR_Coverage, 7095,
     /* 120273 */   GIR_EraseRootFromParent_Done,
     /* 120274 */ // Label 2064: @120274
     /* 120274 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(120332), // Rule ID 7097 //
     /* 120279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120282 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120293 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120304 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120311 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15865>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 120314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120330 */   GIR_RootConstrainSelectedInstOperands,
     /* 120331 */   // GIR_Coverage, 7097,
     /* 120331 */   GIR_EraseRootFromParent_Done,
     /* 120332 */ // Label 2065: @120332
     /* 120332 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(120390), // Rule ID 7103 //
     /* 120337 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120351 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120369 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 120372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120388 */   GIR_RootConstrainSelectedInstOperands,
     /* 120389 */   // GIR_Coverage, 7103,
     /* 120389 */   GIR_EraseRootFromParent_Done,
     /* 120390 */ // Label 2066: @120390
     /* 120390 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(120448), // Rule ID 7104 //
     /* 120395 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120409 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120427 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15873>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 120430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120446 */   GIR_RootConstrainSelectedInstOperands,
     /* 120447 */   // GIR_Coverage, 7104,
     /* 120447 */   GIR_EraseRootFromParent_Done,
     /* 120448 */ // Label 2067: @120448
     /* 120448 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(120509), // Rule ID 7489 //
     /* 120453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120456 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120459 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120463 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120470 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120481 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120488 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15846>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 120491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120507 */   GIR_RootConstrainSelectedInstOperands,
     /* 120508 */   // GIR_Coverage, 7489,
     /* 120508 */   GIR_EraseRootFromParent_Done,
     /* 120509 */ // Label 2068: @120509
     /* 120509 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(120570), // Rule ID 7491 //
     /* 120514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120517 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120542 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120549 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15848>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 120552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120568 */   GIR_RootConstrainSelectedInstOperands,
     /* 120569 */   // GIR_Coverage, 7491,
     /* 120569 */   GIR_EraseRootFromParent_Done,
     /* 120570 */ // Label 2069: @120570
     /* 120570 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(120631), // Rule ID 7493 //
     /* 120575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120578 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120610 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15850>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 120613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120629 */   GIR_RootConstrainSelectedInstOperands,
     /* 120630 */   // GIR_Coverage, 7493,
     /* 120630 */   GIR_EraseRootFromParent_Done,
     /* 120631 */ // Label 2070: @120631
     /* 120631 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(120675), // Rule ID 7069 //
     /* 120636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120639 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120642 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120660 */   // MIs[0] ptr
     /* 120660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120668 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15846>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 120673 */   GIR_RootConstrainSelectedInstOperands,
     /* 120674 */   // GIR_Coverage, 7069,
     /* 120674 */   GIR_Done,
     /* 120675 */ // Label 2071: @120675
     /* 120675 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(120719), // Rule ID 7071 //
     /* 120680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120704 */   // MIs[0] ptr
     /* 120704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120712 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15848>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 120717 */   GIR_RootConstrainSelectedInstOperands,
     /* 120718 */   // GIR_Coverage, 7071,
     /* 120718 */   GIR_Done,
     /* 120719 */ // Label 2072: @120719
     /* 120719 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120763), // Rule ID 7073 //
     /* 120724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120748 */   // MIs[0] ptr
     /* 120748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120756 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15850>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 120761 */   GIR_RootConstrainSelectedInstOperands,
     /* 120762 */   // GIR_Coverage, 7073,
     /* 120762 */   GIR_Done,
     /* 120763 */ // Label 2073: @120763
     /* 120763 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120804), // Rule ID 7075 //
     /* 120768 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120789 */   // MIs[0] ptr
     /* 120789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120797 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15854>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 120802 */   GIR_RootConstrainSelectedInstOperands,
     /* 120803 */   // GIR_Coverage, 7075,
     /* 120803 */   GIR_Done,
     /* 120804 */ // Label 2074: @120804
     /* 120804 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120845), // Rule ID 7077 //
     /* 120809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120830 */   // MIs[0] ptr
     /* 120830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120838 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15846>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 120843 */   GIR_RootConstrainSelectedInstOperands,
     /* 120844 */   // GIR_Coverage, 7077,
     /* 120844 */   GIR_Done,
     /* 120845 */ // Label 2075: @120845
     /* 120845 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120886), // Rule ID 7087 //
     /* 120850 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120853 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120871 */   // MIs[0] ptr
     /* 120871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120879 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15862>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 120884 */   GIR_RootConstrainSelectedInstOperands,
     /* 120885 */   // GIR_Coverage, 7087,
     /* 120885 */   GIR_Done,
     /* 120886 */ // Label 2076: @120886
     /* 120886 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(120927), // Rule ID 7089 //
     /* 120891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120894 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120898 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120912 */   // MIs[0] ptr
     /* 120912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120920 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15848>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 120925 */   GIR_RootConstrainSelectedInstOperands,
     /* 120926 */   // GIR_Coverage, 7089,
     /* 120926 */   GIR_Done,
     /* 120927 */ // Label 2077: @120927
     /* 120927 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(120968), // Rule ID 7099 //
     /* 120932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120953 */   // MIs[0] ptr
     /* 120953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120961 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15870>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 120966 */   GIR_RootConstrainSelectedInstOperands,
     /* 120967 */   // GIR_Coverage, 7099,
     /* 120967 */   GIR_Done,
     /* 120968 */ // Label 2078: @120968
     /* 120968 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(121009), // Rule ID 7100 //
     /* 120973 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120994 */   // MIs[0] ptr
     /* 120994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121002 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15850>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 121007 */   GIR_RootConstrainSelectedInstOperands,
     /* 121008 */   // GIR_Coverage, 7100,
     /* 121008 */   GIR_Done,
     /* 121009 */ // Label 2079: @121009
     /* 121009 */ GIM_Reject,
     /* 121010 */ // Label 2008: @121010
     /* 121010 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(121063), // Rule ID 235 //
     /* 121015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121037 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 121040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121061 */   GIR_RootConstrainSelectedInstOperands,
     /* 121062 */   // GIR_Coverage, 235,
     /* 121062 */   GIR_EraseRootFromParent_Done,
     /* 121063 */ // Label 2080: @121063
     /* 121063 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(121116), // Rule ID 236 //
     /* 121068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121090 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 121093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121114 */   GIR_RootConstrainSelectedInstOperands,
     /* 121115 */   // GIR_Coverage, 236,
     /* 121115 */   GIR_EraseRootFromParent_Done,
     /* 121116 */ // Label 2081: @121116
     /* 121116 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(121172), // Rule ID 243 //
     /* 121121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121139 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121146 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121170 */   GIR_RootConstrainSelectedInstOperands,
     /* 121171 */   // GIR_Coverage, 243,
     /* 121171 */   GIR_EraseRootFromParent_Done,
     /* 121172 */ // Label 2082: @121172
     /* 121172 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(121228), // Rule ID 244 //
     /* 121177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121191 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121195 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121202 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121226 */   GIR_RootConstrainSelectedInstOperands,
     /* 121227 */   // GIR_Coverage, 244,
     /* 121227 */   GIR_EraseRootFromParent_Done,
     /* 121228 */ // Label 2083: @121228
     /* 121228 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(121281), // Rule ID 4090 //
     /* 121233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121248 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121255 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121279 */   GIR_RootConstrainSelectedInstOperands,
     /* 121280 */   // GIR_Coverage, 4090,
     /* 121280 */   GIR_EraseRootFromParent_Done,
     /* 121281 */ // Label 2084: @121281
     /* 121281 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(121334), // Rule ID 4091 //
     /* 121286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121308 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121332 */   GIR_RootConstrainSelectedInstOperands,
     /* 121333 */   // GIR_Coverage, 4091,
     /* 121333 */   GIR_EraseRootFromParent_Done,
     /* 121334 */ // Label 2085: @121334
     /* 121334 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121387), // Rule ID 4092 //
     /* 121339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121361 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121385 */   GIR_RootConstrainSelectedInstOperands,
     /* 121386 */   // GIR_Coverage, 4092,
     /* 121386 */   GIR_EraseRootFromParent_Done,
     /* 121387 */ // Label 2086: @121387
     /* 121387 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121440), // Rule ID 4093 //
     /* 121392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121403 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121407 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121414 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121438 */   GIR_RootConstrainSelectedInstOperands,
     /* 121439 */   // GIR_Coverage, 4093,
     /* 121439 */   GIR_EraseRootFromParent_Done,
     /* 121440 */ // Label 2087: @121440
     /* 121440 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121532), // Rule ID 4116 //
     /* 121445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121448 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 121474 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 121481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121501 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121531 */   // GIR_Coverage, 4116,
     /* 121531 */   GIR_EraseRootFromParent_Done,
     /* 121532 */ // Label 2088: @121532
     /* 121532 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121624), // Rule ID 4117 //
     /* 121537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121540 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 121566 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 121573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121593 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121623 */   // GIR_Coverage, 4117,
     /* 121623 */   GIR_EraseRootFromParent_Done,
     /* 121624 */ // Label 2089: @121624
     /* 121624 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121716), // Rule ID 4118 //
     /* 121629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121632 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 121658 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 121665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121685 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121715 */   // GIR_Coverage, 4118,
     /* 121715 */   GIR_EraseRootFromParent_Done,
     /* 121716 */ // Label 2090: @121716
     /* 121716 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121808), // Rule ID 4119 //
     /* 121721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121724 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 121750 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 121757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121777 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121807 */   // GIR_Coverage, 4119,
     /* 121807 */   GIR_EraseRootFromParent_Done,
     /* 121808 */ // Label 2091: @121808
     /* 121808 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121900), // Rule ID 4120 //
     /* 121813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121816 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 121842 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 121849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121869 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121899 */   // GIR_Coverage, 4120,
     /* 121899 */   GIR_EraseRootFromParent_Done,
     /* 121900 */ // Label 2092: @121900
     /* 121900 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121992), // Rule ID 4121 //
     /* 121905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121908 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 121934 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 121941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121961 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121991 */   // GIR_Coverage, 4121,
     /* 121991 */   GIR_EraseRootFromParent_Done,
     /* 121992 */ // Label 2093: @121992
     /* 121992 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(122084), // Rule ID 4122 //
     /* 121997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122000 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122004 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122019 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 122026 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 122033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122053 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122083 */   // GIR_Coverage, 4122,
     /* 122083 */   GIR_EraseRootFromParent_Done,
     /* 122084 */ // Label 2094: @122084
     /* 122084 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(122176), // Rule ID 4123 //
     /* 122089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122092 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122107 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 122118 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 122125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122145 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122175 */   // GIR_Coverage, 4123,
     /* 122175 */   GIR_EraseRootFromParent_Done,
     /* 122176 */ // Label 2095: @122176
     /* 122176 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(122224), // Rule ID 259 //
     /* 122181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122192 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122196 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122203 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 122206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122222 */   GIR_RootConstrainSelectedInstOperands,
     /* 122223 */   // GIR_Coverage, 259,
     /* 122223 */   GIR_EraseRootFromParent_Done,
     /* 122224 */ // Label 2096: @122224
     /* 122224 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(122275), // Rule ID 264 //
     /* 122229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122232 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122235 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122243 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122254 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122273 */   GIR_RootConstrainSelectedInstOperands,
     /* 122274 */   // GIR_Coverage, 264,
     /* 122274 */   GIR_EraseRootFromParent_Done,
     /* 122275 */ // Label 2097: @122275
     /* 122275 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(122338), // Rule ID 7107 //
     /* 122280 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122294 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122312 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 122315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122336 */   GIR_RootConstrainSelectedInstOperands,
     /* 122337 */   // GIR_Coverage, 7107,
     /* 122337 */   GIR_EraseRootFromParent_Done,
     /* 122338 */ // Label 2098: @122338
     /* 122338 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(122401), // Rule ID 7108 //
     /* 122343 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122357 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122375 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 122378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122399 */   GIR_RootConstrainSelectedInstOperands,
     /* 122400 */   // GIR_Coverage, 7108,
     /* 122400 */   GIR_EraseRootFromParent_Done,
     /* 122401 */ // Label 2099: @122401
     /* 122401 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122449), // Rule ID 280 //
     /* 122406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122417 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122428 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 122431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122447 */   GIR_RootConstrainSelectedInstOperands,
     /* 122448 */   // GIR_Coverage, 280,
     /* 122448 */   GIR_EraseRootFromParent_Done,
     /* 122449 */ // Label 2100: @122449
     /* 122449 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122500), // Rule ID 285 //
     /* 122454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122479 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122498 */   GIR_RootConstrainSelectedInstOperands,
     /* 122499 */   // GIR_Coverage, 285,
     /* 122499 */   GIR_EraseRootFromParent_Done,
     /* 122500 */ // Label 2101: @122500
     /* 122500 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122548), // Rule ID 4137 //
     /* 122505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122527 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122546 */   GIR_RootConstrainSelectedInstOperands,
     /* 122547 */   // GIR_Coverage, 4137,
     /* 122547 */   GIR_EraseRootFromParent_Done,
     /* 122548 */ // Label 2102: @122548
     /* 122548 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122596), // Rule ID 4138 //
     /* 122553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122575 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122594 */   GIR_RootConstrainSelectedInstOperands,
     /* 122595 */   // GIR_Coverage, 4138,
     /* 122595 */   GIR_EraseRootFromParent_Done,
     /* 122596 */ // Label 2103: @122596
     /* 122596 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122683), // Rule ID 4154 //
     /* 122601 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122604 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 122630 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 122637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122652 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122682 */   // GIR_Coverage, 4154,
     /* 122682 */   GIR_EraseRootFromParent_Done,
     /* 122683 */ // Label 2104: @122683
     /* 122683 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122770), // Rule ID 4155 //
     /* 122688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122710 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 122717 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 122724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122739 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122769 */   // GIR_Coverage, 4155,
     /* 122769 */   GIR_EraseRootFromParent_Done,
     /* 122770 */ // Label 2105: @122770
     /* 122770 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122857), // Rule ID 4156 //
     /* 122775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 122804 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 122811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122826 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122856 */   // GIR_Coverage, 4156,
     /* 122856 */   GIR_EraseRootFromParent_Done,
     /* 122857 */ // Label 2106: @122857
     /* 122857 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122944), // Rule ID 4157 //
     /* 122862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122865 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 122891 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 122898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122913 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122938 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122943 */   // GIR_Coverage, 4157,
     /* 122943 */   GIR_EraseRootFromParent_Done,
     /* 122944 */ // Label 2107: @122944
     /* 122944 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122992), // Rule ID 4165 //
     /* 122949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122952 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122971 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122990 */   GIR_RootConstrainSelectedInstOperands,
     /* 122991 */   // GIR_Coverage, 4165,
     /* 122991 */   GIR_EraseRootFromParent_Done,
     /* 122992 */ // Label 2108: @122992
     /* 122992 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(123040), // Rule ID 4166 //
     /* 122997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123019 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123038 */   GIR_RootConstrainSelectedInstOperands,
     /* 123039 */   // GIR_Coverage, 4166,
     /* 123039 */   GIR_EraseRootFromParent_Done,
     /* 123040 */ // Label 2109: @123040
     /* 123040 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(123127), // Rule ID 4177 //
     /* 123045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123048 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123067 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 123074 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 123081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123096 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123126 */   // GIR_Coverage, 4177,
     /* 123126 */   GIR_EraseRootFromParent_Done,
     /* 123127 */ // Label 2110: @123127
     /* 123127 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(123214), // Rule ID 4178 //
     /* 123132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123135 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123139 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 123161 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 123168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123183 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123213 */   // GIR_Coverage, 4178,
     /* 123213 */   GIR_EraseRootFromParent_Done,
     /* 123214 */ // Label 2111: @123214
     /* 123214 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(123301), // Rule ID 4179 //
     /* 123219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123248 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123270 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123300 */   // GIR_Coverage, 4179,
     /* 123300 */   GIR_EraseRootFromParent_Done,
     /* 123301 */ // Label 2112: @123301
     /* 123301 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(123388), // Rule ID 4180 //
     /* 123306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123309 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123313 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123335 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123357 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123387 */   // GIR_Coverage, 4180,
     /* 123387 */   GIR_EraseRootFromParent_Done,
     /* 123388 */ // Label 2113: @123388
     /* 123388 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(123446), // Rule ID 7109 //
     /* 123393 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123425 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 123428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123444 */   GIR_RootConstrainSelectedInstOperands,
     /* 123445 */   // GIR_Coverage, 7109,
     /* 123445 */   GIR_EraseRootFromParent_Done,
     /* 123446 */ // Label 2114: @123446
     /* 123446 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(123504), // Rule ID 7110 //
     /* 123451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123465 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123483 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15881>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 123486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123502 */   GIR_RootConstrainSelectedInstOperands,
     /* 123503 */   // GIR_Coverage, 7110,
     /* 123503 */   GIR_EraseRootFromParent_Done,
     /* 123504 */ // Label 2115: @123504
     /* 123504 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(123565), // Rule ID 7494 //
     /* 123509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 123512 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123515 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123544 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15852>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 123547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123563 */   GIR_RootConstrainSelectedInstOperands,
     /* 123564 */   // GIR_Coverage, 7494,
     /* 123564 */   GIR_EraseRootFromParent_Done,
     /* 123565 */ // Label 2116: @123565
     /* 123565 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(123596), // Rule ID 6442 //
     /* 123570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123581 */   // MIs[0] Rn
     /* 123581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123589 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 123594 */   GIR_RootConstrainSelectedInstOperands,
     /* 123595 */   // GIR_Coverage, 6442,
     /* 123595 */   GIR_Done,
     /* 123596 */ // Label 2117: @123596
     /* 123596 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(123640), // Rule ID 7074 //
     /* 123601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 123604 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123611 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123625 */   // MIs[0] ptr
     /* 123625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123633 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15852>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 123638 */   GIR_RootConstrainSelectedInstOperands,
     /* 123639 */   // GIR_Coverage, 7074,
     /* 123639 */   GIR_Done,
     /* 123640 */ // Label 2118: @123640
     /* 123640 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(123681), // Rule ID 7105 //
     /* 123645 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123666 */   // MIs[0] ptr
     /* 123666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123674 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15878>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 123679 */   GIR_RootConstrainSelectedInstOperands,
     /* 123680 */   // GIR_Coverage, 7105,
     /* 123680 */   GIR_Done,
     /* 123681 */ // Label 2119: @123681
     /* 123681 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(123722), // Rule ID 7106 //
     /* 123686 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123689 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123707 */   // MIs[0] ptr
     /* 123707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123715 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15852>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 123720 */   GIR_RootConstrainSelectedInstOperands,
     /* 123721 */   // GIR_Coverage, 7106,
     /* 123721 */   GIR_Done,
     /* 123722 */ // Label 2120: @123722
     /* 123722 */ GIM_Reject,
     /* 123723 */ // Label 2009: @123723
     /* 123723 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(123931),
     /* 123728 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123743 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(123784), // Rule ID 245 //
     /* 123748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123758 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123782 */     GIR_RootConstrainSelectedInstOperands,
     /* 123783 */     // GIR_Coverage, 245,
     /* 123783 */     GIR_EraseRootFromParent_Done,
     /* 123784 */   // Label 2122: @123784
     /* 123784 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(123825), // Rule ID 246 //
     /* 123789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123799 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123823 */     GIR_RootConstrainSelectedInstOperands,
     /* 123824 */     // GIR_Coverage, 246,
     /* 123824 */     GIR_EraseRootFromParent_Done,
     /* 123825 */   // Label 2123: @123825
     /* 123825 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(123861), // Rule ID 265 //
     /* 123830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123840 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123859 */     GIR_RootConstrainSelectedInstOperands,
     /* 123860 */     // GIR_Coverage, 265,
     /* 123860 */     GIR_EraseRootFromParent_Done,
     /* 123861 */   // Label 2124: @123861
     /* 123861 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(123897), // Rule ID 286 //
     /* 123866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123876 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 123876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123895 */     GIR_RootConstrainSelectedInstOperands,
     /* 123896 */     // GIR_Coverage, 286,
     /* 123896 */     GIR_EraseRootFromParent_Done,
     /* 123897 */   // Label 2125: @123897
     /* 123897 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(123930), // Rule ID 4146 //
     /* 123902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123909 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123928 */     GIR_RootConstrainSelectedInstOperands,
     /* 123929 */     // GIR_Coverage, 4146,
     /* 123929 */     GIR_EraseRootFromParent_Done,
     /* 123930 */   // Label 2126: @123930
     /* 123930 */   GIM_Reject,
     /* 123931 */ // Label 2121: @123931
     /* 123931 */ GIM_Reject,
     /* 123932 */ // Label 2010: @123932
     /* 123932 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(124309),
     /* 123937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123948 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(123993), // Rule ID 4080 //
     /* 123953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123967 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123991 */     GIR_RootConstrainSelectedInstOperands,
     /* 123992 */     // GIR_Coverage, 4080,
     /* 123992 */     GIR_EraseRootFromParent_Done,
     /* 123993 */   // Label 2128: @123993
     /* 123993 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(124038), // Rule ID 4081 //
     /* 123998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124012 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124036 */     GIR_RootConstrainSelectedInstOperands,
     /* 124037 */     // GIR_Coverage, 4081,
     /* 124037 */     GIR_EraseRootFromParent_Done,
     /* 124038 */   // Label 2129: @124038
     /* 124038 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(124083), // Rule ID 4082 //
     /* 124043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124057 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124081 */     GIR_RootConstrainSelectedInstOperands,
     /* 124082 */     // GIR_Coverage, 4082,
     /* 124082 */     GIR_EraseRootFromParent_Done,
     /* 124083 */   // Label 2130: @124083
     /* 124083 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(124128), // Rule ID 4083 //
     /* 124088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124102 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124126 */     GIR_RootConstrainSelectedInstOperands,
     /* 124127 */     // GIR_Coverage, 4083,
     /* 124127 */     GIR_EraseRootFromParent_Done,
     /* 124128 */   // Label 2131: @124128
     /* 124128 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(124168), // Rule ID 4132 //
     /* 124133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124147 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124166 */     GIR_RootConstrainSelectedInstOperands,
     /* 124167 */     // GIR_Coverage, 4132,
     /* 124167 */     GIR_EraseRootFromParent_Done,
     /* 124168 */   // Label 2132: @124168
     /* 124168 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(124208), // Rule ID 4135 //
     /* 124173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124187 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124206 */     GIR_RootConstrainSelectedInstOperands,
     /* 124207 */     // GIR_Coverage, 4135,
     /* 124207 */     GIR_EraseRootFromParent_Done,
     /* 124208 */   // Label 2133: @124208
     /* 124208 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(124248), // Rule ID 4160 //
     /* 124213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124227 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124246 */     GIR_RootConstrainSelectedInstOperands,
     /* 124247 */     // GIR_Coverage, 4160,
     /* 124247 */     GIR_EraseRootFromParent_Done,
     /* 124248 */   // Label 2134: @124248
     /* 124248 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(124288), // Rule ID 4161 //
     /* 124253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124267 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124286 */     GIR_RootConstrainSelectedInstOperands,
     /* 124287 */     // GIR_Coverage, 4161,
     /* 124287 */     GIR_EraseRootFromParent_Done,
     /* 124288 */   // Label 2135: @124288
     /* 124288 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(124308), // Rule ID 6441 //
     /* 124293 */     // MIs[0] Rn
     /* 124293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124301 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 124306 */     GIR_RootConstrainSelectedInstOperands,
     /* 124307 */     // GIR_Coverage, 6441,
     /* 124307 */     GIR_Done,
     /* 124308 */   // Label 2136: @124308
     /* 124308 */   GIM_Reject,
     /* 124309 */ // Label 2127: @124309
     /* 124309 */ GIM_Reject,
     /* 124310 */ // Label 2011: @124310
     /* 124310 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(124687),
     /* 124315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124326 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(124371), // Rule ID 4094 //
     /* 124331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124345 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124369 */     GIR_RootConstrainSelectedInstOperands,
     /* 124370 */     // GIR_Coverage, 4094,
     /* 124370 */     GIR_EraseRootFromParent_Done,
     /* 124371 */   // Label 2138: @124371
     /* 124371 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(124416), // Rule ID 4095 //
     /* 124376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124390 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124414 */     GIR_RootConstrainSelectedInstOperands,
     /* 124415 */     // GIR_Coverage, 4095,
     /* 124415 */     GIR_EraseRootFromParent_Done,
     /* 124416 */   // Label 2139: @124416
     /* 124416 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(124461), // Rule ID 4096 //
     /* 124421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124435 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124459 */     GIR_RootConstrainSelectedInstOperands,
     /* 124460 */     // GIR_Coverage, 4096,
     /* 124460 */     GIR_EraseRootFromParent_Done,
     /* 124461 */   // Label 2140: @124461
     /* 124461 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(124506), // Rule ID 4097 //
     /* 124466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124480 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124504 */     GIR_RootConstrainSelectedInstOperands,
     /* 124505 */     // GIR_Coverage, 4097,
     /* 124505 */     GIR_EraseRootFromParent_Done,
     /* 124506 */   // Label 2141: @124506
     /* 124506 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(124546), // Rule ID 4140 //
     /* 124511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124525 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124544 */     GIR_RootConstrainSelectedInstOperands,
     /* 124545 */     // GIR_Coverage, 4140,
     /* 124545 */     GIR_EraseRootFromParent_Done,
     /* 124546 */   // Label 2142: @124546
     /* 124546 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(124586), // Rule ID 4144 //
     /* 124551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124565 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124584 */     GIR_RootConstrainSelectedInstOperands,
     /* 124585 */     // GIR_Coverage, 4144,
     /* 124585 */     GIR_EraseRootFromParent_Done,
     /* 124586 */   // Label 2143: @124586
     /* 124586 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(124626), // Rule ID 4167 //
     /* 124591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124605 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124624 */     GIR_RootConstrainSelectedInstOperands,
     /* 124625 */     // GIR_Coverage, 4167,
     /* 124625 */     GIR_EraseRootFromParent_Done,
     /* 124626 */   // Label 2144: @124626
     /* 124626 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(124666), // Rule ID 4168 //
     /* 124631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124645 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124664 */     GIR_RootConstrainSelectedInstOperands,
     /* 124665 */     // GIR_Coverage, 4168,
     /* 124665 */     GIR_EraseRootFromParent_Done,
     /* 124666 */   // Label 2145: @124666
     /* 124666 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(124686), // Rule ID 6438 //
     /* 124671 */     // MIs[0] Rn
     /* 124671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124679 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 124684 */     GIR_RootConstrainSelectedInstOperands,
     /* 124685 */     // GIR_Coverage, 6438,
     /* 124685 */     GIR_Done,
     /* 124686 */   // Label 2146: @124686
     /* 124686 */   GIM_Reject,
     /* 124687 */ // Label 2137: @124687
     /* 124687 */ GIM_Reject,
     /* 124688 */ // Label 2012: @124688
     /* 124688 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(125065),
     /* 124693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124704 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(124749), // Rule ID 4086 //
     /* 124709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124723 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124747 */     GIR_RootConstrainSelectedInstOperands,
     /* 124748 */     // GIR_Coverage, 4086,
     /* 124748 */     GIR_EraseRootFromParent_Done,
     /* 124749 */   // Label 2148: @124749
     /* 124749 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(124794), // Rule ID 4087 //
     /* 124754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124768 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124792 */     GIR_RootConstrainSelectedInstOperands,
     /* 124793 */     // GIR_Coverage, 4087,
     /* 124793 */     GIR_EraseRootFromParent_Done,
     /* 124794 */   // Label 2149: @124794
     /* 124794 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(124839), // Rule ID 4088 //
     /* 124799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124813 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124837 */     GIR_RootConstrainSelectedInstOperands,
     /* 124838 */     // GIR_Coverage, 4088,
     /* 124838 */     GIR_EraseRootFromParent_Done,
     /* 124839 */   // Label 2150: @124839
     /* 124839 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(124884), // Rule ID 4089 //
     /* 124844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124858 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124882 */     GIR_RootConstrainSelectedInstOperands,
     /* 124883 */     // GIR_Coverage, 4089,
     /* 124883 */     GIR_EraseRootFromParent_Done,
     /* 124884 */   // Label 2151: @124884
     /* 124884 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(124924), // Rule ID 4134 //
     /* 124889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124903 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124922 */     GIR_RootConstrainSelectedInstOperands,
     /* 124923 */     // GIR_Coverage, 4134,
     /* 124923 */     GIR_EraseRootFromParent_Done,
     /* 124924 */   // Label 2152: @124924
     /* 124924 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(124964), // Rule ID 4136 //
     /* 124929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124943 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124962 */     GIR_RootConstrainSelectedInstOperands,
     /* 124963 */     // GIR_Coverage, 4136,
     /* 124963 */     GIR_EraseRootFromParent_Done,
     /* 124964 */   // Label 2153: @124964
     /* 124964 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(125004), // Rule ID 4162 //
     /* 124969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124983 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125002 */     GIR_RootConstrainSelectedInstOperands,
     /* 125003 */     // GIR_Coverage, 4162,
     /* 125003 */     GIR_EraseRootFromParent_Done,
     /* 125004 */   // Label 2154: @125004
     /* 125004 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(125044), // Rule ID 4164 //
     /* 125009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125023 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125042 */     GIR_RootConstrainSelectedInstOperands,
     /* 125043 */     // GIR_Coverage, 4164,
     /* 125043 */     GIR_EraseRootFromParent_Done,
     /* 125044 */   // Label 2155: @125044
     /* 125044 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(125064), // Rule ID 6440 //
     /* 125049 */     // MIs[0] Rn
     /* 125049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125057 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 125062 */     GIR_RootConstrainSelectedInstOperands,
     /* 125063 */     // GIR_Coverage, 6440,
     /* 125063 */     GIR_Done,
     /* 125064 */   // Label 2156: @125064
     /* 125064 */   GIM_Reject,
     /* 125065 */ // Label 2147: @125065
     /* 125065 */ GIM_Reject,
     /* 125066 */ // Label 2013: @125066
     /* 125066 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(125443),
     /* 125071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125082 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(125127), // Rule ID 4098 //
     /* 125087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125101 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125125 */     GIR_RootConstrainSelectedInstOperands,
     /* 125126 */     // GIR_Coverage, 4098,
     /* 125126 */     GIR_EraseRootFromParent_Done,
     /* 125127 */   // Label 2158: @125127
     /* 125127 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(125172), // Rule ID 4099 //
     /* 125132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125146 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125170 */     GIR_RootConstrainSelectedInstOperands,
     /* 125171 */     // GIR_Coverage, 4099,
     /* 125171 */     GIR_EraseRootFromParent_Done,
     /* 125172 */   // Label 2159: @125172
     /* 125172 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(125217), // Rule ID 4100 //
     /* 125177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125191 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125215 */     GIR_RootConstrainSelectedInstOperands,
     /* 125216 */     // GIR_Coverage, 4100,
     /* 125216 */     GIR_EraseRootFromParent_Done,
     /* 125217 */   // Label 2160: @125217
     /* 125217 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(125262), // Rule ID 4101 //
     /* 125222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125236 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125260 */     GIR_RootConstrainSelectedInstOperands,
     /* 125261 */     // GIR_Coverage, 4101,
     /* 125261 */     GIR_EraseRootFromParent_Done,
     /* 125262 */   // Label 2161: @125262
     /* 125262 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(125302), // Rule ID 4139 //
     /* 125267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125281 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125300 */     GIR_RootConstrainSelectedInstOperands,
     /* 125301 */     // GIR_Coverage, 4139,
     /* 125301 */     GIR_EraseRootFromParent_Done,
     /* 125302 */   // Label 2162: @125302
     /* 125302 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(125342), // Rule ID 4143 //
     /* 125307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125321 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125340 */     GIR_RootConstrainSelectedInstOperands,
     /* 125341 */     // GIR_Coverage, 4143,
     /* 125341 */     GIR_EraseRootFromParent_Done,
     /* 125342 */   // Label 2163: @125342
     /* 125342 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(125382), // Rule ID 4169 //
     /* 125347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125361 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125380 */     GIR_RootConstrainSelectedInstOperands,
     /* 125381 */     // GIR_Coverage, 4169,
     /* 125381 */     GIR_EraseRootFromParent_Done,
     /* 125382 */   // Label 2164: @125382
     /* 125382 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(125422), // Rule ID 4170 //
     /* 125387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125401 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125420 */     GIR_RootConstrainSelectedInstOperands,
     /* 125421 */     // GIR_Coverage, 4170,
     /* 125421 */     GIR_EraseRootFromParent_Done,
     /* 125422 */   // Label 2165: @125422
     /* 125422 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(125442), // Rule ID 6437 //
     /* 125427 */     // MIs[0] Rn
     /* 125427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125435 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 125440 */     GIR_RootConstrainSelectedInstOperands,
     /* 125441 */     // GIR_Coverage, 6437,
     /* 125441 */     GIR_Done,
     /* 125442 */   // Label 2166: @125442
     /* 125442 */   GIM_Reject,
     /* 125443 */ // Label 2157: @125443
     /* 125443 */ GIM_Reject,
     /* 125444 */ // Label 2014: @125444
     /* 125444 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(125651),
     /* 125449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 125460 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(125505), // Rule ID 4084 //
     /* 125465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 125479 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 125479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 125482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125503 */     GIR_RootConstrainSelectedInstOperands,
     /* 125504 */     // GIR_Coverage, 4084,
     /* 125504 */     GIR_EraseRootFromParent_Done,
     /* 125505 */   // Label 2168: @125505
     /* 125505 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(125550), // Rule ID 4085 //
     /* 125510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 125524 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 125524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 125527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125548 */     GIR_RootConstrainSelectedInstOperands,
     /* 125549 */     // GIR_Coverage, 4085,
     /* 125549 */     GIR_EraseRootFromParent_Done,
     /* 125550 */   // Label 2169: @125550
     /* 125550 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(125590), // Rule ID 4133 //
     /* 125555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 125569 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 125569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 125572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125588 */     GIR_RootConstrainSelectedInstOperands,
     /* 125589 */     // GIR_Coverage, 4133,
     /* 125589 */     GIR_EraseRootFromParent_Done,
     /* 125590 */   // Label 2170: @125590
     /* 125590 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(125630), // Rule ID 4163 //
     /* 125595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125609 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125628 */     GIR_RootConstrainSelectedInstOperands,
     /* 125629 */     // GIR_Coverage, 4163,
     /* 125629 */     GIR_EraseRootFromParent_Done,
     /* 125630 */   // Label 2171: @125630
     /* 125630 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(125650), // Rule ID 6439 //
     /* 125635 */     // MIs[0] Rn
     /* 125635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125643 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 125648 */     GIR_RootConstrainSelectedInstOperands,
     /* 125649 */     // GIR_Coverage, 6439,
     /* 125649 */     GIR_Done,
     /* 125650 */   // Label 2172: @125650
     /* 125650 */   GIM_Reject,
     /* 125651 */ // Label 2167: @125651
     /* 125651 */ GIM_Reject,
     /* 125652 */ // Label 2015: @125652
     /* 125652 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(126029),
     /* 125657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125668 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(125713), // Rule ID 4102 //
     /* 125673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125687 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125711 */     GIR_RootConstrainSelectedInstOperands,
     /* 125712 */     // GIR_Coverage, 4102,
     /* 125712 */     GIR_EraseRootFromParent_Done,
     /* 125713 */   // Label 2174: @125713
     /* 125713 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(125758), // Rule ID 4103 //
     /* 125718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125732 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125756 */     GIR_RootConstrainSelectedInstOperands,
     /* 125757 */     // GIR_Coverage, 4103,
     /* 125757 */     GIR_EraseRootFromParent_Done,
     /* 125758 */   // Label 2175: @125758
     /* 125758 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(125803), // Rule ID 4104 //
     /* 125763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125777 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125801 */     GIR_RootConstrainSelectedInstOperands,
     /* 125802 */     // GIR_Coverage, 4104,
     /* 125802 */     GIR_EraseRootFromParent_Done,
     /* 125803 */   // Label 2176: @125803
     /* 125803 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(125848), // Rule ID 4105 //
     /* 125808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125822 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125846 */     GIR_RootConstrainSelectedInstOperands,
     /* 125847 */     // GIR_Coverage, 4105,
     /* 125847 */     GIR_EraseRootFromParent_Done,
     /* 125848 */   // Label 2177: @125848
     /* 125848 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(125888), // Rule ID 4142 //
     /* 125853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125867 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125886 */     GIR_RootConstrainSelectedInstOperands,
     /* 125887 */     // GIR_Coverage, 4142,
     /* 125887 */     GIR_EraseRootFromParent_Done,
     /* 125888 */   // Label 2178: @125888
     /* 125888 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(125928), // Rule ID 4145 //
     /* 125893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125907 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125926 */     GIR_RootConstrainSelectedInstOperands,
     /* 125927 */     // GIR_Coverage, 4145,
     /* 125927 */     GIR_EraseRootFromParent_Done,
     /* 125928 */   // Label 2179: @125928
     /* 125928 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(125968), // Rule ID 4171 //
     /* 125933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125947 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125966 */     GIR_RootConstrainSelectedInstOperands,
     /* 125967 */     // GIR_Coverage, 4171,
     /* 125967 */     GIR_EraseRootFromParent_Done,
     /* 125968 */   // Label 2180: @125968
     /* 125968 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(126008), // Rule ID 4173 //
     /* 125973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125987 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126006 */     GIR_RootConstrainSelectedInstOperands,
     /* 126007 */     // GIR_Coverage, 4173,
     /* 126007 */     GIR_EraseRootFromParent_Done,
     /* 126008 */   // Label 2181: @126008
     /* 126008 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(126028), // Rule ID 6436 //
     /* 126013 */     // MIs[0] Rn
     /* 126013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126021 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 126026 */     GIR_RootConstrainSelectedInstOperands,
     /* 126027 */     // GIR_Coverage, 6436,
     /* 126027 */     GIR_Done,
     /* 126028 */   // Label 2182: @126028
     /* 126028 */   GIM_Reject,
     /* 126029 */ // Label 2173: @126029
     /* 126029 */ GIM_Reject,
     /* 126030 */ // Label 2016: @126030
     /* 126030 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(126237),
     /* 126035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 126046 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(126091), // Rule ID 4106 //
     /* 126051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 126065 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 126065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 126068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126089 */     GIR_RootConstrainSelectedInstOperands,
     /* 126090 */     // GIR_Coverage, 4106,
     /* 126090 */     GIR_EraseRootFromParent_Done,
     /* 126091 */   // Label 2184: @126091
     /* 126091 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(126136), // Rule ID 4107 //
     /* 126096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 126110 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 126110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 126113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126134 */     GIR_RootConstrainSelectedInstOperands,
     /* 126135 */     // GIR_Coverage, 4107,
     /* 126135 */     GIR_EraseRootFromParent_Done,
     /* 126136 */   // Label 2185: @126136
     /* 126136 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(126176), // Rule ID 4141 //
     /* 126141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 126155 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 126155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 126158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126174 */     GIR_RootConstrainSelectedInstOperands,
     /* 126175 */     // GIR_Coverage, 4141,
     /* 126175 */     GIR_EraseRootFromParent_Done,
     /* 126176 */   // Label 2186: @126176
     /* 126176 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(126216), // Rule ID 4172 //
     /* 126181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 126195 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 126195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 126198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126214 */     GIR_RootConstrainSelectedInstOperands,
     /* 126215 */     // GIR_Coverage, 4172,
     /* 126215 */     GIR_EraseRootFromParent_Done,
     /* 126216 */   // Label 2187: @126216
     /* 126216 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(126236), // Rule ID 6435 //
     /* 126221 */     // MIs[0] Rn
     /* 126221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126229 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 126234 */     GIR_RootConstrainSelectedInstOperands,
     /* 126235 */     // GIR_Coverage, 6435,
     /* 126235 */     GIR_Done,
     /* 126236 */   // Label 2188: @126236
     /* 126236 */   GIM_Reject,
     /* 126237 */ // Label 2183: @126237
     /* 126237 */ GIM_Reject,
     /* 126238 */ // Label 2017: @126238
     /* 126238 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(126301), // Rule ID 11019 //
     /* 126243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126257 */   // MIs[0] base
     /* 126257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126265 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126277 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 126285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126290 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126299 */   GIR_RootConstrainSelectedInstOperands,
     /* 126300 */   // GIR_Coverage, 11019,
     /* 126300 */   GIR_EraseRootFromParent_Done,
     /* 126301 */ // Label 2189: @126301
     /* 126301 */ GIM_Reject,
     /* 126302 */ // Label 2018: @126302
     /* 126302 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(126365), // Rule ID 11025 //
     /* 126307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126321 */   // MIs[0] base
     /* 126321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126329 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126341 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 126349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126354 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126363 */   GIR_RootConstrainSelectedInstOperands,
     /* 126364 */   // GIR_Coverage, 11025,
     /* 126364 */   GIR_EraseRootFromParent_Done,
     /* 126365 */ // Label 2190: @126365
     /* 126365 */ GIM_Reject,
     /* 126366 */ // Label 2019: @126366
     /* 126366 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(126539),
     /* 126371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126386 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(126434), // Rule ID 11010 //
     /* 126391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126398 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126423 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126432 */     GIR_RootConstrainSelectedInstOperands,
     /* 126433 */     // GIR_Coverage, 11010,
     /* 126433 */     GIR_EraseRootFromParent_Done,
     /* 126434 */   // Label 2192: @126434
     /* 126434 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(126482), // Rule ID 11028 //
     /* 126439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126446 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126471 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126480 */     GIR_RootConstrainSelectedInstOperands,
     /* 126481 */     // GIR_Coverage, 11028,
     /* 126481 */     GIR_EraseRootFromParent_Done,
     /* 126482 */   // Label 2193: @126482
     /* 126482 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(126510), // Rule ID 11055 //
     /* 126487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126494 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126499 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126508 */     GIR_RootConstrainSelectedInstOperands,
     /* 126509 */     // GIR_Coverage, 11055,
     /* 126509 */     GIR_EraseRootFromParent_Done,
     /* 126510 */   // Label 2194: @126510
     /* 126510 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(126538), // Rule ID 11067 //
     /* 126515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126522 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126527 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126536 */     GIR_RootConstrainSelectedInstOperands,
     /* 126537 */     // GIR_Coverage, 11067,
     /* 126537 */     GIR_EraseRootFromParent_Done,
     /* 126538 */   // Label 2195: @126538
     /* 126538 */   GIM_Reject,
     /* 126539 */ // Label 2191: @126539
     /* 126539 */ GIM_Reject,
     /* 126540 */ // Label 2020: @126540
     /* 126540 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(126603), // Rule ID 11016 //
     /* 126545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126559 */   // MIs[0] base
     /* 126559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126567 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126579 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 126587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126592 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126601 */   GIR_RootConstrainSelectedInstOperands,
     /* 126602 */   // GIR_Coverage, 11016,
     /* 126602 */   GIR_EraseRootFromParent_Done,
     /* 126603 */ // Label 2196: @126603
     /* 126603 */ GIM_Reject,
     /* 126604 */ // Label 2021: @126604
     /* 126604 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(126777),
     /* 126609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126624 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(126672), // Rule ID 10998 //
     /* 126629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126636 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 126656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126661 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126670 */     GIR_RootConstrainSelectedInstOperands,
     /* 126671 */     // GIR_Coverage, 10998,
     /* 126671 */     GIR_EraseRootFromParent_Done,
     /* 126672 */   // Label 2198: @126672
     /* 126672 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(126720), // Rule ID 11022 //
     /* 126677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126684 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 126704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126709 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126718 */     GIR_RootConstrainSelectedInstOperands,
     /* 126719 */     // GIR_Coverage, 11022,
     /* 126719 */     GIR_EraseRootFromParent_Done,
     /* 126720 */   // Label 2199: @126720
     /* 126720 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(126748), // Rule ID 11051 //
     /* 126725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126732 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126737 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126746 */     GIR_RootConstrainSelectedInstOperands,
     /* 126747 */     // GIR_Coverage, 11051,
     /* 126747 */     GIR_EraseRootFromParent_Done,
     /* 126748 */   // Label 2200: @126748
     /* 126748 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(126776), // Rule ID 11063 //
     /* 126753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126760 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126765 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126774 */     GIR_RootConstrainSelectedInstOperands,
     /* 126775 */     // GIR_Coverage, 11063,
     /* 126775 */     GIR_EraseRootFromParent_Done,
     /* 126776 */   // Label 2201: @126776
     /* 126776 */   GIM_Reject,
     /* 126777 */ // Label 2197: @126777
     /* 126777 */ GIM_Reject,
     /* 126778 */ // Label 2022: @126778
     /* 126778 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(126951),
     /* 126783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126798 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(126846), // Rule ID 10977 //
     /* 126803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126810 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 126817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 126830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126835 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126844 */     GIR_RootConstrainSelectedInstOperands,
     /* 126845 */     // GIR_Coverage, 10977,
     /* 126845 */     GIR_EraseRootFromParent_Done,
     /* 126846 */   // Label 2203: @126846
     /* 126846 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(126894), // Rule ID 11013 //
     /* 126851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126858 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 126865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 126878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126883 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126892 */     GIR_RootConstrainSelectedInstOperands,
     /* 126893 */     // GIR_Coverage, 11013,
     /* 126893 */     GIR_EraseRootFromParent_Done,
     /* 126894 */   // Label 2204: @126894
     /* 126894 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(126922), // Rule ID 11047 //
     /* 126899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126906 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126911 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126920 */     GIR_RootConstrainSelectedInstOperands,
     /* 126921 */     // GIR_Coverage, 11047,
     /* 126921 */     GIR_EraseRootFromParent_Done,
     /* 126922 */   // Label 2205: @126922
     /* 126922 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(126950), // Rule ID 11059 //
     /* 126927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126934 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126939 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126948 */     GIR_RootConstrainSelectedInstOperands,
     /* 126949 */     // GIR_Coverage, 11059,
     /* 126949 */     GIR_EraseRootFromParent_Done,
     /* 126950 */   // Label 2206: @126950
     /* 126950 */   GIM_Reject,
     /* 126951 */ // Label 2202: @126951
     /* 126951 */ GIM_Reject,
     /* 126952 */ // Label 2023: @126952
     /* 126952 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(126995), // Rule ID 2431 //
     /* 126957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 126971 */   // MIs[0] base
     /* 126971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126979 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 126982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 126984 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126993 */   GIR_RootConstrainSelectedInstOperands,
     /* 126994 */   // GIR_Coverage, 2431,
     /* 126994 */   GIR_EraseRootFromParent_Done,
     /* 126995 */ // Label 2207: @126995
     /* 126995 */ GIM_Reject,
     /* 126996 */ // Label 2024: @126996
     /* 126996 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(127093),
     /* 127001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 127012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127016 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(127064), // Rule ID 10945 //
     /* 127021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127028 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 127035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 127048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127053 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127062 */     GIR_RootConstrainSelectedInstOperands,
     /* 127063 */     // GIR_Coverage, 10945,
     /* 127063 */     GIR_EraseRootFromParent_Done,
     /* 127064 */   // Label 2209: @127064
     /* 127064 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(127092), // Rule ID 11043 //
     /* 127069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127076 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127081 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127090 */     GIR_RootConstrainSelectedInstOperands,
     /* 127091 */     // GIR_Coverage, 11043,
     /* 127091 */     GIR_EraseRootFromParent_Done,
     /* 127092 */   // Label 2210: @127092
     /* 127092 */   GIM_Reject,
     /* 127093 */ // Label 2208: @127093
     /* 127093 */ GIM_Reject,
     /* 127094 */ // Label 2025: @127094
     /* 127094 */ GIM_Reject,
     /* 127095 */ // Label 17: @127095
     /* 127095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2213*/ GIMT_Encode4(128144),
     /* 127106 */ /*GILLT_s32*//*Label 2211*/ GIMT_Encode4(127114),
     /* 127110 */ /*GILLT_s64*//*Label 2212*/ GIMT_Encode4(127528),
     /* 127114 */ // Label 2211: @127114
     /* 127114 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(127527),
     /* 127119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127122 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(127175), // Rule ID 247 //
     /* 127127 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127149 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 127152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127173 */     GIR_RootConstrainSelectedInstOperands,
     /* 127174 */     // GIR_Coverage, 247,
     /* 127174 */     GIR_EraseRootFromParent_Done,
     /* 127175 */   // Label 2215: @127175
     /* 127175 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(127228), // Rule ID 248 //
     /* 127180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127202 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 127205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127226 */     GIR_RootConstrainSelectedInstOperands,
     /* 127227 */     // GIR_Coverage, 248,
     /* 127227 */     GIR_EraseRootFromParent_Done,
     /* 127228 */   // Label 2216: @127228
     /* 127228 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(127281), // Rule ID 251 //
     /* 127233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127255 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 127255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 127258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127279 */     GIR_RootConstrainSelectedInstOperands,
     /* 127280 */     // GIR_Coverage, 251,
     /* 127280 */     GIR_EraseRootFromParent_Done,
     /* 127281 */   // Label 2217: @127281
     /* 127281 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(127334), // Rule ID 252 //
     /* 127286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127308 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 127308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 127311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127332 */     GIR_RootConstrainSelectedInstOperands,
     /* 127333 */     // GIR_Coverage, 252,
     /* 127333 */     GIR_EraseRootFromParent_Done,
     /* 127334 */   // Label 2218: @127334
     /* 127334 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(127382), // Rule ID 268 //
     /* 127339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127361 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 127364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127380 */     GIR_RootConstrainSelectedInstOperands,
     /* 127381 */     // GIR_Coverage, 268,
     /* 127381 */     GIR_EraseRootFromParent_Done,
     /* 127382 */   // Label 2219: @127382
     /* 127382 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(127430), // Rule ID 270 //
     /* 127387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127409 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 127412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127428 */     GIR_RootConstrainSelectedInstOperands,
     /* 127429 */     // GIR_Coverage, 270,
     /* 127429 */     GIR_EraseRootFromParent_Done,
     /* 127430 */   // Label 2220: @127430
     /* 127430 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(127478), // Rule ID 289 //
     /* 127435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127457 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 127460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127476 */     GIR_RootConstrainSelectedInstOperands,
     /* 127477 */     // GIR_Coverage, 289,
     /* 127477 */     GIR_EraseRootFromParent_Done,
     /* 127478 */   // Label 2221: @127478
     /* 127478 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(127526), // Rule ID 291 //
     /* 127483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127505 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 127508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127524 */     GIR_RootConstrainSelectedInstOperands,
     /* 127525 */     // GIR_Coverage, 291,
     /* 127525 */     GIR_EraseRootFromParent_Done,
     /* 127526 */   // Label 2222: @127526
     /* 127526 */   GIM_Reject,
     /* 127527 */ // Label 2214: @127527
     /* 127527 */ GIM_Reject,
     /* 127528 */ // Label 2212: @127528
     /* 127528 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(128143),
     /* 127533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127536 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(127589), // Rule ID 249 //
     /* 127541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127563 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 127566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127587 */     GIR_RootConstrainSelectedInstOperands,
     /* 127588 */     // GIR_Coverage, 249,
     /* 127588 */     GIR_EraseRootFromParent_Done,
     /* 127589 */   // Label 2224: @127589
     /* 127589 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(127642), // Rule ID 250 //
     /* 127594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127616 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 127619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127640 */     GIR_RootConstrainSelectedInstOperands,
     /* 127641 */     // GIR_Coverage, 250,
     /* 127641 */     GIR_EraseRootFromParent_Done,
     /* 127642 */   // Label 2225: @127642
     /* 127642 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(127695), // Rule ID 253 //
     /* 127647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127669 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 127669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 127672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127693 */     GIR_RootConstrainSelectedInstOperands,
     /* 127694 */     // GIR_Coverage, 253,
     /* 127694 */     GIR_EraseRootFromParent_Done,
     /* 127695 */   // Label 2226: @127695
     /* 127695 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(127748), // Rule ID 254 //
     /* 127700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127722 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 127722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 127725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127746 */     GIR_RootConstrainSelectedInstOperands,
     /* 127747 */     // GIR_Coverage, 254,
     /* 127747 */     GIR_EraseRootFromParent_Done,
     /* 127748 */   // Label 2227: @127748
     /* 127748 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(127801), // Rule ID 255 //
     /* 127753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 127775 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 127775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 127778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127799 */     GIR_RootConstrainSelectedInstOperands,
     /* 127800 */     // GIR_Coverage, 255,
     /* 127800 */     GIR_EraseRootFromParent_Done,
     /* 127801 */   // Label 2228: @127801
     /* 127801 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127854), // Rule ID 256 //
     /* 127806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 127828 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 127828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 127831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127852 */     GIR_RootConstrainSelectedInstOperands,
     /* 127853 */     // GIR_Coverage, 256,
     /* 127853 */     GIR_EraseRootFromParent_Done,
     /* 127854 */   // Label 2229: @127854
     /* 127854 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(127902), // Rule ID 269 //
     /* 127859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127881 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 127884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127900 */     GIR_RootConstrainSelectedInstOperands,
     /* 127901 */     // GIR_Coverage, 269,
     /* 127901 */     GIR_EraseRootFromParent_Done,
     /* 127902 */   // Label 2230: @127902
     /* 127902 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127950), // Rule ID 271 //
     /* 127907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127929 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 127932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127948 */     GIR_RootConstrainSelectedInstOperands,
     /* 127949 */     // GIR_Coverage, 271,
     /* 127949 */     GIR_EraseRootFromParent_Done,
     /* 127950 */   // Label 2231: @127950
     /* 127950 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(127998), // Rule ID 272 //
     /* 127955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 127977 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 127977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 127980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127996 */     GIR_RootConstrainSelectedInstOperands,
     /* 127997 */     // GIR_Coverage, 272,
     /* 127997 */     GIR_EraseRootFromParent_Done,
     /* 127998 */   // Label 2232: @127998
     /* 127998 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(128046), // Rule ID 290 //
     /* 128003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128025 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 128028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128044 */     GIR_RootConstrainSelectedInstOperands,
     /* 128045 */     // GIR_Coverage, 290,
     /* 128045 */     GIR_EraseRootFromParent_Done,
     /* 128046 */   // Label 2233: @128046
     /* 128046 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(128094), // Rule ID 292 //
     /* 128051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 128073 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 128076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128092 */     GIR_RootConstrainSelectedInstOperands,
     /* 128093 */     // GIR_Coverage, 292,
     /* 128093 */     GIR_EraseRootFromParent_Done,
     /* 128094 */   // Label 2234: @128094
     /* 128094 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(128142), // Rule ID 293 //
     /* 128099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 128121 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 128124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128140 */     GIR_RootConstrainSelectedInstOperands,
     /* 128141 */     // GIR_Coverage, 293,
     /* 128141 */     GIR_EraseRootFromParent_Done,
     /* 128142 */   // Label 2235: @128142
     /* 128142 */   GIM_Reject,
     /* 128143 */ // Label 2223: @128143
     /* 128143 */ GIM_Reject,
     /* 128144 */ // Label 2213: @128144
     /* 128144 */ GIM_Reject,
     /* 128145 */ // Label 18: @128145
     /* 128145 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2238*/ GIMT_Encode4(131193),
     /* 128156 */ /*GILLT_s32*//*Label 2236*/ GIMT_Encode4(128164),
     /* 128160 */ /*GILLT_s64*//*Label 2237*/ GIMT_Encode4(129703),
     /* 128164 */ // Label 2236: @128164
     /* 128164 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(128220), // Rule ID 229 //
     /* 128169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128194 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128218 */   GIR_RootConstrainSelectedInstOperands,
     /* 128219 */   // GIR_Coverage, 229,
     /* 128219 */   GIR_EraseRootFromParent_Done,
     /* 128220 */ // Label 2239: @128220
     /* 128220 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(128276), // Rule ID 230 //
     /* 128225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128250 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128274 */   GIR_RootConstrainSelectedInstOperands,
     /* 128275 */   // GIR_Coverage, 230,
     /* 128275 */   GIR_EraseRootFromParent_Done,
     /* 128276 */ // Label 2240: @128276
     /* 128276 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(128332), // Rule ID 231 //
     /* 128281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128299 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128306 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 128306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128330 */   GIR_RootConstrainSelectedInstOperands,
     /* 128331 */   // GIR_Coverage, 231,
     /* 128331 */   GIR_EraseRootFromParent_Done,
     /* 128332 */ // Label 2241: @128332
     /* 128332 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(128388), // Rule ID 232 //
     /* 128337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128340 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128362 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128386 */   GIR_RootConstrainSelectedInstOperands,
     /* 128387 */   // GIR_Coverage, 232,
     /* 128387 */   GIR_EraseRootFromParent_Done,
     /* 128388 */ // Label 2242: @128388
     /* 128388 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(128444), // Rule ID 4130 //
     /* 128393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128411 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128418 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128442 */   GIR_RootConstrainSelectedInstOperands,
     /* 128443 */   // GIR_Coverage, 4130,
     /* 128443 */   GIR_EraseRootFromParent_Done,
     /* 128444 */ // Label 2243: @128444
     /* 128444 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(128500), // Rule ID 4131 //
     /* 128449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128474 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128498 */   GIR_RootConstrainSelectedInstOperands,
     /* 128499 */   // GIR_Coverage, 4131,
     /* 128499 */   GIR_EraseRootFromParent_Done,
     /* 128500 */ // Label 2244: @128500
     /* 128500 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(128551), // Rule ID 266 //
     /* 128505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 128530 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 128530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 128533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128549 */   GIR_RootConstrainSelectedInstOperands,
     /* 128550 */   // GIR_Coverage, 266,
     /* 128550 */   GIR_EraseRootFromParent_Done,
     /* 128551 */ // Label 2245: @128551
     /* 128551 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(128602), // Rule ID 267 //
     /* 128556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128581 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128600 */   GIR_RootConstrainSelectedInstOperands,
     /* 128601 */   // GIR_Coverage, 267,
     /* 128601 */   GIR_EraseRootFromParent_Done,
     /* 128602 */ // Label 2246: @128602
     /* 128602 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(128661), // Rule ID 7080 //
     /* 128607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128617 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128635 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15857>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 128635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128659 */   GIR_RootConstrainSelectedInstOperands,
     /* 128660 */   // GIR_Coverage, 7080,
     /* 128660 */   GIR_EraseRootFromParent_Done,
     /* 128661 */ // Label 2247: @128661
     /* 128661 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128720), // Rule ID 7082 //
     /* 128666 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128676 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128694 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15857>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 128694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128718 */   GIR_RootConstrainSelectedInstOperands,
     /* 128719 */   // GIR_Coverage, 7082,
     /* 128719 */   GIR_EraseRootFromParent_Done,
     /* 128720 */ // Label 2248: @128720
     /* 128720 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128779), // Rule ID 7092 //
     /* 128725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128735 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128753 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15865>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 128753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128777 */   GIR_RootConstrainSelectedInstOperands,
     /* 128778 */   // GIR_Coverage, 7092,
     /* 128778 */   GIR_EraseRootFromParent_Done,
     /* 128779 */ // Label 2249: @128779
     /* 128779 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128838), // Rule ID 7094 //
     /* 128784 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128794 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128812 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15865>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128836 */   GIR_RootConstrainSelectedInstOperands,
     /* 128837 */   // GIR_Coverage, 7094,
     /* 128837 */   GIR_EraseRootFromParent_Done,
     /* 128838 */ // Label 2250: @128838
     /* 128838 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128889), // Rule ID 287 //
     /* 128843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128868 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 128871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128887 */   GIR_RootConstrainSelectedInstOperands,
     /* 128888 */   // GIR_Coverage, 287,
     /* 128888 */   GIR_EraseRootFromParent_Done,
     /* 128889 */ // Label 2251: @128889
     /* 128889 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(128940), // Rule ID 288 //
     /* 128894 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128897 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128912 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128919 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 128922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128938 */   GIR_RootConstrainSelectedInstOperands,
     /* 128939 */   // GIR_Coverage, 288,
     /* 128939 */   GIR_EraseRootFromParent_Done,
     /* 128940 */ // Label 2252: @128940
     /* 128940 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128991), // Rule ID 4149 //
     /* 128945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128948 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128970 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128989 */   GIR_RootConstrainSelectedInstOperands,
     /* 128990 */   // GIR_Coverage, 4149,
     /* 128990 */   GIR_EraseRootFromParent_Done,
     /* 128991 */ // Label 2253: @128991
     /* 128991 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(129042), // Rule ID 4181 //
     /* 128996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129021 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129040 */   GIR_RootConstrainSelectedInstOperands,
     /* 129041 */   // GIR_Coverage, 4181,
     /* 129041 */   GIR_EraseRootFromParent_Done,
     /* 129042 */ // Label 2254: @129042
     /* 129042 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(129093), // Rule ID 4182 //
     /* 129047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129072 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129091 */   GIR_RootConstrainSelectedInstOperands,
     /* 129092 */   // GIR_Coverage, 4182,
     /* 129092 */   GIR_EraseRootFromParent_Done,
     /* 129093 */ // Label 2255: @129093
     /* 129093 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(129144), // Rule ID 4183 //
     /* 129098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129123 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129142 */   GIR_RootConstrainSelectedInstOperands,
     /* 129143 */   // GIR_Coverage, 4183,
     /* 129143 */   GIR_EraseRootFromParent_Done,
     /* 129144 */ // Label 2256: @129144
     /* 129144 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(129198), // Rule ID 7084 //
     /* 129149 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129159 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129177 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15857>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 129177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129196 */   GIR_RootConstrainSelectedInstOperands,
     /* 129197 */   // GIR_Coverage, 7084,
     /* 129197 */   GIR_EraseRootFromParent_Done,
     /* 129198 */ // Label 2257: @129198
     /* 129198 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(129252), // Rule ID 7086 //
     /* 129203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129213 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129231 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15857>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129250 */   GIR_RootConstrainSelectedInstOperands,
     /* 129251 */   // GIR_Coverage, 7086,
     /* 129251 */   GIR_EraseRootFromParent_Done,
     /* 129252 */ // Label 2258: @129252
     /* 129252 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(129306), // Rule ID 7096 //
     /* 129257 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129267 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129274 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129278 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 129285 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15865>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 129285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 129288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129304 */   GIR_RootConstrainSelectedInstOperands,
     /* 129305 */   // GIR_Coverage, 7096,
     /* 129305 */   GIR_EraseRootFromParent_Done,
     /* 129306 */ // Label 2259: @129306
     /* 129306 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(129360), // Rule ID 7098 //
     /* 129311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129321 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129339 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15865>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129358 */   GIR_RootConstrainSelectedInstOperands,
     /* 129359 */   // GIR_Coverage, 7098,
     /* 129359 */   GIR_EraseRootFromParent_Done,
     /* 129360 */ // Label 2260: @129360
     /* 129360 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(129417), // Rule ID 7490 //
     /* 129365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129368 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129371 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129396 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15846>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 129399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129415 */   GIR_RootConstrainSelectedInstOperands,
     /* 129416 */   // GIR_Coverage, 7490,
     /* 129416 */   GIR_EraseRootFromParent_Done,
     /* 129417 */ // Label 2261: @129417
     /* 129417 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(129474), // Rule ID 7492 //
     /* 129422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129425 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129446 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129453 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15848>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 129456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129472 */   GIR_RootConstrainSelectedInstOperands,
     /* 129473 */   // GIR_Coverage, 7492,
     /* 129473 */   GIR_EraseRootFromParent_Done,
     /* 129474 */ // Label 2262: @129474
     /* 129474 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(129514), // Rule ID 7070 //
     /* 129479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129499 */   // MIs[0] ptr
     /* 129499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129507 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15846>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 129512 */   GIR_RootConstrainSelectedInstOperands,
     /* 129513 */   // GIR_Coverage, 7070,
     /* 129513 */   GIR_Done,
     /* 129514 */ // Label 2263: @129514
     /* 129514 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129554), // Rule ID 7072 //
     /* 129519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129522 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129539 */   // MIs[0] ptr
     /* 129539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129547 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15848>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 129552 */   GIR_RootConstrainSelectedInstOperands,
     /* 129553 */   // GIR_Coverage, 7072,
     /* 129553 */   GIR_Done,
     /* 129554 */ // Label 2264: @129554
     /* 129554 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129591), // Rule ID 7076 //
     /* 129559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129576 */   // MIs[0] ptr
     /* 129576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129584 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15854>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 129589 */   GIR_RootConstrainSelectedInstOperands,
     /* 129590 */   // GIR_Coverage, 7076,
     /* 129590 */   GIR_Done,
     /* 129591 */ // Label 2265: @129591
     /* 129591 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129628), // Rule ID 7078 //
     /* 129596 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129599 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129606 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129613 */   // MIs[0] ptr
     /* 129613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129621 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15846>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 129626 */   GIR_RootConstrainSelectedInstOperands,
     /* 129627 */   // GIR_Coverage, 7078,
     /* 129627 */   GIR_Done,
     /* 129628 */ // Label 2266: @129628
     /* 129628 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129665), // Rule ID 7088 //
     /* 129633 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129643 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129650 */   // MIs[0] ptr
     /* 129650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129658 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15862>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 129663 */   GIR_RootConstrainSelectedInstOperands,
     /* 129664 */   // GIR_Coverage, 7088,
     /* 129664 */   GIR_Done,
     /* 129665 */ // Label 2267: @129665
     /* 129665 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129702), // Rule ID 7090 //
     /* 129670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129687 */   // MIs[0] ptr
     /* 129687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129695 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15848>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 129700 */   GIR_RootConstrainSelectedInstOperands,
     /* 129701 */   // GIR_Coverage, 7090,
     /* 129701 */   GIR_Done,
     /* 129702 */ // Label 2268: @129702
     /* 129702 */ GIM_Reject,
     /* 129703 */ // Label 2237: @129703
     /* 129703 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(131192),
     /* 129708 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129711 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(129796), // Rule ID 4108 //
     /* 129716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 129738 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 129745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129795 */     // GIR_Coverage, 4108,
     /* 129795 */     GIR_EraseRootFromParent_Done,
     /* 129796 */   // Label 2270: @129796
     /* 129796 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(129881), // Rule ID 4109 //
     /* 129801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 129823 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 129830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129850 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129880 */     // GIR_Coverage, 4109,
     /* 129880 */     GIR_EraseRootFromParent_Done,
     /* 129881 */   // Label 2271: @129881
     /* 129881 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(129966), // Rule ID 4110 //
     /* 129886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 129908 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 129915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129935 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129965 */     // GIR_Coverage, 4110,
     /* 129965 */     GIR_EraseRootFromParent_Done,
     /* 129966 */   // Label 2272: @129966
     /* 129966 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(130051), // Rule ID 4111 //
     /* 129971 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 129993 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 130000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130050 */     // GIR_Coverage, 4111,
     /* 130050 */     GIR_EraseRootFromParent_Done,
     /* 130051 */   // Label 2273: @130051
     /* 130051 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(130136), // Rule ID 4112 //
     /* 130056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 130078 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 130085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130105 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130135 */     // GIR_Coverage, 4112,
     /* 130135 */     GIR_EraseRootFromParent_Done,
     /* 130136 */   // Label 2274: @130136
     /* 130136 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(130221), // Rule ID 4113 //
     /* 130141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 130163 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 130170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130220 */     // GIR_Coverage, 4113,
     /* 130220 */     GIR_EraseRootFromParent_Done,
     /* 130221 */   // Label 2275: @130221
     /* 130221 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(130306), // Rule ID 4114 //
     /* 130226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130248 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 130255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130275 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130305 */     // GIR_Coverage, 4114,
     /* 130305 */     GIR_EraseRootFromParent_Done,
     /* 130306 */   // Label 2276: @130306
     /* 130306 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(130391), // Rule ID 4115 //
     /* 130311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130333 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 130340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130390 */     // GIR_Coverage, 4115,
     /* 130390 */     GIR_EraseRootFromParent_Done,
     /* 130391 */   // Label 2277: @130391
     /* 130391 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(130471), // Rule ID 4147 //
     /* 130396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130418 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130470 */     // GIR_Coverage, 4147,
     /* 130470 */     GIR_EraseRootFromParent_Done,
     /* 130471 */   // Label 2278: @130471
     /* 130471 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(130551), // Rule ID 4148 //
     /* 130476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130498 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 130505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130550 */     // GIR_Coverage, 4148,
     /* 130550 */     GIR_EraseRootFromParent_Done,
     /* 130551 */   // Label 2279: @130551
     /* 130551 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(130631), // Rule ID 4150 //
     /* 130556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130578 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130630 */     // GIR_Coverage, 4150,
     /* 130630 */     GIR_EraseRootFromParent_Done,
     /* 130631 */   // Label 2280: @130631
     /* 130631 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(130711), // Rule ID 4158 //
     /* 130636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 130658 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 130665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130710 */     // GIR_Coverage, 4158,
     /* 130710 */     GIR_EraseRootFromParent_Done,
     /* 130711 */   // Label 2281: @130711
     /* 130711 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(130791), // Rule ID 4184 //
     /* 130716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 130738 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 130745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130760 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130790 */     // GIR_Coverage, 4184,
     /* 130790 */     GIR_EraseRootFromParent_Done,
     /* 130791 */   // Label 2282: @130791
     /* 130791 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(130871), // Rule ID 4185 //
     /* 130796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 130818 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 130825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130870 */     // GIR_Coverage, 4185,
     /* 130870 */     GIR_EraseRootFromParent_Done,
     /* 130871 */   // Label 2283: @130871
     /* 130871 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(130951), // Rule ID 4186 //
     /* 130876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130898 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 130905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130920 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130950 */     // GIR_Coverage, 4186,
     /* 130950 */     GIR_EraseRootFromParent_Done,
     /* 130951 */   // Label 2284: @130951
     /* 130951 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(131031), // Rule ID 4187 //
     /* 130956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130978 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 130985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131000 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131030 */     // GIR_Coverage, 4187,
     /* 131030 */     GIR_EraseRootFromParent_Done,
     /* 131031 */   // Label 2285: @131031
     /* 131031 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(131111), // Rule ID 4188 //
     /* 131036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131058 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 131065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131080 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131110 */     // GIR_Coverage, 4188,
     /* 131110 */     GIR_EraseRootFromParent_Done,
     /* 131111 */   // Label 2286: @131111
     /* 131111 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(131191), // Rule ID 4189 //
     /* 131116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131138 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 131145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131190 */     // GIR_Coverage, 4189,
     /* 131190 */     GIR_EraseRootFromParent_Done,
     /* 131191 */   // Label 2287: @131191
     /* 131191 */   GIM_Reject,
     /* 131192 */ // Label 2269: @131192
     /* 131192 */ GIM_Reject,
     /* 131193 */ // Label 2238: @131193
     /* 131193 */ GIM_Reject,
     /* 131194 */ // Label 19: @131194
     /* 131194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2308*/ GIMT_Encode4(144719),
     /* 131205 */ /*GILLT_s8*//*Label 2288*/ GIMT_Encode4(131301),
     /* 131209 */ /*GILLT_s16*//*Label 2289*/ GIMT_Encode4(131668),
     /* 131213 */ /*GILLT_s32*//*Label 2290*/ GIMT_Encode4(132807),
     /* 131217 */ /*GILLT_s64*//*Label 2291*/ GIMT_Encode4(137402),
     /* 131221 */ /*GILLT_s128*//*Label 2292*/ GIMT_Encode4(141171),
     /* 131225 */ /*GILLT_v2s32*//*Label 2293*/ GIMT_Encode4(141377),
     /* 131229 */ /*GILLT_v2s64*//*Label 2294*/ GIMT_Encode4(141783),
     /* 131233 */ /*GILLT_v4s16*//*Label 2295*/ GIMT_Encode4(142233),
     /* 131237 */ /*GILLT_v4s32*//*Label 2296*/ GIMT_Encode4(142639),
     /* 131241 */ /*GILLT_v8s8*//*Label 2297*/ GIMT_Encode4(143045),
     /* 131245 */ /*GILLT_v8s16*//*Label 2298*/ GIMT_Encode4(143265),
     /* 131249 */ /*GILLT_v16s8*//*Label 2299*/ GIMT_Encode4(143671), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131261 */ /*GILLT_nxv2s16*//*Label 2300*/ GIMT_Encode4(143891),
     /* 131265 */ /*GILLT_nxv2s32*//*Label 2301*/ GIMT_Encode4(143951),
     /* 131269 */ /*GILLT_nxv2s64*//*Label 2302*/ GIMT_Encode4(144011), GIMT_Encode4(0),
     /* 131277 */ /*GILLT_nxv4s16*//*Label 2303*/ GIMT_Encode4(144181),
     /* 131281 */ /*GILLT_nxv4s32*//*Label 2304*/ GIMT_Encode4(144241), GIMT_Encode4(0),
     /* 131289 */ /*GILLT_nxv8s16*//*Label 2305*/ GIMT_Encode4(144411),
     /* 131293 */ /*GILLT_nxv16s1*//*Label 2306*/ GIMT_Encode4(144581),
     /* 131297 */ /*GILLT_nxv16s8*//*Label 2307*/ GIMT_Encode4(144625),
     /* 131301 */ // Label 2288: @131301
     /* 131301 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(131667),
     /* 131306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131313 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(131381), // Rule ID 13278 //
     /* 131318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 131330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131351 */     // MIs[2] Operand 1
     /* 131351 */     // No operand predicates
     /* 131351 */     // MIs[0] Rn
     /* 131351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131361 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131379 */     GIR_RootConstrainSelectedInstOperands,
     /* 131380 */     // GIR_Coverage, 13278,
     /* 131380 */     GIR_EraseRootFromParent_Done,
     /* 131381 */   // Label 2310: @131381
     /* 131381 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(131480), // Rule ID 13279 //
     /* 131386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 131398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131419 */     // MIs[2] Operand 1
     /* 131419 */     // No operand predicates
     /* 131419 */     // MIs[0] Rn
     /* 131419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131429 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 131432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 131444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131478 */     GIR_RootConstrainSelectedInstOperands,
     /* 131479 */     // GIR_Coverage, 13279,
     /* 131479 */     GIR_EraseRootFromParent_Done,
     /* 131480 */   // Label 2311: @131480
     /* 131480 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(131529), // Rule ID 303 //
     /* 131485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 131503 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 131503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 131506 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131527 */     GIR_RootConstrainSelectedInstOperands,
     /* 131528 */     // GIR_Coverage, 303,
     /* 131528 */     GIR_EraseRootFromParent_Done,
     /* 131529 */   // Label 2312: @131529
     /* 131529 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(131578), // Rule ID 304 //
     /* 131534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 131552 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 131552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 131555 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131576 */     GIR_RootConstrainSelectedInstOperands,
     /* 131577 */     // GIR_Coverage, 304,
     /* 131577 */     GIR_EraseRootFromParent_Done,
     /* 131578 */   // Label 2313: @131578
     /* 131578 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131622), // Rule ID 313 //
     /* 131583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 131601 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 131601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 131604 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131620 */     GIR_RootConstrainSelectedInstOperands,
     /* 131621 */     // GIR_Coverage, 313,
     /* 131621 */     GIR_EraseRootFromParent_Done,
     /* 131622 */   // Label 2314: @131622
     /* 131622 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131666), // Rule ID 321 //
     /* 131627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131645 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 131645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 131648 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131664 */     GIR_RootConstrainSelectedInstOperands,
     /* 131665 */     // GIR_Coverage, 321,
     /* 131665 */     GIR_EraseRootFromParent_Done,
     /* 131666 */   // Label 2315: @131666
     /* 131666 */   GIM_Reject,
     /* 131667 */ // Label 2309: @131667
     /* 131667 */ GIM_Reject,
     /* 131668 */ // Label 2289: @131668
     /* 131668 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(132806),
     /* 131673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131680 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131779), // Rule ID 4522 //
     /* 131685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131723 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131777 */     GIR_RootConstrainSelectedInstOperands,
     /* 131778 */     // GIR_Coverage, 4522,
     /* 131778 */     GIR_EraseRootFromParent_Done,
     /* 131779 */   // Label 2317: @131779
     /* 131779 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131878), // Rule ID 4523 //
     /* 131784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131822 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131834 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131876 */     GIR_RootConstrainSelectedInstOperands,
     /* 131877 */     // GIR_Coverage, 4523,
     /* 131877 */     GIR_EraseRootFromParent_Done,
     /* 131878 */   // Label 2318: @131878
     /* 131878 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131977), // Rule ID 13276 //
     /* 131883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131921 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131975 */     GIR_RootConstrainSelectedInstOperands,
     /* 131976 */     // GIR_Coverage, 13276,
     /* 131976 */     GIR_EraseRootFromParent_Done,
     /* 131977 */   // Label 2319: @131977
     /* 131977 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(132076), // Rule ID 13277 //
     /* 131982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132020 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132074 */     GIR_RootConstrainSelectedInstOperands,
     /* 132075 */     // GIR_Coverage, 13277,
     /* 132075 */     GIR_EraseRootFromParent_Done,
     /* 132076 */   // Label 2320: @132076
     /* 132076 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(132170), // Rule ID 4551 //
     /* 132081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132119 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132168 */     GIR_RootConstrainSelectedInstOperands,
     /* 132169 */     // GIR_Coverage, 4551,
     /* 132169 */     GIR_EraseRootFromParent_Done,
     /* 132170 */   // Label 2321: @132170
     /* 132170 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132264), // Rule ID 4578 //
     /* 132175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132213 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132262 */     GIR_RootConstrainSelectedInstOperands,
     /* 132263 */     // GIR_Coverage, 4578,
     /* 132263 */     GIR_EraseRootFromParent_Done,
     /* 132264 */   // Label 2322: @132264
     /* 132264 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132358), // Rule ID 13275 //
     /* 132269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132307 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132356 */     GIR_RootConstrainSelectedInstOperands,
     /* 132357 */     // GIR_Coverage, 13275,
     /* 132357 */     GIR_EraseRootFromParent_Done,
     /* 132358 */   // Label 2323: @132358
     /* 132358 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132452), // Rule ID 13281 //
     /* 132363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132401 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132413 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132450 */     GIR_RootConstrainSelectedInstOperands,
     /* 132451 */     // GIR_Coverage, 13281,
     /* 132451 */     GIR_EraseRootFromParent_Done,
     /* 132452 */   // Label 2324: @132452
     /* 132452 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132520), // Rule ID 6512 //
     /* 132457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132490 */     // MIs[2] Operand 1
     /* 132490 */     // No operand predicates
     /* 132490 */     // MIs[0] Rn
     /* 132490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132500 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132518 */     GIR_RootConstrainSelectedInstOperands,
     /* 132519 */     // GIR_Coverage, 6512,
     /* 132519 */     GIR_EraseRootFromParent_Done,
     /* 132520 */   // Label 2325: @132520
     /* 132520 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132619), // Rule ID 6517 //
     /* 132525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132558 */     // MIs[2] Operand 1
     /* 132558 */     // No operand predicates
     /* 132558 */     // MIs[0] Rn
     /* 132558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132568 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 132571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 132575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 132583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 132590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132617 */     GIR_RootConstrainSelectedInstOperands,
     /* 132618 */     // GIR_Coverage, 6517,
     /* 132618 */     GIR_EraseRootFromParent_Done,
     /* 132619 */   // Label 2326: @132619
     /* 132619 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132668), // Rule ID 305 //
     /* 132624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132642 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132645 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132666 */     GIR_RootConstrainSelectedInstOperands,
     /* 132667 */     // GIR_Coverage, 305,
     /* 132667 */     GIR_EraseRootFromParent_Done,
     /* 132668 */   // Label 2327: @132668
     /* 132668 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132717), // Rule ID 306 //
     /* 132673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132691 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132694 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132715 */     GIR_RootConstrainSelectedInstOperands,
     /* 132716 */     // GIR_Coverage, 306,
     /* 132716 */     GIR_EraseRootFromParent_Done,
     /* 132717 */   // Label 2328: @132717
     /* 132717 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132761), // Rule ID 314 //
     /* 132722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132740 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132743 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132759 */     GIR_RootConstrainSelectedInstOperands,
     /* 132760 */     // GIR_Coverage, 314,
     /* 132760 */     GIR_EraseRootFromParent_Done,
     /* 132761 */   // Label 2329: @132761
     /* 132761 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132805), // Rule ID 322 //
     /* 132766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 132784 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 132784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132787 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132803 */     GIR_RootConstrainSelectedInstOperands,
     /* 132804 */     // GIR_Coverage, 322,
     /* 132804 */     GIR_EraseRootFromParent_Done,
     /* 132805 */   // Label 2330: @132805
     /* 132805 */   GIM_Reject,
     /* 132806 */ // Label 2316: @132806
     /* 132806 */ GIM_Reject,
     /* 132807 */ // Label 2290: @132807
     /* 132807 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(132920), // Rule ID 4520 //
     /* 132812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132826 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132830 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132834 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132838 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132847 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132851 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132864 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132876 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132918 */   GIR_RootConstrainSelectedInstOperands,
     /* 132919 */   // GIR_Coverage, 4520,
     /* 132919 */   GIR_EraseRootFromParent_Done,
     /* 132920 */ // Label 2331: @132920
     /* 132920 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133033), // Rule ID 4521 //
     /* 132925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132928 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132932 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132947 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132951 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132977 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132989 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 133008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133031 */   GIR_RootConstrainSelectedInstOperands,
     /* 133032 */   // GIR_Coverage, 4521,
     /* 133032 */   GIR_EraseRootFromParent_Done,
     /* 133033 */ // Label 2332: @133033
     /* 133033 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133139), // Rule ID 4524 //
     /* 133038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133041 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133053 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133057 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133061 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133066 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133083 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133095 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133137 */   GIR_RootConstrainSelectedInstOperands,
     /* 133138 */   // GIR_Coverage, 4524,
     /* 133138 */   GIR_EraseRootFromParent_Done,
     /* 133139 */ // Label 2333: @133139
     /* 133139 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133245), // Rule ID 4525 //
     /* 133144 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133159 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133163 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133167 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133172 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133182 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133189 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133201 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133243 */   GIR_RootConstrainSelectedInstOperands,
     /* 133244 */   // GIR_Coverage, 4525,
     /* 133244 */   GIR_EraseRootFromParent_Done,
     /* 133245 */ // Label 2334: @133245
     /* 133245 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133351), // Rule ID 4526 //
     /* 133250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133265 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133273 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133278 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133286 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133295 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133307 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133318 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133349 */   GIR_RootConstrainSelectedInstOperands,
     /* 133350 */   // GIR_Coverage, 4526,
     /* 133350 */   GIR_EraseRootFromParent_Done,
     /* 133351 */ // Label 2335: @133351
     /* 133351 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133457), // Rule ID 4527 //
     /* 133356 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133359 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133371 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133375 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133384 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133388 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133394 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133401 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133413 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133455 */   GIR_RootConstrainSelectedInstOperands,
     /* 133456 */   // GIR_Coverage, 4527,
     /* 133456 */   GIR_EraseRootFromParent_Done,
     /* 133457 */ // Label 2336: @133457
     /* 133457 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133563), // Rule ID 13283 //
     /* 133462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133465 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133481 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133490 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133498 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133500 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133507 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133519 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133561 */   GIR_RootConstrainSelectedInstOperands,
     /* 133562 */   // GIR_Coverage, 13283,
     /* 133562 */   GIR_EraseRootFromParent_Done,
     /* 133563 */ // Label 2337: @133563
     /* 133563 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133669), // Rule ID 13284 //
     /* 133568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133571 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133583 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133591 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133596 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133613 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133625 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133667 */   GIR_RootConstrainSelectedInstOperands,
     /* 133668 */   // GIR_Coverage, 13284,
     /* 133668 */   GIR_EraseRootFromParent_Done,
     /* 133669 */ // Label 2338: @133669
     /* 133669 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133777), // Rule ID 4550 //
     /* 133674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133677 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133709 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 133726 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 133726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 133729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133738 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 133744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 133757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133775 */   GIR_RootConstrainSelectedInstOperands,
     /* 133776 */   // GIR_Coverage, 4550,
     /* 133776 */   GIR_EraseRootFromParent_Done,
     /* 133777 */ // Label 2339: @133777
     /* 133777 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133878), // Rule ID 4552 //
     /* 133782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133810 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133820 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 133827 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 133827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133839 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 133858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133876 */   GIR_RootConstrainSelectedInstOperands,
     /* 133877 */   // GIR_Coverage, 4552,
     /* 133877 */   GIR_EraseRootFromParent_Done,
     /* 133878 */ // Label 2340: @133878
     /* 133878 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133979), // Rule ID 4553 //
     /* 133883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133902 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133906 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133911 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133919 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 133928 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 133928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133940 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 133959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133977 */   GIR_RootConstrainSelectedInstOperands,
     /* 133978 */   // GIR_Coverage, 4553,
     /* 133978 */   GIR_EraseRootFromParent_Done,
     /* 133979 */ // Label 2341: @133979
     /* 133979 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(134087), // Rule ID 4577 //
     /* 133984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133987 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134006 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134010 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134014 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134019 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134036 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 134039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134048 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 134054 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 134067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134085 */   GIR_RootConstrainSelectedInstOperands,
     /* 134086 */   // GIR_Coverage, 4577,
     /* 134086 */   GIR_EraseRootFromParent_Done,
     /* 134087 */ // Label 2342: @134087
     /* 134087 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(134188), // Rule ID 4579 //
     /* 134092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134115 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134120 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134137 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134149 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134160 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134186 */   GIR_RootConstrainSelectedInstOperands,
     /* 134187 */   // GIR_Coverage, 4579,
     /* 134187 */   GIR_EraseRootFromParent_Done,
     /* 134188 */ // Label 2343: @134188
     /* 134188 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(134289), // Rule ID 4580 //
     /* 134193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134208 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134212 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134216 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134221 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134238 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134250 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134256 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134261 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134287 */   GIR_RootConstrainSelectedInstOperands,
     /* 134288 */   // GIR_Coverage, 4580,
     /* 134288 */   GIR_EraseRootFromParent_Done,
     /* 134289 */ // Label 2344: @134289
     /* 134289 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134390), // Rule ID 13280 //
     /* 134294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134309 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134313 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134317 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134322 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134339 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134351 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134388 */   GIR_RootConstrainSelectedInstOperands,
     /* 134389 */   // GIR_Coverage, 13280,
     /* 134389 */   GIR_EraseRootFromParent_Done,
     /* 134390 */ // Label 2345: @134390
     /* 134390 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134491), // Rule ID 13282 //
     /* 134395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134410 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134414 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134423 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 134440 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134452 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134489 */   GIR_RootConstrainSelectedInstOperands,
     /* 134490 */   // GIR_Coverage, 13282,
     /* 134490 */   GIR_EraseRootFromParent_Done,
     /* 134491 */ // Label 2346: @134491
     /* 134491 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134573), // Rule ID 6506 //
     /* 134496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134499 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134503 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134518 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 134522 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134539 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 134543 */   // MIs[2] Operand 1
     /* 134543 */   // No operand predicates
     /* 134543 */   // MIs[0] Rn
     /* 134543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134551 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134553 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 134556 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134560 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134563 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134571 */   GIR_RootConstrainSelectedInstOperands,
     /* 134572 */   // GIR_Coverage, 6506,
     /* 134572 */   GIR_EraseRootFromParent_Done,
     /* 134573 */ // Label 2347: @134573
     /* 134573 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134655), // Rule ID 6507 //
     /* 134578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134581 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134608 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134613 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134621 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 134625 */   // MIs[2] Operand 1
     /* 134625 */   // No operand predicates
     /* 134625 */   // MIs[0] Rn
     /* 134625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134633 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134635 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 134638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134642 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134645 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134653 */   GIR_RootConstrainSelectedInstOperands,
     /* 134654 */   // GIR_Coverage, 6507,
     /* 134654 */   GIR_EraseRootFromParent_Done,
     /* 134655 */ // Label 2348: @134655
     /* 134655 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134730), // Rule ID 6508 //
     /* 134660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134679 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134683 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134688 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134692 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134696 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 134700 */   // MIs[2] Operand 1
     /* 134700 */   // No operand predicates
     /* 134700 */   // MIs[0] Rn
     /* 134700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134708 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134710 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 134713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134717 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134720 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134728 */   GIR_RootConstrainSelectedInstOperands,
     /* 134729 */   // GIR_Coverage, 6508,
     /* 134729 */   GIR_EraseRootFromParent_Done,
     /* 134730 */ // Label 2349: @134730
     /* 134730 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134805), // Rule ID 6509 //
     /* 134735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134754 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134763 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134767 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134771 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 134775 */   // MIs[2] Operand 1
     /* 134775 */   // No operand predicates
     /* 134775 */   // MIs[0] Rn
     /* 134775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134783 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134785 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 134788 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134792 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134795 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134803 */   GIR_RootConstrainSelectedInstOperands,
     /* 134804 */   // GIR_Coverage, 6509,
     /* 134804 */   GIR_EraseRootFromParent_Done,
     /* 134805 */ // Label 2350: @134805
     /* 134805 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134918), // Rule ID 6513 //
     /* 134810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134813 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134817 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134832 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 134836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134840 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134845 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134849 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134853 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 134857 */   // MIs[2] Operand 1
     /* 134857 */   // No operand predicates
     /* 134857 */   // MIs[0] Rn
     /* 134857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134865 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134867 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 134870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 134874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134879 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 134882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134886 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 134889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 134902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134905 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134916 */   GIR_RootConstrainSelectedInstOperands,
     /* 134917 */   // GIR_Coverage, 6513,
     /* 134917 */   GIR_EraseRootFromParent_Done,
     /* 134918 */ // Label 2351: @134918
     /* 134918 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(135031), // Rule ID 6514 //
     /* 134923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 134949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134958 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134962 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134966 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 134970 */   // MIs[2] Operand 1
     /* 134970 */   // No operand predicates
     /* 134970 */   // MIs[0] Rn
     /* 134970 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134978 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134980 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 134983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 134987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134992 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 134995 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134999 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 135015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135018 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135021 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135029 */   GIR_RootConstrainSelectedInstOperands,
     /* 135030 */   // GIR_Coverage, 6514,
     /* 135030 */   GIR_EraseRootFromParent_Done,
     /* 135031 */ // Label 2352: @135031
     /* 135031 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(135137), // Rule ID 6515 //
     /* 135036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135039 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135043 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135051 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135055 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135064 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135068 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135072 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135076 */   // MIs[2] Operand 1
     /* 135076 */   // No operand predicates
     /* 135076 */   // MIs[0] Rn
     /* 135076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135084 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135086 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135098 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135105 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135124 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135127 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135135 */   GIR_RootConstrainSelectedInstOperands,
     /* 135136 */   // GIR_Coverage, 6515,
     /* 135136 */   GIR_EraseRootFromParent_Done,
     /* 135137 */ // Label 2353: @135137
     /* 135137 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(135243), // Rule ID 6516 //
     /* 135142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135145 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135149 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135157 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135161 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135165 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135170 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135174 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135178 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135182 */   // MIs[2] Operand 1
     /* 135182 */   // No operand predicates
     /* 135182 */   // MIs[0] Rn
     /* 135182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135190 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135192 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135204 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135211 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135230 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135233 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135241 */   GIR_RootConstrainSelectedInstOperands,
     /* 135242 */   // GIR_Coverage, 6516,
     /* 135242 */   GIR_EraseRootFromParent_Done,
     /* 135243 */ // Label 2354: @135243
     /* 135243 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(135303), // Rule ID 295 //
     /* 135248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135251 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135255 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135270 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 135277 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 135277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 135280 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135301 */   GIR_RootConstrainSelectedInstOperands,
     /* 135302 */   // GIR_Coverage, 295,
     /* 135302 */   GIR_EraseRootFromParent_Done,
     /* 135303 */ // Label 2355: @135303
     /* 135303 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(135363), // Rule ID 296 //
     /* 135308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135311 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 135337 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 135337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 135340 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135361 */   GIR_RootConstrainSelectedInstOperands,
     /* 135362 */   // GIR_Coverage, 296,
     /* 135362 */   GIR_EraseRootFromParent_Done,
     /* 135363 */ // Label 2356: @135363
     /* 135363 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(135423), // Rule ID 297 //
     /* 135368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 135397 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 135397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 135400 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135421 */   GIR_RootConstrainSelectedInstOperands,
     /* 135422 */   // GIR_Coverage, 297,
     /* 135422 */   GIR_EraseRootFromParent_Done,
     /* 135423 */ // Label 2357: @135423
     /* 135423 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(135483), // Rule ID 298 //
     /* 135428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135431 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135435 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135450 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 135457 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 135457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 135460 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135481 */   GIR_RootConstrainSelectedInstOperands,
     /* 135482 */   // GIR_Coverage, 298,
     /* 135482 */   GIR_EraseRootFromParent_Done,
     /* 135483 */ // Label 2358: @135483
     /* 135483 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(135536), // Rule ID 299 //
     /* 135488 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135491 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135510 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 135513 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135534 */   GIR_RootConstrainSelectedInstOperands,
     /* 135535 */   // GIR_Coverage, 299,
     /* 135535 */   GIR_EraseRootFromParent_Done,
     /* 135536 */ // Label 2359: @135536
     /* 135536 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135589), // Rule ID 300 //
     /* 135541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 135563 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 135563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 135566 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135587 */   GIR_RootConstrainSelectedInstOperands,
     /* 135588 */   // GIR_Coverage, 300,
     /* 135588 */   GIR_EraseRootFromParent_Done,
     /* 135589 */ // Label 2360: @135589
     /* 135589 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135645), // Rule ID 307 //
     /* 135594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135619 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 135622 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135643 */   GIR_RootConstrainSelectedInstOperands,
     /* 135644 */   // GIR_Coverage, 307,
     /* 135644 */   GIR_EraseRootFromParent_Done,
     /* 135645 */ // Label 2361: @135645
     /* 135645 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135701), // Rule ID 308 //
     /* 135650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 135675 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 135675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 135678 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135699 */   GIR_RootConstrainSelectedInstOperands,
     /* 135700 */   // GIR_Coverage, 308,
     /* 135700 */   GIR_EraseRootFromParent_Done,
     /* 135701 */ // Label 2362: @135701
     /* 135701 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135753), // Rule ID 312 //
     /* 135706 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135709 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135721 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135728 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 135731 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135751 */   GIR_RootConstrainSelectedInstOperands,
     /* 135752 */   // GIR_Coverage, 312,
     /* 135752 */   GIR_EraseRootFromParent_Done,
     /* 135753 */ // Label 2363: @135753
     /* 135753 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135804), // Rule ID 315 //
     /* 135758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135783 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 135786 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135802 */   GIR_RootConstrainSelectedInstOperands,
     /* 135803 */   // GIR_Coverage, 315,
     /* 135803 */   GIR_EraseRootFromParent_Done,
     /* 135804 */ // Label 2364: @135804
     /* 135804 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135863), // Rule ID 317 //
     /* 135809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 135838 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 135838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 135841 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135857 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135861 */   GIR_RootConstrainSelectedInstOperands,
     /* 135862 */   // GIR_Coverage, 317,
     /* 135862 */   GIR_EraseRootFromParent_Done,
     /* 135863 */ // Label 2365: @135863
     /* 135863 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135922), // Rule ID 318 //
     /* 135868 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135871 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135875 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 135897 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 135897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 135900 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135920 */   GIR_RootConstrainSelectedInstOperands,
     /* 135921 */   // GIR_Coverage, 318,
     /* 135921 */   GIR_EraseRootFromParent_Done,
     /* 135922 */ // Label 2366: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135999), // Rule ID 7139 //
     /* 135927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135937 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 135948 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 135952 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135970 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 135973 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135997 */   GIR_RootConstrainSelectedInstOperands,
     /* 135998 */   // GIR_Coverage, 7139,
     /* 135998 */   GIR_EraseRootFromParent_Done,
     /* 135999 */ // Label 2367: @135999
     /* 135999 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(136076), // Rule ID 7140 //
     /* 136004 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136007 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136014 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136029 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136038 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136047 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 136050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136074 */   GIR_RootConstrainSelectedInstOperands,
     /* 136075 */   // GIR_Coverage, 7140,
     /* 136075 */   GIR_EraseRootFromParent_Done,
     /* 136076 */ // Label 2368: @136076
     /* 136076 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(136135), // Rule ID 7120 //
     /* 136081 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136091 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136098 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 136109 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15896>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 136109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 136112 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136133 */   GIR_RootConstrainSelectedInstOperands,
     /* 136134 */   // GIR_Coverage, 7120,
     /* 136134 */   GIR_EraseRootFromParent_Done,
     /* 136135 */ // Label 2369: @136135
     /* 136135 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(136194), // Rule ID 7121 //
     /* 136140 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136143 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136150 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 136168 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15896>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 136168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 136171 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136192 */   GIR_RootConstrainSelectedInstOperands,
     /* 136193 */   // GIR_Coverage, 7121,
     /* 136193 */   GIR_EraseRootFromParent_Done,
     /* 136194 */ // Label 2370: @136194
     /* 136194 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(136253), // Rule ID 7125 //
     /* 136199 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136209 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136220 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 136227 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15903>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 136227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 136230 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136251 */   GIR_RootConstrainSelectedInstOperands,
     /* 136252 */   // GIR_Coverage, 7125,
     /* 136252 */   GIR_EraseRootFromParent_Done,
     /* 136253 */ // Label 2371: @136253
     /* 136253 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(136312), // Rule ID 7126 //
     /* 136258 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136268 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136279 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 136286 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15903>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 136286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 136289 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136310 */   GIR_RootConstrainSelectedInstOperands,
     /* 136311 */   // GIR_Coverage, 7126,
     /* 136311 */   GIR_EraseRootFromParent_Done,
     /* 136312 */ // Label 2372: @136312
     /* 136312 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(136371), // Rule ID 7130 //
     /* 136317 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136327 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 136345 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 136345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 136348 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136369 */   GIR_RootConstrainSelectedInstOperands,
     /* 136370 */   // GIR_Coverage, 7130,
     /* 136370 */   GIR_EraseRootFromParent_Done,
     /* 136371 */ // Label 2373: @136371
     /* 136371 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(136430), // Rule ID 7131 //
     /* 136376 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136379 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136386 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136404 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 136407 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136428 */   GIR_RootConstrainSelectedInstOperands,
     /* 136429 */   // GIR_Coverage, 7131,
     /* 136429 */   GIR_EraseRootFromParent_Done,
     /* 136430 */ // Label 2374: @136430
     /* 136430 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(136502), // Rule ID 7141 //
     /* 136435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136445 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136456 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136460 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 136478 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 136478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 136481 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136500 */   GIR_RootConstrainSelectedInstOperands,
     /* 136501 */   // GIR_Coverage, 7141,
     /* 136501 */   GIR_EraseRootFromParent_Done,
     /* 136502 */ // Label 2375: @136502
     /* 136502 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(136574), // Rule ID 7142 //
     /* 136507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136517 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136532 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136550 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 136553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136567 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136572 */   GIR_RootConstrainSelectedInstOperands,
     /* 136573 */   // GIR_Coverage, 7142,
     /* 136573 */   GIR_EraseRootFromParent_Done,
     /* 136574 */ // Label 2376: @136574
     /* 136574 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(136626), // Rule ID 320 //
     /* 136579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136601 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 136604 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136624 */   GIR_RootConstrainSelectedInstOperands,
     /* 136625 */   // GIR_Coverage, 320,
     /* 136625 */   GIR_EraseRootFromParent_Done,
     /* 136626 */ // Label 2377: @136626
     /* 136626 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136677), // Rule ID 323 //
     /* 136631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136656 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 136659 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136675 */   GIR_RootConstrainSelectedInstOperands,
     /* 136676 */   // GIR_Coverage, 323,
     /* 136676 */   GIR_EraseRootFromParent_Done,
     /* 136677 */ // Label 2378: @136677
     /* 136677 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136736), // Rule ID 326 //
     /* 136682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136685 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 136711 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 136714 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136734 */   GIR_RootConstrainSelectedInstOperands,
     /* 136735 */   // GIR_Coverage, 326,
     /* 136735 */   GIR_EraseRootFromParent_Done,
     /* 136736 */ // Label 2379: @136736
     /* 136736 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136795), // Rule ID 327 //
     /* 136741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136744 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 136770 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 136773 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136793 */   GIR_RootConstrainSelectedInstOperands,
     /* 136794 */   // GIR_Coverage, 327,
     /* 136794 */   GIR_EraseRootFromParent_Done,
     /* 136795 */ // Label 2380: @136795
     /* 136795 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136849), // Rule ID 7122 //
     /* 136800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 136828 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15896>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 136828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 136831 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136847 */   GIR_RootConstrainSelectedInstOperands,
     /* 136848 */   // GIR_Coverage, 7122,
     /* 136848 */   GIR_EraseRootFromParent_Done,
     /* 136849 */ // Label 2381: @136849
     /* 136849 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136903), // Rule ID 7123 //
     /* 136854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 136882 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15896>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 136885 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136901 */   GIR_RootConstrainSelectedInstOperands,
     /* 136902 */   // GIR_Coverage, 7123,
     /* 136902 */   GIR_EraseRootFromParent_Done,
     /* 136903 */ // Label 2382: @136903
     /* 136903 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136957), // Rule ID 7127 //
     /* 136908 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136911 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136918 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 136936 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15903>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 136936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 136939 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136955 */   GIR_RootConstrainSelectedInstOperands,
     /* 136956 */   // GIR_Coverage, 7127,
     /* 136956 */   GIR_EraseRootFromParent_Done,
     /* 136957 */ // Label 2383: @136957
     /* 136957 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(137011), // Rule ID 7128 //
     /* 136962 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136965 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136972 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 136990 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15903>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 136993 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137009 */   GIR_RootConstrainSelectedInstOperands,
     /* 137010 */   // GIR_Coverage, 7128,
     /* 137010 */   GIR_EraseRootFromParent_Done,
     /* 137011 */ // Label 2384: @137011
     /* 137011 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(137065), // Rule ID 7132 //
     /* 137016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137026 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 137044 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 137044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 137047 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137063 */   GIR_RootConstrainSelectedInstOperands,
     /* 137064 */   // GIR_Coverage, 7132,
     /* 137064 */   GIR_EraseRootFromParent_Done,
     /* 137065 */ // Label 2385: @137065
     /* 137065 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(137119), // Rule ID 7133 //
     /* 137070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137080 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137098 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15910>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 137101 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137117 */   GIR_RootConstrainSelectedInstOperands,
     /* 137118 */   // GIR_Coverage, 7133,
     /* 137118 */   GIR_EraseRootFromParent_Done,
     /* 137119 */ // Label 2386: @137119
     /* 137119 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(137176), // Rule ID 7495 //
     /* 137124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137127 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137137 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 137155 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15894>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 137158 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137174 */   GIR_RootConstrainSelectedInstOperands,
     /* 137175 */   // GIR_Coverage, 7495,
     /* 137175 */   GIR_EraseRootFromParent_Done,
     /* 137176 */ // Label 2387: @137176
     /* 137176 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(137233), // Rule ID 7496 //
     /* 137181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137184 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 137212 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15901>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 137215 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137231 */   GIR_RootConstrainSelectedInstOperands,
     /* 137232 */   // GIR_Coverage, 7496,
     /* 137232 */   GIR_EraseRootFromParent_Done,
     /* 137233 */ // Label 2388: @137233
     /* 137233 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137290), // Rule ID 7497 //
     /* 137238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137251 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137269 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15908>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 137272 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137288 */   GIR_RootConstrainSelectedInstOperands,
     /* 137289 */   // GIR_Coverage, 7497,
     /* 137289 */   GIR_EraseRootFromParent_Done,
     /* 137290 */ // Label 2389: @137290
     /* 137290 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137327), // Rule ID 7119 //
     /* 137295 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137305 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137312 */   // MIs[0] ptr
     /* 137312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137320 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15894>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 137325 */   GIR_RootConstrainSelectedInstOperands,
     /* 137326 */   // GIR_Coverage, 7119,
     /* 137326 */   GIR_Done,
     /* 137327 */ // Label 2390: @137327
     /* 137327 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137364), // Rule ID 7124 //
     /* 137332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137342 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137349 */   // MIs[0] ptr
     /* 137349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137357 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15901>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 137362 */   GIR_RootConstrainSelectedInstOperands,
     /* 137363 */   // GIR_Coverage, 7124,
     /* 137363 */   GIR_Done,
     /* 137364 */ // Label 2391: @137364
     /* 137364 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137401), // Rule ID 7129 //
     /* 137369 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137379 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137386 */   // MIs[0] ptr
     /* 137386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137394 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15908>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 137399 */   GIR_RootConstrainSelectedInstOperands,
     /* 137400 */   // GIR_Coverage, 7129,
     /* 137400 */   GIR_Done,
     /* 137401 */ // Label 2392: @137401
     /* 137401 */ GIM_Reject,
     /* 137402 */ // Label 2291: @137402
     /* 137402 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137508), // Rule ID 4528 //
     /* 137407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137435 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137452 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137464 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137506 */   GIR_RootConstrainSelectedInstOperands,
     /* 137507 */   // GIR_Coverage, 4528,
     /* 137507 */   GIR_EraseRootFromParent_Done,
     /* 137508 */ // Label 2393: @137508
     /* 137508 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137614), // Rule ID 4529 //
     /* 137513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137516 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137532 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137536 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137541 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137549 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137551 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137558 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137570 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137612 */   GIR_RootConstrainSelectedInstOperands,
     /* 137613 */   // GIR_Coverage, 4529,
     /* 137613 */   GIR_EraseRootFromParent_Done,
     /* 137614 */ // Label 2394: @137614
     /* 137614 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137720), // Rule ID 4530 //
     /* 137619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137634 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137642 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137647 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137664 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137676 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137718 */   GIR_RootConstrainSelectedInstOperands,
     /* 137719 */   // GIR_Coverage, 4530,
     /* 137719 */   GIR_EraseRootFromParent_Done,
     /* 137720 */ // Label 2395: @137720
     /* 137720 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137826), // Rule ID 4531 //
     /* 137725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137744 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137748 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137770 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137782 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137824 */   GIR_RootConstrainSelectedInstOperands,
     /* 137825 */   // GIR_Coverage, 4531,
     /* 137825 */   GIR_EraseRootFromParent_Done,
     /* 137826 */ // Label 2396: @137826
     /* 137826 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137927), // Rule ID 4554 //
     /* 137831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137859 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137876 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137888 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137899 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137925 */   GIR_RootConstrainSelectedInstOperands,
     /* 137926 */   // GIR_Coverage, 4554,
     /* 137926 */   GIR_EraseRootFromParent_Done,
     /* 137927 */ // Label 2397: @137927
     /* 137927 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(138028), // Rule ID 4555 //
     /* 137932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137947 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137951 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137977 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137989 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138026 */   GIR_RootConstrainSelectedInstOperands,
     /* 138027 */   // GIR_Coverage, 4555,
     /* 138027 */   GIR_EraseRootFromParent_Done,
     /* 138028 */ // Label 2398: @138028
     /* 138028 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(138129), // Rule ID 4581 //
     /* 138033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138056 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138078 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138090 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138127 */   GIR_RootConstrainSelectedInstOperands,
     /* 138128 */   // GIR_Coverage, 4581,
     /* 138128 */   GIR_EraseRootFromParent_Done,
     /* 138129 */ // Label 2399: @138129
     /* 138129 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(138230), // Rule ID 4582 //
     /* 138134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138137 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138149 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138153 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138162 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138179 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138191 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138228 */   GIR_RootConstrainSelectedInstOperands,
     /* 138229 */   // GIR_Coverage, 4582,
     /* 138229 */   GIR_EraseRootFromParent_Done,
     /* 138230 */ // Label 2400: @138230
     /* 138230 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(138305), // Rule ID 6510 //
     /* 138235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138263 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138267 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138271 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138275 */   // MIs[2] Operand 1
     /* 138275 */   // No operand predicates
     /* 138275 */   // MIs[0] Rn
     /* 138275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138283 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138285 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138292 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138295 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138303 */   GIR_RootConstrainSelectedInstOperands,
     /* 138304 */   // GIR_Coverage, 6510,
     /* 138304 */   GIR_EraseRootFromParent_Done,
     /* 138305 */ // Label 2401: @138305
     /* 138305 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(138380), // Rule ID 6511 //
     /* 138310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138325 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138329 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138338 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138342 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138346 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138350 */   // MIs[2] Operand 1
     /* 138350 */   // No operand predicates
     /* 138350 */   // MIs[0] Rn
     /* 138350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138358 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138360 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138363 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138367 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138370 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138378 */   GIR_RootConstrainSelectedInstOperands,
     /* 138379 */   // GIR_Coverage, 6511,
     /* 138379 */   GIR_EraseRootFromParent_Done,
     /* 138380 */ // Label 2402: @138380
     /* 138380 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(138433), // Rule ID 301 //
     /* 138385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138407 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138410 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138431 */   GIR_RootConstrainSelectedInstOperands,
     /* 138432 */   // GIR_Coverage, 301,
     /* 138432 */   GIR_EraseRootFromParent_Done,
     /* 138433 */ // Label 2403: @138433
     /* 138433 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138486), // Rule ID 302 //
     /* 138438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138460 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138463 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138484 */   GIR_RootConstrainSelectedInstOperands,
     /* 138485 */   // GIR_Coverage, 302,
     /* 138485 */   GIR_EraseRootFromParent_Done,
     /* 138486 */ // Label 2404: @138486
     /* 138486 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138542), // Rule ID 309 //
     /* 138491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138516 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138519 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138540 */   GIR_RootConstrainSelectedInstOperands,
     /* 138541 */   // GIR_Coverage, 309,
     /* 138541 */   GIR_EraseRootFromParent_Done,
     /* 138542 */ // Label 2405: @138542
     /* 138542 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138598), // Rule ID 310 //
     /* 138547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138572 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138575 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138596 */   GIR_RootConstrainSelectedInstOperands,
     /* 138597 */   // GIR_Coverage, 310,
     /* 138597 */   GIR_EraseRootFromParent_Done,
     /* 138598 */ // Label 2406: @138598
     /* 138598 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138687), // Rule ID 4486 //
     /* 138603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 138632 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 138632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138644 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138650 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138655 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 138663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138685 */   GIR_RootConstrainSelectedInstOperands,
     /* 138686 */   // GIR_Coverage, 4486,
     /* 138686 */   GIR_EraseRootFromParent_Done,
     /* 138687 */ // Label 2407: @138687
     /* 138687 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138776), // Rule ID 4487 //
     /* 138692 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138695 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138699 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 138721 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 138721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138733 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 138752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138774 */   GIR_RootConstrainSelectedInstOperands,
     /* 138775 */   // GIR_Coverage, 4487,
     /* 138775 */   GIR_EraseRootFromParent_Done,
     /* 138776 */ // Label 2408: @138776
     /* 138776 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138865), // Rule ID 4488 //
     /* 138781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138784 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138788 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 138810 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 138810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138822 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 138841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138863 */   GIR_RootConstrainSelectedInstOperands,
     /* 138864 */   // GIR_Coverage, 4488,
     /* 138864 */   GIR_EraseRootFromParent_Done,
     /* 138865 */ // Label 2409: @138865
     /* 138865 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138954), // Rule ID 4489 //
     /* 138870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138873 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138888 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138892 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 138899 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 138899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138911 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138922 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 138930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138952 */   GIR_RootConstrainSelectedInstOperands,
     /* 138953 */   // GIR_Coverage, 4489,
     /* 138953 */   GIR_EraseRootFromParent_Done,
     /* 138954 */ // Label 2410: @138954
     /* 138954 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(139043), // Rule ID 4490 //
     /* 138959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138962 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 138988 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 138988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139000 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 139019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139041 */   GIR_RootConstrainSelectedInstOperands,
     /* 139042 */   // GIR_Coverage, 4490,
     /* 139042 */   GIR_EraseRootFromParent_Done,
     /* 139043 */ // Label 2411: @139043
     /* 139043 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(139132), // Rule ID 4491 //
     /* 139048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139051 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 139077 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 139077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139089 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139100 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 139108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139130 */   GIR_RootConstrainSelectedInstOperands,
     /* 139131 */   // GIR_Coverage, 4491,
     /* 139131 */   GIR_EraseRootFromParent_Done,
     /* 139132 */ // Label 2412: @139132
     /* 139132 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(139185), // Rule ID 4502 //
     /* 139137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139140 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139159 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139162 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139183 */   GIR_RootConstrainSelectedInstOperands,
     /* 139184 */   // GIR_Coverage, 4502,
     /* 139184 */   GIR_EraseRootFromParent_Done,
     /* 139185 */ // Label 2413: @139185
     /* 139185 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(139238), // Rule ID 4503 //
     /* 139190 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139212 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139215 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139236 */   GIR_RootConstrainSelectedInstOperands,
     /* 139237 */   // GIR_Coverage, 4503,
     /* 139237 */   GIR_EraseRootFromParent_Done,
     /* 139238 */ // Label 2414: @139238
     /* 139238 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(139291), // Rule ID 4504 //
     /* 139243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139265 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139268 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139289 */   GIR_RootConstrainSelectedInstOperands,
     /* 139290 */   // GIR_Coverage, 4504,
     /* 139290 */   GIR_EraseRootFromParent_Done,
     /* 139291 */ // Label 2415: @139291
     /* 139291 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(139344), // Rule ID 4505 //
     /* 139296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139318 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139321 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139342 */   GIR_RootConstrainSelectedInstOperands,
     /* 139343 */   // GIR_Coverage, 4505,
     /* 139343 */   GIR_EraseRootFromParent_Done,
     /* 139344 */ // Label 2416: @139344
     /* 139344 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(139396), // Rule ID 311 //
     /* 139349 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139352 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139371 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 139374 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 139380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139394 */   GIR_RootConstrainSelectedInstOperands,
     /* 139395 */   // GIR_Coverage, 311,
     /* 139395 */   GIR_EraseRootFromParent_Done,
     /* 139396 */ // Label 2417: @139396
     /* 139396 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(139447), // Rule ID 316 //
     /* 139401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139426 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139429 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139445 */   GIR_RootConstrainSelectedInstOperands,
     /* 139446 */   // GIR_Coverage, 316,
     /* 139446 */   GIR_EraseRootFromParent_Done,
     /* 139447 */ // Label 2418: @139447
     /* 139447 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139495), // Rule ID 4532 //
     /* 139452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139474 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139477 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139493 */   GIR_RootConstrainSelectedInstOperands,
     /* 139494 */   // GIR_Coverage, 4532,
     /* 139494 */   GIR_EraseRootFromParent_Done,
     /* 139495 */ // Label 2419: @139495
     /* 139495 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139543), // Rule ID 4533 //
     /* 139500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139522 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139525 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139541 */   GIR_RootConstrainSelectedInstOperands,
     /* 139542 */   // GIR_Coverage, 4533,
     /* 139542 */   GIR_EraseRootFromParent_Done,
     /* 139543 */ // Label 2420: @139543
     /* 139543 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139627), // Rule ID 4547 //
     /* 139548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139551 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139570 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 139577 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 139577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139589 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 139608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139621 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139625 */   GIR_RootConstrainSelectedInstOperands,
     /* 139626 */   // GIR_Coverage, 4547,
     /* 139626 */   GIR_EraseRootFromParent_Done,
     /* 139627 */ // Label 2421: @139627
     /* 139627 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139711), // Rule ID 4548 //
     /* 139632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139635 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139639 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 139661 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 139661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139673 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139684 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 139692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139709 */   GIR_RootConstrainSelectedInstOperands,
     /* 139710 */   // GIR_Coverage, 4548,
     /* 139710 */   GIR_EraseRootFromParent_Done,
     /* 139711 */ // Label 2422: @139711
     /* 139711 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139795), // Rule ID 4549 //
     /* 139716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139719 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139723 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 139745 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 139745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139757 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139763 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139768 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 139776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139793 */   GIR_RootConstrainSelectedInstOperands,
     /* 139794 */   // GIR_Coverage, 4549,
     /* 139794 */   GIR_EraseRootFromParent_Done,
     /* 139795 */ // Label 2423: @139795
     /* 139795 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139872), // Rule ID 7143 //
     /* 139800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139825 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139836 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139843 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139846 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 139850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139865 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139870 */   GIR_RootConstrainSelectedInstOperands,
     /* 139871 */   // GIR_Coverage, 7143,
     /* 139871 */   GIR_EraseRootFromParent_Done,
     /* 139872 */ // Label 2424: @139872
     /* 139872 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139949), // Rule ID 7144 //
     /* 139877 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139880 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139887 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139920 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139923 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 139927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139947 */   GIR_RootConstrainSelectedInstOperands,
     /* 139948 */   // GIR_Coverage, 7144,
     /* 139948 */   GIR_EraseRootFromParent_Done,
     /* 139949 */ // Label 2425: @139949
     /* 139949 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(140008), // Rule ID 7135 //
     /* 139954 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139957 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139964 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139975 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139982 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 139985 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140006 */   GIR_RootConstrainSelectedInstOperands,
     /* 140007 */   // GIR_Coverage, 7135,
     /* 140007 */   GIR_EraseRootFromParent_Done,
     /* 140008 */ // Label 2426: @140008
     /* 140008 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(140067), // Rule ID 7136 //
     /* 140013 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140016 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140023 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140041 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 140044 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140065 */   GIR_RootConstrainSelectedInstOperands,
     /* 140066 */   // GIR_Coverage, 7136,
     /* 140066 */   GIR_EraseRootFromParent_Done,
     /* 140067 */ // Label 2427: @140067
     /* 140067 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(140139), // Rule ID 7145 //
     /* 140072 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140082 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140093 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140097 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140108 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140115 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 140115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140118 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140137 */   GIR_RootConstrainSelectedInstOperands,
     /* 140138 */   // GIR_Coverage, 7145,
     /* 140138 */   GIR_EraseRootFromParent_Done,
     /* 140139 */ // Label 2428: @140139
     /* 140139 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(140211), // Rule ID 7146 //
     /* 140144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140147 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140154 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140165 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140180 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140187 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140190 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140209 */   GIR_RootConstrainSelectedInstOperands,
     /* 140210 */   // GIR_Coverage, 7146,
     /* 140210 */   GIR_EraseRootFromParent_Done,
     /* 140211 */ // Label 2429: @140211
     /* 140211 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(140308), // Rule ID 7487 //
     /* 140216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 140219 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140222 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140244 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 140248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 140252 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 140256 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140260 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140265 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 140269 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 140273 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 140277 */   // MIs[3] Operand 1
     /* 140277 */   // No operand predicates
     /* 140277 */   // MIs[0] Rn
     /* 140277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140285 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140287 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15915>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 140287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 140290 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 140294 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 140297 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140299 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 140306 */   GIR_RootConstrainSelectedInstOperands,
     /* 140307 */   // GIR_Coverage, 7487,
     /* 140307 */   GIR_EraseRootFromParent_Done,
     /* 140308 */ // Label 2430: @140308
     /* 140308 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(140360), // Rule ID 319 //
     /* 140313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140335 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140338 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 140344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140358 */   GIR_RootConstrainSelectedInstOperands,
     /* 140359 */   // GIR_Coverage, 319,
     /* 140359 */   GIR_EraseRootFromParent_Done,
     /* 140360 */ // Label 2431: @140360
     /* 140360 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(140411), // Rule ID 324 //
     /* 140365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140390 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140393 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140409 */   GIR_RootConstrainSelectedInstOperands,
     /* 140410 */   // GIR_Coverage, 324,
     /* 140410 */   GIR_EraseRootFromParent_Done,
     /* 140411 */ // Label 2432: @140411
     /* 140411 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(140465), // Rule ID 7137 //
     /* 140416 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140419 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140426 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140437 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140444 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 140447 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140459 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140463 */   GIR_RootConstrainSelectedInstOperands,
     /* 140464 */   // GIR_Coverage, 7137,
     /* 140464 */   GIR_EraseRootFromParent_Done,
     /* 140465 */ // Label 2433: @140465
     /* 140465 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(140519), // Rule ID 7138 //
     /* 140470 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140473 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140480 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140498 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15917>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140501 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140517 */   GIR_RootConstrainSelectedInstOperands,
     /* 140518 */   // GIR_Coverage, 7138,
     /* 140518 */   GIR_EraseRootFromParent_Done,
     /* 140519 */ // Label 2434: @140519
     /* 140519 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(140576), // Rule ID 7498 //
     /* 140524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 140527 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140537 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140555 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15915>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 140558 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140574 */   GIR_RootConstrainSelectedInstOperands,
     /* 140575 */   // GIR_Coverage, 7498,
     /* 140575 */   GIR_EraseRootFromParent_Done,
     /* 140576 */ // Label 2435: @140576
     /* 140576 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(140624), // Rule ID 4556 //
     /* 140581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140603 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140606 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140622 */   GIR_RootConstrainSelectedInstOperands,
     /* 140623 */   // GIR_Coverage, 4556,
     /* 140623 */   GIR_EraseRootFromParent_Done,
     /* 140624 */ // Label 2436: @140624
     /* 140624 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(140672), // Rule ID 4557 //
     /* 140629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140651 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140654 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140670 */   GIR_RootConstrainSelectedInstOperands,
     /* 140671 */   // GIR_Coverage, 4557,
     /* 140671 */   GIR_EraseRootFromParent_Done,
     /* 140672 */ // Label 2437: @140672
     /* 140672 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(140756), // Rule ID 4572 //
     /* 140677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140680 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140684 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 140691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 140706 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140718 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140729 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 140737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140754 */   GIR_RootConstrainSelectedInstOperands,
     /* 140755 */   // GIR_Coverage, 4572,
     /* 140755 */   GIR_EraseRootFromParent_Done,
     /* 140756 */ // Label 2438: @140756
     /* 140756 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140840), // Rule ID 4573 //
     /* 140761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140764 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 140775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 140790 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140802 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 140821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140838 */   GIR_RootConstrainSelectedInstOperands,
     /* 140839 */   // GIR_Coverage, 4573,
     /* 140839 */   GIR_EraseRootFromParent_Done,
     /* 140840 */ // Label 2439: @140840
     /* 140840 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140924), // Rule ID 4574 //
     /* 140845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140848 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 140874 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140886 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 140905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140922 */   GIR_RootConstrainSelectedInstOperands,
     /* 140923 */   // GIR_Coverage, 4574,
     /* 140923 */   GIR_EraseRootFromParent_Done,
     /* 140924 */ // Label 2440: @140924
     /* 140924 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(141008), // Rule ID 7486 //
     /* 140929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 140932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140935 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140942 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 140953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 140957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140966 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140970 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 140974 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 140978 */   // MIs[2] Operand 1
     /* 140978 */   // No operand predicates
     /* 140978 */   // MIs[0] Rn
     /* 140978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140986 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140988 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15915>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 140988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 140991 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 140995 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 140998 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 141006 */   GIR_RootConstrainSelectedInstOperands,
     /* 141007 */   // GIR_Coverage, 7486,
     /* 141007 */   GIR_EraseRootFromParent_Done,
     /* 141008 */ // Label 2441: @141008
     /* 141008 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(141106), // Rule ID 7488 //
     /* 141013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 141016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141026 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 141033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 141037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 141041 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141046 */   // MIs[0] Rn
     /* 141046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141056 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15915>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 141056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 141059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 141063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141068 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 141071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 141075 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 141078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 141091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141097 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141104 */   GIR_RootConstrainSelectedInstOperands,
     /* 141105 */   // GIR_Coverage, 7488,
     /* 141105 */   GIR_EraseRootFromParent_Done,
     /* 141106 */ // Label 2442: @141106
     /* 141106 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(141143), // Rule ID 7134 //
     /* 141111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141114 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141121 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141128 */   // MIs[0] ptr
     /* 141128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141136 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15915>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 141136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 141141 */   GIR_RootConstrainSelectedInstOperands,
     /* 141142 */   // GIR_Coverage, 7134,
     /* 141142 */   GIR_Done,
     /* 141143 */ // Label 2443: @141143
     /* 141143 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(141170), // Rule ID 6450 //
     /* 141148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141155 */   // MIs[0] Rn
     /* 141155 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141163 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 141168 */   GIR_RootConstrainSelectedInstOperands,
     /* 141169 */   // GIR_Coverage, 6450,
     /* 141169 */   GIR_Done,
     /* 141170 */ // Label 2444: @141170
     /* 141170 */ GIM_Reject,
     /* 141171 */ // Label 2292: @141171
     /* 141171 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(141376),
     /* 141176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141179 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141191 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(141232), // Rule ID 4484 //
     /* 141196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141206 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141209 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141230 */     GIR_RootConstrainSelectedInstOperands,
     /* 141231 */     // GIR_Coverage, 4484,
     /* 141231 */     GIR_EraseRootFromParent_Done,
     /* 141232 */   // Label 2446: @141232
     /* 141232 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(141273), // Rule ID 4485 //
     /* 141237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141247 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141250 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141271 */     GIR_RootConstrainSelectedInstOperands,
     /* 141272 */     // GIR_Coverage, 4485,
     /* 141272 */     GIR_EraseRootFromParent_Done,
     /* 141273 */   // Label 2447: @141273
     /* 141273 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(141306), // Rule ID 4539 //
     /* 141278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141285 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141288 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141304 */     GIR_RootConstrainSelectedInstOperands,
     /* 141305 */     // GIR_Coverage, 4539,
     /* 141305 */     GIR_EraseRootFromParent_Done,
     /* 141306 */   // Label 2448: @141306
     /* 141306 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(141339), // Rule ID 4563 //
     /* 141311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141318 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141321 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141337 */     GIR_RootConstrainSelectedInstOperands,
     /* 141338 */     // GIR_Coverage, 4563,
     /* 141338 */     GIR_EraseRootFromParent_Done,
     /* 141339 */   // Label 2449: @141339
     /* 141339 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(141375), // Rule ID 325 //
     /* 141344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141354 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 141354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141357 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141373 */     GIR_RootConstrainSelectedInstOperands,
     /* 141374 */     // GIR_Coverage, 325,
     /* 141374 */     GIR_EraseRootFromParent_Done,
     /* 141375 */   // Label 2450: @141375
     /* 141375 */   GIM_Reject,
     /* 141376 */ // Label 2445: @141376
     /* 141376 */ GIM_Reject,
     /* 141377 */ // Label 2293: @141377
     /* 141377 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(141782),
     /* 141382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141385 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141389 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(141438), // Rule ID 4492 //
     /* 141394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141412 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141415 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141436 */     GIR_RootConstrainSelectedInstOperands,
     /* 141437 */     // GIR_Coverage, 4492,
     /* 141437 */     GIR_EraseRootFromParent_Done,
     /* 141438 */   // Label 2452: @141438
     /* 141438 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(141487), // Rule ID 4493 //
     /* 141443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141461 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141464 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141485 */     GIR_RootConstrainSelectedInstOperands,
     /* 141486 */     // GIR_Coverage, 4493,
     /* 141486 */     GIR_EraseRootFromParent_Done,
     /* 141487 */   // Label 2453: @141487
     /* 141487 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(141536), // Rule ID 4494 //
     /* 141492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141510 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141513 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141534 */     GIR_RootConstrainSelectedInstOperands,
     /* 141535 */     // GIR_Coverage, 4494,
     /* 141535 */     GIR_EraseRootFromParent_Done,
     /* 141536 */   // Label 2454: @141536
     /* 141536 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(141585), // Rule ID 4495 //
     /* 141541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141559 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141562 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141583 */     GIR_RootConstrainSelectedInstOperands,
     /* 141584 */     // GIR_Coverage, 4495,
     /* 141584 */     GIR_EraseRootFromParent_Done,
     /* 141585 */   // Label 2455: @141585
     /* 141585 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(141629), // Rule ID 4534 //
     /* 141590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141608 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141611 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141627 */     GIR_RootConstrainSelectedInstOperands,
     /* 141628 */     // GIR_Coverage, 4534,
     /* 141628 */     GIR_EraseRootFromParent_Done,
     /* 141629 */   // Label 2456: @141629
     /* 141629 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(141673), // Rule ID 4537 //
     /* 141634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141652 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141655 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141671 */     GIR_RootConstrainSelectedInstOperands,
     /* 141672 */     // GIR_Coverage, 4537,
     /* 141672 */     GIR_EraseRootFromParent_Done,
     /* 141673 */   // Label 2457: @141673
     /* 141673 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(141717), // Rule ID 4558 //
     /* 141678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141696 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141699 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141715 */     GIR_RootConstrainSelectedInstOperands,
     /* 141716 */     // GIR_Coverage, 4558,
     /* 141716 */     GIR_EraseRootFromParent_Done,
     /* 141717 */   // Label 2458: @141717
     /* 141717 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(141761), // Rule ID 4561 //
     /* 141722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141740 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141743 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141759 */     GIR_RootConstrainSelectedInstOperands,
     /* 141760 */     // GIR_Coverage, 4561,
     /* 141760 */     GIR_EraseRootFromParent_Done,
     /* 141761 */   // Label 2459: @141761
     /* 141761 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(141781), // Rule ID 6449 //
     /* 141766 */     // MIs[0] Rn
     /* 141766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141774 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 141779 */     GIR_RootConstrainSelectedInstOperands,
     /* 141780 */     // GIR_Coverage, 6449,
     /* 141780 */     GIR_Done,
     /* 141781 */   // Label 2460: @141781
     /* 141781 */   GIM_Reject,
     /* 141782 */ // Label 2451: @141782
     /* 141782 */ GIM_Reject,
     /* 141783 */ // Label 2294: @141783
     /* 141783 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(142232),
     /* 141788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141791 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141795 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(141844), // Rule ID 4506 //
     /* 141800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141818 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141821 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141842 */     GIR_RootConstrainSelectedInstOperands,
     /* 141843 */     // GIR_Coverage, 4506,
     /* 141843 */     GIR_EraseRootFromParent_Done,
     /* 141844 */   // Label 2462: @141844
     /* 141844 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(141893), // Rule ID 4507 //
     /* 141849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141867 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141870 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141891 */     GIR_RootConstrainSelectedInstOperands,
     /* 141892 */     // GIR_Coverage, 4507,
     /* 141892 */     GIR_EraseRootFromParent_Done,
     /* 141893 */   // Label 2463: @141893
     /* 141893 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(141942), // Rule ID 4508 //
     /* 141898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141916 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141919 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141940 */     GIR_RootConstrainSelectedInstOperands,
     /* 141941 */     // GIR_Coverage, 4508,
     /* 141941 */     GIR_EraseRootFromParent_Done,
     /* 141942 */   // Label 2464: @141942
     /* 141942 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(141991), // Rule ID 4509 //
     /* 141947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141965 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141968 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141989 */     GIR_RootConstrainSelectedInstOperands,
     /* 141990 */     // GIR_Coverage, 4509,
     /* 141990 */     GIR_EraseRootFromParent_Done,
     /* 141991 */   // Label 2465: @141991
     /* 141991 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(142035), // Rule ID 4541 //
     /* 141996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142014 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142017 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142033 */     GIR_RootConstrainSelectedInstOperands,
     /* 142034 */     // GIR_Coverage, 4541,
     /* 142034 */     GIR_EraseRootFromParent_Done,
     /* 142035 */   // Label 2466: @142035
     /* 142035 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(142079), // Rule ID 4545 //
     /* 142040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142058 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142061 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142077 */     GIR_RootConstrainSelectedInstOperands,
     /* 142078 */     // GIR_Coverage, 4545,
     /* 142078 */     GIR_EraseRootFromParent_Done,
     /* 142079 */   // Label 2467: @142079
     /* 142079 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(142123), // Rule ID 4565 //
     /* 142084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142102 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142105 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142121 */     GIR_RootConstrainSelectedInstOperands,
     /* 142122 */     // GIR_Coverage, 4565,
     /* 142122 */     GIR_EraseRootFromParent_Done,
     /* 142123 */   // Label 2468: @142123
     /* 142123 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(142167), // Rule ID 4569 //
     /* 142128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142146 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142149 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142165 */     GIR_RootConstrainSelectedInstOperands,
     /* 142166 */     // GIR_Coverage, 4569,
     /* 142166 */     GIR_EraseRootFromParent_Done,
     /* 142167 */   // Label 2469: @142167
     /* 142167 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(142211), // Rule ID 4570 //
     /* 142172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142190 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142193 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142209 */     GIR_RootConstrainSelectedInstOperands,
     /* 142210 */     // GIR_Coverage, 4570,
     /* 142210 */     GIR_EraseRootFromParent_Done,
     /* 142211 */   // Label 2470: @142211
     /* 142211 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(142231), // Rule ID 6446 //
     /* 142216 */     // MIs[0] Rn
     /* 142216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142224 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 142229 */     GIR_RootConstrainSelectedInstOperands,
     /* 142230 */     // GIR_Coverage, 6446,
     /* 142230 */     GIR_Done,
     /* 142231 */   // Label 2471: @142231
     /* 142231 */   GIM_Reject,
     /* 142232 */ // Label 2461: @142232
     /* 142232 */ GIM_Reject,
     /* 142233 */ // Label 2295: @142233
     /* 142233 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(142638),
     /* 142238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142241 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142245 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(142294), // Rule ID 4496 //
     /* 142250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142268 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142271 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142292 */     GIR_RootConstrainSelectedInstOperands,
     /* 142293 */     // GIR_Coverage, 4496,
     /* 142293 */     GIR_EraseRootFromParent_Done,
     /* 142294 */   // Label 2473: @142294
     /* 142294 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(142343), // Rule ID 4497 //
     /* 142299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142317 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142320 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142341 */     GIR_RootConstrainSelectedInstOperands,
     /* 142342 */     // GIR_Coverage, 4497,
     /* 142342 */     GIR_EraseRootFromParent_Done,
     /* 142343 */   // Label 2474: @142343
     /* 142343 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(142392), // Rule ID 4500 //
     /* 142348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142366 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142369 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142390 */     GIR_RootConstrainSelectedInstOperands,
     /* 142391 */     // GIR_Coverage, 4500,
     /* 142391 */     GIR_EraseRootFromParent_Done,
     /* 142392 */   // Label 2475: @142392
     /* 142392 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(142441), // Rule ID 4501 //
     /* 142397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142415 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142418 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142439 */     GIR_RootConstrainSelectedInstOperands,
     /* 142440 */     // GIR_Coverage, 4501,
     /* 142440 */     GIR_EraseRootFromParent_Done,
     /* 142441 */   // Label 2476: @142441
     /* 142441 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(142485), // Rule ID 4536 //
     /* 142446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142464 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142467 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142483 */     GIR_RootConstrainSelectedInstOperands,
     /* 142484 */     // GIR_Coverage, 4536,
     /* 142484 */     GIR_EraseRootFromParent_Done,
     /* 142485 */   // Label 2477: @142485
     /* 142485 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(142529), // Rule ID 4538 //
     /* 142490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142508 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142511 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142527 */     GIR_RootConstrainSelectedInstOperands,
     /* 142528 */     // GIR_Coverage, 4538,
     /* 142528 */     GIR_EraseRootFromParent_Done,
     /* 142529 */   // Label 2478: @142529
     /* 142529 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(142573), // Rule ID 4560 //
     /* 142534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142552 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142555 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142571 */     GIR_RootConstrainSelectedInstOperands,
     /* 142572 */     // GIR_Coverage, 4560,
     /* 142572 */     GIR_EraseRootFromParent_Done,
     /* 142573 */   // Label 2479: @142573
     /* 142573 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(142617), // Rule ID 4562 //
     /* 142578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142596 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142599 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142615 */     GIR_RootConstrainSelectedInstOperands,
     /* 142616 */     // GIR_Coverage, 4562,
     /* 142616 */     GIR_EraseRootFromParent_Done,
     /* 142617 */   // Label 2480: @142617
     /* 142617 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(142637), // Rule ID 6448 //
     /* 142622 */     // MIs[0] Rn
     /* 142622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142630 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 142635 */     GIR_RootConstrainSelectedInstOperands,
     /* 142636 */     // GIR_Coverage, 6448,
     /* 142636 */     GIR_Done,
     /* 142637 */   // Label 2481: @142637
     /* 142637 */   GIM_Reject,
     /* 142638 */ // Label 2472: @142638
     /* 142638 */ GIM_Reject,
     /* 142639 */ // Label 2296: @142639
     /* 142639 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(143044),
     /* 142644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142651 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(142700), // Rule ID 4510 //
     /* 142656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142674 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142677 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142698 */     GIR_RootConstrainSelectedInstOperands,
     /* 142699 */     // GIR_Coverage, 4510,
     /* 142699 */     GIR_EraseRootFromParent_Done,
     /* 142700 */   // Label 2483: @142700
     /* 142700 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(142749), // Rule ID 4511 //
     /* 142705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142723 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142726 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142747 */     GIR_RootConstrainSelectedInstOperands,
     /* 142748 */     // GIR_Coverage, 4511,
     /* 142748 */     GIR_EraseRootFromParent_Done,
     /* 142749 */   // Label 2484: @142749
     /* 142749 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(142798), // Rule ID 4512 //
     /* 142754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142772 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142775 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142796 */     GIR_RootConstrainSelectedInstOperands,
     /* 142797 */     // GIR_Coverage, 4512,
     /* 142797 */     GIR_EraseRootFromParent_Done,
     /* 142798 */   // Label 2485: @142798
     /* 142798 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(142847), // Rule ID 4513 //
     /* 142803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142821 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142824 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142845 */     GIR_RootConstrainSelectedInstOperands,
     /* 142846 */     // GIR_Coverage, 4513,
     /* 142846 */     GIR_EraseRootFromParent_Done,
     /* 142847 */   // Label 2486: @142847
     /* 142847 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(142891), // Rule ID 4540 //
     /* 142852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142870 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142873 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142889 */     GIR_RootConstrainSelectedInstOperands,
     /* 142890 */     // GIR_Coverage, 4540,
     /* 142890 */     GIR_EraseRootFromParent_Done,
     /* 142891 */   // Label 2487: @142891
     /* 142891 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(142935), // Rule ID 4544 //
     /* 142896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142914 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142917 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142933 */     GIR_RootConstrainSelectedInstOperands,
     /* 142934 */     // GIR_Coverage, 4544,
     /* 142934 */     GIR_EraseRootFromParent_Done,
     /* 142935 */   // Label 2488: @142935
     /* 142935 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(142979), // Rule ID 4564 //
     /* 142940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142958 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142961 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142977 */     GIR_RootConstrainSelectedInstOperands,
     /* 142978 */     // GIR_Coverage, 4564,
     /* 142978 */     GIR_EraseRootFromParent_Done,
     /* 142979 */   // Label 2489: @142979
     /* 142979 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(143023), // Rule ID 4568 //
     /* 142984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143002 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143005 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143021 */     GIR_RootConstrainSelectedInstOperands,
     /* 143022 */     // GIR_Coverage, 4568,
     /* 143022 */     GIR_EraseRootFromParent_Done,
     /* 143023 */   // Label 2490: @143023
     /* 143023 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(143043), // Rule ID 6445 //
     /* 143028 */     // MIs[0] Rn
     /* 143028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143036 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 143041 */     GIR_RootConstrainSelectedInstOperands,
     /* 143042 */     // GIR_Coverage, 6445,
     /* 143042 */     GIR_Done,
     /* 143043 */   // Label 2491: @143043
     /* 143043 */   GIM_Reject,
     /* 143044 */ // Label 2482: @143044
     /* 143044 */ GIM_Reject,
     /* 143045 */ // Label 2297: @143045
     /* 143045 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(143264),
     /* 143050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143053 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143057 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(143106), // Rule ID 4498 //
     /* 143062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 143080 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 143080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 143083 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143104 */     GIR_RootConstrainSelectedInstOperands,
     /* 143105 */     // GIR_Coverage, 4498,
     /* 143105 */     GIR_EraseRootFromParent_Done,
     /* 143106 */   // Label 2493: @143106
     /* 143106 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(143155), // Rule ID 4499 //
     /* 143111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 143129 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 143129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 143132 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143153 */     GIR_RootConstrainSelectedInstOperands,
     /* 143154 */     // GIR_Coverage, 4499,
     /* 143154 */     GIR_EraseRootFromParent_Done,
     /* 143155 */   // Label 2494: @143155
     /* 143155 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(143199), // Rule ID 4535 //
     /* 143160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 143178 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 143178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 143181 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143197 */     GIR_RootConstrainSelectedInstOperands,
     /* 143198 */     // GIR_Coverage, 4535,
     /* 143198 */     GIR_EraseRootFromParent_Done,
     /* 143199 */   // Label 2495: @143199
     /* 143199 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(143243), // Rule ID 4559 //
     /* 143204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 143222 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 143225 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143241 */     GIR_RootConstrainSelectedInstOperands,
     /* 143242 */     // GIR_Coverage, 4559,
     /* 143242 */     GIR_EraseRootFromParent_Done,
     /* 143243 */   // Label 2496: @143243
     /* 143243 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(143263), // Rule ID 6447 //
     /* 143248 */     // MIs[0] Rn
     /* 143248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143256 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 143261 */     GIR_RootConstrainSelectedInstOperands,
     /* 143262 */     // GIR_Coverage, 6447,
     /* 143262 */     GIR_Done,
     /* 143263 */   // Label 2497: @143263
     /* 143263 */   GIM_Reject,
     /* 143264 */ // Label 2492: @143264
     /* 143264 */ GIM_Reject,
     /* 143265 */ // Label 2298: @143265
     /* 143265 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(143670),
     /* 143270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143273 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143277 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(143326), // Rule ID 4514 //
     /* 143282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143300 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143303 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143324 */     GIR_RootConstrainSelectedInstOperands,
     /* 143325 */     // GIR_Coverage, 4514,
     /* 143325 */     GIR_EraseRootFromParent_Done,
     /* 143326 */   // Label 2499: @143326
     /* 143326 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(143375), // Rule ID 4515 //
     /* 143331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143349 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143352 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143373 */     GIR_RootConstrainSelectedInstOperands,
     /* 143374 */     // GIR_Coverage, 4515,
     /* 143374 */     GIR_EraseRootFromParent_Done,
     /* 143375 */   // Label 2500: @143375
     /* 143375 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(143424), // Rule ID 4518 //
     /* 143380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143398 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143401 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143422 */     GIR_RootConstrainSelectedInstOperands,
     /* 143423 */     // GIR_Coverage, 4518,
     /* 143423 */     GIR_EraseRootFromParent_Done,
     /* 143424 */   // Label 2501: @143424
     /* 143424 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(143473), // Rule ID 4519 //
     /* 143429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143447 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143450 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143471 */     GIR_RootConstrainSelectedInstOperands,
     /* 143472 */     // GIR_Coverage, 4519,
     /* 143472 */     GIR_EraseRootFromParent_Done,
     /* 143473 */   // Label 2502: @143473
     /* 143473 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(143517), // Rule ID 4543 //
     /* 143478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143496 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143499 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143515 */     GIR_RootConstrainSelectedInstOperands,
     /* 143516 */     // GIR_Coverage, 4543,
     /* 143516 */     GIR_EraseRootFromParent_Done,
     /* 143517 */   // Label 2503: @143517
     /* 143517 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(143561), // Rule ID 4546 //
     /* 143522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143540 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143543 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143559 */     GIR_RootConstrainSelectedInstOperands,
     /* 143560 */     // GIR_Coverage, 4546,
     /* 143560 */     GIR_EraseRootFromParent_Done,
     /* 143561 */   // Label 2504: @143561
     /* 143561 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(143605), // Rule ID 4567 //
     /* 143566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143584 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143587 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143603 */     GIR_RootConstrainSelectedInstOperands,
     /* 143604 */     // GIR_Coverage, 4567,
     /* 143604 */     GIR_EraseRootFromParent_Done,
     /* 143605 */   // Label 2505: @143605
     /* 143605 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(143649), // Rule ID 4571 //
     /* 143610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143628 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143631 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143647 */     GIR_RootConstrainSelectedInstOperands,
     /* 143648 */     // GIR_Coverage, 4571,
     /* 143648 */     GIR_EraseRootFromParent_Done,
     /* 143649 */   // Label 2506: @143649
     /* 143649 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(143669), // Rule ID 6444 //
     /* 143654 */     // MIs[0] Rn
     /* 143654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143662 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 143667 */     GIR_RootConstrainSelectedInstOperands,
     /* 143668 */     // GIR_Coverage, 6444,
     /* 143668 */     GIR_Done,
     /* 143669 */   // Label 2507: @143669
     /* 143669 */   GIM_Reject,
     /* 143670 */ // Label 2498: @143670
     /* 143670 */ GIM_Reject,
     /* 143671 */ // Label 2299: @143671
     /* 143671 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(143890),
     /* 143676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143683 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(143732), // Rule ID 4516 //
     /* 143688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143706 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143709 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143730 */     GIR_RootConstrainSelectedInstOperands,
     /* 143731 */     // GIR_Coverage, 4516,
     /* 143731 */     GIR_EraseRootFromParent_Done,
     /* 143732 */   // Label 2509: @143732
     /* 143732 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(143781), // Rule ID 4517 //
     /* 143737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143755 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143758 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143779 */     GIR_RootConstrainSelectedInstOperands,
     /* 143780 */     // GIR_Coverage, 4517,
     /* 143780 */     GIR_EraseRootFromParent_Done,
     /* 143781 */   // Label 2510: @143781
     /* 143781 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(143825), // Rule ID 4542 //
     /* 143786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143804 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143807 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143823 */     GIR_RootConstrainSelectedInstOperands,
     /* 143824 */     // GIR_Coverage, 4542,
     /* 143824 */     GIR_EraseRootFromParent_Done,
     /* 143825 */   // Label 2511: @143825
     /* 143825 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(143869), // Rule ID 4566 //
     /* 143830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143848 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143851 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143867 */     GIR_RootConstrainSelectedInstOperands,
     /* 143868 */     // GIR_Coverage, 4566,
     /* 143868 */     GIR_EraseRootFromParent_Done,
     /* 143869 */   // Label 2512: @143869
     /* 143869 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(143889), // Rule ID 6443 //
     /* 143874 */     // MIs[0] Rn
     /* 143874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143882 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 143887 */     GIR_RootConstrainSelectedInstOperands,
     /* 143888 */     // GIR_Coverage, 6443,
     /* 143888 */     GIR_Done,
     /* 143889 */   // Label 2513: @143889
     /* 143889 */   GIM_Reject,
     /* 143890 */ // Label 2508: @143890
     /* 143890 */ GIM_Reject,
     /* 143891 */ // Label 2300: @143891
     /* 143891 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(143950), // Rule ID 10935 //
     /* 143896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143906 */   // MIs[0] base
     /* 143906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143914 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 143921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143926 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 143934 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143939 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143948 */   GIR_RootConstrainSelectedInstOperands,
     /* 143949 */   // GIR_Coverage, 10935,
     /* 143949 */   GIR_EraseRootFromParent_Done,
     /* 143950 */ // Label 2514: @143950
     /* 143950 */ GIM_Reject,
     /* 143951 */ // Label 2301: @143951
     /* 143951 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(144010), // Rule ID 10941 //
     /* 143956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143962 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143966 */   // MIs[0] base
     /* 143966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143974 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 143981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143986 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 143994 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143999 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144008 */   GIR_RootConstrainSelectedInstOperands,
     /* 144009 */   // GIR_Coverage, 10941,
     /* 144009 */   GIR_EraseRootFromParent_Done,
     /* 144010 */ // Label 2515: @144010
     /* 144010 */ GIM_Reject,
     /* 144011 */ // Label 2302: @144011
     /* 144011 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(144180),
     /* 144016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144019 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144027 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(144075), // Rule ID 10926 //
     /* 144032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144039 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144059 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144064 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144073 */     GIR_RootConstrainSelectedInstOperands,
     /* 144074 */     // GIR_Coverage, 10926,
     /* 144074 */     GIR_EraseRootFromParent_Done,
     /* 144075 */   // Label 2517: @144075
     /* 144075 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(144123), // Rule ID 10944 //
     /* 144080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144087 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144107 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144112 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144121 */     GIR_RootConstrainSelectedInstOperands,
     /* 144122 */     // GIR_Coverage, 10944,
     /* 144122 */     GIR_EraseRootFromParent_Done,
     /* 144123 */   // Label 2518: @144123
     /* 144123 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(144151), // Rule ID 11056 //
     /* 144128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144135 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144138 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144140 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144149 */     GIR_RootConstrainSelectedInstOperands,
     /* 144150 */     // GIR_Coverage, 11056,
     /* 144150 */     GIR_EraseRootFromParent_Done,
     /* 144151 */   // Label 2519: @144151
     /* 144151 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(144179), // Rule ID 11068 //
     /* 144156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144163 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144166 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144168 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144177 */     GIR_RootConstrainSelectedInstOperands,
     /* 144178 */     // GIR_Coverage, 11068,
     /* 144178 */     GIR_EraseRootFromParent_Done,
     /* 144179 */   // Label 2520: @144179
     /* 144179 */   GIM_Reject,
     /* 144180 */ // Label 2516: @144180
     /* 144180 */ GIM_Reject,
     /* 144181 */ // Label 2303: @144181
     /* 144181 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(144240), // Rule ID 10932 //
     /* 144186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144196 */   // MIs[0] base
     /* 144196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144204 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144216 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 144224 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144229 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144238 */   GIR_RootConstrainSelectedInstOperands,
     /* 144239 */   // GIR_Coverage, 10932,
     /* 144239 */   GIR_EraseRootFromParent_Done,
     /* 144240 */ // Label 2521: @144240
     /* 144240 */ GIM_Reject,
     /* 144241 */ // Label 2304: @144241
     /* 144241 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(144410),
     /* 144246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144253 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144257 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(144305), // Rule ID 10920 //
     /* 144262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144269 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144289 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144294 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144303 */     GIR_RootConstrainSelectedInstOperands,
     /* 144304 */     // GIR_Coverage, 10920,
     /* 144304 */     GIR_EraseRootFromParent_Done,
     /* 144305 */   // Label 2523: @144305
     /* 144305 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(144353), // Rule ID 10938 //
     /* 144310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144317 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144337 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144342 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144351 */     GIR_RootConstrainSelectedInstOperands,
     /* 144352 */     // GIR_Coverage, 10938,
     /* 144352 */     GIR_EraseRootFromParent_Done,
     /* 144353 */   // Label 2524: @144353
     /* 144353 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(144381), // Rule ID 11052 //
     /* 144358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144365 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144368 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144370 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144379 */     GIR_RootConstrainSelectedInstOperands,
     /* 144380 */     // GIR_Coverage, 11052,
     /* 144380 */     GIR_EraseRootFromParent_Done,
     /* 144381 */   // Label 2525: @144381
     /* 144381 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(144409), // Rule ID 11064 //
     /* 144386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144393 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144396 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144398 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144407 */     GIR_RootConstrainSelectedInstOperands,
     /* 144408 */     // GIR_Coverage, 11064,
     /* 144408 */     GIR_EraseRootFromParent_Done,
     /* 144409 */   // Label 2526: @144409
     /* 144409 */   GIM_Reject,
     /* 144410 */ // Label 2522: @144410
     /* 144410 */ GIM_Reject,
     /* 144411 */ // Label 2305: @144411
     /* 144411 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(144580),
     /* 144416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144427 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(144475), // Rule ID 10911 //
     /* 144432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144439 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144459 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144464 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144473 */     GIR_RootConstrainSelectedInstOperands,
     /* 144474 */     // GIR_Coverage, 10911,
     /* 144474 */     GIR_EraseRootFromParent_Done,
     /* 144475 */   // Label 2528: @144475
     /* 144475 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(144523), // Rule ID 10929 //
     /* 144480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144487 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144507 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144512 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144521 */     GIR_RootConstrainSelectedInstOperands,
     /* 144522 */     // GIR_Coverage, 10929,
     /* 144522 */     GIR_EraseRootFromParent_Done,
     /* 144523 */   // Label 2529: @144523
     /* 144523 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(144551), // Rule ID 11048 //
     /* 144528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144535 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144538 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144540 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144549 */     GIR_RootConstrainSelectedInstOperands,
     /* 144550 */     // GIR_Coverage, 11048,
     /* 144550 */     GIR_EraseRootFromParent_Done,
     /* 144551 */   // Label 2530: @144551
     /* 144551 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(144579), // Rule ID 11060 //
     /* 144556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144563 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144566 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144568 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144577 */     GIR_RootConstrainSelectedInstOperands,
     /* 144578 */     // GIR_Coverage, 11060,
     /* 144578 */     GIR_EraseRootFromParent_Done,
     /* 144579 */   // Label 2531: @144579
     /* 144579 */   GIM_Reject,
     /* 144580 */ // Label 2527: @144580
     /* 144580 */ GIM_Reject,
     /* 144581 */ // Label 2306: @144581
     /* 144581 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(144624), // Rule ID 2433 //
     /* 144586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144600 */   // MIs[0] base
     /* 144600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144608 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 144611 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 144613 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144622 */   GIR_RootConstrainSelectedInstOperands,
     /* 144623 */   // GIR_Coverage, 2433,
     /* 144623 */   GIR_EraseRootFromParent_Done,
     /* 144624 */ // Label 2532: @144624
     /* 144624 */ GIM_Reject,
     /* 144625 */ // Label 2307: @144625
     /* 144625 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(144718),
     /* 144630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144641 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(144689), // Rule ID 10897 //
     /* 144646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144653 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 144660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 144673 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144678 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144687 */     GIR_RootConstrainSelectedInstOperands,
     /* 144688 */     // GIR_Coverage, 10897,
     /* 144688 */     GIR_EraseRootFromParent_Done,
     /* 144689 */   // Label 2534: @144689
     /* 144689 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(144717), // Rule ID 11044 //
     /* 144694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144701 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144704 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144706 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144715 */     GIR_RootConstrainSelectedInstOperands,
     /* 144716 */     // GIR_Coverage, 11044,
     /* 144716 */     GIR_EraseRootFromParent_Done,
     /* 144717 */   // Label 2535: @144717
     /* 144717 */   GIM_Reject,
     /* 144718 */ // Label 2533: @144718
     /* 144718 */ GIM_Reject,
     /* 144719 */ // Label 2308: @144719
     /* 144719 */ GIM_Reject,
     /* 144720 */ // Label 20: @144720
     /* 144720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2538*/ GIMT_Encode4(146070),
     /* 144731 */ /*GILLT_s32*//*Label 2536*/ GIMT_Encode4(144739),
     /* 144735 */ /*GILLT_s64*//*Label 2537*/ GIMT_Encode4(145757),
     /* 144739 */ // Label 2536: @144739
     /* 144739 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(145756),
     /* 144744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 144750 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(144805), // Rule ID 7357 //
     /* 144755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144772 */     // MIs[0] Rn
     /* 144772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144788 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 144791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144803 */     GIR_RootConstrainSelectedInstOperands,
     /* 144804 */     // GIR_Coverage, 7357,
     /* 144804 */     GIR_EraseRootFromParent_Done,
     /* 144805 */   // Label 2540: @144805
     /* 144805 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(144860), // Rule ID 7358 //
     /* 144810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144827 */     // MIs[0] Rn
     /* 144827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144843 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 144846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144858 */     GIR_RootConstrainSelectedInstOperands,
     /* 144859 */     // GIR_Coverage, 7358,
     /* 144859 */     GIR_EraseRootFromParent_Done,
     /* 144860 */   // Label 2541: @144860
     /* 144860 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(144915), // Rule ID 7359 //
     /* 144865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144882 */     // MIs[0] Rn
     /* 144882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144898 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 144901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144913 */     GIR_RootConstrainSelectedInstOperands,
     /* 144914 */     // GIR_Coverage, 7359,
     /* 144914 */     GIR_EraseRootFromParent_Done,
     /* 144915 */   // Label 2542: @144915
     /* 144915 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(144970), // Rule ID 7360 //
     /* 144920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144937 */     // MIs[0] Rn
     /* 144937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144953 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 144956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144968 */     GIR_RootConstrainSelectedInstOperands,
     /* 144969 */     // GIR_Coverage, 7360,
     /* 144969 */     GIR_EraseRootFromParent_Done,
     /* 144970 */   // Label 2543: @144970
     /* 144970 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(145025), // Rule ID 7361 //
     /* 144975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144992 */     // MIs[0] Rn
     /* 144992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145008 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 145011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145023 */     GIR_RootConstrainSelectedInstOperands,
     /* 145024 */     // GIR_Coverage, 7361,
     /* 145024 */     GIR_EraseRootFromParent_Done,
     /* 145025 */   // Label 2544: @145025
     /* 145025 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(145080), // Rule ID 7362 //
     /* 145030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145047 */     // MIs[0] Rn
     /* 145047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145063 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 145066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145078 */     GIR_RootConstrainSelectedInstOperands,
     /* 145079 */     // GIR_Coverage, 7362,
     /* 145079 */     GIR_EraseRootFromParent_Done,
     /* 145080 */   // Label 2545: @145080
     /* 145080 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(145135), // Rule ID 7363 //
     /* 145085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145102 */     // MIs[0] Rn
     /* 145102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145118 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 145121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145133 */     GIR_RootConstrainSelectedInstOperands,
     /* 145134 */     // GIR_Coverage, 7363,
     /* 145134 */     GIR_EraseRootFromParent_Done,
     /* 145135 */   // Label 2546: @145135
     /* 145135 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(145190), // Rule ID 7364 //
     /* 145140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145143 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145150 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145157 */     // MIs[0] Rn
     /* 145157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145173 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 145176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145188 */     GIR_RootConstrainSelectedInstOperands,
     /* 145189 */     // GIR_Coverage, 7364,
     /* 145189 */     GIR_EraseRootFromParent_Done,
     /* 145190 */   // Label 2547: @145190
     /* 145190 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(145245), // Rule ID 7365 //
     /* 145195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145212 */     // MIs[0] Rn
     /* 145212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145228 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145243 */     GIR_RootConstrainSelectedInstOperands,
     /* 145244 */     // GIR_Coverage, 7365,
     /* 145244 */     GIR_EraseRootFromParent_Done,
     /* 145245 */   // Label 2548: @145245
     /* 145245 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(145300), // Rule ID 7366 //
     /* 145250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145267 */     // MIs[0] Rn
     /* 145267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145283 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145298 */     GIR_RootConstrainSelectedInstOperands,
     /* 145299 */     // GIR_Coverage, 7366,
     /* 145299 */     GIR_EraseRootFromParent_Done,
     /* 145300 */   // Label 2549: @145300
     /* 145300 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(145355), // Rule ID 7367 //
     /* 145305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145322 */     // MIs[0] Rn
     /* 145322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145338 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 145341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145353 */     GIR_RootConstrainSelectedInstOperands,
     /* 145354 */     // GIR_Coverage, 7367,
     /* 145354 */     GIR_EraseRootFromParent_Done,
     /* 145355 */   // Label 2550: @145355
     /* 145355 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(145410), // Rule ID 7368 //
     /* 145360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145377 */     // MIs[0] Rn
     /* 145377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145393 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 145396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145408 */     GIR_RootConstrainSelectedInstOperands,
     /* 145409 */     // GIR_Coverage, 7368,
     /* 145409 */     GIR_EraseRootFromParent_Done,
     /* 145410 */   // Label 2551: @145410
     /* 145410 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(145465), // Rule ID 7369 //
     /* 145415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145432 */     // MIs[0] Rn
     /* 145432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145448 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 145451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145463 */     GIR_RootConstrainSelectedInstOperands,
     /* 145464 */     // GIR_Coverage, 7369,
     /* 145464 */     GIR_EraseRootFromParent_Done,
     /* 145465 */   // Label 2552: @145465
     /* 145465 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(145520), // Rule ID 7370 //
     /* 145470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145487 */     // MIs[0] Rn
     /* 145487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145503 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145518 */     GIR_RootConstrainSelectedInstOperands,
     /* 145519 */     // GIR_Coverage, 7370,
     /* 145519 */     GIR_EraseRootFromParent_Done,
     /* 145520 */   // Label 2553: @145520
     /* 145520 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(145575), // Rule ID 7371 //
     /* 145525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145542 */     // MIs[0] Rn
     /* 145542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145558 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145573 */     GIR_RootConstrainSelectedInstOperands,
     /* 145574 */     // GIR_Coverage, 7371,
     /* 145574 */     GIR_EraseRootFromParent_Done,
     /* 145575 */   // Label 2554: @145575
     /* 145575 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(145635), // Rule ID 13207 //
     /* 145580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145594 */     // MIs[0] addr
     /* 145594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145610 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 145616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145618 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145623 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145625 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145627 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145633 */     GIR_RootConstrainSelectedInstOperands,
     /* 145634 */     // GIR_Coverage, 13207,
     /* 145634 */     GIR_EraseRootFromParent_Done,
     /* 145635 */   // Label 2555: @145635
     /* 145635 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(145695), // Rule ID 13208 //
     /* 145640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145654 */     // MIs[0] addr
     /* 145654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145670 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 145676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145678 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145683 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145685 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145687 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145693 */     GIR_RootConstrainSelectedInstOperands,
     /* 145694 */     // GIR_Coverage, 13208,
     /* 145694 */     GIR_EraseRootFromParent_Done,
     /* 145695 */   // Label 2556: @145695
     /* 145695 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(145755), // Rule ID 13209 //
     /* 145700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145714 */     // MIs[0] addr
     /* 145714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145730 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 145736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145738 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145743 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145745 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145753 */     GIR_RootConstrainSelectedInstOperands,
     /* 145754 */     // GIR_Coverage, 13209,
     /* 145754 */     GIR_EraseRootFromParent_Done,
     /* 145755 */   // Label 2557: @145755
     /* 145755 */   GIM_Reject,
     /* 145756 */ // Label 2539: @145756
     /* 145756 */ GIM_Reject,
     /* 145757 */ // Label 2537: @145757
     /* 145757 */ GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(146069),
     /* 145762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 145768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 145775 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(145823), // Rule ID 2585 //
     /* 145780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145790 */     // MIs[0] Rn
     /* 145790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145806 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 145809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145821 */     GIR_RootConstrainSelectedInstOperands,
     /* 145822 */     // GIR_Coverage, 2585,
     /* 145822 */     GIR_EraseRootFromParent_Done,
     /* 145823 */   // Label 2559: @145823
     /* 145823 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(145871), // Rule ID 2586 //
     /* 145828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145838 */     // MIs[0] Rn
     /* 145838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145854 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 145857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145869 */     GIR_RootConstrainSelectedInstOperands,
     /* 145870 */     // GIR_Coverage, 2586,
     /* 145870 */     GIR_EraseRootFromParent_Done,
     /* 145871 */   // Label 2560: @145871
     /* 145871 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145919), // Rule ID 2587 //
     /* 145876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145886 */     // MIs[0] Rn
     /* 145886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145902 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 145905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145917 */     GIR_RootConstrainSelectedInstOperands,
     /* 145918 */     // GIR_Coverage, 2587,
     /* 145918 */     GIR_EraseRootFromParent_Done,
     /* 145919 */   // Label 2561: @145919
     /* 145919 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(145967), // Rule ID 2588 //
     /* 145924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145934 */     // MIs[0] Rn
     /* 145934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145950 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 145953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145965 */     GIR_RootConstrainSelectedInstOperands,
     /* 145966 */     // GIR_Coverage, 2588,
     /* 145966 */     GIR_EraseRootFromParent_Done,
     /* 145967 */   // Label 2562: @145967
     /* 145967 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(146015), // Rule ID 2589 //
     /* 145972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145975 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145982 */     // MIs[0] Rn
     /* 145982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145998 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 146001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146013 */     GIR_RootConstrainSelectedInstOperands,
     /* 146014 */     // GIR_Coverage, 2589,
     /* 146014 */     GIR_EraseRootFromParent_Done,
     /* 146015 */   // Label 2563: @146015
     /* 146015 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(146068), // Rule ID 13210 //
     /* 146020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 146023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146027 */     // MIs[0] addr
     /* 146027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146043 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 146043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 146049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146051 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 146056 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 146058 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 146060 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 146062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146066 */     GIR_RootConstrainSelectedInstOperands,
     /* 146067 */     // GIR_Coverage, 13210,
     /* 146067 */     GIR_EraseRootFromParent_Done,
     /* 146068 */   // Label 2564: @146068
     /* 146068 */   GIM_Reject,
     /* 146069 */ // Label 2558: @146069
     /* 146069 */ GIM_Reject,
     /* 146070 */ // Label 2538: @146070
     /* 146070 */ GIM_Reject,
     /* 146071 */ // Label 21: @146071
     /* 146071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2567*/ GIMT_Encode4(147062),
     /* 146082 */ /*GILLT_s32*//*Label 2565*/ GIMT_Encode4(146090),
     /* 146086 */ /*GILLT_s64*//*Label 2566*/ GIMT_Encode4(146835),
     /* 146090 */ // Label 2565: @146090
     /* 146090 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(146834),
     /* 146095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146098 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(146147), // Rule ID 7342 //
     /* 146103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146120 */     // MIs[0] Rn
     /* 146120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146132 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 146135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146145 */     GIR_RootConstrainSelectedInstOperands,
     /* 146146 */     // GIR_Coverage, 7342,
     /* 146146 */     GIR_EraseRootFromParent_Done,
     /* 146147 */   // Label 2569: @146147
     /* 146147 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(146196), // Rule ID 7343 //
     /* 146152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146169 */     // MIs[0] Rn
     /* 146169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146181 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 146184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146194 */     GIR_RootConstrainSelectedInstOperands,
     /* 146195 */     // GIR_Coverage, 7343,
     /* 146195 */     GIR_EraseRootFromParent_Done,
     /* 146196 */   // Label 2570: @146196
     /* 146196 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(146245), // Rule ID 7344 //
     /* 146201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146218 */     // MIs[0] Rn
     /* 146218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146230 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 146233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146243 */     GIR_RootConstrainSelectedInstOperands,
     /* 146244 */     // GIR_Coverage, 7344,
     /* 146244 */     GIR_EraseRootFromParent_Done,
     /* 146245 */   // Label 2571: @146245
     /* 146245 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(146294), // Rule ID 7345 //
     /* 146250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146267 */     // MIs[0] Rn
     /* 146267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146279 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146292 */     GIR_RootConstrainSelectedInstOperands,
     /* 146293 */     // GIR_Coverage, 7345,
     /* 146293 */     GIR_EraseRootFromParent_Done,
     /* 146294 */   // Label 2572: @146294
     /* 146294 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(146343), // Rule ID 7346 //
     /* 146299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146316 */     // MIs[0] Rn
     /* 146316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146328 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146341 */     GIR_RootConstrainSelectedInstOperands,
     /* 146342 */     // GIR_Coverage, 7346,
     /* 146342 */     GIR_EraseRootFromParent_Done,
     /* 146343 */   // Label 2573: @146343
     /* 146343 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(146392), // Rule ID 7347 //
     /* 146348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146365 */     // MIs[0] Rn
     /* 146365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146377 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 146380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146390 */     GIR_RootConstrainSelectedInstOperands,
     /* 146391 */     // GIR_Coverage, 7347,
     /* 146391 */     GIR_EraseRootFromParent_Done,
     /* 146392 */   // Label 2574: @146392
     /* 146392 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(146441), // Rule ID 7348 //
     /* 146397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146414 */     // MIs[0] Rn
     /* 146414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146426 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 146429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146439 */     GIR_RootConstrainSelectedInstOperands,
     /* 146440 */     // GIR_Coverage, 7348,
     /* 146440 */     GIR_EraseRootFromParent_Done,
     /* 146441 */   // Label 2575: @146441
     /* 146441 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(146490), // Rule ID 7349 //
     /* 146446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146463 */     // MIs[0] Rn
     /* 146463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146475 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 146478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146488 */     GIR_RootConstrainSelectedInstOperands,
     /* 146489 */     // GIR_Coverage, 7349,
     /* 146489 */     GIR_EraseRootFromParent_Done,
     /* 146490 */   // Label 2576: @146490
     /* 146490 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(146539), // Rule ID 7350 //
     /* 146495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146512 */     // MIs[0] Rn
     /* 146512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146524 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146537 */     GIR_RootConstrainSelectedInstOperands,
     /* 146538 */     // GIR_Coverage, 7350,
     /* 146538 */     GIR_EraseRootFromParent_Done,
     /* 146539 */   // Label 2577: @146539
     /* 146539 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(146588), // Rule ID 7351 //
     /* 146544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146561 */     // MIs[0] Rn
     /* 146561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146573 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146586 */     GIR_RootConstrainSelectedInstOperands,
     /* 146587 */     // GIR_Coverage, 7351,
     /* 146587 */     GIR_EraseRootFromParent_Done,
     /* 146588 */   // Label 2578: @146588
     /* 146588 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(146637), // Rule ID 7352 //
     /* 146593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146610 */     // MIs[0] Rn
     /* 146610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146622 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 146625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146635 */     GIR_RootConstrainSelectedInstOperands,
     /* 146636 */     // GIR_Coverage, 7352,
     /* 146636 */     GIR_EraseRootFromParent_Done,
     /* 146637 */   // Label 2579: @146637
     /* 146637 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(146686), // Rule ID 7353 //
     /* 146642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146659 */     // MIs[0] Rn
     /* 146659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146671 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 146674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146684 */     GIR_RootConstrainSelectedInstOperands,
     /* 146685 */     // GIR_Coverage, 7353,
     /* 146685 */     GIR_EraseRootFromParent_Done,
     /* 146686 */   // Label 2580: @146686
     /* 146686 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(146735), // Rule ID 7354 //
     /* 146691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146708 */     // MIs[0] Rn
     /* 146708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146720 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 146723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146733 */     GIR_RootConstrainSelectedInstOperands,
     /* 146734 */     // GIR_Coverage, 7354,
     /* 146734 */     GIR_EraseRootFromParent_Done,
     /* 146735 */   // Label 2581: @146735
     /* 146735 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(146784), // Rule ID 7355 //
     /* 146740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146757 */     // MIs[0] Rn
     /* 146757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146769 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 146772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146782 */     GIR_RootConstrainSelectedInstOperands,
     /* 146783 */     // GIR_Coverage, 7355,
     /* 146783 */     GIR_EraseRootFromParent_Done,
     /* 146784 */   // Label 2582: @146784
     /* 146784 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(146833), // Rule ID 7356 //
     /* 146789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146806 */     // MIs[0] Rn
     /* 146806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146818 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 146821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146831 */     GIR_RootConstrainSelectedInstOperands,
     /* 146832 */     // GIR_Coverage, 7356,
     /* 146832 */     GIR_EraseRootFromParent_Done,
     /* 146833 */   // Label 2583: @146833
     /* 146833 */   GIM_Reject,
     /* 146834 */ // Label 2568: @146834
     /* 146834 */ GIM_Reject,
     /* 146835 */ // Label 2566: @146835
     /* 146835 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(147061),
     /* 146840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146843 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146850 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(146892), // Rule ID 7337 //
     /* 146855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146865 */     // MIs[0] Rn
     /* 146865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146877 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 146880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146890 */     GIR_RootConstrainSelectedInstOperands,
     /* 146891 */     // GIR_Coverage, 7337,
     /* 146891 */     GIR_EraseRootFromParent_Done,
     /* 146892 */   // Label 2585: @146892
     /* 146892 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(146934), // Rule ID 7338 //
     /* 146897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146907 */     // MIs[0] Rn
     /* 146907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146919 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 146922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146932 */     GIR_RootConstrainSelectedInstOperands,
     /* 146933 */     // GIR_Coverage, 7338,
     /* 146933 */     GIR_EraseRootFromParent_Done,
     /* 146934 */   // Label 2586: @146934
     /* 146934 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(146976), // Rule ID 7339 //
     /* 146939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146949 */     // MIs[0] Rn
     /* 146949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146961 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146974 */     GIR_RootConstrainSelectedInstOperands,
     /* 146975 */     // GIR_Coverage, 7339,
     /* 146975 */     GIR_EraseRootFromParent_Done,
     /* 146976 */   // Label 2587: @146976
     /* 146976 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(147018), // Rule ID 7340 //
     /* 146981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146991 */     // MIs[0] Rn
     /* 146991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147003 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147016 */     GIR_RootConstrainSelectedInstOperands,
     /* 147017 */     // GIR_Coverage, 7340,
     /* 147017 */     GIR_EraseRootFromParent_Done,
     /* 147018 */   // Label 2588: @147018
     /* 147018 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(147060), // Rule ID 7341 //
     /* 147023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147033 */     // MIs[0] Rn
     /* 147033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147045 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147058 */     GIR_RootConstrainSelectedInstOperands,
     /* 147059 */     // GIR_Coverage, 7341,
     /* 147059 */     GIR_EraseRootFromParent_Done,
     /* 147060 */   // Label 2589: @147060
     /* 147060 */   GIM_Reject,
     /* 147061 */ // Label 2584: @147061
     /* 147061 */ GIM_Reject,
     /* 147062 */ // Label 2567: @147062
     /* 147062 */ GIM_Reject,
     /* 147063 */ // Label 22: @147063
     /* 147063 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2592*/ GIMT_Encode4(148054),
     /* 147074 */ /*GILLT_s32*//*Label 2590*/ GIMT_Encode4(147082),
     /* 147078 */ /*GILLT_s64*//*Label 2591*/ GIMT_Encode4(147827),
     /* 147082 */ // Label 2590: @147082
     /* 147082 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(147826),
     /* 147087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147090 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(147139), // Rule ID 7182 //
     /* 147095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147112 */     // MIs[0] Rn
     /* 147112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147124 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 147127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147137 */     GIR_RootConstrainSelectedInstOperands,
     /* 147138 */     // GIR_Coverage, 7182,
     /* 147138 */     GIR_EraseRootFromParent_Done,
     /* 147139 */   // Label 2594: @147139
     /* 147139 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(147188), // Rule ID 7183 //
     /* 147144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147161 */     // MIs[0] Rn
     /* 147161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147173 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 147176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147186 */     GIR_RootConstrainSelectedInstOperands,
     /* 147187 */     // GIR_Coverage, 7183,
     /* 147187 */     GIR_EraseRootFromParent_Done,
     /* 147188 */   // Label 2595: @147188
     /* 147188 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(147237), // Rule ID 7184 //
     /* 147193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147210 */     // MIs[0] Rn
     /* 147210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147222 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 147225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147235 */     GIR_RootConstrainSelectedInstOperands,
     /* 147236 */     // GIR_Coverage, 7184,
     /* 147236 */     GIR_EraseRootFromParent_Done,
     /* 147237 */   // Label 2596: @147237
     /* 147237 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(147286), // Rule ID 7185 //
     /* 147242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147259 */     // MIs[0] Rn
     /* 147259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147271 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147284 */     GIR_RootConstrainSelectedInstOperands,
     /* 147285 */     // GIR_Coverage, 7185,
     /* 147285 */     GIR_EraseRootFromParent_Done,
     /* 147286 */   // Label 2597: @147286
     /* 147286 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(147335), // Rule ID 7186 //
     /* 147291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147308 */     // MIs[0] Rn
     /* 147308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147320 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147333 */     GIR_RootConstrainSelectedInstOperands,
     /* 147334 */     // GIR_Coverage, 7186,
     /* 147334 */     GIR_EraseRootFromParent_Done,
     /* 147335 */   // Label 2598: @147335
     /* 147335 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(147384), // Rule ID 7187 //
     /* 147340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147357 */     // MIs[0] Rn
     /* 147357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147369 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 147372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147382 */     GIR_RootConstrainSelectedInstOperands,
     /* 147383 */     // GIR_Coverage, 7187,
     /* 147383 */     GIR_EraseRootFromParent_Done,
     /* 147384 */   // Label 2599: @147384
     /* 147384 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(147433), // Rule ID 7188 //
     /* 147389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147406 */     // MIs[0] Rn
     /* 147406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147418 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147431 */     GIR_RootConstrainSelectedInstOperands,
     /* 147432 */     // GIR_Coverage, 7188,
     /* 147432 */     GIR_EraseRootFromParent_Done,
     /* 147433 */   // Label 2600: @147433
     /* 147433 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(147482), // Rule ID 7189 //
     /* 147438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147455 */     // MIs[0] Rn
     /* 147455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147467 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147480 */     GIR_RootConstrainSelectedInstOperands,
     /* 147481 */     // GIR_Coverage, 7189,
     /* 147481 */     GIR_EraseRootFromParent_Done,
     /* 147482 */   // Label 2601: @147482
     /* 147482 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(147531), // Rule ID 7190 //
     /* 147487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147504 */     // MIs[0] Rn
     /* 147504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147516 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147529 */     GIR_RootConstrainSelectedInstOperands,
     /* 147530 */     // GIR_Coverage, 7190,
     /* 147530 */     GIR_EraseRootFromParent_Done,
     /* 147531 */   // Label 2602: @147531
     /* 147531 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(147580), // Rule ID 7191 //
     /* 147536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147553 */     // MIs[0] Rn
     /* 147553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147565 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147578 */     GIR_RootConstrainSelectedInstOperands,
     /* 147579 */     // GIR_Coverage, 7191,
     /* 147579 */     GIR_EraseRootFromParent_Done,
     /* 147580 */   // Label 2603: @147580
     /* 147580 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(147629), // Rule ID 7192 //
     /* 147585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147602 */     // MIs[0] Rn
     /* 147602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147614 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 147617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147627 */     GIR_RootConstrainSelectedInstOperands,
     /* 147628 */     // GIR_Coverage, 7192,
     /* 147628 */     GIR_EraseRootFromParent_Done,
     /* 147629 */   // Label 2604: @147629
     /* 147629 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(147678), // Rule ID 7193 //
     /* 147634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147651 */     // MIs[0] Rn
     /* 147651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147663 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 147666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147676 */     GIR_RootConstrainSelectedInstOperands,
     /* 147677 */     // GIR_Coverage, 7193,
     /* 147677 */     GIR_EraseRootFromParent_Done,
     /* 147678 */   // Label 2605: @147678
     /* 147678 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(147727), // Rule ID 7194 //
     /* 147683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147700 */     // MIs[0] Rn
     /* 147700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147712 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 147715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147725 */     GIR_RootConstrainSelectedInstOperands,
     /* 147726 */     // GIR_Coverage, 7194,
     /* 147726 */     GIR_EraseRootFromParent_Done,
     /* 147727 */   // Label 2606: @147727
     /* 147727 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(147776), // Rule ID 7195 //
     /* 147732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147749 */     // MIs[0] Rn
     /* 147749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147761 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147774 */     GIR_RootConstrainSelectedInstOperands,
     /* 147775 */     // GIR_Coverage, 7195,
     /* 147775 */     GIR_EraseRootFromParent_Done,
     /* 147776 */   // Label 2607: @147776
     /* 147776 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(147825), // Rule ID 7196 //
     /* 147781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147798 */     // MIs[0] Rn
     /* 147798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147810 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147823 */     GIR_RootConstrainSelectedInstOperands,
     /* 147824 */     // GIR_Coverage, 7196,
     /* 147824 */     GIR_EraseRootFromParent_Done,
     /* 147825 */   // Label 2608: @147825
     /* 147825 */   GIM_Reject,
     /* 147826 */ // Label 2593: @147826
     /* 147826 */ GIM_Reject,
     /* 147827 */ // Label 2591: @147827
     /* 147827 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(148053),
     /* 147832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147842 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(147884), // Rule ID 2575 //
     /* 147847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147857 */     // MIs[0] Rn
     /* 147857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147869 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 147872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147882 */     GIR_RootConstrainSelectedInstOperands,
     /* 147883 */     // GIR_Coverage, 2575,
     /* 147883 */     GIR_EraseRootFromParent_Done,
     /* 147884 */   // Label 2610: @147884
     /* 147884 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(147926), // Rule ID 2576 //
     /* 147889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147899 */     // MIs[0] Rn
     /* 147899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147911 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 147914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147924 */     GIR_RootConstrainSelectedInstOperands,
     /* 147925 */     // GIR_Coverage, 2576,
     /* 147925 */     GIR_EraseRootFromParent_Done,
     /* 147926 */   // Label 2611: @147926
     /* 147926 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(147968), // Rule ID 2577 //
     /* 147931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147941 */     // MIs[0] Rn
     /* 147941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147953 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 147956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147966 */     GIR_RootConstrainSelectedInstOperands,
     /* 147967 */     // GIR_Coverage, 2577,
     /* 147967 */     GIR_EraseRootFromParent_Done,
     /* 147968 */   // Label 2612: @147968
     /* 147968 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(148010), // Rule ID 2578 //
     /* 147973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147983 */     // MIs[0] Rn
     /* 147983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147995 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148008 */     GIR_RootConstrainSelectedInstOperands,
     /* 148009 */     // GIR_Coverage, 2578,
     /* 148009 */     GIR_EraseRootFromParent_Done,
     /* 148010 */   // Label 2613: @148010
     /* 148010 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(148052), // Rule ID 2579 //
     /* 148015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148025 */     // MIs[0] Rn
     /* 148025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148037 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148050 */     GIR_RootConstrainSelectedInstOperands,
     /* 148051 */     // GIR_Coverage, 2579,
     /* 148051 */     GIR_EraseRootFromParent_Done,
     /* 148052 */   // Label 2614: @148052
     /* 148052 */   GIM_Reject,
     /* 148053 */ // Label 2609: @148053
     /* 148053 */ GIM_Reject,
     /* 148054 */ // Label 2592: @148054
     /* 148054 */ GIM_Reject,
     /* 148055 */ // Label 23: @148055
     /* 148055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2617*/ GIMT_Encode4(149546),
     /* 148066 */ /*GILLT_s32*//*Label 2615*/ GIMT_Encode4(148074),
     /* 148070 */ /*GILLT_s64*//*Label 2616*/ GIMT_Encode4(149194),
     /* 148074 */ // Label 2615: @148074
     /* 148074 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(149193),
     /* 148079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148082 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(148156), // Rule ID 7377 //
     /* 148087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148104 */     // MIs[0] Rn
     /* 148104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148116 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148128 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 148143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148154 */     GIR_RootConstrainSelectedInstOperands,
     /* 148155 */     // GIR_Coverage, 7377,
     /* 148155 */     GIR_EraseRootFromParent_Done,
     /* 148156 */   // Label 2619: @148156
     /* 148156 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(148230), // Rule ID 7378 //
     /* 148161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148178 */     // MIs[0] Rn
     /* 148178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148190 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148202 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 148217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148228 */     GIR_RootConstrainSelectedInstOperands,
     /* 148229 */     // GIR_Coverage, 7378,
     /* 148229 */     GIR_EraseRootFromParent_Done,
     /* 148230 */   // Label 2620: @148230
     /* 148230 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(148304), // Rule ID 7379 //
     /* 148235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148252 */     // MIs[0] Rn
     /* 148252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148264 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148276 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 148291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148302 */     GIR_RootConstrainSelectedInstOperands,
     /* 148303 */     // GIR_Coverage, 7379,
     /* 148303 */     GIR_EraseRootFromParent_Done,
     /* 148304 */   // Label 2621: @148304
     /* 148304 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(148378), // Rule ID 7380 //
     /* 148309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148326 */     // MIs[0] Rn
     /* 148326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148338 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148350 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148376 */     GIR_RootConstrainSelectedInstOperands,
     /* 148377 */     // GIR_Coverage, 7380,
     /* 148377 */     GIR_EraseRootFromParent_Done,
     /* 148378 */   // Label 2622: @148378
     /* 148378 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(148452), // Rule ID 7381 //
     /* 148383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148400 */     // MIs[0] Rn
     /* 148400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148412 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148424 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148450 */     GIR_RootConstrainSelectedInstOperands,
     /* 148451 */     // GIR_Coverage, 7381,
     /* 148451 */     GIR_EraseRootFromParent_Done,
     /* 148452 */   // Label 2623: @148452
     /* 148452 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(148526), // Rule ID 7382 //
     /* 148457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148474 */     // MIs[0] Rn
     /* 148474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148486 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148498 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 148513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148524 */     GIR_RootConstrainSelectedInstOperands,
     /* 148525 */     // GIR_Coverage, 7382,
     /* 148525 */     GIR_EraseRootFromParent_Done,
     /* 148526 */   // Label 2624: @148526
     /* 148526 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(148600), // Rule ID 7383 //
     /* 148531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148548 */     // MIs[0] Rn
     /* 148548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148560 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148572 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 148587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148598 */     GIR_RootConstrainSelectedInstOperands,
     /* 148599 */     // GIR_Coverage, 7383,
     /* 148599 */     GIR_EraseRootFromParent_Done,
     /* 148600 */   // Label 2625: @148600
     /* 148600 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(148674), // Rule ID 7384 //
     /* 148605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148622 */     // MIs[0] Rn
     /* 148622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148634 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148646 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 148661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148672 */     GIR_RootConstrainSelectedInstOperands,
     /* 148673 */     // GIR_Coverage, 7384,
     /* 148673 */     GIR_EraseRootFromParent_Done,
     /* 148674 */   // Label 2626: @148674
     /* 148674 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(148748), // Rule ID 7385 //
     /* 148679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148696 */     // MIs[0] Rn
     /* 148696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148708 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148720 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 148735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148746 */     GIR_RootConstrainSelectedInstOperands,
     /* 148747 */     // GIR_Coverage, 7385,
     /* 148747 */     GIR_EraseRootFromParent_Done,
     /* 148748 */   // Label 2627: @148748
     /* 148748 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(148822), // Rule ID 7386 //
     /* 148753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148770 */     // MIs[0] Rn
     /* 148770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148782 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148794 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 148809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148820 */     GIR_RootConstrainSelectedInstOperands,
     /* 148821 */     // GIR_Coverage, 7386,
     /* 148821 */     GIR_EraseRootFromParent_Done,
     /* 148822 */   // Label 2628: @148822
     /* 148822 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148896), // Rule ID 7387 //
     /* 148827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148844 */     // MIs[0] Rn
     /* 148844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148856 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148868 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 148883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148894 */     GIR_RootConstrainSelectedInstOperands,
     /* 148895 */     // GIR_Coverage, 7387,
     /* 148895 */     GIR_EraseRootFromParent_Done,
     /* 148896 */   // Label 2629: @148896
     /* 148896 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148970), // Rule ID 7388 //
     /* 148901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148918 */     // MIs[0] Rn
     /* 148918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148930 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148942 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 148957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148968 */     GIR_RootConstrainSelectedInstOperands,
     /* 148969 */     // GIR_Coverage, 7388,
     /* 148969 */     GIR_EraseRootFromParent_Done,
     /* 148970 */   // Label 2630: @148970
     /* 148970 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(149044), // Rule ID 7389 //
     /* 148975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148992 */     // MIs[0] Rn
     /* 148992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149004 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149016 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 149031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149042 */     GIR_RootConstrainSelectedInstOperands,
     /* 149043 */     // GIR_Coverage, 7389,
     /* 149043 */     GIR_EraseRootFromParent_Done,
     /* 149044 */   // Label 2631: @149044
     /* 149044 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(149118), // Rule ID 7390 //
     /* 149049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149066 */     // MIs[0] Rn
     /* 149066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149078 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149090 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149116 */     GIR_RootConstrainSelectedInstOperands,
     /* 149117 */     // GIR_Coverage, 7390,
     /* 149117 */     GIR_EraseRootFromParent_Done,
     /* 149118 */   // Label 2632: @149118
     /* 149118 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(149192), // Rule ID 7391 //
     /* 149123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149140 */     // MIs[0] Rn
     /* 149140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149152 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149164 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149190 */     GIR_RootConstrainSelectedInstOperands,
     /* 149191 */     // GIR_Coverage, 7391,
     /* 149191 */     GIR_EraseRootFromParent_Done,
     /* 149192 */   // Label 2633: @149192
     /* 149192 */   GIM_Reject,
     /* 149193 */ // Label 2618: @149193
     /* 149193 */ GIM_Reject,
     /* 149194 */ // Label 2616: @149194
     /* 149194 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(149545),
     /* 149199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149209 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(149276), // Rule ID 7372 //
     /* 149214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149224 */     // MIs[0] Rn
     /* 149224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149236 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149248 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 149263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149274 */     GIR_RootConstrainSelectedInstOperands,
     /* 149275 */     // GIR_Coverage, 7372,
     /* 149275 */     GIR_EraseRootFromParent_Done,
     /* 149276 */   // Label 2635: @149276
     /* 149276 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(149343), // Rule ID 7373 //
     /* 149281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149291 */     // MIs[0] Rn
     /* 149291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149303 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149315 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 149330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149341 */     GIR_RootConstrainSelectedInstOperands,
     /* 149342 */     // GIR_Coverage, 7373,
     /* 149342 */     GIR_EraseRootFromParent_Done,
     /* 149343 */   // Label 2636: @149343
     /* 149343 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(149410), // Rule ID 7374 //
     /* 149348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149358 */     // MIs[0] Rn
     /* 149358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149370 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149382 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 149397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149408 */     GIR_RootConstrainSelectedInstOperands,
     /* 149409 */     // GIR_Coverage, 7374,
     /* 149409 */     GIR_EraseRootFromParent_Done,
     /* 149410 */   // Label 2637: @149410
     /* 149410 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(149477), // Rule ID 7375 //
     /* 149415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149425 */     // MIs[0] Rn
     /* 149425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149437 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149449 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149475 */     GIR_RootConstrainSelectedInstOperands,
     /* 149476 */     // GIR_Coverage, 7375,
     /* 149476 */     GIR_EraseRootFromParent_Done,
     /* 149477 */   // Label 2638: @149477
     /* 149477 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(149544), // Rule ID 7376 //
     /* 149482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149492 */     // MIs[0] Rn
     /* 149492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149504 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149516 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149542 */     GIR_RootConstrainSelectedInstOperands,
     /* 149543 */     // GIR_Coverage, 7376,
     /* 149543 */     GIR_EraseRootFromParent_Done,
     /* 149544 */   // Label 2639: @149544
     /* 149544 */   GIM_Reject,
     /* 149545 */ // Label 2634: @149545
     /* 149545 */ GIM_Reject,
     /* 149546 */ // Label 2617: @149546
     /* 149546 */ GIM_Reject,
     /* 149547 */ // Label 24: @149547
     /* 149547 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2642*/ GIMT_Encode4(151038),
     /* 149558 */ /*GILLT_s32*//*Label 2640*/ GIMT_Encode4(149566),
     /* 149562 */ /*GILLT_s64*//*Label 2641*/ GIMT_Encode4(150686),
     /* 149566 */ // Label 2640: @149566
     /* 149566 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(150685),
     /* 149571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149574 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(149648), // Rule ID 7397 //
     /* 149579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149596 */     // MIs[0] Rn
     /* 149596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149608 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149620 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 149635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149646 */     GIR_RootConstrainSelectedInstOperands,
     /* 149647 */     // GIR_Coverage, 7397,
     /* 149647 */     GIR_EraseRootFromParent_Done,
     /* 149648 */   // Label 2644: @149648
     /* 149648 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149722), // Rule ID 7398 //
     /* 149653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149670 */     // MIs[0] Rn
     /* 149670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149682 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149694 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 149709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149720 */     GIR_RootConstrainSelectedInstOperands,
     /* 149721 */     // GIR_Coverage, 7398,
     /* 149721 */     GIR_EraseRootFromParent_Done,
     /* 149722 */   // Label 2645: @149722
     /* 149722 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149796), // Rule ID 7399 //
     /* 149727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149744 */     // MIs[0] Rn
     /* 149744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149756 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149768 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 149783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149794 */     GIR_RootConstrainSelectedInstOperands,
     /* 149795 */     // GIR_Coverage, 7399,
     /* 149795 */     GIR_EraseRootFromParent_Done,
     /* 149796 */   // Label 2646: @149796
     /* 149796 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(149870), // Rule ID 7400 //
     /* 149801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149818 */     // MIs[0] Rn
     /* 149818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149830 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149842 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 149857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149868 */     GIR_RootConstrainSelectedInstOperands,
     /* 149869 */     // GIR_Coverage, 7400,
     /* 149869 */     GIR_EraseRootFromParent_Done,
     /* 149870 */   // Label 2647: @149870
     /* 149870 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(149944), // Rule ID 7401 //
     /* 149875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149892 */     // MIs[0] Rn
     /* 149892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149904 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149916 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 149931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149942 */     GIR_RootConstrainSelectedInstOperands,
     /* 149943 */     // GIR_Coverage, 7401,
     /* 149943 */     GIR_EraseRootFromParent_Done,
     /* 149944 */   // Label 2648: @149944
     /* 149944 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(150018), // Rule ID 7402 //
     /* 149949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149966 */     // MIs[0] Rn
     /* 149966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149978 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149990 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 150005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150016 */     GIR_RootConstrainSelectedInstOperands,
     /* 150017 */     // GIR_Coverage, 7402,
     /* 150017 */     GIR_EraseRootFromParent_Done,
     /* 150018 */   // Label 2649: @150018
     /* 150018 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(150092), // Rule ID 7403 //
     /* 150023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150040 */     // MIs[0] Rn
     /* 150040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150052 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 150079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150090 */     GIR_RootConstrainSelectedInstOperands,
     /* 150091 */     // GIR_Coverage, 7403,
     /* 150091 */     GIR_EraseRootFromParent_Done,
     /* 150092 */   // Label 2650: @150092
     /* 150092 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(150166), // Rule ID 7404 //
     /* 150097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150114 */     // MIs[0] Rn
     /* 150114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150126 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150138 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 150153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150164 */     GIR_RootConstrainSelectedInstOperands,
     /* 150165 */     // GIR_Coverage, 7404,
     /* 150165 */     GIR_EraseRootFromParent_Done,
     /* 150166 */   // Label 2651: @150166
     /* 150166 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(150240), // Rule ID 7405 //
     /* 150171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150188 */     // MIs[0] Rn
     /* 150188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150200 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150212 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150238 */     GIR_RootConstrainSelectedInstOperands,
     /* 150239 */     // GIR_Coverage, 7405,
     /* 150239 */     GIR_EraseRootFromParent_Done,
     /* 150240 */   // Label 2652: @150240
     /* 150240 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(150314), // Rule ID 7406 //
     /* 150245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150262 */     // MIs[0] Rn
     /* 150262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150274 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150286 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150312 */     GIR_RootConstrainSelectedInstOperands,
     /* 150313 */     // GIR_Coverage, 7406,
     /* 150313 */     GIR_EraseRootFromParent_Done,
     /* 150314 */   // Label 2653: @150314
     /* 150314 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(150388), // Rule ID 7407 //
     /* 150319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150336 */     // MIs[0] Rn
     /* 150336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150348 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150360 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 150375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150386 */     GIR_RootConstrainSelectedInstOperands,
     /* 150387 */     // GIR_Coverage, 7407,
     /* 150387 */     GIR_EraseRootFromParent_Done,
     /* 150388 */   // Label 2654: @150388
     /* 150388 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(150462), // Rule ID 7408 //
     /* 150393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150410 */     // MIs[0] Rn
     /* 150410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150422 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150434 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 150449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150460 */     GIR_RootConstrainSelectedInstOperands,
     /* 150461 */     // GIR_Coverage, 7408,
     /* 150461 */     GIR_EraseRootFromParent_Done,
     /* 150462 */   // Label 2655: @150462
     /* 150462 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(150536), // Rule ID 7409 //
     /* 150467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150477 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150484 */     // MIs[0] Rn
     /* 150484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150496 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150508 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 150523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150534 */     GIR_RootConstrainSelectedInstOperands,
     /* 150535 */     // GIR_Coverage, 7409,
     /* 150535 */     GIR_EraseRootFromParent_Done,
     /* 150536 */   // Label 2656: @150536
     /* 150536 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(150610), // Rule ID 7410 //
     /* 150541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150558 */     // MIs[0] Rn
     /* 150558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150570 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150582 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 150597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150608 */     GIR_RootConstrainSelectedInstOperands,
     /* 150609 */     // GIR_Coverage, 7410,
     /* 150609 */     GIR_EraseRootFromParent_Done,
     /* 150610 */   // Label 2657: @150610
     /* 150610 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(150684), // Rule ID 7411 //
     /* 150615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150632 */     // MIs[0] Rn
     /* 150632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150644 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150656 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 150671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150682 */     GIR_RootConstrainSelectedInstOperands,
     /* 150683 */     // GIR_Coverage, 7411,
     /* 150683 */     GIR_EraseRootFromParent_Done,
     /* 150684 */   // Label 2658: @150684
     /* 150684 */   GIM_Reject,
     /* 150685 */ // Label 2643: @150685
     /* 150685 */ GIM_Reject,
     /* 150686 */ // Label 2641: @150686
     /* 150686 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(151037),
     /* 150691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150701 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(150768), // Rule ID 7392 //
     /* 150706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150716 */     // MIs[0] Rn
     /* 150716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150728 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150740 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 150755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150766 */     GIR_RootConstrainSelectedInstOperands,
     /* 150767 */     // GIR_Coverage, 7392,
     /* 150767 */     GIR_EraseRootFromParent_Done,
     /* 150768 */   // Label 2660: @150768
     /* 150768 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(150835), // Rule ID 7393 //
     /* 150773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150783 */     // MIs[0] Rn
     /* 150783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150795 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150807 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 150822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150833 */     GIR_RootConstrainSelectedInstOperands,
     /* 150834 */     // GIR_Coverage, 7393,
     /* 150834 */     GIR_EraseRootFromParent_Done,
     /* 150835 */   // Label 2661: @150835
     /* 150835 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150902), // Rule ID 7394 //
     /* 150840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150850 */     // MIs[0] Rn
     /* 150850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150862 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150874 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 150889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150900 */     GIR_RootConstrainSelectedInstOperands,
     /* 150901 */     // GIR_Coverage, 7394,
     /* 150901 */     GIR_EraseRootFromParent_Done,
     /* 150902 */   // Label 2662: @150902
     /* 150902 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150969), // Rule ID 7395 //
     /* 150907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150917 */     // MIs[0] Rn
     /* 150917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150929 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150941 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 150956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150967 */     GIR_RootConstrainSelectedInstOperands,
     /* 150968 */     // GIR_Coverage, 7395,
     /* 150968 */     GIR_EraseRootFromParent_Done,
     /* 150969 */   // Label 2663: @150969
     /* 150969 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(151036), // Rule ID 7396 //
     /* 150974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150984 */     // MIs[0] Rn
     /* 150984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150996 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151008 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 151023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151034 */     GIR_RootConstrainSelectedInstOperands,
     /* 151035 */     // GIR_Coverage, 7396,
     /* 151035 */     GIR_EraseRootFromParent_Done,
     /* 151036 */   // Label 2664: @151036
     /* 151036 */   GIM_Reject,
     /* 151037 */ // Label 2659: @151037
     /* 151037 */ GIM_Reject,
     /* 151038 */ // Label 2642: @151038
     /* 151038 */ GIM_Reject,
     /* 151039 */ // Label 25: @151039
     /* 151039 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2667*/ GIMT_Encode4(152030),
     /* 151050 */ /*GILLT_s32*//*Label 2665*/ GIMT_Encode4(151058),
     /* 151054 */ /*GILLT_s64*//*Label 2666*/ GIMT_Encode4(151803),
     /* 151058 */ // Label 2665: @151058
     /* 151058 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(151802),
     /* 151063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151066 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(151115), // Rule ID 7202 //
     /* 151071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151088 */     // MIs[0] Rn
     /* 151088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151100 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 151103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151113 */     GIR_RootConstrainSelectedInstOperands,
     /* 151114 */     // GIR_Coverage, 7202,
     /* 151114 */     GIR_EraseRootFromParent_Done,
     /* 151115 */   // Label 2669: @151115
     /* 151115 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(151164), // Rule ID 7203 //
     /* 151120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151137 */     // MIs[0] Rn
     /* 151137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151149 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 151152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151162 */     GIR_RootConstrainSelectedInstOperands,
     /* 151163 */     // GIR_Coverage, 7203,
     /* 151163 */     GIR_EraseRootFromParent_Done,
     /* 151164 */   // Label 2670: @151164
     /* 151164 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(151213), // Rule ID 7204 //
     /* 151169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151186 */     // MIs[0] Rn
     /* 151186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151198 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 151201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151211 */     GIR_RootConstrainSelectedInstOperands,
     /* 151212 */     // GIR_Coverage, 7204,
     /* 151212 */     GIR_EraseRootFromParent_Done,
     /* 151213 */   // Label 2671: @151213
     /* 151213 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(151262), // Rule ID 7205 //
     /* 151218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151235 */     // MIs[0] Rn
     /* 151235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151247 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151260 */     GIR_RootConstrainSelectedInstOperands,
     /* 151261 */     // GIR_Coverage, 7205,
     /* 151261 */     GIR_EraseRootFromParent_Done,
     /* 151262 */   // Label 2672: @151262
     /* 151262 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(151311), // Rule ID 7206 //
     /* 151267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151284 */     // MIs[0] Rn
     /* 151284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151296 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151309 */     GIR_RootConstrainSelectedInstOperands,
     /* 151310 */     // GIR_Coverage, 7206,
     /* 151310 */     GIR_EraseRootFromParent_Done,
     /* 151311 */   // Label 2673: @151311
     /* 151311 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(151360), // Rule ID 7207 //
     /* 151316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151333 */     // MIs[0] Rn
     /* 151333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151345 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 151348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151358 */     GIR_RootConstrainSelectedInstOperands,
     /* 151359 */     // GIR_Coverage, 7207,
     /* 151359 */     GIR_EraseRootFromParent_Done,
     /* 151360 */   // Label 2674: @151360
     /* 151360 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(151409), // Rule ID 7208 //
     /* 151365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151382 */     // MIs[0] Rn
     /* 151382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151394 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 151397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151407 */     GIR_RootConstrainSelectedInstOperands,
     /* 151408 */     // GIR_Coverage, 7208,
     /* 151408 */     GIR_EraseRootFromParent_Done,
     /* 151409 */   // Label 2675: @151409
     /* 151409 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(151458), // Rule ID 7209 //
     /* 151414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151431 */     // MIs[0] Rn
     /* 151431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151443 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 151446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151456 */     GIR_RootConstrainSelectedInstOperands,
     /* 151457 */     // GIR_Coverage, 7209,
     /* 151457 */     GIR_EraseRootFromParent_Done,
     /* 151458 */   // Label 2676: @151458
     /* 151458 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(151507), // Rule ID 7210 //
     /* 151463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151480 */     // MIs[0] Rn
     /* 151480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151492 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151505 */     GIR_RootConstrainSelectedInstOperands,
     /* 151506 */     // GIR_Coverage, 7210,
     /* 151506 */     GIR_EraseRootFromParent_Done,
     /* 151507 */   // Label 2677: @151507
     /* 151507 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(151556), // Rule ID 7211 //
     /* 151512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151529 */     // MIs[0] Rn
     /* 151529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151541 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151554 */     GIR_RootConstrainSelectedInstOperands,
     /* 151555 */     // GIR_Coverage, 7211,
     /* 151555 */     GIR_EraseRootFromParent_Done,
     /* 151556 */   // Label 2678: @151556
     /* 151556 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(151605), // Rule ID 7212 //
     /* 151561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151578 */     // MIs[0] Rn
     /* 151578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151590 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 151593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151603 */     GIR_RootConstrainSelectedInstOperands,
     /* 151604 */     // GIR_Coverage, 7212,
     /* 151604 */     GIR_EraseRootFromParent_Done,
     /* 151605 */   // Label 2679: @151605
     /* 151605 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(151654), // Rule ID 7213 //
     /* 151610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151627 */     // MIs[0] Rn
     /* 151627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151639 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 151642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151652 */     GIR_RootConstrainSelectedInstOperands,
     /* 151653 */     // GIR_Coverage, 7213,
     /* 151653 */     GIR_EraseRootFromParent_Done,
     /* 151654 */   // Label 2680: @151654
     /* 151654 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(151703), // Rule ID 7214 //
     /* 151659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151676 */     // MIs[0] Rn
     /* 151676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151688 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 151691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151701 */     GIR_RootConstrainSelectedInstOperands,
     /* 151702 */     // GIR_Coverage, 7214,
     /* 151702 */     GIR_EraseRootFromParent_Done,
     /* 151703 */   // Label 2681: @151703
     /* 151703 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(151752), // Rule ID 7215 //
     /* 151708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151725 */     // MIs[0] Rn
     /* 151725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151737 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 151740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151750 */     GIR_RootConstrainSelectedInstOperands,
     /* 151751 */     // GIR_Coverage, 7215,
     /* 151751 */     GIR_EraseRootFromParent_Done,
     /* 151752 */   // Label 2682: @151752
     /* 151752 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(151801), // Rule ID 7216 //
     /* 151757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151774 */     // MIs[0] Rn
     /* 151774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151786 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 151789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151799 */     GIR_RootConstrainSelectedInstOperands,
     /* 151800 */     // GIR_Coverage, 7216,
     /* 151800 */     GIR_EraseRootFromParent_Done,
     /* 151801 */   // Label 2683: @151801
     /* 151801 */   GIM_Reject,
     /* 151802 */ // Label 2668: @151802
     /* 151802 */ GIM_Reject,
     /* 151803 */ // Label 2666: @151803
     /* 151803 */ GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(152029),
     /* 151808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151811 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151818 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(151860), // Rule ID 7197 //
     /* 151823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151833 */     // MIs[0] Rn
     /* 151833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151845 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 151848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151858 */     GIR_RootConstrainSelectedInstOperands,
     /* 151859 */     // GIR_Coverage, 7197,
     /* 151859 */     GIR_EraseRootFromParent_Done,
     /* 151860 */   // Label 2685: @151860
     /* 151860 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(151902), // Rule ID 7198 //
     /* 151865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151875 */     // MIs[0] Rn
     /* 151875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151887 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 151890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151900 */     GIR_RootConstrainSelectedInstOperands,
     /* 151901 */     // GIR_Coverage, 7198,
     /* 151901 */     GIR_EraseRootFromParent_Done,
     /* 151902 */   // Label 2686: @151902
     /* 151902 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(151944), // Rule ID 7199 //
     /* 151907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151917 */     // MIs[0] Rn
     /* 151917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151929 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 151932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151942 */     GIR_RootConstrainSelectedInstOperands,
     /* 151943 */     // GIR_Coverage, 7199,
     /* 151943 */     GIR_EraseRootFromParent_Done,
     /* 151944 */   // Label 2687: @151944
     /* 151944 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(151986), // Rule ID 7200 //
     /* 151949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151959 */     // MIs[0] Rn
     /* 151959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151971 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 151974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151984 */     GIR_RootConstrainSelectedInstOperands,
     /* 151985 */     // GIR_Coverage, 7200,
     /* 151985 */     GIR_EraseRootFromParent_Done,
     /* 151986 */   // Label 2688: @151986
     /* 151986 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(152028), // Rule ID 7201 //
     /* 151991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152001 */     // MIs[0] Rn
     /* 152001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152013 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 152016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152026 */     GIR_RootConstrainSelectedInstOperands,
     /* 152027 */     // GIR_Coverage, 7201,
     /* 152027 */     GIR_EraseRootFromParent_Done,
     /* 152028 */   // Label 2689: @152028
     /* 152028 */   GIM_Reject,
     /* 152029 */ // Label 2684: @152029
     /* 152029 */ GIM_Reject,
     /* 152030 */ // Label 2667: @152030
     /* 152030 */ GIM_Reject,
     /* 152031 */ // Label 26: @152031
     /* 152031 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2692*/ GIMT_Encode4(153022),
     /* 152042 */ /*GILLT_s32*//*Label 2690*/ GIMT_Encode4(152050),
     /* 152046 */ /*GILLT_s64*//*Label 2691*/ GIMT_Encode4(152795),
     /* 152050 */ // Label 2690: @152050
     /* 152050 */ GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(152794),
     /* 152055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152058 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(152107), // Rule ID 7222 //
     /* 152063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152080 */     // MIs[0] Rn
     /* 152080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152092 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 152095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152105 */     GIR_RootConstrainSelectedInstOperands,
     /* 152106 */     // GIR_Coverage, 7222,
     /* 152106 */     GIR_EraseRootFromParent_Done,
     /* 152107 */   // Label 2694: @152107
     /* 152107 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(152156), // Rule ID 7223 //
     /* 152112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152129 */     // MIs[0] Rn
     /* 152129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152141 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 152144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152154 */     GIR_RootConstrainSelectedInstOperands,
     /* 152155 */     // GIR_Coverage, 7223,
     /* 152155 */     GIR_EraseRootFromParent_Done,
     /* 152156 */   // Label 2695: @152156
     /* 152156 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(152205), // Rule ID 7224 //
     /* 152161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152178 */     // MIs[0] Rn
     /* 152178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152190 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 152193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152203 */     GIR_RootConstrainSelectedInstOperands,
     /* 152204 */     // GIR_Coverage, 7224,
     /* 152204 */     GIR_EraseRootFromParent_Done,
     /* 152205 */   // Label 2696: @152205
     /* 152205 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(152254), // Rule ID 7225 //
     /* 152210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152227 */     // MIs[0] Rn
     /* 152227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152239 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152252 */     GIR_RootConstrainSelectedInstOperands,
     /* 152253 */     // GIR_Coverage, 7225,
     /* 152253 */     GIR_EraseRootFromParent_Done,
     /* 152254 */   // Label 2697: @152254
     /* 152254 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(152303), // Rule ID 7226 //
     /* 152259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152276 */     // MIs[0] Rn
     /* 152276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152288 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152301 */     GIR_RootConstrainSelectedInstOperands,
     /* 152302 */     // GIR_Coverage, 7226,
     /* 152302 */     GIR_EraseRootFromParent_Done,
     /* 152303 */   // Label 2698: @152303
     /* 152303 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(152352), // Rule ID 7227 //
     /* 152308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152325 */     // MIs[0] Rn
     /* 152325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152337 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 152340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152350 */     GIR_RootConstrainSelectedInstOperands,
     /* 152351 */     // GIR_Coverage, 7227,
     /* 152351 */     GIR_EraseRootFromParent_Done,
     /* 152352 */   // Label 2699: @152352
     /* 152352 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(152401), // Rule ID 7228 //
     /* 152357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152374 */     // MIs[0] Rn
     /* 152374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152386 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 152389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152399 */     GIR_RootConstrainSelectedInstOperands,
     /* 152400 */     // GIR_Coverage, 7228,
     /* 152400 */     GIR_EraseRootFromParent_Done,
     /* 152401 */   // Label 2700: @152401
     /* 152401 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(152450), // Rule ID 7229 //
     /* 152406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152423 */     // MIs[0] Rn
     /* 152423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152435 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 152438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152448 */     GIR_RootConstrainSelectedInstOperands,
     /* 152449 */     // GIR_Coverage, 7229,
     /* 152449 */     GIR_EraseRootFromParent_Done,
     /* 152450 */   // Label 2701: @152450
     /* 152450 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(152499), // Rule ID 7230 //
     /* 152455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152472 */     // MIs[0] Rn
     /* 152472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152484 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152497 */     GIR_RootConstrainSelectedInstOperands,
     /* 152498 */     // GIR_Coverage, 7230,
     /* 152498 */     GIR_EraseRootFromParent_Done,
     /* 152499 */   // Label 2702: @152499
     /* 152499 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(152548), // Rule ID 7231 //
     /* 152504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152521 */     // MIs[0] Rn
     /* 152521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152533 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152546 */     GIR_RootConstrainSelectedInstOperands,
     /* 152547 */     // GIR_Coverage, 7231,
     /* 152547 */     GIR_EraseRootFromParent_Done,
     /* 152548 */   // Label 2703: @152548
     /* 152548 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(152597), // Rule ID 7232 //
     /* 152553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152570 */     // MIs[0] Rn
     /* 152570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152582 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 152585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152595 */     GIR_RootConstrainSelectedInstOperands,
     /* 152596 */     // GIR_Coverage, 7232,
     /* 152596 */     GIR_EraseRootFromParent_Done,
     /* 152597 */   // Label 2704: @152597
     /* 152597 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(152646), // Rule ID 7233 //
     /* 152602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152619 */     // MIs[0] Rn
     /* 152619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152631 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 152634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152644 */     GIR_RootConstrainSelectedInstOperands,
     /* 152645 */     // GIR_Coverage, 7233,
     /* 152645 */     GIR_EraseRootFromParent_Done,
     /* 152646 */   // Label 2705: @152646
     /* 152646 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(152695), // Rule ID 7234 //
     /* 152651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152668 */     // MIs[0] Rn
     /* 152668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152680 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 152683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152693 */     GIR_RootConstrainSelectedInstOperands,
     /* 152694 */     // GIR_Coverage, 7234,
     /* 152694 */     GIR_EraseRootFromParent_Done,
     /* 152695 */   // Label 2706: @152695
     /* 152695 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(152744), // Rule ID 7235 //
     /* 152700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152717 */     // MIs[0] Rn
     /* 152717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152729 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 152732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152742 */     GIR_RootConstrainSelectedInstOperands,
     /* 152743 */     // GIR_Coverage, 7235,
     /* 152743 */     GIR_EraseRootFromParent_Done,
     /* 152744 */   // Label 2707: @152744
     /* 152744 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(152793), // Rule ID 7236 //
     /* 152749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152766 */     // MIs[0] Rn
     /* 152766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152778 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 152781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152791 */     GIR_RootConstrainSelectedInstOperands,
     /* 152792 */     // GIR_Coverage, 7236,
     /* 152792 */     GIR_EraseRootFromParent_Done,
     /* 152793 */   // Label 2708: @152793
     /* 152793 */   GIM_Reject,
     /* 152794 */ // Label 2693: @152794
     /* 152794 */ GIM_Reject,
     /* 152795 */ // Label 2691: @152795
     /* 152795 */ GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(153021),
     /* 152800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152810 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(152852), // Rule ID 7217 //
     /* 152815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152825 */     // MIs[0] Rn
     /* 152825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152837 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 152840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152850 */     GIR_RootConstrainSelectedInstOperands,
     /* 152851 */     // GIR_Coverage, 7217,
     /* 152851 */     GIR_EraseRootFromParent_Done,
     /* 152852 */   // Label 2710: @152852
     /* 152852 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(152894), // Rule ID 7218 //
     /* 152857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152867 */     // MIs[0] Rn
     /* 152867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152879 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 152882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152892 */     GIR_RootConstrainSelectedInstOperands,
     /* 152893 */     // GIR_Coverage, 7218,
     /* 152893 */     GIR_EraseRootFromParent_Done,
     /* 152894 */   // Label 2711: @152894
     /* 152894 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(152936), // Rule ID 7219 //
     /* 152899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152909 */     // MIs[0] Rn
     /* 152909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152921 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 152924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152934 */     GIR_RootConstrainSelectedInstOperands,
     /* 152935 */     // GIR_Coverage, 7219,
     /* 152935 */     GIR_EraseRootFromParent_Done,
     /* 152936 */   // Label 2712: @152936
     /* 152936 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(152978), // Rule ID 7220 //
     /* 152941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152951 */     // MIs[0] Rn
     /* 152951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152963 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 152966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152976 */     GIR_RootConstrainSelectedInstOperands,
     /* 152977 */     // GIR_Coverage, 7220,
     /* 152977 */     GIR_EraseRootFromParent_Done,
     /* 152978 */   // Label 2713: @152978
     /* 152978 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(153020), // Rule ID 7221 //
     /* 152983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152986 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152993 */     // MIs[0] Rn
     /* 152993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153005 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 153008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153018 */     GIR_RootConstrainSelectedInstOperands,
     /* 153019 */     // GIR_Coverage, 7221,
     /* 153019 */     GIR_EraseRootFromParent_Done,
     /* 153020 */   // Label 2714: @153020
     /* 153020 */   GIM_Reject,
     /* 153021 */ // Label 2709: @153021
     /* 153021 */ GIM_Reject,
     /* 153022 */ // Label 2692: @153022
     /* 153022 */ GIM_Reject,
     /* 153023 */ // Label 27: @153023
     /* 153023 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2717*/ GIMT_Encode4(154014),
     /* 153034 */ /*GILLT_s32*//*Label 2715*/ GIMT_Encode4(153042),
     /* 153038 */ /*GILLT_s64*//*Label 2716*/ GIMT_Encode4(153787),
     /* 153042 */ // Label 2715: @153042
     /* 153042 */ GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(153786),
     /* 153047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153050 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(153099), // Rule ID 7262 //
     /* 153055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153072 */     // MIs[0] Rn
     /* 153072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153084 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 153087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153097 */     GIR_RootConstrainSelectedInstOperands,
     /* 153098 */     // GIR_Coverage, 7262,
     /* 153098 */     GIR_EraseRootFromParent_Done,
     /* 153099 */   // Label 2719: @153099
     /* 153099 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(153148), // Rule ID 7263 //
     /* 153104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153121 */     // MIs[0] Rn
     /* 153121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153133 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 153136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153146 */     GIR_RootConstrainSelectedInstOperands,
     /* 153147 */     // GIR_Coverage, 7263,
     /* 153147 */     GIR_EraseRootFromParent_Done,
     /* 153148 */   // Label 2720: @153148
     /* 153148 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(153197), // Rule ID 7264 //
     /* 153153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153170 */     // MIs[0] Rn
     /* 153170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153182 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 153185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153195 */     GIR_RootConstrainSelectedInstOperands,
     /* 153196 */     // GIR_Coverage, 7264,
     /* 153196 */     GIR_EraseRootFromParent_Done,
     /* 153197 */   // Label 2721: @153197
     /* 153197 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(153246), // Rule ID 7265 //
     /* 153202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153219 */     // MIs[0] Rn
     /* 153219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153231 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153244 */     GIR_RootConstrainSelectedInstOperands,
     /* 153245 */     // GIR_Coverage, 7265,
     /* 153245 */     GIR_EraseRootFromParent_Done,
     /* 153246 */   // Label 2722: @153246
     /* 153246 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(153295), // Rule ID 7266 //
     /* 153251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153268 */     // MIs[0] Rn
     /* 153268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153280 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153293 */     GIR_RootConstrainSelectedInstOperands,
     /* 153294 */     // GIR_Coverage, 7266,
     /* 153294 */     GIR_EraseRootFromParent_Done,
     /* 153295 */   // Label 2723: @153295
     /* 153295 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(153344), // Rule ID 7267 //
     /* 153300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153317 */     // MIs[0] Rn
     /* 153317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153329 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 153332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153342 */     GIR_RootConstrainSelectedInstOperands,
     /* 153343 */     // GIR_Coverage, 7267,
     /* 153343 */     GIR_EraseRootFromParent_Done,
     /* 153344 */   // Label 2724: @153344
     /* 153344 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(153393), // Rule ID 7268 //
     /* 153349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153366 */     // MIs[0] Rn
     /* 153366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153378 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 153381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153391 */     GIR_RootConstrainSelectedInstOperands,
     /* 153392 */     // GIR_Coverage, 7268,
     /* 153392 */     GIR_EraseRootFromParent_Done,
     /* 153393 */   // Label 2725: @153393
     /* 153393 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(153442), // Rule ID 7269 //
     /* 153398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153415 */     // MIs[0] Rn
     /* 153415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153427 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 153430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153440 */     GIR_RootConstrainSelectedInstOperands,
     /* 153441 */     // GIR_Coverage, 7269,
     /* 153441 */     GIR_EraseRootFromParent_Done,
     /* 153442 */   // Label 2726: @153442
     /* 153442 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(153491), // Rule ID 7270 //
     /* 153447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153464 */     // MIs[0] Rn
     /* 153464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153476 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153489 */     GIR_RootConstrainSelectedInstOperands,
     /* 153490 */     // GIR_Coverage, 7270,
     /* 153490 */     GIR_EraseRootFromParent_Done,
     /* 153491 */   // Label 2727: @153491
     /* 153491 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153540), // Rule ID 7271 //
     /* 153496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153513 */     // MIs[0] Rn
     /* 153513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153525 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153538 */     GIR_RootConstrainSelectedInstOperands,
     /* 153539 */     // GIR_Coverage, 7271,
     /* 153539 */     GIR_EraseRootFromParent_Done,
     /* 153540 */   // Label 2728: @153540
     /* 153540 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(153589), // Rule ID 7272 //
     /* 153545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153562 */     // MIs[0] Rn
     /* 153562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153574 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 153577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153587 */     GIR_RootConstrainSelectedInstOperands,
     /* 153588 */     // GIR_Coverage, 7272,
     /* 153588 */     GIR_EraseRootFromParent_Done,
     /* 153589 */   // Label 2729: @153589
     /* 153589 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(153638), // Rule ID 7273 //
     /* 153594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153611 */     // MIs[0] Rn
     /* 153611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153623 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 153626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153636 */     GIR_RootConstrainSelectedInstOperands,
     /* 153637 */     // GIR_Coverage, 7273,
     /* 153637 */     GIR_EraseRootFromParent_Done,
     /* 153638 */   // Label 2730: @153638
     /* 153638 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(153687), // Rule ID 7274 //
     /* 153643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153660 */     // MIs[0] Rn
     /* 153660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153672 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 153675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153685 */     GIR_RootConstrainSelectedInstOperands,
     /* 153686 */     // GIR_Coverage, 7274,
     /* 153686 */     GIR_EraseRootFromParent_Done,
     /* 153687 */   // Label 2731: @153687
     /* 153687 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(153736), // Rule ID 7275 //
     /* 153692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153709 */     // MIs[0] Rn
     /* 153709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153721 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 153724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153734 */     GIR_RootConstrainSelectedInstOperands,
     /* 153735 */     // GIR_Coverage, 7275,
     /* 153735 */     GIR_EraseRootFromParent_Done,
     /* 153736 */   // Label 2732: @153736
     /* 153736 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(153785), // Rule ID 7276 //
     /* 153741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153758 */     // MIs[0] Rn
     /* 153758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153770 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 153773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153783 */     GIR_RootConstrainSelectedInstOperands,
     /* 153784 */     // GIR_Coverage, 7276,
     /* 153784 */     GIR_EraseRootFromParent_Done,
     /* 153785 */   // Label 2733: @153785
     /* 153785 */   GIM_Reject,
     /* 153786 */ // Label 2718: @153786
     /* 153786 */ GIM_Reject,
     /* 153787 */ // Label 2716: @153787
     /* 153787 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(154013),
     /* 153792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153795 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153802 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(153844), // Rule ID 7257 //
     /* 153807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153817 */     // MIs[0] Rn
     /* 153817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153829 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 153832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153842 */     GIR_RootConstrainSelectedInstOperands,
     /* 153843 */     // GIR_Coverage, 7257,
     /* 153843 */     GIR_EraseRootFromParent_Done,
     /* 153844 */   // Label 2735: @153844
     /* 153844 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(153886), // Rule ID 7258 //
     /* 153849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153859 */     // MIs[0] Rn
     /* 153859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153871 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 153874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153884 */     GIR_RootConstrainSelectedInstOperands,
     /* 153885 */     // GIR_Coverage, 7258,
     /* 153885 */     GIR_EraseRootFromParent_Done,
     /* 153886 */   // Label 2736: @153886
     /* 153886 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(153928), // Rule ID 7259 //
     /* 153891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153901 */     // MIs[0] Rn
     /* 153901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153913 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 153916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153926 */     GIR_RootConstrainSelectedInstOperands,
     /* 153927 */     // GIR_Coverage, 7259,
     /* 153927 */     GIR_EraseRootFromParent_Done,
     /* 153928 */   // Label 2737: @153928
     /* 153928 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(153970), // Rule ID 7260 //
     /* 153933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153943 */     // MIs[0] Rn
     /* 153943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153955 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 153958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153968 */     GIR_RootConstrainSelectedInstOperands,
     /* 153969 */     // GIR_Coverage, 7260,
     /* 153969 */     GIR_EraseRootFromParent_Done,
     /* 153970 */   // Label 2738: @153970
     /* 153970 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(154012), // Rule ID 7261 //
     /* 153975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153978 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153985 */     // MIs[0] Rn
     /* 153985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153997 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 154000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154010 */     GIR_RootConstrainSelectedInstOperands,
     /* 154011 */     // GIR_Coverage, 7261,
     /* 154011 */     GIR_EraseRootFromParent_Done,
     /* 154012 */   // Label 2739: @154012
     /* 154012 */   GIM_Reject,
     /* 154013 */ // Label 2734: @154013
     /* 154013 */ GIM_Reject,
     /* 154014 */ // Label 2717: @154014
     /* 154014 */ GIM_Reject,
     /* 154015 */ // Label 28: @154015
     /* 154015 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2742*/ GIMT_Encode4(155006),
     /* 154026 */ /*GILLT_s32*//*Label 2740*/ GIMT_Encode4(154034),
     /* 154030 */ /*GILLT_s64*//*Label 2741*/ GIMT_Encode4(154779),
     /* 154034 */ // Label 2740: @154034
     /* 154034 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(154778),
     /* 154039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154042 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(154091), // Rule ID 7282 //
     /* 154047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154064 */     // MIs[0] Rn
     /* 154064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154076 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 154079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154089 */     GIR_RootConstrainSelectedInstOperands,
     /* 154090 */     // GIR_Coverage, 7282,
     /* 154090 */     GIR_EraseRootFromParent_Done,
     /* 154091 */   // Label 2744: @154091
     /* 154091 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(154140), // Rule ID 7283 //
     /* 154096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154106 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154113 */     // MIs[0] Rn
     /* 154113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154125 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 154128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154138 */     GIR_RootConstrainSelectedInstOperands,
     /* 154139 */     // GIR_Coverage, 7283,
     /* 154139 */     GIR_EraseRootFromParent_Done,
     /* 154140 */   // Label 2745: @154140
     /* 154140 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154189), // Rule ID 7284 //
     /* 154145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154162 */     // MIs[0] Rn
     /* 154162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154174 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 154177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154187 */     GIR_RootConstrainSelectedInstOperands,
     /* 154188 */     // GIR_Coverage, 7284,
     /* 154188 */     GIR_EraseRootFromParent_Done,
     /* 154189 */   // Label 2746: @154189
     /* 154189 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(154238), // Rule ID 7285 //
     /* 154194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154211 */     // MIs[0] Rn
     /* 154211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154223 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154236 */     GIR_RootConstrainSelectedInstOperands,
     /* 154237 */     // GIR_Coverage, 7285,
     /* 154237 */     GIR_EraseRootFromParent_Done,
     /* 154238 */   // Label 2747: @154238
     /* 154238 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(154287), // Rule ID 7286 //
     /* 154243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154260 */     // MIs[0] Rn
     /* 154260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154272 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154285 */     GIR_RootConstrainSelectedInstOperands,
     /* 154286 */     // GIR_Coverage, 7286,
     /* 154286 */     GIR_EraseRootFromParent_Done,
     /* 154287 */   // Label 2748: @154287
     /* 154287 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(154336), // Rule ID 7287 //
     /* 154292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154309 */     // MIs[0] Rn
     /* 154309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154321 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 154324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154334 */     GIR_RootConstrainSelectedInstOperands,
     /* 154335 */     // GIR_Coverage, 7287,
     /* 154335 */     GIR_EraseRootFromParent_Done,
     /* 154336 */   // Label 2749: @154336
     /* 154336 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(154385), // Rule ID 7288 //
     /* 154341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154358 */     // MIs[0] Rn
     /* 154358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154370 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 154373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154383 */     GIR_RootConstrainSelectedInstOperands,
     /* 154384 */     // GIR_Coverage, 7288,
     /* 154384 */     GIR_EraseRootFromParent_Done,
     /* 154385 */   // Label 2750: @154385
     /* 154385 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(154434), // Rule ID 7289 //
     /* 154390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154407 */     // MIs[0] Rn
     /* 154407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154419 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 154422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154432 */     GIR_RootConstrainSelectedInstOperands,
     /* 154433 */     // GIR_Coverage, 7289,
     /* 154433 */     GIR_EraseRootFromParent_Done,
     /* 154434 */   // Label 2751: @154434
     /* 154434 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(154483), // Rule ID 7290 //
     /* 154439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154456 */     // MIs[0] Rn
     /* 154456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154468 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154481 */     GIR_RootConstrainSelectedInstOperands,
     /* 154482 */     // GIR_Coverage, 7290,
     /* 154482 */     GIR_EraseRootFromParent_Done,
     /* 154483 */   // Label 2752: @154483
     /* 154483 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(154532), // Rule ID 7291 //
     /* 154488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154505 */     // MIs[0] Rn
     /* 154505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154517 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154530 */     GIR_RootConstrainSelectedInstOperands,
     /* 154531 */     // GIR_Coverage, 7291,
     /* 154531 */     GIR_EraseRootFromParent_Done,
     /* 154532 */   // Label 2753: @154532
     /* 154532 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(154581), // Rule ID 7292 //
     /* 154537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154554 */     // MIs[0] Rn
     /* 154554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154566 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 154569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154579 */     GIR_RootConstrainSelectedInstOperands,
     /* 154580 */     // GIR_Coverage, 7292,
     /* 154580 */     GIR_EraseRootFromParent_Done,
     /* 154581 */   // Label 2754: @154581
     /* 154581 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(154630), // Rule ID 7293 //
     /* 154586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154603 */     // MIs[0] Rn
     /* 154603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154615 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 154618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154628 */     GIR_RootConstrainSelectedInstOperands,
     /* 154629 */     // GIR_Coverage, 7293,
     /* 154629 */     GIR_EraseRootFromParent_Done,
     /* 154630 */   // Label 2755: @154630
     /* 154630 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(154679), // Rule ID 7294 //
     /* 154635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154652 */     // MIs[0] Rn
     /* 154652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154664 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 154667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154677 */     GIR_RootConstrainSelectedInstOperands,
     /* 154678 */     // GIR_Coverage, 7294,
     /* 154678 */     GIR_EraseRootFromParent_Done,
     /* 154679 */   // Label 2756: @154679
     /* 154679 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(154728), // Rule ID 7295 //
     /* 154684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154701 */     // MIs[0] Rn
     /* 154701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154713 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 154716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154726 */     GIR_RootConstrainSelectedInstOperands,
     /* 154727 */     // GIR_Coverage, 7295,
     /* 154727 */     GIR_EraseRootFromParent_Done,
     /* 154728 */   // Label 2757: @154728
     /* 154728 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(154777), // Rule ID 7296 //
     /* 154733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154750 */     // MIs[0] Rn
     /* 154750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154762 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 154765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154775 */     GIR_RootConstrainSelectedInstOperands,
     /* 154776 */     // GIR_Coverage, 7296,
     /* 154776 */     GIR_EraseRootFromParent_Done,
     /* 154777 */   // Label 2758: @154777
     /* 154777 */   GIM_Reject,
     /* 154778 */ // Label 2743: @154778
     /* 154778 */ GIM_Reject,
     /* 154779 */ // Label 2741: @154779
     /* 154779 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(155005),
     /* 154784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154794 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(154836), // Rule ID 7277 //
     /* 154799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154809 */     // MIs[0] Rn
     /* 154809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154821 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 154824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154834 */     GIR_RootConstrainSelectedInstOperands,
     /* 154835 */     // GIR_Coverage, 7277,
     /* 154835 */     GIR_EraseRootFromParent_Done,
     /* 154836 */   // Label 2760: @154836
     /* 154836 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(154878), // Rule ID 7278 //
     /* 154841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154851 */     // MIs[0] Rn
     /* 154851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154863 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 154866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154876 */     GIR_RootConstrainSelectedInstOperands,
     /* 154877 */     // GIR_Coverage, 7278,
     /* 154877 */     GIR_EraseRootFromParent_Done,
     /* 154878 */   // Label 2761: @154878
     /* 154878 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(154920), // Rule ID 7279 //
     /* 154883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154893 */     // MIs[0] Rn
     /* 154893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154905 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 154908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154918 */     GIR_RootConstrainSelectedInstOperands,
     /* 154919 */     // GIR_Coverage, 7279,
     /* 154919 */     GIR_EraseRootFromParent_Done,
     /* 154920 */   // Label 2762: @154920
     /* 154920 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(154962), // Rule ID 7280 //
     /* 154925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154935 */     // MIs[0] Rn
     /* 154935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154947 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 154950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154960 */     GIR_RootConstrainSelectedInstOperands,
     /* 154961 */     // GIR_Coverage, 7280,
     /* 154961 */     GIR_EraseRootFromParent_Done,
     /* 154962 */   // Label 2763: @154962
     /* 154962 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(155004), // Rule ID 7281 //
     /* 154967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154977 */     // MIs[0] Rn
     /* 154977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154989 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 154992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155002 */     GIR_RootConstrainSelectedInstOperands,
     /* 155003 */     // GIR_Coverage, 7281,
     /* 155003 */     GIR_EraseRootFromParent_Done,
     /* 155004 */   // Label 2764: @155004
     /* 155004 */   GIM_Reject,
     /* 155005 */ // Label 2759: @155005
     /* 155005 */ GIM_Reject,
     /* 155006 */ // Label 2742: @155006
     /* 155006 */ GIM_Reject,
     /* 155007 */ // Label 29: @155007
     /* 155007 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2767*/ GIMT_Encode4(155998),
     /* 155018 */ /*GILLT_s32*//*Label 2765*/ GIMT_Encode4(155026),
     /* 155022 */ /*GILLT_s64*//*Label 2766*/ GIMT_Encode4(155771),
     /* 155026 */ // Label 2765: @155026
     /* 155026 */ GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(155770),
     /* 155031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155034 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(155083), // Rule ID 7302 //
     /* 155039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155056 */     // MIs[0] Rn
     /* 155056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155068 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 155071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155081 */     GIR_RootConstrainSelectedInstOperands,
     /* 155082 */     // GIR_Coverage, 7302,
     /* 155082 */     GIR_EraseRootFromParent_Done,
     /* 155083 */   // Label 2769: @155083
     /* 155083 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(155132), // Rule ID 7303 //
     /* 155088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155105 */     // MIs[0] Rn
     /* 155105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155117 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 155120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155130 */     GIR_RootConstrainSelectedInstOperands,
     /* 155131 */     // GIR_Coverage, 7303,
     /* 155131 */     GIR_EraseRootFromParent_Done,
     /* 155132 */   // Label 2770: @155132
     /* 155132 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(155181), // Rule ID 7304 //
     /* 155137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155154 */     // MIs[0] Rn
     /* 155154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155166 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 155169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155179 */     GIR_RootConstrainSelectedInstOperands,
     /* 155180 */     // GIR_Coverage, 7304,
     /* 155180 */     GIR_EraseRootFromParent_Done,
     /* 155181 */   // Label 2771: @155181
     /* 155181 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(155230), // Rule ID 7305 //
     /* 155186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155203 */     // MIs[0] Rn
     /* 155203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155215 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155228 */     GIR_RootConstrainSelectedInstOperands,
     /* 155229 */     // GIR_Coverage, 7305,
     /* 155229 */     GIR_EraseRootFromParent_Done,
     /* 155230 */   // Label 2772: @155230
     /* 155230 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(155279), // Rule ID 7306 //
     /* 155235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155252 */     // MIs[0] Rn
     /* 155252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155264 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155277 */     GIR_RootConstrainSelectedInstOperands,
     /* 155278 */     // GIR_Coverage, 7306,
     /* 155278 */     GIR_EraseRootFromParent_Done,
     /* 155279 */   // Label 2773: @155279
     /* 155279 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(155328), // Rule ID 7307 //
     /* 155284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155301 */     // MIs[0] Rn
     /* 155301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155313 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 155316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155326 */     GIR_RootConstrainSelectedInstOperands,
     /* 155327 */     // GIR_Coverage, 7307,
     /* 155327 */     GIR_EraseRootFromParent_Done,
     /* 155328 */   // Label 2774: @155328
     /* 155328 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(155377), // Rule ID 7308 //
     /* 155333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155350 */     // MIs[0] Rn
     /* 155350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155362 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 155365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155375 */     GIR_RootConstrainSelectedInstOperands,
     /* 155376 */     // GIR_Coverage, 7308,
     /* 155376 */     GIR_EraseRootFromParent_Done,
     /* 155377 */   // Label 2775: @155377
     /* 155377 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(155426), // Rule ID 7309 //
     /* 155382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155399 */     // MIs[0] Rn
     /* 155399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155411 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 155414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155424 */     GIR_RootConstrainSelectedInstOperands,
     /* 155425 */     // GIR_Coverage, 7309,
     /* 155425 */     GIR_EraseRootFromParent_Done,
     /* 155426 */   // Label 2776: @155426
     /* 155426 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(155475), // Rule ID 7310 //
     /* 155431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155448 */     // MIs[0] Rn
     /* 155448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155460 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155473 */     GIR_RootConstrainSelectedInstOperands,
     /* 155474 */     // GIR_Coverage, 7310,
     /* 155474 */     GIR_EraseRootFromParent_Done,
     /* 155475 */   // Label 2777: @155475
     /* 155475 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(155524), // Rule ID 7311 //
     /* 155480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155497 */     // MIs[0] Rn
     /* 155497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155509 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155522 */     GIR_RootConstrainSelectedInstOperands,
     /* 155523 */     // GIR_Coverage, 7311,
     /* 155523 */     GIR_EraseRootFromParent_Done,
     /* 155524 */   // Label 2778: @155524
     /* 155524 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(155573), // Rule ID 7312 //
     /* 155529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155546 */     // MIs[0] Rn
     /* 155546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155558 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 155561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155571 */     GIR_RootConstrainSelectedInstOperands,
     /* 155572 */     // GIR_Coverage, 7312,
     /* 155572 */     GIR_EraseRootFromParent_Done,
     /* 155573 */   // Label 2779: @155573
     /* 155573 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(155622), // Rule ID 7313 //
     /* 155578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155595 */     // MIs[0] Rn
     /* 155595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155607 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 155610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155620 */     GIR_RootConstrainSelectedInstOperands,
     /* 155621 */     // GIR_Coverage, 7313,
     /* 155621 */     GIR_EraseRootFromParent_Done,
     /* 155622 */   // Label 2780: @155622
     /* 155622 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(155671), // Rule ID 7314 //
     /* 155627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155644 */     // MIs[0] Rn
     /* 155644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155656 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 155659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155669 */     GIR_RootConstrainSelectedInstOperands,
     /* 155670 */     // GIR_Coverage, 7314,
     /* 155670 */     GIR_EraseRootFromParent_Done,
     /* 155671 */   // Label 2781: @155671
     /* 155671 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(155720), // Rule ID 7315 //
     /* 155676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155693 */     // MIs[0] Rn
     /* 155693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155705 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 155708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155718 */     GIR_RootConstrainSelectedInstOperands,
     /* 155719 */     // GIR_Coverage, 7315,
     /* 155719 */     GIR_EraseRootFromParent_Done,
     /* 155720 */   // Label 2782: @155720
     /* 155720 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(155769), // Rule ID 7316 //
     /* 155725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155742 */     // MIs[0] Rn
     /* 155742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155754 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 155757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155767 */     GIR_RootConstrainSelectedInstOperands,
     /* 155768 */     // GIR_Coverage, 7316,
     /* 155768 */     GIR_EraseRootFromParent_Done,
     /* 155769 */   // Label 2783: @155769
     /* 155769 */   GIM_Reject,
     /* 155770 */ // Label 2768: @155770
     /* 155770 */ GIM_Reject,
     /* 155771 */ // Label 2766: @155771
     /* 155771 */ GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(155997),
     /* 155776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155779 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155786 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(155828), // Rule ID 7297 //
     /* 155791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155801 */     // MIs[0] Rn
     /* 155801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155813 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 155816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155826 */     GIR_RootConstrainSelectedInstOperands,
     /* 155827 */     // GIR_Coverage, 7297,
     /* 155827 */     GIR_EraseRootFromParent_Done,
     /* 155828 */   // Label 2785: @155828
     /* 155828 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155870), // Rule ID 7298 //
     /* 155833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155843 */     // MIs[0] Rn
     /* 155843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155855 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 155858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155868 */     GIR_RootConstrainSelectedInstOperands,
     /* 155869 */     // GIR_Coverage, 7298,
     /* 155869 */     GIR_EraseRootFromParent_Done,
     /* 155870 */   // Label 2786: @155870
     /* 155870 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155912), // Rule ID 7299 //
     /* 155875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155885 */     // MIs[0] Rn
     /* 155885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155897 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 155900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155910 */     GIR_RootConstrainSelectedInstOperands,
     /* 155911 */     // GIR_Coverage, 7299,
     /* 155911 */     GIR_EraseRootFromParent_Done,
     /* 155912 */   // Label 2787: @155912
     /* 155912 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155954), // Rule ID 7300 //
     /* 155917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155927 */     // MIs[0] Rn
     /* 155927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155939 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 155942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155952 */     GIR_RootConstrainSelectedInstOperands,
     /* 155953 */     // GIR_Coverage, 7300,
     /* 155953 */     GIR_EraseRootFromParent_Done,
     /* 155954 */   // Label 2788: @155954
     /* 155954 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155996), // Rule ID 7301 //
     /* 155959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155962 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155969 */     // MIs[0] Rn
     /* 155969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155981 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 155984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155994 */     GIR_RootConstrainSelectedInstOperands,
     /* 155995 */     // GIR_Coverage, 7301,
     /* 155995 */     GIR_EraseRootFromParent_Done,
     /* 155996 */   // Label 2789: @155996
     /* 155996 */   GIM_Reject,
     /* 155997 */ // Label 2784: @155997
     /* 155997 */ GIM_Reject,
     /* 155998 */ // Label 2767: @155998
     /* 155998 */ GIM_Reject,
     /* 155999 */ // Label 30: @155999
     /* 155999 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2792*/ GIMT_Encode4(156990),
     /* 156010 */ /*GILLT_s32*//*Label 2790*/ GIMT_Encode4(156018),
     /* 156014 */ /*GILLT_s64*//*Label 2791*/ GIMT_Encode4(156763),
     /* 156018 */ // Label 2790: @156018
     /* 156018 */ GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(156762),
     /* 156023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156026 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(156075), // Rule ID 7322 //
     /* 156031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156048 */     // MIs[0] Rn
     /* 156048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156060 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 156063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156073 */     GIR_RootConstrainSelectedInstOperands,
     /* 156074 */     // GIR_Coverage, 7322,
     /* 156074 */     GIR_EraseRootFromParent_Done,
     /* 156075 */   // Label 2794: @156075
     /* 156075 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(156124), // Rule ID 7323 //
     /* 156080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156097 */     // MIs[0] Rn
     /* 156097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156109 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 156112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156122 */     GIR_RootConstrainSelectedInstOperands,
     /* 156123 */     // GIR_Coverage, 7323,
     /* 156123 */     GIR_EraseRootFromParent_Done,
     /* 156124 */   // Label 2795: @156124
     /* 156124 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(156173), // Rule ID 7324 //
     /* 156129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156146 */     // MIs[0] Rn
     /* 156146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156158 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 156161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156171 */     GIR_RootConstrainSelectedInstOperands,
     /* 156172 */     // GIR_Coverage, 7324,
     /* 156172 */     GIR_EraseRootFromParent_Done,
     /* 156173 */   // Label 2796: @156173
     /* 156173 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(156222), // Rule ID 7325 //
     /* 156178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156195 */     // MIs[0] Rn
     /* 156195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156207 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156220 */     GIR_RootConstrainSelectedInstOperands,
     /* 156221 */     // GIR_Coverage, 7325,
     /* 156221 */     GIR_EraseRootFromParent_Done,
     /* 156222 */   // Label 2797: @156222
     /* 156222 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(156271), // Rule ID 7326 //
     /* 156227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156244 */     // MIs[0] Rn
     /* 156244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156256 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156269 */     GIR_RootConstrainSelectedInstOperands,
     /* 156270 */     // GIR_Coverage, 7326,
     /* 156270 */     GIR_EraseRootFromParent_Done,
     /* 156271 */   // Label 2798: @156271
     /* 156271 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(156320), // Rule ID 7327 //
     /* 156276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156293 */     // MIs[0] Rn
     /* 156293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156305 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 156308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156318 */     GIR_RootConstrainSelectedInstOperands,
     /* 156319 */     // GIR_Coverage, 7327,
     /* 156319 */     GIR_EraseRootFromParent_Done,
     /* 156320 */   // Label 2799: @156320
     /* 156320 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(156369), // Rule ID 7328 //
     /* 156325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156342 */     // MIs[0] Rn
     /* 156342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156354 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 156357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156367 */     GIR_RootConstrainSelectedInstOperands,
     /* 156368 */     // GIR_Coverage, 7328,
     /* 156368 */     GIR_EraseRootFromParent_Done,
     /* 156369 */   // Label 2800: @156369
     /* 156369 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(156418), // Rule ID 7329 //
     /* 156374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156391 */     // MIs[0] Rn
     /* 156391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156403 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 156406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156416 */     GIR_RootConstrainSelectedInstOperands,
     /* 156417 */     // GIR_Coverage, 7329,
     /* 156417 */     GIR_EraseRootFromParent_Done,
     /* 156418 */   // Label 2801: @156418
     /* 156418 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(156467), // Rule ID 7330 //
     /* 156423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156440 */     // MIs[0] Rn
     /* 156440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156452 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156465 */     GIR_RootConstrainSelectedInstOperands,
     /* 156466 */     // GIR_Coverage, 7330,
     /* 156466 */     GIR_EraseRootFromParent_Done,
     /* 156467 */   // Label 2802: @156467
     /* 156467 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(156516), // Rule ID 7331 //
     /* 156472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156489 */     // MIs[0] Rn
     /* 156489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156501 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156514 */     GIR_RootConstrainSelectedInstOperands,
     /* 156515 */     // GIR_Coverage, 7331,
     /* 156515 */     GIR_EraseRootFromParent_Done,
     /* 156516 */   // Label 2803: @156516
     /* 156516 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(156565), // Rule ID 7332 //
     /* 156521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156538 */     // MIs[0] Rn
     /* 156538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156550 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 156553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156563 */     GIR_RootConstrainSelectedInstOperands,
     /* 156564 */     // GIR_Coverage, 7332,
     /* 156564 */     GIR_EraseRootFromParent_Done,
     /* 156565 */   // Label 2804: @156565
     /* 156565 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(156614), // Rule ID 7333 //
     /* 156570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156587 */     // MIs[0] Rn
     /* 156587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156599 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 156602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156612 */     GIR_RootConstrainSelectedInstOperands,
     /* 156613 */     // GIR_Coverage, 7333,
     /* 156613 */     GIR_EraseRootFromParent_Done,
     /* 156614 */   // Label 2805: @156614
     /* 156614 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(156663), // Rule ID 7334 //
     /* 156619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156636 */     // MIs[0] Rn
     /* 156636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156648 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 156651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156661 */     GIR_RootConstrainSelectedInstOperands,
     /* 156662 */     // GIR_Coverage, 7334,
     /* 156662 */     GIR_EraseRootFromParent_Done,
     /* 156663 */   // Label 2806: @156663
     /* 156663 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(156712), // Rule ID 7335 //
     /* 156668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156685 */     // MIs[0] Rn
     /* 156685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156697 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 156700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156710 */     GIR_RootConstrainSelectedInstOperands,
     /* 156711 */     // GIR_Coverage, 7335,
     /* 156711 */     GIR_EraseRootFromParent_Done,
     /* 156712 */   // Label 2807: @156712
     /* 156712 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(156761), // Rule ID 7336 //
     /* 156717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156734 */     // MIs[0] Rn
     /* 156734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156746 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 156749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156759 */     GIR_RootConstrainSelectedInstOperands,
     /* 156760 */     // GIR_Coverage, 7336,
     /* 156760 */     GIR_EraseRootFromParent_Done,
     /* 156761 */   // Label 2808: @156761
     /* 156761 */   GIM_Reject,
     /* 156762 */ // Label 2793: @156762
     /* 156762 */ GIM_Reject,
     /* 156763 */ // Label 2791: @156763
     /* 156763 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156989),
     /* 156768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156771 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156778 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(156820), // Rule ID 7317 //
     /* 156783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156793 */     // MIs[0] Rn
     /* 156793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156805 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 156808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156818 */     GIR_RootConstrainSelectedInstOperands,
     /* 156819 */     // GIR_Coverage, 7317,
     /* 156819 */     GIR_EraseRootFromParent_Done,
     /* 156820 */   // Label 2810: @156820
     /* 156820 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156862), // Rule ID 7318 //
     /* 156825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156835 */     // MIs[0] Rn
     /* 156835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156847 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 156850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156860 */     GIR_RootConstrainSelectedInstOperands,
     /* 156861 */     // GIR_Coverage, 7318,
     /* 156861 */     GIR_EraseRootFromParent_Done,
     /* 156862 */   // Label 2811: @156862
     /* 156862 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156904), // Rule ID 7319 //
     /* 156867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156877 */     // MIs[0] Rn
     /* 156877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156889 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 156892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156902 */     GIR_RootConstrainSelectedInstOperands,
     /* 156903 */     // GIR_Coverage, 7319,
     /* 156903 */     GIR_EraseRootFromParent_Done,
     /* 156904 */   // Label 2812: @156904
     /* 156904 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(156946), // Rule ID 7320 //
     /* 156909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156919 */     // MIs[0] Rn
     /* 156919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156931 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 156934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156944 */     GIR_RootConstrainSelectedInstOperands,
     /* 156945 */     // GIR_Coverage, 7320,
     /* 156945 */     GIR_EraseRootFromParent_Done,
     /* 156946 */   // Label 2813: @156946
     /* 156946 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(156988), // Rule ID 7321 //
     /* 156951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156961 */     // MIs[0] Rn
     /* 156961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156973 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 156976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156986 */     GIR_RootConstrainSelectedInstOperands,
     /* 156987 */     // GIR_Coverage, 7321,
     /* 156987 */     GIR_EraseRootFromParent_Done,
     /* 156988 */   // Label 2814: @156988
     /* 156988 */   GIM_Reject,
     /* 156989 */ // Label 2809: @156989
     /* 156989 */ GIM_Reject,
     /* 156990 */ // Label 2792: @156990
     /* 156990 */ GIM_Reject,
     /* 156991 */ // Label 31: @156991
     /* 156991 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2818*/ GIMT_Encode4(157695),
     /* 157002 */ /*GILLT_s16*//*Label 2815*/ GIMT_Encode4(157014),
     /* 157006 */ /*GILLT_s32*//*Label 2816*/ GIMT_Encode4(157241),
     /* 157010 */ /*GILLT_s64*//*Label 2817*/ GIMT_Encode4(157468),
     /* 157014 */ // Label 2815: @157014
     /* 157014 */ GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(157240),
     /* 157019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157029 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(157071), // Rule ID 2580 //
     /* 157034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157044 */     // MIs[0] Rn
     /* 157044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157056 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 157059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157069 */     GIR_RootConstrainSelectedInstOperands,
     /* 157070 */     // GIR_Coverage, 2580,
     /* 157070 */     GIR_EraseRootFromParent_Done,
     /* 157071 */   // Label 2820: @157071
     /* 157071 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(157113), // Rule ID 2581 //
     /* 157076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157086 */     // MIs[0] Rn
     /* 157086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157098 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 157101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157111 */     GIR_RootConstrainSelectedInstOperands,
     /* 157112 */     // GIR_Coverage, 2581,
     /* 157112 */     GIR_EraseRootFromParent_Done,
     /* 157113 */   // Label 2821: @157113
     /* 157113 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(157155), // Rule ID 2582 //
     /* 157118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157128 */     // MIs[0] Rn
     /* 157128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157140 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 157143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157153 */     GIR_RootConstrainSelectedInstOperands,
     /* 157154 */     // GIR_Coverage, 2582,
     /* 157154 */     GIR_EraseRootFromParent_Done,
     /* 157155 */   // Label 2822: @157155
     /* 157155 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(157197), // Rule ID 2583 //
     /* 157160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157170 */     // MIs[0] Rn
     /* 157170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157182 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157195 */     GIR_RootConstrainSelectedInstOperands,
     /* 157196 */     // GIR_Coverage, 2583,
     /* 157196 */     GIR_EraseRootFromParent_Done,
     /* 157197 */   // Label 2823: @157197
     /* 157197 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(157239), // Rule ID 2584 //
     /* 157202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157212 */     // MIs[0] Rn
     /* 157212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157224 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157237 */     GIR_RootConstrainSelectedInstOperands,
     /* 157238 */     // GIR_Coverage, 2584,
     /* 157238 */     GIR_EraseRootFromParent_Done,
     /* 157239 */   // Label 2824: @157239
     /* 157239 */   GIM_Reject,
     /* 157240 */ // Label 2819: @157240
     /* 157240 */ GIM_Reject,
     /* 157241 */ // Label 2816: @157241
     /* 157241 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(157467),
     /* 157246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157256 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(157298), // Rule ID 7412 //
     /* 157261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157271 */     // MIs[0] Rn
     /* 157271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157283 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 157286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157296 */     GIR_RootConstrainSelectedInstOperands,
     /* 157297 */     // GIR_Coverage, 7412,
     /* 157297 */     GIR_EraseRootFromParent_Done,
     /* 157298 */   // Label 2826: @157298
     /* 157298 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(157340), // Rule ID 7413 //
     /* 157303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157313 */     // MIs[0] Rn
     /* 157313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157325 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 157328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157338 */     GIR_RootConstrainSelectedInstOperands,
     /* 157339 */     // GIR_Coverage, 7413,
     /* 157339 */     GIR_EraseRootFromParent_Done,
     /* 157340 */   // Label 2827: @157340
     /* 157340 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(157382), // Rule ID 7414 //
     /* 157345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157355 */     // MIs[0] Rn
     /* 157355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157367 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 157370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157380 */     GIR_RootConstrainSelectedInstOperands,
     /* 157381 */     // GIR_Coverage, 7414,
     /* 157381 */     GIR_EraseRootFromParent_Done,
     /* 157382 */   // Label 2828: @157382
     /* 157382 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(157424), // Rule ID 7415 //
     /* 157387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157397 */     // MIs[0] Rn
     /* 157397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157409 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157422 */     GIR_RootConstrainSelectedInstOperands,
     /* 157423 */     // GIR_Coverage, 7415,
     /* 157423 */     GIR_EraseRootFromParent_Done,
     /* 157424 */   // Label 2829: @157424
     /* 157424 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(157466), // Rule ID 7416 //
     /* 157429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157439 */     // MIs[0] Rn
     /* 157439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157451 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157464 */     GIR_RootConstrainSelectedInstOperands,
     /* 157465 */     // GIR_Coverage, 7416,
     /* 157465 */     GIR_EraseRootFromParent_Done,
     /* 157466 */   // Label 2830: @157466
     /* 157466 */   GIM_Reject,
     /* 157467 */ // Label 2825: @157467
     /* 157467 */ GIM_Reject,
     /* 157468 */ // Label 2817: @157468
     /* 157468 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(157694),
     /* 157473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157483 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(157525), // Rule ID 7417 //
     /* 157488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157498 */     // MIs[0] Rn
     /* 157498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157510 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 157513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157523 */     GIR_RootConstrainSelectedInstOperands,
     /* 157524 */     // GIR_Coverage, 7417,
     /* 157524 */     GIR_EraseRootFromParent_Done,
     /* 157525 */   // Label 2832: @157525
     /* 157525 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(157567), // Rule ID 7418 //
     /* 157530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157540 */     // MIs[0] Rn
     /* 157540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157552 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 157555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157565 */     GIR_RootConstrainSelectedInstOperands,
     /* 157566 */     // GIR_Coverage, 7418,
     /* 157566 */     GIR_EraseRootFromParent_Done,
     /* 157567 */   // Label 2833: @157567
     /* 157567 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(157609), // Rule ID 7419 //
     /* 157572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157582 */     // MIs[0] Rn
     /* 157582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157594 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 157597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157607 */     GIR_RootConstrainSelectedInstOperands,
     /* 157608 */     // GIR_Coverage, 7419,
     /* 157608 */     GIR_EraseRootFromParent_Done,
     /* 157609 */   // Label 2834: @157609
     /* 157609 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(157651), // Rule ID 7420 //
     /* 157614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157624 */     // MIs[0] Rn
     /* 157624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157636 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 157639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157649 */     GIR_RootConstrainSelectedInstOperands,
     /* 157650 */     // GIR_Coverage, 7420,
     /* 157650 */     GIR_EraseRootFromParent_Done,
     /* 157651 */   // Label 2835: @157651
     /* 157651 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(157693), // Rule ID 7421 //
     /* 157656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157666 */     // MIs[0] Rn
     /* 157666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157678 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 157681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157691 */     GIR_RootConstrainSelectedInstOperands,
     /* 157692 */     // GIR_Coverage, 7421,
     /* 157692 */     GIR_EraseRootFromParent_Done,
     /* 157693 */   // Label 2836: @157693
     /* 157693 */   GIM_Reject,
     /* 157694 */ // Label 2831: @157694
     /* 157694 */ GIM_Reject,
     /* 157695 */ // Label 2818: @157695
     /* 157695 */ GIM_Reject,
     /* 157696 */ // Label 32: @157696
     /* 157696 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2840*/ GIMT_Encode4(158400),
     /* 157707 */ /*GILLT_s16*//*Label 2837*/ GIMT_Encode4(157719),
     /* 157711 */ /*GILLT_s32*//*Label 2838*/ GIMT_Encode4(157946),
     /* 157715 */ /*GILLT_s64*//*Label 2839*/ GIMT_Encode4(158173),
     /* 157719 */ // Label 2837: @157719
     /* 157719 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(157945),
     /* 157724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157734 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(157776), // Rule ID 7422 //
     /* 157739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157749 */     // MIs[0] Rn
     /* 157749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157761 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 157764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157774 */     GIR_RootConstrainSelectedInstOperands,
     /* 157775 */     // GIR_Coverage, 7422,
     /* 157775 */     GIR_EraseRootFromParent_Done,
     /* 157776 */   // Label 2842: @157776
     /* 157776 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(157818), // Rule ID 7423 //
     /* 157781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157791 */     // MIs[0] Rn
     /* 157791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157803 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 157806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157816 */     GIR_RootConstrainSelectedInstOperands,
     /* 157817 */     // GIR_Coverage, 7423,
     /* 157817 */     GIR_EraseRootFromParent_Done,
     /* 157818 */   // Label 2843: @157818
     /* 157818 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(157860), // Rule ID 7424 //
     /* 157823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157833 */     // MIs[0] Rn
     /* 157833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157845 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 157848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157858 */     GIR_RootConstrainSelectedInstOperands,
     /* 157859 */     // GIR_Coverage, 7424,
     /* 157859 */     GIR_EraseRootFromParent_Done,
     /* 157860 */   // Label 2844: @157860
     /* 157860 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(157902), // Rule ID 7425 //
     /* 157865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157875 */     // MIs[0] Rn
     /* 157875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157887 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 157890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157900 */     GIR_RootConstrainSelectedInstOperands,
     /* 157901 */     // GIR_Coverage, 7425,
     /* 157901 */     GIR_EraseRootFromParent_Done,
     /* 157902 */   // Label 2845: @157902
     /* 157902 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(157944), // Rule ID 7426 //
     /* 157907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157917 */     // MIs[0] Rn
     /* 157917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157929 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 157932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157942 */     GIR_RootConstrainSelectedInstOperands,
     /* 157943 */     // GIR_Coverage, 7426,
     /* 157943 */     GIR_EraseRootFromParent_Done,
     /* 157944 */   // Label 2846: @157944
     /* 157944 */   GIM_Reject,
     /* 157945 */ // Label 2841: @157945
     /* 157945 */ GIM_Reject,
     /* 157946 */ // Label 2838: @157946
     /* 157946 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(158172),
     /* 157951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157961 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(158003), // Rule ID 7427 //
     /* 157966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157976 */     // MIs[0] Rn
     /* 157976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157988 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 157991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158001 */     GIR_RootConstrainSelectedInstOperands,
     /* 158002 */     // GIR_Coverage, 7427,
     /* 158002 */     GIR_EraseRootFromParent_Done,
     /* 158003 */   // Label 2848: @158003
     /* 158003 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(158045), // Rule ID 7428 //
     /* 158008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158018 */     // MIs[0] Rn
     /* 158018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158030 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 158033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158043 */     GIR_RootConstrainSelectedInstOperands,
     /* 158044 */     // GIR_Coverage, 7428,
     /* 158044 */     GIR_EraseRootFromParent_Done,
     /* 158045 */   // Label 2849: @158045
     /* 158045 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(158087), // Rule ID 7429 //
     /* 158050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158060 */     // MIs[0] Rn
     /* 158060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158072 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 158075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158085 */     GIR_RootConstrainSelectedInstOperands,
     /* 158086 */     // GIR_Coverage, 7429,
     /* 158086 */     GIR_EraseRootFromParent_Done,
     /* 158087 */   // Label 2850: @158087
     /* 158087 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(158129), // Rule ID 7430 //
     /* 158092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158102 */     // MIs[0] Rn
     /* 158102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158114 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158127 */     GIR_RootConstrainSelectedInstOperands,
     /* 158128 */     // GIR_Coverage, 7430,
     /* 158128 */     GIR_EraseRootFromParent_Done,
     /* 158129 */   // Label 2851: @158129
     /* 158129 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(158171), // Rule ID 7431 //
     /* 158134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158144 */     // MIs[0] Rn
     /* 158144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158156 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158169 */     GIR_RootConstrainSelectedInstOperands,
     /* 158170 */     // GIR_Coverage, 7431,
     /* 158170 */     GIR_EraseRootFromParent_Done,
     /* 158171 */   // Label 2852: @158171
     /* 158171 */   GIM_Reject,
     /* 158172 */ // Label 2847: @158172
     /* 158172 */ GIM_Reject,
     /* 158173 */ // Label 2839: @158173
     /* 158173 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(158399),
     /* 158178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158181 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158188 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(158230), // Rule ID 7432 //
     /* 158193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158203 */     // MIs[0] Rn
     /* 158203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158215 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 158218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158228 */     GIR_RootConstrainSelectedInstOperands,
     /* 158229 */     // GIR_Coverage, 7432,
     /* 158229 */     GIR_EraseRootFromParent_Done,
     /* 158230 */   // Label 2854: @158230
     /* 158230 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(158272), // Rule ID 7433 //
     /* 158235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158245 */     // MIs[0] Rn
     /* 158245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158257 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 158260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158270 */     GIR_RootConstrainSelectedInstOperands,
     /* 158271 */     // GIR_Coverage, 7433,
     /* 158271 */     GIR_EraseRootFromParent_Done,
     /* 158272 */   // Label 2855: @158272
     /* 158272 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(158314), // Rule ID 7434 //
     /* 158277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158287 */     // MIs[0] Rn
     /* 158287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158299 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 158302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158312 */     GIR_RootConstrainSelectedInstOperands,
     /* 158313 */     // GIR_Coverage, 7434,
     /* 158313 */     GIR_EraseRootFromParent_Done,
     /* 158314 */   // Label 2856: @158314
     /* 158314 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(158356), // Rule ID 7435 //
     /* 158319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158329 */     // MIs[0] Rn
     /* 158329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158341 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158354 */     GIR_RootConstrainSelectedInstOperands,
     /* 158355 */     // GIR_Coverage, 7435,
     /* 158355 */     GIR_EraseRootFromParent_Done,
     /* 158356 */   // Label 2857: @158356
     /* 158356 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(158398), // Rule ID 7436 //
     /* 158361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158371 */     // MIs[0] Rn
     /* 158371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158383 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158396 */     GIR_RootConstrainSelectedInstOperands,
     /* 158397 */     // GIR_Coverage, 7436,
     /* 158397 */     GIR_EraseRootFromParent_Done,
     /* 158398 */   // Label 2858: @158398
     /* 158398 */   GIM_Reject,
     /* 158399 */ // Label 2853: @158399
     /* 158399 */ GIM_Reject,
     /* 158400 */ // Label 2840: @158400
     /* 158400 */ GIM_Reject,
     /* 158401 */ // Label 33: @158401
     /* 158401 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2862*/ GIMT_Encode4(159105),
     /* 158412 */ /*GILLT_s16*//*Label 2859*/ GIMT_Encode4(158424),
     /* 158416 */ /*GILLT_s32*//*Label 2860*/ GIMT_Encode4(158651),
     /* 158420 */ /*GILLT_s64*//*Label 2861*/ GIMT_Encode4(158878),
     /* 158424 */ // Label 2859: @158424
     /* 158424 */ GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(158650),
     /* 158429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158439 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(158481), // Rule ID 7437 //
     /* 158444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158454 */     // MIs[0] Rn
     /* 158454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158466 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 158469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158479 */     GIR_RootConstrainSelectedInstOperands,
     /* 158480 */     // GIR_Coverage, 7437,
     /* 158480 */     GIR_EraseRootFromParent_Done,
     /* 158481 */   // Label 2864: @158481
     /* 158481 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(158523), // Rule ID 7438 //
     /* 158486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158496 */     // MIs[0] Rn
     /* 158496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158508 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 158511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158521 */     GIR_RootConstrainSelectedInstOperands,
     /* 158522 */     // GIR_Coverage, 7438,
     /* 158522 */     GIR_EraseRootFromParent_Done,
     /* 158523 */   // Label 2865: @158523
     /* 158523 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(158565), // Rule ID 7439 //
     /* 158528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158538 */     // MIs[0] Rn
     /* 158538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158550 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 158553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158563 */     GIR_RootConstrainSelectedInstOperands,
     /* 158564 */     // GIR_Coverage, 7439,
     /* 158564 */     GIR_EraseRootFromParent_Done,
     /* 158565 */   // Label 2866: @158565
     /* 158565 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(158607), // Rule ID 7440 //
     /* 158570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158580 */     // MIs[0] Rn
     /* 158580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158592 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 158595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158605 */     GIR_RootConstrainSelectedInstOperands,
     /* 158606 */     // GIR_Coverage, 7440,
     /* 158606 */     GIR_EraseRootFromParent_Done,
     /* 158607 */   // Label 2867: @158607
     /* 158607 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(158649), // Rule ID 7441 //
     /* 158612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158622 */     // MIs[0] Rn
     /* 158622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158634 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 158637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158647 */     GIR_RootConstrainSelectedInstOperands,
     /* 158648 */     // GIR_Coverage, 7441,
     /* 158648 */     GIR_EraseRootFromParent_Done,
     /* 158649 */   // Label 2868: @158649
     /* 158649 */   GIM_Reject,
     /* 158650 */ // Label 2863: @158650
     /* 158650 */ GIM_Reject,
     /* 158651 */ // Label 2860: @158651
     /* 158651 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(158877),
     /* 158656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158666 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(158708), // Rule ID 7442 //
     /* 158671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158681 */     // MIs[0] Rn
     /* 158681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158693 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 158696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158706 */     GIR_RootConstrainSelectedInstOperands,
     /* 158707 */     // GIR_Coverage, 7442,
     /* 158707 */     GIR_EraseRootFromParent_Done,
     /* 158708 */   // Label 2870: @158708
     /* 158708 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(158750), // Rule ID 7443 //
     /* 158713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158723 */     // MIs[0] Rn
     /* 158723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158735 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 158738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158748 */     GIR_RootConstrainSelectedInstOperands,
     /* 158749 */     // GIR_Coverage, 7443,
     /* 158749 */     GIR_EraseRootFromParent_Done,
     /* 158750 */   // Label 2871: @158750
     /* 158750 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(158792), // Rule ID 7444 //
     /* 158755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158765 */     // MIs[0] Rn
     /* 158765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158777 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 158780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158790 */     GIR_RootConstrainSelectedInstOperands,
     /* 158791 */     // GIR_Coverage, 7444,
     /* 158791 */     GIR_EraseRootFromParent_Done,
     /* 158792 */   // Label 2872: @158792
     /* 158792 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(158834), // Rule ID 7445 //
     /* 158797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158807 */     // MIs[0] Rn
     /* 158807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158819 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 158822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158832 */     GIR_RootConstrainSelectedInstOperands,
     /* 158833 */     // GIR_Coverage, 7445,
     /* 158833 */     GIR_EraseRootFromParent_Done,
     /* 158834 */   // Label 2873: @158834
     /* 158834 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(158876), // Rule ID 7446 //
     /* 158839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158849 */     // MIs[0] Rn
     /* 158849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158861 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 158864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158874 */     GIR_RootConstrainSelectedInstOperands,
     /* 158875 */     // GIR_Coverage, 7446,
     /* 158875 */     GIR_EraseRootFromParent_Done,
     /* 158876 */   // Label 2874: @158876
     /* 158876 */   GIM_Reject,
     /* 158877 */ // Label 2869: @158877
     /* 158877 */ GIM_Reject,
     /* 158878 */ // Label 2861: @158878
     /* 158878 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(159104),
     /* 158883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158893 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(158935), // Rule ID 7447 //
     /* 158898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158908 */     // MIs[0] Rn
     /* 158908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158920 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 158923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158933 */     GIR_RootConstrainSelectedInstOperands,
     /* 158934 */     // GIR_Coverage, 7447,
     /* 158934 */     GIR_EraseRootFromParent_Done,
     /* 158935 */   // Label 2876: @158935
     /* 158935 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(158977), // Rule ID 7448 //
     /* 158940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158950 */     // MIs[0] Rn
     /* 158950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158962 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 158965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158975 */     GIR_RootConstrainSelectedInstOperands,
     /* 158976 */     // GIR_Coverage, 7448,
     /* 158976 */     GIR_EraseRootFromParent_Done,
     /* 158977 */   // Label 2877: @158977
     /* 158977 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(159019), // Rule ID 7449 //
     /* 158982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158992 */     // MIs[0] Rn
     /* 158992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159004 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 159007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159017 */     GIR_RootConstrainSelectedInstOperands,
     /* 159018 */     // GIR_Coverage, 7449,
     /* 159018 */     GIR_EraseRootFromParent_Done,
     /* 159019 */   // Label 2878: @159019
     /* 159019 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(159061), // Rule ID 7450 //
     /* 159024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159027 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159034 */     // MIs[0] Rn
     /* 159034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159046 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159059 */     GIR_RootConstrainSelectedInstOperands,
     /* 159060 */     // GIR_Coverage, 7450,
     /* 159060 */     GIR_EraseRootFromParent_Done,
     /* 159061 */   // Label 2879: @159061
     /* 159061 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(159103), // Rule ID 7451 //
     /* 159066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159076 */     // MIs[0] Rn
     /* 159076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159088 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159101 */     GIR_RootConstrainSelectedInstOperands,
     /* 159102 */     // GIR_Coverage, 7451,
     /* 159102 */     GIR_EraseRootFromParent_Done,
     /* 159103 */   // Label 2880: @159103
     /* 159103 */   GIM_Reject,
     /* 159104 */ // Label 2875: @159104
     /* 159104 */ GIM_Reject,
     /* 159105 */ // Label 2862: @159105
     /* 159105 */ GIM_Reject,
     /* 159106 */ // Label 34: @159106
     /* 159106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2884*/ GIMT_Encode4(159810),
     /* 159117 */ /*GILLT_s16*//*Label 2881*/ GIMT_Encode4(159129),
     /* 159121 */ /*GILLT_s32*//*Label 2882*/ GIMT_Encode4(159356),
     /* 159125 */ /*GILLT_s64*//*Label 2883*/ GIMT_Encode4(159583),
     /* 159129 */ // Label 2881: @159129
     /* 159129 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(159355),
     /* 159134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159144 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(159186), // Rule ID 7452 //
     /* 159149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159159 */     // MIs[0] Rn
     /* 159159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159171 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 159174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159184 */     GIR_RootConstrainSelectedInstOperands,
     /* 159185 */     // GIR_Coverage, 7452,
     /* 159185 */     GIR_EraseRootFromParent_Done,
     /* 159186 */   // Label 2886: @159186
     /* 159186 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(159228), // Rule ID 7453 //
     /* 159191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159201 */     // MIs[0] Rn
     /* 159201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159213 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 159216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159226 */     GIR_RootConstrainSelectedInstOperands,
     /* 159227 */     // GIR_Coverage, 7453,
     /* 159227 */     GIR_EraseRootFromParent_Done,
     /* 159228 */   // Label 2887: @159228
     /* 159228 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(159270), // Rule ID 7454 //
     /* 159233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159243 */     // MIs[0] Rn
     /* 159243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159255 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 159258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159268 */     GIR_RootConstrainSelectedInstOperands,
     /* 159269 */     // GIR_Coverage, 7454,
     /* 159269 */     GIR_EraseRootFromParent_Done,
     /* 159270 */   // Label 2888: @159270
     /* 159270 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(159312), // Rule ID 7455 //
     /* 159275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159285 */     // MIs[0] Rn
     /* 159285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159297 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159310 */     GIR_RootConstrainSelectedInstOperands,
     /* 159311 */     // GIR_Coverage, 7455,
     /* 159311 */     GIR_EraseRootFromParent_Done,
     /* 159312 */   // Label 2889: @159312
     /* 159312 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(159354), // Rule ID 7456 //
     /* 159317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159327 */     // MIs[0] Rn
     /* 159327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159339 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159352 */     GIR_RootConstrainSelectedInstOperands,
     /* 159353 */     // GIR_Coverage, 7456,
     /* 159353 */     GIR_EraseRootFromParent_Done,
     /* 159354 */   // Label 2890: @159354
     /* 159354 */   GIM_Reject,
     /* 159355 */ // Label 2885: @159355
     /* 159355 */ GIM_Reject,
     /* 159356 */ // Label 2882: @159356
     /* 159356 */ GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(159582),
     /* 159361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159371 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(159413), // Rule ID 7457 //
     /* 159376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159386 */     // MIs[0] Rn
     /* 159386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159398 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 159401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159411 */     GIR_RootConstrainSelectedInstOperands,
     /* 159412 */     // GIR_Coverage, 7457,
     /* 159412 */     GIR_EraseRootFromParent_Done,
     /* 159413 */   // Label 2892: @159413
     /* 159413 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(159455), // Rule ID 7458 //
     /* 159418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159428 */     // MIs[0] Rn
     /* 159428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159440 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 159443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159453 */     GIR_RootConstrainSelectedInstOperands,
     /* 159454 */     // GIR_Coverage, 7458,
     /* 159454 */     GIR_EraseRootFromParent_Done,
     /* 159455 */   // Label 2893: @159455
     /* 159455 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(159497), // Rule ID 7459 //
     /* 159460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159470 */     // MIs[0] Rn
     /* 159470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159482 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 159485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159495 */     GIR_RootConstrainSelectedInstOperands,
     /* 159496 */     // GIR_Coverage, 7459,
     /* 159496 */     GIR_EraseRootFromParent_Done,
     /* 159497 */   // Label 2894: @159497
     /* 159497 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(159539), // Rule ID 7460 //
     /* 159502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159512 */     // MIs[0] Rn
     /* 159512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159524 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159537 */     GIR_RootConstrainSelectedInstOperands,
     /* 159538 */     // GIR_Coverage, 7460,
     /* 159538 */     GIR_EraseRootFromParent_Done,
     /* 159539 */   // Label 2895: @159539
     /* 159539 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(159581), // Rule ID 7461 //
     /* 159544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159554 */     // MIs[0] Rn
     /* 159554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159566 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159579 */     GIR_RootConstrainSelectedInstOperands,
     /* 159580 */     // GIR_Coverage, 7461,
     /* 159580 */     GIR_EraseRootFromParent_Done,
     /* 159581 */   // Label 2896: @159581
     /* 159581 */   GIM_Reject,
     /* 159582 */ // Label 2891: @159582
     /* 159582 */ GIM_Reject,
     /* 159583 */ // Label 2883: @159583
     /* 159583 */ GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(159809),
     /* 159588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159591 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159598 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(159640), // Rule ID 7462 //
     /* 159603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159613 */     // MIs[0] Rn
     /* 159613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159625 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 159628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159638 */     GIR_RootConstrainSelectedInstOperands,
     /* 159639 */     // GIR_Coverage, 7462,
     /* 159639 */     GIR_EraseRootFromParent_Done,
     /* 159640 */   // Label 2898: @159640
     /* 159640 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(159682), // Rule ID 7463 //
     /* 159645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159655 */     // MIs[0] Rn
     /* 159655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159667 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 159670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159680 */     GIR_RootConstrainSelectedInstOperands,
     /* 159681 */     // GIR_Coverage, 7463,
     /* 159681 */     GIR_EraseRootFromParent_Done,
     /* 159682 */   // Label 2899: @159682
     /* 159682 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(159724), // Rule ID 7464 //
     /* 159687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159697 */     // MIs[0] Rn
     /* 159697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159709 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 159712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159722 */     GIR_RootConstrainSelectedInstOperands,
     /* 159723 */     // GIR_Coverage, 7464,
     /* 159723 */     GIR_EraseRootFromParent_Done,
     /* 159724 */   // Label 2900: @159724
     /* 159724 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(159766), // Rule ID 7465 //
     /* 159729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159739 */     // MIs[0] Rn
     /* 159739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159751 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 159754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159764 */     GIR_RootConstrainSelectedInstOperands,
     /* 159765 */     // GIR_Coverage, 7465,
     /* 159765 */     GIR_EraseRootFromParent_Done,
     /* 159766 */   // Label 2901: @159766
     /* 159766 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(159808), // Rule ID 7466 //
     /* 159771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159781 */     // MIs[0] Rn
     /* 159781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159793 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 159796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159806 */     GIR_RootConstrainSelectedInstOperands,
     /* 159807 */     // GIR_Coverage, 7466,
     /* 159807 */     GIR_EraseRootFromParent_Done,
     /* 159808 */   // Label 2902: @159808
     /* 159808 */   GIM_Reject,
     /* 159809 */ // Label 2897: @159809
     /* 159809 */ GIM_Reject,
     /* 159810 */ // Label 2884: @159810
     /* 159810 */ GIM_Reject,
     /* 159811 */ // Label 35: @159811
     /* 159811 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2906*/ GIMT_Encode4(160515),
     /* 159822 */ /*GILLT_s16*//*Label 2903*/ GIMT_Encode4(159834),
     /* 159826 */ /*GILLT_s32*//*Label 2904*/ GIMT_Encode4(160061),
     /* 159830 */ /*GILLT_s64*//*Label 2905*/ GIMT_Encode4(160288),
     /* 159834 */ // Label 2903: @159834
     /* 159834 */ GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(160060),
     /* 159839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159842 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159849 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(159891), // Rule ID 7467 //
     /* 159854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159864 */     // MIs[0] Rn
     /* 159864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159876 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 159879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159889 */     GIR_RootConstrainSelectedInstOperands,
     /* 159890 */     // GIR_Coverage, 7467,
     /* 159890 */     GIR_EraseRootFromParent_Done,
     /* 159891 */   // Label 2908: @159891
     /* 159891 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(159933), // Rule ID 7468 //
     /* 159896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159906 */     // MIs[0] Rn
     /* 159906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159918 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 159921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159931 */     GIR_RootConstrainSelectedInstOperands,
     /* 159932 */     // GIR_Coverage, 7468,
     /* 159932 */     GIR_EraseRootFromParent_Done,
     /* 159933 */   // Label 2909: @159933
     /* 159933 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(159975), // Rule ID 7469 //
     /* 159938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159948 */     // MIs[0] Rn
     /* 159948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159960 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 159963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159973 */     GIR_RootConstrainSelectedInstOperands,
     /* 159974 */     // GIR_Coverage, 7469,
     /* 159974 */     GIR_EraseRootFromParent_Done,
     /* 159975 */   // Label 2910: @159975
     /* 159975 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(160017), // Rule ID 7470 //
     /* 159980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159990 */     // MIs[0] Rn
     /* 159990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160002 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160015 */     GIR_RootConstrainSelectedInstOperands,
     /* 160016 */     // GIR_Coverage, 7470,
     /* 160016 */     GIR_EraseRootFromParent_Done,
     /* 160017 */   // Label 2911: @160017
     /* 160017 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(160059), // Rule ID 7471 //
     /* 160022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160032 */     // MIs[0] Rn
     /* 160032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160044 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160057 */     GIR_RootConstrainSelectedInstOperands,
     /* 160058 */     // GIR_Coverage, 7471,
     /* 160058 */     GIR_EraseRootFromParent_Done,
     /* 160059 */   // Label 2912: @160059
     /* 160059 */   GIM_Reject,
     /* 160060 */ // Label 2907: @160060
     /* 160060 */ GIM_Reject,
     /* 160061 */ // Label 2904: @160061
     /* 160061 */ GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(160287),
     /* 160066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160069 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160076 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(160118), // Rule ID 7472 //
     /* 160081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160091 */     // MIs[0] Rn
     /* 160091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160103 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 160106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160116 */     GIR_RootConstrainSelectedInstOperands,
     /* 160117 */     // GIR_Coverage, 7472,
     /* 160117 */     GIR_EraseRootFromParent_Done,
     /* 160118 */   // Label 2914: @160118
     /* 160118 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(160160), // Rule ID 7473 //
     /* 160123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160133 */     // MIs[0] Rn
     /* 160133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160145 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 160148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160158 */     GIR_RootConstrainSelectedInstOperands,
     /* 160159 */     // GIR_Coverage, 7473,
     /* 160159 */     GIR_EraseRootFromParent_Done,
     /* 160160 */   // Label 2915: @160160
     /* 160160 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(160202), // Rule ID 7474 //
     /* 160165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160175 */     // MIs[0] Rn
     /* 160175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160187 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 160190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160200 */     GIR_RootConstrainSelectedInstOperands,
     /* 160201 */     // GIR_Coverage, 7474,
     /* 160201 */     GIR_EraseRootFromParent_Done,
     /* 160202 */   // Label 2916: @160202
     /* 160202 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(160244), // Rule ID 7475 //
     /* 160207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160217 */     // MIs[0] Rn
     /* 160217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160229 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160242 */     GIR_RootConstrainSelectedInstOperands,
     /* 160243 */     // GIR_Coverage, 7475,
     /* 160243 */     GIR_EraseRootFromParent_Done,
     /* 160244 */   // Label 2917: @160244
     /* 160244 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(160286), // Rule ID 7476 //
     /* 160249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160259 */     // MIs[0] Rn
     /* 160259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160271 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160284 */     GIR_RootConstrainSelectedInstOperands,
     /* 160285 */     // GIR_Coverage, 7476,
     /* 160285 */     GIR_EraseRootFromParent_Done,
     /* 160286 */   // Label 2918: @160286
     /* 160286 */   GIM_Reject,
     /* 160287 */ // Label 2913: @160287
     /* 160287 */ GIM_Reject,
     /* 160288 */ // Label 2905: @160288
     /* 160288 */ GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(160514),
     /* 160293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 160303 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(160345), // Rule ID 7477 //
     /* 160308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160318 */     // MIs[0] Rn
     /* 160318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160330 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 160333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160343 */     GIR_RootConstrainSelectedInstOperands,
     /* 160344 */     // GIR_Coverage, 7477,
     /* 160344 */     GIR_EraseRootFromParent_Done,
     /* 160345 */   // Label 2920: @160345
     /* 160345 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(160387), // Rule ID 7478 //
     /* 160350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160360 */     // MIs[0] Rn
     /* 160360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160372 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 160375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160385 */     GIR_RootConstrainSelectedInstOperands,
     /* 160386 */     // GIR_Coverage, 7478,
     /* 160386 */     GIR_EraseRootFromParent_Done,
     /* 160387 */   // Label 2921: @160387
     /* 160387 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(160429), // Rule ID 7479 //
     /* 160392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160402 */     // MIs[0] Rn
     /* 160402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160414 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 160417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160427 */     GIR_RootConstrainSelectedInstOperands,
     /* 160428 */     // GIR_Coverage, 7479,
     /* 160428 */     GIR_EraseRootFromParent_Done,
     /* 160429 */   // Label 2922: @160429
     /* 160429 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(160471), // Rule ID 7480 //
     /* 160434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160437 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160444 */     // MIs[0] Rn
     /* 160444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160456 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160469 */     GIR_RootConstrainSelectedInstOperands,
     /* 160470 */     // GIR_Coverage, 7480,
     /* 160470 */     GIR_EraseRootFromParent_Done,
     /* 160471 */   // Label 2923: @160471
     /* 160471 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(160513), // Rule ID 7481 //
     /* 160476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160486 */     // MIs[0] Rn
     /* 160486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160498 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160511 */     GIR_RootConstrainSelectedInstOperands,
     /* 160512 */     // GIR_Coverage, 7481,
     /* 160512 */     GIR_EraseRootFromParent_Done,
     /* 160513 */   // Label 2924: @160513
     /* 160513 */   GIM_Reject,
     /* 160514 */ // Label 2919: @160514
     /* 160514 */ GIM_Reject,
     /* 160515 */ // Label 2906: @160515
     /* 160515 */ GIM_Reject,
     /* 160516 */ // Label 36: @160516
     /* 160516 */ GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(160543), // Rule ID 7067 //
     /* 160521 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160524 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 160528 */   // MIs[0] Operand 1
     /* 160528 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160531 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 160531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160541 */   GIR_RootConstrainSelectedInstOperands,
     /* 160542 */   // GIR_Coverage, 7067,
     /* 160542 */   GIR_EraseRootFromParent_Done,
     /* 160543 */ // Label 2925: @160543
     /* 160543 */ GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(160566), // Rule ID 7068 //
     /* 160548 */   // MIs[0] Operand 0
     /* 160548 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 160551 */   // MIs[0] Operand 1
     /* 160551 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160554 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 160554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 160560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160564 */   GIR_RootConstrainSelectedInstOperands,
     /* 160565 */   // GIR_Coverage, 7068,
     /* 160565 */   GIR_EraseRootFromParent_Done,
     /* 160566 */ // Label 2926: @160566
     /* 160566 */ GIM_Reject,
     /* 160567 */ // Label 37: @160567
     /* 160567 */ GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(173094),
     /* 160572 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 160575 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(160666), // Rule ID 6546 //
     /* 160580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 160583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 160588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 160591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 160614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 160622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160634 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 160634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 160637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 160641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 160650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 160654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 160659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160664 */     GIR_RootConstrainSelectedInstOperands,
     /* 160665 */     // GIR_Coverage, 6546,
     /* 160665 */     GIR_EraseRootFromParent_Done,
     /* 160666 */   // Label 2928: @160666
     /* 160666 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(160757), // Rule ID 6547 //
     /* 160671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 160674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 160679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 160682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160697 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160700 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 160705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160709 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 160713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160725 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 160725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 160728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 160732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 160741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 160745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 160750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160755 */     GIR_RootConstrainSelectedInstOperands,
     /* 160756 */     // GIR_Coverage, 6547,
     /* 160756 */     GIR_EraseRootFromParent_Done,
     /* 160757 */   // Label 2929: @160757
     /* 160757 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(160818), // Rule ID 4938 //
     /* 160762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 160767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 160785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160794 */     // MIs[1] Operand 2
     /* 160794 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 160805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160807 */     // (intrinsic_wo_chain:{ *:[v4f32] } 777:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 160807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 160810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 160816 */     GIR_RootConstrainSelectedInstOperands,
     /* 160817 */     // GIR_Coverage, 4938,
     /* 160817 */     GIR_EraseRootFromParent_Done,
     /* 160818 */   // Label 2930: @160818
     /* 160818 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(160858), // Rule ID 2647 //
     /* 160823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 160831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160838 */     // MIs[0] pattern
     /* 160838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160846 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 160849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160851 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160856 */     GIR_RootConstrainSelectedInstOperands,
     /* 160857 */     // GIR_Coverage, 2647,
     /* 160857 */     GIR_EraseRootFromParent_Done,
     /* 160858 */   // Label 2931: @160858
     /* 160858 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(160898), // Rule ID 9988 //
     /* 160863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 160871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160878 */     // MIs[0] pattern
     /* 160878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160886 */     // (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 160889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160891 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160896 */     GIR_RootConstrainSelectedInstOperands,
     /* 160897 */     // GIR_Coverage, 9988,
     /* 160897 */     GIR_EraseRootFromParent_Done,
     /* 160898 */   // Label 2932: @160898
     /* 160898 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(160938), // Rule ID 9991 //
     /* 160903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 160911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160918 */     // MIs[0] pattern
     /* 160918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160926 */     // (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 160929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160931 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160936 */     GIR_RootConstrainSelectedInstOperands,
     /* 160937 */     // GIR_Coverage, 9991,
     /* 160937 */     GIR_EraseRootFromParent_Done,
     /* 160938 */   // Label 2933: @160938
     /* 160938 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(160978), // Rule ID 9994 //
     /* 160943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 160951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160958 */     // MIs[0] pattern
     /* 160958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160966 */     // (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 160969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160971 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160976 */     GIR_RootConstrainSelectedInstOperands,
     /* 160977 */     // GIR_Coverage, 9994,
     /* 160977 */     GIR_EraseRootFromParent_Done,
     /* 160978 */   // Label 2934: @160978
     /* 160978 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(161017), // Rule ID 66 //
     /* 160983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 160986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 160991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161005 */     // (intrinsic_wo_chain:{ *:[i32] } 556:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 161008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 161015 */     GIR_RootConstrainSelectedInstOperands,
     /* 161016 */     // GIR_Coverage, 66,
     /* 161016 */     GIR_EraseRootFromParent_Done,
     /* 161017 */   // Label 2935: @161017
     /* 161017 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(161053), // Rule ID 346 //
     /* 161022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161044 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 161047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161051 */     GIR_RootConstrainSelectedInstOperands,
     /* 161052 */     // GIR_Coverage, 346,
     /* 161052 */     GIR_EraseRootFromParent_Done,
     /* 161053 */   // Label 2936: @161053
     /* 161053 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(161089), // Rule ID 347 //
     /* 161058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161080 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 161083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161087 */     GIR_RootConstrainSelectedInstOperands,
     /* 161088 */     // GIR_Coverage, 347,
     /* 161088 */     GIR_EraseRootFromParent_Done,
     /* 161089 */   // Label 2937: @161089
     /* 161089 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(161125), // Rule ID 348 //
     /* 161094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161116 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 161119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161123 */     GIR_RootConstrainSelectedInstOperands,
     /* 161124 */     // GIR_Coverage, 348,
     /* 161124 */     GIR_EraseRootFromParent_Done,
     /* 161125 */   // Label 2938: @161125
     /* 161125 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(161161), // Rule ID 349 //
     /* 161130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161152 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 161155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161159 */     GIR_RootConstrainSelectedInstOperands,
     /* 161160 */     // GIR_Coverage, 349,
     /* 161160 */     GIR_EraseRootFromParent_Done,
     /* 161161 */   // Label 2939: @161161
     /* 161161 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(161197), // Rule ID 350 //
     /* 161166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161188 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 161191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161195 */     GIR_RootConstrainSelectedInstOperands,
     /* 161196 */     // GIR_Coverage, 350,
     /* 161196 */     GIR_EraseRootFromParent_Done,
     /* 161197 */   // Label 2940: @161197
     /* 161197 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(161233), // Rule ID 351 //
     /* 161202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161224 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 161227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161231 */     GIR_RootConstrainSelectedInstOperands,
     /* 161232 */     // GIR_Coverage, 351,
     /* 161232 */     GIR_EraseRootFromParent_Done,
     /* 161233 */   // Label 2941: @161233
     /* 161233 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(161269), // Rule ID 352 //
     /* 161238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161260 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 161263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161267 */     GIR_RootConstrainSelectedInstOperands,
     /* 161268 */     // GIR_Coverage, 352,
     /* 161268 */     GIR_EraseRootFromParent_Done,
     /* 161269 */   // Label 2942: @161269
     /* 161269 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(161305), // Rule ID 353 //
     /* 161274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161296 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 161299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161303 */     GIR_RootConstrainSelectedInstOperands,
     /* 161304 */     // GIR_Coverage, 353,
     /* 161304 */     GIR_EraseRootFromParent_Done,
     /* 161305 */   // Label 2943: @161305
     /* 161305 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(161341), // Rule ID 354 //
     /* 161310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161332 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 161335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161339 */     GIR_RootConstrainSelectedInstOperands,
     /* 161340 */     // GIR_Coverage, 354,
     /* 161340 */     GIR_EraseRootFromParent_Done,
     /* 161341 */   // Label 2944: @161341
     /* 161341 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(161377), // Rule ID 355 //
     /* 161346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161368 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 161371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161375 */     GIR_RootConstrainSelectedInstOperands,
     /* 161376 */     // GIR_Coverage, 355,
     /* 161376 */     GIR_EraseRootFromParent_Done,
     /* 161377 */   // Label 2945: @161377
     /* 161377 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(161413), // Rule ID 356 //
     /* 161382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161404 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 161407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161411 */     GIR_RootConstrainSelectedInstOperands,
     /* 161412 */     // GIR_Coverage, 356,
     /* 161412 */     GIR_EraseRootFromParent_Done,
     /* 161413 */   // Label 2946: @161413
     /* 161413 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(161449), // Rule ID 357 //
     /* 161418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161440 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 161443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161447 */     GIR_RootConstrainSelectedInstOperands,
     /* 161448 */     // GIR_Coverage, 357,
     /* 161448 */     GIR_EraseRootFromParent_Done,
     /* 161449 */   // Label 2947: @161449
     /* 161449 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(161485), // Rule ID 358 //
     /* 161454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161476 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 161479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161483 */     GIR_RootConstrainSelectedInstOperands,
     /* 161484 */     // GIR_Coverage, 358,
     /* 161484 */     GIR_EraseRootFromParent_Done,
     /* 161485 */   // Label 2948: @161485
     /* 161485 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(161521), // Rule ID 359 //
     /* 161490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161512 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 161515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161519 */     GIR_RootConstrainSelectedInstOperands,
     /* 161520 */     // GIR_Coverage, 359,
     /* 161520 */     GIR_EraseRootFromParent_Done,
     /* 161521 */   // Label 2949: @161521
     /* 161521 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(161557), // Rule ID 360 //
     /* 161526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161548 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 161551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161555 */     GIR_RootConstrainSelectedInstOperands,
     /* 161556 */     // GIR_Coverage, 360,
     /* 161556 */     GIR_EraseRootFromParent_Done,
     /* 161557 */   // Label 2950: @161557
     /* 161557 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(161593), // Rule ID 361 //
     /* 161562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161584 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 161587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161591 */     GIR_RootConstrainSelectedInstOperands,
     /* 161592 */     // GIR_Coverage, 361,
     /* 161592 */     GIR_EraseRootFromParent_Done,
     /* 161593 */   // Label 2951: @161593
     /* 161593 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(161629), // Rule ID 362 //
     /* 161598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161620 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 161623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161627 */     GIR_RootConstrainSelectedInstOperands,
     /* 161628 */     // GIR_Coverage, 362,
     /* 161628 */     GIR_EraseRootFromParent_Done,
     /* 161629 */   // Label 2952: @161629
     /* 161629 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(161665), // Rule ID 363 //
     /* 161634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161656 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 161659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161663 */     GIR_RootConstrainSelectedInstOperands,
     /* 161664 */     // GIR_Coverage, 363,
     /* 161664 */     GIR_EraseRootFromParent_Done,
     /* 161665 */   // Label 2953: @161665
     /* 161665 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(161701), // Rule ID 364 //
     /* 161670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161692 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 161695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161699 */     GIR_RootConstrainSelectedInstOperands,
     /* 161700 */     // GIR_Coverage, 364,
     /* 161700 */     GIR_EraseRootFromParent_Done,
     /* 161701 */   // Label 2954: @161701
     /* 161701 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(161737), // Rule ID 365 //
     /* 161706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161728 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 161731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161735 */     GIR_RootConstrainSelectedInstOperands,
     /* 161736 */     // GIR_Coverage, 365,
     /* 161736 */     GIR_EraseRootFromParent_Done,
     /* 161737 */   // Label 2955: @161737
     /* 161737 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(161773), // Rule ID 366 //
     /* 161742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161764 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 161767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161771 */     GIR_RootConstrainSelectedInstOperands,
     /* 161772 */     // GIR_Coverage, 366,
     /* 161772 */     GIR_EraseRootFromParent_Done,
     /* 161773 */   // Label 2956: @161773
     /* 161773 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(161809), // Rule ID 367 //
     /* 161778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161800 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 161803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161807 */     GIR_RootConstrainSelectedInstOperands,
     /* 161808 */     // GIR_Coverage, 367,
     /* 161808 */     GIR_EraseRootFromParent_Done,
     /* 161809 */   // Label 2957: @161809
     /* 161809 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(161845), // Rule ID 368 //
     /* 161814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161836 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 161839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161843 */     GIR_RootConstrainSelectedInstOperands,
     /* 161844 */     // GIR_Coverage, 368,
     /* 161844 */     GIR_EraseRootFromParent_Done,
     /* 161845 */   // Label 2958: @161845
     /* 161845 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(161881), // Rule ID 369 //
     /* 161850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161872 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 161875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161879 */     GIR_RootConstrainSelectedInstOperands,
     /* 161880 */     // GIR_Coverage, 369,
     /* 161880 */     GIR_EraseRootFromParent_Done,
     /* 161881 */   // Label 2959: @161881
     /* 161881 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(161917), // Rule ID 370 //
     /* 161886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161908 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 161911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161915 */     GIR_RootConstrainSelectedInstOperands,
     /* 161916 */     // GIR_Coverage, 370,
     /* 161916 */     GIR_EraseRootFromParent_Done,
     /* 161917 */   // Label 2960: @161917
     /* 161917 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(161953), // Rule ID 371 //
     /* 161922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161944 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 161947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161951 */     GIR_RootConstrainSelectedInstOperands,
     /* 161952 */     // GIR_Coverage, 371,
     /* 161952 */     GIR_EraseRootFromParent_Done,
     /* 161953 */   // Label 2961: @161953
     /* 161953 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(161989), // Rule ID 372 //
     /* 161958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161980 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 161983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161987 */     GIR_RootConstrainSelectedInstOperands,
     /* 161988 */     // GIR_Coverage, 372,
     /* 161988 */     GIR_EraseRootFromParent_Done,
     /* 161989 */   // Label 2962: @161989
     /* 161989 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(162025), // Rule ID 373 //
     /* 161994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162016 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 162019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162023 */     GIR_RootConstrainSelectedInstOperands,
     /* 162024 */     // GIR_Coverage, 373,
     /* 162024 */     GIR_EraseRootFromParent_Done,
     /* 162025 */   // Label 2963: @162025
     /* 162025 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(162061), // Rule ID 374 //
     /* 162030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162052 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 162055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162059 */     GIR_RootConstrainSelectedInstOperands,
     /* 162060 */     // GIR_Coverage, 374,
     /* 162060 */     GIR_EraseRootFromParent_Done,
     /* 162061 */   // Label 2964: @162061
     /* 162061 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(162097), // Rule ID 375 //
     /* 162066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162088 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 162091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162095 */     GIR_RootConstrainSelectedInstOperands,
     /* 162096 */     // GIR_Coverage, 375,
     /* 162096 */     GIR_EraseRootFromParent_Done,
     /* 162097 */   // Label 2965: @162097
     /* 162097 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(162133), // Rule ID 376 //
     /* 162102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162124 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 162127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162131 */     GIR_RootConstrainSelectedInstOperands,
     /* 162132 */     // GIR_Coverage, 376,
     /* 162132 */     GIR_EraseRootFromParent_Done,
     /* 162133 */   // Label 2966: @162133
     /* 162133 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(162169), // Rule ID 377 //
     /* 162138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162160 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 162163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162167 */     GIR_RootConstrainSelectedInstOperands,
     /* 162168 */     // GIR_Coverage, 377,
     /* 162168 */     GIR_EraseRootFromParent_Done,
     /* 162169 */   // Label 2967: @162169
     /* 162169 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(162205), // Rule ID 378 //
     /* 162174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162196 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162203 */     GIR_RootConstrainSelectedInstOperands,
     /* 162204 */     // GIR_Coverage, 378,
     /* 162204 */     GIR_EraseRootFromParent_Done,
     /* 162205 */   // Label 2968: @162205
     /* 162205 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(162241), // Rule ID 379 //
     /* 162210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162232 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 162235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162239 */     GIR_RootConstrainSelectedInstOperands,
     /* 162240 */     // GIR_Coverage, 379,
     /* 162240 */     GIR_EraseRootFromParent_Done,
     /* 162241 */   // Label 2969: @162241
     /* 162241 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(162277), // Rule ID 380 //
     /* 162246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162268 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 162271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162275 */     GIR_RootConstrainSelectedInstOperands,
     /* 162276 */     // GIR_Coverage, 380,
     /* 162276 */     GIR_EraseRootFromParent_Done,
     /* 162277 */   // Label 2970: @162277
     /* 162277 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(162313), // Rule ID 381 //
     /* 162282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162304 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 162307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162311 */     GIR_RootConstrainSelectedInstOperands,
     /* 162312 */     // GIR_Coverage, 381,
     /* 162312 */     GIR_EraseRootFromParent_Done,
     /* 162313 */   // Label 2971: @162313
     /* 162313 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(162349), // Rule ID 382 //
     /* 162318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162340 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 162343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162347 */     GIR_RootConstrainSelectedInstOperands,
     /* 162348 */     // GIR_Coverage, 382,
     /* 162348 */     GIR_EraseRootFromParent_Done,
     /* 162349 */   // Label 2972: @162349
     /* 162349 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(162385), // Rule ID 383 //
     /* 162354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162376 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 162379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162383 */     GIR_RootConstrainSelectedInstOperands,
     /* 162384 */     // GIR_Coverage, 383,
     /* 162384 */     GIR_EraseRootFromParent_Done,
     /* 162385 */   // Label 2973: @162385
     /* 162385 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(162421), // Rule ID 384 //
     /* 162390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162412 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 162415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162419 */     GIR_RootConstrainSelectedInstOperands,
     /* 162420 */     // GIR_Coverage, 384,
     /* 162420 */     GIR_EraseRootFromParent_Done,
     /* 162421 */   // Label 2974: @162421
     /* 162421 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(162457), // Rule ID 385 //
     /* 162426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162448 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 162451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162455 */     GIR_RootConstrainSelectedInstOperands,
     /* 162456 */     // GIR_Coverage, 385,
     /* 162456 */     GIR_EraseRootFromParent_Done,
     /* 162457 */   // Label 2975: @162457
     /* 162457 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(162493), // Rule ID 386 //
     /* 162462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162484 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 162487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162491 */     GIR_RootConstrainSelectedInstOperands,
     /* 162492 */     // GIR_Coverage, 386,
     /* 162492 */     GIR_EraseRootFromParent_Done,
     /* 162493 */   // Label 2976: @162493
     /* 162493 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(162529), // Rule ID 387 //
     /* 162498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162520 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 162523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162527 */     GIR_RootConstrainSelectedInstOperands,
     /* 162528 */     // GIR_Coverage, 387,
     /* 162528 */     GIR_EraseRootFromParent_Done,
     /* 162529 */   // Label 2977: @162529
     /* 162529 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(162565), // Rule ID 388 //
     /* 162534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162556 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 162559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162563 */     GIR_RootConstrainSelectedInstOperands,
     /* 162564 */     // GIR_Coverage, 388,
     /* 162564 */     GIR_EraseRootFromParent_Done,
     /* 162565 */   // Label 2978: @162565
     /* 162565 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(162601), // Rule ID 389 //
     /* 162570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162592 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 162595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162599 */     GIR_RootConstrainSelectedInstOperands,
     /* 162600 */     // GIR_Coverage, 389,
     /* 162600 */     GIR_EraseRootFromParent_Done,
     /* 162601 */   // Label 2979: @162601
     /* 162601 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(162637), // Rule ID 390 //
     /* 162606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162628 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 162631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162635 */     GIR_RootConstrainSelectedInstOperands,
     /* 162636 */     // GIR_Coverage, 390,
     /* 162636 */     GIR_EraseRootFromParent_Done,
     /* 162637 */   // Label 2980: @162637
     /* 162637 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(162673), // Rule ID 391 //
     /* 162642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162664 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 162667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162671 */     GIR_RootConstrainSelectedInstOperands,
     /* 162672 */     // GIR_Coverage, 391,
     /* 162672 */     GIR_EraseRootFromParent_Done,
     /* 162673 */   // Label 2981: @162673
     /* 162673 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(162709), // Rule ID 392 //
     /* 162678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162700 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 162703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162707 */     GIR_RootConstrainSelectedInstOperands,
     /* 162708 */     // GIR_Coverage, 392,
     /* 162708 */     GIR_EraseRootFromParent_Done,
     /* 162709 */   // Label 2982: @162709
     /* 162709 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(162745), // Rule ID 393 //
     /* 162714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162736 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 162739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162743 */     GIR_RootConstrainSelectedInstOperands,
     /* 162744 */     // GIR_Coverage, 393,
     /* 162744 */     GIR_EraseRootFromParent_Done,
     /* 162745 */   // Label 2983: @162745
     /* 162745 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(162781), // Rule ID 575 //
     /* 162750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 162758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162772 */     // (intrinsic_wo_chain:{ *:[f32] } 558:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 162775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162779 */     GIR_RootConstrainSelectedInstOperands,
     /* 162780 */     // GIR_Coverage, 575,
     /* 162780 */     GIR_EraseRootFromParent_Done,
     /* 162781 */   // Label 2984: @162781
     /* 162781 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(162817), // Rule ID 576 //
     /* 162786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 162794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162808 */     // (intrinsic_wo_chain:{ *:[f64] } 558:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 162811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162815 */     GIR_RootConstrainSelectedInstOperands,
     /* 162816 */     // GIR_Coverage, 576,
     /* 162816 */     GIR_EraseRootFromParent_Done,
     /* 162817 */   // Label 2985: @162817
     /* 162817 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(162853), // Rule ID 577 //
     /* 162822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 162830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162844 */     // (intrinsic_wo_chain:{ *:[f32] } 560:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 162847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162851 */     GIR_RootConstrainSelectedInstOperands,
     /* 162852 */     // GIR_Coverage, 577,
     /* 162852 */     GIR_EraseRootFromParent_Done,
     /* 162853 */   // Label 2986: @162853
     /* 162853 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(162889), // Rule ID 578 //
     /* 162858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 162866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162880 */     // (intrinsic_wo_chain:{ *:[f64] } 560:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 162883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162887 */     GIR_RootConstrainSelectedInstOperands,
     /* 162888 */     // GIR_Coverage, 578,
     /* 162888 */     GIR_EraseRootFromParent_Done,
     /* 162889 */   // Label 2987: @162889
     /* 162889 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(162925), // Rule ID 579 //
     /* 162894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 162902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162916 */     // (intrinsic_wo_chain:{ *:[f32] } 557:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 162919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162923 */     GIR_RootConstrainSelectedInstOperands,
     /* 162924 */     // GIR_Coverage, 579,
     /* 162924 */     GIR_EraseRootFromParent_Done,
     /* 162925 */   // Label 2988: @162925
     /* 162925 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(162961), // Rule ID 580 //
     /* 162930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 162938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162952 */     // (intrinsic_wo_chain:{ *:[f64] } 557:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 162955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162959 */     GIR_RootConstrainSelectedInstOperands,
     /* 162960 */     // GIR_Coverage, 580,
     /* 162960 */     GIR_EraseRootFromParent_Done,
     /* 162961 */   // Label 2989: @162961
     /* 162961 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(162997), // Rule ID 581 //
     /* 162966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 162974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162988 */     // (intrinsic_wo_chain:{ *:[f32] } 559:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 162991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162995 */     GIR_RootConstrainSelectedInstOperands,
     /* 162996 */     // GIR_Coverage, 581,
     /* 162996 */     GIR_EraseRootFromParent_Done,
     /* 162997 */   // Label 2990: @162997
     /* 162997 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(163033), // Rule ID 582 //
     /* 163002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 163010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163024 */     // (intrinsic_wo_chain:{ *:[f64] } 559:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 163024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 163027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163031 */     GIR_RootConstrainSelectedInstOperands,
     /* 163032 */     // GIR_Coverage, 582,
     /* 163032 */     GIR_EraseRootFromParent_Done,
     /* 163033 */   // Label 2991: @163033
     /* 163033 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(163069), // Rule ID 710 //
     /* 163038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 163049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 163052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163060 */     // (intrinsic_wo_chain:{ *:[v8i8] } 585:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 163060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 163063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163067 */     GIR_RootConstrainSelectedInstOperands,
     /* 163068 */     // GIR_Coverage, 710,
     /* 163068 */     GIR_EraseRootFromParent_Done,
     /* 163069 */   // Label 2992: @163069
     /* 163069 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(163105), // Rule ID 711 //
     /* 163074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 163085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163096 */     // (intrinsic_wo_chain:{ *:[v16i8] } 585:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 163096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 163099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163103 */     GIR_RootConstrainSelectedInstOperands,
     /* 163104 */     // GIR_Coverage, 711,
     /* 163104 */     GIR_EraseRootFromParent_Done,
     /* 163105 */   // Label 2993: @163105
     /* 163105 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(163141), // Rule ID 712 //
     /* 163110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163132 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 163132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 163135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163139 */     GIR_RootConstrainSelectedInstOperands,
     /* 163140 */     // GIR_Coverage, 712,
     /* 163140 */     GIR_EraseRootFromParent_Done,
     /* 163141 */   // Label 2994: @163141
     /* 163141 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(163177), // Rule ID 713 //
     /* 163146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 163168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 163171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163175 */     GIR_RootConstrainSelectedInstOperands,
     /* 163176 */     // GIR_Coverage, 713,
     /* 163176 */     GIR_EraseRootFromParent_Done,
     /* 163177 */   // Label 2995: @163177
     /* 163177 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(163213), // Rule ID 714 //
     /* 163182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163204 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 163204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 163207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163211 */     GIR_RootConstrainSelectedInstOperands,
     /* 163212 */     // GIR_Coverage, 714,
     /* 163212 */     GIR_EraseRootFromParent_Done,
     /* 163213 */   // Label 2996: @163213
     /* 163213 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(163249), // Rule ID 715 //
     /* 163218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163240 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 163240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 163243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163247 */     GIR_RootConstrainSelectedInstOperands,
     /* 163248 */     // GIR_Coverage, 715,
     /* 163248 */     GIR_EraseRootFromParent_Done,
     /* 163249 */   // Label 2997: @163249
     /* 163249 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(163285), // Rule ID 796 //
     /* 163254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163276 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 163279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163283 */     GIR_RootConstrainSelectedInstOperands,
     /* 163284 */     // GIR_Coverage, 796,
     /* 163284 */     GIR_EraseRootFromParent_Done,
     /* 163285 */   // Label 2998: @163285
     /* 163285 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(163321), // Rule ID 797 //
     /* 163290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163312 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 163315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163319 */     GIR_RootConstrainSelectedInstOperands,
     /* 163320 */     // GIR_Coverage, 797,
     /* 163320 */     GIR_EraseRootFromParent_Done,
     /* 163321 */   // Label 2999: @163321
     /* 163321 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(163357), // Rule ID 798 //
     /* 163326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 163351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163355 */     GIR_RootConstrainSelectedInstOperands,
     /* 163356 */     // GIR_Coverage, 798,
     /* 163356 */     GIR_EraseRootFromParent_Done,
     /* 163357 */   // Label 3000: @163357
     /* 163357 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(163393), // Rule ID 799 //
     /* 163362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 163387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163391 */     GIR_RootConstrainSelectedInstOperands,
     /* 163392 */     // GIR_Coverage, 799,
     /* 163392 */     GIR_EraseRootFromParent_Done,
     /* 163393 */   // Label 3001: @163393
     /* 163393 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(163429), // Rule ID 800 //
     /* 163398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163420 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 163423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163427 */     GIR_RootConstrainSelectedInstOperands,
     /* 163428 */     // GIR_Coverage, 800,
     /* 163428 */     GIR_EraseRootFromParent_Done,
     /* 163429 */   // Label 3002: @163429
     /* 163429 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(163465), // Rule ID 801 //
     /* 163434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163456 */     // (intrinsic_wo_chain:{ *:[v4i16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 163459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163463 */     GIR_RootConstrainSelectedInstOperands,
     /* 163464 */     // GIR_Coverage, 801,
     /* 163464 */     GIR_EraseRootFromParent_Done,
     /* 163465 */   // Label 3003: @163465
     /* 163465 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(163501), // Rule ID 802 //
     /* 163470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163492 */     // (intrinsic_wo_chain:{ *:[v8i16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 163495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163499 */     GIR_RootConstrainSelectedInstOperands,
     /* 163500 */     // GIR_Coverage, 802,
     /* 163500 */     GIR_EraseRootFromParent_Done,
     /* 163501 */   // Label 3004: @163501
     /* 163501 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(163537), // Rule ID 803 //
     /* 163506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163528 */     // (intrinsic_wo_chain:{ *:[v2i32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 163531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163535 */     GIR_RootConstrainSelectedInstOperands,
     /* 163536 */     // GIR_Coverage, 803,
     /* 163536 */     GIR_EraseRootFromParent_Done,
     /* 163537 */   // Label 3005: @163537
     /* 163537 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(163573), // Rule ID 804 //
     /* 163542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163564 */     // (intrinsic_wo_chain:{ *:[v4i32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 163567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163571 */     GIR_RootConstrainSelectedInstOperands,
     /* 163572 */     // GIR_Coverage, 804,
     /* 163572 */     GIR_EraseRootFromParent_Done,
     /* 163573 */   // Label 3006: @163573
     /* 163573 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(163609), // Rule ID 805 //
     /* 163578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163600 */     // (intrinsic_wo_chain:{ *:[v2i64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 163603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163607 */     GIR_RootConstrainSelectedInstOperands,
     /* 163608 */     // GIR_Coverage, 805,
     /* 163608 */     GIR_EraseRootFromParent_Done,
     /* 163609 */   // Label 3007: @163609
     /* 163609 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(163645), // Rule ID 806 //
     /* 163614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163636 */     // (intrinsic_wo_chain:{ *:[v4i16] } 595:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 163639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163643 */     GIR_RootConstrainSelectedInstOperands,
     /* 163644 */     // GIR_Coverage, 806,
     /* 163644 */     GIR_EraseRootFromParent_Done,
     /* 163645 */   // Label 3008: @163645
     /* 163645 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(163681), // Rule ID 807 //
     /* 163650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 595:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 163675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163679 */     GIR_RootConstrainSelectedInstOperands,
     /* 163680 */     // GIR_Coverage, 807,
     /* 163680 */     GIR_EraseRootFromParent_Done,
     /* 163681 */   // Label 3009: @163681
     /* 163681 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(163717), // Rule ID 808 //
     /* 163686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163708 */     // (intrinsic_wo_chain:{ *:[v2i32] } 595:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 163711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163715 */     GIR_RootConstrainSelectedInstOperands,
     /* 163716 */     // GIR_Coverage, 808,
     /* 163716 */     GIR_EraseRootFromParent_Done,
     /* 163717 */   // Label 3010: @163717
     /* 163717 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(163753), // Rule ID 809 //
     /* 163722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 595:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 163747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163751 */     GIR_RootConstrainSelectedInstOperands,
     /* 163752 */     // GIR_Coverage, 809,
     /* 163752 */     GIR_EraseRootFromParent_Done,
     /* 163753 */   // Label 3011: @163753
     /* 163753 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(163789), // Rule ID 810 //
     /* 163758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163780 */     // (intrinsic_wo_chain:{ *:[v2i64] } 595:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 163783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163787 */     GIR_RootConstrainSelectedInstOperands,
     /* 163788 */     // GIR_Coverage, 810,
     /* 163788 */     GIR_EraseRootFromParent_Done,
     /* 163789 */   // Label 3012: @163789
     /* 163789 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(163825), // Rule ID 811 //
     /* 163794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163816 */     // (intrinsic_wo_chain:{ *:[v4i16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 163819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163823 */     GIR_RootConstrainSelectedInstOperands,
     /* 163824 */     // GIR_Coverage, 811,
     /* 163824 */     GIR_EraseRootFromParent_Done,
     /* 163825 */   // Label 3013: @163825
     /* 163825 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(163861), // Rule ID 812 //
     /* 163830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 163855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163859 */     GIR_RootConstrainSelectedInstOperands,
     /* 163860 */     // GIR_Coverage, 812,
     /* 163860 */     GIR_EraseRootFromParent_Done,
     /* 163861 */   // Label 3014: @163861
     /* 163861 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(163897), // Rule ID 813 //
     /* 163866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163888 */     // (intrinsic_wo_chain:{ *:[v2i32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 163891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163895 */     GIR_RootConstrainSelectedInstOperands,
     /* 163896 */     // GIR_Coverage, 813,
     /* 163896 */     GIR_EraseRootFromParent_Done,
     /* 163897 */   // Label 3015: @163897
     /* 163897 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(163933), // Rule ID 814 //
     /* 163902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 163927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163931 */     GIR_RootConstrainSelectedInstOperands,
     /* 163932 */     // GIR_Coverage, 814,
     /* 163932 */     GIR_EraseRootFromParent_Done,
     /* 163933 */   // Label 3016: @163933
     /* 163933 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(163969), // Rule ID 815 //
     /* 163938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163960 */     // (intrinsic_wo_chain:{ *:[v2i64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 163963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163967 */     GIR_RootConstrainSelectedInstOperands,
     /* 163968 */     // GIR_Coverage, 815,
     /* 163968 */     GIR_EraseRootFromParent_Done,
     /* 163969 */   // Label 3017: @163969
     /* 163969 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(164005), // Rule ID 816 //
     /* 163974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 163982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163996 */     // (intrinsic_wo_chain:{ *:[v4i16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 163999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164003 */     GIR_RootConstrainSelectedInstOperands,
     /* 164004 */     // GIR_Coverage, 816,
     /* 164004 */     GIR_EraseRootFromParent_Done,
     /* 164005 */   // Label 3018: @164005
     /* 164005 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(164041), // Rule ID 817 //
     /* 164010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164032 */     // (intrinsic_wo_chain:{ *:[v8i16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 164035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164039 */     GIR_RootConstrainSelectedInstOperands,
     /* 164040 */     // GIR_Coverage, 817,
     /* 164040 */     GIR_EraseRootFromParent_Done,
     /* 164041 */   // Label 3019: @164041
     /* 164041 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(164077), // Rule ID 818 //
     /* 164046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164068 */     // (intrinsic_wo_chain:{ *:[v2i32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 164071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164075 */     GIR_RootConstrainSelectedInstOperands,
     /* 164076 */     // GIR_Coverage, 818,
     /* 164076 */     GIR_EraseRootFromParent_Done,
     /* 164077 */   // Label 3020: @164077
     /* 164077 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(164113), // Rule ID 819 //
     /* 164082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164104 */     // (intrinsic_wo_chain:{ *:[v4i32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 164107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164111 */     GIR_RootConstrainSelectedInstOperands,
     /* 164112 */     // GIR_Coverage, 819,
     /* 164112 */     GIR_EraseRootFromParent_Done,
     /* 164113 */   // Label 3021: @164113
     /* 164113 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(164149), // Rule ID 820 //
     /* 164118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164140 */     // (intrinsic_wo_chain:{ *:[v2i64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 164143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164147 */     GIR_RootConstrainSelectedInstOperands,
     /* 164148 */     // GIR_Coverage, 820,
     /* 164148 */     GIR_EraseRootFromParent_Done,
     /* 164149 */   // Label 3022: @164149
     /* 164149 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(164185), // Rule ID 821 //
     /* 164154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164176 */     // (intrinsic_wo_chain:{ *:[v4i16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 164179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164183 */     GIR_RootConstrainSelectedInstOperands,
     /* 164184 */     // GIR_Coverage, 821,
     /* 164184 */     GIR_EraseRootFromParent_Done,
     /* 164185 */   // Label 3023: @164185
     /* 164185 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(164221), // Rule ID 822 //
     /* 164190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164212 */     // (intrinsic_wo_chain:{ *:[v8i16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 164215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164219 */     GIR_RootConstrainSelectedInstOperands,
     /* 164220 */     // GIR_Coverage, 822,
     /* 164220 */     GIR_EraseRootFromParent_Done,
     /* 164221 */   // Label 3024: @164221
     /* 164221 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(164257), // Rule ID 823 //
     /* 164226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164248 */     // (intrinsic_wo_chain:{ *:[v2i32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 164251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164255 */     GIR_RootConstrainSelectedInstOperands,
     /* 164256 */     // GIR_Coverage, 823,
     /* 164256 */     GIR_EraseRootFromParent_Done,
     /* 164257 */   // Label 3025: @164257
     /* 164257 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(164293), // Rule ID 824 //
     /* 164262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 164287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164291 */     GIR_RootConstrainSelectedInstOperands,
     /* 164292 */     // GIR_Coverage, 824,
     /* 164292 */     GIR_EraseRootFromParent_Done,
     /* 164293 */   // Label 3026: @164293
     /* 164293 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(164329), // Rule ID 825 //
     /* 164298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164320 */     // (intrinsic_wo_chain:{ *:[v2i64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 164323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164327 */     GIR_RootConstrainSelectedInstOperands,
     /* 164328 */     // GIR_Coverage, 825,
     /* 164328 */     GIR_EraseRootFromParent_Done,
     /* 164329 */   // Label 3027: @164329
     /* 164329 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(164365), // Rule ID 826 //
     /* 164334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164356 */     // (intrinsic_wo_chain:{ *:[v4i16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 164359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164363 */     GIR_RootConstrainSelectedInstOperands,
     /* 164364 */     // GIR_Coverage, 826,
     /* 164364 */     GIR_EraseRootFromParent_Done,
     /* 164365 */   // Label 3028: @164365
     /* 164365 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(164401), // Rule ID 827 //
     /* 164370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164392 */     // (intrinsic_wo_chain:{ *:[v8i16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 164395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164399 */     GIR_RootConstrainSelectedInstOperands,
     /* 164400 */     // GIR_Coverage, 827,
     /* 164400 */     GIR_EraseRootFromParent_Done,
     /* 164401 */   // Label 3029: @164401
     /* 164401 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(164437), // Rule ID 828 //
     /* 164406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164428 */     // (intrinsic_wo_chain:{ *:[v2i32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 164431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164435 */     GIR_RootConstrainSelectedInstOperands,
     /* 164436 */     // GIR_Coverage, 828,
     /* 164436 */     GIR_EraseRootFromParent_Done,
     /* 164437 */   // Label 3030: @164437
     /* 164437 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(164473), // Rule ID 829 //
     /* 164442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164464 */     // (intrinsic_wo_chain:{ *:[v4i32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 164467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164471 */     GIR_RootConstrainSelectedInstOperands,
     /* 164472 */     // GIR_Coverage, 829,
     /* 164472 */     GIR_EraseRootFromParent_Done,
     /* 164473 */   // Label 3031: @164473
     /* 164473 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(164509), // Rule ID 830 //
     /* 164478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164500 */     // (intrinsic_wo_chain:{ *:[v2i64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 164503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164507 */     GIR_RootConstrainSelectedInstOperands,
     /* 164508 */     // GIR_Coverage, 830,
     /* 164508 */     GIR_EraseRootFromParent_Done,
     /* 164509 */   // Label 3032: @164509
     /* 164509 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(164545), // Rule ID 831 //
     /* 164514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 600:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 164539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164543 */     GIR_RootConstrainSelectedInstOperands,
     /* 164544 */     // GIR_Coverage, 831,
     /* 164544 */     GIR_EraseRootFromParent_Done,
     /* 164545 */   // Label 3033: @164545
     /* 164545 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(164581), // Rule ID 832 //
     /* 164550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164572 */     // (intrinsic_wo_chain:{ *:[v8i16] } 600:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 164575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164579 */     GIR_RootConstrainSelectedInstOperands,
     /* 164580 */     // GIR_Coverage, 832,
     /* 164580 */     GIR_EraseRootFromParent_Done,
     /* 164581 */   // Label 3034: @164581
     /* 164581 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(164617), // Rule ID 833 //
     /* 164586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164608 */     // (intrinsic_wo_chain:{ *:[v2i32] } 600:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 164611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164615 */     GIR_RootConstrainSelectedInstOperands,
     /* 164616 */     // GIR_Coverage, 833,
     /* 164616 */     GIR_EraseRootFromParent_Done,
     /* 164617 */   // Label 3035: @164617
     /* 164617 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(164653), // Rule ID 834 //
     /* 164622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164644 */     // (intrinsic_wo_chain:{ *:[v4i32] } 600:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 164647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164651 */     GIR_RootConstrainSelectedInstOperands,
     /* 164652 */     // GIR_Coverage, 834,
     /* 164652 */     GIR_EraseRootFromParent_Done,
     /* 164653 */   // Label 3036: @164653
     /* 164653 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(164689), // Rule ID 835 //
     /* 164658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164680 */     // (intrinsic_wo_chain:{ *:[v2i64] } 600:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 164683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164687 */     GIR_RootConstrainSelectedInstOperands,
     /* 164688 */     // GIR_Coverage, 835,
     /* 164688 */     GIR_EraseRootFromParent_Done,
     /* 164689 */   // Label 3037: @164689
     /* 164689 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(164725), // Rule ID 836 //
     /* 164694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 164702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164716 */     // (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 164716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164723 */     GIR_RootConstrainSelectedInstOperands,
     /* 164724 */     // GIR_Coverage, 836,
     /* 164724 */     GIR_EraseRootFromParent_Done,
     /* 164725 */   // Label 3038: @164725
     /* 164725 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(164761), // Rule ID 863 //
     /* 164730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164752 */     // (intrinsic_wo_chain:{ *:[v4f16] } 642:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 164752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 164755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164759 */     GIR_RootConstrainSelectedInstOperands,
     /* 164760 */     // GIR_Coverage, 863,
     /* 164760 */     GIR_EraseRootFromParent_Done,
     /* 164761 */   // Label 3039: @164761
     /* 164761 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(164797), // Rule ID 864 //
     /* 164766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164788 */     // (intrinsic_wo_chain:{ *:[v8f16] } 642:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 164788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 164791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164795 */     GIR_RootConstrainSelectedInstOperands,
     /* 164796 */     // GIR_Coverage, 864,
     /* 164796 */     GIR_EraseRootFromParent_Done,
     /* 164797 */   // Label 3040: @164797
     /* 164797 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(164833), // Rule ID 865 //
     /* 164802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164824 */     // (intrinsic_wo_chain:{ *:[v2f32] } 642:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 164824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 164827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164831 */     GIR_RootConstrainSelectedInstOperands,
     /* 164832 */     // GIR_Coverage, 865,
     /* 164832 */     GIR_EraseRootFromParent_Done,
     /* 164833 */   // Label 3041: @164833
     /* 164833 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(164869), // Rule ID 866 //
     /* 164838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164860 */     // (intrinsic_wo_chain:{ *:[v4f32] } 642:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 164860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 164863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164867 */     GIR_RootConstrainSelectedInstOperands,
     /* 164868 */     // GIR_Coverage, 866,
     /* 164868 */     GIR_EraseRootFromParent_Done,
     /* 164869 */   // Label 3042: @164869
     /* 164869 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(164905), // Rule ID 867 //
     /* 164874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164896 */     // (intrinsic_wo_chain:{ *:[v2f64] } 642:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 164896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 164899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164903 */     GIR_RootConstrainSelectedInstOperands,
     /* 164904 */     // GIR_Coverage, 867,
     /* 164904 */     GIR_EraseRootFromParent_Done,
     /* 164905 */   // Label 3043: @164905
     /* 164905 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(164941), // Rule ID 938 //
     /* 164910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164932 */     // (intrinsic_wo_chain:{ *:[v2f32] } 646:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 164932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 164935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164939 */     GIR_RootConstrainSelectedInstOperands,
     /* 164940 */     // GIR_Coverage, 938,
     /* 164940 */     GIR_EraseRootFromParent_Done,
     /* 164941 */   // Label 3044: @164941
     /* 164941 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(164977), // Rule ID 939 //
     /* 164946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164968 */     // (intrinsic_wo_chain:{ *:[v4f32] } 646:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 164968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 164971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164975 */     GIR_RootConstrainSelectedInstOperands,
     /* 164976 */     // GIR_Coverage, 939,
     /* 164976 */     GIR_EraseRootFromParent_Done,
     /* 164977 */   // Label 3045: @164977
     /* 164977 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(165013), // Rule ID 940 //
     /* 164982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165004 */     // (intrinsic_wo_chain:{ *:[v2f64] } 646:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 165007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165011 */     GIR_RootConstrainSelectedInstOperands,
     /* 165012 */     // GIR_Coverage, 940,
     /* 165012 */     GIR_EraseRootFromParent_Done,
     /* 165013 */   // Label 3046: @165013
     /* 165013 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(165049), // Rule ID 941 //
     /* 165018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165040 */     // (intrinsic_wo_chain:{ *:[v2f32] } 648:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 165043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165047 */     GIR_RootConstrainSelectedInstOperands,
     /* 165048 */     // GIR_Coverage, 941,
     /* 165048 */     GIR_EraseRootFromParent_Done,
     /* 165049 */   // Label 3047: @165049
     /* 165049 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(165085), // Rule ID 942 //
     /* 165054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165076 */     // (intrinsic_wo_chain:{ *:[v4f32] } 648:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 165079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165083 */     GIR_RootConstrainSelectedInstOperands,
     /* 165084 */     // GIR_Coverage, 942,
     /* 165084 */     GIR_EraseRootFromParent_Done,
     /* 165085 */   // Label 3048: @165085
     /* 165085 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(165121), // Rule ID 943 //
     /* 165090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165112 */     // (intrinsic_wo_chain:{ *:[v2f64] } 648:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 165115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165119 */     GIR_RootConstrainSelectedInstOperands,
     /* 165120 */     // GIR_Coverage, 943,
     /* 165120 */     GIR_EraseRootFromParent_Done,
     /* 165121 */   // Label 3049: @165121
     /* 165121 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(165157), // Rule ID 944 //
     /* 165126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165148 */     // (intrinsic_wo_chain:{ *:[v2f32] } 645:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 165151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165155 */     GIR_RootConstrainSelectedInstOperands,
     /* 165156 */     // GIR_Coverage, 944,
     /* 165156 */     GIR_EraseRootFromParent_Done,
     /* 165157 */   // Label 3050: @165157
     /* 165157 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(165193), // Rule ID 945 //
     /* 165162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165184 */     // (intrinsic_wo_chain:{ *:[v4f32] } 645:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 165187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165191 */     GIR_RootConstrainSelectedInstOperands,
     /* 165192 */     // GIR_Coverage, 945,
     /* 165192 */     GIR_EraseRootFromParent_Done,
     /* 165193 */   // Label 3051: @165193
     /* 165193 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(165229), // Rule ID 946 //
     /* 165198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165220 */     // (intrinsic_wo_chain:{ *:[v2f64] } 645:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 165223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165227 */     GIR_RootConstrainSelectedInstOperands,
     /* 165228 */     // GIR_Coverage, 946,
     /* 165228 */     GIR_EraseRootFromParent_Done,
     /* 165229 */   // Label 3052: @165229
     /* 165229 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(165265), // Rule ID 947 //
     /* 165234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165256 */     // (intrinsic_wo_chain:{ *:[v2f32] } 647:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 165259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165263 */     GIR_RootConstrainSelectedInstOperands,
     /* 165264 */     // GIR_Coverage, 947,
     /* 165264 */     GIR_EraseRootFromParent_Done,
     /* 165265 */   // Label 3053: @165265
     /* 165265 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(165301), // Rule ID 948 //
     /* 165270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165292 */     // (intrinsic_wo_chain:{ *:[v4f32] } 647:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 165295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165299 */     GIR_RootConstrainSelectedInstOperands,
     /* 165300 */     // GIR_Coverage, 948,
     /* 165300 */     GIR_EraseRootFromParent_Done,
     /* 165301 */   // Label 3054: @165301
     /* 165301 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(165337), // Rule ID 949 //
     /* 165306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165328 */     // (intrinsic_wo_chain:{ *:[v2f64] } 647:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 165331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165335 */     GIR_RootConstrainSelectedInstOperands,
     /* 165336 */     // GIR_Coverage, 949,
     /* 165336 */     GIR_EraseRootFromParent_Done,
     /* 165337 */   // Label 3055: @165337
     /* 165337 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(165373), // Rule ID 950 //
     /* 165342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165364 */     // (intrinsic_wo_chain:{ *:[v4f16] } 649:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 165367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165371 */     GIR_RootConstrainSelectedInstOperands,
     /* 165372 */     // GIR_Coverage, 950,
     /* 165372 */     GIR_EraseRootFromParent_Done,
     /* 165373 */   // Label 3056: @165373
     /* 165373 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(165409), // Rule ID 951 //
     /* 165378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165400 */     // (intrinsic_wo_chain:{ *:[v8f16] } 649:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 165403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165407 */     GIR_RootConstrainSelectedInstOperands,
     /* 165408 */     // GIR_Coverage, 951,
     /* 165408 */     GIR_EraseRootFromParent_Done,
     /* 165409 */   // Label 3057: @165409
     /* 165409 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(165445), // Rule ID 952 //
     /* 165414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165436 */     // (intrinsic_wo_chain:{ *:[v2f32] } 649:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 165439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165443 */     GIR_RootConstrainSelectedInstOperands,
     /* 165444 */     // GIR_Coverage, 952,
     /* 165444 */     GIR_EraseRootFromParent_Done,
     /* 165445 */   // Label 3058: @165445
     /* 165445 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(165481), // Rule ID 953 //
     /* 165450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165472 */     // (intrinsic_wo_chain:{ *:[v4f32] } 649:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 165475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165479 */     GIR_RootConstrainSelectedInstOperands,
     /* 165480 */     // GIR_Coverage, 953,
     /* 165480 */     GIR_EraseRootFromParent_Done,
     /* 165481 */   // Label 3059: @165481
     /* 165481 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(165517), // Rule ID 954 //
     /* 165486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165508 */     // (intrinsic_wo_chain:{ *:[v2f64] } 649:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 165511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165515 */     GIR_RootConstrainSelectedInstOperands,
     /* 165516 */     // GIR_Coverage, 954,
     /* 165516 */     GIR_EraseRootFromParent_Done,
     /* 165517 */   // Label 3060: @165517
     /* 165517 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(165553), // Rule ID 1001 //
     /* 165522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165544 */     // (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 165544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 165547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165551 */     GIR_RootConstrainSelectedInstOperands,
     /* 165552 */     // GIR_Coverage, 1001,
     /* 165552 */     GIR_EraseRootFromParent_Done,
     /* 165553 */   // Label 3061: @165553
     /* 165553 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(165589), // Rule ID 1003 //
     /* 165558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165580 */     // (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 165580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 165583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165587 */     GIR_RootConstrainSelectedInstOperands,
     /* 165588 */     // GIR_Coverage, 1003,
     /* 165588 */     GIR_EraseRootFromParent_Done,
     /* 165589 */   // Label 3062: @165589
     /* 165589 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(165625), // Rule ID 1005 //
     /* 165594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165616 */     // (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 165616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 165619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165623 */     GIR_RootConstrainSelectedInstOperands,
     /* 165624 */     // GIR_Coverage, 1005,
     /* 165624 */     GIR_EraseRootFromParent_Done,
     /* 165625 */   // Label 3063: @165625
     /* 165625 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(165661), // Rule ID 1007 //
     /* 165630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165652 */     // (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 165652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 165655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165659 */     GIR_RootConstrainSelectedInstOperands,
     /* 165660 */     // GIR_Coverage, 1007,
     /* 165660 */     GIR_EraseRootFromParent_Done,
     /* 165661 */   // Label 3064: @165661
     /* 165661 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(165697), // Rule ID 1009 //
     /* 165666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165688 */     // (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 165688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 165691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165695 */     GIR_RootConstrainSelectedInstOperands,
     /* 165696 */     // GIR_Coverage, 1009,
     /* 165696 */     GIR_EraseRootFromParent_Done,
     /* 165697 */   // Label 3065: @165697
     /* 165697 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(165733), // Rule ID 1011 //
     /* 165702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 165724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 165727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165731 */     GIR_RootConstrainSelectedInstOperands,
     /* 165732 */     // GIR_Coverage, 1011,
     /* 165732 */     GIR_EraseRootFromParent_Done,
     /* 165733 */   // Label 3066: @165733
     /* 165733 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(165769), // Rule ID 1022 //
     /* 165738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165760 */     // (intrinsic_wo_chain:{ *:[v8i8] } 688:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 165760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 165763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165767 */     GIR_RootConstrainSelectedInstOperands,
     /* 165768 */     // GIR_Coverage, 1022,
     /* 165768 */     GIR_EraseRootFromParent_Done,
     /* 165769 */   // Label 3067: @165769
     /* 165769 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(165805), // Rule ID 1023 //
     /* 165774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165796 */     // (intrinsic_wo_chain:{ *:[v16i8] } 688:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 165799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165803 */     GIR_RootConstrainSelectedInstOperands,
     /* 165804 */     // GIR_Coverage, 1023,
     /* 165804 */     GIR_EraseRootFromParent_Done,
     /* 165805 */   // Label 3068: @165805
     /* 165805 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(165841), // Rule ID 1024 //
     /* 165810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165832 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 165832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 165835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165839 */     GIR_RootConstrainSelectedInstOperands,
     /* 165840 */     // GIR_Coverage, 1024,
     /* 165840 */     GIR_EraseRootFromParent_Done,
     /* 165841 */   // Label 3069: @165841
     /* 165841 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(165877), // Rule ID 1025 //
     /* 165846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165868 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 165868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165875 */     GIR_RootConstrainSelectedInstOperands,
     /* 165876 */     // GIR_Coverage, 1025,
     /* 165876 */     GIR_EraseRootFromParent_Done,
     /* 165877 */   // Label 3070: @165877
     /* 165877 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(165913), // Rule ID 1026 //
     /* 165882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165904 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 165907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165911 */     GIR_RootConstrainSelectedInstOperands,
     /* 165912 */     // GIR_Coverage, 1026,
     /* 165912 */     GIR_EraseRootFromParent_Done,
     /* 165913 */   // Label 3071: @165913
     /* 165913 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165949), // Rule ID 1027 //
     /* 165918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165940 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 165943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165947 */     GIR_RootConstrainSelectedInstOperands,
     /* 165948 */     // GIR_Coverage, 1027,
     /* 165948 */     GIR_EraseRootFromParent_Done,
     /* 165949 */   // Label 3072: @165949
     /* 165949 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165985), // Rule ID 1028 //
     /* 165954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165976 */     // (intrinsic_wo_chain:{ *:[v2i64] } 688:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 165976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 165979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165983 */     GIR_RootConstrainSelectedInstOperands,
     /* 165984 */     // GIR_Coverage, 1028,
     /* 165984 */     GIR_EraseRootFromParent_Done,
     /* 165985 */   // Label 3073: @165985
     /* 165985 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(166021), // Rule ID 1029 //
     /* 165990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166012 */     // (intrinsic_wo_chain:{ *:[v8i8] } 695:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 166012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 166015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166019 */     GIR_RootConstrainSelectedInstOperands,
     /* 166020 */     // GIR_Coverage, 1029,
     /* 166020 */     GIR_EraseRootFromParent_Done,
     /* 166021 */   // Label 3074: @166021
     /* 166021 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(166057), // Rule ID 1030 //
     /* 166026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 695:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 166048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 166051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166055 */     GIR_RootConstrainSelectedInstOperands,
     /* 166056 */     // GIR_Coverage, 1030,
     /* 166056 */     GIR_EraseRootFromParent_Done,
     /* 166057 */   // Label 3075: @166057
     /* 166057 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(166093), // Rule ID 1031 //
     /* 166062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166084 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 166084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 166087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166091 */     GIR_RootConstrainSelectedInstOperands,
     /* 166092 */     // GIR_Coverage, 1031,
     /* 166092 */     GIR_EraseRootFromParent_Done,
     /* 166093 */   // Label 3076: @166093
     /* 166093 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(166129), // Rule ID 1032 //
     /* 166098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 166120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 166123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166127 */     GIR_RootConstrainSelectedInstOperands,
     /* 166128 */     // GIR_Coverage, 1032,
     /* 166128 */     GIR_EraseRootFromParent_Done,
     /* 166129 */   // Label 3077: @166129
     /* 166129 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(166165), // Rule ID 1033 //
     /* 166134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166156 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 166159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166163 */     GIR_RootConstrainSelectedInstOperands,
     /* 166164 */     // GIR_Coverage, 1033,
     /* 166164 */     GIR_EraseRootFromParent_Done,
     /* 166165 */   // Label 3078: @166165
     /* 166165 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(166201), // Rule ID 1034 //
     /* 166170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 166195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166199 */     GIR_RootConstrainSelectedInstOperands,
     /* 166200 */     // GIR_Coverage, 1034,
     /* 166200 */     GIR_EraseRootFromParent_Done,
     /* 166201 */   // Label 3079: @166201
     /* 166201 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(166237), // Rule ID 1035 //
     /* 166206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166228 */     // (intrinsic_wo_chain:{ *:[v2i64] } 695:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 166228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 166231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166235 */     GIR_RootConstrainSelectedInstOperands,
     /* 166236 */     // GIR_Coverage, 1035,
     /* 166236 */     GIR_EraseRootFromParent_Done,
     /* 166237 */   // Label 3080: @166237
     /* 166237 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(166273), // Rule ID 1062 //
     /* 166242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 166264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 166267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166271 */     GIR_RootConstrainSelectedInstOperands,
     /* 166272 */     // GIR_Coverage, 1062,
     /* 166272 */     GIR_EraseRootFromParent_Done,
     /* 166273 */   // Label 3081: @166273
     /* 166273 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(166309), // Rule ID 1064 //
     /* 166278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166300 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 166300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 166303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166307 */     GIR_RootConstrainSelectedInstOperands,
     /* 166308 */     // GIR_Coverage, 1064,
     /* 166308 */     GIR_EraseRootFromParent_Done,
     /* 166309 */   // Label 3082: @166309
     /* 166309 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(166345), // Rule ID 1066 //
     /* 166314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166336 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 166336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 166339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166343 */     GIR_RootConstrainSelectedInstOperands,
     /* 166344 */     // GIR_Coverage, 1066,
     /* 166344 */     GIR_EraseRootFromParent_Done,
     /* 166345 */   // Label 3083: @166345
     /* 166345 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(166381), // Rule ID 1068 //
     /* 166350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166372 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 166372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 166375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166379 */     GIR_RootConstrainSelectedInstOperands,
     /* 166380 */     // GIR_Coverage, 1068,
     /* 166380 */     GIR_EraseRootFromParent_Done,
     /* 166381 */   // Label 3084: @166381
     /* 166381 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(166417), // Rule ID 1070 //
     /* 166386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166408 */     // (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 166408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 166411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166415 */     GIR_RootConstrainSelectedInstOperands,
     /* 166416 */     // GIR_Coverage, 1070,
     /* 166416 */     GIR_EraseRootFromParent_Done,
     /* 166417 */   // Label 3085: @166417
     /* 166417 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(166453), // Rule ID 1072 //
     /* 166422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 166444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 166447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166451 */     GIR_RootConstrainSelectedInstOperands,
     /* 166452 */     // GIR_Coverage, 1072,
     /* 166452 */     GIR_EraseRootFromParent_Done,
     /* 166453 */   // Label 3086: @166453
     /* 166453 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(166489), // Rule ID 1086 //
     /* 166458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166480 */     // (intrinsic_wo_chain:{ *:[v2i32] } 756:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 166483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166487 */     GIR_RootConstrainSelectedInstOperands,
     /* 166488 */     // GIR_Coverage, 1086,
     /* 166488 */     GIR_EraseRootFromParent_Done,
     /* 166489 */   // Label 3087: @166489
     /* 166489 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(166525), // Rule ID 1087 //
     /* 166494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166516 */     // (intrinsic_wo_chain:{ *:[v4i32] } 756:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166523 */     GIR_RootConstrainSelectedInstOperands,
     /* 166524 */     // GIR_Coverage, 1087,
     /* 166524 */     GIR_EraseRootFromParent_Done,
     /* 166525 */   // Label 3088: @166525
     /* 166525 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(166561), // Rule ID 1088 //
     /* 166530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 759:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 166555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166559 */     GIR_RootConstrainSelectedInstOperands,
     /* 166560 */     // GIR_Coverage, 1088,
     /* 166560 */     GIR_EraseRootFromParent_Done,
     /* 166561 */   // Label 3089: @166561
     /* 166561 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(166597), // Rule ID 1089 //
     /* 166566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 759:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 166591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166595 */     GIR_RootConstrainSelectedInstOperands,
     /* 166596 */     // GIR_Coverage, 1089,
     /* 166596 */     GIR_EraseRootFromParent_Done,
     /* 166597 */   // Label 3090: @166597
     /* 166597 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(166633), // Rule ID 1653 //
     /* 166602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 166610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166624 */     // (intrinsic_wo_chain:{ *:[f32] } 796:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 166627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166631 */     GIR_RootConstrainSelectedInstOperands,
     /* 166632 */     // GIR_Coverage, 1653,
     /* 166632 */     GIR_EraseRootFromParent_Done,
     /* 166633 */   // Label 3091: @166633
     /* 166633 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(166669), // Rule ID 1659 //
     /* 166638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166660 */     // (intrinsic_wo_chain:{ *:[i64] } 688:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 166660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 166663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166667 */     GIR_RootConstrainSelectedInstOperands,
     /* 166668 */     // GIR_Coverage, 1659,
     /* 166668 */     GIR_EraseRootFromParent_Done,
     /* 166669 */   // Label 3092: @166669
     /* 166669 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(166705), // Rule ID 1660 //
     /* 166674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166696 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 166696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 166699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166703 */     GIR_RootConstrainSelectedInstOperands,
     /* 166704 */     // GIR_Coverage, 1660,
     /* 166704 */     GIR_EraseRootFromParent_Done,
     /* 166705 */   // Label 3093: @166705
     /* 166705 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(166741), // Rule ID 1661 //
     /* 166710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166732 */     // (intrinsic_wo_chain:{ *:[i64] } 695:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 166732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 166735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166739 */     GIR_RootConstrainSelectedInstOperands,
     /* 166740 */     // GIR_Coverage, 1661,
     /* 166740 */     GIR_EraseRootFromParent_Done,
     /* 166741 */   // Label 3094: @166741
     /* 166741 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(166777), // Rule ID 1662 //
     /* 166746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166768 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 166768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 166771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166775 */     GIR_RootConstrainSelectedInstOperands,
     /* 166776 */     // GIR_Coverage, 1662,
     /* 166776 */     GIR_EraseRootFromParent_Done,
     /* 166777 */   // Label 3095: @166777
     /* 166777 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(166813), // Rule ID 1663 //
     /* 166782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 166790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166804 */     // (intrinsic_wo_chain:{ *:[f32] } 673:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 166807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166811 */     GIR_RootConstrainSelectedInstOperands,
     /* 166812 */     // GIR_Coverage, 1663,
     /* 166812 */     GIR_EraseRootFromParent_Done,
     /* 166813 */   // Label 3096: @166813
     /* 166813 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(166849), // Rule ID 1664 //
     /* 166818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 166826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166840 */     // (intrinsic_wo_chain:{ *:[f32] } 674:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 166843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166847 */     GIR_RootConstrainSelectedInstOperands,
     /* 166848 */     // GIR_Coverage, 1664,
     /* 166848 */     GIR_EraseRootFromParent_Done,
     /* 166849 */   // Label 3097: @166849
     /* 166849 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(166885), // Rule ID 1670 //
     /* 166854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 166862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166876 */     // (intrinsic_wo_chain:{ *:[f32] } 675:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 166879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166883 */     GIR_RootConstrainSelectedInstOperands,
     /* 166884 */     // GIR_Coverage, 1670,
     /* 166884 */     GIR_EraseRootFromParent_Done,
     /* 166885 */   // Label 3098: @166885
     /* 166885 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(166921), // Rule ID 1943 //
     /* 166890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 166901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166912 */     // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 166912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 166915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166919 */     GIR_RootConstrainSelectedInstOperands,
     /* 166920 */     // GIR_Coverage, 1943,
     /* 166920 */     GIR_EraseRootFromParent_Done,
     /* 166921 */   // Label 3099: @166921
     /* 166921 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166957), // Rule ID 1945 //
     /* 166926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 166937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166948 */     // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 166948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 166951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166955 */     GIR_RootConstrainSelectedInstOperands,
     /* 166956 */     // GIR_Coverage, 1945,
     /* 166956 */     GIR_EraseRootFromParent_Done,
     /* 166957 */   // Label 3100: @166957
     /* 166957 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166993), // Rule ID 1947 //
     /* 166962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166984 */     // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 166984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 166987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166991 */     GIR_RootConstrainSelectedInstOperands,
     /* 166992 */     // GIR_Coverage, 1947,
     /* 166992 */     GIR_EraseRootFromParent_Done,
     /* 166993 */   // Label 3101: @166993
     /* 166993 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(167029), // Rule ID 1949 //
     /* 166998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167020 */     // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 167023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167027 */     GIR_RootConstrainSelectedInstOperands,
     /* 167028 */     // GIR_Coverage, 1949,
     /* 167028 */     GIR_EraseRootFromParent_Done,
     /* 167029 */   // Label 3102: @167029
     /* 167029 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(167065), // Rule ID 1951 //
     /* 167034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167056 */     // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 167059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167063 */     GIR_RootConstrainSelectedInstOperands,
     /* 167064 */     // GIR_Coverage, 1951,
     /* 167064 */     GIR_EraseRootFromParent_Done,
     /* 167065 */   // Label 3103: @167065
     /* 167065 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(167101), // Rule ID 1953 //
     /* 167070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167092 */     // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 167095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167099 */     GIR_RootConstrainSelectedInstOperands,
     /* 167100 */     // GIR_Coverage, 1953,
     /* 167100 */     GIR_EraseRootFromParent_Done,
     /* 167101 */   // Label 3104: @167101
     /* 167101 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(167137), // Rule ID 1955 //
     /* 167106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167128 */     // (intrinsic_wo_chain:{ *:[f16] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 167131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167135 */     GIR_RootConstrainSelectedInstOperands,
     /* 167136 */     // GIR_Coverage, 1955,
     /* 167136 */     GIR_EraseRootFromParent_Done,
     /* 167137 */   // Label 3105: @167137
     /* 167137 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(167173), // Rule ID 1957 //
     /* 167142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167164 */     // (intrinsic_wo_chain:{ *:[f16] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 167167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167171 */     GIR_RootConstrainSelectedInstOperands,
     /* 167172 */     // GIR_Coverage, 1957,
     /* 167172 */     GIR_EraseRootFromParent_Done,
     /* 167173 */   // Label 3106: @167173
     /* 167173 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(167209), // Rule ID 1959 //
     /* 167178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167200 */     // (intrinsic_wo_chain:{ *:[f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 167203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167207 */     GIR_RootConstrainSelectedInstOperands,
     /* 167208 */     // GIR_Coverage, 1959,
     /* 167208 */     GIR_EraseRootFromParent_Done,
     /* 167209 */   // Label 3107: @167209
     /* 167209 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(167245), // Rule ID 1961 //
     /* 167214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167236 */     // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 167239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167243 */     GIR_RootConstrainSelectedInstOperands,
     /* 167244 */     // GIR_Coverage, 1961,
     /* 167244 */     GIR_EraseRootFromParent_Done,
     /* 167245 */   // Label 3108: @167245
     /* 167245 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(167281), // Rule ID 1963 //
     /* 167250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167272 */     // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 167275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167279 */     GIR_RootConstrainSelectedInstOperands,
     /* 167280 */     // GIR_Coverage, 1963,
     /* 167280 */     GIR_EraseRootFromParent_Done,
     /* 167281 */   // Label 3109: @167281
     /* 167281 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(167317), // Rule ID 1965 //
     /* 167286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167308 */     // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 167311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167315 */     GIR_RootConstrainSelectedInstOperands,
     /* 167316 */     // GIR_Coverage, 1965,
     /* 167316 */     GIR_EraseRootFromParent_Done,
     /* 167317 */   // Label 3110: @167317
     /* 167317 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(167353), // Rule ID 2305 //
     /* 167322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 167330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167344 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 167347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167351 */     GIR_RootConstrainSelectedInstOperands,
     /* 167352 */     // GIR_Coverage, 2305,
     /* 167352 */     GIR_EraseRootFromParent_Done,
     /* 167353 */   // Label 3111: @167353
     /* 167353 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(167389), // Rule ID 2306 //
     /* 167358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 167366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167380 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 167383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167387 */     GIR_RootConstrainSelectedInstOperands,
     /* 167388 */     // GIR_Coverage, 2306,
     /* 167388 */     GIR_EraseRootFromParent_Done,
     /* 167389 */   // Label 3112: @167389
     /* 167389 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(167425), // Rule ID 2314 //
     /* 167394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 167397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 167402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167416 */     // (intrinsic_wo_chain:{ *:[i32] } 531:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 167416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 167419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167423 */     GIR_RootConstrainSelectedInstOperands,
     /* 167424 */     // GIR_Coverage, 2314,
     /* 167424 */     GIR_EraseRootFromParent_Done,
     /* 167425 */   // Label 3113: @167425
     /* 167425 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(167461), // Rule ID 2511 //
     /* 167430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 167438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167452 */     // (intrinsic_wo_chain:{ *:[v1i64] } 688:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 167452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 167455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167459 */     GIR_RootConstrainSelectedInstOperands,
     /* 167460 */     // GIR_Coverage, 2511,
     /* 167460 */     GIR_EraseRootFromParent_Done,
     /* 167461 */   // Label 3114: @167461
     /* 167461 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(167500), // Rule ID 3546 //
     /* 167466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 167477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 167480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 167488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 167491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167498 */     GIR_RootConstrainSelectedInstOperands,
     /* 167499 */     // GIR_Coverage, 3546,
     /* 167499 */     GIR_EraseRootFromParent_Done,
     /* 167500 */   // Label 3115: @167500
     /* 167500 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(167539), // Rule ID 3547 //
     /* 167505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 167516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167527 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 167527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 167530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167537 */     GIR_RootConstrainSelectedInstOperands,
     /* 167538 */     // GIR_Coverage, 3547,
     /* 167538 */     GIR_EraseRootFromParent_Done,
     /* 167539 */   // Label 3116: @167539
     /* 167539 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(167578), // Rule ID 3548 //
     /* 167544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 167555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167566 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 167566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 167569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167576 */     GIR_RootConstrainSelectedInstOperands,
     /* 167577 */     // GIR_Coverage, 3548,
     /* 167577 */     GIR_EraseRootFromParent_Done,
     /* 167578 */   // Label 3117: @167578
     /* 167578 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(167617), // Rule ID 3549 //
     /* 167583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 167594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 167605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 167608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167615 */     GIR_RootConstrainSelectedInstOperands,
     /* 167616 */     // GIR_Coverage, 3549,
     /* 167616 */     GIR_EraseRootFromParent_Done,
     /* 167617 */   // Label 3118: @167617
     /* 167617 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(167673), // Rule ID 3553 //
     /* 167622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 167636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 167644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 167661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167671 */     GIR_RootConstrainSelectedInstOperands,
     /* 167672 */     // GIR_Coverage, 3553,
     /* 167672 */     GIR_EraseRootFromParent_Done,
     /* 167673 */   // Label 3119: @167673
     /* 167673 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(167729), // Rule ID 3554 //
     /* 167678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 167692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1639:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 167700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 167717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167727 */     GIR_RootConstrainSelectedInstOperands,
     /* 167728 */     // GIR_Coverage, 3554,
     /* 167728 */     GIR_EraseRootFromParent_Done,
     /* 167729 */   // Label 3120: @167729
     /* 167729 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(167785), // Rule ID 3555 //
     /* 167734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 167748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 167756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 167773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167783 */     GIR_RootConstrainSelectedInstOperands,
     /* 167784 */     // GIR_Coverage, 3555,
     /* 167784 */     GIR_EraseRootFromParent_Done,
     /* 167785 */   // Label 3121: @167785
     /* 167785 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(167841), // Rule ID 3556 //
     /* 167790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 167801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 167804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 167812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 167829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167839 */     GIR_RootConstrainSelectedInstOperands,
     /* 167840 */     // GIR_Coverage, 3556,
     /* 167840 */     GIR_EraseRootFromParent_Done,
     /* 167841 */   // Label 3122: @167841
     /* 167841 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167874), // Rule ID 4013 //
     /* 167846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 167851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167865 */     // (intrinsic_wo_chain:{ *:[i32] } 511:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 167865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 167868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167872 */     GIR_RootConstrainSelectedInstOperands,
     /* 167873 */     // GIR_Coverage, 4013,
     /* 167873 */     GIR_EraseRootFromParent_Done,
     /* 167874 */   // Label 3123: @167874
     /* 167874 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(167939), // Rule ID 4014 //
     /* 167879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 167884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167898 */     // (intrinsic_wo_chain:{ *:[i32] } 512:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 167898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 167905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 167914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167921 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 167928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167938 */     // GIR_Coverage, 4014,
     /* 167938 */     GIR_EraseRootFromParent_Done,
     /* 167939 */   // Label 3124: @167939
     /* 167939 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(167972), // Rule ID 4820 //
     /* 167944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 167949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167963 */     // (intrinsic_wo_chain:{ *:[v1f64] } 646:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 167966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167970 */     GIR_RootConstrainSelectedInstOperands,
     /* 167971 */     // GIR_Coverage, 4820,
     /* 167971 */     GIR_EraseRootFromParent_Done,
     /* 167972 */   // Label 3125: @167972
     /* 167972 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(168005), // Rule ID 4821 //
     /* 167977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 167982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167996 */     // (intrinsic_wo_chain:{ *:[v1f64] } 648:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 167999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168003 */     GIR_RootConstrainSelectedInstOperands,
     /* 168004 */     // GIR_Coverage, 4821,
     /* 168004 */     GIR_EraseRootFromParent_Done,
     /* 168005 */   // Label 3126: @168005
     /* 168005 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(168038), // Rule ID 4822 //
     /* 168010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 168015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168029 */     // (intrinsic_wo_chain:{ *:[v1f64] } 645:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 168032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168036 */     GIR_RootConstrainSelectedInstOperands,
     /* 168037 */     // GIR_Coverage, 4822,
     /* 168037 */     GIR_EraseRootFromParent_Done,
     /* 168038 */   // Label 3127: @168038
     /* 168038 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(168071), // Rule ID 4823 //
     /* 168043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 168048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168062 */     // (intrinsic_wo_chain:{ *:[v1f64] } 647:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 168065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168069 */     GIR_RootConstrainSelectedInstOperands,
     /* 168070 */     // GIR_Coverage, 4823,
     /* 168070 */     GIR_EraseRootFromParent_Done,
     /* 168071 */   // Label 3128: @168071
     /* 168071 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(168104), // Rule ID 4937 //
     /* 168076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 168081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168095 */     // (intrinsic_wo_chain:{ *:[v4f32] } 777:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 168095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 168098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168102 */     GIR_RootConstrainSelectedInstOperands,
     /* 168103 */     // GIR_Coverage, 4937,
     /* 168103 */     GIR_EraseRootFromParent_Done,
     /* 168104 */   // Label 3129: @168104
     /* 168104 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(168137), // Rule ID 4947 //
     /* 168109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 168114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168128 */     // (intrinsic_wo_chain:{ *:[v4i16] } 774:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 168128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 168131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168135 */     GIR_RootConstrainSelectedInstOperands,
     /* 168136 */     // GIR_Coverage, 4947,
     /* 168136 */     GIR_EraseRootFromParent_Done,
     /* 168137 */   // Label 3130: @168137
     /* 168137 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(168173), // Rule ID 5268 //
     /* 168142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 168150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168164 */     // (intrinsic_wo_chain:{ *:[v1i64] } 695:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 168164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 168167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168171 */     GIR_RootConstrainSelectedInstOperands,
     /* 168172 */     // GIR_Coverage, 5268,
     /* 168172 */     GIR_EraseRootFromParent_Done,
     /* 168173 */   // Label 3131: @168173
     /* 168173 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(168206), // Rule ID 5271 //
     /* 168178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 168183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168197 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 168200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168204 */     GIR_RootConstrainSelectedInstOperands,
     /* 168205 */     // GIR_Coverage, 5271,
     /* 168205 */     GIR_EraseRootFromParent_Done,
     /* 168206 */   // Label 3132: @168206
     /* 168206 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(168239), // Rule ID 5272 //
     /* 168211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 168216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168230 */     // (intrinsic_wo_chain:{ *:[v1i64] } 594:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 168233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168237 */     GIR_RootConstrainSelectedInstOperands,
     /* 168238 */     // GIR_Coverage, 5272,
     /* 168238 */     GIR_EraseRootFromParent_Done,
     /* 168239 */   // Label 3133: @168239
     /* 168239 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(168272), // Rule ID 5273 //
     /* 168244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 168249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168263 */     // (intrinsic_wo_chain:{ *:[v1i64] } 595:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 168266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168270 */     GIR_RootConstrainSelectedInstOperands,
     /* 168271 */     // GIR_Coverage, 5273,
     /* 168271 */     GIR_EraseRootFromParent_Done,
     /* 168272 */   // Label 3134: @168272
     /* 168272 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(168305), // Rule ID 5274 //
     /* 168277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 168282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168296 */     // (intrinsic_wo_chain:{ *:[v1i64] } 596:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 168299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168303 */     GIR_RootConstrainSelectedInstOperands,
     /* 168304 */     // GIR_Coverage, 5274,
     /* 168304 */     GIR_EraseRootFromParent_Done,
     /* 168305 */   // Label 3135: @168305
     /* 168305 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(168338), // Rule ID 5275 //
     /* 168310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 168315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168329 */     // (intrinsic_wo_chain:{ *:[v1i64] } 597:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 168332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168336 */     GIR_RootConstrainSelectedInstOperands,
     /* 168337 */     // GIR_Coverage, 5275,
     /* 168337 */     GIR_EraseRootFromParent_Done,
     /* 168338 */   // Label 3136: @168338
     /* 168338 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(168371), // Rule ID 5276 //
     /* 168343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 168348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168362 */     // (intrinsic_wo_chain:{ *:[v1i64] } 598:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 168365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168369 */     GIR_RootConstrainSelectedInstOperands,
     /* 168370 */     // GIR_Coverage, 5276,
     /* 168370 */     GIR_EraseRootFromParent_Done,
     /* 168371 */   // Label 3137: @168371
     /* 168371 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(168404), // Rule ID 5277 //
     /* 168376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 168381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168395 */     // (intrinsic_wo_chain:{ *:[v1i64] } 599:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 168398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168402 */     GIR_RootConstrainSelectedInstOperands,
     /* 168403 */     // GIR_Coverage, 5277,
     /* 168403 */     GIR_EraseRootFromParent_Done,
     /* 168404 */   // Label 3138: @168404
     /* 168404 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(168437), // Rule ID 5278 //
     /* 168409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 168414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168428 */     // (intrinsic_wo_chain:{ *:[v1i64] } 600:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 168431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168435 */     GIR_RootConstrainSelectedInstOperands,
     /* 168436 */     // GIR_Coverage, 5278,
     /* 168436 */     GIR_EraseRootFromParent_Done,
     /* 168437 */   // Label 3139: @168437
     /* 168437 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(168470), // Rule ID 5279 //
     /* 168442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 168447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168461 */     // (intrinsic_wo_chain:{ *:[v1i64] } 602:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 168464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168468 */     GIR_RootConstrainSelectedInstOperands,
     /* 168469 */     // GIR_Coverage, 5279,
     /* 168469 */     GIR_EraseRootFromParent_Done,
     /* 168470 */   // Label 3140: @168470
     /* 168470 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(168503), // Rule ID 5280 //
     /* 168475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 168480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168494 */     // (intrinsic_wo_chain:{ *:[v1i64] } 603:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 168497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168501 */     GIR_RootConstrainSelectedInstOperands,
     /* 168502 */     // GIR_Coverage, 5280,
     /* 168502 */     GIR_EraseRootFromParent_Done,
     /* 168503 */   // Label 3141: @168503
     /* 168503 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(168536), // Rule ID 5281 //
     /* 168508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168527 */     // (intrinsic_wo_chain:{ *:[f16] } 642:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 168530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168534 */     GIR_RootConstrainSelectedInstOperands,
     /* 168535 */     // GIR_Coverage, 5281,
     /* 168535 */     GIR_EraseRootFromParent_Done,
     /* 168536 */   // Label 3142: @168536
     /* 168536 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(168569), // Rule ID 5282 //
     /* 168541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168560 */     // (intrinsic_wo_chain:{ *:[f32] } 642:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 168563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168567 */     GIR_RootConstrainSelectedInstOperands,
     /* 168568 */     // GIR_Coverage, 5282,
     /* 168568 */     GIR_EraseRootFromParent_Done,
     /* 168569 */   // Label 3143: @168569
     /* 168569 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(168602), // Rule ID 5283 //
     /* 168574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168593 */     // (intrinsic_wo_chain:{ *:[f64] } 642:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 168596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168600 */     GIR_RootConstrainSelectedInstOperands,
     /* 168601 */     // GIR_Coverage, 5283,
     /* 168601 */     GIR_EraseRootFromParent_Done,
     /* 168602 */   // Label 3144: @168602
     /* 168602 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(168635), // Rule ID 5284 //
     /* 168607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168626 */     // (intrinsic_wo_chain:{ *:[v1f64] } 642:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 168629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168633 */     GIR_RootConstrainSelectedInstOperands,
     /* 168634 */     // GIR_Coverage, 5284,
     /* 168634 */     GIR_EraseRootFromParent_Done,
     /* 168635 */   // Label 3145: @168635
     /* 168635 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(168668), // Rule ID 5296 //
     /* 168640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168659 */     // (intrinsic_wo_chain:{ *:[f16] } 644:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 168662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168666 */     GIR_RootConstrainSelectedInstOperands,
     /* 168667 */     // GIR_Coverage, 5296,
     /* 168667 */     GIR_EraseRootFromParent_Done,
     /* 168668 */   // Label 3146: @168668
     /* 168668 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(168701), // Rule ID 5297 //
     /* 168673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168692 */     // (intrinsic_wo_chain:{ *:[f32] } 644:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 168695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168699 */     GIR_RootConstrainSelectedInstOperands,
     /* 168700 */     // GIR_Coverage, 5297,
     /* 168700 */     GIR_EraseRootFromParent_Done,
     /* 168701 */   // Label 3147: @168701
     /* 168701 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(168734), // Rule ID 5298 //
     /* 168706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168725 */     // (intrinsic_wo_chain:{ *:[f64] } 644:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 168728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168732 */     GIR_RootConstrainSelectedInstOperands,
     /* 168733 */     // GIR_Coverage, 5298,
     /* 168733 */     GIR_EraseRootFromParent_Done,
     /* 168734 */   // Label 3148: @168734
     /* 168734 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(168767), // Rule ID 5299 //
     /* 168739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168758 */     // (intrinsic_wo_chain:{ *:[f16] } 649:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 168761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168765 */     GIR_RootConstrainSelectedInstOperands,
     /* 168766 */     // GIR_Coverage, 5299,
     /* 168766 */     GIR_EraseRootFromParent_Done,
     /* 168767 */   // Label 3149: @168767
     /* 168767 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(168800), // Rule ID 5300 //
     /* 168772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168791 */     // (intrinsic_wo_chain:{ *:[f32] } 649:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 168794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168798 */     GIR_RootConstrainSelectedInstOperands,
     /* 168799 */     // GIR_Coverage, 5300,
     /* 168799 */     GIR_EraseRootFromParent_Done,
     /* 168800 */   // Label 3150: @168800
     /* 168800 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(168833), // Rule ID 5301 //
     /* 168805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168824 */     // (intrinsic_wo_chain:{ *:[f64] } 649:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 168827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168831 */     GIR_RootConstrainSelectedInstOperands,
     /* 168832 */     // GIR_Coverage, 5301,
     /* 168832 */     GIR_EraseRootFromParent_Done,
     /* 168833 */   // Label 3151: @168833
     /* 168833 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(168866), // Rule ID 5302 //
     /* 168838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168857 */     // (intrinsic_wo_chain:{ *:[v1f64] } 649:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 168860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168864 */     GIR_RootConstrainSelectedInstOperands,
     /* 168865 */     // GIR_Coverage, 5302,
     /* 168865 */     GIR_EraseRootFromParent_Done,
     /* 168866 */   // Label 3152: @168866
     /* 168866 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168899), // Rule ID 5632 //
     /* 168871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168890 */     // (intrinsic_wo_chain:{ *:[f32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 168890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 168893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168897 */     GIR_RootConstrainSelectedInstOperands,
     /* 168898 */     // GIR_Coverage, 5632,
     /* 168898 */     GIR_EraseRootFromParent_Done,
     /* 168899 */   // Label 3153: @168899
     /* 168899 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168984), // Rule ID 5633 //
     /* 168904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168923 */     // (intrinsic_wo_chain:{ *:[f32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 168923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 168926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 168930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168957 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 168977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168982 */     GIR_RootConstrainSelectedInstOperands,
     /* 168983 */     // GIR_Coverage, 5633,
     /* 168983 */     GIR_EraseRootFromParent_Done,
     /* 168984 */   // Label 3154: @168984
     /* 168984 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(169017), // Rule ID 5634 //
     /* 168989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169008 */     // (intrinsic_wo_chain:{ *:[f64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 169011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169015 */     GIR_RootConstrainSelectedInstOperands,
     /* 169016 */     // GIR_Coverage, 5634,
     /* 169016 */     GIR_EraseRootFromParent_Done,
     /* 169017 */   // Label 3155: @169017
     /* 169017 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(169050), // Rule ID 5636 //
     /* 169022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169041 */     // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 169044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169048 */     GIR_RootConstrainSelectedInstOperands,
     /* 169049 */     // GIR_Coverage, 5636,
     /* 169049 */     GIR_EraseRootFromParent_Done,
     /* 169050 */   // Label 3156: @169050
     /* 169050 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(169083), // Rule ID 5638 //
     /* 169055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169074 */     // (intrinsic_wo_chain:{ *:[f64] } 607:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 169077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169081 */     GIR_RootConstrainSelectedInstOperands,
     /* 169082 */     // GIR_Coverage, 5638,
     /* 169082 */     GIR_EraseRootFromParent_Done,
     /* 169083 */   // Label 3157: @169083
     /* 169083 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(169116), // Rule ID 5640 //
     /* 169088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169107 */     // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 169110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169114 */     GIR_RootConstrainSelectedInstOperands,
     /* 169115 */     // GIR_Coverage, 5640,
     /* 169115 */     GIR_EraseRootFromParent_Done,
     /* 169116 */   // Label 3158: @169116
     /* 169116 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(169149), // Rule ID 5642 //
     /* 169121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169140 */     // (intrinsic_wo_chain:{ *:[f64] } 609:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 169143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169147 */     GIR_RootConstrainSelectedInstOperands,
     /* 169148 */     // GIR_Coverage, 5642,
     /* 169148 */     GIR_EraseRootFromParent_Done,
     /* 169149 */   // Label 3159: @169149
     /* 169149 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(169182), // Rule ID 5644 //
     /* 169154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169173 */     // (intrinsic_wo_chain:{ *:[f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 169176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169180 */     GIR_RootConstrainSelectedInstOperands,
     /* 169181 */     // GIR_Coverage, 5644,
     /* 169181 */     GIR_EraseRootFromParent_Done,
     /* 169182 */   // Label 3160: @169182
     /* 169182 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(169215), // Rule ID 5646 //
     /* 169187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169206 */     // (intrinsic_wo_chain:{ *:[f64] } 613:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 169209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169213 */     GIR_RootConstrainSelectedInstOperands,
     /* 169214 */     // GIR_Coverage, 5646,
     /* 169214 */     GIR_EraseRootFromParent_Done,
     /* 169215 */   // Label 3161: @169215
     /* 169215 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(169248), // Rule ID 5648 //
     /* 169220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169239 */     // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 169242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169246 */     GIR_RootConstrainSelectedInstOperands,
     /* 169247 */     // GIR_Coverage, 5648,
     /* 169247 */     GIR_EraseRootFromParent_Done,
     /* 169248 */   // Label 3162: @169248
     /* 169248 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(169281), // Rule ID 5650 //
     /* 169253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169272 */     // (intrinsic_wo_chain:{ *:[f64] } 615:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 169275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169279 */     GIR_RootConstrainSelectedInstOperands,
     /* 169280 */     // GIR_Coverage, 5650,
     /* 169280 */     GIR_EraseRootFromParent_Done,
     /* 169281 */   // Label 3163: @169281
     /* 169281 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(169314), // Rule ID 13214 //
     /* 169286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169305 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169312 */     GIR_RootConstrainSelectedInstOperands,
     /* 169313 */     // GIR_Coverage, 13214,
     /* 169313 */     GIR_EraseRootFromParent_Done,
     /* 169314 */   // Label 3164: @169314
     /* 169314 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(169347), // Rule ID 13216 //
     /* 169319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169338 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169345 */     GIR_RootConstrainSelectedInstOperands,
     /* 169346 */     // GIR_Coverage, 13216,
     /* 169346 */     GIR_EraseRootFromParent_Done,
     /* 169347 */   // Label 3165: @169347
     /* 169347 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(169380), // Rule ID 13218 //
     /* 169352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169371 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 169374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169378 */     GIR_RootConstrainSelectedInstOperands,
     /* 169379 */     // GIR_Coverage, 13218,
     /* 169379 */     GIR_EraseRootFromParent_Done,
     /* 169380 */   // Label 3166: @169380
     /* 169380 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169413), // Rule ID 13220 //
     /* 169385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169404 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 169407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169411 */     GIR_RootConstrainSelectedInstOperands,
     /* 169412 */     // GIR_Coverage, 13220,
     /* 169412 */     GIR_EraseRootFromParent_Done,
     /* 169413 */   // Label 3167: @169413
     /* 169413 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169528), // Rule ID 13221 //
     /* 169418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169437 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169437 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169440 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 169444 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169449 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169455 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169458 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169462 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169510 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169527 */     // GIR_Coverage, 13221,
     /* 169527 */     GIR_EraseRootFromParent_Done,
     /* 169528 */   // Label 3168: @169528
     /* 169528 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169561), // Rule ID 13223 //
     /* 169533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169552 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169559 */     GIR_RootConstrainSelectedInstOperands,
     /* 169560 */     // GIR_Coverage, 13223,
     /* 169560 */     GIR_EraseRootFromParent_Done,
     /* 169561 */   // Label 3169: @169561
     /* 169561 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169594), // Rule ID 13225 //
     /* 169566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169585 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169592 */     GIR_RootConstrainSelectedInstOperands,
     /* 169593 */     // GIR_Coverage, 13225,
     /* 169593 */     GIR_EraseRootFromParent_Done,
     /* 169594 */   // Label 3170: @169594
     /* 169594 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169627), // Rule ID 13227 //
     /* 169599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169618 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 169621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169625 */     GIR_RootConstrainSelectedInstOperands,
     /* 169626 */     // GIR_Coverage, 13227,
     /* 169626 */     GIR_EraseRootFromParent_Done,
     /* 169627 */   // Label 3171: @169627
     /* 169627 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169660), // Rule ID 13229 //
     /* 169632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169651 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 169654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169658 */     GIR_RootConstrainSelectedInstOperands,
     /* 169659 */     // GIR_Coverage, 13229,
     /* 169659 */     GIR_EraseRootFromParent_Done,
     /* 169660 */   // Label 3172: @169660
     /* 169660 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169775), // Rule ID 13230 //
     /* 169665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169684 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169684 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169687 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 169691 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169757 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169774 */     // GIR_Coverage, 13230,
     /* 169774 */     GIR_EraseRootFromParent_Done,
     /* 169775 */   // Label 3173: @169775
     /* 169775 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169894), // Rule ID 13231 //
     /* 169780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169799 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169799 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169802 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 169806 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169811 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169815 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169893 */     // GIR_Coverage, 13231,
     /* 169893 */     GIR_EraseRootFromParent_Done,
     /* 169894 */   // Label 3174: @169894
     /* 169894 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(170009), // Rule ID 13232 //
     /* 169899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     // (intrinsic_wo_chain:{ *:[i64] } 672:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 169918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 169925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169930 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 169939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 169953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 169998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170008 */     // GIR_Coverage, 13232,
     /* 170008 */     GIR_EraseRootFromParent_Done,
     /* 170009 */   // Label 3175: @170009
     /* 170009 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(170128), // Rule ID 13233 //
     /* 170014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170033 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170033 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170036 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 170040 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170045 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170049 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170087 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170127 */     // GIR_Coverage, 13233,
     /* 170127 */     GIR_EraseRootFromParent_Done,
     /* 170128 */   // Label 3176: @170128
     /* 170128 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(170243), // Rule ID 13234 //
     /* 170133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170152 */     // (intrinsic_wo_chain:{ *:[i64] } 737:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 170152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 170159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170164 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 170173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 170187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170202 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170225 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 170232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170242 */     // GIR_Coverage, 13234,
     /* 170242 */     GIR_EraseRootFromParent_Done,
     /* 170243 */   // Label 3177: @170243
     /* 170243 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(170276), // Rule ID 13236 //
     /* 170248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170267 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 170270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170274 */     GIR_RootConstrainSelectedInstOperands,
     /* 170275 */     // GIR_Coverage, 13236,
     /* 170275 */     GIR_EraseRootFromParent_Done,
     /* 170276 */   // Label 3178: @170276
     /* 170276 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(170309), // Rule ID 13238 //
     /* 170281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170300 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 170300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 170303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170307 */     GIR_RootConstrainSelectedInstOperands,
     /* 170308 */     // GIR_Coverage, 13238,
     /* 170308 */     GIR_EraseRootFromParent_Done,
     /* 170309 */   // Label 3179: @170309
     /* 170309 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(170342), // Rule ID 13240 //
     /* 170314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170333 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 170336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170340 */     GIR_RootConstrainSelectedInstOperands,
     /* 170341 */     // GIR_Coverage, 13240,
     /* 170341 */     GIR_EraseRootFromParent_Done,
     /* 170342 */   // Label 3180: @170342
     /* 170342 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(170375), // Rule ID 13242 //
     /* 170347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170366 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 170369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170373 */     GIR_RootConstrainSelectedInstOperands,
     /* 170374 */     // GIR_Coverage, 13242,
     /* 170374 */     GIR_EraseRootFromParent_Done,
     /* 170375 */   // Label 3181: @170375
     /* 170375 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(170490), // Rule ID 13243 //
     /* 170380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170399 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 170406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170411 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170472 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170489 */     // GIR_Coverage, 13243,
     /* 170489 */     GIR_EraseRootFromParent_Done,
     /* 170490 */   // Label 3182: @170490
     /* 170490 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(170609), // Rule ID 13244 //
     /* 170495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170514 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170514 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170517 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 170521 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170526 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170530 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170565 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170591 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170608 */     // GIR_Coverage, 13244,
     /* 170608 */     GIR_EraseRootFromParent_Done,
     /* 170609 */   // Label 3183: @170609
     /* 170609 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(170642), // Rule ID 13246 //
     /* 170614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170633 */     // (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 170636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170640 */     GIR_RootConstrainSelectedInstOperands,
     /* 170641 */     // GIR_Coverage, 13246,
     /* 170641 */     GIR_EraseRootFromParent_Done,
     /* 170642 */   // Label 3184: @170642
     /* 170642 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170675), // Rule ID 13248 //
     /* 170647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170666 */     // (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 170666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 170669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170673 */     GIR_RootConstrainSelectedInstOperands,
     /* 170674 */     // GIR_Coverage, 13248,
     /* 170674 */     GIR_EraseRootFromParent_Done,
     /* 170675 */   // Label 3185: @170675
     /* 170675 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170708), // Rule ID 13250 //
     /* 170680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170699 */     // (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 170702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170706 */     GIR_RootConstrainSelectedInstOperands,
     /* 170707 */     // GIR_Coverage, 13250,
     /* 170707 */     GIR_EraseRootFromParent_Done,
     /* 170708 */   // Label 3186: @170708
     /* 170708 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170741), // Rule ID 13252 //
     /* 170713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170732 */     // (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 170735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170739 */     GIR_RootConstrainSelectedInstOperands,
     /* 170740 */     // GIR_Coverage, 13252,
     /* 170740 */     GIR_EraseRootFromParent_Done,
     /* 170741 */   // Label 3187: @170741
     /* 170741 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170856), // Rule ID 13253 //
     /* 170746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170765 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170765 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170768 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 170772 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170777 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170812 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170815 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170838 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170855 */     // GIR_Coverage, 13253,
     /* 170855 */     GIR_EraseRootFromParent_Done,
     /* 170856 */   // Label 3188: @170856
     /* 170856 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170975), // Rule ID 13254 //
     /* 170861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170880 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 170887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170892 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170896 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170957 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170974 */     // GIR_Coverage, 13254,
     /* 170974 */     GIR_EraseRootFromParent_Done,
     /* 170975 */   // Label 3189: @170975
     /* 170975 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(171008), // Rule ID 13256 //
     /* 170980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 170985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170999 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 171002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171006 */     GIR_RootConstrainSelectedInstOperands,
     /* 171007 */     // GIR_Coverage, 13256,
     /* 171007 */     GIR_EraseRootFromParent_Done,
     /* 171008 */   // Label 3190: @171008
     /* 171008 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(171041), // Rule ID 13258 //
     /* 171013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171032 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 171035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171039 */     GIR_RootConstrainSelectedInstOperands,
     /* 171040 */     // GIR_Coverage, 13258,
     /* 171040 */     GIR_EraseRootFromParent_Done,
     /* 171041 */   // Label 3191: @171041
     /* 171041 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(171074), // Rule ID 13260 //
     /* 171046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171065 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 171068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171072 */     GIR_RootConstrainSelectedInstOperands,
     /* 171073 */     // GIR_Coverage, 13260,
     /* 171073 */     GIR_EraseRootFromParent_Done,
     /* 171074 */   // Label 3192: @171074
     /* 171074 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(171107), // Rule ID 13262 //
     /* 171079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171098 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 171101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171105 */     GIR_RootConstrainSelectedInstOperands,
     /* 171106 */     // GIR_Coverage, 13262,
     /* 171106 */     GIR_EraseRootFromParent_Done,
     /* 171107 */   // Label 3193: @171107
     /* 171107 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(171222), // Rule ID 13263 //
     /* 171112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171131 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171131 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171134 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 171138 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171143 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171221 */     // GIR_Coverage, 13263,
     /* 171221 */     GIR_EraseRootFromParent_Done,
     /* 171222 */   // Label 3194: @171222
     /* 171222 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(171341), // Rule ID 13264 //
     /* 171227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171246 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171246 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171249 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 171253 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171258 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171262 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171323 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171340 */     // GIR_Coverage, 13264,
     /* 171340 */     GIR_EraseRootFromParent_Done,
     /* 171341 */   // Label 3195: @171341
     /* 171341 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(171374), // Rule ID 13266 //
     /* 171346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171365 */     // (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 171365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 171368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171372 */     GIR_RootConstrainSelectedInstOperands,
     /* 171373 */     // GIR_Coverage, 13266,
     /* 171373 */     GIR_EraseRootFromParent_Done,
     /* 171374 */   // Label 3196: @171374
     /* 171374 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(171407), // Rule ID 13268 //
     /* 171379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171398 */     // (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 171401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171405 */     GIR_RootConstrainSelectedInstOperands,
     /* 171406 */     // GIR_Coverage, 13268,
     /* 171406 */     GIR_EraseRootFromParent_Done,
     /* 171407 */   // Label 3197: @171407
     /* 171407 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(171440), // Rule ID 13270 //
     /* 171412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171431 */     // (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 171434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171438 */     GIR_RootConstrainSelectedInstOperands,
     /* 171439 */     // GIR_Coverage, 13270,
     /* 171439 */     GIR_EraseRootFromParent_Done,
     /* 171440 */   // Label 3198: @171440
     /* 171440 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(171473), // Rule ID 13272 //
     /* 171445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171464 */     // (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 171467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171471 */     GIR_RootConstrainSelectedInstOperands,
     /* 171472 */     // GIR_Coverage, 13272,
     /* 171472 */     GIR_EraseRootFromParent_Done,
     /* 171473 */   // Label 3199: @171473
     /* 171473 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(171588), // Rule ID 13273 //
     /* 171478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171497 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171497 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171500 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 171504 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171509 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171515 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171518 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171522 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171541 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171570 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171587 */     // GIR_Coverage, 13273,
     /* 171587 */     GIR_EraseRootFromParent_Done,
     /* 171588 */   // Label 3200: @171588
     /* 171588 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(171707), // Rule ID 13274 //
     /* 171593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171612 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171612 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171615 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 171619 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171624 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171628 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171663 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171706 */     // GIR_Coverage, 13274,
     /* 171706 */     GIR_EraseRootFromParent_Done,
     /* 171707 */   // Label 3201: @171707
     /* 171707 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(171739), // Rule ID 2393 //
     /* 171712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 171720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1679:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 171733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171737 */     GIR_RootConstrainSelectedInstOperands,
     /* 171738 */     // GIR_Coverage, 2393,
     /* 171738 */     GIR_EraseRootFromParent_Done,
     /* 171739 */   // Label 3202: @171739
     /* 171739 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(171771), // Rule ID 2394 //
     /* 171744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 171752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171762 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1680:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 171765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171769 */     GIR_RootConstrainSelectedInstOperands,
     /* 171770 */     // GIR_Coverage, 2394,
     /* 171770 */     GIR_EraseRootFromParent_Done,
     /* 171771 */   // Label 3203: @171771
     /* 171771 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(171803), // Rule ID 2395 //
     /* 171776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 171784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1681:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 171797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171801 */     GIR_RootConstrainSelectedInstOperands,
     /* 171802 */     // GIR_Coverage, 2395,
     /* 171802 */     GIR_EraseRootFromParent_Done,
     /* 171803 */   // Label 3204: @171803
     /* 171803 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(171835), // Rule ID 3089 //
     /* 171808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 171829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171833 */     GIR_RootConstrainSelectedInstOperands,
     /* 171834 */     // GIR_Coverage, 3089,
     /* 171834 */     GIR_EraseRootFromParent_Done,
     /* 171835 */   // Label 3205: @171835
     /* 171835 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(171867), // Rule ID 3090 //
     /* 171840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 171861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171865 */     GIR_RootConstrainSelectedInstOperands,
     /* 171866 */     // GIR_Coverage, 3090,
     /* 171866 */     GIR_EraseRootFromParent_Done,
     /* 171867 */   // Label 3206: @171867
     /* 171867 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(171899), // Rule ID 3091 //
     /* 171872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 171893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171897 */     GIR_RootConstrainSelectedInstOperands,
     /* 171898 */     // GIR_Coverage, 3091,
     /* 171898 */     GIR_EraseRootFromParent_Done,
     /* 171899 */   // Label 3207: @171899
     /* 171899 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(171931), // Rule ID 3345 //
     /* 171904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 171915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171922 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 171922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171929 */     GIR_RootConstrainSelectedInstOperands,
     /* 171930 */     // GIR_Coverage, 3345,
     /* 171930 */     GIR_EraseRootFromParent_Done,
     /* 171931 */   // Label 3208: @171931
     /* 171931 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(171963), // Rule ID 3346 //
     /* 171936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 171947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 171950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1671:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 171954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171961 */     GIR_RootConstrainSelectedInstOperands,
     /* 171962 */     // GIR_Coverage, 3346,
     /* 171962 */     GIR_EraseRootFromParent_Done,
     /* 171963 */   // Label 3209: @171963
     /* 171963 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(171995), // Rule ID 3347 //
     /* 171968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 171979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 171982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1671:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 171986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171993 */     GIR_RootConstrainSelectedInstOperands,
     /* 171994 */     // GIR_Coverage, 3347,
     /* 171994 */     GIR_EraseRootFromParent_Done,
     /* 171995 */   // Label 3210: @171995
     /* 171995 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(172027), // Rule ID 3429 //
     /* 172000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172018 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 172021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172025 */     GIR_RootConstrainSelectedInstOperands,
     /* 172026 */     // GIR_Coverage, 3429,
     /* 172026 */     GIR_EraseRootFromParent_Done,
     /* 172027 */   // Label 3211: @172027
     /* 172027 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(172059), // Rule ID 3430 //
     /* 172032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 172053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172057 */     GIR_RootConstrainSelectedInstOperands,
     /* 172058 */     // GIR_Coverage, 3430,
     /* 172058 */     GIR_EraseRootFromParent_Done,
     /* 172059 */   // Label 3212: @172059
     /* 172059 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(172091), // Rule ID 3431 //
     /* 172064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 172075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 172085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172089 */     GIR_RootConstrainSelectedInstOperands,
     /* 172090 */     // GIR_Coverage, 3431,
     /* 172090 */     GIR_EraseRootFromParent_Done,
     /* 172091 */   // Label 3213: @172091
     /* 172091 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(172123), // Rule ID 3456 //
     /* 172096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 172099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 172104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 172110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 172114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 172117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 172119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172121 */     GIR_RootConstrainSelectedInstOperands,
     /* 172122 */     // GIR_Coverage, 3456,
     /* 172122 */     GIR_EraseRootFromParent_Done,
     /* 172123 */   // Label 3214: @172123
     /* 172123 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(172155), // Rule ID 4665 //
     /* 172128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172146 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 172149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172153 */     GIR_RootConstrainSelectedInstOperands,
     /* 172154 */     // GIR_Coverage, 4665,
     /* 172154 */     GIR_EraseRootFromParent_Done,
     /* 172155 */   // Label 3215: @172155
     /* 172155 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(172187), // Rule ID 4666 //
     /* 172160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172178 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 172181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172185 */     GIR_RootConstrainSelectedInstOperands,
     /* 172186 */     // GIR_Coverage, 4666,
     /* 172186 */     GIR_EraseRootFromParent_Done,
     /* 172187 */   // Label 3216: @172187
     /* 172187 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(172216), // Rule ID 4667 //
     /* 172192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172207 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 172210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172214 */     GIR_RootConstrainSelectedInstOperands,
     /* 172215 */     // GIR_Coverage, 4667,
     /* 172215 */     GIR_EraseRootFromParent_Done,
     /* 172216 */   // Label 3217: @172216
     /* 172216 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(172245), // Rule ID 4668 //
     /* 172221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172236 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 172239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172243 */     GIR_RootConstrainSelectedInstOperands,
     /* 172244 */     // GIR_Coverage, 4668,
     /* 172244 */     GIR_EraseRootFromParent_Done,
     /* 172245 */   // Label 3218: @172245
     /* 172245 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(172274), // Rule ID 4669 //
     /* 172250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172265 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 172268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172272 */     GIR_RootConstrainSelectedInstOperands,
     /* 172273 */     // GIR_Coverage, 4669,
     /* 172273 */     GIR_EraseRootFromParent_Done,
     /* 172274 */   // Label 3219: @172274
     /* 172274 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(172303), // Rule ID 4670 //
     /* 172279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172294 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 172297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172301 */     GIR_RootConstrainSelectedInstOperands,
     /* 172302 */     // GIR_Coverage, 4670,
     /* 172302 */     GIR_EraseRootFromParent_Done,
     /* 172303 */   // Label 3220: @172303
     /* 172303 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(172335), // Rule ID 4677 //
     /* 172308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172326 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 172329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172333 */     GIR_RootConstrainSelectedInstOperands,
     /* 172334 */     // GIR_Coverage, 4677,
     /* 172334 */     GIR_EraseRootFromParent_Done,
     /* 172335 */   // Label 3221: @172335
     /* 172335 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(172367), // Rule ID 4678 //
     /* 172340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172358 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 172361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172365 */     GIR_RootConstrainSelectedInstOperands,
     /* 172366 */     // GIR_Coverage, 4678,
     /* 172366 */     GIR_EraseRootFromParent_Done,
     /* 172367 */   // Label 3222: @172367
     /* 172367 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(172396), // Rule ID 4679 //
     /* 172372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172387 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 172390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172394 */     GIR_RootConstrainSelectedInstOperands,
     /* 172395 */     // GIR_Coverage, 4679,
     /* 172395 */     GIR_EraseRootFromParent_Done,
     /* 172396 */   // Label 3223: @172396
     /* 172396 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(172425), // Rule ID 4680 //
     /* 172401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172416 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 172419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172423 */     GIR_RootConstrainSelectedInstOperands,
     /* 172424 */     // GIR_Coverage, 4680,
     /* 172424 */     GIR_EraseRootFromParent_Done,
     /* 172425 */   // Label 3224: @172425
     /* 172425 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(172454), // Rule ID 4681 //
     /* 172430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172445 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 172448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172452 */     GIR_RootConstrainSelectedInstOperands,
     /* 172453 */     // GIR_Coverage, 4681,
     /* 172453 */     GIR_EraseRootFromParent_Done,
     /* 172454 */   // Label 3225: @172454
     /* 172454 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(172483), // Rule ID 4682 //
     /* 172459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172474 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 172477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172481 */     GIR_RootConstrainSelectedInstOperands,
     /* 172482 */     // GIR_Coverage, 4682,
     /* 172482 */     GIR_EraseRootFromParent_Done,
     /* 172483 */   // Label 3226: @172483
     /* 172483 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(172512), // Rule ID 4977 //
     /* 172488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172503 */     // (intrinsic_wo_chain:{ *:[v4i16] } 602:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 172503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 172506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172510 */     GIR_RootConstrainSelectedInstOperands,
     /* 172511 */     // GIR_Coverage, 4977,
     /* 172511 */     GIR_EraseRootFromParent_Done,
     /* 172512 */   // Label 3227: @172512
     /* 172512 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(172541), // Rule ID 4978 //
     /* 172517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 602:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 172532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 172535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172539 */     GIR_RootConstrainSelectedInstOperands,
     /* 172540 */     // GIR_Coverage, 4978,
     /* 172540 */     GIR_EraseRootFromParent_Done,
     /* 172541 */   // Label 3228: @172541
     /* 172541 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(172570), // Rule ID 4979 //
     /* 172546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172561 */     // (intrinsic_wo_chain:{ *:[v2i32] } 602:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 172561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 172564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172568 */     GIR_RootConstrainSelectedInstOperands,
     /* 172569 */     // GIR_Coverage, 4979,
     /* 172569 */     GIR_EraseRootFromParent_Done,
     /* 172570 */   // Label 3229: @172570
     /* 172570 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(172599), // Rule ID 4980 //
     /* 172575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 602:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 172590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 172593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172597 */     GIR_RootConstrainSelectedInstOperands,
     /* 172598 */     // GIR_Coverage, 4980,
     /* 172598 */     GIR_EraseRootFromParent_Done,
     /* 172599 */   // Label 3230: @172599
     /* 172599 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(172628), // Rule ID 4981 //
     /* 172604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172619 */     // (intrinsic_wo_chain:{ *:[v2i64] } 602:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 172619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 172622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172626 */     GIR_RootConstrainSelectedInstOperands,
     /* 172627 */     // GIR_Coverage, 4981,
     /* 172627 */     GIR_EraseRootFromParent_Done,
     /* 172628 */   // Label 3231: @172628
     /* 172628 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(172657), // Rule ID 4982 //
     /* 172633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172648 */     // (intrinsic_wo_chain:{ *:[v4i16] } 603:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 172648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 172651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172655 */     GIR_RootConstrainSelectedInstOperands,
     /* 172656 */     // GIR_Coverage, 4982,
     /* 172656 */     GIR_EraseRootFromParent_Done,
     /* 172657 */   // Label 3232: @172657
     /* 172657 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(172686), // Rule ID 4983 //
     /* 172662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172677 */     // (intrinsic_wo_chain:{ *:[v8i16] } 603:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 172677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 172680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172684 */     GIR_RootConstrainSelectedInstOperands,
     /* 172685 */     // GIR_Coverage, 4983,
     /* 172685 */     GIR_EraseRootFromParent_Done,
     /* 172686 */   // Label 3233: @172686
     /* 172686 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(172715), // Rule ID 4984 //
     /* 172691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172706 */     // (intrinsic_wo_chain:{ *:[v2i32] } 603:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 172706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 172709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172713 */     GIR_RootConstrainSelectedInstOperands,
     /* 172714 */     // GIR_Coverage, 4984,
     /* 172714 */     GIR_EraseRootFromParent_Done,
     /* 172715 */   // Label 3234: @172715
     /* 172715 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172744), // Rule ID 4985 //
     /* 172720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 603:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 172735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 172738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172742 */     GIR_RootConstrainSelectedInstOperands,
     /* 172743 */     // GIR_Coverage, 4985,
     /* 172743 */     GIR_EraseRootFromParent_Done,
     /* 172744 */   // Label 3235: @172744
     /* 172744 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172773), // Rule ID 4986 //
     /* 172749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172764 */     // (intrinsic_wo_chain:{ *:[v2i64] } 603:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 172764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 172767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172771 */     GIR_RootConstrainSelectedInstOperands,
     /* 172772 */     // GIR_Coverage, 4986,
     /* 172772 */     GIR_EraseRootFromParent_Done,
     /* 172773 */   // Label 3236: @172773
     /* 172773 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172805), // Rule ID 8466 //
     /* 172778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 172789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 172792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 172796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172803 */     GIR_RootConstrainSelectedInstOperands,
     /* 172804 */     // GIR_Coverage, 8466,
     /* 172804 */     GIR_EraseRootFromParent_Done,
     /* 172805 */   // Label 3237: @172805
     /* 172805 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172837), // Rule ID 8467 //
     /* 172810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 172821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 172824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1670:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 172828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172835 */     GIR_RootConstrainSelectedInstOperands,
     /* 172836 */     // GIR_Coverage, 8467,
     /* 172836 */     GIR_EraseRootFromParent_Done,
     /* 172837 */   // Label 3238: @172837
     /* 172837 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172869), // Rule ID 8468 //
     /* 172842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 172853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 172856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1670:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 172860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172867 */     GIR_RootConstrainSelectedInstOperands,
     /* 172868 */     // GIR_Coverage, 8468,
     /* 172868 */     GIR_EraseRootFromParent_Done,
     /* 172869 */   // Label 3239: @172869
     /* 172869 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172901), // Rule ID 11889 //
     /* 172874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 172895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172899 */     GIR_RootConstrainSelectedInstOperands,
     /* 172900 */     // GIR_Coverage, 11889,
     /* 172900 */     GIR_EraseRootFromParent_Done,
     /* 172901 */   // Label 3240: @172901
     /* 172901 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172933), // Rule ID 11890 //
     /* 172906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 172927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172931 */     GIR_RootConstrainSelectedInstOperands,
     /* 172932 */     // GIR_Coverage, 11890,
     /* 172932 */     GIR_EraseRootFromParent_Done,
     /* 172933 */   // Label 3241: @172933
     /* 172933 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(172965), // Rule ID 11891 //
     /* 172938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 172959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172963 */     GIR_RootConstrainSelectedInstOperands,
     /* 172964 */     // GIR_Coverage, 11891,
     /* 172964 */     GIR_EraseRootFromParent_Done,
     /* 172965 */   // Label 3242: @172965
     /* 172965 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(172997), // Rule ID 11892 //
     /* 172970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 172978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 172991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172995 */     GIR_RootConstrainSelectedInstOperands,
     /* 172996 */     // GIR_Coverage, 11892,
     /* 172996 */     GIR_EraseRootFromParent_Done,
     /* 172997 */   // Label 3243: @172997
     /* 172997 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(173029), // Rule ID 11893 //
     /* 173002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 173013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 173016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 173020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 173023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173027 */     GIR_RootConstrainSelectedInstOperands,
     /* 173028 */     // GIR_Coverage, 11893,
     /* 173028 */     GIR_EraseRootFromParent_Done,
     /* 173029 */   // Label 3244: @173029
     /* 173029 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173061), // Rule ID 11894 //
     /* 173034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 173045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 173048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 173052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 173055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173059 */     GIR_RootConstrainSelectedInstOperands,
     /* 173060 */     // GIR_Coverage, 11894,
     /* 173060 */     GIR_EraseRootFromParent_Done,
     /* 173061 */   // Label 3245: @173061
     /* 173061 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173093), // Rule ID 12060 //
     /* 173066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 173069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 173074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 173077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 173080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1270:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 173084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 173087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 173089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173091 */     GIR_RootConstrainSelectedInstOperands,
     /* 173092 */     // GIR_Coverage, 12060,
     /* 173092 */     GIR_EraseRootFromParent_Done,
     /* 173093 */   // Label 3246: @173093
     /* 173093 */   GIM_Reject,
     /* 173094 */ // Label 2927: @173094
     /* 173094 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(215531),
     /* 173099 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 173102 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173286), // Rule ID 2564 //
     /* 173107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173156 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173159 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173168 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173205 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173210 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173214 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173218 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173222 */     // MIs[5] Operand 1
     /* 173222 */     // No operand predicates
     /* 173222 */     // MIs[3] Operand 2
     /* 173222 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173237 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173239 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173251 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173284 */     GIR_RootConstrainSelectedInstOperands,
     /* 173285 */     // GIR_Coverage, 2564,
     /* 173285 */     GIR_EraseRootFromParent_Done,
     /* 173286 */   // Label 3248: @173286
     /* 173286 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173470), // Rule ID 6306 //
     /* 173291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173340 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173343 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173352 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173373 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173377 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173381 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173385 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173389 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173394 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173398 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173402 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173406 */     // MIs[5] Operand 1
     /* 173406 */     // No operand predicates
     /* 173406 */     // MIs[3] Operand 2
     /* 173406 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173421 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173423 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173435 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173468 */     GIR_RootConstrainSelectedInstOperands,
     /* 173469 */     // GIR_Coverage, 6306,
     /* 173469 */     GIR_EraseRootFromParent_Done,
     /* 173470 */   // Label 3249: @173470
     /* 173470 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(173631), // Rule ID 2565 //
     /* 173475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173524 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173527 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173536 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173553 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173557 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173561 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173566 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173570 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173574 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173578 */     // MIs[4] Operand 1
     /* 173578 */     // No operand predicates
     /* 173578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173582 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173584 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173629 */     GIR_RootConstrainSelectedInstOperands,
     /* 173630 */     // GIR_Coverage, 2565,
     /* 173630 */     GIR_EraseRootFromParent_Done,
     /* 173631 */   // Label 3250: @173631
     /* 173631 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(173792), // Rule ID 6307 //
     /* 173636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173685 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173688 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173697 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173722 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173731 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173735 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173739 */     // MIs[4] Operand 1
     /* 173739 */     // No operand predicates
     /* 173739 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173745 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173790 */     GIR_RootConstrainSelectedInstOperands,
     /* 173791 */     // GIR_Coverage, 6307,
     /* 173791 */     GIR_EraseRootFromParent_Done,
     /* 173792 */   // Label 3251: @173792
     /* 173792 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(173902), // Rule ID 2085 //
     /* 173797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173863 */     // MIs[3] Operand 1
     /* 173863 */     // No operand predicates
     /* 173863 */     // MIs[1] Operand 2
     /* 173863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 173874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173883 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 173886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173900 */     GIR_RootConstrainSelectedInstOperands,
     /* 173901 */     // GIR_Coverage, 2085,
     /* 173901 */     GIR_EraseRootFromParent_Done,
     /* 173902 */   // Label 3252: @173902
     /* 173902 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(174012), // Rule ID 2088 //
     /* 173907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173969 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173973 */     // MIs[3] Operand 1
     /* 173973 */     // No operand predicates
     /* 173973 */     // MIs[1] Operand 2
     /* 173973 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 173984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173993 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 173996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 174003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174010 */     GIR_RootConstrainSelectedInstOperands,
     /* 174011 */     // GIR_Coverage, 2088,
     /* 174011 */     GIR_EraseRootFromParent_Done,
     /* 174012 */   // Label 3253: @174012
     /* 174012 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(174134), // Rule ID 6968 //
     /* 174017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174052 */     // MIs[1] Operand 2
     /* 174052 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174071 */     // MIs[2] Rn
     /* 174071 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174076 */     // MIs[2] Operand 2
     /* 174076 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174089 */     // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 174089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 174096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174105 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174133 */     // GIR_Coverage, 6968,
     /* 174133 */     GIR_EraseRootFromParent_Done,
     /* 174134 */   // Label 3254: @174134
     /* 174134 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(174256), // Rule ID 6970 //
     /* 174139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174174 */     // MIs[1] Operand 2
     /* 174174 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174193 */     // MIs[2] Rn
     /* 174193 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174198 */     // MIs[2] Operand 2
     /* 174198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174211 */     // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 174211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 174218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174238 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174255 */     // GIR_Coverage, 6970,
     /* 174255 */     GIR_EraseRootFromParent_Done,
     /* 174256 */   // Label 3255: @174256
     /* 174256 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(174378), // Rule ID 6972 //
     /* 174261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 174291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174296 */     // MIs[1] Operand 2
     /* 174296 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174315 */     // MIs[2] Rn
     /* 174315 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174320 */     // MIs[2] Operand 2
     /* 174320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 174331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174333 */     // (intrinsic_wo_chain:{ *:[v8i8] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 174333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 174340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174360 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174377 */     // GIR_Coverage, 6972,
     /* 174377 */     GIR_EraseRootFromParent_Done,
     /* 174378 */   // Label 3256: @174378
     /* 174378 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(174500), // Rule ID 6974 //
     /* 174383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     // MIs[1] Operand 2
     /* 174418 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174437 */     // MIs[2] Rn
     /* 174437 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174442 */     // MIs[2] Operand 2
     /* 174442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174455 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 174455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 174462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174482 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174499 */     // GIR_Coverage, 6974,
     /* 174499 */     GIR_EraseRootFromParent_Done,
     /* 174500 */   // Label 3257: @174500
     /* 174500 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(174622), // Rule ID 6976 //
     /* 174505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174540 */     // MIs[1] Operand 2
     /* 174540 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174559 */     // MIs[2] Rn
     /* 174559 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174564 */     // MIs[2] Operand 2
     /* 174564 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174577 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 174577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 174584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174621 */     // GIR_Coverage, 6976,
     /* 174621 */     GIR_EraseRootFromParent_Done,
     /* 174622 */   // Label 3258: @174622
     /* 174622 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(174805), // Rule ID 2563 //
     /* 174627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174688 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174708 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174734 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 174790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174803 */     GIR_RootConstrainSelectedInstOperands,
     /* 174804 */     // GIR_Coverage, 2563,
     /* 174804 */     GIR_EraseRootFromParent_Done,
     /* 174805 */   // Label 3259: @174805
     /* 174805 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(174988), // Rule ID 6305 //
     /* 174810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174859 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174862 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174871 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174885 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174891 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174891 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174894 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174898 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174917 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174920 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174924 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174927 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174954 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 174973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174986 */     GIR_RootConstrainSelectedInstOperands,
     /* 174987 */     // GIR_Coverage, 6305,
     /* 174987 */     GIR_EraseRootFromParent_Done,
     /* 174988 */   // Label 3260: @174988
     /* 174988 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(175092), // Rule ID 13529 //
     /* 174993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175055 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175059 */     // MIs[3] Operand 1
     /* 175059 */     // No operand predicates
     /* 175059 */     // MIs[1] Operand 2
     /* 175059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175076 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 175079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175090 */     GIR_RootConstrainSelectedInstOperands,
     /* 175091 */     // GIR_Coverage, 13529,
     /* 175091 */     GIR_EraseRootFromParent_Done,
     /* 175092 */   // Label 3261: @175092
     /* 175092 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(175196), // Rule ID 13532 //
     /* 175097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175159 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175163 */     // MIs[3] Operand 1
     /* 175163 */     // No operand predicates
     /* 175163 */     // MIs[1] Operand 2
     /* 175163 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175180 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175194 */     GIR_RootConstrainSelectedInstOperands,
     /* 175195 */     // GIR_Coverage, 13532,
     /* 175195 */     GIR_EraseRootFromParent_Done,
     /* 175196 */   // Label 3262: @175196
     /* 175196 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(175327), // Rule ID 2520 //
     /* 175201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175276 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175280 */     // MIs[3] Operand 1
     /* 175280 */     // No operand predicates
     /* 175280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175282 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175294 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175325 */     GIR_RootConstrainSelectedInstOperands,
     /* 175326 */     // GIR_Coverage, 2520,
     /* 175326 */     GIR_EraseRootFromParent_Done,
     /* 175327 */   // Label 3263: @175327
     /* 175327 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(175458), // Rule ID 2521 //
     /* 175332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175407 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175411 */     // MIs[3] Operand 1
     /* 175411 */     // No operand predicates
     /* 175411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175413 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175456 */     GIR_RootConstrainSelectedInstOperands,
     /* 175457 */     // GIR_Coverage, 2521,
     /* 175457 */     GIR_EraseRootFromParent_Done,
     /* 175458 */   // Label 3264: @175458
     /* 175458 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(175589), // Rule ID 2522 //
     /* 175463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175542 */     // MIs[3] Operand 1
     /* 175542 */     // No operand predicates
     /* 175542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175544 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175587 */     GIR_RootConstrainSelectedInstOperands,
     /* 175588 */     // GIR_Coverage, 2522,
     /* 175588 */     GIR_EraseRootFromParent_Done,
     /* 175589 */   // Label 3265: @175589
     /* 175589 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(175720), // Rule ID 13721 //
     /* 175594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175648 */     // MIs[2] Operand 1
     /* 175648 */     // No operand predicates
     /* 175648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175664 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175669 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175675 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175687 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175718 */     GIR_RootConstrainSelectedInstOperands,
     /* 175719 */     // GIR_Coverage, 13721,
     /* 175719 */     GIR_EraseRootFromParent_Done,
     /* 175720 */   // Label 3266: @175720
     /* 175720 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(175851), // Rule ID 13722 //
     /* 175725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175779 */     // MIs[2] Operand 1
     /* 175779 */     // No operand predicates
     /* 175779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175791 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175795 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175800 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175806 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175818 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175849 */     GIR_RootConstrainSelectedInstOperands,
     /* 175850 */     // GIR_Coverage, 13722,
     /* 175850 */     GIR_EraseRootFromParent_Done,
     /* 175851 */   // Label 3267: @175851
     /* 175851 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(175982), // Rule ID 13723 //
     /* 175856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175910 */     // MIs[2] Operand 1
     /* 175910 */     // No operand predicates
     /* 175910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175926 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175931 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175937 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175949 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175980 */     GIR_RootConstrainSelectedInstOperands,
     /* 175981 */     // GIR_Coverage, 13723,
     /* 175981 */     GIR_EraseRootFromParent_Done,
     /* 175982 */   // Label 3268: @175982
     /* 175982 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(176096), // Rule ID 2061 //
     /* 175987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 175995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176020 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176023 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176074 */     // MIs[3] Operand 1
     /* 176074 */     // No operand predicates
     /* 176074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176076 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 176079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176094 */     GIR_RootConstrainSelectedInstOperands,
     /* 176095 */     // GIR_Coverage, 2061,
     /* 176095 */     GIR_EraseRootFromParent_Done,
     /* 176096 */   // Label 3269: @176096
     /* 176096 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(176210), // Rule ID 2068 //
     /* 176101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176134 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176137 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176146 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176184 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176188 */     // MIs[3] Operand 1
     /* 176188 */     // No operand predicates
     /* 176188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176190 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 176193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176208 */     GIR_RootConstrainSelectedInstOperands,
     /* 176209 */     // GIR_Coverage, 2068,
     /* 176209 */     GIR_EraseRootFromParent_Done,
     /* 176210 */   // Label 3270: @176210
     /* 176210 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(176314), // Rule ID 1987 //
     /* 176215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176281 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176285 */     // MIs[3] Operand 1
     /* 176285 */     // No operand predicates
     /* 176285 */     // MIs[1] Operand 2
     /* 176285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176298 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176312 */     GIR_RootConstrainSelectedInstOperands,
     /* 176313 */     // GIR_Coverage, 1987,
     /* 176313 */     GIR_EraseRootFromParent_Done,
     /* 176314 */   // Label 3271: @176314
     /* 176314 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(176418), // Rule ID 2017 //
     /* 176319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176389 */     // MIs[3] Operand 1
     /* 176389 */     // No operand predicates
     /* 176389 */     // MIs[1] Operand 2
     /* 176389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176402 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 176405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176416 */     GIR_RootConstrainSelectedInstOperands,
     /* 176417 */     // GIR_Coverage, 2017,
     /* 176417 */     GIR_EraseRootFromParent_Done,
     /* 176418 */   // Label 3272: @176418
     /* 176418 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176522), // Rule ID 2024 //
     /* 176423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176493 */     // MIs[3] Operand 1
     /* 176493 */     // No operand predicates
     /* 176493 */     // MIs[1] Operand 2
     /* 176493 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176506 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 176509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176520 */     GIR_RootConstrainSelectedInstOperands,
     /* 176521 */     // GIR_Coverage, 2024,
     /* 176521 */     GIR_EraseRootFromParent_Done,
     /* 176522 */   // Label 3273: @176522
     /* 176522 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(176626), // Rule ID 2083 //
     /* 176527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176593 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176597 */     // MIs[3] Operand 1
     /* 176597 */     // No operand predicates
     /* 176597 */     // MIs[1] Operand 2
     /* 176597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 176613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176624 */     GIR_RootConstrainSelectedInstOperands,
     /* 176625 */     // GIR_Coverage, 2083,
     /* 176625 */     GIR_EraseRootFromParent_Done,
     /* 176626 */   // Label 3274: @176626
     /* 176626 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(176730), // Rule ID 1990 //
     /* 176631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176697 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176701 */     // MIs[3] Operand 1
     /* 176701 */     // No operand predicates
     /* 176701 */     // MIs[1] Operand 2
     /* 176701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176714 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 176717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176728 */     GIR_RootConstrainSelectedInstOperands,
     /* 176729 */     // GIR_Coverage, 1990,
     /* 176729 */     GIR_EraseRootFromParent_Done,
     /* 176730 */   // Label 3275: @176730
     /* 176730 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(176834), // Rule ID 2020 //
     /* 176735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176801 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176805 */     // MIs[3] Operand 1
     /* 176805 */     // No operand predicates
     /* 176805 */     // MIs[1] Operand 2
     /* 176805 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176818 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 176821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176832 */     GIR_RootConstrainSelectedInstOperands,
     /* 176833 */     // GIR_Coverage, 2020,
     /* 176833 */     GIR_EraseRootFromParent_Done,
     /* 176834 */   // Label 3276: @176834
     /* 176834 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(176938), // Rule ID 2027 //
     /* 176839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176905 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176909 */     // MIs[3] Operand 1
     /* 176909 */     // No operand predicates
     /* 176909 */     // MIs[1] Operand 2
     /* 176909 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176922 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 176925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176936 */     GIR_RootConstrainSelectedInstOperands,
     /* 176937 */     // GIR_Coverage, 2027,
     /* 176937 */     GIR_EraseRootFromParent_Done,
     /* 176938 */   // Label 3277: @176938
     /* 176938 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(177042), // Rule ID 2086 //
     /* 176943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177013 */     // MIs[3] Operand 1
     /* 177013 */     // No operand predicates
     /* 177013 */     // MIs[1] Operand 2
     /* 177013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177026 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 177029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177040 */     GIR_RootConstrainSelectedInstOperands,
     /* 177041 */     // GIR_Coverage, 2086,
     /* 177041 */     GIR_EraseRootFromParent_Done,
     /* 177042 */   // Label 3278: @177042
     /* 177042 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(177099), // Rule ID 1751 //
     /* 177047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177082 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 177085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177097 */     GIR_RootConstrainSelectedInstOperands,
     /* 177098 */     // GIR_Coverage, 1751,
     /* 177098 */     GIR_EraseRootFromParent_Done,
     /* 177099 */   // Label 3279: @177099
     /* 177099 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(177156), // Rule ID 1753 //
     /* 177104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 177142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177154 */     GIR_RootConstrainSelectedInstOperands,
     /* 177155 */     // GIR_Coverage, 1753,
     /* 177155 */     GIR_EraseRootFromParent_Done,
     /* 177156 */   // Label 3280: @177156
     /* 177156 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177266), // Rule ID 6324 //
     /* 177161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 177166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 177187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177200 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 177211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177223 */     // MIs[2] Operand 1
     /* 177223 */     // No operand predicates
     /* 177223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177225 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177237 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 177256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177264 */     GIR_RootConstrainSelectedInstOperands,
     /* 177265 */     // GIR_Coverage, 6324,
     /* 177265 */     GIR_EraseRootFromParent_Done,
     /* 177266 */   // Label 3281: @177266
     /* 177266 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177363), // Rule ID 13992 //
     /* 177271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177313 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177323 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177361 */     GIR_RootConstrainSelectedInstOperands,
     /* 177362 */     // GIR_Coverage, 13992,
     /* 177362 */     GIR_EraseRootFromParent_Done,
     /* 177363 */   // Label 3282: @177363
     /* 177363 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177460), // Rule ID 13993 //
     /* 177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177420 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177458 */     GIR_RootConstrainSelectedInstOperands,
     /* 177459 */     // GIR_Coverage, 13993,
     /* 177459 */     GIR_EraseRootFromParent_Done,
     /* 177460 */   // Label 3283: @177460
     /* 177460 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177557), // Rule ID 13994 //
     /* 177465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177517 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177529 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177555 */     GIR_RootConstrainSelectedInstOperands,
     /* 177556 */     // GIR_Coverage, 13994,
     /* 177556 */     GIR_EraseRootFromParent_Done,
     /* 177557 */   // Label 3284: @177557
     /* 177557 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(177637), // Rule ID 5256 //
     /* 177562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177592 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177595 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177604 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 177608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177620 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 177623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 177631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 177635 */     GIR_RootConstrainSelectedInstOperands,
     /* 177636 */     // GIR_Coverage, 5256,
     /* 177636 */     GIR_EraseRootFromParent_Done,
     /* 177637 */   // Label 3285: @177637
     /* 177637 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(177717), // Rule ID 5257 //
     /* 177642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 177647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 177688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177700 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 177703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 177711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 177715 */     GIR_RootConstrainSelectedInstOperands,
     /* 177716 */     // GIR_Coverage, 5257,
     /* 177716 */     GIR_EraseRootFromParent_Done,
     /* 177717 */   // Label 3286: @177717
     /* 177717 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(177814), // Rule ID 5253 //
     /* 177722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177774 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177786 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177812 */     GIR_RootConstrainSelectedInstOperands,
     /* 177813 */     // GIR_Coverage, 5253,
     /* 177813 */     GIR_EraseRootFromParent_Done,
     /* 177814 */   // Label 3287: @177814
     /* 177814 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(177911), // Rule ID 5254 //
     /* 177819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177865 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177871 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177909 */     GIR_RootConstrainSelectedInstOperands,
     /* 177910 */     // GIR_Coverage, 5254,
     /* 177910 */     GIR_EraseRootFromParent_Done,
     /* 177911 */   // Label 3288: @177911
     /* 177911 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(178008), // Rule ID 5255 //
     /* 177916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177968 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178006 */     GIR_RootConstrainSelectedInstOperands,
     /* 178007 */     // GIR_Coverage, 5255,
     /* 178007 */     GIR_EraseRootFromParent_Done,
     /* 178008 */   // Label 3289: @178008
     /* 178008 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(178089), // Rule ID 13530 //
     /* 178013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178063 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178067 */     // MIs[2] Operand 1
     /* 178067 */     // No operand predicates
     /* 178067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178073 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178087 */     GIR_RootConstrainSelectedInstOperands,
     /* 178088 */     // GIR_Coverage, 13530,
     /* 178088 */     GIR_EraseRootFromParent_Done,
     /* 178089 */   // Label 3290: @178089
     /* 178089 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(178170), // Rule ID 13531 //
     /* 178094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178144 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178148 */     // MIs[2] Operand 1
     /* 178148 */     // No operand predicates
     /* 178148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178154 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178168 */     GIR_RootConstrainSelectedInstOperands,
     /* 178169 */     // GIR_Coverage, 13531,
     /* 178169 */     GIR_EraseRootFromParent_Done,
     /* 178170 */   // Label 3291: @178170
     /* 178170 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178251), // Rule ID 13533 //
     /* 178175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178229 */     // MIs[2] Operand 1
     /* 178229 */     // No operand predicates
     /* 178229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178235 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 178238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178249 */     GIR_RootConstrainSelectedInstOperands,
     /* 178250 */     // GIR_Coverage, 13533,
     /* 178250 */     GIR_EraseRootFromParent_Done,
     /* 178251 */   // Label 3292: @178251
     /* 178251 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178332), // Rule ID 13534 //
     /* 178256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178310 */     // MIs[2] Operand 1
     /* 178310 */     // No operand predicates
     /* 178310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178316 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 178319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178330 */     GIR_RootConstrainSelectedInstOperands,
     /* 178331 */     // GIR_Coverage, 13534,
     /* 178331 */     GIR_EraseRootFromParent_Done,
     /* 178332 */   // Label 3293: @178332
     /* 178332 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178413), // Rule ID 13535 //
     /* 178337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 178366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178391 */     // MIs[2] Operand 1
     /* 178391 */     // No operand predicates
     /* 178391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178397 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 178400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178411 */     GIR_RootConstrainSelectedInstOperands,
     /* 178412 */     // GIR_Coverage, 13535,
     /* 178412 */     GIR_EraseRootFromParent_Done,
     /* 178413 */   // Label 3294: @178413
     /* 178413 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178494), // Rule ID 13536 //
     /* 178418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178472 */     // MIs[2] Operand 1
     /* 178472 */     // No operand predicates
     /* 178472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178478 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 178481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178492 */     GIR_RootConstrainSelectedInstOperands,
     /* 178493 */     // GIR_Coverage, 13536,
     /* 178493 */     GIR_EraseRootFromParent_Done,
     /* 178494 */   // Label 3295: @178494
     /* 178494 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178575), // Rule ID 13537 //
     /* 178499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178549 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178553 */     // MIs[2] Operand 1
     /* 178553 */     // No operand predicates
     /* 178553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178559 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 178562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178573 */     GIR_RootConstrainSelectedInstOperands,
     /* 178574 */     // GIR_Coverage, 13537,
     /* 178574 */     GIR_EraseRootFromParent_Done,
     /* 178575 */   // Label 3296: @178575
     /* 178575 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(178656), // Rule ID 13538 //
     /* 178580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178634 */     // MIs[2] Operand 1
     /* 178634 */     // No operand predicates
     /* 178634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178640 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 178643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178654 */     GIR_RootConstrainSelectedInstOperands,
     /* 178655 */     // GIR_Coverage, 13538,
     /* 178655 */     GIR_EraseRootFromParent_Done,
     /* 178656 */   // Label 3297: @178656
     /* 178656 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(178762), // Rule ID 6321 //
     /* 178661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 178666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 178687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 178691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178696 */     // MIs[1] Operand 2
     /* 178696 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 178707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 178711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178715 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 178719 */     // MIs[2] Operand 1
     /* 178719 */     // No operand predicates
     /* 178719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178721 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 178721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 178724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 178739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 178752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 178760 */     GIR_RootConstrainSelectedInstOperands,
     /* 178761 */     // GIR_Coverage, 6321,
     /* 178761 */     GIR_EraseRootFromParent_Done,
     /* 178762 */   // Label 3298: @178762
     /* 178762 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(178843), // Rule ID 1988 //
     /* 178767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178825 */     // MIs[2] Operand 1
     /* 178825 */     // No operand predicates
     /* 178825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178827 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178841 */     GIR_RootConstrainSelectedInstOperands,
     /* 178842 */     // GIR_Coverage, 1988,
     /* 178842 */     GIR_EraseRootFromParent_Done,
     /* 178843 */   // Label 3299: @178843
     /* 178843 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(178924), // Rule ID 1989 //
     /* 178848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178906 */     // MIs[2] Operand 1
     /* 178906 */     // No operand predicates
     /* 178906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178908 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178922 */     GIR_RootConstrainSelectedInstOperands,
     /* 178923 */     // GIR_Coverage, 1989,
     /* 178923 */     GIR_EraseRootFromParent_Done,
     /* 178924 */   // Label 3300: @178924
     /* 178924 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(179005), // Rule ID 2018 //
     /* 178929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178987 */     // MIs[2] Operand 1
     /* 178987 */     // No operand predicates
     /* 178987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178989 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 178992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179003 */     GIR_RootConstrainSelectedInstOperands,
     /* 179004 */     // GIR_Coverage, 2018,
     /* 179004 */     GIR_EraseRootFromParent_Done,
     /* 179005 */   // Label 3301: @179005
     /* 179005 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(179086), // Rule ID 2019 //
     /* 179010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179068 */     // MIs[2] Operand 1
     /* 179068 */     // No operand predicates
     /* 179068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179070 */     // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 179073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179084 */     GIR_RootConstrainSelectedInstOperands,
     /* 179085 */     // GIR_Coverage, 2019,
     /* 179085 */     GIR_EraseRootFromParent_Done,
     /* 179086 */   // Label 3302: @179086
     /* 179086 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(179167), // Rule ID 2025 //
     /* 179091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179149 */     // MIs[2] Operand 1
     /* 179149 */     // No operand predicates
     /* 179149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179151 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 179154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179165 */     GIR_RootConstrainSelectedInstOperands,
     /* 179166 */     // GIR_Coverage, 2025,
     /* 179166 */     GIR_EraseRootFromParent_Done,
     /* 179167 */   // Label 3303: @179167
     /* 179167 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(179248), // Rule ID 2026 //
     /* 179172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179230 */     // MIs[2] Operand 1
     /* 179230 */     // No operand predicates
     /* 179230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179232 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 179235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179246 */     GIR_RootConstrainSelectedInstOperands,
     /* 179247 */     // GIR_Coverage, 2026,
     /* 179247 */     GIR_EraseRootFromParent_Done,
     /* 179248 */   // Label 3304: @179248
     /* 179248 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179329), // Rule ID 2084 //
     /* 179253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179311 */     // MIs[2] Operand 1
     /* 179311 */     // No operand predicates
     /* 179311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 179316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179327 */     GIR_RootConstrainSelectedInstOperands,
     /* 179328 */     // GIR_Coverage, 2084,
     /* 179328 */     GIR_EraseRootFromParent_Done,
     /* 179329 */   // Label 3305: @179329
     /* 179329 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179410), // Rule ID 1991 //
     /* 179334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179392 */     // MIs[2] Operand 1
     /* 179392 */     // No operand predicates
     /* 179392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179394 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 179397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179408 */     GIR_RootConstrainSelectedInstOperands,
     /* 179409 */     // GIR_Coverage, 1991,
     /* 179409 */     GIR_EraseRootFromParent_Done,
     /* 179410 */   // Label 3306: @179410
     /* 179410 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179491), // Rule ID 1992 //
     /* 179415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179469 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179473 */     // MIs[2] Operand 1
     /* 179473 */     // No operand predicates
     /* 179473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179475 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 179478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179489 */     GIR_RootConstrainSelectedInstOperands,
     /* 179490 */     // GIR_Coverage, 1992,
     /* 179490 */     GIR_EraseRootFromParent_Done,
     /* 179491 */   // Label 3307: @179491
     /* 179491 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179572), // Rule ID 2021 //
     /* 179496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179554 */     // MIs[2] Operand 1
     /* 179554 */     // No operand predicates
     /* 179554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179556 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 179559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179570 */     GIR_RootConstrainSelectedInstOperands,
     /* 179571 */     // GIR_Coverage, 2021,
     /* 179571 */     GIR_EraseRootFromParent_Done,
     /* 179572 */   // Label 3308: @179572
     /* 179572 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(179653), // Rule ID 2022 //
     /* 179577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179631 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179635 */     // MIs[2] Operand 1
     /* 179635 */     // No operand predicates
     /* 179635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179637 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 179640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179651 */     GIR_RootConstrainSelectedInstOperands,
     /* 179652 */     // GIR_Coverage, 2022,
     /* 179652 */     GIR_EraseRootFromParent_Done,
     /* 179653 */   // Label 3309: @179653
     /* 179653 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(179734), // Rule ID 2028 //
     /* 179658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179716 */     // MIs[2] Operand 1
     /* 179716 */     // No operand predicates
     /* 179716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179718 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 179721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179732 */     GIR_RootConstrainSelectedInstOperands,
     /* 179733 */     // GIR_Coverage, 2028,
     /* 179733 */     GIR_EraseRootFromParent_Done,
     /* 179734 */   // Label 3310: @179734
     /* 179734 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(179815), // Rule ID 2029 //
     /* 179739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179797 */     // MIs[2] Operand 1
     /* 179797 */     // No operand predicates
     /* 179797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179799 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 179802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179813 */     GIR_RootConstrainSelectedInstOperands,
     /* 179814 */     // GIR_Coverage, 2029,
     /* 179814 */     GIR_EraseRootFromParent_Done,
     /* 179815 */   // Label 3311: @179815
     /* 179815 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(179896), // Rule ID 2087 //
     /* 179820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179878 */     // MIs[2] Operand 1
     /* 179878 */     // No operand predicates
     /* 179878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 179883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179894 */     GIR_RootConstrainSelectedInstOperands,
     /* 179895 */     // GIR_Coverage, 2087,
     /* 179895 */     GIR_EraseRootFromParent_Done,
     /* 179896 */   // Label 3312: @179896
     /* 179896 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(179977), // Rule ID 1993 //
     /* 179901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 179934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179959 */     // MIs[2] Operand 1
     /* 179959 */     // No operand predicates
     /* 179959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179961 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 179964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179975 */     GIR_RootConstrainSelectedInstOperands,
     /* 179976 */     // GIR_Coverage, 1993,
     /* 179976 */     GIR_EraseRootFromParent_Done,
     /* 179977 */   // Label 3313: @179977
     /* 179977 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(180058), // Rule ID 1994 //
     /* 179982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 180028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180036 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180040 */     // MIs[2] Operand 1
     /* 180040 */     // No operand predicates
     /* 180040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180042 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 180045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180056 */     GIR_RootConstrainSelectedInstOperands,
     /* 180057 */     // GIR_Coverage, 1994,
     /* 180057 */     GIR_EraseRootFromParent_Done,
     /* 180058 */   // Label 3314: @180058
     /* 180058 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(180139), // Rule ID 1995 //
     /* 180063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180117 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180121 */     // MIs[2] Operand 1
     /* 180121 */     // No operand predicates
     /* 180121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180123 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 180126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180137 */     GIR_RootConstrainSelectedInstOperands,
     /* 180138 */     // GIR_Coverage, 1995,
     /* 180138 */     GIR_EraseRootFromParent_Done,
     /* 180139 */   // Label 3315: @180139
     /* 180139 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(180220), // Rule ID 1996 //
     /* 180144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180202 */     // MIs[2] Operand 1
     /* 180202 */     // No operand predicates
     /* 180202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180204 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 180207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180218 */     GIR_RootConstrainSelectedInstOperands,
     /* 180219 */     // GIR_Coverage, 1996,
     /* 180219 */     GIR_EraseRootFromParent_Done,
     /* 180220 */   // Label 3316: @180220
     /* 180220 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(180301), // Rule ID 2023 //
     /* 180225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180279 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180283 */     // MIs[2] Operand 1
     /* 180283 */     // No operand predicates
     /* 180283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180285 */     // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 180288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180299 */     GIR_RootConstrainSelectedInstOperands,
     /* 180300 */     // GIR_Coverage, 2023,
     /* 180300 */     GIR_EraseRootFromParent_Done,
     /* 180301 */   // Label 3317: @180301
     /* 180301 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(180382), // Rule ID 2030 //
     /* 180306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180364 */     // MIs[2] Operand 1
     /* 180364 */     // No operand predicates
     /* 180364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180366 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 180369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180380 */     GIR_RootConstrainSelectedInstOperands,
     /* 180381 */     // GIR_Coverage, 2030,
     /* 180381 */     GIR_EraseRootFromParent_Done,
     /* 180382 */   // Label 3318: @180382
     /* 180382 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(180460), // Rule ID 6308 //
     /* 180387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 180392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180442 */     // MIs[2] Operand 1
     /* 180442 */     // No operand predicates
     /* 180442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180444 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 180444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 180447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 180455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180458 */     GIR_RootConstrainSelectedInstOperands,
     /* 180459 */     // GIR_Coverage, 6308,
     /* 180459 */     GIR_EraseRootFromParent_Done,
     /* 180460 */   // Label 3319: @180460
     /* 180460 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(180520), // Rule ID 6374 //
     /* 180465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 180473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 180491 */     // (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 180491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 180494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180503 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 180511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180518 */     GIR_RootConstrainSelectedInstOperands,
     /* 180519 */     // GIR_Coverage, 6374,
     /* 180519 */     GIR_EraseRootFromParent_Done,
     /* 180520 */   // Label 3320: @180520
     /* 180520 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(180580), // Rule ID 6375 //
     /* 180525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 180551 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 180551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 180554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 180571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180578 */     GIR_RootConstrainSelectedInstOperands,
     /* 180579 */     // GIR_Coverage, 6375,
     /* 180579 */     GIR_EraseRootFromParent_Done,
     /* 180580 */   // Label 3321: @180580
     /* 180580 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(180640), // Rule ID 6376 //
     /* 180585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 180611 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 180611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 180614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 180631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180638 */     GIR_RootConstrainSelectedInstOperands,
     /* 180639 */     // GIR_Coverage, 6376,
     /* 180639 */     GIR_EraseRootFromParent_Done,
     /* 180640 */   // Label 3322: @180640
     /* 180640 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(180687), // Rule ID 3901 //
     /* 180645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180667 */     // MIs[0] Operand 3
     /* 180667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 180678 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 180681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180685 */     GIR_RootConstrainSelectedInstOperands,
     /* 180686 */     // GIR_Coverage, 3901,
     /* 180686 */     GIR_EraseRootFromParent_Done,
     /* 180687 */   // Label 3323: @180687
     /* 180687 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(180734), // Rule ID 3902 //
     /* 180692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180714 */     // MIs[0] Operand 3
     /* 180714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 180725 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 180728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180732 */     GIR_RootConstrainSelectedInstOperands,
     /* 180733 */     // GIR_Coverage, 3902,
     /* 180733 */     GIR_EraseRootFromParent_Done,
     /* 180734 */   // Label 3324: @180734
     /* 180734 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(180781), // Rule ID 3903 //
     /* 180739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180761 */     // MIs[0] Operand 3
     /* 180761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 180772 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 180775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180779 */     GIR_RootConstrainSelectedInstOperands,
     /* 180780 */     // GIR_Coverage, 3903,
     /* 180780 */     GIR_EraseRootFromParent_Done,
     /* 180781 */   // Label 3325: @180781
     /* 180781 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(180828), // Rule ID 3904 //
     /* 180786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180808 */     // MIs[0] Operand 3
     /* 180808 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 180819 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 180822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180826 */     GIR_RootConstrainSelectedInstOperands,
     /* 180827 */     // GIR_Coverage, 3904,
     /* 180827 */     GIR_EraseRootFromParent_Done,
     /* 180828 */   // Label 3326: @180828
     /* 180828 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(180874), // Rule ID 3542 //
     /* 180833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180855 */     // MIs[0] Idx
     /* 180855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 180863 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 180863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 180866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180872 */     GIR_RootConstrainSelectedInstOperands,
     /* 180873 */     // GIR_Coverage, 3542,
     /* 180873 */     GIR_EraseRootFromParent_Done,
     /* 180874 */   // Label 3327: @180874
     /* 180874 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(180920), // Rule ID 3543 //
     /* 180879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 180890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180901 */     // MIs[0] Idx
     /* 180901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 180909 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 180909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 180912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180918 */     GIR_RootConstrainSelectedInstOperands,
     /* 180919 */     // GIR_Coverage, 3543,
     /* 180919 */     GIR_EraseRootFromParent_Done,
     /* 180920 */   // Label 3328: @180920
     /* 180920 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(180966), // Rule ID 3544 //
     /* 180925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180947 */     // MIs[0] Idx
     /* 180947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 180955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 180955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 180958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180964 */     GIR_RootConstrainSelectedInstOperands,
     /* 180965 */     // GIR_Coverage, 3544,
     /* 180965 */     GIR_EraseRootFromParent_Done,
     /* 180966 */   // Label 3329: @180966
     /* 180966 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(181012), // Rule ID 3545 //
     /* 180971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180993 */     // MIs[0] Idx
     /* 180993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 181001 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 181001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 181004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181010 */     GIR_RootConstrainSelectedInstOperands,
     /* 181011 */     // GIR_Coverage, 3545,
     /* 181011 */     GIR_EraseRootFromParent_Done,
     /* 181012 */   // Label 3330: @181012
     /* 181012 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(181068), // Rule ID 2109 //
     /* 181017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 181025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181054 */     // MIs[1] Operand 1
     /* 181054 */     // No operand predicates
     /* 181054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181056 */     // (intrinsic_wo_chain:{ *:[i32] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 181059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181066 */     GIR_RootConstrainSelectedInstOperands,
     /* 181067 */     // GIR_Coverage, 2109,
     /* 181067 */     GIR_EraseRootFromParent_Done,
     /* 181068 */   // Label 3331: @181068
     /* 181068 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(181124), // Rule ID 2110 //
     /* 181073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 181081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181110 */     // MIs[1] Operand 1
     /* 181110 */     // No operand predicates
     /* 181110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181112 */     // (intrinsic_wo_chain:{ *:[i32] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 181115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181122 */     GIR_RootConstrainSelectedInstOperands,
     /* 181123 */     // GIR_Coverage, 2110,
     /* 181123 */     GIR_EraseRootFromParent_Done,
     /* 181124 */   // Label 3332: @181124
     /* 181124 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(181180), // Rule ID 2115 //
     /* 181129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 181137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181166 */     // MIs[1] Operand 1
     /* 181166 */     // No operand predicates
     /* 181166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181168 */     // (intrinsic_wo_chain:{ *:[i32] } 706:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 181171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181178 */     GIR_RootConstrainSelectedInstOperands,
     /* 181179 */     // GIR_Coverage, 2115,
     /* 181179 */     GIR_EraseRootFromParent_Done,
     /* 181180 */   // Label 3333: @181180
     /* 181180 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(181236), // Rule ID 2116 //
     /* 181185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 181193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181222 */     // MIs[1] Operand 1
     /* 181222 */     // No operand predicates
     /* 181222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181224 */     // (intrinsic_wo_chain:{ *:[i32] } 707:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 181227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181234 */     GIR_RootConstrainSelectedInstOperands,
     /* 181235 */     // GIR_Coverage, 2116,
     /* 181235 */     GIR_EraseRootFromParent_Done,
     /* 181236 */   // Label 3334: @181236
     /* 181236 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(181292), // Rule ID 2123 //
     /* 181241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 181249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181278 */     // MIs[1] Operand 1
     /* 181278 */     // No operand predicates
     /* 181278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181280 */     // (intrinsic_wo_chain:{ *:[i32] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 181283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181290 */     GIR_RootConstrainSelectedInstOperands,
     /* 181291 */     // GIR_Coverage, 2123,
     /* 181291 */     GIR_EraseRootFromParent_Done,
     /* 181292 */   // Label 3335: @181292
     /* 181292 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(181348), // Rule ID 2126 //
     /* 181297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 181305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181334 */     // MIs[1] Operand 1
     /* 181334 */     // No operand predicates
     /* 181334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181336 */     // (intrinsic_wo_chain:{ *:[i32] } 753:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 181339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181346 */     GIR_RootConstrainSelectedInstOperands,
     /* 181347 */     // GIR_Coverage, 2126,
     /* 181347 */     GIR_EraseRootFromParent_Done,
     /* 181348 */   // Label 3336: @181348
     /* 181348 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(181404), // Rule ID 2148 //
     /* 181353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 181390 */     // MIs[1] Operand 1
     /* 181390 */     // No operand predicates
     /* 181390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181392 */     // (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 181395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181402 */     GIR_RootConstrainSelectedInstOperands,
     /* 181403 */     // GIR_Coverage, 2148,
     /* 181403 */     GIR_EraseRootFromParent_Done,
     /* 181404 */   // Label 3337: @181404
     /* 181404 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(181460), // Rule ID 2150 //
     /* 181409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 181446 */     // MIs[1] Operand 1
     /* 181446 */     // No operand predicates
     /* 181446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181448 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 181451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181458 */     GIR_RootConstrainSelectedInstOperands,
     /* 181459 */     // GIR_Coverage, 2150,
     /* 181459 */     GIR_EraseRootFromParent_Done,
     /* 181460 */   // Label 3338: @181460
     /* 181460 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(181516), // Rule ID 2152 //
     /* 181465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 181502 */     // MIs[1] Operand 1
     /* 181502 */     // No operand predicates
     /* 181502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181504 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 181507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181514 */     GIR_RootConstrainSelectedInstOperands,
     /* 181515 */     // GIR_Coverage, 2152,
     /* 181515 */     GIR_EraseRootFromParent_Done,
     /* 181516 */   // Label 3339: @181516
     /* 181516 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(181569), // Rule ID 6309 //
     /* 181521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181555 */     // MIs[1] Operand 1
     /* 181555 */     // No operand predicates
     /* 181555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181557 */     // (intrinsic_wo_chain:{ *:[i32] } 772:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 181560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181567 */     GIR_RootConstrainSelectedInstOperands,
     /* 181568 */     // GIR_Coverage, 6309,
     /* 181568 */     GIR_EraseRootFromParent_Done,
     /* 181569 */   // Label 3340: @181569
     /* 181569 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(181622), // Rule ID 6310 //
     /* 181574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181608 */     // MIs[1] Operand 1
     /* 181608 */     // No operand predicates
     /* 181608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181610 */     // (intrinsic_wo_chain:{ *:[i32] } 773:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 181613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181620 */     GIR_RootConstrainSelectedInstOperands,
     /* 181621 */     // GIR_Coverage, 6310,
     /* 181621 */     GIR_EraseRootFromParent_Done,
     /* 181622 */   // Label 3341: @181622
     /* 181622 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(181675), // Rule ID 6311 //
     /* 181627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181661 */     // MIs[1] Operand 1
     /* 181661 */     // No operand predicates
     /* 181661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181663 */     // (intrinsic_wo_chain:{ *:[i64] } 772:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 181666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181673 */     GIR_RootConstrainSelectedInstOperands,
     /* 181674 */     // GIR_Coverage, 6311,
     /* 181674 */     GIR_EraseRootFromParent_Done,
     /* 181675 */   // Label 3342: @181675
     /* 181675 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(181728), // Rule ID 6312 //
     /* 181680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181714 */     // MIs[1] Operand 1
     /* 181714 */     // No operand predicates
     /* 181714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181716 */     // (intrinsic_wo_chain:{ *:[i64] } 773:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 181719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181726 */     GIR_RootConstrainSelectedInstOperands,
     /* 181727 */     // GIR_Coverage, 6312,
     /* 181727 */     GIR_EraseRootFromParent_Done,
     /* 181728 */   // Label 3343: @181728
     /* 181728 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(181781), // Rule ID 6313 //
     /* 181733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181767 */     // MIs[1] Operand 1
     /* 181767 */     // No operand predicates
     /* 181767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181769 */     // (intrinsic_wo_chain:{ *:[v1i64] } 772:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 181772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181779 */     GIR_RootConstrainSelectedInstOperands,
     /* 181780 */     // GIR_Coverage, 6313,
     /* 181780 */     GIR_EraseRootFromParent_Done,
     /* 181781 */   // Label 3344: @181781
     /* 181781 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(181834), // Rule ID 6314 //
     /* 181786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181820 */     // MIs[1] Operand 1
     /* 181820 */     // No operand predicates
     /* 181820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181822 */     // (intrinsic_wo_chain:{ *:[v1i64] } 773:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 181825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181832 */     GIR_RootConstrainSelectedInstOperands,
     /* 181833 */     // GIR_Coverage, 6314,
     /* 181833 */     GIR_EraseRootFromParent_Done,
     /* 181834 */   // Label 3345: @181834
     /* 181834 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(181887), // Rule ID 6315 //
     /* 181839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 181844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181873 */     // MIs[1] Operand 1
     /* 181873 */     // No operand predicates
     /* 181873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181875 */     // (intrinsic_wo_chain:{ *:[f32] } 776:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 181878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181885 */     GIR_RootConstrainSelectedInstOperands,
     /* 181886 */     // GIR_Coverage, 6315,
     /* 181886 */     GIR_EraseRootFromParent_Done,
     /* 181887 */   // Label 3346: @181887
     /* 181887 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(181940), // Rule ID 6316 //
     /* 181892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 181897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181926 */     // MIs[1] Operand 1
     /* 181926 */     // No operand predicates
     /* 181926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181928 */     // (intrinsic_wo_chain:{ *:[f64] } 776:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 181931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181938 */     GIR_RootConstrainSelectedInstOperands,
     /* 181939 */     // GIR_Coverage, 6316,
     /* 181939 */     GIR_EraseRootFromParent_Done,
     /* 181940 */   // Label 3347: @181940
     /* 181940 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(181993), // Rule ID 6317 //
     /* 181945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 181950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181979 */     // MIs[1] Operand 1
     /* 181979 */     // No operand predicates
     /* 181979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181981 */     // (intrinsic_wo_chain:{ *:[v1f64] } 775:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 181984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181991 */     GIR_RootConstrainSelectedInstOperands,
     /* 181992 */     // GIR_Coverage, 6317,
     /* 181992 */     GIR_EraseRootFromParent_Done,
     /* 181993 */   // Label 3348: @181993
     /* 181993 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(182046), // Rule ID 6318 //
     /* 181998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182032 */     // MIs[1] Operand 1
     /* 182032 */     // No operand predicates
     /* 182032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182034 */     // (intrinsic_wo_chain:{ *:[f64] } 775:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182044 */     GIR_RootConstrainSelectedInstOperands,
     /* 182045 */     // GIR_Coverage, 6318,
     /* 182045 */     GIR_EraseRootFromParent_Done,
     /* 182046 */   // Label 3349: @182046
     /* 182046 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(182099), // Rule ID 6319 //
     /* 182051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182085 */     // MIs[1] Operand 1
     /* 182085 */     // No operand predicates
     /* 182085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182087 */     // (intrinsic_wo_chain:{ *:[v1f64] } 776:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182097 */     GIR_RootConstrainSelectedInstOperands,
     /* 182098 */     // GIR_Coverage, 6319,
     /* 182098 */     GIR_EraseRootFromParent_Done,
     /* 182099 */   // Label 3350: @182099
     /* 182099 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(182152), // Rule ID 6320 //
     /* 182104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182138 */     // MIs[1] Operand 1
     /* 182138 */     // No operand predicates
     /* 182138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182140 */     // (intrinsic_wo_chain:{ *:[f32] } 775:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 182143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182150 */     GIR_RootConstrainSelectedInstOperands,
     /* 182151 */     // GIR_Coverage, 6320,
     /* 182151 */     GIR_EraseRootFromParent_Done,
     /* 182152 */   // Label 3351: @182152
     /* 182152 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(182234), // Rule ID 6322 //
     /* 182157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182191 */     // MIs[1] Operand 1
     /* 182191 */     // No operand predicates
     /* 182191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182193 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182205 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182232 */     GIR_RootConstrainSelectedInstOperands,
     /* 182233 */     // GIR_Coverage, 6322,
     /* 182233 */     GIR_EraseRootFromParent_Done,
     /* 182234 */   // Label 3352: @182234
     /* 182234 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(182316), // Rule ID 6323 //
     /* 182239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182273 */     // MIs[1] Operand 1
     /* 182273 */     // No operand predicates
     /* 182273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182275 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182314 */     GIR_RootConstrainSelectedInstOperands,
     /* 182315 */     // GIR_Coverage, 6323,
     /* 182315 */     GIR_EraseRootFromParent_Done,
     /* 182316 */   // Label 3353: @182316
     /* 182316 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(182398), // Rule ID 6325 //
     /* 182321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182355 */     // MIs[1] Operand 1
     /* 182355 */     // No operand predicates
     /* 182355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182357 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182396 */     GIR_RootConstrainSelectedInstOperands,
     /* 182397 */     // GIR_Coverage, 6325,
     /* 182397 */     GIR_EraseRootFromParent_Done,
     /* 182398 */   // Label 3354: @182398
     /* 182398 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(182480), // Rule ID 6326 //
     /* 182403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182437 */     // MIs[1] Operand 1
     /* 182437 */     // No operand predicates
     /* 182437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182439 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182451 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182478 */     GIR_RootConstrainSelectedInstOperands,
     /* 182479 */     // GIR_Coverage, 6326,
     /* 182479 */     GIR_EraseRootFromParent_Done,
     /* 182480 */   // Label 3355: @182480
     /* 182480 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(182586), // Rule ID 6327 //
     /* 182485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182519 */     // MIs[1] Operand 1
     /* 182519 */     // No operand predicates
     /* 182519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182521 */     // (intrinsic_wo_chain:{ *:[i32] } 772:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 182521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 182528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182533 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182585 */     // GIR_Coverage, 6327,
     /* 182585 */     GIR_EraseRootFromParent_Done,
     /* 182586 */   // Label 3356: @182586
     /* 182586 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(182692), // Rule ID 6328 //
     /* 182591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182625 */     // MIs[1] Operand 1
     /* 182625 */     // No operand predicates
     /* 182625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182627 */     // (intrinsic_wo_chain:{ *:[i64] } 772:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 182627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 182634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 182651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182691 */     // GIR_Coverage, 6328,
     /* 182691 */     GIR_EraseRootFromParent_Done,
     /* 182692 */   // Label 3357: @182692
     /* 182692 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(182798), // Rule ID 6329 //
     /* 182697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182731 */     // MIs[1] Operand 1
     /* 182731 */     // No operand predicates
     /* 182731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182733 */     // (intrinsic_wo_chain:{ *:[i32] } 773:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 182733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 182740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182745 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182797 */     // GIR_Coverage, 6329,
     /* 182797 */     GIR_EraseRootFromParent_Done,
     /* 182798 */   // Label 3358: @182798
     /* 182798 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(182904), // Rule ID 6330 //
     /* 182803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182837 */     // MIs[1] Operand 1
     /* 182837 */     // No operand predicates
     /* 182837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182839 */     // (intrinsic_wo_chain:{ *:[i64] } 773:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 182839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 182846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 182863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182903 */     // GIR_Coverage, 6330,
     /* 182903 */     GIR_EraseRootFromParent_Done,
     /* 182904 */   // Label 3359: @182904
     /* 182904 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(182962), // Rule ID 7029 //
     /* 182909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 182914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 182943 */     // MIs[1] Operand 1
     /* 182943 */     // No operand predicates
     /* 182943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182945 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 182945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 182948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182952 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 182957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 182960 */     GIR_RootConstrainSelectedInstOperands,
     /* 182961 */     // GIR_Coverage, 7029,
     /* 182961 */     GIR_EraseRootFromParent_Done,
     /* 182962 */   // Label 3360: @182962
     /* 182962 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(183004), // Rule ID 3041 //
     /* 182967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 182975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182985 */     // MIs[0] Op2
     /* 182985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 182993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183002 */     GIR_RootConstrainSelectedInstOperands,
     /* 183003 */     // GIR_Coverage, 3041,
     /* 183003 */     GIR_EraseRootFromParent_Done,
     /* 183004 */   // Label 3361: @183004
     /* 183004 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(183046), // Rule ID 3042 //
     /* 183009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183027 */     // MIs[0] Op2
     /* 183027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 183038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183044 */     GIR_RootConstrainSelectedInstOperands,
     /* 183045 */     // GIR_Coverage, 3042,
     /* 183045 */     GIR_EraseRootFromParent_Done,
     /* 183046 */   // Label 3362: @183046
     /* 183046 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(183088), // Rule ID 3043 //
     /* 183051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183069 */     // MIs[0] Op2
     /* 183069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 183080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183086 */     GIR_RootConstrainSelectedInstOperands,
     /* 183087 */     // GIR_Coverage, 3043,
     /* 183087 */     GIR_EraseRootFromParent_Done,
     /* 183088 */   // Label 3363: @183088
     /* 183088 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(183130), // Rule ID 3077 //
     /* 183093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183111 */     // MIs[0] Op2
     /* 183111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 183122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183128 */     GIR_RootConstrainSelectedInstOperands,
     /* 183129 */     // GIR_Coverage, 3077,
     /* 183129 */     GIR_EraseRootFromParent_Done,
     /* 183130 */   // Label 3364: @183130
     /* 183130 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(183172), // Rule ID 3078 //
     /* 183135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183153 */     // MIs[0] Op2
     /* 183153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183161 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 183164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183170 */     GIR_RootConstrainSelectedInstOperands,
     /* 183171 */     // GIR_Coverage, 3078,
     /* 183171 */     GIR_EraseRootFromParent_Done,
     /* 183172 */   // Label 3365: @183172
     /* 183172 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(183214), // Rule ID 3079 //
     /* 183177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183195 */     // MIs[0] Op2
     /* 183195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 183206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183212 */     GIR_RootConstrainSelectedInstOperands,
     /* 183213 */     // GIR_Coverage, 3079,
     /* 183213 */     GIR_EraseRootFromParent_Done,
     /* 183214 */   // Label 3366: @183214
     /* 183214 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(183256), // Rule ID 3528 //
     /* 183219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183237 */     // MIs[0] Op2
     /* 183237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 183245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1355:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 183245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 183248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183254 */     GIR_RootConstrainSelectedInstOperands,
     /* 183255 */     // GIR_Coverage, 3528,
     /* 183255 */     GIR_EraseRootFromParent_Done,
     /* 183256 */   // Label 3367: @183256
     /* 183256 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(183298), // Rule ID 3529 //
     /* 183261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183279 */     // MIs[0] Op2
     /* 183279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1355:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183296 */     GIR_RootConstrainSelectedInstOperands,
     /* 183297 */     // GIR_Coverage, 3529,
     /* 183297 */     GIR_EraseRootFromParent_Done,
     /* 183298 */   // Label 3368: @183298
     /* 183298 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(183340), // Rule ID 3530 //
     /* 183303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183321 */     // MIs[0] Op2
     /* 183321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1355:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183338 */     GIR_RootConstrainSelectedInstOperands,
     /* 183339 */     // GIR_Coverage, 3530,
     /* 183339 */     GIR_EraseRootFromParent_Done,
     /* 183340 */   // Label 3369: @183340
     /* 183340 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(183382), // Rule ID 3531 //
     /* 183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183363 */     // MIs[0] Op2
     /* 183363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183371 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1355:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183380 */     GIR_RootConstrainSelectedInstOperands,
     /* 183381 */     // GIR_Coverage, 3531,
     /* 183381 */     GIR_EraseRootFromParent_Done,
     /* 183382 */   // Label 3370: @183382
     /* 183382 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(183424), // Rule ID 3532 //
     /* 183387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183405 */     // MIs[0] Op2
     /* 183405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183413 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183422 */     GIR_RootConstrainSelectedInstOperands,
     /* 183423 */     // GIR_Coverage, 3532,
     /* 183423 */     GIR_EraseRootFromParent_Done,
     /* 183424 */   // Label 3371: @183424
     /* 183424 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(183466), // Rule ID 3533 //
     /* 183429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183447 */     // MIs[0] Op2
     /* 183447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183464 */     GIR_RootConstrainSelectedInstOperands,
     /* 183465 */     // GIR_Coverage, 3533,
     /* 183465 */     GIR_EraseRootFromParent_Done,
     /* 183466 */   // Label 3372: @183466
     /* 183466 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(183508), // Rule ID 3534 //
     /* 183471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183489 */     // MIs[0] Op2
     /* 183489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183497 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183506 */     GIR_RootConstrainSelectedInstOperands,
     /* 183507 */     // GIR_Coverage, 3534,
     /* 183507 */     GIR_EraseRootFromParent_Done,
     /* 183508 */   // Label 3373: @183508
     /* 183508 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(183550), // Rule ID 11826 //
     /* 183513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183531 */     // MIs[0] Op2
     /* 183531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 183542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183548 */     GIR_RootConstrainSelectedInstOperands,
     /* 183549 */     // GIR_Coverage, 11826,
     /* 183549 */     GIR_EraseRootFromParent_Done,
     /* 183550 */   // Label 3374: @183550
     /* 183550 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(183592), // Rule ID 11827 //
     /* 183555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183573 */     // MIs[0] Op2
     /* 183573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 183584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183590 */     GIR_RootConstrainSelectedInstOperands,
     /* 183591 */     // GIR_Coverage, 11827,
     /* 183591 */     GIR_EraseRootFromParent_Done,
     /* 183592 */   // Label 3375: @183592
     /* 183592 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(183634), // Rule ID 11828 //
     /* 183597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183615 */     // MIs[0] Op2
     /* 183615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 183626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183632 */     GIR_RootConstrainSelectedInstOperands,
     /* 183633 */     // GIR_Coverage, 11828,
     /* 183633 */     GIR_EraseRootFromParent_Done,
     /* 183634 */   // Label 3376: @183634
     /* 183634 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(183676), // Rule ID 11829 //
     /* 183639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183657 */     // MIs[0] Op2
     /* 183657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 183668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183674 */     GIR_RootConstrainSelectedInstOperands,
     /* 183675 */     // GIR_Coverage, 11829,
     /* 183675 */     GIR_EraseRootFromParent_Done,
     /* 183676 */   // Label 3377: @183676
     /* 183676 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(183718), // Rule ID 11830 //
     /* 183681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183699 */     // MIs[0] Op2
     /* 183699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 183710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183716 */     GIR_RootConstrainSelectedInstOperands,
     /* 183717 */     // GIR_Coverage, 11830,
     /* 183717 */     GIR_EraseRootFromParent_Done,
     /* 183718 */   // Label 3378: @183718
     /* 183718 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(183760), // Rule ID 11831 //
     /* 183723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183741 */     // MIs[0] Op2
     /* 183741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 183752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183758 */     GIR_RootConstrainSelectedInstOperands,
     /* 183759 */     // GIR_Coverage, 11831,
     /* 183759 */     GIR_EraseRootFromParent_Done,
     /* 183760 */   // Label 3379: @183760
     /* 183760 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(183802), // Rule ID 11833 //
     /* 183765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183783 */     // MIs[0] Op2
     /* 183783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183791 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 183794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183800 */     GIR_RootConstrainSelectedInstOperands,
     /* 183801 */     // GIR_Coverage, 11833,
     /* 183801 */     GIR_EraseRootFromParent_Done,
     /* 183802 */   // Label 3380: @183802
     /* 183802 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(183844), // Rule ID 11835 //
     /* 183807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183825 */     // MIs[0] Op2
     /* 183825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183833 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 183836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183842 */     GIR_RootConstrainSelectedInstOperands,
     /* 183843 */     // GIR_Coverage, 11835,
     /* 183843 */     GIR_EraseRootFromParent_Done,
     /* 183844 */   // Label 3381: @183844
     /* 183844 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(183886), // Rule ID 11837 //
     /* 183849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183867 */     // MIs[0] Op2
     /* 183867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 183878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183884 */     GIR_RootConstrainSelectedInstOperands,
     /* 183885 */     // GIR_Coverage, 11837,
     /* 183885 */     GIR_EraseRootFromParent_Done,
     /* 183886 */   // Label 3382: @183886
     /* 183886 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(183928), // Rule ID 11838 //
     /* 183891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183909 */     // MIs[0] Op2
     /* 183909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 183920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183926 */     GIR_RootConstrainSelectedInstOperands,
     /* 183927 */     // GIR_Coverage, 11838,
     /* 183927 */     GIR_EraseRootFromParent_Done,
     /* 183928 */   // Label 3383: @183928
     /* 183928 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(183970), // Rule ID 11839 //
     /* 183933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183951 */     // MIs[0] Op2
     /* 183951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 183962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183968 */     GIR_RootConstrainSelectedInstOperands,
     /* 183969 */     // GIR_Coverage, 11839,
     /* 183969 */     GIR_EraseRootFromParent_Done,
     /* 183970 */   // Label 3384: @183970
     /* 183970 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(184012), // Rule ID 11840 //
     /* 183975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183993 */     // MIs[0] Op2
     /* 183993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 184004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184010 */     GIR_RootConstrainSelectedInstOperands,
     /* 184011 */     // GIR_Coverage, 11840,
     /* 184011 */     GIR_EraseRootFromParent_Done,
     /* 184012 */   // Label 3385: @184012
     /* 184012 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(184054), // Rule ID 11841 //
     /* 184017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184035 */     // MIs[0] Op2
     /* 184035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 184046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184052 */     GIR_RootConstrainSelectedInstOperands,
     /* 184053 */     // GIR_Coverage, 11841,
     /* 184053 */     GIR_EraseRootFromParent_Done,
     /* 184054 */   // Label 3386: @184054
     /* 184054 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(184096), // Rule ID 11842 //
     /* 184059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184077 */     // MIs[0] Op2
     /* 184077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 184088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184094 */     GIR_RootConstrainSelectedInstOperands,
     /* 184095 */     // GIR_Coverage, 11842,
     /* 184095 */     GIR_EraseRootFromParent_Done,
     /* 184096 */   // Label 3387: @184096
     /* 184096 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(184138), // Rule ID 11843 //
     /* 184101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184119 */     // MIs[0] Op2
     /* 184119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 184130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184136 */     GIR_RootConstrainSelectedInstOperands,
     /* 184137 */     // GIR_Coverage, 11843,
     /* 184137 */     GIR_EraseRootFromParent_Done,
     /* 184138 */   // Label 3388: @184138
     /* 184138 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(184180), // Rule ID 11844 //
     /* 184143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184161 */     // MIs[0] Op2
     /* 184161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 184172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184178 */     GIR_RootConstrainSelectedInstOperands,
     /* 184179 */     // GIR_Coverage, 11844,
     /* 184179 */     GIR_EraseRootFromParent_Done,
     /* 184180 */   // Label 3389: @184180
     /* 184180 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(184222), // Rule ID 11845 //
     /* 184185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184203 */     // MIs[0] Op2
     /* 184203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 184214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184220 */     GIR_RootConstrainSelectedInstOperands,
     /* 184221 */     // GIR_Coverage, 11845,
     /* 184221 */     GIR_EraseRootFromParent_Done,
     /* 184222 */   // Label 3390: @184222
     /* 184222 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(184264), // Rule ID 11846 //
     /* 184227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184245 */     // MIs[0] Op2
     /* 184245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 184256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184262 */     GIR_RootConstrainSelectedInstOperands,
     /* 184263 */     // GIR_Coverage, 11846,
     /* 184263 */     GIR_EraseRootFromParent_Done,
     /* 184264 */   // Label 3391: @184264
     /* 184264 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(184306), // Rule ID 11847 //
     /* 184269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184287 */     // MIs[0] Op2
     /* 184287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 184298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184304 */     GIR_RootConstrainSelectedInstOperands,
     /* 184305 */     // GIR_Coverage, 11847,
     /* 184305 */     GIR_EraseRootFromParent_Done,
     /* 184306 */   // Label 3392: @184306
     /* 184306 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(184348), // Rule ID 11848 //
     /* 184311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184329 */     // MIs[0] Op2
     /* 184329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 184340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184346 */     GIR_RootConstrainSelectedInstOperands,
     /* 184347 */     // GIR_Coverage, 11848,
     /* 184347 */     GIR_EraseRootFromParent_Done,
     /* 184348 */   // Label 3393: @184348
     /* 184348 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(184390), // Rule ID 11849 //
     /* 184353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184371 */     // MIs[0] Op2
     /* 184371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 184382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184388 */     GIR_RootConstrainSelectedInstOperands,
     /* 184389 */     // GIR_Coverage, 11849,
     /* 184389 */     GIR_EraseRootFromParent_Done,
     /* 184390 */   // Label 3394: @184390
     /* 184390 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(184432), // Rule ID 11907 //
     /* 184395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184413 */     // MIs[0] Op2
     /* 184413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 184424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184430 */     GIR_RootConstrainSelectedInstOperands,
     /* 184431 */     // GIR_Coverage, 11907,
     /* 184431 */     GIR_EraseRootFromParent_Done,
     /* 184432 */   // Label 3395: @184432
     /* 184432 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(184474), // Rule ID 11908 //
     /* 184437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184455 */     // MIs[0] Op2
     /* 184455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 184466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184472 */     GIR_RootConstrainSelectedInstOperands,
     /* 184473 */     // GIR_Coverage, 11908,
     /* 184473 */     GIR_EraseRootFromParent_Done,
     /* 184474 */   // Label 3396: @184474
     /* 184474 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(184516), // Rule ID 11909 //
     /* 184479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184497 */     // MIs[0] Op2
     /* 184497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 184508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184514 */     GIR_RootConstrainSelectedInstOperands,
     /* 184515 */     // GIR_Coverage, 11909,
     /* 184515 */     GIR_EraseRootFromParent_Done,
     /* 184516 */   // Label 3397: @184516
     /* 184516 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(184558), // Rule ID 11910 //
     /* 184521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184539 */     // MIs[0] Op2
     /* 184539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 184550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184556 */     GIR_RootConstrainSelectedInstOperands,
     /* 184557 */     // GIR_Coverage, 11910,
     /* 184557 */     GIR_EraseRootFromParent_Done,
     /* 184558 */   // Label 3398: @184558
     /* 184558 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(184600), // Rule ID 11911 //
     /* 184563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184581 */     // MIs[0] Op2
     /* 184581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 184592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184598 */     GIR_RootConstrainSelectedInstOperands,
     /* 184599 */     // GIR_Coverage, 11911,
     /* 184599 */     GIR_EraseRootFromParent_Done,
     /* 184600 */   // Label 3399: @184600
     /* 184600 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(184642), // Rule ID 11912 //
     /* 184605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184623 */     // MIs[0] Op2
     /* 184623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 184634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184640 */     GIR_RootConstrainSelectedInstOperands,
     /* 184641 */     // GIR_Coverage, 11912,
     /* 184641 */     GIR_EraseRootFromParent_Done,
     /* 184642 */   // Label 3400: @184642
     /* 184642 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(184684), // Rule ID 11913 //
     /* 184647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184665 */     // MIs[0] Op2
     /* 184665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 184676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184682 */     GIR_RootConstrainSelectedInstOperands,
     /* 184683 */     // GIR_Coverage, 11913,
     /* 184683 */     GIR_EraseRootFromParent_Done,
     /* 184684 */   // Label 3401: @184684
     /* 184684 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(184726), // Rule ID 11914 //
     /* 184689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184707 */     // MIs[0] Op2
     /* 184707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 184718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184724 */     GIR_RootConstrainSelectedInstOperands,
     /* 184725 */     // GIR_Coverage, 11914,
     /* 184725 */     GIR_EraseRootFromParent_Done,
     /* 184726 */   // Label 3402: @184726
     /* 184726 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(184768), // Rule ID 11915 //
     /* 184731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184749 */     // MIs[0] Op2
     /* 184749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 184760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184766 */     GIR_RootConstrainSelectedInstOperands,
     /* 184767 */     // GIR_Coverage, 11915,
     /* 184767 */     GIR_EraseRootFromParent_Done,
     /* 184768 */   // Label 3403: @184768
     /* 184768 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(184820), // Rule ID 2132 //
     /* 184773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 184784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 184787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184806 */     // MIs[1] Operand 1
     /* 184806 */     // No operand predicates
     /* 184806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184808 */     // (intrinsic_wo_chain:{ *:[v4i16] } 772:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 184811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184818 */     GIR_RootConstrainSelectedInstOperands,
     /* 184819 */     // GIR_Coverage, 2132,
     /* 184819 */     GIR_EraseRootFromParent_Done,
     /* 184820 */   // Label 3404: @184820
     /* 184820 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(184872), // Rule ID 2133 //
     /* 184825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 184836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184858 */     // MIs[1] Operand 1
     /* 184858 */     // No operand predicates
     /* 184858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184860 */     // (intrinsic_wo_chain:{ *:[v8i16] } 772:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 184863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184870 */     GIR_RootConstrainSelectedInstOperands,
     /* 184871 */     // GIR_Coverage, 2133,
     /* 184871 */     GIR_EraseRootFromParent_Done,
     /* 184872 */   // Label 3405: @184872
     /* 184872 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(184924), // Rule ID 2134 //
     /* 184877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 184888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 184891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184910 */     // MIs[1] Operand 1
     /* 184910 */     // No operand predicates
     /* 184910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184912 */     // (intrinsic_wo_chain:{ *:[v2i32] } 772:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 184915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184922 */     GIR_RootConstrainSelectedInstOperands,
     /* 184923 */     // GIR_Coverage, 2134,
     /* 184923 */     GIR_EraseRootFromParent_Done,
     /* 184924 */   // Label 3406: @184924
     /* 184924 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(184976), // Rule ID 2135 //
     /* 184929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 184940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 184943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184962 */     // MIs[1] Operand 1
     /* 184962 */     // No operand predicates
     /* 184962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184964 */     // (intrinsic_wo_chain:{ *:[v4i32] } 772:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 184967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184974 */     GIR_RootConstrainSelectedInstOperands,
     /* 184975 */     // GIR_Coverage, 2135,
     /* 184975 */     GIR_EraseRootFromParent_Done,
     /* 184976 */   // Label 3407: @184976
     /* 184976 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(185028), // Rule ID 2136 //
     /* 184981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 184992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 184995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185014 */     // MIs[1] Operand 1
     /* 185014 */     // No operand predicates
     /* 185014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185016 */     // (intrinsic_wo_chain:{ *:[v2i64] } 772:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 185019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185026 */     GIR_RootConstrainSelectedInstOperands,
     /* 185027 */     // GIR_Coverage, 2136,
     /* 185027 */     GIR_EraseRootFromParent_Done,
     /* 185028 */   // Label 3408: @185028
     /* 185028 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(185080), // Rule ID 2137 //
     /* 185033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185066 */     // MIs[1] Operand 1
     /* 185066 */     // No operand predicates
     /* 185066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185068 */     // (intrinsic_wo_chain:{ *:[v4i16] } 773:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 185071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185078 */     GIR_RootConstrainSelectedInstOperands,
     /* 185079 */     // GIR_Coverage, 2137,
     /* 185079 */     GIR_EraseRootFromParent_Done,
     /* 185080 */   // Label 3409: @185080
     /* 185080 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(185132), // Rule ID 2138 //
     /* 185085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185118 */     // MIs[1] Operand 1
     /* 185118 */     // No operand predicates
     /* 185118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 773:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 185123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185130 */     GIR_RootConstrainSelectedInstOperands,
     /* 185131 */     // GIR_Coverage, 2138,
     /* 185131 */     GIR_EraseRootFromParent_Done,
     /* 185132 */   // Label 3410: @185132
     /* 185132 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(185184), // Rule ID 2139 //
     /* 185137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185170 */     // MIs[1] Operand 1
     /* 185170 */     // No operand predicates
     /* 185170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185172 */     // (intrinsic_wo_chain:{ *:[v2i32] } 773:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 185175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185182 */     GIR_RootConstrainSelectedInstOperands,
     /* 185183 */     // GIR_Coverage, 2139,
     /* 185183 */     GIR_EraseRootFromParent_Done,
     /* 185184 */   // Label 3411: @185184
     /* 185184 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(185236), // Rule ID 2140 //
     /* 185189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185222 */     // MIs[1] Operand 1
     /* 185222 */     // No operand predicates
     /* 185222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185224 */     // (intrinsic_wo_chain:{ *:[v4i32] } 773:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 185227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185234 */     GIR_RootConstrainSelectedInstOperands,
     /* 185235 */     // GIR_Coverage, 2140,
     /* 185235 */     GIR_EraseRootFromParent_Done,
     /* 185236 */   // Label 3412: @185236
     /* 185236 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(185288), // Rule ID 2141 //
     /* 185241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185274 */     // MIs[1] Operand 1
     /* 185274 */     // No operand predicates
     /* 185274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185276 */     // (intrinsic_wo_chain:{ *:[v2i64] } 773:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 185279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185286 */     GIR_RootConstrainSelectedInstOperands,
     /* 185287 */     // GIR_Coverage, 2141,
     /* 185287 */     GIR_EraseRootFromParent_Done,
     /* 185288 */   // Label 3413: @185288
     /* 185288 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(185340), // Rule ID 2142 //
     /* 185293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185326 */     // MIs[1] Operand 1
     /* 185326 */     // No operand predicates
     /* 185326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185328 */     // (intrinsic_wo_chain:{ *:[v4f16] } 775:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 185331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185338 */     GIR_RootConstrainSelectedInstOperands,
     /* 185339 */     // GIR_Coverage, 2142,
     /* 185339 */     GIR_EraseRootFromParent_Done,
     /* 185340 */   // Label 3414: @185340
     /* 185340 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(185392), // Rule ID 2143 //
     /* 185345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185378 */     // MIs[1] Operand 1
     /* 185378 */     // No operand predicates
     /* 185378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185380 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 185383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185390 */     GIR_RootConstrainSelectedInstOperands,
     /* 185391 */     // GIR_Coverage, 2143,
     /* 185391 */     GIR_EraseRootFromParent_Done,
     /* 185392 */   // Label 3415: @185392
     /* 185392 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(185444), // Rule ID 2144 //
     /* 185397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185430 */     // MIs[1] Operand 1
     /* 185430 */     // No operand predicates
     /* 185430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185432 */     // (intrinsic_wo_chain:{ *:[v2f32] } 775:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 185435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185442 */     GIR_RootConstrainSelectedInstOperands,
     /* 185443 */     // GIR_Coverage, 2144,
     /* 185443 */     GIR_EraseRootFromParent_Done,
     /* 185444 */   // Label 3416: @185444
     /* 185444 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(185496), // Rule ID 2145 //
     /* 185449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185482 */     // MIs[1] Operand 1
     /* 185482 */     // No operand predicates
     /* 185482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185484 */     // (intrinsic_wo_chain:{ *:[v4f32] } 775:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 185487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185494 */     GIR_RootConstrainSelectedInstOperands,
     /* 185495 */     // GIR_Coverage, 2145,
     /* 185495 */     GIR_EraseRootFromParent_Done,
     /* 185496 */   // Label 3417: @185496
     /* 185496 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(185548), // Rule ID 2146 //
     /* 185501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185534 */     // MIs[1] Operand 1
     /* 185534 */     // No operand predicates
     /* 185534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185536 */     // (intrinsic_wo_chain:{ *:[v2f64] } 775:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 185539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185546 */     GIR_RootConstrainSelectedInstOperands,
     /* 185547 */     // GIR_Coverage, 2146,
     /* 185547 */     GIR_EraseRootFromParent_Done,
     /* 185548 */   // Label 3418: @185548
     /* 185548 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(185600), // Rule ID 2244 //
     /* 185553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185586 */     // MIs[1] Operand 1
     /* 185586 */     // No operand predicates
     /* 185586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185588 */     // (intrinsic_wo_chain:{ *:[v4f16] } 776:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 185591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185598 */     GIR_RootConstrainSelectedInstOperands,
     /* 185599 */     // GIR_Coverage, 2244,
     /* 185599 */     GIR_EraseRootFromParent_Done,
     /* 185600 */   // Label 3419: @185600
     /* 185600 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(185652), // Rule ID 2245 //
     /* 185605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185638 */     // MIs[1] Operand 1
     /* 185638 */     // No operand predicates
     /* 185638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185640 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 185643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185650 */     GIR_RootConstrainSelectedInstOperands,
     /* 185651 */     // GIR_Coverage, 2245,
     /* 185651 */     GIR_EraseRootFromParent_Done,
     /* 185652 */   // Label 3420: @185652
     /* 185652 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(185704), // Rule ID 2246 //
     /* 185657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185690 */     // MIs[1] Operand 1
     /* 185690 */     // No operand predicates
     /* 185690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185692 */     // (intrinsic_wo_chain:{ *:[v2f32] } 776:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 185695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185702 */     GIR_RootConstrainSelectedInstOperands,
     /* 185703 */     // GIR_Coverage, 2246,
     /* 185703 */     GIR_EraseRootFromParent_Done,
     /* 185704 */   // Label 3421: @185704
     /* 185704 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(185756), // Rule ID 2247 //
     /* 185709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185742 */     // MIs[1] Operand 1
     /* 185742 */     // No operand predicates
     /* 185742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185744 */     // (intrinsic_wo_chain:{ *:[v4f32] } 776:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 185747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185754 */     GIR_RootConstrainSelectedInstOperands,
     /* 185755 */     // GIR_Coverage, 2247,
     /* 185755 */     GIR_EraseRootFromParent_Done,
     /* 185756 */   // Label 3422: @185756
     /* 185756 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(185808), // Rule ID 2248 //
     /* 185761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185794 */     // MIs[1] Operand 1
     /* 185794 */     // No operand predicates
     /* 185794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185796 */     // (intrinsic_wo_chain:{ *:[v2f64] } 776:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 185799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185806 */     GIR_RootConstrainSelectedInstOperands,
     /* 185807 */     // GIR_Coverage, 2248,
     /* 185807 */     GIR_EraseRootFromParent_Done,
     /* 185808 */   // Label 3423: @185808
     /* 185808 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(185853), // Rule ID 63 //
     /* 185813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 185816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 185821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 185842 */     // (intrinsic_wo_chain:{ *:[i64] } 301:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 185842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 185845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185851 */     GIR_RootConstrainSelectedInstOperands,
     /* 185852 */     // GIR_Coverage, 63,
     /* 185852 */     GIR_EraseRootFromParent_Done,
     /* 185853 */   // Label 3424: @185853
     /* 185853 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(185898), // Rule ID 129 //
     /* 185858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 185866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185887 */     // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 185890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185896 */     GIR_RootConstrainSelectedInstOperands,
     /* 185897 */     // GIR_Coverage, 129,
     /* 185897 */     GIR_EraseRootFromParent_Done,
     /* 185898 */   // Label 3425: @185898
     /* 185898 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(185943), // Rule ID 130 //
     /* 185903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 185911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185932 */     // (intrinsic_wo_chain:{ *:[i32] } 518:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 185935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185941 */     GIR_RootConstrainSelectedInstOperands,
     /* 185942 */     // GIR_Coverage, 130,
     /* 185942 */     GIR_EraseRootFromParent_Done,
     /* 185943 */   // Label 3426: @185943
     /* 185943 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(185988), // Rule ID 131 //
     /* 185948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 185956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185977 */     // (intrinsic_wo_chain:{ *:[i32] } 519:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 185980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185986 */     GIR_RootConstrainSelectedInstOperands,
     /* 185987 */     // GIR_Coverage, 131,
     /* 185987 */     GIR_EraseRootFromParent_Done,
     /* 185988 */   // Label 3427: @185988
     /* 185988 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(186033), // Rule ID 132 //
     /* 185993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 186001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186022 */     // (intrinsic_wo_chain:{ *:[i32] } 520:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 186025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186031 */     GIR_RootConstrainSelectedInstOperands,
     /* 186032 */     // GIR_Coverage, 132,
     /* 186032 */     GIR_EraseRootFromParent_Done,
     /* 186033 */   // Label 3428: @186033
     /* 186033 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(186078), // Rule ID 133 //
     /* 186038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 186046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186067 */     // (intrinsic_wo_chain:{ *:[i32] } 514:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 186070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186076 */     GIR_RootConstrainSelectedInstOperands,
     /* 186077 */     // GIR_Coverage, 133,
     /* 186077 */     GIR_EraseRootFromParent_Done,
     /* 186078 */   // Label 3429: @186078
     /* 186078 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(186123), // Rule ID 134 //
     /* 186083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 186091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186112 */     // (intrinsic_wo_chain:{ *:[i32] } 515:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 186115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186121 */     GIR_RootConstrainSelectedInstOperands,
     /* 186122 */     // GIR_Coverage, 134,
     /* 186122 */     GIR_EraseRootFromParent_Done,
     /* 186123 */   // Label 3430: @186123
     /* 186123 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(186168), // Rule ID 135 //
     /* 186128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 186136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186157 */     // (intrinsic_wo_chain:{ *:[i32] } 516:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 186160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186166 */     GIR_RootConstrainSelectedInstOperands,
     /* 186167 */     // GIR_Coverage, 135,
     /* 186167 */     GIR_EraseRootFromParent_Done,
     /* 186168 */   // Label 3431: @186168
     /* 186168 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(186213), // Rule ID 136 //
     /* 186173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 186181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186202 */     // (intrinsic_wo_chain:{ *:[i32] } 517:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 186205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186211 */     GIR_RootConstrainSelectedInstOperands,
     /* 186212 */     // GIR_Coverage, 136,
     /* 186212 */     GIR_EraseRootFromParent_Done,
     /* 186213 */   // Label 3432: @186213
     /* 186213 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(186258), // Rule ID 1042 //
     /* 186218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186247 */     // (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 186250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186256 */     GIR_RootConstrainSelectedInstOperands,
     /* 186257 */     // GIR_Coverage, 1042,
     /* 186257 */     GIR_EraseRootFromParent_Done,
     /* 186258 */   // Label 3433: @186258
     /* 186258 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(186303), // Rule ID 1043 //
     /* 186263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 186295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186301 */     GIR_RootConstrainSelectedInstOperands,
     /* 186302 */     // GIR_Coverage, 1043,
     /* 186302 */     GIR_EraseRootFromParent_Done,
     /* 186303 */   // Label 3434: @186303
     /* 186303 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(186348), // Rule ID 1044 //
     /* 186308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186337 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 186337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 186340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186346 */     GIR_RootConstrainSelectedInstOperands,
     /* 186347 */     // GIR_Coverage, 1044,
     /* 186347 */     GIR_EraseRootFromParent_Done,
     /* 186348 */   // Label 3435: @186348
     /* 186348 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(186393), // Rule ID 1045 //
     /* 186353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186382 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 186382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 186385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186391 */     GIR_RootConstrainSelectedInstOperands,
     /* 186392 */     // GIR_Coverage, 1045,
     /* 186392 */     GIR_EraseRootFromParent_Done,
     /* 186393 */   // Label 3436: @186393
     /* 186393 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(186438), // Rule ID 1046 //
     /* 186398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186427 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 186427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 186430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186436 */     GIR_RootConstrainSelectedInstOperands,
     /* 186437 */     // GIR_Coverage, 1046,
     /* 186437 */     GIR_EraseRootFromParent_Done,
     /* 186438 */   // Label 3437: @186438
     /* 186438 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(186483), // Rule ID 1047 //
     /* 186443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 186472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 186475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186481 */     GIR_RootConstrainSelectedInstOperands,
     /* 186482 */     // GIR_Coverage, 1047,
     /* 186482 */     GIR_EraseRootFromParent_Done,
     /* 186483 */   // Label 3438: @186483
     /* 186483 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(186528), // Rule ID 1048 //
     /* 186488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186517 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 186517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 186520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186526 */     GIR_RootConstrainSelectedInstOperands,
     /* 186527 */     // GIR_Coverage, 1048,
     /* 186527 */     GIR_EraseRootFromParent_Done,
     /* 186528 */   // Label 3439: @186528
     /* 186528 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(186573), // Rule ID 1090 //
     /* 186533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186562 */     // (intrinsic_wo_chain:{ *:[v8i8] } 764:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 186565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186571 */     GIR_RootConstrainSelectedInstOperands,
     /* 186572 */     // GIR_Coverage, 1090,
     /* 186572 */     GIR_EraseRootFromParent_Done,
     /* 186573 */   // Label 3440: @186573
     /* 186573 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(186618), // Rule ID 1091 //
     /* 186578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186607 */     // (intrinsic_wo_chain:{ *:[v16i8] } 764:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 186610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186616 */     GIR_RootConstrainSelectedInstOperands,
     /* 186617 */     // GIR_Coverage, 1091,
     /* 186617 */     GIR_EraseRootFromParent_Done,
     /* 186618 */   // Label 3441: @186618
     /* 186618 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(186663), // Rule ID 1092 //
     /* 186623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186652 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 186652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 186655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186661 */     GIR_RootConstrainSelectedInstOperands,
     /* 186662 */     // GIR_Coverage, 1092,
     /* 186662 */     GIR_EraseRootFromParent_Done,
     /* 186663 */   // Label 3442: @186663
     /* 186663 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(186708), // Rule ID 1093 //
     /* 186668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186697 */     // (intrinsic_wo_chain:{ *:[v8i16] } 764:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 186697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 186700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186706 */     GIR_RootConstrainSelectedInstOperands,
     /* 186707 */     // GIR_Coverage, 1093,
     /* 186707 */     GIR_EraseRootFromParent_Done,
     /* 186708 */   // Label 3443: @186708
     /* 186708 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(186753), // Rule ID 1094 //
     /* 186713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186742 */     // (intrinsic_wo_chain:{ *:[v2i32] } 764:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 186742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 186745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186751 */     GIR_RootConstrainSelectedInstOperands,
     /* 186752 */     // GIR_Coverage, 1094,
     /* 186752 */     GIR_EraseRootFromParent_Done,
     /* 186753 */   // Label 3444: @186753
     /* 186753 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(186798), // Rule ID 1095 //
     /* 186758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 764:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 186787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 186790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186796 */     GIR_RootConstrainSelectedInstOperands,
     /* 186797 */     // GIR_Coverage, 1095,
     /* 186797 */     GIR_EraseRootFromParent_Done,
     /* 186798 */   // Label 3445: @186798
     /* 186798 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(186843), // Rule ID 1096 //
     /* 186803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186832 */     // (intrinsic_wo_chain:{ *:[v2i64] } 764:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 186832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 186835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186841 */     GIR_RootConstrainSelectedInstOperands,
     /* 186842 */     // GIR_Coverage, 1096,
     /* 186842 */     GIR_EraseRootFromParent_Done,
     /* 186843 */   // Label 3446: @186843
     /* 186843 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(186888), // Rule ID 1108 //
     /* 186848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186877 */     // (intrinsic_wo_chain:{ *:[v8i8] } 580:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 186877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 186880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186886 */     GIR_RootConstrainSelectedInstOperands,
     /* 186887 */     // GIR_Coverage, 1108,
     /* 186887 */     GIR_EraseRootFromParent_Done,
     /* 186888 */   // Label 3447: @186888
     /* 186888 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(186933), // Rule ID 1110 //
     /* 186893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186922 */     // (intrinsic_wo_chain:{ *:[v16i8] } 580:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 186922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 186925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186931 */     GIR_RootConstrainSelectedInstOperands,
     /* 186932 */     // GIR_Coverage, 1110,
     /* 186932 */     GIR_EraseRootFromParent_Done,
     /* 186933 */   // Label 3448: @186933
     /* 186933 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(186978), // Rule ID 1112 //
     /* 186938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186967 */     // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 186967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 186970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186976 */     GIR_RootConstrainSelectedInstOperands,
     /* 186977 */     // GIR_Coverage, 1112,
     /* 186977 */     GIR_EraseRootFromParent_Done,
     /* 186978 */   // Label 3449: @186978
     /* 186978 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(187023), // Rule ID 1114 //
     /* 186983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 580:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 187012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 187015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187021 */     GIR_RootConstrainSelectedInstOperands,
     /* 187022 */     // GIR_Coverage, 1114,
     /* 187022 */     GIR_EraseRootFromParent_Done,
     /* 187023 */   // Label 3450: @187023
     /* 187023 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(187068), // Rule ID 1116 //
     /* 187028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187057 */     // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 187057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 187060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187066 */     GIR_RootConstrainSelectedInstOperands,
     /* 187067 */     // GIR_Coverage, 1116,
     /* 187067 */     GIR_EraseRootFromParent_Done,
     /* 187068 */   // Label 3451: @187068
     /* 187068 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(187113), // Rule ID 1118 //
     /* 187073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187102 */     // (intrinsic_wo_chain:{ *:[v4i32] } 580:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 187102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 187105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187111 */     GIR_RootConstrainSelectedInstOperands,
     /* 187112 */     // GIR_Coverage, 1118,
     /* 187112 */     GIR_EraseRootFromParent_Done,
     /* 187113 */   // Label 3452: @187113
     /* 187113 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(187158), // Rule ID 1120 //
     /* 187118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187147 */     // (intrinsic_wo_chain:{ *:[v2i64] } 580:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 187147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 187150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187156 */     GIR_RootConstrainSelectedInstOperands,
     /* 187157 */     // GIR_Coverage, 1120,
     /* 187157 */     GIR_EraseRootFromParent_Done,
     /* 187158 */   // Label 3453: @187158
     /* 187158 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(187203), // Rule ID 1163 //
     /* 187163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187192 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 187195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187201 */     GIR_RootConstrainSelectedInstOperands,
     /* 187202 */     // GIR_Coverage, 1163,
     /* 187202 */     GIR_EraseRootFromParent_Done,
     /* 187203 */   // Label 3454: @187203
     /* 187203 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(187248), // Rule ID 1164 //
     /* 187208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187237 */     // (intrinsic_wo_chain:{ *:[v8f16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 187240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187246 */     GIR_RootConstrainSelectedInstOperands,
     /* 187247 */     // GIR_Coverage, 1164,
     /* 187247 */     GIR_EraseRootFromParent_Done,
     /* 187248 */   // Label 3455: @187248
     /* 187248 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(187293), // Rule ID 1165 //
     /* 187253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187282 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 187285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187291 */     GIR_RootConstrainSelectedInstOperands,
     /* 187292 */     // GIR_Coverage, 1165,
     /* 187292 */     GIR_EraseRootFromParent_Done,
     /* 187293 */   // Label 3456: @187293
     /* 187293 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(187338), // Rule ID 1166 //
     /* 187298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187327 */     // (intrinsic_wo_chain:{ *:[v4f32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 187330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187336 */     GIR_RootConstrainSelectedInstOperands,
     /* 187337 */     // GIR_Coverage, 1166,
     /* 187337 */     GIR_EraseRootFromParent_Done,
     /* 187338 */   // Label 3457: @187338
     /* 187338 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(187383), // Rule ID 1167 //
     /* 187343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187372 */     // (intrinsic_wo_chain:{ *:[v2f64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 187375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187381 */     GIR_RootConstrainSelectedInstOperands,
     /* 187382 */     // GIR_Coverage, 1167,
     /* 187382 */     GIR_EraseRootFromParent_Done,
     /* 187383 */   // Label 3458: @187383
     /* 187383 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(187428), // Rule ID 1169 //
     /* 187388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187417 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 187420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187426 */     GIR_RootConstrainSelectedInstOperands,
     /* 187427 */     // GIR_Coverage, 1169,
     /* 187427 */     GIR_EraseRootFromParent_Done,
     /* 187428 */   // Label 3459: @187428
     /* 187428 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(187473), // Rule ID 1171 //
     /* 187433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187462 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 187465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187471 */     GIR_RootConstrainSelectedInstOperands,
     /* 187472 */     // GIR_Coverage, 1171,
     /* 187472 */     GIR_EraseRootFromParent_Done,
     /* 187473 */   // Label 3460: @187473
     /* 187473 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(187518), // Rule ID 1173 //
     /* 187478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187507 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 187510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187516 */     GIR_RootConstrainSelectedInstOperands,
     /* 187517 */     // GIR_Coverage, 1173,
     /* 187517 */     GIR_EraseRootFromParent_Done,
     /* 187518 */   // Label 3461: @187518
     /* 187518 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(187563), // Rule ID 1175 //
     /* 187523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187552 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 187555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187561 */     GIR_RootConstrainSelectedInstOperands,
     /* 187562 */     // GIR_Coverage, 1175,
     /* 187562 */     GIR_EraseRootFromParent_Done,
     /* 187563 */   // Label 3462: @187563
     /* 187563 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(187608), // Rule ID 1177 //
     /* 187568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187597 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 187600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187606 */     GIR_RootConstrainSelectedInstOperands,
     /* 187607 */     // GIR_Coverage, 1177,
     /* 187607 */     GIR_EraseRootFromParent_Done,
     /* 187608 */   // Label 3463: @187608
     /* 187608 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(187653), // Rule ID 1179 //
     /* 187613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187642 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 187645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187651 */     GIR_RootConstrainSelectedInstOperands,
     /* 187652 */     // GIR_Coverage, 1179,
     /* 187652 */     GIR_EraseRootFromParent_Done,
     /* 187653 */   // Label 3464: @187653
     /* 187653 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(187698), // Rule ID 1181 //
     /* 187658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187687 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 187690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187696 */     GIR_RootConstrainSelectedInstOperands,
     /* 187697 */     // GIR_Coverage, 1181,
     /* 187697 */     GIR_EraseRootFromParent_Done,
     /* 187698 */   // Label 3465: @187698
     /* 187698 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(187743), // Rule ID 1183 //
     /* 187703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187732 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 187735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187741 */     GIR_RootConstrainSelectedInstOperands,
     /* 187742 */     // GIR_Coverage, 1183,
     /* 187742 */     GIR_EraseRootFromParent_Done,
     /* 187743 */   // Label 3466: @187743
     /* 187743 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(187788), // Rule ID 1185 //
     /* 187748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 187780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187786 */     GIR_RootConstrainSelectedInstOperands,
     /* 187787 */     // GIR_Coverage, 1185,
     /* 187787 */     GIR_EraseRootFromParent_Done,
     /* 187788 */   // Label 3467: @187788
     /* 187788 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(187833), // Rule ID 1187 //
     /* 187793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187822 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 187825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187831 */     GIR_RootConstrainSelectedInstOperands,
     /* 187832 */     // GIR_Coverage, 1187,
     /* 187832 */     GIR_EraseRootFromParent_Done,
     /* 187833 */   // Label 3468: @187833
     /* 187833 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(187878), // Rule ID 1189 //
     /* 187838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187867 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 187870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187876 */     GIR_RootConstrainSelectedInstOperands,
     /* 187877 */     // GIR_Coverage, 1189,
     /* 187877 */     GIR_EraseRootFromParent_Done,
     /* 187878 */   // Label 3469: @187878
     /* 187878 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(187923), // Rule ID 1191 //
     /* 187883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187912 */     // (intrinsic_wo_chain:{ *:[v8f16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 187915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187921 */     GIR_RootConstrainSelectedInstOperands,
     /* 187922 */     // GIR_Coverage, 1191,
     /* 187922 */     GIR_EraseRootFromParent_Done,
     /* 187923 */   // Label 3470: @187923
     /* 187923 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(187968), // Rule ID 1193 //
     /* 187928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187957 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 187960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187966 */     GIR_RootConstrainSelectedInstOperands,
     /* 187967 */     // GIR_Coverage, 1193,
     /* 187967 */     GIR_EraseRootFromParent_Done,
     /* 187968 */   // Label 3471: @187968
     /* 187968 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(188013), // Rule ID 1195 //
     /* 187973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188002 */     // (intrinsic_wo_chain:{ *:[v4f32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 188005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188011 */     GIR_RootConstrainSelectedInstOperands,
     /* 188012 */     // GIR_Coverage, 1195,
     /* 188012 */     GIR_EraseRootFromParent_Done,
     /* 188013 */   // Label 3472: @188013
     /* 188013 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(188058), // Rule ID 1197 //
     /* 188018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188047 */     // (intrinsic_wo_chain:{ *:[v2f64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 188050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188056 */     GIR_RootConstrainSelectedInstOperands,
     /* 188057 */     // GIR_Coverage, 1197,
     /* 188057 */     GIR_EraseRootFromParent_Done,
     /* 188058 */   // Label 3473: @188058
     /* 188058 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(188103), // Rule ID 1233 //
     /* 188063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188092 */     // (intrinsic_wo_chain:{ *:[v4f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 188095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188101 */     GIR_RootConstrainSelectedInstOperands,
     /* 188102 */     // GIR_Coverage, 1233,
     /* 188102 */     GIR_EraseRootFromParent_Done,
     /* 188103 */   // Label 3474: @188103
     /* 188103 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(188148), // Rule ID 1234 //
     /* 188108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188137 */     // (intrinsic_wo_chain:{ *:[v8f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 188140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188146 */     GIR_RootConstrainSelectedInstOperands,
     /* 188147 */     // GIR_Coverage, 1234,
     /* 188147 */     GIR_EraseRootFromParent_Done,
     /* 188148 */   // Label 3475: @188148
     /* 188148 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(188193), // Rule ID 1235 //
     /* 188153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188182 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 188185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188191 */     GIR_RootConstrainSelectedInstOperands,
     /* 188192 */     // GIR_Coverage, 1235,
     /* 188192 */     GIR_EraseRootFromParent_Done,
     /* 188193 */   // Label 3476: @188193
     /* 188193 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(188238), // Rule ID 1236 //
     /* 188198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188227 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 188230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188236 */     GIR_RootConstrainSelectedInstOperands,
     /* 188237 */     // GIR_Coverage, 1236,
     /* 188237 */     GIR_EraseRootFromParent_Done,
     /* 188238 */   // Label 3477: @188238
     /* 188238 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(188283), // Rule ID 1237 //
     /* 188243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188272 */     // (intrinsic_wo_chain:{ *:[v2f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 188275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188281 */     GIR_RootConstrainSelectedInstOperands,
     /* 188282 */     // GIR_Coverage, 1237,
     /* 188282 */     GIR_EraseRootFromParent_Done,
     /* 188283 */   // Label 3478: @188283
     /* 188283 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(188328), // Rule ID 1248 //
     /* 188288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188317 */     // (intrinsic_wo_chain:{ *:[v4f16] } 608:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 188320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188326 */     GIR_RootConstrainSelectedInstOperands,
     /* 188327 */     // GIR_Coverage, 1248,
     /* 188327 */     GIR_EraseRootFromParent_Done,
     /* 188328 */   // Label 3479: @188328
     /* 188328 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(188373), // Rule ID 1249 //
     /* 188333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188362 */     // (intrinsic_wo_chain:{ *:[v8f16] } 608:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 188365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188371 */     GIR_RootConstrainSelectedInstOperands,
     /* 188372 */     // GIR_Coverage, 1249,
     /* 188372 */     GIR_EraseRootFromParent_Done,
     /* 188373 */   // Label 3480: @188373
     /* 188373 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(188418), // Rule ID 1250 //
     /* 188378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188407 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 188410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188416 */     GIR_RootConstrainSelectedInstOperands,
     /* 188417 */     // GIR_Coverage, 1250,
     /* 188417 */     GIR_EraseRootFromParent_Done,
     /* 188418 */   // Label 3481: @188418
     /* 188418 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(188463), // Rule ID 1251 //
     /* 188423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188452 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 188455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188461 */     GIR_RootConstrainSelectedInstOperands,
     /* 188462 */     // GIR_Coverage, 1251,
     /* 188462 */     GIR_EraseRootFromParent_Done,
     /* 188463 */   // Label 3482: @188463
     /* 188463 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(188508), // Rule ID 1252 //
     /* 188468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188497 */     // (intrinsic_wo_chain:{ *:[v2f64] } 608:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 188500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188506 */     GIR_RootConstrainSelectedInstOperands,
     /* 188507 */     // GIR_Coverage, 1252,
     /* 188507 */     GIR_EraseRootFromParent_Done,
     /* 188508 */   // Label 3483: @188508
     /* 188508 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(188553), // Rule ID 1263 //
     /* 188513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188542 */     // (intrinsic_wo_chain:{ *:[v4f16] } 612:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 188545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188551 */     GIR_RootConstrainSelectedInstOperands,
     /* 188552 */     // GIR_Coverage, 1263,
     /* 188552 */     GIR_EraseRootFromParent_Done,
     /* 188553 */   // Label 3484: @188553
     /* 188553 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(188598), // Rule ID 1264 //
     /* 188558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188587 */     // (intrinsic_wo_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 188590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188596 */     GIR_RootConstrainSelectedInstOperands,
     /* 188597 */     // GIR_Coverage, 1264,
     /* 188597 */     GIR_EraseRootFromParent_Done,
     /* 188598 */   // Label 3485: @188598
     /* 188598 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(188643), // Rule ID 1265 //
     /* 188603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188632 */     // (intrinsic_wo_chain:{ *:[v2f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 188635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188641 */     GIR_RootConstrainSelectedInstOperands,
     /* 188642 */     // GIR_Coverage, 1265,
     /* 188642 */     GIR_EraseRootFromParent_Done,
     /* 188643 */   // Label 3486: @188643
     /* 188643 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(188688), // Rule ID 1266 //
     /* 188648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188677 */     // (intrinsic_wo_chain:{ *:[v4f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 188680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188686 */     GIR_RootConstrainSelectedInstOperands,
     /* 188687 */     // GIR_Coverage, 1266,
     /* 188687 */     GIR_EraseRootFromParent_Done,
     /* 188688 */   // Label 3487: @188688
     /* 188688 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(188733), // Rule ID 1267 //
     /* 188693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188722 */     // (intrinsic_wo_chain:{ *:[v2f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 188725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188731 */     GIR_RootConstrainSelectedInstOperands,
     /* 188732 */     // GIR_Coverage, 1267,
     /* 188732 */     GIR_EraseRootFromParent_Done,
     /* 188733 */   // Label 3488: @188733
     /* 188733 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(188778), // Rule ID 1278 //
     /* 188738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188767 */     // (intrinsic_wo_chain:{ *:[v4f16] } 614:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 188770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188776 */     GIR_RootConstrainSelectedInstOperands,
     /* 188777 */     // GIR_Coverage, 1278,
     /* 188777 */     GIR_EraseRootFromParent_Done,
     /* 188778 */   // Label 3489: @188778
     /* 188778 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(188823), // Rule ID 1279 //
     /* 188783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188812 */     // (intrinsic_wo_chain:{ *:[v8f16] } 614:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 188815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188821 */     GIR_RootConstrainSelectedInstOperands,
     /* 188822 */     // GIR_Coverage, 1279,
     /* 188822 */     GIR_EraseRootFromParent_Done,
     /* 188823 */   // Label 3490: @188823
     /* 188823 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(188868), // Rule ID 1280 //
     /* 188828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188857 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 188860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188866 */     GIR_RootConstrainSelectedInstOperands,
     /* 188867 */     // GIR_Coverage, 1280,
     /* 188867 */     GIR_EraseRootFromParent_Done,
     /* 188868 */   // Label 3491: @188868
     /* 188868 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(188913), // Rule ID 1281 //
     /* 188873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188902 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 188905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188911 */     GIR_RootConstrainSelectedInstOperands,
     /* 188912 */     // GIR_Coverage, 1281,
     /* 188912 */     GIR_EraseRootFromParent_Done,
     /* 188913 */   // Label 3492: @188913
     /* 188913 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(188958), // Rule ID 1282 //
     /* 188918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188947 */     // (intrinsic_wo_chain:{ *:[v2f64] } 614:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 188950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188956 */     GIR_RootConstrainSelectedInstOperands,
     /* 188957 */     // GIR_Coverage, 1282,
     /* 188957 */     GIR_EraseRootFromParent_Done,
     /* 188958 */   // Label 3493: @188958
     /* 188958 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(189003), // Rule ID 1313 //
     /* 188963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 188971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188992 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 188995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189001 */     GIR_RootConstrainSelectedInstOperands,
     /* 189002 */     // GIR_Coverage, 1313,
     /* 189002 */     GIR_EraseRootFromParent_Done,
     /* 189003 */   // Label 3494: @189003
     /* 189003 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(189048), // Rule ID 1314 //
     /* 189008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189037 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 189040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189046 */     GIR_RootConstrainSelectedInstOperands,
     /* 189047 */     // GIR_Coverage, 1314,
     /* 189047 */     GIR_EraseRootFromParent_Done,
     /* 189048 */   // Label 3495: @189048
     /* 189048 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(189093), // Rule ID 1315 //
     /* 189053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189082 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 189085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189091 */     GIR_RootConstrainSelectedInstOperands,
     /* 189092 */     // GIR_Coverage, 1315,
     /* 189092 */     GIR_EraseRootFromParent_Done,
     /* 189093 */   // Label 3496: @189093
     /* 189093 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(189138), // Rule ID 1316 //
     /* 189098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189127 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 189130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189136 */     GIR_RootConstrainSelectedInstOperands,
     /* 189137 */     // GIR_Coverage, 1316,
     /* 189137 */     GIR_EraseRootFromParent_Done,
     /* 189138 */   // Label 3497: @189138
     /* 189138 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(189183), // Rule ID 1317 //
     /* 189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189172 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 189175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189181 */     GIR_RootConstrainSelectedInstOperands,
     /* 189182 */     // GIR_Coverage, 1317,
     /* 189182 */     GIR_EraseRootFromParent_Done,
     /* 189183 */   // Label 3498: @189183
     /* 189183 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(189228), // Rule ID 1328 //
     /* 189188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189217 */     // (intrinsic_wo_chain:{ *:[v4f16] } 643:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 189220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189226 */     GIR_RootConstrainSelectedInstOperands,
     /* 189227 */     // GIR_Coverage, 1328,
     /* 189227 */     GIR_EraseRootFromParent_Done,
     /* 189228 */   // Label 3499: @189228
     /* 189228 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(189273), // Rule ID 1329 //
     /* 189233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189262 */     // (intrinsic_wo_chain:{ *:[v8f16] } 643:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 189265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189271 */     GIR_RootConstrainSelectedInstOperands,
     /* 189272 */     // GIR_Coverage, 1329,
     /* 189272 */     GIR_EraseRootFromParent_Done,
     /* 189273 */   // Label 3500: @189273
     /* 189273 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(189318), // Rule ID 1330 //
     /* 189278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189307 */     // (intrinsic_wo_chain:{ *:[v2f32] } 643:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 189310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189316 */     GIR_RootConstrainSelectedInstOperands,
     /* 189317 */     // GIR_Coverage, 1330,
     /* 189317 */     GIR_EraseRootFromParent_Done,
     /* 189318 */   // Label 3501: @189318
     /* 189318 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(189363), // Rule ID 1331 //
     /* 189323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189352 */     // (intrinsic_wo_chain:{ *:[v4f32] } 643:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 189355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189361 */     GIR_RootConstrainSelectedInstOperands,
     /* 189362 */     // GIR_Coverage, 1331,
     /* 189362 */     GIR_EraseRootFromParent_Done,
     /* 189363 */   // Label 3502: @189363
     /* 189363 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(189408), // Rule ID 1332 //
     /* 189368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189397 */     // (intrinsic_wo_chain:{ *:[v2f64] } 643:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 189400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189406 */     GIR_RootConstrainSelectedInstOperands,
     /* 189407 */     // GIR_Coverage, 1332,
     /* 189407 */     GIR_EraseRootFromParent_Done,
     /* 189408 */   // Label 3503: @189408
     /* 189408 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(189453), // Rule ID 1333 //
     /* 189413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189442 */     // (intrinsic_wo_chain:{ *:[v4f16] } 650:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 189445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189451 */     GIR_RootConstrainSelectedInstOperands,
     /* 189452 */     // GIR_Coverage, 1333,
     /* 189452 */     GIR_EraseRootFromParent_Done,
     /* 189453 */   // Label 3504: @189453
     /* 189453 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(189498), // Rule ID 1334 //
     /* 189458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189487 */     // (intrinsic_wo_chain:{ *:[v8f16] } 650:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 189490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189496 */     GIR_RootConstrainSelectedInstOperands,
     /* 189497 */     // GIR_Coverage, 1334,
     /* 189497 */     GIR_EraseRootFromParent_Done,
     /* 189498 */   // Label 3505: @189498
     /* 189498 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(189543), // Rule ID 1335 //
     /* 189503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189532 */     // (intrinsic_wo_chain:{ *:[v2f32] } 650:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 189535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189541 */     GIR_RootConstrainSelectedInstOperands,
     /* 189542 */     // GIR_Coverage, 1335,
     /* 189542 */     GIR_EraseRootFromParent_Done,
     /* 189543 */   // Label 3506: @189543
     /* 189543 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(189588), // Rule ID 1336 //
     /* 189548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189577 */     // (intrinsic_wo_chain:{ *:[v4f32] } 650:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 189580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189586 */     GIR_RootConstrainSelectedInstOperands,
     /* 189587 */     // GIR_Coverage, 1336,
     /* 189587 */     GIR_EraseRootFromParent_Done,
     /* 189588 */   // Label 3507: @189588
     /* 189588 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(189633), // Rule ID 1337 //
     /* 189593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189622 */     // (intrinsic_wo_chain:{ *:[v2f64] } 650:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 189625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189631 */     GIR_RootConstrainSelectedInstOperands,
     /* 189632 */     // GIR_Coverage, 1337,
     /* 189632 */     GIR_EraseRootFromParent_Done,
     /* 189633 */   // Label 3508: @189633
     /* 189633 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(189678), // Rule ID 1354 //
     /* 189638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 189646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189667 */     // (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 189670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189676 */     GIR_RootConstrainSelectedInstOperands,
     /* 189677 */     // GIR_Coverage, 1354,
     /* 189677 */     GIR_EraseRootFromParent_Done,
     /* 189678 */   // Label 3509: @189678
     /* 189678 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(189723), // Rule ID 1355 //
     /* 189683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 189691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189712 */     // (intrinsic_wo_chain:{ *:[v16i8] } 663:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 189715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189721 */     GIR_RootConstrainSelectedInstOperands,
     /* 189722 */     // GIR_Coverage, 1355,
     /* 189722 */     GIR_EraseRootFromParent_Done,
     /* 189723 */   // Label 3510: @189723
     /* 189723 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(189768), // Rule ID 1369 //
     /* 189728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189757 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 189760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189766 */     GIR_RootConstrainSelectedInstOperands,
     /* 189767 */     // GIR_Coverage, 1369,
     /* 189767 */     GIR_EraseRootFromParent_Done,
     /* 189768 */   // Label 3511: @189768
     /* 189768 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(189813), // Rule ID 1371 //
     /* 189773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189802 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 189805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189811 */     GIR_RootConstrainSelectedInstOperands,
     /* 189812 */     // GIR_Coverage, 1371,
     /* 189812 */     GIR_EraseRootFromParent_Done,
     /* 189813 */   // Label 3512: @189813
     /* 189813 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(189858), // Rule ID 1373 //
     /* 189818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189847 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 189850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189856 */     GIR_RootConstrainSelectedInstOperands,
     /* 189857 */     // GIR_Coverage, 1373,
     /* 189857 */     GIR_EraseRootFromParent_Done,
     /* 189858 */   // Label 3513: @189858
     /* 189858 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(189903), // Rule ID 1375 //
     /* 189863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189892 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 189895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189901 */     GIR_RootConstrainSelectedInstOperands,
     /* 189902 */     // GIR_Coverage, 1375,
     /* 189902 */     GIR_EraseRootFromParent_Done,
     /* 189903 */   // Label 3514: @189903
     /* 189903 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(189948), // Rule ID 1377 //
     /* 189908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189937 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 189940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189946 */     GIR_RootConstrainSelectedInstOperands,
     /* 189947 */     // GIR_Coverage, 1377,
     /* 189947 */     GIR_EraseRootFromParent_Done,
     /* 189948 */   // Label 3515: @189948
     /* 189948 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(189993), // Rule ID 1379 //
     /* 189953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189982 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 189985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189991 */     GIR_RootConstrainSelectedInstOperands,
     /* 189992 */     // GIR_Coverage, 1379,
     /* 189992 */     GIR_EraseRootFromParent_Done,
     /* 189993 */   // Label 3516: @189993
     /* 189993 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(190038), // Rule ID 1386 //
     /* 189998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190027 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 190030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190036 */     GIR_RootConstrainSelectedInstOperands,
     /* 190037 */     // GIR_Coverage, 1386,
     /* 190037 */     GIR_EraseRootFromParent_Done,
     /* 190038 */   // Label 3517: @190038
     /* 190038 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(190083), // Rule ID 1387 //
     /* 190043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190072 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 190075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190081 */     GIR_RootConstrainSelectedInstOperands,
     /* 190082 */     // GIR_Coverage, 1387,
     /* 190082 */     GIR_EraseRootFromParent_Done,
     /* 190083 */   // Label 3518: @190083
     /* 190083 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(190128), // Rule ID 1388 //
     /* 190088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190117 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 190120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190126 */     GIR_RootConstrainSelectedInstOperands,
     /* 190127 */     // GIR_Coverage, 1388,
     /* 190127 */     GIR_EraseRootFromParent_Done,
     /* 190128 */   // Label 3519: @190128
     /* 190128 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(190173), // Rule ID 1389 //
     /* 190133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190162 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 190165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190171 */     GIR_RootConstrainSelectedInstOperands,
     /* 190172 */     // GIR_Coverage, 1389,
     /* 190172 */     GIR_EraseRootFromParent_Done,
     /* 190173 */   // Label 3520: @190173
     /* 190173 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(190218), // Rule ID 1390 //
     /* 190178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190207 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 190210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190216 */     GIR_RootConstrainSelectedInstOperands,
     /* 190217 */     // GIR_Coverage, 1390,
     /* 190217 */     GIR_EraseRootFromParent_Done,
     /* 190218 */   // Label 3521: @190218
     /* 190218 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(190263), // Rule ID 1391 //
     /* 190223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190252 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 190255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190261 */     GIR_RootConstrainSelectedInstOperands,
     /* 190262 */     // GIR_Coverage, 1391,
     /* 190262 */     GIR_EraseRootFromParent_Done,
     /* 190263 */   // Label 3522: @190263
     /* 190263 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(190308), // Rule ID 1392 //
     /* 190268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190297 */     // (intrinsic_wo_chain:{ *:[v8i8] } 681:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 190300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190306 */     GIR_RootConstrainSelectedInstOperands,
     /* 190307 */     // GIR_Coverage, 1392,
     /* 190307 */     GIR_EraseRootFromParent_Done,
     /* 190308 */   // Label 3523: @190308
     /* 190308 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(190353), // Rule ID 1393 //
     /* 190313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190342 */     // (intrinsic_wo_chain:{ *:[v16i8] } 681:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 190345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190351 */     GIR_RootConstrainSelectedInstOperands,
     /* 190352 */     // GIR_Coverage, 1393,
     /* 190352 */     GIR_EraseRootFromParent_Done,
     /* 190353 */   // Label 3524: @190353
     /* 190353 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(190398), // Rule ID 1394 //
     /* 190358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190387 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 190390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190396 */     GIR_RootConstrainSelectedInstOperands,
     /* 190397 */     // GIR_Coverage, 1394,
     /* 190397 */     GIR_EraseRootFromParent_Done,
     /* 190398 */   // Label 3525: @190398
     /* 190398 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(190443), // Rule ID 1395 //
     /* 190403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 190435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190441 */     GIR_RootConstrainSelectedInstOperands,
     /* 190442 */     // GIR_Coverage, 1395,
     /* 190442 */     GIR_EraseRootFromParent_Done,
     /* 190443 */   // Label 3526: @190443
     /* 190443 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(190488), // Rule ID 1396 //
     /* 190448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190477 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 190480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190486 */     GIR_RootConstrainSelectedInstOperands,
     /* 190487 */     // GIR_Coverage, 1396,
     /* 190487 */     GIR_EraseRootFromParent_Done,
     /* 190488 */   // Label 3527: @190488
     /* 190488 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(190533), // Rule ID 1397 //
     /* 190493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190522 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 190525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190531 */     GIR_RootConstrainSelectedInstOperands,
     /* 190532 */     // GIR_Coverage, 1397,
     /* 190532 */     GIR_EraseRootFromParent_Done,
     /* 190533 */   // Label 3528: @190533
     /* 190533 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(190578), // Rule ID 1404 //
     /* 190538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190567 */     // (intrinsic_wo_chain:{ *:[v8i8] } 684:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 190570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190576 */     GIR_RootConstrainSelectedInstOperands,
     /* 190577 */     // GIR_Coverage, 1404,
     /* 190577 */     GIR_EraseRootFromParent_Done,
     /* 190578 */   // Label 3529: @190578
     /* 190578 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(190623), // Rule ID 1405 //
     /* 190583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190612 */     // (intrinsic_wo_chain:{ *:[v16i8] } 684:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 190615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190621 */     GIR_RootConstrainSelectedInstOperands,
     /* 190622 */     // GIR_Coverage, 1405,
     /* 190622 */     GIR_EraseRootFromParent_Done,
     /* 190623 */   // Label 3530: @190623
     /* 190623 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(190668), // Rule ID 1406 //
     /* 190628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190657 */     // (intrinsic_wo_chain:{ *:[v4i16] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 190660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190666 */     GIR_RootConstrainSelectedInstOperands,
     /* 190667 */     // GIR_Coverage, 1406,
     /* 190667 */     GIR_EraseRootFromParent_Done,
     /* 190668 */   // Label 3531: @190668
     /* 190668 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(190713), // Rule ID 1407 //
     /* 190673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190702 */     // (intrinsic_wo_chain:{ *:[v8i16] } 684:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 190705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190711 */     GIR_RootConstrainSelectedInstOperands,
     /* 190712 */     // GIR_Coverage, 1407,
     /* 190712 */     GIR_EraseRootFromParent_Done,
     /* 190713 */   // Label 3532: @190713
     /* 190713 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(190758), // Rule ID 1408 //
     /* 190718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190747 */     // (intrinsic_wo_chain:{ *:[v2i32] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 190750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190756 */     GIR_RootConstrainSelectedInstOperands,
     /* 190757 */     // GIR_Coverage, 1408,
     /* 190757 */     GIR_EraseRootFromParent_Done,
     /* 190758 */   // Label 3533: @190758
     /* 190758 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(190803), // Rule ID 1409 //
     /* 190763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190792 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 190795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190801 */     GIR_RootConstrainSelectedInstOperands,
     /* 190802 */     // GIR_Coverage, 1409,
     /* 190802 */     GIR_EraseRootFromParent_Done,
     /* 190803 */   // Label 3534: @190803
     /* 190803 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(190848), // Rule ID 1423 //
     /* 190808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190837 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 190840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190846 */     GIR_RootConstrainSelectedInstOperands,
     /* 190847 */     // GIR_Coverage, 1423,
     /* 190847 */     GIR_EraseRootFromParent_Done,
     /* 190848 */   // Label 3535: @190848
     /* 190848 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(190893), // Rule ID 1424 //
     /* 190853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190882 */     // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 190885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190891 */     GIR_RootConstrainSelectedInstOperands,
     /* 190892 */     // GIR_Coverage, 1424,
     /* 190892 */     GIR_EraseRootFromParent_Done,
     /* 190893 */   // Label 3536: @190893
     /* 190893 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(190938), // Rule ID 1425 //
     /* 190898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190927 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 190930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190936 */     GIR_RootConstrainSelectedInstOperands,
     /* 190937 */     // GIR_Coverage, 1425,
     /* 190937 */     GIR_EraseRootFromParent_Done,
     /* 190938 */   // Label 3537: @190938
     /* 190938 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(190983), // Rule ID 1426 //
     /* 190943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 190975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190981 */     GIR_RootConstrainSelectedInstOperands,
     /* 190982 */     // GIR_Coverage, 1426,
     /* 190982 */     GIR_EraseRootFromParent_Done,
     /* 190983 */   // Label 3538: @190983
     /* 190983 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(191028), // Rule ID 1427 //
     /* 190988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 190996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191017 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 191020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191026 */     GIR_RootConstrainSelectedInstOperands,
     /* 191027 */     // GIR_Coverage, 1427,
     /* 191027 */     GIR_EraseRootFromParent_Done,
     /* 191028 */   // Label 3539: @191028
     /* 191028 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(191073), // Rule ID 1428 //
     /* 191033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191062 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 191065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191071 */     GIR_RootConstrainSelectedInstOperands,
     /* 191072 */     // GIR_Coverage, 1428,
     /* 191072 */     GIR_EraseRootFromParent_Done,
     /* 191073 */   // Label 3540: @191073
     /* 191073 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(191118), // Rule ID 1429 //
     /* 191078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191107 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 191110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191116 */     GIR_RootConstrainSelectedInstOperands,
     /* 191117 */     // GIR_Coverage, 1429,
     /* 191117 */     GIR_EraseRootFromParent_Done,
     /* 191118 */   // Label 3541: @191118
     /* 191118 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(191163), // Rule ID 1430 //
     /* 191123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 191155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191161 */     GIR_RootConstrainSelectedInstOperands,
     /* 191162 */     // GIR_Coverage, 1430,
     /* 191162 */     GIR_EraseRootFromParent_Done,
     /* 191163 */   // Label 3542: @191163
     /* 191163 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(191208), // Rule ID 1431 //
     /* 191168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191197 */     // (intrinsic_wo_chain:{ *:[v8i8] } 701:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 191200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191206 */     GIR_RootConstrainSelectedInstOperands,
     /* 191207 */     // GIR_Coverage, 1431,
     /* 191207 */     GIR_EraseRootFromParent_Done,
     /* 191208 */   // Label 3543: @191208
     /* 191208 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(191253), // Rule ID 1432 //
     /* 191213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 701:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 191245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191251 */     GIR_RootConstrainSelectedInstOperands,
     /* 191252 */     // GIR_Coverage, 1432,
     /* 191252 */     GIR_EraseRootFromParent_Done,
     /* 191253 */   // Label 3544: @191253
     /* 191253 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(191298), // Rule ID 1433 //
     /* 191258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191287 */     // (intrinsic_wo_chain:{ *:[v4i16] } 701:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 191290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191296 */     GIR_RootConstrainSelectedInstOperands,
     /* 191297 */     // GIR_Coverage, 1433,
     /* 191297 */     GIR_EraseRootFromParent_Done,
     /* 191298 */   // Label 3545: @191298
     /* 191298 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(191343), // Rule ID 1434 //
     /* 191303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191332 */     // (intrinsic_wo_chain:{ *:[v8i16] } 701:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 191335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191341 */     GIR_RootConstrainSelectedInstOperands,
     /* 191342 */     // GIR_Coverage, 1434,
     /* 191342 */     GIR_EraseRootFromParent_Done,
     /* 191343 */   // Label 3546: @191343
     /* 191343 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(191388), // Rule ID 1435 //
     /* 191348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191377 */     // (intrinsic_wo_chain:{ *:[v2i32] } 701:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 191380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191386 */     GIR_RootConstrainSelectedInstOperands,
     /* 191387 */     // GIR_Coverage, 1435,
     /* 191387 */     GIR_EraseRootFromParent_Done,
     /* 191388 */   // Label 3547: @191388
     /* 191388 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(191433), // Rule ID 1436 //
     /* 191393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 701:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 191425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191431 */     GIR_RootConstrainSelectedInstOperands,
     /* 191432 */     // GIR_Coverage, 1436,
     /* 191432 */     GIR_EraseRootFromParent_Done,
     /* 191433 */   // Label 3548: @191433
     /* 191433 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(191478), // Rule ID 1437 //
     /* 191438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191467 */     // (intrinsic_wo_chain:{ *:[v2i64] } 701:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 191470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191476 */     GIR_RootConstrainSelectedInstOperands,
     /* 191477 */     // GIR_Coverage, 1437,
     /* 191477 */     GIR_EraseRootFromParent_Done,
     /* 191478 */   // Label 3549: @191478
     /* 191478 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(191523), // Rule ID 1438 //
     /* 191483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191512 */     // (intrinsic_wo_chain:{ *:[v8i8] } 704:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 191515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191521 */     GIR_RootConstrainSelectedInstOperands,
     /* 191522 */     // GIR_Coverage, 1438,
     /* 191522 */     GIR_EraseRootFromParent_Done,
     /* 191523 */   // Label 3550: @191523
     /* 191523 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(191568), // Rule ID 1439 //
     /* 191528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191557 */     // (intrinsic_wo_chain:{ *:[v16i8] } 704:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 191560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191566 */     GIR_RootConstrainSelectedInstOperands,
     /* 191567 */     // GIR_Coverage, 1439,
     /* 191567 */     GIR_EraseRootFromParent_Done,
     /* 191568 */   // Label 3551: @191568
     /* 191568 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(191613), // Rule ID 1440 //
     /* 191573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191602 */     // (intrinsic_wo_chain:{ *:[v4i16] } 704:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 191605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191611 */     GIR_RootConstrainSelectedInstOperands,
     /* 191612 */     // GIR_Coverage, 1440,
     /* 191612 */     GIR_EraseRootFromParent_Done,
     /* 191613 */   // Label 3552: @191613
     /* 191613 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(191658), // Rule ID 1441 //
     /* 191618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 704:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 191650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191656 */     GIR_RootConstrainSelectedInstOperands,
     /* 191657 */     // GIR_Coverage, 1441,
     /* 191657 */     GIR_EraseRootFromParent_Done,
     /* 191658 */   // Label 3553: @191658
     /* 191658 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(191703), // Rule ID 1442 //
     /* 191663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191692 */     // (intrinsic_wo_chain:{ *:[v2i32] } 704:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 191695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191701 */     GIR_RootConstrainSelectedInstOperands,
     /* 191702 */     // GIR_Coverage, 1442,
     /* 191702 */     GIR_EraseRootFromParent_Done,
     /* 191703 */   // Label 3554: @191703
     /* 191703 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(191748), // Rule ID 1443 //
     /* 191708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191737 */     // (intrinsic_wo_chain:{ *:[v4i32] } 704:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 191740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191746 */     GIR_RootConstrainSelectedInstOperands,
     /* 191747 */     // GIR_Coverage, 1443,
     /* 191747 */     GIR_EraseRootFromParent_Done,
     /* 191748 */   // Label 3555: @191748
     /* 191748 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(191793), // Rule ID 1444 //
     /* 191753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191782 */     // (intrinsic_wo_chain:{ *:[v2i64] } 704:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 191785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191791 */     GIR_RootConstrainSelectedInstOperands,
     /* 191792 */     // GIR_Coverage, 1444,
     /* 191792 */     GIR_EraseRootFromParent_Done,
     /* 191793 */   // Label 3556: @191793
     /* 191793 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(191838), // Rule ID 1458 //
     /* 191798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191827 */     // (intrinsic_wo_chain:{ *:[v8i8] } 712:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 191830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191836 */     GIR_RootConstrainSelectedInstOperands,
     /* 191837 */     // GIR_Coverage, 1458,
     /* 191837 */     GIR_EraseRootFromParent_Done,
     /* 191838 */   // Label 3557: @191838
     /* 191838 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(191883), // Rule ID 1459 //
     /* 191843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191872 */     // (intrinsic_wo_chain:{ *:[v16i8] } 712:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 191875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191881 */     GIR_RootConstrainSelectedInstOperands,
     /* 191882 */     // GIR_Coverage, 1459,
     /* 191882 */     GIR_EraseRootFromParent_Done,
     /* 191883 */   // Label 3558: @191883
     /* 191883 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(191928), // Rule ID 1460 //
     /* 191888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191917 */     // (intrinsic_wo_chain:{ *:[v4i16] } 712:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 191920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191926 */     GIR_RootConstrainSelectedInstOperands,
     /* 191927 */     // GIR_Coverage, 1460,
     /* 191927 */     GIR_EraseRootFromParent_Done,
     /* 191928 */   // Label 3559: @191928
     /* 191928 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(191973), // Rule ID 1461 //
     /* 191933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191962 */     // (intrinsic_wo_chain:{ *:[v8i16] } 712:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 191965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191971 */     GIR_RootConstrainSelectedInstOperands,
     /* 191972 */     // GIR_Coverage, 1461,
     /* 191972 */     GIR_EraseRootFromParent_Done,
     /* 191973 */   // Label 3560: @191973
     /* 191973 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(192018), // Rule ID 1462 //
     /* 191978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192007 */     // (intrinsic_wo_chain:{ *:[v2i32] } 712:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 192010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192016 */     GIR_RootConstrainSelectedInstOperands,
     /* 192017 */     // GIR_Coverage, 1462,
     /* 192017 */     GIR_EraseRootFromParent_Done,
     /* 192018 */   // Label 3561: @192018
     /* 192018 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(192063), // Rule ID 1463 //
     /* 192023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192052 */     // (intrinsic_wo_chain:{ *:[v4i32] } 712:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 192055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192061 */     GIR_RootConstrainSelectedInstOperands,
     /* 192062 */     // GIR_Coverage, 1463,
     /* 192062 */     GIR_EraseRootFromParent_Done,
     /* 192063 */   // Label 3562: @192063
     /* 192063 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(192108), // Rule ID 1464 //
     /* 192068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192097 */     // (intrinsic_wo_chain:{ *:[v2i64] } 712:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 192100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192106 */     GIR_RootConstrainSelectedInstOperands,
     /* 192107 */     // GIR_Coverage, 1464,
     /* 192107 */     GIR_EraseRootFromParent_Done,
     /* 192108 */   // Label 3563: @192108
     /* 192108 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(192153), // Rule ID 1465 //
     /* 192113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192142 */     // (intrinsic_wo_chain:{ *:[v8i8] } 713:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 192145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192151 */     GIR_RootConstrainSelectedInstOperands,
     /* 192152 */     // GIR_Coverage, 1465,
     /* 192152 */     GIR_EraseRootFromParent_Done,
     /* 192153 */   // Label 3564: @192153
     /* 192153 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(192198), // Rule ID 1466 //
     /* 192158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192187 */     // (intrinsic_wo_chain:{ *:[v16i8] } 713:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 192190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192196 */     GIR_RootConstrainSelectedInstOperands,
     /* 192197 */     // GIR_Coverage, 1466,
     /* 192197 */     GIR_EraseRootFromParent_Done,
     /* 192198 */   // Label 3565: @192198
     /* 192198 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(192243), // Rule ID 1467 //
     /* 192203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192232 */     // (intrinsic_wo_chain:{ *:[v4i16] } 713:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 192235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192241 */     GIR_RootConstrainSelectedInstOperands,
     /* 192242 */     // GIR_Coverage, 1467,
     /* 192242 */     GIR_EraseRootFromParent_Done,
     /* 192243 */   // Label 3566: @192243
     /* 192243 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(192288), // Rule ID 1468 //
     /* 192248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192277 */     // (intrinsic_wo_chain:{ *:[v8i16] } 713:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 192280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192286 */     GIR_RootConstrainSelectedInstOperands,
     /* 192287 */     // GIR_Coverage, 1468,
     /* 192287 */     GIR_EraseRootFromParent_Done,
     /* 192288 */   // Label 3567: @192288
     /* 192288 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(192333), // Rule ID 1469 //
     /* 192293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192322 */     // (intrinsic_wo_chain:{ *:[v2i32] } 713:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 192325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192331 */     GIR_RootConstrainSelectedInstOperands,
     /* 192332 */     // GIR_Coverage, 1469,
     /* 192332 */     GIR_EraseRootFromParent_Done,
     /* 192333 */   // Label 3568: @192333
     /* 192333 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(192378), // Rule ID 1470 //
     /* 192338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192367 */     // (intrinsic_wo_chain:{ *:[v4i32] } 713:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 192370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192376 */     GIR_RootConstrainSelectedInstOperands,
     /* 192377 */     // GIR_Coverage, 1470,
     /* 192377 */     GIR_EraseRootFromParent_Done,
     /* 192378 */   // Label 3569: @192378
     /* 192378 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(192423), // Rule ID 1471 //
     /* 192383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192412 */     // (intrinsic_wo_chain:{ *:[v2i64] } 713:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 192415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192421 */     GIR_RootConstrainSelectedInstOperands,
     /* 192422 */     // GIR_Coverage, 1471,
     /* 192422 */     GIR_EraseRootFromParent_Done,
     /* 192423 */   // Label 3570: @192423
     /* 192423 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(192468), // Rule ID 1492 //
     /* 192428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192457 */     // (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 192460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192466 */     GIR_RootConstrainSelectedInstOperands,
     /* 192467 */     // GIR_Coverage, 1492,
     /* 192467 */     GIR_EraseRootFromParent_Done,
     /* 192468 */   // Label 3571: @192468
     /* 192468 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(192513), // Rule ID 1494 //
     /* 192473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192502 */     // (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 192505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192511 */     GIR_RootConstrainSelectedInstOperands,
     /* 192512 */     // GIR_Coverage, 1494,
     /* 192512 */     GIR_EraseRootFromParent_Done,
     /* 192513 */   // Label 3572: @192513
     /* 192513 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(192558), // Rule ID 1496 //
     /* 192518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192547 */     // (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 192550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192556 */     GIR_RootConstrainSelectedInstOperands,
     /* 192557 */     // GIR_Coverage, 1496,
     /* 192557 */     GIR_EraseRootFromParent_Done,
     /* 192558 */   // Label 3573: @192558
     /* 192558 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(192603), // Rule ID 1498 //
     /* 192563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 192595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192601 */     GIR_RootConstrainSelectedInstOperands,
     /* 192602 */     // GIR_Coverage, 1498,
     /* 192602 */     GIR_EraseRootFromParent_Done,
     /* 192603 */   // Label 3574: @192603
     /* 192603 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(192648), // Rule ID 1500 //
     /* 192608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192637 */     // (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 192640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192646 */     GIR_RootConstrainSelectedInstOperands,
     /* 192647 */     // GIR_Coverage, 1500,
     /* 192647 */     GIR_EraseRootFromParent_Done,
     /* 192648 */   // Label 3575: @192648
     /* 192648 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(192693), // Rule ID 1502 //
     /* 192653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192682 */     // (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 192685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192691 */     GIR_RootConstrainSelectedInstOperands,
     /* 192692 */     // GIR_Coverage, 1502,
     /* 192692 */     GIR_EraseRootFromParent_Done,
     /* 192693 */   // Label 3576: @192693
     /* 192693 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(192738), // Rule ID 1509 //
     /* 192698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192727 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 192730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192736 */     GIR_RootConstrainSelectedInstOperands,
     /* 192737 */     // GIR_Coverage, 1509,
     /* 192737 */     GIR_EraseRootFromParent_Done,
     /* 192738 */   // Label 3577: @192738
     /* 192738 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(192783), // Rule ID 1510 //
     /* 192743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192772 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 192775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192781 */     GIR_RootConstrainSelectedInstOperands,
     /* 192782 */     // GIR_Coverage, 1510,
     /* 192782 */     GIR_EraseRootFromParent_Done,
     /* 192783 */   // Label 3578: @192783
     /* 192783 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(192828), // Rule ID 1511 //
     /* 192788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192817 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 192820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192826 */     GIR_RootConstrainSelectedInstOperands,
     /* 192827 */     // GIR_Coverage, 1511,
     /* 192827 */     GIR_EraseRootFromParent_Done,
     /* 192828 */   // Label 3579: @192828
     /* 192828 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(192873), // Rule ID 1512 //
     /* 192833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192862 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 192865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192871 */     GIR_RootConstrainSelectedInstOperands,
     /* 192872 */     // GIR_Coverage, 1512,
     /* 192872 */     GIR_EraseRootFromParent_Done,
     /* 192873 */   // Label 3580: @192873
     /* 192873 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(192918), // Rule ID 1513 //
     /* 192878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192907 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 192910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192916 */     GIR_RootConstrainSelectedInstOperands,
     /* 192917 */     // GIR_Coverage, 1513,
     /* 192917 */     GIR_EraseRootFromParent_Done,
     /* 192918 */   // Label 3581: @192918
     /* 192918 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(192963), // Rule ID 1514 //
     /* 192923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192952 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 192955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192961 */     GIR_RootConstrainSelectedInstOperands,
     /* 192962 */     // GIR_Coverage, 1514,
     /* 192962 */     GIR_EraseRootFromParent_Done,
     /* 192963 */   // Label 3582: @192963
     /* 192963 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(193008), // Rule ID 1515 //
     /* 192968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 192976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192997 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 193000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193006 */     GIR_RootConstrainSelectedInstOperands,
     /* 193007 */     // GIR_Coverage, 1515,
     /* 193007 */     GIR_EraseRootFromParent_Done,
     /* 193008 */   // Label 3583: @193008
     /* 193008 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(193053), // Rule ID 1516 //
     /* 193013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193042 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 193045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193051 */     GIR_RootConstrainSelectedInstOperands,
     /* 193052 */     // GIR_Coverage, 1516,
     /* 193052 */     GIR_EraseRootFromParent_Done,
     /* 193053 */   // Label 3584: @193053
     /* 193053 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(193098), // Rule ID 1517 //
     /* 193058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193087 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 193090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193096 */     GIR_RootConstrainSelectedInstOperands,
     /* 193097 */     // GIR_Coverage, 1517,
     /* 193097 */     GIR_EraseRootFromParent_Done,
     /* 193098 */   // Label 3585: @193098
     /* 193098 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(193143), // Rule ID 1518 //
     /* 193103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193132 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 193135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193141 */     GIR_RootConstrainSelectedInstOperands,
     /* 193142 */     // GIR_Coverage, 1518,
     /* 193142 */     GIR_EraseRootFromParent_Done,
     /* 193143 */   // Label 3586: @193143
     /* 193143 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(193188), // Rule ID 1519 //
     /* 193148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193177 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 193180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193186 */     GIR_RootConstrainSelectedInstOperands,
     /* 193187 */     // GIR_Coverage, 1519,
     /* 193187 */     GIR_EraseRootFromParent_Done,
     /* 193188 */   // Label 3587: @193188
     /* 193188 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(193233), // Rule ID 1520 //
     /* 193193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193222 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 193225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193231 */     GIR_RootConstrainSelectedInstOperands,
     /* 193232 */     // GIR_Coverage, 1520,
     /* 193232 */     GIR_EraseRootFromParent_Done,
     /* 193233 */   // Label 3588: @193233
     /* 193233 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(193278), // Rule ID 1527 //
     /* 193238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193267 */     // (intrinsic_wo_chain:{ *:[v8i8] } 745:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 193270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193276 */     GIR_RootConstrainSelectedInstOperands,
     /* 193277 */     // GIR_Coverage, 1527,
     /* 193277 */     GIR_EraseRootFromParent_Done,
     /* 193278 */   // Label 3589: @193278
     /* 193278 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(193323), // Rule ID 1528 //
     /* 193283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193312 */     // (intrinsic_wo_chain:{ *:[v16i8] } 745:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 193315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193321 */     GIR_RootConstrainSelectedInstOperands,
     /* 193322 */     // GIR_Coverage, 1528,
     /* 193322 */     GIR_EraseRootFromParent_Done,
     /* 193323 */   // Label 3590: @193323
     /* 193323 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(193368), // Rule ID 1529 //
     /* 193328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193357 */     // (intrinsic_wo_chain:{ *:[v4i16] } 745:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 193360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193366 */     GIR_RootConstrainSelectedInstOperands,
     /* 193367 */     // GIR_Coverage, 1529,
     /* 193367 */     GIR_EraseRootFromParent_Done,
     /* 193368 */   // Label 3591: @193368
     /* 193368 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(193413), // Rule ID 1530 //
     /* 193373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193402 */     // (intrinsic_wo_chain:{ *:[v8i16] } 745:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 193405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193411 */     GIR_RootConstrainSelectedInstOperands,
     /* 193412 */     // GIR_Coverage, 1530,
     /* 193412 */     GIR_EraseRootFromParent_Done,
     /* 193413 */   // Label 3592: @193413
     /* 193413 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(193458), // Rule ID 1531 //
     /* 193418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193447 */     // (intrinsic_wo_chain:{ *:[v2i32] } 745:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 193450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193456 */     GIR_RootConstrainSelectedInstOperands,
     /* 193457 */     // GIR_Coverage, 1531,
     /* 193457 */     GIR_EraseRootFromParent_Done,
     /* 193458 */   // Label 3593: @193458
     /* 193458 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(193503), // Rule ID 1532 //
     /* 193463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 745:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 193495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193501 */     GIR_RootConstrainSelectedInstOperands,
     /* 193502 */     // GIR_Coverage, 1532,
     /* 193502 */     GIR_EraseRootFromParent_Done,
     /* 193503 */   // Label 3594: @193503
     /* 193503 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(193548), // Rule ID 1546 //
     /* 193508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193537 */     // (intrinsic_wo_chain:{ *:[v8i8] } 750:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 193540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193546 */     GIR_RootConstrainSelectedInstOperands,
     /* 193547 */     // GIR_Coverage, 1546,
     /* 193547 */     GIR_EraseRootFromParent_Done,
     /* 193548 */   // Label 3595: @193548
     /* 193548 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(193593), // Rule ID 1547 //
     /* 193553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193582 */     // (intrinsic_wo_chain:{ *:[v16i8] } 750:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 193585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193591 */     GIR_RootConstrainSelectedInstOperands,
     /* 193592 */     // GIR_Coverage, 1547,
     /* 193592 */     GIR_EraseRootFromParent_Done,
     /* 193593 */   // Label 3596: @193593
     /* 193593 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(193638), // Rule ID 1548 //
     /* 193598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193627 */     // (intrinsic_wo_chain:{ *:[v4i16] } 750:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 193630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193636 */     GIR_RootConstrainSelectedInstOperands,
     /* 193637 */     // GIR_Coverage, 1548,
     /* 193637 */     GIR_EraseRootFromParent_Done,
     /* 193638 */   // Label 3597: @193638
     /* 193638 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(193683), // Rule ID 1549 //
     /* 193643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 750:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 193675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193681 */     GIR_RootConstrainSelectedInstOperands,
     /* 193682 */     // GIR_Coverage, 1549,
     /* 193682 */     GIR_EraseRootFromParent_Done,
     /* 193683 */   // Label 3598: @193683
     /* 193683 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(193728), // Rule ID 1550 //
     /* 193688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193717 */     // (intrinsic_wo_chain:{ *:[v2i32] } 750:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 193720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193726 */     GIR_RootConstrainSelectedInstOperands,
     /* 193727 */     // GIR_Coverage, 1550,
     /* 193727 */     GIR_EraseRootFromParent_Done,
     /* 193728 */   // Label 3599: @193728
     /* 193728 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(193773), // Rule ID 1551 //
     /* 193733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193762 */     // (intrinsic_wo_chain:{ *:[v4i32] } 750:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 193765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193771 */     GIR_RootConstrainSelectedInstOperands,
     /* 193772 */     // GIR_Coverage, 1551,
     /* 193772 */     GIR_EraseRootFromParent_Done,
     /* 193773 */   // Label 3600: @193773
     /* 193773 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(193818), // Rule ID 1552 //
     /* 193778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193807 */     // (intrinsic_wo_chain:{ *:[v2i64] } 750:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 193810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193816 */     GIR_RootConstrainSelectedInstOperands,
     /* 193817 */     // GIR_Coverage, 1552,
     /* 193817 */     GIR_EraseRootFromParent_Done,
     /* 193818 */   // Label 3601: @193818
     /* 193818 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(193863), // Rule ID 1553 //
     /* 193823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193852 */     // (intrinsic_wo_chain:{ *:[v8i8] } 752:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 193855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193861 */     GIR_RootConstrainSelectedInstOperands,
     /* 193862 */     // GIR_Coverage, 1553,
     /* 193862 */     GIR_EraseRootFromParent_Done,
     /* 193863 */   // Label 3602: @193863
     /* 193863 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(193908), // Rule ID 1554 //
     /* 193868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193897 */     // (intrinsic_wo_chain:{ *:[v16i8] } 752:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 193900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193906 */     GIR_RootConstrainSelectedInstOperands,
     /* 193907 */     // GIR_Coverage, 1554,
     /* 193907 */     GIR_EraseRootFromParent_Done,
     /* 193908 */   // Label 3603: @193908
     /* 193908 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(193953), // Rule ID 1555 //
     /* 193913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193942 */     // (intrinsic_wo_chain:{ *:[v4i16] } 752:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 193945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193951 */     GIR_RootConstrainSelectedInstOperands,
     /* 193952 */     // GIR_Coverage, 1555,
     /* 193952 */     GIR_EraseRootFromParent_Done,
     /* 193953 */   // Label 3604: @193953
     /* 193953 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(193998), // Rule ID 1556 //
     /* 193958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193987 */     // (intrinsic_wo_chain:{ *:[v8i16] } 752:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 193990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193996 */     GIR_RootConstrainSelectedInstOperands,
     /* 193997 */     // GIR_Coverage, 1556,
     /* 193997 */     GIR_EraseRootFromParent_Done,
     /* 193998 */   // Label 3605: @193998
     /* 193998 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(194043), // Rule ID 1557 //
     /* 194003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194032 */     // (intrinsic_wo_chain:{ *:[v2i32] } 752:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 194035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194041 */     GIR_RootConstrainSelectedInstOperands,
     /* 194042 */     // GIR_Coverage, 1557,
     /* 194042 */     GIR_EraseRootFromParent_Done,
     /* 194043 */   // Label 3606: @194043
     /* 194043 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(194088), // Rule ID 1558 //
     /* 194048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194077 */     // (intrinsic_wo_chain:{ *:[v4i32] } 752:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 194080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194086 */     GIR_RootConstrainSelectedInstOperands,
     /* 194087 */     // GIR_Coverage, 1558,
     /* 194087 */     GIR_EraseRootFromParent_Done,
     /* 194088 */   // Label 3607: @194088
     /* 194088 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(194133), // Rule ID 1559 //
     /* 194093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194122 */     // (intrinsic_wo_chain:{ *:[v2i64] } 752:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 194125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194131 */     GIR_RootConstrainSelectedInstOperands,
     /* 194132 */     // GIR_Coverage, 1559,
     /* 194132 */     GIR_EraseRootFromParent_Done,
     /* 194133 */   // Label 3608: @194133
     /* 194133 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(194178), // Rule ID 1573 //
     /* 194138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194167 */     // (intrinsic_wo_chain:{ *:[v8i8] } 758:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 194170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194176 */     GIR_RootConstrainSelectedInstOperands,
     /* 194177 */     // GIR_Coverage, 1573,
     /* 194177 */     GIR_EraseRootFromParent_Done,
     /* 194178 */   // Label 3609: @194178
     /* 194178 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(194223), // Rule ID 1574 //
     /* 194183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194212 */     // (intrinsic_wo_chain:{ *:[v16i8] } 758:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 194215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194221 */     GIR_RootConstrainSelectedInstOperands,
     /* 194222 */     // GIR_Coverage, 1574,
     /* 194222 */     GIR_EraseRootFromParent_Done,
     /* 194223 */   // Label 3610: @194223
     /* 194223 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(194268), // Rule ID 1575 //
     /* 194228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194257 */     // (intrinsic_wo_chain:{ *:[v4i16] } 758:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 194260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194266 */     GIR_RootConstrainSelectedInstOperands,
     /* 194267 */     // GIR_Coverage, 1575,
     /* 194267 */     GIR_EraseRootFromParent_Done,
     /* 194268 */   // Label 3611: @194268
     /* 194268 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(194313), // Rule ID 1576 //
     /* 194273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194302 */     // (intrinsic_wo_chain:{ *:[v8i16] } 758:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 194305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194311 */     GIR_RootConstrainSelectedInstOperands,
     /* 194312 */     // GIR_Coverage, 1576,
     /* 194312 */     GIR_EraseRootFromParent_Done,
     /* 194313 */   // Label 3612: @194313
     /* 194313 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(194358), // Rule ID 1577 //
     /* 194318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194347 */     // (intrinsic_wo_chain:{ *:[v2i32] } 758:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 194350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194356 */     GIR_RootConstrainSelectedInstOperands,
     /* 194357 */     // GIR_Coverage, 1577,
     /* 194357 */     GIR_EraseRootFromParent_Done,
     /* 194358 */   // Label 3613: @194358
     /* 194358 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(194403), // Rule ID 1578 //
     /* 194363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194392 */     // (intrinsic_wo_chain:{ *:[v4i32] } 758:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 194395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194401 */     GIR_RootConstrainSelectedInstOperands,
     /* 194402 */     // GIR_Coverage, 1578,
     /* 194402 */     GIR_EraseRootFromParent_Done,
     /* 194403 */   // Label 3614: @194403
     /* 194403 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(194448), // Rule ID 1579 //
     /* 194408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194437 */     // (intrinsic_wo_chain:{ *:[v2i64] } 758:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 194440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194446 */     GIR_RootConstrainSelectedInstOperands,
     /* 194447 */     // GIR_Coverage, 1579,
     /* 194447 */     GIR_EraseRootFromParent_Done,
     /* 194448 */   // Label 3615: @194448
     /* 194448 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(194493), // Rule ID 1580 //
     /* 194453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194482 */     // (intrinsic_wo_chain:{ *:[v8i8] } 761:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 194485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194491 */     GIR_RootConstrainSelectedInstOperands,
     /* 194492 */     // GIR_Coverage, 1580,
     /* 194492 */     GIR_EraseRootFromParent_Done,
     /* 194493 */   // Label 3616: @194493
     /* 194493 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(194538), // Rule ID 1581 //
     /* 194498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194527 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 194530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194536 */     GIR_RootConstrainSelectedInstOperands,
     /* 194537 */     // GIR_Coverage, 1581,
     /* 194537 */     GIR_EraseRootFromParent_Done,
     /* 194538 */   // Label 3617: @194538
     /* 194538 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(194583), // Rule ID 1582 //
     /* 194543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194572 */     // (intrinsic_wo_chain:{ *:[v4i16] } 761:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 194575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194581 */     GIR_RootConstrainSelectedInstOperands,
     /* 194582 */     // GIR_Coverage, 1582,
     /* 194582 */     GIR_EraseRootFromParent_Done,
     /* 194583 */   // Label 3618: @194583
     /* 194583 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(194628), // Rule ID 1583 //
     /* 194588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194617 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 194620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194626 */     GIR_RootConstrainSelectedInstOperands,
     /* 194627 */     // GIR_Coverage, 1583,
     /* 194627 */     GIR_EraseRootFromParent_Done,
     /* 194628 */   // Label 3619: @194628
     /* 194628 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(194673), // Rule ID 1584 //
     /* 194633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194662 */     // (intrinsic_wo_chain:{ *:[v2i32] } 761:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 194665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194671 */     GIR_RootConstrainSelectedInstOperands,
     /* 194672 */     // GIR_Coverage, 1584,
     /* 194672 */     GIR_EraseRootFromParent_Done,
     /* 194673 */   // Label 3620: @194673
     /* 194673 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(194718), // Rule ID 1585 //
     /* 194678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194707 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 194710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194716 */     GIR_RootConstrainSelectedInstOperands,
     /* 194717 */     // GIR_Coverage, 1585,
     /* 194717 */     GIR_EraseRootFromParent_Done,
     /* 194718 */   // Label 3621: @194718
     /* 194718 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(194763), // Rule ID 1586 //
     /* 194723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194752 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 194755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194761 */     GIR_RootConstrainSelectedInstOperands,
     /* 194762 */     // GIR_Coverage, 1586,
     /* 194762 */     GIR_EraseRootFromParent_Done,
     /* 194763 */   // Label 3622: @194763
     /* 194763 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(194808), // Rule ID 1614 //
     /* 194768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194797 */     // (intrinsic_wo_chain:{ *:[f64] } 795:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 194797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 194800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194806 */     GIR_RootConstrainSelectedInstOperands,
     /* 194807 */     // GIR_Coverage, 1614,
     /* 194807 */     GIR_EraseRootFromParent_Done,
     /* 194808 */   // Label 3623: @194808
     /* 194808 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(194853), // Rule ID 1615 //
     /* 194813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194842 */     // (intrinsic_wo_chain:{ *:[f32] } 795:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 194842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 194845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194851 */     GIR_RootConstrainSelectedInstOperands,
     /* 194852 */     // GIR_Coverage, 1615,
     /* 194852 */     GIR_EraseRootFromParent_Done,
     /* 194853 */   // Label 3624: @194853
     /* 194853 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(194898), // Rule ID 1616 //
     /* 194858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 194861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 194869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 194872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 194875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194887 */     // (intrinsic_wo_chain:{ *:[f16] } 795:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 194887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 194890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194896 */     GIR_RootConstrainSelectedInstOperands,
     /* 194897 */     // GIR_Coverage, 1616,
     /* 194897 */     GIR_EraseRootFromParent_Done,
     /* 194898 */   // Label 3625: @194898
     /* 194898 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(194943), // Rule ID 1617 //
     /* 194903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 194911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194932 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 194932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 194935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194941 */     GIR_RootConstrainSelectedInstOperands,
     /* 194942 */     // GIR_Coverage, 1617,
     /* 194942 */     GIR_EraseRootFromParent_Done,
     /* 194943 */   // Label 3626: @194943
     /* 194943 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(194988), // Rule ID 1618 //
     /* 194948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 194956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194977 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 194977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 194980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194986 */     GIR_RootConstrainSelectedInstOperands,
     /* 194987 */     // GIR_Coverage, 1618,
     /* 194987 */     GIR_EraseRootFromParent_Done,
     /* 194988 */   // Label 3627: @194988
     /* 194988 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(195033), // Rule ID 1619 //
     /* 194993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195022 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 195025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195031 */     GIR_RootConstrainSelectedInstOperands,
     /* 195032 */     // GIR_Coverage, 1619,
     /* 195032 */     GIR_EraseRootFromParent_Done,
     /* 195033 */   // Label 3628: @195033
     /* 195033 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(195078), // Rule ID 1620 //
     /* 195038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195067 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 195070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195076 */     GIR_RootConstrainSelectedInstOperands,
     /* 195077 */     // GIR_Coverage, 1620,
     /* 195077 */     GIR_EraseRootFromParent_Done,
     /* 195078 */   // Label 3629: @195078
     /* 195078 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(195123), // Rule ID 1627 //
     /* 195083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195112 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 195115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195121 */     GIR_RootConstrainSelectedInstOperands,
     /* 195122 */     // GIR_Coverage, 1627,
     /* 195122 */     GIR_EraseRootFromParent_Done,
     /* 195123 */   // Label 3630: @195123
     /* 195123 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(195168), // Rule ID 1628 //
     /* 195128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195157 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 195160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195166 */     GIR_RootConstrainSelectedInstOperands,
     /* 195167 */     // GIR_Coverage, 1628,
     /* 195167 */     GIR_EraseRootFromParent_Done,
     /* 195168 */   // Label 3631: @195168
     /* 195168 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(195213), // Rule ID 1629 //
     /* 195173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195202 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 195205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195211 */     GIR_RootConstrainSelectedInstOperands,
     /* 195212 */     // GIR_Coverage, 1629,
     /* 195212 */     GIR_EraseRootFromParent_Done,
     /* 195213 */   // Label 3632: @195213
     /* 195213 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(195258), // Rule ID 1630 //
     /* 195218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195247 */     // (intrinsic_wo_chain:{ *:[f64] } 643:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 195250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195256 */     GIR_RootConstrainSelectedInstOperands,
     /* 195257 */     // GIR_Coverage, 1630,
     /* 195257 */     GIR_EraseRootFromParent_Done,
     /* 195258 */   // Label 3633: @195258
     /* 195258 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(195303), // Rule ID 1631 //
     /* 195263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195292 */     // (intrinsic_wo_chain:{ *:[f32] } 643:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 195295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195301 */     GIR_RootConstrainSelectedInstOperands,
     /* 195302 */     // GIR_Coverage, 1631,
     /* 195302 */     GIR_EraseRootFromParent_Done,
     /* 195303 */   // Label 3634: @195303
     /* 195303 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(195348), // Rule ID 1632 //
     /* 195308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195337 */     // (intrinsic_wo_chain:{ *:[f16] } 643:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 195340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195346 */     GIR_RootConstrainSelectedInstOperands,
     /* 195347 */     // GIR_Coverage, 1632,
     /* 195347 */     GIR_EraseRootFromParent_Done,
     /* 195348 */   // Label 3635: @195348
     /* 195348 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(195393), // Rule ID 1633 //
     /* 195353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195382 */     // (intrinsic_wo_chain:{ *:[f64] } 650:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 195385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195391 */     GIR_RootConstrainSelectedInstOperands,
     /* 195392 */     // GIR_Coverage, 1633,
     /* 195392 */     GIR_EraseRootFromParent_Done,
     /* 195393 */   // Label 3636: @195393
     /* 195393 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(195438), // Rule ID 1634 //
     /* 195398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195427 */     // (intrinsic_wo_chain:{ *:[f32] } 650:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 195430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195436 */     GIR_RootConstrainSelectedInstOperands,
     /* 195437 */     // GIR_Coverage, 1634,
     /* 195437 */     GIR_EraseRootFromParent_Done,
     /* 195438 */   // Label 3637: @195438
     /* 195438 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(195483), // Rule ID 1635 //
     /* 195443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195472 */     // (intrinsic_wo_chain:{ *:[f16] } 650:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 195475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195481 */     GIR_RootConstrainSelectedInstOperands,
     /* 195482 */     // GIR_Coverage, 1635,
     /* 195482 */     GIR_EraseRootFromParent_Done,
     /* 195483 */   // Label 3638: @195483
     /* 195483 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(195528), // Rule ID 1637 //
     /* 195488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 195496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195517 */     // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 195520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195526 */     GIR_RootConstrainSelectedInstOperands,
     /* 195527 */     // GIR_Coverage, 1637,
     /* 195527 */     GIR_EraseRootFromParent_Done,
     /* 195528 */   // Label 3639: @195528
     /* 195528 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(195573), // Rule ID 1638 //
     /* 195533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 195541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195562 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 195565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195571 */     GIR_RootConstrainSelectedInstOperands,
     /* 195572 */     // GIR_Coverage, 1638,
     /* 195572 */     GIR_EraseRootFromParent_Done,
     /* 195573 */   // Label 3640: @195573
     /* 195573 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(195618), // Rule ID 1639 //
     /* 195578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 195586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195607 */     // (intrinsic_wo_chain:{ *:[v1i64] } 701:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 195610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195616 */     GIR_RootConstrainSelectedInstOperands,
     /* 195617 */     // GIR_Coverage, 1639,
     /* 195617 */     GIR_EraseRootFromParent_Done,
     /* 195618 */   // Label 3641: @195618
     /* 195618 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(195663), // Rule ID 1640 //
     /* 195623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 195631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195652 */     // (intrinsic_wo_chain:{ *:[v1i64] } 704:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 195655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195661 */     GIR_RootConstrainSelectedInstOperands,
     /* 195662 */     // GIR_Coverage, 1640,
     /* 195662 */     GIR_EraseRootFromParent_Done,
     /* 195663 */   // Label 3642: @195663
     /* 195663 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(195708), // Rule ID 1642 //
     /* 195668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 195676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195697 */     // (intrinsic_wo_chain:{ *:[v1i64] } 712:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 195700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195706 */     GIR_RootConstrainSelectedInstOperands,
     /* 195707 */     // GIR_Coverage, 1642,
     /* 195707 */     GIR_EraseRootFromParent_Done,
     /* 195708 */   // Label 3643: @195708
     /* 195708 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(195753), // Rule ID 1643 //
     /* 195713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 195721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195742 */     // (intrinsic_wo_chain:{ *:[v1i64] } 713:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 195745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195751 */     GIR_RootConstrainSelectedInstOperands,
     /* 195752 */     // GIR_Coverage, 1643,
     /* 195752 */     GIR_EraseRootFromParent_Done,
     /* 195753 */   // Label 3644: @195753
     /* 195753 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(195798), // Rule ID 1646 //
     /* 195758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195787 */     // (intrinsic_wo_chain:{ *:[v1i64] } 750:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 195790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195796 */     GIR_RootConstrainSelectedInstOperands,
     /* 195797 */     // GIR_Coverage, 1646,
     /* 195797 */     GIR_EraseRootFromParent_Done,
     /* 195798 */   // Label 3645: @195798
     /* 195798 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(195843), // Rule ID 1647 //
     /* 195803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195832 */     // (intrinsic_wo_chain:{ *:[v1i64] } 752:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 195835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195841 */     GIR_RootConstrainSelectedInstOperands,
     /* 195842 */     // GIR_Coverage, 1647,
     /* 195842 */     GIR_EraseRootFromParent_Done,
     /* 195843 */   // Label 3646: @195843
     /* 195843 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(195888), // Rule ID 1649 //
     /* 195848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 195856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195877 */     // (intrinsic_wo_chain:{ *:[v1i64] } 758:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 195880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195886 */     GIR_RootConstrainSelectedInstOperands,
     /* 195887 */     // GIR_Coverage, 1649,
     /* 195887 */     GIR_EraseRootFromParent_Done,
     /* 195888 */   // Label 3647: @195888
     /* 195888 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(195933), // Rule ID 1650 //
     /* 195893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 195901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195922 */     // (intrinsic_wo_chain:{ *:[v1i64] } 761:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 195925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195931 */     GIR_RootConstrainSelectedInstOperands,
     /* 195932 */     // GIR_Coverage, 1650,
     /* 195932 */     GIR_EraseRootFromParent_Done,
     /* 195933 */   // Label 3648: @195933
     /* 195933 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(195978), // Rule ID 1651 //
     /* 195938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 195946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195967 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 195970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195976 */     GIR_RootConstrainSelectedInstOperands,
     /* 195977 */     // GIR_Coverage, 1651,
     /* 195977 */     GIR_EraseRootFromParent_Done,
     /* 195978 */   // Label 3649: @195978
     /* 195978 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(196023), // Rule ID 1665 //
     /* 195983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 195991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196012 */     // (intrinsic_wo_chain:{ *:[i64] } 725:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 196015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196021 */     GIR_RootConstrainSelectedInstOperands,
     /* 196022 */     // GIR_Coverage, 1665,
     /* 196022 */     GIR_EraseRootFromParent_Done,
     /* 196023 */   // Label 3650: @196023
     /* 196023 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(196068), // Rule ID 1666 //
     /* 196028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 196036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196057 */     // (intrinsic_wo_chain:{ *:[i32] } 725:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 196060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196066 */     GIR_RootConstrainSelectedInstOperands,
     /* 196067 */     // GIR_Coverage, 1666,
     /* 196067 */     GIR_EraseRootFromParent_Done,
     /* 196068 */   // Label 3651: @196068
     /* 196068 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(196113), // Rule ID 1671 //
     /* 196073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196102 */     // (intrinsic_wo_chain:{ *:[i64] } 764:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 196105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196111 */     GIR_RootConstrainSelectedInstOperands,
     /* 196112 */     // GIR_Coverage, 1671,
     /* 196112 */     GIR_EraseRootFromParent_Done,
     /* 196113 */   // Label 3652: @196113
     /* 196113 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(196158), // Rule ID 1672 //
     /* 196118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196147 */     // (intrinsic_wo_chain:{ *:[i32] } 764:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 196150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196156 */     GIR_RootConstrainSelectedInstOperands,
     /* 196157 */     // GIR_Coverage, 1672,
     /* 196157 */     GIR_EraseRootFromParent_Done,
     /* 196158 */   // Label 3653: @196158
     /* 196158 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(196203), // Rule ID 1673 //
     /* 196163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196192 */     // (intrinsic_wo_chain:{ *:[v8i8] } 579:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 196195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196201 */     GIR_RootConstrainSelectedInstOperands,
     /* 196202 */     // GIR_Coverage, 1673,
     /* 196202 */     GIR_EraseRootFromParent_Done,
     /* 196203 */   // Label 3654: @196203
     /* 196203 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(196248), // Rule ID 1674 //
     /* 196208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196237 */     // (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 196240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196246 */     GIR_RootConstrainSelectedInstOperands,
     /* 196247 */     // GIR_Coverage, 1674,
     /* 196247 */     GIR_EraseRootFromParent_Done,
     /* 196248 */   // Label 3655: @196248
     /* 196248 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(196293), // Rule ID 1675 //
     /* 196253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196282 */     // (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 196285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196291 */     GIR_RootConstrainSelectedInstOperands,
     /* 196292 */     // GIR_Coverage, 1675,
     /* 196292 */     GIR_EraseRootFromParent_Done,
     /* 196293 */   // Label 3656: @196293
     /* 196293 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(196338), // Rule ID 1676 //
     /* 196298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196327 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 196330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196336 */     GIR_RootConstrainSelectedInstOperands,
     /* 196337 */     // GIR_Coverage, 1676,
     /* 196337 */     GIR_EraseRootFromParent_Done,
     /* 196338 */   // Label 3657: @196338
     /* 196338 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(196383), // Rule ID 1677 //
     /* 196343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196372 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 196375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196381 */     GIR_RootConstrainSelectedInstOperands,
     /* 196382 */     // GIR_Coverage, 1677,
     /* 196382 */     GIR_EraseRootFromParent_Done,
     /* 196383 */   // Label 3658: @196383
     /* 196383 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(196428), // Rule ID 1678 //
     /* 196388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196417 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 196420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196426 */     GIR_RootConstrainSelectedInstOperands,
     /* 196427 */     // GIR_Coverage, 1678,
     /* 196427 */     GIR_EraseRootFromParent_Done,
     /* 196428 */   // Label 3659: @196428
     /* 196428 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(196473), // Rule ID 1679 //
     /* 196433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196462 */     // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 196465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196471 */     GIR_RootConstrainSelectedInstOperands,
     /* 196472 */     // GIR_Coverage, 1679,
     /* 196472 */     GIR_EraseRootFromParent_Done,
     /* 196473 */   // Label 3660: @196473
     /* 196473 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(196518), // Rule ID 1680 //
     /* 196478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196507 */     // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 196510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196516 */     GIR_RootConstrainSelectedInstOperands,
     /* 196517 */     // GIR_Coverage, 1680,
     /* 196517 */     GIR_EraseRootFromParent_Done,
     /* 196518 */   // Label 3661: @196518
     /* 196518 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(196563), // Rule ID 1681 //
     /* 196523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 196555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196561 */     GIR_RootConstrainSelectedInstOperands,
     /* 196562 */     // GIR_Coverage, 1681,
     /* 196562 */     GIR_EraseRootFromParent_Done,
     /* 196563 */   // Label 3662: @196563
     /* 196563 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(196608), // Rule ID 1682 //
     /* 196568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196597 */     // (intrinsic_wo_chain:{ *:[v8i8] } 668:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 196600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196606 */     GIR_RootConstrainSelectedInstOperands,
     /* 196607 */     // GIR_Coverage, 1682,
     /* 196607 */     GIR_EraseRootFromParent_Done,
     /* 196608 */   // Label 3663: @196608
     /* 196608 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(196653), // Rule ID 1683 //
     /* 196613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196642 */     // (intrinsic_wo_chain:{ *:[v4i16] } 668:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 196645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196651 */     GIR_RootConstrainSelectedInstOperands,
     /* 196652 */     // GIR_Coverage, 1683,
     /* 196652 */     GIR_EraseRootFromParent_Done,
     /* 196653 */   // Label 3664: @196653
     /* 196653 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(196698), // Rule ID 1684 //
     /* 196658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196687 */     // (intrinsic_wo_chain:{ *:[v2i32] } 668:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 196690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196696 */     GIR_RootConstrainSelectedInstOperands,
     /* 196697 */     // GIR_Coverage, 1684,
     /* 196697 */     GIR_EraseRootFromParent_Done,
     /* 196698 */   // Label 3665: @196698
     /* 196698 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(196743), // Rule ID 1750 //
     /* 196703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 196711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196732 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 196732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 196735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196741 */     GIR_RootConstrainSelectedInstOperands,
     /* 196742 */     // GIR_Coverage, 1750,
     /* 196742 */     GIR_EraseRootFromParent_Done,
     /* 196743 */   // Label 3666: @196743
     /* 196743 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(196788), // Rule ID 1752 //
     /* 196748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 196756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196777 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 196780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196786 */     GIR_RootConstrainSelectedInstOperands,
     /* 196787 */     // GIR_Coverage, 1752,
     /* 196787 */     GIR_EraseRootFromParent_Done,
     /* 196788 */   // Label 3667: @196788
     /* 196788 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(196833), // Rule ID 2303 //
     /* 196793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 196796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 196801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 196822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 196825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196831 */     GIR_RootConstrainSelectedInstOperands,
     /* 196832 */     // GIR_Coverage, 2303,
     /* 196832 */     GIR_EraseRootFromParent_Done,
     /* 196833 */   // Label 3668: @196833
     /* 196833 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(196878), // Rule ID 2304 //
     /* 196838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 196841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 196846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 196867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 196870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196876 */     GIR_RootConstrainSelectedInstOperands,
     /* 196877 */     // GIR_Coverage, 2304,
     /* 196877 */     GIR_EraseRootFromParent_Done,
     /* 196878 */   // Label 3669: @196878
     /* 196878 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(196923), // Rule ID 2315 //
     /* 196883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 196886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 196891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 196912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 196915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196921 */     GIR_RootConstrainSelectedInstOperands,
     /* 196922 */     // GIR_Coverage, 2315,
     /* 196922 */     GIR_EraseRootFromParent_Done,
     /* 196923 */   // Label 3670: @196923
     /* 196923 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(196968), // Rule ID 2316 //
     /* 196928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 196931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 196936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196957 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 196957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 196960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196966 */     GIR_RootConstrainSelectedInstOperands,
     /* 196967 */     // GIR_Coverage, 2316,
     /* 196967 */     GIR_EraseRootFromParent_Done,
     /* 196968 */   // Label 3671: @196968
     /* 196968 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(197013), // Rule ID 2339 //
     /* 196973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 196976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 196981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197002 */     // (intrinsic_wo_chain:{ *:[v4f16] } 641:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 197002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 197005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197011 */     GIR_RootConstrainSelectedInstOperands,
     /* 197012 */     // GIR_Coverage, 2339,
     /* 197012 */     GIR_EraseRootFromParent_Done,
     /* 197013 */   // Label 3672: @197013
     /* 197013 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(197058), // Rule ID 2340 //
     /* 197018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197047 */     // (intrinsic_wo_chain:{ *:[v8f16] } 641:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 197047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 197050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197056 */     GIR_RootConstrainSelectedInstOperands,
     /* 197057 */     // GIR_Coverage, 2340,
     /* 197057 */     GIR_EraseRootFromParent_Done,
     /* 197058 */   // Label 3673: @197058
     /* 197058 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(197103), // Rule ID 2341 //
     /* 197063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197092 */     // (intrinsic_wo_chain:{ *:[v2f32] } 641:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 197092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 197095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197101 */     GIR_RootConstrainSelectedInstOperands,
     /* 197102 */     // GIR_Coverage, 2341,
     /* 197102 */     GIR_EraseRootFromParent_Done,
     /* 197103 */   // Label 3674: @197103
     /* 197103 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(197148), // Rule ID 2342 //
     /* 197108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197137 */     // (intrinsic_wo_chain:{ *:[v4f32] } 641:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 197137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 197140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197146 */     GIR_RootConstrainSelectedInstOperands,
     /* 197147 */     // GIR_Coverage, 2342,
     /* 197147 */     GIR_EraseRootFromParent_Done,
     /* 197148 */   // Label 3675: @197148
     /* 197148 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(197193), // Rule ID 2343 //
     /* 197153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197182 */     // (intrinsic_wo_chain:{ *:[v2f64] } 641:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 197182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 197185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197191 */     GIR_RootConstrainSelectedInstOperands,
     /* 197192 */     // GIR_Coverage, 2343,
     /* 197192 */     GIR_EraseRootFromParent_Done,
     /* 197193 */   // Label 3676: @197193
     /* 197193 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(197238), // Rule ID 2344 //
     /* 197198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197227 */     // (intrinsic_wo_chain:{ *:[v4f16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 197230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197236 */     GIR_RootConstrainSelectedInstOperands,
     /* 197237 */     // GIR_Coverage, 2344,
     /* 197237 */     GIR_EraseRootFromParent_Done,
     /* 197238 */   // Label 3677: @197238
     /* 197238 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(197283), // Rule ID 2347 //
     /* 197243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197272 */     // (intrinsic_wo_chain:{ *:[v8f16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 197275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197281 */     GIR_RootConstrainSelectedInstOperands,
     /* 197282 */     // GIR_Coverage, 2347,
     /* 197282 */     GIR_EraseRootFromParent_Done,
     /* 197283 */   // Label 3678: @197283
     /* 197283 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(197328), // Rule ID 2350 //
     /* 197288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197317 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 197320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197326 */     GIR_RootConstrainSelectedInstOperands,
     /* 197327 */     // GIR_Coverage, 2350,
     /* 197327 */     GIR_EraseRootFromParent_Done,
     /* 197328 */   // Label 3679: @197328
     /* 197328 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(197373), // Rule ID 2353 //
     /* 197333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197362 */     // (intrinsic_wo_chain:{ *:[v4f32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 197365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197371 */     GIR_RootConstrainSelectedInstOperands,
     /* 197372 */     // GIR_Coverage, 2353,
     /* 197372 */     GIR_EraseRootFromParent_Done,
     /* 197373 */   // Label 3680: @197373
     /* 197373 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(197418), // Rule ID 2356 //
     /* 197378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197407 */     // (intrinsic_wo_chain:{ *:[v2f64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 197407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 197410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197416 */     GIR_RootConstrainSelectedInstOperands,
     /* 197417 */     // GIR_Coverage, 2356,
     /* 197417 */     GIR_EraseRootFromParent_Done,
     /* 197418 */   // Label 3681: @197418
     /* 197418 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(197463), // Rule ID 2359 //
     /* 197423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197452 */     // (intrinsic_wo_chain:{ *:[v4f16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 197455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197461 */     GIR_RootConstrainSelectedInstOperands,
     /* 197462 */     // GIR_Coverage, 2359,
     /* 197462 */     GIR_EraseRootFromParent_Done,
     /* 197463 */   // Label 3682: @197463
     /* 197463 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(197508), // Rule ID 2362 //
     /* 197468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197497 */     // (intrinsic_wo_chain:{ *:[v8f16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 197500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197506 */     GIR_RootConstrainSelectedInstOperands,
     /* 197507 */     // GIR_Coverage, 2362,
     /* 197507 */     GIR_EraseRootFromParent_Done,
     /* 197508 */   // Label 3683: @197508
     /* 197508 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(197553), // Rule ID 2365 //
     /* 197513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197542 */     // (intrinsic_wo_chain:{ *:[v2f32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 197545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197551 */     GIR_RootConstrainSelectedInstOperands,
     /* 197552 */     // GIR_Coverage, 2365,
     /* 197552 */     GIR_EraseRootFromParent_Done,
     /* 197553 */   // Label 3684: @197553
     /* 197553 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(197598), // Rule ID 2368 //
     /* 197558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197587 */     // (intrinsic_wo_chain:{ *:[v4f32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 197590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197596 */     GIR_RootConstrainSelectedInstOperands,
     /* 197597 */     // GIR_Coverage, 2368,
     /* 197597 */     GIR_EraseRootFromParent_Done,
     /* 197598 */   // Label 3685: @197598
     /* 197598 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(197643), // Rule ID 2371 //
     /* 197603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197632 */     // (intrinsic_wo_chain:{ *:[v2f64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 197632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 197635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197641 */     GIR_RootConstrainSelectedInstOperands,
     /* 197642 */     // GIR_Coverage, 2371,
     /* 197642 */     GIR_EraseRootFromParent_Done,
     /* 197643 */   // Label 3686: @197643
     /* 197643 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(197688), // Rule ID 2423 //
     /* 197648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 197656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197677 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 197677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 197680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197682 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197686 */     GIR_RootConstrainSelectedInstOperands,
     /* 197687 */     // GIR_Coverage, 2423,
     /* 197687 */     GIR_EraseRootFromParent_Done,
     /* 197688 */   // Label 3687: @197688
     /* 197688 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(197733), // Rule ID 2424 //
     /* 197693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 197701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197722 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1268:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 197722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 197725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197727 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197731 */     GIR_RootConstrainSelectedInstOperands,
     /* 197732 */     // GIR_Coverage, 2424,
     /* 197732 */     GIR_EraseRootFromParent_Done,
     /* 197733 */   // Label 3688: @197733
     /* 197733 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(197778), // Rule ID 2425 //
     /* 197738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 197741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 197746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)
     /* 197767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 197770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197772 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197776 */     GIR_RootConstrainSelectedInstOperands,
     /* 197777 */     // GIR_Coverage, 2425,
     /* 197777 */     GIR_EraseRootFromParent_Done,
     /* 197778 */   // Label 3689: @197778
     /* 197778 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(197823), // Rule ID 2504 //
     /* 197783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197812 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 197812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 197815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197821 */     GIR_RootConstrainSelectedInstOperands,
     /* 197822 */     // GIR_Coverage, 2504,
     /* 197822 */     GIR_EraseRootFromParent_Done,
     /* 197823 */   // Label 3690: @197823
     /* 197823 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(197868), // Rule ID 2505 //
     /* 197828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197857 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 197860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197866 */     GIR_RootConstrainSelectedInstOperands,
     /* 197867 */     // GIR_Coverage, 2505,
     /* 197867 */     GIR_EraseRootFromParent_Done,
     /* 197868 */   // Label 3691: @197868
     /* 197868 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(197913), // Rule ID 2506 //
     /* 197873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 197881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197902 */     // (intrinsic_wo_chain:{ *:[v1f64] } 795:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 197905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197911 */     GIR_RootConstrainSelectedInstOperands,
     /* 197912 */     // GIR_Coverage, 2506,
     /* 197912 */     GIR_EraseRootFromParent_Done,
     /* 197913 */   // Label 3692: @197913
     /* 197913 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(197958), // Rule ID 2507 //
     /* 197918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 197926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197947 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 197950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197956 */     GIR_RootConstrainSelectedInstOperands,
     /* 197957 */     // GIR_Coverage, 2507,
     /* 197957 */     GIR_EraseRootFromParent_Done,
     /* 197958 */   // Label 3693: @197958
     /* 197958 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(198003), // Rule ID 2512 //
     /* 197963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 197971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197992 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 197992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 197995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198001 */     GIR_RootConstrainSelectedInstOperands,
     /* 198002 */     // GIR_Coverage, 2512,
     /* 198002 */     GIR_EraseRootFromParent_Done,
     /* 198003 */   // Label 3694: @198003
     /* 198003 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(198048), // Rule ID 2630 //
     /* 198008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198037 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 198040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198046 */     GIR_RootConstrainSelectedInstOperands,
     /* 198047 */     // GIR_Coverage, 2630,
     /* 198047 */     GIR_EraseRootFromParent_Done,
     /* 198048 */   // Label 3695: @198048
     /* 198048 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(198093), // Rule ID 2631 //
     /* 198053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198082 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 198085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198091 */     GIR_RootConstrainSelectedInstOperands,
     /* 198092 */     // GIR_Coverage, 2631,
     /* 198092 */     GIR_EraseRootFromParent_Done,
     /* 198093 */   // Label 3696: @198093
     /* 198093 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(198138), // Rule ID 2632 //
     /* 198098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198127 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 198130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198136 */     GIR_RootConstrainSelectedInstOperands,
     /* 198137 */     // GIR_Coverage, 2632,
     /* 198137 */     GIR_EraseRootFromParent_Done,
     /* 198138 */   // Label 3697: @198138
     /* 198138 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(198183), // Rule ID 2633 //
     /* 198143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198172 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 198175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198181 */     GIR_RootConstrainSelectedInstOperands,
     /* 198182 */     // GIR_Coverage, 2633,
     /* 198182 */     GIR_EraseRootFromParent_Done,
     /* 198183 */   // Label 3698: @198183
     /* 198183 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(198228), // Rule ID 2634 //
     /* 198188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198217 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 198220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198226 */     GIR_RootConstrainSelectedInstOperands,
     /* 198227 */     // GIR_Coverage, 2634,
     /* 198227 */     GIR_EraseRootFromParent_Done,
     /* 198228 */   // Label 3699: @198228
     /* 198228 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(198273), // Rule ID 2635 //
     /* 198233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198262 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 198265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198271 */     GIR_RootConstrainSelectedInstOperands,
     /* 198272 */     // GIR_Coverage, 2635,
     /* 198272 */     GIR_EraseRootFromParent_Done,
     /* 198273 */   // Label 3700: @198273
     /* 198273 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(198318), // Rule ID 2636 //
     /* 198278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198307 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 198310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198316 */     GIR_RootConstrainSelectedInstOperands,
     /* 198317 */     // GIR_Coverage, 2636,
     /* 198317 */     GIR_EraseRootFromParent_Done,
     /* 198318 */   // Label 3701: @198318
     /* 198318 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(198363), // Rule ID 2637 //
     /* 198323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198352 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 198355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198361 */     GIR_RootConstrainSelectedInstOperands,
     /* 198362 */     // GIR_Coverage, 2637,
     /* 198362 */     GIR_EraseRootFromParent_Done,
     /* 198363 */   // Label 3702: @198363
     /* 198363 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(198408), // Rule ID 3819 //
     /* 198368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 198376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198397 */     // (intrinsic_wo_chain:{ *:[v2i64] } 542:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 198400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198406 */     GIR_RootConstrainSelectedInstOperands,
     /* 198407 */     // GIR_Coverage, 3819,
     /* 198407 */     GIR_EraseRootFromParent_Done,
     /* 198408 */   // Label 3703: @198408
     /* 198408 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(198453), // Rule ID 3847 //
     /* 198413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 198421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198442 */     // (intrinsic_wo_chain:{ *:[v2i64] } 529:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 198445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198451 */     GIR_RootConstrainSelectedInstOperands,
     /* 198452 */     // GIR_Coverage, 3847,
     /* 198452 */     GIR_EraseRootFromParent_Done,
     /* 198453 */   // Label 3704: @198453
     /* 198453 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(198498), // Rule ID 3857 //
     /* 198458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 198466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198487 */     // (intrinsic_wo_chain:{ *:[v4i32] } 552:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 198490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198496 */     GIR_RootConstrainSelectedInstOperands,
     /* 198497 */     // GIR_Coverage, 3857,
     /* 198497 */     GIR_EraseRootFromParent_Done,
     /* 198498 */   // Label 3705: @198498
     /* 198498 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(198543), // Rule ID 3858 //
     /* 198503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 198511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198532 */     // (intrinsic_wo_chain:{ *:[v4i32] } 551:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 198535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198541 */     GIR_RootConstrainSelectedInstOperands,
     /* 198542 */     // GIR_Coverage, 3858,
     /* 198542 */     GIR_EraseRootFromParent_Done,
     /* 198543 */   // Label 3706: @198543
     /* 198543 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(198591), // Rule ID 3859 //
     /* 198548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198577 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 198577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 198580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198589 */     GIR_RootConstrainSelectedInstOperands,
     /* 198590 */     // GIR_Coverage, 3859,
     /* 198590 */     GIR_EraseRootFromParent_Done,
     /* 198591 */   // Label 3707: @198591
     /* 198591 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(198639), // Rule ID 3860 //
     /* 198596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198625 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 198625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 198628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198637 */     GIR_RootConstrainSelectedInstOperands,
     /* 198638 */     // GIR_Coverage, 3860,
     /* 198638 */     GIR_EraseRootFromParent_Done,
     /* 198639 */   // Label 3708: @198639
     /* 198639 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(198687), // Rule ID 3861 //
     /* 198644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198673 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 198673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 198676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198685 */     GIR_RootConstrainSelectedInstOperands,
     /* 198686 */     // GIR_Coverage, 3861,
     /* 198686 */     GIR_EraseRootFromParent_Done,
     /* 198687 */   // Label 3709: @198687
     /* 198687 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(198735), // Rule ID 3862 //
     /* 198692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198721 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 198721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 198724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198733 */     GIR_RootConstrainSelectedInstOperands,
     /* 198734 */     // GIR_Coverage, 3862,
     /* 198734 */     GIR_EraseRootFromParent_Done,
     /* 198735 */   // Label 3710: @198735
     /* 198735 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(198783), // Rule ID 3863 //
     /* 198740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198769 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 198769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 198772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198781 */     GIR_RootConstrainSelectedInstOperands,
     /* 198782 */     // GIR_Coverage, 3863,
     /* 198782 */     GIR_EraseRootFromParent_Done,
     /* 198783 */   // Label 3711: @198783
     /* 198783 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(198831), // Rule ID 3864 //
     /* 198788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198817 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 198817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 198820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198829 */     GIR_RootConstrainSelectedInstOperands,
     /* 198830 */     // GIR_Coverage, 3864,
     /* 198830 */     GIR_EraseRootFromParent_Done,
     /* 198831 */   // Label 3712: @198831
     /* 198831 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(198879), // Rule ID 3865 //
     /* 198836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198865 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 198865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 198868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198877 */     GIR_RootConstrainSelectedInstOperands,
     /* 198878 */     // GIR_Coverage, 3865,
     /* 198878 */     GIR_EraseRootFromParent_Done,
     /* 198879 */   // Label 3713: @198879
     /* 198879 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(198927), // Rule ID 3866 //
     /* 198884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198913 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 198913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 198916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198925 */     GIR_RootConstrainSelectedInstOperands,
     /* 198926 */     // GIR_Coverage, 3866,
     /* 198926 */     GIR_EraseRootFromParent_Done,
     /* 198927 */   // Label 3714: @198927
     /* 198927 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(198975), // Rule ID 3867 //
     /* 198932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198961 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 198961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 198964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198973 */     GIR_RootConstrainSelectedInstOperands,
     /* 198974 */     // GIR_Coverage, 3867,
     /* 198974 */     GIR_EraseRootFromParent_Done,
     /* 198975 */   // Label 3715: @198975
     /* 198975 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(199023), // Rule ID 3868 //
     /* 198980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199009 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 199009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 199012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199021 */     GIR_RootConstrainSelectedInstOperands,
     /* 199022 */     // GIR_Coverage, 3868,
     /* 199022 */     GIR_EraseRootFromParent_Done,
     /* 199023 */   // Label 3716: @199023
     /* 199023 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(199065), // Rule ID 3933 //
     /* 199028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199054 */     // (intrinsic_wo_chain:{ *:[i32] } 2179:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 199057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199063 */     GIR_RootConstrainSelectedInstOperands,
     /* 199064 */     // GIR_Coverage, 3933,
     /* 199064 */     GIR_EraseRootFromParent_Done,
     /* 199065 */   // Label 3717: @199065
     /* 199065 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(199107), // Rule ID 3934 //
     /* 199070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199096 */     // (intrinsic_wo_chain:{ *:[i64] } 2179:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 199099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199105 */     GIR_RootConstrainSelectedInstOperands,
     /* 199106 */     // GIR_Coverage, 3934,
     /* 199106 */     GIR_EraseRootFromParent_Done,
     /* 199107 */   // Label 3718: @199107
     /* 199107 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(199149), // Rule ID 3935 //
     /* 199112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199138 */     // (intrinsic_wo_chain:{ *:[i32] } 789:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 199141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199147 */     GIR_RootConstrainSelectedInstOperands,
     /* 199148 */     // GIR_Coverage, 3935,
     /* 199148 */     GIR_EraseRootFromParent_Done,
     /* 199149 */   // Label 3719: @199149
     /* 199149 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(199191), // Rule ID 3936 //
     /* 199154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199180 */     // (intrinsic_wo_chain:{ *:[i64] } 789:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 199183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199189 */     GIR_RootConstrainSelectedInstOperands,
     /* 199190 */     // GIR_Coverage, 3936,
     /* 199190 */     GIR_EraseRootFromParent_Done,
     /* 199191 */   // Label 3720: @199191
     /* 199191 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(199233), // Rule ID 5226 //
     /* 199196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 199201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199222 */     // (intrinsic_wo_chain:{ *:[v1f64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 199225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199231 */     GIR_RootConstrainSelectedInstOperands,
     /* 199232 */     // GIR_Coverage, 5226,
     /* 199232 */     GIR_EraseRootFromParent_Done,
     /* 199233 */   // Label 3721: @199233
     /* 199233 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(199278), // Rule ID 5230 //
     /* 199238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 199246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199267 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 199270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199276 */     GIR_RootConstrainSelectedInstOperands,
     /* 199277 */     // GIR_Coverage, 5230,
     /* 199277 */     GIR_EraseRootFromParent_Done,
     /* 199278 */   // Label 3722: @199278
     /* 199278 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(199323), // Rule ID 5234 //
     /* 199283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 199291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199312 */     // (intrinsic_wo_chain:{ *:[v1f64] } 620:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 199315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199321 */     GIR_RootConstrainSelectedInstOperands,
     /* 199322 */     // GIR_Coverage, 5234,
     /* 199322 */     GIR_EraseRootFromParent_Done,
     /* 199323 */   // Label 3723: @199323
     /* 199323 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(199368), // Rule ID 5235 //
     /* 199328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 199336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199357 */     // (intrinsic_wo_chain:{ *:[v1f64] } 643:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 199360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199366 */     GIR_RootConstrainSelectedInstOperands,
     /* 199367 */     // GIR_Coverage, 5235,
     /* 199367 */     GIR_EraseRootFromParent_Done,
     /* 199368 */   // Label 3724: @199368
     /* 199368 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(199413), // Rule ID 5236 //
     /* 199373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 199381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199402 */     // (intrinsic_wo_chain:{ *:[v1f64] } 650:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 199405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199411 */     GIR_RootConstrainSelectedInstOperands,
     /* 199412 */     // GIR_Coverage, 5236,
     /* 199412 */     GIR_EraseRootFromParent_Done,
     /* 199413 */   // Label 3725: @199413
     /* 199413 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(199458), // Rule ID 5237 //
     /* 199418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199447 */     // (intrinsic_wo_chain:{ *:[i64] } 701:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 199450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199456 */     GIR_RootConstrainSelectedInstOperands,
     /* 199457 */     // GIR_Coverage, 5237,
     /* 199457 */     GIR_EraseRootFromParent_Done,
     /* 199458 */   // Label 3726: @199458
     /* 199458 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(199503), // Rule ID 5238 //
     /* 199463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199492 */     // (intrinsic_wo_chain:{ *:[i32] } 701:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 199495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199501 */     GIR_RootConstrainSelectedInstOperands,
     /* 199502 */     // GIR_Coverage, 5238,
     /* 199502 */     GIR_EraseRootFromParent_Done,
     /* 199503 */   // Label 3727: @199503
     /* 199503 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(199548), // Rule ID 5239 //
     /* 199508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199537 */     // (intrinsic_wo_chain:{ *:[i64] } 704:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 199540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199546 */     GIR_RootConstrainSelectedInstOperands,
     /* 199547 */     // GIR_Coverage, 5239,
     /* 199547 */     GIR_EraseRootFromParent_Done,
     /* 199548 */   // Label 3728: @199548
     /* 199548 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(199593), // Rule ID 5240 //
     /* 199553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199582 */     // (intrinsic_wo_chain:{ *:[i32] } 704:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 199585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199591 */     GIR_RootConstrainSelectedInstOperands,
     /* 199592 */     // GIR_Coverage, 5240,
     /* 199592 */     GIR_EraseRootFromParent_Done,
     /* 199593 */   // Label 3729: @199593
     /* 199593 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(199638), // Rule ID 5241 //
     /* 199598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 199606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199627 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 199630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199636 */     GIR_RootConstrainSelectedInstOperands,
     /* 199637 */     // GIR_Coverage, 5241,
     /* 199637 */     GIR_EraseRootFromParent_Done,
     /* 199638 */   // Label 3730: @199638
     /* 199638 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(199683), // Rule ID 5242 //
     /* 199643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 199651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199672 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 199675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199681 */     GIR_RootConstrainSelectedInstOperands,
     /* 199682 */     // GIR_Coverage, 5242,
     /* 199682 */     GIR_EraseRootFromParent_Done,
     /* 199683 */   // Label 3731: @199683
     /* 199683 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(199728), // Rule ID 5243 //
     /* 199688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 199696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199717 */     // (intrinsic_wo_chain:{ *:[i64] } 749:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 199720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199726 */     GIR_RootConstrainSelectedInstOperands,
     /* 199727 */     // GIR_Coverage, 5243,
     /* 199727 */     GIR_EraseRootFromParent_Done,
     /* 199728 */   // Label 3732: @199728
     /* 199728 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(199773), // Rule ID 5244 //
     /* 199733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 199741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199762 */     // (intrinsic_wo_chain:{ *:[i32] } 749:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 199765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199771 */     GIR_RootConstrainSelectedInstOperands,
     /* 199772 */     // GIR_Coverage, 5244,
     /* 199772 */     GIR_EraseRootFromParent_Done,
     /* 199773 */   // Label 3733: @199773
     /* 199773 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(199818), // Rule ID 5245 //
     /* 199778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 199786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199807 */     // (intrinsic_wo_chain:{ *:[i64] } 750:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 199810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199816 */     GIR_RootConstrainSelectedInstOperands,
     /* 199817 */     // GIR_Coverage, 5245,
     /* 199817 */     GIR_EraseRootFromParent_Done,
     /* 199818 */   // Label 3734: @199818
     /* 199818 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(199863), // Rule ID 5246 //
     /* 199823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 199831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199852 */     // (intrinsic_wo_chain:{ *:[i32] } 750:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 199855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199861 */     GIR_RootConstrainSelectedInstOperands,
     /* 199862 */     // GIR_Coverage, 5246,
     /* 199862 */     GIR_EraseRootFromParent_Done,
     /* 199863 */   // Label 3735: @199863
     /* 199863 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(199908), // Rule ID 5247 //
     /* 199868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 199876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199897 */     // (intrinsic_wo_chain:{ *:[i64] } 752:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 199900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199906 */     GIR_RootConstrainSelectedInstOperands,
     /* 199907 */     // GIR_Coverage, 5247,
     /* 199907 */     GIR_EraseRootFromParent_Done,
     /* 199908 */   // Label 3736: @199908
     /* 199908 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(199953), // Rule ID 5248 //
     /* 199913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 199921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199942 */     // (intrinsic_wo_chain:{ *:[i32] } 752:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 199945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199951 */     GIR_RootConstrainSelectedInstOperands,
     /* 199952 */     // GIR_Coverage, 5248,
     /* 199952 */     GIR_EraseRootFromParent_Done,
     /* 199953 */   // Label 3737: @199953
     /* 199953 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(199998), // Rule ID 5249 //
     /* 199958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 199966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199987 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 199990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199996 */     GIR_RootConstrainSelectedInstOperands,
     /* 199997 */     // GIR_Coverage, 5249,
     /* 199997 */     GIR_EraseRootFromParent_Done,
     /* 199998 */   // Label 3738: @199998
     /* 199998 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(200043), // Rule ID 5250 //
     /* 200003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 200011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200032 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 200035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200041 */     GIR_RootConstrainSelectedInstOperands,
     /* 200042 */     // GIR_Coverage, 5250,
     /* 200042 */     GIR_EraseRootFromParent_Done,
     /* 200043 */   // Label 3739: @200043
     /* 200043 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(200088), // Rule ID 5269 //
     /* 200048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 200056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200077 */     // (intrinsic_wo_chain:{ *:[v1i64] } 764:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 200077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 200080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200086 */     GIR_RootConstrainSelectedInstOperands,
     /* 200087 */     // GIR_Coverage, 5269,
     /* 200087 */     GIR_EraseRootFromParent_Done,
     /* 200088 */   // Label 3740: @200088
     /* 200088 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(200130), // Rule ID 5603 //
     /* 200093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 200101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 200107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200119 */     // (intrinsic_wo_chain:{ *:[v8i8] } 726:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 200119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 200122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 200128 */     GIR_RootConstrainSelectedInstOperands,
     /* 200129 */     // GIR_Coverage, 5603,
     /* 200129 */     GIR_EraseRootFromParent_Done,
     /* 200130 */   // Label 3741: @200130
     /* 200130 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(200172), // Rule ID 5604 //
     /* 200135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 200143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 200149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 200161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 200164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 200168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200170 */     GIR_RootConstrainSelectedInstOperands,
     /* 200171 */     // GIR_Coverage, 5604,
     /* 200171 */     GIR_EraseRootFromParent_Done,
     /* 200172 */   // Label 3742: @200172
     /* 200172 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(200269), // Rule ID 6331 //
     /* 200177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 200182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200203 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 200210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200268 */     // GIR_Coverage, 6331,
     /* 200268 */     GIR_EraseRootFromParent_Done,
     /* 200269 */   // Label 3743: @200269
     /* 200269 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(200366), // Rule ID 6332 //
     /* 200274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 200279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200300 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 200307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200312 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200365 */     // GIR_Coverage, 6332,
     /* 200365 */     GIR_EraseRootFromParent_Done,
     /* 200366 */   // Label 3744: @200366
     /* 200366 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(200408), // Rule ID 6987 //
     /* 200371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 200376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200397 */     // (intrinsic_wo_chain:{ *:[i64] } 713:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 200400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200406 */     GIR_RootConstrainSelectedInstOperands,
     /* 200407 */     // GIR_Coverage, 6987,
     /* 200407 */     GIR_EraseRootFromParent_Done,
     /* 200408 */   // Label 3745: @200408
     /* 200408 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(200450), // Rule ID 6988 //
     /* 200413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 200418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200439 */     // (intrinsic_wo_chain:{ *:[i64] } 761:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 200442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200448 */     GIR_RootConstrainSelectedInstOperands,
     /* 200449 */     // GIR_Coverage, 6988,
     /* 200449 */     GIR_EraseRootFromParent_Done,
     /* 200450 */   // Label 3746: @200450
     /* 200450 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(200492), // Rule ID 6989 //
     /* 200455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 200460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200481 */     // (intrinsic_wo_chain:{ *:[i64] } 712:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 200484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200490 */     GIR_RootConstrainSelectedInstOperands,
     /* 200491 */     // GIR_Coverage, 6989,
     /* 200491 */     GIR_EraseRootFromParent_Done,
     /* 200492 */   // Label 3747: @200492
     /* 200492 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(200534), // Rule ID 6990 //
     /* 200497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 200502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200523 */     // (intrinsic_wo_chain:{ *:[i64] } 758:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 200526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200532 */     GIR_RootConstrainSelectedInstOperands,
     /* 200533 */     // GIR_Coverage, 6990,
     /* 200533 */     GIR_EraseRootFromParent_Done,
     /* 200534 */   // Label 3748: @200534
     /* 200534 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(200582), // Rule ID 7030 //
     /* 200539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 200544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200565 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 200565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 200568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 200577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 200580 */     GIR_RootConstrainSelectedInstOperands,
     /* 200581 */     // GIR_Coverage, 7030,
     /* 200581 */     GIR_EraseRootFromParent_Done,
     /* 200582 */   // Label 3749: @200582
     /* 200582 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(200627), // Rule ID 10088 //
     /* 200587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200616 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 200619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200625 */     GIR_RootConstrainSelectedInstOperands,
     /* 200626 */     // GIR_Coverage, 10088,
     /* 200626 */     GIR_EraseRootFromParent_Done,
     /* 200627 */   // Label 3750: @200627
     /* 200627 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(200672), // Rule ID 10089 //
     /* 200632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200661 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 200664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200670 */     GIR_RootConstrainSelectedInstOperands,
     /* 200671 */     // GIR_Coverage, 10089,
     /* 200671 */     GIR_EraseRootFromParent_Done,
     /* 200672 */   // Label 3751: @200672
     /* 200672 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(200717), // Rule ID 10090 //
     /* 200677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200706 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 200709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200715 */     GIR_RootConstrainSelectedInstOperands,
     /* 200716 */     // GIR_Coverage, 10090,
     /* 200716 */     GIR_EraseRootFromParent_Done,
     /* 200717 */   // Label 3752: @200717
     /* 200717 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(200762), // Rule ID 10091 //
     /* 200722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200751 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 200754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200760 */     GIR_RootConstrainSelectedInstOperands,
     /* 200761 */     // GIR_Coverage, 10091,
     /* 200761 */     GIR_EraseRootFromParent_Done,
     /* 200762 */   // Label 3753: @200762
     /* 200762 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(200807), // Rule ID 10100 //
     /* 200767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200796 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 200799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200805 */     GIR_RootConstrainSelectedInstOperands,
     /* 200806 */     // GIR_Coverage, 10100,
     /* 200806 */     GIR_EraseRootFromParent_Done,
     /* 200807 */   // Label 3754: @200807
     /* 200807 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(200852), // Rule ID 10101 //
     /* 200812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200841 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 200844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200850 */     GIR_RootConstrainSelectedInstOperands,
     /* 200851 */     // GIR_Coverage, 10101,
     /* 200851 */     GIR_EraseRootFromParent_Done,
     /* 200852 */   // Label 3755: @200852
     /* 200852 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(200897), // Rule ID 10102 //
     /* 200857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200886 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 200889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200895 */     GIR_RootConstrainSelectedInstOperands,
     /* 200896 */     // GIR_Coverage, 10102,
     /* 200896 */     GIR_EraseRootFromParent_Done,
     /* 200897 */   // Label 3756: @200897
     /* 200897 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(200942), // Rule ID 10103 //
     /* 200902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200931 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 200934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200940 */     GIR_RootConstrainSelectedInstOperands,
     /* 200941 */     // GIR_Coverage, 10103,
     /* 200941 */     GIR_EraseRootFromParent_Done,
     /* 200942 */   // Label 3757: @200942
     /* 200942 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(200987), // Rule ID 10104 //
     /* 200947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 200955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200976 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 200979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200985 */     GIR_RootConstrainSelectedInstOperands,
     /* 200986 */     // GIR_Coverage, 10104,
     /* 200986 */     GIR_EraseRootFromParent_Done,
     /* 200987 */   // Label 3758: @200987
     /* 200987 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(201032), // Rule ID 10105 //
     /* 200992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201021 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 201024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201030 */     GIR_RootConstrainSelectedInstOperands,
     /* 201031 */     // GIR_Coverage, 10105,
     /* 201031 */     GIR_EraseRootFromParent_Done,
     /* 201032 */   // Label 3759: @201032
     /* 201032 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(201077), // Rule ID 10106 //
     /* 201037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201066 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 201069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201075 */     GIR_RootConstrainSelectedInstOperands,
     /* 201076 */     // GIR_Coverage, 10106,
     /* 201076 */     GIR_EraseRootFromParent_Done,
     /* 201077 */   // Label 3760: @201077
     /* 201077 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(201122), // Rule ID 10107 //
     /* 201082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201111 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 201114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201120 */     GIR_RootConstrainSelectedInstOperands,
     /* 201121 */     // GIR_Coverage, 10107,
     /* 201121 */     GIR_EraseRootFromParent_Done,
     /* 201122 */   // Label 3761: @201122
     /* 201122 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(201167), // Rule ID 10108 //
     /* 201127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201156 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 201159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201165 */     GIR_RootConstrainSelectedInstOperands,
     /* 201166 */     // GIR_Coverage, 10108,
     /* 201166 */     GIR_EraseRootFromParent_Done,
     /* 201167 */   // Label 3762: @201167
     /* 201167 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(201212), // Rule ID 10109 //
     /* 201172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201201 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 201204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201210 */     GIR_RootConstrainSelectedInstOperands,
     /* 201211 */     // GIR_Coverage, 10109,
     /* 201211 */     GIR_EraseRootFromParent_Done,
     /* 201212 */   // Label 3763: @201212
     /* 201212 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(201257), // Rule ID 10110 //
     /* 201217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201246 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 201249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201255 */     GIR_RootConstrainSelectedInstOperands,
     /* 201256 */     // GIR_Coverage, 10110,
     /* 201256 */     GIR_EraseRootFromParent_Done,
     /* 201257 */   // Label 3764: @201257
     /* 201257 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(201302), // Rule ID 10111 //
     /* 201262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201291 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 201294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201300 */     GIR_RootConstrainSelectedInstOperands,
     /* 201301 */     // GIR_Coverage, 10111,
     /* 201301 */     GIR_EraseRootFromParent_Done,
     /* 201302 */   // Label 3765: @201302
     /* 201302 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(201348), // Rule ID 138 //
     /* 201307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 201315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201325 */     // MIs[0] Rn
     /* 201325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201337 */     // (intrinsic_wo_chain:{ *:[i64] } 565:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 201340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201346 */     GIR_RootConstrainSelectedInstOperands,
     /* 201347 */     // GIR_Coverage, 138,
     /* 201347 */     GIR_EraseRootFromParent_Done,
     /* 201348 */   // Label 3766: @201348
     /* 201348 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(201395), // Rule ID 139 //
     /* 201353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 201361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201368 */     // MIs[0] Rn
     /* 201368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201376 */     // MIs[0] Rm
     /* 201376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 201380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201384 */     // (intrinsic_wo_chain:{ *:[i64] } 1252:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 201384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 201387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201393 */     GIR_RootConstrainSelectedInstOperands,
     /* 201394 */     // GIR_Coverage, 139,
     /* 201394 */     GIR_EraseRootFromParent_Done,
     /* 201395 */   // Label 3767: @201395
     /* 201395 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(201432), // Rule ID 2399 //
     /* 201400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 201408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2161:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 201424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201430 */     GIR_RootConstrainSelectedInstOperands,
     /* 201431 */     // GIR_Coverage, 2399,
     /* 201431 */     GIR_EraseRootFromParent_Done,
     /* 201432 */   // Label 3768: @201432
     /* 201432 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(201469), // Rule ID 2400 //
     /* 201437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 201445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2162:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 201461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201467 */     GIR_RootConstrainSelectedInstOperands,
     /* 201468 */     // GIR_Coverage, 2400,
     /* 201468 */     GIR_EraseRootFromParent_Done,
     /* 201469 */   // Label 3769: @201469
     /* 201469 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(201506), // Rule ID 2401 //
     /* 201474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 201482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201495 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2163:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 201498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201504 */     GIR_RootConstrainSelectedInstOperands,
     /* 201505 */     // GIR_Coverage, 2401,
     /* 201505 */     GIR_EraseRootFromParent_Done,
     /* 201506 */   // Label 3770: @201506
     /* 201506 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(201543), // Rule ID 2403 //
     /* 201511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 201519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2166:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 201535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201541 */     GIR_RootConstrainSelectedInstOperands,
     /* 201542 */     // GIR_Coverage, 2403,
     /* 201542 */     GIR_EraseRootFromParent_Done,
     /* 201543 */   // Label 3771: @201543
     /* 201543 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(201580), // Rule ID 2404 //
     /* 201548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 201556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201569 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2167:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 201572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201578 */     GIR_RootConstrainSelectedInstOperands,
     /* 201579 */     // GIR_Coverage, 2404,
     /* 201579 */     GIR_EraseRootFromParent_Done,
     /* 201580 */   // Label 3772: @201580
     /* 201580 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(201617), // Rule ID 2405 //
     /* 201585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 201593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2168:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 201609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201615 */     GIR_RootConstrainSelectedInstOperands,
     /* 201616 */     // GIR_Coverage, 2405,
     /* 201616 */     GIR_EraseRootFromParent_Done,
     /* 201617 */   // Label 3773: @201617
     /* 201617 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(201654), // Rule ID 2407 //
     /* 201622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 201630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2087:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 201646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201652 */     GIR_RootConstrainSelectedInstOperands,
     /* 201653 */     // GIR_Coverage, 2407,
     /* 201653 */     GIR_EraseRootFromParent_Done,
     /* 201654 */   // Label 3774: @201654
     /* 201654 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(201691), // Rule ID 2408 //
     /* 201659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 201667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 201683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201689 */     GIR_RootConstrainSelectedInstOperands,
     /* 201690 */     // GIR_Coverage, 2408,
     /* 201690 */     GIR_EraseRootFromParent_Done,
     /* 201691 */   // Label 3775: @201691
     /* 201691 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(201728), // Rule ID 2409 //
     /* 201696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 201704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2089:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 201720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201726 */     GIR_RootConstrainSelectedInstOperands,
     /* 201727 */     // GIR_Coverage, 2409,
     /* 201727 */     GIR_EraseRootFromParent_Done,
     /* 201728 */   // Label 3776: @201728
     /* 201728 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(201765), // Rule ID 2411 //
     /* 201733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 201741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2092:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 201757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201763 */     GIR_RootConstrainSelectedInstOperands,
     /* 201764 */     // GIR_Coverage, 2411,
     /* 201764 */     GIR_EraseRootFromParent_Done,
     /* 201765 */   // Label 3777: @201765
     /* 201765 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(201802), // Rule ID 2412 //
     /* 201770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 201778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2093:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 201794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201800 */     GIR_RootConstrainSelectedInstOperands,
     /* 201801 */     // GIR_Coverage, 2412,
     /* 201801 */     GIR_EraseRootFromParent_Done,
     /* 201802 */   // Label 3778: @201802
     /* 201802 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(201839), // Rule ID 2413 //
     /* 201807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 201815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 201831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201837 */     GIR_RootConstrainSelectedInstOperands,
     /* 201838 */     // GIR_Coverage, 2413,
     /* 201838 */     GIR_EraseRootFromParent_Done,
     /* 201839 */   // Label 3779: @201839
     /* 201839 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(201876), // Rule ID 2415 //
     /* 201844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 201852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1931:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 201868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201874 */     GIR_RootConstrainSelectedInstOperands,
     /* 201875 */     // GIR_Coverage, 2415,
     /* 201875 */     GIR_EraseRootFromParent_Done,
     /* 201876 */   // Label 3780: @201876
     /* 201876 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(201913), // Rule ID 2416 //
     /* 201881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 201889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1932:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 201905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201911 */     GIR_RootConstrainSelectedInstOperands,
     /* 201912 */     // GIR_Coverage, 2416,
     /* 201912 */     GIR_EraseRootFromParent_Done,
     /* 201913 */   // Label 3781: @201913
     /* 201913 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(201950), // Rule ID 2417 //
     /* 201918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 201926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201939 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 201942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201948 */     GIR_RootConstrainSelectedInstOperands,
     /* 201949 */     // GIR_Coverage, 2417,
     /* 201949 */     GIR_EraseRootFromParent_Done,
     /* 201950 */   // Label 3782: @201950
     /* 201950 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(201987), // Rule ID 2419 //
     /* 201955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 201963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201976 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1936:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 201979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201985 */     GIR_RootConstrainSelectedInstOperands,
     /* 201986 */     // GIR_Coverage, 2419,
     /* 201986 */     GIR_EraseRootFromParent_Done,
     /* 201987 */   // Label 3783: @201987
     /* 201987 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(202024), // Rule ID 2420 //
     /* 201992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 202000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202013 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1937:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 202016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202022 */     GIR_RootConstrainSelectedInstOperands,
     /* 202023 */     // GIR_Coverage, 2420,
     /* 202023 */     GIR_EraseRootFromParent_Done,
     /* 202024 */   // Label 3784: @202024
     /* 202024 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(202061), // Rule ID 2421 //
     /* 202029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 202037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1938:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 202053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202059 */     GIR_RootConstrainSelectedInstOperands,
     /* 202060 */     // GIR_Coverage, 2421,
     /* 202060 */     GIR_EraseRootFromParent_Done,
     /* 202061 */   // Label 3785: @202061
     /* 202061 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(202098), // Rule ID 2422 //
     /* 202066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 202069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 202074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202087 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1556:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 202087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 202090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 202096 */     GIR_RootConstrainSelectedInstOperands,
     /* 202097 */     // GIR_Coverage, 2422,
     /* 202097 */     GIR_EraseRootFromParent_Done,
     /* 202098 */   // Label 3786: @202098
     /* 202098 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(202138), // Rule ID 2617 //
     /* 202103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 202111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1635:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 202127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202136 */     GIR_RootConstrainSelectedInstOperands,
     /* 202137 */     // GIR_Coverage, 2617,
     /* 202137 */     GIR_EraseRootFromParent_Done,
     /* 202138 */   // Label 3787: @202138
     /* 202138 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(202178), // Rule ID 2618 //
     /* 202143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202164 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1643:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 202167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202176 */     GIR_RootConstrainSelectedInstOperands,
     /* 202177 */     // GIR_Coverage, 2618,
     /* 202177 */     GIR_EraseRootFromParent_Done,
     /* 202178 */   // Label 3788: @202178
     /* 202178 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(202218), // Rule ID 2619 //
     /* 202183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 202194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1643:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 202207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202216 */     GIR_RootConstrainSelectedInstOperands,
     /* 202217 */     // GIR_Coverage, 2619,
     /* 202217 */     GIR_EraseRootFromParent_Done,
     /* 202218 */   // Label 3789: @202218
     /* 202218 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(202258), // Rule ID 2620 //
     /* 202223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1643:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 202247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202256 */     GIR_RootConstrainSelectedInstOperands,
     /* 202257 */     // GIR_Coverage, 2620,
     /* 202257 */     GIR_EraseRootFromParent_Done,
     /* 202258 */   // Label 3790: @202258
     /* 202258 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(202298), // Rule ID 2621 //
     /* 202263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1643:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 202287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202296 */     GIR_RootConstrainSelectedInstOperands,
     /* 202297 */     // GIR_Coverage, 2621,
     /* 202297 */     GIR_EraseRootFromParent_Done,
     /* 202298 */   // Label 3791: @202298
     /* 202298 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(202335), // Rule ID 2638 //
     /* 202303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 202327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202333 */     GIR_RootConstrainSelectedInstOperands,
     /* 202334 */     // GIR_Coverage, 2638,
     /* 202334 */     GIR_EraseRootFromParent_Done,
     /* 202335 */   // Label 3792: @202335
     /* 202335 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(202372), // Rule ID 2639 //
     /* 202340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 202364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202370 */     GIR_RootConstrainSelectedInstOperands,
     /* 202371 */     // GIR_Coverage, 2639,
     /* 202371 */     GIR_EraseRootFromParent_Done,
     /* 202372 */   // Label 3793: @202372
     /* 202372 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(202409), // Rule ID 2640 //
     /* 202377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 202401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202407 */     GIR_RootConstrainSelectedInstOperands,
     /* 202408 */     // GIR_Coverage, 2640,
     /* 202408 */     GIR_EraseRootFromParent_Done,
     /* 202409 */   // Label 3794: @202409
     /* 202409 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(202446), // Rule ID 2641 //
     /* 202414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202435 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 202438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202444 */     GIR_RootConstrainSelectedInstOperands,
     /* 202445 */     // GIR_Coverage, 2641,
     /* 202445 */     GIR_EraseRootFromParent_Done,
     /* 202446 */   // Label 3795: @202446
     /* 202446 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(202483), // Rule ID 2642 //
     /* 202451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202472 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 202475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202481 */     GIR_RootConstrainSelectedInstOperands,
     /* 202482 */     // GIR_Coverage, 2642,
     /* 202482 */     GIR_EraseRootFromParent_Done,
     /* 202483 */   // Label 3796: @202483
     /* 202483 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(202520), // Rule ID 2643 //
     /* 202488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202509 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 202512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202518 */     GIR_RootConstrainSelectedInstOperands,
     /* 202519 */     // GIR_Coverage, 2643,
     /* 202519 */     GIR_EraseRootFromParent_Done,
     /* 202520 */   // Label 3797: @202520
     /* 202520 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(202557), // Rule ID 2644 //
     /* 202525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202546 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 202549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202555 */     GIR_RootConstrainSelectedInstOperands,
     /* 202556 */     // GIR_Coverage, 2644,
     /* 202556 */     GIR_EraseRootFromParent_Done,
     /* 202557 */   // Label 3798: @202557
     /* 202557 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(202594), // Rule ID 2822 //
     /* 202562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202583 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1553:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 202586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202592 */     GIR_RootConstrainSelectedInstOperands,
     /* 202593 */     // GIR_Coverage, 2822,
     /* 202593 */     GIR_EraseRootFromParent_Done,
     /* 202594 */   // Label 3799: @202594
     /* 202594 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(202631), // Rule ID 2823 //
     /* 202599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1553:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 202623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202629 */     GIR_RootConstrainSelectedInstOperands,
     /* 202630 */     // GIR_Coverage, 2823,
     /* 202630 */     GIR_EraseRootFromParent_Done,
     /* 202631 */   // Label 3800: @202631
     /* 202631 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(202668), // Rule ID 2824 //
     /* 202636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1553:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 202660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202666 */     GIR_RootConstrainSelectedInstOperands,
     /* 202667 */     // GIR_Coverage, 2824,
     /* 202667 */     GIR_EraseRootFromParent_Done,
     /* 202668 */   // Label 3801: @202668
     /* 202668 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(202705), // Rule ID 2995 //
     /* 202673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 202697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202703 */     GIR_RootConstrainSelectedInstOperands,
     /* 202704 */     // GIR_Coverage, 2995,
     /* 202704 */     GIR_EraseRootFromParent_Done,
     /* 202705 */   // Label 3802: @202705
     /* 202705 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(202742), // Rule ID 2996 //
     /* 202710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 202734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202740 */     GIR_RootConstrainSelectedInstOperands,
     /* 202741 */     // GIR_Coverage, 2996,
     /* 202741 */     GIR_EraseRootFromParent_Done,
     /* 202742 */   // Label 3803: @202742
     /* 202742 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(202779), // Rule ID 2997 //
     /* 202747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 202771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202777 */     GIR_RootConstrainSelectedInstOperands,
     /* 202778 */     // GIR_Coverage, 2997,
     /* 202778 */     GIR_EraseRootFromParent_Done,
     /* 202779 */   // Label 3804: @202779
     /* 202779 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(202816), // Rule ID 2998 //
     /* 202784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202805 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 202808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202814 */     GIR_RootConstrainSelectedInstOperands,
     /* 202815 */     // GIR_Coverage, 2998,
     /* 202815 */     GIR_EraseRootFromParent_Done,
     /* 202816 */   // Label 3805: @202816
     /* 202816 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(202853), // Rule ID 2999 //
     /* 202821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 202829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1640:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 202845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202851 */     GIR_RootConstrainSelectedInstOperands,
     /* 202852 */     // GIR_Coverage, 2999,
     /* 202852 */     GIR_EraseRootFromParent_Done,
     /* 202853 */   // Label 3806: @202853
     /* 202853 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(202890), // Rule ID 3021 //
     /* 202858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1698:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 202882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202888 */     GIR_RootConstrainSelectedInstOperands,
     /* 202889 */     // GIR_Coverage, 3021,
     /* 202889 */     GIR_EraseRootFromParent_Done,
     /* 202890 */   // Label 3807: @202890
     /* 202890 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(202927), // Rule ID 3022 //
     /* 202895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 202919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202925 */     GIR_RootConstrainSelectedInstOperands,
     /* 202926 */     // GIR_Coverage, 3022,
     /* 202926 */     GIR_EraseRootFromParent_Done,
     /* 202927 */   // Label 3808: @202927
     /* 202927 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(202964), // Rule ID 3023 //
     /* 202932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 202956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202962 */     GIR_RootConstrainSelectedInstOperands,
     /* 202963 */     // GIR_Coverage, 3023,
     /* 202963 */     GIR_EraseRootFromParent_Done,
     /* 202964 */   // Label 3809: @202964
     /* 202964 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(203001), // Rule ID 3027 //
     /* 202969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 202972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 202977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1641:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 202993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202999 */     GIR_RootConstrainSelectedInstOperands,
     /* 203000 */     // GIR_Coverage, 3027,
     /* 203000 */     GIR_EraseRootFromParent_Done,
     /* 203001 */   // Label 3810: @203001
     /* 203001 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(203038), // Rule ID 3028 //
     /* 203006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1641:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 203030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203036 */     GIR_RootConstrainSelectedInstOperands,
     /* 203037 */     // GIR_Coverage, 3028,
     /* 203037 */     GIR_EraseRootFromParent_Done,
     /* 203038 */   // Label 3811: @203038
     /* 203038 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(203075), // Rule ID 3029 //
     /* 203043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1641:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 203067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203073 */     GIR_RootConstrainSelectedInstOperands,
     /* 203074 */     // GIR_Coverage, 3029,
     /* 203074 */     GIR_EraseRootFromParent_Done,
     /* 203075 */   // Label 3812: @203075
     /* 203075 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(203112), // Rule ID 3030 //
     /* 203080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1283:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 203104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203110 */     GIR_RootConstrainSelectedInstOperands,
     /* 203111 */     // GIR_Coverage, 3030,
     /* 203111 */     GIR_EraseRootFromParent_Done,
     /* 203112 */   // Label 3813: @203112
     /* 203112 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(203149), // Rule ID 3031 //
     /* 203117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1283:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 203141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203147 */     GIR_RootConstrainSelectedInstOperands,
     /* 203148 */     // GIR_Coverage, 3031,
     /* 203148 */     GIR_EraseRootFromParent_Done,
     /* 203149 */   // Label 3814: @203149
     /* 203149 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(203186), // Rule ID 3032 //
     /* 203154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1283:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 203178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203184 */     GIR_RootConstrainSelectedInstOperands,
     /* 203185 */     // GIR_Coverage, 3032,
     /* 203185 */     GIR_EraseRootFromParent_Done,
     /* 203186 */   // Label 3815: @203186
     /* 203186 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(203223), // Rule ID 3033 //
     /* 203191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1283:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 203215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203221 */     GIR_RootConstrainSelectedInstOperands,
     /* 203222 */     // GIR_Coverage, 3033,
     /* 203222 */     GIR_EraseRootFromParent_Done,
     /* 203223 */   // Label 3816: @203223
     /* 203223 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(203260), // Rule ID 3034 //
     /* 203228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 203252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203258 */     GIR_RootConstrainSelectedInstOperands,
     /* 203259 */     // GIR_Coverage, 3034,
     /* 203259 */     GIR_EraseRootFromParent_Done,
     /* 203260 */   // Label 3817: @203260
     /* 203260 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(203297), // Rule ID 3035 //
     /* 203265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 203289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203295 */     GIR_RootConstrainSelectedInstOperands,
     /* 203296 */     // GIR_Coverage, 3035,
     /* 203296 */     GIR_EraseRootFromParent_Done,
     /* 203297 */   // Label 3818: @203297
     /* 203297 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(203334), // Rule ID 3036 //
     /* 203302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203332 */     GIR_RootConstrainSelectedInstOperands,
     /* 203333 */     // GIR_Coverage, 3036,
     /* 203333 */     GIR_EraseRootFromParent_Done,
     /* 203334 */   // Label 3819: @203334
     /* 203334 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(203371), // Rule ID 3083 //
     /* 203339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 203363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203369 */     GIR_RootConstrainSelectedInstOperands,
     /* 203370 */     // GIR_Coverage, 3083,
     /* 203370 */     GIR_EraseRootFromParent_Done,
     /* 203371 */   // Label 3820: @203371
     /* 203371 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(203408), // Rule ID 3084 //
     /* 203376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1260:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 203400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203406 */     GIR_RootConstrainSelectedInstOperands,
     /* 203407 */     // GIR_Coverage, 3084,
     /* 203407 */     GIR_EraseRootFromParent_Done,
     /* 203408 */   // Label 3821: @203408
     /* 203408 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(203445), // Rule ID 3085 //
     /* 203413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 203437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203443 */     GIR_RootConstrainSelectedInstOperands,
     /* 203444 */     // GIR_Coverage, 3085,
     /* 203444 */     GIR_EraseRootFromParent_Done,
     /* 203445 */   // Label 3822: @203445
     /* 203445 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(203482), // Rule ID 3092 //
     /* 203450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 203474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203480 */     GIR_RootConstrainSelectedInstOperands,
     /* 203481 */     // GIR_Coverage, 3092,
     /* 203481 */     GIR_EraseRootFromParent_Done,
     /* 203482 */   // Label 3823: @203482
     /* 203482 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(203519), // Rule ID 3093 //
     /* 203487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 203511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203517 */     GIR_RootConstrainSelectedInstOperands,
     /* 203518 */     // GIR_Coverage, 3093,
     /* 203518 */     GIR_EraseRootFromParent_Done,
     /* 203519 */   // Label 3824: @203519
     /* 203519 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(203556), // Rule ID 3094 //
     /* 203524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 203548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203554 */     GIR_RootConstrainSelectedInstOperands,
     /* 203555 */     // GIR_Coverage, 3094,
     /* 203555 */     GIR_EraseRootFromParent_Done,
     /* 203556 */   // Label 3825: @203556
     /* 203556 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(203596), // Rule ID 3198 //
     /* 203561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 203585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203594 */     GIR_RootConstrainSelectedInstOperands,
     /* 203595 */     // GIR_Coverage, 3198,
     /* 203595 */     GIR_EraseRootFromParent_Done,
     /* 203596 */   // Label 3826: @203596
     /* 203596 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(203636), // Rule ID 3199 //
     /* 203601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 203612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 203625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203634 */     GIR_RootConstrainSelectedInstOperands,
     /* 203635 */     // GIR_Coverage, 3199,
     /* 203635 */     GIR_EraseRootFromParent_Done,
     /* 203636 */   // Label 3827: @203636
     /* 203636 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(203676), // Rule ID 3200 //
     /* 203641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 203652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 203665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203674 */     GIR_RootConstrainSelectedInstOperands,
     /* 203675 */     // GIR_Coverage, 3200,
     /* 203675 */     GIR_EraseRootFromParent_Done,
     /* 203676 */   // Label 3828: @203676
     /* 203676 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(203716), // Rule ID 3201 //
     /* 203681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 203692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 203705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203714 */     GIR_RootConstrainSelectedInstOperands,
     /* 203715 */     // GIR_Coverage, 3201,
     /* 203715 */     GIR_EraseRootFromParent_Done,
     /* 203716 */   // Label 3829: @203716
     /* 203716 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(203756), // Rule ID 3206 //
     /* 203721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 203745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203754 */     GIR_RootConstrainSelectedInstOperands,
     /* 203755 */     // GIR_Coverage, 3206,
     /* 203755 */     GIR_EraseRootFromParent_Done,
     /* 203756 */   // Label 3830: @203756
     /* 203756 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(203796), // Rule ID 3207 //
     /* 203761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 203772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 203785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203794 */     GIR_RootConstrainSelectedInstOperands,
     /* 203795 */     // GIR_Coverage, 3207,
     /* 203795 */     GIR_EraseRootFromParent_Done,
     /* 203796 */   // Label 3831: @203796
     /* 203796 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(203836), // Rule ID 3208 //
     /* 203801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 203812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 203825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203834 */     GIR_RootConstrainSelectedInstOperands,
     /* 203835 */     // GIR_Coverage, 3208,
     /* 203835 */     GIR_EraseRootFromParent_Done,
     /* 203836 */   // Label 3832: @203836
     /* 203836 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(203876), // Rule ID 3209 //
     /* 203841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 203852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 203865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203874 */     GIR_RootConstrainSelectedInstOperands,
     /* 203875 */     // GIR_Coverage, 3209,
     /* 203875 */     GIR_EraseRootFromParent_Done,
     /* 203876 */   // Label 3833: @203876
     /* 203876 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(203913), // Rule ID 3398 //
     /* 203881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 203905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203911 */     GIR_RootConstrainSelectedInstOperands,
     /* 203912 */     // GIR_Coverage, 3398,
     /* 203912 */     GIR_EraseRootFromParent_Done,
     /* 203913 */   // Label 3834: @203913
     /* 203913 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(203950), // Rule ID 3399 //
     /* 203918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 203939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 203942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203948 */     GIR_RootConstrainSelectedInstOperands,
     /* 203949 */     // GIR_Coverage, 3399,
     /* 203949 */     GIR_EraseRootFromParent_Done,
     /* 203950 */   // Label 3835: @203950
     /* 203950 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(203987), // Rule ID 3400 //
     /* 203955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 203979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203985 */     GIR_RootConstrainSelectedInstOperands,
     /* 203986 */     // GIR_Coverage, 3400,
     /* 203986 */     GIR_EraseRootFromParent_Done,
     /* 203987 */   // Label 3836: @203987
     /* 203987 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(204024), // Rule ID 3401 //
     /* 203992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 204016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204022 */     GIR_RootConstrainSelectedInstOperands,
     /* 204023 */     // GIR_Coverage, 3401,
     /* 204023 */     GIR_EraseRootFromParent_Done,
     /* 204024 */   // Label 3837: @204024
     /* 204024 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(204061), // Rule ID 3402 //
     /* 204029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (COMPACT_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_B),
     /* 204053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204059 */     GIR_RootConstrainSelectedInstOperands,
     /* 204060 */     // GIR_Coverage, 3402,
     /* 204060 */     GIR_EraseRootFromParent_Done,
     /* 204061 */   // Label 3838: @204061
     /* 204061 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(204098), // Rule ID 3403 //
     /* 204066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (COMPACT_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_H),
     /* 204090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204096 */     GIR_RootConstrainSelectedInstOperands,
     /* 204097 */     // GIR_Coverage, 3403,
     /* 204097 */     GIR_EraseRootFromParent_Done,
     /* 204098 */   // Label 3839: @204098
     /* 204098 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(204135), // Rule ID 3404 //
     /* 204103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204124 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (COMPACT_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_H),
     /* 204127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204133 */     GIR_RootConstrainSelectedInstOperands,
     /* 204134 */     // GIR_Coverage, 3404,
     /* 204134 */     GIR_EraseRootFromParent_Done,
     /* 204135 */   // Label 3840: @204135
     /* 204135 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(204172), // Rule ID 3426 //
     /* 204140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204161 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1554:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 204164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204170 */     GIR_RootConstrainSelectedInstOperands,
     /* 204171 */     // GIR_Coverage, 3426,
     /* 204171 */     GIR_EraseRootFromParent_Done,
     /* 204172 */   // Label 3841: @204172
     /* 204172 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(204209), // Rule ID 3427 //
     /* 204177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204198 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1554:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 204201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204207 */     GIR_RootConstrainSelectedInstOperands,
     /* 204208 */     // GIR_Coverage, 3427,
     /* 204208 */     GIR_EraseRootFromParent_Done,
     /* 204209 */   // Label 3842: @204209
     /* 204209 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(204246), // Rule ID 3428 //
     /* 204214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204235 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1554:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 204238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204244 */     GIR_RootConstrainSelectedInstOperands,
     /* 204245 */     // GIR_Coverage, 3428,
     /* 204245 */     GIR_EraseRootFromParent_Done,
     /* 204246 */   // Label 3843: @204246
     /* 204246 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(204283), // Rule ID 3450 //
     /* 204251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 204259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204272 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1304:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 204275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204281 */     GIR_RootConstrainSelectedInstOperands,
     /* 204282 */     // GIR_Coverage, 3450,
     /* 204282 */     GIR_EraseRootFromParent_Done,
     /* 204283 */   // Label 3844: @204283
     /* 204283 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(204320), // Rule ID 3455 //
     /* 204288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 204291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 204296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 204312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204318 */     GIR_RootConstrainSelectedInstOperands,
     /* 204319 */     // GIR_Coverage, 3455,
     /* 204319 */     GIR_EraseRootFromParent_Done,
     /* 204320 */   // Label 3845: @204320
     /* 204320 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(204357), // Rule ID 3464 //
     /* 204325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204355 */     GIR_RootConstrainSelectedInstOperands,
     /* 204356 */     // GIR_Coverage, 3464,
     /* 204356 */     GIR_EraseRootFromParent_Done,
     /* 204357 */   // Label 3846: @204357
     /* 204357 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(204394), // Rule ID 3465 //
     /* 204362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2164:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204392 */     GIR_RootConstrainSelectedInstOperands,
     /* 204393 */     // GIR_Coverage, 3465,
     /* 204393 */     GIR_EraseRootFromParent_Done,
     /* 204394 */   // Label 3847: @204394
     /* 204394 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(204431), // Rule ID 3466 //
     /* 204399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2164:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204429 */     GIR_RootConstrainSelectedInstOperands,
     /* 204430 */     // GIR_Coverage, 3466,
     /* 204430 */     GIR_EraseRootFromParent_Done,
     /* 204431 */   // Label 3848: @204431
     /* 204431 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(204468), // Rule ID 3467 //
     /* 204436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2164:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204466 */     GIR_RootConstrainSelectedInstOperands,
     /* 204467 */     // GIR_Coverage, 3467,
     /* 204467 */     GIR_EraseRootFromParent_Done,
     /* 204468 */   // Label 3849: @204468
     /* 204468 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(204505), // Rule ID 3468 //
     /* 204473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204494 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2164:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204503 */     GIR_RootConstrainSelectedInstOperands,
     /* 204504 */     // GIR_Coverage, 3468,
     /* 204504 */     GIR_EraseRootFromParent_Done,
     /* 204505 */   // Label 3850: @204505
     /* 204505 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(204542), // Rule ID 3469 //
     /* 204510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2164:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204540 */     GIR_RootConstrainSelectedInstOperands,
     /* 204541 */     // GIR_Coverage, 3469,
     /* 204541 */     GIR_EraseRootFromParent_Done,
     /* 204542 */   // Label 3851: @204542
     /* 204542 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(204579), // Rule ID 3470 //
     /* 204547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204568 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2164:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204577 */     GIR_RootConstrainSelectedInstOperands,
     /* 204578 */     // GIR_Coverage, 3470,
     /* 204578 */     GIR_EraseRootFromParent_Done,
     /* 204579 */   // Label 3852: @204579
     /* 204579 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(204616), // Rule ID 3525 //
     /* 204584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204605 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1377:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 204608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204614 */     GIR_RootConstrainSelectedInstOperands,
     /* 204615 */     // GIR_Coverage, 3525,
     /* 204615 */     GIR_EraseRootFromParent_Done,
     /* 204616 */   // Label 3853: @204616
     /* 204616 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(204653), // Rule ID 3526 //
     /* 204621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204642 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 204645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204651 */     GIR_RootConstrainSelectedInstOperands,
     /* 204652 */     // GIR_Coverage, 3526,
     /* 204652 */     GIR_EraseRootFromParent_Done,
     /* 204653 */   // Label 3854: @204653
     /* 204653 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(204690), // Rule ID 3527 //
     /* 204658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 204669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204679 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 204682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204688 */     GIR_RootConstrainSelectedInstOperands,
     /* 204689 */     // GIR_Coverage, 3527,
     /* 204689 */     GIR_EraseRootFromParent_Done,
     /* 204690 */   // Label 3855: @204690
     /* 204690 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(204727), // Rule ID 3557 //
     /* 204695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 204706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204716 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1628:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 204719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204725 */     GIR_RootConstrainSelectedInstOperands,
     /* 204726 */     // GIR_Coverage, 3557,
     /* 204726 */     GIR_EraseRootFromParent_Done,
     /* 204727 */   // Label 3856: @204727
     /* 204727 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(204764), // Rule ID 3558 //
     /* 204732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204753 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1628:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 204756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204762 */     GIR_RootConstrainSelectedInstOperands,
     /* 204763 */     // GIR_Coverage, 3558,
     /* 204763 */     GIR_EraseRootFromParent_Done,
     /* 204764 */   // Label 3857: @204764
     /* 204764 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(204801), // Rule ID 3559 //
     /* 204769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204790 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1628:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 204793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204799 */     GIR_RootConstrainSelectedInstOperands,
     /* 204800 */     // GIR_Coverage, 3559,
     /* 204800 */     GIR_EraseRootFromParent_Done,
     /* 204801 */   // Label 3858: @204801
     /* 204801 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(204838), // Rule ID 3560 //
     /* 204806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 204817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204827 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1628:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 204830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204836 */     GIR_RootConstrainSelectedInstOperands,
     /* 204837 */     // GIR_Coverage, 3560,
     /* 204837 */     GIR_EraseRootFromParent_Done,
     /* 204838 */   // Label 3859: @204838
     /* 204838 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(204875), // Rule ID 3561 //
     /* 204843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2172:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 204867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204873 */     GIR_RootConstrainSelectedInstOperands,
     /* 204874 */     // GIR_Coverage, 3561,
     /* 204874 */     GIR_EraseRootFromParent_Done,
     /* 204875 */   // Label 3860: @204875
     /* 204875 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(204912), // Rule ID 3562 //
     /* 204880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2172:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 204904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204910 */     GIR_RootConstrainSelectedInstOperands,
     /* 204911 */     // GIR_Coverage, 3562,
     /* 204911 */     GIR_EraseRootFromParent_Done,
     /* 204912 */   // Label 3861: @204912
     /* 204912 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(204949), // Rule ID 3563 //
     /* 204917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2172:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 204941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204947 */     GIR_RootConstrainSelectedInstOperands,
     /* 204948 */     // GIR_Coverage, 3563,
     /* 204948 */     GIR_EraseRootFromParent_Done,
     /* 204949 */   // Label 3862: @204949
     /* 204949 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(204986), // Rule ID 3564 //
     /* 204954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2172:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 204978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204984 */     GIR_RootConstrainSelectedInstOperands,
     /* 204985 */     // GIR_Coverage, 3564,
     /* 204985 */     GIR_EraseRootFromParent_Done,
     /* 204986 */   // Label 3863: @204986
     /* 204986 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(205023), // Rule ID 3565 //
     /* 204991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205012 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2172:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 205015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205021 */     GIR_RootConstrainSelectedInstOperands,
     /* 205022 */     // GIR_Coverage, 3565,
     /* 205022 */     GIR_EraseRootFromParent_Done,
     /* 205023 */   // Label 3864: @205023
     /* 205023 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(205060), // Rule ID 3566 //
     /* 205028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205049 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2172:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 205052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205058 */     GIR_RootConstrainSelectedInstOperands,
     /* 205059 */     // GIR_Coverage, 3566,
     /* 205059 */     GIR_EraseRootFromParent_Done,
     /* 205060 */   // Label 3865: @205060
     /* 205060 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(205097), // Rule ID 3567 //
     /* 205065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205086 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2172:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 205089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205095 */     GIR_RootConstrainSelectedInstOperands,
     /* 205096 */     // GIR_Coverage, 3567,
     /* 205096 */     GIR_EraseRootFromParent_Done,
     /* 205097 */   // Label 3866: @205097
     /* 205097 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(205134), // Rule ID 3568 //
     /* 205102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205123 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1927:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 205126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205132 */     GIR_RootConstrainSelectedInstOperands,
     /* 205133 */     // GIR_Coverage, 3568,
     /* 205133 */     GIR_EraseRootFromParent_Done,
     /* 205134 */   // Label 3867: @205134
     /* 205134 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(205171), // Rule ID 3569 //
     /* 205139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205169 */     GIR_RootConstrainSelectedInstOperands,
     /* 205170 */     // GIR_Coverage, 3569,
     /* 205170 */     GIR_EraseRootFromParent_Done,
     /* 205171 */   // Label 3868: @205171
     /* 205171 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(205208), // Rule ID 3570 //
     /* 205176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1927:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205206 */     GIR_RootConstrainSelectedInstOperands,
     /* 205207 */     // GIR_Coverage, 3570,
     /* 205207 */     GIR_EraseRootFromParent_Done,
     /* 205208 */   // Label 3869: @205208
     /* 205208 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(205245), // Rule ID 3571 //
     /* 205213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1927:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205243 */     GIR_RootConstrainSelectedInstOperands,
     /* 205244 */     // GIR_Coverage, 3571,
     /* 205244 */     GIR_EraseRootFromParent_Done,
     /* 205245 */   // Label 3870: @205245
     /* 205245 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(205282), // Rule ID 3572 //
     /* 205250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205271 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1927:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205280 */     GIR_RootConstrainSelectedInstOperands,
     /* 205281 */     // GIR_Coverage, 3572,
     /* 205281 */     GIR_EraseRootFromParent_Done,
     /* 205282 */   // Label 3871: @205282
     /* 205282 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(205319), // Rule ID 3573 //
     /* 205287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205308 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1927:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205317 */     GIR_RootConstrainSelectedInstOperands,
     /* 205318 */     // GIR_Coverage, 3573,
     /* 205318 */     GIR_EraseRootFromParent_Done,
     /* 205319 */   // Label 3872: @205319
     /* 205319 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(205356), // Rule ID 3574 //
     /* 205324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205345 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1927:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205354 */     GIR_RootConstrainSelectedInstOperands,
     /* 205355 */     // GIR_Coverage, 3574,
     /* 205355 */     GIR_EraseRootFromParent_Done,
     /* 205356 */   // Label 3873: @205356
     /* 205356 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(205393), // Rule ID 8471 //
     /* 205361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 205369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 205375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 205378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205382 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 205382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 205385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205391 */     GIR_RootConstrainSelectedInstOperands,
     /* 205392 */     // GIR_Coverage, 8471,
     /* 205392 */     GIR_EraseRootFromParent_Done,
     /* 205393 */   // Label 3874: @205393
     /* 205393 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(205430), // Rule ID 8947 //
     /* 205398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1264:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 205422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205428 */     GIR_RootConstrainSelectedInstOperands,
     /* 205429 */     // GIR_Coverage, 8947,
     /* 205429 */     GIR_EraseRootFromParent_Done,
     /* 205430 */   // Label 3875: @205430
     /* 205430 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(205467), // Rule ID 8948 //
     /* 205435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1266:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 205459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205465 */     GIR_RootConstrainSelectedInstOperands,
     /* 205466 */     // GIR_Coverage, 8948,
     /* 205466 */     GIR_EraseRootFromParent_Done,
     /* 205467 */   // Label 3876: @205467
     /* 205467 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(205504), // Rule ID 8949 //
     /* 205472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 205480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 205496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205502 */     GIR_RootConstrainSelectedInstOperands,
     /* 205503 */     // GIR_Coverage, 8949,
     /* 205503 */     GIR_EraseRootFromParent_Done,
     /* 205504 */   // Label 3877: @205504
     /* 205504 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(205541), // Rule ID 8950 //
     /* 205509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 205517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1265:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 205533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205539 */     GIR_RootConstrainSelectedInstOperands,
     /* 205540 */     // GIR_Coverage, 8950,
     /* 205540 */     GIR_EraseRootFromParent_Done,
     /* 205541 */   // Label 3878: @205541
     /* 205541 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(205578), // Rule ID 8951 //
     /* 205546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1264:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 205570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205576 */     GIR_RootConstrainSelectedInstOperands,
     /* 205577 */     // GIR_Coverage, 8951,
     /* 205577 */     GIR_EraseRootFromParent_Done,
     /* 205578 */   // Label 3879: @205578
     /* 205578 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(205615), // Rule ID 8952 //
     /* 205583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1266:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 205607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205613 */     GIR_RootConstrainSelectedInstOperands,
     /* 205614 */     // GIR_Coverage, 8952,
     /* 205614 */     GIR_EraseRootFromParent_Done,
     /* 205615 */   // Label 3880: @205615
     /* 205615 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(205652), // Rule ID 8953 //
     /* 205620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 205628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205641 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 205644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205650 */     GIR_RootConstrainSelectedInstOperands,
     /* 205651 */     // GIR_Coverage, 8953,
     /* 205651 */     GIR_EraseRootFromParent_Done,
     /* 205652 */   // Label 3881: @205652
     /* 205652 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(205689), // Rule ID 8954 //
     /* 205657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 205665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1265:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 205681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205687 */     GIR_RootConstrainSelectedInstOperands,
     /* 205688 */     // GIR_Coverage, 8954,
     /* 205688 */     GIR_EraseRootFromParent_Done,
     /* 205689 */   // Label 3882: @205689
     /* 205689 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(205729), // Rule ID 9954 //
     /* 205694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205715 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 205718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205727 */     GIR_RootConstrainSelectedInstOperands,
     /* 205728 */     // GIR_Coverage, 9954,
     /* 205728 */     GIR_EraseRootFromParent_Done,
     /* 205729 */   // Label 3883: @205729
     /* 205729 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(205769), // Rule ID 9955 //
     /* 205734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 205758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205767 */     GIR_RootConstrainSelectedInstOperands,
     /* 205768 */     // GIR_Coverage, 9955,
     /* 205768 */     GIR_EraseRootFromParent_Done,
     /* 205769 */   // Label 3884: @205769
     /* 205769 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(205809), // Rule ID 9956 //
     /* 205774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205795 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 205798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205807 */     GIR_RootConstrainSelectedInstOperands,
     /* 205808 */     // GIR_Coverage, 9956,
     /* 205808 */     GIR_EraseRootFromParent_Done,
     /* 205809 */   // Label 3885: @205809
     /* 205809 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(205849), // Rule ID 9957 //
     /* 205814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 205838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205847 */     GIR_RootConstrainSelectedInstOperands,
     /* 205848 */     // GIR_Coverage, 9957,
     /* 205848 */     GIR_EraseRootFromParent_Done,
     /* 205849 */   // Label 3886: @205849
     /* 205849 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(205889), // Rule ID 9966 //
     /* 205854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205875 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 205878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205887 */     GIR_RootConstrainSelectedInstOperands,
     /* 205888 */     // GIR_Coverage, 9966,
     /* 205888 */     GIR_EraseRootFromParent_Done,
     /* 205889 */   // Label 3887: @205889
     /* 205889 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(205929), // Rule ID 9967 //
     /* 205894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205915 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 205918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205927 */     GIR_RootConstrainSelectedInstOperands,
     /* 205928 */     // GIR_Coverage, 9967,
     /* 205928 */     GIR_EraseRootFromParent_Done,
     /* 205929 */   // Label 3888: @205929
     /* 205929 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(205969), // Rule ID 9968 //
     /* 205934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 205958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205967 */     GIR_RootConstrainSelectedInstOperands,
     /* 205968 */     // GIR_Coverage, 9968,
     /* 205968 */     GIR_EraseRootFromParent_Done,
     /* 205969 */   // Label 3889: @205969
     /* 205969 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(206009), // Rule ID 9969 //
     /* 205974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 205998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206007 */     GIR_RootConstrainSelectedInstOperands,
     /* 206008 */     // GIR_Coverage, 9969,
     /* 206008 */     GIR_EraseRootFromParent_Done,
     /* 206009 */   // Label 3890: @206009
     /* 206009 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(206049), // Rule ID 9970 //
     /* 206014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206035 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 206038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206047 */     GIR_RootConstrainSelectedInstOperands,
     /* 206048 */     // GIR_Coverage, 9970,
     /* 206048 */     GIR_EraseRootFromParent_Done,
     /* 206049 */   // Label 3891: @206049
     /* 206049 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(206089), // Rule ID 9971 //
     /* 206054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206075 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 206078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206087 */     GIR_RootConstrainSelectedInstOperands,
     /* 206088 */     // GIR_Coverage, 9971,
     /* 206088 */     GIR_EraseRootFromParent_Done,
     /* 206089 */   // Label 3892: @206089
     /* 206089 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(206129), // Rule ID 9972 //
     /* 206094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 206118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206127 */     GIR_RootConstrainSelectedInstOperands,
     /* 206128 */     // GIR_Coverage, 9972,
     /* 206128 */     GIR_EraseRootFromParent_Done,
     /* 206129 */   // Label 3893: @206129
     /* 206129 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(206169), // Rule ID 9973 //
     /* 206134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206155 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 206158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206167 */     GIR_RootConstrainSelectedInstOperands,
     /* 206168 */     // GIR_Coverage, 9973,
     /* 206168 */     GIR_EraseRootFromParent_Done,
     /* 206169 */   // Label 3894: @206169
     /* 206169 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(206209), // Rule ID 9982 //
     /* 206174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 206198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206207 */     GIR_RootConstrainSelectedInstOperands,
     /* 206208 */     // GIR_Coverage, 9982,
     /* 206208 */     GIR_EraseRootFromParent_Done,
     /* 206209 */   // Label 3895: @206209
     /* 206209 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(206249), // Rule ID 9983 //
     /* 206214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206235 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 206238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206247 */     GIR_RootConstrainSelectedInstOperands,
     /* 206248 */     // GIR_Coverage, 9983,
     /* 206248 */     GIR_EraseRootFromParent_Done,
     /* 206249 */   // Label 3896: @206249
     /* 206249 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(206289), // Rule ID 9984 //
     /* 206254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 206278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206287 */     GIR_RootConstrainSelectedInstOperands,
     /* 206288 */     // GIR_Coverage, 9984,
     /* 206288 */     GIR_EraseRootFromParent_Done,
     /* 206289 */   // Label 3897: @206289
     /* 206289 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(206329), // Rule ID 9985 //
     /* 206294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206315 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 206318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206327 */     GIR_RootConstrainSelectedInstOperands,
     /* 206328 */     // GIR_Coverage, 9985,
     /* 206328 */     GIR_EraseRootFromParent_Done,
     /* 206329 */   // Label 3898: @206329
     /* 206329 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(206366), // Rule ID 10144 //
     /* 206334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2034:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 206358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206364 */     GIR_RootConstrainSelectedInstOperands,
     /* 206365 */     // GIR_Coverage, 10144,
     /* 206365 */     GIR_EraseRootFromParent_Done,
     /* 206366 */   // Label 3899: @206366
     /* 206366 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(206403), // Rule ID 10145 //
     /* 206371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 206395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206401 */     GIR_RootConstrainSelectedInstOperands,
     /* 206402 */     // GIR_Coverage, 10145,
     /* 206402 */     GIR_EraseRootFromParent_Done,
     /* 206403 */   // Label 3900: @206403
     /* 206403 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(206440), // Rule ID 10146 //
     /* 206408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2034:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 206432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206438 */     GIR_RootConstrainSelectedInstOperands,
     /* 206439 */     // GIR_Coverage, 10146,
     /* 206439 */     GIR_EraseRootFromParent_Done,
     /* 206440 */   // Label 3901: @206440
     /* 206440 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(206477), // Rule ID 10147 //
     /* 206445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1789:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 206469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206475 */     GIR_RootConstrainSelectedInstOperands,
     /* 206476 */     // GIR_Coverage, 10147,
     /* 206476 */     GIR_EraseRootFromParent_Done,
     /* 206477 */   // Label 3902: @206477
     /* 206477 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(206514), // Rule ID 10148 //
     /* 206482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 206506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206512 */     GIR_RootConstrainSelectedInstOperands,
     /* 206513 */     // GIR_Coverage, 10148,
     /* 206513 */     GIR_EraseRootFromParent_Done,
     /* 206514 */   // Label 3903: @206514
     /* 206514 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(206551), // Rule ID 10149 //
     /* 206519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 206543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206549 */     GIR_RootConstrainSelectedInstOperands,
     /* 206550 */     // GIR_Coverage, 10149,
     /* 206550 */     GIR_EraseRootFromParent_Done,
     /* 206551 */   // Label 3904: @206551
     /* 206551 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(206588), // Rule ID 10150 //
     /* 206556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2020:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 206580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206586 */     GIR_RootConstrainSelectedInstOperands,
     /* 206587 */     // GIR_Coverage, 10150,
     /* 206587 */     GIR_EraseRootFromParent_Done,
     /* 206588 */   // Label 3905: @206588
     /* 206588 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(206625), // Rule ID 10151 //
     /* 206593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2020:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 206617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206623 */     GIR_RootConstrainSelectedInstOperands,
     /* 206624 */     // GIR_Coverage, 10151,
     /* 206624 */     GIR_EraseRootFromParent_Done,
     /* 206625 */   // Label 3906: @206625
     /* 206625 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(206662), // Rule ID 10152 //
     /* 206630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2020:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 206654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206660 */     GIR_RootConstrainSelectedInstOperands,
     /* 206661 */     // GIR_Coverage, 10152,
     /* 206661 */     GIR_EraseRootFromParent_Done,
     /* 206662 */   // Label 3907: @206662
     /* 206662 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(206699), // Rule ID 11340 //
     /* 206667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2169:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206697 */     GIR_RootConstrainSelectedInstOperands,
     /* 206698 */     // GIR_Coverage, 11340,
     /* 206698 */     GIR_EraseRootFromParent_Done,
     /* 206699 */   // Label 3908: @206699
     /* 206699 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(206736), // Rule ID 11341 //
     /* 206704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2169:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206734 */     GIR_RootConstrainSelectedInstOperands,
     /* 206735 */     // GIR_Coverage, 11341,
     /* 206735 */     GIR_EraseRootFromParent_Done,
     /* 206736 */   // Label 3909: @206736
     /* 206736 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(206773), // Rule ID 11342 //
     /* 206741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2169:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206771 */     GIR_RootConstrainSelectedInstOperands,
     /* 206772 */     // GIR_Coverage, 11342,
     /* 206772 */     GIR_EraseRootFromParent_Done,
     /* 206773 */   // Label 3910: @206773
     /* 206773 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(206810), // Rule ID 11343 //
     /* 206778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2169:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206808 */     GIR_RootConstrainSelectedInstOperands,
     /* 206809 */     // GIR_Coverage, 11343,
     /* 206809 */     GIR_EraseRootFromParent_Done,
     /* 206810 */   // Label 3911: @206810
     /* 206810 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(206847), // Rule ID 11344 //
     /* 206815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2169:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206845 */     GIR_RootConstrainSelectedInstOperands,
     /* 206846 */     // GIR_Coverage, 11344,
     /* 206846 */     GIR_EraseRootFromParent_Done,
     /* 206847 */   // Label 3912: @206847
     /* 206847 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(206884), // Rule ID 11345 //
     /* 206852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2169:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206882 */     GIR_RootConstrainSelectedInstOperands,
     /* 206883 */     // GIR_Coverage, 11345,
     /* 206883 */     GIR_EraseRootFromParent_Done,
     /* 206884 */   // Label 3913: @206884
     /* 206884 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(206921), // Rule ID 11346 //
     /* 206889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206910 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2169:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206919 */     GIR_RootConstrainSelectedInstOperands,
     /* 206920 */     // GIR_Coverage, 11346,
     /* 206920 */     GIR_EraseRootFromParent_Done,
     /* 206921 */   // Label 3914: @206921
     /* 206921 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(206958), // Rule ID 11347 //
     /* 206926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206947 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2090:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206956 */     GIR_RootConstrainSelectedInstOperands,
     /* 206957 */     // GIR_Coverage, 11347,
     /* 206957 */     GIR_EraseRootFromParent_Done,
     /* 206958 */   // Label 3915: @206958
     /* 206958 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(206995), // Rule ID 11348 //
     /* 206963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2090:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206993 */     GIR_RootConstrainSelectedInstOperands,
     /* 206994 */     // GIR_Coverage, 11348,
     /* 206994 */     GIR_EraseRootFromParent_Done,
     /* 206995 */   // Label 3916: @206995
     /* 206995 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(207032), // Rule ID 11349 //
     /* 207000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2090:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207030 */     GIR_RootConstrainSelectedInstOperands,
     /* 207031 */     // GIR_Coverage, 11349,
     /* 207031 */     GIR_EraseRootFromParent_Done,
     /* 207032 */   // Label 3917: @207032
     /* 207032 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(207069), // Rule ID 11350 //
     /* 207037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2090:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207067 */     GIR_RootConstrainSelectedInstOperands,
     /* 207068 */     // GIR_Coverage, 11350,
     /* 207068 */     GIR_EraseRootFromParent_Done,
     /* 207069 */   // Label 3918: @207069
     /* 207069 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(207106), // Rule ID 11351 //
     /* 207074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207095 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2090:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207104 */     GIR_RootConstrainSelectedInstOperands,
     /* 207105 */     // GIR_Coverage, 11351,
     /* 207105 */     GIR_EraseRootFromParent_Done,
     /* 207106 */   // Label 3919: @207106
     /* 207106 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(207143), // Rule ID 11352 //
     /* 207111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2090:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207141 */     GIR_RootConstrainSelectedInstOperands,
     /* 207142 */     // GIR_Coverage, 11352,
     /* 207142 */     GIR_EraseRootFromParent_Done,
     /* 207143 */   // Label 3920: @207143
     /* 207143 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(207180), // Rule ID 11353 //
     /* 207148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207169 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2090:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207178 */     GIR_RootConstrainSelectedInstOperands,
     /* 207179 */     // GIR_Coverage, 11353,
     /* 207179 */     GIR_EraseRootFromParent_Done,
     /* 207180 */   // Label 3921: @207180
     /* 207180 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(207217), // Rule ID 11354 //
     /* 207185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2095:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207215 */     GIR_RootConstrainSelectedInstOperands,
     /* 207216 */     // GIR_Coverage, 11354,
     /* 207216 */     GIR_EraseRootFromParent_Done,
     /* 207217 */   // Label 3922: @207217
     /* 207217 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(207254), // Rule ID 11355 //
     /* 207222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2095:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207252 */     GIR_RootConstrainSelectedInstOperands,
     /* 207253 */     // GIR_Coverage, 11355,
     /* 207253 */     GIR_EraseRootFromParent_Done,
     /* 207254 */   // Label 3923: @207254
     /* 207254 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(207291), // Rule ID 11356 //
     /* 207259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2095:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207289 */     GIR_RootConstrainSelectedInstOperands,
     /* 207290 */     // GIR_Coverage, 11356,
     /* 207290 */     GIR_EraseRootFromParent_Done,
     /* 207291 */   // Label 3924: @207291
     /* 207291 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(207328), // Rule ID 11357 //
     /* 207296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2095:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207326 */     GIR_RootConstrainSelectedInstOperands,
     /* 207327 */     // GIR_Coverage, 11357,
     /* 207327 */     GIR_EraseRootFromParent_Done,
     /* 207328 */   // Label 3925: @207328
     /* 207328 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(207365), // Rule ID 11358 //
     /* 207333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207354 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2095:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207363 */     GIR_RootConstrainSelectedInstOperands,
     /* 207364 */     // GIR_Coverage, 11358,
     /* 207364 */     GIR_EraseRootFromParent_Done,
     /* 207365 */   // Label 3926: @207365
     /* 207365 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(207402), // Rule ID 11359 //
     /* 207370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2095:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207400 */     GIR_RootConstrainSelectedInstOperands,
     /* 207401 */     // GIR_Coverage, 11359,
     /* 207401 */     GIR_EraseRootFromParent_Done,
     /* 207402 */   // Label 3927: @207402
     /* 207402 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(207439), // Rule ID 11360 //
     /* 207407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207428 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2095:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207437 */     GIR_RootConstrainSelectedInstOperands,
     /* 207438 */     // GIR_Coverage, 11360,
     /* 207438 */     GIR_EraseRootFromParent_Done,
     /* 207439 */   // Label 3928: @207439
     /* 207439 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(207476), // Rule ID 11361 //
     /* 207444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1934:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207474 */     GIR_RootConstrainSelectedInstOperands,
     /* 207475 */     // GIR_Coverage, 11361,
     /* 207475 */     GIR_EraseRootFromParent_Done,
     /* 207476 */   // Label 3929: @207476
     /* 207476 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(207513), // Rule ID 11362 //
     /* 207481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1934:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207511 */     GIR_RootConstrainSelectedInstOperands,
     /* 207512 */     // GIR_Coverage, 11362,
     /* 207512 */     GIR_EraseRootFromParent_Done,
     /* 207513 */   // Label 3930: @207513
     /* 207513 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(207550), // Rule ID 11363 //
     /* 207518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207539 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1934:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207548 */     GIR_RootConstrainSelectedInstOperands,
     /* 207549 */     // GIR_Coverage, 11363,
     /* 207549 */     GIR_EraseRootFromParent_Done,
     /* 207550 */   // Label 3931: @207550
     /* 207550 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(207587), // Rule ID 11364 //
     /* 207555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1934:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207585 */     GIR_RootConstrainSelectedInstOperands,
     /* 207586 */     // GIR_Coverage, 11364,
     /* 207586 */     GIR_EraseRootFromParent_Done,
     /* 207587 */   // Label 3932: @207587
     /* 207587 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(207624), // Rule ID 11365 //
     /* 207592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1934:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207622 */     GIR_RootConstrainSelectedInstOperands,
     /* 207623 */     // GIR_Coverage, 11365,
     /* 207623 */     GIR_EraseRootFromParent_Done,
     /* 207624 */   // Label 3933: @207624
     /* 207624 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(207661), // Rule ID 11366 //
     /* 207629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1934:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207659 */     GIR_RootConstrainSelectedInstOperands,
     /* 207660 */     // GIR_Coverage, 11366,
     /* 207660 */     GIR_EraseRootFromParent_Done,
     /* 207661 */   // Label 3934: @207661
     /* 207661 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(207698), // Rule ID 11367 //
     /* 207666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207687 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1934:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207696 */     GIR_RootConstrainSelectedInstOperands,
     /* 207697 */     // GIR_Coverage, 11367,
     /* 207697 */     GIR_EraseRootFromParent_Done,
     /* 207698 */   // Label 3935: @207698
     /* 207698 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(207735), // Rule ID 11368 //
     /* 207703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207724 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207733 */     GIR_RootConstrainSelectedInstOperands,
     /* 207734 */     // GIR_Coverage, 11368,
     /* 207734 */     GIR_EraseRootFromParent_Done,
     /* 207735 */   // Label 3936: @207735
     /* 207735 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(207772), // Rule ID 11369 //
     /* 207740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207770 */     GIR_RootConstrainSelectedInstOperands,
     /* 207771 */     // GIR_Coverage, 11369,
     /* 207771 */     GIR_EraseRootFromParent_Done,
     /* 207772 */   // Label 3937: @207772
     /* 207772 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(207809), // Rule ID 11370 //
     /* 207777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1939:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207807 */     GIR_RootConstrainSelectedInstOperands,
     /* 207808 */     // GIR_Coverage, 11370,
     /* 207808 */     GIR_EraseRootFromParent_Done,
     /* 207809 */   // Label 3938: @207809
     /* 207809 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(207846), // Rule ID 11371 //
     /* 207814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207844 */     GIR_RootConstrainSelectedInstOperands,
     /* 207845 */     // GIR_Coverage, 11371,
     /* 207845 */     GIR_EraseRootFromParent_Done,
     /* 207846 */   // Label 3939: @207846
     /* 207846 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(207883), // Rule ID 11372 //
     /* 207851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207872 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1939:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207881 */     GIR_RootConstrainSelectedInstOperands,
     /* 207882 */     // GIR_Coverage, 11372,
     /* 207882 */     GIR_EraseRootFromParent_Done,
     /* 207883 */   // Label 3940: @207883
     /* 207883 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(207920), // Rule ID 11373 //
     /* 207888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207918 */     GIR_RootConstrainSelectedInstOperands,
     /* 207919 */     // GIR_Coverage, 11373,
     /* 207919 */     GIR_EraseRootFromParent_Done,
     /* 207920 */   // Label 3941: @207920
     /* 207920 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(207957), // Rule ID 11374 //
     /* 207925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207946 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1939:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207955 */     GIR_RootConstrainSelectedInstOperands,
     /* 207956 */     // GIR_Coverage, 11374,
     /* 207956 */     GIR_EraseRootFromParent_Done,
     /* 207957 */   // Label 3942: @207957
     /* 207957 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(207994), // Rule ID 11394 //
     /* 207962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 207970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 207986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207992 */     GIR_RootConstrainSelectedInstOperands,
     /* 207993 */     // GIR_Coverage, 11394,
     /* 207993 */     GIR_EraseRootFromParent_Done,
     /* 207994 */   // Label 3943: @207994
     /* 207994 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(208031), // Rule ID 11395 //
     /* 207999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 208023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208029 */     GIR_RootConstrainSelectedInstOperands,
     /* 208030 */     // GIR_Coverage, 11395,
     /* 208030 */     GIR_EraseRootFromParent_Done,
     /* 208031 */   // Label 3944: @208031
     /* 208031 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(208068), // Rule ID 11396 //
     /* 208036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 208060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208066 */     GIR_RootConstrainSelectedInstOperands,
     /* 208067 */     // GIR_Coverage, 11396,
     /* 208067 */     GIR_EraseRootFromParent_Done,
     /* 208068 */   // Label 3945: @208068
     /* 208068 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(208105), // Rule ID 11397 //
     /* 208073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 208097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208103 */     GIR_RootConstrainSelectedInstOperands,
     /* 208104 */     // GIR_Coverage, 11397,
     /* 208104 */     GIR_EraseRootFromParent_Done,
     /* 208105 */   // Label 3946: @208105
     /* 208105 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(208142), // Rule ID 11685 //
     /* 208110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1700:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 208134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208140 */     GIR_RootConstrainSelectedInstOperands,
     /* 208141 */     // GIR_Coverage, 11685,
     /* 208141 */     GIR_EraseRootFromParent_Done,
     /* 208142 */   // Label 3947: @208142
     /* 208142 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(208179), // Rule ID 11686 //
     /* 208147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 208171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208177 */     GIR_RootConstrainSelectedInstOperands,
     /* 208178 */     // GIR_Coverage, 11686,
     /* 208178 */     GIR_EraseRootFromParent_Done,
     /* 208179 */   // Label 3948: @208179
     /* 208179 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(208216), // Rule ID 11687 //
     /* 208184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 208208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208214 */     GIR_RootConstrainSelectedInstOperands,
     /* 208215 */     // GIR_Coverage, 11687,
     /* 208215 */     GIR_EraseRootFromParent_Done,
     /* 208216 */   // Label 3949: @208216
     /* 208216 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(208253), // Rule ID 11688 //
     /* 208221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1948:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 208245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208251 */     GIR_RootConstrainSelectedInstOperands,
     /* 208252 */     // GIR_Coverage, 11688,
     /* 208252 */     GIR_EraseRootFromParent_Done,
     /* 208253 */   // Label 3950: @208253
     /* 208253 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(208290), // Rule ID 11689 //
     /* 208258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1948:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 208282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208288 */     GIR_RootConstrainSelectedInstOperands,
     /* 208289 */     // GIR_Coverage, 11689,
     /* 208289 */     GIR_EraseRootFromParent_Done,
     /* 208290 */   // Label 3951: @208290
     /* 208290 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(208327), // Rule ID 11690 //
     /* 208295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1948:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 208319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208325 */     GIR_RootConstrainSelectedInstOperands,
     /* 208326 */     // GIR_Coverage, 11690,
     /* 208326 */     GIR_EraseRootFromParent_Done,
     /* 208327 */   // Label 3952: @208327
     /* 208327 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(208364), // Rule ID 11691 //
     /* 208332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1949:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 208356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208362 */     GIR_RootConstrainSelectedInstOperands,
     /* 208363 */     // GIR_Coverage, 11691,
     /* 208363 */     GIR_EraseRootFromParent_Done,
     /* 208364 */   // Label 3953: @208364
     /* 208364 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(208401), // Rule ID 11692 //
     /* 208369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 208393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208399 */     GIR_RootConstrainSelectedInstOperands,
     /* 208400 */     // GIR_Coverage, 11692,
     /* 208400 */     GIR_EraseRootFromParent_Done,
     /* 208401 */   // Label 3954: @208401
     /* 208401 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(208438), // Rule ID 11693 //
     /* 208406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208427 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 208430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208436 */     GIR_RootConstrainSelectedInstOperands,
     /* 208437 */     // GIR_Coverage, 11693,
     /* 208437 */     GIR_EraseRootFromParent_Done,
     /* 208438 */   // Label 3955: @208438
     /* 208438 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(208475), // Rule ID 11694 //
     /* 208443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1877:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 208467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208473 */     GIR_RootConstrainSelectedInstOperands,
     /* 208474 */     // GIR_Coverage, 11694,
     /* 208474 */     GIR_EraseRootFromParent_Done,
     /* 208475 */   // Label 3956: @208475
     /* 208475 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(208512), // Rule ID 11695 //
     /* 208480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1877:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 208504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208510 */     GIR_RootConstrainSelectedInstOperands,
     /* 208511 */     // GIR_Coverage, 11695,
     /* 208511 */     GIR_EraseRootFromParent_Done,
     /* 208512 */   // Label 3957: @208512
     /* 208512 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(208549), // Rule ID 11696 //
     /* 208517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1877:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 208541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208547 */     GIR_RootConstrainSelectedInstOperands,
     /* 208548 */     // GIR_Coverage, 11696,
     /* 208548 */     GIR_EraseRootFromParent_Done,
     /* 208549 */   // Label 3958: @208549
     /* 208549 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(208586), // Rule ID 11697 //
     /* 208554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1879:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 208578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208584 */     GIR_RootConstrainSelectedInstOperands,
     /* 208585 */     // GIR_Coverage, 11697,
     /* 208585 */     GIR_EraseRootFromParent_Done,
     /* 208586 */   // Label 3959: @208586
     /* 208586 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(208623), // Rule ID 11698 //
     /* 208591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1879:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 208615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208621 */     GIR_RootConstrainSelectedInstOperands,
     /* 208622 */     // GIR_Coverage, 11698,
     /* 208622 */     GIR_EraseRootFromParent_Done,
     /* 208623 */   // Label 3960: @208623
     /* 208623 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(208660), // Rule ID 11699 //
     /* 208628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1879:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 208652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208658 */     GIR_RootConstrainSelectedInstOperands,
     /* 208659 */     // GIR_Coverage, 11699,
     /* 208659 */     GIR_EraseRootFromParent_Done,
     /* 208660 */   // Label 3961: @208660
     /* 208660 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(208697), // Rule ID 11700 //
     /* 208665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2073:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 208689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208695 */     GIR_RootConstrainSelectedInstOperands,
     /* 208696 */     // GIR_Coverage, 11700,
     /* 208696 */     GIR_EraseRootFromParent_Done,
     /* 208697 */   // Label 3962: @208697
     /* 208697 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(208734), // Rule ID 11701 //
     /* 208702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2073:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 208726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208732 */     GIR_RootConstrainSelectedInstOperands,
     /* 208733 */     // GIR_Coverage, 11701,
     /* 208733 */     GIR_EraseRootFromParent_Done,
     /* 208734 */   // Label 3963: @208734
     /* 208734 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(208771), // Rule ID 11702 //
     /* 208739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2073:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 208763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208769 */     GIR_RootConstrainSelectedInstOperands,
     /* 208770 */     // GIR_Coverage, 11702,
     /* 208770 */     GIR_EraseRootFromParent_Done,
     /* 208771 */   // Label 3964: @208771
     /* 208771 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(208808), // Rule ID 11703 //
     /* 208776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2074:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 208800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208806 */     GIR_RootConstrainSelectedInstOperands,
     /* 208807 */     // GIR_Coverage, 11703,
     /* 208807 */     GIR_EraseRootFromParent_Done,
     /* 208808 */   // Label 3965: @208808
     /* 208808 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(208845), // Rule ID 11704 //
     /* 208813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2074:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 208837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208843 */     GIR_RootConstrainSelectedInstOperands,
     /* 208844 */     // GIR_Coverage, 11704,
     /* 208844 */     GIR_EraseRootFromParent_Done,
     /* 208845 */   // Label 3966: @208845
     /* 208845 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(208882), // Rule ID 11705 //
     /* 208850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208871 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2074:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 208874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208880 */     GIR_RootConstrainSelectedInstOperands,
     /* 208881 */     // GIR_Coverage, 11705,
     /* 208881 */     GIR_EraseRootFromParent_Done,
     /* 208882 */   // Label 3967: @208882
     /* 208882 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(208919), // Rule ID 11706 //
     /* 208887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1695:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 208911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208917 */     GIR_RootConstrainSelectedInstOperands,
     /* 208918 */     // GIR_Coverage, 11706,
     /* 208918 */     GIR_EraseRootFromParent_Done,
     /* 208919 */   // Label 3968: @208919
     /* 208919 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(208956), // Rule ID 11707 //
     /* 208924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 208948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208954 */     GIR_RootConstrainSelectedInstOperands,
     /* 208955 */     // GIR_Coverage, 11707,
     /* 208955 */     GIR_EraseRootFromParent_Done,
     /* 208956 */   // Label 3969: @208956
     /* 208956 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(208993), // Rule ID 11708 //
     /* 208961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 208985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208991 */     GIR_RootConstrainSelectedInstOperands,
     /* 208992 */     // GIR_Coverage, 11708,
     /* 208992 */     GIR_EraseRootFromParent_Done,
     /* 208993 */   // Label 3970: @208993
     /* 208993 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(209030), // Rule ID 11709 //
     /* 208998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 209022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209028 */     GIR_RootConstrainSelectedInstOperands,
     /* 209029 */     // GIR_Coverage, 11709,
     /* 209029 */     GIR_EraseRootFromParent_Done,
     /* 209030 */   // Label 3971: @209030
     /* 209030 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(209067), // Rule ID 11710 //
     /* 209035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 209059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209065 */     GIR_RootConstrainSelectedInstOperands,
     /* 209066 */     // GIR_Coverage, 11710,
     /* 209066 */     GIR_EraseRootFromParent_Done,
     /* 209067 */   // Label 3972: @209067
     /* 209067 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(209104), // Rule ID 11711 //
     /* 209072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 209096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209102 */     GIR_RootConstrainSelectedInstOperands,
     /* 209103 */     // GIR_Coverage, 11711,
     /* 209103 */     GIR_EraseRootFromParent_Done,
     /* 209104 */   // Label 3973: @209104
     /* 209104 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(209141), // Rule ID 11712 //
     /* 209109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 209133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209139 */     GIR_RootConstrainSelectedInstOperands,
     /* 209140 */     // GIR_Coverage, 11712,
     /* 209140 */     GIR_EraseRootFromParent_Done,
     /* 209141 */   // Label 3974: @209141
     /* 209141 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(209178), // Rule ID 11713 //
     /* 209146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 209170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209176 */     GIR_RootConstrainSelectedInstOperands,
     /* 209177 */     // GIR_Coverage, 11713,
     /* 209177 */     GIR_EraseRootFromParent_Done,
     /* 209178 */   // Label 3975: @209178
     /* 209178 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(209215), // Rule ID 11714 //
     /* 209183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 209207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209213 */     GIR_RootConstrainSelectedInstOperands,
     /* 209214 */     // GIR_Coverage, 11714,
     /* 209214 */     GIR_EraseRootFromParent_Done,
     /* 209215 */   // Label 3976: @209215
     /* 209215 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(209252), // Rule ID 11715 //
     /* 209220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 209244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209250 */     GIR_RootConstrainSelectedInstOperands,
     /* 209251 */     // GIR_Coverage, 11715,
     /* 209251 */     GIR_EraseRootFromParent_Done,
     /* 209252 */   // Label 3977: @209252
     /* 209252 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(209289), // Rule ID 11716 //
     /* 209257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 209281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209287 */     GIR_RootConstrainSelectedInstOperands,
     /* 209288 */     // GIR_Coverage, 11716,
     /* 209288 */     GIR_EraseRootFromParent_Done,
     /* 209289 */   // Label 3978: @209289
     /* 209289 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(209326), // Rule ID 11717 //
     /* 209294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 209318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209324 */     GIR_RootConstrainSelectedInstOperands,
     /* 209325 */     // GIR_Coverage, 11717,
     /* 209325 */     GIR_EraseRootFromParent_Done,
     /* 209326 */   // Label 3979: @209326
     /* 209326 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(209363), // Rule ID 11727 //
     /* 209331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1881:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 209355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209361 */     GIR_RootConstrainSelectedInstOperands,
     /* 209362 */     // GIR_Coverage, 11727,
     /* 209362 */     GIR_EraseRootFromParent_Done,
     /* 209363 */   // Label 3980: @209363
     /* 209363 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(209400), // Rule ID 11728 //
     /* 209368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1881:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 209392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209398 */     GIR_RootConstrainSelectedInstOperands,
     /* 209399 */     // GIR_Coverage, 11728,
     /* 209399 */     GIR_EraseRootFromParent_Done,
     /* 209400 */   // Label 3981: @209400
     /* 209400 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(209437), // Rule ID 11729 //
     /* 209405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1881:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 209429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209435 */     GIR_RootConstrainSelectedInstOperands,
     /* 209436 */     // GIR_Coverage, 11729,
     /* 209436 */     GIR_EraseRootFromParent_Done,
     /* 209437 */   // Label 3982: @209437
     /* 209437 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(209474), // Rule ID 11730 //
     /* 209442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1882:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 209466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209472 */     GIR_RootConstrainSelectedInstOperands,
     /* 209473 */     // GIR_Coverage, 11730,
     /* 209473 */     GIR_EraseRootFromParent_Done,
     /* 209474 */   // Label 3983: @209474
     /* 209474 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(209511), // Rule ID 11731 //
     /* 209479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1882:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 209503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209509 */     GIR_RootConstrainSelectedInstOperands,
     /* 209510 */     // GIR_Coverage, 11731,
     /* 209510 */     GIR_EraseRootFromParent_Done,
     /* 209511 */   // Label 3984: @209511
     /* 209511 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(209548), // Rule ID 11732 //
     /* 209516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1882:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 209540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209546 */     GIR_RootConstrainSelectedInstOperands,
     /* 209547 */     // GIR_Coverage, 11732,
     /* 209547 */     GIR_EraseRootFromParent_Done,
     /* 209548 */   // Label 3985: @209548
     /* 209548 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(209585), // Rule ID 11733 //
     /* 209553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2075:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 209577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209583 */     GIR_RootConstrainSelectedInstOperands,
     /* 209584 */     // GIR_Coverage, 11733,
     /* 209584 */     GIR_EraseRootFromParent_Done,
     /* 209585 */   // Label 3986: @209585
     /* 209585 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(209622), // Rule ID 11734 //
     /* 209590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2075:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 209614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209620 */     GIR_RootConstrainSelectedInstOperands,
     /* 209621 */     // GIR_Coverage, 11734,
     /* 209621 */     GIR_EraseRootFromParent_Done,
     /* 209622 */   // Label 3987: @209622
     /* 209622 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(209659), // Rule ID 11735 //
     /* 209627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2075:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 209651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209657 */     GIR_RootConstrainSelectedInstOperands,
     /* 209658 */     // GIR_Coverage, 11735,
     /* 209658 */     GIR_EraseRootFromParent_Done,
     /* 209659 */   // Label 3988: @209659
     /* 209659 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(209696), // Rule ID 11736 //
     /* 209664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209685 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2076:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 209688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209694 */     GIR_RootConstrainSelectedInstOperands,
     /* 209695 */     // GIR_Coverage, 11736,
     /* 209695 */     GIR_EraseRootFromParent_Done,
     /* 209696 */   // Label 3989: @209696
     /* 209696 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(209733), // Rule ID 11737 //
     /* 209701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2076:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 209725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209731 */     GIR_RootConstrainSelectedInstOperands,
     /* 209732 */     // GIR_Coverage, 11737,
     /* 209732 */     GIR_EraseRootFromParent_Done,
     /* 209733 */   // Label 3990: @209733
     /* 209733 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(209770), // Rule ID 11738 //
     /* 209738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209759 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2076:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 209762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209768 */     GIR_RootConstrainSelectedInstOperands,
     /* 209769 */     // GIR_Coverage, 11738,
     /* 209769 */     GIR_EraseRootFromParent_Done,
     /* 209770 */   // Label 3991: @209770
     /* 209770 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(209807), // Rule ID 11751 //
     /* 209775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 209799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209805 */     GIR_RootConstrainSelectedInstOperands,
     /* 209806 */     // GIR_Coverage, 11751,
     /* 209806 */     GIR_EraseRootFromParent_Done,
     /* 209807 */   // Label 3992: @209807
     /* 209807 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(209844), // Rule ID 11752 //
     /* 209812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 209836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209842 */     GIR_RootConstrainSelectedInstOperands,
     /* 209843 */     // GIR_Coverage, 11752,
     /* 209843 */     GIR_EraseRootFromParent_Done,
     /* 209844 */   // Label 3993: @209844
     /* 209844 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(209881), // Rule ID 11753 //
     /* 209849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 209873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209879 */     GIR_RootConstrainSelectedInstOperands,
     /* 209880 */     // GIR_Coverage, 11753,
     /* 209880 */     GIR_EraseRootFromParent_Done,
     /* 209881 */   // Label 3994: @209881
     /* 209881 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(209918), // Rule ID 11754 //
     /* 209886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 209910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209916 */     GIR_RootConstrainSelectedInstOperands,
     /* 209917 */     // GIR_Coverage, 11754,
     /* 209917 */     GIR_EraseRootFromParent_Done,
     /* 209918 */   // Label 3995: @209918
     /* 209918 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(209955), // Rule ID 11755 //
     /* 209923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 209947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209953 */     GIR_RootConstrainSelectedInstOperands,
     /* 209954 */     // GIR_Coverage, 11755,
     /* 209954 */     GIR_EraseRootFromParent_Done,
     /* 209955 */   // Label 3996: @209955
     /* 209955 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(209992), // Rule ID 11756 //
     /* 209960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 209984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209990 */     GIR_RootConstrainSelectedInstOperands,
     /* 209991 */     // GIR_Coverage, 11756,
     /* 209991 */     GIR_EraseRootFromParent_Done,
     /* 209992 */   // Label 3997: @209992
     /* 209992 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(210029), // Rule ID 11757 //
     /* 209997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1764:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 210021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210027 */     GIR_RootConstrainSelectedInstOperands,
     /* 210028 */     // GIR_Coverage, 11757,
     /* 210028 */     GIR_EraseRootFromParent_Done,
     /* 210029 */   // Label 3998: @210029
     /* 210029 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(210066), // Rule ID 11758 //
     /* 210034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1764:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 210058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210064 */     GIR_RootConstrainSelectedInstOperands,
     /* 210065 */     // GIR_Coverage, 11758,
     /* 210065 */     GIR_EraseRootFromParent_Done,
     /* 210066 */   // Label 3999: @210066
     /* 210066 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(210103), // Rule ID 11759 //
     /* 210071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1764:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 210095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210101 */     GIR_RootConstrainSelectedInstOperands,
     /* 210102 */     // GIR_Coverage, 11759,
     /* 210102 */     GIR_EraseRootFromParent_Done,
     /* 210103 */   // Label 4000: @210103
     /* 210103 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(210140), // Rule ID 11760 //
     /* 210108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 210132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210138 */     GIR_RootConstrainSelectedInstOperands,
     /* 210139 */     // GIR_Coverage, 11760,
     /* 210139 */     GIR_EraseRootFromParent_Done,
     /* 210140 */   // Label 4001: @210140
     /* 210140 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(210177), // Rule ID 11761 //
     /* 210145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 210169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210175 */     GIR_RootConstrainSelectedInstOperands,
     /* 210176 */     // GIR_Coverage, 11761,
     /* 210176 */     GIR_EraseRootFromParent_Done,
     /* 210177 */   // Label 4002: @210177
     /* 210177 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(210214), // Rule ID 11762 //
     /* 210182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 210206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210212 */     GIR_RootConstrainSelectedInstOperands,
     /* 210213 */     // GIR_Coverage, 11762,
     /* 210213 */     GIR_EraseRootFromParent_Done,
     /* 210214 */   // Label 4003: @210214
     /* 210214 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(210251), // Rule ID 11763 //
     /* 210219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2002:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 210243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210249 */     GIR_RootConstrainSelectedInstOperands,
     /* 210250 */     // GIR_Coverage, 11763,
     /* 210250 */     GIR_EraseRootFromParent_Done,
     /* 210251 */   // Label 4004: @210251
     /* 210251 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(210288), // Rule ID 11764 //
     /* 210256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2002:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 210280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210286 */     GIR_RootConstrainSelectedInstOperands,
     /* 210287 */     // GIR_Coverage, 11764,
     /* 210287 */     GIR_EraseRootFromParent_Done,
     /* 210288 */   // Label 4005: @210288
     /* 210288 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(210325), // Rule ID 11765 //
     /* 210293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2002:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 210317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210323 */     GIR_RootConstrainSelectedInstOperands,
     /* 210324 */     // GIR_Coverage, 11765,
     /* 210324 */     GIR_EraseRootFromParent_Done,
     /* 210325 */   // Label 4006: @210325
     /* 210325 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(210362), // Rule ID 11766 //
     /* 210330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2004:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 210354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210360 */     GIR_RootConstrainSelectedInstOperands,
     /* 210361 */     // GIR_Coverage, 11766,
     /* 210361 */     GIR_EraseRootFromParent_Done,
     /* 210362 */   // Label 4007: @210362
     /* 210362 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(210399), // Rule ID 11767 //
     /* 210367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2004:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 210391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210397 */     GIR_RootConstrainSelectedInstOperands,
     /* 210398 */     // GIR_Coverage, 11767,
     /* 210398 */     GIR_EraseRootFromParent_Done,
     /* 210399 */   // Label 4008: @210399
     /* 210399 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(210436), // Rule ID 11768 //
     /* 210404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210425 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 210428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210434 */     GIR_RootConstrainSelectedInstOperands,
     /* 210435 */     // GIR_Coverage, 11768,
     /* 210435 */     GIR_EraseRootFromParent_Done,
     /* 210436 */   // Label 4009: @210436
     /* 210436 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(210473), // Rule ID 11769 //
     /* 210441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1642:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 210465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210471 */     GIR_RootConstrainSelectedInstOperands,
     /* 210472 */     // GIR_Coverage, 11769,
     /* 210472 */     GIR_EraseRootFromParent_Done,
     /* 210473 */   // Label 4010: @210473
     /* 210473 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(210510), // Rule ID 11770 //
     /* 210478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1642:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 210502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210508 */     GIR_RootConstrainSelectedInstOperands,
     /* 210509 */     // GIR_Coverage, 11770,
     /* 210509 */     GIR_EraseRootFromParent_Done,
     /* 210510 */   // Label 4011: @210510
     /* 210510 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(210547), // Rule ID 11871 //
     /* 210515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 210539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210545 */     GIR_RootConstrainSelectedInstOperands,
     /* 210546 */     // GIR_Coverage, 11871,
     /* 210546 */     GIR_EraseRootFromParent_Done,
     /* 210547 */   // Label 4012: @210547
     /* 210547 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(210584), // Rule ID 11872 //
     /* 210552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 210576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210582 */     GIR_RootConstrainSelectedInstOperands,
     /* 210583 */     // GIR_Coverage, 11872,
     /* 210583 */     GIR_EraseRootFromParent_Done,
     /* 210584 */   // Label 4013: @210584
     /* 210584 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(210621), // Rule ID 11873 //
     /* 210589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 210613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210619 */     GIR_RootConstrainSelectedInstOperands,
     /* 210620 */     // GIR_Coverage, 11873,
     /* 210620 */     GIR_EraseRootFromParent_Done,
     /* 210621 */   // Label 4014: @210621
     /* 210621 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(210658), // Rule ID 11874 //
     /* 210626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1913:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 210650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210656 */     GIR_RootConstrainSelectedInstOperands,
     /* 210657 */     // GIR_Coverage, 11874,
     /* 210657 */     GIR_EraseRootFromParent_Done,
     /* 210658 */   // Label 4015: @210658
     /* 210658 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(210695), // Rule ID 11875 //
     /* 210663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1913:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 210687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210693 */     GIR_RootConstrainSelectedInstOperands,
     /* 210694 */     // GIR_Coverage, 11875,
     /* 210694 */     GIR_EraseRootFromParent_Done,
     /* 210695 */   // Label 4016: @210695
     /* 210695 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(210732), // Rule ID 11876 //
     /* 210700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1913:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 210724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210730 */     GIR_RootConstrainSelectedInstOperands,
     /* 210731 */     // GIR_Coverage, 11876,
     /* 210731 */     GIR_EraseRootFromParent_Done,
     /* 210732 */   // Label 4017: @210732
     /* 210732 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(210769), // Rule ID 11877 //
     /* 210737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 210761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210767 */     GIR_RootConstrainSelectedInstOperands,
     /* 210768 */     // GIR_Coverage, 11877,
     /* 210768 */     GIR_EraseRootFromParent_Done,
     /* 210769 */   // Label 4018: @210769
     /* 210769 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(210806), // Rule ID 11878 //
     /* 210774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 210798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210804 */     GIR_RootConstrainSelectedInstOperands,
     /* 210805 */     // GIR_Coverage, 11878,
     /* 210805 */     GIR_EraseRootFromParent_Done,
     /* 210806 */   // Label 4019: @210806
     /* 210806 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(210843), // Rule ID 11879 //
     /* 210811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 210835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210841 */     GIR_RootConstrainSelectedInstOperands,
     /* 210842 */     // GIR_Coverage, 11879,
     /* 210842 */     GIR_EraseRootFromParent_Done,
     /* 210843 */   // Label 4020: @210843
     /* 210843 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(210880), // Rule ID 11895 //
     /* 210848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 210872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210878 */     GIR_RootConstrainSelectedInstOperands,
     /* 210879 */     // GIR_Coverage, 11895,
     /* 210879 */     GIR_EraseRootFromParent_Done,
     /* 210880 */   // Label 4021: @210880
     /* 210880 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(210917), // Rule ID 11896 //
     /* 210885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 210909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210915 */     GIR_RootConstrainSelectedInstOperands,
     /* 210916 */     // GIR_Coverage, 11896,
     /* 210916 */     GIR_EraseRootFromParent_Done,
     /* 210917 */   // Label 4022: @210917
     /* 210917 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(210954), // Rule ID 11897 //
     /* 210922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 210946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210952 */     GIR_RootConstrainSelectedInstOperands,
     /* 210953 */     // GIR_Coverage, 11897,
     /* 210953 */     GIR_EraseRootFromParent_Done,
     /* 210954 */   // Label 4023: @210954
     /* 210954 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(210991), // Rule ID 11898 //
     /* 210959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 210967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210980 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 210983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210989 */     GIR_RootConstrainSelectedInstOperands,
     /* 210990 */     // GIR_Coverage, 11898,
     /* 210990 */     GIR_EraseRootFromParent_Done,
     /* 210991 */   // Label 4024: @210991
     /* 210991 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(211028), // Rule ID 11899 //
     /* 210996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 211004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 211020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211026 */     GIR_RootConstrainSelectedInstOperands,
     /* 211027 */     // GIR_Coverage, 11899,
     /* 211027 */     GIR_EraseRootFromParent_Done,
     /* 211028 */   // Label 4025: @211028
     /* 211028 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(211065), // Rule ID 11900 //
     /* 211033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 211041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 211057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211063 */     GIR_RootConstrainSelectedInstOperands,
     /* 211064 */     // GIR_Coverage, 11900,
     /* 211064 */     GIR_EraseRootFromParent_Done,
     /* 211065 */   // Label 4026: @211065
     /* 211065 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(211102), // Rule ID 11916 //
     /* 211070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1878:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 211094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211100 */     GIR_RootConstrainSelectedInstOperands,
     /* 211101 */     // GIR_Coverage, 11916,
     /* 211101 */     GIR_EraseRootFromParent_Done,
     /* 211102 */   // Label 4027: @211102
     /* 211102 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(211139), // Rule ID 11917 //
     /* 211107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1878:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 211131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211137 */     GIR_RootConstrainSelectedInstOperands,
     /* 211138 */     // GIR_Coverage, 11917,
     /* 211138 */     GIR_EraseRootFromParent_Done,
     /* 211139 */   // Label 4028: @211139
     /* 211139 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(211176), // Rule ID 11918 //
     /* 211144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1878:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 211168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211174 */     GIR_RootConstrainSelectedInstOperands,
     /* 211175 */     // GIR_Coverage, 11918,
     /* 211175 */     GIR_EraseRootFromParent_Done,
     /* 211176 */   // Label 4029: @211176
     /* 211176 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(211213), // Rule ID 11919 //
     /* 211181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1880:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 211205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211211 */     GIR_RootConstrainSelectedInstOperands,
     /* 211212 */     // GIR_Coverage, 11919,
     /* 211212 */     GIR_EraseRootFromParent_Done,
     /* 211213 */   // Label 4030: @211213
     /* 211213 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(211250), // Rule ID 11920 //
     /* 211218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1880:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 211242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211248 */     GIR_RootConstrainSelectedInstOperands,
     /* 211249 */     // GIR_Coverage, 11920,
     /* 211249 */     GIR_EraseRootFromParent_Done,
     /* 211250 */   // Label 4031: @211250
     /* 211250 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(211287), // Rule ID 11921 //
     /* 211255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1880:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 211279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211285 */     GIR_RootConstrainSelectedInstOperands,
     /* 211286 */     // GIR_Coverage, 11921,
     /* 211286 */     GIR_EraseRootFromParent_Done,
     /* 211287 */   // Label 4032: @211287
     /* 211287 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(211327), // Rule ID 12008 //
     /* 211292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211313 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 211316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211325 */     GIR_RootConstrainSelectedInstOperands,
     /* 211326 */     // GIR_Coverage, 12008,
     /* 211326 */     GIR_EraseRootFromParent_Done,
     /* 211327 */   // Label 4033: @211327
     /* 211327 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(211367), // Rule ID 12009 //
     /* 211332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211353 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 211356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211365 */     GIR_RootConstrainSelectedInstOperands,
     /* 211366 */     // GIR_Coverage, 12009,
     /* 211366 */     GIR_EraseRootFromParent_Done,
     /* 211367 */   // Label 4034: @211367
     /* 211367 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(211407), // Rule ID 12010 //
     /* 211372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211393 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 211396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211405 */     GIR_RootConstrainSelectedInstOperands,
     /* 211406 */     // GIR_Coverage, 12010,
     /* 211406 */     GIR_EraseRootFromParent_Done,
     /* 211407 */   // Label 4035: @211407
     /* 211407 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(211447), // Rule ID 12011 //
     /* 211412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211433 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 211436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211445 */     GIR_RootConstrainSelectedInstOperands,
     /* 211446 */     // GIR_Coverage, 12011,
     /* 211446 */     GIR_EraseRootFromParent_Done,
     /* 211447 */   // Label 4036: @211447
     /* 211447 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(211487), // Rule ID 12012 //
     /* 211452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 211476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211485 */     GIR_RootConstrainSelectedInstOperands,
     /* 211486 */     // GIR_Coverage, 12012,
     /* 211486 */     GIR_EraseRootFromParent_Done,
     /* 211487 */   // Label 4037: @211487
     /* 211487 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(211527), // Rule ID 12013 //
     /* 211492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211513 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 211516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211525 */     GIR_RootConstrainSelectedInstOperands,
     /* 211526 */     // GIR_Coverage, 12013,
     /* 211526 */     GIR_EraseRootFromParent_Done,
     /* 211527 */   // Label 4038: @211527
     /* 211527 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(211567), // Rule ID 12014 //
     /* 211532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211553 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 211556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211565 */     GIR_RootConstrainSelectedInstOperands,
     /* 211566 */     // GIR_Coverage, 12014,
     /* 211566 */     GIR_EraseRootFromParent_Done,
     /* 211567 */   // Label 4039: @211567
     /* 211567 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(211607), // Rule ID 12015 //
     /* 211572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211593 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 211596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211605 */     GIR_RootConstrainSelectedInstOperands,
     /* 211606 */     // GIR_Coverage, 12015,
     /* 211606 */     GIR_EraseRootFromParent_Done,
     /* 211607 */   // Label 4040: @211607
     /* 211607 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(211647), // Rule ID 12020 //
     /* 211612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211633 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 211636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211645 */     GIR_RootConstrainSelectedInstOperands,
     /* 211646 */     // GIR_Coverage, 12020,
     /* 211646 */     GIR_EraseRootFromParent_Done,
     /* 211647 */   // Label 4041: @211647
     /* 211647 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(211687), // Rule ID 12021 //
     /* 211652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211673 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 211676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211685 */     GIR_RootConstrainSelectedInstOperands,
     /* 211686 */     // GIR_Coverage, 12021,
     /* 211686 */     GIR_EraseRootFromParent_Done,
     /* 211687 */   // Label 4042: @211687
     /* 211687 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(211727), // Rule ID 12022 //
     /* 211692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 211716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211725 */     GIR_RootConstrainSelectedInstOperands,
     /* 211726 */     // GIR_Coverage, 12022,
     /* 211726 */     GIR_EraseRootFromParent_Done,
     /* 211727 */   // Label 4043: @211727
     /* 211727 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(211767), // Rule ID 12023 //
     /* 211732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211753 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 211756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211765 */     GIR_RootConstrainSelectedInstOperands,
     /* 211766 */     // GIR_Coverage, 12023,
     /* 211766 */     GIR_EraseRootFromParent_Done,
     /* 211767 */   // Label 4044: @211767
     /* 211767 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(211807), // Rule ID 12024 //
     /* 211772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211793 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 211796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211805 */     GIR_RootConstrainSelectedInstOperands,
     /* 211806 */     // GIR_Coverage, 12024,
     /* 211806 */     GIR_EraseRootFromParent_Done,
     /* 211807 */   // Label 4045: @211807
     /* 211807 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(211847), // Rule ID 12025 //
     /* 211812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 211836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211845 */     GIR_RootConstrainSelectedInstOperands,
     /* 211846 */     // GIR_Coverage, 12025,
     /* 211846 */     GIR_EraseRootFromParent_Done,
     /* 211847 */   // Label 4046: @211847
     /* 211847 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(211887), // Rule ID 12026 //
     /* 211852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211873 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 211876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211885 */     GIR_RootConstrainSelectedInstOperands,
     /* 211886 */     // GIR_Coverage, 12026,
     /* 211886 */     GIR_EraseRootFromParent_Done,
     /* 211887 */   // Label 4047: @211887
     /* 211887 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(211927), // Rule ID 12027 //
     /* 211892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211913 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 211916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211925 */     GIR_RootConstrainSelectedInstOperands,
     /* 211926 */     // GIR_Coverage, 12027,
     /* 211926 */     GIR_EraseRootFromParent_Done,
     /* 211927 */   // Label 4048: @211927
     /* 211927 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(211967), // Rule ID 12032 //
     /* 211932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211953 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 211956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211965 */     GIR_RootConstrainSelectedInstOperands,
     /* 211966 */     // GIR_Coverage, 12032,
     /* 211966 */     GIR_EraseRootFromParent_Done,
     /* 211967 */   // Label 4049: @211967
     /* 211967 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(212007), // Rule ID 12033 //
     /* 211972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211993 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 211996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212005 */     GIR_RootConstrainSelectedInstOperands,
     /* 212006 */     // GIR_Coverage, 12033,
     /* 212006 */     GIR_EraseRootFromParent_Done,
     /* 212007 */   // Label 4050: @212007
     /* 212007 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(212047), // Rule ID 12034 //
     /* 212012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212033 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 212036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212045 */     GIR_RootConstrainSelectedInstOperands,
     /* 212046 */     // GIR_Coverage, 12034,
     /* 212046 */     GIR_EraseRootFromParent_Done,
     /* 212047 */   // Label 4051: @212047
     /* 212047 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(212087), // Rule ID 12035 //
     /* 212052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212073 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 212076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212085 */     GIR_RootConstrainSelectedInstOperands,
     /* 212086 */     // GIR_Coverage, 12035,
     /* 212086 */     GIR_EraseRootFromParent_Done,
     /* 212087 */   // Label 4052: @212087
     /* 212087 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(212127), // Rule ID 12036 //
     /* 212092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212113 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 212116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212125 */     GIR_RootConstrainSelectedInstOperands,
     /* 212126 */     // GIR_Coverage, 12036,
     /* 212126 */     GIR_EraseRootFromParent_Done,
     /* 212127 */   // Label 4053: @212127
     /* 212127 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(212167), // Rule ID 12037 //
     /* 212132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212153 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 212156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212165 */     GIR_RootConstrainSelectedInstOperands,
     /* 212166 */     // GIR_Coverage, 12037,
     /* 212166 */     GIR_EraseRootFromParent_Done,
     /* 212167 */   // Label 4054: @212167
     /* 212167 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(212207), // Rule ID 12038 //
     /* 212172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212193 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 212196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212205 */     GIR_RootConstrainSelectedInstOperands,
     /* 212206 */     // GIR_Coverage, 12038,
     /* 212206 */     GIR_EraseRootFromParent_Done,
     /* 212207 */   // Label 4055: @212207
     /* 212207 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(212247), // Rule ID 12039 //
     /* 212212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212233 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 212236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212245 */     GIR_RootConstrainSelectedInstOperands,
     /* 212246 */     // GIR_Coverage, 12039,
     /* 212246 */     GIR_EraseRootFromParent_Done,
     /* 212247 */   // Label 4056: @212247
     /* 212247 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(212287), // Rule ID 12044 //
     /* 212252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 212276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212285 */     GIR_RootConstrainSelectedInstOperands,
     /* 212286 */     // GIR_Coverage, 12044,
     /* 212286 */     GIR_EraseRootFromParent_Done,
     /* 212287 */   // Label 4057: @212287
     /* 212287 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(212327), // Rule ID 12045 //
     /* 212292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212313 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 212316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212325 */     GIR_RootConstrainSelectedInstOperands,
     /* 212326 */     // GIR_Coverage, 12045,
     /* 212326 */     GIR_EraseRootFromParent_Done,
     /* 212327 */   // Label 4058: @212327
     /* 212327 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(212367), // Rule ID 12046 //
     /* 212332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212353 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 212356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212365 */     GIR_RootConstrainSelectedInstOperands,
     /* 212366 */     // GIR_Coverage, 12046,
     /* 212366 */     GIR_EraseRootFromParent_Done,
     /* 212367 */   // Label 4059: @212367
     /* 212367 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(212407), // Rule ID 12047 //
     /* 212372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212393 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 212396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212405 */     GIR_RootConstrainSelectedInstOperands,
     /* 212406 */     // GIR_Coverage, 12047,
     /* 212406 */     GIR_EraseRootFromParent_Done,
     /* 212407 */   // Label 4060: @212407
     /* 212407 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(212447), // Rule ID 12048 //
     /* 212412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212433 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 212436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212445 */     GIR_RootConstrainSelectedInstOperands,
     /* 212446 */     // GIR_Coverage, 12048,
     /* 212446 */     GIR_EraseRootFromParent_Done,
     /* 212447 */   // Label 4061: @212447
     /* 212447 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(212487), // Rule ID 12049 //
     /* 212452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212473 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 212476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212485 */     GIR_RootConstrainSelectedInstOperands,
     /* 212486 */     // GIR_Coverage, 12049,
     /* 212486 */     GIR_EraseRootFromParent_Done,
     /* 212487 */   // Label 4062: @212487
     /* 212487 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(212527), // Rule ID 12050 //
     /* 212492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212513 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 212516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212525 */     GIR_RootConstrainSelectedInstOperands,
     /* 212526 */     // GIR_Coverage, 12050,
     /* 212526 */     GIR_EraseRootFromParent_Done,
     /* 212527 */   // Label 4063: @212527
     /* 212527 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(212567), // Rule ID 12051 //
     /* 212532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212553 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 212556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212565 */     GIR_RootConstrainSelectedInstOperands,
     /* 212566 */     // GIR_Coverage, 12051,
     /* 212566 */     GIR_EraseRootFromParent_Done,
     /* 212567 */   // Label 4064: @212567
     /* 212567 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(212604), // Rule ID 12061 //
     /* 212572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 212575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212593 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1642:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 212596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212602 */     GIR_RootConstrainSelectedInstOperands,
     /* 212603 */     // GIR_Coverage, 12061,
     /* 212603 */     GIR_EraseRootFromParent_Done,
     /* 212604 */   // Label 4065: @212604
     /* 212604 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(212641), // Rule ID 12062 //
     /* 212609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 212612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 212617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 212633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212639 */     GIR_RootConstrainSelectedInstOperands,
     /* 212640 */     // GIR_Coverage, 12062,
     /* 212640 */     GIR_EraseRootFromParent_Done,
     /* 212641 */   // Label 4066: @212641
     /* 212641 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(212678), // Rule ID 12063 //
     /* 212646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212667 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1282:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 212670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212676 */     GIR_RootConstrainSelectedInstOperands,
     /* 212677 */     // GIR_Coverage, 12063,
     /* 212677 */     GIR_EraseRootFromParent_Done,
     /* 212678 */   // Label 4067: @212678
     /* 212678 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(212715), // Rule ID 12064 //
     /* 212683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1282:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 212707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212713 */     GIR_RootConstrainSelectedInstOperands,
     /* 212714 */     // GIR_Coverage, 12064,
     /* 212714 */     GIR_EraseRootFromParent_Done,
     /* 212715 */   // Label 4068: @212715
     /* 212715 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(212752), // Rule ID 12065 //
     /* 212720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1282:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 212744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212750 */     GIR_RootConstrainSelectedInstOperands,
     /* 212751 */     // GIR_Coverage, 12065,
     /* 212751 */     GIR_EraseRootFromParent_Done,
     /* 212752 */   // Label 4069: @212752
     /* 212752 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(212789), // Rule ID 12066 //
     /* 212757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1282:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 212781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212787 */     GIR_RootConstrainSelectedInstOperands,
     /* 212788 */     // GIR_Coverage, 12066,
     /* 212788 */     GIR_EraseRootFromParent_Done,
     /* 212789 */   // Label 4070: @212789
     /* 212789 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(212826), // Rule ID 12067 //
     /* 212794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1299:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 212818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212824 */     GIR_RootConstrainSelectedInstOperands,
     /* 212825 */     // GIR_Coverage, 12067,
     /* 212825 */     GIR_EraseRootFromParent_Done,
     /* 212826 */   // Label 4071: @212826
     /* 212826 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(212863), // Rule ID 12068 //
     /* 212831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1299:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 212855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212861 */     GIR_RootConstrainSelectedInstOperands,
     /* 212862 */     // GIR_Coverage, 12068,
     /* 212862 */     GIR_EraseRootFromParent_Done,
     /* 212863 */   // Label 4072: @212863
     /* 212863 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(212900), // Rule ID 12069 //
     /* 212868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1299:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 212892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212898 */     GIR_RootConstrainSelectedInstOperands,
     /* 212899 */     // GIR_Coverage, 12069,
     /* 212899 */     GIR_EraseRootFromParent_Done,
     /* 212900 */   // Label 4073: @212900
     /* 212900 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(212937), // Rule ID 12070 //
     /* 212905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1299:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 212929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212935 */     GIR_RootConstrainSelectedInstOperands,
     /* 212936 */     // GIR_Coverage, 12070,
     /* 212936 */     GIR_EraseRootFromParent_Done,
     /* 212937 */   // Label 4074: @212937
     /* 212937 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(212974), // Rule ID 12184 //
     /* 212942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 212950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212963 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1448:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 212963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 212966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212972 */     GIR_RootConstrainSelectedInstOperands,
     /* 212973 */     // GIR_Coverage, 12184,
     /* 212973 */     GIR_EraseRootFromParent_Done,
     /* 212974 */   // Label 4075: @212974
     /* 212974 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(213011), // Rule ID 12185 //
     /* 212979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 212987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213000 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1448:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 213003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213009 */     GIR_RootConstrainSelectedInstOperands,
     /* 213010 */     // GIR_Coverage, 12185,
     /* 213010 */     GIR_EraseRootFromParent_Done,
     /* 213011 */   // Label 4076: @213011
     /* 213011 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(213048), // Rule ID 12186 //
     /* 213016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 213024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213037 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1448:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 213040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213046 */     GIR_RootConstrainSelectedInstOperands,
     /* 213047 */     // GIR_Coverage, 12186,
     /* 213047 */     GIR_EraseRootFromParent_Done,
     /* 213048 */   // Label 4077: @213048
     /* 213048 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(213085), // Rule ID 12187 //
     /* 213053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213074 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 213077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213083 */     GIR_RootConstrainSelectedInstOperands,
     /* 213084 */     // GIR_Coverage, 12187,
     /* 213084 */     GIR_EraseRootFromParent_Done,
     /* 213085 */   // Label 4078: @213085
     /* 213085 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(213122), // Rule ID 12188 //
     /* 213090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213111 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 213114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213120 */     GIR_RootConstrainSelectedInstOperands,
     /* 213121 */     // GIR_Coverage, 12188,
     /* 213121 */     GIR_EraseRootFromParent_Done,
     /* 213122 */   // Label 4079: @213122
     /* 213122 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(213159), // Rule ID 12189 //
     /* 213127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213148 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 213151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213157 */     GIR_RootConstrainSelectedInstOperands,
     /* 213158 */     // GIR_Coverage, 12189,
     /* 213158 */     GIR_EraseRootFromParent_Done,
     /* 213159 */   // Label 4080: @213159
     /* 213159 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(213196), // Rule ID 12190 //
     /* 213164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213185 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1451:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 213188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213194 */     GIR_RootConstrainSelectedInstOperands,
     /* 213195 */     // GIR_Coverage, 12190,
     /* 213195 */     GIR_EraseRootFromParent_Done,
     /* 213196 */   // Label 4081: @213196
     /* 213196 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(213233), // Rule ID 12191 //
     /* 213201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213222 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 213225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213231 */     GIR_RootConstrainSelectedInstOperands,
     /* 213232 */     // GIR_Coverage, 12191,
     /* 213232 */     GIR_EraseRootFromParent_Done,
     /* 213233 */   // Label 4082: @213233
     /* 213233 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(213270), // Rule ID 12192 //
     /* 213238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213259 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 213262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213268 */     GIR_RootConstrainSelectedInstOperands,
     /* 213269 */     // GIR_Coverage, 12192,
     /* 213269 */     GIR_EraseRootFromParent_Done,
     /* 213270 */   // Label 4083: @213270
     /* 213270 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(213307), // Rule ID 12193 //
     /* 213275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213296 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1469:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 213299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213305 */     GIR_RootConstrainSelectedInstOperands,
     /* 213306 */     // GIR_Coverage, 12193,
     /* 213306 */     GIR_EraseRootFromParent_Done,
     /* 213307 */   // Label 4084: @213307
     /* 213307 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(213344), // Rule ID 12194 //
     /* 213312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213333 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 213336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213342 */     GIR_RootConstrainSelectedInstOperands,
     /* 213343 */     // GIR_Coverage, 12194,
     /* 213343 */     GIR_EraseRootFromParent_Done,
     /* 213344 */   // Label 4085: @213344
     /* 213344 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(213381), // Rule ID 12195 //
     /* 213349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213370 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 213373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213379 */     GIR_RootConstrainSelectedInstOperands,
     /* 213380 */     // GIR_Coverage, 12195,
     /* 213380 */     GIR_EraseRootFromParent_Done,
     /* 213381 */   // Label 4086: @213381
     /* 213381 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(213418), // Rule ID 12196 //
     /* 213386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213407 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1363:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213416 */     GIR_RootConstrainSelectedInstOperands,
     /* 213417 */     // GIR_Coverage, 12196,
     /* 213417 */     GIR_EraseRootFromParent_Done,
     /* 213418 */   // Label 4087: @213418
     /* 213418 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(213455), // Rule ID 12197 //
     /* 213423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213444 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 213447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213453 */     GIR_RootConstrainSelectedInstOperands,
     /* 213454 */     // GIR_Coverage, 12197,
     /* 213454 */     GIR_EraseRootFromParent_Done,
     /* 213455 */   // Label 4088: @213455
     /* 213455 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(213492), // Rule ID 12198 //
     /* 213460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 213484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213490 */     GIR_RootConstrainSelectedInstOperands,
     /* 213491 */     // GIR_Coverage, 12198,
     /* 213491 */     GIR_EraseRootFromParent_Done,
     /* 213492 */   // Label 4089: @213492
     /* 213492 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(213529), // Rule ID 12199 //
     /* 213497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213518 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 213521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213527 */     GIR_RootConstrainSelectedInstOperands,
     /* 213528 */     // GIR_Coverage, 12199,
     /* 213528 */     GIR_EraseRootFromParent_Done,
     /* 213529 */   // Label 4090: @213529
     /* 213529 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(213566), // Rule ID 12200 //
     /* 213534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213555 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1275:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 213558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213564 */     GIR_RootConstrainSelectedInstOperands,
     /* 213565 */     // GIR_Coverage, 12200,
     /* 213565 */     GIR_EraseRootFromParent_Done,
     /* 213566 */   // Label 4091: @213566
     /* 213566 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(213603), // Rule ID 12201 //
     /* 213571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1275:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 213595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213601 */     GIR_RootConstrainSelectedInstOperands,
     /* 213602 */     // GIR_Coverage, 12201,
     /* 213602 */     GIR_EraseRootFromParent_Done,
     /* 213603 */   // Label 4092: @213603
     /* 213603 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(213640), // Rule ID 12202 //
     /* 213608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213629 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1275:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 213632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213638 */     GIR_RootConstrainSelectedInstOperands,
     /* 213639 */     // GIR_Coverage, 12202,
     /* 213639 */     GIR_EraseRootFromParent_Done,
     /* 213640 */   // Label 4093: @213640
     /* 213640 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(213677), // Rule ID 12203 //
     /* 213645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213666 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1275:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 213669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213675 */     GIR_RootConstrainSelectedInstOperands,
     /* 213676 */     // GIR_Coverage, 12203,
     /* 213676 */     GIR_EraseRootFromParent_Done,
     /* 213677 */   // Label 4094: @213677
     /* 213677 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(213714), // Rule ID 12204 //
     /* 213682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213703 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1263:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 213706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213712 */     GIR_RootConstrainSelectedInstOperands,
     /* 213713 */     // GIR_Coverage, 12204,
     /* 213713 */     GIR_EraseRootFromParent_Done,
     /* 213714 */   // Label 4095: @213714
     /* 213714 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(213751), // Rule ID 12205 //
     /* 213719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213740 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1263:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 213743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213749 */     GIR_RootConstrainSelectedInstOperands,
     /* 213750 */     // GIR_Coverage, 12205,
     /* 213750 */     GIR_EraseRootFromParent_Done,
     /* 213751 */   // Label 4096: @213751
     /* 213751 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(213788), // Rule ID 12206 //
     /* 213756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1263:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 213780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213786 */     GIR_RootConstrainSelectedInstOperands,
     /* 213787 */     // GIR_Coverage, 12206,
     /* 213787 */     GIR_EraseRootFromParent_Done,
     /* 213788 */   // Label 4097: @213788
     /* 213788 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(213825), // Rule ID 12207 //
     /* 213793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1263:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 213817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213823 */     GIR_RootConstrainSelectedInstOperands,
     /* 213824 */     // GIR_Coverage, 12207,
     /* 213824 */     GIR_EraseRootFromParent_Done,
     /* 213825 */   // Label 4098: @213825
     /* 213825 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(213862), // Rule ID 12208 //
     /* 213830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213851 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1742:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 213854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213860 */     GIR_RootConstrainSelectedInstOperands,
     /* 213861 */     // GIR_Coverage, 12208,
     /* 213861 */     GIR_EraseRootFromParent_Done,
     /* 213862 */   // Label 4099: @213862
     /* 213862 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(213899), // Rule ID 12209 //
     /* 213867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213888 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1742:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 213891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213897 */     GIR_RootConstrainSelectedInstOperands,
     /* 213898 */     // GIR_Coverage, 12209,
     /* 213898 */     GIR_EraseRootFromParent_Done,
     /* 213899 */   // Label 4100: @213899
     /* 213899 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(213936), // Rule ID 12210 //
     /* 213904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213925 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1742:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 213928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213934 */     GIR_RootConstrainSelectedInstOperands,
     /* 213935 */     // GIR_Coverage, 12210,
     /* 213935 */     GIR_EraseRootFromParent_Done,
     /* 213936 */   // Label 4101: @213936
     /* 213936 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(213973), // Rule ID 12211 //
     /* 213941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213962 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1742:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 213965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213971 */     GIR_RootConstrainSelectedInstOperands,
     /* 213972 */     // GIR_Coverage, 12211,
     /* 213972 */     GIR_EraseRootFromParent_Done,
     /* 213973 */   // Label 4102: @213973
     /* 213973 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(214010), // Rule ID 12212 //
     /* 213978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 213986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213999 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1980:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 214002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214008 */     GIR_RootConstrainSelectedInstOperands,
     /* 214009 */     // GIR_Coverage, 12212,
     /* 214009 */     GIR_EraseRootFromParent_Done,
     /* 214010 */   // Label 4103: @214010
     /* 214010 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(214047), // Rule ID 12213 //
     /* 214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214036 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1980:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 214039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214045 */     GIR_RootConstrainSelectedInstOperands,
     /* 214046 */     // GIR_Coverage, 12213,
     /* 214046 */     GIR_EraseRootFromParent_Done,
     /* 214047 */   // Label 4104: @214047
     /* 214047 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(214084), // Rule ID 12214 //
     /* 214052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1980:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 214076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214082 */     GIR_RootConstrainSelectedInstOperands,
     /* 214083 */     // GIR_Coverage, 12214,
     /* 214083 */     GIR_EraseRootFromParent_Done,
     /* 214084 */   // Label 4105: @214084
     /* 214084 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(214121), // Rule ID 12215 //
     /* 214089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214110 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1980:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 214113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214119 */     GIR_RootConstrainSelectedInstOperands,
     /* 214120 */     // GIR_Coverage, 12215,
     /* 214120 */     GIR_EraseRootFromParent_Done,
     /* 214121 */   // Label 4106: @214121
     /* 214121 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(214158), // Rule ID 12216 //
     /* 214126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214147 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1751:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 214150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214156 */     GIR_RootConstrainSelectedInstOperands,
     /* 214157 */     // GIR_Coverage, 12216,
     /* 214157 */     GIR_EraseRootFromParent_Done,
     /* 214158 */   // Label 4107: @214158
     /* 214158 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(214195), // Rule ID 12217 //
     /* 214163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214184 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1751:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 214187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214193 */     GIR_RootConstrainSelectedInstOperands,
     /* 214194 */     // GIR_Coverage, 12217,
     /* 214194 */     GIR_EraseRootFromParent_Done,
     /* 214195 */   // Label 4108: @214195
     /* 214195 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(214232), // Rule ID 12218 //
     /* 214200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214221 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1751:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 214224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214230 */     GIR_RootConstrainSelectedInstOperands,
     /* 214231 */     // GIR_Coverage, 12218,
     /* 214231 */     GIR_EraseRootFromParent_Done,
     /* 214232 */   // Label 4109: @214232
     /* 214232 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(214269), // Rule ID 12219 //
     /* 214237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214258 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1751:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 214261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214267 */     GIR_RootConstrainSelectedInstOperands,
     /* 214268 */     // GIR_Coverage, 12219,
     /* 214268 */     GIR_EraseRootFromParent_Done,
     /* 214269 */   // Label 4110: @214269
     /* 214269 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(214306), // Rule ID 12220 //
     /* 214274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214295 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1989:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 214298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214304 */     GIR_RootConstrainSelectedInstOperands,
     /* 214305 */     // GIR_Coverage, 12220,
     /* 214305 */     GIR_EraseRootFromParent_Done,
     /* 214306 */   // Label 4111: @214306
     /* 214306 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(214343), // Rule ID 12221 //
     /* 214311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214332 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1989:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214341 */     GIR_RootConstrainSelectedInstOperands,
     /* 214342 */     // GIR_Coverage, 12221,
     /* 214342 */     GIR_EraseRootFromParent_Done,
     /* 214343 */   // Label 4112: @214343
     /* 214343 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(214380), // Rule ID 12222 //
     /* 214348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1989:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 214372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214378 */     GIR_RootConstrainSelectedInstOperands,
     /* 214379 */     // GIR_Coverage, 12222,
     /* 214379 */     GIR_EraseRootFromParent_Done,
     /* 214380 */   // Label 4113: @214380
     /* 214380 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(214417), // Rule ID 12223 //
     /* 214385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214406 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1989:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 214409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214415 */     GIR_RootConstrainSelectedInstOperands,
     /* 214416 */     // GIR_Coverage, 12223,
     /* 214416 */     GIR_EraseRootFromParent_Done,
     /* 214417 */   // Label 4114: @214417
     /* 214417 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(214454), // Rule ID 12224 //
     /* 214422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2173:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 214446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214452 */     GIR_RootConstrainSelectedInstOperands,
     /* 214453 */     // GIR_Coverage, 12224,
     /* 214453 */     GIR_EraseRootFromParent_Done,
     /* 214454 */   // Label 4115: @214454
     /* 214454 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(214491), // Rule ID 12225 //
     /* 214459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2173:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214489 */     GIR_RootConstrainSelectedInstOperands,
     /* 214490 */     // GIR_Coverage, 12225,
     /* 214490 */     GIR_EraseRootFromParent_Done,
     /* 214491 */   // Label 4116: @214491
     /* 214491 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(214528), // Rule ID 12226 //
     /* 214496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2173:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 214520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214526 */     GIR_RootConstrainSelectedInstOperands,
     /* 214527 */     // GIR_Coverage, 12226,
     /* 214527 */     GIR_EraseRootFromParent_Done,
     /* 214528 */   // Label 4117: @214528
     /* 214528 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(214565), // Rule ID 12227 //
     /* 214533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2173:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 214557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214563 */     GIR_RootConstrainSelectedInstOperands,
     /* 214564 */     // GIR_Coverage, 12227,
     /* 214564 */     GIR_EraseRootFromParent_Done,
     /* 214565 */   // Label 4118: @214565
     /* 214565 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(214602), // Rule ID 12228 //
     /* 214570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214591 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2173:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214600 */     GIR_RootConstrainSelectedInstOperands,
     /* 214601 */     // GIR_Coverage, 12228,
     /* 214601 */     GIR_EraseRootFromParent_Done,
     /* 214602 */   // Label 4119: @214602
     /* 214602 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(214639), // Rule ID 12229 //
     /* 214607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214628 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2173:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 214628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 214631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214637 */     GIR_RootConstrainSelectedInstOperands,
     /* 214638 */     // GIR_Coverage, 12229,
     /* 214638 */     GIR_EraseRootFromParent_Done,
     /* 214639 */   // Label 4120: @214639
     /* 214639 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(214676), // Rule ID 12230 //
     /* 214644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214665 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2173:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 214665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 214668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214674 */     GIR_RootConstrainSelectedInstOperands,
     /* 214675 */     // GIR_Coverage, 12230,
     /* 214675 */     GIR_EraseRootFromParent_Done,
     /* 214676 */   // Label 4121: @214676
     /* 214676 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(214713), // Rule ID 12231 //
     /* 214681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214702 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2098:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 214705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214711 */     GIR_RootConstrainSelectedInstOperands,
     /* 214712 */     // GIR_Coverage, 12231,
     /* 214712 */     GIR_EraseRootFromParent_Done,
     /* 214713 */   // Label 4122: @214713
     /* 214713 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(214750), // Rule ID 12232 //
     /* 214718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2098:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 214742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214748 */     GIR_RootConstrainSelectedInstOperands,
     /* 214749 */     // GIR_Coverage, 12232,
     /* 214749 */     GIR_EraseRootFromParent_Done,
     /* 214750 */   // Label 4123: @214750
     /* 214750 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(214787), // Rule ID 12233 //
     /* 214755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2098:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 214779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214785 */     GIR_RootConstrainSelectedInstOperands,
     /* 214786 */     // GIR_Coverage, 12233,
     /* 214786 */     GIR_EraseRootFromParent_Done,
     /* 214787 */   // Label 4124: @214787
     /* 214787 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(214824), // Rule ID 12234 //
     /* 214792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2098:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 214816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214822 */     GIR_RootConstrainSelectedInstOperands,
     /* 214823 */     // GIR_Coverage, 12234,
     /* 214823 */     GIR_EraseRootFromParent_Done,
     /* 214824 */   // Label 4125: @214824
     /* 214824 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(214861), // Rule ID 12235 //
     /* 214829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214850 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2098:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 214853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214859 */     GIR_RootConstrainSelectedInstOperands,
     /* 214860 */     // GIR_Coverage, 12235,
     /* 214860 */     GIR_EraseRootFromParent_Done,
     /* 214861 */   // Label 4126: @214861
     /* 214861 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(214898), // Rule ID 12236 //
     /* 214866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214887 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2098:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 214887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 214890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214896 */     GIR_RootConstrainSelectedInstOperands,
     /* 214897 */     // GIR_Coverage, 12236,
     /* 214897 */     GIR_EraseRootFromParent_Done,
     /* 214898 */   // Label 4127: @214898
     /* 214898 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(214935), // Rule ID 12237 //
     /* 214903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214924 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2098:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 214924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 214927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214933 */     GIR_RootConstrainSelectedInstOperands,
     /* 214934 */     // GIR_Coverage, 12237,
     /* 214934 */     GIR_EraseRootFromParent_Done,
     /* 214935 */   // Label 4128: @214935
     /* 214935 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(214972), // Rule ID 12238 //
     /* 214940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214961 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2099:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 214964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214970 */     GIR_RootConstrainSelectedInstOperands,
     /* 214971 */     // GIR_Coverage, 12238,
     /* 214971 */     GIR_EraseRootFromParent_Done,
     /* 214972 */   // Label 4129: @214972
     /* 214972 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(215009), // Rule ID 12239 //
     /* 214977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2099:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 215001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215007 */     GIR_RootConstrainSelectedInstOperands,
     /* 215008 */     // GIR_Coverage, 12239,
     /* 215008 */     GIR_EraseRootFromParent_Done,
     /* 215009 */   // Label 4130: @215009
     /* 215009 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(215046), // Rule ID 12240 //
     /* 215014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2099:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 215038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215044 */     GIR_RootConstrainSelectedInstOperands,
     /* 215045 */     // GIR_Coverage, 12240,
     /* 215045 */     GIR_EraseRootFromParent_Done,
     /* 215046 */   // Label 4131: @215046
     /* 215046 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(215083), // Rule ID 12241 //
     /* 215051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2099:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 215075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215081 */     GIR_RootConstrainSelectedInstOperands,
     /* 215082 */     // GIR_Coverage, 12241,
     /* 215082 */     GIR_EraseRootFromParent_Done,
     /* 215083 */   // Label 4132: @215083
     /* 215083 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(215120), // Rule ID 12242 //
     /* 215088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215109 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2099:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 215112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215118 */     GIR_RootConstrainSelectedInstOperands,
     /* 215119 */     // GIR_Coverage, 12242,
     /* 215119 */     GIR_EraseRootFromParent_Done,
     /* 215120 */   // Label 4133: @215120
     /* 215120 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(215157), // Rule ID 12243 //
     /* 215125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2099:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 215149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215155 */     GIR_RootConstrainSelectedInstOperands,
     /* 215156 */     // GIR_Coverage, 12243,
     /* 215156 */     GIR_EraseRootFromParent_Done,
     /* 215157 */   // Label 4134: @215157
     /* 215157 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(215194), // Rule ID 12244 //
     /* 215162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2099:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 215186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215192 */     GIR_RootConstrainSelectedInstOperands,
     /* 215193 */     // GIR_Coverage, 12244,
     /* 215193 */     GIR_EraseRootFromParent_Done,
     /* 215194 */   // Label 4135: @215194
     /* 215194 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(215236), // Rule ID 3214 //
     /* 215199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 215207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215214 */     // MIs[0] Op1
     /* 215214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215218 */     // MIs[0] Op2
     /* 215218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 215225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215234 */     GIR_RootConstrainSelectedInstOperands,
     /* 215235 */     // GIR_Coverage, 3214,
     /* 215235 */     GIR_EraseRootFromParent_Done,
     /* 215236 */   // Label 4136: @215236
     /* 215236 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(215278), // Rule ID 3215 //
     /* 215241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 215249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215256 */     // MIs[0] Op1
     /* 215256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215260 */     // MIs[0] Op2
     /* 215260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2154:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 215267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215276 */     GIR_RootConstrainSelectedInstOperands,
     /* 215277 */     // GIR_Coverage, 3215,
     /* 215277 */     GIR_EraseRootFromParent_Done,
     /* 215278 */   // Label 4137: @215278
     /* 215278 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(215320), // Rule ID 3216 //
     /* 215283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 215291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215298 */     // MIs[0] Op1
     /* 215298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215302 */     // MIs[0] Op2
     /* 215302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2155:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 215309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215318 */     GIR_RootConstrainSelectedInstOperands,
     /* 215319 */     // GIR_Coverage, 3216,
     /* 215319 */     GIR_EraseRootFromParent_Done,
     /* 215320 */   // Label 4138: @215320
     /* 215320 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(215362), // Rule ID 3217 //
     /* 215325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 215333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215340 */     // MIs[0] Op1
     /* 215340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215344 */     // MIs[0] Op2
     /* 215344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215348 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2153:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 215351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215360 */     GIR_RootConstrainSelectedInstOperands,
     /* 215361 */     // GIR_Coverage, 3217,
     /* 215361 */     GIR_EraseRootFromParent_Done,
     /* 215362 */   // Label 4139: @215362
     /* 215362 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(215404), // Rule ID 12056 //
     /* 215367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 215375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215382 */     // MIs[0] Op1
     /* 215382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215386 */     // MIs[0] Op2
     /* 215386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2148:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 215393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215402 */     GIR_RootConstrainSelectedInstOperands,
     /* 215403 */     // GIR_Coverage, 12056,
     /* 215403 */     GIR_EraseRootFromParent_Done,
     /* 215404 */   // Label 4140: @215404
     /* 215404 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(215446), // Rule ID 12057 //
     /* 215409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 215417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215424 */     // MIs[0] Op1
     /* 215424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215428 */     // MIs[0] Op2
     /* 215428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2150:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 215435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215444 */     GIR_RootConstrainSelectedInstOperands,
     /* 215445 */     // GIR_Coverage, 12057,
     /* 215445 */     GIR_EraseRootFromParent_Done,
     /* 215446 */   // Label 4141: @215446
     /* 215446 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(215488), // Rule ID 12058 //
     /* 215451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 215459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215466 */     // MIs[0] Op1
     /* 215466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215470 */     // MIs[0] Op2
     /* 215470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2151:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 215477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215486 */     GIR_RootConstrainSelectedInstOperands,
     /* 215487 */     // GIR_Coverage, 12058,
     /* 215487 */     GIR_EraseRootFromParent_Done,
     /* 215488 */   // Label 4142: @215488
     /* 215488 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(215530), // Rule ID 12059 //
     /* 215493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 215501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215508 */     // MIs[0] Op1
     /* 215508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215512 */     // MIs[0] Op2
     /* 215512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2149:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 215519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215528 */     GIR_RootConstrainSelectedInstOperands,
     /* 215529 */     // GIR_Coverage, 12059,
     /* 215529 */     GIR_EraseRootFromParent_Done,
     /* 215530 */   // Label 4143: @215530
     /* 215530 */   GIM_Reject,
     /* 215531 */ // Label 3247: @215531
     /* 215531 */ GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(258642),
     /* 215536 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 215539 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(215652), // Rule ID 2069 //
     /* 215544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 215596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 215609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215617 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 215621 */     // MIs[3] Operand 1
     /* 215621 */     // No operand predicates
     /* 215621 */     // MIs[1] Operand 2
     /* 215621 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215634 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 215637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215650 */     GIR_RootConstrainSelectedInstOperands,
     /* 215651 */     // GIR_Coverage, 2069,
     /* 215651 */     GIR_EraseRootFromParent_Done,
     /* 215652 */   // Label 4145: @215652
     /* 215652 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(215765), // Rule ID 2076 //
     /* 215657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 215709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 215722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 215734 */     // MIs[3] Operand 1
     /* 215734 */     // No operand predicates
     /* 215734 */     // MIs[1] Operand 2
     /* 215734 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215747 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 215750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215763 */     GIR_RootConstrainSelectedInstOperands,
     /* 215764 */     // GIR_Coverage, 2076,
     /* 215764 */     GIR_EraseRootFromParent_Done,
     /* 215765 */   // Label 4146: @215765
     /* 215765 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(215878), // Rule ID 2072 //
     /* 215770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215847 */     // MIs[3] Operand 1
     /* 215847 */     // No operand predicates
     /* 215847 */     // MIs[1] Operand 2
     /* 215847 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215860 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 215863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215876 */     GIR_RootConstrainSelectedInstOperands,
     /* 215877 */     // GIR_Coverage, 2072,
     /* 215877 */     GIR_EraseRootFromParent_Done,
     /* 215878 */   // Label 4147: @215878
     /* 215878 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(215991), // Rule ID 2079 //
     /* 215883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215956 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215960 */     // MIs[3] Operand 1
     /* 215960 */     // No operand predicates
     /* 215960 */     // MIs[1] Operand 2
     /* 215960 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215973 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 215976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215989 */     GIR_RootConstrainSelectedInstOperands,
     /* 215990 */     // GIR_Coverage, 2079,
     /* 215990 */     GIR_EraseRootFromParent_Done,
     /* 215991 */   // Label 4148: @215991
     /* 215991 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(216096), // Rule ID 3873 //
     /* 215996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216073 */     // MIs[3] Operand 1
     /* 216073 */     // No operand predicates
     /* 216073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216075 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216094 */     GIR_RootConstrainSelectedInstOperands,
     /* 216095 */     // GIR_Coverage, 3873,
     /* 216095 */     GIR_EraseRootFromParent_Done,
     /* 216096 */   // Label 4149: @216096
     /* 216096 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(216201), // Rule ID 3874 //
     /* 216101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216174 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216178 */     // MIs[3] Operand 1
     /* 216178 */     // No operand predicates
     /* 216178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216180 */     // (intrinsic_wo_chain:{ *:[v4f16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216199 */     GIR_RootConstrainSelectedInstOperands,
     /* 216200 */     // GIR_Coverage, 3874,
     /* 216200 */     GIR_EraseRootFromParent_Done,
     /* 216201 */   // Label 4150: @216201
     /* 216201 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(216306), // Rule ID 3875 //
     /* 216206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216279 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216283 */     // MIs[3] Operand 1
     /* 216283 */     // No operand predicates
     /* 216283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216285 */     // (intrinsic_wo_chain:{ *:[v4f16] } 768:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 216285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216304 */     GIR_RootConstrainSelectedInstOperands,
     /* 216305 */     // GIR_Coverage, 3875,
     /* 216305 */     GIR_EraseRootFromParent_Done,
     /* 216306 */   // Label 4151: @216306
     /* 216306 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216411), // Rule ID 3876 //
     /* 216311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216384 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216388 */     // MIs[3] Operand 1
     /* 216388 */     // No operand predicates
     /* 216388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216390 */     // (intrinsic_wo_chain:{ *:[v4f16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 216390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216409 */     GIR_RootConstrainSelectedInstOperands,
     /* 216410 */     // GIR_Coverage, 3876,
     /* 216410 */     GIR_EraseRootFromParent_Done,
     /* 216411 */   // Label 4152: @216411
     /* 216411 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216516), // Rule ID 3881 //
     /* 216416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216493 */     // MIs[3] Operand 1
     /* 216493 */     // No operand predicates
     /* 216493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216495 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216514 */     GIR_RootConstrainSelectedInstOperands,
     /* 216515 */     // GIR_Coverage, 3881,
     /* 216515 */     GIR_EraseRootFromParent_Done,
     /* 216516 */   // Label 4153: @216516
     /* 216516 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216621), // Rule ID 3882 //
     /* 216521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216594 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216598 */     // MIs[3] Operand 1
     /* 216598 */     // No operand predicates
     /* 216598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216600 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216619 */     GIR_RootConstrainSelectedInstOperands,
     /* 216620 */     // GIR_Coverage, 3882,
     /* 216620 */     GIR_EraseRootFromParent_Done,
     /* 216621 */   // Label 4154: @216621
     /* 216621 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216726), // Rule ID 3883 //
     /* 216626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216703 */     // MIs[3] Operand 1
     /* 216703 */     // No operand predicates
     /* 216703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216705 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 216705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216724 */     GIR_RootConstrainSelectedInstOperands,
     /* 216725 */     // GIR_Coverage, 3883,
     /* 216725 */     GIR_EraseRootFromParent_Done,
     /* 216726 */   // Label 4155: @216726
     /* 216726 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(216831), // Rule ID 3884 //
     /* 216731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216804 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216808 */     // MIs[3] Operand 1
     /* 216808 */     // No operand predicates
     /* 216808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216810 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 216810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216829 */     GIR_RootConstrainSelectedInstOperands,
     /* 216830 */     // GIR_Coverage, 3884,
     /* 216830 */     GIR_EraseRootFromParent_Done,
     /* 216831 */   // Label 4156: @216831
     /* 216831 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(216936), // Rule ID 3897 //
     /* 216836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 216888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216909 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216913 */     // MIs[3] Operand 1
     /* 216913 */     // No operand predicates
     /* 216913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216915 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 216918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216934 */     GIR_RootConstrainSelectedInstOperands,
     /* 216935 */     // GIR_Coverage, 3897,
     /* 216935 */     GIR_EraseRootFromParent_Done,
     /* 216936 */   // Label 4157: @216936
     /* 216936 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(217041), // Rule ID 3898 //
     /* 216941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 216993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217018 */     // MIs[3] Operand 1
     /* 217018 */     // No operand predicates
     /* 217018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217020 */     // (intrinsic_wo_chain:{ *:[v4f32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 217020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217039 */     GIR_RootConstrainSelectedInstOperands,
     /* 217040 */     // GIR_Coverage, 3898,
     /* 217040 */     GIR_EraseRootFromParent_Done,
     /* 217041 */   // Label 4158: @217041
     /* 217041 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(217146), // Rule ID 3899 //
     /* 217046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217119 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217123 */     // MIs[3] Operand 1
     /* 217123 */     // No operand predicates
     /* 217123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217125 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 217125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217144 */     GIR_RootConstrainSelectedInstOperands,
     /* 217145 */     // GIR_Coverage, 3899,
     /* 217145 */     GIR_EraseRootFromParent_Done,
     /* 217146 */   // Label 4159: @217146
     /* 217146 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(217251), // Rule ID 3900 //
     /* 217151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217224 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217228 */     // MIs[3] Operand 1
     /* 217228 */     // No operand predicates
     /* 217228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217230 */     // (intrinsic_wo_chain:{ *:[v4f32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 217230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217249 */     GIR_RootConstrainSelectedInstOperands,
     /* 217250 */     // GIR_Coverage, 3900,
     /* 217250 */     GIR_EraseRootFromParent_Done,
     /* 217251 */   // Label 4160: @217251
     /* 217251 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(217305), // Rule ID 59 //
     /* 217256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217281 */     // MIs[0] Operand 3
     /* 217281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 217292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217296 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 217299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217303 */     GIR_RootConstrainSelectedInstOperands,
     /* 217304 */     // GIR_Coverage, 59,
     /* 217304 */     GIR_EraseRootFromParent_Done,
     /* 217305 */   // Label 4161: @217305
     /* 217305 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(217359), // Rule ID 60 //
     /* 217310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217335 */     // MIs[0] Operand 3
     /* 217335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 217346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217350 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 217353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217357 */     GIR_RootConstrainSelectedInstOperands,
     /* 217358 */     // GIR_Coverage, 60,
     /* 217358 */     GIR_EraseRootFromParent_Done,
     /* 217359 */   // Label 4162: @217359
     /* 217359 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(217413), // Rule ID 61 //
     /* 217364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217389 */     // MIs[0] Operand 3
     /* 217389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 217400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217404 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 217407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217411 */     GIR_RootConstrainSelectedInstOperands,
     /* 217412 */     // GIR_Coverage, 61,
     /* 217412 */     GIR_EraseRootFromParent_Done,
     /* 217413 */   // Label 4163: @217413
     /* 217413 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(217467), // Rule ID 62 //
     /* 217418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217443 */     // MIs[0] Operand 3
     /* 217443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 217454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217458 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 217461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217465 */     GIR_RootConstrainSelectedInstOperands,
     /* 217466 */     // GIR_Coverage, 62,
     /* 217466 */     GIR_EraseRootFromParent_Done,
     /* 217467 */   // Label 4164: @217467
     /* 217467 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(217523), // Rule ID 2648 //
     /* 217472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 217480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217494 */     // MIs[0] pattern
     /* 217494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217502 */     // MIs[0] imm4
     /* 217502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 217513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217517 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217519 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217521 */     GIR_RootConstrainSelectedInstOperands,
     /* 217522 */     // GIR_Coverage, 2648,
     /* 217522 */     GIR_EraseRootFromParent_Done,
     /* 217523 */   // Label 4165: @217523
     /* 217523 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(217579), // Rule ID 2657 //
     /* 217528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 217536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217550 */     // MIs[0] pattern
     /* 217550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217558 */     // MIs[0] imm4
     /* 217558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217566 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 217569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217573 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217575 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217577 */     GIR_RootConstrainSelectedInstOperands,
     /* 217578 */     // GIR_Coverage, 2657,
     /* 217578 */     GIR_EraseRootFromParent_Done,
     /* 217579 */   // Label 4166: @217579
     /* 217579 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(217635), // Rule ID 2658 //
     /* 217584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 217592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217606 */     // MIs[0] pattern
     /* 217606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217614 */     // MIs[0] imm4
     /* 217614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217622 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 217625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217629 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217631 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217633 */     GIR_RootConstrainSelectedInstOperands,
     /* 217634 */     // GIR_Coverage, 2658,
     /* 217634 */     GIR_EraseRootFromParent_Done,
     /* 217635 */   // Label 4167: @217635
     /* 217635 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217691), // Rule ID 10043 //
     /* 217640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 217648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217662 */     // MIs[0] pattern
     /* 217662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217670 */     // MIs[0] imm4
     /* 217670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217678 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 217681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217685 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217687 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217689 */     GIR_RootConstrainSelectedInstOperands,
     /* 217690 */     // GIR_Coverage, 10043,
     /* 217690 */     GIR_EraseRootFromParent_Done,
     /* 217691 */   // Label 4168: @217691
     /* 217691 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217747), // Rule ID 10044 //
     /* 217696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 217704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217718 */     // MIs[0] pattern
     /* 217718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217726 */     // MIs[0] imm4
     /* 217726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217734 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 217737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217741 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217743 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217745 */     GIR_RootConstrainSelectedInstOperands,
     /* 217746 */     // GIR_Coverage, 10044,
     /* 217746 */     GIR_EraseRootFromParent_Done,
     /* 217747 */   // Label 4169: @217747
     /* 217747 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217803), // Rule ID 10045 //
     /* 217752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 217760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217774 */     // MIs[0] pattern
     /* 217774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217782 */     // MIs[0] imm4
     /* 217782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217790 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 217793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217797 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217799 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217801 */     GIR_RootConstrainSelectedInstOperands,
     /* 217802 */     // GIR_Coverage, 10045,
     /* 217802 */     GIR_EraseRootFromParent_Done,
     /* 217803 */   // Label 4170: @217803
     /* 217803 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217859), // Rule ID 10046 //
     /* 217808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 217816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217830 */     // MIs[0] pattern
     /* 217830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217838 */     // MIs[0] imm4
     /* 217838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217846 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 217849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217853 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217855 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217857 */     GIR_RootConstrainSelectedInstOperands,
     /* 217858 */     // GIR_Coverage, 10046,
     /* 217858 */     GIR_EraseRootFromParent_Done,
     /* 217859 */   // Label 4171: @217859
     /* 217859 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217915), // Rule ID 10049 //
     /* 217864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 217872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217886 */     // MIs[0] pattern
     /* 217886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217894 */     // MIs[0] imm4
     /* 217894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217902 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 217905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217909 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217911 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217913 */     GIR_RootConstrainSelectedInstOperands,
     /* 217914 */     // GIR_Coverage, 10049,
     /* 217914 */     GIR_EraseRootFromParent_Done,
     /* 217915 */   // Label 4172: @217915
     /* 217915 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(217971), // Rule ID 10052 //
     /* 217920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 217928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217942 */     // MIs[0] pattern
     /* 217942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217950 */     // MIs[0] imm4
     /* 217950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217958 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 217961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217965 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217967 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217969 */     GIR_RootConstrainSelectedInstOperands,
     /* 217970 */     // GIR_Coverage, 10052,
     /* 217970 */     GIR_EraseRootFromParent_Done,
     /* 217971 */   // Label 4173: @217971
     /* 217971 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(218027), // Rule ID 10053 //
     /* 217976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 217984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217998 */     // MIs[0] pattern
     /* 217998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218006 */     // MIs[0] imm4
     /* 218006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218014 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 218017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218021 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218023 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218025 */     GIR_RootConstrainSelectedInstOperands,
     /* 218026 */     // GIR_Coverage, 10053,
     /* 218026 */     GIR_EraseRootFromParent_Done,
     /* 218027 */   // Label 4174: @218027
     /* 218027 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(218083), // Rule ID 10054 //
     /* 218032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 218040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218054 */     // MIs[0] pattern
     /* 218054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218062 */     // MIs[0] imm4
     /* 218062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218070 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 218073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218077 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218079 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218081 */     GIR_RootConstrainSelectedInstOperands,
     /* 218082 */     // GIR_Coverage, 10054,
     /* 218082 */     GIR_EraseRootFromParent_Done,
     /* 218083 */   // Label 4175: @218083
     /* 218083 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(218139), // Rule ID 10055 //
     /* 218088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 218096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218110 */     // MIs[0] pattern
     /* 218110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218118 */     // MIs[0] imm4
     /* 218118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218126 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 218129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218133 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218135 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218137 */     GIR_RootConstrainSelectedInstOperands,
     /* 218138 */     // GIR_Coverage, 10055,
     /* 218138 */     GIR_EraseRootFromParent_Done,
     /* 218139 */   // Label 4176: @218139
     /* 218139 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(218195), // Rule ID 10056 //
     /* 218144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 218152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218166 */     // MIs[0] pattern
     /* 218166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218174 */     // MIs[0] imm4
     /* 218174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218182 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 218185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218189 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218191 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218193 */     GIR_RootConstrainSelectedInstOperands,
     /* 218194 */     // GIR_Coverage, 10056,
     /* 218194 */     GIR_EraseRootFromParent_Done,
     /* 218195 */   // Label 4177: @218195
     /* 218195 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(218251), // Rule ID 10059 //
     /* 218200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 218208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218222 */     // MIs[0] pattern
     /* 218222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218230 */     // MIs[0] imm4
     /* 218230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218238 */     // (intrinsic_wo_chain:{ *:[i32] } 2038:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 218241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218245 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218247 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218249 */     GIR_RootConstrainSelectedInstOperands,
     /* 218250 */     // GIR_Coverage, 10059,
     /* 218250 */     GIR_EraseRootFromParent_Done,
     /* 218251 */   // Label 4178: @218251
     /* 218251 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(218307), // Rule ID 10062 //
     /* 218256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 218264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218278 */     // MIs[0] pattern
     /* 218278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218286 */     // MIs[0] imm4
     /* 218286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218294 */     // (intrinsic_wo_chain:{ *:[i32] } 2024:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 218297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218301 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218303 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218305 */     GIR_RootConstrainSelectedInstOperands,
     /* 218306 */     // GIR_Coverage, 10062,
     /* 218306 */     GIR_EraseRootFromParent_Done,
     /* 218307 */   // Label 4179: @218307
     /* 218307 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(218363), // Rule ID 10063 //
     /* 218312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 218320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218334 */     // MIs[0] pattern
     /* 218334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218342 */     // MIs[0] imm4
     /* 218342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218350 */     // (intrinsic_wo_chain:{ *:[i64] } 1828:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 218353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218357 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218359 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218361 */     GIR_RootConstrainSelectedInstOperands,
     /* 218362 */     // GIR_Coverage, 10063,
     /* 218362 */     GIR_EraseRootFromParent_Done,
     /* 218363 */   // Label 4180: @218363
     /* 218363 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(218419), // Rule ID 10064 //
     /* 218368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 218376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218390 */     // MIs[0] pattern
     /* 218390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218398 */     // MIs[0] imm4
     /* 218398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218406 */     // (intrinsic_wo_chain:{ *:[i64] } 2039:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 218409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218413 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218415 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218417 */     GIR_RootConstrainSelectedInstOperands,
     /* 218418 */     // GIR_Coverage, 10064,
     /* 218418 */     GIR_EraseRootFromParent_Done,
     /* 218419 */   // Label 4181: @218419
     /* 218419 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(218475), // Rule ID 10065 //
     /* 218424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 218432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218446 */     // MIs[0] pattern
     /* 218446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218454 */     // MIs[0] imm4
     /* 218454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218462 */     // (intrinsic_wo_chain:{ *:[i64] } 1794:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 218465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218469 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218471 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218473 */     GIR_RootConstrainSelectedInstOperands,
     /* 218474 */     // GIR_Coverage, 10065,
     /* 218474 */     GIR_EraseRootFromParent_Done,
     /* 218475 */   // Label 4182: @218475
     /* 218475 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(218531), // Rule ID 10066 //
     /* 218480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 218488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218502 */     // MIs[0] pattern
     /* 218502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218510 */     // MIs[0] imm4
     /* 218510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218518 */     // (intrinsic_wo_chain:{ *:[i64] } 2025:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 218521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218525 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218527 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218529 */     GIR_RootConstrainSelectedInstOperands,
     /* 218530 */     // GIR_Coverage, 10066,
     /* 218530 */     GIR_EraseRootFromParent_Done,
     /* 218531 */   // Label 4183: @218531
     /* 218531 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(218587), // Rule ID 10069 //
     /* 218536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 218544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218558 */     // MIs[0] pattern
     /* 218558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218566 */     // MIs[0] imm4
     /* 218566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218574 */     // (intrinsic_wo_chain:{ *:[i32] } 2029:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 218577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218581 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218583 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218585 */     GIR_RootConstrainSelectedInstOperands,
     /* 218586 */     // GIR_Coverage, 10069,
     /* 218586 */     GIR_EraseRootFromParent_Done,
     /* 218587 */   // Label 4184: @218587
     /* 218587 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(218643), // Rule ID 10072 //
     /* 218592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 218600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218614 */     // MIs[0] pattern
     /* 218614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218622 */     // MIs[0] imm4
     /* 218622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218630 */     // (intrinsic_wo_chain:{ *:[i32] } 2015:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 218633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218637 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218639 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218641 */     GIR_RootConstrainSelectedInstOperands,
     /* 218642 */     // GIR_Coverage, 10072,
     /* 218642 */     GIR_EraseRootFromParent_Done,
     /* 218643 */   // Label 4185: @218643
     /* 218643 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218699), // Rule ID 10073 //
     /* 218648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 218656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218670 */     // MIs[0] pattern
     /* 218670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218678 */     // MIs[0] imm4
     /* 218678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218686 */     // (intrinsic_wo_chain:{ *:[i64] } 1819:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 218689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218693 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218695 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218697 */     GIR_RootConstrainSelectedInstOperands,
     /* 218698 */     // GIR_Coverage, 10073,
     /* 218698 */     GIR_EraseRootFromParent_Done,
     /* 218699 */   // Label 4186: @218699
     /* 218699 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218755), // Rule ID 10074 //
     /* 218704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 218712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218726 */     // MIs[0] pattern
     /* 218726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218734 */     // MIs[0] imm4
     /* 218734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218742 */     // (intrinsic_wo_chain:{ *:[i64] } 2030:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 218745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218749 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218751 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218753 */     GIR_RootConstrainSelectedInstOperands,
     /* 218754 */     // GIR_Coverage, 10074,
     /* 218754 */     GIR_EraseRootFromParent_Done,
     /* 218755 */   // Label 4187: @218755
     /* 218755 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218811), // Rule ID 10075 //
     /* 218760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 218768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218782 */     // MIs[0] pattern
     /* 218782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218790 */     // MIs[0] imm4
     /* 218790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218798 */     // (intrinsic_wo_chain:{ *:[i64] } 1785:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 218801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218805 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218807 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218809 */     GIR_RootConstrainSelectedInstOperands,
     /* 218810 */     // GIR_Coverage, 10075,
     /* 218810 */     GIR_EraseRootFromParent_Done,
     /* 218811 */   // Label 4188: @218811
     /* 218811 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218867), // Rule ID 10076 //
     /* 218816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 218824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218838 */     // MIs[0] pattern
     /* 218838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218846 */     // MIs[0] imm4
     /* 218846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218854 */     // (intrinsic_wo_chain:{ *:[i64] } 2016:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 218857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218861 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218863 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218865 */     GIR_RootConstrainSelectedInstOperands,
     /* 218866 */     // GIR_Coverage, 10076,
     /* 218866 */     GIR_EraseRootFromParent_Done,
     /* 218867 */   // Label 4189: @218867
     /* 218867 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218923), // Rule ID 10077 //
     /* 218872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 218880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218894 */     // MIs[0] pattern
     /* 218894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218902 */     // MIs[0] imm4
     /* 218902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 218913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218917 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218919 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218921 */     GIR_RootConstrainSelectedInstOperands,
     /* 218922 */     // GIR_Coverage, 10077,
     /* 218922 */     GIR_EraseRootFromParent_Done,
     /* 218923 */   // Label 4190: @218923
     /* 218923 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(218979), // Rule ID 10078 //
     /* 218928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 218936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218950 */     // MIs[0] pattern
     /* 218950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218958 */     // MIs[0] imm4
     /* 218958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1786:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 218969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218973 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218975 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218977 */     GIR_RootConstrainSelectedInstOperands,
     /* 218978 */     // GIR_Coverage, 10078,
     /* 218978 */     GIR_EraseRootFromParent_Done,
     /* 218979 */   // Label 4191: @218979
     /* 218979 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(219035), // Rule ID 10079 //
     /* 218984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 218992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219006 */     // MIs[0] pattern
     /* 219006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219014 */     // MIs[0] imm4
     /* 219014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2017:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 219025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219029 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219031 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219033 */     GIR_RootConstrainSelectedInstOperands,
     /* 219034 */     // GIR_Coverage, 10079,
     /* 219034 */     GIR_EraseRootFromParent_Done,
     /* 219035 */   // Label 4192: @219035
     /* 219035 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(219091), // Rule ID 10080 //
     /* 219040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 219048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219062 */     // MIs[0] pattern
     /* 219062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219070 */     // MIs[0] imm4
     /* 219070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 219081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219085 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219087 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219089 */     GIR_RootConstrainSelectedInstOperands,
     /* 219090 */     // GIR_Coverage, 10080,
     /* 219090 */     GIR_EraseRootFromParent_Done,
     /* 219091 */   // Label 4193: @219091
     /* 219091 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(219147), // Rule ID 10081 //
     /* 219096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 219104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219118 */     // MIs[0] pattern
     /* 219118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219126 */     // MIs[0] imm4
     /* 219126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 219137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219141 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219143 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219145 */     GIR_RootConstrainSelectedInstOperands,
     /* 219146 */     // GIR_Coverage, 10081,
     /* 219146 */     GIR_EraseRootFromParent_Done,
     /* 219147 */   // Label 4194: @219147
     /* 219147 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(219203), // Rule ID 10082 //
     /* 219152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 219160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219174 */     // MIs[0] pattern
     /* 219174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219182 */     // MIs[0] imm4
     /* 219182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 219193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219197 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219199 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219201 */     GIR_RootConstrainSelectedInstOperands,
     /* 219202 */     // GIR_Coverage, 10082,
     /* 219202 */     GIR_EraseRootFromParent_Done,
     /* 219203 */   // Label 4195: @219203
     /* 219203 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(219259), // Rule ID 10083 //
     /* 219208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 219216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219230 */     // MIs[0] pattern
     /* 219230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219238 */     // MIs[0] imm4
     /* 219238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2023:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 219249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219253 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219255 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219257 */     GIR_RootConstrainSelectedInstOperands,
     /* 219258 */     // GIR_Coverage, 10083,
     /* 219258 */     GIR_EraseRootFromParent_Done,
     /* 219259 */   // Label 4196: @219259
     /* 219259 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219315), // Rule ID 10084 //
     /* 219264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 219272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219286 */     // MIs[0] pattern
     /* 219286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219294 */     // MIs[0] imm4
     /* 219294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 219305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219309 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219311 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219313 */     GIR_RootConstrainSelectedInstOperands,
     /* 219314 */     // GIR_Coverage, 10084,
     /* 219314 */     GIR_EraseRootFromParent_Done,
     /* 219315 */   // Label 4197: @219315
     /* 219315 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219371), // Rule ID 10085 //
     /* 219320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 219328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219342 */     // MIs[0] pattern
     /* 219342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219350 */     // MIs[0] imm4
     /* 219350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2028:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 219361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219365 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219367 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219369 */     GIR_RootConstrainSelectedInstOperands,
     /* 219370 */     // GIR_Coverage, 10085,
     /* 219370 */     GIR_EraseRootFromParent_Done,
     /* 219371 */   // Label 4198: @219371
     /* 219371 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219427), // Rule ID 10086 //
     /* 219376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 219384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219398 */     // MIs[0] pattern
     /* 219398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219406 */     // MIs[0] imm4
     /* 219406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1783:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 219417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219421 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219423 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219425 */     GIR_RootConstrainSelectedInstOperands,
     /* 219426 */     // GIR_Coverage, 10086,
     /* 219426 */     GIR_EraseRootFromParent_Done,
     /* 219427 */   // Label 4199: @219427
     /* 219427 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219483), // Rule ID 10087 //
     /* 219432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 219440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219454 */     // MIs[0] pattern
     /* 219454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219462 */     // MIs[0] imm4
     /* 219462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2014:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 219473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219477 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219479 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219481 */     GIR_RootConstrainSelectedInstOperands,
     /* 219482 */     // GIR_Coverage, 10087,
     /* 219482 */     GIR_EraseRootFromParent_Done,
     /* 219483 */   // Label 4200: @219483
     /* 219483 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219573), // Rule ID 47 //
     /* 219488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219549 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219553 */     // MIs[2] Operand 1
     /* 219553 */     // No operand predicates
     /* 219553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219555 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 219558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219571 */     GIR_RootConstrainSelectedInstOperands,
     /* 219572 */     // GIR_Coverage, 47,
     /* 219572 */     GIR_EraseRootFromParent_Done,
     /* 219573 */   // Label 4201: @219573
     /* 219573 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219663), // Rule ID 48 //
     /* 219578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219643 */     // MIs[2] Operand 1
     /* 219643 */     // No operand predicates
     /* 219643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219645 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 219648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219661 */     GIR_RootConstrainSelectedInstOperands,
     /* 219662 */     // GIR_Coverage, 48,
     /* 219662 */     GIR_EraseRootFromParent_Done,
     /* 219663 */   // Label 4202: @219663
     /* 219663 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219753), // Rule ID 49 //
     /* 219668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 219676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219733 */     // MIs[2] Operand 1
     /* 219733 */     // No operand predicates
     /* 219733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219735 */     // (intrinsic_wo_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 219738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219751 */     GIR_RootConstrainSelectedInstOperands,
     /* 219752 */     // GIR_Coverage, 49,
     /* 219752 */     GIR_EraseRootFromParent_Done,
     /* 219753 */   // Label 4203: @219753
     /* 219753 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(219843), // Rule ID 50 //
     /* 219758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 219766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219823 */     // MIs[2] Operand 1
     /* 219823 */     // No operand predicates
     /* 219823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219825 */     // (intrinsic_wo_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 219828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219841 */     GIR_RootConstrainSelectedInstOperands,
     /* 219842 */     // GIR_Coverage, 50,
     /* 219842 */     GIR_EraseRootFromParent_Done,
     /* 219843 */   // Label 4204: @219843
     /* 219843 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(219933), // Rule ID 51 //
     /* 219848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 219856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219909 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219913 */     // MIs[2] Operand 1
     /* 219913 */     // No operand predicates
     /* 219913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219915 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 219918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219931 */     GIR_RootConstrainSelectedInstOperands,
     /* 219932 */     // GIR_Coverage, 51,
     /* 219932 */     GIR_EraseRootFromParent_Done,
     /* 219933 */   // Label 4205: @219933
     /* 219933 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(220023), // Rule ID 52 //
     /* 219938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 219946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219999 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220003 */     // MIs[2] Operand 1
     /* 220003 */     // No operand predicates
     /* 220003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220005 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 220008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220021 */     GIR_RootConstrainSelectedInstOperands,
     /* 220022 */     // GIR_Coverage, 52,
     /* 220022 */     GIR_EraseRootFromParent_Done,
     /* 220023 */   // Label 4206: @220023
     /* 220023 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(220113), // Rule ID 53 //
     /* 220028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 220036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220089 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220093 */     // MIs[2] Operand 1
     /* 220093 */     // No operand predicates
     /* 220093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220095 */     // (intrinsic_wo_chain:{ *:[v2f32] } 619:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 220098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220111 */     GIR_RootConstrainSelectedInstOperands,
     /* 220112 */     // GIR_Coverage, 53,
     /* 220112 */     GIR_EraseRootFromParent_Done,
     /* 220113 */   // Label 4207: @220113
     /* 220113 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(220203), // Rule ID 54 //
     /* 220118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 220126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220179 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220183 */     // MIs[2] Operand 1
     /* 220183 */     // No operand predicates
     /* 220183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220185 */     // (intrinsic_wo_chain:{ *:[v4f32] } 619:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 220188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220201 */     GIR_RootConstrainSelectedInstOperands,
     /* 220202 */     // GIR_Coverage, 54,
     /* 220202 */     GIR_EraseRootFromParent_Done,
     /* 220203 */   // Label 4208: @220203
     /* 220203 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220293), // Rule ID 2070 //
     /* 220208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220269 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220273 */     // MIs[2] Operand 1
     /* 220273 */     // No operand predicates
     /* 220273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220275 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 220278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220291 */     GIR_RootConstrainSelectedInstOperands,
     /* 220292 */     // GIR_Coverage, 2070,
     /* 220292 */     GIR_EraseRootFromParent_Done,
     /* 220293 */   // Label 4209: @220293
     /* 220293 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220383), // Rule ID 2071 //
     /* 220298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220359 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220363 */     // MIs[2] Operand 1
     /* 220363 */     // No operand predicates
     /* 220363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220365 */     // (intrinsic_wo_chain:{ *:[v8i16] } 696:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 220368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220381 */     GIR_RootConstrainSelectedInstOperands,
     /* 220382 */     // GIR_Coverage, 2071,
     /* 220382 */     GIR_EraseRootFromParent_Done,
     /* 220383 */   // Label 4210: @220383
     /* 220383 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220473), // Rule ID 2077 //
     /* 220388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220449 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220453 */     // MIs[2] Operand 1
     /* 220453 */     // No operand predicates
     /* 220453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220455 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 220458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220471 */     GIR_RootConstrainSelectedInstOperands,
     /* 220472 */     // GIR_Coverage, 2077,
     /* 220472 */     GIR_EraseRootFromParent_Done,
     /* 220473 */   // Label 4211: @220473
     /* 220473 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220563), // Rule ID 2078 //
     /* 220478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220539 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220543 */     // MIs[2] Operand 1
     /* 220543 */     // No operand predicates
     /* 220543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220545 */     // (intrinsic_wo_chain:{ *:[v8i16] } 697:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 220548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220561 */     GIR_RootConstrainSelectedInstOperands,
     /* 220562 */     // GIR_Coverage, 2078,
     /* 220562 */     GIR_EraseRootFromParent_Done,
     /* 220563 */   // Label 4212: @220563
     /* 220563 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220653), // Rule ID 2073 //
     /* 220568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 220585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 220588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220629 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220633 */     // MIs[2] Operand 1
     /* 220633 */     // No operand predicates
     /* 220633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220635 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 220638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220651 */     GIR_RootConstrainSelectedInstOperands,
     /* 220652 */     // GIR_Coverage, 2073,
     /* 220652 */     GIR_EraseRootFromParent_Done,
     /* 220653 */   // Label 4213: @220653
     /* 220653 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220743), // Rule ID 2074 //
     /* 220658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 220675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 220678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220719 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220723 */     // MIs[2] Operand 1
     /* 220723 */     // No operand predicates
     /* 220723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220725 */     // (intrinsic_wo_chain:{ *:[v4i32] } 696:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 220728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220741 */     GIR_RootConstrainSelectedInstOperands,
     /* 220742 */     // GIR_Coverage, 2074,
     /* 220742 */     GIR_EraseRootFromParent_Done,
     /* 220743 */   // Label 4214: @220743
     /* 220743 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220833), // Rule ID 2080 //
     /* 220748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 220765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 220768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220813 */     // MIs[2] Operand 1
     /* 220813 */     // No operand predicates
     /* 220813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220815 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 220818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220831 */     GIR_RootConstrainSelectedInstOperands,
     /* 220832 */     // GIR_Coverage, 2080,
     /* 220832 */     GIR_EraseRootFromParent_Done,
     /* 220833 */   // Label 4215: @220833
     /* 220833 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(220923), // Rule ID 2081 //
     /* 220838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 220855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 220858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220903 */     // MIs[2] Operand 1
     /* 220903 */     // No operand predicates
     /* 220903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220905 */     // (intrinsic_wo_chain:{ *:[v4i32] } 697:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 220908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220921 */     GIR_RootConstrainSelectedInstOperands,
     /* 220922 */     // GIR_Coverage, 2081,
     /* 220922 */     GIR_EraseRootFromParent_Done,
     /* 220923 */   // Label 4216: @220923
     /* 220923 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(221013), // Rule ID 2075 //
     /* 220928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 220968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220993 */     // MIs[2] Operand 1
     /* 220993 */     // No operand predicates
     /* 220993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220995 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 220998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221011 */     GIR_RootConstrainSelectedInstOperands,
     /* 221012 */     // GIR_Coverage, 2075,
     /* 221012 */     GIR_EraseRootFromParent_Done,
     /* 221013 */   // Label 4217: @221013
     /* 221013 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(221103), // Rule ID 2082 //
     /* 221018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 221021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 221026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 221029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 221035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 221038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 221058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221083 */     // MIs[2] Operand 1
     /* 221083 */     // No operand predicates
     /* 221083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221085 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 221088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221101 */     GIR_RootConstrainSelectedInstOperands,
     /* 221102 */     // GIR_Coverage, 2082,
     /* 221102 */     GIR_EraseRootFromParent_Done,
     /* 221103 */   // Label 4218: @221103
     /* 221103 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(221180), // Rule ID 2777 //
     /* 221108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221160 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221164 */     // MIs[2] Operand 1
     /* 221164 */     // No operand predicates
     /* 221164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221166 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221178 */     GIR_RootConstrainSelectedInstOperands,
     /* 221179 */     // GIR_Coverage, 2777,
     /* 221179 */     GIR_EraseRootFromParent_Done,
     /* 221180 */   // Label 4219: @221180
     /* 221180 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(221257), // Rule ID 2778 //
     /* 221185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221237 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221241 */     // MIs[2] Operand 1
     /* 221241 */     // No operand predicates
     /* 221241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221255 */     GIR_RootConstrainSelectedInstOperands,
     /* 221256 */     // GIR_Coverage, 2778,
     /* 221256 */     GIR_EraseRootFromParent_Done,
     /* 221257 */   // Label 4220: @221257
     /* 221257 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(221334), // Rule ID 2779 //
     /* 221262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221314 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221318 */     // MIs[2] Operand 1
     /* 221318 */     // No operand predicates
     /* 221318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221320 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221332 */     GIR_RootConstrainSelectedInstOperands,
     /* 221333 */     // GIR_Coverage, 2779,
     /* 221333 */     GIR_EraseRootFromParent_Done,
     /* 221334 */   // Label 4221: @221334
     /* 221334 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(221411), // Rule ID 2780 //
     /* 221339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221391 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221395 */     // MIs[2] Operand 1
     /* 221395 */     // No operand predicates
     /* 221395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221397 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221409 */     GIR_RootConstrainSelectedInstOperands,
     /* 221410 */     // GIR_Coverage, 2780,
     /* 221410 */     GIR_EraseRootFromParent_Done,
     /* 221411 */   // Label 4222: @221411
     /* 221411 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(221488), // Rule ID 2781 //
     /* 221416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221468 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221472 */     // MIs[2] Operand 1
     /* 221472 */     // No operand predicates
     /* 221472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221474 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221486 */     GIR_RootConstrainSelectedInstOperands,
     /* 221487 */     // GIR_Coverage, 2781,
     /* 221487 */     GIR_EraseRootFromParent_Done,
     /* 221488 */   // Label 4223: @221488
     /* 221488 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(221565), // Rule ID 2782 //
     /* 221493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221545 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221549 */     // MIs[2] Operand 1
     /* 221549 */     // No operand predicates
     /* 221549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221551 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221563 */     GIR_RootConstrainSelectedInstOperands,
     /* 221564 */     // GIR_Coverage, 2782,
     /* 221564 */     GIR_EraseRootFromParent_Done,
     /* 221565 */   // Label 4224: @221565
     /* 221565 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(221642), // Rule ID 7930 //
     /* 221570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221622 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221626 */     // MIs[2] Operand 1
     /* 221626 */     // No operand predicates
     /* 221626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221628 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 221631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221640 */     GIR_RootConstrainSelectedInstOperands,
     /* 221641 */     // GIR_Coverage, 7930,
     /* 221641 */     GIR_EraseRootFromParent_Done,
     /* 221642 */   // Label 4225: @221642
     /* 221642 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(221719), // Rule ID 7931 //
     /* 221647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221699 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221703 */     // MIs[2] Operand 1
     /* 221703 */     // No operand predicates
     /* 221703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 221708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221717 */     GIR_RootConstrainSelectedInstOperands,
     /* 221718 */     // GIR_Coverage, 7931,
     /* 221718 */     GIR_EraseRootFromParent_Done,
     /* 221719 */   // Label 4226: @221719
     /* 221719 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221796), // Rule ID 7932 //
     /* 221724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221776 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221780 */     // MIs[2] Operand 1
     /* 221780 */     // No operand predicates
     /* 221780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221782 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 221785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221794 */     GIR_RootConstrainSelectedInstOperands,
     /* 221795 */     // GIR_Coverage, 7932,
     /* 221795 */     GIR_EraseRootFromParent_Done,
     /* 221796 */   // Label 4227: @221796
     /* 221796 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221873), // Rule ID 7933 //
     /* 221801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221853 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221857 */     // MIs[2] Operand 1
     /* 221857 */     // No operand predicates
     /* 221857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 221862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221871 */     GIR_RootConstrainSelectedInstOperands,
     /* 221872 */     // GIR_Coverage, 7933,
     /* 221872 */     GIR_EraseRootFromParent_Done,
     /* 221873 */   // Label 4228: @221873
     /* 221873 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(221950), // Rule ID 7934 //
     /* 221878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221930 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221934 */     // MIs[2] Operand 1
     /* 221934 */     // No operand predicates
     /* 221934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 221939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221948 */     GIR_RootConstrainSelectedInstOperands,
     /* 221949 */     // GIR_Coverage, 7934,
     /* 221949 */     GIR_EraseRootFromParent_Done,
     /* 221950 */   // Label 4229: @221950
     /* 221950 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(222027), // Rule ID 7935 //
     /* 221955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222007 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222011 */     // MIs[2] Operand 1
     /* 222011 */     // No operand predicates
     /* 222011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 222016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222025 */     GIR_RootConstrainSelectedInstOperands,
     /* 222026 */     // GIR_Coverage, 7935,
     /* 222026 */     GIR_EraseRootFromParent_Done,
     /* 222027 */   // Label 4230: @222027
     /* 222027 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(222104), // Rule ID 7936 //
     /* 222032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222084 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222088 */     // MIs[2] Operand 1
     /* 222088 */     // No operand predicates
     /* 222088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222090 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 222093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222102 */     GIR_RootConstrainSelectedInstOperands,
     /* 222103 */     // GIR_Coverage, 7936,
     /* 222103 */     GIR_EraseRootFromParent_Done,
     /* 222104 */   // Label 4231: @222104
     /* 222104 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(222181), // Rule ID 7937 //
     /* 222109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222161 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222165 */     // MIs[2] Operand 1
     /* 222165 */     // No operand predicates
     /* 222165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222167 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 222170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222179 */     GIR_RootConstrainSelectedInstOperands,
     /* 222180 */     // GIR_Coverage, 7937,
     /* 222180 */     GIR_EraseRootFromParent_Done,
     /* 222181 */   // Label 4232: @222181
     /* 222181 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(222258), // Rule ID 7938 //
     /* 222186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222238 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222242 */     // MIs[2] Operand 1
     /* 222242 */     // No operand predicates
     /* 222242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222256 */     GIR_RootConstrainSelectedInstOperands,
     /* 222257 */     // GIR_Coverage, 7938,
     /* 222257 */     GIR_EraseRootFromParent_Done,
     /* 222258 */   // Label 4233: @222258
     /* 222258 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(222335), // Rule ID 7939 //
     /* 222263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222315 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222319 */     // MIs[2] Operand 1
     /* 222319 */     // No operand predicates
     /* 222319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222321 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222333 */     GIR_RootConstrainSelectedInstOperands,
     /* 222334 */     // GIR_Coverage, 7939,
     /* 222334 */     GIR_EraseRootFromParent_Done,
     /* 222335 */   // Label 4234: @222335
     /* 222335 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(222412), // Rule ID 7940 //
     /* 222340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222392 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222396 */     // MIs[2] Operand 1
     /* 222396 */     // No operand predicates
     /* 222396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222410 */     GIR_RootConstrainSelectedInstOperands,
     /* 222411 */     // GIR_Coverage, 7940,
     /* 222411 */     GIR_EraseRootFromParent_Done,
     /* 222412 */   // Label 4235: @222412
     /* 222412 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(222489), // Rule ID 7941 //
     /* 222417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222469 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222473 */     // MIs[2] Operand 1
     /* 222473 */     // No operand predicates
     /* 222473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222475 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222487 */     GIR_RootConstrainSelectedInstOperands,
     /* 222488 */     // GIR_Coverage, 7941,
     /* 222488 */     GIR_EraseRootFromParent_Done,
     /* 222489 */   // Label 4236: @222489
     /* 222489 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(222566), // Rule ID 7942 //
     /* 222494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222546 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222550 */     // MIs[2] Operand 1
     /* 222550 */     // No operand predicates
     /* 222550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 222555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222564 */     GIR_RootConstrainSelectedInstOperands,
     /* 222565 */     // GIR_Coverage, 7942,
     /* 222565 */     GIR_EraseRootFromParent_Done,
     /* 222566 */   // Label 4237: @222566
     /* 222566 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(222643), // Rule ID 7943 //
     /* 222571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222623 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222627 */     // MIs[2] Operand 1
     /* 222627 */     // No operand predicates
     /* 222627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222629 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 222632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222641 */     GIR_RootConstrainSelectedInstOperands,
     /* 222642 */     // GIR_Coverage, 7943,
     /* 222642 */     GIR_EraseRootFromParent_Done,
     /* 222643 */   // Label 4238: @222643
     /* 222643 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(222720), // Rule ID 7944 //
     /* 222648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222700 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222704 */     // MIs[2] Operand 1
     /* 222704 */     // No operand predicates
     /* 222704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222706 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 222709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222718 */     GIR_RootConstrainSelectedInstOperands,
     /* 222719 */     // GIR_Coverage, 7944,
     /* 222719 */     GIR_EraseRootFromParent_Done,
     /* 222720 */   // Label 4239: @222720
     /* 222720 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(222797), // Rule ID 7945 //
     /* 222725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222777 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222781 */     // MIs[2] Operand 1
     /* 222781 */     // No operand predicates
     /* 222781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222783 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 222786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222795 */     GIR_RootConstrainSelectedInstOperands,
     /* 222796 */     // GIR_Coverage, 7945,
     /* 222796 */     GIR_EraseRootFromParent_Done,
     /* 222797 */   // Label 4240: @222797
     /* 222797 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(222874), // Rule ID 7946 //
     /* 222802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222854 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222858 */     // MIs[2] Operand 1
     /* 222858 */     // No operand predicates
     /* 222858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222860 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 222863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222872 */     GIR_RootConstrainSelectedInstOperands,
     /* 222873 */     // GIR_Coverage, 7946,
     /* 222873 */     GIR_EraseRootFromParent_Done,
     /* 222874 */   // Label 4241: @222874
     /* 222874 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(222951), // Rule ID 7947 //
     /* 222879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222931 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222935 */     // MIs[2] Operand 1
     /* 222935 */     // No operand predicates
     /* 222935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222937 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 222940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222949 */     GIR_RootConstrainSelectedInstOperands,
     /* 222950 */     // GIR_Coverage, 7947,
     /* 222950 */     GIR_EraseRootFromParent_Done,
     /* 222951 */   // Label 4242: @222951
     /* 222951 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(223028), // Rule ID 7948 //
     /* 222956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 222964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223008 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223012 */     // MIs[2] Operand 1
     /* 223012 */     // No operand predicates
     /* 223012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223014 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 223017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223026 */     GIR_RootConstrainSelectedInstOperands,
     /* 223027 */     // GIR_Coverage, 7948,
     /* 223027 */     GIR_EraseRootFromParent_Done,
     /* 223028 */   // Label 4243: @223028
     /* 223028 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(223105), // Rule ID 7949 //
     /* 223033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223085 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223089 */     // MIs[2] Operand 1
     /* 223089 */     // No operand predicates
     /* 223089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 223094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223103 */     GIR_RootConstrainSelectedInstOperands,
     /* 223104 */     // GIR_Coverage, 7949,
     /* 223104 */     GIR_EraseRootFromParent_Done,
     /* 223105 */   // Label 4244: @223105
     /* 223105 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(223182), // Rule ID 7950 //
     /* 223110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223162 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223166 */     // MIs[2] Operand 1
     /* 223166 */     // No operand predicates
     /* 223166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223168 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223180 */     GIR_RootConstrainSelectedInstOperands,
     /* 223181 */     // GIR_Coverage, 7950,
     /* 223181 */     GIR_EraseRootFromParent_Done,
     /* 223182 */   // Label 4245: @223182
     /* 223182 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(223259), // Rule ID 7951 //
     /* 223187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223239 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223243 */     // MIs[2] Operand 1
     /* 223243 */     // No operand predicates
     /* 223243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223257 */     GIR_RootConstrainSelectedInstOperands,
     /* 223258 */     // GIR_Coverage, 7951,
     /* 223258 */     GIR_EraseRootFromParent_Done,
     /* 223259 */   // Label 4246: @223259
     /* 223259 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(223336), // Rule ID 7952 //
     /* 223264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223316 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223320 */     // MIs[2] Operand 1
     /* 223320 */     // No operand predicates
     /* 223320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223334 */     GIR_RootConstrainSelectedInstOperands,
     /* 223335 */     // GIR_Coverage, 7952,
     /* 223335 */     GIR_EraseRootFromParent_Done,
     /* 223336 */   // Label 4247: @223336
     /* 223336 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(223413), // Rule ID 7953 //
     /* 223341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223393 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223397 */     // MIs[2] Operand 1
     /* 223397 */     // No operand predicates
     /* 223397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223411 */     GIR_RootConstrainSelectedInstOperands,
     /* 223412 */     // GIR_Coverage, 7953,
     /* 223412 */     GIR_EraseRootFromParent_Done,
     /* 223413 */   // Label 4248: @223413
     /* 223413 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(223490), // Rule ID 7954 //
     /* 223418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223470 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223474 */     // MIs[2] Operand 1
     /* 223474 */     // No operand predicates
     /* 223474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223476 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223488 */     GIR_RootConstrainSelectedInstOperands,
     /* 223489 */     // GIR_Coverage, 7954,
     /* 223489 */     GIR_EraseRootFromParent_Done,
     /* 223490 */   // Label 4249: @223490
     /* 223490 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(223567), // Rule ID 7955 //
     /* 223495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223547 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223551 */     // MIs[2] Operand 1
     /* 223551 */     // No operand predicates
     /* 223551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223553 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223565 */     GIR_RootConstrainSelectedInstOperands,
     /* 223566 */     // GIR_Coverage, 7955,
     /* 223566 */     GIR_EraseRootFromParent_Done,
     /* 223567 */   // Label 4250: @223567
     /* 223567 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(223644), // Rule ID 7956 //
     /* 223572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223624 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223628 */     // MIs[2] Operand 1
     /* 223628 */     // No operand predicates
     /* 223628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 223633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223642 */     GIR_RootConstrainSelectedInstOperands,
     /* 223643 */     // GIR_Coverage, 7956,
     /* 223643 */     GIR_EraseRootFromParent_Done,
     /* 223644 */   // Label 4251: @223644
     /* 223644 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(223721), // Rule ID 7957 //
     /* 223649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223701 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223705 */     // MIs[2] Operand 1
     /* 223705 */     // No operand predicates
     /* 223705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 223710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223719 */     GIR_RootConstrainSelectedInstOperands,
     /* 223720 */     // GIR_Coverage, 7957,
     /* 223720 */     GIR_EraseRootFromParent_Done,
     /* 223721 */   // Label 4252: @223721
     /* 223721 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(223798), // Rule ID 7958 //
     /* 223726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223778 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223782 */     // MIs[2] Operand 1
     /* 223782 */     // No operand predicates
     /* 223782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 223787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223796 */     GIR_RootConstrainSelectedInstOperands,
     /* 223797 */     // GIR_Coverage, 7958,
     /* 223797 */     GIR_EraseRootFromParent_Done,
     /* 223798 */   // Label 4253: @223798
     /* 223798 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223875), // Rule ID 7959 //
     /* 223803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223855 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223859 */     // MIs[2] Operand 1
     /* 223859 */     // No operand predicates
     /* 223859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223861 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 223864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223873 */     GIR_RootConstrainSelectedInstOperands,
     /* 223874 */     // GIR_Coverage, 7959,
     /* 223874 */     GIR_EraseRootFromParent_Done,
     /* 223875 */   // Label 4254: @223875
     /* 223875 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(223952), // Rule ID 7960 //
     /* 223880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 223888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223932 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223936 */     // MIs[2] Operand 1
     /* 223936 */     // No operand predicates
     /* 223936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223938 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 223941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223950 */     GIR_RootConstrainSelectedInstOperands,
     /* 223951 */     // GIR_Coverage, 7960,
     /* 223951 */     GIR_EraseRootFromParent_Done,
     /* 223952 */   // Label 4255: @223952
     /* 223952 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(224029), // Rule ID 7961 //
     /* 223957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 223965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224009 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224013 */     // MIs[2] Operand 1
     /* 224013 */     // No operand predicates
     /* 224013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 224018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224027 */     GIR_RootConstrainSelectedInstOperands,
     /* 224028 */     // GIR_Coverage, 7961,
     /* 224028 */     GIR_EraseRootFromParent_Done,
     /* 224029 */   // Label 4256: @224029
     /* 224029 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(224106), // Rule ID 7962 //
     /* 224034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224086 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224090 */     // MIs[2] Operand 1
     /* 224090 */     // No operand predicates
     /* 224090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 224095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224104 */     GIR_RootConstrainSelectedInstOperands,
     /* 224105 */     // GIR_Coverage, 7962,
     /* 224105 */     GIR_EraseRootFromParent_Done,
     /* 224106 */   // Label 4257: @224106
     /* 224106 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(224183), // Rule ID 7963 //
     /* 224111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224163 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224167 */     // MIs[2] Operand 1
     /* 224167 */     // No operand predicates
     /* 224167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224169 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 224172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224181 */     GIR_RootConstrainSelectedInstOperands,
     /* 224182 */     // GIR_Coverage, 7963,
     /* 224182 */     GIR_EraseRootFromParent_Done,
     /* 224183 */   // Label 4258: @224183
     /* 224183 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(224260), // Rule ID 7964 //
     /* 224188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224240 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224244 */     // MIs[2] Operand 1
     /* 224244 */     // No operand predicates
     /* 224244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224246 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224258 */     GIR_RootConstrainSelectedInstOperands,
     /* 224259 */     // GIR_Coverage, 7964,
     /* 224259 */     GIR_EraseRootFromParent_Done,
     /* 224260 */   // Label 4259: @224260
     /* 224260 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(224337), // Rule ID 7965 //
     /* 224265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224317 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224321 */     // MIs[2] Operand 1
     /* 224321 */     // No operand predicates
     /* 224321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224323 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224335 */     GIR_RootConstrainSelectedInstOperands,
     /* 224336 */     // GIR_Coverage, 7965,
     /* 224336 */     GIR_EraseRootFromParent_Done,
     /* 224337 */   // Label 4260: @224337
     /* 224337 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(224414), // Rule ID 7966 //
     /* 224342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224394 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224398 */     // MIs[2] Operand 1
     /* 224398 */     // No operand predicates
     /* 224398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224412 */     GIR_RootConstrainSelectedInstOperands,
     /* 224413 */     // GIR_Coverage, 7966,
     /* 224413 */     GIR_EraseRootFromParent_Done,
     /* 224414 */   // Label 4261: @224414
     /* 224414 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(224491), // Rule ID 7967 //
     /* 224419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224471 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224475 */     // MIs[2] Operand 1
     /* 224475 */     // No operand predicates
     /* 224475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224477 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224489 */     GIR_RootConstrainSelectedInstOperands,
     /* 224490 */     // GIR_Coverage, 7967,
     /* 224490 */     GIR_EraseRootFromParent_Done,
     /* 224491 */   // Label 4262: @224491
     /* 224491 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(224568), // Rule ID 7968 //
     /* 224496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224548 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224552 */     // MIs[2] Operand 1
     /* 224552 */     // No operand predicates
     /* 224552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 224557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224566 */     GIR_RootConstrainSelectedInstOperands,
     /* 224567 */     // GIR_Coverage, 7968,
     /* 224567 */     GIR_EraseRootFromParent_Done,
     /* 224568 */   // Label 4263: @224568
     /* 224568 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(224645), // Rule ID 7969 //
     /* 224573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224625 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224629 */     // MIs[2] Operand 1
     /* 224629 */     // No operand predicates
     /* 224629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224631 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 224634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224643 */     GIR_RootConstrainSelectedInstOperands,
     /* 224644 */     // GIR_Coverage, 7969,
     /* 224644 */     GIR_EraseRootFromParent_Done,
     /* 224645 */   // Label 4264: @224645
     /* 224645 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(224722), // Rule ID 7970 //
     /* 224650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224702 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224706 */     // MIs[2] Operand 1
     /* 224706 */     // No operand predicates
     /* 224706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224708 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 224711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224720 */     GIR_RootConstrainSelectedInstOperands,
     /* 224721 */     // GIR_Coverage, 7970,
     /* 224721 */     GIR_EraseRootFromParent_Done,
     /* 224722 */   // Label 4265: @224722
     /* 224722 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224799), // Rule ID 7971 //
     /* 224727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224779 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224783 */     // MIs[2] Operand 1
     /* 224783 */     // No operand predicates
     /* 224783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224785 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 224788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224797 */     GIR_RootConstrainSelectedInstOperands,
     /* 224798 */     // GIR_Coverage, 7971,
     /* 224798 */     GIR_EraseRootFromParent_Done,
     /* 224799 */   // Label 4266: @224799
     /* 224799 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224855), // Rule ID 55 //
     /* 224804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224829 */     // MIs[0] Operand 3
     /* 224829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 224840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224844 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 224847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224853 */     GIR_RootConstrainSelectedInstOperands,
     /* 224854 */     // GIR_Coverage, 55,
     /* 224854 */     GIR_EraseRootFromParent_Done,
     /* 224855 */   // Label 4267: @224855
     /* 224855 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224911), // Rule ID 56 //
     /* 224860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224885 */     // MIs[0] Operand 3
     /* 224885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 224896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224900 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 224903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224909 */     GIR_RootConstrainSelectedInstOperands,
     /* 224910 */     // GIR_Coverage, 56,
     /* 224910 */     GIR_EraseRootFromParent_Done,
     /* 224911 */   // Label 4268: @224911
     /* 224911 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(224967), // Rule ID 57 //
     /* 224916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224941 */     // MIs[0] Operand 3
     /* 224941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 224952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224956 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 224959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224965 */     GIR_RootConstrainSelectedInstOperands,
     /* 224966 */     // GIR_Coverage, 57,
     /* 224966 */     GIR_EraseRootFromParent_Done,
     /* 224967 */   // Label 4269: @224967
     /* 224967 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(225023), // Rule ID 58 //
     /* 224972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224997 */     // MIs[0] Operand 3
     /* 224997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 225008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 225012 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 225012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 225015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 225019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 225021 */     GIR_RootConstrainSelectedInstOperands,
     /* 225022 */     // GIR_Coverage, 58,
     /* 225022 */     GIR_EraseRootFromParent_Done,
     /* 225023 */   // Label 4270: @225023
     /* 225023 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(225078), // Rule ID 2795 //
     /* 225028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225057 */     // MIs[0] imm
     /* 225057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225065 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1552:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 225068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225074 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225076 */     GIR_RootConstrainSelectedInstOperands,
     /* 225077 */     // GIR_Coverage, 2795,
     /* 225077 */     GIR_EraseRootFromParent_Done,
     /* 225078 */   // Label 4271: @225078
     /* 225078 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(225133), // Rule ID 2796 //
     /* 225083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225112 */     // MIs[0] imm
     /* 225112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225120 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1552:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 225123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225129 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225131 */     GIR_RootConstrainSelectedInstOperands,
     /* 225132 */     // GIR_Coverage, 2796,
     /* 225132 */     GIR_EraseRootFromParent_Done,
     /* 225133 */   // Label 4272: @225133
     /* 225133 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(225188), // Rule ID 2797 //
     /* 225138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225167 */     // MIs[0] imm
     /* 225167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1552:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 225178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225184 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225186 */     GIR_RootConstrainSelectedInstOperands,
     /* 225187 */     // GIR_Coverage, 2797,
     /* 225187 */     GIR_EraseRootFromParent_Done,
     /* 225188 */   // Label 4273: @225188
     /* 225188 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(225243), // Rule ID 3550 //
     /* 225193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225222 */     // MIs[0] Idx
     /* 225222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 225230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 225230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 225233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225241 */     GIR_RootConstrainSelectedInstOperands,
     /* 225242 */     // GIR_Coverage, 3550,
     /* 225242 */     GIR_EraseRootFromParent_Done,
     /* 225243 */   // Label 4274: @225243
     /* 225243 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(225298), // Rule ID 3551 //
     /* 225248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225277 */     // MIs[0] Idx
     /* 225277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 225285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 225285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 225288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225296 */     GIR_RootConstrainSelectedInstOperands,
     /* 225297 */     // GIR_Coverage, 3551,
     /* 225297 */     GIR_EraseRootFromParent_Done,
     /* 225298 */   // Label 4275: @225298
     /* 225298 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(225353), // Rule ID 3552 //
     /* 225303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225332 */     // MIs[0] Idx
     /* 225332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 225340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 225340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 225343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225351 */     GIR_RootConstrainSelectedInstOperands,
     /* 225352 */     // GIR_Coverage, 3552,
     /* 225352 */     GIR_EraseRootFromParent_Done,
     /* 225353 */   // Label 4276: @225353
     /* 225353 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(225408), // Rule ID 3848 //
     /* 225358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 225361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 225366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 225369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 225372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 225375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225387 */     // MIs[0] imm
     /* 225387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 225395 */     // (intrinsic_wo_chain:{ *:[v2i64] } 553:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 225395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 225398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 225400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 225402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 225404 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225406 */     GIR_RootConstrainSelectedInstOperands,
     /* 225407 */     // GIR_Coverage, 3848,
     /* 225407 */     GIR_EraseRootFromParent_Done,
     /* 225408 */   // Label 4277: @225408
     /* 225408 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(225455), // Rule ID 2849 //
     /* 225413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225434 */     // MIs[0] idx
     /* 225434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 225442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 225445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225451 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225453 */     GIR_RootConstrainSelectedInstOperands,
     /* 225454 */     // GIR_Coverage, 2849,
     /* 225454 */     GIR_EraseRootFromParent_Done,
     /* 225455 */   // Label 4278: @225455
     /* 225455 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(225502), // Rule ID 2850 //
     /* 225460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225481 */     // MIs[0] idx
     /* 225481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225489 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 225489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 225492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225498 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225500 */     GIR_RootConstrainSelectedInstOperands,
     /* 225501 */     // GIR_Coverage, 2850,
     /* 225501 */     GIR_EraseRootFromParent_Done,
     /* 225502 */   // Label 4279: @225502
     /* 225502 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(225549), // Rule ID 2851 //
     /* 225507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225528 */     // MIs[0] idx
     /* 225528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 225536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 225539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225545 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225547 */     GIR_RootConstrainSelectedInstOperands,
     /* 225548 */     // GIR_Coverage, 2851,
     /* 225548 */     GIR_EraseRootFromParent_Done,
     /* 225549 */   // Label 4280: @225549
     /* 225549 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(225596), // Rule ID 3000 //
     /* 225554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225575 */     // MIs[0] Op3
     /* 225575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1619:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 225586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225594 */     GIR_RootConstrainSelectedInstOperands,
     /* 225595 */     // GIR_Coverage, 3000,
     /* 225595 */     GIR_EraseRootFromParent_Done,
     /* 225596 */   // Label 4281: @225596
     /* 225596 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(225643), // Rule ID 3001 //
     /* 225601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225622 */     // MIs[0] Op3
     /* 225622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1619:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 225633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225641 */     GIR_RootConstrainSelectedInstOperands,
     /* 225642 */     // GIR_Coverage, 3001,
     /* 225642 */     GIR_EraseRootFromParent_Done,
     /* 225643 */   // Label 4282: @225643
     /* 225643 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(225690), // Rule ID 3002 //
     /* 225648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225669 */     // MIs[0] Op3
     /* 225669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1619:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 225677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 225680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225688 */     GIR_RootConstrainSelectedInstOperands,
     /* 225689 */     // GIR_Coverage, 3002,
     /* 225689 */     GIR_EraseRootFromParent_Done,
     /* 225690 */   // Label 4283: @225690
     /* 225690 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(225737), // Rule ID 3003 //
     /* 225695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 225703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225716 */     // MIs[0] Op3
     /* 225716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1765:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 225727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225735 */     GIR_RootConstrainSelectedInstOperands,
     /* 225736 */     // GIR_Coverage, 3003,
     /* 225736 */     GIR_EraseRootFromParent_Done,
     /* 225737 */   // Label 4284: @225737
     /* 225737 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225784), // Rule ID 3004 //
     /* 225742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 225750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225763 */     // MIs[0] Op3
     /* 225763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225771 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1765:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 225774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225782 */     GIR_RootConstrainSelectedInstOperands,
     /* 225783 */     // GIR_Coverage, 3004,
     /* 225783 */     GIR_EraseRootFromParent_Done,
     /* 225784 */   // Label 4285: @225784
     /* 225784 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225831), // Rule ID 3052 //
     /* 225789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225810 */     // MIs[0] Op3
     /* 225810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 225818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1876:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 225818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 225821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225829 */     GIR_RootConstrainSelectedInstOperands,
     /* 225830 */     // GIR_Coverage, 3052,
     /* 225830 */     GIR_EraseRootFromParent_Done,
     /* 225831 */   // Label 4286: @225831
     /* 225831 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225878), // Rule ID 3054 //
     /* 225836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225857 */     // MIs[0] Op3
     /* 225857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 225865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 225865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 225868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225876 */     GIR_RootConstrainSelectedInstOperands,
     /* 225877 */     // GIR_Coverage, 3054,
     /* 225877 */     GIR_EraseRootFromParent_Done,
     /* 225878 */   // Label 4287: @225878
     /* 225878 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225925), // Rule ID 3056 //
     /* 225883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225904 */     // MIs[0] Op3
     /* 225904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 225912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 225912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 225915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225923 */     GIR_RootConstrainSelectedInstOperands,
     /* 225924 */     // GIR_Coverage, 3056,
     /* 225924 */     GIR_EraseRootFromParent_Done,
     /* 225925 */   // Label 4288: @225925
     /* 225925 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(225972), // Rule ID 3058 //
     /* 225930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225951 */     // MIs[0] Op3
     /* 225951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 225959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 225959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 225962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225970 */     GIR_RootConstrainSelectedInstOperands,
     /* 225971 */     // GIR_Coverage, 3058,
     /* 225971 */     GIR_EraseRootFromParent_Done,
     /* 225972 */   // Label 4289: @225972
     /* 225972 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(226019), // Rule ID 3080 //
     /* 225977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 225985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225998 */     // MIs[0] Op3
     /* 225998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1856:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 226009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226017 */     GIR_RootConstrainSelectedInstOperands,
     /* 226018 */     // GIR_Coverage, 3080,
     /* 226018 */     GIR_EraseRootFromParent_Done,
     /* 226019 */   // Label 4290: @226019
     /* 226019 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(226066), // Rule ID 3081 //
     /* 226024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 226032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226045 */     // MIs[0] Op3
     /* 226045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226053 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 226056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226064 */     GIR_RootConstrainSelectedInstOperands,
     /* 226065 */     // GIR_Coverage, 3081,
     /* 226065 */     GIR_EraseRootFromParent_Done,
     /* 226066 */   // Label 4291: @226066
     /* 226066 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(226113), // Rule ID 3082 //
     /* 226071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 226079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226092 */     // MIs[0] Op3
     /* 226092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 226103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226111 */     GIR_RootConstrainSelectedInstOperands,
     /* 226112 */     // GIR_Coverage, 3082,
     /* 226112 */     GIR_EraseRootFromParent_Done,
     /* 226113 */   // Label 4292: @226113
     /* 226113 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(226160), // Rule ID 3151 //
     /* 226118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226139 */     // MIs[0] Op3
     /* 226139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226147 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 226150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226158 */     GIR_RootConstrainSelectedInstOperands,
     /* 226159 */     // GIR_Coverage, 3151,
     /* 226159 */     GIR_EraseRootFromParent_Done,
     /* 226160 */   // Label 4293: @226160
     /* 226160 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(226207), // Rule ID 3152 //
     /* 226165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226186 */     // MIs[0] Op3
     /* 226186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 226197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226205 */     GIR_RootConstrainSelectedInstOperands,
     /* 226206 */     // GIR_Coverage, 3152,
     /* 226206 */     GIR_EraseRootFromParent_Done,
     /* 226207 */   // Label 4294: @226207
     /* 226207 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(226254), // Rule ID 3153 //
     /* 226212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226233 */     // MIs[0] Op3
     /* 226233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 226244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226252 */     GIR_RootConstrainSelectedInstOperands,
     /* 226253 */     // GIR_Coverage, 3153,
     /* 226253 */     GIR_EraseRootFromParent_Done,
     /* 226254 */   // Label 4295: @226254
     /* 226254 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(226301), // Rule ID 3154 //
     /* 226259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226280 */     // MIs[0] Op3
     /* 226280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2157:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 226291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226299 */     GIR_RootConstrainSelectedInstOperands,
     /* 226300 */     // GIR_Coverage, 3154,
     /* 226300 */     GIR_EraseRootFromParent_Done,
     /* 226301 */   // Label 4296: @226301
     /* 226301 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(226348), // Rule ID 3535 //
     /* 226306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 226309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 226314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226327 */     // MIs[0] Op3
     /* 226327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 226335 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1367:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 226335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 226338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226346 */     GIR_RootConstrainSelectedInstOperands,
     /* 226347 */     // GIR_Coverage, 3535,
     /* 226347 */     GIR_EraseRootFromParent_Done,
     /* 226348 */   // Label 4297: @226348
     /* 226348 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(226395), // Rule ID 3583 //
     /* 226353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226374 */     // MIs[0] Op3
     /* 226374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 226385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226393 */     GIR_RootConstrainSelectedInstOperands,
     /* 226394 */     // GIR_Coverage, 3583,
     /* 226394 */     GIR_EraseRootFromParent_Done,
     /* 226395 */   // Label 4298: @226395
     /* 226395 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(226442), // Rule ID 3584 //
     /* 226400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226421 */     // MIs[0] Op3
     /* 226421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226440 */     GIR_RootConstrainSelectedInstOperands,
     /* 226441 */     // GIR_Coverage, 3584,
     /* 226441 */     GIR_EraseRootFromParent_Done,
     /* 226442 */   // Label 4299: @226442
     /* 226442 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(226489), // Rule ID 3585 //
     /* 226447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226468 */     // MIs[0] Op3
     /* 226468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226476 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1606:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226487 */     GIR_RootConstrainSelectedInstOperands,
     /* 226488 */     // GIR_Coverage, 3585,
     /* 226488 */     GIR_EraseRootFromParent_Done,
     /* 226489 */   // Label 4300: @226489
     /* 226489 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(226536), // Rule ID 3586 //
     /* 226494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226515 */     // MIs[0] Op3
     /* 226515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 226523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 226523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 226526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226534 */     GIR_RootConstrainSelectedInstOperands,
     /* 226535 */     // GIR_Coverage, 3586,
     /* 226535 */     GIR_EraseRootFromParent_Done,
     /* 226536 */   // Label 4301: @226536
     /* 226536 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(226583), // Rule ID 3587 //
     /* 226541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226562 */     // MIs[0] Op3
     /* 226562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 226573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226581 */     GIR_RootConstrainSelectedInstOperands,
     /* 226582 */     // GIR_Coverage, 3587,
     /* 226582 */     GIR_EraseRootFromParent_Done,
     /* 226583 */   // Label 4302: @226583
     /* 226583 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(226630), // Rule ID 3588 //
     /* 226588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226609 */     // MIs[0] Op3
     /* 226609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226617 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1607:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 226620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226628 */     GIR_RootConstrainSelectedInstOperands,
     /* 226629 */     // GIR_Coverage, 3588,
     /* 226629 */     GIR_EraseRootFromParent_Done,
     /* 226630 */   // Label 4303: @226630
     /* 226630 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(226677), // Rule ID 11388 //
     /* 226635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226656 */     // MIs[0] Op3
     /* 226656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1806:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 226667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226675 */     GIR_RootConstrainSelectedInstOperands,
     /* 226676 */     // GIR_Coverage, 11388,
     /* 226676 */     GIR_EraseRootFromParent_Done,
     /* 226677 */   // Label 4304: @226677
     /* 226677 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(226724), // Rule ID 11389 //
     /* 226682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226703 */     // MIs[0] Op3
     /* 226703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1806:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 226714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226722 */     GIR_RootConstrainSelectedInstOperands,
     /* 226723 */     // GIR_Coverage, 11389,
     /* 226723 */     GIR_EraseRootFromParent_Done,
     /* 226724 */   // Label 4305: @226724
     /* 226724 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(226771), // Rule ID 11390 //
     /* 226729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226750 */     // MIs[0] Op3
     /* 226750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 226758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1806:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 226758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 226761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226769 */     GIR_RootConstrainSelectedInstOperands,
     /* 226770 */     // GIR_Coverage, 11390,
     /* 226770 */     GIR_EraseRootFromParent_Done,
     /* 226771 */   // Label 4306: @226771
     /* 226771 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(226818), // Rule ID 11391 //
     /* 226776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226797 */     // MIs[0] Op3
     /* 226797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 226808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226816 */     GIR_RootConstrainSelectedInstOperands,
     /* 226817 */     // GIR_Coverage, 11391,
     /* 226817 */     GIR_EraseRootFromParent_Done,
     /* 226818 */   // Label 4307: @226818
     /* 226818 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(226865), // Rule ID 11392 //
     /* 226823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226844 */     // MIs[0] Op3
     /* 226844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 226855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226863 */     GIR_RootConstrainSelectedInstOperands,
     /* 226864 */     // GIR_Coverage, 11392,
     /* 226864 */     GIR_EraseRootFromParent_Done,
     /* 226865 */   // Label 4308: @226865
     /* 226865 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(226912), // Rule ID 11393 //
     /* 226870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226891 */     // MIs[0] Op3
     /* 226891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 226899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 226899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 226902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226910 */     GIR_RootConstrainSelectedInstOperands,
     /* 226911 */     // GIR_Coverage, 11393,
     /* 226911 */     GIR_EraseRootFromParent_Done,
     /* 226912 */   // Label 4309: @226912
     /* 226912 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(226959), // Rule ID 11416 //
     /* 226917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 226925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226938 */     // MIs[0] Op3
     /* 226938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1767:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 226949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226957 */     GIR_RootConstrainSelectedInstOperands,
     /* 226958 */     // GIR_Coverage, 11416,
     /* 226958 */     GIR_EraseRootFromParent_Done,
     /* 226959 */   // Label 4310: @226959
     /* 226959 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(227006), // Rule ID 11417 //
     /* 226964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 226972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226985 */     // MIs[0] Op3
     /* 226985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1767:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 226996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227004 */     GIR_RootConstrainSelectedInstOperands,
     /* 227005 */     // GIR_Coverage, 11417,
     /* 227005 */     GIR_EraseRootFromParent_Done,
     /* 227006 */   // Label 4311: @227006
     /* 227006 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(227053), // Rule ID 11418 //
     /* 227011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 227019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227032 */     // MIs[0] Op3
     /* 227032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2003:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 227043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227051 */     GIR_RootConstrainSelectedInstOperands,
     /* 227052 */     // GIR_Coverage, 11418,
     /* 227052 */     GIR_EraseRootFromParent_Done,
     /* 227053 */   // Label 4312: @227053
     /* 227053 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(227100), // Rule ID 11419 //
     /* 227058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 227066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227079 */     // MIs[0] Op3
     /* 227079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2003:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 227090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227098 */     GIR_RootConstrainSelectedInstOperands,
     /* 227099 */     // GIR_Coverage, 11419,
     /* 227099 */     GIR_EraseRootFromParent_Done,
     /* 227100 */   // Label 4313: @227100
     /* 227100 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(227147), // Rule ID 11420 //
     /* 227105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227126 */     // MIs[0] Op3
     /* 227126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2005:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 227137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227145 */     GIR_RootConstrainSelectedInstOperands,
     /* 227146 */     // GIR_Coverage, 11420,
     /* 227146 */     GIR_EraseRootFromParent_Done,
     /* 227147 */   // Label 4314: @227147
     /* 227147 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(227194), // Rule ID 11421 //
     /* 227152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227173 */     // MIs[0] Op3
     /* 227173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2005:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 227184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227192 */     GIR_RootConstrainSelectedInstOperands,
     /* 227193 */     // GIR_Coverage, 11421,
     /* 227193 */     GIR_EraseRootFromParent_Done,
     /* 227194 */   // Label 4315: @227194
     /* 227194 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(227241), // Rule ID 11422 //
     /* 227199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227220 */     // MIs[0] Op3
     /* 227220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 227231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227239 */     GIR_RootConstrainSelectedInstOperands,
     /* 227240 */     // GIR_Coverage, 11422,
     /* 227240 */     GIR_EraseRootFromParent_Done,
     /* 227241 */   // Label 4316: @227241
     /* 227241 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(227288), // Rule ID 11423 //
     /* 227246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227267 */     // MIs[0] Op3
     /* 227267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 227278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227286 */     GIR_RootConstrainSelectedInstOperands,
     /* 227287 */     // GIR_Coverage, 11423,
     /* 227287 */     GIR_EraseRootFromParent_Done,
     /* 227288 */   // Label 4317: @227288
     /* 227288 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(227335), // Rule ID 11424 //
     /* 227293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227314 */     // MIs[0] Op3
     /* 227314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 227325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227333 */     GIR_RootConstrainSelectedInstOperands,
     /* 227334 */     // GIR_Coverage, 11424,
     /* 227334 */     GIR_EraseRootFromParent_Done,
     /* 227335 */   // Label 4318: @227335
     /* 227335 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(227382), // Rule ID 11425 //
     /* 227340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227361 */     // MIs[0] Op3
     /* 227361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 227372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227380 */     GIR_RootConstrainSelectedInstOperands,
     /* 227381 */     // GIR_Coverage, 11425,
     /* 227381 */     GIR_EraseRootFromParent_Done,
     /* 227382 */   // Label 4319: @227382
     /* 227382 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(227429), // Rule ID 11669 //
     /* 227387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227408 */     // MIs[0] Op3
     /* 227408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1872:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 227419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227427 */     GIR_RootConstrainSelectedInstOperands,
     /* 227428 */     // GIR_Coverage, 11669,
     /* 227428 */     GIR_EraseRootFromParent_Done,
     /* 227429 */   // Label 4320: @227429
     /* 227429 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(227476), // Rule ID 11670 //
     /* 227434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227455 */     // MIs[0] Op3
     /* 227455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 227466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227474 */     GIR_RootConstrainSelectedInstOperands,
     /* 227475 */     // GIR_Coverage, 11670,
     /* 227475 */     GIR_EraseRootFromParent_Done,
     /* 227476 */   // Label 4321: @227476
     /* 227476 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(227523), // Rule ID 11671 //
     /* 227481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227502 */     // MIs[0] Op3
     /* 227502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 227513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227521 */     GIR_RootConstrainSelectedInstOperands,
     /* 227522 */     // GIR_Coverage, 11671,
     /* 227522 */     GIR_EraseRootFromParent_Done,
     /* 227523 */   // Label 4322: @227523
     /* 227523 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(227570), // Rule ID 11672 //
     /* 227528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227549 */     // MIs[0] Op3
     /* 227549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 227560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227568 */     GIR_RootConstrainSelectedInstOperands,
     /* 227569 */     // GIR_Coverage, 11672,
     /* 227569 */     GIR_EraseRootFromParent_Done,
     /* 227570 */   // Label 4323: @227570
     /* 227570 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(227617), // Rule ID 11673 //
     /* 227575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227596 */     // MIs[0] Op3
     /* 227596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 227607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227615 */     GIR_RootConstrainSelectedInstOperands,
     /* 227616 */     // GIR_Coverage, 11673,
     /* 227616 */     GIR_EraseRootFromParent_Done,
     /* 227617 */   // Label 4324: @227617
     /* 227617 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(227664), // Rule ID 11675 //
     /* 227622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227643 */     // MIs[0] Op3
     /* 227643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 227654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227662 */     GIR_RootConstrainSelectedInstOperands,
     /* 227663 */     // GIR_Coverage, 11675,
     /* 227663 */     GIR_EraseRootFromParent_Done,
     /* 227664 */   // Label 4325: @227664
     /* 227664 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(227711), // Rule ID 11677 //
     /* 227669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227690 */     // MIs[0] Op3
     /* 227690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 227701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227709 */     GIR_RootConstrainSelectedInstOperands,
     /* 227710 */     // GIR_Coverage, 11677,
     /* 227710 */     GIR_EraseRootFromParent_Done,
     /* 227711 */   // Label 4326: @227711
     /* 227711 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(227758), // Rule ID 11679 //
     /* 227716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227737 */     // MIs[0] Op3
     /* 227737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 227748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227756 */     GIR_RootConstrainSelectedInstOperands,
     /* 227757 */     // GIR_Coverage, 11679,
     /* 227757 */     GIR_EraseRootFromParent_Done,
     /* 227758 */   // Label 4327: @227758
     /* 227758 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(227805), // Rule ID 11681 //
     /* 227763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227784 */     // MIs[0] Op3
     /* 227784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 227792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 227792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 227795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227803 */     GIR_RootConstrainSelectedInstOperands,
     /* 227804 */     // GIR_Coverage, 11681,
     /* 227804 */     GIR_EraseRootFromParent_Done,
     /* 227805 */   // Label 4328: @227805
     /* 227805 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(227852), // Rule ID 11682 //
     /* 227810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227831 */     // MIs[0] Op3
     /* 227831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 227839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 227839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 227842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227850 */     GIR_RootConstrainSelectedInstOperands,
     /* 227851 */     // GIR_Coverage, 11682,
     /* 227851 */     GIR_EraseRootFromParent_Done,
     /* 227852 */   // Label 4329: @227852
     /* 227852 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(227899), // Rule ID 11683 //
     /* 227857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227878 */     // MIs[0] Op3
     /* 227878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 227886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 227886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 227889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227897 */     GIR_RootConstrainSelectedInstOperands,
     /* 227898 */     // GIR_Coverage, 11683,
     /* 227898 */     GIR_EraseRootFromParent_Done,
     /* 227899 */   // Label 4330: @227899
     /* 227899 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(227946), // Rule ID 11684 //
     /* 227904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227925 */     // MIs[0] Op3
     /* 227925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 227933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1852:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 227933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 227936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227944 */     GIR_RootConstrainSelectedInstOperands,
     /* 227945 */     // GIR_Coverage, 11684,
     /* 227945 */     GIR_EraseRootFromParent_Done,
     /* 227946 */   // Label 4331: @227946
     /* 227946 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(227993), // Rule ID 11771 //
     /* 227951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 227959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227972 */     // MIs[0] Op3
     /* 227972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227980 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2072:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 227983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227991 */     GIR_RootConstrainSelectedInstOperands,
     /* 227992 */     // GIR_Coverage, 11771,
     /* 227992 */     GIR_EraseRootFromParent_Done,
     /* 227993 */   // Label 4332: @227993
     /* 227993 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(228040), // Rule ID 11773 //
     /* 227998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228019 */     // MIs[0] Op3
     /* 228019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2072:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 228030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228038 */     GIR_RootConstrainSelectedInstOperands,
     /* 228039 */     // GIR_Coverage, 11773,
     /* 228039 */     GIR_EraseRootFromParent_Done,
     /* 228040 */   // Label 4333: @228040
     /* 228040 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(228087), // Rule ID 11775 //
     /* 228045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228066 */     // MIs[0] Op3
     /* 228066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2072:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 228077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228085 */     GIR_RootConstrainSelectedInstOperands,
     /* 228086 */     // GIR_Coverage, 11775,
     /* 228086 */     GIR_EraseRootFromParent_Done,
     /* 228087 */   // Label 4334: @228087
     /* 228087 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(228134), // Rule ID 11777 //
     /* 228092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228113 */     // MIs[0] Op3
     /* 228113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2072:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 228124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228132 */     GIR_RootConstrainSelectedInstOperands,
     /* 228133 */     // GIR_Coverage, 11777,
     /* 228133 */     GIR_EraseRootFromParent_Done,
     /* 228134 */   // Label 4335: @228134
     /* 228134 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(228181), // Rule ID 11779 //
     /* 228139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228160 */     // MIs[0] Op3
     /* 228160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1873:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 228171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228179 */     GIR_RootConstrainSelectedInstOperands,
     /* 228180 */     // GIR_Coverage, 11779,
     /* 228180 */     GIR_EraseRootFromParent_Done,
     /* 228181 */   // Label 4336: @228181
     /* 228181 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(228228), // Rule ID 11780 //
     /* 228186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228207 */     // MIs[0] Op3
     /* 228207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 228218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228226 */     GIR_RootConstrainSelectedInstOperands,
     /* 228227 */     // GIR_Coverage, 11780,
     /* 228227 */     GIR_EraseRootFromParent_Done,
     /* 228228 */   // Label 4337: @228228
     /* 228228 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(228275), // Rule ID 11781 //
     /* 228233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228254 */     // MIs[0] Op3
     /* 228254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 228265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228273 */     GIR_RootConstrainSelectedInstOperands,
     /* 228274 */     // GIR_Coverage, 11781,
     /* 228274 */     GIR_EraseRootFromParent_Done,
     /* 228275 */   // Label 4338: @228275
     /* 228275 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(228322), // Rule ID 11782 //
     /* 228280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228301 */     // MIs[0] Op3
     /* 228301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 228312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228320 */     GIR_RootConstrainSelectedInstOperands,
     /* 228321 */     // GIR_Coverage, 11782,
     /* 228321 */     GIR_EraseRootFromParent_Done,
     /* 228322 */   // Label 4339: @228322
     /* 228322 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(228369), // Rule ID 11787 //
     /* 228327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228348 */     // MIs[0] Op3
     /* 228348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 228359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228367 */     GIR_RootConstrainSelectedInstOperands,
     /* 228368 */     // GIR_Coverage, 11787,
     /* 228368 */     GIR_EraseRootFromParent_Done,
     /* 228369 */   // Label 4340: @228369
     /* 228369 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(228416), // Rule ID 11788 //
     /* 228374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228395 */     // MIs[0] Op3
     /* 228395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 228406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228414 */     GIR_RootConstrainSelectedInstOperands,
     /* 228415 */     // GIR_Coverage, 11788,
     /* 228415 */     GIR_EraseRootFromParent_Done,
     /* 228416 */   // Label 4341: @228416
     /* 228416 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(228463), // Rule ID 11789 //
     /* 228421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228442 */     // MIs[0] Op3
     /* 228442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 228453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228461 */     GIR_RootConstrainSelectedInstOperands,
     /* 228462 */     // GIR_Coverage, 11789,
     /* 228462 */     GIR_EraseRootFromParent_Done,
     /* 228463 */   // Label 4342: @228463
     /* 228463 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(228510), // Rule ID 11790 //
     /* 228468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228489 */     // MIs[0] Op3
     /* 228489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 228500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228508 */     GIR_RootConstrainSelectedInstOperands,
     /* 228509 */     // GIR_Coverage, 11790,
     /* 228509 */     GIR_EraseRootFromParent_Done,
     /* 228510 */   // Label 4343: @228510
     /* 228510 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(228557), // Rule ID 11850 //
     /* 228515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228536 */     // MIs[0] Op3
     /* 228536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 228547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228555 */     GIR_RootConstrainSelectedInstOperands,
     /* 228556 */     // GIR_Coverage, 11850,
     /* 228556 */     GIR_EraseRootFromParent_Done,
     /* 228557 */   // Label 4344: @228557
     /* 228557 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(228604), // Rule ID 11851 //
     /* 228562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228583 */     // MIs[0] Op3
     /* 228583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 228594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228602 */     GIR_RootConstrainSelectedInstOperands,
     /* 228603 */     // GIR_Coverage, 11851,
     /* 228603 */     GIR_EraseRootFromParent_Done,
     /* 228604 */   // Label 4345: @228604
     /* 228604 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(228651), // Rule ID 11852 //
     /* 228609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228630 */     // MIs[0] Op3
     /* 228630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 228641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228649 */     GIR_RootConstrainSelectedInstOperands,
     /* 228650 */     // GIR_Coverage, 11852,
     /* 228650 */     GIR_EraseRootFromParent_Done,
     /* 228651 */   // Label 4346: @228651
     /* 228651 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(228698), // Rule ID 11853 //
     /* 228656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228677 */     // MIs[0] Op3
     /* 228677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228685 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1729:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 228688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228696 */     GIR_RootConstrainSelectedInstOperands,
     /* 228697 */     // GIR_Coverage, 11853,
     /* 228697 */     GIR_EraseRootFromParent_Done,
     /* 228698 */   // Label 4347: @228698
     /* 228698 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(228745), // Rule ID 11854 //
     /* 228703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228724 */     // MIs[0] Op3
     /* 228724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 228735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228743 */     GIR_RootConstrainSelectedInstOperands,
     /* 228744 */     // GIR_Coverage, 11854,
     /* 228744 */     GIR_EraseRootFromParent_Done,
     /* 228745 */   // Label 4348: @228745
     /* 228745 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(228792), // Rule ID 11855 //
     /* 228750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228771 */     // MIs[0] Op3
     /* 228771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 228782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228790 */     GIR_RootConstrainSelectedInstOperands,
     /* 228791 */     // GIR_Coverage, 11855,
     /* 228791 */     GIR_EraseRootFromParent_Done,
     /* 228792 */   // Label 4349: @228792
     /* 228792 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(228839), // Rule ID 11856 //
     /* 228797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228818 */     // MIs[0] Op3
     /* 228818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 228829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228837 */     GIR_RootConstrainSelectedInstOperands,
     /* 228838 */     // GIR_Coverage, 11856,
     /* 228838 */     GIR_EraseRootFromParent_Done,
     /* 228839 */   // Label 4350: @228839
     /* 228839 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(228886), // Rule ID 11857 //
     /* 228844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228865 */     // MIs[0] Op3
     /* 228865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 228876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228884 */     GIR_RootConstrainSelectedInstOperands,
     /* 228885 */     // GIR_Coverage, 11857,
     /* 228885 */     GIR_EraseRootFromParent_Done,
     /* 228886 */   // Label 4351: @228886
     /* 228886 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(228933), // Rule ID 11858 //
     /* 228891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228912 */     // MIs[0] Op3
     /* 228912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 228923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228931 */     GIR_RootConstrainSelectedInstOperands,
     /* 228932 */     // GIR_Coverage, 11858,
     /* 228932 */     GIR_EraseRootFromParent_Done,
     /* 228933 */   // Label 4352: @228933
     /* 228933 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(228980), // Rule ID 11859 //
     /* 228938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 228946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228959 */     // MIs[0] Op3
     /* 228959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 228970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228978 */     GIR_RootConstrainSelectedInstOperands,
     /* 228979 */     // GIR_Coverage, 11859,
     /* 228979 */     GIR_EraseRootFromParent_Done,
     /* 228980 */   // Label 4353: @228980
     /* 228980 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(229027), // Rule ID 11860 //
     /* 228985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 228993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229006 */     // MIs[0] Op3
     /* 229006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 229017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229025 */     GIR_RootConstrainSelectedInstOperands,
     /* 229026 */     // GIR_Coverage, 11860,
     /* 229026 */     GIR_EraseRootFromParent_Done,
     /* 229027 */   // Label 4354: @229027
     /* 229027 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(229074), // Rule ID 11861 //
     /* 229032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 229040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229053 */     // MIs[0] Op3
     /* 229053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 229064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229072 */     GIR_RootConstrainSelectedInstOperands,
     /* 229073 */     // GIR_Coverage, 11861,
     /* 229073 */     GIR_EraseRootFromParent_Done,
     /* 229074 */   // Label 4355: @229074
     /* 229074 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(229121), // Rule ID 11862 //
     /* 229079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229100 */     // MIs[0] Op3
     /* 229100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229108 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 229111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229119 */     GIR_RootConstrainSelectedInstOperands,
     /* 229120 */     // GIR_Coverage, 11862,
     /* 229120 */     GIR_EraseRootFromParent_Done,
     /* 229121 */   // Label 4356: @229121
     /* 229121 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(229168), // Rule ID 11863 //
     /* 229126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229147 */     // MIs[0] Op3
     /* 229147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229155 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 229158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229166 */     GIR_RootConstrainSelectedInstOperands,
     /* 229167 */     // GIR_Coverage, 11863,
     /* 229167 */     GIR_EraseRootFromParent_Done,
     /* 229168 */   // Label 4357: @229168
     /* 229168 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(229215), // Rule ID 11864 //
     /* 229173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229194 */     // MIs[0] Op3
     /* 229194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 229205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229213 */     GIR_RootConstrainSelectedInstOperands,
     /* 229214 */     // GIR_Coverage, 11864,
     /* 229214 */     GIR_EraseRootFromParent_Done,
     /* 229215 */   // Label 4358: @229215
     /* 229215 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(229262), // Rule ID 11865 //
     /* 229220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229241 */     // MIs[0] Op3
     /* 229241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229249 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2049:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 229252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229260 */     GIR_RootConstrainSelectedInstOperands,
     /* 229261 */     // GIR_Coverage, 11865,
     /* 229261 */     GIR_EraseRootFromParent_Done,
     /* 229262 */   // Label 4359: @229262
     /* 229262 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(229309), // Rule ID 11866 //
     /* 229267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229288 */     // MIs[0] Op3
     /* 229288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2049:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 229299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229307 */     GIR_RootConstrainSelectedInstOperands,
     /* 229308 */     // GIR_Coverage, 11866,
     /* 229308 */     GIR_EraseRootFromParent_Done,
     /* 229309 */   // Label 4360: @229309
     /* 229309 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(229356), // Rule ID 11867 //
     /* 229314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229335 */     // MIs[0] Op3
     /* 229335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 229346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229354 */     GIR_RootConstrainSelectedInstOperands,
     /* 229355 */     // GIR_Coverage, 11867,
     /* 229355 */     GIR_EraseRootFromParent_Done,
     /* 229356 */   // Label 4361: @229356
     /* 229356 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(229403), // Rule ID 11868 //
     /* 229361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229382 */     // MIs[0] Op3
     /* 229382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229390 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2046:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 229393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229401 */     GIR_RootConstrainSelectedInstOperands,
     /* 229402 */     // GIR_Coverage, 11868,
     /* 229402 */     GIR_EraseRootFromParent_Done,
     /* 229403 */   // Label 4362: @229403
     /* 229403 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(229450), // Rule ID 11869 //
     /* 229408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229429 */     // MIs[0] Op3
     /* 229429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229437 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2046:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 229440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229448 */     GIR_RootConstrainSelectedInstOperands,
     /* 229449 */     // GIR_Coverage, 11869,
     /* 229449 */     GIR_EraseRootFromParent_Done,
     /* 229450 */   // Label 4363: @229450
     /* 229450 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229497), // Rule ID 11870 //
     /* 229455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229476 */     // MIs[0] Op3
     /* 229476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 229487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229495 */     GIR_RootConstrainSelectedInstOperands,
     /* 229496 */     // GIR_Coverage, 11870,
     /* 229496 */     GIR_EraseRootFromParent_Done,
     /* 229497 */   // Label 4364: @229497
     /* 229497 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(229564), // Rule ID 2600 //
     /* 229502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 229510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 229553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229562 */     GIR_RootConstrainSelectedInstOperands,
     /* 229563 */     // GIR_Coverage, 2600,
     /* 229563 */     GIR_EraseRootFromParent_Done,
     /* 229564 */   // Label 4365: @229564
     /* 229564 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(229631), // Rule ID 7769 //
     /* 229569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229603 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 229620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229629 */     GIR_RootConstrainSelectedInstOperands,
     /* 229630 */     // GIR_Coverage, 7769,
     /* 229630 */     GIR_EraseRootFromParent_Done,
     /* 229631 */   // Label 4366: @229631
     /* 229631 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(229698), // Rule ID 7771 //
     /* 229636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 229687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229696 */     GIR_RootConstrainSelectedInstOperands,
     /* 229697 */     // GIR_Coverage, 7771,
     /* 229697 */     GIR_EraseRootFromParent_Done,
     /* 229698 */   // Label 4367: @229698
     /* 229698 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(229765), // Rule ID 7773 //
     /* 229703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 229754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229763 */     GIR_RootConstrainSelectedInstOperands,
     /* 229764 */     // GIR_Coverage, 7773,
     /* 229764 */     GIR_EraseRootFromParent_Done,
     /* 229765 */   // Label 4368: @229765
     /* 229765 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(229832), // Rule ID 7775 //
     /* 229770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 229821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229830 */     GIR_RootConstrainSelectedInstOperands,
     /* 229831 */     // GIR_Coverage, 7775,
     /* 229831 */     GIR_EraseRootFromParent_Done,
     /* 229832 */   // Label 4369: @229832
     /* 229832 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(229899), // Rule ID 7805 //
     /* 229837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 229888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229897 */     GIR_RootConstrainSelectedInstOperands,
     /* 229898 */     // GIR_Coverage, 7805,
     /* 229898 */     GIR_EraseRootFromParent_Done,
     /* 229899 */   // Label 4370: @229899
     /* 229899 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(229966), // Rule ID 7807 //
     /* 229904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 229955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229964 */     GIR_RootConstrainSelectedInstOperands,
     /* 229965 */     // GIR_Coverage, 7807,
     /* 229965 */     GIR_EraseRootFromParent_Done,
     /* 229966 */   // Label 4371: @229966
     /* 229966 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(230033), // Rule ID 7809 //
     /* 229971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230005 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 230022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230031 */     GIR_RootConstrainSelectedInstOperands,
     /* 230032 */     // GIR_Coverage, 7809,
     /* 230032 */     GIR_EraseRootFromParent_Done,
     /* 230033 */   // Label 4372: @230033
     /* 230033 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(230100), // Rule ID 7811 //
     /* 230038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 230046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 230089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230098 */     GIR_RootConstrainSelectedInstOperands,
     /* 230099 */     // GIR_Coverage, 7811,
     /* 230099 */     GIR_EraseRootFromParent_Done,
     /* 230100 */   // Label 4373: @230100
     /* 230100 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(230167), // Rule ID 7817 //
     /* 230105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 230156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230165 */     GIR_RootConstrainSelectedInstOperands,
     /* 230166 */     // GIR_Coverage, 7817,
     /* 230166 */     GIR_EraseRootFromParent_Done,
     /* 230167 */   // Label 4374: @230167
     /* 230167 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(230234), // Rule ID 7819 //
     /* 230172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 230223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230232 */     GIR_RootConstrainSelectedInstOperands,
     /* 230233 */     // GIR_Coverage, 7819,
     /* 230233 */     GIR_EraseRootFromParent_Done,
     /* 230234 */   // Label 4375: @230234
     /* 230234 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(230301), // Rule ID 7821 //
     /* 230239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 230290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230299 */     GIR_RootConstrainSelectedInstOperands,
     /* 230300 */     // GIR_Coverage, 7821,
     /* 230300 */     GIR_EraseRootFromParent_Done,
     /* 230301 */   // Label 4376: @230301
     /* 230301 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(230368), // Rule ID 7823 //
     /* 230306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 230357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230366 */     GIR_RootConstrainSelectedInstOperands,
     /* 230367 */     // GIR_Coverage, 7823,
     /* 230367 */     GIR_EraseRootFromParent_Done,
     /* 230368 */   // Label 4377: @230368
     /* 230368 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(230435), // Rule ID 11551 //
     /* 230373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 230381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 230424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230433 */     GIR_RootConstrainSelectedInstOperands,
     /* 230434 */     // GIR_Coverage, 11551,
     /* 230434 */     GIR_EraseRootFromParent_Done,
     /* 230435 */   // Label 4378: @230435
     /* 230435 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(230502), // Rule ID 11553 //
     /* 230440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 230491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230500 */     GIR_RootConstrainSelectedInstOperands,
     /* 230501 */     // GIR_Coverage, 11553,
     /* 230501 */     GIR_EraseRootFromParent_Done,
     /* 230502 */   // Label 4379: @230502
     /* 230502 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(230569), // Rule ID 11555 //
     /* 230507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 230558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230567 */     GIR_RootConstrainSelectedInstOperands,
     /* 230568 */     // GIR_Coverage, 11555,
     /* 230568 */     GIR_EraseRootFromParent_Done,
     /* 230569 */   // Label 4380: @230569
     /* 230569 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230636), // Rule ID 11557 //
     /* 230574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 230625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230634 */     GIR_RootConstrainSelectedInstOperands,
     /* 230635 */     // GIR_Coverage, 11557,
     /* 230635 */     GIR_EraseRootFromParent_Done,
     /* 230636 */   // Label 4381: @230636
     /* 230636 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230703), // Rule ID 11559 //
     /* 230641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 230692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230701 */     GIR_RootConstrainSelectedInstOperands,
     /* 230702 */     // GIR_Coverage, 11559,
     /* 230702 */     GIR_EraseRootFromParent_Done,
     /* 230703 */   // Label 4382: @230703
     /* 230703 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230770), // Rule ID 11565 //
     /* 230708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230742 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 230759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230768 */     GIR_RootConstrainSelectedInstOperands,
     /* 230769 */     // GIR_Coverage, 11565,
     /* 230769 */     GIR_EraseRootFromParent_Done,
     /* 230770 */   // Label 4383: @230770
     /* 230770 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230837), // Rule ID 11567 //
     /* 230775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 230826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230835 */     GIR_RootConstrainSelectedInstOperands,
     /* 230836 */     // GIR_Coverage, 11567,
     /* 230836 */     GIR_EraseRootFromParent_Done,
     /* 230837 */   // Label 4384: @230837
     /* 230837 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230904), // Rule ID 11569 //
     /* 230842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 230893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230902 */     GIR_RootConstrainSelectedInstOperands,
     /* 230903 */     // GIR_Coverage, 11569,
     /* 230903 */     GIR_EraseRootFromParent_Done,
     /* 230904 */   // Label 4385: @230904
     /* 230904 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(230971), // Rule ID 11571 //
     /* 230909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 230960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230969 */     GIR_RootConstrainSelectedInstOperands,
     /* 230970 */     // GIR_Coverage, 11571,
     /* 230970 */     GIR_EraseRootFromParent_Done,
     /* 230971 */   // Label 4386: @230971
     /* 230971 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(231025), // Rule ID 30 //
     /* 230976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 230979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 230984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 230993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 230996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 231015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231023 */     GIR_RootConstrainSelectedInstOperands,
     /* 231024 */     // GIR_Coverage, 30,
     /* 231024 */     GIR_EraseRootFromParent_Done,
     /* 231025 */   // Label 4387: @231025
     /* 231025 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(231079), // Rule ID 31 //
     /* 231030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 231033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 231038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 747:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 231069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231077 */     GIR_RootConstrainSelectedInstOperands,
     /* 231078 */     // GIR_Coverage, 31,
     /* 231078 */     GIR_EraseRootFromParent_Done,
     /* 231079 */   // Label 4388: @231079
     /* 231079 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(231133), // Rule ID 32 //
     /* 231084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 231087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 231092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231120 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 231123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231131 */     GIR_RootConstrainSelectedInstOperands,
     /* 231132 */     // GIR_Coverage, 32,
     /* 231132 */     GIR_EraseRootFromParent_Done,
     /* 231133 */   // Label 4389: @231133
     /* 231133 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(231187), // Rule ID 39 //
     /* 231138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231174 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 231177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231185 */     GIR_RootConstrainSelectedInstOperands,
     /* 231186 */     // GIR_Coverage, 39,
     /* 231186 */     GIR_EraseRootFromParent_Done,
     /* 231187 */   // Label 4390: @231187
     /* 231187 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(231241), // Rule ID 40 //
     /* 231192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231228 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 231231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231239 */     GIR_RootConstrainSelectedInstOperands,
     /* 231240 */     // GIR_Coverage, 40,
     /* 231240 */     GIR_EraseRootFromParent_Done,
     /* 231241 */   // Label 4391: @231241
     /* 231241 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(231295), // Rule ID 41 //
     /* 231246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231282 */     // (intrinsic_wo_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 231285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231293 */     GIR_RootConstrainSelectedInstOperands,
     /* 231294 */     // GIR_Coverage, 41,
     /* 231294 */     GIR_EraseRootFromParent_Done,
     /* 231295 */   // Label 4392: @231295
     /* 231295 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(231349), // Rule ID 42 //
     /* 231300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231336 */     // (intrinsic_wo_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 231339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231347 */     GIR_RootConstrainSelectedInstOperands,
     /* 231348 */     // GIR_Coverage, 42,
     /* 231348 */     GIR_EraseRootFromParent_Done,
     /* 231349 */   // Label 4393: @231349
     /* 231349 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(231403), // Rule ID 43 //
     /* 231354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231390 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 231393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231401 */     GIR_RootConstrainSelectedInstOperands,
     /* 231402 */     // GIR_Coverage, 43,
     /* 231402 */     GIR_EraseRootFromParent_Done,
     /* 231403 */   // Label 4394: @231403
     /* 231403 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(231457), // Rule ID 44 //
     /* 231408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231444 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 231447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231455 */     GIR_RootConstrainSelectedInstOperands,
     /* 231456 */     // GIR_Coverage, 44,
     /* 231456 */     GIR_EraseRootFromParent_Done,
     /* 231457 */   // Label 4395: @231457
     /* 231457 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(231511), // Rule ID 45 //
     /* 231462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231498 */     // (intrinsic_wo_chain:{ *:[v2f32] } 619:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 231501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231509 */     GIR_RootConstrainSelectedInstOperands,
     /* 231510 */     // GIR_Coverage, 45,
     /* 231510 */     GIR_EraseRootFromParent_Done,
     /* 231511 */   // Label 4396: @231511
     /* 231511 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(231565), // Rule ID 46 //
     /* 231516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231552 */     // (intrinsic_wo_chain:{ *:[v4f32] } 619:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 231555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231563 */     GIR_RootConstrainSelectedInstOperands,
     /* 231564 */     // GIR_Coverage, 46,
     /* 231564 */     GIR_EraseRootFromParent_Done,
     /* 231565 */   // Label 4397: @231565
     /* 231565 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(231619), // Rule ID 1587 //
     /* 231570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 231581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 231584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231606 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 231606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 231609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231617 */     GIR_RootConstrainSelectedInstOperands,
     /* 231618 */     // GIR_Coverage, 1587,
     /* 231618 */     GIR_EraseRootFromParent_Done,
     /* 231619 */   // Label 4398: @231619
     /* 231619 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(231673), // Rule ID 1588 //
     /* 231624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231660 */     // (intrinsic_wo_chain:{ *:[v8i16] } 696:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 231660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 231663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231671 */     GIR_RootConstrainSelectedInstOperands,
     /* 231672 */     // GIR_Coverage, 1588,
     /* 231672 */     GIR_EraseRootFromParent_Done,
     /* 231673 */   // Label 4399: @231673
     /* 231673 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231727), // Rule ID 1589 //
     /* 231678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 231695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 231698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231714 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 231714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 231717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231725 */     GIR_RootConstrainSelectedInstOperands,
     /* 231726 */     // GIR_Coverage, 1589,
     /* 231726 */     GIR_EraseRootFromParent_Done,
     /* 231727 */   // Label 4400: @231727
     /* 231727 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231781), // Rule ID 1590 //
     /* 231732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231768 */     // (intrinsic_wo_chain:{ *:[v4i32] } 696:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 231771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231779 */     GIR_RootConstrainSelectedInstOperands,
     /* 231780 */     // GIR_Coverage, 1590,
     /* 231780 */     GIR_EraseRootFromParent_Done,
     /* 231781 */   // Label 4401: @231781
     /* 231781 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231835), // Rule ID 1591 //
     /* 231786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 231797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 231800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231822 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 231822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 231825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231833 */     GIR_RootConstrainSelectedInstOperands,
     /* 231834 */     // GIR_Coverage, 1591,
     /* 231834 */     GIR_EraseRootFromParent_Done,
     /* 231835 */   // Label 4402: @231835
     /* 231835 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231889), // Rule ID 1592 //
     /* 231840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231876 */     // (intrinsic_wo_chain:{ *:[v8i16] } 697:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 231876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 231879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231887 */     GIR_RootConstrainSelectedInstOperands,
     /* 231888 */     // GIR_Coverage, 1592,
     /* 231888 */     GIR_EraseRootFromParent_Done,
     /* 231889 */   // Label 4403: @231889
     /* 231889 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231943), // Rule ID 1593 //
     /* 231894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 231911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 231914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231930 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 231930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 231933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231941 */     GIR_RootConstrainSelectedInstOperands,
     /* 231942 */     // GIR_Coverage, 1593,
     /* 231942 */     GIR_EraseRootFromParent_Done,
     /* 231943 */   // Label 4404: @231943
     /* 231943 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(231997), // Rule ID 1594 //
     /* 231948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 697:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 231987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231995 */     GIR_RootConstrainSelectedInstOperands,
     /* 231996 */     // GIR_Coverage, 1594,
     /* 231996 */     GIR_EraseRootFromParent_Done,
     /* 231997 */   // Label 4405: @231997
     /* 231997 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(232051), // Rule ID 2307 //
     /* 232002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 232010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232038 */     // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 232041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232049 */     GIR_RootConstrainSelectedInstOperands,
     /* 232050 */     // GIR_Coverage, 2307,
     /* 232050 */     GIR_EraseRootFromParent_Done,
     /* 232051 */   // Label 4406: @232051
     /* 232051 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(232105), // Rule ID 2308 //
     /* 232056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 232064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 232095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232103 */     GIR_RootConstrainSelectedInstOperands,
     /* 232104 */     // GIR_Coverage, 2308,
     /* 232104 */     GIR_EraseRootFromParent_Done,
     /* 232105 */   // Label 4407: @232105
     /* 232105 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(232159), // Rule ID 2309 //
     /* 232110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 232118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232146 */     // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 232149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232157 */     GIR_RootConstrainSelectedInstOperands,
     /* 232158 */     // GIR_Coverage, 2309,
     /* 232158 */     GIR_EraseRootFromParent_Done,
     /* 232159 */   // Label 4408: @232159
     /* 232159 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(232213), // Rule ID 2310 //
     /* 232164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 232172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 232203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232211 */     GIR_RootConstrainSelectedInstOperands,
     /* 232212 */     // GIR_Coverage, 2310,
     /* 232212 */     GIR_EraseRootFromParent_Done,
     /* 232213 */   // Label 4409: @232213
     /* 232213 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(232267), // Rule ID 2311 //
     /* 232218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 232226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232254 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 232257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232265 */     GIR_RootConstrainSelectedInstOperands,
     /* 232266 */     // GIR_Coverage, 2311,
     /* 232266 */     GIR_EraseRootFromParent_Done,
     /* 232267 */   // Label 4410: @232267
     /* 232267 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(232321), // Rule ID 2312 //
     /* 232272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 232280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232308 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 232311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232319 */     GIR_RootConstrainSelectedInstOperands,
     /* 232320 */     // GIR_Coverage, 2312,
     /* 232320 */     GIR_EraseRootFromParent_Done,
     /* 232321 */   // Label 4411: @232321
     /* 232321 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(232375), // Rule ID 2313 //
     /* 232326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 232334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232362 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 232365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232373 */     GIR_RootConstrainSelectedInstOperands,
     /* 232374 */     // GIR_Coverage, 2313,
     /* 232374 */     GIR_EraseRootFromParent_Done,
     /* 232375 */   // Label 4412: @232375
     /* 232375 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(232432), // Rule ID 3638 //
     /* 232380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 232419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232425 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232430 */     GIR_RootConstrainSelectedInstOperands,
     /* 232431 */     // GIR_Coverage, 3638,
     /* 232431 */     GIR_EraseRootFromParent_Done,
     /* 232432 */   // Label 4413: @232432
     /* 232432 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(232489), // Rule ID 3639 //
     /* 232437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 232476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232482 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232487 */     GIR_RootConstrainSelectedInstOperands,
     /* 232488 */     // GIR_Coverage, 3639,
     /* 232488 */     GIR_EraseRootFromParent_Done,
     /* 232489 */   // Label 4414: @232489
     /* 232489 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(232546), // Rule ID 3640 //
     /* 232494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 232533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232539 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232544 */     GIR_RootConstrainSelectedInstOperands,
     /* 232545 */     // GIR_Coverage, 3640,
     /* 232545 */     GIR_EraseRootFromParent_Done,
     /* 232546 */   // Label 4415: @232546
     /* 232546 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(232603), // Rule ID 3641 //
     /* 232551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 232590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232596 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232601 */     GIR_RootConstrainSelectedInstOperands,
     /* 232602 */     // GIR_Coverage, 3641,
     /* 232602 */     GIR_EraseRootFromParent_Done,
     /* 232603 */   // Label 4416: @232603
     /* 232603 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(232657), // Rule ID 3820 //
     /* 232608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 232616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232644 */     // (intrinsic_wo_chain:{ *:[v2i64] } 540:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 232647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232655 */     GIR_RootConstrainSelectedInstOperands,
     /* 232656 */     // GIR_Coverage, 3820,
     /* 232656 */     GIR_EraseRootFromParent_Done,
     /* 232657 */   // Label 4417: @232657
     /* 232657 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232711), // Rule ID 3821 //
     /* 232662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 232670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232698 */     // (intrinsic_wo_chain:{ *:[v2i64] } 541:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 232701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232709 */     GIR_RootConstrainSelectedInstOperands,
     /* 232710 */     // GIR_Coverage, 3821,
     /* 232710 */     GIR_EraseRootFromParent_Done,
     /* 232711 */   // Label 4418: @232711
     /* 232711 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232765), // Rule ID 3822 //
     /* 232716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 232724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232752 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 232755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232763 */     GIR_RootConstrainSelectedInstOperands,
     /* 232764 */     // GIR_Coverage, 3822,
     /* 232764 */     GIR_EraseRootFromParent_Done,
     /* 232765 */   // Label 4419: @232765
     /* 232765 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(232819), // Rule ID 3823 //
     /* 232770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 232781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 232784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 232787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 232790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232806 */     // (intrinsic_wo_chain:{ *:[v16i8] } 528:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 232806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232817 */     GIR_RootConstrainSelectedInstOperands,
     /* 232818 */     // GIR_Coverage, 3823,
     /* 232818 */     GIR_EraseRootFromParent_Done,
     /* 232819 */   // Label 4420: @232819
     /* 232819 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(232873), // Rule ID 3824 //
     /* 232824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232860 */     // (intrinsic_wo_chain:{ *:[v8i16] } 528:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 232860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232871 */     GIR_RootConstrainSelectedInstOperands,
     /* 232872 */     // GIR_Coverage, 3824,
     /* 232872 */     GIR_EraseRootFromParent_Done,
     /* 232873 */   // Label 4421: @232873
     /* 232873 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(232927), // Rule ID 3825 //
     /* 232878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232914 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232925 */     GIR_RootConstrainSelectedInstOperands,
     /* 232926 */     // GIR_Coverage, 3825,
     /* 232926 */     GIR_EraseRootFromParent_Done,
     /* 232927 */   // Label 4422: @232927
     /* 232927 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(232981), // Rule ID 3826 //
     /* 232932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232968 */     // (intrinsic_wo_chain:{ *:[v2i64] } 528:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232979 */     GIR_RootConstrainSelectedInstOperands,
     /* 232980 */     // GIR_Coverage, 3826,
     /* 232980 */     GIR_EraseRootFromParent_Done,
     /* 232981 */   // Label 4423: @232981
     /* 232981 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(233035), // Rule ID 3835 //
     /* 232986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 232994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 232997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233022 */     // (intrinsic_wo_chain:{ *:[v16i8] } 526:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233033 */     GIR_RootConstrainSelectedInstOperands,
     /* 233034 */     // GIR_Coverage, 3835,
     /* 233034 */     GIR_EraseRootFromParent_Done,
     /* 233035 */   // Label 4424: @233035
     /* 233035 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(233089), // Rule ID 3836 //
     /* 233040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 526:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233087 */     GIR_RootConstrainSelectedInstOperands,
     /* 233088 */     // GIR_Coverage, 3836,
     /* 233088 */     GIR_EraseRootFromParent_Done,
     /* 233089 */   // Label 4425: @233089
     /* 233089 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(233143), // Rule ID 3837 //
     /* 233094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233141 */     GIR_RootConstrainSelectedInstOperands,
     /* 233142 */     // GIR_Coverage, 3837,
     /* 233142 */     GIR_EraseRootFromParent_Done,
     /* 233143 */   // Label 4426: @233143
     /* 233143 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(233197), // Rule ID 3838 //
     /* 233148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 526:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233195 */     GIR_RootConstrainSelectedInstOperands,
     /* 233196 */     // GIR_Coverage, 3838,
     /* 233196 */     GIR_EraseRootFromParent_Done,
     /* 233197 */   // Label 4427: @233197
     /* 233197 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(233251), // Rule ID 3839 //
     /* 233202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233238 */     // (intrinsic_wo_chain:{ *:[v16i8] } 527:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233249 */     GIR_RootConstrainSelectedInstOperands,
     /* 233250 */     // GIR_Coverage, 3839,
     /* 233250 */     GIR_EraseRootFromParent_Done,
     /* 233251 */   // Label 4428: @233251
     /* 233251 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(233305), // Rule ID 3840 //
     /* 233256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233292 */     // (intrinsic_wo_chain:{ *:[v8i16] } 527:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233303 */     GIR_RootConstrainSelectedInstOperands,
     /* 233304 */     // GIR_Coverage, 3840,
     /* 233304 */     GIR_EraseRootFromParent_Done,
     /* 233305 */   // Label 4429: @233305
     /* 233305 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(233359), // Rule ID 3841 //
     /* 233310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233357 */     GIR_RootConstrainSelectedInstOperands,
     /* 233358 */     // GIR_Coverage, 3841,
     /* 233358 */     GIR_EraseRootFromParent_Done,
     /* 233359 */   // Label 4430: @233359
     /* 233359 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(233413), // Rule ID 3842 //
     /* 233364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233400 */     // (intrinsic_wo_chain:{ *:[v2i64] } 527:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233411 */     GIR_RootConstrainSelectedInstOperands,
     /* 233412 */     // GIR_Coverage, 3842,
     /* 233412 */     GIR_EraseRootFromParent_Done,
     /* 233413 */   // Label 4431: @233413
     /* 233413 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(233467), // Rule ID 3843 //
     /* 233418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233454 */     // (intrinsic_wo_chain:{ *:[v16i8] } 525:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233465 */     GIR_RootConstrainSelectedInstOperands,
     /* 233466 */     // GIR_Coverage, 3843,
     /* 233466 */     GIR_EraseRootFromParent_Done,
     /* 233467 */   // Label 4432: @233467
     /* 233467 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(233521), // Rule ID 3844 //
     /* 233472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 525:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233519 */     GIR_RootConstrainSelectedInstOperands,
     /* 233520 */     // GIR_Coverage, 3844,
     /* 233520 */     GIR_EraseRootFromParent_Done,
     /* 233521 */   // Label 4433: @233521
     /* 233521 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(233575), // Rule ID 3845 //
     /* 233526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233562 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233573 */     GIR_RootConstrainSelectedInstOperands,
     /* 233574 */     // GIR_Coverage, 3845,
     /* 233574 */     GIR_EraseRootFromParent_Done,
     /* 233575 */   // Label 4434: @233575
     /* 233575 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(233629), // Rule ID 3846 //
     /* 233580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233616 */     // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233627 */     GIR_RootConstrainSelectedInstOperands,
     /* 233628 */     // GIR_Coverage, 3846,
     /* 233628 */     GIR_EraseRootFromParent_Done,
     /* 233629 */   // Label 4435: @233629
     /* 233629 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233683), // Rule ID 3850 //
     /* 233634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 233642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233670 */     // (intrinsic_wo_chain:{ *:[v4i32] } 546:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 233670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 233673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 233677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 233679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 233681 */     GIR_RootConstrainSelectedInstOperands,
     /* 233682 */     // GIR_Coverage, 3850,
     /* 233682 */     GIR_EraseRootFromParent_Done,
     /* 233683 */   // Label 4436: @233683
     /* 233683 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233737), // Rule ID 3851 //
     /* 233688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 233696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 544:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 233727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233735 */     GIR_RootConstrainSelectedInstOperands,
     /* 233736 */     // GIR_Coverage, 3851,
     /* 233736 */     GIR_EraseRootFromParent_Done,
     /* 233737 */   // Label 4437: @233737
     /* 233737 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(233791), // Rule ID 3852 //
     /* 233742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 233750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233778 */     // (intrinsic_wo_chain:{ *:[v4i32] } 545:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 233781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233789 */     GIR_RootConstrainSelectedInstOperands,
     /* 233790 */     // GIR_Coverage, 3852,
     /* 233790 */     GIR_EraseRootFromParent_Done,
     /* 233791 */   // Label 4438: @233791
     /* 233791 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(233848), // Rule ID 3869 //
     /* 233796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 233804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233832 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 233832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233846 */     GIR_RootConstrainSelectedInstOperands,
     /* 233847 */     // GIR_Coverage, 3869,
     /* 233847 */     GIR_EraseRootFromParent_Done,
     /* 233848 */   // Label 4439: @233848
     /* 233848 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(233905), // Rule ID 3870 //
     /* 233853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 233861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233889 */     // (intrinsic_wo_chain:{ *:[v4f16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 233889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 233903 */     GIR_RootConstrainSelectedInstOperands,
     /* 233904 */     // GIR_Coverage, 3870,
     /* 233904 */     GIR_EraseRootFromParent_Done,
     /* 233905 */   // Label 4440: @233905
     /* 233905 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(233962), // Rule ID 3871 //
     /* 233910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 233918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233946 */     // (intrinsic_wo_chain:{ *:[v4f16] } 768:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 233946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 233960 */     GIR_RootConstrainSelectedInstOperands,
     /* 233961 */     // GIR_Coverage, 3871,
     /* 233961 */     GIR_EraseRootFromParent_Done,
     /* 233962 */   // Label 4441: @233962
     /* 233962 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(234019), // Rule ID 3872 //
     /* 233967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 233975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234003 */     // (intrinsic_wo_chain:{ *:[v4f16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 234003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 234006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234017 */     GIR_RootConstrainSelectedInstOperands,
     /* 234018 */     // GIR_Coverage, 3872,
     /* 234018 */     GIR_EraseRootFromParent_Done,
     /* 234019 */   // Label 4442: @234019
     /* 234019 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(234076), // Rule ID 3877 //
     /* 234024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234060 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 234060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234074 */     GIR_RootConstrainSelectedInstOperands,
     /* 234075 */     // GIR_Coverage, 3877,
     /* 234075 */     GIR_EraseRootFromParent_Done,
     /* 234076 */   // Label 4443: @234076
     /* 234076 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(234133), // Rule ID 3878 //
     /* 234081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234117 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 234117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234131 */     GIR_RootConstrainSelectedInstOperands,
     /* 234132 */     // GIR_Coverage, 3878,
     /* 234132 */     GIR_EraseRootFromParent_Done,
     /* 234133 */   // Label 4444: @234133
     /* 234133 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(234190), // Rule ID 3879 //
     /* 234138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234174 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 234174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234188 */     GIR_RootConstrainSelectedInstOperands,
     /* 234189 */     // GIR_Coverage, 3879,
     /* 234189 */     GIR_EraseRootFromParent_Done,
     /* 234190 */   // Label 4445: @234190
     /* 234190 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(234247), // Rule ID 3880 //
     /* 234195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234231 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 234231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234245 */     GIR_RootConstrainSelectedInstOperands,
     /* 234246 */     // GIR_Coverage, 3880,
     /* 234246 */     GIR_EraseRootFromParent_Done,
     /* 234247 */   // Label 4446: @234247
     /* 234247 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(234304), // Rule ID 3885 //
     /* 234252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234288 */     // (intrinsic_wo_chain:{ *:[v2f32] } 767:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 234288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234302 */     GIR_RootConstrainSelectedInstOperands,
     /* 234303 */     // GIR_Coverage, 3885,
     /* 234303 */     GIR_EraseRootFromParent_Done,
     /* 234304 */   // Label 4447: @234304
     /* 234304 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(234361), // Rule ID 3886 //
     /* 234309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234345 */     // (intrinsic_wo_chain:{ *:[v2f32] } 770:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 234345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234359 */     GIR_RootConstrainSelectedInstOperands,
     /* 234360 */     // GIR_Coverage, 3886,
     /* 234360 */     GIR_EraseRootFromParent_Done,
     /* 234361 */   // Label 4448: @234361
     /* 234361 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(234418), // Rule ID 3887 //
     /* 234366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234402 */     // (intrinsic_wo_chain:{ *:[v2f32] } 768:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 234402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234416 */     GIR_RootConstrainSelectedInstOperands,
     /* 234417 */     // GIR_Coverage, 3887,
     /* 234417 */     GIR_EraseRootFromParent_Done,
     /* 234418 */   // Label 4449: @234418
     /* 234418 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(234475), // Rule ID 3888 //
     /* 234423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234459 */     // (intrinsic_wo_chain:{ *:[v2f32] } 769:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 234459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234473 */     GIR_RootConstrainSelectedInstOperands,
     /* 234474 */     // GIR_Coverage, 3888,
     /* 234474 */     GIR_EraseRootFromParent_Done,
     /* 234475 */   // Label 4450: @234475
     /* 234475 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(234532), // Rule ID 3889 //
     /* 234480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234516 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 234516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234530 */     GIR_RootConstrainSelectedInstOperands,
     /* 234531 */     // GIR_Coverage, 3889,
     /* 234531 */     GIR_EraseRootFromParent_Done,
     /* 234532 */   // Label 4451: @234532
     /* 234532 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(234589), // Rule ID 3890 //
     /* 234537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234573 */     // (intrinsic_wo_chain:{ *:[v4f32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 234573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234587 */     GIR_RootConstrainSelectedInstOperands,
     /* 234588 */     // GIR_Coverage, 3890,
     /* 234588 */     GIR_EraseRootFromParent_Done,
     /* 234589 */   // Label 4452: @234589
     /* 234589 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(234646), // Rule ID 3891 //
     /* 234594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234630 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 234630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234644 */     GIR_RootConstrainSelectedInstOperands,
     /* 234645 */     // GIR_Coverage, 3891,
     /* 234645 */     GIR_EraseRootFromParent_Done,
     /* 234646 */   // Label 4453: @234646
     /* 234646 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(234703), // Rule ID 3892 //
     /* 234651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 234687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234701 */     GIR_RootConstrainSelectedInstOperands,
     /* 234702 */     // GIR_Coverage, 3892,
     /* 234702 */     GIR_EraseRootFromParent_Done,
     /* 234703 */   // Label 4454: @234703
     /* 234703 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(234760), // Rule ID 3893 //
     /* 234708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234744 */     // (intrinsic_wo_chain:{ *:[v2f64] } 767:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 234744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234758 */     GIR_RootConstrainSelectedInstOperands,
     /* 234759 */     // GIR_Coverage, 3893,
     /* 234759 */     GIR_EraseRootFromParent_Done,
     /* 234760 */   // Label 4455: @234760
     /* 234760 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(234817), // Rule ID 3894 //
     /* 234765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234801 */     // (intrinsic_wo_chain:{ *:[v2f64] } 770:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 234801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234815 */     GIR_RootConstrainSelectedInstOperands,
     /* 234816 */     // GIR_Coverage, 3894,
     /* 234816 */     GIR_EraseRootFromParent_Done,
     /* 234817 */   // Label 4456: @234817
     /* 234817 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(234874), // Rule ID 3895 //
     /* 234822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234858 */     // (intrinsic_wo_chain:{ *:[v2f64] } 768:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 234858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234872 */     GIR_RootConstrainSelectedInstOperands,
     /* 234873 */     // GIR_Coverage, 3895,
     /* 234873 */     GIR_EraseRootFromParent_Done,
     /* 234874 */   // Label 4457: @234874
     /* 234874 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(234931), // Rule ID 3896 //
     /* 234879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234915 */     // (intrinsic_wo_chain:{ *:[v2f64] } 769:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 234915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234929 */     GIR_RootConstrainSelectedInstOperands,
     /* 234930 */     // GIR_Coverage, 3896,
     /* 234930 */     GIR_EraseRootFromParent_Done,
     /* 234931 */   // Label 4458: @234931
     /* 234931 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(234985), // Rule ID 5251 //
     /* 234936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 234939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 234944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234972 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 234972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 234975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234983 */     GIR_RootConstrainSelectedInstOperands,
     /* 234984 */     // GIR_Coverage, 5251,
     /* 234984 */     GIR_EraseRootFromParent_Done,
     /* 234985 */   // Label 4459: @234985
     /* 234985 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(235039), // Rule ID 5252 //
     /* 234990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 234993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235026 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 235026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 235029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235037 */     GIR_RootConstrainSelectedInstOperands,
     /* 235038 */     // GIR_Coverage, 5252,
     /* 235038 */     GIR_EraseRootFromParent_Done,
     /* 235039 */   // Label 4460: @235039
     /* 235039 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(235090), // Rule ID 5605 //
     /* 235044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 235049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 235052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 235055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 235061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235077 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 235077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 235080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 235088 */     GIR_RootConstrainSelectedInstOperands,
     /* 235089 */     // GIR_Coverage, 5605,
     /* 235089 */     GIR_EraseRootFromParent_Done,
     /* 235090 */   // Label 4461: @235090
     /* 235090 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(235141), // Rule ID 5606 //
     /* 235095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 235100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235128 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 235128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 235131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 235137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 235139 */     GIR_RootConstrainSelectedInstOperands,
     /* 235140 */     // GIR_Coverage, 5606,
     /* 235140 */     GIR_EraseRootFromParent_Done,
     /* 235141 */   // Label 4462: @235141
     /* 235141 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(235183), // Rule ID 2695 //
     /* 235146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1928:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 235173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235181 */     GIR_RootConstrainSelectedInstOperands,
     /* 235182 */     // GIR_Coverage, 2695,
     /* 235182 */     GIR_EraseRootFromParent_Done,
     /* 235183 */   // Label 4463: @235183
     /* 235183 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(235225), // Rule ID 2696 //
     /* 235188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1928:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235223 */     GIR_RootConstrainSelectedInstOperands,
     /* 235224 */     // GIR_Coverage, 2696,
     /* 235224 */     GIR_EraseRootFromParent_Done,
     /* 235225 */   // Label 4464: @235225
     /* 235225 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(235267), // Rule ID 2697 //
     /* 235230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1928:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235265 */     GIR_RootConstrainSelectedInstOperands,
     /* 235266 */     // GIR_Coverage, 2697,
     /* 235266 */     GIR_EraseRootFromParent_Done,
     /* 235267 */   // Label 4465: @235267
     /* 235267 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(235309), // Rule ID 2698 //
     /* 235272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1928:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235307 */     GIR_RootConstrainSelectedInstOperands,
     /* 235308 */     // GIR_Coverage, 2698,
     /* 235308 */     GIR_EraseRootFromParent_Done,
     /* 235309 */   // Label 4466: @235309
     /* 235309 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(235351), // Rule ID 2699 //
     /* 235314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235338 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1928:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235349 */     GIR_RootConstrainSelectedInstOperands,
     /* 235350 */     // GIR_Coverage, 2699,
     /* 235350 */     GIR_EraseRootFromParent_Done,
     /* 235351 */   // Label 4467: @235351
     /* 235351 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(235393), // Rule ID 2700 //
     /* 235356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235380 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1928:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235391 */     GIR_RootConstrainSelectedInstOperands,
     /* 235392 */     // GIR_Coverage, 2700,
     /* 235392 */     GIR_EraseRootFromParent_Done,
     /* 235393 */   // Label 4468: @235393
     /* 235393 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(235435), // Rule ID 2701 //
     /* 235398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235422 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1928:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235433 */     GIR_RootConstrainSelectedInstOperands,
     /* 235434 */     // GIR_Coverage, 2701,
     /* 235434 */     GIR_EraseRootFromParent_Done,
     /* 235435 */   // Label 4469: @235435
     /* 235435 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(235477), // Rule ID 2740 //
     /* 235440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 235451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 235457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 235460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1274:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 235464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235475 */     GIR_RootConstrainSelectedInstOperands,
     /* 235476 */     // GIR_Coverage, 2740,
     /* 235476 */     GIR_EraseRootFromParent_Done,
     /* 235477 */   // Label 4470: @235477
     /* 235477 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(235519), // Rule ID 2741 //
     /* 235482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 235493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 235499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 235502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1274:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 235506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235517 */     GIR_RootConstrainSelectedInstOperands,
     /* 235518 */     // GIR_Coverage, 2741,
     /* 235518 */     GIR_EraseRootFromParent_Done,
     /* 235519 */   // Label 4471: @235519
     /* 235519 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(235561), // Rule ID 2742 //
     /* 235524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 235535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 235544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1274:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 235548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235559 */     GIR_RootConstrainSelectedInstOperands,
     /* 235560 */     // GIR_Coverage, 2742,
     /* 235560 */     GIR_EraseRootFromParent_Done,
     /* 235561 */   // Label 4472: @235561
     /* 235561 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(235603), // Rule ID 2743 //
     /* 235566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 235577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 235586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235590 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1274:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 235590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235601 */     GIR_RootConstrainSelectedInstOperands,
     /* 235602 */     // GIR_Coverage, 2743,
     /* 235602 */     GIR_EraseRootFromParent_Done,
     /* 235603 */   // Label 4473: @235603
     /* 235603 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(235645), // Rule ID 2744 //
     /* 235608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 235619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 235622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 235625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 235628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1274:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 235632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235643 */     GIR_RootConstrainSelectedInstOperands,
     /* 235644 */     // GIR_Coverage, 2744,
     /* 235644 */     GIR_EraseRootFromParent_Done,
     /* 235645 */   // Label 4474: @235645
     /* 235645 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(235687), // Rule ID 2783 //
     /* 235650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 235677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235685 */     GIR_RootConstrainSelectedInstOperands,
     /* 235686 */     // GIR_Coverage, 2783,
     /* 235686 */     GIR_EraseRootFromParent_Done,
     /* 235687 */   // Label 4475: @235687
     /* 235687 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(235729), // Rule ID 2785 //
     /* 235692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235716 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 235719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235727 */     GIR_RootConstrainSelectedInstOperands,
     /* 235728 */     // GIR_Coverage, 2785,
     /* 235728 */     GIR_EraseRootFromParent_Done,
     /* 235729 */   // Label 4476: @235729
     /* 235729 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(235771), // Rule ID 2787 //
     /* 235734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235758 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 235761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235769 */     GIR_RootConstrainSelectedInstOperands,
     /* 235770 */     // GIR_Coverage, 2787,
     /* 235770 */     GIR_EraseRootFromParent_Done,
     /* 235771 */   // Label 4477: @235771
     /* 235771 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(235813), // Rule ID 2789 //
     /* 235776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235800 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1547:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 235803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235811 */     GIR_RootConstrainSelectedInstOperands,
     /* 235812 */     // GIR_Coverage, 2789,
     /* 235812 */     GIR_EraseRootFromParent_Done,
     /* 235813 */   // Label 4478: @235813
     /* 235813 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(235855), // Rule ID 2790 //
     /* 235818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235842 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1547:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 235845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235853 */     GIR_RootConstrainSelectedInstOperands,
     /* 235854 */     // GIR_Coverage, 2790,
     /* 235854 */     GIR_EraseRootFromParent_Done,
     /* 235855 */   // Label 4479: @235855
     /* 235855 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(235897), // Rule ID 2791 //
     /* 235860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1547:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 235887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235895 */     GIR_RootConstrainSelectedInstOperands,
     /* 235896 */     // GIR_Coverage, 2791,
     /* 235896 */     GIR_EraseRootFromParent_Done,
     /* 235897 */   // Label 4480: @235897
     /* 235897 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(235939), // Rule ID 2860 //
     /* 235902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 235910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235926 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 235929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235937 */     GIR_RootConstrainSelectedInstOperands,
     /* 235938 */     // GIR_Coverage, 2860,
     /* 235938 */     GIR_EraseRootFromParent_Done,
     /* 235939 */   // Label 4481: @235939
     /* 235939 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(235981), // Rule ID 2861 //
     /* 235944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 235952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235968 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 235971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235979 */     GIR_RootConstrainSelectedInstOperands,
     /* 235980 */     // GIR_Coverage, 2861,
     /* 235980 */     GIR_EraseRootFromParent_Done,
     /* 235981 */   // Label 4482: @235981
     /* 235981 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(236023), // Rule ID 2862 //
     /* 235986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 235994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1405:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 236013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236021 */     GIR_RootConstrainSelectedInstOperands,
     /* 236022 */     // GIR_Coverage, 2862,
     /* 236022 */     GIR_EraseRootFromParent_Done,
     /* 236023 */   // Label 4483: @236023
     /* 236023 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(236065), // Rule ID 2863 //
     /* 236028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 236036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236052 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1406:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 236055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236063 */     GIR_RootConstrainSelectedInstOperands,
     /* 236064 */     // GIR_Coverage, 2863,
     /* 236064 */     GIR_EraseRootFromParent_Done,
     /* 236065 */   // Label 4484: @236065
     /* 236065 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(236107), // Rule ID 2864 //
     /* 236070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 236078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1412:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 236097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236105 */     GIR_RootConstrainSelectedInstOperands,
     /* 236106 */     // GIR_Coverage, 2864,
     /* 236106 */     GIR_EraseRootFromParent_Done,
     /* 236107 */   // Label 4485: @236107
     /* 236107 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(236149), // Rule ID 2865 //
     /* 236112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236136 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 236139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236147 */     GIR_RootConstrainSelectedInstOperands,
     /* 236148 */     // GIR_Coverage, 2865,
     /* 236148 */     GIR_EraseRootFromParent_Done,
     /* 236149 */   // Label 4486: @236149
     /* 236149 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(236191), // Rule ID 2866 //
     /* 236154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236178 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 236181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236189 */     GIR_RootConstrainSelectedInstOperands,
     /* 236190 */     // GIR_Coverage, 2866,
     /* 236190 */     GIR_EraseRootFromParent_Done,
     /* 236191 */   // Label 4487: @236191
     /* 236191 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(236233), // Rule ID 2867 //
     /* 236196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236220 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 236223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236231 */     GIR_RootConstrainSelectedInstOperands,
     /* 236232 */     // GIR_Coverage, 2867,
     /* 236232 */     GIR_EraseRootFromParent_Done,
     /* 236233 */   // Label 4488: @236233
     /* 236233 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(236275), // Rule ID 2878 //
     /* 236238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 236246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236262 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1398:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 236265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236273 */     GIR_RootConstrainSelectedInstOperands,
     /* 236274 */     // GIR_Coverage, 2878,
     /* 236274 */     GIR_EraseRootFromParent_Done,
     /* 236275 */   // Label 4489: @236275
     /* 236275 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(236317), // Rule ID 2880 //
     /* 236280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 236288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1396:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 236307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236315 */     GIR_RootConstrainSelectedInstOperands,
     /* 236316 */     // GIR_Coverage, 2880,
     /* 236316 */     GIR_EraseRootFromParent_Done,
     /* 236317 */   // Label 4490: @236317
     /* 236317 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(236359), // Rule ID 2888 //
     /* 236322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1433:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 236349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236357 */     GIR_RootConstrainSelectedInstOperands,
     /* 236358 */     // GIR_Coverage, 2888,
     /* 236358 */     GIR_EraseRootFromParent_Done,
     /* 236359 */   // Label 4491: @236359
     /* 236359 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(236401), // Rule ID 2889 //
     /* 236364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1433:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 236391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236399 */     GIR_RootConstrainSelectedInstOperands,
     /* 236400 */     // GIR_Coverage, 2889,
     /* 236400 */     GIR_EraseRootFromParent_Done,
     /* 236401 */   // Label 4492: @236401
     /* 236401 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(236443), // Rule ID 2890 //
     /* 236406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1433:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 236433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236441 */     GIR_RootConstrainSelectedInstOperands,
     /* 236442 */     // GIR_Coverage, 2890,
     /* 236442 */     GIR_EraseRootFromParent_Done,
     /* 236443 */   // Label 4493: @236443
     /* 236443 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(236485), // Rule ID 2894 //
     /* 236448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 236456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 236475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236483 */     GIR_RootConstrainSelectedInstOperands,
     /* 236484 */     // GIR_Coverage, 2894,
     /* 236484 */     GIR_EraseRootFromParent_Done,
     /* 236485 */   // Label 4494: @236485
     /* 236485 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(236527), // Rule ID 2939 //
     /* 236490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1716:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 236517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236525 */     GIR_RootConstrainSelectedInstOperands,
     /* 236526 */     // GIR_Coverage, 2939,
     /* 236526 */     GIR_EraseRootFromParent_Done,
     /* 236527 */   // Label 4495: @236527
     /* 236527 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(236569), // Rule ID 2940 //
     /* 236532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1716:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 236559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236567 */     GIR_RootConstrainSelectedInstOperands,
     /* 236568 */     // GIR_Coverage, 2940,
     /* 236568 */     GIR_EraseRootFromParent_Done,
     /* 236569 */   // Label 4496: @236569
     /* 236569 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(236611), // Rule ID 2969 //
     /* 236574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236598 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1832:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 236601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236609 */     GIR_RootConstrainSelectedInstOperands,
     /* 236610 */     // GIR_Coverage, 2969,
     /* 236610 */     GIR_EraseRootFromParent_Done,
     /* 236611 */   // Label 4497: @236611
     /* 236611 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(236653), // Rule ID 2970 //
     /* 236616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 236643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236651 */     GIR_RootConstrainSelectedInstOperands,
     /* 236652 */     // GIR_Coverage, 2970,
     /* 236652 */     GIR_EraseRootFromParent_Done,
     /* 236653 */   // Label 4498: @236653
     /* 236653 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(236695), // Rule ID 2971 //
     /* 236658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 236685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236693 */     GIR_RootConstrainSelectedInstOperands,
     /* 236694 */     // GIR_Coverage, 2971,
     /* 236694 */     GIR_EraseRootFromParent_Done,
     /* 236695 */   // Label 4499: @236695
     /* 236695 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(236737), // Rule ID 2972 //
     /* 236700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1832:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 236727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236735 */     GIR_RootConstrainSelectedInstOperands,
     /* 236736 */     // GIR_Coverage, 2972,
     /* 236736 */     GIR_EraseRootFromParent_Done,
     /* 236737 */   // Label 4500: @236737
     /* 236737 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(236779), // Rule ID 2973 //
     /* 236742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236766 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 236769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236777 */     GIR_RootConstrainSelectedInstOperands,
     /* 236778 */     // GIR_Coverage, 2973,
     /* 236778 */     GIR_EraseRootFromParent_Done,
     /* 236779 */   // Label 4501: @236779
     /* 236779 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(236821), // Rule ID 2974 //
     /* 236784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 236811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236819 */     GIR_RootConstrainSelectedInstOperands,
     /* 236820 */     // GIR_Coverage, 2974,
     /* 236820 */     GIR_EraseRootFromParent_Done,
     /* 236821 */   // Label 4502: @236821
     /* 236821 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(236863), // Rule ID 2975 //
     /* 236826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 236853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236861 */     GIR_RootConstrainSelectedInstOperands,
     /* 236862 */     // GIR_Coverage, 2975,
     /* 236862 */     GIR_EraseRootFromParent_Done,
     /* 236863 */   // Label 4503: @236863
     /* 236863 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(236905), // Rule ID 3005 //
     /* 236868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 236895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236903 */     GIR_RootConstrainSelectedInstOperands,
     /* 236904 */     // GIR_Coverage, 3005,
     /* 236904 */     GIR_EraseRootFromParent_Done,
     /* 236905 */   // Label 4504: @236905
     /* 236905 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(236947), // Rule ID 3007 //
     /* 236910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 236937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236945 */     GIR_RootConstrainSelectedInstOperands,
     /* 236946 */     // GIR_Coverage, 3007,
     /* 236946 */     GIR_EraseRootFromParent_Done,
     /* 236947 */   // Label 4505: @236947
     /* 236947 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(236989), // Rule ID 3009 //
     /* 236952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 236979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236987 */     GIR_RootConstrainSelectedInstOperands,
     /* 236988 */     // GIR_Coverage, 3009,
     /* 236988 */     GIR_EraseRootFromParent_Done,
     /* 236989 */   // Label 4506: @236989
     /* 236989 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(237031), // Rule ID 3011 //
     /* 236994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 237002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 237021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237029 */     GIR_RootConstrainSelectedInstOperands,
     /* 237030 */     // GIR_Coverage, 3011,
     /* 237030 */     GIR_EraseRootFromParent_Done,
     /* 237031 */   // Label 4507: @237031
     /* 237031 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(237073), // Rule ID 3013 //
     /* 237036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1697:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 237063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237071 */     GIR_RootConstrainSelectedInstOperands,
     /* 237072 */     // GIR_Coverage, 3013,
     /* 237072 */     GIR_EraseRootFromParent_Done,
     /* 237073 */   // Label 4508: @237073
     /* 237073 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(237115), // Rule ID 3014 //
     /* 237078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 237105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237113 */     GIR_RootConstrainSelectedInstOperands,
     /* 237114 */     // GIR_Coverage, 3014,
     /* 237114 */     GIR_EraseRootFromParent_Done,
     /* 237115 */   // Label 4509: @237115
     /* 237115 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(237157), // Rule ID 3015 //
     /* 237120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 237147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237155 */     GIR_RootConstrainSelectedInstOperands,
     /* 237156 */     // GIR_Coverage, 3015,
     /* 237156 */     GIR_EraseRootFromParent_Done,
     /* 237157 */   // Label 4510: @237157
     /* 237157 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(237199), // Rule ID 3016 //
     /* 237162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 237170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 237189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237197 */     GIR_RootConstrainSelectedInstOperands,
     /* 237198 */     // GIR_Coverage, 3016,
     /* 237198 */     GIR_EraseRootFromParent_Done,
     /* 237199 */   // Label 4511: @237199
     /* 237199 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(237241), // Rule ID 3017 //
     /* 237204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 237231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237239 */     GIR_RootConstrainSelectedInstOperands,
     /* 237240 */     // GIR_Coverage, 3017,
     /* 237240 */     GIR_EraseRootFromParent_Done,
     /* 237241 */   // Label 4512: @237241
     /* 237241 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(237283), // Rule ID 3018 //
     /* 237246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 237263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 237273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237281 */     GIR_RootConstrainSelectedInstOperands,
     /* 237282 */     // GIR_Coverage, 3018,
     /* 237282 */     GIR_EraseRootFromParent_Done,
     /* 237283 */   // Label 4513: @237283
     /* 237283 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(237325), // Rule ID 3019 //
     /* 237288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 237315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237323 */     GIR_RootConstrainSelectedInstOperands,
     /* 237324 */     // GIR_Coverage, 3019,
     /* 237324 */     GIR_EraseRootFromParent_Done,
     /* 237325 */   // Label 4514: @237325
     /* 237325 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(237367), // Rule ID 3020 //
     /* 237330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 237347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 237357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237365 */     GIR_RootConstrainSelectedInstOperands,
     /* 237366 */     // GIR_Coverage, 3020,
     /* 237366 */     GIR_EraseRootFromParent_Done,
     /* 237367 */   // Label 4515: @237367
     /* 237367 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(237409), // Rule ID 3037 //
     /* 237372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1362:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 237399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237407 */     GIR_RootConstrainSelectedInstOperands,
     /* 237408 */     // GIR_Coverage, 3037,
     /* 237408 */     GIR_EraseRootFromParent_Done,
     /* 237409 */   // Label 4516: @237409
     /* 237409 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(237451), // Rule ID 3038 //
     /* 237414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1362:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 237441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237449 */     GIR_RootConstrainSelectedInstOperands,
     /* 237450 */     // GIR_Coverage, 3038,
     /* 237450 */     GIR_EraseRootFromParent_Done,
     /* 237451 */   // Label 4517: @237451
     /* 237451 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(237493), // Rule ID 3039 //
     /* 237456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1362:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 237483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237491 */     GIR_RootConstrainSelectedInstOperands,
     /* 237492 */     // GIR_Coverage, 3039,
     /* 237492 */     GIR_EraseRootFromParent_Done,
     /* 237493 */   // Label 4518: @237493
     /* 237493 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(237535), // Rule ID 3040 //
     /* 237498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1362:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 237525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237533 */     GIR_RootConstrainSelectedInstOperands,
     /* 237534 */     // GIR_Coverage, 3040,
     /* 237534 */     GIR_EraseRootFromParent_Done,
     /* 237535 */   // Label 4519: @237535
     /* 237535 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(237577), // Rule ID 3064 //
     /* 237540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 237567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237575 */     GIR_RootConstrainSelectedInstOperands,
     /* 237576 */     // GIR_Coverage, 3064,
     /* 237576 */     GIR_EraseRootFromParent_Done,
     /* 237577 */   // Label 4520: @237577
     /* 237577 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(237619), // Rule ID 3066 //
     /* 237582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237606 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 237609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237617 */     GIR_RootConstrainSelectedInstOperands,
     /* 237618 */     // GIR_Coverage, 3066,
     /* 237618 */     GIR_EraseRootFromParent_Done,
     /* 237619 */   // Label 4521: @237619
     /* 237619 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(237661), // Rule ID 3068 //
     /* 237624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 237651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237659 */     GIR_RootConstrainSelectedInstOperands,
     /* 237660 */     // GIR_Coverage, 3068,
     /* 237660 */     GIR_EraseRootFromParent_Done,
     /* 237661 */   // Label 4522: @237661
     /* 237661 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(237703), // Rule ID 3070 //
     /* 237666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 237693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237701 */     GIR_RootConstrainSelectedInstOperands,
     /* 237702 */     // GIR_Coverage, 3070,
     /* 237702 */     GIR_EraseRootFromParent_Done,
     /* 237703 */   // Label 4523: @237703
     /* 237703 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(237745), // Rule ID 3072 //
     /* 237708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 237735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237743 */     GIR_RootConstrainSelectedInstOperands,
     /* 237744 */     // GIR_Coverage, 3072,
     /* 237744 */     GIR_EraseRootFromParent_Done,
     /* 237745 */   // Label 4524: @237745
     /* 237745 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(237787), // Rule ID 3073 //
     /* 237750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 237777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237785 */     GIR_RootConstrainSelectedInstOperands,
     /* 237786 */     // GIR_Coverage, 3073,
     /* 237786 */     GIR_EraseRootFromParent_Done,
     /* 237787 */   // Label 4525: @237787
     /* 237787 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(237829), // Rule ID 3074 //
     /* 237792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 237819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237827 */     GIR_RootConstrainSelectedInstOperands,
     /* 237828 */     // GIR_Coverage, 3074,
     /* 237828 */     GIR_EraseRootFromParent_Done,
     /* 237829 */   // Label 4526: @237829
     /* 237829 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(237871), // Rule ID 3075 //
     /* 237834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 237842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 237861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237869 */     GIR_RootConstrainSelectedInstOperands,
     /* 237870 */     // GIR_Coverage, 3075,
     /* 237870 */     GIR_EraseRootFromParent_Done,
     /* 237871 */   // Label 4527: @237871
     /* 237871 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(237913), // Rule ID 3076 //
     /* 237876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 237884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 237903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237911 */     GIR_RootConstrainSelectedInstOperands,
     /* 237912 */     // GIR_Coverage, 3076,
     /* 237912 */     GIR_EraseRootFromParent_Done,
     /* 237913 */   // Label 4528: @237913
     /* 237913 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(237955), // Rule ID 3086 //
     /* 237918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 237926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237942 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 237945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237953 */     GIR_RootConstrainSelectedInstOperands,
     /* 237954 */     // GIR_Coverage, 3086,
     /* 237954 */     GIR_EraseRootFromParent_Done,
     /* 237955 */   // Label 4529: @237955
     /* 237955 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(237997), // Rule ID 3087 //
     /* 237960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 237968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1261:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 237987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237995 */     GIR_RootConstrainSelectedInstOperands,
     /* 237996 */     // GIR_Coverage, 3087,
     /* 237996 */     GIR_EraseRootFromParent_Done,
     /* 237997 */   // Label 4530: @237997
     /* 237997 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(238039), // Rule ID 3088 //
     /* 238002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 238010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1261:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 238029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238037 */     GIR_RootConstrainSelectedInstOperands,
     /* 238038 */     // GIR_Coverage, 3088,
     /* 238038 */     GIR_EraseRootFromParent_Done,
     /* 238039 */   // Label 4531: @238039
     /* 238039 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(238081), // Rule ID 3105 //
     /* 238044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 238061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1320:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 238068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 238071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238079 */     GIR_RootConstrainSelectedInstOperands,
     /* 238080 */     // GIR_Coverage, 3105,
     /* 238080 */     GIR_EraseRootFromParent_Done,
     /* 238081 */   // Label 4532: @238081
     /* 238081 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(238123), // Rule ID 3106 //
     /* 238086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 238103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1320:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 238110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 238113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238121 */     GIR_RootConstrainSelectedInstOperands,
     /* 238122 */     // GIR_Coverage, 3106,
     /* 238122 */     GIR_EraseRootFromParent_Done,
     /* 238123 */   // Label 4533: @238123
     /* 238123 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(238165), // Rule ID 3107 //
     /* 238128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1320:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 238152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 238155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238163 */     GIR_RootConstrainSelectedInstOperands,
     /* 238164 */     // GIR_Coverage, 3107,
     /* 238164 */     GIR_EraseRootFromParent_Done,
     /* 238165 */   // Label 4534: @238165
     /* 238165 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(238207), // Rule ID 3108 //
     /* 238170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238194 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 238194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 238197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238205 */     GIR_RootConstrainSelectedInstOperands,
     /* 238206 */     // GIR_Coverage, 3108,
     /* 238206 */     GIR_EraseRootFromParent_Done,
     /* 238207 */   // Label 4535: @238207
     /* 238207 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(238249), // Rule ID 3143 //
     /* 238212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1361:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238247 */     GIR_RootConstrainSelectedInstOperands,
     /* 238248 */     // GIR_Coverage, 3143,
     /* 238248 */     GIR_EraseRootFromParent_Done,
     /* 238249 */   // Label 4536: @238249
     /* 238249 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(238291), // Rule ID 3145 //
     /* 238254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1361:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238289 */     GIR_RootConstrainSelectedInstOperands,
     /* 238290 */     // GIR_Coverage, 3145,
     /* 238290 */     GIR_EraseRootFromParent_Done,
     /* 238291 */   // Label 4537: @238291
     /* 238291 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(238333), // Rule ID 3147 //
     /* 238296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1361:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238331 */     GIR_RootConstrainSelectedInstOperands,
     /* 238332 */     // GIR_Coverage, 3147,
     /* 238332 */     GIR_EraseRootFromParent_Done,
     /* 238333 */   // Label 4538: @238333
     /* 238333 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(238375), // Rule ID 3149 //
     /* 238338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238362 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1361:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238373 */     GIR_RootConstrainSelectedInstOperands,
     /* 238374 */     // GIR_Coverage, 3149,
     /* 238374 */     GIR_EraseRootFromParent_Done,
     /* 238375 */   // Label 4539: @238375
     /* 238375 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(238420), // Rule ID 3188 //
     /* 238380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 238407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238418 */     GIR_RootConstrainSelectedInstOperands,
     /* 238419 */     // GIR_Coverage, 3188,
     /* 238419 */     GIR_EraseRootFromParent_Done,
     /* 238420 */   // Label 4540: @238420
     /* 238420 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(238465), // Rule ID 3189 //
     /* 238425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238449 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 238452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238463 */     GIR_RootConstrainSelectedInstOperands,
     /* 238464 */     // GIR_Coverage, 3189,
     /* 238464 */     GIR_EraseRootFromParent_Done,
     /* 238465 */   // Label 4541: @238465
     /* 238465 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(238510), // Rule ID 3190 //
     /* 238470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 238497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238508 */     GIR_RootConstrainSelectedInstOperands,
     /* 238509 */     // GIR_Coverage, 3190,
     /* 238509 */     GIR_EraseRootFromParent_Done,
     /* 238510 */   // Label 4542: @238510
     /* 238510 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(238555), // Rule ID 3191 //
     /* 238515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238539 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 238542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238553 */     GIR_RootConstrainSelectedInstOperands,
     /* 238554 */     // GIR_Coverage, 3191,
     /* 238554 */     GIR_EraseRootFromParent_Done,
     /* 238555 */   // Label 4543: @238555
     /* 238555 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(238600), // Rule ID 3192 //
     /* 238560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 238587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238598 */     GIR_RootConstrainSelectedInstOperands,
     /* 238599 */     // GIR_Coverage, 3192,
     /* 238599 */     GIR_EraseRootFromParent_Done,
     /* 238600 */   // Label 4544: @238600
     /* 238600 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(238645), // Rule ID 3193 //
     /* 238605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238629 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 238632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238643 */     GIR_RootConstrainSelectedInstOperands,
     /* 238644 */     // GIR_Coverage, 3193,
     /* 238644 */     GIR_EraseRootFromParent_Done,
     /* 238645 */   // Label 4545: @238645
     /* 238645 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(238687), // Rule ID 3248 //
     /* 238650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238674 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 238677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238685 */     GIR_RootConstrainSelectedInstOperands,
     /* 238686 */     // GIR_Coverage, 3248,
     /* 238686 */     GIR_EraseRootFromParent_Done,
     /* 238687 */   // Label 4546: @238687
     /* 238687 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(238729), // Rule ID 3249 //
     /* 238692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 238719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238727 */     GIR_RootConstrainSelectedInstOperands,
     /* 238728 */     // GIR_Coverage, 3249,
     /* 238728 */     GIR_EraseRootFromParent_Done,
     /* 238729 */   // Label 4547: @238729
     /* 238729 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(238771), // Rule ID 3250 //
     /* 238734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 238745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 238761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238769 */     GIR_RootConstrainSelectedInstOperands,
     /* 238770 */     // GIR_Coverage, 3250,
     /* 238770 */     GIR_EraseRootFromParent_Done,
     /* 238771 */   // Label 4548: @238771
     /* 238771 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(238813), // Rule ID 3302 //
     /* 238776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1277:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 238803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238811 */     GIR_RootConstrainSelectedInstOperands,
     /* 238812 */     // GIR_Coverage, 3302,
     /* 238812 */     GIR_EraseRootFromParent_Done,
     /* 238813 */   // Label 4549: @238813
     /* 238813 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(238855), // Rule ID 3303 //
     /* 238818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1277:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 238845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238853 */     GIR_RootConstrainSelectedInstOperands,
     /* 238854 */     // GIR_Coverage, 3303,
     /* 238854 */     GIR_EraseRootFromParent_Done,
     /* 238855 */   // Label 4550: @238855
     /* 238855 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(238897), // Rule ID 3304 //
     /* 238860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1277:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 238887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238895 */     GIR_RootConstrainSelectedInstOperands,
     /* 238896 */     // GIR_Coverage, 3304,
     /* 238896 */     GIR_EraseRootFromParent_Done,
     /* 238897 */   // Label 4551: @238897
     /* 238897 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(238939), // Rule ID 3305 //
     /* 238902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1277:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 238929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238937 */     GIR_RootConstrainSelectedInstOperands,
     /* 238938 */     // GIR_Coverage, 3305,
     /* 238938 */     GIR_EraseRootFromParent_Done,
     /* 238939 */   // Label 4552: @238939
     /* 238939 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(238981), // Rule ID 3314 //
     /* 238944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 238952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1279:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 238971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238979 */     GIR_RootConstrainSelectedInstOperands,
     /* 238980 */     // GIR_Coverage, 3314,
     /* 238980 */     GIR_EraseRootFromParent_Done,
     /* 238981 */   // Label 4553: @238981
     /* 238981 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(239023), // Rule ID 3315 //
     /* 238986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 238994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1279:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 239013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239021 */     GIR_RootConstrainSelectedInstOperands,
     /* 239022 */     // GIR_Coverage, 3315,
     /* 239022 */     GIR_EraseRootFromParent_Done,
     /* 239023 */   // Label 4554: @239023
     /* 239023 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(239065), // Rule ID 3316 //
     /* 239028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 239036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1279:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 239055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239063 */     GIR_RootConstrainSelectedInstOperands,
     /* 239064 */     // GIR_Coverage, 3316,
     /* 239064 */     GIR_EraseRootFromParent_Done,
     /* 239065 */   // Label 4555: @239065
     /* 239065 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(239107), // Rule ID 3355 //
     /* 239070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 239097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239105 */     GIR_RootConstrainSelectedInstOperands,
     /* 239106 */     // GIR_Coverage, 3355,
     /* 239106 */     GIR_EraseRootFromParent_Done,
     /* 239107 */   // Label 4556: @239107
     /* 239107 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(239149), // Rule ID 3356 //
     /* 239112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239147 */     GIR_RootConstrainSelectedInstOperands,
     /* 239148 */     // GIR_Coverage, 3356,
     /* 239148 */     GIR_EraseRootFromParent_Done,
     /* 239149 */   // Label 4557: @239149
     /* 239149 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(239191), // Rule ID 3357 //
     /* 239154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239189 */     GIR_RootConstrainSelectedInstOperands,
     /* 239190 */     // GIR_Coverage, 3357,
     /* 239190 */     GIR_EraseRootFromParent_Done,
     /* 239191 */   // Label 4558: @239191
     /* 239191 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(239233), // Rule ID 3358 //
     /* 239196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239231 */     GIR_RootConstrainSelectedInstOperands,
     /* 239232 */     // GIR_Coverage, 3358,
     /* 239232 */     GIR_EraseRootFromParent_Done,
     /* 239233 */   // Label 4559: @239233
     /* 239233 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(239275), // Rule ID 3359 //
     /* 239238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239262 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239273 */     GIR_RootConstrainSelectedInstOperands,
     /* 239274 */     // GIR_Coverage, 3359,
     /* 239274 */     GIR_EraseRootFromParent_Done,
     /* 239275 */   // Label 4560: @239275
     /* 239275 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(239317), // Rule ID 3360 //
     /* 239280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239315 */     GIR_RootConstrainSelectedInstOperands,
     /* 239316 */     // GIR_Coverage, 3360,
     /* 239316 */     GIR_EraseRootFromParent_Done,
     /* 239317 */   // Label 4561: @239317
     /* 239317 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(239359), // Rule ID 3361 //
     /* 239322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239346 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1316:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239357 */     GIR_RootConstrainSelectedInstOperands,
     /* 239358 */     // GIR_Coverage, 3361,
     /* 239358 */     GIR_EraseRootFromParent_Done,
     /* 239359 */   // Label 4562: @239359
     /* 239359 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(239401), // Rule ID 3447 //
     /* 239364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 239372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239388 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 239391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239399 */     GIR_RootConstrainSelectedInstOperands,
     /* 239400 */     // GIR_Coverage, 3447,
     /* 239400 */     GIR_EraseRootFromParent_Done,
     /* 239401 */   // Label 4563: @239401
     /* 239401 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(239443), // Rule ID 3448 //
     /* 239406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 239414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 239433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 239435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239441 */     GIR_RootConstrainSelectedInstOperands,
     /* 239442 */     // GIR_Coverage, 3448,
     /* 239442 */     GIR_EraseRootFromParent_Done,
     /* 239443 */   // Label 4564: @239443
     /* 239443 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(239485), // Rule ID 3449 //
     /* 239448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 239456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239472 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 239475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239483 */     GIR_RootConstrainSelectedInstOperands,
     /* 239484 */     // GIR_Coverage, 3449,
     /* 239484 */     GIR_EraseRootFromParent_Done,
     /* 239485 */   // Label 4565: @239485
     /* 239485 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(239530), // Rule ID 3451 //
     /* 239490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1610:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 239517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239528 */     GIR_RootConstrainSelectedInstOperands,
     /* 239529 */     // GIR_Coverage, 3451,
     /* 239529 */     GIR_EraseRootFromParent_Done,
     /* 239530 */   // Label 4566: @239530
     /* 239530 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(239575), // Rule ID 3452 //
     /* 239535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 239546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239559 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1610:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 239562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239573 */     GIR_RootConstrainSelectedInstOperands,
     /* 239574 */     // GIR_Coverage, 3452,
     /* 239574 */     GIR_EraseRootFromParent_Done,
     /* 239575 */   // Label 4567: @239575
     /* 239575 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(239617), // Rule ID 3453 //
     /* 239580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 239588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1555:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 239607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239615 */     GIR_RootConstrainSelectedInstOperands,
     /* 239616 */     // GIR_Coverage, 3453,
     /* 239616 */     GIR_EraseRootFromParent_Done,
     /* 239617 */   // Label 4568: @239617
     /* 239617 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(239659), // Rule ID 3454 //
     /* 239622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 239630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1555:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 239649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239657 */     GIR_RootConstrainSelectedInstOperands,
     /* 239658 */     // GIR_Coverage, 3454,
     /* 239658 */     GIR_EraseRootFromParent_Done,
     /* 239659 */   // Label 4569: @239659
     /* 239659 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(239701), // Rule ID 3458 //
     /* 239664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 239667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 239672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 239691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239699 */     GIR_RootConstrainSelectedInstOperands,
     /* 239700 */     // GIR_Coverage, 3458,
     /* 239700 */     GIR_EraseRootFromParent_Done,
     /* 239701 */   // Label 4570: @239701
     /* 239701 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(239743), // Rule ID 3497 //
     /* 239706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 239733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239741 */     GIR_RootConstrainSelectedInstOperands,
     /* 239742 */     // GIR_Coverage, 3497,
     /* 239742 */     GIR_EraseRootFromParent_Done,
     /* 239743 */   // Label 4571: @239743
     /* 239743 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(239785), // Rule ID 3499 //
     /* 239748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 239775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239783 */     GIR_RootConstrainSelectedInstOperands,
     /* 239784 */     // GIR_Coverage, 3499,
     /* 239784 */     GIR_EraseRootFromParent_Done,
     /* 239785 */   // Label 4572: @239785
     /* 239785 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(239827), // Rule ID 3501 //
     /* 239790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239814 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1384:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 239817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239825 */     GIR_RootConstrainSelectedInstOperands,
     /* 239826 */     // GIR_Coverage, 3501,
     /* 239826 */     GIR_EraseRootFromParent_Done,
     /* 239827 */   // Label 4573: @239827
     /* 239827 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(239869), // Rule ID 3503 //
     /* 239832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 239840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 239859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239867 */     GIR_RootConstrainSelectedInstOperands,
     /* 239868 */     // GIR_Coverage, 3503,
     /* 239868 */     GIR_EraseRootFromParent_Done,
     /* 239869 */   // Label 4574: @239869
     /* 239869 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(239911), // Rule ID 3630 //
     /* 239874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239898 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1706:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 239901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239909 */     GIR_RootConstrainSelectedInstOperands,
     /* 239910 */     // GIR_Coverage, 3630,
     /* 239910 */     GIR_EraseRootFromParent_Done,
     /* 239911 */   // Label 4575: @239911
     /* 239911 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(239953), // Rule ID 3632 //
     /* 239916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1706:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 239943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239951 */     GIR_RootConstrainSelectedInstOperands,
     /* 239952 */     // GIR_Coverage, 3632,
     /* 239952 */     GIR_EraseRootFromParent_Done,
     /* 239953 */   // Label 4576: @239953
     /* 239953 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(239995), // Rule ID 3634 //
     /* 239958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 239985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239993 */     GIR_RootConstrainSelectedInstOperands,
     /* 239994 */     // GIR_Coverage, 3634,
     /* 239994 */     GIR_EraseRootFromParent_Done,
     /* 239995 */   // Label 4577: @239995
     /* 239995 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(240037), // Rule ID 3636 //
     /* 240000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 240008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 240027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240035 */     GIR_RootConstrainSelectedInstOperands,
     /* 240036 */     // GIR_Coverage, 3636,
     /* 240036 */     GIR_EraseRootFromParent_Done,
     /* 240037 */   // Label 4578: @240037
     /* 240037 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(240079), // Rule ID 7551 //
     /* 240042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1915:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 240069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240077 */     GIR_RootConstrainSelectedInstOperands,
     /* 240078 */     // GIR_Coverage, 7551,
     /* 240078 */     GIR_EraseRootFromParent_Done,
     /* 240079 */   // Label 4579: @240079
     /* 240079 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(240121), // Rule ID 7553 //
     /* 240084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1915:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 240111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240119 */     GIR_RootConstrainSelectedInstOperands,
     /* 240120 */     // GIR_Coverage, 7553,
     /* 240120 */     GIR_EraseRootFromParent_Done,
     /* 240121 */   // Label 4580: @240121
     /* 240121 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(240163), // Rule ID 7555 //
     /* 240126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1915:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 240153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240161 */     GIR_RootConstrainSelectedInstOperands,
     /* 240162 */     // GIR_Coverage, 7555,
     /* 240162 */     GIR_EraseRootFromParent_Done,
     /* 240163 */   // Label 4581: @240163
     /* 240163 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(240205), // Rule ID 7557 //
     /* 240168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1915:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 240195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240203 */     GIR_RootConstrainSelectedInstOperands,
     /* 240204 */     // GIR_Coverage, 7557,
     /* 240204 */     GIR_EraseRootFromParent_Done,
     /* 240205 */   // Label 4582: @240205
     /* 240205 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(240247), // Rule ID 7575 //
     /* 240210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 240237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240245 */     GIR_RootConstrainSelectedInstOperands,
     /* 240246 */     // GIR_Coverage, 7575,
     /* 240246 */     GIR_EraseRootFromParent_Done,
     /* 240247 */   // Label 4583: @240247
     /* 240247 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(240289), // Rule ID 7576 //
     /* 240252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 240279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240287 */     GIR_RootConstrainSelectedInstOperands,
     /* 240288 */     // GIR_Coverage, 7576,
     /* 240288 */     GIR_EraseRootFromParent_Done,
     /* 240289 */   // Label 4584: @240289
     /* 240289 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(240331), // Rule ID 7577 //
     /* 240294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 240321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240329 */     GIR_RootConstrainSelectedInstOperands,
     /* 240330 */     // GIR_Coverage, 7577,
     /* 240330 */     GIR_EraseRootFromParent_Done,
     /* 240331 */   // Label 4585: @240331
     /* 240331 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(240373), // Rule ID 7578 //
     /* 240336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 240363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240371 */     GIR_RootConstrainSelectedInstOperands,
     /* 240372 */     // GIR_Coverage, 7578,
     /* 240372 */     GIR_EraseRootFromParent_Done,
     /* 240373 */   // Label 4586: @240373
     /* 240373 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(240415), // Rule ID 7691 //
     /* 240378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1762:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 240405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240413 */     GIR_RootConstrainSelectedInstOperands,
     /* 240414 */     // GIR_Coverage, 7691,
     /* 240414 */     GIR_EraseRootFromParent_Done,
     /* 240415 */   // Label 4587: @240415
     /* 240415 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(240457), // Rule ID 7692 //
     /* 240420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1762:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 240447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240455 */     GIR_RootConstrainSelectedInstOperands,
     /* 240456 */     // GIR_Coverage, 7692,
     /* 240456 */     GIR_EraseRootFromParent_Done,
     /* 240457 */   // Label 4588: @240457
     /* 240457 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(240499), // Rule ID 7693 //
     /* 240462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1762:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 240489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240497 */     GIR_RootConstrainSelectedInstOperands,
     /* 240498 */     // GIR_Coverage, 7693,
     /* 240498 */     GIR_EraseRootFromParent_Done,
     /* 240499 */   // Label 4589: @240499
     /* 240499 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(240541), // Rule ID 7694 //
     /* 240504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1762:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 240531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240539 */     GIR_RootConstrainSelectedInstOperands,
     /* 240540 */     // GIR_Coverage, 7694,
     /* 240540 */     GIR_EraseRootFromParent_Done,
     /* 240541 */   // Label 4590: @240541
     /* 240541 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(240583), // Rule ID 7695 //
     /* 240546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2000:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 240573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240581 */     GIR_RootConstrainSelectedInstOperands,
     /* 240582 */     // GIR_Coverage, 7695,
     /* 240582 */     GIR_EraseRootFromParent_Done,
     /* 240583 */   // Label 4591: @240583
     /* 240583 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(240625), // Rule ID 7696 //
     /* 240588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240612 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2000:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 240615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240623 */     GIR_RootConstrainSelectedInstOperands,
     /* 240624 */     // GIR_Coverage, 7696,
     /* 240624 */     GIR_EraseRootFromParent_Done,
     /* 240625 */   // Label 4592: @240625
     /* 240625 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(240667), // Rule ID 7697 //
     /* 240630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2000:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 240657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240665 */     GIR_RootConstrainSelectedInstOperands,
     /* 240666 */     // GIR_Coverage, 7697,
     /* 240666 */     GIR_EraseRootFromParent_Done,
     /* 240667 */   // Label 4593: @240667
     /* 240667 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(240709), // Rule ID 7698 //
     /* 240672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2000:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 240699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240707 */     GIR_RootConstrainSelectedInstOperands,
     /* 240708 */     // GIR_Coverage, 7698,
     /* 240708 */     GIR_EraseRootFromParent_Done,
     /* 240709 */   // Label 4594: @240709
     /* 240709 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(240751), // Rule ID 7707 //
     /* 240714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 240722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 240741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240749 */     GIR_RootConstrainSelectedInstOperands,
     /* 240750 */     // GIR_Coverage, 7707,
     /* 240750 */     GIR_EraseRootFromParent_Done,
     /* 240751 */   // Label 4595: @240751
     /* 240751 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(240793), // Rule ID 7708 //
     /* 240756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 240764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1963:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 240783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240791 */     GIR_RootConstrainSelectedInstOperands,
     /* 240792 */     // GIR_Coverage, 7708,
     /* 240792 */     GIR_EraseRootFromParent_Done,
     /* 240793 */   // Label 4596: @240793
     /* 240793 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(240835), // Rule ID 7709 //
     /* 240798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 240806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 240825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240833 */     GIR_RootConstrainSelectedInstOperands,
     /* 240834 */     // GIR_Coverage, 7709,
     /* 240834 */     GIR_EraseRootFromParent_Done,
     /* 240835 */   // Label 4597: @240835
     /* 240835 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(240877), // Rule ID 7710 //
     /* 240840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 240848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1718:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 240867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240875 */     GIR_RootConstrainSelectedInstOperands,
     /* 240876 */     // GIR_Coverage, 7710,
     /* 240876 */     GIR_EraseRootFromParent_Done,
     /* 240877 */   // Label 4598: @240877
     /* 240877 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(240919), // Rule ID 7711 //
     /* 240882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 240890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 240909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240917 */     GIR_RootConstrainSelectedInstOperands,
     /* 240918 */     // GIR_Coverage, 7711,
     /* 240918 */     GIR_EraseRootFromParent_Done,
     /* 240919 */   // Label 4599: @240919
     /* 240919 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(240961), // Rule ID 7712 //
     /* 240924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 240932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 240951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240959 */     GIR_RootConstrainSelectedInstOperands,
     /* 240960 */     // GIR_Coverage, 7712,
     /* 240960 */     GIR_EraseRootFromParent_Done,
     /* 240961 */   // Label 4600: @240961
     /* 240961 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(241003), // Rule ID 7801 //
     /* 240966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 240974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 240983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240990 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 240990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 240993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241001 */     GIR_RootConstrainSelectedInstOperands,
     /* 241002 */     // GIR_Coverage, 7801,
     /* 241002 */     GIR_EraseRootFromParent_Done,
     /* 241003 */   // Label 4601: @241003
     /* 241003 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(241045), // Rule ID 7802 //
     /* 241008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 241032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 241035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241043 */     GIR_RootConstrainSelectedInstOperands,
     /* 241044 */     // GIR_Coverage, 7802,
     /* 241044 */     GIR_EraseRootFromParent_Done,
     /* 241045 */   // Label 4602: @241045
     /* 241045 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(241087), // Rule ID 7803 //
     /* 241050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 241074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 241077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241085 */     GIR_RootConstrainSelectedInstOperands,
     /* 241086 */     // GIR_Coverage, 7803,
     /* 241086 */     GIR_EraseRootFromParent_Done,
     /* 241087 */   // Label 4603: @241087
     /* 241087 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(241129), // Rule ID 7804 //
     /* 241092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 241119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241127 */     GIR_RootConstrainSelectedInstOperands,
     /* 241128 */     // GIR_Coverage, 7804,
     /* 241128 */     GIR_EraseRootFromParent_Done,
     /* 241129 */   // Label 4604: @241129
     /* 241129 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(241171), // Rule ID 7813 //
     /* 241134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241158 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 241158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 241161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241169 */     GIR_RootConstrainSelectedInstOperands,
     /* 241170 */     // GIR_Coverage, 7813,
     /* 241170 */     GIR_EraseRootFromParent_Done,
     /* 241171 */   // Label 4605: @241171
     /* 241171 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(241213), // Rule ID 7814 //
     /* 241176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241200 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 241200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 241203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241211 */     GIR_RootConstrainSelectedInstOperands,
     /* 241212 */     // GIR_Coverage, 7814,
     /* 241212 */     GIR_EraseRootFromParent_Done,
     /* 241213 */   // Label 4606: @241213
     /* 241213 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(241255), // Rule ID 7815 //
     /* 241218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 241242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 241245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241253 */     GIR_RootConstrainSelectedInstOperands,
     /* 241254 */     // GIR_Coverage, 7815,
     /* 241254 */     GIR_EraseRootFromParent_Done,
     /* 241255 */   // Label 4607: @241255
     /* 241255 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(241297), // Rule ID 7816 //
     /* 241260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 241287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241295 */     GIR_RootConstrainSelectedInstOperands,
     /* 241296 */     // GIR_Coverage, 7816,
     /* 241296 */     GIR_EraseRootFromParent_Done,
     /* 241297 */   // Label 4608: @241297
     /* 241297 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(241339), // Rule ID 7895 //
     /* 241302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1693:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 241329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241337 */     GIR_RootConstrainSelectedInstOperands,
     /* 241338 */     // GIR_Coverage, 7895,
     /* 241338 */     GIR_EraseRootFromParent_Done,
     /* 241339 */   // Label 4609: @241339
     /* 241339 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(241381), // Rule ID 7896 //
     /* 241344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 241371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241379 */     GIR_RootConstrainSelectedInstOperands,
     /* 241380 */     // GIR_Coverage, 7896,
     /* 241380 */     GIR_EraseRootFromParent_Done,
     /* 241381 */   // Label 4610: @241381
     /* 241381 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(241423), // Rule ID 7897 //
     /* 241386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 241413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241421 */     GIR_RootConstrainSelectedInstOperands,
     /* 241422 */     // GIR_Coverage, 7897,
     /* 241422 */     GIR_EraseRootFromParent_Done,
     /* 241423 */   // Label 4611: @241423
     /* 241423 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(241465), // Rule ID 7898 //
     /* 241428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 241455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241463 */     GIR_RootConstrainSelectedInstOperands,
     /* 241464 */     // GIR_Coverage, 7898,
     /* 241464 */     GIR_EraseRootFromParent_Done,
     /* 241465 */   // Label 4612: @241465
     /* 241465 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(241507), // Rule ID 7899 //
     /* 241470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 241497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241505 */     GIR_RootConstrainSelectedInstOperands,
     /* 241506 */     // GIR_Coverage, 7899,
     /* 241506 */     GIR_EraseRootFromParent_Done,
     /* 241507 */   // Label 4613: @241507
     /* 241507 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(241549), // Rule ID 7900 //
     /* 241512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241536 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 241539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241547 */     GIR_RootConstrainSelectedInstOperands,
     /* 241548 */     // GIR_Coverage, 7900,
     /* 241548 */     GIR_EraseRootFromParent_Done,
     /* 241549 */   // Label 4614: @241549
     /* 241549 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(241591), // Rule ID 7901 //
     /* 241554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 241581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241589 */     GIR_RootConstrainSelectedInstOperands,
     /* 241590 */     // GIR_Coverage, 7901,
     /* 241590 */     GIR_EraseRootFromParent_Done,
     /* 241591 */   // Label 4615: @241591
     /* 241591 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(241633), // Rule ID 7902 //
     /* 241596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 241623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241631 */     GIR_RootConstrainSelectedInstOperands,
     /* 241632 */     // GIR_Coverage, 7902,
     /* 241632 */     GIR_EraseRootFromParent_Done,
     /* 241633 */   // Label 4616: @241633
     /* 241633 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(241675), // Rule ID 8098 //
     /* 241638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241662 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 241665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241673 */     GIR_RootConstrainSelectedInstOperands,
     /* 241674 */     // GIR_Coverage, 8098,
     /* 241674 */     GIR_EraseRootFromParent_Done,
     /* 241675 */   // Label 4617: @241675
     /* 241675 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(241717), // Rule ID 8100 //
     /* 241680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241704 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 241707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241715 */     GIR_RootConstrainSelectedInstOperands,
     /* 241716 */     // GIR_Coverage, 8100,
     /* 241716 */     GIR_EraseRootFromParent_Done,
     /* 241717 */   // Label 4618: @241717
     /* 241717 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(241759), // Rule ID 8102 //
     /* 241722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 241749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241757 */     GIR_RootConstrainSelectedInstOperands,
     /* 241758 */     // GIR_Coverage, 8102,
     /* 241758 */     GIR_EraseRootFromParent_Done,
     /* 241759 */   // Label 4619: @241759
     /* 241759 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(241801), // Rule ID 8110 //
     /* 241764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241788 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 241791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241799 */     GIR_RootConstrainSelectedInstOperands,
     /* 241800 */     // GIR_Coverage, 8110,
     /* 241800 */     GIR_EraseRootFromParent_Done,
     /* 241801 */   // Label 4620: @241801
     /* 241801 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(241843), // Rule ID 8112 //
     /* 241806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 241833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241841 */     GIR_RootConstrainSelectedInstOperands,
     /* 241842 */     // GIR_Coverage, 8112,
     /* 241842 */     GIR_EraseRootFromParent_Done,
     /* 241843 */   // Label 4621: @241843
     /* 241843 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(241885), // Rule ID 8114 //
     /* 241848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 241875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241883 */     GIR_RootConstrainSelectedInstOperands,
     /* 241884 */     // GIR_Coverage, 8114,
     /* 241884 */     GIR_EraseRootFromParent_Done,
     /* 241885 */   // Label 4622: @241885
     /* 241885 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(241927), // Rule ID 8152 //
     /* 241890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241914 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 241917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241925 */     GIR_RootConstrainSelectedInstOperands,
     /* 241926 */     // GIR_Coverage, 8152,
     /* 241926 */     GIR_EraseRootFromParent_Done,
     /* 241927 */   // Label 4623: @241927
     /* 241927 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(241969), // Rule ID 8153 //
     /* 241932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241956 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 241959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241967 */     GIR_RootConstrainSelectedInstOperands,
     /* 241968 */     // GIR_Coverage, 8153,
     /* 241968 */     GIR_EraseRootFromParent_Done,
     /* 241969 */   // Label 4624: @241969
     /* 241969 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(242011), // Rule ID 8154 //
     /* 241974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 242001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242009 */     GIR_RootConstrainSelectedInstOperands,
     /* 242010 */     // GIR_Coverage, 8154,
     /* 242010 */     GIR_EraseRootFromParent_Done,
     /* 242011 */   // Label 4625: @242011
     /* 242011 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(242053), // Rule ID 8155 //
     /* 242016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 242043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242051 */     GIR_RootConstrainSelectedInstOperands,
     /* 242052 */     // GIR_Coverage, 8155,
     /* 242052 */     GIR_EraseRootFromParent_Done,
     /* 242053 */   // Label 4626: @242053
     /* 242053 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(242095), // Rule ID 8156 //
     /* 242058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 242085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242093 */     GIR_RootConstrainSelectedInstOperands,
     /* 242094 */     // GIR_Coverage, 8156,
     /* 242094 */     GIR_EraseRootFromParent_Done,
     /* 242095 */   // Label 4627: @242095
     /* 242095 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(242137), // Rule ID 8157 //
     /* 242100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1490:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 242127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242135 */     GIR_RootConstrainSelectedInstOperands,
     /* 242136 */     // GIR_Coverage, 8157,
     /* 242136 */     GIR_EraseRootFromParent_Done,
     /* 242137 */   // Label 4628: @242137
     /* 242137 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(242179), // Rule ID 8158 //
     /* 242142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242166 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 242169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242177 */     GIR_RootConstrainSelectedInstOperands,
     /* 242178 */     // GIR_Coverage, 8158,
     /* 242178 */     GIR_EraseRootFromParent_Done,
     /* 242179 */   // Label 4629: @242179
     /* 242179 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(242221), // Rule ID 8159 //
     /* 242184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242208 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 242211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242219 */     GIR_RootConstrainSelectedInstOperands,
     /* 242220 */     // GIR_Coverage, 8159,
     /* 242220 */     GIR_EraseRootFromParent_Done,
     /* 242221 */   // Label 4630: @242221
     /* 242221 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(242263), // Rule ID 8160 //
     /* 242226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 242253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242261 */     GIR_RootConstrainSelectedInstOperands,
     /* 242262 */     // GIR_Coverage, 8160,
     /* 242262 */     GIR_EraseRootFromParent_Done,
     /* 242263 */   // Label 4631: @242263
     /* 242263 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(242305), // Rule ID 8161 //
     /* 242268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242292 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1427:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 242295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242303 */     GIR_RootConstrainSelectedInstOperands,
     /* 242304 */     // GIR_Coverage, 8161,
     /* 242304 */     GIR_EraseRootFromParent_Done,
     /* 242305 */   // Label 4632: @242305
     /* 242305 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(242347), // Rule ID 8162 //
     /* 242310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1427:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 242337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242345 */     GIR_RootConstrainSelectedInstOperands,
     /* 242346 */     // GIR_Coverage, 8162,
     /* 242346 */     GIR_EraseRootFromParent_Done,
     /* 242347 */   // Label 4633: @242347
     /* 242347 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(242389), // Rule ID 8163 //
     /* 242352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1427:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 242379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242387 */     GIR_RootConstrainSelectedInstOperands,
     /* 242388 */     // GIR_Coverage, 8163,
     /* 242388 */     GIR_EraseRootFromParent_Done,
     /* 242389 */   // Label 4634: @242389
     /* 242389 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(242431), // Rule ID 8200 //
     /* 242394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242418 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242429 */     GIR_RootConstrainSelectedInstOperands,
     /* 242430 */     // GIR_Coverage, 8200,
     /* 242430 */     GIR_EraseRootFromParent_Done,
     /* 242431 */   // Label 4635: @242431
     /* 242431 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(242473), // Rule ID 8202 //
     /* 242436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242460 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242471 */     GIR_RootConstrainSelectedInstOperands,
     /* 242472 */     // GIR_Coverage, 8202,
     /* 242472 */     GIR_EraseRootFromParent_Done,
     /* 242473 */   // Label 4636: @242473
     /* 242473 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(242515), // Rule ID 8204 //
     /* 242478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242502 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242513 */     GIR_RootConstrainSelectedInstOperands,
     /* 242514 */     // GIR_Coverage, 8204,
     /* 242514 */     GIR_EraseRootFromParent_Done,
     /* 242515 */   // Label 4637: @242515
     /* 242515 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(242557), // Rule ID 8206 //
     /* 242520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242555 */     GIR_RootConstrainSelectedInstOperands,
     /* 242556 */     // GIR_Coverage, 8206,
     /* 242556 */     GIR_EraseRootFromParent_Done,
     /* 242557 */   // Label 4638: @242557
     /* 242557 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(242599), // Rule ID 8208 //
     /* 242562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242586 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242597 */     GIR_RootConstrainSelectedInstOperands,
     /* 242598 */     // GIR_Coverage, 8208,
     /* 242598 */     GIR_EraseRootFromParent_Done,
     /* 242599 */   // Label 4639: @242599
     /* 242599 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(242641), // Rule ID 8210 //
     /* 242604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 242631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242639 */     GIR_RootConstrainSelectedInstOperands,
     /* 242640 */     // GIR_Coverage, 8210,
     /* 242640 */     GIR_EraseRootFromParent_Done,
     /* 242641 */   // Label 4640: @242641
     /* 242641 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(242683), // Rule ID 8212 //
     /* 242646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242670 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242681 */     GIR_RootConstrainSelectedInstOperands,
     /* 242682 */     // GIR_Coverage, 8212,
     /* 242682 */     GIR_EraseRootFromParent_Done,
     /* 242683 */   // Label 4641: @242683
     /* 242683 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(242725), // Rule ID 8213 //
     /* 242688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242712 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242723 */     GIR_RootConstrainSelectedInstOperands,
     /* 242724 */     // GIR_Coverage, 8213,
     /* 242724 */     GIR_EraseRootFromParent_Done,
     /* 242725 */   // Label 4642: @242725
     /* 242725 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(242767), // Rule ID 8214 //
     /* 242730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242754 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242765 */     GIR_RootConstrainSelectedInstOperands,
     /* 242766 */     // GIR_Coverage, 8214,
     /* 242766 */     GIR_EraseRootFromParent_Done,
     /* 242767 */   // Label 4643: @242767
     /* 242767 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(242809), // Rule ID 8215 //
     /* 242772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242796 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 242799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242807 */     GIR_RootConstrainSelectedInstOperands,
     /* 242808 */     // GIR_Coverage, 8215,
     /* 242808 */     GIR_EraseRootFromParent_Done,
     /* 242809 */   // Label 4644: @242809
     /* 242809 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(242851), // Rule ID 8216 //
     /* 242814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242838 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 242841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242849 */     GIR_RootConstrainSelectedInstOperands,
     /* 242850 */     // GIR_Coverage, 8216,
     /* 242850 */     GIR_EraseRootFromParent_Done,
     /* 242851 */   // Label 4645: @242851
     /* 242851 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(242893), // Rule ID 8217 //
     /* 242856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242880 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 242883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242891 */     GIR_RootConstrainSelectedInstOperands,
     /* 242892 */     // GIR_Coverage, 8217,
     /* 242892 */     GIR_EraseRootFromParent_Done,
     /* 242893 */   // Label 4646: @242893
     /* 242893 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(242935), // Rule ID 8470 //
     /* 242898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 242906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 242925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242933 */     GIR_RootConstrainSelectedInstOperands,
     /* 242934 */     // GIR_Coverage, 8470,
     /* 242934 */     GIR_EraseRootFromParent_Done,
     /* 242935 */   // Label 4647: @242935
     /* 242935 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(242977), // Rule ID 8472 //
     /* 242940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 242948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 242967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242975 */     GIR_RootConstrainSelectedInstOperands,
     /* 242976 */     // GIR_Coverage, 8472,
     /* 242976 */     GIR_EraseRootFromParent_Done,
     /* 242977 */   // Label 4648: @242977
     /* 242977 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(243019), // Rule ID 8473 //
     /* 242982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 242990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1302:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243017 */     GIR_RootConstrainSelectedInstOperands,
     /* 243018 */     // GIR_Coverage, 8473,
     /* 243018 */     GIR_EraseRootFromParent_Done,
     /* 243019 */   // Label 4649: @243019
     /* 243019 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(243061), // Rule ID 8474 //
     /* 243024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243048 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1302:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243059 */     GIR_RootConstrainSelectedInstOperands,
     /* 243060 */     // GIR_Coverage, 8474,
     /* 243060 */     GIR_EraseRootFromParent_Done,
     /* 243061 */   // Label 4650: @243061
     /* 243061 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(243103), // Rule ID 8475 //
     /* 243066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1302:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243101 */     GIR_RootConstrainSelectedInstOperands,
     /* 243102 */     // GIR_Coverage, 8475,
     /* 243102 */     GIR_EraseRootFromParent_Done,
     /* 243103 */   // Label 4651: @243103
     /* 243103 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(243145), // Rule ID 8476 //
     /* 243108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1302:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243143 */     GIR_RootConstrainSelectedInstOperands,
     /* 243144 */     // GIR_Coverage, 8476,
     /* 243144 */     GIR_EraseRootFromParent_Done,
     /* 243145 */   // Label 4652: @243145
     /* 243145 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(243187), // Rule ID 8477 //
     /* 243150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1302:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243185 */     GIR_RootConstrainSelectedInstOperands,
     /* 243186 */     // GIR_Coverage, 8477,
     /* 243186 */     GIR_EraseRootFromParent_Done,
     /* 243187 */   // Label 4653: @243187
     /* 243187 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(243229), // Rule ID 8498 //
     /* 243192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1360:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243227 */     GIR_RootConstrainSelectedInstOperands,
     /* 243228 */     // GIR_Coverage, 8498,
     /* 243228 */     GIR_EraseRootFromParent_Done,
     /* 243229 */   // Label 4654: @243229
     /* 243229 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(243271), // Rule ID 8499 //
     /* 243234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243269 */     GIR_RootConstrainSelectedInstOperands,
     /* 243270 */     // GIR_Coverage, 8499,
     /* 243270 */     GIR_EraseRootFromParent_Done,
     /* 243271 */   // Label 4655: @243271
     /* 243271 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(243313), // Rule ID 8500 //
     /* 243276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243311 */     GIR_RootConstrainSelectedInstOperands,
     /* 243312 */     // GIR_Coverage, 8500,
     /* 243312 */     GIR_EraseRootFromParent_Done,
     /* 243313 */   // Label 4656: @243313
     /* 243313 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(243355), // Rule ID 8501 //
     /* 243318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243353 */     GIR_RootConstrainSelectedInstOperands,
     /* 243354 */     // GIR_Coverage, 8501,
     /* 243354 */     GIR_EraseRootFromParent_Done,
     /* 243355 */   // Label 4657: @243355
     /* 243355 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(243397), // Rule ID 8502 //
     /* 243360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1360:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243395 */     GIR_RootConstrainSelectedInstOperands,
     /* 243396 */     // GIR_Coverage, 8502,
     /* 243396 */     GIR_EraseRootFromParent_Done,
     /* 243397 */   // Label 4658: @243397
     /* 243397 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(243439), // Rule ID 8518 //
     /* 243402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1631:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243437 */     GIR_RootConstrainSelectedInstOperands,
     /* 243438 */     // GIR_Coverage, 8518,
     /* 243438 */     GIR_EraseRootFromParent_Done,
     /* 243439 */   // Label 4659: @243439
     /* 243439 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(243481), // Rule ID 8519 //
     /* 243444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1631:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243479 */     GIR_RootConstrainSelectedInstOperands,
     /* 243480 */     // GIR_Coverage, 8519,
     /* 243480 */     GIR_EraseRootFromParent_Done,
     /* 243481 */   // Label 4660: @243481
     /* 243481 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(243523), // Rule ID 8520 //
     /* 243486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243510 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1631:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243521 */     GIR_RootConstrainSelectedInstOperands,
     /* 243522 */     // GIR_Coverage, 8520,
     /* 243522 */     GIR_EraseRootFromParent_Done,
     /* 243523 */   // Label 4661: @243523
     /* 243523 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(243565), // Rule ID 8521 //
     /* 243528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1631:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243563 */     GIR_RootConstrainSelectedInstOperands,
     /* 243564 */     // GIR_Coverage, 8521,
     /* 243564 */     GIR_EraseRootFromParent_Done,
     /* 243565 */   // Label 4662: @243565
     /* 243565 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(243607), // Rule ID 8522 //
     /* 243570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243594 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1631:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243605 */     GIR_RootConstrainSelectedInstOperands,
     /* 243606 */     // GIR_Coverage, 8522,
     /* 243606 */     GIR_EraseRootFromParent_Done,
     /* 243607 */   // Label 4663: @243607
     /* 243607 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(243649), // Rule ID 8523 //
     /* 243612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243647 */     GIR_RootConstrainSelectedInstOperands,
     /* 243648 */     // GIR_Coverage, 8523,
     /* 243648 */     GIR_EraseRootFromParent_Done,
     /* 243649 */   // Label 4664: @243649
     /* 243649 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(243691), // Rule ID 8524 //
     /* 243654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243678 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243689 */     GIR_RootConstrainSelectedInstOperands,
     /* 243690 */     // GIR_Coverage, 8524,
     /* 243690 */     GIR_EraseRootFromParent_Done,
     /* 243691 */   // Label 4665: @243691
     /* 243691 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(243733), // Rule ID 8525 //
     /* 243696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243731 */     GIR_RootConstrainSelectedInstOperands,
     /* 243732 */     // GIR_Coverage, 8525,
     /* 243732 */     GIR_EraseRootFromParent_Done,
     /* 243733 */   // Label 4666: @243733
     /* 243733 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(243775), // Rule ID 8526 //
     /* 243738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243773 */     GIR_RootConstrainSelectedInstOperands,
     /* 243774 */     // GIR_Coverage, 8526,
     /* 243774 */     GIR_EraseRootFromParent_Done,
     /* 243775 */   // Label 4667: @243775
     /* 243775 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(243817), // Rule ID 8527 //
     /* 243780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243804 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1627:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243815 */     GIR_RootConstrainSelectedInstOperands,
     /* 243816 */     // GIR_Coverage, 8527,
     /* 243816 */     GIR_EraseRootFromParent_Done,
     /* 243817 */   // Label 4668: @243817
     /* 243817 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(243859), // Rule ID 8528 //
     /* 243822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243846 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243857 */     GIR_RootConstrainSelectedInstOperands,
     /* 243858 */     // GIR_Coverage, 8528,
     /* 243858 */     GIR_EraseRootFromParent_Done,
     /* 243859 */   // Label 4669: @243859
     /* 243859 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(243901), // Rule ID 8529 //
     /* 243864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1625:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243899 */     GIR_RootConstrainSelectedInstOperands,
     /* 243900 */     // GIR_Coverage, 8529,
     /* 243900 */     GIR_EraseRootFromParent_Done,
     /* 243901 */   // Label 4670: @243901
     /* 243901 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(243943), // Rule ID 8530 //
     /* 243906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1625:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243941 */     GIR_RootConstrainSelectedInstOperands,
     /* 243942 */     // GIR_Coverage, 8530,
     /* 243942 */     GIR_EraseRootFromParent_Done,
     /* 243943 */   // Label 4671: @243943
     /* 243943 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(243985), // Rule ID 8531 //
     /* 243948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1625:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243983 */     GIR_RootConstrainSelectedInstOperands,
     /* 243984 */     // GIR_Coverage, 8531,
     /* 243984 */     GIR_EraseRootFromParent_Done,
     /* 243985 */   // Label 4672: @243985
     /* 243985 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(244027), // Rule ID 8532 //
     /* 243990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1625:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 244017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244025 */     GIR_RootConstrainSelectedInstOperands,
     /* 244026 */     // GIR_Coverage, 8532,
     /* 244026 */     GIR_EraseRootFromParent_Done,
     /* 244027 */   // Label 4673: @244027
     /* 244027 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(244069), // Rule ID 8533 //
     /* 244032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 244049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 244052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 244056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244067 */     GIR_RootConstrainSelectedInstOperands,
     /* 244068 */     // GIR_Coverage, 8533,
     /* 244068 */     GIR_EraseRootFromParent_Done,
     /* 244069 */   // Label 4674: @244069
     /* 244069 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(244111), // Rule ID 8534 //
     /* 244074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 244091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 244094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 244098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244109 */     GIR_RootConstrainSelectedInstOperands,
     /* 244110 */     // GIR_Coverage, 8534,
     /* 244110 */     GIR_EraseRootFromParent_Done,
     /* 244111 */   // Label 4675: @244111
     /* 244111 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(244153), // Rule ID 8535 //
     /* 244116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 244133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 244136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 244140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244151 */     GIR_RootConstrainSelectedInstOperands,
     /* 244152 */     // GIR_Coverage, 8535,
     /* 244152 */     GIR_EraseRootFromParent_Done,
     /* 244153 */   // Label 4676: @244153
     /* 244153 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(244195), // Rule ID 8536 //
     /* 244158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 244178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244182 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 244182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244193 */     GIR_RootConstrainSelectedInstOperands,
     /* 244194 */     // GIR_Coverage, 8536,
     /* 244194 */     GIR_EraseRootFromParent_Done,
     /* 244195 */   // Label 4677: @244195
     /* 244195 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(244237), // Rule ID 8537 //
     /* 244200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244235 */     GIR_RootConstrainSelectedInstOperands,
     /* 244236 */     // GIR_Coverage, 8537,
     /* 244236 */     GIR_EraseRootFromParent_Done,
     /* 244237 */   // Label 4678: @244237
     /* 244237 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(244279), // Rule ID 8545 //
     /* 244242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1318:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 244269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244277 */     GIR_RootConstrainSelectedInstOperands,
     /* 244278 */     // GIR_Coverage, 8545,
     /* 244278 */     GIR_EraseRootFromParent_Done,
     /* 244279 */   // Label 4679: @244279
     /* 244279 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(244321), // Rule ID 8546 //
     /* 244284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244319 */     GIR_RootConstrainSelectedInstOperands,
     /* 244320 */     // GIR_Coverage, 8546,
     /* 244320 */     GIR_EraseRootFromParent_Done,
     /* 244321 */   // Label 4680: @244321
     /* 244321 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(244363), // Rule ID 8547 //
     /* 244326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244361 */     GIR_RootConstrainSelectedInstOperands,
     /* 244362 */     // GIR_Coverage, 8547,
     /* 244362 */     GIR_EraseRootFromParent_Done,
     /* 244363 */   // Label 4681: @244363
     /* 244363 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(244405), // Rule ID 8548 //
     /* 244368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1318:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244403 */     GIR_RootConstrainSelectedInstOperands,
     /* 244404 */     // GIR_Coverage, 8548,
     /* 244404 */     GIR_EraseRootFromParent_Done,
     /* 244405 */   // Label 4682: @244405
     /* 244405 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(244447), // Rule ID 8549 //
     /* 244410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244445 */     GIR_RootConstrainSelectedInstOperands,
     /* 244446 */     // GIR_Coverage, 8549,
     /* 244446 */     GIR_EraseRootFromParent_Done,
     /* 244447 */   // Label 4683: @244447
     /* 244447 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(244489), // Rule ID 8550 //
     /* 244452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244487 */     GIR_RootConstrainSelectedInstOperands,
     /* 244488 */     // GIR_Coverage, 8550,
     /* 244488 */     GIR_EraseRootFromParent_Done,
     /* 244489 */   // Label 4684: @244489
     /* 244489 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(244531), // Rule ID 8551 //
     /* 244494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244518 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1318:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244529 */     GIR_RootConstrainSelectedInstOperands,
     /* 244530 */     // GIR_Coverage, 8551,
     /* 244530 */     GIR_EraseRootFromParent_Done,
     /* 244531 */   // Label 4685: @244531
     /* 244531 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(244576), // Rule ID 9247 //
     /* 244536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1339:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 244563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244574 */     GIR_RootConstrainSelectedInstOperands,
     /* 244575 */     // GIR_Coverage, 9247,
     /* 244575 */     GIR_EraseRootFromParent_Done,
     /* 244576 */   // Label 4686: @244576
     /* 244576 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(244621), // Rule ID 9248 //
     /* 244581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244605 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1339:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 244608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244619 */     GIR_RootConstrainSelectedInstOperands,
     /* 244620 */     // GIR_Coverage, 9248,
     /* 244620 */     GIR_EraseRootFromParent_Done,
     /* 244621 */   // Label 4687: @244621
     /* 244621 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(244666), // Rule ID 9249 //
     /* 244626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1339:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 244653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244664 */     GIR_RootConstrainSelectedInstOperands,
     /* 244665 */     // GIR_Coverage, 9249,
     /* 244665 */     GIR_EraseRootFromParent_Done,
     /* 244666 */   // Label 4688: @244666
     /* 244666 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(244711), // Rule ID 9250 //
     /* 244671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244695 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 244698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244709 */     GIR_RootConstrainSelectedInstOperands,
     /* 244710 */     // GIR_Coverage, 9250,
     /* 244710 */     GIR_EraseRootFromParent_Done,
     /* 244711 */   // Label 4689: @244711
     /* 244711 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(244756), // Rule ID 9251 //
     /* 244716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 244743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244754 */     GIR_RootConstrainSelectedInstOperands,
     /* 244755 */     // GIR_Coverage, 9251,
     /* 244755 */     GIR_EraseRootFromParent_Done,
     /* 244756 */   // Label 4690: @244756
     /* 244756 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(244801), // Rule ID 9252 //
     /* 244761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244785 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 244788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244799 */     GIR_RootConstrainSelectedInstOperands,
     /* 244800 */     // GIR_Coverage, 9252,
     /* 244800 */     GIR_EraseRootFromParent_Done,
     /* 244801 */   // Label 4691: @244801
     /* 244801 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(244846), // Rule ID 9253 //
     /* 244806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244830 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1337:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 244833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244844 */     GIR_RootConstrainSelectedInstOperands,
     /* 244845 */     // GIR_Coverage, 9253,
     /* 244845 */     GIR_EraseRootFromParent_Done,
     /* 244846 */   // Label 4692: @244846
     /* 244846 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(244891), // Rule ID 9254 //
     /* 244851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244875 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1337:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 244878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244889 */     GIR_RootConstrainSelectedInstOperands,
     /* 244890 */     // GIR_Coverage, 9254,
     /* 244890 */     GIR_EraseRootFromParent_Done,
     /* 244891 */   // Label 4693: @244891
     /* 244891 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(244936), // Rule ID 9255 //
     /* 244896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1337:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 244923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244934 */     GIR_RootConstrainSelectedInstOperands,
     /* 244935 */     // GIR_Coverage, 9255,
     /* 244935 */     GIR_EraseRootFromParent_Done,
     /* 244936 */   // Label 4694: @244936
     /* 244936 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(244981), // Rule ID 9256 //
     /* 244941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 244949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244965 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1334:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 244968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244979 */     GIR_RootConstrainSelectedInstOperands,
     /* 244980 */     // GIR_Coverage, 9256,
     /* 244980 */     GIR_EraseRootFromParent_Done,
     /* 244981 */   // Label 4695: @244981
     /* 244981 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(245026), // Rule ID 9257 //
     /* 244986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 244994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245010 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1334:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 245013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245024 */     GIR_RootConstrainSelectedInstOperands,
     /* 245025 */     // GIR_Coverage, 9257,
     /* 245025 */     GIR_EraseRootFromParent_Done,
     /* 245026 */   // Label 4696: @245026
     /* 245026 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(245071), // Rule ID 9258 //
     /* 245031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 245039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245055 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 245058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245069 */     GIR_RootConstrainSelectedInstOperands,
     /* 245070 */     // GIR_Coverage, 9258,
     /* 245070 */     GIR_EraseRootFromParent_Done,
     /* 245071 */   // Label 4697: @245071
     /* 245071 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(245116), // Rule ID 9259 //
     /* 245076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1333:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 245103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245114 */     GIR_RootConstrainSelectedInstOperands,
     /* 245115 */     // GIR_Coverage, 9259,
     /* 245115 */     GIR_EraseRootFromParent_Done,
     /* 245116 */   // Label 4698: @245116
     /* 245116 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(245161), // Rule ID 9260 //
     /* 245121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245145 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1333:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 245148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245159 */     GIR_RootConstrainSelectedInstOperands,
     /* 245160 */     // GIR_Coverage, 9260,
     /* 245160 */     GIR_EraseRootFromParent_Done,
     /* 245161 */   // Label 4699: @245161
     /* 245161 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(245206), // Rule ID 9261 //
     /* 245166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 245193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245204 */     GIR_RootConstrainSelectedInstOperands,
     /* 245205 */     // GIR_Coverage, 9261,
     /* 245205 */     GIR_EraseRootFromParent_Done,
     /* 245206 */   // Label 4700: @245206
     /* 245206 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(245251), // Rule ID 9262 //
     /* 245211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1331:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 245238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245249 */     GIR_RootConstrainSelectedInstOperands,
     /* 245250 */     // GIR_Coverage, 9262,
     /* 245250 */     GIR_EraseRootFromParent_Done,
     /* 245251 */   // Label 4701: @245251
     /* 245251 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(245296), // Rule ID 9263 //
     /* 245256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1331:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 245283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245294 */     GIR_RootConstrainSelectedInstOperands,
     /* 245295 */     // GIR_Coverage, 9263,
     /* 245295 */     GIR_EraseRootFromParent_Done,
     /* 245296 */   // Label 4702: @245296
     /* 245296 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(245341), // Rule ID 9264 //
     /* 245301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245325 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 245328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245339 */     GIR_RootConstrainSelectedInstOperands,
     /* 245340 */     // GIR_Coverage, 9264,
     /* 245340 */     GIR_EraseRootFromParent_Done,
     /* 245341 */   // Label 4703: @245341
     /* 245341 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(245386), // Rule ID 9265 //
     /* 245346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 245373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245384 */     GIR_RootConstrainSelectedInstOperands,
     /* 245385 */     // GIR_Coverage, 9265,
     /* 245385 */     GIR_EraseRootFromParent_Done,
     /* 245386 */   // Label 4704: @245386
     /* 245386 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(245431), // Rule ID 9266 //
     /* 245391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245415 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 245418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245429 */     GIR_RootConstrainSelectedInstOperands,
     /* 245430 */     // GIR_Coverage, 9266,
     /* 245430 */     GIR_EraseRootFromParent_Done,
     /* 245431 */   // Label 4705: @245431
     /* 245431 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(245476), // Rule ID 9267 //
     /* 245436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 245463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245474 */     GIR_RootConstrainSelectedInstOperands,
     /* 245475 */     // GIR_Coverage, 9267,
     /* 245475 */     GIR_EraseRootFromParent_Done,
     /* 245476 */   // Label 4706: @245476
     /* 245476 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(245521), // Rule ID 9268 //
     /* 245481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245505 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 245508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245519 */     GIR_RootConstrainSelectedInstOperands,
     /* 245520 */     // GIR_Coverage, 9268,
     /* 245520 */     GIR_EraseRootFromParent_Done,
     /* 245521 */   // Label 4707: @245521
     /* 245521 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(245566), // Rule ID 9269 //
     /* 245526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245550 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 245553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245564 */     GIR_RootConstrainSelectedInstOperands,
     /* 245565 */     // GIR_Coverage, 9269,
     /* 245565 */     GIR_EraseRootFromParent_Done,
     /* 245566 */   // Label 4708: @245566
     /* 245566 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(245611), // Rule ID 9270 //
     /* 245571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 245598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245609 */     GIR_RootConstrainSelectedInstOperands,
     /* 245610 */     // GIR_Coverage, 9270,
     /* 245610 */     GIR_EraseRootFromParent_Done,
     /* 245611 */   // Label 4709: @245611
     /* 245611 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(245653), // Rule ID 9667 //
     /* 245616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 245643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245651 */     GIR_RootConstrainSelectedInstOperands,
     /* 245652 */     // GIR_Coverage, 9667,
     /* 245652 */     GIR_EraseRootFromParent_Done,
     /* 245653 */   // Label 4710: @245653
     /* 245653 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(245695), // Rule ID 9668 //
     /* 245658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245682 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 245685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245693 */     GIR_RootConstrainSelectedInstOperands,
     /* 245694 */     // GIR_Coverage, 9668,
     /* 245694 */     GIR_EraseRootFromParent_Done,
     /* 245695 */   // Label 4711: @245695
     /* 245695 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(245737), // Rule ID 9669 //
     /* 245700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 245727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245735 */     GIR_RootConstrainSelectedInstOperands,
     /* 245736 */     // GIR_Coverage, 9669,
     /* 245736 */     GIR_EraseRootFromParent_Done,
     /* 245737 */   // Label 4712: @245737
     /* 245737 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(245779), // Rule ID 10207 //
     /* 245742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 245769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245777 */     GIR_RootConstrainSelectedInstOperands,
     /* 245778 */     // GIR_Coverage, 10207,
     /* 245778 */     GIR_EraseRootFromParent_Done,
     /* 245779 */   // Label 4713: @245779
     /* 245779 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(245821), // Rule ID 10208 //
     /* 245784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 245811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245819 */     GIR_RootConstrainSelectedInstOperands,
     /* 245820 */     // GIR_Coverage, 10208,
     /* 245820 */     GIR_EraseRootFromParent_Done,
     /* 245821 */   // Label 4714: @245821
     /* 245821 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(245863), // Rule ID 10209 //
     /* 245826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 245853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245861 */     GIR_RootConstrainSelectedInstOperands,
     /* 245862 */     // GIR_Coverage, 10209,
     /* 245862 */     GIR_EraseRootFromParent_Done,
     /* 245863 */   // Label 4715: @245863
     /* 245863 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(245905), // Rule ID 10210 //
     /* 245868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 245895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245903 */     GIR_RootConstrainSelectedInstOperands,
     /* 245904 */     // GIR_Coverage, 10210,
     /* 245904 */     GIR_EraseRootFromParent_Done,
     /* 245905 */   // Label 4716: @245905
     /* 245905 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(245947), // Rule ID 10211 //
     /* 245910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 245937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245945 */     GIR_RootConstrainSelectedInstOperands,
     /* 245946 */     // GIR_Coverage, 10211,
     /* 245946 */     GIR_EraseRootFromParent_Done,
     /* 245947 */   // Label 4717: @245947
     /* 245947 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(245989), // Rule ID 10212 //
     /* 245952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 245979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245987 */     GIR_RootConstrainSelectedInstOperands,
     /* 245988 */     // GIR_Coverage, 10212,
     /* 245988 */     GIR_EraseRootFromParent_Done,
     /* 245989 */   // Label 4718: @245989
     /* 245989 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(246031), // Rule ID 10213 //
     /* 245994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 246021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246029 */     GIR_RootConstrainSelectedInstOperands,
     /* 246030 */     // GIR_Coverage, 10213,
     /* 246030 */     GIR_EraseRootFromParent_Done,
     /* 246031 */   // Label 4719: @246031
     /* 246031 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(246073), // Rule ID 10214 //
     /* 246036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 246063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246071 */     GIR_RootConstrainSelectedInstOperands,
     /* 246072 */     // GIR_Coverage, 10214,
     /* 246072 */     GIR_EraseRootFromParent_Done,
     /* 246073 */   // Label 4720: @246073
     /* 246073 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(246115), // Rule ID 10227 //
     /* 246078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1605:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 246105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246113 */     GIR_RootConstrainSelectedInstOperands,
     /* 246114 */     // GIR_Coverage, 10227,
     /* 246114 */     GIR_EraseRootFromParent_Done,
     /* 246115 */   // Label 4721: @246115
     /* 246115 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(246157), // Rule ID 10228 //
     /* 246120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 246147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246155 */     GIR_RootConstrainSelectedInstOperands,
     /* 246156 */     // GIR_Coverage, 10228,
     /* 246156 */     GIR_EraseRootFromParent_Done,
     /* 246157 */   // Label 4722: @246157
     /* 246157 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(246199), // Rule ID 10229 //
     /* 246162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 246189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246197 */     GIR_RootConstrainSelectedInstOperands,
     /* 246198 */     // GIR_Coverage, 10229,
     /* 246198 */     GIR_EraseRootFromParent_Done,
     /* 246199 */   // Label 4723: @246199
     /* 246199 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(246241), // Rule ID 10230 //
     /* 246204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 246231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246239 */     GIR_RootConstrainSelectedInstOperands,
     /* 246240 */     // GIR_Coverage, 10230,
     /* 246240 */     GIR_EraseRootFromParent_Done,
     /* 246241 */   // Label 4724: @246241
     /* 246241 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(246283), // Rule ID 10231 //
     /* 246246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 246273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246281 */     GIR_RootConstrainSelectedInstOperands,
     /* 246282 */     // GIR_Coverage, 10231,
     /* 246282 */     GIR_EraseRootFromParent_Done,
     /* 246283 */   // Label 4725: @246283
     /* 246283 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(246325), // Rule ID 10232 //
     /* 246288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 246315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246323 */     GIR_RootConstrainSelectedInstOperands,
     /* 246324 */     // GIR_Coverage, 10232,
     /* 246324 */     GIR_EraseRootFromParent_Done,
     /* 246325 */   // Label 4726: @246325
     /* 246325 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(246367), // Rule ID 10259 //
     /* 246330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 246338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246354 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1397:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 246357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246365 */     GIR_RootConstrainSelectedInstOperands,
     /* 246366 */     // GIR_Coverage, 10259,
     /* 246366 */     GIR_EraseRootFromParent_Done,
     /* 246367 */   // Label 4727: @246367
     /* 246367 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(246409), // Rule ID 10263 //
     /* 246372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 246380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1400:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 246399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246407 */     GIR_RootConstrainSelectedInstOperands,
     /* 246408 */     // GIR_Coverage, 10263,
     /* 246408 */     GIR_EraseRootFromParent_Done,
     /* 246409 */   // Label 4728: @246409
     /* 246409 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(246451), // Rule ID 10267 //
     /* 246414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 246422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246438 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1399:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 246441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246449 */     GIR_RootConstrainSelectedInstOperands,
     /* 246450 */     // GIR_Coverage, 10267,
     /* 246450 */     GIR_EraseRootFromParent_Done,
     /* 246451 */   // Label 4729: @246451
     /* 246451 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(246493), // Rule ID 10271 //
     /* 246456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 246464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246480 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1401:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 246483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246491 */     GIR_RootConstrainSelectedInstOperands,
     /* 246492 */     // GIR_Coverage, 10271,
     /* 246492 */     GIR_EraseRootFromParent_Done,
     /* 246493 */   // Label 4730: @246493
     /* 246493 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(246535), // Rule ID 10275 //
     /* 246498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 246506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246522 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1713:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 246525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246533 */     GIR_RootConstrainSelectedInstOperands,
     /* 246534 */     // GIR_Coverage, 10275,
     /* 246534 */     GIR_EraseRootFromParent_Done,
     /* 246535 */   // Label 4731: @246535
     /* 246535 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(246577), // Rule ID 10276 //
     /* 246540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 246548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1960:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 246567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246575 */     GIR_RootConstrainSelectedInstOperands,
     /* 246576 */     // GIR_Coverage, 10276,
     /* 246576 */     GIR_EraseRootFromParent_Done,
     /* 246577 */   // Label 4732: @246577
     /* 246577 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(246619), // Rule ID 10277 //
     /* 246582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 246590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246606 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1957:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 246609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246617 */     GIR_RootConstrainSelectedInstOperands,
     /* 246618 */     // GIR_Coverage, 10277,
     /* 246618 */     GIR_EraseRootFromParent_Done,
     /* 246619 */   // Label 4733: @246619
     /* 246619 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(246661), // Rule ID 10281 //
     /* 246624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 246632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246648 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1712:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 246651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246659 */     GIR_RootConstrainSelectedInstOperands,
     /* 246660 */     // GIR_Coverage, 10281,
     /* 246660 */     GIR_EraseRootFromParent_Done,
     /* 246661 */   // Label 4734: @246661
     /* 246661 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(246703), // Rule ID 10285 //
     /* 246666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 246674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246690 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1710:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 246693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246701 */     GIR_RootConstrainSelectedInstOperands,
     /* 246702 */     // GIR_Coverage, 10285,
     /* 246702 */     GIR_EraseRootFromParent_Done,
     /* 246703 */   // Label 4735: @246703
     /* 246703 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(246745), // Rule ID 10289 //
     /* 246708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 246716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1711:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 246735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246743 */     GIR_RootConstrainSelectedInstOperands,
     /* 246744 */     // GIR_Coverage, 10289,
     /* 246744 */     GIR_EraseRootFromParent_Done,
     /* 246745 */   // Label 4736: @246745
     /* 246745 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(246787), // Rule ID 10293 //
     /* 246750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 246758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246774 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1959:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 246777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246785 */     GIR_RootConstrainSelectedInstOperands,
     /* 246786 */     // GIR_Coverage, 10293,
     /* 246786 */     GIR_EraseRootFromParent_Done,
     /* 246787 */   // Label 4737: @246787
     /* 246787 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(246829), // Rule ID 10297 //
     /* 246792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 246800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1958:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 246819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246827 */     GIR_RootConstrainSelectedInstOperands,
     /* 246828 */     // GIR_Coverage, 10297,
     /* 246828 */     GIR_EraseRootFromParent_Done,
     /* 246829 */   // Label 4738: @246829
     /* 246829 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246871), // Rule ID 10307 //
     /* 246834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 246842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1415:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 246861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246869 */     GIR_RootConstrainSelectedInstOperands,
     /* 246870 */     // GIR_Coverage, 10307,
     /* 246870 */     GIR_EraseRootFromParent_Done,
     /* 246871 */   // Label 4739: @246871
     /* 246871 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246913), // Rule ID 10308 //
     /* 246876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 246884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 246903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246911 */     GIR_RootConstrainSelectedInstOperands,
     /* 246912 */     // GIR_Coverage, 10308,
     /* 246912 */     GIR_EraseRootFromParent_Done,
     /* 246913 */   // Label 4740: @246913
     /* 246913 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246955), // Rule ID 10309 //
     /* 246918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 246926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1417:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 246945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246953 */     GIR_RootConstrainSelectedInstOperands,
     /* 246954 */     // GIR_Coverage, 10309,
     /* 246954 */     GIR_EraseRootFromParent_Done,
     /* 246955 */   // Label 4741: @246955
     /* 246955 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(246997), // Rule ID 10313 //
     /* 246960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 246968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1414:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 246987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246995 */     GIR_RootConstrainSelectedInstOperands,
     /* 246996 */     // GIR_Coverage, 10313,
     /* 246996 */     GIR_EraseRootFromParent_Done,
     /* 246997 */   // Label 4742: @246997
     /* 246997 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(247039), // Rule ID 10317 //
     /* 247002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 247010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1416:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 247029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247037 */     GIR_RootConstrainSelectedInstOperands,
     /* 247038 */     // GIR_Coverage, 10317,
     /* 247038 */     GIR_EraseRootFromParent_Done,
     /* 247039 */   // Label 4743: @247039
     /* 247039 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(247081), // Rule ID 10321 //
     /* 247044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 247052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1421:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 247071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247079 */     GIR_RootConstrainSelectedInstOperands,
     /* 247080 */     // GIR_Coverage, 10321,
     /* 247080 */     GIR_EraseRootFromParent_Done,
     /* 247081 */   // Label 4744: @247081
     /* 247081 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(247123), // Rule ID 10325 //
     /* 247086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 247094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 247113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247121 */     GIR_RootConstrainSelectedInstOperands,
     /* 247122 */     // GIR_Coverage, 10325,
     /* 247122 */     GIR_EraseRootFromParent_Done,
     /* 247123 */   // Label 4745: @247123
     /* 247123 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(247165), // Rule ID 10329 //
     /* 247128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 247136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1424:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 247155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247163 */     GIR_RootConstrainSelectedInstOperands,
     /* 247164 */     // GIR_Coverage, 10329,
     /* 247164 */     GIR_EraseRootFromParent_Done,
     /* 247165 */   // Label 4746: @247165
     /* 247165 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(247207), // Rule ID 11326 //
     /* 247170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 247178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 247197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247205 */     GIR_RootConstrainSelectedInstOperands,
     /* 247206 */     // GIR_Coverage, 11326,
     /* 247206 */     GIR_EraseRootFromParent_Done,
     /* 247207 */   // Label 4747: @247207
     /* 247207 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247249), // Rule ID 11327 //
     /* 247212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 247220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2070:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 247239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247247 */     GIR_RootConstrainSelectedInstOperands,
     /* 247248 */     // GIR_Coverage, 11327,
     /* 247248 */     GIR_EraseRootFromParent_Done,
     /* 247249 */   // Label 4748: @247249
     /* 247249 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247291), // Rule ID 11329 //
     /* 247254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 247257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247278 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 247281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247289 */     GIR_RootConstrainSelectedInstOperands,
     /* 247290 */     // GIR_Coverage, 11329,
     /* 247290 */     GIR_EraseRootFromParent_Done,
     /* 247291 */   // Label 4749: @247291
     /* 247291 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247333), // Rule ID 11330 //
     /* 247296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 247299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247320 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 247320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 247323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247331 */     GIR_RootConstrainSelectedInstOperands,
     /* 247332 */     // GIR_Coverage, 11330,
     /* 247332 */     GIR_EraseRootFromParent_Done,
     /* 247333 */   // Label 4750: @247333
     /* 247333 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(247375), // Rule ID 11384 //
     /* 247338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247362 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 247365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247373 */     GIR_RootConstrainSelectedInstOperands,
     /* 247374 */     // GIR_Coverage, 11384,
     /* 247374 */     GIR_EraseRootFromParent_Done,
     /* 247375 */   // Label 4751: @247375
     /* 247375 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(247417), // Rule ID 11385 //
     /* 247380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 247407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247415 */     GIR_RootConstrainSelectedInstOperands,
     /* 247416 */     // GIR_Coverage, 11385,
     /* 247416 */     GIR_EraseRootFromParent_Done,
     /* 247417 */   // Label 4752: @247417
     /* 247417 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(247459), // Rule ID 11386 //
     /* 247422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 247449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247457 */     GIR_RootConstrainSelectedInstOperands,
     /* 247458 */     // GIR_Coverage, 11386,
     /* 247458 */     GIR_EraseRootFromParent_Done,
     /* 247459 */   // Label 4753: @247459
     /* 247459 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(247501), // Rule ID 11387 //
     /* 247464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1834:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 247491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247499 */     GIR_RootConstrainSelectedInstOperands,
     /* 247500 */     // GIR_Coverage, 11387,
     /* 247500 */     GIR_EraseRootFromParent_Done,
     /* 247501 */   // Label 4754: @247501
     /* 247501 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(247543), // Rule ID 11440 //
     /* 247506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 247533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247541 */     GIR_RootConstrainSelectedInstOperands,
     /* 247542 */     // GIR_Coverage, 11440,
     /* 247542 */     GIR_EraseRootFromParent_Done,
     /* 247543 */   // Label 4755: @247543
     /* 247543 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(247585), // Rule ID 11441 //
     /* 247548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 247575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247583 */     GIR_RootConstrainSelectedInstOperands,
     /* 247584 */     // GIR_Coverage, 11441,
     /* 247584 */     GIR_EraseRootFromParent_Done,
     /* 247585 */   // Label 4756: @247585
     /* 247585 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(247627), // Rule ID 11442 //
     /* 247590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 247617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247625 */     GIR_RootConstrainSelectedInstOperands,
     /* 247626 */     // GIR_Coverage, 11442,
     /* 247626 */     GIR_EraseRootFromParent_Done,
     /* 247627 */   // Label 4757: @247627
     /* 247627 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(247669), // Rule ID 11443 //
     /* 247632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 247659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247667 */     GIR_RootConstrainSelectedInstOperands,
     /* 247668 */     // GIR_Coverage, 11443,
     /* 247668 */     GIR_EraseRootFromParent_Done,
     /* 247669 */   // Label 4758: @247669
     /* 247669 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(247711), // Rule ID 11444 //
     /* 247674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 247701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247709 */     GIR_RootConstrainSelectedInstOperands,
     /* 247710 */     // GIR_Coverage, 11444,
     /* 247710 */     GIR_EraseRootFromParent_Done,
     /* 247711 */   // Label 4759: @247711
     /* 247711 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(247753), // Rule ID 11445 //
     /* 247716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247740 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 247743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247751 */     GIR_RootConstrainSelectedInstOperands,
     /* 247752 */     // GIR_Coverage, 11445,
     /* 247752 */     GIR_EraseRootFromParent_Done,
     /* 247753 */   // Label 4760: @247753
     /* 247753 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(247795), // Rule ID 11446 //
     /* 247758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 247785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247793 */     GIR_RootConstrainSelectedInstOperands,
     /* 247794 */     // GIR_Coverage, 11446,
     /* 247794 */     GIR_EraseRootFromParent_Done,
     /* 247795 */   // Label 4761: @247795
     /* 247795 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(247837), // Rule ID 11447 //
     /* 247800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 247827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247835 */     GIR_RootConstrainSelectedInstOperands,
     /* 247836 */     // GIR_Coverage, 11447,
     /* 247836 */     GIR_EraseRootFromParent_Done,
     /* 247837 */   // Label 4762: @247837
     /* 247837 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(247879), // Rule ID 11448 //
     /* 247842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 247869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247877 */     GIR_RootConstrainSelectedInstOperands,
     /* 247878 */     // GIR_Coverage, 11448,
     /* 247878 */     GIR_EraseRootFromParent_Done,
     /* 247879 */   // Label 4763: @247879
     /* 247879 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(247921), // Rule ID 11449 //
     /* 247884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 247911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247919 */     GIR_RootConstrainSelectedInstOperands,
     /* 247920 */     // GIR_Coverage, 11449,
     /* 247920 */     GIR_EraseRootFromParent_Done,
     /* 247921 */   // Label 4764: @247921
     /* 247921 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(247963), // Rule ID 11450 //
     /* 247926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 247953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247961 */     GIR_RootConstrainSelectedInstOperands,
     /* 247962 */     // GIR_Coverage, 11450,
     /* 247962 */     GIR_EraseRootFromParent_Done,
     /* 247963 */   // Label 4765: @247963
     /* 247963 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(248005), // Rule ID 11451 //
     /* 247968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247992 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 247995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248003 */     GIR_RootConstrainSelectedInstOperands,
     /* 248004 */     // GIR_Coverage, 11451,
     /* 248004 */     GIR_EraseRootFromParent_Done,
     /* 248005 */   // Label 4766: @248005
     /* 248005 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248047), // Rule ID 11452 //
     /* 248010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 248037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248045 */     GIR_RootConstrainSelectedInstOperands,
     /* 248046 */     // GIR_Coverage, 11452,
     /* 248046 */     GIR_EraseRootFromParent_Done,
     /* 248047 */   // Label 4767: @248047
     /* 248047 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248089), // Rule ID 11453 //
     /* 248052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 248079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248087 */     GIR_RootConstrainSelectedInstOperands,
     /* 248088 */     // GIR_Coverage, 11453,
     /* 248088 */     GIR_EraseRootFromParent_Done,
     /* 248089 */   // Label 4768: @248089
     /* 248089 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248131), // Rule ID 11454 //
     /* 248094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 248121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248129 */     GIR_RootConstrainSelectedInstOperands,
     /* 248130 */     // GIR_Coverage, 11454,
     /* 248130 */     GIR_EraseRootFromParent_Done,
     /* 248131 */   // Label 4769: @248131
     /* 248131 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248173), // Rule ID 11455 //
     /* 248136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 248163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248171 */     GIR_RootConstrainSelectedInstOperands,
     /* 248172 */     // GIR_Coverage, 11455,
     /* 248172 */     GIR_EraseRootFromParent_Done,
     /* 248173 */   // Label 4770: @248173
     /* 248173 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248215), // Rule ID 11456 //
     /* 248178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 248205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248213 */     GIR_RootConstrainSelectedInstOperands,
     /* 248214 */     // GIR_Coverage, 11456,
     /* 248214 */     GIR_EraseRootFromParent_Done,
     /* 248215 */   // Label 4771: @248215
     /* 248215 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248257), // Rule ID 11457 //
     /* 248220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 248247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248255 */     GIR_RootConstrainSelectedInstOperands,
     /* 248256 */     // GIR_Coverage, 11457,
     /* 248256 */     GIR_EraseRootFromParent_Done,
     /* 248257 */   // Label 4772: @248257
     /* 248257 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248299), // Rule ID 11458 //
     /* 248262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1997:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 248289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248297 */     GIR_RootConstrainSelectedInstOperands,
     /* 248298 */     // GIR_Coverage, 11458,
     /* 248298 */     GIR_EraseRootFromParent_Done,
     /* 248299 */   // Label 4773: @248299
     /* 248299 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248341), // Rule ID 11459 //
     /* 248304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1997:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 248331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248339 */     GIR_RootConstrainSelectedInstOperands,
     /* 248340 */     // GIR_Coverage, 11459,
     /* 248340 */     GIR_EraseRootFromParent_Done,
     /* 248341 */   // Label 4774: @248341
     /* 248341 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248383), // Rule ID 11460 //
     /* 248346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1997:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 248373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248381 */     GIR_RootConstrainSelectedInstOperands,
     /* 248382 */     // GIR_Coverage, 11460,
     /* 248382 */     GIR_EraseRootFromParent_Done,
     /* 248383 */   // Label 4775: @248383
     /* 248383 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(248425), // Rule ID 11469 //
     /* 248388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 248415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248423 */     GIR_RootConstrainSelectedInstOperands,
     /* 248424 */     // GIR_Coverage, 11469,
     /* 248424 */     GIR_EraseRootFromParent_Done,
     /* 248425 */   // Label 4776: @248425
     /* 248425 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(248467), // Rule ID 11470 //
     /* 248430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 248457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248465 */     GIR_RootConstrainSelectedInstOperands,
     /* 248466 */     // GIR_Coverage, 11470,
     /* 248466 */     GIR_EraseRootFromParent_Done,
     /* 248467 */   // Label 4777: @248467
     /* 248467 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(248509), // Rule ID 11471 //
     /* 248472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 248499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248507 */     GIR_RootConstrainSelectedInstOperands,
     /* 248508 */     // GIR_Coverage, 11471,
     /* 248508 */     GIR_EraseRootFromParent_Done,
     /* 248509 */   // Label 4778: @248509
     /* 248509 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(248551), // Rule ID 11472 //
     /* 248514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248538 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1798:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 248541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248549 */     GIR_RootConstrainSelectedInstOperands,
     /* 248550 */     // GIR_Coverage, 11472,
     /* 248550 */     GIR_EraseRootFromParent_Done,
     /* 248551 */   // Label 4779: @248551
     /* 248551 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(248593), // Rule ID 11473 //
     /* 248556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1798:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 248583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248591 */     GIR_RootConstrainSelectedInstOperands,
     /* 248592 */     // GIR_Coverage, 11473,
     /* 248592 */     GIR_EraseRootFromParent_Done,
     /* 248593 */   // Label 4780: @248593
     /* 248593 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(248635), // Rule ID 11474 //
     /* 248598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1798:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 248625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248633 */     GIR_RootConstrainSelectedInstOperands,
     /* 248634 */     // GIR_Coverage, 11474,
     /* 248634 */     GIR_EraseRootFromParent_Done,
     /* 248635 */   // Label 4781: @248635
     /* 248635 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(248677), // Rule ID 11475 //
     /* 248640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1800:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 248667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248675 */     GIR_RootConstrainSelectedInstOperands,
     /* 248676 */     // GIR_Coverage, 11475,
     /* 248676 */     GIR_EraseRootFromParent_Done,
     /* 248677 */   // Label 4782: @248677
     /* 248677 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(248719), // Rule ID 11476 //
     /* 248682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1800:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 248709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248717 */     GIR_RootConstrainSelectedInstOperands,
     /* 248718 */     // GIR_Coverage, 11476,
     /* 248718 */     GIR_EraseRootFromParent_Done,
     /* 248719 */   // Label 4783: @248719
     /* 248719 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(248761), // Rule ID 11477 //
     /* 248724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1800:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 248751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248759 */     GIR_RootConstrainSelectedInstOperands,
     /* 248760 */     // GIR_Coverage, 11477,
     /* 248760 */     GIR_EraseRootFromParent_Done,
     /* 248761 */   // Label 4784: @248761
     /* 248761 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(248803), // Rule ID 11478 //
     /* 248766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 248793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248801 */     GIR_RootConstrainSelectedInstOperands,
     /* 248802 */     // GIR_Coverage, 11478,
     /* 248802 */     GIR_EraseRootFromParent_Done,
     /* 248803 */   // Label 4785: @248803
     /* 248803 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(248845), // Rule ID 11479 //
     /* 248808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 248835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248843 */     GIR_RootConstrainSelectedInstOperands,
     /* 248844 */     // GIR_Coverage, 11479,
     /* 248844 */     GIR_EraseRootFromParent_Done,
     /* 248845 */   // Label 4786: @248845
     /* 248845 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(248887), // Rule ID 11480 //
     /* 248850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 248877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248885 */     GIR_RootConstrainSelectedInstOperands,
     /* 248886 */     // GIR_Coverage, 11480,
     /* 248886 */     GIR_EraseRootFromParent_Done,
     /* 248887 */   // Label 4787: @248887
     /* 248887 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(248929), // Rule ID 11481 //
     /* 248892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 248919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248927 */     GIR_RootConstrainSelectedInstOperands,
     /* 248928 */     // GIR_Coverage, 11481,
     /* 248928 */     GIR_EraseRootFromParent_Done,
     /* 248929 */   // Label 4788: @248929
     /* 248929 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(248971), // Rule ID 11482 //
     /* 248934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 248961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248969 */     GIR_RootConstrainSelectedInstOperands,
     /* 248970 */     // GIR_Coverage, 11482,
     /* 248970 */     GIR_EraseRootFromParent_Done,
     /* 248971 */   // Label 4789: @248971
     /* 248971 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249013), // Rule ID 11483 //
     /* 248976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 249003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249011 */     GIR_RootConstrainSelectedInstOperands,
     /* 249012 */     // GIR_Coverage, 11483,
     /* 249012 */     GIR_EraseRootFromParent_Done,
     /* 249013 */   // Label 4790: @249013
     /* 249013 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249055), // Rule ID 11484 //
     /* 249018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249042 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 249045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249053 */     GIR_RootConstrainSelectedInstOperands,
     /* 249054 */     // GIR_Coverage, 11484,
     /* 249054 */     GIR_EraseRootFromParent_Done,
     /* 249055 */   // Label 4791: @249055
     /* 249055 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249097), // Rule ID 11485 //
     /* 249060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 249087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249093 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249095 */     GIR_RootConstrainSelectedInstOperands,
     /* 249096 */     // GIR_Coverage, 11485,
     /* 249096 */     GIR_EraseRootFromParent_Done,
     /* 249097 */   // Label 4792: @249097
     /* 249097 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(249139), // Rule ID 11486 //
     /* 249102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 249129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249137 */     GIR_RootConstrainSelectedInstOperands,
     /* 249138 */     // GIR_Coverage, 11486,
     /* 249138 */     GIR_EraseRootFromParent_Done,
     /* 249139 */   // Label 4793: @249139
     /* 249139 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(249181), // Rule ID 11487 //
     /* 249144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 249171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249179 */     GIR_RootConstrainSelectedInstOperands,
     /* 249180 */     // GIR_Coverage, 11487,
     /* 249180 */     GIR_EraseRootFromParent_Done,
     /* 249181 */   // Label 4794: @249181
     /* 249181 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(249223), // Rule ID 11489 //
     /* 249186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 249213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249221 */     GIR_RootConstrainSelectedInstOperands,
     /* 249222 */     // GIR_Coverage, 11489,
     /* 249222 */     GIR_EraseRootFromParent_Done,
     /* 249223 */   // Label 4795: @249223
     /* 249223 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(249265), // Rule ID 11491 //
     /* 249228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 249255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249263 */     GIR_RootConstrainSelectedInstOperands,
     /* 249264 */     // GIR_Coverage, 11491,
     /* 249264 */     GIR_EraseRootFromParent_Done,
     /* 249265 */   // Label 4796: @249265
     /* 249265 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(249307), // Rule ID 11493 //
     /* 249270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 249297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249305 */     GIR_RootConstrainSelectedInstOperands,
     /* 249306 */     // GIR_Coverage, 11493,
     /* 249306 */     GIR_EraseRootFromParent_Done,
     /* 249307 */   // Label 4797: @249307
     /* 249307 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(249349), // Rule ID 11495 //
     /* 249312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249336 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 249339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249347 */     GIR_RootConstrainSelectedInstOperands,
     /* 249348 */     // GIR_Coverage, 11495,
     /* 249348 */     GIR_EraseRootFromParent_Done,
     /* 249349 */   // Label 4798: @249349
     /* 249349 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(249391), // Rule ID 11496 //
     /* 249354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 249381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249389 */     GIR_RootConstrainSelectedInstOperands,
     /* 249390 */     // GIR_Coverage, 11496,
     /* 249390 */     GIR_EraseRootFromParent_Done,
     /* 249391 */   // Label 4799: @249391
     /* 249391 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(249433), // Rule ID 11497 //
     /* 249396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 249423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249431 */     GIR_RootConstrainSelectedInstOperands,
     /* 249432 */     // GIR_Coverage, 11497,
     /* 249432 */     GIR_EraseRootFromParent_Done,
     /* 249433 */   // Label 4800: @249433
     /* 249433 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(249475), // Rule ID 11498 //
     /* 249438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 249465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249473 */     GIR_RootConstrainSelectedInstOperands,
     /* 249474 */     // GIR_Coverage, 11498,
     /* 249474 */     GIR_EraseRootFromParent_Done,
     /* 249475 */   // Label 4801: @249475
     /* 249475 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(249517), // Rule ID 11499 //
     /* 249480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1971:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 249507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249515 */     GIR_RootConstrainSelectedInstOperands,
     /* 249516 */     // GIR_Coverage, 11499,
     /* 249516 */     GIR_EraseRootFromParent_Done,
     /* 249517 */   // Label 4802: @249517
     /* 249517 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(249559), // Rule ID 11500 //
     /* 249522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 249549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249557 */     GIR_RootConstrainSelectedInstOperands,
     /* 249558 */     // GIR_Coverage, 11500,
     /* 249558 */     GIR_EraseRootFromParent_Done,
     /* 249559 */   // Label 4803: @249559
     /* 249559 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(249601), // Rule ID 11501 //
     /* 249564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 249591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249599 */     GIR_RootConstrainSelectedInstOperands,
     /* 249600 */     // GIR_Coverage, 11501,
     /* 249600 */     GIR_EraseRootFromParent_Done,
     /* 249601 */   // Label 4804: @249601
     /* 249601 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(249643), // Rule ID 11502 //
     /* 249606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 249633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249641 */     GIR_RootConstrainSelectedInstOperands,
     /* 249642 */     // GIR_Coverage, 11502,
     /* 249642 */     GIR_EraseRootFromParent_Done,
     /* 249643 */   // Label 4805: @249643
     /* 249643 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(249685), // Rule ID 11503 //
     /* 249648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1865:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 249675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249683 */     GIR_RootConstrainSelectedInstOperands,
     /* 249684 */     // GIR_Coverage, 11503,
     /* 249684 */     GIR_EraseRootFromParent_Done,
     /* 249685 */   // Label 4806: @249685
     /* 249685 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(249727), // Rule ID 11505 //
     /* 249690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 249717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249725 */     GIR_RootConstrainSelectedInstOperands,
     /* 249726 */     // GIR_Coverage, 11505,
     /* 249726 */     GIR_EraseRootFromParent_Done,
     /* 249727 */   // Label 4807: @249727
     /* 249727 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(249769), // Rule ID 11507 //
     /* 249732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 249759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249767 */     GIR_RootConstrainSelectedInstOperands,
     /* 249768 */     // GIR_Coverage, 11507,
     /* 249768 */     GIR_EraseRootFromParent_Done,
     /* 249769 */   // Label 4808: @249769
     /* 249769 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249811), // Rule ID 11509 //
     /* 249774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 249801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249809 */     GIR_RootConstrainSelectedInstOperands,
     /* 249810 */     // GIR_Coverage, 11509,
     /* 249810 */     GIR_EraseRootFromParent_Done,
     /* 249811 */   // Label 4809: @249811
     /* 249811 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249853), // Rule ID 11511 //
     /* 249816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249840 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2057:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 249843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249851 */     GIR_RootConstrainSelectedInstOperands,
     /* 249852 */     // GIR_Coverage, 11511,
     /* 249852 */     GIR_EraseRootFromParent_Done,
     /* 249853 */   // Label 4810: @249853
     /* 249853 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249895), // Rule ID 11513 //
     /* 249858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2057:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 249885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249893 */     GIR_RootConstrainSelectedInstOperands,
     /* 249894 */     // GIR_Coverage, 11513,
     /* 249894 */     GIR_EraseRootFromParent_Done,
     /* 249895 */   // Label 4811: @249895
     /* 249895 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249937), // Rule ID 11515 //
     /* 249900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 249927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249935 */     GIR_RootConstrainSelectedInstOperands,
     /* 249936 */     // GIR_Coverage, 11515,
     /* 249936 */     GIR_EraseRootFromParent_Done,
     /* 249937 */   // Label 4812: @249937
     /* 249937 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249979), // Rule ID 11517 //
     /* 249942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2057:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 249969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249977 */     GIR_RootConstrainSelectedInstOperands,
     /* 249978 */     // GIR_Coverage, 11517,
     /* 249978 */     GIR_EraseRootFromParent_Done,
     /* 249979 */   // Label 4813: @249979
     /* 249979 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(250021), // Rule ID 11519 //
     /* 249984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 249992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250008 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 250011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250019 */     GIR_RootConstrainSelectedInstOperands,
     /* 250020 */     // GIR_Coverage, 11519,
     /* 250020 */     GIR_EraseRootFromParent_Done,
     /* 250021 */   // Label 4814: @250021
     /* 250021 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(250063), // Rule ID 11520 //
     /* 250026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 250053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250061 */     GIR_RootConstrainSelectedInstOperands,
     /* 250062 */     // GIR_Coverage, 11520,
     /* 250062 */     GIR_EraseRootFromParent_Done,
     /* 250063 */   // Label 4815: @250063
     /* 250063 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(250105), // Rule ID 11521 //
     /* 250068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 250095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250103 */     GIR_RootConstrainSelectedInstOperands,
     /* 250104 */     // GIR_Coverage, 11521,
     /* 250104 */     GIR_EraseRootFromParent_Done,
     /* 250105 */   // Label 4816: @250105
     /* 250105 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(250147), // Rule ID 11522 //
     /* 250110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 250137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250145 */     GIR_RootConstrainSelectedInstOperands,
     /* 250146 */     // GIR_Coverage, 11522,
     /* 250146 */     GIR_EraseRootFromParent_Done,
     /* 250147 */   // Label 4817: @250147
     /* 250147 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(250189), // Rule ID 11523 //
     /* 250152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250176 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1972:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 250179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250187 */     GIR_RootConstrainSelectedInstOperands,
     /* 250188 */     // GIR_Coverage, 11523,
     /* 250188 */     GIR_EraseRootFromParent_Done,
     /* 250189 */   // Label 4818: @250189
     /* 250189 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(250231), // Rule ID 11524 //
     /* 250194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1972:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 250221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250229 */     GIR_RootConstrainSelectedInstOperands,
     /* 250230 */     // GIR_Coverage, 11524,
     /* 250230 */     GIR_EraseRootFromParent_Done,
     /* 250231 */   // Label 4819: @250231
     /* 250231 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(250273), // Rule ID 11525 //
     /* 250236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 250263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250271 */     GIR_RootConstrainSelectedInstOperands,
     /* 250272 */     // GIR_Coverage, 11525,
     /* 250272 */     GIR_EraseRootFromParent_Done,
     /* 250273 */   // Label 4820: @250273
     /* 250273 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(250315), // Rule ID 11526 //
     /* 250278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 250305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250313 */     GIR_RootConstrainSelectedInstOperands,
     /* 250314 */     // GIR_Coverage, 11526,
     /* 250314 */     GIR_EraseRootFromParent_Done,
     /* 250315 */   // Label 4821: @250315
     /* 250315 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(250357), // Rule ID 11527 //
     /* 250320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1947:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 250347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250355 */     GIR_RootConstrainSelectedInstOperands,
     /* 250356 */     // GIR_Coverage, 11527,
     /* 250356 */     GIR_EraseRootFromParent_Done,
     /* 250357 */   // Label 4822: @250357
     /* 250357 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(250399), // Rule ID 11528 //
     /* 250362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1947:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 250389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250397 */     GIR_RootConstrainSelectedInstOperands,
     /* 250398 */     // GIR_Coverage, 11528,
     /* 250398 */     GIR_EraseRootFromParent_Done,
     /* 250399 */   // Label 4823: @250399
     /* 250399 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(250441), // Rule ID 11529 //
     /* 250404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1947:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 250431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250439 */     GIR_RootConstrainSelectedInstOperands,
     /* 250440 */     // GIR_Coverage, 11529,
     /* 250440 */     GIR_EraseRootFromParent_Done,
     /* 250441 */   // Label 4824: @250441
     /* 250441 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250483), // Rule ID 11530 //
     /* 250446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1262:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 250473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250481 */     GIR_RootConstrainSelectedInstOperands,
     /* 250482 */     // GIR_Coverage, 11530,
     /* 250482 */     GIR_EraseRootFromParent_Done,
     /* 250483 */   // Label 4825: @250483
     /* 250483 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250525), // Rule ID 11531 //
     /* 250488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1262:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 250515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250523 */     GIR_RootConstrainSelectedInstOperands,
     /* 250524 */     // GIR_Coverage, 11531,
     /* 250524 */     GIR_EraseRootFromParent_Done,
     /* 250525 */   // Label 4826: @250525
     /* 250525 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250567), // Rule ID 11532 //
     /* 250530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1262:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 250557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250565 */     GIR_RootConstrainSelectedInstOperands,
     /* 250566 */     // GIR_Coverage, 11532,
     /* 250566 */     GIR_EraseRootFromParent_Done,
     /* 250567 */   // Label 4827: @250567
     /* 250567 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250609), // Rule ID 11533 //
     /* 250572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1262:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 250599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250607 */     GIR_RootConstrainSelectedInstOperands,
     /* 250608 */     // GIR_Coverage, 11533,
     /* 250608 */     GIR_EraseRootFromParent_Done,
     /* 250609 */   // Label 4828: @250609
     /* 250609 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250651), // Rule ID 11534 //
     /* 250614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 250641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250649 */     GIR_RootConstrainSelectedInstOperands,
     /* 250650 */     // GIR_Coverage, 11534,
     /* 250650 */     GIR_EraseRootFromParent_Done,
     /* 250651 */   // Label 4829: @250651
     /* 250651 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250693), // Rule ID 11535 //
     /* 250656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 250683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250691 */     GIR_RootConstrainSelectedInstOperands,
     /* 250692 */     // GIR_Coverage, 11535,
     /* 250692 */     GIR_EraseRootFromParent_Done,
     /* 250693 */   // Label 4830: @250693
     /* 250693 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250735), // Rule ID 11536 //
     /* 250698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 250725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250733 */     GIR_RootConstrainSelectedInstOperands,
     /* 250734 */     // GIR_Coverage, 11536,
     /* 250734 */     GIR_EraseRootFromParent_Done,
     /* 250735 */   // Label 4831: @250735
     /* 250735 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250777), // Rule ID 11537 //
     /* 250740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 250767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250775 */     GIR_RootConstrainSelectedInstOperands,
     /* 250776 */     // GIR_Coverage, 11537,
     /* 250776 */     GIR_EraseRootFromParent_Done,
     /* 250777 */   // Label 4832: @250777
     /* 250777 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250819), // Rule ID 11538 //
     /* 250782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250806 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 250809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250817 */     GIR_RootConstrainSelectedInstOperands,
     /* 250818 */     // GIR_Coverage, 11538,
     /* 250818 */     GIR_EraseRootFromParent_Done,
     /* 250819 */   // Label 4833: @250819
     /* 250819 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250861), // Rule ID 11539 //
     /* 250824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 250851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250859 */     GIR_RootConstrainSelectedInstOperands,
     /* 250860 */     // GIR_Coverage, 11539,
     /* 250860 */     GIR_EraseRootFromParent_Done,
     /* 250861 */   // Label 4834: @250861
     /* 250861 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250903), // Rule ID 11540 //
     /* 250866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 250893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250901 */     GIR_RootConstrainSelectedInstOperands,
     /* 250902 */     // GIR_Coverage, 11540,
     /* 250902 */     GIR_EraseRootFromParent_Done,
     /* 250903 */   // Label 4835: @250903
     /* 250903 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250945), // Rule ID 11541 //
     /* 250908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 250935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250943 */     GIR_RootConstrainSelectedInstOperands,
     /* 250944 */     // GIR_Coverage, 11541,
     /* 250944 */     GIR_EraseRootFromParent_Done,
     /* 250945 */   // Label 4836: @250945
     /* 250945 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250987), // Rule ID 11542 //
     /* 250950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 250958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 250977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250985 */     GIR_RootConstrainSelectedInstOperands,
     /* 250986 */     // GIR_Coverage, 11542,
     /* 250986 */     GIR_EraseRootFromParent_Done,
     /* 250987 */   // Label 4837: @250987
     /* 250987 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(251029), // Rule ID 11543 //
     /* 250992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 251019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251027 */     GIR_RootConstrainSelectedInstOperands,
     /* 251028 */     // GIR_Coverage, 11543,
     /* 251028 */     GIR_EraseRootFromParent_Done,
     /* 251029 */   // Label 4838: @251029
     /* 251029 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(251071), // Rule ID 11544 //
     /* 251034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 251061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251069 */     GIR_RootConstrainSelectedInstOperands,
     /* 251070 */     // GIR_Coverage, 11544,
     /* 251070 */     GIR_EraseRootFromParent_Done,
     /* 251071 */   // Label 4839: @251071
     /* 251071 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251113), // Rule ID 11545 //
     /* 251076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 251103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251111 */     GIR_RootConstrainSelectedInstOperands,
     /* 251112 */     // GIR_Coverage, 11545,
     /* 251112 */     GIR_EraseRootFromParent_Done,
     /* 251113 */   // Label 4840: @251113
     /* 251113 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251155), // Rule ID 11546 //
     /* 251118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 251145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251153 */     GIR_RootConstrainSelectedInstOperands,
     /* 251154 */     // GIR_Coverage, 11546,
     /* 251154 */     GIR_EraseRootFromParent_Done,
     /* 251155 */   // Label 4841: @251155
     /* 251155 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251197), // Rule ID 11547 //
     /* 251160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 251187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251195 */     GIR_RootConstrainSelectedInstOperands,
     /* 251196 */     // GIR_Coverage, 11547,
     /* 251196 */     GIR_EraseRootFromParent_Done,
     /* 251197 */   // Label 4842: @251197
     /* 251197 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251239), // Rule ID 11548 //
     /* 251202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 251229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251237 */     GIR_RootConstrainSelectedInstOperands,
     /* 251238 */     // GIR_Coverage, 11548,
     /* 251238 */     GIR_EraseRootFromParent_Done,
     /* 251239 */   // Label 4843: @251239
     /* 251239 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251281), // Rule ID 11549 //
     /* 251244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 251271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251279 */     GIR_RootConstrainSelectedInstOperands,
     /* 251280 */     // GIR_Coverage, 11549,
     /* 251280 */     GIR_EraseRootFromParent_Done,
     /* 251281 */   // Label 4844: @251281
     /* 251281 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251323), // Rule ID 11550 //
     /* 251286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 251294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 251313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251321 */     GIR_RootConstrainSelectedInstOperands,
     /* 251322 */     // GIR_Coverage, 11550,
     /* 251322 */     GIR_EraseRootFromParent_Done,
     /* 251323 */   // Label 4845: @251323
     /* 251323 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251365), // Rule ID 11561 //
     /* 251328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 251355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251363 */     GIR_RootConstrainSelectedInstOperands,
     /* 251364 */     // GIR_Coverage, 11561,
     /* 251364 */     GIR_EraseRootFromParent_Done,
     /* 251365 */   // Label 4846: @251365
     /* 251365 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251407), // Rule ID 11562 //
     /* 251370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 251397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251405 */     GIR_RootConstrainSelectedInstOperands,
     /* 251406 */     // GIR_Coverage, 11562,
     /* 251406 */     GIR_EraseRootFromParent_Done,
     /* 251407 */   // Label 4847: @251407
     /* 251407 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251449), // Rule ID 11563 //
     /* 251412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 251439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251447 */     GIR_RootConstrainSelectedInstOperands,
     /* 251448 */     // GIR_Coverage, 11563,
     /* 251448 */     GIR_EraseRootFromParent_Done,
     /* 251449 */   // Label 4848: @251449
     /* 251449 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251491), // Rule ID 11564 //
     /* 251454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251478 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 251481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251489 */     GIR_RootConstrainSelectedInstOperands,
     /* 251490 */     // GIR_Coverage, 11564,
     /* 251490 */     GIR_EraseRootFromParent_Done,
     /* 251491 */   // Label 4849: @251491
     /* 251491 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251533), // Rule ID 11573 //
     /* 251496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1770:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 251523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251531 */     GIR_RootConstrainSelectedInstOperands,
     /* 251532 */     // GIR_Coverage, 11573,
     /* 251532 */     GIR_EraseRootFromParent_Done,
     /* 251533 */   // Label 4850: @251533
     /* 251533 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251575), // Rule ID 11574 //
     /* 251538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1770:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 251565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251573 */     GIR_RootConstrainSelectedInstOperands,
     /* 251574 */     // GIR_Coverage, 11574,
     /* 251574 */     GIR_EraseRootFromParent_Done,
     /* 251575 */   // Label 4851: @251575
     /* 251575 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251617), // Rule ID 11575 //
     /* 251580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1770:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 251607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251615 */     GIR_RootConstrainSelectedInstOperands,
     /* 251616 */     // GIR_Coverage, 11575,
     /* 251616 */     GIR_EraseRootFromParent_Done,
     /* 251617 */   // Label 4852: @251617
     /* 251617 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251659), // Rule ID 11576 //
     /* 251622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1770:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 251649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251657 */     GIR_RootConstrainSelectedInstOperands,
     /* 251658 */     // GIR_Coverage, 11576,
     /* 251658 */     GIR_EraseRootFromParent_Done,
     /* 251659 */   // Label 4853: @251659
     /* 251659 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251701), // Rule ID 11577 //
     /* 251664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2006:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 251691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251699 */     GIR_RootConstrainSelectedInstOperands,
     /* 251700 */     // GIR_Coverage, 11577,
     /* 251700 */     GIR_EraseRootFromParent_Done,
     /* 251701 */   // Label 4854: @251701
     /* 251701 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(251743), // Rule ID 11578 //
     /* 251706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2006:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 251733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251741 */     GIR_RootConstrainSelectedInstOperands,
     /* 251742 */     // GIR_Coverage, 11578,
     /* 251742 */     GIR_EraseRootFromParent_Done,
     /* 251743 */   // Label 4855: @251743
     /* 251743 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(251785), // Rule ID 11579 //
     /* 251748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2006:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 251775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251783 */     GIR_RootConstrainSelectedInstOperands,
     /* 251784 */     // GIR_Coverage, 11579,
     /* 251784 */     GIR_EraseRootFromParent_Done,
     /* 251785 */   // Label 4856: @251785
     /* 251785 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(251827), // Rule ID 11580 //
     /* 251790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2006:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 251817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251825 */     GIR_RootConstrainSelectedInstOperands,
     /* 251826 */     // GIR_Coverage, 11580,
     /* 251826 */     GIR_EraseRootFromParent_Done,
     /* 251827 */   // Label 4857: @251827
     /* 251827 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(251869), // Rule ID 11581 //
     /* 251832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 251859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251867 */     GIR_RootConstrainSelectedInstOperands,
     /* 251868 */     // GIR_Coverage, 11581,
     /* 251868 */     GIR_EraseRootFromParent_Done,
     /* 251869 */   // Label 4858: @251869
     /* 251869 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(251911), // Rule ID 11582 //
     /* 251874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 251901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251909 */     GIR_RootConstrainSelectedInstOperands,
     /* 251910 */     // GIR_Coverage, 11582,
     /* 251910 */     GIR_EraseRootFromParent_Done,
     /* 251911 */   // Label 4859: @251911
     /* 251911 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(251953), // Rule ID 11583 //
     /* 251916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 251943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251951 */     GIR_RootConstrainSelectedInstOperands,
     /* 251952 */     // GIR_Coverage, 11583,
     /* 251952 */     GIR_EraseRootFromParent_Done,
     /* 251953 */   // Label 4860: @251953
     /* 251953 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(251995), // Rule ID 11584 //
     /* 251958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 251985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251993 */     GIR_RootConstrainSelectedInstOperands,
     /* 251994 */     // GIR_Coverage, 11584,
     /* 251994 */     GIR_EraseRootFromParent_Done,
     /* 251995 */   // Label 4861: @251995
     /* 251995 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252037), // Rule ID 11585 //
     /* 252000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2050:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 252027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252035 */     GIR_RootConstrainSelectedInstOperands,
     /* 252036 */     // GIR_Coverage, 11585,
     /* 252036 */     GIR_EraseRootFromParent_Done,
     /* 252037 */   // Label 4862: @252037
     /* 252037 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252079), // Rule ID 11586 //
     /* 252042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 252069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252077 */     GIR_RootConstrainSelectedInstOperands,
     /* 252078 */     // GIR_Coverage, 11586,
     /* 252078 */     GIR_EraseRootFromParent_Done,
     /* 252079 */   // Label 4863: @252079
     /* 252079 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252121), // Rule ID 11587 //
     /* 252084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 252111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252119 */     GIR_RootConstrainSelectedInstOperands,
     /* 252120 */     // GIR_Coverage, 11587,
     /* 252120 */     GIR_EraseRootFromParent_Done,
     /* 252121 */   // Label 4864: @252121
     /* 252121 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252163), // Rule ID 11588 //
     /* 252126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 252153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252161 */     GIR_RootConstrainSelectedInstOperands,
     /* 252162 */     // GIR_Coverage, 11588,
     /* 252162 */     GIR_EraseRootFromParent_Done,
     /* 252163 */   // Label 4865: @252163
     /* 252163 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252205), // Rule ID 11589 //
     /* 252168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 252195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252203 */     GIR_RootConstrainSelectedInstOperands,
     /* 252204 */     // GIR_Coverage, 11589,
     /* 252204 */     GIR_EraseRootFromParent_Done,
     /* 252205 */   // Label 4866: @252205
     /* 252205 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252247), // Rule ID 11590 //
     /* 252210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1921:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 252237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252245 */     GIR_RootConstrainSelectedInstOperands,
     /* 252246 */     // GIR_Coverage, 11590,
     /* 252246 */     GIR_EraseRootFromParent_Done,
     /* 252247 */   // Label 4867: @252247
     /* 252247 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252289), // Rule ID 11591 //
     /* 252252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1921:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 252279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252287 */     GIR_RootConstrainSelectedInstOperands,
     /* 252288 */     // GIR_Coverage, 11591,
     /* 252288 */     GIR_EraseRootFromParent_Done,
     /* 252289 */   // Label 4868: @252289
     /* 252289 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252331), // Rule ID 11592 //
     /* 252294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1921:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 252321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252329 */     GIR_RootConstrainSelectedInstOperands,
     /* 252330 */     // GIR_Coverage, 11592,
     /* 252330 */     GIR_EraseRootFromParent_Done,
     /* 252331 */   // Label 4869: @252331
     /* 252331 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252373), // Rule ID 11593 //
     /* 252336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2071:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 252363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252371 */     GIR_RootConstrainSelectedInstOperands,
     /* 252372 */     // GIR_Coverage, 11593,
     /* 252372 */     GIR_EraseRootFromParent_Done,
     /* 252373 */   // Label 4870: @252373
     /* 252373 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(252415), // Rule ID 11594 //
     /* 252378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 252405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252413 */     GIR_RootConstrainSelectedInstOperands,
     /* 252414 */     // GIR_Coverage, 11594,
     /* 252414 */     GIR_EraseRootFromParent_Done,
     /* 252415 */   // Label 4871: @252415
     /* 252415 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(252457), // Rule ID 11595 //
     /* 252420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 252447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252455 */     GIR_RootConstrainSelectedInstOperands,
     /* 252456 */     // GIR_Coverage, 11595,
     /* 252456 */     GIR_EraseRootFromParent_Done,
     /* 252457 */   // Label 4872: @252457
     /* 252457 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(252499), // Rule ID 11596 //
     /* 252462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 252489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252497 */     GIR_RootConstrainSelectedInstOperands,
     /* 252498 */     // GIR_Coverage, 11596,
     /* 252498 */     GIR_EraseRootFromParent_Done,
     /* 252499 */   // Label 4873: @252499
     /* 252499 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(252541), // Rule ID 11597 //
     /* 252504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1860:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 252531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252539 */     GIR_RootConstrainSelectedInstOperands,
     /* 252540 */     // GIR_Coverage, 11597,
     /* 252540 */     GIR_EraseRootFromParent_Done,
     /* 252541 */   // Label 4874: @252541
     /* 252541 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(252583), // Rule ID 11598 //
     /* 252546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 252573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252581 */     GIR_RootConstrainSelectedInstOperands,
     /* 252582 */     // GIR_Coverage, 11598,
     /* 252582 */     GIR_EraseRootFromParent_Done,
     /* 252583 */   // Label 4875: @252583
     /* 252583 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(252625), // Rule ID 11599 //
     /* 252588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 252615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252623 */     GIR_RootConstrainSelectedInstOperands,
     /* 252624 */     // GIR_Coverage, 11599,
     /* 252624 */     GIR_EraseRootFromParent_Done,
     /* 252625 */   // Label 4876: @252625
     /* 252625 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(252667), // Rule ID 11600 //
     /* 252630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1860:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 252657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252665 */     GIR_RootConstrainSelectedInstOperands,
     /* 252666 */     // GIR_Coverage, 11600,
     /* 252666 */     GIR_EraseRootFromParent_Done,
     /* 252667 */   // Label 4877: @252667
     /* 252667 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(252709), // Rule ID 11601 //
     /* 252672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 252699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252707 */     GIR_RootConstrainSelectedInstOperands,
     /* 252708 */     // GIR_Coverage, 11601,
     /* 252708 */     GIR_EraseRootFromParent_Done,
     /* 252709 */   // Label 4878: @252709
     /* 252709 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(252751), // Rule ID 11602 //
     /* 252714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252738 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 252741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252749 */     GIR_RootConstrainSelectedInstOperands,
     /* 252750 */     // GIR_Coverage, 11602,
     /* 252750 */     GIR_EraseRootFromParent_Done,
     /* 252751 */   // Label 4879: @252751
     /* 252751 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(252793), // Rule ID 11603 //
     /* 252756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 252783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252791 */     GIR_RootConstrainSelectedInstOperands,
     /* 252792 */     // GIR_Coverage, 11603,
     /* 252792 */     GIR_EraseRootFromParent_Done,
     /* 252793 */   // Label 4880: @252793
     /* 252793 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(252835), // Rule ID 11604 //
     /* 252798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 252825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252833 */     GIR_RootConstrainSelectedInstOperands,
     /* 252834 */     // GIR_Coverage, 11604,
     /* 252834 */     GIR_EraseRootFromParent_Done,
     /* 252835 */   // Label 4881: @252835
     /* 252835 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(252877), // Rule ID 11605 //
     /* 252840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 252867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252875 */     GIR_RootConstrainSelectedInstOperands,
     /* 252876 */     // GIR_Coverage, 11605,
     /* 252876 */     GIR_EraseRootFromParent_Done,
     /* 252877 */   // Label 4882: @252877
     /* 252877 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(252919), // Rule ID 11606 //
     /* 252882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 252909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252917 */     GIR_RootConstrainSelectedInstOperands,
     /* 252918 */     // GIR_Coverage, 11606,
     /* 252918 */     GIR_EraseRootFromParent_Done,
     /* 252919 */   // Label 4883: @252919
     /* 252919 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(252961), // Rule ID 11607 //
     /* 252924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 252951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252959 */     GIR_RootConstrainSelectedInstOperands,
     /* 252960 */     // GIR_Coverage, 11607,
     /* 252960 */     GIR_EraseRootFromParent_Done,
     /* 252961 */   // Label 4884: @252961
     /* 252961 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253003), // Rule ID 11608 //
     /* 252966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 252993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253001 */     GIR_RootConstrainSelectedInstOperands,
     /* 253002 */     // GIR_Coverage, 11608,
     /* 253002 */     GIR_EraseRootFromParent_Done,
     /* 253003 */   // Label 4885: @253003
     /* 253003 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253045), // Rule ID 11609 //
     /* 253008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2058:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 253035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253043 */     GIR_RootConstrainSelectedInstOperands,
     /* 253044 */     // GIR_Coverage, 11609,
     /* 253044 */     GIR_EraseRootFromParent_Done,
     /* 253045 */   // Label 4886: @253045
     /* 253045 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253087), // Rule ID 11610 //
     /* 253050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253074 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 253077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253085 */     GIR_RootConstrainSelectedInstOperands,
     /* 253086 */     // GIR_Coverage, 11610,
     /* 253086 */     GIR_EraseRootFromParent_Done,
     /* 253087 */   // Label 4887: @253087
     /* 253087 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253129), // Rule ID 11611 //
     /* 253092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 253119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253127 */     GIR_RootConstrainSelectedInstOperands,
     /* 253128 */     // GIR_Coverage, 11611,
     /* 253128 */     GIR_EraseRootFromParent_Done,
     /* 253129 */   // Label 4888: @253129
     /* 253129 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(253171), // Rule ID 11612 //
     /* 253134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 253161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253169 */     GIR_RootConstrainSelectedInstOperands,
     /* 253170 */     // GIR_Coverage, 11612,
     /* 253170 */     GIR_EraseRootFromParent_Done,
     /* 253171 */   // Label 4889: @253171
     /* 253171 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(253213), // Rule ID 11613 //
     /* 253176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 253203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253211 */     GIR_RootConstrainSelectedInstOperands,
     /* 253212 */     // GIR_Coverage, 11613,
     /* 253212 */     GIR_EraseRootFromParent_Done,
     /* 253213 */   // Label 4890: @253213
     /* 253213 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(253255), // Rule ID 11614 //
     /* 253218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 253245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253253 */     GIR_RootConstrainSelectedInstOperands,
     /* 253254 */     // GIR_Coverage, 11614,
     /* 253254 */     GIR_EraseRootFromParent_Done,
     /* 253255 */   // Label 4891: @253255
     /* 253255 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(253297), // Rule ID 11615 //
     /* 253260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 253287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253295 */     GIR_RootConstrainSelectedInstOperands,
     /* 253296 */     // GIR_Coverage, 11615,
     /* 253296 */     GIR_EraseRootFromParent_Done,
     /* 253297 */   // Label 4892: @253297
     /* 253297 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(253339), // Rule ID 11616 //
     /* 253302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 253329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253337 */     GIR_RootConstrainSelectedInstOperands,
     /* 253338 */     // GIR_Coverage, 11616,
     /* 253338 */     GIR_EraseRootFromParent_Done,
     /* 253339 */   // Label 4893: @253339
     /* 253339 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(253381), // Rule ID 11617 //
     /* 253344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 253371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253379 */     GIR_RootConstrainSelectedInstOperands,
     /* 253380 */     // GIR_Coverage, 11617,
     /* 253380 */     GIR_EraseRootFromParent_Done,
     /* 253381 */   // Label 4894: @253381
     /* 253381 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(253423), // Rule ID 11618 //
     /* 253386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 253413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253421 */     GIR_RootConstrainSelectedInstOperands,
     /* 253422 */     // GIR_Coverage, 11618,
     /* 253422 */     GIR_EraseRootFromParent_Done,
     /* 253423 */   // Label 4895: @253423
     /* 253423 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(253465), // Rule ID 11619 //
     /* 253428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 253455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253463 */     GIR_RootConstrainSelectedInstOperands,
     /* 253464 */     // GIR_Coverage, 11619,
     /* 253464 */     GIR_EraseRootFromParent_Done,
     /* 253465 */   // Label 4896: @253465
     /* 253465 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(253507), // Rule ID 11620 //
     /* 253470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 253497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253505 */     GIR_RootConstrainSelectedInstOperands,
     /* 253506 */     // GIR_Coverage, 11620,
     /* 253506 */     GIR_EraseRootFromParent_Done,
     /* 253507 */   // Label 4897: @253507
     /* 253507 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(253549), // Rule ID 11621 //
     /* 253512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1838:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 253539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253547 */     GIR_RootConstrainSelectedInstOperands,
     /* 253548 */     // GIR_Coverage, 11621,
     /* 253548 */     GIR_EraseRootFromParent_Done,
     /* 253549 */   // Label 4898: @253549
     /* 253549 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(253591), // Rule ID 11622 //
     /* 253554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 253581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253589 */     GIR_RootConstrainSelectedInstOperands,
     /* 253590 */     // GIR_Coverage, 11622,
     /* 253590 */     GIR_EraseRootFromParent_Done,
     /* 253591 */   // Label 4899: @253591
     /* 253591 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(253633), // Rule ID 11623 //
     /* 253596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 253623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253631 */     GIR_RootConstrainSelectedInstOperands,
     /* 253632 */     // GIR_Coverage, 11623,
     /* 253632 */     GIR_EraseRootFromParent_Done,
     /* 253633 */   // Label 4900: @253633
     /* 253633 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(253675), // Rule ID 11624 //
     /* 253638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1838:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 253665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253673 */     GIR_RootConstrainSelectedInstOperands,
     /* 253674 */     // GIR_Coverage, 11624,
     /* 253674 */     GIR_EraseRootFromParent_Done,
     /* 253675 */   // Label 4901: @253675
     /* 253675 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(253717), // Rule ID 11625 //
     /* 253680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 253707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253715 */     GIR_RootConstrainSelectedInstOperands,
     /* 253716 */     // GIR_Coverage, 11625,
     /* 253716 */     GIR_EraseRootFromParent_Done,
     /* 253717 */   // Label 4902: @253717
     /* 253717 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(253759), // Rule ID 11626 //
     /* 253722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 253749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253757 */     GIR_RootConstrainSelectedInstOperands,
     /* 253758 */     // GIR_Coverage, 11626,
     /* 253758 */     GIR_EraseRootFromParent_Done,
     /* 253759 */   // Label 4903: @253759
     /* 253759 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(253801), // Rule ID 11627 //
     /* 253764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 253791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253799 */     GIR_RootConstrainSelectedInstOperands,
     /* 253800 */     // GIR_Coverage, 11627,
     /* 253800 */     GIR_EraseRootFromParent_Done,
     /* 253801 */   // Label 4904: @253801
     /* 253801 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(253843), // Rule ID 11628 //
     /* 253806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 253833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253841 */     GIR_RootConstrainSelectedInstOperands,
     /* 253842 */     // GIR_Coverage, 11628,
     /* 253842 */     GIR_EraseRootFromParent_Done,
     /* 253843 */   // Label 4905: @253843
     /* 253843 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(253885), // Rule ID 11803 //
     /* 253848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1940:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 253875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253883 */     GIR_RootConstrainSelectedInstOperands,
     /* 253884 */     // GIR_Coverage, 11803,
     /* 253884 */     GIR_EraseRootFromParent_Done,
     /* 253885 */   // Label 4906: @253885
     /* 253885 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(253927), // Rule ID 11805 //
     /* 253890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1940:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 253917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253925 */     GIR_RootConstrainSelectedInstOperands,
     /* 253926 */     // GIR_Coverage, 11805,
     /* 253926 */     GIR_EraseRootFromParent_Done,
     /* 253927 */   // Label 4907: @253927
     /* 253927 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(253969), // Rule ID 11807 //
     /* 253932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 253959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253967 */     GIR_RootConstrainSelectedInstOperands,
     /* 253968 */     // GIR_Coverage, 11807,
     /* 253968 */     GIR_EraseRootFromParent_Done,
     /* 253969 */   // Label 4908: @253969
     /* 253969 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(254011), // Rule ID 11809 //
     /* 253974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1940:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 254001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254009 */     GIR_RootConstrainSelectedInstOperands,
     /* 254010 */     // GIR_Coverage, 11809,
     /* 254010 */     GIR_EraseRootFromParent_Done,
     /* 254011 */   // Label 4909: @254011
     /* 254011 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(254053), // Rule ID 11811 //
     /* 254016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1692:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 254043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254051 */     GIR_RootConstrainSelectedInstOperands,
     /* 254052 */     // GIR_Coverage, 11811,
     /* 254052 */     GIR_EraseRootFromParent_Done,
     /* 254053 */   // Label 4910: @254053
     /* 254053 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(254095), // Rule ID 11812 //
     /* 254058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 254085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254093 */     GIR_RootConstrainSelectedInstOperands,
     /* 254094 */     // GIR_Coverage, 11812,
     /* 254094 */     GIR_EraseRootFromParent_Done,
     /* 254095 */   // Label 4911: @254095
     /* 254095 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(254137), // Rule ID 11813 //
     /* 254100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 254127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254135 */     GIR_RootConstrainSelectedInstOperands,
     /* 254136 */     // GIR_Coverage, 11813,
     /* 254136 */     GIR_EraseRootFromParent_Done,
     /* 254137 */   // Label 4912: @254137
     /* 254137 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(254179), // Rule ID 11814 //
     /* 254142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 254169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254177 */     GIR_RootConstrainSelectedInstOperands,
     /* 254178 */     // GIR_Coverage, 11814,
     /* 254178 */     GIR_EraseRootFromParent_Done,
     /* 254179 */   // Label 4913: @254179
     /* 254179 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(254221), // Rule ID 11815 //
     /* 254184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 254211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254219 */     GIR_RootConstrainSelectedInstOperands,
     /* 254220 */     // GIR_Coverage, 11815,
     /* 254220 */     GIR_EraseRootFromParent_Done,
     /* 254221 */   // Label 4914: @254221
     /* 254221 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(254263), // Rule ID 11816 //
     /* 254226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1941:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 254253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254261 */     GIR_RootConstrainSelectedInstOperands,
     /* 254262 */     // GIR_Coverage, 11816,
     /* 254262 */     GIR_EraseRootFromParent_Done,
     /* 254263 */   // Label 4915: @254263
     /* 254263 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(254305), // Rule ID 11817 //
     /* 254268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 254295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254303 */     GIR_RootConstrainSelectedInstOperands,
     /* 254304 */     // GIR_Coverage, 11817,
     /* 254304 */     GIR_EraseRootFromParent_Done,
     /* 254305 */   // Label 4916: @254305
     /* 254305 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(254347), // Rule ID 11818 //
     /* 254310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 254337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254345 */     GIR_RootConstrainSelectedInstOperands,
     /* 254346 */     // GIR_Coverage, 11818,
     /* 254346 */     GIR_EraseRootFromParent_Done,
     /* 254347 */   // Label 4917: @254347
     /* 254347 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(254389), // Rule ID 11819 //
     /* 254352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1942:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 254379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254387 */     GIR_RootConstrainSelectedInstOperands,
     /* 254388 */     // GIR_Coverage, 11819,
     /* 254388 */     GIR_EraseRootFromParent_Done,
     /* 254389 */   // Label 4918: @254389
     /* 254389 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(254431), // Rule ID 11820 //
     /* 254394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 254421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254429 */     GIR_RootConstrainSelectedInstOperands,
     /* 254430 */     // GIR_Coverage, 11820,
     /* 254430 */     GIR_EraseRootFromParent_Done,
     /* 254431 */   // Label 4919: @254431
     /* 254431 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(254473), // Rule ID 11821 //
     /* 254436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 254463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254471 */     GIR_RootConstrainSelectedInstOperands,
     /* 254472 */     // GIR_Coverage, 11821,
     /* 254472 */     GIR_EraseRootFromParent_Done,
     /* 254473 */   // Label 4920: @254473
     /* 254473 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(254515), // Rule ID 11822 //
     /* 254478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 254505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254513 */     GIR_RootConstrainSelectedInstOperands,
     /* 254514 */     // GIR_Coverage, 11822,
     /* 254514 */     GIR_EraseRootFromParent_Done,
     /* 254515 */   // Label 4921: @254515
     /* 254515 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(254557), // Rule ID 11823 //
     /* 254520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1704:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 254547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254555 */     GIR_RootConstrainSelectedInstOperands,
     /* 254556 */     // GIR_Coverage, 11823,
     /* 254556 */     GIR_EraseRootFromParent_Done,
     /* 254557 */   // Label 4922: @254557
     /* 254557 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(254599), // Rule ID 11824 //
     /* 254562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1705:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 254589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254597 */     GIR_RootConstrainSelectedInstOperands,
     /* 254598 */     // GIR_Coverage, 11824,
     /* 254598 */     GIR_EraseRootFromParent_Done,
     /* 254599 */   // Label 4923: @254599
     /* 254599 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(254641), // Rule ID 11825 //
     /* 254604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1705:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 254631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254639 */     GIR_RootConstrainSelectedInstOperands,
     /* 254640 */     // GIR_Coverage, 11825,
     /* 254640 */     GIR_EraseRootFromParent_Done,
     /* 254641 */   // Label 4924: @254641
     /* 254641 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(254683), // Rule ID 11880 //
     /* 254646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1673:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 254673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254681 */     GIR_RootConstrainSelectedInstOperands,
     /* 254682 */     // GIR_Coverage, 11880,
     /* 254682 */     GIR_EraseRootFromParent_Done,
     /* 254683 */   // Label 4925: @254683
     /* 254683 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(254725), // Rule ID 11881 //
     /* 254688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 254715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254723 */     GIR_RootConstrainSelectedInstOperands,
     /* 254724 */     // GIR_Coverage, 11881,
     /* 254724 */     GIR_EraseRootFromParent_Done,
     /* 254725 */   // Label 4926: @254725
     /* 254725 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(254767), // Rule ID 11882 //
     /* 254730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 254757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254765 */     GIR_RootConstrainSelectedInstOperands,
     /* 254766 */     // GIR_Coverage, 11882,
     /* 254766 */     GIR_EraseRootFromParent_Done,
     /* 254767 */   // Label 4927: @254767
     /* 254767 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(254809), // Rule ID 11883 //
     /* 254772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1914:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 254799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254807 */     GIR_RootConstrainSelectedInstOperands,
     /* 254808 */     // GIR_Coverage, 11883,
     /* 254808 */     GIR_EraseRootFromParent_Done,
     /* 254809 */   // Label 4928: @254809
     /* 254809 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(254851), // Rule ID 11884 //
     /* 254814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1914:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 254841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254849 */     GIR_RootConstrainSelectedInstOperands,
     /* 254850 */     // GIR_Coverage, 11884,
     /* 254850 */     GIR_EraseRootFromParent_Done,
     /* 254851 */   // Label 4929: @254851
     /* 254851 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(254893), // Rule ID 11885 //
     /* 254856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1914:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 254883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254891 */     GIR_RootConstrainSelectedInstOperands,
     /* 254892 */     // GIR_Coverage, 11885,
     /* 254892 */     GIR_EraseRootFromParent_Done,
     /* 254893 */   // Label 4930: @254893
     /* 254893 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(254935), // Rule ID 11886 //
     /* 254898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254922 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 254925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254933 */     GIR_RootConstrainSelectedInstOperands,
     /* 254934 */     // GIR_Coverage, 11886,
     /* 254934 */     GIR_EraseRootFromParent_Done,
     /* 254935 */   // Label 4931: @254935
     /* 254935 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(254977), // Rule ID 11887 //
     /* 254940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 254967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254975 */     GIR_RootConstrainSelectedInstOperands,
     /* 254976 */     // GIR_Coverage, 11887,
     /* 254976 */     GIR_EraseRootFromParent_Done,
     /* 254977 */   // Label 4932: @254977
     /* 254977 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(255019), // Rule ID 11888 //
     /* 254982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 255009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255017 */     GIR_RootConstrainSelectedInstOperands,
     /* 255018 */     // GIR_Coverage, 11888,
     /* 255018 */     GIR_EraseRootFromParent_Done,
     /* 255019 */   // Label 4933: @255019
     /* 255019 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(255064), // Rule ID 11901 //
     /* 255024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 255027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 255032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 255035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 255048 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1624:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 255051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 255053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 255062 */     GIR_RootConstrainSelectedInstOperands,
     /* 255063 */     // GIR_Coverage, 11901,
     /* 255063 */     GIR_EraseRootFromParent_Done,
     /* 255064 */   // Label 4934: @255064
     /* 255064 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(255109), // Rule ID 11902 //
     /* 255069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 255072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 255077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 255080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 255093 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1624:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 255096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 255098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 255107 */     GIR_RootConstrainSelectedInstOperands,
     /* 255108 */     // GIR_Coverage, 11902,
     /* 255108 */     GIR_EraseRootFromParent_Done,
     /* 255109 */   // Label 4935: @255109
     /* 255109 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(255151), // Rule ID 11903 //
     /* 255114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1364:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 255141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255149 */     GIR_RootConstrainSelectedInstOperands,
     /* 255150 */     // GIR_Coverage, 11903,
     /* 255150 */     GIR_EraseRootFromParent_Done,
     /* 255151 */   // Label 4936: @255151
     /* 255151 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(255193), // Rule ID 11904 //
     /* 255156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1364:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 255183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255191 */     GIR_RootConstrainSelectedInstOperands,
     /* 255192 */     // GIR_Coverage, 11904,
     /* 255192 */     GIR_EraseRootFromParent_Done,
     /* 255193 */   // Label 4937: @255193
     /* 255193 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(255235), // Rule ID 11905 //
     /* 255198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1364:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 255225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255233 */     GIR_RootConstrainSelectedInstOperands,
     /* 255234 */     // GIR_Coverage, 11905,
     /* 255234 */     GIR_EraseRootFromParent_Done,
     /* 255235 */   // Label 4938: @255235
     /* 255235 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(255277), // Rule ID 11906 //
     /* 255240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1364:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 255267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255275 */     GIR_RootConstrainSelectedInstOperands,
     /* 255276 */     // GIR_Coverage, 11906,
     /* 255276 */     GIR_EraseRootFromParent_Done,
     /* 255277 */   // Label 4939: @255277
     /* 255277 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(255319), // Rule ID 11922 //
     /* 255282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255306 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 255309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255317 */     GIR_RootConstrainSelectedInstOperands,
     /* 255318 */     // GIR_Coverage, 11922,
     /* 255318 */     GIR_EraseRootFromParent_Done,
     /* 255319 */   // Label 4940: @255319
     /* 255319 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(255361), // Rule ID 11923 //
     /* 255324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 255351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255359 */     GIR_RootConstrainSelectedInstOperands,
     /* 255360 */     // GIR_Coverage, 11923,
     /* 255360 */     GIR_EraseRootFromParent_Done,
     /* 255361 */   // Label 4941: @255361
     /* 255361 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(255403), // Rule ID 11924 //
     /* 255366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255390 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 255393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255401 */     GIR_RootConstrainSelectedInstOperands,
     /* 255402 */     // GIR_Coverage, 11924,
     /* 255402 */     GIR_EraseRootFromParent_Done,
     /* 255403 */   // Label 4942: @255403
     /* 255403 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(255445), // Rule ID 11925 //
     /* 255408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1465:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 255435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255443 */     GIR_RootConstrainSelectedInstOperands,
     /* 255444 */     // GIR_Coverage, 11925,
     /* 255444 */     GIR_EraseRootFromParent_Done,
     /* 255445 */   // Label 4943: @255445
     /* 255445 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(255487), // Rule ID 11926 //
     /* 255450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 255477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255485 */     GIR_RootConstrainSelectedInstOperands,
     /* 255486 */     // GIR_Coverage, 11926,
     /* 255486 */     GIR_EraseRootFromParent_Done,
     /* 255487 */   // Label 4944: @255487
     /* 255487 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(255529), // Rule ID 11927 //
     /* 255492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255516 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1465:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 255519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255527 */     GIR_RootConstrainSelectedInstOperands,
     /* 255528 */     // GIR_Coverage, 11927,
     /* 255528 */     GIR_EraseRootFromParent_Done,
     /* 255529 */   // Label 4945: @255529
     /* 255529 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(255571), // Rule ID 11928 //
     /* 255534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255558 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 255561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255569 */     GIR_RootConstrainSelectedInstOperands,
     /* 255570 */     // GIR_Coverage, 11928,
     /* 255570 */     GIR_EraseRootFromParent_Done,
     /* 255571 */   // Label 4946: @255571
     /* 255571 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(255613), // Rule ID 11929 //
     /* 255576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255600 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 255603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255611 */     GIR_RootConstrainSelectedInstOperands,
     /* 255612 */     // GIR_Coverage, 11929,
     /* 255612 */     GIR_EraseRootFromParent_Done,
     /* 255613 */   // Label 4947: @255613
     /* 255613 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(255655), // Rule ID 11930 //
     /* 255618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255642 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 255645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255653 */     GIR_RootConstrainSelectedInstOperands,
     /* 255654 */     // GIR_Coverage, 11930,
     /* 255654 */     GIR_EraseRootFromParent_Done,
     /* 255655 */   // Label 4948: @255655
     /* 255655 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(255697), // Rule ID 11931 //
     /* 255660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255684 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 255687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255695 */     GIR_RootConstrainSelectedInstOperands,
     /* 255696 */     // GIR_Coverage, 11931,
     /* 255696 */     GIR_EraseRootFromParent_Done,
     /* 255697 */   // Label 4949: @255697
     /* 255697 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(255739), // Rule ID 11932 //
     /* 255702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255726 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 255729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255737 */     GIR_RootConstrainSelectedInstOperands,
     /* 255738 */     // GIR_Coverage, 11932,
     /* 255738 */     GIR_EraseRootFromParent_Done,
     /* 255739 */   // Label 4950: @255739
     /* 255739 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(255781), // Rule ID 11933 //
     /* 255744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255768 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 255771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255779 */     GIR_RootConstrainSelectedInstOperands,
     /* 255780 */     // GIR_Coverage, 11933,
     /* 255780 */     GIR_EraseRootFromParent_Done,
     /* 255781 */   // Label 4951: @255781
     /* 255781 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(255823), // Rule ID 11938 //
     /* 255786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 255794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 255813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255821 */     GIR_RootConstrainSelectedInstOperands,
     /* 255822 */     // GIR_Coverage, 11938,
     /* 255822 */     GIR_EraseRootFromParent_Done,
     /* 255823 */   // Label 4952: @255823
     /* 255823 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(255865), // Rule ID 11939 //
     /* 255828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 255836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255852 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 255855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255863 */     GIR_RootConstrainSelectedInstOperands,
     /* 255864 */     // GIR_Coverage, 11939,
     /* 255864 */     GIR_EraseRootFromParent_Done,
     /* 255865 */   // Label 4953: @255865
     /* 255865 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(255907), // Rule ID 11940 //
     /* 255870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 255878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 255897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255905 */     GIR_RootConstrainSelectedInstOperands,
     /* 255906 */     // GIR_Coverage, 11940,
     /* 255906 */     GIR_EraseRootFromParent_Done,
     /* 255907 */   // Label 4954: @255907
     /* 255907 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(255949), // Rule ID 11941 //
     /* 255912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 255920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 255939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255947 */     GIR_RootConstrainSelectedInstOperands,
     /* 255948 */     // GIR_Coverage, 11941,
     /* 255948 */     GIR_EraseRootFromParent_Done,
     /* 255949 */   // Label 4955: @255949
     /* 255949 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(255991), // Rule ID 11942 //
     /* 255954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 255962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255978 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1281:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 255981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255989 */     GIR_RootConstrainSelectedInstOperands,
     /* 255990 */     // GIR_Coverage, 11942,
     /* 255990 */     GIR_EraseRootFromParent_Done,
     /* 255991 */   // Label 4956: @255991
     /* 255991 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(256033), // Rule ID 11944 //
     /* 255996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1281:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256031 */     GIR_RootConstrainSelectedInstOperands,
     /* 256032 */     // GIR_Coverage, 11944,
     /* 256032 */     GIR_EraseRootFromParent_Done,
     /* 256033 */   // Label 4957: @256033
     /* 256033 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(256075), // Rule ID 11946 //
     /* 256038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1281:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256073 */     GIR_RootConstrainSelectedInstOperands,
     /* 256074 */     // GIR_Coverage, 11946,
     /* 256074 */     GIR_EraseRootFromParent_Done,
     /* 256075 */   // Label 4958: @256075
     /* 256075 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(256117), // Rule ID 11948 //
     /* 256080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1281:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256115 */     GIR_RootConstrainSelectedInstOperands,
     /* 256116 */     // GIR_Coverage, 11948,
     /* 256116 */     GIR_EraseRootFromParent_Done,
     /* 256117 */   // Label 4959: @256117
     /* 256117 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(256159), // Rule ID 12072 //
     /* 256122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256146 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 256149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256157 */     GIR_RootConstrainSelectedInstOperands,
     /* 256158 */     // GIR_Coverage, 12072,
     /* 256158 */     GIR_EraseRootFromParent_Done,
     /* 256159 */   // Label 4960: @256159
     /* 256159 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(256201), // Rule ID 12074 //
     /* 256164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 256191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256199 */     GIR_RootConstrainSelectedInstOperands,
     /* 256200 */     // GIR_Coverage, 12074,
     /* 256200 */     GIR_EraseRootFromParent_Done,
     /* 256201 */   // Label 4961: @256201
     /* 256201 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(256243), // Rule ID 12076 //
     /* 256206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 256233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256241 */     GIR_RootConstrainSelectedInstOperands,
     /* 256242 */     // GIR_Coverage, 12076,
     /* 256242 */     GIR_EraseRootFromParent_Done,
     /* 256243 */   // Label 4962: @256243
     /* 256243 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(256285), // Rule ID 12078 //
     /* 256248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 256275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256283 */     GIR_RootConstrainSelectedInstOperands,
     /* 256284 */     // GIR_Coverage, 12078,
     /* 256284 */     GIR_EraseRootFromParent_Done,
     /* 256285 */   // Label 4963: @256285
     /* 256285 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(256327), // Rule ID 12080 //
     /* 256290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 256298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256314 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 256317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256325 */     GIR_RootConstrainSelectedInstOperands,
     /* 256326 */     // GIR_Coverage, 12080,
     /* 256326 */     GIR_EraseRootFromParent_Done,
     /* 256327 */   // Label 4964: @256327
     /* 256327 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(256369), // Rule ID 12082 //
     /* 256332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 256340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 256359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256367 */     GIR_RootConstrainSelectedInstOperands,
     /* 256368 */     // GIR_Coverage, 12082,
     /* 256368 */     GIR_EraseRootFromParent_Done,
     /* 256369 */   // Label 4965: @256369
     /* 256369 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(256411), // Rule ID 12245 //
     /* 256374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 256401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256409 */     GIR_RootConstrainSelectedInstOperands,
     /* 256410 */     // GIR_Coverage, 12245,
     /* 256410 */     GIR_EraseRootFromParent_Done,
     /* 256411 */   // Label 4966: @256411
     /* 256411 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(256453), // Rule ID 12246 //
     /* 256416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256451 */     GIR_RootConstrainSelectedInstOperands,
     /* 256452 */     // GIR_Coverage, 12246,
     /* 256452 */     GIR_EraseRootFromParent_Done,
     /* 256453 */   // Label 4967: @256453
     /* 256453 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(256495), // Rule ID 12247 //
     /* 256458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256493 */     GIR_RootConstrainSelectedInstOperands,
     /* 256494 */     // GIR_Coverage, 12247,
     /* 256494 */     GIR_EraseRootFromParent_Done,
     /* 256495 */   // Label 4968: @256495
     /* 256495 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(256537), // Rule ID 12248 //
     /* 256500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 256527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256535 */     GIR_RootConstrainSelectedInstOperands,
     /* 256536 */     // GIR_Coverage, 12248,
     /* 256536 */     GIR_EraseRootFromParent_Done,
     /* 256537 */   // Label 4969: @256537
     /* 256537 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(256579), // Rule ID 12249 //
     /* 256542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256577 */     GIR_RootConstrainSelectedInstOperands,
     /* 256578 */     // GIR_Coverage, 12249,
     /* 256578 */     GIR_EraseRootFromParent_Done,
     /* 256579 */   // Label 4970: @256579
     /* 256579 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(256621), // Rule ID 12250 //
     /* 256584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256619 */     GIR_RootConstrainSelectedInstOperands,
     /* 256620 */     // GIR_Coverage, 12250,
     /* 256620 */     GIR_EraseRootFromParent_Done,
     /* 256621 */   // Label 4971: @256621
     /* 256621 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(256663), // Rule ID 12251 //
     /* 256626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 256653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256661 */     GIR_RootConstrainSelectedInstOperands,
     /* 256662 */     // GIR_Coverage, 12251,
     /* 256662 */     GIR_EraseRootFromParent_Done,
     /* 256663 */   // Label 4972: @256663
     /* 256663 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(256705), // Rule ID 12596 //
     /* 256668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256692 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1381:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 256695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256703 */     GIR_RootConstrainSelectedInstOperands,
     /* 256704 */     // GIR_Coverage, 12596,
     /* 256704 */     GIR_EraseRootFromParent_Done,
     /* 256705 */   // Label 4973: @256705
     /* 256705 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(256747), // Rule ID 12597 //
     /* 256710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 256737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256745 */     GIR_RootConstrainSelectedInstOperands,
     /* 256746 */     // GIR_Coverage, 12597,
     /* 256746 */     GIR_EraseRootFromParent_Done,
     /* 256747 */   // Label 4974: @256747
     /* 256747 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(256789), // Rule ID 12598 //
     /* 256752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 256779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256787 */     GIR_RootConstrainSelectedInstOperands,
     /* 256788 */     // GIR_Coverage, 12598,
     /* 256788 */     GIR_EraseRootFromParent_Done,
     /* 256789 */   // Label 4975: @256789
     /* 256789 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(256831), // Rule ID 12599 //
     /* 256794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256818 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1379:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 256821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256829 */     GIR_RootConstrainSelectedInstOperands,
     /* 256830 */     // GIR_Coverage, 12599,
     /* 256830 */     GIR_EraseRootFromParent_Done,
     /* 256831 */   // Label 4976: @256831
     /* 256831 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(256873), // Rule ID 12600 //
     /* 256836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 256863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256871 */     GIR_RootConstrainSelectedInstOperands,
     /* 256872 */     // GIR_Coverage, 12600,
     /* 256872 */     GIR_EraseRootFromParent_Done,
     /* 256873 */   // Label 4977: @256873
     /* 256873 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(256915), // Rule ID 12601 //
     /* 256878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 256905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256913 */     GIR_RootConstrainSelectedInstOperands,
     /* 256914 */     // GIR_Coverage, 12601,
     /* 256914 */     GIR_EraseRootFromParent_Done,
     /* 256915 */   // Label 4978: @256915
     /* 256915 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(256957), // Rule ID 12602 //
     /* 256920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256944 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1380:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 256947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256955 */     GIR_RootConstrainSelectedInstOperands,
     /* 256956 */     // GIR_Coverage, 12602,
     /* 256956 */     GIR_EraseRootFromParent_Done,
     /* 256957 */   // Label 4979: @256957
     /* 256957 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(256999), // Rule ID 12605 //
     /* 256962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 256973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 256979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 256982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256986 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1380:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 256986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 256989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256997 */     GIR_RootConstrainSelectedInstOperands,
     /* 256998 */     // GIR_Coverage, 12605,
     /* 256998 */     GIR_EraseRootFromParent_Done,
     /* 256999 */   // Label 4980: @256999
     /* 256999 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(257041), // Rule ID 12608 //
     /* 257004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 257015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 257021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 257024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257028 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 257028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 257031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257039 */     GIR_RootConstrainSelectedInstOperands,
     /* 257040 */     // GIR_Coverage, 12608,
     /* 257040 */     GIR_EraseRootFromParent_Done,
     /* 257041 */   // Label 4981: @257041
     /* 257041 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(257083), // Rule ID 12611 //
     /* 257046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 257073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257081 */     GIR_RootConstrainSelectedInstOperands,
     /* 257082 */     // GIR_Coverage, 12611,
     /* 257082 */     GIR_EraseRootFromParent_Done,
     /* 257083 */   // Label 4982: @257083
     /* 257083 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(257125), // Rule ID 12614 //
     /* 257088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 257099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 257105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 257108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 257115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257123 */     GIR_RootConstrainSelectedInstOperands,
     /* 257124 */     // GIR_Coverage, 12614,
     /* 257124 */     GIR_EraseRootFromParent_Done,
     /* 257125 */   // Label 4983: @257125
     /* 257125 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(257167), // Rule ID 12617 //
     /* 257130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257154 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 257157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257165 */     GIR_RootConstrainSelectedInstOperands,
     /* 257166 */     // GIR_Coverage, 12617,
     /* 257166 */     GIR_EraseRootFromParent_Done,
     /* 257167 */   // Label 4984: @257167
     /* 257167 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(257209), // Rule ID 12620 //
     /* 257172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257196 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1382:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257207 */     GIR_RootConstrainSelectedInstOperands,
     /* 257208 */     // GIR_Coverage, 12620,
     /* 257208 */     GIR_EraseRootFromParent_Done,
     /* 257209 */   // Label 4985: @257209
     /* 257209 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(257251), // Rule ID 12623 //
     /* 257214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 257225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 257231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 257234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257238 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 257238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257249 */     GIR_RootConstrainSelectedInstOperands,
     /* 257250 */     // GIR_Coverage, 12623,
     /* 257250 */     GIR_EraseRootFromParent_Done,
     /* 257251 */   // Label 4986: @257251
     /* 257251 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(257293), // Rule ID 12626 //
     /* 257256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 257267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 257273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 257276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257280 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 257280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257291 */     GIR_RootConstrainSelectedInstOperands,
     /* 257292 */     // GIR_Coverage, 12626,
     /* 257292 */     GIR_EraseRootFromParent_Done,
     /* 257293 */   // Label 4987: @257293
     /* 257293 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257335), // Rule ID 12629 //
     /* 257298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257322 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257333 */     GIR_RootConstrainSelectedInstOperands,
     /* 257334 */     // GIR_Coverage, 12629,
     /* 257334 */     GIR_EraseRootFromParent_Done,
     /* 257335 */   // Label 4988: @257335
     /* 257335 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(257377), // Rule ID 12632 //
     /* 257340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 257351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 257357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 257360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257375 */     GIR_RootConstrainSelectedInstOperands,
     /* 257376 */     // GIR_Coverage, 12632,
     /* 257376 */     GIR_EraseRootFromParent_Done,
     /* 257377 */   // Label 4989: @257377
     /* 257377 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(257419), // Rule ID 12635 //
     /* 257382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257406 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 257409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257417 */     GIR_RootConstrainSelectedInstOperands,
     /* 257418 */     // GIR_Coverage, 12635,
     /* 257418 */     GIR_EraseRootFromParent_Done,
     /* 257419 */   // Label 4990: @257419
     /* 257419 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(257562), // Rule ID 5607 //
     /* 257424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257445 */     // MIs[0] idx
     /* 257445 */     // No operand predicates
     /* 257445 */     // (intrinsic_wo_chain:{ *:[v16i8] } 778:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257445 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 257448 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257452 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 257459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 257462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257471 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 257474 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257478 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 257481 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257486 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257491 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 257558 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257560 */     GIR_RootConstrainSelectedInstOperands,
     /* 257561 */     // GIR_Coverage, 5607,
     /* 257561 */     GIR_EraseRootFromParent_Done,
     /* 257562 */   // Label 4991: @257562
     /* 257562 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(257653), // Rule ID 5608 //
     /* 257567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257588 */     // MIs[0] idx
     /* 257588 */     // No operand predicates
     /* 257588 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257649 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257651 */     GIR_RootConstrainSelectedInstOperands,
     /* 257652 */     // GIR_Coverage, 5608,
     /* 257652 */     GIR_EraseRootFromParent_Done,
     /* 257653 */   // Label 4992: @257653
     /* 257653 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(257744), // Rule ID 5609 //
     /* 257658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257679 */     // MIs[0] idx
     /* 257679 */     // No operand predicates
     /* 257679 */     // (intrinsic_wo_chain:{ *:[v16i8] } 778:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257740 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257742 */     GIR_RootConstrainSelectedInstOperands,
     /* 257743 */     // GIR_Coverage, 5609,
     /* 257743 */     GIR_EraseRootFromParent_Done,
     /* 257744 */   // Label 4993: @257744
     /* 257744 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(257783), // Rule ID 5610 //
     /* 257749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257770 */     // MIs[0] idx
     /* 257770 */     // No operand predicates
     /* 257770 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257779 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257781 */     GIR_RootConstrainSelectedInstOperands,
     /* 257782 */     // GIR_Coverage, 5610,
     /* 257782 */     GIR_EraseRootFromParent_Done,
     /* 257783 */   // Label 4994: @257783
     /* 257783 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(257926), // Rule ID 5611 //
     /* 257788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257809 */     // MIs[0] idx
     /* 257809 */     // No operand predicates
     /* 257809 */     // (intrinsic_wo_chain:{ *:[v8i16] } 778:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257809 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 257812 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257816 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 257823 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 257826 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257830 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257835 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 257838 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257842 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 257845 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257850 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257855 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257893 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 257914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 257922 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257924 */     GIR_RootConstrainSelectedInstOperands,
     /* 257925 */     // GIR_Coverage, 5611,
     /* 257925 */     GIR_EraseRootFromParent_Done,
     /* 257926 */   // Label 4995: @257926
     /* 257926 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(258017), // Rule ID 5612 //
     /* 257931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257952 */     // MIs[0] idx
     /* 257952 */     // No operand predicates
     /* 257952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 779:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257978 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258013 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258015 */     GIR_RootConstrainSelectedInstOperands,
     /* 258016 */     // GIR_Coverage, 5612,
     /* 258016 */     GIR_EraseRootFromParent_Done,
     /* 258017 */   // Label 4996: @258017
     /* 258017 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(258108), // Rule ID 5613 //
     /* 258022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258043 */     // MIs[0] idx
     /* 258043 */     // No operand predicates
     /* 258043 */     // (intrinsic_wo_chain:{ *:[v8i16] } 778:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258104 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258106 */     GIR_RootConstrainSelectedInstOperands,
     /* 258107 */     // GIR_Coverage, 5613,
     /* 258107 */     GIR_EraseRootFromParent_Done,
     /* 258108 */   // Label 4997: @258108
     /* 258108 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(258147), // Rule ID 5614 //
     /* 258113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258134 */     // MIs[0] idx
     /* 258134 */     // No operand predicates
     /* 258134 */     // (intrinsic_wo_chain:{ *:[v8i16] } 779:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258143 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258145 */     GIR_RootConstrainSelectedInstOperands,
     /* 258146 */     // GIR_Coverage, 5614,
     /* 258146 */     GIR_EraseRootFromParent_Done,
     /* 258147 */   // Label 4998: @258147
     /* 258147 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(258290), // Rule ID 5615 //
     /* 258152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258173 */     // MIs[0] idx
     /* 258173 */     // No operand predicates
     /* 258173 */     // (intrinsic_wo_chain:{ *:[v8f16] } 778:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258173 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 258176 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258180 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 258187 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 258190 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258194 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258199 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 258202 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258206 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 258209 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258214 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258219 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258224 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258227 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258231 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 258286 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258288 */     GIR_RootConstrainSelectedInstOperands,
     /* 258289 */     // GIR_Coverage, 5615,
     /* 258289 */     GIR_EraseRootFromParent_Done,
     /* 258290 */   // Label 4999: @258290
     /* 258290 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(258381), // Rule ID 5616 //
     /* 258295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258316 */     // MIs[0] idx
     /* 258316 */     // No operand predicates
     /* 258316 */     // (intrinsic_wo_chain:{ *:[v8f16] } 779:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258377 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258379 */     GIR_RootConstrainSelectedInstOperands,
     /* 258380 */     // GIR_Coverage, 5616,
     /* 258380 */     GIR_EraseRootFromParent_Done,
     /* 258381 */   // Label 5000: @258381
     /* 258381 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(258472), // Rule ID 5617 //
     /* 258386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258407 */     // MIs[0] idx
     /* 258407 */     // No operand predicates
     /* 258407 */     // (intrinsic_wo_chain:{ *:[v8f16] } 778:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258468 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258470 */     GIR_RootConstrainSelectedInstOperands,
     /* 258471 */     // GIR_Coverage, 5617,
     /* 258471 */     GIR_EraseRootFromParent_Done,
     /* 258472 */   // Label 5001: @258472
     /* 258472 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(258511), // Rule ID 5618 //
     /* 258477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258498 */     // MIs[0] idx
     /* 258498 */     // No operand predicates
     /* 258498 */     // (intrinsic_wo_chain:{ *:[v8f16] } 779:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258507 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258509 */     GIR_RootConstrainSelectedInstOperands,
     /* 258510 */     // GIR_Coverage, 5618,
     /* 258510 */     GIR_EraseRootFromParent_Done,
     /* 258511 */   // Label 5002: @258511
     /* 258511 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(258550), // Rule ID 5619 //
     /* 258516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 258524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258537 */     // MIs[0] idx
     /* 258537 */     // No operand predicates
     /* 258537 */     // (intrinsic_wo_chain:{ *:[v16i8] } 782:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 258540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258546 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258548 */     GIR_RootConstrainSelectedInstOperands,
     /* 258549 */     // GIR_Coverage, 5619,
     /* 258549 */     GIR_EraseRootFromParent_Done,
     /* 258550 */   // Label 5003: @258550
     /* 258550 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(258641), // Rule ID 5620 //
     /* 258555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 258563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258576 */     // MIs[0] idx
     /* 258576 */     // No operand predicates
     /* 258576 */     // (intrinsic_wo_chain:{ *:[v16i8] } 780:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258576 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258579 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258583 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 258630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258637 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258639 */     GIR_RootConstrainSelectedInstOperands,
     /* 258640 */     // GIR_Coverage, 5620,
     /* 258640 */     GIR_EraseRootFromParent_Done,
     /* 258641 */   // Label 5004: @258641
     /* 258641 */   GIM_Reject,
     /* 258642 */ // Label 4144: @258642
     /* 258642 */ GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(265753),
     /* 258647 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 258650 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(258697), // Rule ID 2961 //
     /* 258655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1613:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 258682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 258685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258695 */     GIR_RootConstrainSelectedInstOperands,
     /* 258696 */     // GIR_Coverage, 2961,
     /* 258696 */     GIR_EraseRootFromParent_Done,
     /* 258697 */   // Label 5006: @258697
     /* 258697 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258744), // Rule ID 2963 //
     /* 258702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1613:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 258729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 258732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258740 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258742 */     GIR_RootConstrainSelectedInstOperands,
     /* 258743 */     // GIR_Coverage, 2963,
     /* 258743 */     GIR_EraseRootFromParent_Done,
     /* 258744 */   // Label 5007: @258744
     /* 258744 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258791), // Rule ID 2965 //
     /* 258749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1613:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 258776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 258779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258789 */     GIR_RootConstrainSelectedInstOperands,
     /* 258790 */     // GIR_Coverage, 2965,
     /* 258790 */     GIR_EraseRootFromParent_Done,
     /* 258791 */   // Label 5008: @258791
     /* 258791 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258838), // Rule ID 2967 //
     /* 258796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258823 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1613:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 258823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 258826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258836 */     GIR_RootConstrainSelectedInstOperands,
     /* 258837 */     // GIR_Coverage, 2967,
     /* 258837 */     GIR_EraseRootFromParent_Done,
     /* 258838 */   // Label 5009: @258838
     /* 258838 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258885), // Rule ID 7647 //
     /* 258843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258870 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 258870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 258873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258883 */     GIR_RootConstrainSelectedInstOperands,
     /* 258884 */     // GIR_Coverage, 7647,
     /* 258884 */     GIR_EraseRootFromParent_Done,
     /* 258885 */   // Label 5010: @258885
     /* 258885 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(258932), // Rule ID 7649 //
     /* 258890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 258917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 258920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258928 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258930 */     GIR_RootConstrainSelectedInstOperands,
     /* 258931 */     // GIR_Coverage, 7649,
     /* 258931 */     GIR_EraseRootFromParent_Done,
     /* 258932 */   // Label 5011: @258932
     /* 258932 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(258979), // Rule ID 7651 //
     /* 258937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 258964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 258967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258977 */     GIR_RootConstrainSelectedInstOperands,
     /* 258978 */     // GIR_Coverage, 7651,
     /* 258978 */     GIR_EraseRootFromParent_Done,
     /* 258979 */   // Label 5012: @258979
     /* 258979 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(259026), // Rule ID 7653 //
     /* 258984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 259011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 259014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259024 */     GIR_RootConstrainSelectedInstOperands,
     /* 259025 */     // GIR_Coverage, 7653,
     /* 259025 */     GIR_EraseRootFromParent_Done,
     /* 259026 */   // Label 5013: @259026
     /* 259026 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(259106), // Rule ID 5729 //
     /* 259031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 259071 */     // MIs[1] Operand 1
     /* 259071 */     // No operand predicates
     /* 259071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 259087 */     // MIs[2] Operand 1
     /* 259087 */     // No operand predicates
     /* 259087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259089 */     // (intrinsic_wo_chain:{ *:[v16i8] } 771:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 259089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 259092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259104 */     GIR_RootConstrainSelectedInstOperands,
     /* 259105 */     // GIR_Coverage, 5729,
     /* 259105 */     GIR_EraseRootFromParent_Done,
     /* 259106 */   // Label 5014: @259106
     /* 259106 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(259186), // Rule ID 5730 //
     /* 259111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 259128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259151 */     // MIs[1] Operand 1
     /* 259151 */     // No operand predicates
     /* 259151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259167 */     // MIs[2] Operand 1
     /* 259167 */     // No operand predicates
     /* 259167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259169 */     // (intrinsic_wo_chain:{ *:[v8i16] } 771:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 259169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 259172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259184 */     GIR_RootConstrainSelectedInstOperands,
     /* 259185 */     // GIR_Coverage, 5730,
     /* 259185 */     GIR_EraseRootFromParent_Done,
     /* 259186 */   // Label 5015: @259186
     /* 259186 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(259266), // Rule ID 5731 //
     /* 259191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259231 */     // MIs[1] Operand 1
     /* 259231 */     // No operand predicates
     /* 259231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259243 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259247 */     // MIs[2] Operand 1
     /* 259247 */     // No operand predicates
     /* 259247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 771:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 259249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 259252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259264 */     GIR_RootConstrainSelectedInstOperands,
     /* 259265 */     // GIR_Coverage, 5731,
     /* 259265 */     GIR_EraseRootFromParent_Done,
     /* 259266 */   // Label 5016: @259266
     /* 259266 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(259346), // Rule ID 5732 //
     /* 259271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 259279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 259282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 259288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259311 */     // MIs[1] Operand 1
     /* 259311 */     // No operand predicates
     /* 259311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259327 */     // MIs[2] Operand 1
     /* 259327 */     // No operand predicates
     /* 259327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259329 */     // (intrinsic_wo_chain:{ *:[v2i64] } 771:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 259329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 259332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259344 */     GIR_RootConstrainSelectedInstOperands,
     /* 259345 */     // GIR_Coverage, 5732,
     /* 259345 */     GIR_EraseRootFromParent_Done,
     /* 259346 */   // Label 5017: @259346
     /* 259346 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(259410), // Rule ID 3853 //
     /* 259351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 259359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259387 */     // MIs[0] imm
     /* 259387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259395 */     // (intrinsic_wo_chain:{ *:[v4i32] } 547:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 259398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259408 */     GIR_RootConstrainSelectedInstOperands,
     /* 259409 */     // GIR_Coverage, 3853,
     /* 259409 */     GIR_EraseRootFromParent_Done,
     /* 259410 */   // Label 5018: @259410
     /* 259410 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(259474), // Rule ID 3854 //
     /* 259415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 259423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259451 */     // MIs[0] imm
     /* 259451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 548:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 259462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259470 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259472 */     GIR_RootConstrainSelectedInstOperands,
     /* 259473 */     // GIR_Coverage, 3854,
     /* 259473 */     GIR_EraseRootFromParent_Done,
     /* 259474 */   // Label 5019: @259474
     /* 259474 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(259538), // Rule ID 3855 //
     /* 259479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 259487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259515 */     // MIs[0] imm
     /* 259515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259523 */     // (intrinsic_wo_chain:{ *:[v4i32] } 549:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 259526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259534 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259536 */     GIR_RootConstrainSelectedInstOperands,
     /* 259537 */     // GIR_Coverage, 3855,
     /* 259537 */     GIR_EraseRootFromParent_Done,
     /* 259538 */   // Label 5020: @259538
     /* 259538 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(259602), // Rule ID 3856 //
     /* 259543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 259551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259579 */     // MIs[0] imm
     /* 259579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259587 */     // (intrinsic_wo_chain:{ *:[v4i32] } 550:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 259590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259598 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259600 */     GIR_RootConstrainSelectedInstOperands,
     /* 259601 */     // GIR_Coverage, 3856,
     /* 259601 */     GIR_EraseRootFromParent_Done,
     /* 259602 */   // Label 5021: @259602
     /* 259602 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(259654), // Rule ID 2846 //
     /* 259607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259631 */     // MIs[0] idx
     /* 259631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259639 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1472:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 259639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 259642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259650 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259652 */     GIR_RootConstrainSelectedInstOperands,
     /* 259653 */     // GIR_Coverage, 2846,
     /* 259653 */     GIR_EraseRootFromParent_Done,
     /* 259654 */   // Label 5022: @259654
     /* 259654 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(259706), // Rule ID 2847 //
     /* 259659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259683 */     // MIs[0] idx
     /* 259683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259691 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 259694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259702 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259704 */     GIR_RootConstrainSelectedInstOperands,
     /* 259705 */     // GIR_Coverage, 2847,
     /* 259705 */     GIR_EraseRootFromParent_Done,
     /* 259706 */   // Label 5023: @259706
     /* 259706 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259758), // Rule ID 2848 //
     /* 259711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259735 */     // MIs[0] idx
     /* 259735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259743 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 259743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 259746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259754 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259756 */     GIR_RootConstrainSelectedInstOperands,
     /* 259757 */     // GIR_Coverage, 2848,
     /* 259757 */     GIR_EraseRootFromParent_Done,
     /* 259758 */   // Label 5024: @259758
     /* 259758 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259810), // Rule ID 2976 //
     /* 259763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259787 */     // MIs[0] Op4
     /* 259787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 259798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259806 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259808 */     GIR_RootConstrainSelectedInstOperands,
     /* 259809 */     // GIR_Coverage, 2976,
     /* 259809 */     GIR_EraseRootFromParent_Done,
     /* 259810 */   // Label 5025: @259810
     /* 259810 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259862), // Rule ID 2977 //
     /* 259815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259839 */     // MIs[0] Op4
     /* 259839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 259850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259858 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259860 */     GIR_RootConstrainSelectedInstOperands,
     /* 259861 */     // GIR_Coverage, 2977,
     /* 259861 */     GIR_EraseRootFromParent_Done,
     /* 259862 */   // Label 5026: @259862
     /* 259862 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259914), // Rule ID 2978 //
     /* 259867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259891 */     // MIs[0] Op4
     /* 259891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 259902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259910 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259912 */     GIR_RootConstrainSelectedInstOperands,
     /* 259913 */     // GIR_Coverage, 2978,
     /* 259913 */     GIR_EraseRootFromParent_Done,
     /* 259914 */   // Label 5027: @259914
     /* 259914 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(259966), // Rule ID 2979 //
     /* 259919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 259927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259943 */     // MIs[0] Op4
     /* 259943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 259954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259962 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259964 */     GIR_RootConstrainSelectedInstOperands,
     /* 259965 */     // GIR_Coverage, 2979,
     /* 259965 */     GIR_EraseRootFromParent_Done,
     /* 259966 */   // Label 5028: @259966
     /* 259966 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(260018), // Rule ID 2980 //
     /* 259971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 259979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259995 */     // MIs[0] Op4
     /* 259995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 260006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260014 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260016 */     GIR_RootConstrainSelectedInstOperands,
     /* 260017 */     // GIR_Coverage, 2980,
     /* 260017 */     GIR_EraseRootFromParent_Done,
     /* 260018 */   // Label 5029: @260018
     /* 260018 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(260070), // Rule ID 2983 //
     /* 260023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 260031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260047 */     // MIs[0] Op4
     /* 260047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 260058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260066 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260068 */     GIR_RootConstrainSelectedInstOperands,
     /* 260069 */     // GIR_Coverage, 2983,
     /* 260069 */     GIR_EraseRootFromParent_Done,
     /* 260070 */   // Label 5030: @260070
     /* 260070 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(260122), // Rule ID 2984 //
     /* 260075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 260083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260099 */     // MIs[0] Op4
     /* 260099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260107 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 260110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260118 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260120 */     GIR_RootConstrainSelectedInstOperands,
     /* 260121 */     // GIR_Coverage, 2984,
     /* 260121 */     GIR_EraseRootFromParent_Done,
     /* 260122 */   // Label 5031: @260122
     /* 260122 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(260174), // Rule ID 3460 //
     /* 260127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 260135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260151 */     // MIs[0] Op4
     /* 260151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2067:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 260162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260170 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260172 */     GIR_RootConstrainSelectedInstOperands,
     /* 260173 */     // GIR_Coverage, 3460,
     /* 260173 */     GIR_EraseRootFromParent_Done,
     /* 260174 */   // Label 5032: @260174
     /* 260174 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(260226), // Rule ID 3504 //
     /* 260179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 260187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260203 */     // MIs[0] Op4
     /* 260203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 260214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260222 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260224 */     GIR_RootConstrainSelectedInstOperands,
     /* 260225 */     // GIR_Coverage, 3504,
     /* 260225 */     GIR_EraseRootFromParent_Done,
     /* 260226 */   // Label 5033: @260226
     /* 260226 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(260278), // Rule ID 7721 //
     /* 260231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260255 */     // MIs[0] Op4
     /* 260255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 260266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260274 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260276 */     GIR_RootConstrainSelectedInstOperands,
     /* 260277 */     // GIR_Coverage, 7721,
     /* 260277 */     GIR_EraseRootFromParent_Done,
     /* 260278 */   // Label 5034: @260278
     /* 260278 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(260330), // Rule ID 7722 //
     /* 260283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260307 */     // MIs[0] Op4
     /* 260307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 260318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260326 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260328 */     GIR_RootConstrainSelectedInstOperands,
     /* 260329 */     // GIR_Coverage, 7722,
     /* 260329 */     GIR_EraseRootFromParent_Done,
     /* 260330 */   // Label 5035: @260330
     /* 260330 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(260382), // Rule ID 8362 //
     /* 260335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260359 */     // MIs[0] idx
     /* 260359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260367 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 260367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 260370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260378 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260380 */     GIR_RootConstrainSelectedInstOperands,
     /* 260381 */     // GIR_Coverage, 8362,
     /* 260381 */     GIR_EraseRootFromParent_Done,
     /* 260382 */   // Label 5036: @260382
     /* 260382 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(260434), // Rule ID 8363 //
     /* 260387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260411 */     // MIs[0] idx
     /* 260411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260419 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 260422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260430 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260432 */     GIR_RootConstrainSelectedInstOperands,
     /* 260433 */     // GIR_Coverage, 8363,
     /* 260433 */     GIR_EraseRootFromParent_Done,
     /* 260434 */   // Label 5037: @260434
     /* 260434 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(260486), // Rule ID 8364 //
     /* 260439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260463 */     // MIs[0] idx
     /* 260463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260471 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1479:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 260474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260482 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260484 */     GIR_RootConstrainSelectedInstOperands,
     /* 260485 */     // GIR_Coverage, 8364,
     /* 260485 */     GIR_EraseRootFromParent_Done,
     /* 260486 */   // Label 5038: @260486
     /* 260486 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(260538), // Rule ID 11328 //
     /* 260491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 260499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260515 */     // MIs[0] Op4
     /* 260515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 260526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260534 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260536 */     GIR_RootConstrainSelectedInstOperands,
     /* 260537 */     // GIR_Coverage, 11328,
     /* 260537 */     GIR_EraseRootFromParent_Done,
     /* 260538 */   // Label 5039: @260538
     /* 260538 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(260590), // Rule ID 11375 //
     /* 260543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260567 */     // MIs[0] Op4
     /* 260567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1615:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 260578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260586 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260588 */     GIR_RootConstrainSelectedInstOperands,
     /* 260589 */     // GIR_Coverage, 11375,
     /* 260589 */     GIR_EraseRootFromParent_Done,
     /* 260590 */   // Label 5040: @260590
     /* 260590 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(260642), // Rule ID 11376 //
     /* 260595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260619 */     // MIs[0] Op4
     /* 260619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1615:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 260630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260638 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260640 */     GIR_RootConstrainSelectedInstOperands,
     /* 260641 */     // GIR_Coverage, 11376,
     /* 260641 */     GIR_EraseRootFromParent_Done,
     /* 260642 */   // Label 5041: @260642
     /* 260642 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(260694), // Rule ID 11377 //
     /* 260647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260671 */     // MIs[0] Op4
     /* 260671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260679 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1615:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 260682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260690 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260692 */     GIR_RootConstrainSelectedInstOperands,
     /* 260693 */     // GIR_Coverage, 11377,
     /* 260693 */     GIR_EraseRootFromParent_Done,
     /* 260694 */   // Label 5042: @260694
     /* 260694 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260746), // Rule ID 11378 //
     /* 260699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260723 */     // MIs[0] Op4
     /* 260723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 260734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260742 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260744 */     GIR_RootConstrainSelectedInstOperands,
     /* 260745 */     // GIR_Coverage, 11378,
     /* 260745 */     GIR_EraseRootFromParent_Done,
     /* 260746 */   // Label 5043: @260746
     /* 260746 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260798), // Rule ID 11379 //
     /* 260751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260775 */     // MIs[0] Op4
     /* 260775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 260786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260794 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260796 */     GIR_RootConstrainSelectedInstOperands,
     /* 260797 */     // GIR_Coverage, 11379,
     /* 260797 */     GIR_EraseRootFromParent_Done,
     /* 260798 */   // Label 5044: @260798
     /* 260798 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(260850), // Rule ID 11380 //
     /* 260803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260827 */     // MIs[0] Op4
     /* 260827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260835 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 260838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260846 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260848 */     GIR_RootConstrainSelectedInstOperands,
     /* 260849 */     // GIR_Coverage, 11380,
     /* 260849 */     GIR_EraseRootFromParent_Done,
     /* 260850 */   // Label 5045: @260850
     /* 260850 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(260902), // Rule ID 11381 //
     /* 260855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260879 */     // MIs[0] Op4
     /* 260879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 260890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260898 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260900 */     GIR_RootConstrainSelectedInstOperands,
     /* 260901 */     // GIR_Coverage, 11381,
     /* 260901 */     GIR_EraseRootFromParent_Done,
     /* 260902 */   // Label 5046: @260902
     /* 260902 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(260954), // Rule ID 11382 //
     /* 260907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260931 */     // MIs[0] Op4
     /* 260931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 260942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260950 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260952 */     GIR_RootConstrainSelectedInstOperands,
     /* 260953 */     // GIR_Coverage, 11382,
     /* 260953 */     GIR_EraseRootFromParent_Done,
     /* 260954 */   // Label 5047: @260954
     /* 260954 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(261006), // Rule ID 11383 //
     /* 260959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260983 */     // MIs[0] Op4
     /* 260983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 260994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261002 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261004 */     GIR_RootConstrainSelectedInstOperands,
     /* 261005 */     // GIR_Coverage, 11383,
     /* 261005 */     GIR_EraseRootFromParent_Done,
     /* 261006 */   // Label 5048: @261006
     /* 261006 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(261058), // Rule ID 11426 //
     /* 261011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 261019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261035 */     // MIs[0] Op4
     /* 261035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 261046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261054 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261056 */     GIR_RootConstrainSelectedInstOperands,
     /* 261057 */     // GIR_Coverage, 11426,
     /* 261057 */     GIR_EraseRootFromParent_Done,
     /* 261058 */   // Label 5049: @261058
     /* 261058 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(261110), // Rule ID 11427 //
     /* 261063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 261071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261087 */     // MIs[0] Op4
     /* 261087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 261098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261106 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261108 */     GIR_RootConstrainSelectedInstOperands,
     /* 261109 */     // GIR_Coverage, 11427,
     /* 261109 */     GIR_EraseRootFromParent_Done,
     /* 261110 */   // Label 5050: @261110
     /* 261110 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(261162), // Rule ID 11428 //
     /* 261115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261139 */     // MIs[0] Op4
     /* 261139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261147 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 261150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261158 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261160 */     GIR_RootConstrainSelectedInstOperands,
     /* 261161 */     // GIR_Coverage, 11428,
     /* 261161 */     GIR_EraseRootFromParent_Done,
     /* 261162 */   // Label 5051: @261162
     /* 261162 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(261214), // Rule ID 11429 //
     /* 261167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261191 */     // MIs[0] Op4
     /* 261191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261199 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 261202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261212 */     GIR_RootConstrainSelectedInstOperands,
     /* 261213 */     // GIR_Coverage, 11429,
     /* 261213 */     GIR_EraseRootFromParent_Done,
     /* 261214 */   // Label 5052: @261214
     /* 261214 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(261266), // Rule ID 11430 //
     /* 261219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261243 */     // MIs[0] Op4
     /* 261243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 261254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261262 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261264 */     GIR_RootConstrainSelectedInstOperands,
     /* 261265 */     // GIR_Coverage, 11430,
     /* 261265 */     GIR_EraseRootFromParent_Done,
     /* 261266 */   // Label 5053: @261266
     /* 261266 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(261318), // Rule ID 11431 //
     /* 261271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261295 */     // MIs[0] Op4
     /* 261295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 261306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261314 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261316 */     GIR_RootConstrainSelectedInstOperands,
     /* 261317 */     // GIR_Coverage, 11431,
     /* 261317 */     GIR_EraseRootFromParent_Done,
     /* 261318 */   // Label 5054: @261318
     /* 261318 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(261370), // Rule ID 11432 //
     /* 261323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261347 */     // MIs[0] Op4
     /* 261347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 261358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261366 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261368 */     GIR_RootConstrainSelectedInstOperands,
     /* 261369 */     // GIR_Coverage, 11432,
     /* 261369 */     GIR_EraseRootFromParent_Done,
     /* 261370 */   // Label 5055: @261370
     /* 261370 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(261422), // Rule ID 11433 //
     /* 261375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261399 */     // MIs[0] Op4
     /* 261399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261407 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1758:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 261410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261418 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261420 */     GIR_RootConstrainSelectedInstOperands,
     /* 261421 */     // GIR_Coverage, 11433,
     /* 261421 */     GIR_EraseRootFromParent_Done,
     /* 261422 */   // Label 5056: @261422
     /* 261422 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(261474), // Rule ID 11434 //
     /* 261427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261451 */     // MIs[0] Op4
     /* 261451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 261462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261470 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261472 */     GIR_RootConstrainSelectedInstOperands,
     /* 261473 */     // GIR_Coverage, 11434,
     /* 261473 */     GIR_EraseRootFromParent_Done,
     /* 261474 */   // Label 5057: @261474
     /* 261474 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(261526), // Rule ID 11435 //
     /* 261479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261503 */     // MIs[0] Op4
     /* 261503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 261514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261522 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261524 */     GIR_RootConstrainSelectedInstOperands,
     /* 261525 */     // GIR_Coverage, 11435,
     /* 261525 */     GIR_EraseRootFromParent_Done,
     /* 261526 */   // Label 5058: @261526
     /* 261526 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(261578), // Rule ID 11436 //
     /* 261531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261555 */     // MIs[0] Op4
     /* 261555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 261566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261574 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261576 */     GIR_RootConstrainSelectedInstOperands,
     /* 261577 */     // GIR_Coverage, 11436,
     /* 261577 */     GIR_EraseRootFromParent_Done,
     /* 261578 */   // Label 5059: @261578
     /* 261578 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(261630), // Rule ID 11437 //
     /* 261583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261607 */     // MIs[0] Op4
     /* 261607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261615 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 261618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261626 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261628 */     GIR_RootConstrainSelectedInstOperands,
     /* 261629 */     // GIR_Coverage, 11437,
     /* 261629 */     GIR_EraseRootFromParent_Done,
     /* 261630 */   // Label 5060: @261630
     /* 261630 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(261682), // Rule ID 11438 //
     /* 261635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 261643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261659 */     // MIs[0] Op4
     /* 261659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1998:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 261670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261678 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261680 */     GIR_RootConstrainSelectedInstOperands,
     /* 261681 */     // GIR_Coverage, 11438,
     /* 261681 */     GIR_EraseRootFromParent_Done,
     /* 261682 */   // Label 5061: @261682
     /* 261682 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(261734), // Rule ID 11439 //
     /* 261687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 261695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261711 */     // MIs[0] Op4
     /* 261711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261719 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1998:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 261722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261730 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261732 */     GIR_RootConstrainSelectedInstOperands,
     /* 261733 */     // GIR_Coverage, 11439,
     /* 261733 */     GIR_EraseRootFromParent_Done,
     /* 261734 */   // Label 5062: @261734
     /* 261734 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(261786), // Rule ID 11461 //
     /* 261739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 261747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261763 */     // MIs[0] Op4
     /* 261763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 261774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261784 */     GIR_RootConstrainSelectedInstOperands,
     /* 261785 */     // GIR_Coverage, 11461,
     /* 261785 */     GIR_EraseRootFromParent_Done,
     /* 261786 */   // Label 5063: @261786
     /* 261786 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(261838), // Rule ID 11462 //
     /* 261791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 261799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261815 */     // MIs[0] Op4
     /* 261815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261823 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 261826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261836 */     GIR_RootConstrainSelectedInstOperands,
     /* 261837 */     // GIR_Coverage, 11462,
     /* 261837 */     GIR_EraseRootFromParent_Done,
     /* 261838 */   // Label 5064: @261838
     /* 261838 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(261890), // Rule ID 11463 //
     /* 261843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 261851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261867 */     // MIs[0] Op4
     /* 261867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 261878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261886 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261888 */     GIR_RootConstrainSelectedInstOperands,
     /* 261889 */     // GIR_Coverage, 11463,
     /* 261889 */     GIR_EraseRootFromParent_Done,
     /* 261890 */   // Label 5065: @261890
     /* 261890 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(261942), // Rule ID 11464 //
     /* 261895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 261903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261919 */     // MIs[0] Op4
     /* 261919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 261930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261938 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261940 */     GIR_RootConstrainSelectedInstOperands,
     /* 261941 */     // GIR_Coverage, 11464,
     /* 261941 */     GIR_EraseRootFromParent_Done,
     /* 261942 */   // Label 5066: @261942
     /* 261942 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(261994), // Rule ID 11465 //
     /* 261947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 261955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261971 */     // MIs[0] Op4
     /* 261971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 261982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261990 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261992 */     GIR_RootConstrainSelectedInstOperands,
     /* 261993 */     // GIR_Coverage, 11465,
     /* 261993 */     GIR_EraseRootFromParent_Done,
     /* 261994 */   // Label 5067: @261994
     /* 261994 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(262046), // Rule ID 11466 //
     /* 261999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 262007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262023 */     // MIs[0] Op4
     /* 262023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 262034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262042 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262044 */     GIR_RootConstrainSelectedInstOperands,
     /* 262045 */     // GIR_Coverage, 11466,
     /* 262045 */     GIR_EraseRootFromParent_Done,
     /* 262046 */   // Label 5068: @262046
     /* 262046 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(262098), // Rule ID 11467 //
     /* 262051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 262059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262075 */     // MIs[0] Op4
     /* 262075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 262086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262094 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262096 */     GIR_RootConstrainSelectedInstOperands,
     /* 262097 */     // GIR_Coverage, 11467,
     /* 262097 */     GIR_EraseRootFromParent_Done,
     /* 262098 */   // Label 5069: @262098
     /* 262098 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(262150), // Rule ID 11468 //
     /* 262103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 262111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262127 */     // MIs[0] Op4
     /* 262127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 262138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262146 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262148 */     GIR_RootConstrainSelectedInstOperands,
     /* 262149 */     // GIR_Coverage, 11468,
     /* 262149 */     GIR_EraseRootFromParent_Done,
     /* 262150 */   // Label 5070: @262150
     /* 262150 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(262202), // Rule ID 11934 //
     /* 262155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 262163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262179 */     // MIs[0] Op4
     /* 262179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262187 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 262190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262198 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262200 */     GIR_RootConstrainSelectedInstOperands,
     /* 262201 */     // GIR_Coverage, 11934,
     /* 262201 */     GIR_EraseRootFromParent_Done,
     /* 262202 */   // Label 5071: @262202
     /* 262202 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(262254), // Rule ID 11935 //
     /* 262207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 262215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262231 */     // MIs[0] Op4
     /* 262231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262239 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 262242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262250 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262252 */     GIR_RootConstrainSelectedInstOperands,
     /* 262253 */     // GIR_Coverage, 11935,
     /* 262253 */     GIR_EraseRootFromParent_Done,
     /* 262254 */   // Label 5072: @262254
     /* 262254 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(262306), // Rule ID 11936 //
     /* 262259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 262267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262283 */     // MIs[0] Op4
     /* 262283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262291 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1482:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 262294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262302 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262304 */     GIR_RootConstrainSelectedInstOperands,
     /* 262305 */     // GIR_Coverage, 11936,
     /* 262305 */     GIR_EraseRootFromParent_Done,
     /* 262306 */   // Label 5073: @262306
     /* 262306 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(262358), // Rule ID 11937 //
     /* 262311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 262319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262335 */     // MIs[0] Op4
     /* 262335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262343 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 262346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262354 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262356 */     GIR_RootConstrainSelectedInstOperands,
     /* 262357 */     // GIR_Coverage, 11937,
     /* 262357 */     GIR_EraseRootFromParent_Done,
     /* 262358 */   // Label 5074: @262358
     /* 262358 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(262410), // Rule ID 12081 //
     /* 262363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 262371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262387 */     // MIs[0] Op4
     /* 262387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262395 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1430:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 262398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262408 */     GIR_RootConstrainSelectedInstOperands,
     /* 262409 */     // GIR_Coverage, 12081,
     /* 262409 */     GIR_EraseRootFromParent_Done,
     /* 262410 */   // Label 5075: @262410
     /* 262410 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(262462), // Rule ID 12083 //
     /* 262415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 262423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262439 */     // MIs[0] Op4
     /* 262439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 262450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262458 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262460 */     GIR_RootConstrainSelectedInstOperands,
     /* 262461 */     // GIR_Coverage, 12083,
     /* 262461 */     GIR_EraseRootFromParent_Done,
     /* 262462 */   // Label 5076: @262462
     /* 262462 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(262509), // Rule ID 2825 //
     /* 262467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1471:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262505 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262507 */     GIR_RootConstrainSelectedInstOperands,
     /* 262508 */     // GIR_Coverage, 2825,
     /* 262508 */     GIR_EraseRootFromParent_Done,
     /* 262509 */   // Label 5077: @262509
     /* 262509 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(262556), // Rule ID 2828 //
     /* 262514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262541 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262552 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262554 */     GIR_RootConstrainSelectedInstOperands,
     /* 262555 */     // GIR_Coverage, 2828,
     /* 262555 */     GIR_EraseRootFromParent_Done,
     /* 262556 */   // Label 5078: @262556
     /* 262556 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(262603), // Rule ID 2831 //
     /* 262561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262588 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262601 */     GIR_RootConstrainSelectedInstOperands,
     /* 262602 */     // GIR_Coverage, 2831,
     /* 262602 */     GIR_EraseRootFromParent_Done,
     /* 262603 */   // Label 5079: @262603
     /* 262603 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(262650), // Rule ID 2834 //
     /* 262608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262635 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 262638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262646 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262648 */     GIR_RootConstrainSelectedInstOperands,
     /* 262649 */     // GIR_Coverage, 2834,
     /* 262649 */     GIR_EraseRootFromParent_Done,
     /* 262650 */   // Label 5080: @262650
     /* 262650 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(262697), // Rule ID 2837 //
     /* 262655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262682 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 262685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262695 */     GIR_RootConstrainSelectedInstOperands,
     /* 262696 */     // GIR_Coverage, 2837,
     /* 262696 */     GIR_EraseRootFromParent_Done,
     /* 262697 */   // Label 5081: @262697
     /* 262697 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(262744), // Rule ID 2840 //
     /* 262702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 262732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262740 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262742 */     GIR_RootConstrainSelectedInstOperands,
     /* 262743 */     // GIR_Coverage, 2840,
     /* 262743 */     GIR_EraseRootFromParent_Done,
     /* 262744 */   // Label 5082: @262744
     /* 262744 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(262791), // Rule ID 2843 //
     /* 262749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262776 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1434:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 262779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262789 */     GIR_RootConstrainSelectedInstOperands,
     /* 262790 */     // GIR_Coverage, 2843,
     /* 262790 */     GIR_EraseRootFromParent_Done,
     /* 262791 */   // Label 5083: @262791
     /* 262791 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(262838), // Rule ID 2844 //
     /* 262796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262823 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1434:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 262826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262836 */     GIR_RootConstrainSelectedInstOperands,
     /* 262837 */     // GIR_Coverage, 2844,
     /* 262837 */     GIR_EraseRootFromParent_Done,
     /* 262838 */   // Label 5084: @262838
     /* 262838 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(262885), // Rule ID 2845 //
     /* 262843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1434:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 262873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262883 */     GIR_RootConstrainSelectedInstOperands,
     /* 262884 */     // GIR_Coverage, 2845,
     /* 262884 */     GIR_EraseRootFromParent_Done,
     /* 262885 */   // Label 5085: @262885
     /* 262885 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(262932), // Rule ID 2941 //
     /* 262890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 262901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 262904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 262913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1609:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 262917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 262920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262928 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262930 */     GIR_RootConstrainSelectedInstOperands,
     /* 262931 */     // GIR_Coverage, 2941,
     /* 262931 */     GIR_EraseRootFromParent_Done,
     /* 262932 */   // Label 5086: @262932
     /* 262932 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(262979), // Rule ID 2944 //
     /* 262937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 262964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 262967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262977 */     GIR_RootConstrainSelectedInstOperands,
     /* 262978 */     // GIR_Coverage, 2944,
     /* 262978 */     GIR_EraseRootFromParent_Done,
     /* 262979 */   // Label 5087: @262979
     /* 262979 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(263026), // Rule ID 2947 //
     /* 262984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 263014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263024 */     GIR_RootConstrainSelectedInstOperands,
     /* 263025 */     // GIR_Coverage, 2947,
     /* 263025 */     GIR_EraseRootFromParent_Done,
     /* 263026 */   // Label 5088: @263026
     /* 263026 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(263073), // Rule ID 2950 //
     /* 263031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 263039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 263061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263069 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263071 */     GIR_RootConstrainSelectedInstOperands,
     /* 263072 */     // GIR_Coverage, 2950,
     /* 263072 */     GIR_EraseRootFromParent_Done,
     /* 263073 */   // Label 5089: @263073
     /* 263073 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(263120), // Rule ID 2953 //
     /* 263078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263105 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 263108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263116 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263118 */     GIR_RootConstrainSelectedInstOperands,
     /* 263119 */     // GIR_Coverage, 2953,
     /* 263119 */     GIR_EraseRootFromParent_Done,
     /* 263120 */   // Label 5090: @263120
     /* 263120 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(263167), // Rule ID 2955 //
     /* 263125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 263155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263165 */     GIR_RootConstrainSelectedInstOperands,
     /* 263166 */     // GIR_Coverage, 2955,
     /* 263166 */     GIR_EraseRootFromParent_Done,
     /* 263167 */   // Label 5091: @263167
     /* 263167 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(263214), // Rule ID 2957 //
     /* 263172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 263202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263212 */     GIR_RootConstrainSelectedInstOperands,
     /* 263213 */     // GIR_Coverage, 2957,
     /* 263213 */     GIR_EraseRootFromParent_Done,
     /* 263214 */   // Label 5092: @263214
     /* 263214 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(263261), // Rule ID 2959 //
     /* 263219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 263249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263259 */     GIR_RootConstrainSelectedInstOperands,
     /* 263260 */     // GIR_Coverage, 2959,
     /* 263260 */     GIR_EraseRootFromParent_Done,
     /* 263261 */   // Label 5093: @263261
     /* 263261 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(263308), // Rule ID 7627 //
     /* 263266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263293 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 263296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263304 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263306 */     GIR_RootConstrainSelectedInstOperands,
     /* 263307 */     // GIR_Coverage, 7627,
     /* 263307 */     GIR_EraseRootFromParent_Done,
     /* 263308 */   // Label 5094: @263308
     /* 263308 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(263355), // Rule ID 7630 //
     /* 263313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 263343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263353 */     GIR_RootConstrainSelectedInstOperands,
     /* 263354 */     // GIR_Coverage, 7630,
     /* 263354 */     GIR_EraseRootFromParent_Done,
     /* 263355 */   // Label 5095: @263355
     /* 263355 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(263402), // Rule ID 7633 //
     /* 263360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 263390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263398 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263400 */     GIR_RootConstrainSelectedInstOperands,
     /* 263401 */     // GIR_Coverage, 7633,
     /* 263401 */     GIR_EraseRootFromParent_Done,
     /* 263402 */   // Label 5096: @263402
     /* 263402 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(263449), // Rule ID 7636 //
     /* 263407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 263437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263445 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263447 */     GIR_RootConstrainSelectedInstOperands,
     /* 263448 */     // GIR_Coverage, 7636,
     /* 263448 */     GIR_EraseRootFromParent_Done,
     /* 263449 */   // Label 5097: @263449
     /* 263449 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(263496), // Rule ID 7639 //
     /* 263454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 263484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263492 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263494 */     GIR_RootConstrainSelectedInstOperands,
     /* 263495 */     // GIR_Coverage, 7639,
     /* 263495 */     GIR_EraseRootFromParent_Done,
     /* 263496 */   // Label 5098: @263496
     /* 263496 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(263543), // Rule ID 7641 //
     /* 263501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 263531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263541 */     GIR_RootConstrainSelectedInstOperands,
     /* 263542 */     // GIR_Coverage, 7641,
     /* 263542 */     GIR_EraseRootFromParent_Done,
     /* 263543 */   // Label 5099: @263543
     /* 263543 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(263590), // Rule ID 7643 //
     /* 263548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 263578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263586 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263588 */     GIR_RootConstrainSelectedInstOperands,
     /* 263589 */     // GIR_Coverage, 7643,
     /* 263589 */     GIR_EraseRootFromParent_Done,
     /* 263590 */   // Label 5100: @263590
     /* 263590 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(263637), // Rule ID 7645 //
     /* 263595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 263625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263635 */     GIR_RootConstrainSelectedInstOperands,
     /* 263636 */     // GIR_Coverage, 7645,
     /* 263636 */     GIR_EraseRootFromParent_Done,
     /* 263637 */   // Label 5101: @263637
     /* 263637 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(263684), // Rule ID 8275 //
     /* 263642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263669 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263680 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263682 */     GIR_RootConstrainSelectedInstOperands,
     /* 263683 */     // GIR_Coverage, 8275,
     /* 263683 */     GIR_EraseRootFromParent_Done,
     /* 263684 */   // Label 5102: @263684
     /* 263684 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(263731), // Rule ID 8278 //
     /* 263689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263716 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263727 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263729 */     GIR_RootConstrainSelectedInstOperands,
     /* 263730 */     // GIR_Coverage, 8278,
     /* 263730 */     GIR_EraseRootFromParent_Done,
     /* 263731 */   // Label 5103: @263731
     /* 263731 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(263778), // Rule ID 8281 //
     /* 263736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263763 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263774 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263776 */     GIR_RootConstrainSelectedInstOperands,
     /* 263777 */     // GIR_Coverage, 8281,
     /* 263777 */     GIR_EraseRootFromParent_Done,
     /* 263778 */   // Label 5104: @263778
     /* 263778 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(263825), // Rule ID 8284 //
     /* 263783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 263813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263821 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263823 */     GIR_RootConstrainSelectedInstOperands,
     /* 263824 */     // GIR_Coverage, 8284,
     /* 263824 */     GIR_EraseRootFromParent_Done,
     /* 263825 */   // Label 5105: @263825
     /* 263825 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(263872), // Rule ID 8287 //
     /* 263830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263857 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 263860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263868 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263870 */     GIR_RootConstrainSelectedInstOperands,
     /* 263871 */     // GIR_Coverage, 8287,
     /* 263871 */     GIR_EraseRootFromParent_Done,
     /* 263872 */   // Label 5106: @263872
     /* 263872 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(263919), // Rule ID 8290 //
     /* 263877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 263907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263915 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263917 */     GIR_RootConstrainSelectedInstOperands,
     /* 263918 */     // GIR_Coverage, 8290,
     /* 263918 */     GIR_EraseRootFromParent_Done,
     /* 263919 */   // Label 5107: @263919
     /* 263919 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(263966), // Rule ID 8293 //
     /* 263924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263951 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1494:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 263954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263962 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263964 */     GIR_RootConstrainSelectedInstOperands,
     /* 263965 */     // GIR_Coverage, 8293,
     /* 263965 */     GIR_EraseRootFromParent_Done,
     /* 263966 */   // Label 5108: @263966
     /* 263966 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(264013), // Rule ID 8294 //
     /* 263971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263998 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 264001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264009 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264011 */     GIR_RootConstrainSelectedInstOperands,
     /* 264012 */     // GIR_Coverage, 8294,
     /* 264012 */     GIR_EraseRootFromParent_Done,
     /* 264013 */   // Label 5109: @264013
     /* 264013 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(264060), // Rule ID 8295 //
     /* 264018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 264048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264056 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264058 */     GIR_RootConstrainSelectedInstOperands,
     /* 264059 */     // GIR_Coverage, 8295,
     /* 264059 */     GIR_EraseRootFromParent_Done,
     /* 264060 */   // Label 5110: @264060
     /* 264060 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(264107), // Rule ID 8296 //
     /* 264065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 264095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264103 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264105 */     GIR_RootConstrainSelectedInstOperands,
     /* 264106 */     // GIR_Coverage, 8296,
     /* 264106 */     GIR_EraseRootFromParent_Done,
     /* 264107 */   // Label 5111: @264107
     /* 264107 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(264154), // Rule ID 8297 //
     /* 264112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264139 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 264142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264150 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264152 */     GIR_RootConstrainSelectedInstOperands,
     /* 264153 */     // GIR_Coverage, 8297,
     /* 264153 */     GIR_EraseRootFromParent_Done,
     /* 264154 */   // Label 5112: @264154
     /* 264154 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(264201), // Rule ID 8298 //
     /* 264159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 264189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264197 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264199 */     GIR_RootConstrainSelectedInstOperands,
     /* 264200 */     // GIR_Coverage, 8298,
     /* 264200 */     GIR_EraseRootFromParent_Done,
     /* 264201 */   // Label 5113: @264201
     /* 264201 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(264248), // Rule ID 8299 //
     /* 264206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264233 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1496:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264244 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264246 */     GIR_RootConstrainSelectedInstOperands,
     /* 264247 */     // GIR_Coverage, 8299,
     /* 264247 */     GIR_EraseRootFromParent_Done,
     /* 264248 */   // Label 5114: @264248
     /* 264248 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(264295), // Rule ID 8300 //
     /* 264253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264291 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264293 */     GIR_RootConstrainSelectedInstOperands,
     /* 264294 */     // GIR_Coverage, 8300,
     /* 264294 */     GIR_EraseRootFromParent_Done,
     /* 264295 */   // Label 5115: @264295
     /* 264295 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(264342), // Rule ID 8301 //
     /* 264300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264327 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264338 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264340 */     GIR_RootConstrainSelectedInstOperands,
     /* 264341 */     // GIR_Coverage, 8301,
     /* 264341 */     GIR_EraseRootFromParent_Done,
     /* 264342 */   // Label 5116: @264342
     /* 264342 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(264389), // Rule ID 8302 //
     /* 264347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264387 */     GIR_RootConstrainSelectedInstOperands,
     /* 264388 */     // GIR_Coverage, 8302,
     /* 264388 */     GIR_EraseRootFromParent_Done,
     /* 264389 */   // Label 5117: @264389
     /* 264389 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(264436), // Rule ID 8303 //
     /* 264394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264421 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264432 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264434 */     GIR_RootConstrainSelectedInstOperands,
     /* 264435 */     // GIR_Coverage, 8303,
     /* 264435 */     GIR_EraseRootFromParent_Done,
     /* 264436 */   // Label 5118: @264436
     /* 264436 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(264483), // Rule ID 8304 //
     /* 264441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264468 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 264471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264481 */     GIR_RootConstrainSelectedInstOperands,
     /* 264482 */     // GIR_Coverage, 8304,
     /* 264482 */     GIR_EraseRootFromParent_Done,
     /* 264483 */   // Label 5119: @264483
     /* 264483 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(264530), // Rule ID 8305 //
     /* 264488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264515 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 264518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264528 */     GIR_RootConstrainSelectedInstOperands,
     /* 264529 */     // GIR_Coverage, 8305,
     /* 264529 */     GIR_EraseRootFromParent_Done,
     /* 264530 */   // Label 5120: @264530
     /* 264530 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(264577), // Rule ID 8306 //
     /* 264535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264562 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 264565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264575 */     GIR_RootConstrainSelectedInstOperands,
     /* 264576 */     // GIR_Coverage, 8306,
     /* 264576 */     GIR_EraseRootFromParent_Done,
     /* 264577 */   // Label 5121: @264577
     /* 264577 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(264624), // Rule ID 8307 //
     /* 264582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264609 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 264612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264622 */     GIR_RootConstrainSelectedInstOperands,
     /* 264623 */     // GIR_Coverage, 8307,
     /* 264623 */     GIR_EraseRootFromParent_Done,
     /* 264624 */   // Label 5122: @264624
     /* 264624 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(264671), // Rule ID 8308 //
     /* 264629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264656 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 264659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264669 */     GIR_RootConstrainSelectedInstOperands,
     /* 264670 */     // GIR_Coverage, 8308,
     /* 264670 */     GIR_EraseRootFromParent_Done,
     /* 264671 */   // Label 5123: @264671
     /* 264671 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(264718), // Rule ID 8309 //
     /* 264676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 264706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264716 */     GIR_RootConstrainSelectedInstOperands,
     /* 264717 */     // GIR_Coverage, 8309,
     /* 264717 */     GIR_EraseRootFromParent_Done,
     /* 264718 */   // Label 5124: @264718
     /* 264718 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(264765), // Rule ID 8310 //
     /* 264723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264750 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 264753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264763 */     GIR_RootConstrainSelectedInstOperands,
     /* 264764 */     // GIR_Coverage, 8310,
     /* 264764 */     GIR_EraseRootFromParent_Done,
     /* 264765 */   // Label 5125: @264765
     /* 264765 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(264812), // Rule ID 8311 //
     /* 264770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264797 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 264800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264808 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264810 */     GIR_RootConstrainSelectedInstOperands,
     /* 264811 */     // GIR_Coverage, 8311,
     /* 264811 */     GIR_EraseRootFromParent_Done,
     /* 264812 */   // Label 5126: @264812
     /* 264812 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(264859), // Rule ID 8312 //
     /* 264817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 264847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264855 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264857 */     GIR_RootConstrainSelectedInstOperands,
     /* 264858 */     // GIR_Coverage, 8312,
     /* 264858 */     GIR_EraseRootFromParent_Done,
     /* 264859 */   // Label 5127: @264859
     /* 264859 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(264906), // Rule ID 8313 //
     /* 264864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264891 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1498:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 264894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264902 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264904 */     GIR_RootConstrainSelectedInstOperands,
     /* 264905 */     // GIR_Coverage, 8313,
     /* 264905 */     GIR_EraseRootFromParent_Done,
     /* 264906 */   // Label 5128: @264906
     /* 264906 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(264953), // Rule ID 8314 //
     /* 264911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264938 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 264941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264951 */     GIR_RootConstrainSelectedInstOperands,
     /* 264952 */     // GIR_Coverage, 8314,
     /* 264952 */     GIR_EraseRootFromParent_Done,
     /* 264953 */   // Label 5129: @264953
     /* 264953 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(265000), // Rule ID 8317 //
     /* 264958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264985 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 264988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264996 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264998 */     GIR_RootConstrainSelectedInstOperands,
     /* 264999 */     // GIR_Coverage, 8317,
     /* 264999 */     GIR_EraseRootFromParent_Done,
     /* 265000 */   // Label 5130: @265000
     /* 265000 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(265047), // Rule ID 8320 //
     /* 265005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265032 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 265035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265043 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265045 */     GIR_RootConstrainSelectedInstOperands,
     /* 265046 */     // GIR_Coverage, 8320,
     /* 265046 */     GIR_EraseRootFromParent_Done,
     /* 265047 */   // Label 5131: @265047
     /* 265047 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(265094), // Rule ID 8323 //
     /* 265052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265079 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 265082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265090 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265092 */     GIR_RootConstrainSelectedInstOperands,
     /* 265093 */     // GIR_Coverage, 8323,
     /* 265093 */     GIR_EraseRootFromParent_Done,
     /* 265094 */   // Label 5132: @265094
     /* 265094 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(265141), // Rule ID 8326 //
     /* 265099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265126 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 265129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265137 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265139 */     GIR_RootConstrainSelectedInstOperands,
     /* 265140 */     // GIR_Coverage, 8326,
     /* 265140 */     GIR_EraseRootFromParent_Done,
     /* 265141 */   // Label 5133: @265141
     /* 265141 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(265188), // Rule ID 8329 //
     /* 265146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265173 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 265176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265184 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265186 */     GIR_RootConstrainSelectedInstOperands,
     /* 265187 */     // GIR_Coverage, 8329,
     /* 265187 */     GIR_EraseRootFromParent_Done,
     /* 265188 */   // Label 5134: @265188
     /* 265188 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(265235), // Rule ID 8332 //
     /* 265193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1495:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265231 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265233 */     GIR_RootConstrainSelectedInstOperands,
     /* 265234 */     // GIR_Coverage, 8332,
     /* 265234 */     GIR_EraseRootFromParent_Done,
     /* 265235 */   // Label 5135: @265235
     /* 265235 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(265282), // Rule ID 8335 //
     /* 265240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265267 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265278 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265280 */     GIR_RootConstrainSelectedInstOperands,
     /* 265281 */     // GIR_Coverage, 8335,
     /* 265281 */     GIR_EraseRootFromParent_Done,
     /* 265282 */   // Label 5136: @265282
     /* 265282 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(265329), // Rule ID 8338 //
     /* 265287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265314 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265325 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265327 */     GIR_RootConstrainSelectedInstOperands,
     /* 265328 */     // GIR_Coverage, 8338,
     /* 265328 */     GIR_EraseRootFromParent_Done,
     /* 265329 */   // Label 5137: @265329
     /* 265329 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(265376), // Rule ID 8341 //
     /* 265334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265372 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265374 */     GIR_RootConstrainSelectedInstOperands,
     /* 265375 */     // GIR_Coverage, 8341,
     /* 265375 */     GIR_EraseRootFromParent_Done,
     /* 265376 */   // Label 5138: @265376
     /* 265376 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(265423), // Rule ID 8344 //
     /* 265381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265419 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265421 */     GIR_RootConstrainSelectedInstOperands,
     /* 265422 */     // GIR_Coverage, 8344,
     /* 265422 */     GIR_EraseRootFromParent_Done,
     /* 265423 */   // Label 5139: @265423
     /* 265423 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(265470), // Rule ID 8347 //
     /* 265428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265455 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 265458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265466 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265468 */     GIR_RootConstrainSelectedInstOperands,
     /* 265469 */     // GIR_Coverage, 8347,
     /* 265469 */     GIR_EraseRootFromParent_Done,
     /* 265470 */   // Label 5140: @265470
     /* 265470 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(265517), // Rule ID 8350 //
     /* 265475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265515 */     GIR_RootConstrainSelectedInstOperands,
     /* 265516 */     // GIR_Coverage, 8350,
     /* 265516 */     GIR_EraseRootFromParent_Done,
     /* 265517 */   // Label 5141: @265517
     /* 265517 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(265564), // Rule ID 8352 //
     /* 265522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265549 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1497:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265560 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265562 */     GIR_RootConstrainSelectedInstOperands,
     /* 265563 */     // GIR_Coverage, 8352,
     /* 265563 */     GIR_EraseRootFromParent_Done,
     /* 265564 */   // Label 5142: @265564
     /* 265564 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(265611), // Rule ID 8354 //
     /* 265569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265596 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265609 */     GIR_RootConstrainSelectedInstOperands,
     /* 265610 */     // GIR_Coverage, 8354,
     /* 265610 */     GIR_EraseRootFromParent_Done,
     /* 265611 */   // Label 5143: @265611
     /* 265611 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(265658), // Rule ID 8356 //
     /* 265616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265643 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1497:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 265646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265654 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265656 */     GIR_RootConstrainSelectedInstOperands,
     /* 265657 */     // GIR_Coverage, 8356,
     /* 265657 */     GIR_EraseRootFromParent_Done,
     /* 265658 */   // Label 5144: @265658
     /* 265658 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(265705), // Rule ID 8358 //
     /* 265663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 265693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265703 */     GIR_RootConstrainSelectedInstOperands,
     /* 265704 */     // GIR_Coverage, 8358,
     /* 265704 */     GIR_EraseRootFromParent_Done,
     /* 265705 */   // Label 5145: @265705
     /* 265705 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(265752), // Rule ID 8360 //
     /* 265710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265737 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 265740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265748 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265750 */     GIR_RootConstrainSelectedInstOperands,
     /* 265751 */     // GIR_Coverage, 8360,
     /* 265751 */     GIR_EraseRootFromParent_Done,
     /* 265752 */   // Label 5146: @265752
     /* 265752 */   GIM_Reject,
     /* 265753 */ // Label 5005: @265753
     /* 265753 */ GIM_Reject,
     /* 265754 */ // Label 38: @265754
     /* 265754 */ GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(265832),
     /* 265759 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 265762 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(265784), // Rule ID 78 //
     /* 265767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 265770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 265775 */     // (intrinsic_void 2176:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 265775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 265778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265782 */     GIR_RootConstrainSelectedInstOperands,
     /* 265783 */     // GIR_Coverage, 78,
     /* 265783 */     GIR_EraseRootFromParent_Done,
     /* 265784 */   // Label 5148: @265784
     /* 265784 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(265809), // Rule ID 2386 //
     /* 265789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 265792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 265797 */     // (intrinsic_void 1726:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 265797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 265800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 265803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265807 */     GIR_RootConstrainSelectedInstOperands,
     /* 265808 */     // GIR_Coverage, 2386,
     /* 265808 */     GIR_EraseRootFromParent_Done,
     /* 265809 */   // Label 5149: @265809
     /* 265809 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(265831), // Rule ID 7181 //
     /* 265814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 265819 */     // (intrinsic_void 510:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 265819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 265822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265829 */     GIR_RootConstrainSelectedInstOperands,
     /* 265830 */     // GIR_Coverage, 7181,
     /* 265830 */     GIR_EraseRootFromParent_Done,
     /* 265831 */   // Label 5150: @265831
     /* 265831 */   GIM_Reject,
     /* 265832 */ // Label 5147: @265832
     /* 265832 */ GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(266432),
     /* 265837 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 265840 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(265872), // Rule ID 79 //
     /* 265845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 265848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 265853 */     // MIs[0] imm
     /* 265853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 265861 */     // (intrinsic_void 2175:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 265861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 265864 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265870 */     GIR_RootConstrainSelectedInstOperands,
     /* 265871 */     // GIR_Coverage, 79,
     /* 265871 */     GIR_EraseRootFromParent_Done,
     /* 265872 */   // Label 5152: @265872
     /* 265872 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(265897), // Rule ID 227 //
     /* 265877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 265882 */     // MIs[0] imm
     /* 265882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 265890 */     // (intrinsic_void 508:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 265890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 265893 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265895 */     GIR_RootConstrainSelectedInstOperands,
     /* 265896 */     // GIR_Coverage, 227,
     /* 265896 */     GIR_EraseRootFromParent_Done,
     /* 265897 */   // Label 5153: @265897
     /* 265897 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(265922), // Rule ID 228 //
     /* 265902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 265907 */     // MIs[0] imm
     /* 265907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 265915 */     // (intrinsic_void 567:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 265915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 265918 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265920 */     GIR_RootConstrainSelectedInstOperands,
     /* 265921 */     // GIR_Coverage, 228,
     /* 265921 */     GIR_EraseRootFromParent_Done,
     /* 265922 */   // Label 5154: @265922
     /* 265922 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(265954), // Rule ID 3622 //
     /* 265927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 265930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 265935 */     // MIs[0] imm
     /* 265935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 265943 */     // (intrinsic_void 1232:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 265943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 265946 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265952 */     GIR_RootConstrainSelectedInstOperands,
     /* 265953 */     // GIR_Coverage, 3622,
     /* 265953 */     GIR_EraseRootFromParent_Done,
     /* 265954 */   // Label 5155: @265954
     /* 265954 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(265994), // Rule ID 16 //
     /* 265959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 265964 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 265979 */     // MIs[1] Operand 1
     /* 265979 */     // No operand predicates
     /* 265979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265981 */     // (intrinsic_void 566:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 265981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 265984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 265987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 265992 */     GIR_RootConstrainSelectedInstOperands,
     /* 265993 */     // GIR_Coverage, 16,
     /* 265993 */     GIR_EraseRootFromParent_Done,
     /* 265994 */   // Label 5156: @265994
     /* 265994 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(266034), // Rule ID 17 //
     /* 265999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 266004 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266019 */     // MIs[1] Operand 1
     /* 266019 */     // No operand predicates
     /* 266019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266021 */     // (intrinsic_void 554:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 266021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 266024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266032 */     GIR_RootConstrainSelectedInstOperands,
     /* 266033 */     // GIR_Coverage, 17,
     /* 266033 */     GIR_EraseRootFromParent_Done,
     /* 266034 */   // Label 5157: @266034
     /* 266034 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(266074), // Rule ID 18 //
     /* 266039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 266044 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266059 */     // MIs[1] Operand 1
     /* 266059 */     // No operand predicates
     /* 266059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266061 */     // (intrinsic_void 555:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 266061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 266064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266072 */     GIR_RootConstrainSelectedInstOperands,
     /* 266073 */     // GIR_Coverage, 18,
     /* 266073 */     GIR_EraseRootFromParent_Done,
     /* 266074 */   // Label 5158: @266074
     /* 266074 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(266114), // Rule ID 19 //
     /* 266079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 266084 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266099 */     // MIs[1] Operand 1
     /* 266099 */     // No operand predicates
     /* 266099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266101 */     // (intrinsic_void 570:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 266101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 266104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266112 */     GIR_RootConstrainSelectedInstOperands,
     /* 266113 */     // GIR_Coverage, 19,
     /* 266113 */     GIR_EraseRootFromParent_Done,
     /* 266114 */   // Label 5159: @266114
     /* 266114 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(266138), // Rule ID 72 //
     /* 266119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 266124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266131 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 266131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 266134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266136 */     GIR_RootConstrainSelectedInstOperands,
     /* 266137 */     // GIR_Coverage, 72,
     /* 266137 */     GIR_EraseRootFromParent_Done,
     /* 266138 */   // Label 5160: @266138
     /* 266138 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(266162), // Rule ID 74 //
     /* 266143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 266148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266155 */     // (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 266155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 266158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266160 */     GIR_RootConstrainSelectedInstOperands,
     /* 266161 */     // GIR_Coverage, 74,
     /* 266161 */     GIR_EraseRootFromParent_Done,
     /* 266162 */   // Label 5161: @266162
     /* 266162 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(266193), // Rule ID 77 //
     /* 266167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 266175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266182 */     // (intrinsic_w_chain:{ *:[i64] } 2177:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 266182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 266185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266191 */     GIR_RootConstrainSelectedInstOperands,
     /* 266192 */     // GIR_Coverage, 77,
     /* 266192 */     GIR_EraseRootFromParent_Done,
     /* 266193 */   // Label 5162: @266193
     /* 266193 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(266220), // Rule ID 80 //
     /* 266198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 266206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266213 */     // (intrinsic_w_chain:{ *:[i64] } 2178:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 266213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 266216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266218 */     GIR_RootConstrainSelectedInstOperands,
     /* 266219 */     // GIR_Coverage, 80,
     /* 266219 */     GIR_EraseRootFromParent_Done,
     /* 266220 */   // Label 5163: @266220
     /* 266220 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(266251), // Rule ID 2385 //
     /* 266225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 266233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 266236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266240 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1676:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 266240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 266243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 266245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266249 */     GIR_RootConstrainSelectedInstOperands,
     /* 266250 */     // GIR_Coverage, 2385,
     /* 266250 */     GIR_EraseRootFromParent_Done,
     /* 266251 */   // Label 5164: @266251
     /* 266251 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(266291), // Rule ID 12867 //
     /* 266256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 266264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266271 */     // (intrinsic_w_chain:{ *:[i64] } 901:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 266271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 266274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266276 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 266289 */     GIR_RootConstrainSelectedInstOperands,
     /* 266290 */     // GIR_Coverage, 12867,
     /* 266290 */     GIR_EraseRootFromParent_Done,
     /* 266291 */   // Label 5165: @266291
     /* 266291 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(266325), // Rule ID 2387 //
     /* 266296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 266304 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 266307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266311 */     // (intrinsic_void 2156:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 266311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 266314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 266316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 266319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266323 */     GIR_RootConstrainSelectedInstOperands,
     /* 266324 */     // GIR_Coverage, 2387,
     /* 266324 */     GIR_EraseRootFromParent_Done,
     /* 266325 */   // Label 5166: @266325
     /* 266325 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(266348), // Rule ID 73 //
     /* 266330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 266335 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266338 */     // (intrinsic_void 790:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 266338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 266341 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 266346 */     GIR_RootConstrainSelectedInstOperands,
     /* 266347 */     // GIR_Coverage, 73,
     /* 266347 */     GIR_EraseRootFromParent_Done,
     /* 266348 */   // Label 5167: @266348
     /* 266348 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(266371), // Rule ID 75 //
     /* 266353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 266358 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266361 */     // (intrinsic_void 792:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 266361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 266364 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 266369 */     GIR_RootConstrainSelectedInstOperands,
     /* 266370 */     // GIR_Coverage, 75,
     /* 266370 */     GIR_EraseRootFromParent_Done,
     /* 266371 */   // Label 5168: @266371
     /* 266371 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(266398), // Rule ID 76 //
     /* 266376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 266381 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266384 */     // (intrinsic_void 791:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 266384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 266387 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 266392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266396 */     GIR_RootConstrainSelectedInstOperands,
     /* 266397 */     // GIR_Coverage, 76,
     /* 266397 */     GIR_EraseRootFromParent_Done,
     /* 266398 */   // Label 5169: @266398
     /* 266398 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(266431), // Rule ID 12866 //
     /* 266403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 266411 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266414 */     // (intrinsic_void 976:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 266414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 266417 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266427 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266429 */     GIR_RootConstrainSelectedInstOperands,
     /* 266430 */     // GIR_Coverage, 12866,
     /* 266430 */     GIR_EraseRootFromParent_Done,
     /* 266431 */   // Label 5170: @266431
     /* 266431 */   GIM_Reject,
     /* 266432 */ // Label 5151: @266432
     /* 266432 */ GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(267403),
     /* 266437 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 266440 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(266516), // Rule ID 7147 //
     /* 266445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266457 */     // MIs[0] addr
     /* 266457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 266469 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 266476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266485 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266515 */     // GIR_Coverage, 7147,
     /* 266515 */     GIR_EraseRootFromParent_Done,
     /* 266516 */   // Label 5172: @266516
     /* 266516 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(266592), // Rule ID 7148 //
     /* 266521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266533 */     // MIs[0] addr
     /* 266533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 266545 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 266552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266557 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266561 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266591 */     // GIR_Coverage, 7148,
     /* 266591 */     GIR_EraseRootFromParent_Done,
     /* 266592 */   // Label 5173: @266592
     /* 266592 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(266668), // Rule ID 7149 //
     /* 266597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266609 */     // MIs[0] addr
     /* 266609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 266621 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 266628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266637 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266667 */     // GIR_Coverage, 7149,
     /* 266667 */     GIR_EraseRootFromParent_Done,
     /* 266668 */   // Label 5174: @266668
     /* 266668 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(266710), // Rule ID 7150 //
     /* 266673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266685 */     // MIs[0] addr
     /* 266685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 266697 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 266697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 266700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266702 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 266704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266708 */     GIR_RootConstrainSelectedInstOperands,
     /* 266709 */     // GIR_Coverage, 7150,
     /* 266709 */     GIR_EraseRootFromParent_Done,
     /* 266710 */   // Label 5175: @266710
     /* 266710 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(266786), // Rule ID 7154 //
     /* 266715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266727 */     // MIs[0] addr
     /* 266727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 266739 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 266746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266755 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266785 */     // GIR_Coverage, 7154,
     /* 266785 */     GIR_EraseRootFromParent_Done,
     /* 266786 */   // Label 5176: @266786
     /* 266786 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(266862), // Rule ID 7155 //
     /* 266791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266803 */     // MIs[0] addr
     /* 266803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 266815 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 266822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266827 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266861 */     // GIR_Coverage, 7155,
     /* 266861 */     GIR_EraseRootFromParent_Done,
     /* 266862 */   // Label 5177: @266862
     /* 266862 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(266938), // Rule ID 7156 //
     /* 266867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266879 */     // MIs[0] addr
     /* 266879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 266891 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 266898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266907 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266937 */     // GIR_Coverage, 7156,
     /* 266937 */     GIR_EraseRootFromParent_Done,
     /* 266938 */   // Label 5178: @266938
     /* 266938 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(266980), // Rule ID 7157 //
     /* 266943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266955 */     // MIs[0] addr
     /* 266955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 266967 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 266967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 266970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266972 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 266974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266978 */     GIR_RootConstrainSelectedInstOperands,
     /* 266979 */     // GIR_Coverage, 7157,
     /* 266979 */     GIR_EraseRootFromParent_Done,
     /* 266980 */   // Label 5179: @266980
     /* 266980 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(267020), // Rule ID 20 //
     /* 266985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 266988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 266993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267007 */     // (intrinsic_w_chain:{ *:[i64] } 561:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 267007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 267010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 267012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 267014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267018 */     GIR_RootConstrainSelectedInstOperands,
     /* 267019 */     // GIR_Coverage, 20,
     /* 267019 */     GIR_EraseRootFromParent_Done,
     /* 267020 */   // Label 5180: @267020
     /* 267020 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(267060), // Rule ID 2384 //
     /* 267025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 267028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 267033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 267036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 267039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 267043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 267047 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1677:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 267047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 267050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 267052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 267054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267058 */     GIR_RootConstrainSelectedInstOperands,
     /* 267059 */     // GIR_Coverage, 2384,
     /* 267059 */     GIR_EraseRootFromParent_Done,
     /* 267060 */   // Label 5181: @267060
     /* 267060 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(267100), // Rule ID 2491 //
     /* 267065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 267073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267087 */     // (intrinsic_w_chain:{ *:[v8f16] } 621:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 267087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 267090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267098 */     GIR_RootConstrainSelectedInstOperands,
     /* 267099 */     // GIR_Coverage, 2491,
     /* 267099 */     GIR_EraseRootFromParent_Done,
     /* 267100 */   // Label 5182: @267100
     /* 267100 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(267140), // Rule ID 2492 //
     /* 267105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 267113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267127 */     // (intrinsic_w_chain:{ *:[v8f16] } 621:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 267130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267138 */     GIR_RootConstrainSelectedInstOperands,
     /* 267139 */     // GIR_Coverage, 2492,
     /* 267139 */     GIR_EraseRootFromParent_Done,
     /* 267140 */   // Label 5183: @267140
     /* 267140 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(267180), // Rule ID 7034 //
     /* 267145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267167 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 267167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 267170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267178 */     GIR_RootConstrainSelectedInstOperands,
     /* 267179 */     // GIR_Coverage, 7034,
     /* 267179 */     GIR_EraseRootFromParent_Done,
     /* 267180 */   // Label 5184: @267180
     /* 267180 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(267220), // Rule ID 7035 //
     /* 267185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267207 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 267210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267218 */     GIR_RootConstrainSelectedInstOperands,
     /* 267219 */     // GIR_Coverage, 7035,
     /* 267219 */     GIR_EraseRootFromParent_Done,
     /* 267220 */   // Label 5185: @267220
     /* 267220 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(267256), // Rule ID 3575 //
     /* 267225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 267233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267243 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1501:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 267246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267254 */     GIR_RootConstrainSelectedInstOperands,
     /* 267255 */     // GIR_Coverage, 3575,
     /* 267255 */     GIR_EraseRootFromParent_Done,
     /* 267256 */   // Label 5186: @267256
     /* 267256 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(267294), // Rule ID 4005 //
     /* 267261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 267264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 267269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267279 */     // (intrinsic_w_chain:{ *:[i64] } 569:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 267279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 267282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 267290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 267292 */     GIR_RootConstrainSelectedInstOperands,
     /* 267293 */     // GIR_Coverage, 4005,
     /* 267293 */     GIR_EraseRootFromParent_Done,
     /* 267294 */   // Label 5187: @267294
     /* 267294 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(267330), // Rule ID 12592 //
     /* 267299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 267307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267317 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 267320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267328 */     GIR_RootConstrainSelectedInstOperands,
     /* 267329 */     // GIR_Coverage, 12592,
     /* 267329 */     GIR_EraseRootFromParent_Done,
     /* 267330 */   // Label 5188: @267330
     /* 267330 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(267366), // Rule ID 12593 //
     /* 267335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 267343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267353 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1507:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 267356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267364 */     GIR_RootConstrainSelectedInstOperands,
     /* 267365 */     // GIR_Coverage, 12593,
     /* 267365 */     GIR_EraseRootFromParent_Done,
     /* 267366 */   // Label 5189: @267366
     /* 267366 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(267402), // Rule ID 12594 //
     /* 267371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 267379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267389 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1508:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 267392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267400 */     GIR_RootConstrainSelectedInstOperands,
     /* 267401 */     // GIR_Coverage, 12594,
     /* 267401 */     GIR_EraseRootFromParent_Done,
     /* 267402 */   // Label 5190: @267402
     /* 267402 */   GIM_Reject,
     /* 267403 */ // Label 5171: @267403
     /* 267403 */ GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(271571),
     /* 267408 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 267411 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(267508), // Rule ID 7165 //
     /* 267416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267464 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 267475 */     // MIs[0] addr
     /* 267475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 267487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267489 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 267492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267498 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267506 */     GIR_RootConstrainSelectedInstOperands,
     /* 267507 */     // GIR_Coverage, 7165,
     /* 267507 */     GIR_EraseRootFromParent_Done,
     /* 267508 */   // Label 5192: @267508
     /* 267508 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(267605), // Rule ID 7166 //
     /* 267513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267561 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 267572 */     // MIs[0] addr
     /* 267572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 267584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267586 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 267589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267595 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267603 */     GIR_RootConstrainSelectedInstOperands,
     /* 267604 */     // GIR_Coverage, 7166,
     /* 267604 */     GIR_EraseRootFromParent_Done,
     /* 267605 */   // Label 5193: @267605
     /* 267605 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(267702), // Rule ID 7175 //
     /* 267610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267658 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 267669 */     // MIs[0] addr
     /* 267669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 267681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267683 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 267686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267692 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267700 */     GIR_RootConstrainSelectedInstOperands,
     /* 267701 */     // GIR_Coverage, 7175,
     /* 267701 */     GIR_EraseRootFromParent_Done,
     /* 267702 */   // Label 5194: @267702
     /* 267702 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(267799), // Rule ID 7176 //
     /* 267707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267755 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 267766 */     // MIs[0] addr
     /* 267766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 267778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267780 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 267783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267789 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267797 */     GIR_RootConstrainSelectedInstOperands,
     /* 267798 */     // GIR_Coverage, 7176,
     /* 267798 */     GIR_EraseRootFromParent_Done,
     /* 267799 */   // Label 5195: @267799
     /* 267799 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(267910), // Rule ID 7168 //
     /* 267804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 267831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267840 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 267851 */     // MIs[0] addr
     /* 267851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 267863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267865 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 267865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 267896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267901 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267908 */     GIR_RootConstrainSelectedInstOperands,
     /* 267909 */     // GIR_Coverage, 7168,
     /* 267909 */     GIR_EraseRootFromParent_Done,
     /* 267910 */   // Label 5196: @267910
     /* 267910 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(268021), // Rule ID 7169 //
     /* 267915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 267942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267951 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 267962 */     // MIs[0] addr
     /* 267962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 267974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267976 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 267976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 268007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268012 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268019 */     GIR_RootConstrainSelectedInstOperands,
     /* 268020 */     // GIR_Coverage, 7169,
     /* 268020 */     GIR_EraseRootFromParent_Done,
     /* 268021 */   // Label 5197: @268021
     /* 268021 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(268132), // Rule ID 7170 //
     /* 268026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268062 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 268073 */     // MIs[0] addr
     /* 268073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 268085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268087 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268123 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268130 */     GIR_RootConstrainSelectedInstOperands,
     /* 268131 */     // GIR_Coverage, 7170,
     /* 268131 */     GIR_EraseRootFromParent_Done,
     /* 268132 */   // Label 5198: @268132
     /* 268132 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(268243), // Rule ID 7178 //
     /* 268137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268173 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 268184 */     // MIs[0] addr
     /* 268184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 268196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268198 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268210 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 268229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268234 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268241 */     GIR_RootConstrainSelectedInstOperands,
     /* 268242 */     // GIR_Coverage, 7178,
     /* 268242 */     GIR_EraseRootFromParent_Done,
     /* 268243 */   // Label 5199: @268243
     /* 268243 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(268354), // Rule ID 7179 //
     /* 268248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268284 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 268295 */     // MIs[0] addr
     /* 268295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 268307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268309 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 268340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268345 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268352 */     GIR_RootConstrainSelectedInstOperands,
     /* 268353 */     // GIR_Coverage, 7179,
     /* 268353 */     GIR_EraseRootFromParent_Done,
     /* 268354 */   // Label 5200: @268354
     /* 268354 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(268465), // Rule ID 7180 //
     /* 268359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268395 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 268406 */     // MIs[0] addr
     /* 268406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 268418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268420 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 268451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268456 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268463 */     GIR_RootConstrainSelectedInstOperands,
     /* 268464 */     // GIR_Coverage, 7180,
     /* 268464 */     GIR_EraseRootFromParent_Done,
     /* 268465 */   // Label 5201: @268465
     /* 268465 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(268516), // Rule ID 70 //
     /* 268470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 268475 */     // MIs[0] ptr
     /* 268475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268483 */     // MIs[0] accessinfo
     /* 268483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268486 */     // MIs[0] fixed_shadow
     /* 268486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268489 */     // (intrinsic_void 194:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 268492 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268494 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268496 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268514 */     GIR_RootConstrainSelectedInstOperands,
     /* 268515 */     // GIR_Coverage, 70,
     /* 268515 */     GIR_EraseRootFromParent_Done,
     /* 268516 */   // Label 5202: @268516
     /* 268516 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(268567), // Rule ID 71 //
     /* 268521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 268526 */     // MIs[0] ptr
     /* 268526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268534 */     // MIs[0] accessinfo
     /* 268534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268537 */     // MIs[0] fixed_shadow
     /* 268537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268540 */     // (intrinsic_void 196:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 268543 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268545 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268547 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268565 */     GIR_RootConstrainSelectedInstOperands,
     /* 268566 */     // GIR_Coverage, 71,
     /* 268566 */     GIR_EraseRootFromParent_Done,
     /* 268567 */   // Label 5203: @268567
     /* 268567 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(268636), // Rule ID 7167 //
     /* 268572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268604 */     // MIs[0] addr
     /* 268604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 268616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268618 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 268627 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268634 */     GIR_RootConstrainSelectedInstOperands,
     /* 268635 */     // GIR_Coverage, 7167,
     /* 268635 */     GIR_EraseRootFromParent_Done,
     /* 268636 */   // Label 5204: @268636
     /* 268636 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(268705), // Rule ID 7177 //
     /* 268641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268673 */     // MIs[0] addr
     /* 268673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 268685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268687 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 268690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 268696 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268703 */     GIR_RootConstrainSelectedInstOperands,
     /* 268704 */     // GIR_Coverage, 7177,
     /* 268704 */     GIR_EraseRootFromParent_Done,
     /* 268705 */   // Label 5205: @268705
     /* 268705 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(268747), // Rule ID 3599 //
     /* 268710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 268718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268724 */     // MIs[0] tile
     /* 268724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268732 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 268735 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268745 */     GIR_RootConstrainSelectedInstOperands,
     /* 268746 */     // GIR_Coverage, 3599,
     /* 268746 */     GIR_EraseRootFromParent_Done,
     /* 268747 */   // Label 5206: @268747
     /* 268747 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(268789), // Rule ID 3603 //
     /* 268752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 268760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268766 */     // MIs[0] tile
     /* 268766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268774 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 268777 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268787 */     GIR_RootConstrainSelectedInstOperands,
     /* 268788 */     // GIR_Coverage, 3603,
     /* 268788 */     GIR_EraseRootFromParent_Done,
     /* 268789 */   // Label 5207: @268789
     /* 268789 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(268831), // Rule ID 3607 //
     /* 268794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 268802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268808 */     // MIs[0] tile
     /* 268808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268816 */     // (intrinsic_void 1029:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 268819 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268829 */     GIR_RootConstrainSelectedInstOperands,
     /* 268830 */     // GIR_Coverage, 3607,
     /* 268830 */     GIR_EraseRootFromParent_Done,
     /* 268831 */   // Label 5208: @268831
     /* 268831 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268873), // Rule ID 3777 //
     /* 268836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 268839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268850 */     // MIs[0] tile
     /* 268850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 268858 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 268861 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268871 */     GIR_RootConstrainSelectedInstOperands,
     /* 268872 */     // GIR_Coverage, 3777,
     /* 268872 */     GIR_EraseRootFromParent_Done,
     /* 268873 */   // Label 5209: @268873
     /* 268873 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268915), // Rule ID 3781 //
     /* 268878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 268881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 268886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268892 */     // MIs[0] tile
     /* 268892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268900 */     // (intrinsic_void 885:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 268903 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268913 */     GIR_RootConstrainSelectedInstOperands,
     /* 268914 */     // GIR_Coverage, 3781,
     /* 268914 */     GIR_EraseRootFromParent_Done,
     /* 268915 */   // Label 5210: @268915
     /* 268915 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(268957), // Rule ID 3785 //
     /* 268920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 268931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 268934 */     // MIs[0] tile
     /* 268934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268942 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 268942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 268945 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268955 */     GIR_RootConstrainSelectedInstOperands,
     /* 268956 */     // GIR_Coverage, 3785,
     /* 268956 */     GIR_EraseRootFromParent_Done,
     /* 268957 */   // Label 5211: @268957
     /* 268957 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(268999), // Rule ID 3789 //
     /* 268962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 268965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 268973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 268976 */     // MIs[0] tile
     /* 268976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268984 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 268984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 268987 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268997 */     GIR_RootConstrainSelectedInstOperands,
     /* 268998 */     // GIR_Coverage, 3789,
     /* 268998 */     GIR_EraseRootFromParent_Done,
     /* 268999 */   // Label 5212: @268999
     /* 268999 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(269041), // Rule ID 3793 //
     /* 269004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 269012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269018 */     // MIs[0] tile
     /* 269018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269026 */     // (intrinsic_void 926:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 269029 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269039 */     GIR_RootConstrainSelectedInstOperands,
     /* 269040 */     // GIR_Coverage, 3793,
     /* 269040 */     GIR_EraseRootFromParent_Done,
     /* 269041 */   // Label 5213: @269041
     /* 269041 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(269083), // Rule ID 3797 //
     /* 269046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 269049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 269054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269060 */     // MIs[0] tile
     /* 269060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 269068 */     // (intrinsic_void 881:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 269071 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269081 */     GIR_RootConstrainSelectedInstOperands,
     /* 269082 */     // GIR_Coverage, 3797,
     /* 269082 */     GIR_EraseRootFromParent_Done,
     /* 269083 */   // Label 5214: @269083
     /* 269083 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(269125), // Rule ID 12671 //
     /* 269088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 269096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269102 */     // MIs[0] tile
     /* 269102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269110 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 269113 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269123 */     GIR_RootConstrainSelectedInstOperands,
     /* 269124 */     // GIR_Coverage, 12671,
     /* 269124 */     GIR_EraseRootFromParent_Done,
     /* 269125 */   // Label 5215: @269125
     /* 269125 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(269167), // Rule ID 12675 //
     /* 269130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 269138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269144 */     // MIs[0] tile
     /* 269144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269152 */     // (intrinsic_void 1077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 269155 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269165 */     GIR_RootConstrainSelectedInstOperands,
     /* 269166 */     // GIR_Coverage, 12675,
     /* 269166 */     GIR_EraseRootFromParent_Done,
     /* 269167 */   // Label 5216: @269167
     /* 269167 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(269209), // Rule ID 12679 //
     /* 269172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 269180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269186 */     // MIs[0] tile
     /* 269186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269194 */     // (intrinsic_void 1085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 269197 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269207 */     GIR_RootConstrainSelectedInstOperands,
     /* 269208 */     // GIR_Coverage, 12679,
     /* 269208 */     GIR_EraseRootFromParent_Done,
     /* 269209 */   // Label 5217: @269209
     /* 269209 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(269251), // Rule ID 12683 //
     /* 269214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 269222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269228 */     // MIs[0] tile
     /* 269228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269236 */     // (intrinsic_void 1194:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 269239 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269249 */     GIR_RootConstrainSelectedInstOperands,
     /* 269250 */     // GIR_Coverage, 12683,
     /* 269250 */     GIR_EraseRootFromParent_Done,
     /* 269251 */   // Label 5218: @269251
     /* 269251 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(269293), // Rule ID 12687 //
     /* 269256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 269264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269270 */     // MIs[0] tile
     /* 269270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269278 */     // (intrinsic_void 1202:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 269281 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269291 */     GIR_RootConstrainSelectedInstOperands,
     /* 269292 */     // GIR_Coverage, 12687,
     /* 269292 */     GIR_EraseRootFromParent_Done,
     /* 269293 */   // Label 5219: @269293
     /* 269293 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(269335), // Rule ID 12691 //
     /* 269298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269312 */     // MIs[0] tile
     /* 269312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269320 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 269323 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269333 */     GIR_RootConstrainSelectedInstOperands,
     /* 269334 */     // GIR_Coverage, 12691,
     /* 269334 */     GIR_EraseRootFromParent_Done,
     /* 269335 */   // Label 5220: @269335
     /* 269335 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(269377), // Rule ID 12695 //
     /* 269340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269354 */     // MIs[0] tile
     /* 269354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269362 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 269365 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269375 */     GIR_RootConstrainSelectedInstOperands,
     /* 269376 */     // GIR_Coverage, 12695,
     /* 269376 */     GIR_EraseRootFromParent_Done,
     /* 269377 */   // Label 5221: @269377
     /* 269377 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(269419), // Rule ID 12699 //
     /* 269382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 269390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269396 */     // MIs[0] tile
     /* 269396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269404 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 269407 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269417 */     GIR_RootConstrainSelectedInstOperands,
     /* 269418 */     // GIR_Coverage, 12699,
     /* 269418 */     GIR_EraseRootFromParent_Done,
     /* 269419 */   // Label 5222: @269419
     /* 269419 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(269461), // Rule ID 12703 //
     /* 269424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269438 */     // MIs[0] tile
     /* 269438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269446 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 269449 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269459 */     GIR_RootConstrainSelectedInstOperands,
     /* 269460 */     // GIR_Coverage, 12703,
     /* 269460 */     GIR_EraseRootFromParent_Done,
     /* 269461 */   // Label 5223: @269461
     /* 269461 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(269503), // Rule ID 12707 //
     /* 269466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269480 */     // MIs[0] tile
     /* 269480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269488 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 269491 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269501 */     GIR_RootConstrainSelectedInstOperands,
     /* 269502 */     // GIR_Coverage, 12707,
     /* 269502 */     GIR_EraseRootFromParent_Done,
     /* 269503 */   // Label 5224: @269503
     /* 269503 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(269545), // Rule ID 12711 //
     /* 269508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 269516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269522 */     // MIs[0] tile
     /* 269522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269530 */     // (intrinsic_void 1037:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 269533 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269543 */     GIR_RootConstrainSelectedInstOperands,
     /* 269544 */     // GIR_Coverage, 12711,
     /* 269544 */     GIR_EraseRootFromParent_Done,
     /* 269545 */   // Label 5225: @269545
     /* 269545 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(269587), // Rule ID 12715 //
     /* 269550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 269558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269564 */     // MIs[0] tile
     /* 269564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269572 */     // (intrinsic_void 1081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 269575 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269585 */     GIR_RootConstrainSelectedInstOperands,
     /* 269586 */     // GIR_Coverage, 12715,
     /* 269586 */     GIR_EraseRootFromParent_Done,
     /* 269587 */   // Label 5226: @269587
     /* 269587 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(269629), // Rule ID 12719 //
     /* 269592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 269600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269606 */     // MIs[0] tile
     /* 269606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269614 */     // (intrinsic_void 1089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 269617 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269627 */     GIR_RootConstrainSelectedInstOperands,
     /* 269628 */     // GIR_Coverage, 12719,
     /* 269628 */     GIR_EraseRootFromParent_Done,
     /* 269629 */   // Label 5227: @269629
     /* 269629 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(269671), // Rule ID 12723 //
     /* 269634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 269642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269648 */     // MIs[0] tile
     /* 269648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269656 */     // (intrinsic_void 1164:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 269659 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269669 */     GIR_RootConstrainSelectedInstOperands,
     /* 269670 */     // GIR_Coverage, 12723,
     /* 269670 */     GIR_EraseRootFromParent_Done,
     /* 269671 */   // Label 5228: @269671
     /* 269671 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269713), // Rule ID 12727 //
     /* 269676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 269684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269690 */     // MIs[0] tile
     /* 269690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269698 */     // (intrinsic_void 1172:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 269701 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269711 */     GIR_RootConstrainSelectedInstOperands,
     /* 269712 */     // GIR_Coverage, 12727,
     /* 269712 */     GIR_EraseRootFromParent_Done,
     /* 269713 */   // Label 5229: @269713
     /* 269713 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269755), // Rule ID 12731 //
     /* 269718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 269726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269732 */     // MIs[0] tile
     /* 269732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269740 */     // (intrinsic_void 1198:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 269743 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269753 */     GIR_RootConstrainSelectedInstOperands,
     /* 269754 */     // GIR_Coverage, 12731,
     /* 269754 */     GIR_EraseRootFromParent_Done,
     /* 269755 */   // Label 5230: @269755
     /* 269755 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(269797), // Rule ID 12735 //
     /* 269760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 269768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269774 */     // MIs[0] tile
     /* 269774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269782 */     // (intrinsic_void 1206:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 269785 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269795 */     GIR_RootConstrainSelectedInstOperands,
     /* 269796 */     // GIR_Coverage, 12735,
     /* 269796 */     GIR_EraseRootFromParent_Done,
     /* 269797 */   // Label 5231: @269797
     /* 269797 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(269839), // Rule ID 13190 //
     /* 269802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 269810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269816 */     // MIs[0] tile
     /* 269816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269824 */     // (intrinsic_void 934:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 269827 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269837 */     GIR_RootConstrainSelectedInstOperands,
     /* 269838 */     // GIR_Coverage, 13190,
     /* 269838 */     GIR_EraseRootFromParent_Done,
     /* 269839 */   // Label 5232: @269839
     /* 269839 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(269881), // Rule ID 13194 //
     /* 269844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269858 */     // MIs[0] tile
     /* 269858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269866 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 269866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 269869 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269879 */     GIR_RootConstrainSelectedInstOperands,
     /* 269880 */     // GIR_Coverage, 13194,
     /* 269880 */     GIR_EraseRootFromParent_Done,
     /* 269881 */   // Label 5233: @269881
     /* 269881 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(269923), // Rule ID 13198 //
     /* 269886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 269889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269900 */     // MIs[0] tile
     /* 269900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 269908 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 269911 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269921 */     GIR_RootConstrainSelectedInstOperands,
     /* 269922 */     // GIR_Coverage, 13198,
     /* 269922 */     GIR_EraseRootFromParent_Done,
     /* 269923 */   // Label 5234: @269923
     /* 269923 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(269965), // Rule ID 13202 //
     /* 269928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 269931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269942 */     // MIs[0] tile
     /* 269942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269950 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 269950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 269953 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269963 */     GIR_RootConstrainSelectedInstOperands,
     /* 269964 */     // GIR_Coverage, 13202,
     /* 269964 */     GIR_EraseRootFromParent_Done,
     /* 269965 */   // Label 5235: @269965
     /* 269965 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(270019), // Rule ID 8914 //
     /* 269970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 269978 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269985 */     // MIs[0] base
     /* 269985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269993 */     // MIs[0] prfop
     /* 269993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 269996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270001 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 270004 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270006 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270008 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270017 */     GIR_RootConstrainSelectedInstOperands,
     /* 270018 */     // GIR_Coverage, 8914,
     /* 270018 */     GIR_EraseRootFromParent_Done,
     /* 270019 */   // Label 5236: @270019
     /* 270019 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(270073), // Rule ID 8917 //
     /* 270024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270032 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 270035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270039 */     // MIs[0] base
     /* 270039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270047 */     // MIs[0] prfop
     /* 270047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270055 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 270058 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270060 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270062 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270071 */     GIR_RootConstrainSelectedInstOperands,
     /* 270072 */     // GIR_Coverage, 8917,
     /* 270072 */     GIR_EraseRootFromParent_Done,
     /* 270073 */   // Label 5237: @270073
     /* 270073 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(270127), // Rule ID 8920 //
     /* 270078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270086 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270093 */     // MIs[0] base
     /* 270093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270101 */     // MIs[0] prfop
     /* 270101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270109 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 270112 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270114 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270116 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270125 */     GIR_RootConstrainSelectedInstOperands,
     /* 270126 */     // GIR_Coverage, 8920,
     /* 270126 */     GIR_EraseRootFromParent_Done,
     /* 270127 */   // Label 5238: @270127
     /* 270127 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(270181), // Rule ID 8923 //
     /* 270132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270140 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270147 */     // MIs[0] base
     /* 270147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270155 */     // MIs[0] prfop
     /* 270155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270163 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 270166 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270168 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270170 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270179 */     GIR_RootConstrainSelectedInstOperands,
     /* 270180 */     // GIR_Coverage, 8923,
     /* 270180 */     GIR_EraseRootFromParent_Done,
     /* 270181 */   // Label 5239: @270181
     /* 270181 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(270235), // Rule ID 15 //
     /* 270186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 270191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 270194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 270197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270212 */     // MIs[1] Operand 1
     /* 270212 */     // No operand predicates
     /* 270212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270218 */     // (intrinsic_w_chain:{ *:[i64] } 1242:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 270218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 270221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 270226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270233 */     GIR_RootConstrainSelectedInstOperands,
     /* 270234 */     // GIR_Coverage, 15,
     /* 270234 */     GIR_EraseRootFromParent_Done,
     /* 270235 */   // Label 5240: @270235
     /* 270235 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(270303), // Rule ID 68 //
     /* 270240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 270245 */     // MIs[0] Operand 1
     /* 270245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 270253 */     // MIs[0] ptr
     /* 270253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270261 */     // MIs[0] accessinfo
     /* 270261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270264 */     // (intrinsic_void 193:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270268 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 270278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 270281 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270283 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270301 */     GIR_RootConstrainSelectedInstOperands,
     /* 270302 */     // GIR_Coverage, 68,
     /* 270302 */     GIR_EraseRootFromParent_Done,
     /* 270303 */   // Label 5241: @270303
     /* 270303 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(270371), // Rule ID 69 //
     /* 270308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 270313 */     // MIs[0] Operand 1
     /* 270313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 270321 */     // MIs[0] ptr
     /* 270321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270329 */     // MIs[0] accessinfo
     /* 270329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270332 */     // (intrinsic_void 195:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270336 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 270346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 270349 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270351 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270369 */     GIR_RootConstrainSelectedInstOperands,
     /* 270370 */     // GIR_Coverage, 69,
     /* 270370 */     GIR_EraseRootFromParent_Done,
     /* 270371 */   // Label 5242: @270371
     /* 270371 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(270451), // Rule ID 7161 //
     /* 270376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270395 */     // MIs[0] addr
     /* 270395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 270407 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270419 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 270438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270443 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270449 */     GIR_RootConstrainSelectedInstOperands,
     /* 270450 */     // GIR_Coverage, 7161,
     /* 270450 */     GIR_EraseRootFromParent_Done,
     /* 270451 */   // Label 5243: @270451
     /* 270451 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(270531), // Rule ID 7162 //
     /* 270456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270475 */     // MIs[0] addr
     /* 270475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 270487 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270499 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 270518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270523 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270529 */     GIR_RootConstrainSelectedInstOperands,
     /* 270530 */     // GIR_Coverage, 7162,
     /* 270530 */     GIR_EraseRootFromParent_Done,
     /* 270531 */   // Label 5244: @270531
     /* 270531 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(270611), // Rule ID 7163 //
     /* 270536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270555 */     // MIs[0] addr
     /* 270555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270567 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270603 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270609 */     GIR_RootConstrainSelectedInstOperands,
     /* 270610 */     // GIR_Coverage, 7163,
     /* 270610 */     GIR_EraseRootFromParent_Done,
     /* 270611 */   // Label 5245: @270611
     /* 270611 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(270662), // Rule ID 7164 //
     /* 270616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270635 */     // MIs[0] addr
     /* 270635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 270647 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 270650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270652 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 270654 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270660 */     GIR_RootConstrainSelectedInstOperands,
     /* 270661 */     // GIR_Coverage, 7164,
     /* 270661 */     GIR_EraseRootFromParent_Done,
     /* 270662 */   // Label 5246: @270662
     /* 270662 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(270742), // Rule ID 7171 //
     /* 270667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270686 */     // MIs[0] addr
     /* 270686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 270698 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 270729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270734 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270740 */     GIR_RootConstrainSelectedInstOperands,
     /* 270741 */     // GIR_Coverage, 7171,
     /* 270741 */     GIR_EraseRootFromParent_Done,
     /* 270742 */   // Label 5247: @270742
     /* 270742 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(270822), // Rule ID 7172 //
     /* 270747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270766 */     // MIs[0] addr
     /* 270766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 270778 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 270809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270814 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270820 */     GIR_RootConstrainSelectedInstOperands,
     /* 270821 */     // GIR_Coverage, 7172,
     /* 270821 */     GIR_EraseRootFromParent_Done,
     /* 270822 */   // Label 5248: @270822
     /* 270822 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(270902), // Rule ID 7173 //
     /* 270827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270846 */     // MIs[0] addr
     /* 270846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 270858 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 270889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270894 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270900 */     GIR_RootConstrainSelectedInstOperands,
     /* 270901 */     // GIR_Coverage, 7173,
     /* 270901 */     GIR_EraseRootFromParent_Done,
     /* 270902 */   // Label 5249: @270902
     /* 270902 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(270953), // Rule ID 7174 //
     /* 270907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270926 */     // MIs[0] addr
     /* 270926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 270938 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 270941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270943 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 270945 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270951 */     GIR_RootConstrainSelectedInstOperands,
     /* 270952 */     // GIR_Coverage, 7174,
     /* 270952 */     GIR_EraseRootFromParent_Done,
     /* 270953 */   // Label 5250: @270953
     /* 270953 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(271002), // Rule ID 2484 //
     /* 270958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 270961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 270966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 270969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 270975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270987 */     // (intrinsic_w_chain:{ *:[v8i8] } 623:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 270987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 270990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271000 */     GIR_RootConstrainSelectedInstOperands,
     /* 271001 */     // GIR_Coverage, 2484,
     /* 271001 */     GIR_EraseRootFromParent_Done,
     /* 271002 */   // Label 5251: @271002
     /* 271002 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(271051), // Rule ID 2485 //
     /* 271007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 271010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 271015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 271018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 271024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271036 */     // (intrinsic_w_chain:{ *:[v16i8] } 623:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 271036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 271039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271049 */     GIR_RootConstrainSelectedInstOperands,
     /* 271050 */     // GIR_Coverage, 2485,
     /* 271050 */     GIR_EraseRootFromParent_Done,
     /* 271051 */   // Label 5252: @271051
     /* 271051 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(271100), // Rule ID 2486 //
     /* 271056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 271059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 271064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 271067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271085 */     // (intrinsic_w_chain:{ *:[v8i8] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 271085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 271088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271098 */     GIR_RootConstrainSelectedInstOperands,
     /* 271099 */     // GIR_Coverage, 2486,
     /* 271099 */     GIR_EraseRootFromParent_Done,
     /* 271100 */   // Label 5253: @271100
     /* 271100 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(271153), // Rule ID 8800 //
     /* 271105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271127 */     // MIs[0] base
     /* 271127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271135 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1577:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271142 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271151 */     GIR_RootConstrainSelectedInstOperands,
     /* 271152 */     // GIR_Coverage, 8800,
     /* 271152 */     GIR_EraseRootFromParent_Done,
     /* 271153 */   // Label 5254: @271153
     /* 271153 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(271206), // Rule ID 8803 //
     /* 271158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271180 */     // MIs[0] base
     /* 271180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271188 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1577:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271195 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271204 */     GIR_RootConstrainSelectedInstOperands,
     /* 271205 */     // GIR_Coverage, 8803,
     /* 271205 */     GIR_EraseRootFromParent_Done,
     /* 271206 */   // Label 5255: @271206
     /* 271206 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(271259), // Rule ID 8812 //
     /* 271211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271233 */     // MIs[0] base
     /* 271233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271241 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271248 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271257 */     GIR_RootConstrainSelectedInstOperands,
     /* 271258 */     // GIR_Coverage, 8812,
     /* 271258 */     GIR_EraseRootFromParent_Done,
     /* 271259 */   // Label 5256: @271259
     /* 271259 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(271312), // Rule ID 8815 //
     /* 271264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271286 */     // MIs[0] base
     /* 271286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271294 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1576:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271301 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271310 */     GIR_RootConstrainSelectedInstOperands,
     /* 271311 */     // GIR_Coverage, 8815,
     /* 271311 */     GIR_EraseRootFromParent_Done,
     /* 271312 */   // Label 5257: @271312
     /* 271312 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(271358), // Rule ID 137 //
     /* 271317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 271320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 271325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 271328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271335 */     // MIs[0] Rn
     /* 271335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271347 */     // (intrinsic_w_chain:{ *:[i64] } 568:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 271350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271356 */     GIR_RootConstrainSelectedInstOperands,
     /* 271357 */     // GIR_Coverage, 137,
     /* 271357 */     GIR_EraseRootFromParent_Done,
     /* 271358 */   // Label 5258: @271358
     /* 271358 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(271411), // Rule ID 8806 //
     /* 271363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271371 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271385 */     // MIs[0] base
     /* 271385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271393 */     // (intrinsic_void 1897:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271400 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271409 */     GIR_RootConstrainSelectedInstOperands,
     /* 271410 */     // GIR_Coverage, 8806,
     /* 271410 */     GIR_EraseRootFromParent_Done,
     /* 271411 */   // Label 5259: @271411
     /* 271411 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(271464), // Rule ID 8809 //
     /* 271416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271424 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271438 */     // MIs[0] base
     /* 271438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271446 */     // (intrinsic_void 1897:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271453 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271462 */     GIR_RootConstrainSelectedInstOperands,
     /* 271463 */     // GIR_Coverage, 8809,
     /* 271463 */     GIR_EraseRootFromParent_Done,
     /* 271464 */   // Label 5260: @271464
     /* 271464 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(271517), // Rule ID 8818 //
     /* 271469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271477 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271491 */     // MIs[0] base
     /* 271491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271499 */     // (intrinsic_void 1893:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271506 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271515 */     GIR_RootConstrainSelectedInstOperands,
     /* 271516 */     // GIR_Coverage, 8818,
     /* 271516 */     GIR_EraseRootFromParent_Done,
     /* 271517 */   // Label 5261: @271517
     /* 271517 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(271570), // Rule ID 8821 //
     /* 271522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271530 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271544 */     // MIs[0] base
     /* 271544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271552 */     // (intrinsic_void 1893:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271559 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271568 */     GIR_RootConstrainSelectedInstOperands,
     /* 271569 */     // GIR_Coverage, 8821,
     /* 271569 */     GIR_EraseRootFromParent_Done,
     /* 271570 */   // Label 5262: @271570
     /* 271570 */   GIM_Reject,
     /* 271571 */ // Label 5191: @271571
     /* 271571 */ GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(274276),
     /* 271576 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 271579 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(271650), // Rule ID 3412 //
     /* 271584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 271592 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271621 */     // MIs[1] Operand 1
     /* 271621 */     // No operand predicates
     /* 271621 */     // MIs[0] prfop
     /* 271621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271631 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 271634 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 271648 */     GIR_RootConstrainSelectedInstOperands,
     /* 271649 */     // GIR_Coverage, 3412,
     /* 271649 */     GIR_EraseRootFromParent_Done,
     /* 271650 */   // Label 5264: @271650
     /* 271650 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271721), // Rule ID 3425 //
     /* 271655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 271663 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271692 */     // MIs[1] Operand 1
     /* 271692 */     // No operand predicates
     /* 271692 */     // MIs[0] prfop
     /* 271692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271702 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 271705 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 271719 */     GIR_RootConstrainSelectedInstOperands,
     /* 271720 */     // GIR_Coverage, 3425,
     /* 271720 */     GIR_EraseRootFromParent_Done,
     /* 271721 */   // Label 5265: @271721
     /* 271721 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271780), // Rule ID 3611 //
     /* 271726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 271729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 271734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 271737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 271740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 271743 */     // MIs[0] tile
     /* 271743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271763 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 271763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 271766 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271768 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271770 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271772 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271778 */     GIR_RootConstrainSelectedInstOperands,
     /* 271779 */     // GIR_Coverage, 3611,
     /* 271779 */     GIR_EraseRootFromParent_Done,
     /* 271780 */   // Label 5266: @271780
     /* 271780 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271839), // Rule ID 3612 //
     /* 271785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 271788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 271793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 271796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 271799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 271802 */     // MIs[0] tile
     /* 271802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271822 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 271822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 271825 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271827 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271829 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271831 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271837 */     GIR_RootConstrainSelectedInstOperands,
     /* 271838 */     // GIR_Coverage, 3612,
     /* 271838 */     GIR_EraseRootFromParent_Done,
     /* 271839 */   // Label 5267: @271839
     /* 271839 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(271898), // Rule ID 12652 //
     /* 271844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 271847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 271852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 271855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 271858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 271861 */     // MIs[0] tile
     /* 271861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271881 */     // (intrinsic_void 808:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 271881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 271884 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271886 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271888 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271890 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271896 */     GIR_RootConstrainSelectedInstOperands,
     /* 271897 */     // GIR_Coverage, 12652,
     /* 271897 */     GIR_EraseRootFromParent_Done,
     /* 271898 */   // Label 5268: @271898
     /* 271898 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(271957), // Rule ID 12653 //
     /* 271903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 271906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 271911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 271914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 271917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 271920 */     // MIs[0] tile
     /* 271920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271940 */     // (intrinsic_void 808:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 271940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 271943 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271945 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271947 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271949 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271955 */     GIR_RootConstrainSelectedInstOperands,
     /* 271956 */     // GIR_Coverage, 12653,
     /* 271956 */     GIR_EraseRootFromParent_Done,
     /* 271957 */   // Label 5269: @271957
     /* 271957 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(272017), // Rule ID 3410 //
     /* 271962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 271970 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271980 */     // MIs[0] Rn
     /* 271980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271992 */     // MIs[0] prfop
     /* 271992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272000 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 272000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 272003 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272015 */     GIR_RootConstrainSelectedInstOperands,
     /* 272016 */     // GIR_Coverage, 3410,
     /* 272016 */     GIR_EraseRootFromParent_Done,
     /* 272017 */   // Label 5270: @272017
     /* 272017 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(272077), // Rule ID 3411 //
     /* 272022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 272030 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272040 */     // MIs[0] Rn
     /* 272040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272052 */     // MIs[0] prfop
     /* 272052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272060 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 272060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 272063 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272075 */     GIR_RootConstrainSelectedInstOperands,
     /* 272076 */     // GIR_Coverage, 3411,
     /* 272076 */     GIR_EraseRootFromParent_Done,
     /* 272077 */   // Label 5271: @272077
     /* 272077 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(272137), // Rule ID 3422 //
     /* 272082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 272090 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272100 */     // MIs[0] Rn
     /* 272100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272112 */     // MIs[0] prfop
     /* 272112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272120 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 272123 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272135 */     GIR_RootConstrainSelectedInstOperands,
     /* 272136 */     // GIR_Coverage, 3422,
     /* 272136 */     GIR_EraseRootFromParent_Done,
     /* 272137 */   // Label 5272: @272137
     /* 272137 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(272197), // Rule ID 3423 //
     /* 272142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 272150 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272160 */     // MIs[0] Rn
     /* 272160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272172 */     // MIs[0] prfop
     /* 272172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272180 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 272183 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272195 */     GIR_RootConstrainSelectedInstOperands,
     /* 272196 */     // GIR_Coverage, 3423,
     /* 272196 */     GIR_EraseRootFromParent_Done,
     /* 272197 */   // Label 5273: @272197
     /* 272197 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(272257), // Rule ID 3424 //
     /* 272202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 272210 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272220 */     // MIs[0] Rn
     /* 272220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272232 */     // MIs[0] prfop
     /* 272232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272240 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 272240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 272243 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272255 */     GIR_RootConstrainSelectedInstOperands,
     /* 272256 */     // GIR_Coverage, 3424,
     /* 272256 */     GIR_EraseRootFromParent_Done,
     /* 272257 */   // Label 5274: @272257
     /* 272257 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(272317), // Rule ID 8926 //
     /* 272262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 272270 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272280 */     // MIs[0] Rn
     /* 272280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272292 */     // MIs[0] prfop
     /* 272292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272300 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 272303 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272315 */     GIR_RootConstrainSelectedInstOperands,
     /* 272316 */     // GIR_Coverage, 8926,
     /* 272316 */     GIR_EraseRootFromParent_Done,
     /* 272317 */   // Label 5275: @272317
     /* 272317 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(272377), // Rule ID 8927 //
     /* 272322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 272330 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272340 */     // MIs[0] Rn
     /* 272340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272352 */     // MIs[0] prfop
     /* 272352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272360 */     // (intrinsic_void 1655:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 272363 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272375 */     GIR_RootConstrainSelectedInstOperands,
     /* 272376 */     // GIR_Coverage, 8927,
     /* 272376 */     GIR_EraseRootFromParent_Done,
     /* 272377 */   // Label 5276: @272377
     /* 272377 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(272437), // Rule ID 8928 //
     /* 272382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 272390 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272400 */     // MIs[0] Rn
     /* 272400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272412 */     // MIs[0] prfop
     /* 272412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272420 */     // (intrinsic_void 1660:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 272423 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272435 */     GIR_RootConstrainSelectedInstOperands,
     /* 272436 */     // GIR_Coverage, 8928,
     /* 272436 */     GIR_EraseRootFromParent_Done,
     /* 272437 */   // Label 5277: @272437
     /* 272437 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(272497), // Rule ID 8929 //
     /* 272442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 272450 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272460 */     // MIs[0] Rn
     /* 272460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272472 */     // MIs[0] prfop
     /* 272472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272480 */     // (intrinsic_void 1659:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 272483 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272495 */     GIR_RootConstrainSelectedInstOperands,
     /* 272496 */     // GIR_Coverage, 8929,
     /* 272496 */     GIR_EraseRootFromParent_Done,
     /* 272497 */   // Label 5278: @272497
     /* 272497 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(272557), // Rule ID 8930 //
     /* 272502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 272510 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272520 */     // MIs[0] Rn
     /* 272520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272532 */     // MIs[0] prfop
     /* 272532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272540 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 272543 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272555 */     GIR_RootConstrainSelectedInstOperands,
     /* 272556 */     // GIR_Coverage, 8930,
     /* 272556 */     GIR_EraseRootFromParent_Done,
     /* 272557 */   // Label 5279: @272557
     /* 272557 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272617), // Rule ID 8931 //
     /* 272562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 272570 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272580 */     // MIs[0] Rn
     /* 272580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272592 */     // MIs[0] prfop
     /* 272592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272600 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 272603 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272615 */     GIR_RootConstrainSelectedInstOperands,
     /* 272616 */     // GIR_Coverage, 8931,
     /* 272616 */     GIR_EraseRootFromParent_Done,
     /* 272617 */   // Label 5280: @272617
     /* 272617 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272677), // Rule ID 8932 //
     /* 272622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 272630 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272640 */     // MIs[0] Rn
     /* 272640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272652 */     // MIs[0] prfop
     /* 272652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272660 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 272660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 272663 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272675 */     GIR_RootConstrainSelectedInstOperands,
     /* 272676 */     // GIR_Coverage, 8932,
     /* 272676 */     GIR_EraseRootFromParent_Done,
     /* 272677 */   // Label 5281: @272677
     /* 272677 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272737), // Rule ID 8933 //
     /* 272682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 272690 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272700 */     // MIs[0] Rn
     /* 272700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272712 */     // MIs[0] prfop
     /* 272712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272720 */     // (intrinsic_void 1655:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 272720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 272723 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272735 */     GIR_RootConstrainSelectedInstOperands,
     /* 272736 */     // GIR_Coverage, 8933,
     /* 272736 */     GIR_EraseRootFromParent_Done,
     /* 272737 */   // Label 5282: @272737
     /* 272737 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272797), // Rule ID 8934 //
     /* 272742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 272750 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272760 */     // MIs[0] Rn
     /* 272760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272772 */     // MIs[0] prfop
     /* 272772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272780 */     // (intrinsic_void 1660:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 272780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 272783 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272795 */     GIR_RootConstrainSelectedInstOperands,
     /* 272796 */     // GIR_Coverage, 8934,
     /* 272796 */     GIR_EraseRootFromParent_Done,
     /* 272797 */   // Label 5283: @272797
     /* 272797 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(272857), // Rule ID 8935 //
     /* 272802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 272810 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272820 */     // MIs[0] Rn
     /* 272820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272832 */     // MIs[0] prfop
     /* 272832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272840 */     // (intrinsic_void 1659:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 272840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 272843 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272855 */     GIR_RootConstrainSelectedInstOperands,
     /* 272856 */     // GIR_Coverage, 8935,
     /* 272856 */     GIR_EraseRootFromParent_Done,
     /* 272857 */   // Label 5284: @272857
     /* 272857 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(272917), // Rule ID 8936 //
     /* 272862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 272870 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272880 */     // MIs[0] Rn
     /* 272880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272892 */     // MIs[0] prfop
     /* 272892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272900 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 272900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 272903 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272915 */     GIR_RootConstrainSelectedInstOperands,
     /* 272916 */     // GIR_Coverage, 8936,
     /* 272916 */     GIR_EraseRootFromParent_Done,
     /* 272917 */   // Label 5285: @272917
     /* 272917 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(272977), // Rule ID 8937 //
     /* 272922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 272930 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272940 */     // MIs[0] Rn
     /* 272940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272952 */     // MIs[0] prfop
     /* 272952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272960 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 272960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 272963 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272975 */     GIR_RootConstrainSelectedInstOperands,
     /* 272976 */     // GIR_Coverage, 8937,
     /* 272976 */     GIR_EraseRootFromParent_Done,
     /* 272977 */   // Label 5286: @272977
     /* 272977 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(273037), // Rule ID 8938 //
     /* 272982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 272990 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273000 */     // MIs[0] Rn
     /* 273000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273012 */     // MIs[0] prfop
     /* 273012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273020 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 273020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 273023 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273035 */     GIR_RootConstrainSelectedInstOperands,
     /* 273036 */     // GIR_Coverage, 8938,
     /* 273036 */     GIR_EraseRootFromParent_Done,
     /* 273037 */   // Label 5287: @273037
     /* 273037 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(273097), // Rule ID 8939 //
     /* 273042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 273050 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273060 */     // MIs[0] Rn
     /* 273060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273072 */     // MIs[0] prfop
     /* 273072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273080 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 273080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 273083 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273095 */     GIR_RootConstrainSelectedInstOperands,
     /* 273096 */     // GIR_Coverage, 8939,
     /* 273096 */     GIR_EraseRootFromParent_Done,
     /* 273097 */   // Label 5288: @273097
     /* 273097 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(273157), // Rule ID 8940 //
     /* 273102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 273110 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273120 */     // MIs[0] Rn
     /* 273120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273132 */     // MIs[0] prfop
     /* 273132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273140 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 273140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 273143 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273155 */     GIR_RootConstrainSelectedInstOperands,
     /* 273156 */     // GIR_Coverage, 8940,
     /* 273156 */     GIR_EraseRootFromParent_Done,
     /* 273157 */   // Label 5289: @273157
     /* 273157 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(273215), // Rule ID 2374 //
     /* 273162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 273170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273198 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 273201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273213 */     GIR_RootConstrainSelectedInstOperands,
     /* 273214 */     // GIR_Coverage, 2374,
     /* 273214 */     GIR_EraseRootFromParent_Done,
     /* 273215 */   // Label 5290: @273215
     /* 273215 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(273273), // Rule ID 2375 //
     /* 273220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 273228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273256 */     // (intrinsic_w_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 273259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273271 */     GIR_RootConstrainSelectedInstOperands,
     /* 273272 */     // GIR_Coverage, 2375,
     /* 273272 */     GIR_EraseRootFromParent_Done,
     /* 273273 */   // Label 5291: @273273
     /* 273273 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(273331), // Rule ID 2376 //
     /* 273278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 273286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273314 */     // (intrinsic_w_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 273317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273329 */     GIR_RootConstrainSelectedInstOperands,
     /* 273330 */     // GIR_Coverage, 2376,
     /* 273330 */     GIR_EraseRootFromParent_Done,
     /* 273331 */   // Label 5292: @273331
     /* 273331 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(273389), // Rule ID 2377 //
     /* 273336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 273344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273372 */     // (intrinsic_w_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 273375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273387 */     GIR_RootConstrainSelectedInstOperands,
     /* 273388 */     // GIR_Coverage, 2377,
     /* 273388 */     GIR_EraseRootFromParent_Done,
     /* 273389 */   // Label 5293: @273389
     /* 273389 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(273447), // Rule ID 2378 //
     /* 273394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 273402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273430 */     // (intrinsic_w_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 273433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273445 */     GIR_RootConstrainSelectedInstOperands,
     /* 273446 */     // GIR_Coverage, 2378,
     /* 273446 */     GIR_EraseRootFromParent_Done,
     /* 273447 */   // Label 5294: @273447
     /* 273447 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(273505), // Rule ID 2379 //
     /* 273452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 273460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273488 */     // (intrinsic_w_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 273491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273503 */     GIR_RootConstrainSelectedInstOperands,
     /* 273504 */     // GIR_Coverage, 2379,
     /* 273504 */     GIR_EraseRootFromParent_Done,
     /* 273505 */   // Label 5295: @273505
     /* 273505 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(273563), // Rule ID 2380 //
     /* 273510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 273521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 273530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273546 */     // (intrinsic_w_chain:{ *:[v4f16] } 625:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 273549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273561 */     GIR_RootConstrainSelectedInstOperands,
     /* 273562 */     // GIR_Coverage, 2380,
     /* 273562 */     GIR_EraseRootFromParent_Done,
     /* 273563 */   // Label 5296: @273563
     /* 273563 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(273621), // Rule ID 2381 //
     /* 273568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273604 */     // (intrinsic_w_chain:{ *:[v8f16] } 625:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 273607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273619 */     GIR_RootConstrainSelectedInstOperands,
     /* 273620 */     // GIR_Coverage, 2381,
     /* 273620 */     GIR_EraseRootFromParent_Done,
     /* 273621 */   // Label 5297: @273621
     /* 273621 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(273679), // Rule ID 2382 //
     /* 273626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 273629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 273634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 273637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 273646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273662 */     // (intrinsic_w_chain:{ *:[v2f32] } 627:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 273665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273677 */     GIR_RootConstrainSelectedInstOperands,
     /* 273678 */     // GIR_Coverage, 2382,
     /* 273678 */     GIR_EraseRootFromParent_Done,
     /* 273679 */   // Label 5298: @273679
     /* 273679 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(273737), // Rule ID 2383 //
     /* 273684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 273687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 273692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273720 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 273723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273735 */     GIR_RootConstrainSelectedInstOperands,
     /* 273736 */     // GIR_Coverage, 2383,
     /* 273736 */     GIR_EraseRootFromParent_Done,
     /* 273737 */   // Label 5299: @273737
     /* 273737 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273795), // Rule ID 2487 //
     /* 273742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 273750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 273753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 273756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 273762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273778 */     // (intrinsic_w_chain:{ *:[v16i8] } 624:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 273778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 273781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273783 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 273785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273793 */     GIR_RootConstrainSelectedInstOperands,
     /* 273794 */     // GIR_Coverage, 2487,
     /* 273794 */     GIR_EraseRootFromParent_Done,
     /* 273795 */   // Label 5300: @273795
     /* 273795 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273851), // Rule ID 13211 //
     /* 273800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 273805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273826 */     // MIs[0] addr
     /* 273826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 273830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273834 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 273834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 273837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273839 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 273841 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 273843 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 273845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273849 */     GIR_RootConstrainSelectedInstOperands,
     /* 273850 */     // GIR_Coverage, 13211,
     /* 273850 */     GIR_EraseRootFromParent_Done,
     /* 273851 */   // Label 5301: @273851
     /* 273851 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273907), // Rule ID 13212 //
     /* 273856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 273861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273882 */     // MIs[0] addr
     /* 273882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 273886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273890 */     // (intrinsic_w_chain:{ *:[i32] } 1250:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 273890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 273893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273895 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 273897 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 273899 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 273901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273905 */     GIR_RootConstrainSelectedInstOperands,
     /* 273906 */     // GIR_Coverage, 13212,
     /* 273906 */     GIR_EraseRootFromParent_Done,
     /* 273907 */   // Label 5302: @273907
     /* 273907 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(273953), // Rule ID 3457 //
     /* 273912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 273915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 273920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 273923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273936 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1513:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 273939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273951 */     GIR_RootConstrainSelectedInstOperands,
     /* 273952 */     // GIR_Coverage, 3457,
     /* 273952 */     GIR_EraseRootFromParent_Done,
     /* 273953 */   // Label 5303: @273953
     /* 273953 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(273999), // Rule ID 3579 //
     /* 273958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 273961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 273966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 273969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273982 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 273985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273997 */     GIR_RootConstrainSelectedInstOperands,
     /* 273998 */     // GIR_Coverage, 3579,
     /* 273998 */     GIR_EraseRootFromParent_Done,
     /* 273999 */   // Label 5304: @273999
     /* 273999 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(274045), // Rule ID 12639 //
     /* 274004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 274012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 274015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274028 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 274031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274043 */     GIR_RootConstrainSelectedInstOperands,
     /* 274044 */     // GIR_Coverage, 12639,
     /* 274044 */     GIR_EraseRootFromParent_Done,
     /* 274045 */   // Label 5305: @274045
     /* 274045 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(274091), // Rule ID 12643 //
     /* 274050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 274058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274074 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1517:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 274077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274089 */     GIR_RootConstrainSelectedInstOperands,
     /* 274090 */     // GIR_Coverage, 12643,
     /* 274090 */     GIR_EraseRootFromParent_Done,
     /* 274091 */   // Label 5306: @274091
     /* 274091 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(274137), // Rule ID 12644 //
     /* 274096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 274104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274120 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1519:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 274123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274135 */     GIR_RootConstrainSelectedInstOperands,
     /* 274136 */     // GIR_Coverage, 12644,
     /* 274136 */     GIR_EraseRootFromParent_Done,
     /* 274137 */   // Label 5307: @274137
     /* 274137 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(274183), // Rule ID 12645 //
     /* 274142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 274150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274166 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1521:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 274169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274181 */     GIR_RootConstrainSelectedInstOperands,
     /* 274182 */     // GIR_Coverage, 12645,
     /* 274182 */     GIR_EraseRootFromParent_Done,
     /* 274183 */   // Label 5308: @274183
     /* 274183 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(274229), // Rule ID 12646 //
     /* 274188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 274196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274212 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1523:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 274215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274227 */     GIR_RootConstrainSelectedInstOperands,
     /* 274228 */     // GIR_Coverage, 12646,
     /* 274228 */     GIR_EraseRootFromParent_Done,
     /* 274229 */   // Label 5309: @274229
     /* 274229 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(274275), // Rule ID 12647 //
     /* 274234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 274237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 274242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274258 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 274261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274273 */     GIR_RootConstrainSelectedInstOperands,
     /* 274274 */     // GIR_Coverage, 12647,
     /* 274274 */     GIR_EraseRootFromParent_Done,
     /* 274275 */   // Label 5310: @274275
     /* 274275 */   GIM_Reject,
     /* 274276 */ // Label 5263: @274276
     /* 274276 */ GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(277269),
     /* 274281 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 274284 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(274352), // Rule ID 2514 //
     /* 274289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 274297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274325 */     // MIs[0] Idx
     /* 274325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274333 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 274336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274344 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274350 */     GIR_RootConstrainSelectedInstOperands,
     /* 274351 */     // GIR_Coverage, 2514,
     /* 274351 */     GIR_EraseRootFromParent_Done,
     /* 274352 */   // Label 5312: @274352
     /* 274352 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(274420), // Rule ID 2515 //
     /* 274357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 274365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274393 */     // MIs[0] Idx
     /* 274393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274401 */     // (intrinsic_w_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 274404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274412 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274418 */     GIR_RootConstrainSelectedInstOperands,
     /* 274419 */     // GIR_Coverage, 2515,
     /* 274419 */     GIR_EraseRootFromParent_Done,
     /* 274420 */   // Label 5313: @274420
     /* 274420 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(274488), // Rule ID 2516 //
     /* 274425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274461 */     // MIs[0] Idx
     /* 274461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274469 */     // (intrinsic_w_chain:{ *:[v2f32] } 628:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 274472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274480 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274486 */     GIR_RootConstrainSelectedInstOperands,
     /* 274487 */     // GIR_Coverage, 2516,
     /* 274487 */     GIR_EraseRootFromParent_Done,
     /* 274488 */   // Label 5314: @274488
     /* 274488 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274556), // Rule ID 2517 //
     /* 274493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274529 */     // MIs[0] Idx
     /* 274529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274537 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 274540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274548 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274554 */     GIR_RootConstrainSelectedInstOperands,
     /* 274555 */     // GIR_Coverage, 2517,
     /* 274555 */     GIR_EraseRootFromParent_Done,
     /* 274556 */   // Label 5315: @274556
     /* 274556 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274624), // Rule ID 2518 //
     /* 274561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 274564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 274569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 274597 */     // MIs[0] Idx
     /* 274597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 274605 */     // (intrinsic_w_chain:{ *:[v4f16] } 626:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 274608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274622 */     GIR_RootConstrainSelectedInstOperands,
     /* 274623 */     // GIR_Coverage, 2518,
     /* 274623 */     GIR_EraseRootFromParent_Done,
     /* 274624 */   // Label 5316: @274624
     /* 274624 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274692), // Rule ID 2519 //
     /* 274629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 274632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 274637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 274665 */     // MIs[0] Idx
     /* 274665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 274673 */     // (intrinsic_w_chain:{ *:[v8f16] } 626:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 274676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274684 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274690 */     GIR_RootConstrainSelectedInstOperands,
     /* 274691 */     // GIR_Coverage, 2519,
     /* 274691 */     GIR_EraseRootFromParent_Done,
     /* 274692 */   // Label 5317: @274692
     /* 274692 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(274760), // Rule ID 7036 //
     /* 274697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 274705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274733 */     // MIs[0] Idx
     /* 274733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274741 */     // (intrinsic_w_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 274744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274752 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274758 */     GIR_RootConstrainSelectedInstOperands,
     /* 274759 */     // GIR_Coverage, 7036,
     /* 274759 */     GIR_EraseRootFromParent_Done,
     /* 274760 */   // Label 5318: @274760
     /* 274760 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274828), // Rule ID 7037 //
     /* 274765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 274773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274801 */     // MIs[0] Idx
     /* 274801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274809 */     // (intrinsic_w_chain:{ *:[v4f32] } 634:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 274812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274820 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274826 */     GIR_RootConstrainSelectedInstOperands,
     /* 274827 */     // GIR_Coverage, 7037,
     /* 274827 */     GIR_EraseRootFromParent_Done,
     /* 274828 */   // Label 5319: @274828
     /* 274828 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(274896), // Rule ID 7038 //
     /* 274833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 274841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274869 */     // MIs[0] Idx
     /* 274869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274877 */     // (intrinsic_w_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 274880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274888 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274894 */     GIR_RootConstrainSelectedInstOperands,
     /* 274895 */     // GIR_Coverage, 7038,
     /* 274895 */     GIR_EraseRootFromParent_Done,
     /* 274896 */   // Label 5320: @274896
     /* 274896 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(274964), // Rule ID 7039 //
     /* 274901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 274909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274937 */     // MIs[0] Idx
     /* 274937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274945 */     // (intrinsic_w_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 274948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274956 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274962 */     GIR_RootConstrainSelectedInstOperands,
     /* 274963 */     // GIR_Coverage, 7039,
     /* 274963 */     GIR_EraseRootFromParent_Done,
     /* 274964 */   // Label 5321: @274964
     /* 274964 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(275024), // Rule ID 3591 //
     /* 274969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 274977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 274989 */     // MIs[0] tile
     /* 274989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275005 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 275005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 275008 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275016 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275022 */     GIR_RootConstrainSelectedInstOperands,
     /* 275023 */     // GIR_Coverage, 3591,
     /* 275023 */     GIR_EraseRootFromParent_Done,
     /* 275024 */   // Label 5322: @275024
     /* 275024 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(275084), // Rule ID 3592 //
     /* 275029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 275032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 275037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275049 */     // MIs[0] tile
     /* 275049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275065 */     // (intrinsic_void 890:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 275068 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275076 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275082 */     GIR_RootConstrainSelectedInstOperands,
     /* 275083 */     // GIR_Coverage, 3592,
     /* 275083 */     GIR_EraseRootFromParent_Done,
     /* 275084 */   // Label 5323: @275084
     /* 275084 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(275144), // Rule ID 3593 //
     /* 275089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 275092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 275100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 275103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 275106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 275109 */     // MIs[0] tile
     /* 275109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275125 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 275125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 275128 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275136 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275142 */     GIR_RootConstrainSelectedInstOperands,
     /* 275143 */     // GIR_Coverage, 3593,
     /* 275143 */     GIR_EraseRootFromParent_Done,
     /* 275144 */   // Label 5324: @275144
     /* 275144 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(275204), // Rule ID 3594 //
     /* 275149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 275152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 275157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275169 */     // MIs[0] tile
     /* 275169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275185 */     // (intrinsic_void 889:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 275188 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275196 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275202 */     GIR_RootConstrainSelectedInstOperands,
     /* 275203 */     // GIR_Coverage, 3594,
     /* 275203 */     GIR_EraseRootFromParent_Done,
     /* 275204 */   // Label 5325: @275204
     /* 275204 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(275264), // Rule ID 3595 //
     /* 275209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 275212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275229 */     // MIs[0] tile
     /* 275229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275245 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 275248 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275256 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275262 */     GIR_RootConstrainSelectedInstOperands,
     /* 275263 */     // GIR_Coverage, 3595,
     /* 275263 */     GIR_EraseRootFromParent_Done,
     /* 275264 */   // Label 5326: @275264
     /* 275264 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(275324), // Rule ID 3596 //
     /* 275269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275289 */     // MIs[0] tile
     /* 275289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275305 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 275308 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275316 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275322 */     GIR_RootConstrainSelectedInstOperands,
     /* 275323 */     // GIR_Coverage, 3596,
     /* 275323 */     GIR_EraseRootFromParent_Done,
     /* 275324 */   // Label 5327: @275324
     /* 275324 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(275384), // Rule ID 3597 //
     /* 275329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 275332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275349 */     // MIs[0] tile
     /* 275349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275365 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 275368 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275376 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275382 */     GIR_RootConstrainSelectedInstOperands,
     /* 275383 */     // GIR_Coverage, 3597,
     /* 275383 */     GIR_EraseRootFromParent_Done,
     /* 275384 */   // Label 5328: @275384
     /* 275384 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(275444), // Rule ID 3598 //
     /* 275389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 275397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275409 */     // MIs[0] tile
     /* 275409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275425 */     // (intrinsic_void 940:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 275428 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275436 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275442 */     GIR_RootConstrainSelectedInstOperands,
     /* 275443 */     // GIR_Coverage, 3598,
     /* 275443 */     GIR_EraseRootFromParent_Done,
     /* 275444 */   // Label 5329: @275444
     /* 275444 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(275504), // Rule ID 3692 //
     /* 275449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 275457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275469 */     // MIs[0] tile
     /* 275469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275485 */     // (intrinsic_void 1042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 275488 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275496 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275502 */     GIR_RootConstrainSelectedInstOperands,
     /* 275503 */     // GIR_Coverage, 3692,
     /* 275503 */     GIR_EraseRootFromParent_Done,
     /* 275504 */   // Label 5330: @275504
     /* 275504 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(275564), // Rule ID 3693 //
     /* 275509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 275517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275529 */     // MIs[0] tile
     /* 275529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275545 */     // (intrinsic_void 809:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 275545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 275548 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275556 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275562 */     GIR_RootConstrainSelectedInstOperands,
     /* 275563 */     // GIR_Coverage, 3693,
     /* 275563 */     GIR_EraseRootFromParent_Done,
     /* 275564 */   // Label 5331: @275564
     /* 275564 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275624), // Rule ID 12654 //
     /* 275569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275589 */     // MIs[0] tile
     /* 275589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275605 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 275605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 275608 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275622 */     GIR_RootConstrainSelectedInstOperands,
     /* 275623 */     // GIR_Coverage, 12654,
     /* 275623 */     GIR_EraseRootFromParent_Done,
     /* 275624 */   // Label 5332: @275624
     /* 275624 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275684), // Rule ID 12655 //
     /* 275629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 275632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 275640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 275643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 275646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 275649 */     // MIs[0] tile
     /* 275649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275665 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 275665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 275668 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275682 */     GIR_RootConstrainSelectedInstOperands,
     /* 275683 */     // GIR_Coverage, 12655,
     /* 275683 */     GIR_EraseRootFromParent_Done,
     /* 275684 */   // Label 5333: @275684
     /* 275684 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275744), // Rule ID 12656 //
     /* 275689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 275697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275709 */     // MIs[0] tile
     /* 275709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275725 */     // (intrinsic_void 943:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 275728 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275736 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275742 */     GIR_RootConstrainSelectedInstOperands,
     /* 275743 */     // GIR_Coverage, 12656,
     /* 275743 */     GIR_EraseRootFromParent_Done,
     /* 275744 */   // Label 5334: @275744
     /* 275744 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275804), // Rule ID 12657 //
     /* 275749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 275757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275769 */     // MIs[0] tile
     /* 275769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275785 */     // (intrinsic_void 1043:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 275788 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275796 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275802 */     GIR_RootConstrainSelectedInstOperands,
     /* 275803 */     // GIR_Coverage, 12657,
     /* 275803 */     GIR_EraseRootFromParent_Done,
     /* 275804 */   // Label 5335: @275804
     /* 275804 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275864), // Rule ID 12658 //
     /* 275809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 275817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275829 */     // MIs[0] tile
     /* 275829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275845 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 275848 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275856 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275862 */     GIR_RootConstrainSelectedInstOperands,
     /* 275863 */     // GIR_Coverage, 12658,
     /* 275863 */     GIR_EraseRootFromParent_Done,
     /* 275864 */   // Label 5336: @275864
     /* 275864 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(275924), // Rule ID 12659 //
     /* 275869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 275877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275889 */     // MIs[0] tile
     /* 275889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275905 */     // (intrinsic_void 1178:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 275908 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275916 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275922 */     GIR_RootConstrainSelectedInstOperands,
     /* 275923 */     // GIR_Coverage, 12659,
     /* 275923 */     GIR_EraseRootFromParent_Done,
     /* 275924 */   // Label 5337: @275924
     /* 275924 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(275984), // Rule ID 12660 //
     /* 275929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 275937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275949 */     // MIs[0] tile
     /* 275949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275965 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 275968 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275976 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275982 */     GIR_RootConstrainSelectedInstOperands,
     /* 275983 */     // GIR_Coverage, 12660,
     /* 275983 */     GIR_EraseRootFromParent_Done,
     /* 275984 */   // Label 5338: @275984
     /* 275984 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(276044), // Rule ID 12661 //
     /* 275989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 275997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276009 */     // MIs[0] tile
     /* 276009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276025 */     // (intrinsic_void 1094:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 276028 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276036 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276042 */     GIR_RootConstrainSelectedInstOperands,
     /* 276043 */     // GIR_Coverage, 12661,
     /* 276043 */     GIR_EraseRootFromParent_Done,
     /* 276044 */   // Label 5339: @276044
     /* 276044 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(276104), // Rule ID 12662 //
     /* 276049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 276057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276069 */     // MIs[0] tile
     /* 276069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276085 */     // (intrinsic_void 1210:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 276088 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276096 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276102 */     GIR_RootConstrainSelectedInstOperands,
     /* 276103 */     // GIR_Coverage, 12662,
     /* 276103 */     GIR_EraseRootFromParent_Done,
     /* 276104 */   // Label 5340: @276104
     /* 276104 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(276164), // Rule ID 12663 //
     /* 276109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276129 */     // MIs[0] tile
     /* 276129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276145 */     // (intrinsic_void 1211:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 276148 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276156 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276162 */     GIR_RootConstrainSelectedInstOperands,
     /* 276163 */     // GIR_Coverage, 12663,
     /* 276163 */     GIR_EraseRootFromParent_Done,
     /* 276164 */   // Label 5341: @276164
     /* 276164 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(276224), // Rule ID 12664 //
     /* 276169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 276177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276189 */     // MIs[0] tile
     /* 276189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276205 */     // (intrinsic_void 1043:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 276208 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276216 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276222 */     GIR_RootConstrainSelectedInstOperands,
     /* 276223 */     // GIR_Coverage, 12664,
     /* 276223 */     GIR_EraseRootFromParent_Done,
     /* 276224 */   // Label 5342: @276224
     /* 276224 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(276284), // Rule ID 12665 //
     /* 276229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 276237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276249 */     // MIs[0] tile
     /* 276249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276265 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 276268 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276276 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276282 */     GIR_RootConstrainSelectedInstOperands,
     /* 276283 */     // GIR_Coverage, 12665,
     /* 276283 */     GIR_EraseRootFromParent_Done,
     /* 276284 */   // Label 5343: @276284
     /* 276284 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(276344), // Rule ID 12666 //
     /* 276289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 276297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276309 */     // MIs[0] tile
     /* 276309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276325 */     // (intrinsic_void 1178:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 276328 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276336 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276342 */     GIR_RootConstrainSelectedInstOperands,
     /* 276343 */     // GIR_Coverage, 12666,
     /* 276343 */     GIR_EraseRootFromParent_Done,
     /* 276344 */   // Label 5344: @276344
     /* 276344 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(276404), // Rule ID 12667 //
     /* 276349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 276357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276369 */     // MIs[0] tile
     /* 276369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276385 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 276388 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276396 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276402 */     GIR_RootConstrainSelectedInstOperands,
     /* 276403 */     // GIR_Coverage, 12667,
     /* 276403 */     GIR_EraseRootFromParent_Done,
     /* 276404 */   // Label 5345: @276404
     /* 276404 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(276464), // Rule ID 12668 //
     /* 276409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 276417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276429 */     // MIs[0] tile
     /* 276429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276445 */     // (intrinsic_void 1094:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 276448 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276456 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276462 */     GIR_RootConstrainSelectedInstOperands,
     /* 276463 */     // GIR_Coverage, 12668,
     /* 276463 */     GIR_EraseRootFromParent_Done,
     /* 276464 */   // Label 5346: @276464
     /* 276464 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(276524), // Rule ID 12669 //
     /* 276469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 276477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276489 */     // MIs[0] tile
     /* 276489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276505 */     // (intrinsic_void 1210:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 276508 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276516 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276522 */     GIR_RootConstrainSelectedInstOperands,
     /* 276523 */     // GIR_Coverage, 12669,
     /* 276523 */     GIR_EraseRootFromParent_Done,
     /* 276524 */   // Label 5347: @276524
     /* 276524 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(276584), // Rule ID 12670 //
     /* 276529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276549 */     // MIs[0] tile
     /* 276549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276565 */     // (intrinsic_void 1211:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 276568 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276576 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276582 */     GIR_RootConstrainSelectedInstOperands,
     /* 276583 */     // GIR_Coverage, 12670,
     /* 276583 */     GIR_EraseRootFromParent_Done,
     /* 276584 */   // Label 5348: @276584
     /* 276584 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(276644), // Rule ID 13044 //
     /* 276589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 276597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 276600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 276603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 276606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 276609 */     // MIs[0] tile
     /* 276609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276625 */     // (intrinsic_void 810:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 276625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 276628 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276636 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276642 */     GIR_RootConstrainSelectedInstOperands,
     /* 276643 */     // GIR_Coverage, 13044,
     /* 276643 */     GIR_EraseRootFromParent_Done,
     /* 276644 */   // Label 5349: @276644
     /* 276644 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(276704), // Rule ID 13045 //
     /* 276649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 276657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276669 */     // MIs[0] tile
     /* 276669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276685 */     // (intrinsic_void 1044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 276688 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276696 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276702 */     GIR_RootConstrainSelectedInstOperands,
     /* 276703 */     // GIR_Coverage, 13045,
     /* 276703 */     GIR_EraseRootFromParent_Done,
     /* 276704 */   // Label 5350: @276704
     /* 276704 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(276764), // Rule ID 13046 //
     /* 276709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 276717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276729 */     // MIs[0] tile
     /* 276729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276745 */     // (intrinsic_void 1177:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 276748 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276756 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276762 */     GIR_RootConstrainSelectedInstOperands,
     /* 276763 */     // GIR_Coverage, 13046,
     /* 276763 */     GIR_EraseRootFromParent_Done,
     /* 276764 */   // Label 5351: @276764
     /* 276764 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(276824), // Rule ID 13047 //
     /* 276769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 276777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276789 */     // MIs[0] tile
     /* 276789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276792 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276805 */     // (intrinsic_void 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 276808 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276816 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276822 */     GIR_RootConstrainSelectedInstOperands,
     /* 276823 */     // GIR_Coverage, 13047,
     /* 276823 */     GIR_EraseRootFromParent_Done,
     /* 276824 */   // Label 5352: @276824
     /* 276824 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(276884), // Rule ID 13158 //
     /* 276829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 276832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 276837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276849 */     // MIs[0] tile
     /* 276849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 276857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276865 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 276865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 276868 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276876 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276882 */     GIR_RootConstrainSelectedInstOperands,
     /* 276883 */     // GIR_Coverage, 13158,
     /* 276883 */     GIR_EraseRootFromParent_Done,
     /* 276884 */   // Label 5353: @276884
     /* 276884 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(276932), // Rule ID 3578 //
     /* 276889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 276897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276913 */     // MIs[0] Op4
     /* 276913 */     // No operand predicates
     /* 276913 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 276916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276924 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276930 */     GIR_RootConstrainSelectedInstOperands,
     /* 276931 */     // GIR_Coverage, 3578,
     /* 276931 */     GIR_EraseRootFromParent_Done,
     /* 276932 */   // Label 5354: @276932
     /* 276932 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(276980), // Rule ID 3580 //
     /* 276937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 276945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276961 */     // MIs[0] Op4
     /* 276961 */     // No operand predicates
     /* 276961 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1518:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 276964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276972 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276978 */     GIR_RootConstrainSelectedInstOperands,
     /* 276979 */     // GIR_Coverage, 3580,
     /* 276979 */     GIR_EraseRootFromParent_Done,
     /* 276980 */   // Label 5355: @276980
     /* 276980 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(277028), // Rule ID 3581 //
     /* 276985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 276988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 276993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277009 */     // MIs[0] Op4
     /* 277009 */     // No operand predicates
     /* 277009 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1514:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 277012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277020 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277026 */     GIR_RootConstrainSelectedInstOperands,
     /* 277027 */     // GIR_Coverage, 3581,
     /* 277027 */     GIR_EraseRootFromParent_Done,
     /* 277028 */   // Label 5356: @277028
     /* 277028 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(277076), // Rule ID 3582 //
     /* 277033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 277036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 277041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277057 */     // MIs[0] Op4
     /* 277057 */     // No operand predicates
     /* 277057 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 277060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277068 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277074 */     GIR_RootConstrainSelectedInstOperands,
     /* 277075 */     // GIR_Coverage, 3582,
     /* 277075 */     GIR_EraseRootFromParent_Done,
     /* 277076 */   // Label 5357: @277076
     /* 277076 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(277124), // Rule ID 12638 //
     /* 277081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 277089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 277092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 277095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277105 */     // MIs[0] Op4
     /* 277105 */     // No operand predicates
     /* 277105 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1526:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 277108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277116 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277122 */     GIR_RootConstrainSelectedInstOperands,
     /* 277123 */     // GIR_Coverage, 12638,
     /* 277123 */     GIR_EraseRootFromParent_Done,
     /* 277124 */   // Label 5358: @277124
     /* 277124 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(277172), // Rule ID 12640 //
     /* 277129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 277137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277153 */     // MIs[0] Op4
     /* 277153 */     // No operand predicates
     /* 277153 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1520:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 277156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277164 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277170 */     GIR_RootConstrainSelectedInstOperands,
     /* 277171 */     // GIR_Coverage, 12640,
     /* 277171 */     GIR_EraseRootFromParent_Done,
     /* 277172 */   // Label 5359: @277172
     /* 277172 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(277220), // Rule ID 12641 //
     /* 277177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 277185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277201 */     // MIs[0] Op4
     /* 277201 */     // No operand predicates
     /* 277201 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1522:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 277204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277212 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277218 */     GIR_RootConstrainSelectedInstOperands,
     /* 277219 */     // GIR_Coverage, 12641,
     /* 277219 */     GIR_EraseRootFromParent_Done,
     /* 277220 */   // Label 5360: @277220
     /* 277220 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(277268), // Rule ID 12642 //
     /* 277225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 277233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277249 */     // MIs[0] Op4
     /* 277249 */     // No operand predicates
     /* 277249 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1524:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 277252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277260 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277266 */     GIR_RootConstrainSelectedInstOperands,
     /* 277267 */     // GIR_Coverage, 12642,
     /* 277267 */     GIR_EraseRootFromParent_Done,
     /* 277268 */   // Label 5361: @277268
     /* 277268 */   GIM_Reject,
     /* 277269 */ // Label 5311: @277269
     /* 277269 */ GIM_Reject,
     /* 277270 */ // Label 39: @277270
     /* 277270 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5366*/ GIMT_Encode4(277559),
     /* 277281 */ /*GILLT_s64*//*Label 5362*/ GIMT_Encode4(277313), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277293 */ /*GILLT_v2s64*//*Label 5363*/ GIMT_Encode4(277373), GIMT_Encode4(0),
     /* 277301 */ /*GILLT_v4s32*//*Label 5364*/ GIMT_Encode4(277435), GIMT_Encode4(0),
     /* 277309 */ /*GILLT_v8s16*//*Label 5365*/ GIMT_Encode4(277497),
     /* 277313 */ // Label 5362: @277313
     /* 277313 */ GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(277372), // Rule ID 6548 //
     /* 277318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277329 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 277329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 277332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 277356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277371 */   // GIR_Coverage, 6548,
     /* 277371 */   GIR_EraseRootFromParent_Done,
     /* 277372 */ // Label 5367: @277372
     /* 277372 */ GIM_Reject,
     /* 277373 */ // Label 5363: @277373
     /* 277373 */ GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(277434),
     /* 277378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277385 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(277412), // Rule ID 6410 //
     /* 277390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 277397 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 277397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 277400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277410 */     GIR_RootConstrainSelectedInstOperands,
     /* 277411 */     // GIR_Coverage, 6410,
     /* 277411 */     GIR_EraseRootFromParent_Done,
     /* 277412 */   // Label 5369: @277412
     /* 277412 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(277433), // Rule ID 6403 //
     /* 277417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277421 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 277421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 277424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277431 */     GIR_RootConstrainSelectedInstOperands,
     /* 277432 */     // GIR_Coverage, 6403,
     /* 277432 */     GIR_EraseRootFromParent_Done,
     /* 277433 */   // Label 5370: @277433
     /* 277433 */   GIM_Reject,
     /* 277434 */ // Label 5368: @277434
     /* 277434 */ GIM_Reject,
     /* 277435 */ // Label 5364: @277435
     /* 277435 */ GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(277496),
     /* 277440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277447 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(277474), // Rule ID 6407 //
     /* 277452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 277459 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 277459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 277462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277472 */     GIR_RootConstrainSelectedInstOperands,
     /* 277473 */     // GIR_Coverage, 6407,
     /* 277473 */     GIR_EraseRootFromParent_Done,
     /* 277474 */   // Label 5372: @277474
     /* 277474 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(277495), // Rule ID 6400 //
     /* 277479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277483 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 277483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 277486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277493 */     GIR_RootConstrainSelectedInstOperands,
     /* 277494 */     // GIR_Coverage, 6400,
     /* 277494 */     GIR_EraseRootFromParent_Done,
     /* 277495 */   // Label 5373: @277495
     /* 277495 */   GIM_Reject,
     /* 277496 */ // Label 5371: @277496
     /* 277496 */ GIM_Reject,
     /* 277497 */ // Label 5365: @277497
     /* 277497 */ GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(277558),
     /* 277502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 277505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277509 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(277536), // Rule ID 6404 //
     /* 277514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 277521 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 277521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 277524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277534 */     GIR_RootConstrainSelectedInstOperands,
     /* 277535 */     // GIR_Coverage, 6404,
     /* 277535 */     GIR_EraseRootFromParent_Done,
     /* 277536 */   // Label 5375: @277536
     /* 277536 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(277557), // Rule ID 6397 //
     /* 277541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277545 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 277545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 277548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277555 */     GIR_RootConstrainSelectedInstOperands,
     /* 277556 */     // GIR_Coverage, 6397,
     /* 277556 */     GIR_EraseRootFromParent_Done,
     /* 277557 */   // Label 5376: @277557
     /* 277557 */   GIM_Reject,
     /* 277558 */ // Label 5374: @277558
     /* 277558 */ GIM_Reject,
     /* 277559 */ // Label 5366: @277559
     /* 277559 */ GIM_Reject,
     /* 277560 */ // Label 40: @277560
     /* 277560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5381*/ GIMT_Encode4(278996),
     /* 277571 */ /*GILLT_s32*//*Label 5377*/ GIMT_Encode4(277603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277583 */ /*GILLT_v2s32*//*Label 5378*/ GIMT_Encode4(277642), GIMT_Encode4(0),
     /* 277591 */ /*GILLT_v4s16*//*Label 5379*/ GIMT_Encode4(277998), GIMT_Encode4(0),
     /* 277599 */ /*GILLT_v8s8*//*Label 5380*/ GIMT_Encode4(278497),
     /* 277603 */ // Label 5377: @277603
     /* 277603 */ GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(277641), // Rule ID 6569 //
     /* 277608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 277611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 277615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 277619 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 277619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277624 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 277630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 277635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 277640 */   // GIR_Coverage, 6569,
     /* 277640 */   GIR_EraseRootFromParent_Done,
     /* 277641 */ // Label 5382: @277641
     /* 277641 */ GIM_Reject,
     /* 277642 */ // Label 5378: @277642
     /* 277642 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(277997),
     /* 277647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277654 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(277732), // Rule ID 5449 //
     /* 277659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 277679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277696 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 277704 */     // MIs[1] Operand 2
     /* 277704 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277717 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 277717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 277720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277730 */     GIR_RootConstrainSelectedInstOperands,
     /* 277731 */     // GIR_Coverage, 5449,
     /* 277731 */     GIR_EraseRootFromParent_Done,
     /* 277732 */   // Label 5384: @277732
     /* 277732 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(277803), // Rule ID 5445 //
     /* 277737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 277757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277775 */     // MIs[1] Operand 2
     /* 277775 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277788 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 277788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 277791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277801 */     GIR_RootConstrainSelectedInstOperands,
     /* 277802 */     // GIR_Coverage, 5445,
     /* 277802 */     GIR_EraseRootFromParent_Done,
     /* 277803 */   // Label 5385: @277803
     /* 277803 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(277874), // Rule ID 5447 //
     /* 277808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 277828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277846 */     // MIs[1] Operand 2
     /* 277846 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277859 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 277859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 277862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277872 */     GIR_RootConstrainSelectedInstOperands,
     /* 277873 */     // GIR_Coverage, 5447,
     /* 277873 */     GIR_EraseRootFromParent_Done,
     /* 277874 */   // Label 5386: @277874
     /* 277874 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(277927), // Rule ID 2162 //
     /* 277879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 277890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277899 */     // MIs[1] imm
     /* 277899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 277911 */     // MIs[2] Operand 1
     /* 277911 */     // No operand predicates
     /* 277911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277913 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 277913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 277916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277925 */     GIR_RootConstrainSelectedInstOperands,
     /* 277926 */     // GIR_Coverage, 2162,
     /* 277926 */     GIR_EraseRootFromParent_Done,
     /* 277927 */   // Label 5387: @277927
     /* 277927 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(277977), // Rule ID 6385 //
     /* 277932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277949 */     // MIs[1] imm
     /* 277949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 277961 */     // MIs[2] Operand 1
     /* 277961 */     // No operand predicates
     /* 277961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277963 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 277963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 277966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277975 */     GIR_RootConstrainSelectedInstOperands,
     /* 277976 */     // GIR_Coverage, 6385,
     /* 277976 */     GIR_EraseRootFromParent_Done,
     /* 277977 */   // Label 5388: @277977
     /* 277977 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(277996), // Rule ID 1099 //
     /* 277982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277989 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 277989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 277994 */     GIR_RootConstrainSelectedInstOperands,
     /* 277995 */     // GIR_Coverage, 1099,
     /* 277995 */     GIR_Done,
     /* 277996 */   // Label 5389: @277996
     /* 277996 */   GIM_Reject,
     /* 277997 */ // Label 5383: @277997
     /* 277997 */ GIM_Reject,
     /* 277998 */ // Label 5379: @277998
     /* 277998 */ GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(278496),
     /* 278003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278010 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(278088), // Rule ID 5443 //
     /* 278015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278052 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278058 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278060 */     // MIs[1] Operand 2
     /* 278060 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278073 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 278076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278086 */     GIR_RootConstrainSelectedInstOperands,
     /* 278087 */     // GIR_Coverage, 5443,
     /* 278087 */     GIR_EraseRootFromParent_Done,
     /* 278088 */   // Label 5391: @278088
     /* 278088 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(278159), // Rule ID 5439 //
     /* 278093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278131 */     // MIs[1] Operand 2
     /* 278131 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278144 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 278147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278157 */     GIR_RootConstrainSelectedInstOperands,
     /* 278158 */     // GIR_Coverage, 5439,
     /* 278158 */     GIR_EraseRootFromParent_Done,
     /* 278159 */   // Label 5392: @278159
     /* 278159 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(278230), // Rule ID 5441 //
     /* 278164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278202 */     // MIs[1] Operand 2
     /* 278202 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278215 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 278218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278228 */     GIR_RootConstrainSelectedInstOperands,
     /* 278229 */     // GIR_Coverage, 5441,
     /* 278229 */     GIR_EraseRootFromParent_Done,
     /* 278230 */   // Label 5393: @278230
     /* 278230 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(278322), // Rule ID 5565 //
     /* 278235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278243 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 278275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278279 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278283 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278290 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 278290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 278297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 278306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 278310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278320 */     GIR_RootConstrainSelectedInstOperands,
     /* 278321 */     // GIR_Coverage, 5565,
     /* 278321 */     GIR_EraseRootFromParent_Done,
     /* 278322 */   // Label 5394: @278322
     /* 278322 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(278375), // Rule ID 2161 //
     /* 278327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278347 */     // MIs[1] imm
     /* 278347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278355 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278359 */     // MIs[2] Operand 1
     /* 278359 */     // No operand predicates
     /* 278359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278361 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278373 */     GIR_RootConstrainSelectedInstOperands,
     /* 278374 */     // GIR_Coverage, 2161,
     /* 278374 */     GIR_EraseRootFromParent_Done,
     /* 278375 */   // Label 5395: @278375
     /* 278375 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(278425), // Rule ID 6384 //
     /* 278380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278397 */     // MIs[1] imm
     /* 278397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278409 */     // MIs[2] Operand 1
     /* 278409 */     // No operand predicates
     /* 278409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278411 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 278411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278423 */     GIR_RootConstrainSelectedInstOperands,
     /* 278424 */     // GIR_Coverage, 6384,
     /* 278424 */     GIR_EraseRootFromParent_Done,
     /* 278425 */   // Label 5396: @278425
     /* 278425 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(278476), // Rule ID 5593 //
     /* 278430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278438 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278461 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 278461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 278464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 278470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 278474 */     GIR_RootConstrainSelectedInstOperands,
     /* 278475 */     // GIR_Coverage, 5593,
     /* 278475 */     GIR_EraseRootFromParent_Done,
     /* 278476 */   // Label 5397: @278476
     /* 278476 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(278495), // Rule ID 1098 //
     /* 278481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278488 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 278488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278493 */     GIR_RootConstrainSelectedInstOperands,
     /* 278494 */     // GIR_Coverage, 1098,
     /* 278494 */     GIR_Done,
     /* 278495 */   // Label 5398: @278495
     /* 278495 */   GIM_Reject,
     /* 278496 */ // Label 5390: @278496
     /* 278496 */ GIM_Reject,
     /* 278497 */ // Label 5380: @278497
     /* 278497 */ GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(278995),
     /* 278502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278509 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(278587), // Rule ID 5437 //
     /* 278514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278559 */     // MIs[1] Operand 2
     /* 278559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278572 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 278575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278585 */     GIR_RootConstrainSelectedInstOperands,
     /* 278586 */     // GIR_Coverage, 5437,
     /* 278586 */     GIR_EraseRootFromParent_Done,
     /* 278587 */   // Label 5400: @278587
     /* 278587 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(278658), // Rule ID 5433 //
     /* 278592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278630 */     // MIs[1] Operand 2
     /* 278630 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278643 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 278646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278656 */     GIR_RootConstrainSelectedInstOperands,
     /* 278657 */     // GIR_Coverage, 5433,
     /* 278657 */     GIR_EraseRootFromParent_Done,
     /* 278658 */   // Label 5401: @278658
     /* 278658 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(278729), // Rule ID 5435 //
     /* 278663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278701 */     // MIs[1] Operand 2
     /* 278701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278714 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 278717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278727 */     GIR_RootConstrainSelectedInstOperands,
     /* 278728 */     // GIR_Coverage, 5435,
     /* 278728 */     GIR_EraseRootFromParent_Done,
     /* 278729 */   // Label 5402: @278729
     /* 278729 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(278821), // Rule ID 5538 //
     /* 278734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278742 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 278774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278782 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278789 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 278789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 278796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 278805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 278809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 278814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278819 */     GIR_RootConstrainSelectedInstOperands,
     /* 278820 */     // GIR_Coverage, 5538,
     /* 278820 */     GIR_EraseRootFromParent_Done,
     /* 278821 */   // Label 5403: @278821
     /* 278821 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(278874), // Rule ID 2160 //
     /* 278826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278846 */     // MIs[1] imm
     /* 278846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 278858 */     // MIs[2] Operand 1
     /* 278858 */     // No operand predicates
     /* 278858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278860 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 278863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278872 */     GIR_RootConstrainSelectedInstOperands,
     /* 278873 */     // GIR_Coverage, 2160,
     /* 278873 */     GIR_EraseRootFromParent_Done,
     /* 278874 */   // Label 5404: @278874
     /* 278874 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(278924), // Rule ID 6383 //
     /* 278879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278896 */     // MIs[1] imm
     /* 278896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 278908 */     // MIs[2] Operand 1
     /* 278908 */     // No operand predicates
     /* 278908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278910 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 278910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 278913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278922 */     GIR_RootConstrainSelectedInstOperands,
     /* 278923 */     // GIR_Coverage, 6383,
     /* 278923 */     GIR_EraseRootFromParent_Done,
     /* 278924 */   // Label 5405: @278924
     /* 278924 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(278975), // Rule ID 5592 //
     /* 278929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278937 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278960 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 278960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 278963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 278969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 278973 */     GIR_RootConstrainSelectedInstOperands,
     /* 278974 */     // GIR_Coverage, 5592,
     /* 278974 */     GIR_EraseRootFromParent_Done,
     /* 278975 */   // Label 5406: @278975
     /* 278975 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(278994), // Rule ID 1097 //
     /* 278980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278987 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 278987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 278992 */     GIR_RootConstrainSelectedInstOperands,
     /* 278993 */     // GIR_Coverage, 1097,
     /* 278993 */     GIR_Done,
     /* 278994 */   // Label 5407: @278994
     /* 278994 */   GIM_Reject,
     /* 278995 */ // Label 5399: @278995
     /* 278995 */ GIM_Reject,
     /* 278996 */ // Label 5381: @278996
     /* 278996 */ GIM_Reject,
     /* 278997 */ // Label 41: @278997
     /* 278997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5410*/ GIMT_Encode4(279116),
     /* 279008 */ /*GILLT_s32*//*Label 5408*/ GIMT_Encode4(279016),
     /* 279012 */ /*GILLT_s64*//*Label 5409*/ GIMT_Encode4(279036),
     /* 279016 */ // Label 5408: @279016
     /* 279016 */ GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(279035), // Rule ID 81 //
     /* 279021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279025 */   // MIs[0] Operand 1
     /* 279025 */   // No operand predicates
     /* 279025 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 279025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 279028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279030 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 279033 */   GIR_RootConstrainSelectedInstOperands,
     /* 279034 */   // GIR_Coverage, 81,
     /* 279034 */   GIR_EraseRootFromParent_Done,
     /* 279035 */ // Label 5411: @279035
     /* 279035 */ GIM_Reject,
     /* 279036 */ // Label 5409: @279036
     /* 279036 */ GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(279096), // Rule ID 3909 //
     /* 279041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 279044 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 279048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279052 */   // MIs[0] Operand 1
     /* 279052 */   // No operand predicates
     /* 279052 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 279052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 279055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 279059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279064 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 279069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 279074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 279085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279095 */   // GIR_Coverage, 3909,
     /* 279095 */   GIR_EraseRootFromParent_Done,
     /* 279096 */ // Label 5412: @279096
     /* 279096 */ GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(279115), // Rule ID 82 //
     /* 279101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 279105 */   // MIs[0] Operand 1
     /* 279105 */   // No operand predicates
     /* 279105 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 279105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 279108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279110 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 279113 */   GIR_RootConstrainSelectedInstOperands,
     /* 279114 */   // GIR_Coverage, 82,
     /* 279114 */   GIR_EraseRootFromParent_Done,
     /* 279115 */ // Label 5413: @279115
     /* 279115 */ GIM_Reject,
     /* 279116 */ // Label 5410: @279116
     /* 279116 */ GIM_Reject,
     /* 279117 */ // Label 42: @279117
     /* 279117 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5417*/ GIMT_Encode4(279357),
     /* 279128 */ /*GILLT_s16*//*Label 5414*/ GIMT_Encode4(279140),
     /* 279132 */ /*GILLT_s32*//*Label 5415*/ GIMT_Encode4(279192),
     /* 279136 */ /*GILLT_s64*//*Label 5416*/ GIMT_Encode4(279305),
     /* 279140 */ // Label 5414: @279140
     /* 279140 */ GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(279163), // Rule ID 506 //
     /* 279145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279148 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279156 */   // MIs[0] Operand 1
     /* 279156 */   // No operand predicates
     /* 279156 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 279156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 279159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279161 */   GIR_RootConstrainSelectedInstOperands,
     /* 279162 */   // GIR_Coverage, 506,
     /* 279162 */   GIR_EraseRootFromParent_Done,
     /* 279163 */ // Label 5418: @279163
     /* 279163 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(279191), // Rule ID 688 //
     /* 279168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279171 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279179 */   // MIs[0] Operand 1
     /* 279179 */   // No operand predicates
     /* 279179 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 279179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 279182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279184 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 279189 */   GIR_RootConstrainSelectedInstOperands,
     /* 279190 */   // GIR_Coverage, 688,
     /* 279190 */   GIR_EraseRootFromParent_Done,
     /* 279191 */ // Label 5419: @279191
     /* 279191 */ GIM_Reject,
     /* 279192 */ // Label 5415: @279192
     /* 279192 */ GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(279215), // Rule ID 507 //
     /* 279197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279200 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279208 */   // MIs[0] Operand 1
     /* 279208 */   // No operand predicates
     /* 279208 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 279208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 279211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279213 */   GIR_RootConstrainSelectedInstOperands,
     /* 279214 */   // GIR_Coverage, 507,
     /* 279214 */   GIR_EraseRootFromParent_Done,
     /* 279215 */ // Label 5420: @279215
     /* 279215 */ GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(279243), // Rule ID 689 //
     /* 279220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279223 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279231 */   // MIs[0] Operand 1
     /* 279231 */   // No operand predicates
     /* 279231 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 279231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 279234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279236 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 279241 */   GIR_RootConstrainSelectedInstOperands,
     /* 279242 */   // GIR_Coverage, 689,
     /* 279242 */   GIR_EraseRootFromParent_Done,
     /* 279243 */ // Label 5421: @279243
     /* 279243 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(279304), // Rule ID 6072 //
     /* 279248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279251 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 279255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279259 */   // MIs[0] Operand 1
     /* 279259 */   // No operand predicates
     /* 279259 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 279259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 279266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279271 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 279276 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 279279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279286 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 279293 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279303 */   // GIR_Coverage, 6072,
     /* 279303 */   GIR_EraseRootFromParent_Done,
     /* 279304 */ // Label 5422: @279304
     /* 279304 */ GIM_Reject,
     /* 279305 */ // Label 5416: @279305
     /* 279305 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(279328), // Rule ID 508 //
     /* 279310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279313 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279321 */   // MIs[0] Operand 1
     /* 279321 */   // No operand predicates
     /* 279321 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 279321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 279324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279326 */   GIR_RootConstrainSelectedInstOperands,
     /* 279327 */   // GIR_Coverage, 508,
     /* 279327 */   GIR_EraseRootFromParent_Done,
     /* 279328 */ // Label 5423: @279328
     /* 279328 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(279356), // Rule ID 690 //
     /* 279333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279336 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 279340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279344 */   // MIs[0] Operand 1
     /* 279344 */   // No operand predicates
     /* 279344 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 279344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 279347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279349 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 279354 */   GIR_RootConstrainSelectedInstOperands,
     /* 279355 */   // GIR_Coverage, 690,
     /* 279355 */   GIR_EraseRootFromParent_Done,
     /* 279356 */ // Label 5424: @279356
     /* 279356 */ GIM_Reject,
     /* 279357 */ // Label 5417: @279357
     /* 279357 */ GIM_Reject,
     /* 279358 */ // Label 43: @279358
     /* 279358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5430*/ GIMT_Encode4(281255),
     /* 279369 */ /*GILLT_s32*//*Label 5425*/ GIMT_Encode4(279405),
     /* 279373 */ /*GILLT_s64*//*Label 5426*/ GIMT_Encode4(280846), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279385 */ /*GILLT_v2s64*//*Label 5427*/ GIMT_Encode4(281069), GIMT_Encode4(0),
     /* 279393 */ /*GILLT_v4s32*//*Label 5428*/ GIMT_Encode4(281131), GIMT_Encode4(0),
     /* 279401 */ /*GILLT_v8s16*//*Label 5429*/ GIMT_Encode4(281193),
     /* 279405 */ // Label 5425: @279405
     /* 279405 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(279525), // Rule ID 13213 //
     /* 279410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279417 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279425 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279428 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 279437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279444 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279444 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279447 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 279451 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279456 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279462 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279465 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279469 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279488 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279491 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279494 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279507 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279523 */   GIR_RootConstrainSelectedInstOperands,
     /* 279524 */   // GIR_Coverage, 13213,
     /* 279524 */   GIR_EraseRootFromParent_Done,
     /* 279525 */ // Label 5431: @279525
     /* 279525 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(279645), // Rule ID 13215 //
     /* 279530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279537 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279545 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279548 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279553 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 279557 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279564 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279564 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279567 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 279571 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279576 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279608 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279611 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279614 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279643 */   GIR_RootConstrainSelectedInstOperands,
     /* 279644 */   // GIR_Coverage, 13215,
     /* 279644 */   GIR_EraseRootFromParent_Done,
     /* 279645 */ // Label 5432: @279645
     /* 279645 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(279765), // Rule ID 13217 //
     /* 279650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279657 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279661 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279665 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279668 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279673 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 279677 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279684 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279684 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279687 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 279691 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279696 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279702 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279705 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279709 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279728 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279731 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279734 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279763 */   GIR_RootConstrainSelectedInstOperands,
     /* 279764 */   // GIR_Coverage, 13217,
     /* 279764 */   GIR_EraseRootFromParent_Done,
     /* 279765 */ // Label 5433: @279765
     /* 279765 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(279885), // Rule ID 13219 //
     /* 279770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279777 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279785 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279788 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279793 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279797 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279802 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279804 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279804 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279807 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 279811 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279816 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279822 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279825 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279829 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279848 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279851 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279854 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279857 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279862 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279883 */   GIR_RootConstrainSelectedInstOperands,
     /* 279884 */   // GIR_Coverage, 13219,
     /* 279884 */   GIR_EraseRootFromParent_Done,
     /* 279885 */ // Label 5434: @279885
     /* 279885 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(280005), // Rule ID 13235 //
     /* 279890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279897 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279905 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279908 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 279913 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 279917 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279924 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279924 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279927 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 279931 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279936 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279968 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279971 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279974 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280003 */   GIR_RootConstrainSelectedInstOperands,
     /* 280004 */   // GIR_Coverage, 13235,
     /* 280004 */   GIR_EraseRootFromParent_Done,
     /* 280005 */ // Label 5435: @280005
     /* 280005 */ GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(280125), // Rule ID 13237 //
     /* 280010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280017 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280025 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280028 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280037 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280042 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280044 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280044 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280047 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 280051 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280056 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280088 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280091 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280094 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280097 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280123 */   GIR_RootConstrainSelectedInstOperands,
     /* 280124 */   // GIR_Coverage, 13237,
     /* 280124 */   GIR_EraseRootFromParent_Done,
     /* 280125 */ // Label 5436: @280125
     /* 280125 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(280245), // Rule ID 13239 //
     /* 280130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280137 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280145 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280148 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280153 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280164 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280164 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280167 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 280171 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280176 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280208 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280211 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280214 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280243 */   GIR_RootConstrainSelectedInstOperands,
     /* 280244 */   // GIR_Coverage, 13239,
     /* 280244 */   GIR_EraseRootFromParent_Done,
     /* 280245 */ // Label 5437: @280245
     /* 280245 */ GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(280365), // Rule ID 13241 //
     /* 280250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280257 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280265 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280268 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280273 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280277 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280284 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280284 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280287 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 280291 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280296 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280302 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280305 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280309 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280328 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280331 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280334 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280342 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280347 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280363 */   GIR_RootConstrainSelectedInstOperands,
     /* 280364 */   // GIR_Coverage, 13241,
     /* 280364 */   GIR_EraseRootFromParent_Done,
     /* 280365 */ // Label 5438: @280365
     /* 280365 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(280485), // Rule ID 13245 //
     /* 280370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280377 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280381 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280385 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280388 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 280397 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280404 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280404 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280407 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 280411 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280416 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280422 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280425 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280429 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280448 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280451 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280454 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280457 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280483 */   GIR_RootConstrainSelectedInstOperands,
     /* 280484 */   // GIR_Coverage, 13245,
     /* 280484 */   GIR_EraseRootFromParent_Done,
     /* 280485 */ // Label 5439: @280485
     /* 280485 */ GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(280605), // Rule ID 13247 //
     /* 280490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280497 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280505 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280508 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280513 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280517 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280524 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280524 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280527 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 280531 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280536 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280542 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280545 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280549 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280574 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280577 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280582 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280587 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280603 */   GIR_RootConstrainSelectedInstOperands,
     /* 280604 */   // GIR_Coverage, 13247,
     /* 280604 */   GIR_EraseRootFromParent_Done,
     /* 280605 */ // Label 5440: @280605
     /* 280605 */ GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(280725), // Rule ID 13249 //
     /* 280610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280617 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280625 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280628 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280633 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280637 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280644 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280644 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280647 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 280651 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280656 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280662 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280665 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280669 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280688 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280691 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280694 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280723 */   GIR_RootConstrainSelectedInstOperands,
     /* 280724 */   // GIR_Coverage, 13249,
     /* 280724 */   GIR_EraseRootFromParent_Done,
     /* 280725 */ // Label 5441: @280725
     /* 280725 */ GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(280845), // Rule ID 13251 //
     /* 280730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280737 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280745 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280748 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280753 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280757 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280764 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 280771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280776 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280782 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280789 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280808 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280811 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280814 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280822 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280843 */   GIR_RootConstrainSelectedInstOperands,
     /* 280844 */   // GIR_Coverage, 13251,
     /* 280844 */   GIR_EraseRootFromParent_Done,
     /* 280845 */ // Label 5442: @280845
     /* 280845 */ GIM_Reject,
     /* 280846 */ // Label 5426: @280846
     /* 280846 */ GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(281068),
     /* 280851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 280854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280858 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(280912), // Rule ID 5678 //
     /* 280863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 280896 */     // MIs[2] Operand 1
     /* 280896 */     // No operand predicates
     /* 280896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280898 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 280898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 280901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280910 */     GIR_RootConstrainSelectedInstOperands,
     /* 280911 */     // GIR_Coverage, 5678,
     /* 280911 */     GIR_EraseRootFromParent_Done,
     /* 280912 */   // Label 5444: @280912
     /* 280912 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(280991), // Rule ID 11295 //
     /* 280917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 280932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280944 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 280948 */     // MIs[2] Operand 1
     /* 280948 */     // No operand predicates
     /* 280948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280950 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 280950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 280953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280962 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 280981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 280989 */     GIR_RootConstrainSelectedInstOperands,
     /* 280990 */     // GIR_Coverage, 11295,
     /* 280990 */     GIR_EraseRootFromParent_Done,
     /* 280991 */   // Label 5445: @280991
     /* 280991 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(281067), // Rule ID 6550 //
     /* 280996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281000 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 281000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 281017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 281036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 281054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 281065 */     GIR_RootConstrainSelectedInstOperands,
     /* 281066 */     // GIR_Coverage, 6550,
     /* 281066 */     GIR_EraseRootFromParent_Done,
     /* 281067 */   // Label 5446: @281067
     /* 281067 */   GIM_Reject,
     /* 281068 */ // Label 5443: @281068
     /* 281068 */ GIM_Reject,
     /* 281069 */ // Label 5427: @281069
     /* 281069 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(281130),
     /* 281074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281081 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(281108), // Rule ID 6412 //
     /* 281086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 281093 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 281093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 281096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281106 */     GIR_RootConstrainSelectedInstOperands,
     /* 281107 */     // GIR_Coverage, 6412,
     /* 281107 */     GIR_EraseRootFromParent_Done,
     /* 281108 */   // Label 5448: @281108
     /* 281108 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(281129), // Rule ID 6401 //
     /* 281113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281117 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 281117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 281120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281127 */     GIR_RootConstrainSelectedInstOperands,
     /* 281128 */     // GIR_Coverage, 6401,
     /* 281128 */     GIR_EraseRootFromParent_Done,
     /* 281129 */   // Label 5449: @281129
     /* 281129 */   GIM_Reject,
     /* 281130 */ // Label 5447: @281130
     /* 281130 */ GIM_Reject,
     /* 281131 */ // Label 5428: @281131
     /* 281131 */ GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(281192),
     /* 281136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281143 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(281170), // Rule ID 6409 //
     /* 281148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 281155 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 281155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 281158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281168 */     GIR_RootConstrainSelectedInstOperands,
     /* 281169 */     // GIR_Coverage, 6409,
     /* 281169 */     GIR_EraseRootFromParent_Done,
     /* 281170 */   // Label 5451: @281170
     /* 281170 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(281191), // Rule ID 6398 //
     /* 281175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281179 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 281179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 281182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281189 */     GIR_RootConstrainSelectedInstOperands,
     /* 281190 */     // GIR_Coverage, 6398,
     /* 281190 */     GIR_EraseRootFromParent_Done,
     /* 281191 */   // Label 5452: @281191
     /* 281191 */   GIM_Reject,
     /* 281192 */ // Label 5450: @281192
     /* 281192 */ GIM_Reject,
     /* 281193 */ // Label 5429: @281193
     /* 281193 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(281254),
     /* 281198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281205 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(281232), // Rule ID 6406 //
     /* 281210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 281217 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 281217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 281220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281230 */     GIR_RootConstrainSelectedInstOperands,
     /* 281231 */     // GIR_Coverage, 6406,
     /* 281231 */     GIR_EraseRootFromParent_Done,
     /* 281232 */   // Label 5454: @281232
     /* 281232 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(281253), // Rule ID 6395 //
     /* 281237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281241 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 281241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 281244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281251 */     GIR_RootConstrainSelectedInstOperands,
     /* 281252 */     // GIR_Coverage, 6395,
     /* 281252 */     GIR_EraseRootFromParent_Done,
     /* 281253 */   // Label 5455: @281253
     /* 281253 */   GIM_Reject,
     /* 281254 */ // Label 5453: @281254
     /* 281254 */ GIM_Reject,
     /* 281255 */ // Label 5430: @281255
     /* 281255 */ GIM_Reject,
     /* 281256 */ // Label 44: @281256
     /* 281256 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5461*/ GIMT_Encode4(282909),
     /* 281267 */ /*GILLT_s32*//*Label 5456*/ GIMT_Encode4(281347),
     /* 281271 */ /*GILLT_s64*//*Label 5457*/ GIMT_Encode4(281841), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281323 */ /*GILLT_nxv2s64*//*Label 5458*/ GIMT_Encode4(282483), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281335 */ /*GILLT_nxv4s32*//*Label 5459*/ GIMT_Encode4(282692), GIMT_Encode4(0),
     /* 281343 */ /*GILLT_nxv8s16*//*Label 5460*/ GIMT_Encode4(282836),
     /* 281347 */ // Label 5456: @281347
     /* 281347 */ GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(281840),
     /* 281352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281359 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(281424), // Rule ID 5673 //
     /* 281364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281397 */     // MIs[2] Operand 1
     /* 281397 */     // No operand predicates
     /* 281397 */     // MIs[0] Operand 2
     /* 281397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281410 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 281410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281422 */     GIR_RootConstrainSelectedInstOperands,
     /* 281423 */     // GIR_Coverage, 5673,
     /* 281423 */     GIR_EraseRootFromParent_Done,
     /* 281424 */   // Label 5463: @281424
     /* 281424 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(281489), // Rule ID 5675 //
     /* 281429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281458 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281462 */     // MIs[2] Operand 1
     /* 281462 */     // No operand predicates
     /* 281462 */     // MIs[0] Operand 2
     /* 281462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281475 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281487 */     GIR_RootConstrainSelectedInstOperands,
     /* 281488 */     // GIR_Coverage, 5675,
     /* 281488 */     GIR_EraseRootFromParent_Done,
     /* 281489 */   // Label 5464: @281489
     /* 281489 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(281554), // Rule ID 5677 //
     /* 281494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281527 */     // MIs[2] Operand 1
     /* 281527 */     // No operand predicates
     /* 281527 */     // MIs[0] Operand 2
     /* 281527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281540 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281552 */     GIR_RootConstrainSelectedInstOperands,
     /* 281553 */     // GIR_Coverage, 5677,
     /* 281553 */     GIR_EraseRootFromParent_Done,
     /* 281554 */   // Label 5465: @281554
     /* 281554 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(281644), // Rule ID 11291 //
     /* 281559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281586 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281590 */     // MIs[2] Operand 1
     /* 281590 */     // No operand predicates
     /* 281590 */     // MIs[0] Operand 2
     /* 281590 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281603 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 281603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281615 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 281642 */     GIR_RootConstrainSelectedInstOperands,
     /* 281643 */     // GIR_Coverage, 11291,
     /* 281643 */     GIR_EraseRootFromParent_Done,
     /* 281644 */   // Label 5466: @281644
     /* 281644 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(281734), // Rule ID 11293 //
     /* 281649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281680 */     // MIs[2] Operand 1
     /* 281680 */     // No operand predicates
     /* 281680 */     // MIs[0] Operand 2
     /* 281680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281693 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 281693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 281696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 281732 */     GIR_RootConstrainSelectedInstOperands,
     /* 281733 */     // GIR_Coverage, 11293,
     /* 281733 */     GIR_EraseRootFromParent_Done,
     /* 281734 */   // Label 5467: @281734
     /* 281734 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(281769), // Rule ID 6555 //
     /* 281739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281743 */     // MIs[0] Operand 2
     /* 281743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281754 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 281754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 281767 */     GIR_RootConstrainSelectedInstOperands,
     /* 281768 */     // GIR_Coverage, 6555,
     /* 281768 */     GIR_EraseRootFromParent_Done,
     /* 281769 */   // Label 5468: @281769
     /* 281769 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(281804), // Rule ID 6556 //
     /* 281774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281778 */     // MIs[0] Operand 2
     /* 281778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281789 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 281789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 281802 */     GIR_RootConstrainSelectedInstOperands,
     /* 281803 */     // GIR_Coverage, 6556,
     /* 281803 */     GIR_EraseRootFromParent_Done,
     /* 281804 */   // Label 5469: @281804
     /* 281804 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(281839), // Rule ID 6557 //
     /* 281809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281813 */     // MIs[0] Operand 2
     /* 281813 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 281824 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 281824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281837 */     GIR_RootConstrainSelectedInstOperands,
     /* 281838 */     // GIR_Coverage, 6557,
     /* 281838 */     GIR_EraseRootFromParent_Done,
     /* 281839 */   // Label 5470: @281839
     /* 281839 */   GIM_Reject,
     /* 281840 */ // Label 5462: @281840
     /* 281840 */ GIM_Reject,
     /* 281841 */ // Label 5457: @281841
     /* 281841 */ GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(282482),
     /* 281846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281853 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(281930), // Rule ID 5679 //
     /* 281858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 281866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281899 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281903 */     // MIs[3] Operand 1
     /* 281903 */     // No operand predicates
     /* 281903 */     // MIs[0] Operand 2
     /* 281903 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281916 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 281916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 281919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 281925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281928 */     GIR_RootConstrainSelectedInstOperands,
     /* 281929 */     // GIR_Coverage, 5679,
     /* 281929 */     GIR_EraseRootFromParent_Done,
     /* 281930 */   // Label 5472: @281930
     /* 281930 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(282007), // Rule ID 5680 //
     /* 281935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 281943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281976 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281980 */     // MIs[3] Operand 1
     /* 281980 */     // No operand predicates
     /* 281980 */     // MIs[0] Operand 2
     /* 281980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281993 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 281996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 282002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 282005 */     GIR_RootConstrainSelectedInstOperands,
     /* 282006 */     // GIR_Coverage, 5680,
     /* 282006 */     GIR_EraseRootFromParent_Done,
     /* 282007 */   // Label 5473: @282007
     /* 282007 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(282109), // Rule ID 11292 //
     /* 282012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282051 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282055 */     // MIs[3] Operand 1
     /* 282055 */     // No operand predicates
     /* 282055 */     // MIs[0] Operand 2
     /* 282055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282068 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 282068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282080 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 282107 */     GIR_RootConstrainSelectedInstOperands,
     /* 282108 */     // GIR_Coverage, 11292,
     /* 282108 */     GIR_EraseRootFromParent_Done,
     /* 282109 */   // Label 5474: @282109
     /* 282109 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(282211), // Rule ID 11294 //
     /* 282114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282157 */     // MIs[3] Operand 1
     /* 282157 */     // No operand predicates
     /* 282157 */     // MIs[0] Operand 2
     /* 282157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282170 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 282170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 282173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282182 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 282209 */     GIR_RootConstrainSelectedInstOperands,
     /* 282210 */     // GIR_Coverage, 11294,
     /* 282210 */     GIR_EraseRootFromParent_Done,
     /* 282211 */   // Label 5475: @282211
     /* 282211 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(282276), // Rule ID 5674 //
     /* 282216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282249 */     // MIs[2] Operand 1
     /* 282249 */     // No operand predicates
     /* 282249 */     // MIs[0] Operand 2
     /* 282249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282262 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 282262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282274 */     GIR_RootConstrainSelectedInstOperands,
     /* 282275 */     // GIR_Coverage, 5674,
     /* 282275 */     GIR_EraseRootFromParent_Done,
     /* 282276 */   // Label 5476: @282276
     /* 282276 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(282341), // Rule ID 5676 //
     /* 282281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282314 */     // MIs[2] Operand 1
     /* 282314 */     // No operand predicates
     /* 282314 */     // MIs[0] Operand 2
     /* 282314 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282327 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282339 */     GIR_RootConstrainSelectedInstOperands,
     /* 282340 */     // GIR_Coverage, 5676,
     /* 282340 */     GIR_EraseRootFromParent_Done,
     /* 282341 */   // Label 5477: @282341
     /* 282341 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(282376), // Rule ID 6551 //
     /* 282346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282350 */     // MIs[0] Operand 2
     /* 282350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282361 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 282361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 282374 */     GIR_RootConstrainSelectedInstOperands,
     /* 282375 */     // GIR_Coverage, 6551,
     /* 282375 */     GIR_EraseRootFromParent_Done,
     /* 282376 */   // Label 5478: @282376
     /* 282376 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(282411), // Rule ID 6552 //
     /* 282381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282385 */     // MIs[0] Operand 2
     /* 282385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282396 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 282396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 282409 */     GIR_RootConstrainSelectedInstOperands,
     /* 282410 */     // GIR_Coverage, 6552,
     /* 282410 */     GIR_EraseRootFromParent_Done,
     /* 282411 */   // Label 5479: @282411
     /* 282411 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(282446), // Rule ID 6553 //
     /* 282416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282420 */     // MIs[0] Operand 2
     /* 282420 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282431 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 282431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 282444 */     GIR_RootConstrainSelectedInstOperands,
     /* 282445 */     // GIR_Coverage, 6553,
     /* 282445 */     GIR_EraseRootFromParent_Done,
     /* 282446 */   // Label 5480: @282446
     /* 282446 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(282481), // Rule ID 6554 //
     /* 282451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282455 */     // MIs[0] Operand 2
     /* 282455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 282466 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 282466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282471 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282479 */     GIR_RootConstrainSelectedInstOperands,
     /* 282480 */     // GIR_Coverage, 6554,
     /* 282480 */     GIR_EraseRootFromParent_Done,
     /* 282481 */   // Label 5481: @282481
     /* 282481 */   GIM_Reject,
     /* 282482 */ // Label 5471: @282482
     /* 282482 */ GIM_Reject,
     /* 282483 */ // Label 5458: @282483
     /* 282483 */ GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(282691),
     /* 282488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282495 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(282560), // Rule ID 10563 //
     /* 282500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282503 */     // MIs[0] Operand 2
     /* 282503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282514 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282526 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 282548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282558 */     GIR_RootConstrainSelectedInstOperands,
     /* 282559 */     // GIR_Coverage, 10563,
     /* 282559 */     GIR_EraseRootFromParent_Done,
     /* 282560 */   // Label 5483: @282560
     /* 282560 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(282625), // Rule ID 10564 //
     /* 282565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282568 */     // MIs[0] Operand 2
     /* 282568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282579 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 282613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282623 */     GIR_RootConstrainSelectedInstOperands,
     /* 282624 */     // GIR_Coverage, 10564,
     /* 282624 */     GIR_EraseRootFromParent_Done,
     /* 282625 */   // Label 5484: @282625
     /* 282625 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(282690), // Rule ID 10565 //
     /* 282630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282633 */     // MIs[0] Operand 2
     /* 282633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282644 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282656 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 282678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282688 */     GIR_RootConstrainSelectedInstOperands,
     /* 282689 */     // GIR_Coverage, 10565,
     /* 282689 */     GIR_EraseRootFromParent_Done,
     /* 282690 */   // Label 5485: @282690
     /* 282690 */   GIM_Reject,
     /* 282691 */ // Label 5482: @282691
     /* 282691 */ GIM_Reject,
     /* 282692 */ // Label 5459: @282692
     /* 282692 */ GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(282835),
     /* 282697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282704 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(282769), // Rule ID 10566 //
     /* 282709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282712 */     // MIs[0] Operand 2
     /* 282712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282723 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 282723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 282730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282735 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 282757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282767 */     GIR_RootConstrainSelectedInstOperands,
     /* 282768 */     // GIR_Coverage, 10566,
     /* 282768 */     GIR_EraseRootFromParent_Done,
     /* 282769 */   // Label 5487: @282769
     /* 282769 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(282834), // Rule ID 10567 //
     /* 282774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282777 */     // MIs[0] Operand 2
     /* 282777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282788 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 282788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 282795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282800 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 282822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282832 */     GIR_RootConstrainSelectedInstOperands,
     /* 282833 */     // GIR_Coverage, 10567,
     /* 282833 */     GIR_EraseRootFromParent_Done,
     /* 282834 */   // Label 5488: @282834
     /* 282834 */   GIM_Reject,
     /* 282835 */ // Label 5486: @282835
     /* 282835 */ GIM_Reject,
     /* 282836 */ // Label 5460: @282836
     /* 282836 */ GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(282908), // Rule ID 10568 //
     /* 282841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282851 */   // MIs[0] Operand 2
     /* 282851 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282862 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 282862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 282869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282874 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 282896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282904 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282906 */   GIR_RootConstrainSelectedInstOperands,
     /* 282907 */   // GIR_Coverage, 10568,
     /* 282907 */   GIR_EraseRootFromParent_Done,
     /* 282908 */ // Label 5489: @282908
     /* 282908 */ GIM_Reject,
     /* 282909 */ // Label 5461: @282909
     /* 282909 */ GIM_Reject,
     /* 282910 */ // Label 45: @282910
     /* 282910 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5494*/ GIMT_Encode4(285688),
     /* 282921 */ /*GILLT_s32*//*Label 5490*/ GIMT_Encode4(282957), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282937 */ /*GILLT_v2s64*//*Label 5491*/ GIMT_Encode4(284758), GIMT_Encode4(0),
     /* 282945 */ /*GILLT_v4s32*//*Label 5492*/ GIMT_Encode4(285068), GIMT_Encode4(0),
     /* 282953 */ /*GILLT_v8s16*//*Label 5493*/ GIMT_Encode4(285378),
     /* 282957 */ // Label 5490: @282957
     /* 282957 */ GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(283107), // Rule ID 13222 //
     /* 282962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282969 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282977 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282980 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 282985 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282989 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282996 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282996 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282999 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 283003 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283008 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283014 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283017 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283021 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283040 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283043 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283046 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283049 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283054 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283059 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283076 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283088 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283106 */   // GIR_Coverage, 13222,
     /* 283106 */   GIR_EraseRootFromParent_Done,
     /* 283107 */ // Label 5495: @283107
     /* 283107 */ GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(283257), // Rule ID 13224 //
     /* 283112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283119 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283127 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283130 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283135 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283139 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283146 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283146 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283149 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 283153 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283158 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283164 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283167 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283171 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283190 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283193 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283196 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283199 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283204 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283209 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283226 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283256 */   // GIR_Coverage, 13224,
     /* 283256 */   GIR_EraseRootFromParent_Done,
     /* 283257 */ // Label 5496: @283257
     /* 283257 */ GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(283407), // Rule ID 13226 //
     /* 283262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283269 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283277 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283280 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283285 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283289 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283296 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283296 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283299 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 283303 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283308 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283314 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283317 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283321 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283328 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283331 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283335 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283340 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283343 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283346 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283349 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283354 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283359 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283376 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283388 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283406 */   // GIR_Coverage, 13226,
     /* 283406 */   GIR_EraseRootFromParent_Done,
     /* 283407 */ // Label 5497: @283407
     /* 283407 */ GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(283557), // Rule ID 13228 //
     /* 283412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283419 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283427 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283430 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283435 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283439 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283444 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283446 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283446 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283449 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 283453 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283458 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283464 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283467 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283471 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283478 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283481 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283485 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283490 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283493 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283496 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283499 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283504 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283509 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283526 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283538 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283548 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283556 */   // GIR_Coverage, 13228,
     /* 283556 */   GIR_EraseRootFromParent_Done,
     /* 283557 */ // Label 5498: @283557
     /* 283557 */ GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(283707), // Rule ID 13255 //
     /* 283562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283569 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283577 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283580 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283585 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283589 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283596 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283596 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283599 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 283603 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283608 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283614 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283617 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283621 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283628 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283631 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283635 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283640 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283643 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283646 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283649 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283654 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283659 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283676 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283688 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283706 */   // GIR_Coverage, 13255,
     /* 283706 */   GIR_EraseRootFromParent_Done,
     /* 283707 */ // Label 5499: @283707
     /* 283707 */ GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(283857), // Rule ID 13257 //
     /* 283712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283719 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283727 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283730 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283735 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283739 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283746 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283746 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283749 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 283753 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283758 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283778 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283781 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283785 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283790 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283793 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283796 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283799 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283804 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283809 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283826 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283856 */   // GIR_Coverage, 13257,
     /* 283856 */   GIR_EraseRootFromParent_Done,
     /* 283857 */ // Label 5500: @283857
     /* 283857 */ GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(284007), // Rule ID 13259 //
     /* 283862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283869 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283877 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283880 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283885 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283889 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283896 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283896 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283899 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 283903 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283908 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283914 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283917 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283921 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283928 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283931 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283935 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283940 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283943 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283946 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283954 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283959 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283976 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284006 */   // GIR_Coverage, 13259,
     /* 284006 */   GIR_EraseRootFromParent_Done,
     /* 284007 */ // Label 5501: @284007
     /* 284007 */ GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(284157), // Rule ID 13261 //
     /* 284012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284019 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284023 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284027 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284030 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 284035 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284039 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284046 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284046 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284049 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 284053 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284058 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284064 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284067 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284071 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284078 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284081 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284085 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284090 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284093 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284096 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284099 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284104 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284109 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284126 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284133 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284138 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284156 */   // GIR_Coverage, 13261,
     /* 284156 */   GIR_EraseRootFromParent_Done,
     /* 284157 */ // Label 5502: @284157
     /* 284157 */ GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(284307), // Rule ID 13265 //
     /* 284162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284169 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284177 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284180 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284185 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284189 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284196 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284196 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284199 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 284203 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284208 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284214 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284217 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284221 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284228 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284231 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284235 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284240 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284243 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284246 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284249 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284254 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284259 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284276 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284306 */   // GIR_Coverage, 13265,
     /* 284306 */   GIR_EraseRootFromParent_Done,
     /* 284307 */ // Label 5503: @284307
     /* 284307 */ GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(284457), // Rule ID 13267 //
     /* 284312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284319 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284327 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284330 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284339 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284346 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284346 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284349 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 284353 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284358 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284364 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284367 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284371 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284378 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284381 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284385 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284390 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284393 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284396 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284399 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284404 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284409 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284426 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284456 */   // GIR_Coverage, 13267,
     /* 284456 */   GIR_EraseRootFromParent_Done,
     /* 284457 */ // Label 5504: @284457
     /* 284457 */ GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(284607), // Rule ID 13269 //
     /* 284462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284469 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284477 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284480 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284485 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284489 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284496 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284496 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284499 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 284503 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284508 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284514 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284517 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284521 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284540 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284543 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284546 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284549 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284554 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284559 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284576 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284583 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284588 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284601 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284606 */   // GIR_Coverage, 13269,
     /* 284606 */   GIR_EraseRootFromParent_Done,
     /* 284607 */ // Label 5505: @284607
     /* 284607 */ GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(284757), // Rule ID 13271 //
     /* 284612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284619 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284627 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284630 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284635 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284646 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284646 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284649 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 284653 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284658 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284664 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284667 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284671 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284678 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284681 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284685 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284690 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284693 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284696 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284699 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284704 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284709 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284726 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284738 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284756 */   // GIR_Coverage, 13271,
     /* 284756 */   GIR_EraseRootFromParent_Done,
     /* 284757 */ // Label 5506: @284757
     /* 284757 */ GIM_Reject,
     /* 284758 */ // Label 5491: @284758
     /* 284758 */ GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(285067),
     /* 284763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284770 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(284835), // Rule ID 702 //
     /* 284775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284786 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284789 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284798 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284818 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 284818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 284821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284833 */     GIR_RootConstrainSelectedInstOperands,
     /* 284834 */     // GIR_Coverage, 702,
     /* 284834 */     GIR_EraseRootFromParent_Done,
     /* 284835 */   // Label 5508: @284835
     /* 284835 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284900), // Rule ID 1711 //
     /* 284840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284851 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284854 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284863 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284883 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 284883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 284886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284898 */     GIR_RootConstrainSelectedInstOperands,
     /* 284899 */     // GIR_Coverage, 1711,
     /* 284899 */     GIR_EraseRootFromParent_Done,
     /* 284900 */   // Label 5509: @284900
     /* 284900 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(284959), // Rule ID 700 //
     /* 284905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284916 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284919 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284944 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 284944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 284947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 284957 */     GIR_RootConstrainSelectedInstOperands,
     /* 284958 */     // GIR_Coverage, 700,
     /* 284958 */     GIR_EraseRootFromParent_Done,
     /* 284959 */   // Label 5510: @284959
     /* 284959 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(285018), // Rule ID 1709 //
     /* 284964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284975 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284978 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285003 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 285003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 285006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285016 */     GIR_RootConstrainSelectedInstOperands,
     /* 285017 */     // GIR_Coverage, 1709,
     /* 285017 */     GIR_EraseRootFromParent_Done,
     /* 285018 */   // Label 5511: @285018
     /* 285018 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(285045), // Rule ID 6411 //
     /* 285023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 285030 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 285030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 285033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285043 */     GIR_RootConstrainSelectedInstOperands,
     /* 285044 */     // GIR_Coverage, 6411,
     /* 285044 */     GIR_EraseRootFromParent_Done,
     /* 285045 */   // Label 5512: @285045
     /* 285045 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(285066), // Rule ID 6402 //
     /* 285050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285054 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 285054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 285057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285064 */     GIR_RootConstrainSelectedInstOperands,
     /* 285065 */     // GIR_Coverage, 6402,
     /* 285065 */     GIR_EraseRootFromParent_Done,
     /* 285066 */   // Label 5513: @285066
     /* 285066 */   GIM_Reject,
     /* 285067 */ // Label 5507: @285067
     /* 285067 */ GIM_Reject,
     /* 285068 */ // Label 5492: @285068
     /* 285068 */ GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(285377),
     /* 285073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285080 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(285145), // Rule ID 698 //
     /* 285085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285128 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 285131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285143 */     GIR_RootConstrainSelectedInstOperands,
     /* 285144 */     // GIR_Coverage, 698,
     /* 285144 */     GIR_EraseRootFromParent_Done,
     /* 285145 */   // Label 5515: @285145
     /* 285145 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(285210), // Rule ID 1707 //
     /* 285150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285161 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285164 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285173 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285193 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 285196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285208 */     GIR_RootConstrainSelectedInstOperands,
     /* 285209 */     // GIR_Coverage, 1707,
     /* 285209 */     GIR_EraseRootFromParent_Done,
     /* 285210 */   // Label 5516: @285210
     /* 285210 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(285269), // Rule ID 696 //
     /* 285215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285226 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285229 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285238 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285254 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 285257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285267 */     GIR_RootConstrainSelectedInstOperands,
     /* 285268 */     // GIR_Coverage, 696,
     /* 285268 */     GIR_EraseRootFromParent_Done,
     /* 285269 */   // Label 5517: @285269
     /* 285269 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(285328), // Rule ID 1705 //
     /* 285274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285285 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285288 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285297 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285313 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 285316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285326 */     GIR_RootConstrainSelectedInstOperands,
     /* 285327 */     // GIR_Coverage, 1705,
     /* 285327 */     GIR_EraseRootFromParent_Done,
     /* 285328 */   // Label 5518: @285328
     /* 285328 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(285355), // Rule ID 6408 //
     /* 285333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285340 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 285340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 285343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285353 */     GIR_RootConstrainSelectedInstOperands,
     /* 285354 */     // GIR_Coverage, 6408,
     /* 285354 */     GIR_EraseRootFromParent_Done,
     /* 285355 */   // Label 5519: @285355
     /* 285355 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(285376), // Rule ID 6399 //
     /* 285360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285364 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 285364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 285367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285374 */     GIR_RootConstrainSelectedInstOperands,
     /* 285375 */     // GIR_Coverage, 6399,
     /* 285375 */     GIR_EraseRootFromParent_Done,
     /* 285376 */   // Label 5520: @285376
     /* 285376 */   GIM_Reject,
     /* 285377 */ // Label 5514: @285377
     /* 285377 */ GIM_Reject,
     /* 285378 */ // Label 5493: @285378
     /* 285378 */ GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(285687),
     /* 285383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285390 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(285455), // Rule ID 694 //
     /* 285395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285406 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285409 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285418 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285438 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 285441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285453 */     GIR_RootConstrainSelectedInstOperands,
     /* 285454 */     // GIR_Coverage, 694,
     /* 285454 */     GIR_EraseRootFromParent_Done,
     /* 285455 */   // Label 5522: @285455
     /* 285455 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(285520), // Rule ID 1703 //
     /* 285460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285471 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285474 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285483 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285503 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 285506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285518 */     GIR_RootConstrainSelectedInstOperands,
     /* 285519 */     // GIR_Coverage, 1703,
     /* 285519 */     GIR_EraseRootFromParent_Done,
     /* 285520 */   // Label 5523: @285520
     /* 285520 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(285579), // Rule ID 692 //
     /* 285525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285536 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285539 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285564 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 285564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 285567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285577 */     GIR_RootConstrainSelectedInstOperands,
     /* 285578 */     // GIR_Coverage, 692,
     /* 285578 */     GIR_EraseRootFromParent_Done,
     /* 285579 */   // Label 5524: @285579
     /* 285579 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(285638), // Rule ID 1701 //
     /* 285584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285595 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285598 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285607 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285623 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 285623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 285626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285636 */     GIR_RootConstrainSelectedInstOperands,
     /* 285637 */     // GIR_Coverage, 1701,
     /* 285637 */     GIR_EraseRootFromParent_Done,
     /* 285638 */   // Label 5525: @285638
     /* 285638 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(285665), // Rule ID 6405 //
     /* 285643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285650 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 285650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 285653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285663 */     GIR_RootConstrainSelectedInstOperands,
     /* 285664 */     // GIR_Coverage, 6405,
     /* 285664 */     GIR_EraseRootFromParent_Done,
     /* 285665 */   // Label 5526: @285665
     /* 285665 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(285686), // Rule ID 6396 //
     /* 285670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285674 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 285674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 285677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285684 */     GIR_RootConstrainSelectedInstOperands,
     /* 285685 */     // GIR_Coverage, 6396,
     /* 285685 */     GIR_EraseRootFromParent_Done,
     /* 285686 */   // Label 5527: @285686
     /* 285686 */   GIM_Reject,
     /* 285687 */ // Label 5521: @285687
     /* 285687 */ GIM_Reject,
     /* 285688 */ // Label 5494: @285688
     /* 285688 */ GIM_Reject,
     /* 285689 */ // Label 46: @285689
     /* 285689 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5533*/ GIMT_Encode4(286513),
     /* 285700 */ /*GILLT_s32*//*Label 5528*/ GIMT_Encode4(285736),
     /* 285704 */ /*GILLT_s64*//*Label 5529*/ GIMT_Encode4(285913), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285716 */ /*GILLT_v2s64*//*Label 5530*/ GIMT_Encode4(286086), GIMT_Encode4(0),
     /* 285724 */ /*GILLT_v4s32*//*Label 5531*/ GIMT_Encode4(286231), GIMT_Encode4(0),
     /* 285732 */ /*GILLT_v8s16*//*Label 5532*/ GIMT_Encode4(286372),
     /* 285736 */ // Label 5528: @285736
     /* 285736 */ GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(285912),
     /* 285741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285755 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(285792), // Rule ID 3939 //
     /* 285760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 285768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285779 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285790 */     GIR_RootConstrainSelectedInstOperands,
     /* 285791 */     // GIR_Coverage, 3939,
     /* 285791 */     GIR_EraseRootFromParent_Done,
     /* 285792 */   // Label 5535: @285792
     /* 285792 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(285829), // Rule ID 3940 //
     /* 285797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285816 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285827 */     GIR_RootConstrainSelectedInstOperands,
     /* 285828 */     // GIR_Coverage, 3940,
     /* 285828 */     GIR_EraseRootFromParent_Done,
     /* 285829 */   // Label 5536: @285829
     /* 285829 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(285866), // Rule ID 3938 //
     /* 285834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285853 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285864 */     GIR_RootConstrainSelectedInstOperands,
     /* 285865 */     // GIR_Coverage, 3938,
     /* 285865 */     GIR_EraseRootFromParent_Done,
     /* 285866 */   // Label 5537: @285866
     /* 285866 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(285911), // Rule ID 3937 //
     /* 285871 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 285871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 285889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285909 */     GIR_RootConstrainSelectedInstOperands,
     /* 285910 */     // GIR_Coverage, 3937,
     /* 285910 */     GIR_EraseRootFromParent_Done,
     /* 285911 */   // Label 5538: @285911
     /* 285911 */   GIM_Reject,
     /* 285912 */ // Label 5534: @285912
     /* 285912 */ GIM_Reject,
     /* 285913 */ // Label 5529: @285913
     /* 285913 */ GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(286085),
     /* 285918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285932 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(286000), // Rule ID 3941 //
     /* 285937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285956 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285975 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 285991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285998 */     GIR_RootConstrainSelectedInstOperands,
     /* 285999 */     // GIR_Coverage, 3941,
     /* 285999 */     GIR_EraseRootFromParent_Done,
     /* 286000 */   // Label 5540: @286000
     /* 286000 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(286068), // Rule ID 3942 //
     /* 286005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286024 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286043 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 286059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286066 */     GIR_RootConstrainSelectedInstOperands,
     /* 286067 */     // GIR_Coverage, 3942,
     /* 286067 */     GIR_EraseRootFromParent_Done,
     /* 286068 */   // Label 5541: @286068
     /* 286068 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(286084), // Rule ID 120 //
     /* 286073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286077 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 286077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 286082 */     GIR_RootConstrainSelectedInstOperands,
     /* 286083 */     // GIR_Coverage, 120,
     /* 286083 */     GIR_Done,
     /* 286084 */   // Label 5542: @286084
     /* 286084 */   GIM_Reject,
     /* 286085 */ // Label 5539: @286085
     /* 286085 */ GIM_Reject,
     /* 286086 */ // Label 5530: @286086
     /* 286086 */ GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(286230),
     /* 286091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286101 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(286165), // Rule ID 6394 //
     /* 286106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286147 */     // MIs[3] Operand 1
     /* 286147 */     // No operand predicates
     /* 286147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286149 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 286152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286158 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286163 */     GIR_RootConstrainSelectedInstOperands,
     /* 286164 */     // GIR_Coverage, 6394,
     /* 286164 */     GIR_EraseRootFromParent_Done,
     /* 286165 */   // Label 5544: @286165
     /* 286165 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(286229), // Rule ID 6391 //
     /* 286170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286207 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286211 */     // MIs[3] Operand 1
     /* 286211 */     // No operand predicates
     /* 286211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286213 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 286216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286222 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286227 */     GIR_RootConstrainSelectedInstOperands,
     /* 286228 */     // GIR_Coverage, 6391,
     /* 286228 */     GIR_EraseRootFromParent_Done,
     /* 286229 */   // Label 5545: @286229
     /* 286229 */   GIM_Reject,
     /* 286230 */ // Label 5543: @286230
     /* 286230 */ GIM_Reject,
     /* 286231 */ // Label 5531: @286231
     /* 286231 */ GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(286371),
     /* 286236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286246 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(286308), // Rule ID 6393 //
     /* 286251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286288 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286292 */     // MIs[3] Operand 1
     /* 286292 */     // No operand predicates
     /* 286292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286294 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 286297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286306 */     GIR_RootConstrainSelectedInstOperands,
     /* 286307 */     // GIR_Coverage, 6393,
     /* 286307 */     GIR_EraseRootFromParent_Done,
     /* 286308 */   // Label 5547: @286308
     /* 286308 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(286370), // Rule ID 6390 //
     /* 286313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286350 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286354 */     // MIs[3] Operand 1
     /* 286354 */     // No operand predicates
     /* 286354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286356 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 286359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286368 */     GIR_RootConstrainSelectedInstOperands,
     /* 286369 */     // GIR_Coverage, 6390,
     /* 286369 */     GIR_EraseRootFromParent_Done,
     /* 286370 */   // Label 5548: @286370
     /* 286370 */   GIM_Reject,
     /* 286371 */ // Label 5546: @286371
     /* 286371 */ GIM_Reject,
     /* 286372 */ // Label 5532: @286372
     /* 286372 */ GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(286512),
     /* 286377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286387 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(286449), // Rule ID 6392 //
     /* 286392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286429 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286433 */     // MIs[3] Operand 1
     /* 286433 */     // No operand predicates
     /* 286433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286435 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 286438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286447 */     GIR_RootConstrainSelectedInstOperands,
     /* 286448 */     // GIR_Coverage, 6392,
     /* 286448 */     GIR_EraseRootFromParent_Done,
     /* 286449 */   // Label 5550: @286449
     /* 286449 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(286511), // Rule ID 6389 //
     /* 286454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286491 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286495 */     // MIs[3] Operand 1
     /* 286495 */     // No operand predicates
     /* 286495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286497 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 286500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286509 */     GIR_RootConstrainSelectedInstOperands,
     /* 286510 */     // GIR_Coverage, 6389,
     /* 286510 */     GIR_EraseRootFromParent_Done,
     /* 286511 */   // Label 5551: @286511
     /* 286511 */   GIM_Reject,
     /* 286512 */ // Label 5549: @286512
     /* 286512 */ GIM_Reject,
     /* 286513 */ // Label 5533: @286513
     /* 286513 */ GIM_Reject,
     /* 286514 */ // Label 47: @286514
     /* 286514 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5554*/ GIMT_Encode4(287057),
     /* 286525 */ /*GILLT_s32*//*Label 5552*/ GIMT_Encode4(286533),
     /* 286529 */ /*GILLT_s64*//*Label 5553*/ GIMT_Encode4(286799),
     /* 286533 */ // Label 5552: @286533
     /* 286533 */ GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(286798),
     /* 286538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286548 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(286587), // Rule ID 4017 //
     /* 286553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286565 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top16Zero),
     /* 286570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 286574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286576 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }<<P:Predicate_top16Zero>>:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 286576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 286579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286585 */     GIR_RootConstrainSelectedInstOperands,
     /* 286586 */     // GIR_Coverage, 4017,
     /* 286586 */     GIR_EraseRootFromParent_Done,
     /* 286587 */   // Label 5556: @286587
     /* 286587 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(286625), // Rule ID 4028 //
     /* 286592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286608 */     // MIs[1] Operand 1
     /* 286608 */     // No operand predicates
     /* 286608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286610 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 286610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 286613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 286623 */     GIR_RootConstrainSelectedInstOperands,
     /* 286624 */     // GIR_Coverage, 4028,
     /* 286624 */     GIR_EraseRootFromParent_Done,
     /* 286625 */   // Label 5557: @286625
     /* 286625 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(286666), // Rule ID 3945 //
     /* 286630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 286642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286653 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286664 */     GIR_RootConstrainSelectedInstOperands,
     /* 286665 */     // GIR_Coverage, 3945,
     /* 286665 */     GIR_EraseRootFromParent_Done,
     /* 286666 */   // Label 5558: @286666
     /* 286666 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(286707), // Rule ID 3946 //
     /* 286671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286694 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286705 */     GIR_RootConstrainSelectedInstOperands,
     /* 286706 */     // GIR_Coverage, 3946,
     /* 286706 */     GIR_EraseRootFromParent_Done,
     /* 286707 */   // Label 5559: @286707
     /* 286707 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(286748), // Rule ID 3944 //
     /* 286712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286735 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286746 */     GIR_RootConstrainSelectedInstOperands,
     /* 286747 */     // GIR_Coverage, 3944,
     /* 286747 */     GIR_EraseRootFromParent_Done,
     /* 286748 */   // Label 5560: @286748
     /* 286748 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(286797), // Rule ID 3943 //
     /* 286753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286757 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 286757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286769 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 286775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286795 */     GIR_RootConstrainSelectedInstOperands,
     /* 286796 */     // GIR_Coverage, 3943,
     /* 286796 */     GIR_EraseRootFromParent_Done,
     /* 286797 */   // Label 5561: @286797
     /* 286797 */   GIM_Reject,
     /* 286798 */ // Label 5555: @286798
     /* 286798 */ GIM_Reject,
     /* 286799 */ // Label 5553: @286799
     /* 286799 */ GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(287056),
     /* 286804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286814 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(286853), // Rule ID 4018 //
     /* 286819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286831 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /* 286836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 286840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286842 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 286842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 286845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286851 */     GIR_RootConstrainSelectedInstOperands,
     /* 286852 */     // GIR_Coverage, 4018,
     /* 286852 */     GIR_EraseRootFromParent_Done,
     /* 286853 */   // Label 5563: @286853
     /* 286853 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(286891), // Rule ID 4029 //
     /* 286858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286874 */     // MIs[1] Operand 1
     /* 286874 */     // No operand predicates
     /* 286874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286876 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 286876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 286879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 286889 */     GIR_RootConstrainSelectedInstOperands,
     /* 286890 */     // GIR_Coverage, 4029,
     /* 286890 */     GIR_EraseRootFromParent_Done,
     /* 286891 */   // Label 5564: @286891
     /* 286891 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(286963), // Rule ID 3947 //
     /* 286896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286919 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 286954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286961 */     GIR_RootConstrainSelectedInstOperands,
     /* 286962 */     // GIR_Coverage, 3947,
     /* 286962 */     GIR_EraseRootFromParent_Done,
     /* 286963 */   // Label 5565: @286963
     /* 286963 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(287035), // Rule ID 3948 //
     /* 286968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286991 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 287026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287033 */     GIR_RootConstrainSelectedInstOperands,
     /* 287034 */     // GIR_Coverage, 3948,
     /* 287034 */     GIR_EraseRootFromParent_Done,
     /* 287035 */   // Label 5566: @287035
     /* 287035 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(287055), // Rule ID 121 //
     /* 287040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287048 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 287048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 287053 */     GIR_RootConstrainSelectedInstOperands,
     /* 287054 */     // GIR_Coverage, 121,
     /* 287054 */     GIR_Done,
     /* 287055 */   // Label 5567: @287055
     /* 287055 */   GIM_Reject,
     /* 287056 */ // Label 5562: @287056
     /* 287056 */ GIM_Reject,
     /* 287057 */ // Label 5554: @287057
     /* 287057 */ GIM_Reject,
     /* 287058 */ // Label 48: @287058
     /* 287058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5570*/ GIMT_Encode4(287882),
     /* 287069 */ /*GILLT_s32*//*Label 5568*/ GIMT_Encode4(287077),
     /* 287073 */ /*GILLT_s64*//*Label 5569*/ GIMT_Encode4(287432),
     /* 287077 */ // Label 5568: @287077
     /* 287077 */ GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(287431),
     /* 287082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287092 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(287156), // Rule ID 6564 //
     /* 287097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287114 */     // MIs[1] Operand 2
     /* 287114 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287133 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287137 */     // MIs[2] Operand 1
     /* 287137 */     // No operand predicates
     /* 287137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287139 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287154 */     GIR_RootConstrainSelectedInstOperands,
     /* 287155 */     // GIR_Coverage, 6564,
     /* 287155 */     GIR_EraseRootFromParent_Done,
     /* 287156 */   // Label 5572: @287156
     /* 287156 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(287220), // Rule ID 6566 //
     /* 287161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287178 */     // MIs[1] Operand 2
     /* 287178 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287201 */     // MIs[2] Operand 1
     /* 287201 */     // No operand predicates
     /* 287201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287203 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287218 */     GIR_RootConstrainSelectedInstOperands,
     /* 287219 */     // GIR_Coverage, 6566,
     /* 287219 */     GIR_EraseRootFromParent_Done,
     /* 287220 */   // Label 5573: @287220
     /* 287220 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(287258), // Rule ID 4026 //
     /* 287225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287241 */     // MIs[1] Operand 1
     /* 287241 */     // No operand predicates
     /* 287241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287243 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287256 */     GIR_RootConstrainSelectedInstOperands,
     /* 287257 */     // GIR_Coverage, 4026,
     /* 287257 */     GIR_EraseRootFromParent_Done,
     /* 287258 */   // Label 5574: @287258
     /* 287258 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(287299), // Rule ID 2438 //
     /* 287263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 287275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287286 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287297 */     GIR_RootConstrainSelectedInstOperands,
     /* 287298 */     // GIR_Coverage, 2438,
     /* 287298 */     GIR_EraseRootFromParent_Done,
     /* 287299 */   // Label 5575: @287299
     /* 287299 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(287340), // Rule ID 2439 //
     /* 287304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287327 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287338 */     GIR_RootConstrainSelectedInstOperands,
     /* 287339 */     // GIR_Coverage, 2439,
     /* 287339 */     GIR_EraseRootFromParent_Done,
     /* 287340 */   // Label 5576: @287340
     /* 287340 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(287381), // Rule ID 2437 //
     /* 287345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287368 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287379 */     GIR_RootConstrainSelectedInstOperands,
     /* 287380 */     // GIR_Coverage, 2437,
     /* 287380 */     GIR_EraseRootFromParent_Done,
     /* 287381 */   // Label 5577: @287381
     /* 287381 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(287430), // Rule ID 2436 //
     /* 287386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287390 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 287390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287402 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 287408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287428 */     GIR_RootConstrainSelectedInstOperands,
     /* 287429 */     // GIR_Coverage, 2436,
     /* 287429 */     GIR_EraseRootFromParent_Done,
     /* 287430 */   // Label 5578: @287430
     /* 287430 */   GIM_Reject,
     /* 287431 */ // Label 5571: @287431
     /* 287431 */ GIM_Reject,
     /* 287432 */ // Label 5569: @287432
     /* 287432 */ GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(287881),
     /* 287437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287447 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(287511), // Rule ID 6565 //
     /* 287452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287469 */     // MIs[1] Operand 2
     /* 287469 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287488 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287492 */     // MIs[2] Operand 1
     /* 287492 */     // No operand predicates
     /* 287492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287494 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287509 */     GIR_RootConstrainSelectedInstOperands,
     /* 287510 */     // GIR_Coverage, 6565,
     /* 287510 */     GIR_EraseRootFromParent_Done,
     /* 287511 */   // Label 5580: @287511
     /* 287511 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(287575), // Rule ID 6567 //
     /* 287516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287533 */     // MIs[1] Operand 2
     /* 287533 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287556 */     // MIs[2] Operand 1
     /* 287556 */     // No operand predicates
     /* 287556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287558 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287573 */     GIR_RootConstrainSelectedInstOperands,
     /* 287574 */     // GIR_Coverage, 6567,
     /* 287574 */     GIR_EraseRootFromParent_Done,
     /* 287575 */   // Label 5581: @287575
     /* 287575 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(287678), // Rule ID 6568 //
     /* 287580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287609 */     // MIs[2] Operand 1
     /* 287609 */     // No operand predicates
     /* 287609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287611 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 287614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 287618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 287625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 287632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287637 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 287640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287644 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287676 */     GIR_RootConstrainSelectedInstOperands,
     /* 287677 */     // GIR_Coverage, 6568,
     /* 287677 */     GIR_EraseRootFromParent_Done,
     /* 287678 */   // Label 5582: @287678
     /* 287678 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(287716), // Rule ID 4027 //
     /* 287683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 287699 */     // MIs[1] Operand 1
     /* 287699 */     // No operand predicates
     /* 287699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287701 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 287701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 287714 */     GIR_RootConstrainSelectedInstOperands,
     /* 287715 */     // GIR_Coverage, 4027,
     /* 287715 */     GIR_EraseRootFromParent_Done,
     /* 287716 */   // Label 5583: @287716
     /* 287716 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(287788), // Rule ID 2440 //
     /* 287721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287744 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287786 */     GIR_RootConstrainSelectedInstOperands,
     /* 287787 */     // GIR_Coverage, 2440,
     /* 287787 */     GIR_EraseRootFromParent_Done,
     /* 287788 */   // Label 5584: @287788
     /* 287788 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(287860), // Rule ID 2441 //
     /* 287793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287816 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287858 */     GIR_RootConstrainSelectedInstOperands,
     /* 287859 */     // GIR_Coverage, 2441,
     /* 287859 */     GIR_EraseRootFromParent_Done,
     /* 287860 */   // Label 5585: @287860
     /* 287860 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(287880), // Rule ID 119 //
     /* 287865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287873 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 287873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287878 */     GIR_RootConstrainSelectedInstOperands,
     /* 287879 */     // GIR_Coverage, 119,
     /* 287879 */     GIR_Done,
     /* 287880 */   // Label 5586: @287880
     /* 287880 */   GIM_Reject,
     /* 287881 */ // Label 5579: @287881
     /* 287881 */ GIM_Reject,
     /* 287882 */ // Label 5570: @287882
     /* 287882 */ GIM_Reject,
     /* 287883 */ // Label 49: @287883
     /* 287883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5589*/ GIMT_Encode4(288012),
     /* 287894 */ /*GILLT_s32*//*Label 5587*/ GIMT_Encode4(287902),
     /* 287898 */ /*GILLT_s64*//*Label 5588*/ GIMT_Encode4(287957),
     /* 287902 */ // Label 5587: @287902
     /* 287902 */ GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(287956), // Rule ID 188 //
     /* 287907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 287913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 287916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287928 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287932 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287936 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287940 */   // MIs[1] Operand 1
     /* 287940 */   // No operand predicates
     /* 287940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287942 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 287942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 287945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287947 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287949 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287951 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287954 */   GIR_RootConstrainSelectedInstOperands,
     /* 287955 */   // GIR_Coverage, 188,
     /* 287955 */   GIR_EraseRootFromParent_Done,
     /* 287956 */ // Label 5590: @287956
     /* 287956 */ GIM_Reject,
     /* 287957 */ // Label 5588: @287957
     /* 287957 */ GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(288011), // Rule ID 189 //
     /* 287962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 287971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287983 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287991 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 287995 */   // MIs[1] Operand 1
     /* 287995 */   // No operand predicates
     /* 287995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287997 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 287997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 288000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288002 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288004 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288006 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288009 */   GIR_RootConstrainSelectedInstOperands,
     /* 288010 */   // GIR_Coverage, 189,
     /* 288010 */   GIR_EraseRootFromParent_Done,
     /* 288011 */ // Label 5591: @288011
     /* 288011 */ GIM_Reject,
     /* 288012 */ // Label 5589: @288012
     /* 288012 */ GIM_Reject,
     /* 288013 */ // Label 50: @288013
     /* 288013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5594*/ GIMT_Encode4(288554),
     /* 288024 */ /*GILLT_s32*//*Label 5592*/ GIMT_Encode4(288032),
     /* 288028 */ /*GILLT_s64*//*Label 5593*/ GIMT_Encode4(288297),
     /* 288032 */ // Label 5592: @288032
     /* 288032 */ GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(288296),
     /* 288037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288047 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(288086), // Rule ID 184 //
     /* 288052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 288060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 288073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288075 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 288075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 288078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288084 */     GIR_RootConstrainSelectedInstOperands,
     /* 288085 */     // GIR_Coverage, 184,
     /* 288085 */     GIR_EraseRootFromParent_Done,
     /* 288086 */   // Label 5596: @288086
     /* 288086 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(288123), // Rule ID 4022 //
     /* 288091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288107 */     // MIs[1] Operand 1
     /* 288107 */     // No operand predicates
     /* 288107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288109 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 288109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 288112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288121 */     GIR_RootConstrainSelectedInstOperands,
     /* 288122 */     // GIR_Coverage, 4022,
     /* 288122 */     GIR_EraseRootFromParent_Done,
     /* 288123 */   // Label 5597: @288123
     /* 288123 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(288164), // Rule ID 3951 //
     /* 288128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 288140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288151 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288162 */     GIR_RootConstrainSelectedInstOperands,
     /* 288163 */     // GIR_Coverage, 3951,
     /* 288163 */     GIR_EraseRootFromParent_Done,
     /* 288164 */   // Label 5598: @288164
     /* 288164 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(288205), // Rule ID 3952 //
     /* 288169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288192 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288203 */     GIR_RootConstrainSelectedInstOperands,
     /* 288204 */     // GIR_Coverage, 3952,
     /* 288204 */     GIR_EraseRootFromParent_Done,
     /* 288205 */   // Label 5599: @288205
     /* 288205 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(288246), // Rule ID 3950 //
     /* 288210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288233 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288244 */     GIR_RootConstrainSelectedInstOperands,
     /* 288245 */     // GIR_Coverage, 3950,
     /* 288245 */     GIR_EraseRootFromParent_Done,
     /* 288246 */   // Label 5600: @288246
     /* 288246 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(288295), // Rule ID 3949 //
     /* 288251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288255 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 288255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288267 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 288273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288293 */     GIR_RootConstrainSelectedInstOperands,
     /* 288294 */     // GIR_Coverage, 3949,
     /* 288294 */     GIR_EraseRootFromParent_Done,
     /* 288295 */   // Label 5601: @288295
     /* 288295 */   GIM_Reject,
     /* 288296 */ // Label 5595: @288296
     /* 288296 */ GIM_Reject,
     /* 288297 */ // Label 5593: @288297
     /* 288297 */ GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(288553),
     /* 288302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288312 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(288351), // Rule ID 187 //
     /* 288317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 288325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 288338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288340 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 288340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 288343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288349 */     GIR_RootConstrainSelectedInstOperands,
     /* 288350 */     // GIR_Coverage, 187,
     /* 288350 */     GIR_EraseRootFromParent_Done,
     /* 288351 */   // Label 5603: @288351
     /* 288351 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(288388), // Rule ID 4023 //
     /* 288356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 288372 */     // MIs[1] Operand 1
     /* 288372 */     // No operand predicates
     /* 288372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288374 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 288374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 288377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288386 */     GIR_RootConstrainSelectedInstOperands,
     /* 288387 */     // GIR_Coverage, 4023,
     /* 288387 */     GIR_EraseRootFromParent_Done,
     /* 288388 */   // Label 5604: @288388
     /* 288388 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(288460), // Rule ID 3953 //
     /* 288393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288416 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288458 */     GIR_RootConstrainSelectedInstOperands,
     /* 288459 */     // GIR_Coverage, 3953,
     /* 288459 */     GIR_EraseRootFromParent_Done,
     /* 288460 */   // Label 5605: @288460
     /* 288460 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(288532), // Rule ID 3954 //
     /* 288465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288488 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288530 */     GIR_RootConstrainSelectedInstOperands,
     /* 288531 */     // GIR_Coverage, 3954,
     /* 288531 */     GIR_EraseRootFromParent_Done,
     /* 288532 */   // Label 5606: @288532
     /* 288532 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(288552), // Rule ID 122 //
     /* 288537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288545 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 288545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288550 */     GIR_RootConstrainSelectedInstOperands,
     /* 288551 */     // GIR_Coverage, 122,
     /* 288551 */     GIR_Done,
     /* 288552 */   // Label 5607: @288552
     /* 288552 */   GIM_Reject,
     /* 288553 */ // Label 5602: @288553
     /* 288553 */ GIM_Reject,
     /* 288554 */ // Label 5594: @288554
     /* 288554 */ GIM_Reject,
     /* 288555 */ // Label 51: @288555
     /* 288555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5616*/ GIMT_Encode4(296331),
     /* 288566 */ /*GILLT_s64*//*Label 5608*/ GIMT_Encode4(288602), GIMT_Encode4(0),
     /* 288574 */ /*GILLT_v2s32*//*Label 5609*/ GIMT_Encode4(288995),
     /* 288578 */ /*GILLT_v2s64*//*Label 5610*/ GIMT_Encode4(290043),
     /* 288582 */ /*GILLT_v4s16*//*Label 5611*/ GIMT_Encode4(291091),
     /* 288586 */ /*GILLT_v4s32*//*Label 5612*/ GIMT_Encode4(292139),
     /* 288590 */ /*GILLT_v8s8*//*Label 5613*/ GIMT_Encode4(293187),
     /* 288594 */ /*GILLT_v8s16*//*Label 5614*/ GIMT_Encode4(294235),
     /* 288598 */ /*GILLT_v16s8*//*Label 5615*/ GIMT_Encode4(295283),
     /* 288602 */ // Label 5608: @288602
     /* 288602 */ GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(288994),
     /* 288607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 288613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288617 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(288653), // Rule ID 5261 //
     /* 288622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288625 */     // MIs[0] Operand 1
     /* 288625 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288644 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 288647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288651 */     GIR_RootConstrainSelectedInstOperands,
     /* 288652 */     // GIR_Coverage, 5261,
     /* 288652 */     GIR_EraseRootFromParent_Done,
     /* 288653 */   // Label 5618: @288653
     /* 288653 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(288689), // Rule ID 5262 //
     /* 288658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288661 */     // MIs[0] Operand 1
     /* 288661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288670 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288676 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288680 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 288683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288687 */     GIR_RootConstrainSelectedInstOperands,
     /* 288688 */     // GIR_Coverage, 5262,
     /* 288688 */     GIR_EraseRootFromParent_Done,
     /* 288689 */   // Label 5619: @288689
     /* 288689 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(288725), // Rule ID 2508 //
     /* 288694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288697 */     // MIs[0] Operand 1
     /* 288697 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288706 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288712 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288716 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 288719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288723 */     GIR_RootConstrainSelectedInstOperands,
     /* 288724 */     // GIR_Coverage, 2508,
     /* 288724 */     GIR_EraseRootFromParent_Done,
     /* 288725 */   // Label 5620: @288725
     /* 288725 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(288761), // Rule ID 5258 //
     /* 288730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288733 */     // MIs[0] Operand 1
     /* 288733 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288742 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288748 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288752 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 288755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288759 */     GIR_RootConstrainSelectedInstOperands,
     /* 288760 */     // GIR_Coverage, 5258,
     /* 288760 */     GIR_EraseRootFromParent_Done,
     /* 288761 */   // Label 5621: @288761
     /* 288761 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(288797), // Rule ID 5259 //
     /* 288766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288769 */     // MIs[0] Operand 1
     /* 288769 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288778 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 288786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288788 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 288791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288795 */     GIR_RootConstrainSelectedInstOperands,
     /* 288796 */     // GIR_Coverage, 5259,
     /* 288796 */     GIR_EraseRootFromParent_Done,
     /* 288797 */   // Label 5622: @288797
     /* 288797 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(288833), // Rule ID 5260 //
     /* 288802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288805 */     // MIs[0] Operand 1
     /* 288805 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288814 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288820 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288824 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 288827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288831 */     GIR_RootConstrainSelectedInstOperands,
     /* 288832 */     // GIR_Coverage, 5260,
     /* 288832 */     GIR_EraseRootFromParent_Done,
     /* 288833 */   // Label 5623: @288833
     /* 288833 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(288865), // Rule ID 1608 //
     /* 288838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288841 */     // MIs[0] Operand 1
     /* 288841 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288854 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 288857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288863 */     GIR_RootConstrainSelectedInstOperands,
     /* 288864 */     // GIR_Coverage, 1608,
     /* 288864 */     GIR_EraseRootFromParent_Done,
     /* 288865 */   // Label 5624: @288865
     /* 288865 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(288897), // Rule ID 1609 //
     /* 288870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288873 */     // MIs[0] Operand 1
     /* 288873 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288886 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 288889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288895 */     GIR_RootConstrainSelectedInstOperands,
     /* 288896 */     // GIR_Coverage, 1609,
     /* 288896 */     GIR_EraseRootFromParent_Done,
     /* 288897 */   // Label 5625: @288897
     /* 288897 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(288929), // Rule ID 1610 //
     /* 288902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288905 */     // MIs[0] Operand 1
     /* 288905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288918 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 288921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288927 */     GIR_RootConstrainSelectedInstOperands,
     /* 288928 */     // GIR_Coverage, 1610,
     /* 288928 */     GIR_EraseRootFromParent_Done,
     /* 288929 */   // Label 5626: @288929
     /* 288929 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(288961), // Rule ID 1611 //
     /* 288934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288937 */     // MIs[0] Operand 1
     /* 288937 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 288942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288950 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 288953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288959 */     GIR_RootConstrainSelectedInstOperands,
     /* 288960 */     // GIR_Coverage, 1611,
     /* 288960 */     GIR_EraseRootFromParent_Done,
     /* 288961 */   // Label 5627: @288961
     /* 288961 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(288993), // Rule ID 1612 //
     /* 288966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288969 */     // MIs[0] Operand 1
     /* 288969 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 288974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288982 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 288985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288991 */     GIR_RootConstrainSelectedInstOperands,
     /* 288992 */     // GIR_Coverage, 1612,
     /* 288992 */     GIR_EraseRootFromParent_Done,
     /* 288993 */   // Label 5628: @288993
     /* 288993 */   GIM_Reject,
     /* 288994 */ // Label 5617: @288994
     /* 288994 */ GIM_Reject,
     /* 288995 */ // Label 5609: @288995
     /* 288995 */ GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(290042),
     /* 289000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 289003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 289006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289010 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(289050), // Rule ID 754 //
     /* 289015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289018 */     // MIs[0] Operand 1
     /* 289018 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289027 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289033 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289041 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289048 */     GIR_RootConstrainSelectedInstOperands,
     /* 289049 */     // GIR_Coverage, 754,
     /* 289049 */     GIR_EraseRootFromParent_Done,
     /* 289050 */   // Label 5630: @289050
     /* 289050 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(289090), // Rule ID 761 //
     /* 289055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289058 */     // MIs[0] Operand 1
     /* 289058 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289081 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289088 */     GIR_RootConstrainSelectedInstOperands,
     /* 289089 */     // GIR_Coverage, 761,
     /* 289089 */     GIR_EraseRootFromParent_Done,
     /* 289090 */   // Label 5631: @289090
     /* 289090 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(289127), // Rule ID 5195 //
     /* 289095 */     // MIs[0] Operand 1
     /* 289095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289104 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289110 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289118 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289125 */     GIR_RootConstrainSelectedInstOperands,
     /* 289126 */     // GIR_Coverage, 5195,
     /* 289126 */     GIR_EraseRootFromParent_Done,
     /* 289127 */   // Label 5632: @289127
     /* 289127 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(289164), // Rule ID 5202 //
     /* 289132 */     // MIs[0] Operand 1
     /* 289132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289155 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289162 */     GIR_RootConstrainSelectedInstOperands,
     /* 289163 */     // GIR_Coverage, 5202,
     /* 289163 */     GIR_EraseRootFromParent_Done,
     /* 289164 */   // Label 5633: @289164
     /* 289164 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(289201), // Rule ID 5209 //
     /* 289169 */     // MIs[0] Operand 1
     /* 289169 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289178 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289184 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289192 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289199 */     GIR_RootConstrainSelectedInstOperands,
     /* 289200 */     // GIR_Coverage, 5209,
     /* 289200 */     GIR_EraseRootFromParent_Done,
     /* 289201 */   // Label 5634: @289201
     /* 289201 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(289238), // Rule ID 5216 //
     /* 289206 */     // MIs[0] Operand 1
     /* 289206 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289221 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289229 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289236 */     GIR_RootConstrainSelectedInstOperands,
     /* 289237 */     // GIR_Coverage, 5216,
     /* 289237 */     GIR_EraseRootFromParent_Done,
     /* 289238 */   // Label 5635: @289238
     /* 289238 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(289275), // Rule ID 5223 //
     /* 289243 */     // MIs[0] Operand 1
     /* 289243 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289266 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289273 */     GIR_RootConstrainSelectedInstOperands,
     /* 289274 */     // GIR_Coverage, 5223,
     /* 289274 */     GIR_EraseRootFromParent_Done,
     /* 289275 */   // Label 5636: @289275
     /* 289275 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(289315), // Rule ID 726 //
     /* 289280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289283 */     // MIs[0] Operand 1
     /* 289283 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289296 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289302 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289306 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289313 */     GIR_RootConstrainSelectedInstOperands,
     /* 289314 */     // GIR_Coverage, 726,
     /* 289314 */     GIR_EraseRootFromParent_Done,
     /* 289315 */   // Label 5637: @289315
     /* 289315 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(289355), // Rule ID 737 //
     /* 289320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289323 */     // MIs[0] Operand 1
     /* 289323 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289346 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289353 */     GIR_RootConstrainSelectedInstOperands,
     /* 289354 */     // GIR_Coverage, 737,
     /* 289354 */     GIR_EraseRootFromParent_Done,
     /* 289355 */   // Label 5638: @289355
     /* 289355 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(289395), // Rule ID 738 //
     /* 289360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289363 */     // MIs[0] Operand 1
     /* 289363 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289376 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289382 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 289384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289386 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289393 */     GIR_RootConstrainSelectedInstOperands,
     /* 289394 */     // GIR_Coverage, 738,
     /* 289394 */     GIR_EraseRootFromParent_Done,
     /* 289395 */   // Label 5639: @289395
     /* 289395 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(289435), // Rule ID 747 //
     /* 289400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289403 */     // MIs[0] Operand 1
     /* 289403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289416 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289422 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289426 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289433 */     GIR_RootConstrainSelectedInstOperands,
     /* 289434 */     // GIR_Coverage, 747,
     /* 289434 */     GIR_EraseRootFromParent_Done,
     /* 289435 */   // Label 5640: @289435
     /* 289435 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(289472), // Rule ID 5160 //
     /* 289440 */     // MIs[0] Operand 1
     /* 289440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289463 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289470 */     GIR_RootConstrainSelectedInstOperands,
     /* 289471 */     // GIR_Coverage, 5160,
     /* 289471 */     GIR_EraseRootFromParent_Done,
     /* 289472 */   // Label 5641: @289472
     /* 289472 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(289509), // Rule ID 5167 //
     /* 289477 */     // MIs[0] Operand 1
     /* 289477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289500 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289507 */     GIR_RootConstrainSelectedInstOperands,
     /* 289508 */     // GIR_Coverage, 5167,
     /* 289508 */     GIR_EraseRootFromParent_Done,
     /* 289509 */   // Label 5642: @289509
     /* 289509 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(289546), // Rule ID 5174 //
     /* 289514 */     // MIs[0] Operand 1
     /* 289514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289527 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289533 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289537 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289544 */     GIR_RootConstrainSelectedInstOperands,
     /* 289545 */     // GIR_Coverage, 5174,
     /* 289545 */     GIR_EraseRootFromParent_Done,
     /* 289546 */   // Label 5643: @289546
     /* 289546 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(289583), // Rule ID 5181 //
     /* 289551 */     // MIs[0] Operand 1
     /* 289551 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289570 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289574 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289581 */     GIR_RootConstrainSelectedInstOperands,
     /* 289582 */     // GIR_Coverage, 5181,
     /* 289582 */     GIR_EraseRootFromParent_Done,
     /* 289583 */   // Label 5644: @289583
     /* 289583 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(289620), // Rule ID 5188 //
     /* 289588 */     // MIs[0] Operand 1
     /* 289588 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289601 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289607 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289611 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289618 */     GIR_RootConstrainSelectedInstOperands,
     /* 289619 */     // GIR_Coverage, 5188,
     /* 289619 */     GIR_EraseRootFromParent_Done,
     /* 289620 */   // Label 5645: @289620
     /* 289620 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(289652), // Rule ID 1125 //
     /* 289625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289628 */     // MIs[0] Operand 1
     /* 289628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289641 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 289644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289650 */     GIR_RootConstrainSelectedInstOperands,
     /* 289651 */     // GIR_Coverage, 1125,
     /* 289651 */     GIR_EraseRootFromParent_Done,
     /* 289652 */   // Label 5646: @289652
     /* 289652 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(289684), // Rule ID 1132 //
     /* 289657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289660 */     // MIs[0] Operand 1
     /* 289660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289673 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289682 */     GIR_RootConstrainSelectedInstOperands,
     /* 289683 */     // GIR_Coverage, 1132,
     /* 289683 */     GIR_EraseRootFromParent_Done,
     /* 289684 */   // Label 5647: @289684
     /* 289684 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(289716), // Rule ID 1139 //
     /* 289689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289692 */     // MIs[0] Operand 1
     /* 289692 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289705 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289714 */     GIR_RootConstrainSelectedInstOperands,
     /* 289715 */     // GIR_Coverage, 1139,
     /* 289715 */     GIR_EraseRootFromParent_Done,
     /* 289716 */   // Label 5648: @289716
     /* 289716 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(289748), // Rule ID 1146 //
     /* 289721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289724 */     // MIs[0] Operand 1
     /* 289724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289737 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 289740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289746 */     GIR_RootConstrainSelectedInstOperands,
     /* 289747 */     // GIR_Coverage, 1146,
     /* 289747 */     GIR_EraseRootFromParent_Done,
     /* 289748 */   // Label 5649: @289748
     /* 289748 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(289780), // Rule ID 1153 //
     /* 289753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289756 */     // MIs[0] Operand 1
     /* 289756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289769 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 289772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289778 */     GIR_RootConstrainSelectedInstOperands,
     /* 289779 */     // GIR_Coverage, 1153,
     /* 289779 */     GIR_EraseRootFromParent_Done,
     /* 289780 */   // Label 5650: @289780
     /* 289780 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(289809), // Rule ID 5097 //
     /* 289785 */     // MIs[0] Operand 1
     /* 289785 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289798 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 289801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289807 */     GIR_RootConstrainSelectedInstOperands,
     /* 289808 */     // GIR_Coverage, 5097,
     /* 289808 */     GIR_EraseRootFromParent_Done,
     /* 289809 */   // Label 5651: @289809
     /* 289809 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(289838), // Rule ID 5104 //
     /* 289814 */     // MIs[0] Operand 1
     /* 289814 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289827 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289836 */     GIR_RootConstrainSelectedInstOperands,
     /* 289837 */     // GIR_Coverage, 5104,
     /* 289837 */     GIR_EraseRootFromParent_Done,
     /* 289838 */   // Label 5652: @289838
     /* 289838 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(289867), // Rule ID 5111 //
     /* 289843 */     // MIs[0] Operand 1
     /* 289843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289856 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289865 */     GIR_RootConstrainSelectedInstOperands,
     /* 289866 */     // GIR_Coverage, 5111,
     /* 289866 */     GIR_EraseRootFromParent_Done,
     /* 289867 */   // Label 5653: @289867
     /* 289867 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(289896), // Rule ID 5118 //
     /* 289872 */     // MIs[0] Operand 1
     /* 289872 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289885 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 289888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289894 */     GIR_RootConstrainSelectedInstOperands,
     /* 289895 */     // GIR_Coverage, 5118,
     /* 289895 */     GIR_EraseRootFromParent_Done,
     /* 289896 */   // Label 5654: @289896
     /* 289896 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(289925), // Rule ID 5125 //
     /* 289901 */     // MIs[0] Operand 1
     /* 289901 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289914 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 289917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289923 */     GIR_RootConstrainSelectedInstOperands,
     /* 289924 */     // GIR_Coverage, 5125,
     /* 289924 */     GIR_EraseRootFromParent_Done,
     /* 289925 */   // Label 5655: @289925
     /* 289925 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(289954), // Rule ID 5132 //
     /* 289930 */     // MIs[0] Operand 1
     /* 289930 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289943 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289952 */     GIR_RootConstrainSelectedInstOperands,
     /* 289953 */     // GIR_Coverage, 5132,
     /* 289953 */     GIR_EraseRootFromParent_Done,
     /* 289954 */   // Label 5656: @289954
     /* 289954 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(289983), // Rule ID 5139 //
     /* 289959 */     // MIs[0] Operand 1
     /* 289959 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289972 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289981 */     GIR_RootConstrainSelectedInstOperands,
     /* 289982 */     // GIR_Coverage, 5139,
     /* 289982 */     GIR_EraseRootFromParent_Done,
     /* 289983 */   // Label 5657: @289983
     /* 289983 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(290012), // Rule ID 5146 //
     /* 289988 */     // MIs[0] Operand 1
     /* 289988 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 289993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290001 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 290004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290010 */     GIR_RootConstrainSelectedInstOperands,
     /* 290011 */     // GIR_Coverage, 5146,
     /* 290011 */     GIR_EraseRootFromParent_Done,
     /* 290012 */   // Label 5658: @290012
     /* 290012 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(290041), // Rule ID 5153 //
     /* 290017 */     // MIs[0] Operand 1
     /* 290017 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290030 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 290033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290039 */     GIR_RootConstrainSelectedInstOperands,
     /* 290040 */     // GIR_Coverage, 5153,
     /* 290040 */     GIR_EraseRootFromParent_Done,
     /* 290041 */   // Label 5659: @290041
     /* 290041 */   GIM_Reject,
     /* 290042 */ // Label 5629: @290042
     /* 290042 */ GIM_Reject,
     /* 290043 */ // Label 5610: @290043
     /* 290043 */ GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(291090),
     /* 290048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 290051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 290054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290058 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(290098), // Rule ID 756 //
     /* 290063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290066 */     // MIs[0] Operand 1
     /* 290066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290089 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290096 */     GIR_RootConstrainSelectedInstOperands,
     /* 290097 */     // GIR_Coverage, 756,
     /* 290097 */     GIR_EraseRootFromParent_Done,
     /* 290098 */   // Label 5661: @290098
     /* 290098 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(290138), // Rule ID 763 //
     /* 290103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290106 */     // MIs[0] Operand 1
     /* 290106 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290115 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290121 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290129 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290136 */     GIR_RootConstrainSelectedInstOperands,
     /* 290137 */     // GIR_Coverage, 763,
     /* 290137 */     GIR_EraseRootFromParent_Done,
     /* 290138 */   // Label 5662: @290138
     /* 290138 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(290175), // Rule ID 5197 //
     /* 290143 */     // MIs[0] Operand 1
     /* 290143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290166 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290173 */     GIR_RootConstrainSelectedInstOperands,
     /* 290174 */     // GIR_Coverage, 5197,
     /* 290174 */     GIR_EraseRootFromParent_Done,
     /* 290175 */   // Label 5663: @290175
     /* 290175 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(290212), // Rule ID 5204 //
     /* 290180 */     // MIs[0] Operand 1
     /* 290180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290203 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290210 */     GIR_RootConstrainSelectedInstOperands,
     /* 290211 */     // GIR_Coverage, 5204,
     /* 290211 */     GIR_EraseRootFromParent_Done,
     /* 290212 */   // Label 5664: @290212
     /* 290212 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(290249), // Rule ID 5211 //
     /* 290217 */     // MIs[0] Operand 1
     /* 290217 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290226 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290232 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290240 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290247 */     GIR_RootConstrainSelectedInstOperands,
     /* 290248 */     // GIR_Coverage, 5211,
     /* 290248 */     GIR_EraseRootFromParent_Done,
     /* 290249 */   // Label 5665: @290249
     /* 290249 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(290286), // Rule ID 5218 //
     /* 290254 */     // MIs[0] Operand 1
     /* 290254 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290269 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290277 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290284 */     GIR_RootConstrainSelectedInstOperands,
     /* 290285 */     // GIR_Coverage, 5218,
     /* 290285 */     GIR_EraseRootFromParent_Done,
     /* 290286 */   // Label 5666: @290286
     /* 290286 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(290323), // Rule ID 5225 //
     /* 290291 */     // MIs[0] Operand 1
     /* 290291 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290300 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290306 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290314 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290321 */     GIR_RootConstrainSelectedInstOperands,
     /* 290322 */     // GIR_Coverage, 5225,
     /* 290322 */     GIR_EraseRootFromParent_Done,
     /* 290323 */   // Label 5667: @290323
     /* 290323 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(290363), // Rule ID 728 //
     /* 290328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290331 */     // MIs[0] Operand 1
     /* 290331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290354 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290361 */     GIR_RootConstrainSelectedInstOperands,
     /* 290362 */     // GIR_Coverage, 728,
     /* 290362 */     GIR_EraseRootFromParent_Done,
     /* 290363 */   // Label 5668: @290363
     /* 290363 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(290403), // Rule ID 741 //
     /* 290368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290371 */     // MIs[0] Operand 1
     /* 290371 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290384 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290390 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290394 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290401 */     GIR_RootConstrainSelectedInstOperands,
     /* 290402 */     // GIR_Coverage, 741,
     /* 290402 */     GIR_EraseRootFromParent_Done,
     /* 290403 */   // Label 5669: @290403
     /* 290403 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(290443), // Rule ID 742 //
     /* 290408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290411 */     // MIs[0] Operand 1
     /* 290411 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290434 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290441 */     GIR_RootConstrainSelectedInstOperands,
     /* 290442 */     // GIR_Coverage, 742,
     /* 290442 */     GIR_EraseRootFromParent_Done,
     /* 290443 */   // Label 5670: @290443
     /* 290443 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(290483), // Rule ID 749 //
     /* 290448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290451 */     // MIs[0] Operand 1
     /* 290451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290474 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290481 */     GIR_RootConstrainSelectedInstOperands,
     /* 290482 */     // GIR_Coverage, 749,
     /* 290482 */     GIR_EraseRootFromParent_Done,
     /* 290483 */   // Label 5671: @290483
     /* 290483 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(290520), // Rule ID 5162 //
     /* 290488 */     // MIs[0] Operand 1
     /* 290488 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290511 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290518 */     GIR_RootConstrainSelectedInstOperands,
     /* 290519 */     // GIR_Coverage, 5162,
     /* 290519 */     GIR_EraseRootFromParent_Done,
     /* 290520 */   // Label 5672: @290520
     /* 290520 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(290557), // Rule ID 5169 //
     /* 290525 */     // MIs[0] Operand 1
     /* 290525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290548 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290555 */     GIR_RootConstrainSelectedInstOperands,
     /* 290556 */     // GIR_Coverage, 5169,
     /* 290556 */     GIR_EraseRootFromParent_Done,
     /* 290557 */   // Label 5673: @290557
     /* 290557 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(290594), // Rule ID 5176 //
     /* 290562 */     // MIs[0] Operand 1
     /* 290562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290575 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290581 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290585 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290592 */     GIR_RootConstrainSelectedInstOperands,
     /* 290593 */     // GIR_Coverage, 5176,
     /* 290593 */     GIR_EraseRootFromParent_Done,
     /* 290594 */   // Label 5674: @290594
     /* 290594 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(290631), // Rule ID 5183 //
     /* 290599 */     // MIs[0] Operand 1
     /* 290599 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290612 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290622 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290629 */     GIR_RootConstrainSelectedInstOperands,
     /* 290630 */     // GIR_Coverage, 5183,
     /* 290630 */     GIR_EraseRootFromParent_Done,
     /* 290631 */   // Label 5675: @290631
     /* 290631 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(290668), // Rule ID 5190 //
     /* 290636 */     // MIs[0] Operand 1
     /* 290636 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290649 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290655 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290659 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290666 */     GIR_RootConstrainSelectedInstOperands,
     /* 290667 */     // GIR_Coverage, 5190,
     /* 290667 */     GIR_EraseRootFromParent_Done,
     /* 290668 */   // Label 5676: @290668
     /* 290668 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(290700), // Rule ID 1127 //
     /* 290673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290676 */     // MIs[0] Operand 1
     /* 290676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290689 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 290692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290698 */     GIR_RootConstrainSelectedInstOperands,
     /* 290699 */     // GIR_Coverage, 1127,
     /* 290699 */     GIR_EraseRootFromParent_Done,
     /* 290700 */   // Label 5677: @290700
     /* 290700 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(290732), // Rule ID 1134 //
     /* 290705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290708 */     // MIs[0] Operand 1
     /* 290708 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290721 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 290724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290730 */     GIR_RootConstrainSelectedInstOperands,
     /* 290731 */     // GIR_Coverage, 1134,
     /* 290731 */     GIR_EraseRootFromParent_Done,
     /* 290732 */   // Label 5678: @290732
     /* 290732 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(290764), // Rule ID 1141 //
     /* 290737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290740 */     // MIs[0] Operand 1
     /* 290740 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290753 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290762 */     GIR_RootConstrainSelectedInstOperands,
     /* 290763 */     // GIR_Coverage, 1141,
     /* 290763 */     GIR_EraseRootFromParent_Done,
     /* 290764 */   // Label 5679: @290764
     /* 290764 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(290796), // Rule ID 1148 //
     /* 290769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290772 */     // MIs[0] Operand 1
     /* 290772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290785 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 290788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290794 */     GIR_RootConstrainSelectedInstOperands,
     /* 290795 */     // GIR_Coverage, 1148,
     /* 290795 */     GIR_EraseRootFromParent_Done,
     /* 290796 */   // Label 5680: @290796
     /* 290796 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(290828), // Rule ID 1155 //
     /* 290801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290804 */     // MIs[0] Operand 1
     /* 290804 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290817 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 290820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290826 */     GIR_RootConstrainSelectedInstOperands,
     /* 290827 */     // GIR_Coverage, 1155,
     /* 290827 */     GIR_EraseRootFromParent_Done,
     /* 290828 */   // Label 5681: @290828
     /* 290828 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(290857), // Rule ID 5099 //
     /* 290833 */     // MIs[0] Operand 1
     /* 290833 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290846 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 290849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290855 */     GIR_RootConstrainSelectedInstOperands,
     /* 290856 */     // GIR_Coverage, 5099,
     /* 290856 */     GIR_EraseRootFromParent_Done,
     /* 290857 */   // Label 5682: @290857
     /* 290857 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(290886), // Rule ID 5106 //
     /* 290862 */     // MIs[0] Operand 1
     /* 290862 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290875 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290884 */     GIR_RootConstrainSelectedInstOperands,
     /* 290885 */     // GIR_Coverage, 5106,
     /* 290885 */     GIR_EraseRootFromParent_Done,
     /* 290886 */   // Label 5683: @290886
     /* 290886 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(290915), // Rule ID 5113 //
     /* 290891 */     // MIs[0] Operand 1
     /* 290891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290904 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 290907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290913 */     GIR_RootConstrainSelectedInstOperands,
     /* 290914 */     // GIR_Coverage, 5113,
     /* 290914 */     GIR_EraseRootFromParent_Done,
     /* 290915 */   // Label 5684: @290915
     /* 290915 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(290944), // Rule ID 5120 //
     /* 290920 */     // MIs[0] Operand 1
     /* 290920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290933 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 290936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290942 */     GIR_RootConstrainSelectedInstOperands,
     /* 290943 */     // GIR_Coverage, 5120,
     /* 290943 */     GIR_EraseRootFromParent_Done,
     /* 290944 */   // Label 5685: @290944
     /* 290944 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(290973), // Rule ID 5127 //
     /* 290949 */     // MIs[0] Operand 1
     /* 290949 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290962 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 290965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290971 */     GIR_RootConstrainSelectedInstOperands,
     /* 290972 */     // GIR_Coverage, 5127,
     /* 290972 */     GIR_EraseRootFromParent_Done,
     /* 290973 */   // Label 5686: @290973
     /* 290973 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(291002), // Rule ID 5134 //
     /* 290978 */     // MIs[0] Operand 1
     /* 290978 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290991 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 290991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291000 */     GIR_RootConstrainSelectedInstOperands,
     /* 291001 */     // GIR_Coverage, 5134,
     /* 291001 */     GIR_EraseRootFromParent_Done,
     /* 291002 */   // Label 5687: @291002
     /* 291002 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(291031), // Rule ID 5141 //
     /* 291007 */     // MIs[0] Operand 1
     /* 291007 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291020 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 291023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291029 */     GIR_RootConstrainSelectedInstOperands,
     /* 291030 */     // GIR_Coverage, 5141,
     /* 291030 */     GIR_EraseRootFromParent_Done,
     /* 291031 */   // Label 5688: @291031
     /* 291031 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(291060), // Rule ID 5148 //
     /* 291036 */     // MIs[0] Operand 1
     /* 291036 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 291041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291049 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 291052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291058 */     GIR_RootConstrainSelectedInstOperands,
     /* 291059 */     // GIR_Coverage, 5148,
     /* 291059 */     GIR_EraseRootFromParent_Done,
     /* 291060 */   // Label 5689: @291060
     /* 291060 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(291089), // Rule ID 5155 //
     /* 291065 */     // MIs[0] Operand 1
     /* 291065 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 291070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291078 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 291081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291087 */     GIR_RootConstrainSelectedInstOperands,
     /* 291088 */     // GIR_Coverage, 5155,
     /* 291088 */     GIR_EraseRootFromParent_Done,
     /* 291089 */   // Label 5690: @291089
     /* 291089 */   GIM_Reject,
     /* 291090 */ // Label 5660: @291090
     /* 291090 */ GIM_Reject,
     /* 291091 */ // Label 5611: @291091
     /* 291091 */ GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(292138),
     /* 291096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 291102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291106 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(291146), // Rule ID 752 //
     /* 291111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291114 */     // MIs[0] Operand 1
     /* 291114 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291123 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291129 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291137 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291144 */     GIR_RootConstrainSelectedInstOperands,
     /* 291145 */     // GIR_Coverage, 752,
     /* 291145 */     GIR_EraseRootFromParent_Done,
     /* 291146 */   // Label 5692: @291146
     /* 291146 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(291186), // Rule ID 759 //
     /* 291151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291154 */     // MIs[0] Operand 1
     /* 291154 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291163 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291169 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291177 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291184 */     GIR_RootConstrainSelectedInstOperands,
     /* 291185 */     // GIR_Coverage, 759,
     /* 291185 */     GIR_EraseRootFromParent_Done,
     /* 291186 */   // Label 5693: @291186
     /* 291186 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(291223), // Rule ID 5193 //
     /* 291191 */     // MIs[0] Operand 1
     /* 291191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291214 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291221 */     GIR_RootConstrainSelectedInstOperands,
     /* 291222 */     // GIR_Coverage, 5193,
     /* 291222 */     GIR_EraseRootFromParent_Done,
     /* 291223 */   // Label 5694: @291223
     /* 291223 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(291260), // Rule ID 5200 //
     /* 291228 */     // MIs[0] Operand 1
     /* 291228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291237 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291243 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291251 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291258 */     GIR_RootConstrainSelectedInstOperands,
     /* 291259 */     // GIR_Coverage, 5200,
     /* 291259 */     GIR_EraseRootFromParent_Done,
     /* 291260 */   // Label 5695: @291260
     /* 291260 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(291297), // Rule ID 5207 //
     /* 291265 */     // MIs[0] Operand 1
     /* 291265 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291274 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291280 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291288 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291295 */     GIR_RootConstrainSelectedInstOperands,
     /* 291296 */     // GIR_Coverage, 5207,
     /* 291296 */     GIR_EraseRootFromParent_Done,
     /* 291297 */   // Label 5696: @291297
     /* 291297 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(291334), // Rule ID 5214 //
     /* 291302 */     // MIs[0] Operand 1
     /* 291302 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291311 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291317 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291325 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291332 */     GIR_RootConstrainSelectedInstOperands,
     /* 291333 */     // GIR_Coverage, 5214,
     /* 291333 */     GIR_EraseRootFromParent_Done,
     /* 291334 */   // Label 5697: @291334
     /* 291334 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(291371), // Rule ID 5221 //
     /* 291339 */     // MIs[0] Operand 1
     /* 291339 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291348 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291354 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291362 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291369 */     GIR_RootConstrainSelectedInstOperands,
     /* 291370 */     // GIR_Coverage, 5221,
     /* 291370 */     GIR_EraseRootFromParent_Done,
     /* 291371 */   // Label 5698: @291371
     /* 291371 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(291411), // Rule ID 724 //
     /* 291376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291379 */     // MIs[0] Operand 1
     /* 291379 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291402 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291409 */     GIR_RootConstrainSelectedInstOperands,
     /* 291410 */     // GIR_Coverage, 724,
     /* 291410 */     GIR_EraseRootFromParent_Done,
     /* 291411 */   // Label 5699: @291411
     /* 291411 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(291451), // Rule ID 733 //
     /* 291416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291419 */     // MIs[0] Operand 1
     /* 291419 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291432 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291438 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291442 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291449 */     GIR_RootConstrainSelectedInstOperands,
     /* 291450 */     // GIR_Coverage, 733,
     /* 291450 */     GIR_EraseRootFromParent_Done,
     /* 291451 */   // Label 5700: @291451
     /* 291451 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(291491), // Rule ID 734 //
     /* 291456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291459 */     // MIs[0] Operand 1
     /* 291459 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 291480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291482 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291489 */     GIR_RootConstrainSelectedInstOperands,
     /* 291490 */     // GIR_Coverage, 734,
     /* 291490 */     GIR_EraseRootFromParent_Done,
     /* 291491 */   // Label 5701: @291491
     /* 291491 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(291531), // Rule ID 745 //
     /* 291496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291499 */     // MIs[0] Operand 1
     /* 291499 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291522 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291529 */     GIR_RootConstrainSelectedInstOperands,
     /* 291530 */     // GIR_Coverage, 745,
     /* 291530 */     GIR_EraseRootFromParent_Done,
     /* 291531 */   // Label 5702: @291531
     /* 291531 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(291568), // Rule ID 5158 //
     /* 291536 */     // MIs[0] Operand 1
     /* 291536 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291549 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291555 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291559 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291566 */     GIR_RootConstrainSelectedInstOperands,
     /* 291567 */     // GIR_Coverage, 5158,
     /* 291567 */     GIR_EraseRootFromParent_Done,
     /* 291568 */   // Label 5703: @291568
     /* 291568 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(291605), // Rule ID 5165 //
     /* 291573 */     // MIs[0] Operand 1
     /* 291573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291596 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291603 */     GIR_RootConstrainSelectedInstOperands,
     /* 291604 */     // GIR_Coverage, 5165,
     /* 291604 */     GIR_EraseRootFromParent_Done,
     /* 291605 */   // Label 5704: @291605
     /* 291605 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(291642), // Rule ID 5172 //
     /* 291610 */     // MIs[0] Operand 1
     /* 291610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291623 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291629 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291633 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291640 */     GIR_RootConstrainSelectedInstOperands,
     /* 291641 */     // GIR_Coverage, 5172,
     /* 291641 */     GIR_EraseRootFromParent_Done,
     /* 291642 */   // Label 5705: @291642
     /* 291642 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(291679), // Rule ID 5179 //
     /* 291647 */     // MIs[0] Operand 1
     /* 291647 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291660 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291666 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291670 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291677 */     GIR_RootConstrainSelectedInstOperands,
     /* 291678 */     // GIR_Coverage, 5179,
     /* 291678 */     GIR_EraseRootFromParent_Done,
     /* 291679 */   // Label 5706: @291679
     /* 291679 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(291716), // Rule ID 5186 //
     /* 291684 */     // MIs[0] Operand 1
     /* 291684 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291697 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291703 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291707 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291714 */     GIR_RootConstrainSelectedInstOperands,
     /* 291715 */     // GIR_Coverage, 5186,
     /* 291715 */     GIR_EraseRootFromParent_Done,
     /* 291716 */   // Label 5707: @291716
     /* 291716 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(291748), // Rule ID 1123 //
     /* 291721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291724 */     // MIs[0] Operand 1
     /* 291724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291737 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 291740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291746 */     GIR_RootConstrainSelectedInstOperands,
     /* 291747 */     // GIR_Coverage, 1123,
     /* 291747 */     GIR_EraseRootFromParent_Done,
     /* 291748 */   // Label 5708: @291748
     /* 291748 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(291780), // Rule ID 1130 //
     /* 291753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291756 */     // MIs[0] Operand 1
     /* 291756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291769 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 291772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291778 */     GIR_RootConstrainSelectedInstOperands,
     /* 291779 */     // GIR_Coverage, 1130,
     /* 291779 */     GIR_EraseRootFromParent_Done,
     /* 291780 */   // Label 5709: @291780
     /* 291780 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(291812), // Rule ID 1137 //
     /* 291785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291788 */     // MIs[0] Operand 1
     /* 291788 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291801 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 291804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291810 */     GIR_RootConstrainSelectedInstOperands,
     /* 291811 */     // GIR_Coverage, 1137,
     /* 291811 */     GIR_EraseRootFromParent_Done,
     /* 291812 */   // Label 5710: @291812
     /* 291812 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(291844), // Rule ID 1144 //
     /* 291817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291820 */     // MIs[0] Operand 1
     /* 291820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291833 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 291836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291842 */     GIR_RootConstrainSelectedInstOperands,
     /* 291843 */     // GIR_Coverage, 1144,
     /* 291843 */     GIR_EraseRootFromParent_Done,
     /* 291844 */   // Label 5711: @291844
     /* 291844 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(291876), // Rule ID 1151 //
     /* 291849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291852 */     // MIs[0] Operand 1
     /* 291852 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291865 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 291868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291874 */     GIR_RootConstrainSelectedInstOperands,
     /* 291875 */     // GIR_Coverage, 1151,
     /* 291875 */     GIR_EraseRootFromParent_Done,
     /* 291876 */   // Label 5712: @291876
     /* 291876 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(291905), // Rule ID 5095 //
     /* 291881 */     // MIs[0] Operand 1
     /* 291881 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291894 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 291897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291903 */     GIR_RootConstrainSelectedInstOperands,
     /* 291904 */     // GIR_Coverage, 5095,
     /* 291904 */     GIR_EraseRootFromParent_Done,
     /* 291905 */   // Label 5713: @291905
     /* 291905 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(291934), // Rule ID 5102 //
     /* 291910 */     // MIs[0] Operand 1
     /* 291910 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291923 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 291926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291932 */     GIR_RootConstrainSelectedInstOperands,
     /* 291933 */     // GIR_Coverage, 5102,
     /* 291933 */     GIR_EraseRootFromParent_Done,
     /* 291934 */   // Label 5714: @291934
     /* 291934 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(291963), // Rule ID 5109 //
     /* 291939 */     // MIs[0] Operand 1
     /* 291939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291952 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 291955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291961 */     GIR_RootConstrainSelectedInstOperands,
     /* 291962 */     // GIR_Coverage, 5109,
     /* 291962 */     GIR_EraseRootFromParent_Done,
     /* 291963 */   // Label 5715: @291963
     /* 291963 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(291992), // Rule ID 5116 //
     /* 291968 */     // MIs[0] Operand 1
     /* 291968 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291981 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 291984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291990 */     GIR_RootConstrainSelectedInstOperands,
     /* 291991 */     // GIR_Coverage, 5116,
     /* 291991 */     GIR_EraseRootFromParent_Done,
     /* 291992 */   // Label 5716: @291992
     /* 291992 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(292021), // Rule ID 5123 //
     /* 291997 */     // MIs[0] Operand 1
     /* 291997 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292010 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292019 */     GIR_RootConstrainSelectedInstOperands,
     /* 292020 */     // GIR_Coverage, 5123,
     /* 292020 */     GIR_EraseRootFromParent_Done,
     /* 292021 */   // Label 5717: @292021
     /* 292021 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(292050), // Rule ID 5130 //
     /* 292026 */     // MIs[0] Operand 1
     /* 292026 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292039 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 292042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292048 */     GIR_RootConstrainSelectedInstOperands,
     /* 292049 */     // GIR_Coverage, 5130,
     /* 292049 */     GIR_EraseRootFromParent_Done,
     /* 292050 */   // Label 5718: @292050
     /* 292050 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(292079), // Rule ID 5137 //
     /* 292055 */     // MIs[0] Operand 1
     /* 292055 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292068 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 292071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292077 */     GIR_RootConstrainSelectedInstOperands,
     /* 292078 */     // GIR_Coverage, 5137,
     /* 292078 */     GIR_EraseRootFromParent_Done,
     /* 292079 */   // Label 5719: @292079
     /* 292079 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(292108), // Rule ID 5144 //
     /* 292084 */     // MIs[0] Operand 1
     /* 292084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 292089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292097 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 292100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292106 */     GIR_RootConstrainSelectedInstOperands,
     /* 292107 */     // GIR_Coverage, 5144,
     /* 292107 */     GIR_EraseRootFromParent_Done,
     /* 292108 */   // Label 5720: @292108
     /* 292108 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(292137), // Rule ID 5151 //
     /* 292113 */     // MIs[0] Operand 1
     /* 292113 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 292118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292126 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292135 */     GIR_RootConstrainSelectedInstOperands,
     /* 292136 */     // GIR_Coverage, 5151,
     /* 292136 */     GIR_EraseRootFromParent_Done,
     /* 292137 */   // Label 5721: @292137
     /* 292137 */   GIM_Reject,
     /* 292138 */ // Label 5691: @292138
     /* 292138 */ GIM_Reject,
     /* 292139 */ // Label 5612: @292139
     /* 292139 */ GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(293186),
     /* 292144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 292147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 292150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292154 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(292194), // Rule ID 755 //
     /* 292159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292162 */     // MIs[0] Operand 1
     /* 292162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292171 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292177 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292185 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292192 */     GIR_RootConstrainSelectedInstOperands,
     /* 292193 */     // GIR_Coverage, 755,
     /* 292193 */     GIR_EraseRootFromParent_Done,
     /* 292194 */   // Label 5723: @292194
     /* 292194 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(292234), // Rule ID 762 //
     /* 292199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292202 */     // MIs[0] Operand 1
     /* 292202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292225 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292232 */     GIR_RootConstrainSelectedInstOperands,
     /* 292233 */     // GIR_Coverage, 762,
     /* 292233 */     GIR_EraseRootFromParent_Done,
     /* 292234 */   // Label 5724: @292234
     /* 292234 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(292271), // Rule ID 5196 //
     /* 292239 */     // MIs[0] Operand 1
     /* 292239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292262 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292269 */     GIR_RootConstrainSelectedInstOperands,
     /* 292270 */     // GIR_Coverage, 5196,
     /* 292270 */     GIR_EraseRootFromParent_Done,
     /* 292271 */   // Label 5725: @292271
     /* 292271 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(292308), // Rule ID 5203 //
     /* 292276 */     // MIs[0] Operand 1
     /* 292276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292285 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292291 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292299 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292306 */     GIR_RootConstrainSelectedInstOperands,
     /* 292307 */     // GIR_Coverage, 5203,
     /* 292307 */     GIR_EraseRootFromParent_Done,
     /* 292308 */   // Label 5726: @292308
     /* 292308 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(292345), // Rule ID 5210 //
     /* 292313 */     // MIs[0] Operand 1
     /* 292313 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292322 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292328 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292336 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292343 */     GIR_RootConstrainSelectedInstOperands,
     /* 292344 */     // GIR_Coverage, 5210,
     /* 292344 */     GIR_EraseRootFromParent_Done,
     /* 292345 */   // Label 5727: @292345
     /* 292345 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(292382), // Rule ID 5217 //
     /* 292350 */     // MIs[0] Operand 1
     /* 292350 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292359 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292365 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292373 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292380 */     GIR_RootConstrainSelectedInstOperands,
     /* 292381 */     // GIR_Coverage, 5217,
     /* 292381 */     GIR_EraseRootFromParent_Done,
     /* 292382 */   // Label 5728: @292382
     /* 292382 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(292419), // Rule ID 5224 //
     /* 292387 */     // MIs[0] Operand 1
     /* 292387 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292402 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292410 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292417 */     GIR_RootConstrainSelectedInstOperands,
     /* 292418 */     // GIR_Coverage, 5224,
     /* 292418 */     GIR_EraseRootFromParent_Done,
     /* 292419 */   // Label 5729: @292419
     /* 292419 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(292459), // Rule ID 727 //
     /* 292424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292427 */     // MIs[0] Operand 1
     /* 292427 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292440 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292446 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292450 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292457 */     GIR_RootConstrainSelectedInstOperands,
     /* 292458 */     // GIR_Coverage, 727,
     /* 292458 */     GIR_EraseRootFromParent_Done,
     /* 292459 */   // Label 5730: @292459
     /* 292459 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(292499), // Rule ID 739 //
     /* 292464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292467 */     // MIs[0] Operand 1
     /* 292467 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292490 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292497 */     GIR_RootConstrainSelectedInstOperands,
     /* 292498 */     // GIR_Coverage, 739,
     /* 292498 */     GIR_EraseRootFromParent_Done,
     /* 292499 */   // Label 5731: @292499
     /* 292499 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(292539), // Rule ID 740 //
     /* 292504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292507 */     // MIs[0] Operand 1
     /* 292507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292530 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292537 */     GIR_RootConstrainSelectedInstOperands,
     /* 292538 */     // GIR_Coverage, 740,
     /* 292538 */     GIR_EraseRootFromParent_Done,
     /* 292539 */   // Label 5732: @292539
     /* 292539 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(292579), // Rule ID 748 //
     /* 292544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292547 */     // MIs[0] Operand 1
     /* 292547 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292570 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292577 */     GIR_RootConstrainSelectedInstOperands,
     /* 292578 */     // GIR_Coverage, 748,
     /* 292578 */     GIR_EraseRootFromParent_Done,
     /* 292579 */   // Label 5733: @292579
     /* 292579 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(292616), // Rule ID 5161 //
     /* 292584 */     // MIs[0] Operand 1
     /* 292584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292607 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292614 */     GIR_RootConstrainSelectedInstOperands,
     /* 292615 */     // GIR_Coverage, 5161,
     /* 292615 */     GIR_EraseRootFromParent_Done,
     /* 292616 */   // Label 5734: @292616
     /* 292616 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(292653), // Rule ID 5168 //
     /* 292621 */     // MIs[0] Operand 1
     /* 292621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292644 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292651 */     GIR_RootConstrainSelectedInstOperands,
     /* 292652 */     // GIR_Coverage, 5168,
     /* 292652 */     GIR_EraseRootFromParent_Done,
     /* 292653 */   // Label 5735: @292653
     /* 292653 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(292690), // Rule ID 5175 //
     /* 292658 */     // MIs[0] Operand 1
     /* 292658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292681 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292688 */     GIR_RootConstrainSelectedInstOperands,
     /* 292689 */     // GIR_Coverage, 5175,
     /* 292689 */     GIR_EraseRootFromParent_Done,
     /* 292690 */   // Label 5736: @292690
     /* 292690 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(292727), // Rule ID 5182 //
     /* 292695 */     // MIs[0] Operand 1
     /* 292695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292718 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292725 */     GIR_RootConstrainSelectedInstOperands,
     /* 292726 */     // GIR_Coverage, 5182,
     /* 292726 */     GIR_EraseRootFromParent_Done,
     /* 292727 */   // Label 5737: @292727
     /* 292727 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(292764), // Rule ID 5189 //
     /* 292732 */     // MIs[0] Operand 1
     /* 292732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292745 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292751 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292755 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292762 */     GIR_RootConstrainSelectedInstOperands,
     /* 292763 */     // GIR_Coverage, 5189,
     /* 292763 */     GIR_EraseRootFromParent_Done,
     /* 292764 */   // Label 5738: @292764
     /* 292764 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(292796), // Rule ID 1126 //
     /* 292769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292772 */     // MIs[0] Operand 1
     /* 292772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292785 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 292788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292794 */     GIR_RootConstrainSelectedInstOperands,
     /* 292795 */     // GIR_Coverage, 1126,
     /* 292795 */     GIR_EraseRootFromParent_Done,
     /* 292796 */   // Label 5739: @292796
     /* 292796 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(292828), // Rule ID 1133 //
     /* 292801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292804 */     // MIs[0] Operand 1
     /* 292804 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292817 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 292820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292826 */     GIR_RootConstrainSelectedInstOperands,
     /* 292827 */     // GIR_Coverage, 1133,
     /* 292827 */     GIR_EraseRootFromParent_Done,
     /* 292828 */   // Label 5740: @292828
     /* 292828 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(292860), // Rule ID 1140 //
     /* 292833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292836 */     // MIs[0] Operand 1
     /* 292836 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292849 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 292852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292858 */     GIR_RootConstrainSelectedInstOperands,
     /* 292859 */     // GIR_Coverage, 1140,
     /* 292859 */     GIR_EraseRootFromParent_Done,
     /* 292860 */   // Label 5741: @292860
     /* 292860 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(292892), // Rule ID 1147 //
     /* 292865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292868 */     // MIs[0] Operand 1
     /* 292868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292881 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 292884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292890 */     GIR_RootConstrainSelectedInstOperands,
     /* 292891 */     // GIR_Coverage, 1147,
     /* 292891 */     GIR_EraseRootFromParent_Done,
     /* 292892 */   // Label 5742: @292892
     /* 292892 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(292924), // Rule ID 1154 //
     /* 292897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292900 */     // MIs[0] Operand 1
     /* 292900 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292913 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 292916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292922 */     GIR_RootConstrainSelectedInstOperands,
     /* 292923 */     // GIR_Coverage, 1154,
     /* 292923 */     GIR_EraseRootFromParent_Done,
     /* 292924 */   // Label 5743: @292924
     /* 292924 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(292953), // Rule ID 5098 //
     /* 292929 */     // MIs[0] Operand 1
     /* 292929 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292942 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 292945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292951 */     GIR_RootConstrainSelectedInstOperands,
     /* 292952 */     // GIR_Coverage, 5098,
     /* 292952 */     GIR_EraseRootFromParent_Done,
     /* 292953 */   // Label 5744: @292953
     /* 292953 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(292982), // Rule ID 5105 //
     /* 292958 */     // MIs[0] Operand 1
     /* 292958 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292971 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 292974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292980 */     GIR_RootConstrainSelectedInstOperands,
     /* 292981 */     // GIR_Coverage, 5105,
     /* 292981 */     GIR_EraseRootFromParent_Done,
     /* 292982 */   // Label 5745: @292982
     /* 292982 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(293011), // Rule ID 5112 //
     /* 292987 */     // MIs[0] Operand 1
     /* 292987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293000 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293009 */     GIR_RootConstrainSelectedInstOperands,
     /* 293010 */     // GIR_Coverage, 5112,
     /* 293010 */     GIR_EraseRootFromParent_Done,
     /* 293011 */   // Label 5746: @293011
     /* 293011 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(293040), // Rule ID 5119 //
     /* 293016 */     // MIs[0] Operand 1
     /* 293016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293029 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293038 */     GIR_RootConstrainSelectedInstOperands,
     /* 293039 */     // GIR_Coverage, 5119,
     /* 293039 */     GIR_EraseRootFromParent_Done,
     /* 293040 */   // Label 5747: @293040
     /* 293040 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(293069), // Rule ID 5126 //
     /* 293045 */     // MIs[0] Operand 1
     /* 293045 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293058 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293067 */     GIR_RootConstrainSelectedInstOperands,
     /* 293068 */     // GIR_Coverage, 5126,
     /* 293068 */     GIR_EraseRootFromParent_Done,
     /* 293069 */   // Label 5748: @293069
     /* 293069 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(293098), // Rule ID 5133 //
     /* 293074 */     // MIs[0] Operand 1
     /* 293074 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293087 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 293090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293096 */     GIR_RootConstrainSelectedInstOperands,
     /* 293097 */     // GIR_Coverage, 5133,
     /* 293097 */     GIR_EraseRootFromParent_Done,
     /* 293098 */   // Label 5749: @293098
     /* 293098 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(293127), // Rule ID 5140 //
     /* 293103 */     // MIs[0] Operand 1
     /* 293103 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293116 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293125 */     GIR_RootConstrainSelectedInstOperands,
     /* 293126 */     // GIR_Coverage, 5140,
     /* 293126 */     GIR_EraseRootFromParent_Done,
     /* 293127 */   // Label 5750: @293127
     /* 293127 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(293156), // Rule ID 5147 //
     /* 293132 */     // MIs[0] Operand 1
     /* 293132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293145 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293154 */     GIR_RootConstrainSelectedInstOperands,
     /* 293155 */     // GIR_Coverage, 5147,
     /* 293155 */     GIR_EraseRootFromParent_Done,
     /* 293156 */   // Label 5751: @293156
     /* 293156 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(293185), // Rule ID 5154 //
     /* 293161 */     // MIs[0] Operand 1
     /* 293161 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293174 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293183 */     GIR_RootConstrainSelectedInstOperands,
     /* 293184 */     // GIR_Coverage, 5154,
     /* 293184 */     GIR_EraseRootFromParent_Done,
     /* 293185 */   // Label 5752: @293185
     /* 293185 */   GIM_Reject,
     /* 293186 */ // Label 5722: @293186
     /* 293186 */ GIM_Reject,
     /* 293187 */ // Label 5613: @293187
     /* 293187 */ GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(294234),
     /* 293192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 293195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 293198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293202 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(293242), // Rule ID 750 //
     /* 293207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293210 */     // MIs[0] Operand 1
     /* 293210 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293219 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293225 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293233 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293240 */     GIR_RootConstrainSelectedInstOperands,
     /* 293241 */     // GIR_Coverage, 750,
     /* 293241 */     GIR_EraseRootFromParent_Done,
     /* 293242 */   // Label 5754: @293242
     /* 293242 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(293282), // Rule ID 757 //
     /* 293247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293250 */     // MIs[0] Operand 1
     /* 293250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293259 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293265 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293273 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293280 */     GIR_RootConstrainSelectedInstOperands,
     /* 293281 */     // GIR_Coverage, 757,
     /* 293281 */     GIR_EraseRootFromParent_Done,
     /* 293282 */   // Label 5755: @293282
     /* 293282 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(293319), // Rule ID 5191 //
     /* 293287 */     // MIs[0] Operand 1
     /* 293287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293296 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293302 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293310 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293317 */     GIR_RootConstrainSelectedInstOperands,
     /* 293318 */     // GIR_Coverage, 5191,
     /* 293318 */     GIR_EraseRootFromParent_Done,
     /* 293319 */   // Label 5756: @293319
     /* 293319 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(293356), // Rule ID 5198 //
     /* 293324 */     // MIs[0] Operand 1
     /* 293324 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293333 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293339 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293347 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293354 */     GIR_RootConstrainSelectedInstOperands,
     /* 293355 */     // GIR_Coverage, 5198,
     /* 293355 */     GIR_EraseRootFromParent_Done,
     /* 293356 */   // Label 5757: @293356
     /* 293356 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(293393), // Rule ID 5205 //
     /* 293361 */     // MIs[0] Operand 1
     /* 293361 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293370 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293376 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293384 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293391 */     GIR_RootConstrainSelectedInstOperands,
     /* 293392 */     // GIR_Coverage, 5205,
     /* 293392 */     GIR_EraseRootFromParent_Done,
     /* 293393 */   // Label 5758: @293393
     /* 293393 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(293430), // Rule ID 5212 //
     /* 293398 */     // MIs[0] Operand 1
     /* 293398 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293413 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293421 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293428 */     GIR_RootConstrainSelectedInstOperands,
     /* 293429 */     // GIR_Coverage, 5212,
     /* 293429 */     GIR_EraseRootFromParent_Done,
     /* 293430 */   // Label 5759: @293430
     /* 293430 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(293467), // Rule ID 5219 //
     /* 293435 */     // MIs[0] Operand 1
     /* 293435 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293458 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293465 */     GIR_RootConstrainSelectedInstOperands,
     /* 293466 */     // GIR_Coverage, 5219,
     /* 293466 */     GIR_EraseRootFromParent_Done,
     /* 293467 */   // Label 5760: @293467
     /* 293467 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(293507), // Rule ID 722 //
     /* 293472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293475 */     // MIs[0] Operand 1
     /* 293475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293488 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293494 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293498 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293505 */     GIR_RootConstrainSelectedInstOperands,
     /* 293506 */     // GIR_Coverage, 722,
     /* 293506 */     GIR_EraseRootFromParent_Done,
     /* 293507 */   // Label 5761: @293507
     /* 293507 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(293547), // Rule ID 729 //
     /* 293512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293515 */     // MIs[0] Operand 1
     /* 293515 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293528 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293534 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293538 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293545 */     GIR_RootConstrainSelectedInstOperands,
     /* 293546 */     // GIR_Coverage, 729,
     /* 293546 */     GIR_EraseRootFromParent_Done,
     /* 293547 */   // Label 5762: @293547
     /* 293547 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(293587), // Rule ID 730 //
     /* 293552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293555 */     // MIs[0] Operand 1
     /* 293555 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293568 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293574 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293578 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293585 */     GIR_RootConstrainSelectedInstOperands,
     /* 293586 */     // GIR_Coverage, 730,
     /* 293586 */     GIR_EraseRootFromParent_Done,
     /* 293587 */   // Label 5763: @293587
     /* 293587 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(293627), // Rule ID 743 //
     /* 293592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293595 */     // MIs[0] Operand 1
     /* 293595 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293608 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293614 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293618 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293625 */     GIR_RootConstrainSelectedInstOperands,
     /* 293626 */     // GIR_Coverage, 743,
     /* 293626 */     GIR_EraseRootFromParent_Done,
     /* 293627 */   // Label 5764: @293627
     /* 293627 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(293664), // Rule ID 5156 //
     /* 293632 */     // MIs[0] Operand 1
     /* 293632 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293645 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293651 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293655 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293662 */     GIR_RootConstrainSelectedInstOperands,
     /* 293663 */     // GIR_Coverage, 5156,
     /* 293663 */     GIR_EraseRootFromParent_Done,
     /* 293664 */   // Label 5765: @293664
     /* 293664 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(293701), // Rule ID 5163 //
     /* 293669 */     // MIs[0] Operand 1
     /* 293669 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293682 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293688 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293692 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293699 */     GIR_RootConstrainSelectedInstOperands,
     /* 293700 */     // GIR_Coverage, 5163,
     /* 293700 */     GIR_EraseRootFromParent_Done,
     /* 293701 */   // Label 5766: @293701
     /* 293701 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(293738), // Rule ID 5170 //
     /* 293706 */     // MIs[0] Operand 1
     /* 293706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293719 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293725 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293729 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293736 */     GIR_RootConstrainSelectedInstOperands,
     /* 293737 */     // GIR_Coverage, 5170,
     /* 293737 */     GIR_EraseRootFromParent_Done,
     /* 293738 */   // Label 5767: @293738
     /* 293738 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(293775), // Rule ID 5177 //
     /* 293743 */     // MIs[0] Operand 1
     /* 293743 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293756 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293762 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293766 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293773 */     GIR_RootConstrainSelectedInstOperands,
     /* 293774 */     // GIR_Coverage, 5177,
     /* 293774 */     GIR_EraseRootFromParent_Done,
     /* 293775 */   // Label 5768: @293775
     /* 293775 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(293812), // Rule ID 5184 //
     /* 293780 */     // MIs[0] Operand 1
     /* 293780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293793 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293799 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293803 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293810 */     GIR_RootConstrainSelectedInstOperands,
     /* 293811 */     // GIR_Coverage, 5184,
     /* 293811 */     GIR_EraseRootFromParent_Done,
     /* 293812 */   // Label 5769: @293812
     /* 293812 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(293844), // Rule ID 1121 //
     /* 293817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293820 */     // MIs[0] Operand 1
     /* 293820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293833 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 293836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293842 */     GIR_RootConstrainSelectedInstOperands,
     /* 293843 */     // GIR_Coverage, 1121,
     /* 293843 */     GIR_EraseRootFromParent_Done,
     /* 293844 */   // Label 5770: @293844
     /* 293844 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(293876), // Rule ID 1128 //
     /* 293849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293852 */     // MIs[0] Operand 1
     /* 293852 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293865 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 293868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293874 */     GIR_RootConstrainSelectedInstOperands,
     /* 293875 */     // GIR_Coverage, 1128,
     /* 293875 */     GIR_EraseRootFromParent_Done,
     /* 293876 */   // Label 5771: @293876
     /* 293876 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(293908), // Rule ID 1135 //
     /* 293881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293884 */     // MIs[0] Operand 1
     /* 293884 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293897 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 293900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293906 */     GIR_RootConstrainSelectedInstOperands,
     /* 293907 */     // GIR_Coverage, 1135,
     /* 293907 */     GIR_EraseRootFromParent_Done,
     /* 293908 */   // Label 5772: @293908
     /* 293908 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(293940), // Rule ID 1142 //
     /* 293913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293916 */     // MIs[0] Operand 1
     /* 293916 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293929 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 293932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293938 */     GIR_RootConstrainSelectedInstOperands,
     /* 293939 */     // GIR_Coverage, 1142,
     /* 293939 */     GIR_EraseRootFromParent_Done,
     /* 293940 */   // Label 5773: @293940
     /* 293940 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(293972), // Rule ID 1149 //
     /* 293945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293948 */     // MIs[0] Operand 1
     /* 293948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293961 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 293964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293970 */     GIR_RootConstrainSelectedInstOperands,
     /* 293971 */     // GIR_Coverage, 1149,
     /* 293971 */     GIR_EraseRootFromParent_Done,
     /* 293972 */   // Label 5774: @293972
     /* 293972 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(294001), // Rule ID 5093 //
     /* 293977 */     // MIs[0] Operand 1
     /* 293977 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293990 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 293993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293999 */     GIR_RootConstrainSelectedInstOperands,
     /* 294000 */     // GIR_Coverage, 5093,
     /* 294000 */     GIR_EraseRootFromParent_Done,
     /* 294001 */   // Label 5775: @294001
     /* 294001 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(294030), // Rule ID 5100 //
     /* 294006 */     // MIs[0] Operand 1
     /* 294006 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294019 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294028 */     GIR_RootConstrainSelectedInstOperands,
     /* 294029 */     // GIR_Coverage, 5100,
     /* 294029 */     GIR_EraseRootFromParent_Done,
     /* 294030 */   // Label 5776: @294030
     /* 294030 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(294059), // Rule ID 5107 //
     /* 294035 */     // MIs[0] Operand 1
     /* 294035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294048 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294057 */     GIR_RootConstrainSelectedInstOperands,
     /* 294058 */     // GIR_Coverage, 5107,
     /* 294058 */     GIR_EraseRootFromParent_Done,
     /* 294059 */   // Label 5777: @294059
     /* 294059 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(294088), // Rule ID 5114 //
     /* 294064 */     // MIs[0] Operand 1
     /* 294064 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294077 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294086 */     GIR_RootConstrainSelectedInstOperands,
     /* 294087 */     // GIR_Coverage, 5114,
     /* 294087 */     GIR_EraseRootFromParent_Done,
     /* 294088 */   // Label 5778: @294088
     /* 294088 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(294117), // Rule ID 5121 //
     /* 294093 */     // MIs[0] Operand 1
     /* 294093 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294106 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294115 */     GIR_RootConstrainSelectedInstOperands,
     /* 294116 */     // GIR_Coverage, 5121,
     /* 294116 */     GIR_EraseRootFromParent_Done,
     /* 294117 */   // Label 5779: @294117
     /* 294117 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(294146), // Rule ID 5128 //
     /* 294122 */     // MIs[0] Operand 1
     /* 294122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294135 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294144 */     GIR_RootConstrainSelectedInstOperands,
     /* 294145 */     // GIR_Coverage, 5128,
     /* 294145 */     GIR_EraseRootFromParent_Done,
     /* 294146 */   // Label 5780: @294146
     /* 294146 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(294175), // Rule ID 5135 //
     /* 294151 */     // MIs[0] Operand 1
     /* 294151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294164 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294173 */     GIR_RootConstrainSelectedInstOperands,
     /* 294174 */     // GIR_Coverage, 5135,
     /* 294174 */     GIR_EraseRootFromParent_Done,
     /* 294175 */   // Label 5781: @294175
     /* 294175 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(294204), // Rule ID 5142 //
     /* 294180 */     // MIs[0] Operand 1
     /* 294180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294193 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294202 */     GIR_RootConstrainSelectedInstOperands,
     /* 294203 */     // GIR_Coverage, 5142,
     /* 294203 */     GIR_EraseRootFromParent_Done,
     /* 294204 */   // Label 5782: @294204
     /* 294204 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(294233), // Rule ID 5149 //
     /* 294209 */     // MIs[0] Operand 1
     /* 294209 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294222 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294231 */     GIR_RootConstrainSelectedInstOperands,
     /* 294232 */     // GIR_Coverage, 5149,
     /* 294232 */     GIR_EraseRootFromParent_Done,
     /* 294233 */   // Label 5783: @294233
     /* 294233 */   GIM_Reject,
     /* 294234 */ // Label 5753: @294234
     /* 294234 */ GIM_Reject,
     /* 294235 */ // Label 5614: @294235
     /* 294235 */ GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(295282),
     /* 294240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 294243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 294246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294250 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(294290), // Rule ID 753 //
     /* 294255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294258 */     // MIs[0] Operand 1
     /* 294258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294281 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294288 */     GIR_RootConstrainSelectedInstOperands,
     /* 294289 */     // GIR_Coverage, 753,
     /* 294289 */     GIR_EraseRootFromParent_Done,
     /* 294290 */   // Label 5785: @294290
     /* 294290 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(294330), // Rule ID 760 //
     /* 294295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294298 */     // MIs[0] Operand 1
     /* 294298 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294307 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294313 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294321 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294328 */     GIR_RootConstrainSelectedInstOperands,
     /* 294329 */     // GIR_Coverage, 760,
     /* 294329 */     GIR_EraseRootFromParent_Done,
     /* 294330 */   // Label 5786: @294330
     /* 294330 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(294367), // Rule ID 5194 //
     /* 294335 */     // MIs[0] Operand 1
     /* 294335 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294358 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294365 */     GIR_RootConstrainSelectedInstOperands,
     /* 294366 */     // GIR_Coverage, 5194,
     /* 294366 */     GIR_EraseRootFromParent_Done,
     /* 294367 */   // Label 5787: @294367
     /* 294367 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(294404), // Rule ID 5201 //
     /* 294372 */     // MIs[0] Operand 1
     /* 294372 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294381 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294387 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294395 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294402 */     GIR_RootConstrainSelectedInstOperands,
     /* 294403 */     // GIR_Coverage, 5201,
     /* 294403 */     GIR_EraseRootFromParent_Done,
     /* 294404 */   // Label 5788: @294404
     /* 294404 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(294441), // Rule ID 5208 //
     /* 294409 */     // MIs[0] Operand 1
     /* 294409 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294424 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294432 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294439 */     GIR_RootConstrainSelectedInstOperands,
     /* 294440 */     // GIR_Coverage, 5208,
     /* 294440 */     GIR_EraseRootFromParent_Done,
     /* 294441 */   // Label 5789: @294441
     /* 294441 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(294478), // Rule ID 5215 //
     /* 294446 */     // MIs[0] Operand 1
     /* 294446 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294455 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294461 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294469 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294476 */     GIR_RootConstrainSelectedInstOperands,
     /* 294477 */     // GIR_Coverage, 5215,
     /* 294477 */     GIR_EraseRootFromParent_Done,
     /* 294478 */   // Label 5790: @294478
     /* 294478 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(294515), // Rule ID 5222 //
     /* 294483 */     // MIs[0] Operand 1
     /* 294483 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294506 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294513 */     GIR_RootConstrainSelectedInstOperands,
     /* 294514 */     // GIR_Coverage, 5222,
     /* 294514 */     GIR_EraseRootFromParent_Done,
     /* 294515 */   // Label 5791: @294515
     /* 294515 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(294555), // Rule ID 725 //
     /* 294520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294523 */     // MIs[0] Operand 1
     /* 294523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294536 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294542 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294546 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294553 */     GIR_RootConstrainSelectedInstOperands,
     /* 294554 */     // GIR_Coverage, 725,
     /* 294554 */     GIR_EraseRootFromParent_Done,
     /* 294555 */   // Label 5792: @294555
     /* 294555 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(294595), // Rule ID 735 //
     /* 294560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294563 */     // MIs[0] Operand 1
     /* 294563 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294576 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294582 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294586 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294593 */     GIR_RootConstrainSelectedInstOperands,
     /* 294594 */     // GIR_Coverage, 735,
     /* 294594 */     GIR_EraseRootFromParent_Done,
     /* 294595 */   // Label 5793: @294595
     /* 294595 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(294635), // Rule ID 736 //
     /* 294600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294603 */     // MIs[0] Operand 1
     /* 294603 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294616 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294622 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 294624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294626 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294633 */     GIR_RootConstrainSelectedInstOperands,
     /* 294634 */     // GIR_Coverage, 736,
     /* 294634 */     GIR_EraseRootFromParent_Done,
     /* 294635 */   // Label 5794: @294635
     /* 294635 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(294675), // Rule ID 746 //
     /* 294640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294643 */     // MIs[0] Operand 1
     /* 294643 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294662 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294666 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294673 */     GIR_RootConstrainSelectedInstOperands,
     /* 294674 */     // GIR_Coverage, 746,
     /* 294674 */     GIR_EraseRootFromParent_Done,
     /* 294675 */   // Label 5795: @294675
     /* 294675 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(294712), // Rule ID 5159 //
     /* 294680 */     // MIs[0] Operand 1
     /* 294680 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294693 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294699 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294703 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294710 */     GIR_RootConstrainSelectedInstOperands,
     /* 294711 */     // GIR_Coverage, 5159,
     /* 294711 */     GIR_EraseRootFromParent_Done,
     /* 294712 */   // Label 5796: @294712
     /* 294712 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(294749), // Rule ID 5166 //
     /* 294717 */     // MIs[0] Operand 1
     /* 294717 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294730 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294736 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294740 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294747 */     GIR_RootConstrainSelectedInstOperands,
     /* 294748 */     // GIR_Coverage, 5166,
     /* 294748 */     GIR_EraseRootFromParent_Done,
     /* 294749 */   // Label 5797: @294749
     /* 294749 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(294786), // Rule ID 5173 //
     /* 294754 */     // MIs[0] Operand 1
     /* 294754 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294773 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294777 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294784 */     GIR_RootConstrainSelectedInstOperands,
     /* 294785 */     // GIR_Coverage, 5173,
     /* 294785 */     GIR_EraseRootFromParent_Done,
     /* 294786 */   // Label 5798: @294786
     /* 294786 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(294823), // Rule ID 5180 //
     /* 294791 */     // MIs[0] Operand 1
     /* 294791 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294804 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294810 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294814 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294821 */     GIR_RootConstrainSelectedInstOperands,
     /* 294822 */     // GIR_Coverage, 5180,
     /* 294822 */     GIR_EraseRootFromParent_Done,
     /* 294823 */   // Label 5799: @294823
     /* 294823 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(294860), // Rule ID 5187 //
     /* 294828 */     // MIs[0] Operand 1
     /* 294828 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294841 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294847 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294851 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294858 */     GIR_RootConstrainSelectedInstOperands,
     /* 294859 */     // GIR_Coverage, 5187,
     /* 294859 */     GIR_EraseRootFromParent_Done,
     /* 294860 */   // Label 5800: @294860
     /* 294860 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(294892), // Rule ID 1124 //
     /* 294865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294868 */     // MIs[0] Operand 1
     /* 294868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294881 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 294884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294890 */     GIR_RootConstrainSelectedInstOperands,
     /* 294891 */     // GIR_Coverage, 1124,
     /* 294891 */     GIR_EraseRootFromParent_Done,
     /* 294892 */   // Label 5801: @294892
     /* 294892 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(294924), // Rule ID 1131 //
     /* 294897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294900 */     // MIs[0] Operand 1
     /* 294900 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294913 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 294916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294922 */     GIR_RootConstrainSelectedInstOperands,
     /* 294923 */     // GIR_Coverage, 1131,
     /* 294923 */     GIR_EraseRootFromParent_Done,
     /* 294924 */   // Label 5802: @294924
     /* 294924 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(294956), // Rule ID 1138 //
     /* 294929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294932 */     // MIs[0] Operand 1
     /* 294932 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294945 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 294948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294954 */     GIR_RootConstrainSelectedInstOperands,
     /* 294955 */     // GIR_Coverage, 1138,
     /* 294955 */     GIR_EraseRootFromParent_Done,
     /* 294956 */   // Label 5803: @294956
     /* 294956 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(294988), // Rule ID 1145 //
     /* 294961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294964 */     // MIs[0] Operand 1
     /* 294964 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294977 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 294980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294986 */     GIR_RootConstrainSelectedInstOperands,
     /* 294987 */     // GIR_Coverage, 1145,
     /* 294987 */     GIR_EraseRootFromParent_Done,
     /* 294988 */   // Label 5804: @294988
     /* 294988 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(295020), // Rule ID 1152 //
     /* 294993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294996 */     // MIs[0] Operand 1
     /* 294996 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295009 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295018 */     GIR_RootConstrainSelectedInstOperands,
     /* 295019 */     // GIR_Coverage, 1152,
     /* 295019 */     GIR_EraseRootFromParent_Done,
     /* 295020 */   // Label 5805: @295020
     /* 295020 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(295049), // Rule ID 5096 //
     /* 295025 */     // MIs[0] Operand 1
     /* 295025 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295038 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 295041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295047 */     GIR_RootConstrainSelectedInstOperands,
     /* 295048 */     // GIR_Coverage, 5096,
     /* 295048 */     GIR_EraseRootFromParent_Done,
     /* 295049 */   // Label 5806: @295049
     /* 295049 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(295078), // Rule ID 5103 //
     /* 295054 */     // MIs[0] Operand 1
     /* 295054 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295067 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295076 */     GIR_RootConstrainSelectedInstOperands,
     /* 295077 */     // GIR_Coverage, 5103,
     /* 295077 */     GIR_EraseRootFromParent_Done,
     /* 295078 */   // Label 5807: @295078
     /* 295078 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(295107), // Rule ID 5110 //
     /* 295083 */     // MIs[0] Operand 1
     /* 295083 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295096 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295105 */     GIR_RootConstrainSelectedInstOperands,
     /* 295106 */     // GIR_Coverage, 5110,
     /* 295106 */     GIR_EraseRootFromParent_Done,
     /* 295107 */   // Label 5808: @295107
     /* 295107 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(295136), // Rule ID 5117 //
     /* 295112 */     // MIs[0] Operand 1
     /* 295112 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295125 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295134 */     GIR_RootConstrainSelectedInstOperands,
     /* 295135 */     // GIR_Coverage, 5117,
     /* 295135 */     GIR_EraseRootFromParent_Done,
     /* 295136 */   // Label 5809: @295136
     /* 295136 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(295165), // Rule ID 5124 //
     /* 295141 */     // MIs[0] Operand 1
     /* 295141 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295154 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295163 */     GIR_RootConstrainSelectedInstOperands,
     /* 295164 */     // GIR_Coverage, 5124,
     /* 295164 */     GIR_EraseRootFromParent_Done,
     /* 295165 */   // Label 5810: @295165
     /* 295165 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(295194), // Rule ID 5131 //
     /* 295170 */     // MIs[0] Operand 1
     /* 295170 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295183 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295192 */     GIR_RootConstrainSelectedInstOperands,
     /* 295193 */     // GIR_Coverage, 5131,
     /* 295193 */     GIR_EraseRootFromParent_Done,
     /* 295194 */   // Label 5811: @295194
     /* 295194 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(295223), // Rule ID 5138 //
     /* 295199 */     // MIs[0] Operand 1
     /* 295199 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295212 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295221 */     GIR_RootConstrainSelectedInstOperands,
     /* 295222 */     // GIR_Coverage, 5138,
     /* 295222 */     GIR_EraseRootFromParent_Done,
     /* 295223 */   // Label 5812: @295223
     /* 295223 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(295252), // Rule ID 5145 //
     /* 295228 */     // MIs[0] Operand 1
     /* 295228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 295233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295241 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295250 */     GIR_RootConstrainSelectedInstOperands,
     /* 295251 */     // GIR_Coverage, 5145,
     /* 295251 */     GIR_EraseRootFromParent_Done,
     /* 295252 */   // Label 5813: @295252
     /* 295252 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(295281), // Rule ID 5152 //
     /* 295257 */     // MIs[0] Operand 1
     /* 295257 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 295262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295270 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295279 */     GIR_RootConstrainSelectedInstOperands,
     /* 295280 */     // GIR_Coverage, 5152,
     /* 295280 */     GIR_EraseRootFromParent_Done,
     /* 295281 */   // Label 5814: @295281
     /* 295281 */   GIM_Reject,
     /* 295282 */ // Label 5784: @295282
     /* 295282 */ GIM_Reject,
     /* 295283 */ // Label 5615: @295283
     /* 295283 */ GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(296330),
     /* 295288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 295291 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 295294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295298 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(295338), // Rule ID 751 //
     /* 295303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295306 */     // MIs[0] Operand 1
     /* 295306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295329 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295336 */     GIR_RootConstrainSelectedInstOperands,
     /* 295337 */     // GIR_Coverage, 751,
     /* 295337 */     GIR_EraseRootFromParent_Done,
     /* 295338 */   // Label 5816: @295338
     /* 295338 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(295378), // Rule ID 758 //
     /* 295343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295346 */     // MIs[0] Operand 1
     /* 295346 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295355 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295369 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295376 */     GIR_RootConstrainSelectedInstOperands,
     /* 295377 */     // GIR_Coverage, 758,
     /* 295377 */     GIR_EraseRootFromParent_Done,
     /* 295378 */   // Label 5817: @295378
     /* 295378 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(295415), // Rule ID 5192 //
     /* 295383 */     // MIs[0] Operand 1
     /* 295383 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295406 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295413 */     GIR_RootConstrainSelectedInstOperands,
     /* 295414 */     // GIR_Coverage, 5192,
     /* 295414 */     GIR_EraseRootFromParent_Done,
     /* 295415 */   // Label 5818: @295415
     /* 295415 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(295452), // Rule ID 5199 //
     /* 295420 */     // MIs[0] Operand 1
     /* 295420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295429 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295435 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295443 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295450 */     GIR_RootConstrainSelectedInstOperands,
     /* 295451 */     // GIR_Coverage, 5199,
     /* 295451 */     GIR_EraseRootFromParent_Done,
     /* 295452 */   // Label 5819: @295452
     /* 295452 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(295489), // Rule ID 5206 //
     /* 295457 */     // MIs[0] Operand 1
     /* 295457 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295466 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295472 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295480 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295487 */     GIR_RootConstrainSelectedInstOperands,
     /* 295488 */     // GIR_Coverage, 5206,
     /* 295488 */     GIR_EraseRootFromParent_Done,
     /* 295489 */   // Label 5820: @295489
     /* 295489 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(295526), // Rule ID 5213 //
     /* 295494 */     // MIs[0] Operand 1
     /* 295494 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295517 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295524 */     GIR_RootConstrainSelectedInstOperands,
     /* 295525 */     // GIR_Coverage, 5213,
     /* 295525 */     GIR_EraseRootFromParent_Done,
     /* 295526 */   // Label 5821: @295526
     /* 295526 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(295563), // Rule ID 5220 //
     /* 295531 */     // MIs[0] Operand 1
     /* 295531 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295554 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295561 */     GIR_RootConstrainSelectedInstOperands,
     /* 295562 */     // GIR_Coverage, 5220,
     /* 295562 */     GIR_EraseRootFromParent_Done,
     /* 295563 */   // Label 5822: @295563
     /* 295563 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(295603), // Rule ID 723 //
     /* 295568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295571 */     // MIs[0] Operand 1
     /* 295571 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295584 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295590 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295594 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295601 */     GIR_RootConstrainSelectedInstOperands,
     /* 295602 */     // GIR_Coverage, 723,
     /* 295602 */     GIR_EraseRootFromParent_Done,
     /* 295603 */   // Label 5823: @295603
     /* 295603 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(295643), // Rule ID 731 //
     /* 295608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295611 */     // MIs[0] Operand 1
     /* 295611 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295624 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295630 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295634 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295641 */     GIR_RootConstrainSelectedInstOperands,
     /* 295642 */     // GIR_Coverage, 731,
     /* 295642 */     GIR_EraseRootFromParent_Done,
     /* 295643 */   // Label 5824: @295643
     /* 295643 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(295683), // Rule ID 732 //
     /* 295648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295651 */     // MIs[0] Operand 1
     /* 295651 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295670 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 295672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295674 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295681 */     GIR_RootConstrainSelectedInstOperands,
     /* 295682 */     // GIR_Coverage, 732,
     /* 295682 */     GIR_EraseRootFromParent_Done,
     /* 295683 */   // Label 5825: @295683
     /* 295683 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(295723), // Rule ID 744 //
     /* 295688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295691 */     // MIs[0] Operand 1
     /* 295691 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295704 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295710 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295714 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295721 */     GIR_RootConstrainSelectedInstOperands,
     /* 295722 */     // GIR_Coverage, 744,
     /* 295722 */     GIR_EraseRootFromParent_Done,
     /* 295723 */   // Label 5826: @295723
     /* 295723 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(295760), // Rule ID 5157 //
     /* 295728 */     // MIs[0] Operand 1
     /* 295728 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295747 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295751 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295758 */     GIR_RootConstrainSelectedInstOperands,
     /* 295759 */     // GIR_Coverage, 5157,
     /* 295759 */     GIR_EraseRootFromParent_Done,
     /* 295760 */   // Label 5827: @295760
     /* 295760 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(295797), // Rule ID 5164 //
     /* 295765 */     // MIs[0] Operand 1
     /* 295765 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295778 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295784 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295788 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295795 */     GIR_RootConstrainSelectedInstOperands,
     /* 295796 */     // GIR_Coverage, 5164,
     /* 295796 */     GIR_EraseRootFromParent_Done,
     /* 295797 */   // Label 5828: @295797
     /* 295797 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(295834), // Rule ID 5171 //
     /* 295802 */     // MIs[0] Operand 1
     /* 295802 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295815 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295821 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295825 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295832 */     GIR_RootConstrainSelectedInstOperands,
     /* 295833 */     // GIR_Coverage, 5171,
     /* 295833 */     GIR_EraseRootFromParent_Done,
     /* 295834 */   // Label 5829: @295834
     /* 295834 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(295871), // Rule ID 5178 //
     /* 295839 */     // MIs[0] Operand 1
     /* 295839 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295862 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295869 */     GIR_RootConstrainSelectedInstOperands,
     /* 295870 */     // GIR_Coverage, 5178,
     /* 295870 */     GIR_EraseRootFromParent_Done,
     /* 295871 */   // Label 5830: @295871
     /* 295871 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(295908), // Rule ID 5185 //
     /* 295876 */     // MIs[0] Operand 1
     /* 295876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295889 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295895 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295899 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295906 */     GIR_RootConstrainSelectedInstOperands,
     /* 295907 */     // GIR_Coverage, 5185,
     /* 295907 */     GIR_EraseRootFromParent_Done,
     /* 295908 */   // Label 5831: @295908
     /* 295908 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(295940), // Rule ID 1122 //
     /* 295913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295916 */     // MIs[0] Operand 1
     /* 295916 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295929 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 295932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295938 */     GIR_RootConstrainSelectedInstOperands,
     /* 295939 */     // GIR_Coverage, 1122,
     /* 295939 */     GIR_EraseRootFromParent_Done,
     /* 295940 */   // Label 5832: @295940
     /* 295940 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(295972), // Rule ID 1129 //
     /* 295945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295948 */     // MIs[0] Operand 1
     /* 295948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295961 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 295964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295970 */     GIR_RootConstrainSelectedInstOperands,
     /* 295971 */     // GIR_Coverage, 1129,
     /* 295971 */     GIR_EraseRootFromParent_Done,
     /* 295972 */   // Label 5833: @295972
     /* 295972 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(296004), // Rule ID 1136 //
     /* 295977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295980 */     // MIs[0] Operand 1
     /* 295980 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295993 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 295996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296002 */     GIR_RootConstrainSelectedInstOperands,
     /* 296003 */     // GIR_Coverage, 1136,
     /* 296003 */     GIR_EraseRootFromParent_Done,
     /* 296004 */   // Label 5834: @296004
     /* 296004 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(296036), // Rule ID 1143 //
     /* 296009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296012 */     // MIs[0] Operand 1
     /* 296012 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296025 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296034 */     GIR_RootConstrainSelectedInstOperands,
     /* 296035 */     // GIR_Coverage, 1143,
     /* 296035 */     GIR_EraseRootFromParent_Done,
     /* 296036 */   // Label 5835: @296036
     /* 296036 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(296068), // Rule ID 1150 //
     /* 296041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296044 */     // MIs[0] Operand 1
     /* 296044 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296057 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296066 */     GIR_RootConstrainSelectedInstOperands,
     /* 296067 */     // GIR_Coverage, 1150,
     /* 296067 */     GIR_EraseRootFromParent_Done,
     /* 296068 */   // Label 5836: @296068
     /* 296068 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(296097), // Rule ID 5094 //
     /* 296073 */     // MIs[0] Operand 1
     /* 296073 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296086 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 296089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296095 */     GIR_RootConstrainSelectedInstOperands,
     /* 296096 */     // GIR_Coverage, 5094,
     /* 296096 */     GIR_EraseRootFromParent_Done,
     /* 296097 */   // Label 5837: @296097
     /* 296097 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(296126), // Rule ID 5101 //
     /* 296102 */     // MIs[0] Operand 1
     /* 296102 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296115 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296124 */     GIR_RootConstrainSelectedInstOperands,
     /* 296125 */     // GIR_Coverage, 5101,
     /* 296125 */     GIR_EraseRootFromParent_Done,
     /* 296126 */   // Label 5838: @296126
     /* 296126 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(296155), // Rule ID 5108 //
     /* 296131 */     // MIs[0] Operand 1
     /* 296131 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296144 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296153 */     GIR_RootConstrainSelectedInstOperands,
     /* 296154 */     // GIR_Coverage, 5108,
     /* 296154 */     GIR_EraseRootFromParent_Done,
     /* 296155 */   // Label 5839: @296155
     /* 296155 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(296184), // Rule ID 5115 //
     /* 296160 */     // MIs[0] Operand 1
     /* 296160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296173 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296182 */     GIR_RootConstrainSelectedInstOperands,
     /* 296183 */     // GIR_Coverage, 5115,
     /* 296183 */     GIR_EraseRootFromParent_Done,
     /* 296184 */   // Label 5840: @296184
     /* 296184 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(296213), // Rule ID 5122 //
     /* 296189 */     // MIs[0] Operand 1
     /* 296189 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296202 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296211 */     GIR_RootConstrainSelectedInstOperands,
     /* 296212 */     // GIR_Coverage, 5122,
     /* 296212 */     GIR_EraseRootFromParent_Done,
     /* 296213 */   // Label 5841: @296213
     /* 296213 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(296242), // Rule ID 5129 //
     /* 296218 */     // MIs[0] Operand 1
     /* 296218 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296231 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296240 */     GIR_RootConstrainSelectedInstOperands,
     /* 296241 */     // GIR_Coverage, 5129,
     /* 296241 */     GIR_EraseRootFromParent_Done,
     /* 296242 */   // Label 5842: @296242
     /* 296242 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(296271), // Rule ID 5136 //
     /* 296247 */     // MIs[0] Operand 1
     /* 296247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296260 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296269 */     GIR_RootConstrainSelectedInstOperands,
     /* 296270 */     // GIR_Coverage, 5136,
     /* 296270 */     GIR_EraseRootFromParent_Done,
     /* 296271 */   // Label 5843: @296271
     /* 296271 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(296300), // Rule ID 5143 //
     /* 296276 */     // MIs[0] Operand 1
     /* 296276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 296281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296289 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296298 */     GIR_RootConstrainSelectedInstOperands,
     /* 296299 */     // GIR_Coverage, 5143,
     /* 296299 */     GIR_EraseRootFromParent_Done,
     /* 296300 */   // Label 5844: @296300
     /* 296300 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(296329), // Rule ID 5150 //
     /* 296305 */     // MIs[0] Operand 1
     /* 296305 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 296310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296318 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296327 */     GIR_RootConstrainSelectedInstOperands,
     /* 296328 */     // GIR_Coverage, 5150,
     /* 296328 */     GIR_EraseRootFromParent_Done,
     /* 296329 */   // Label 5845: @296329
     /* 296329 */   GIM_Reject,
     /* 296330 */ // Label 5815: @296330
     /* 296330 */ GIM_Reject,
     /* 296331 */ // Label 5616: @296331
     /* 296331 */ GIM_Reject,
     /* 296332 */ // Label 52: @296332
     /* 296332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5858*/ GIMT_Encode4(297376),
     /* 296343 */ /*GILLT_nxv1s1*//*Label 5846*/ GIMT_Encode4(296391),
     /* 296347 */ /*GILLT_nxv2s1*//*Label 5847*/ GIMT_Encode4(296420),
     /* 296351 */ /*GILLT_nxv2s16*//*Label 5848*/ GIMT_Encode4(296449),
     /* 296355 */ /*GILLT_nxv2s32*//*Label 5849*/ GIMT_Encode4(296534),
     /* 296359 */ /*GILLT_nxv2s64*//*Label 5850*/ GIMT_Encode4(296619),
     /* 296363 */ /*GILLT_nxv4s1*//*Label 5851*/ GIMT_Encode4(296785),
     /* 296367 */ /*GILLT_nxv4s16*//*Label 5852*/ GIMT_Encode4(296814),
     /* 296371 */ /*GILLT_nxv4s32*//*Label 5853*/ GIMT_Encode4(296899),
     /* 296375 */ /*GILLT_nxv8s1*//*Label 5854*/ GIMT_Encode4(297065),
     /* 296379 */ /*GILLT_nxv8s16*//*Label 5855*/ GIMT_Encode4(297094),
     /* 296383 */ /*GILLT_nxv16s1*//*Label 5856*/ GIMT_Encode4(297260),
     /* 296387 */ /*GILLT_nxv16s8*//*Label 5857*/ GIMT_Encode4(297289),
     /* 296391 */ // Label 5846: @296391
     /* 296391 */ GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(296419), // Rule ID 8512 //
     /* 296396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 296402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 296405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 296408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296412 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 296412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296417 */   GIR_RootConstrainSelectedInstOperands,
     /* 296418 */   // GIR_Coverage, 8512,
     /* 296418 */   GIR_Done,
     /* 296419 */ // Label 5859: @296419
     /* 296419 */ GIM_Reject,
     /* 296420 */ // Label 5847: @296420
     /* 296420 */ GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(296448), // Rule ID 8511 //
     /* 296425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 296434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 296437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296441 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 296441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296446 */   GIR_RootConstrainSelectedInstOperands,
     /* 296447 */   // GIR_Coverage, 8511,
     /* 296447 */   GIR_Done,
     /* 296448 */ // Label 5860: @296448
     /* 296448 */ GIM_Reject,
     /* 296449 */ // Label 5848: @296449
     /* 296449 */ GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(296533),
     /* 296454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 296460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 296463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296467 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(296517), // Rule ID 3157 //
     /* 296472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296495 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 296499 */     // MIs[2] Operand 1
     /* 296499 */     // No operand predicates
     /* 296499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296501 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 296501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 296504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296506 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296508 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296510 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 296515 */     GIR_RootConstrainSelectedInstOperands,
     /* 296516 */     // GIR_Coverage, 3157,
     /* 296516 */     GIR_EraseRootFromParent_Done,
     /* 296517 */   // Label 5862: @296517
     /* 296517 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(296532), // Rule ID 2737 //
     /* 296522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296525 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 296525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296530 */     GIR_RootConstrainSelectedInstOperands,
     /* 296531 */     // GIR_Coverage, 2737,
     /* 296531 */     GIR_Done,
     /* 296532 */   // Label 5863: @296532
     /* 296532 */   GIM_Reject,
     /* 296533 */ // Label 5861: @296533
     /* 296533 */ GIM_Reject,
     /* 296534 */ // Label 5849: @296534
     /* 296534 */ GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(296618),
     /* 296539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 296545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 296548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296552 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(296602), // Rule ID 3159 //
     /* 296557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296580 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 296584 */     // MIs[2] Operand 1
     /* 296584 */     // No operand predicates
     /* 296584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296586 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 296586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 296589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296591 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296593 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296595 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 296600 */     GIR_RootConstrainSelectedInstOperands,
     /* 296601 */     // GIR_Coverage, 3159,
     /* 296601 */     GIR_EraseRootFromParent_Done,
     /* 296602 */   // Label 5865: @296602
     /* 296602 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(296617), // Rule ID 2738 //
     /* 296607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296610 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 296610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296615 */     GIR_RootConstrainSelectedInstOperands,
     /* 296616 */     // GIR_Coverage, 2738,
     /* 296616 */     GIR_Done,
     /* 296617 */   // Label 5866: @296617
     /* 296617 */   GIM_Reject,
     /* 296618 */ // Label 5864: @296618
     /* 296618 */ GIM_Reject,
     /* 296619 */ // Label 5850: @296619
     /* 296619 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(296784),
     /* 296624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 296630 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(296687), // Rule ID 3160 //
     /* 296635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296665 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 296669 */     // MIs[2] Operand 1
     /* 296669 */     // No operand predicates
     /* 296669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296671 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 296671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 296674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296676 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296678 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296680 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 296685 */     GIR_RootConstrainSelectedInstOperands,
     /* 296686 */     // GIR_Coverage, 3160,
     /* 296686 */     GIR_EraseRootFromParent_Done,
     /* 296687 */   // Label 5868: @296687
     /* 296687 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(296739), // Rule ID 7558 //
     /* 296692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 296707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 296711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 296715 */     // MIs[0] Op2
     /* 296715 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 296720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296722 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 296722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 296725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 296727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 296729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 296733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 296737 */     GIR_RootConstrainSelectedInstOperands,
     /* 296738 */     // GIR_Coverage, 7558,
     /* 296738 */     GIR_EraseRootFromParent_Done,
     /* 296739 */   // Label 5869: @296739
     /* 296739 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(296761), // Rule ID 2733 //
     /* 296744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296754 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 296754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296759 */     GIR_RootConstrainSelectedInstOperands,
     /* 296760 */     // GIR_Coverage, 2733,
     /* 296760 */     GIR_Done,
     /* 296761 */   // Label 5870: @296761
     /* 296761 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(296783), // Rule ID 2739 //
     /* 296766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296776 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 296776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296781 */     GIR_RootConstrainSelectedInstOperands,
     /* 296782 */     // GIR_Coverage, 2739,
     /* 296782 */     GIR_Done,
     /* 296783 */   // Label 5871: @296783
     /* 296783 */   GIM_Reject,
     /* 296784 */ // Label 5867: @296784
     /* 296784 */ GIM_Reject,
     /* 296785 */ // Label 5851: @296785
     /* 296785 */ GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(296813), // Rule ID 8510 //
     /* 296790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 296799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 296802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296806 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 296806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296811 */   GIR_RootConstrainSelectedInstOperands,
     /* 296812 */   // GIR_Coverage, 8510,
     /* 296812 */   GIR_Done,
     /* 296813 */ // Label 5872: @296813
     /* 296813 */ GIM_Reject,
     /* 296814 */ // Label 5852: @296814
     /* 296814 */ GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(296898),
     /* 296819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 296825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 296828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296832 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(296882), // Rule ID 3156 //
     /* 296837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296860 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 296864 */     // MIs[2] Operand 1
     /* 296864 */     // No operand predicates
     /* 296864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296866 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 296866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 296869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296871 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296873 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296875 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 296880 */     GIR_RootConstrainSelectedInstOperands,
     /* 296881 */     // GIR_Coverage, 3156,
     /* 296881 */     GIR_EraseRootFromParent_Done,
     /* 296882 */   // Label 5874: @296882
     /* 296882 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(296897), // Rule ID 2735 //
     /* 296887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296890 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 296890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 296895 */     GIR_RootConstrainSelectedInstOperands,
     /* 296896 */     // GIR_Coverage, 2735,
     /* 296896 */     GIR_Done,
     /* 296897 */   // Label 5875: @296897
     /* 296897 */   GIM_Reject,
     /* 296898 */ // Label 5873: @296898
     /* 296898 */ GIM_Reject,
     /* 296899 */ // Label 5853: @296899
     /* 296899 */ GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(297064),
     /* 296904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 296910 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(296967), // Rule ID 3158 //
     /* 296915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 296921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296945 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 296949 */     // MIs[2] Operand 1
     /* 296949 */     // No operand predicates
     /* 296949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296951 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 296951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 296954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296956 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296958 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296960 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 296965 */     GIR_RootConstrainSelectedInstOperands,
     /* 296966 */     // GIR_Coverage, 3158,
     /* 296966 */     GIR_EraseRootFromParent_Done,
     /* 296967 */   // Label 5877: @296967
     /* 296967 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(297019), // Rule ID 7556 //
     /* 296972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 296987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 296991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 296995 */     // MIs[0] Op2
     /* 296995 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297002 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 297002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 297005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297017 */     GIR_RootConstrainSelectedInstOperands,
     /* 297018 */     // GIR_Coverage, 7556,
     /* 297018 */     GIR_EraseRootFromParent_Done,
     /* 297019 */   // Label 5878: @297019
     /* 297019 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(297041), // Rule ID 2732 //
     /* 297024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 297030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297034 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 297034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 297039 */     GIR_RootConstrainSelectedInstOperands,
     /* 297040 */     // GIR_Coverage, 2732,
     /* 297040 */     GIR_Done,
     /* 297041 */   // Label 5879: @297041
     /* 297041 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(297063), // Rule ID 2736 //
     /* 297046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 297052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297056 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 297056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 297061 */     GIR_RootConstrainSelectedInstOperands,
     /* 297062 */     // GIR_Coverage, 2736,
     /* 297062 */     GIR_Done,
     /* 297063 */   // Label 5880: @297063
     /* 297063 */   GIM_Reject,
     /* 297064 */ // Label 5876: @297064
     /* 297064 */ GIM_Reject,
     /* 297065 */ // Label 5854: @297065
     /* 297065 */ GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(297093), // Rule ID 8509 //
     /* 297070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 297076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 297079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 297082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297086 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 297086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297091 */   GIR_RootConstrainSelectedInstOperands,
     /* 297092 */   // GIR_Coverage, 8509,
     /* 297092 */   GIR_Done,
     /* 297093 */ // Label 5881: @297093
     /* 297093 */ GIM_Reject,
     /* 297094 */ // Label 5855: @297094
     /* 297094 */ GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(297259),
     /* 297099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 297102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297105 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(297162), // Rule ID 3155 //
     /* 297110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 297128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 297140 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 297144 */     // MIs[2] Operand 1
     /* 297144 */     // No operand predicates
     /* 297144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297146 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 297146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 297149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 297151 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 297153 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 297155 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 297160 */     GIR_RootConstrainSelectedInstOperands,
     /* 297161 */     // GIR_Coverage, 3155,
     /* 297161 */     GIR_EraseRootFromParent_Done,
     /* 297162 */   // Label 5883: @297162
     /* 297162 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(297214), // Rule ID 7554 //
     /* 297167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 297186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297190 */     // MIs[0] Op2
     /* 297190 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297197 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 297200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297212 */     GIR_RootConstrainSelectedInstOperands,
     /* 297213 */     // GIR_Coverage, 7554,
     /* 297213 */     GIR_EraseRootFromParent_Done,
     /* 297214 */   // Label 5884: @297214
     /* 297214 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(297236), // Rule ID 2731 //
     /* 297219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297229 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297234 */     GIR_RootConstrainSelectedInstOperands,
     /* 297235 */     // GIR_Coverage, 2731,
     /* 297235 */     GIR_Done,
     /* 297236 */   // Label 5885: @297236
     /* 297236 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(297258), // Rule ID 2734 //
     /* 297241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297251 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 297251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297256 */     GIR_RootConstrainSelectedInstOperands,
     /* 297257 */     // GIR_Coverage, 2734,
     /* 297257 */     GIR_Done,
     /* 297258 */   // Label 5886: @297258
     /* 297258 */   GIM_Reject,
     /* 297259 */ // Label 5882: @297259
     /* 297259 */ GIM_Reject,
     /* 297260 */ // Label 5856: @297260
     /* 297260 */ GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(297288), // Rule ID 8508 //
     /* 297265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 297274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 297277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297281 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 297281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297286 */   GIR_RootConstrainSelectedInstOperands,
     /* 297287 */   // GIR_Coverage, 8508,
     /* 297287 */   GIR_Done,
     /* 297288 */ // Label 5887: @297288
     /* 297288 */ GIM_Reject,
     /* 297289 */ // Label 5857: @297289
     /* 297289 */ GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(297375),
     /* 297294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297300 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(297352), // Rule ID 7552 //
     /* 297305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 297324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297328 */     // MIs[0] Op2
     /* 297328 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297335 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 297338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297350 */     GIR_RootConstrainSelectedInstOperands,
     /* 297351 */     // GIR_Coverage, 7552,
     /* 297351 */     GIR_EraseRootFromParent_Done,
     /* 297352 */   // Label 5889: @297352
     /* 297352 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(297374), // Rule ID 2730 //
     /* 297357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 297363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297367 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 297372 */     GIR_RootConstrainSelectedInstOperands,
     /* 297373 */     // GIR_Coverage, 2730,
     /* 297373 */     GIR_Done,
     /* 297374 */   // Label 5890: @297374
     /* 297374 */   GIM_Reject,
     /* 297375 */ // Label 5888: @297375
     /* 297375 */ GIM_Reject,
     /* 297376 */ // Label 5858: @297376
     /* 297376 */ GIM_Reject,
     /* 297377 */ // Label 53: @297377
     /* 297377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5895*/ GIMT_Encode4(297860),
     /* 297388 */ /*GILLT_s64*//*Label 5891*/ GIMT_Encode4(297424), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297408 */ /*GILLT_v4s32*//*Label 5892*/ GIMT_Encode4(297455), GIMT_Encode4(0),
     /* 297416 */ /*GILLT_v8s16*//*Label 5893*/ GIMT_Encode4(297590),
     /* 297420 */ /*GILLT_v16s8*//*Label 5894*/ GIMT_Encode4(297725),
     /* 297424 */ // Label 5891: @297424
     /* 297424 */ GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(297454), // Rule ID 128 //
     /* 297429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297447 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 297447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 297452 */   GIR_RootConstrainSelectedInstOperands,
     /* 297453 */   // GIR_Coverage, 128,
     /* 297453 */   GIR_Done,
     /* 297454 */ // Label 5896: @297454
     /* 297454 */ GIM_Reject,
     /* 297455 */ // Label 5892: @297455
     /* 297455 */ GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(297589), // Rule ID 6578 //
     /* 297460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297478 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 297478 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297481 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 297485 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297490 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297494 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297500 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297503 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297507 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297512 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297518 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297523 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297540 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297546 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297551 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 297563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 297579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297587 */   GIR_RootConstrainSelectedInstOperands,
     /* 297588 */   // GIR_Coverage, 6578,
     /* 297588 */   GIR_EraseRootFromParent_Done,
     /* 297589 */ // Label 5897: @297589
     /* 297589 */ GIM_Reject,
     /* 297590 */ // Label 5893: @297590
     /* 297590 */ GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(297724), // Rule ID 6577 //
     /* 297595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 297601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297613 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 297613 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297616 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 297620 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297625 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297629 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297635 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297638 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297642 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297647 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297653 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297658 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297663 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297666 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297670 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297675 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297681 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297686 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 297698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297703 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297706 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 297714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297722 */   GIR_RootConstrainSelectedInstOperands,
     /* 297723 */   // GIR_Coverage, 6577,
     /* 297723 */   GIR_EraseRootFromParent_Done,
     /* 297724 */ // Label 5898: @297724
     /* 297724 */ GIM_Reject,
     /* 297725 */ // Label 5894: @297725
     /* 297725 */ GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(297859), // Rule ID 6576 //
     /* 297730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 297733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 297736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297748 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 297748 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297751 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 297755 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297760 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297764 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297770 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297773 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297777 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297782 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297788 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297793 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297798 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297801 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297805 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297810 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297816 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297821 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 297833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297838 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297841 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 297849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297857 */   GIR_RootConstrainSelectedInstOperands,
     /* 297858 */   // GIR_Coverage, 6576,
     /* 297858 */   GIR_EraseRootFromParent_Done,
     /* 297859 */ // Label 5899: @297859
     /* 297859 */ GIM_Reject,
     /* 297860 */ // Label 5895: @297860
     /* 297860 */ GIM_Reject,
     /* 297861 */ // Label 54: @297861
     /* 297861 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5904*/ GIMT_Encode4(298344),
     /* 297872 */ /*GILLT_s64*//*Label 5900*/ GIMT_Encode4(297908), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297892 */ /*GILLT_v4s32*//*Label 5901*/ GIMT_Encode4(297939), GIMT_Encode4(0),
     /* 297900 */ /*GILLT_v8s16*//*Label 5902*/ GIMT_Encode4(298074),
     /* 297904 */ /*GILLT_v16s8*//*Label 5903*/ GIMT_Encode4(298209),
     /* 297908 */ // Label 5900: @297908
     /* 297908 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(297938), // Rule ID 127 //
     /* 297913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297931 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 297931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 297936 */   GIR_RootConstrainSelectedInstOperands,
     /* 297937 */   // GIR_Coverage, 127,
     /* 297937 */   GIR_Done,
     /* 297938 */ // Label 5905: @297938
     /* 297938 */ GIM_Reject,
     /* 297939 */ // Label 5901: @297939
     /* 297939 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(298073), // Rule ID 6575 //
     /* 297944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297962 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 297962 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297965 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 297969 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297974 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297978 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297984 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297987 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297991 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297996 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298002 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298007 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298024 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298030 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298035 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 298047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298055 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 298063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298071 */   GIR_RootConstrainSelectedInstOperands,
     /* 298072 */   // GIR_Coverage, 6575,
     /* 298072 */   GIR_EraseRootFromParent_Done,
     /* 298073 */ // Label 5906: @298073
     /* 298073 */ GIM_Reject,
     /* 298074 */ // Label 5902: @298074
     /* 298074 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(298208), // Rule ID 6574 //
     /* 298079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 298085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298097 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 298097 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298100 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 298104 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298109 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298113 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298119 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298122 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298126 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298131 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298137 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298142 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298147 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298150 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298154 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298159 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298165 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298170 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298175 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298178 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 298182 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298187 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298190 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 298198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298206 */   GIR_RootConstrainSelectedInstOperands,
     /* 298207 */   // GIR_Coverage, 6574,
     /* 298207 */   GIR_EraseRootFromParent_Done,
     /* 298208 */ // Label 5907: @298208
     /* 298208 */ GIM_Reject,
     /* 298209 */ // Label 5903: @298209
     /* 298209 */ GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(298343), // Rule ID 6573 //
     /* 298214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298232 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 298232 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298235 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 298239 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298244 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298248 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298254 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298257 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298261 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298266 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298272 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298277 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298294 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298300 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298305 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 298317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298322 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298325 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 298333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298341 */   GIR_RootConstrainSelectedInstOperands,
     /* 298342 */   // GIR_Coverage, 6573,
     /* 298342 */   GIR_EraseRootFromParent_Done,
     /* 298343 */ // Label 5908: @298343
     /* 298343 */ GIM_Reject,
     /* 298344 */ // Label 5904: @298344
     /* 298344 */ GIM_Reject,
     /* 298345 */ // Label 55: @298345
     /* 298345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5921*/ GIMT_Encode4(298816),
     /* 298356 */ /*GILLT_s64*//*Label 5909*/ GIMT_Encode4(298440), GIMT_Encode4(0),
     /* 298364 */ /*GILLT_v2s32*//*Label 5910*/ GIMT_Encode4(298474),
     /* 298368 */ /*GILLT_v2s64*//*Label 5911*/ GIMT_Encode4(298508),
     /* 298372 */ /*GILLT_v4s16*//*Label 5912*/ GIMT_Encode4(298542),
     /* 298376 */ /*GILLT_v4s32*//*Label 5913*/ GIMT_Encode4(298576),
     /* 298380 */ /*GILLT_v8s8*//*Label 5914*/ GIMT_Encode4(298610),
     /* 298384 */ /*GILLT_v8s16*//*Label 5915*/ GIMT_Encode4(298644),
     /* 298388 */ /*GILLT_v16s8*//*Label 5916*/ GIMT_Encode4(298678), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298408 */ /*GILLT_nxv2s64*//*Label 5917*/ GIMT_Encode4(298712), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298420 */ /*GILLT_nxv4s32*//*Label 5918*/ GIMT_Encode4(298738), GIMT_Encode4(0),
     /* 298428 */ /*GILLT_nxv8s16*//*Label 5919*/ GIMT_Encode4(298764), GIMT_Encode4(0),
     /* 298436 */ /*GILLT_nxv16s8*//*Label 5920*/ GIMT_Encode4(298790),
     /* 298440 */ // Label 5909: @298440
     /* 298440 */ GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(298473), // Rule ID 1645 //
     /* 298445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298466 */   // (uaddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 298466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 298471 */   GIR_RootConstrainSelectedInstOperands,
     /* 298472 */   // GIR_Coverage, 1645,
     /* 298472 */   GIR_Done,
     /* 298473 */ // Label 5922: @298473
     /* 298473 */ GIM_Reject,
     /* 298474 */ // Label 5910: @298474
     /* 298474 */ GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(298507), // Rule ID 1543 //
     /* 298479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298500 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 298505 */   GIR_RootConstrainSelectedInstOperands,
     /* 298506 */   // GIR_Coverage, 1543,
     /* 298506 */   GIR_Done,
     /* 298507 */ // Label 5923: @298507
     /* 298507 */ GIM_Reject,
     /* 298508 */ // Label 5911: @298508
     /* 298508 */ GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(298541), // Rule ID 1545 //
     /* 298513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298534 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 298534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 298539 */   GIR_RootConstrainSelectedInstOperands,
     /* 298540 */   // GIR_Coverage, 1545,
     /* 298540 */   GIR_Done,
     /* 298541 */ // Label 5924: @298541
     /* 298541 */ GIM_Reject,
     /* 298542 */ // Label 5912: @298542
     /* 298542 */ GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(298575), // Rule ID 1541 //
     /* 298547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298568 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 298568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 298573 */   GIR_RootConstrainSelectedInstOperands,
     /* 298574 */   // GIR_Coverage, 1541,
     /* 298574 */   GIR_Done,
     /* 298575 */ // Label 5925: @298575
     /* 298575 */ GIM_Reject,
     /* 298576 */ // Label 5913: @298576
     /* 298576 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(298609), // Rule ID 1544 //
     /* 298581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298602 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 298602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 298607 */   GIR_RootConstrainSelectedInstOperands,
     /* 298608 */   // GIR_Coverage, 1544,
     /* 298608 */   GIR_Done,
     /* 298609 */ // Label 5926: @298609
     /* 298609 */ GIM_Reject,
     /* 298610 */ // Label 5914: @298610
     /* 298610 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(298643), // Rule ID 1539 //
     /* 298615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 298621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 298624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298636 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 298636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 298641 */   GIR_RootConstrainSelectedInstOperands,
     /* 298642 */   // GIR_Coverage, 1539,
     /* 298642 */   GIR_Done,
     /* 298643 */ // Label 5927: @298643
     /* 298643 */ GIM_Reject,
     /* 298644 */ // Label 5915: @298644
     /* 298644 */ GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(298677), // Rule ID 1542 //
     /* 298649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 298658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298670 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 298670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 298675 */   GIR_RootConstrainSelectedInstOperands,
     /* 298676 */   // GIR_Coverage, 1542,
     /* 298676 */   GIR_Done,
     /* 298677 */ // Label 5928: @298677
     /* 298677 */ GIM_Reject,
     /* 298678 */ // Label 5916: @298678
     /* 298678 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(298711), // Rule ID 1540 //
     /* 298683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298704 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 298709 */   GIR_RootConstrainSelectedInstOperands,
     /* 298710 */   // GIR_Coverage, 1540,
     /* 298710 */   GIR_Done,
     /* 298711 */ // Label 5929: @298711
     /* 298711 */ GIM_Reject,
     /* 298712 */ // Label 5917: @298712
     /* 298712 */ GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(298737), // Rule ID 7510 //
     /* 298717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 298723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 298726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298730 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 298730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 298735 */   GIR_RootConstrainSelectedInstOperands,
     /* 298736 */   // GIR_Coverage, 7510,
     /* 298736 */   GIR_Done,
     /* 298737 */ // Label 5930: @298737
     /* 298737 */ GIM_Reject,
     /* 298738 */ // Label 5918: @298738
     /* 298738 */ GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(298763), // Rule ID 7509 //
     /* 298743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 298749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 298752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298756 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 298756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 298761 */   GIR_RootConstrainSelectedInstOperands,
     /* 298762 */   // GIR_Coverage, 7509,
     /* 298762 */   GIR_Done,
     /* 298763 */ // Label 5931: @298763
     /* 298763 */ GIM_Reject,
     /* 298764 */ // Label 5919: @298764
     /* 298764 */ GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(298789), // Rule ID 7508 //
     /* 298769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 298775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 298778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298782 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 298782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 298787 */   GIR_RootConstrainSelectedInstOperands,
     /* 298788 */   // GIR_Coverage, 7508,
     /* 298788 */   GIR_Done,
     /* 298789 */ // Label 5932: @298789
     /* 298789 */ GIM_Reject,
     /* 298790 */ // Label 5920: @298790
     /* 298790 */ GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(298815), // Rule ID 7507 //
     /* 298795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 298801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 298804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298808 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 298808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 298813 */   GIR_RootConstrainSelectedInstOperands,
     /* 298814 */   // GIR_Coverage, 7507,
     /* 298814 */   GIR_Done,
     /* 298815 */ // Label 5933: @298815
     /* 298815 */ GIM_Reject,
     /* 298816 */ // Label 5921: @298816
     /* 298816 */ GIM_Reject,
     /* 298817 */ // Label 56: @298817
     /* 298817 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5946*/ GIMT_Encode4(301192),
     /* 298828 */ /*GILLT_s64*//*Label 5934*/ GIMT_Encode4(298912), GIMT_Encode4(0),
     /* 298836 */ /*GILLT_v2s32*//*Label 5935*/ GIMT_Encode4(298946),
     /* 298840 */ /*GILLT_v2s64*//*Label 5936*/ GIMT_Encode4(298980),
     /* 298844 */ /*GILLT_v4s16*//*Label 5937*/ GIMT_Encode4(299966),
     /* 298848 */ /*GILLT_v4s32*//*Label 5938*/ GIMT_Encode4(300000),
     /* 298852 */ /*GILLT_v8s8*//*Label 5939*/ GIMT_Encode4(300986),
     /* 298856 */ /*GILLT_v8s16*//*Label 5940*/ GIMT_Encode4(301020),
     /* 298860 */ /*GILLT_v16s8*//*Label 5941*/ GIMT_Encode4(301054), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298880 */ /*GILLT_nxv2s64*//*Label 5942*/ GIMT_Encode4(301088), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298892 */ /*GILLT_nxv4s32*//*Label 5943*/ GIMT_Encode4(301114), GIMT_Encode4(0),
     /* 298900 */ /*GILLT_nxv8s16*//*Label 5944*/ GIMT_Encode4(301140), GIMT_Encode4(0),
     /* 298908 */ /*GILLT_nxv16s8*//*Label 5945*/ GIMT_Encode4(301166),
     /* 298912 */ // Label 5934: @298912
     /* 298912 */ GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(298945), // Rule ID 1636 //
     /* 298917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298938 */   // (saddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 298938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 298943 */   GIR_RootConstrainSelectedInstOperands,
     /* 298944 */   // GIR_Coverage, 1636,
     /* 298944 */   GIR_Done,
     /* 298945 */ // Label 5947: @298945
     /* 298945 */ GIM_Reject,
     /* 298946 */ // Label 5935: @298946
     /* 298946 */ GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(298979), // Rule ID 1420 //
     /* 298951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298972 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 298977 */   GIR_RootConstrainSelectedInstOperands,
     /* 298978 */   // GIR_Coverage, 1420,
     /* 298978 */   GIR_Done,
     /* 298979 */ // Label 5948: @298979
     /* 298979 */ GIM_Reject,
     /* 298980 */ // Label 5936: @298980
     /* 298980 */ GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(299965),
     /* 298985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298995 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(299117), // Rule ID 13600 //
     /* 299000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299011 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299014 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299023 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299064 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299068 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299072 */     // MIs[4] Operand 1
     /* 299072 */     // No operand predicates
     /* 299072 */     // MIs[2] Operand 2
     /* 299072 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 299083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299087 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299096 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 299099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299115 */     GIR_RootConstrainSelectedInstOperands,
     /* 299116 */     // GIR_Coverage, 13600,
     /* 299116 */     GIR_EraseRootFromParent_Done,
     /* 299117 */   // Label 5950: @299117
     /* 299117 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(299239), // Rule ID 2060 //
     /* 299122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299137 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299140 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299149 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299173 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299177 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299181 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299186 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299190 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299194 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299198 */     // MIs[4] Operand 1
     /* 299198 */     // No operand predicates
     /* 299198 */     // MIs[2] Operand 2
     /* 299198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 299209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299218 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 299221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299237 */     GIR_RootConstrainSelectedInstOperands,
     /* 299238 */     // GIR_Coverage, 2060,
     /* 299238 */     GIR_EraseRootFromParent_Done,
     /* 299239 */   // Label 5951: @299239
     /* 299239 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(299358), // Rule ID 13598 //
     /* 299244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299304 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299309 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299313 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299317 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299321 */     // MIs[4] Operand 1
     /* 299321 */     // No operand predicates
     /* 299321 */     // MIs[2] Operand 2
     /* 299321 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299336 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299338 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299356 */     GIR_RootConstrainSelectedInstOperands,
     /* 299357 */     // GIR_Coverage, 13598,
     /* 299357 */     GIR_EraseRootFromParent_Done,
     /* 299358 */   // Label 5952: @299358
     /* 299358 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(299477), // Rule ID 2058 //
     /* 299363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299390 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299423 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299427 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299440 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299444 */     // MIs[4] Operand 1
     /* 299444 */     // No operand predicates
     /* 299444 */     // MIs[2] Operand 2
     /* 299444 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299455 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299457 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299475 */     GIR_RootConstrainSelectedInstOperands,
     /* 299476 */     // GIR_Coverage, 2058,
     /* 299476 */     GIR_EraseRootFromParent_Done,
     /* 299477 */   // Label 5953: @299477
     /* 299477 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(299548), // Rule ID 13498 //
     /* 299482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299493 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299496 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299505 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299529 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299546 */     GIR_RootConstrainSelectedInstOperands,
     /* 299547 */     // GIR_Coverage, 13498,
     /* 299547 */     GIR_EraseRootFromParent_Done,
     /* 299548 */   // Label 5954: @299548
     /* 299548 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(299619), // Rule ID 1745 //
     /* 299553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299568 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299571 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299580 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299600 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299617 */     GIR_RootConstrainSelectedInstOperands,
     /* 299618 */     // GIR_Coverage, 1745,
     /* 299618 */     GIR_EraseRootFromParent_Done,
     /* 299619 */   // Label 5955: @299619
     /* 299619 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(299715), // Rule ID 13599 //
     /* 299624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299685 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299689 */     // MIs[3] Operand 1
     /* 299689 */     // No operand predicates
     /* 299689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299695 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299713 */     GIR_RootConstrainSelectedInstOperands,
     /* 299714 */     // GIR_Coverage, 13599,
     /* 299714 */     GIR_EraseRootFromParent_Done,
     /* 299715 */   // Label 5956: @299715
     /* 299715 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(299811), // Rule ID 2059 //
     /* 299720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299735 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299738 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299785 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299789 */     // MIs[3] Operand 1
     /* 299789 */     // No operand predicates
     /* 299789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299791 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299809 */     GIR_RootConstrainSelectedInstOperands,
     /* 299810 */     // GIR_Coverage, 2059,
     /* 299810 */     GIR_EraseRootFromParent_Done,
     /* 299811 */   // Label 5957: @299811
     /* 299811 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(299876), // Rule ID 13497 //
     /* 299816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299827 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299830 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299839 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299859 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 299862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299874 */     GIR_RootConstrainSelectedInstOperands,
     /* 299875 */     // GIR_Coverage, 13497,
     /* 299875 */     GIR_EraseRootFromParent_Done,
     /* 299876 */   // Label 5958: @299876
     /* 299876 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(299941), // Rule ID 1744 //
     /* 299881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299896 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299899 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299924 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 299927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299939 */     GIR_RootConstrainSelectedInstOperands,
     /* 299940 */     // GIR_Coverage, 1744,
     /* 299940 */     GIR_EraseRootFromParent_Done,
     /* 299941 */   // Label 5959: @299941
     /* 299941 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(299964), // Rule ID 1422 //
     /* 299946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299957 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 299957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 299962 */     GIR_RootConstrainSelectedInstOperands,
     /* 299963 */     // GIR_Coverage, 1422,
     /* 299963 */     GIR_Done,
     /* 299964 */   // Label 5960: @299964
     /* 299964 */   GIM_Reject,
     /* 299965 */ // Label 5949: @299965
     /* 299965 */ GIM_Reject,
     /* 299966 */ // Label 5937: @299966
     /* 299966 */ GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(299999), // Rule ID 1418 //
     /* 299971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299992 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 299997 */   GIR_RootConstrainSelectedInstOperands,
     /* 299998 */   // GIR_Coverage, 1418,
     /* 299998 */   GIR_Done,
     /* 299999 */ // Label 5961: @299999
     /* 299999 */ GIM_Reject,
     /* 300000 */ // Label 5938: @300000
     /* 300000 */ GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(300985),
     /* 300005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300015 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(300137), // Rule ID 13597 //
     /* 300020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300031 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300034 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300043 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300088 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300092 */     // MIs[4] Operand 1
     /* 300092 */     // No operand predicates
     /* 300092 */     // MIs[2] Operand 2
     /* 300092 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300107 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300116 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300135 */     GIR_RootConstrainSelectedInstOperands,
     /* 300136 */     // GIR_Coverage, 13597,
     /* 300136 */     GIR_EraseRootFromParent_Done,
     /* 300137 */   // Label 5963: @300137
     /* 300137 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(300259), // Rule ID 2057 //
     /* 300142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300157 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300160 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300169 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300197 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300201 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300206 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300210 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300214 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300218 */     // MIs[4] Operand 1
     /* 300218 */     // No operand predicates
     /* 300218 */     // MIs[2] Operand 2
     /* 300218 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300229 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300238 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300257 */     GIR_RootConstrainSelectedInstOperands,
     /* 300258 */     // GIR_Coverage, 2057,
     /* 300258 */     GIR_EraseRootFromParent_Done,
     /* 300259 */   // Label 5964: @300259
     /* 300259 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(300378), // Rule ID 13595 //
     /* 300264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300287 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300329 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300333 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300337 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300341 */     // MIs[4] Operand 1
     /* 300341 */     // No operand predicates
     /* 300341 */     // MIs[2] Operand 2
     /* 300341 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300356 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300358 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300376 */     GIR_RootConstrainSelectedInstOperands,
     /* 300377 */     // GIR_Coverage, 13595,
     /* 300377 */     GIR_EraseRootFromParent_Done,
     /* 300378 */   // Label 5965: @300378
     /* 300378 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(300497), // Rule ID 2055 //
     /* 300383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300398 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300401 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300443 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300447 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300452 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300456 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300460 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300464 */     // MIs[4] Operand 1
     /* 300464 */     // No operand predicates
     /* 300464 */     // MIs[2] Operand 2
     /* 300464 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300475 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300477 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300495 */     GIR_RootConstrainSelectedInstOperands,
     /* 300496 */     // GIR_Coverage, 2055,
     /* 300496 */     GIR_EraseRootFromParent_Done,
     /* 300497 */   // Label 5966: @300497
     /* 300497 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(300568), // Rule ID 13496 //
     /* 300502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300513 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300516 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300525 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300549 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 300552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300566 */     GIR_RootConstrainSelectedInstOperands,
     /* 300567 */     // GIR_Coverage, 13496,
     /* 300567 */     GIR_EraseRootFromParent_Done,
     /* 300568 */   // Label 5967: @300568
     /* 300568 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(300639), // Rule ID 1743 //
     /* 300573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300588 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300591 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300620 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 300623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300637 */     GIR_RootConstrainSelectedInstOperands,
     /* 300638 */     // GIR_Coverage, 1743,
     /* 300638 */     GIR_EraseRootFromParent_Done,
     /* 300639 */   // Label 5968: @300639
     /* 300639 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(300735), // Rule ID 13596 //
     /* 300644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300705 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300709 */     // MIs[3] Operand 1
     /* 300709 */     // No operand predicates
     /* 300709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300715 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300733 */     GIR_RootConstrainSelectedInstOperands,
     /* 300734 */     // GIR_Coverage, 13596,
     /* 300734 */     GIR_EraseRootFromParent_Done,
     /* 300735 */   // Label 5969: @300735
     /* 300735 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(300831), // Rule ID 2056 //
     /* 300740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300755 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300758 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300767 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300805 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300809 */     // MIs[3] Operand 1
     /* 300809 */     // No operand predicates
     /* 300809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300811 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300829 */     GIR_RootConstrainSelectedInstOperands,
     /* 300830 */     // GIR_Coverage, 2056,
     /* 300830 */     GIR_EraseRootFromParent_Done,
     /* 300831 */   // Label 5970: @300831
     /* 300831 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(300896), // Rule ID 13495 //
     /* 300836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300847 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300850 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300879 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 300882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300894 */     GIR_RootConstrainSelectedInstOperands,
     /* 300895 */     // GIR_Coverage, 13495,
     /* 300895 */     GIR_EraseRootFromParent_Done,
     /* 300896 */   // Label 5971: @300896
     /* 300896 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(300961), // Rule ID 1742 //
     /* 300901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300916 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300919 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300944 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 300947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300959 */     GIR_RootConstrainSelectedInstOperands,
     /* 300960 */     // GIR_Coverage, 1742,
     /* 300960 */     GIR_EraseRootFromParent_Done,
     /* 300961 */   // Label 5972: @300961
     /* 300961 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(300984), // Rule ID 1421 //
     /* 300966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300977 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 300977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 300982 */     GIR_RootConstrainSelectedInstOperands,
     /* 300983 */     // GIR_Coverage, 1421,
     /* 300983 */     GIR_Done,
     /* 300984 */   // Label 5973: @300984
     /* 300984 */   GIM_Reject,
     /* 300985 */ // Label 5962: @300985
     /* 300985 */ GIM_Reject,
     /* 300986 */ // Label 5939: @300986
     /* 300986 */ GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(301019), // Rule ID 1416 //
     /* 300991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 300997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301012 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 301017 */   GIR_RootConstrainSelectedInstOperands,
     /* 301018 */   // GIR_Coverage, 1416,
     /* 301018 */   GIR_Done,
     /* 301019 */ // Label 5974: @301019
     /* 301019 */ GIM_Reject,
     /* 301020 */ // Label 5940: @301020
     /* 301020 */ GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(301053), // Rule ID 1419 //
     /* 301025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301046 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 301051 */   GIR_RootConstrainSelectedInstOperands,
     /* 301052 */   // GIR_Coverage, 1419,
     /* 301052 */   GIR_Done,
     /* 301053 */ // Label 5975: @301053
     /* 301053 */ GIM_Reject,
     /* 301054 */ // Label 5941: @301054
     /* 301054 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(301087), // Rule ID 1417 //
     /* 301059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301080 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 301085 */   GIR_RootConstrainSelectedInstOperands,
     /* 301086 */   // GIR_Coverage, 1417,
     /* 301086 */   GIR_Done,
     /* 301087 */ // Label 5976: @301087
     /* 301087 */ GIM_Reject,
     /* 301088 */ // Label 5942: @301088
     /* 301088 */ GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(301113), // Rule ID 7506 //
     /* 301093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301106 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 301111 */   GIR_RootConstrainSelectedInstOperands,
     /* 301112 */   // GIR_Coverage, 7506,
     /* 301112 */   GIR_Done,
     /* 301113 */ // Label 5977: @301113
     /* 301113 */ GIM_Reject,
     /* 301114 */ // Label 5943: @301114
     /* 301114 */ GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(301139), // Rule ID 7505 //
     /* 301119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301132 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 301137 */   GIR_RootConstrainSelectedInstOperands,
     /* 301138 */   // GIR_Coverage, 7505,
     /* 301138 */   GIR_Done,
     /* 301139 */ // Label 5978: @301139
     /* 301139 */ GIM_Reject,
     /* 301140 */ // Label 5944: @301140
     /* 301140 */ GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(301165), // Rule ID 7504 //
     /* 301145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301158 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 301163 */   GIR_RootConstrainSelectedInstOperands,
     /* 301164 */   // GIR_Coverage, 7504,
     /* 301164 */   GIR_Done,
     /* 301165 */ // Label 5979: @301165
     /* 301165 */ GIM_Reject,
     /* 301166 */ // Label 5945: @301166
     /* 301166 */ GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(301191), // Rule ID 7503 //
     /* 301171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301184 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 301189 */   GIR_RootConstrainSelectedInstOperands,
     /* 301190 */   // GIR_Coverage, 7503,
     /* 301190 */   GIR_Done,
     /* 301191 */ // Label 5980: @301191
     /* 301191 */ GIM_Reject,
     /* 301192 */ // Label 5946: @301192
     /* 301192 */ GIM_Reject,
     /* 301193 */ // Label 57: @301193
     /* 301193 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5993*/ GIMT_Encode4(301664),
     /* 301204 */ /*GILLT_s64*//*Label 5981*/ GIMT_Encode4(301288), GIMT_Encode4(0),
     /* 301212 */ /*GILLT_v2s32*//*Label 5982*/ GIMT_Encode4(301322),
     /* 301216 */ /*GILLT_v2s64*//*Label 5983*/ GIMT_Encode4(301356),
     /* 301220 */ /*GILLT_v4s16*//*Label 5984*/ GIMT_Encode4(301390),
     /* 301224 */ /*GILLT_v4s32*//*Label 5985*/ GIMT_Encode4(301424),
     /* 301228 */ /*GILLT_v8s8*//*Label 5986*/ GIMT_Encode4(301458),
     /* 301232 */ /*GILLT_v8s16*//*Label 5987*/ GIMT_Encode4(301492),
     /* 301236 */ /*GILLT_v16s8*//*Label 5988*/ GIMT_Encode4(301526), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301256 */ /*GILLT_nxv2s64*//*Label 5989*/ GIMT_Encode4(301560), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301268 */ /*GILLT_nxv4s32*//*Label 5990*/ GIMT_Encode4(301586), GIMT_Encode4(0),
     /* 301276 */ /*GILLT_nxv8s16*//*Label 5991*/ GIMT_Encode4(301612), GIMT_Encode4(0),
     /* 301284 */ /*GILLT_nxv16s8*//*Label 5992*/ GIMT_Encode4(301638),
     /* 301288 */ // Label 5981: @301288
     /* 301288 */ GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(301321), // Rule ID 1648 //
     /* 301293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301314 */   // (usubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 301314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 301319 */   GIR_RootConstrainSelectedInstOperands,
     /* 301320 */   // GIR_Coverage, 1648,
     /* 301320 */   GIR_Done,
     /* 301321 */ // Label 5994: @301321
     /* 301321 */ GIM_Reject,
     /* 301322 */ // Label 5982: @301322
     /* 301322 */ GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(301355), // Rule ID 1564 //
     /* 301327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301348 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 301348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 301353 */   GIR_RootConstrainSelectedInstOperands,
     /* 301354 */   // GIR_Coverage, 1564,
     /* 301354 */   GIR_Done,
     /* 301355 */ // Label 5995: @301355
     /* 301355 */ GIM_Reject,
     /* 301356 */ // Label 5983: @301356
     /* 301356 */ GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(301389), // Rule ID 1566 //
     /* 301361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301382 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 301382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 301387 */   GIR_RootConstrainSelectedInstOperands,
     /* 301388 */   // GIR_Coverage, 1566,
     /* 301388 */   GIR_Done,
     /* 301389 */ // Label 5996: @301389
     /* 301389 */ GIM_Reject,
     /* 301390 */ // Label 5984: @301390
     /* 301390 */ GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(301423), // Rule ID 1562 //
     /* 301395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301416 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 301421 */   GIR_RootConstrainSelectedInstOperands,
     /* 301422 */   // GIR_Coverage, 1562,
     /* 301422 */   GIR_Done,
     /* 301423 */ // Label 5997: @301423
     /* 301423 */ GIM_Reject,
     /* 301424 */ // Label 5985: @301424
     /* 301424 */ GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(301457), // Rule ID 1565 //
     /* 301429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301450 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 301450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 301455 */   GIR_RootConstrainSelectedInstOperands,
     /* 301456 */   // GIR_Coverage, 1565,
     /* 301456 */   GIR_Done,
     /* 301457 */ // Label 5998: @301457
     /* 301457 */ GIM_Reject,
     /* 301458 */ // Label 5986: @301458
     /* 301458 */ GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(301491), // Rule ID 1560 //
     /* 301463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301484 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 301489 */   GIR_RootConstrainSelectedInstOperands,
     /* 301490 */   // GIR_Coverage, 1560,
     /* 301490 */   GIR_Done,
     /* 301491 */ // Label 5999: @301491
     /* 301491 */ GIM_Reject,
     /* 301492 */ // Label 5987: @301492
     /* 301492 */ GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(301525), // Rule ID 1563 //
     /* 301497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301518 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 301523 */   GIR_RootConstrainSelectedInstOperands,
     /* 301524 */   // GIR_Coverage, 1563,
     /* 301524 */   GIR_Done,
     /* 301525 */ // Label 6000: @301525
     /* 301525 */ GIM_Reject,
     /* 301526 */ // Label 5988: @301526
     /* 301526 */ GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(301559), // Rule ID 1561 //
     /* 301531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301552 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 301557 */   GIR_RootConstrainSelectedInstOperands,
     /* 301558 */   // GIR_Coverage, 1561,
     /* 301558 */   GIR_Done,
     /* 301559 */ // Label 6001: @301559
     /* 301559 */ GIM_Reject,
     /* 301560 */ // Label 5989: @301560
     /* 301560 */ GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(301585), // Rule ID 7518 //
     /* 301565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301578 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 301583 */   GIR_RootConstrainSelectedInstOperands,
     /* 301584 */   // GIR_Coverage, 7518,
     /* 301584 */   GIR_Done,
     /* 301585 */ // Label 6002: @301585
     /* 301585 */ GIM_Reject,
     /* 301586 */ // Label 5990: @301586
     /* 301586 */ GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(301611), // Rule ID 7517 //
     /* 301591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301604 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 301609 */   GIR_RootConstrainSelectedInstOperands,
     /* 301610 */   // GIR_Coverage, 7517,
     /* 301610 */   GIR_Done,
     /* 301611 */ // Label 6003: @301611
     /* 301611 */ GIM_Reject,
     /* 301612 */ // Label 5991: @301612
     /* 301612 */ GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(301637), // Rule ID 7516 //
     /* 301617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301630 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 301635 */   GIR_RootConstrainSelectedInstOperands,
     /* 301636 */   // GIR_Coverage, 7516,
     /* 301636 */   GIR_Done,
     /* 301637 */ // Label 6004: @301637
     /* 301637 */ GIM_Reject,
     /* 301638 */ // Label 5992: @301638
     /* 301638 */ GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(301663), // Rule ID 7515 //
     /* 301643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301656 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 301661 */   GIR_RootConstrainSelectedInstOperands,
     /* 301662 */   // GIR_Coverage, 7515,
     /* 301662 */   GIR_Done,
     /* 301663 */ // Label 6005: @301663
     /* 301663 */ GIM_Reject,
     /* 301664 */ // Label 5993: @301664
     /* 301664 */ GIM_Reject,
     /* 301665 */ // Label 58: @301665
     /* 301665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6018*/ GIMT_Encode4(303054),
     /* 301676 */ /*GILLT_s64*//*Label 6006*/ GIMT_Encode4(301760), GIMT_Encode4(0),
     /* 301684 */ /*GILLT_v2s32*//*Label 6007*/ GIMT_Encode4(301794),
     /* 301688 */ /*GILLT_v2s64*//*Label 6008*/ GIMT_Encode4(301828),
     /* 301692 */ /*GILLT_v4s16*//*Label 6009*/ GIMT_Encode4(302321),
     /* 301696 */ /*GILLT_v4s32*//*Label 6010*/ GIMT_Encode4(302355),
     /* 301700 */ /*GILLT_v8s8*//*Label 6011*/ GIMT_Encode4(302848),
     /* 301704 */ /*GILLT_v8s16*//*Label 6012*/ GIMT_Encode4(302882),
     /* 301708 */ /*GILLT_v16s8*//*Label 6013*/ GIMT_Encode4(302916), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301728 */ /*GILLT_nxv2s64*//*Label 6014*/ GIMT_Encode4(302950), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301740 */ /*GILLT_nxv4s32*//*Label 6015*/ GIMT_Encode4(302976), GIMT_Encode4(0),
     /* 301748 */ /*GILLT_nxv8s16*//*Label 6016*/ GIMT_Encode4(303002), GIMT_Encode4(0),
     /* 301756 */ /*GILLT_nxv16s8*//*Label 6017*/ GIMT_Encode4(303028),
     /* 301760 */ // Label 6006: @301760
     /* 301760 */ GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(301793), // Rule ID 1641 //
     /* 301765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301786 */   // (ssubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 301786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 301791 */   GIR_RootConstrainSelectedInstOperands,
     /* 301792 */   // GIR_Coverage, 1641,
     /* 301792 */   GIR_Done,
     /* 301793 */ // Label 6019: @301793
     /* 301793 */ GIM_Reject,
     /* 301794 */ // Label 6007: @301794
     /* 301794 */ GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(301827), // Rule ID 1449 //
     /* 301799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301820 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 301820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 301825 */   GIR_RootConstrainSelectedInstOperands,
     /* 301826 */   // GIR_Coverage, 1449,
     /* 301826 */   GIR_Done,
     /* 301827 */ // Label 6020: @301827
     /* 301827 */ GIM_Reject,
     /* 301828 */ // Label 6008: @301828
     /* 301828 */ GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(302320),
     /* 301833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301847 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(301965), // Rule ID 2067 //
     /* 301852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301863 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301866 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301875 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 301883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 301887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 301895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301903 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 301907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301912 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 301916 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301920 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301924 */     // MIs[4] Operand 1
     /* 301924 */     // No operand predicates
     /* 301924 */     // MIs[2] Operand 2
     /* 301924 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 301935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 301937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 301944 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 301947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 301956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 301960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 301963 */     GIR_RootConstrainSelectedInstOperands,
     /* 301964 */     // GIR_Coverage, 2067,
     /* 301964 */     GIR_EraseRootFromParent_Done,
     /* 301965 */   // Label 6022: @301965
     /* 301965 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(302080), // Rule ID 2065 //
     /* 301970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301981 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301984 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301993 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302030 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302035 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302039 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302043 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302047 */     // MIs[4] Operand 1
     /* 302047 */     // No operand predicates
     /* 302047 */     // MIs[2] Operand 2
     /* 302047 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 302058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302060 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 302063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302078 */     GIR_RootConstrainSelectedInstOperands,
     /* 302079 */     // GIR_Coverage, 2065,
     /* 302079 */     GIR_EraseRootFromParent_Done,
     /* 302080 */   // Label 6023: @302080
     /* 302080 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(302147), // Rule ID 1749 //
     /* 302085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302128 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 302128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 302131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 302145 */     GIR_RootConstrainSelectedInstOperands,
     /* 302146 */     // GIR_Coverage, 1749,
     /* 302146 */     GIR_EraseRootFromParent_Done,
     /* 302147 */   // Label 6024: @302147
     /* 302147 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(302239), // Rule ID 2066 //
     /* 302152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302163 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302166 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302175 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302217 */     // MIs[3] Operand 1
     /* 302217 */     // No operand predicates
     /* 302217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302219 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 302222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302237 */     GIR_RootConstrainSelectedInstOperands,
     /* 302238 */     // GIR_Coverage, 2066,
     /* 302238 */     GIR_EraseRootFromParent_Done,
     /* 302239 */   // Label 6025: @302239
     /* 302239 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(302300), // Rule ID 1748 //
     /* 302244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302283 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 302283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 302286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 302298 */     GIR_RootConstrainSelectedInstOperands,
     /* 302299 */     // GIR_Coverage, 1748,
     /* 302299 */     GIR_EraseRootFromParent_Done,
     /* 302300 */   // Label 6026: @302300
     /* 302300 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(302319), // Rule ID 1451 //
     /* 302305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302312 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 302312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 302317 */     GIR_RootConstrainSelectedInstOperands,
     /* 302318 */     // GIR_Coverage, 1451,
     /* 302318 */     GIR_Done,
     /* 302319 */   // Label 6027: @302319
     /* 302319 */   GIM_Reject,
     /* 302320 */ // Label 6021: @302320
     /* 302320 */ GIM_Reject,
     /* 302321 */ // Label 6009: @302321
     /* 302321 */ GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(302354), // Rule ID 1447 //
     /* 302326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302347 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 302347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 302352 */   GIR_RootConstrainSelectedInstOperands,
     /* 302353 */   // GIR_Coverage, 1447,
     /* 302353 */   GIR_Done,
     /* 302354 */ // Label 6028: @302354
     /* 302354 */ GIM_Reject,
     /* 302355 */ // Label 6010: @302355
     /* 302355 */ GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(302847),
     /* 302360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302374 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(302492), // Rule ID 2064 //
     /* 302379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302390 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302393 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302430 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302434 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302443 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302447 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302451 */     // MIs[4] Operand 1
     /* 302451 */     // No operand predicates
     /* 302451 */     // MIs[2] Operand 2
     /* 302451 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 302462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302471 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 302474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302490 */     GIR_RootConstrainSelectedInstOperands,
     /* 302491 */     // GIR_Coverage, 2064,
     /* 302491 */     GIR_EraseRootFromParent_Done,
     /* 302492 */   // Label 6030: @302492
     /* 302492 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(302607), // Rule ID 2062 //
     /* 302497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302508 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302511 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302562 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302566 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302570 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302574 */     // MIs[4] Operand 1
     /* 302574 */     // No operand predicates
     /* 302574 */     // MIs[2] Operand 2
     /* 302574 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 302585 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302587 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 302590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302605 */     GIR_RootConstrainSelectedInstOperands,
     /* 302606 */     // GIR_Coverage, 2062,
     /* 302606 */     GIR_EraseRootFromParent_Done,
     /* 302607 */   // Label 6031: @302607
     /* 302607 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(302674), // Rule ID 1747 //
     /* 302612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302623 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302626 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302655 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 302655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 302658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 302672 */     GIR_RootConstrainSelectedInstOperands,
     /* 302673 */     // GIR_Coverage, 1747,
     /* 302673 */     GIR_EraseRootFromParent_Done,
     /* 302674 */   // Label 6032: @302674
     /* 302674 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(302766), // Rule ID 2063 //
     /* 302679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302690 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302693 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302702 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302740 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302744 */     // MIs[3] Operand 1
     /* 302744 */     // No operand predicates
     /* 302744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302746 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 302749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302764 */     GIR_RootConstrainSelectedInstOperands,
     /* 302765 */     // GIR_Coverage, 2063,
     /* 302765 */     GIR_EraseRootFromParent_Done,
     /* 302766 */   // Label 6033: @302766
     /* 302766 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(302827), // Rule ID 1746 //
     /* 302771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302782 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302785 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302794 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302810 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 302810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 302813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 302825 */     GIR_RootConstrainSelectedInstOperands,
     /* 302826 */     // GIR_Coverage, 1746,
     /* 302826 */     GIR_EraseRootFromParent_Done,
     /* 302827 */   // Label 6034: @302827
     /* 302827 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(302846), // Rule ID 1450 //
     /* 302832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302839 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 302839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 302844 */     GIR_RootConstrainSelectedInstOperands,
     /* 302845 */     // GIR_Coverage, 1450,
     /* 302845 */     GIR_Done,
     /* 302846 */   // Label 6035: @302846
     /* 302846 */   GIM_Reject,
     /* 302847 */ // Label 6029: @302847
     /* 302847 */ GIM_Reject,
     /* 302848 */ // Label 6011: @302848
     /* 302848 */ GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(302881), // Rule ID 1445 //
     /* 302853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 302859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 302862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302874 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 302874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 302879 */   GIR_RootConstrainSelectedInstOperands,
     /* 302880 */   // GIR_Coverage, 1445,
     /* 302880 */   GIR_Done,
     /* 302881 */ // Label 6036: @302881
     /* 302881 */ GIM_Reject,
     /* 302882 */ // Label 6012: @302882
     /* 302882 */ GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(302915), // Rule ID 1448 //
     /* 302887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302908 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 302908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 302913 */   GIR_RootConstrainSelectedInstOperands,
     /* 302914 */   // GIR_Coverage, 1448,
     /* 302914 */   GIR_Done,
     /* 302915 */ // Label 6037: @302915
     /* 302915 */ GIM_Reject,
     /* 302916 */ // Label 6013: @302916
     /* 302916 */ GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(302949), // Rule ID 1446 //
     /* 302921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 302927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 302930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302942 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 302942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 302947 */   GIR_RootConstrainSelectedInstOperands,
     /* 302948 */   // GIR_Coverage, 1446,
     /* 302948 */   GIR_Done,
     /* 302949 */ // Label 6038: @302949
     /* 302949 */ GIM_Reject,
     /* 302950 */ // Label 6014: @302950
     /* 302950 */ GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(302975), // Rule ID 7514 //
     /* 302955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 302961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 302964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302968 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 302968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 302973 */   GIR_RootConstrainSelectedInstOperands,
     /* 302974 */   // GIR_Coverage, 7514,
     /* 302974 */   GIR_Done,
     /* 302975 */ // Label 6039: @302975
     /* 302975 */ GIM_Reject,
     /* 302976 */ // Label 6015: @302976
     /* 302976 */ GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(303001), // Rule ID 7513 //
     /* 302981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 302987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 302990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302994 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 302994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 302999 */   GIR_RootConstrainSelectedInstOperands,
     /* 303000 */   // GIR_Coverage, 7513,
     /* 303000 */   GIR_Done,
     /* 303001 */ // Label 6040: @303001
     /* 303001 */ GIM_Reject,
     /* 303002 */ // Label 6016: @303002
     /* 303002 */ GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(303027), // Rule ID 7512 //
     /* 303007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303020 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 303020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 303025 */   GIR_RootConstrainSelectedInstOperands,
     /* 303026 */   // GIR_Coverage, 7512,
     /* 303026 */   GIR_Done,
     /* 303027 */ // Label 6041: @303027
     /* 303027 */ GIM_Reject,
     /* 303028 */ // Label 6017: @303028
     /* 303028 */ GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(303053), // Rule ID 7511 //
     /* 303033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 303039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 303042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303046 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 303046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 303051 */   GIR_RootConstrainSelectedInstOperands,
     /* 303052 */   // GIR_Coverage, 7511,
     /* 303052 */   GIR_Done,
     /* 303053 */ // Label 6042: @303053
     /* 303053 */ GIM_Reject,
     /* 303054 */ // Label 6018: @303054
     /* 303054 */ GIM_Reject,
     /* 303055 */ // Label 59: @303055
     /* 303055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6054*/ GIMT_Encode4(304852),
     /* 303066 */ /*GILLT_s16*//*Label 6043*/ GIMT_Encode4(303150),
     /* 303070 */ /*GILLT_s32*//*Label 6044*/ GIMT_Encode4(303376),
     /* 303074 */ /*GILLT_s64*//*Label 6045*/ GIMT_Encode4(303730), GIMT_Encode4(0),
     /* 303082 */ /*GILLT_v2s32*//*Label 6046*/ GIMT_Encode4(303902),
     /* 303086 */ /*GILLT_v2s64*//*Label 6047*/ GIMT_Encode4(303940),
     /* 303090 */ /*GILLT_v4s16*//*Label 6048*/ GIMT_Encode4(304116),
     /* 303094 */ /*GILLT_v4s32*//*Label 6049*/ GIMT_Encode4(304154), GIMT_Encode4(0),
     /* 303102 */ /*GILLT_v8s16*//*Label 6050*/ GIMT_Encode4(304330), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303126 */ /*GILLT_nxv2s64*//*Label 6051*/ GIMT_Encode4(304774), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303138 */ /*GILLT_nxv4s32*//*Label 6052*/ GIMT_Encode4(304800), GIMT_Encode4(0),
     /* 303146 */ /*GILLT_nxv8s16*//*Label 6053*/ GIMT_Encode4(304826),
     /* 303150 */ // Label 6043: @303150
     /* 303150 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(303375),
     /* 303155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303165 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(303256), // Rule ID 6966 //
     /* 303170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303207 */     // MIs[2] Rn
     /* 303207 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303212 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303218 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303230 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303254 */     GIR_RootConstrainSelectedInstOperands,
     /* 303255 */     // GIR_Coverage, 6966,
     /* 303255 */     GIR_EraseRootFromParent_Done,
     /* 303256 */   // Label 6056: @303256
     /* 303256 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(303347), // Rule ID 14034 //
     /* 303261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303298 */     // MIs[2] Rn
     /* 303298 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303309 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303345 */     GIR_RootConstrainSelectedInstOperands,
     /* 303346 */     // GIR_Coverage, 14034,
     /* 303346 */     GIR_EraseRootFromParent_Done,
     /* 303347 */   // Label 6057: @303347
     /* 303347 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(303374), // Rule ID 584 //
     /* 303352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303363 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 303368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303372 */     GIR_RootConstrainSelectedInstOperands,
     /* 303373 */     // GIR_Coverage, 584,
     /* 303373 */     GIR_Done,
     /* 303374 */   // Label 6058: @303374
     /* 303374 */   GIM_Reject,
     /* 303375 */ // Label 6055: @303375
     /* 303375 */ GIM_Reject,
     /* 303376 */ // Label 6044: @303376
     /* 303376 */ GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(303729),
     /* 303381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303391 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(303482), // Rule ID 6964 //
     /* 303396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303433 */     // MIs[2] Rn
     /* 303433 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303438 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303444 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303456 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303480 */     GIR_RootConstrainSelectedInstOperands,
     /* 303481 */     // GIR_Coverage, 6964,
     /* 303481 */     GIR_EraseRootFromParent_Done,
     /* 303482 */   // Label 6060: @303482
     /* 303482 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(303546), // Rule ID 13206 //
     /* 303487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303524 */     // MIs[2] Rn
     /* 303524 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303529 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303535 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 303535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303544 */     GIR_RootConstrainSelectedInstOperands,
     /* 303545 */     // GIR_Coverage, 13206,
     /* 303545 */     GIR_EraseRootFromParent_Done,
     /* 303546 */   // Label 6061: @303546
     /* 303546 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(303637), // Rule ID 14032 //
     /* 303551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303572 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303588 */     // MIs[2] Rn
     /* 303588 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303593 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303599 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303611 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303635 */     GIR_RootConstrainSelectedInstOperands,
     /* 303636 */     // GIR_Coverage, 14032,
     /* 303636 */     GIR_EraseRootFromParent_Done,
     /* 303637 */   // Label 6062: @303637
     /* 303637 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(303701), // Rule ID 15859 //
     /* 303642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303663 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303679 */     // MIs[2] Rn
     /* 303679 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303690 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 303690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303699 */     GIR_RootConstrainSelectedInstOperands,
     /* 303700 */     // GIR_Coverage, 15859,
     /* 303700 */     GIR_EraseRootFromParent_Done,
     /* 303701 */   // Label 6063: @303701
     /* 303701 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(303728), // Rule ID 586 //
     /* 303706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303717 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 303717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 303722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303726 */     GIR_RootConstrainSelectedInstOperands,
     /* 303727 */     // GIR_Coverage, 586,
     /* 303727 */     GIR_Done,
     /* 303728 */   // Label 6064: @303728
     /* 303728 */   GIM_Reject,
     /* 303729 */ // Label 6059: @303729
     /* 303729 */ GIM_Reject,
     /* 303730 */ // Label 6045: @303730
     /* 303730 */ GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(303901),
     /* 303735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 303741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303745 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(303809), // Rule ID 6962 //
     /* 303750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303787 */     // MIs[2] Rn
     /* 303787 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303798 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 303798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 303801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303807 */     GIR_RootConstrainSelectedInstOperands,
     /* 303808 */     // GIR_Coverage, 6962,
     /* 303808 */     GIR_EraseRootFromParent_Done,
     /* 303809 */   // Label 6066: @303809
     /* 303809 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(303873), // Rule ID 14030 //
     /* 303814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303835 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303851 */     // MIs[2] Rn
     /* 303851 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303856 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303862 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 303862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 303865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303871 */     GIR_RootConstrainSelectedInstOperands,
     /* 303872 */     // GIR_Coverage, 14030,
     /* 303872 */     GIR_EraseRootFromParent_Done,
     /* 303873 */   // Label 6067: @303873
     /* 303873 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(303900), // Rule ID 588 //
     /* 303878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303889 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 303889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 303894 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303898 */     GIR_RootConstrainSelectedInstOperands,
     /* 303899 */     // GIR_Coverage, 588,
     /* 303899 */     GIR_Done,
     /* 303900 */   // Label 6068: @303900
     /* 303900 */   GIM_Reject,
     /* 303901 */ // Label 6065: @303901
     /* 303901 */ GIM_Reject,
     /* 303902 */ // Label 6046: @303902
     /* 303902 */ GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(303939), // Rule ID 1203 //
     /* 303907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 303916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303928 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 303933 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303937 */   GIR_RootConstrainSelectedInstOperands,
     /* 303938 */   // GIR_Coverage, 1203,
     /* 303938 */   GIR_Done,
     /* 303939 */ // Label 6069: @303939
     /* 303939 */ GIM_Reject,
     /* 303940 */ // Label 6047: @303940
     /* 303940 */ GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(304115),
     /* 303945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303955 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(304021), // Rule ID 6984 //
     /* 303960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 303968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 303994 */     // MIs[2] Rn
     /* 303994 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303999 */     // MIs[2] Rm
     /* 303999 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304006 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 304006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 304009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304019 */     GIR_RootConstrainSelectedInstOperands,
     /* 304020 */     // GIR_Coverage, 6984,
     /* 304020 */     GIR_EraseRootFromParent_Done,
     /* 304021 */   // Label 6071: @304021
     /* 304021 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(304087), // Rule ID 14042 //
     /* 304026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 304034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 304042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 304060 */     // MIs[2] Rn
     /* 304060 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304065 */     // MIs[2] Rm
     /* 304065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304072 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 304072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 304075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304085 */     GIR_RootConstrainSelectedInstOperands,
     /* 304086 */     // GIR_Coverage, 14042,
     /* 304086 */     GIR_EraseRootFromParent_Done,
     /* 304087 */   // Label 6072: @304087
     /* 304087 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(304114), // Rule ID 1207 //
     /* 304092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304103 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 304108 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304112 */     GIR_RootConstrainSelectedInstOperands,
     /* 304113 */     // GIR_Coverage, 1207,
     /* 304113 */     GIR_Done,
     /* 304114 */   // Label 6073: @304114
     /* 304114 */   GIM_Reject,
     /* 304115 */ // Label 6070: @304115
     /* 304115 */ GIM_Reject,
     /* 304116 */ // Label 6048: @304116
     /* 304116 */ GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(304153), // Rule ID 1199 //
     /* 304121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304142 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 304147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304151 */   GIR_RootConstrainSelectedInstOperands,
     /* 304152 */   // GIR_Coverage, 1199,
     /* 304152 */   GIR_Done,
     /* 304153 */ // Label 6074: @304153
     /* 304153 */ GIM_Reject,
     /* 304154 */ // Label 6049: @304154
     /* 304154 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(304329),
     /* 304159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304169 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(304235), // Rule ID 6985 //
     /* 304174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304208 */     // MIs[2] Rn
     /* 304208 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304213 */     // MIs[2] Rm
     /* 304213 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304220 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304233 */     GIR_RootConstrainSelectedInstOperands,
     /* 304234 */     // GIR_Coverage, 6985,
     /* 304234 */     GIR_EraseRootFromParent_Done,
     /* 304235 */   // Label 6076: @304235
     /* 304235 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(304301), // Rule ID 14043 //
     /* 304240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304274 */     // MIs[2] Rn
     /* 304274 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304279 */     // MIs[2] Rm
     /* 304279 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304286 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304299 */     GIR_RootConstrainSelectedInstOperands,
     /* 304300 */     // GIR_Coverage, 14043,
     /* 304300 */     GIR_EraseRootFromParent_Done,
     /* 304301 */   // Label 6077: @304301
     /* 304301 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(304328), // Rule ID 1205 //
     /* 304306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304317 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304322 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304326 */     GIR_RootConstrainSelectedInstOperands,
     /* 304327 */     // GIR_Coverage, 1205,
     /* 304327 */     GIR_Done,
     /* 304328 */   // Label 6078: @304328
     /* 304328 */   GIM_Reject,
     /* 304329 */ // Label 6075: @304329
     /* 304329 */ GIM_Reject,
     /* 304330 */ // Label 6050: @304330
     /* 304330 */ GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(304773),
     /* 304335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304345 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(304414), // Rule ID 6986 //
     /* 304350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304387 */     // MIs[2] Rn
     /* 304387 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304392 */     // MIs[2] Rm
     /* 304392 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304399 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304412 */     GIR_RootConstrainSelectedInstOperands,
     /* 304413 */     // GIR_Coverage, 6986,
     /* 304413 */     GIR_EraseRootFromParent_Done,
     /* 304414 */   // Label 6080: @304414
     /* 304414 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(304483), // Rule ID 14044 //
     /* 304419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304456 */     // MIs[2] Rn
     /* 304456 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304461 */     // MIs[2] Rm
     /* 304461 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304468 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304481 */     GIR_RootConstrainSelectedInstOperands,
     /* 304482 */     // GIR_Coverage, 14044,
     /* 304482 */     GIR_EraseRootFromParent_Done,
     /* 304483 */   // Label 6081: @304483
     /* 304483 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(304510), // Rule ID 1201 //
     /* 304488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304499 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 304499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 304504 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304508 */     GIR_RootConstrainSelectedInstOperands,
     /* 304509 */     // GIR_Coverage, 1201,
     /* 304509 */     GIR_Done,
     /* 304510 */   // Label 6082: @304510
     /* 304510 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(304772), // Rule ID 7055 //
     /* 304515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 304518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304526 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 304526 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 304529 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304533 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304538 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 304542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 304544 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 304547 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304551 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304556 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 304560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 304562 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 304565 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304569 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304574 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 304577 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 304580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 304582 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 304585 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304589 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304594 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 304600 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304605 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304610 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 304613 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304617 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304622 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 304625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304627 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 304630 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304634 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304639 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 304645 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304650 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304655 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 304658 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304662 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304667 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304672 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 304675 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304679 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304684 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304687 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 304690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 304695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 304699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304704 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 304709 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304712 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304716 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 304738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 304741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 304762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 304770 */     GIR_RootConstrainSelectedInstOperands,
     /* 304771 */     // GIR_Coverage, 7055,
     /* 304771 */     GIR_EraseRootFromParent_Done,
     /* 304772 */   // Label 6083: @304772
     /* 304772 */   GIM_Reject,
     /* 304773 */ // Label 6079: @304773
     /* 304773 */ GIM_Reject,
     /* 304774 */ // Label 6051: @304774
     /* 304774 */ GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(304799), // Rule ID 2820 //
     /* 304779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 304785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 304788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304792 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 304792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 304797 */   GIR_RootConstrainSelectedInstOperands,
     /* 304798 */   // GIR_Coverage, 2820,
     /* 304798 */   GIR_Done,
     /* 304799 */ // Label 6084: @304799
     /* 304799 */ GIM_Reject,
     /* 304800 */ // Label 6052: @304800
     /* 304800 */ GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(304825), // Rule ID 2818 //
     /* 304805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 304811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 304814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304818 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 304818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 304823 */   GIR_RootConstrainSelectedInstOperands,
     /* 304824 */   // GIR_Coverage, 2818,
     /* 304824 */   GIR_Done,
     /* 304825 */ // Label 6085: @304825
     /* 304825 */ GIM_Reject,
     /* 304826 */ // Label 6053: @304826
     /* 304826 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(304851), // Rule ID 2816 //
     /* 304831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 304837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 304840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304844 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 304844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 304849 */   GIR_RootConstrainSelectedInstOperands,
     /* 304850 */   // GIR_Coverage, 2816,
     /* 304850 */   GIR_Done,
     /* 304851 */ // Label 6086: @304851
     /* 304851 */ GIM_Reject,
     /* 304852 */ // Label 6054: @304852
     /* 304852 */ GIM_Reject,
     /* 304853 */ // Label 60: @304853
     /* 304853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6098*/ GIMT_Encode4(305590),
     /* 304864 */ /*GILLT_s16*//*Label 6087*/ GIMT_Encode4(304948),
     /* 304868 */ /*GILLT_s32*//*Label 6088*/ GIMT_Encode4(304986),
     /* 304872 */ /*GILLT_s64*//*Label 6089*/ GIMT_Encode4(305024), GIMT_Encode4(0),
     /* 304880 */ /*GILLT_v2s32*//*Label 6090*/ GIMT_Encode4(305062),
     /* 304884 */ /*GILLT_v2s64*//*Label 6091*/ GIMT_Encode4(305100),
     /* 304888 */ /*GILLT_v4s16*//*Label 6092*/ GIMT_Encode4(305138),
     /* 304892 */ /*GILLT_v4s32*//*Label 6093*/ GIMT_Encode4(305176), GIMT_Encode4(0),
     /* 304900 */ /*GILLT_v8s16*//*Label 6094*/ GIMT_Encode4(305214), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304924 */ /*GILLT_nxv2s64*//*Label 6095*/ GIMT_Encode4(305512), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304936 */ /*GILLT_nxv4s32*//*Label 6096*/ GIMT_Encode4(305538), GIMT_Encode4(0),
     /* 304944 */ /*GILLT_nxv8s16*//*Label 6097*/ GIMT_Encode4(305564),
     /* 304948 */ // Label 6087: @304948
     /* 304948 */ GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(304985), // Rule ID 632 //
     /* 304953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 304962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304974 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 304974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 304979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304983 */   GIR_RootConstrainSelectedInstOperands,
     /* 304984 */   // GIR_Coverage, 632,
     /* 304984 */   GIR_Done,
     /* 304985 */ // Label 6099: @304985
     /* 304985 */ GIM_Reject,
     /* 304986 */ // Label 6088: @304986
     /* 304986 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(305023), // Rule ID 634 //
     /* 304991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 305000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305012 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 305012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 305017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305021 */   GIR_RootConstrainSelectedInstOperands,
     /* 305022 */   // GIR_Coverage, 634,
     /* 305022 */   GIR_Done,
     /* 305023 */ // Label 6100: @305023
     /* 305023 */ GIM_Reject,
     /* 305024 */ // Label 6089: @305024
     /* 305024 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(305061), // Rule ID 636 //
     /* 305029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 305038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305050 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 305050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 305055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305059 */   GIR_RootConstrainSelectedInstOperands,
     /* 305060 */   // GIR_Coverage, 636,
     /* 305060 */   GIR_Done,
     /* 305061 */ // Label 6101: @305061
     /* 305061 */ GIM_Reject,
     /* 305062 */ // Label 6090: @305062
     /* 305062 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(305099), // Rule ID 1343 //
     /* 305067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 305073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 305076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305088 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 305088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 305093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305097 */   GIR_RootConstrainSelectedInstOperands,
     /* 305098 */   // GIR_Coverage, 1343,
     /* 305098 */   GIR_Done,
     /* 305099 */ // Label 6102: @305099
     /* 305099 */ GIM_Reject,
     /* 305100 */ // Label 6091: @305100
     /* 305100 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(305137), // Rule ID 1347 //
     /* 305105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 305114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305126 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 305126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 305131 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305135 */   GIR_RootConstrainSelectedInstOperands,
     /* 305136 */   // GIR_Coverage, 1347,
     /* 305136 */   GIR_Done,
     /* 305137 */ // Label 6103: @305137
     /* 305137 */ GIM_Reject,
     /* 305138 */ // Label 6092: @305138
     /* 305138 */ GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(305175), // Rule ID 1339 //
     /* 305143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 305152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305164 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 305169 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305173 */   GIR_RootConstrainSelectedInstOperands,
     /* 305174 */   // GIR_Coverage, 1339,
     /* 305174 */   GIR_Done,
     /* 305175 */ // Label 6104: @305175
     /* 305175 */ GIM_Reject,
     /* 305176 */ // Label 6093: @305176
     /* 305176 */ GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(305213), // Rule ID 1345 //
     /* 305181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 305190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305202 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305211 */   GIR_RootConstrainSelectedInstOperands,
     /* 305212 */   // GIR_Coverage, 1345,
     /* 305212 */   GIR_Done,
     /* 305213 */ // Label 6105: @305213
     /* 305213 */ GIM_Reject,
     /* 305214 */ // Label 6094: @305214
     /* 305214 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(305511),
     /* 305219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 305225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305237 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(305256), // Rule ID 1341 //
     /* 305242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305245 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 305250 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305254 */     GIR_RootConstrainSelectedInstOperands,
     /* 305255 */     // GIR_Coverage, 1341,
     /* 305255 */     GIR_Done,
     /* 305256 */   // Label 6107: @305256
     /* 305256 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(305510), // Rule ID 7061 //
     /* 305261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 305264 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 305264 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 305267 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305271 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305276 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 305280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 305282 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 305285 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305289 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305294 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 305298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 305300 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 305303 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305307 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305312 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 305315 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 305318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 305320 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 305323 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305327 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305332 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305338 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305343 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305348 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 305351 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305355 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305360 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 305363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305365 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 305368 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305372 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305377 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305383 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305388 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305393 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 305396 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305400 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305405 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305410 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 305413 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305417 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305422 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305425 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 305428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 305433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 305437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305442 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 305476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 305479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 305482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 305500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 305508 */     GIR_RootConstrainSelectedInstOperands,
     /* 305509 */     // GIR_Coverage, 7061,
     /* 305509 */     GIR_EraseRootFromParent_Done,
     /* 305510 */   // Label 6108: @305510
     /* 305510 */   GIM_Reject,
     /* 305511 */ // Label 6106: @305511
     /* 305511 */ GIM_Reject,
     /* 305512 */ // Label 6095: @305512
     /* 305512 */ GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(305537), // Rule ID 8261 //
     /* 305517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 305523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 305526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305530 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 305530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 305535 */   GIR_RootConstrainSelectedInstOperands,
     /* 305536 */   // GIR_Coverage, 8261,
     /* 305536 */   GIR_Done,
     /* 305537 */ // Label 6109: @305537
     /* 305537 */ GIM_Reject,
     /* 305538 */ // Label 6096: @305538
     /* 305538 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(305563), // Rule ID 8259 //
     /* 305543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 305549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 305552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305556 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 305556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 305561 */   GIR_RootConstrainSelectedInstOperands,
     /* 305562 */   // GIR_Coverage, 8259,
     /* 305562 */   GIR_Done,
     /* 305563 */ // Label 6110: @305563
     /* 305563 */ GIM_Reject,
     /* 305564 */ // Label 6097: @305564
     /* 305564 */ GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(305589), // Rule ID 8257 //
     /* 305569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 305575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 305578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305582 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 305582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 305587 */   GIR_RootConstrainSelectedInstOperands,
     /* 305588 */   // GIR_Coverage, 8257,
     /* 305588 */   GIR_Done,
     /* 305589 */ // Label 6111: @305589
     /* 305589 */ GIM_Reject,
     /* 305590 */ // Label 6098: @305590
     /* 305590 */ GIM_Reject,
     /* 305591 */ // Label 61: @305591
     /* 305591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6123*/ GIMT_Encode4(309686),
     /* 305602 */ /*GILLT_s16*//*Label 6112*/ GIMT_Encode4(305686),
     /* 305606 */ /*GILLT_s32*//*Label 6113*/ GIMT_Encode4(306328),
     /* 305610 */ /*GILLT_s64*//*Label 6114*/ GIMT_Encode4(306958), GIMT_Encode4(0),
     /* 305618 */ /*GILLT_v2s32*//*Label 6115*/ GIMT_Encode4(307588),
     /* 305622 */ /*GILLT_v2s64*//*Label 6116*/ GIMT_Encode4(308118),
     /* 305626 */ /*GILLT_v4s16*//*Label 6117*/ GIMT_Encode4(308476),
     /* 305630 */ /*GILLT_v4s32*//*Label 6118*/ GIMT_Encode4(308818), GIMT_Encode4(0),
     /* 305638 */ /*GILLT_v8s16*//*Label 6119*/ GIMT_Encode4(309176), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305662 */ /*GILLT_nxv2s64*//*Label 6120*/ GIMT_Encode4(309608), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305674 */ /*GILLT_nxv4s32*//*Label 6121*/ GIMT_Encode4(309634), GIMT_Encode4(0),
     /* 305682 */ /*GILLT_nxv8s16*//*Label 6122*/ GIMT_Encode4(309660),
     /* 305686 */ // Label 6112: @305686
     /* 305686 */ GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(306327),
     /* 305691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 305697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305701 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(305814), // Rule ID 6286 //
     /* 305706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305730 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305767 */     // MIs[3] Operand 1
     /* 305767 */     // No operand predicates
     /* 305767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305769 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305781 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 305787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305812 */     GIR_RootConstrainSelectedInstOperands,
     /* 305813 */     // GIR_Coverage, 6286,
     /* 305813 */     GIR_EraseRootFromParent_Done,
     /* 305814 */   // Label 6125: @305814
     /* 305814 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(305927), // Rule ID 14011 //
     /* 305819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305851 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305855 */     // MIs[2] Operand 1
     /* 305855 */     // No operand predicates
     /* 305855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305867 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305871 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305876 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305882 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305894 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 305900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305925 */     GIR_RootConstrainSelectedInstOperands,
     /* 305926 */     // GIR_Coverage, 14011,
     /* 305926 */     GIR_EraseRootFromParent_Done,
     /* 305927 */   // Label 6126: @305927
     /* 305927 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(306006), // Rule ID 13945 //
     /* 305932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305966 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 305966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305978 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 305984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306004 */     GIR_RootConstrainSelectedInstOperands,
     /* 306005 */     // GIR_Coverage, 13945,
     /* 306005 */     GIR_EraseRootFromParent_Done,
     /* 306006 */   // Label 6127: @306006
     /* 306006 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(306085), // Rule ID 4843 //
     /* 306011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306039 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306045 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 306045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306057 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306083 */     GIR_RootConstrainSelectedInstOperands,
     /* 306084 */     // GIR_Coverage, 4843,
     /* 306084 */     GIR_EraseRootFromParent_Done,
     /* 306085 */   // Label 6128: @306085
     /* 306085 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(306148), // Rule ID 13554 //
     /* 306090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306126 */     // MIs[2] Operand 1
     /* 306126 */     // No operand predicates
     /* 306126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306132 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306146 */     GIR_RootConstrainSelectedInstOperands,
     /* 306147 */     // GIR_Coverage, 13554,
     /* 306147 */     GIR_EraseRootFromParent_Done,
     /* 306148 */   // Label 6129: @306148
     /* 306148 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(306211), // Rule ID 2012 //
     /* 306153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306193 */     // MIs[2] Operand 1
     /* 306193 */     // No operand predicates
     /* 306193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306195 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306209 */     GIR_RootConstrainSelectedInstOperands,
     /* 306210 */     // GIR_Coverage, 2012,
     /* 306210 */     GIR_EraseRootFromParent_Done,
     /* 306211 */   // Label 6130: @306211
     /* 306211 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(306255), // Rule ID 4848 //
     /* 306216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306242 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306251 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306253 */     GIR_RootConstrainSelectedInstOperands,
     /* 306254 */     // GIR_Coverage, 4848,
     /* 306254 */     GIR_EraseRootFromParent_Done,
     /* 306255 */   // Label 6131: @306255
     /* 306255 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(306299), // Rule ID 13950 //
     /* 306260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306286 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306295 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306297 */     GIR_RootConstrainSelectedInstOperands,
     /* 306298 */     // GIR_Coverage, 13950,
     /* 306298 */     GIR_EraseRootFromParent_Done,
     /* 306299 */   // Label 6132: @306299
     /* 306299 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(306326), // Rule ID 620 //
     /* 306304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306315 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306320 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306324 */     GIR_RootConstrainSelectedInstOperands,
     /* 306325 */     // GIR_Coverage, 620,
     /* 306325 */     GIR_Done,
     /* 306326 */   // Label 6133: @306326
     /* 306326 */   GIM_Reject,
     /* 306327 */ // Label 6124: @306327
     /* 306327 */ GIM_Reject,
     /* 306328 */ // Label 6113: @306328
     /* 306328 */ GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(306957),
     /* 306333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306343 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(306456), // Rule ID 6288 //
     /* 306348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306405 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306409 */     // MIs[3] Operand 1
     /* 306409 */     // No operand predicates
     /* 306409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306411 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306423 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306454 */     GIR_RootConstrainSelectedInstOperands,
     /* 306455 */     // GIR_Coverage, 6288,
     /* 306455 */     GIR_EraseRootFromParent_Done,
     /* 306456 */   // Label 6135: @306456
     /* 306456 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306569), // Rule ID 14013 //
     /* 306461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306497 */     // MIs[2] Operand 1
     /* 306497 */     // No operand predicates
     /* 306497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306505 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306509 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306513 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306518 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306524 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306567 */     GIR_RootConstrainSelectedInstOperands,
     /* 306568 */     // GIR_Coverage, 14013,
     /* 306568 */     GIR_EraseRootFromParent_Done,
     /* 306569 */   // Label 6136: @306569
     /* 306569 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306645), // Rule ID 13947 //
     /* 306574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306595 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306605 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 306605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306617 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 306623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306643 */     GIR_RootConstrainSelectedInstOperands,
     /* 306644 */     // GIR_Coverage, 13947,
     /* 306644 */     GIR_EraseRootFromParent_Done,
     /* 306645 */   // Label 6137: @306645
     /* 306645 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306721), // Rule ID 4845 //
     /* 306650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306681 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 306681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306693 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 306699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306719 */     GIR_RootConstrainSelectedInstOperands,
     /* 306720 */     // GIR_Coverage, 4845,
     /* 306720 */     GIR_EraseRootFromParent_Done,
     /* 306721 */   // Label 6138: @306721
     /* 306721 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306784), // Rule ID 13556 //
     /* 306726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306758 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306762 */     // MIs[2] Operand 1
     /* 306762 */     // No operand predicates
     /* 306762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306768 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306782 */     GIR_RootConstrainSelectedInstOperands,
     /* 306783 */     // GIR_Coverage, 13556,
     /* 306783 */     GIR_EraseRootFromParent_Done,
     /* 306784 */   // Label 6139: @306784
     /* 306784 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306847), // Rule ID 2014 //
     /* 306789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306829 */     // MIs[2] Operand 1
     /* 306829 */     // No operand predicates
     /* 306829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306831 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306845 */     GIR_RootConstrainSelectedInstOperands,
     /* 306846 */     // GIR_Coverage, 2014,
     /* 306846 */     GIR_EraseRootFromParent_Done,
     /* 306847 */   // Label 6140: @306847
     /* 306847 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(306888), // Rule ID 4849 //
     /* 306852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306875 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306884 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306886 */     GIR_RootConstrainSelectedInstOperands,
     /* 306887 */     // GIR_Coverage, 4849,
     /* 306887 */     GIR_EraseRootFromParent_Done,
     /* 306888 */   // Label 6141: @306888
     /* 306888 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306929), // Rule ID 13951 //
     /* 306893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306916 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306925 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306927 */     GIR_RootConstrainSelectedInstOperands,
     /* 306928 */     // GIR_Coverage, 13951,
     /* 306928 */     GIR_EraseRootFromParent_Done,
     /* 306929 */   // Label 6142: @306929
     /* 306929 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(306956), // Rule ID 622 //
     /* 306934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306945 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306950 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306954 */     GIR_RootConstrainSelectedInstOperands,
     /* 306955 */     // GIR_Coverage, 622,
     /* 306955 */     GIR_Done,
     /* 306956 */   // Label 6143: @306956
     /* 306956 */   GIM_Reject,
     /* 306957 */ // Label 6134: @306957
     /* 306957 */ GIM_Reject,
     /* 306958 */ // Label 6114: @306958
     /* 306958 */ GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(307587),
     /* 306963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306973 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(307086), // Rule ID 6290 //
     /* 306978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307002 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 307010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307035 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307039 */     // MIs[3] Operand 1
     /* 307039 */     // No operand predicates
     /* 307039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307041 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 307041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307053 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307084 */     GIR_RootConstrainSelectedInstOperands,
     /* 307085 */     // GIR_Coverage, 6290,
     /* 307085 */     GIR_EraseRootFromParent_Done,
     /* 307086 */   // Label 6145: @307086
     /* 307086 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(307199), // Rule ID 14015 //
     /* 307091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307127 */     // MIs[2] Operand 1
     /* 307127 */     // No operand predicates
     /* 307127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 307131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307135 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307139 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307143 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307148 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307154 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 307154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307166 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307197 */     GIR_RootConstrainSelectedInstOperands,
     /* 307198 */     // GIR_Coverage, 14015,
     /* 307198 */     GIR_EraseRootFromParent_Done,
     /* 307199 */   // Label 6146: @307199
     /* 307199 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(307275), // Rule ID 13949 //
     /* 307204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307225 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307235 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307247 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307273 */     GIR_RootConstrainSelectedInstOperands,
     /* 307274 */     // GIR_Coverage, 13949,
     /* 307274 */     GIR_EraseRootFromParent_Done,
     /* 307275 */   // Label 6147: @307275
     /* 307275 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(307351), // Rule ID 4847 //
     /* 307280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307305 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307311 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307323 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307349 */     GIR_RootConstrainSelectedInstOperands,
     /* 307350 */     // GIR_Coverage, 4847,
     /* 307350 */     GIR_EraseRootFromParent_Done,
     /* 307351 */   // Label 6148: @307351
     /* 307351 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(307414), // Rule ID 13558 //
     /* 307356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307392 */     // MIs[2] Operand 1
     /* 307392 */     // No operand predicates
     /* 307392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307398 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307412 */     GIR_RootConstrainSelectedInstOperands,
     /* 307413 */     // GIR_Coverage, 13558,
     /* 307413 */     GIR_EraseRootFromParent_Done,
     /* 307414 */   // Label 6149: @307414
     /* 307414 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(307477), // Rule ID 2016 //
     /* 307419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307459 */     // MIs[2] Operand 1
     /* 307459 */     // No operand predicates
     /* 307459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307461 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307475 */     GIR_RootConstrainSelectedInstOperands,
     /* 307476 */     // GIR_Coverage, 2016,
     /* 307476 */     GIR_EraseRootFromParent_Done,
     /* 307477 */   // Label 6150: @307477
     /* 307477 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(307518), // Rule ID 4850 //
     /* 307482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307505 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307514 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 307516 */     GIR_RootConstrainSelectedInstOperands,
     /* 307517 */     // GIR_Coverage, 4850,
     /* 307517 */     GIR_EraseRootFromParent_Done,
     /* 307518 */   // Label 6151: @307518
     /* 307518 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(307559), // Rule ID 13952 //
     /* 307523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307546 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307555 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 307557 */     GIR_RootConstrainSelectedInstOperands,
     /* 307558 */     // GIR_Coverage, 13952,
     /* 307558 */     GIR_EraseRootFromParent_Done,
     /* 307559 */   // Label 6152: @307559
     /* 307559 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307586), // Rule ID 624 //
     /* 307564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307575 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 307575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307580 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307584 */     GIR_RootConstrainSelectedInstOperands,
     /* 307585 */     // GIR_Coverage, 624,
     /* 307585 */     GIR_Done,
     /* 307586 */   // Label 6153: @307586
     /* 307586 */   GIM_Reject,
     /* 307587 */ // Label 6144: @307587
     /* 307587 */ GIM_Reject,
     /* 307588 */ // Label 6115: @307588
     /* 307588 */ GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(308117),
     /* 307593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 307596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 307599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307603 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(307689), // Rule ID 13547 //
     /* 307608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307652 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307656 */     // MIs[3] Operand 1
     /* 307656 */     // No operand predicates
     /* 307656 */     // MIs[1] Operand 2
     /* 307656 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307673 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307687 */     GIR_RootConstrainSelectedInstOperands,
     /* 307688 */     // GIR_Coverage, 13547,
     /* 307688 */     GIR_EraseRootFromParent_Done,
     /* 307689 */   // Label 6155: @307689
     /* 307689 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307775), // Rule ID 2005 //
     /* 307694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307746 */     // MIs[3] Operand 1
     /* 307746 */     // No operand predicates
     /* 307746 */     // MIs[1] Operand 2
     /* 307746 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307759 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307773 */     GIR_RootConstrainSelectedInstOperands,
     /* 307774 */     // GIR_Coverage, 2005,
     /* 307774 */     GIR_EraseRootFromParent_Done,
     /* 307775 */   // Label 6156: @307775
     /* 307775 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307838), // Rule ID 13548 //
     /* 307780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307812 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307816 */     // MIs[2] Operand 1
     /* 307816 */     // No operand predicates
     /* 307816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307822 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307836 */     GIR_RootConstrainSelectedInstOperands,
     /* 307837 */     // GIR_Coverage, 13548,
     /* 307837 */     GIR_EraseRootFromParent_Done,
     /* 307838 */   // Label 6157: @307838
     /* 307838 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(307901), // Rule ID 2006 //
     /* 307843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307879 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307883 */     // MIs[2] Operand 1
     /* 307883 */     // No operand predicates
     /* 307883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307885 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307899 */     GIR_RootConstrainSelectedInstOperands,
     /* 307900 */     // GIR_Coverage, 2006,
     /* 307900 */     GIR_EraseRootFromParent_Done,
     /* 307901 */   // Label 6158: @307901
     /* 307901 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(307995), // Rule ID 14017 //
     /* 307906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307929 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307962 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307993 */     GIR_RootConstrainSelectedInstOperands,
     /* 307994 */     // GIR_Coverage, 14017,
     /* 307994 */     GIR_EraseRootFromParent_Done,
     /* 307995 */   // Label 6159: @307995
     /* 307995 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(308089), // Rule ID 6292 //
     /* 308000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308023 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308087 */     GIR_RootConstrainSelectedInstOperands,
     /* 308088 */     // GIR_Coverage, 6292,
     /* 308088 */     GIR_EraseRootFromParent_Done,
     /* 308089 */   // Label 6160: @308089
     /* 308089 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(308116), // Rule ID 1323 //
     /* 308094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308105 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 308105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 308110 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308114 */     GIR_RootConstrainSelectedInstOperands,
     /* 308115 */     // GIR_Coverage, 1323,
     /* 308115 */     GIR_Done,
     /* 308116 */   // Label 6161: @308116
     /* 308116 */   GIM_Reject,
     /* 308117 */ // Label 6154: @308117
     /* 308117 */ GIM_Reject,
     /* 308118 */ // Label 6116: @308118
     /* 308118 */ GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(308475),
     /* 308123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 308129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308133 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(308196), // Rule ID 13552 //
     /* 308138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308174 */     // MIs[2] Operand 1
     /* 308174 */     // No operand predicates
     /* 308174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308180 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308194 */     GIR_RootConstrainSelectedInstOperands,
     /* 308195 */     // GIR_Coverage, 13552,
     /* 308195 */     GIR_EraseRootFromParent_Done,
     /* 308196 */   // Label 6163: @308196
     /* 308196 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(308259), // Rule ID 2010 //
     /* 308201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308241 */     // MIs[2] Operand 1
     /* 308241 */     // No operand predicates
     /* 308241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308243 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308257 */     GIR_RootConstrainSelectedInstOperands,
     /* 308258 */     // GIR_Coverage, 2010,
     /* 308258 */     GIR_EraseRootFromParent_Done,
     /* 308259 */   // Label 6164: @308259
     /* 308259 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(308353), // Rule ID 14021 //
     /* 308264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308287 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308351 */     GIR_RootConstrainSelectedInstOperands,
     /* 308352 */     // GIR_Coverage, 14021,
     /* 308352 */     GIR_EraseRootFromParent_Done,
     /* 308353 */   // Label 6165: @308353
     /* 308353 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(308447), // Rule ID 6296 //
     /* 308358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308381 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308381 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308384 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308388 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308445 */     GIR_RootConstrainSelectedInstOperands,
     /* 308446 */     // GIR_Coverage, 6296,
     /* 308446 */     GIR_EraseRootFromParent_Done,
     /* 308447 */   // Label 6166: @308447
     /* 308447 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(308474), // Rule ID 1327 //
     /* 308452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308463 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 308463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 308468 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308472 */     GIR_RootConstrainSelectedInstOperands,
     /* 308473 */     // GIR_Coverage, 1327,
     /* 308473 */     GIR_Done,
     /* 308474 */   // Label 6167: @308474
     /* 308474 */   GIM_Reject,
     /* 308475 */ // Label 6162: @308475
     /* 308475 */ GIM_Reject,
     /* 308476 */ // Label 6117: @308476
     /* 308476 */ GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(308817),
     /* 308481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 308484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 308487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308491 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(308577), // Rule ID 13541 //
     /* 308496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308540 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308544 */     // MIs[3] Operand 1
     /* 308544 */     // No operand predicates
     /* 308544 */     // MIs[1] Operand 2
     /* 308544 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308561 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308575 */     GIR_RootConstrainSelectedInstOperands,
     /* 308576 */     // GIR_Coverage, 13541,
     /* 308576 */     GIR_EraseRootFromParent_Done,
     /* 308577 */   // Label 6169: @308577
     /* 308577 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(308663), // Rule ID 1999 //
     /* 308582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308630 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308634 */     // MIs[3] Operand 1
     /* 308634 */     // No operand predicates
     /* 308634 */     // MIs[1] Operand 2
     /* 308634 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308647 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308661 */     GIR_RootConstrainSelectedInstOperands,
     /* 308662 */     // GIR_Coverage, 1999,
     /* 308662 */     GIR_EraseRootFromParent_Done,
     /* 308663 */   // Label 6170: @308663
     /* 308663 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(308726), // Rule ID 13542 //
     /* 308668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308704 */     // MIs[2] Operand 1
     /* 308704 */     // No operand predicates
     /* 308704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308710 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308724 */     GIR_RootConstrainSelectedInstOperands,
     /* 308725 */     // GIR_Coverage, 13542,
     /* 308725 */     GIR_EraseRootFromParent_Done,
     /* 308726 */   // Label 6171: @308726
     /* 308726 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(308789), // Rule ID 2000 //
     /* 308731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308771 */     // MIs[2] Operand 1
     /* 308771 */     // No operand predicates
     /* 308771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308773 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308787 */     GIR_RootConstrainSelectedInstOperands,
     /* 308788 */     // GIR_Coverage, 2000,
     /* 308788 */     GIR_EraseRootFromParent_Done,
     /* 308789 */   // Label 6172: @308789
     /* 308789 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(308816), // Rule ID 1319 //
     /* 308794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308805 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 308805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 308810 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308814 */     GIR_RootConstrainSelectedInstOperands,
     /* 308815 */     // GIR_Coverage, 1319,
     /* 308815 */     GIR_Done,
     /* 308816 */   // Label 6173: @308816
     /* 308816 */   GIM_Reject,
     /* 308817 */ // Label 6168: @308817
     /* 308817 */ GIM_Reject,
     /* 308818 */ // Label 6118: @308818
     /* 308818 */ GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(309175),
     /* 308823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 308829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308833 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(308896), // Rule ID 13550 //
     /* 308838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308874 */     // MIs[2] Operand 1
     /* 308874 */     // No operand predicates
     /* 308874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308880 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308894 */     GIR_RootConstrainSelectedInstOperands,
     /* 308895 */     // GIR_Coverage, 13550,
     /* 308895 */     GIR_EraseRootFromParent_Done,
     /* 308896 */   // Label 6175: @308896
     /* 308896 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(308959), // Rule ID 2008 //
     /* 308901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308941 */     // MIs[2] Operand 1
     /* 308941 */     // No operand predicates
     /* 308941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308943 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308957 */     GIR_RootConstrainSelectedInstOperands,
     /* 308958 */     // GIR_Coverage, 2008,
     /* 308958 */     GIR_EraseRootFromParent_Done,
     /* 308959 */   // Label 6176: @308959
     /* 308959 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(309053), // Rule ID 14019 //
     /* 308964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308987 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 309004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309013 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309051 */     GIR_RootConstrainSelectedInstOperands,
     /* 309052 */     // GIR_Coverage, 14019,
     /* 309052 */     GIR_EraseRootFromParent_Done,
     /* 309053 */   // Label 6177: @309053
     /* 309053 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(309147), // Rule ID 6294 //
     /* 309058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 309070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309081 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 309081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 309084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 309098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309145 */     GIR_RootConstrainSelectedInstOperands,
     /* 309146 */     // GIR_Coverage, 6294,
     /* 309146 */     GIR_EraseRootFromParent_Done,
     /* 309147 */   // Label 6178: @309147
     /* 309147 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(309174), // Rule ID 1325 //
     /* 309152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309163 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 309163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309168 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309172 */     GIR_RootConstrainSelectedInstOperands,
     /* 309173 */     // GIR_Coverage, 1325,
     /* 309173 */     GIR_Done,
     /* 309174 */   // Label 6179: @309174
     /* 309174 */   GIM_Reject,
     /* 309175 */ // Label 6174: @309175
     /* 309175 */ GIM_Reject,
     /* 309176 */ // Label 6119: @309176
     /* 309176 */ GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(309607),
     /* 309181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 309187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309191 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(309254), // Rule ID 13544 //
     /* 309196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309232 */     // MIs[2] Operand 1
     /* 309232 */     // No operand predicates
     /* 309232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309238 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309252 */     GIR_RootConstrainSelectedInstOperands,
     /* 309253 */     // GIR_Coverage, 13544,
     /* 309253 */     GIR_EraseRootFromParent_Done,
     /* 309254 */   // Label 6181: @309254
     /* 309254 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(309317), // Rule ID 2002 //
     /* 309259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309299 */     // MIs[2] Operand 1
     /* 309299 */     // No operand predicates
     /* 309299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309301 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309315 */     GIR_RootConstrainSelectedInstOperands,
     /* 309316 */     // GIR_Coverage, 2002,
     /* 309316 */     GIR_EraseRootFromParent_Done,
     /* 309317 */   // Label 6182: @309317
     /* 309317 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(309344), // Rule ID 1321 //
     /* 309322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309333 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 309333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 309338 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309342 */     GIR_RootConstrainSelectedInstOperands,
     /* 309343 */     // GIR_Coverage, 1321,
     /* 309343 */     GIR_Done,
     /* 309344 */   // Label 6183: @309344
     /* 309344 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(309606), // Rule ID 7059 //
     /* 309349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 309352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309360 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 309360 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 309363 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309367 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309372 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 309376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 309378 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 309381 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309385 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309390 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 309394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 309396 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 309399 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309403 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309408 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 309411 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 309414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 309416 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 309419 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309423 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309428 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309434 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309439 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309444 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 309447 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309451 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309456 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 309459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309461 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 309464 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309468 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309473 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309479 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309484 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309489 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 309492 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309496 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309501 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309506 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 309509 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309513 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309518 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309521 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 309524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309526 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 309529 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 309533 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309538 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309569 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 309578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 309596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 309604 */     GIR_RootConstrainSelectedInstOperands,
     /* 309605 */     // GIR_Coverage, 7059,
     /* 309605 */     GIR_EraseRootFromParent_Done,
     /* 309606 */   // Label 6184: @309606
     /* 309606 */   GIM_Reject,
     /* 309607 */ // Label 6180: @309607
     /* 309607 */ GIM_Reject,
     /* 309608 */ // Label 6120: @309608
     /* 309608 */ GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(309633), // Rule ID 8267 //
     /* 309613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 309619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 309622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309626 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 309626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 309631 */   GIR_RootConstrainSelectedInstOperands,
     /* 309632 */   // GIR_Coverage, 8267,
     /* 309632 */   GIR_Done,
     /* 309633 */ // Label 6185: @309633
     /* 309633 */ GIM_Reject,
     /* 309634 */ // Label 6121: @309634
     /* 309634 */ GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(309659), // Rule ID 8265 //
     /* 309639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 309645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 309648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309652 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 309652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 309657 */   GIR_RootConstrainSelectedInstOperands,
     /* 309658 */   // GIR_Coverage, 8265,
     /* 309658 */   GIR_Done,
     /* 309659 */ // Label 6186: @309659
     /* 309659 */ GIM_Reject,
     /* 309660 */ // Label 6122: @309660
     /* 309660 */ GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(309685), // Rule ID 8263 //
     /* 309665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 309671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 309674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309678 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 309678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 309683 */   GIR_RootConstrainSelectedInstOperands,
     /* 309684 */   // GIR_Coverage, 8263,
     /* 309684 */   GIR_Done,
     /* 309685 */ // Label 6187: @309685
     /* 309685 */ GIM_Reject,
     /* 309686 */ // Label 6123: @309686
     /* 309686 */ GIM_Reject,
     /* 309687 */ // Label 62: @309687
     /* 309687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6196*/ GIMT_Encode4(325959),
     /* 309698 */ /*GILLT_s16*//*Label 6188*/ GIMT_Encode4(309738),
     /* 309702 */ /*GILLT_s32*//*Label 6189*/ GIMT_Encode4(312742),
     /* 309706 */ /*GILLT_s64*//*Label 6190*/ GIMT_Encode4(315890), GIMT_Encode4(0),
     /* 309714 */ /*GILLT_v2s32*//*Label 6191*/ GIMT_Encode4(319038),
     /* 309718 */ /*GILLT_v2s64*//*Label 6192*/ GIMT_Encode4(320559),
     /* 309722 */ /*GILLT_v4s16*//*Label 6193*/ GIMT_Encode4(322080),
     /* 309726 */ /*GILLT_v4s32*//*Label 6194*/ GIMT_Encode4(323259), GIMT_Encode4(0),
     /* 309734 */ /*GILLT_v8s16*//*Label 6195*/ GIMT_Encode4(324780),
     /* 309738 */ // Label 6188: @309738
     /* 309738 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(312741),
     /* 309743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 309749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 309752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309756 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(309906), // Rule ID 4905 //
     /* 309761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309810 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 309818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 309826 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309833 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309845 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309873 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 309892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 309904 */     GIR_RootConstrainSelectedInstOperands,
     /* 309905 */     // GIR_Coverage, 4905,
     /* 309905 */     GIR_EraseRootFromParent_Done,
     /* 309906 */   // Label 6198: @309906
     /* 309906 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310053), // Rule ID 4869 //
     /* 309911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309935 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 309955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309963 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309967 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309972 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309982 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309994 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310022 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310051 */     GIR_RootConstrainSelectedInstOperands,
     /* 310052 */     // GIR_Coverage, 4869,
     /* 310052 */     GIR_EraseRootFromParent_Done,
     /* 310053 */   // Label 6199: @310053
     /* 310053 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310200), // Rule ID 13958 //
     /* 310058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310094 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310114 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310119 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310129 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310129 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310132 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310136 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310141 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310169 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310198 */     GIR_RootConstrainSelectedInstOperands,
     /* 310199 */     // GIR_Coverage, 13958,
     /* 310199 */     GIR_EraseRootFromParent_Done,
     /* 310200 */   // Label 6200: @310200
     /* 310200 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310331), // Rule ID 6124 //
     /* 310205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310229 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 310249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310253 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310257 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310261 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310266 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 310270 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310274 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310278 */     // MIs[4] Operand 1
     /* 310278 */     // No operand predicates
     /* 310278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310282 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310284 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310296 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 310326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 310329 */     GIR_RootConstrainSelectedInstOperands,
     /* 310330 */     // GIR_Coverage, 6124,
     /* 310330 */     GIR_EraseRootFromParent_Done,
     /* 310331 */   // Label 6201: @310331
     /* 310331 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310462), // Rule ID 6156 //
     /* 310336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310372 */     // MIs[2] Operand 1
     /* 310372 */     // No operand predicates
     /* 310372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 310388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310392 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310396 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 310400 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310405 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 310409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310413 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310415 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310427 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310460 */     GIR_RootConstrainSelectedInstOperands,
     /* 310461 */     // GIR_Coverage, 6156,
     /* 310461 */     GIR_EraseRootFromParent_Done,
     /* 310462 */   // Label 6202: @310462
     /* 310462 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310593), // Rule ID 6220 //
     /* 310467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310503 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310515 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310519 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310523 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 310532 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310536 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310540 */     // MIs[4] Operand 1
     /* 310540 */     // No operand predicates
     /* 310540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310544 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310546 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310558 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 310588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 310591 */     GIR_RootConstrainSelectedInstOperands,
     /* 310592 */     // GIR_Coverage, 6220,
     /* 310592 */     GIR_EraseRootFromParent_Done,
     /* 310593 */   // Label 6203: @310593
     /* 310593 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(310724), // Rule ID 6188 //
     /* 310598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310642 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310646 */     // MIs[3] Operand 1
     /* 310646 */     // No operand predicates
     /* 310646 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 310650 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310654 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310658 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 310662 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310667 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 310671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310675 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310677 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310722 */     GIR_RootConstrainSelectedInstOperands,
     /* 310723 */     // GIR_Coverage, 6188,
     /* 310723 */     GIR_EraseRootFromParent_Done,
     /* 310724 */   // Label 6204: @310724
     /* 310724 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(310859), // Rule ID 2459 //
     /* 310729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310753 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310778 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310788 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310800 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310828 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 310847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310857 */     GIR_RootConstrainSelectedInstOperands,
     /* 310858 */     // GIR_Coverage, 2459,
     /* 310858 */     GIR_EraseRootFromParent_Done,
     /* 310859 */   // Label 6205: @310859
     /* 310859 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(310978), // Rule ID 6092 //
     /* 310864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310888 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310925 */     // MIs[3] Operand 1
     /* 310925 */     // No operand predicates
     /* 310925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310931 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310943 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310976 */     GIR_RootConstrainSelectedInstOperands,
     /* 310977 */     // GIR_Coverage, 6092,
     /* 310977 */     GIR_EraseRootFromParent_Done,
     /* 310978 */   // Label 6206: @310978
     /* 310978 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(311097), // Rule ID 2534 //
     /* 310983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311019 */     // MIs[2] Operand 1
     /* 311019 */     // No operand predicates
     /* 311019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311027 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311031 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311040 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311050 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311095 */     GIR_RootConstrainSelectedInstOperands,
     /* 311096 */     // GIR_Coverage, 2534,
     /* 311096 */     GIR_EraseRootFromParent_Done,
     /* 311097 */   // Label 6207: @311097
     /* 311097 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(311197), // Rule ID 4867 //
     /* 311102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311153 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311195 */     GIR_RootConstrainSelectedInstOperands,
     /* 311196 */     // GIR_Coverage, 4867,
     /* 311196 */     GIR_EraseRootFromParent_Done,
     /* 311197 */   // Label 6208: @311197
     /* 311197 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(311297), // Rule ID 4903 //
     /* 311202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311253 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311265 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 311284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311295 */     GIR_RootConstrainSelectedInstOperands,
     /* 311296 */     // GIR_Coverage, 4903,
     /* 311296 */     GIR_EraseRootFromParent_Done,
     /* 311297 */   // Label 6209: @311297
     /* 311297 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(311394), // Rule ID 13954 //
     /* 311302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311338 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311352 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311364 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311392 */     GIR_RootConstrainSelectedInstOperands,
     /* 311393 */     // GIR_Coverage, 13954,
     /* 311393 */     GIR_EraseRootFromParent_Done,
     /* 311394 */   // Label 6210: @311394
     /* 311394 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(311494), // Rule ID 13956 //
     /* 311399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311450 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311462 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311492 */     GIR_RootConstrainSelectedInstOperands,
     /* 311493 */     // GIR_Coverage, 13956,
     /* 311493 */     GIR_EraseRootFromParent_Done,
     /* 311494 */   // Label 6211: @311494
     /* 311494 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(311594), // Rule ID 4901 //
     /* 311499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311527 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311550 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311562 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 311581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311592 */     GIR_RootConstrainSelectedInstOperands,
     /* 311593 */     // GIR_Coverage, 4901,
     /* 311593 */     GIR_EraseRootFromParent_Done,
     /* 311594 */   // Label 6212: @311594
     /* 311594 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(311691), // Rule ID 4865 //
     /* 311599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311639 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311649 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311689 */     GIR_RootConstrainSelectedInstOperands,
     /* 311690 */     // GIR_Coverage, 4865,
     /* 311690 */     GIR_EraseRootFromParent_Done,
     /* 311691 */   // Label 6213: @311691
     /* 311691 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(311775), // Rule ID 6154 //
     /* 311696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311732 */     // MIs[2] Operand 1
     /* 311732 */     // No operand predicates
     /* 311732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311740 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 311744 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311755 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 311766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311773 */     GIR_RootConstrainSelectedInstOperands,
     /* 311774 */     // GIR_Coverage, 6154,
     /* 311774 */     GIR_EraseRootFromParent_Done,
     /* 311775 */   // Label 6214: @311775
     /* 311775 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(311856), // Rule ID 6186 //
     /* 311780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311824 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311828 */     // MIs[3] Operand 1
     /* 311828 */     // No operand predicates
     /* 311828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311838 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311854 */     GIR_RootConstrainSelectedInstOperands,
     /* 311855 */     // GIR_Coverage, 6186,
     /* 311855 */     GIR_EraseRootFromParent_Done,
     /* 311856 */   // Label 6215: @311856
     /* 311856 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(311940), // Rule ID 6218 //
     /* 311861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311914 */     // MIs[3] Operand 1
     /* 311914 */     // No operand predicates
     /* 311914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311920 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311938 */     GIR_RootConstrainSelectedInstOperands,
     /* 311939 */     // GIR_Coverage, 6218,
     /* 311939 */     GIR_EraseRootFromParent_Done,
     /* 311940 */   // Label 6216: @311940
     /* 311940 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(312021), // Rule ID 6122 //
     /* 311945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311993 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311997 */     // MIs[3] Operand 1
     /* 311997 */     // No operand predicates
     /* 311997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312003 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312019 */     GIR_RootConstrainSelectedInstOperands,
     /* 312020 */     // GIR_Coverage, 6122,
     /* 312020 */     GIR_EraseRootFromParent_Done,
     /* 312021 */   // Label 6217: @312021
     /* 312021 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(312106), // Rule ID 2457 //
     /* 312026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312050 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312064 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312104 */     GIR_RootConstrainSelectedInstOperands,
     /* 312105 */     // GIR_Coverage, 2457,
     /* 312105 */     GIR_EraseRootFromParent_Done,
     /* 312106 */   // Label 6218: @312106
     /* 312106 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(312191), // Rule ID 2455 //
     /* 312111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312139 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312149 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312161 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312189 */     GIR_RootConstrainSelectedInstOperands,
     /* 312190 */     // GIR_Coverage, 2455,
     /* 312190 */     GIR_EraseRootFromParent_Done,
     /* 312191 */   // Label 6219: @312191
     /* 312191 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(312260), // Rule ID 2532 //
     /* 312196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312232 */     // MIs[2] Operand 1
     /* 312232 */     // No operand predicates
     /* 312232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312242 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 312245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312258 */     GIR_RootConstrainSelectedInstOperands,
     /* 312259 */     // GIR_Coverage, 2532,
     /* 312259 */     GIR_EraseRootFromParent_Done,
     /* 312260 */   // Label 6220: @312260
     /* 312260 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(312329), // Rule ID 6090 //
     /* 312265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312305 */     // MIs[2] Operand 1
     /* 312305 */     // No operand predicates
     /* 312305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312311 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 312314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312327 */     GIR_RootConstrainSelectedInstOperands,
     /* 312328 */     // GIR_Coverage, 6090,
     /* 312328 */     GIR_EraseRootFromParent_Done,
     /* 312329 */   // Label 6221: @312329
     /* 312329 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(312394), // Rule ID 4921 //
     /* 312334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312377 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 312380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312392 */     GIR_RootConstrainSelectedInstOperands,
     /* 312393 */     // GIR_Coverage, 4921,
     /* 312393 */     GIR_EraseRootFromParent_Done,
     /* 312394 */   // Label 6222: @312394
     /* 312394 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(312459), // Rule ID 13974 //
     /* 312399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312442 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 312445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 312453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312457 */     GIR_RootConstrainSelectedInstOperands,
     /* 312458 */     // GIR_Coverage, 13974,
     /* 312458 */     GIR_EraseRootFromParent_Done,
     /* 312459 */   // Label 6223: @312459
     /* 312459 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(312509), // Rule ID 4918 //
     /* 312464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312494 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312507 */     GIR_RootConstrainSelectedInstOperands,
     /* 312508 */     // GIR_Coverage, 4918,
     /* 312508 */     GIR_EraseRootFromParent_Done,
     /* 312509 */   // Label 6224: @312509
     /* 312509 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(312559), // Rule ID 13390 //
     /* 312514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312544 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312557 */     GIR_RootConstrainSelectedInstOperands,
     /* 312558 */     // GIR_Coverage, 13390,
     /* 312558 */     GIR_EraseRootFromParent_Done,
     /* 312559 */   // Label 6225: @312559
     /* 312559 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(312609), // Rule ID 644 //
     /* 312564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312594 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312607 */     GIR_RootConstrainSelectedInstOperands,
     /* 312608 */     // GIR_Coverage, 644,
     /* 312608 */     GIR_EraseRootFromParent_Done,
     /* 312609 */   // Label 6226: @312609
     /* 312609 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(312659), // Rule ID 13971 //
     /* 312614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312644 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 312655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312657 */     GIR_RootConstrainSelectedInstOperands,
     /* 312658 */     // GIR_Coverage, 13971,
     /* 312658 */     GIR_EraseRootFromParent_Done,
     /* 312659 */   // Label 6227: @312659
     /* 312659 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(312709), // Rule ID 656 //
     /* 312664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 312679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312694 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 312697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 312707 */     GIR_RootConstrainSelectedInstOperands,
     /* 312708 */     // GIR_Coverage, 656,
     /* 312708 */     GIR_EraseRootFromParent_Done,
     /* 312709 */   // Label 6228: @312709
     /* 312709 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(312740), // Rule ID 638 //
     /* 312714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312729 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312738 */     GIR_RootConstrainSelectedInstOperands,
     /* 312739 */     // GIR_Coverage, 638,
     /* 312739 */     GIR_Done,
     /* 312740 */   // Label 6229: @312740
     /* 312740 */   GIM_Reject,
     /* 312741 */ // Label 6197: @312741
     /* 312741 */ GIM_Reject,
     /* 312742 */ // Label 6189: @312742
     /* 312742 */ GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(315889),
     /* 312747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 312756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312760 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(312910), // Rule ID 4911 //
     /* 312765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312789 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312814 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 312822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 312830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312837 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312837 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312840 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312844 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312849 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 312896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 312908 */     GIR_RootConstrainSelectedInstOperands,
     /* 312909 */     // GIR_Coverage, 4911,
     /* 312909 */     GIR_EraseRootFromParent_Done,
     /* 312910 */   // Label 6231: @312910
     /* 312910 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(313057), // Rule ID 4875 //
     /* 312915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312963 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312967 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312971 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312976 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 312980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312986 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312998 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313026 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313055 */     GIR_RootConstrainSelectedInstOperands,
     /* 313056 */     // GIR_Coverage, 4875,
     /* 313056 */     GIR_EraseRootFromParent_Done,
     /* 313057 */   // Label 6232: @313057
     /* 313057 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(313204), // Rule ID 13964 //
     /* 313062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313110 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313114 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313118 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313123 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313133 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313133 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313136 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313140 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313145 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313151 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313156 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313173 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313202 */     GIR_RootConstrainSelectedInstOperands,
     /* 313203 */     // GIR_Coverage, 13964,
     /* 313203 */     GIR_EraseRootFromParent_Done,
     /* 313204 */   // Label 6233: @313204
     /* 313204 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(313335), // Rule ID 6140 //
     /* 313209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313257 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313261 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313265 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313270 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 313274 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313278 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313282 */     // MIs[4] Operand 1
     /* 313282 */     // No operand predicates
     /* 313282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313286 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313288 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313300 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 313330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 313333 */     GIR_RootConstrainSelectedInstOperands,
     /* 313334 */     // GIR_Coverage, 6140,
     /* 313334 */     GIR_EraseRootFromParent_Done,
     /* 313335 */   // Label 6234: @313335
     /* 313335 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(313466), // Rule ID 6172 //
     /* 313340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313372 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313376 */     // MIs[2] Operand 1
     /* 313376 */     // No operand predicates
     /* 313376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313388 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 313392 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313396 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313400 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 313404 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313409 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 313413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313417 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313419 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313431 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313464 */     GIR_RootConstrainSelectedInstOperands,
     /* 313465 */     // GIR_Coverage, 6172,
     /* 313465 */     GIR_EraseRootFromParent_Done,
     /* 313466 */   // Label 6235: @313466
     /* 313466 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(313597), // Rule ID 6236 //
     /* 313471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313507 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 313536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313540 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313544 */     // MIs[4] Operand 1
     /* 313544 */     // No operand predicates
     /* 313544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313548 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313550 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313562 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 313592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 313595 */     GIR_RootConstrainSelectedInstOperands,
     /* 313596 */     // GIR_Coverage, 6236,
     /* 313596 */     GIR_EraseRootFromParent_Done,
     /* 313597 */   // Label 6236: @313597
     /* 313597 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(313728), // Rule ID 6204 //
     /* 313602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313646 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313650 */     // MIs[3] Operand 1
     /* 313650 */     // No operand predicates
     /* 313650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 313654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313658 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313662 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 313666 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313671 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 313675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313679 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313681 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313693 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313726 */     GIR_RootConstrainSelectedInstOperands,
     /* 313727 */     // GIR_Coverage, 6204,
     /* 313727 */     GIR_EraseRootFromParent_Done,
     /* 313728 */   // Label 6237: @313728
     /* 313728 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(313863), // Rule ID 2465 //
     /* 313733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313757 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313782 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313792 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313804 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313832 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 313851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313861 */     GIR_RootConstrainSelectedInstOperands,
     /* 313862 */     // GIR_Coverage, 2465,
     /* 313862 */     GIR_EraseRootFromParent_Done,
     /* 313863 */   // Label 6238: @313863
     /* 313863 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(313982), // Rule ID 6108 //
     /* 313868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313925 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313929 */     // MIs[3] Operand 1
     /* 313929 */     // No operand predicates
     /* 313929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313935 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313980 */     GIR_RootConstrainSelectedInstOperands,
     /* 313981 */     // GIR_Coverage, 6108,
     /* 313981 */     GIR_EraseRootFromParent_Done,
     /* 313982 */   // Label 6239: @313982
     /* 313982 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(314101), // Rule ID 2550 //
     /* 313987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314023 */     // MIs[2] Operand 1
     /* 314023 */     // No operand predicates
     /* 314023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314035 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314044 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314054 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314066 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314099 */     GIR_RootConstrainSelectedInstOperands,
     /* 314100 */     // GIR_Coverage, 2550,
     /* 314100 */     GIR_EraseRootFromParent_Done,
     /* 314101 */   // Label 6240: @314101
     /* 314101 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(314201), // Rule ID 4873 //
     /* 314106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314130 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314157 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314169 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314199 */     GIR_RootConstrainSelectedInstOperands,
     /* 314200 */     // GIR_Coverage, 4873,
     /* 314200 */     GIR_EraseRootFromParent_Done,
     /* 314201 */   // Label 6241: @314201
     /* 314201 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(314301), // Rule ID 4909 //
     /* 314206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314230 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314257 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314269 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314299 */     GIR_RootConstrainSelectedInstOperands,
     /* 314300 */     // GIR_Coverage, 4909,
     /* 314300 */     GIR_EraseRootFromParent_Done,
     /* 314301 */   // Label 6242: @314301
     /* 314301 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(314398), // Rule ID 13960 //
     /* 314306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314342 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314356 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314368 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314396 */     GIR_RootConstrainSelectedInstOperands,
     /* 314397 */     // GIR_Coverage, 13960,
     /* 314397 */     GIR_EraseRootFromParent_Done,
     /* 314398 */   // Label 6243: @314398
     /* 314398 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(314498), // Rule ID 13962 //
     /* 314403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314444 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314454 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314466 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314496 */     GIR_RootConstrainSelectedInstOperands,
     /* 314497 */     // GIR_Coverage, 13962,
     /* 314497 */     GIR_EraseRootFromParent_Done,
     /* 314498 */   // Label 6244: @314498
     /* 314498 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(314598), // Rule ID 4907 //
     /* 314503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314554 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314566 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314596 */     GIR_RootConstrainSelectedInstOperands,
     /* 314597 */     // GIR_Coverage, 4907,
     /* 314597 */     GIR_EraseRootFromParent_Done,
     /* 314598 */   // Label 6245: @314598
     /* 314598 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(314695), // Rule ID 4871 //
     /* 314603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314643 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314653 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314665 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314693 */     GIR_RootConstrainSelectedInstOperands,
     /* 314694 */     // GIR_Coverage, 4871,
     /* 314694 */     GIR_EraseRootFromParent_Done,
     /* 314695 */   // Label 6246: @314695
     /* 314695 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(314773), // Rule ID 6258 //
     /* 314700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 314737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314741 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314745 */     // MIs[3] Operand 1
     /* 314745 */     // No operand predicates
     /* 314745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314755 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314771 */     GIR_RootConstrainSelectedInstOperands,
     /* 314772 */     // GIR_Coverage, 6258,
     /* 314772 */     GIR_EraseRootFromParent_Done,
     /* 314773 */   // Label 6247: @314773
     /* 314773 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(314857), // Rule ID 6170 //
     /* 314778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314814 */     // MIs[2] Operand 1
     /* 314814 */     // No operand predicates
     /* 314814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 314826 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314837 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 314848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314855 */     GIR_RootConstrainSelectedInstOperands,
     /* 314856 */     // GIR_Coverage, 6170,
     /* 314856 */     GIR_EraseRootFromParent_Done,
     /* 314857 */   // Label 6248: @314857
     /* 314857 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(314938), // Rule ID 6202 //
     /* 314862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314910 */     // MIs[3] Operand 1
     /* 314910 */     // No operand predicates
     /* 314910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314920 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314936 */     GIR_RootConstrainSelectedInstOperands,
     /* 314937 */     // GIR_Coverage, 6202,
     /* 314937 */     GIR_EraseRootFromParent_Done,
     /* 314938 */   // Label 6249: @314938
     /* 314938 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(315022), // Rule ID 6234 //
     /* 314943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314992 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314996 */     // MIs[3] Operand 1
     /* 314996 */     // No operand predicates
     /* 314996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315002 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315020 */     GIR_RootConstrainSelectedInstOperands,
     /* 315021 */     // GIR_Coverage, 6234,
     /* 315021 */     GIR_EraseRootFromParent_Done,
     /* 315022 */   // Label 6250: @315022
     /* 315022 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(315100), // Rule ID 6280 //
     /* 315027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 315068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315072 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315076 */     // MIs[3] Operand 1
     /* 315076 */     // No operand predicates
     /* 315076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315082 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315098 */     GIR_RootConstrainSelectedInstOperands,
     /* 315099 */     // GIR_Coverage, 6280,
     /* 315099 */     GIR_EraseRootFromParent_Done,
     /* 315100 */   // Label 6251: @315100
     /* 315100 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(315181), // Rule ID 6138 //
     /* 315105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315157 */     // MIs[3] Operand 1
     /* 315157 */     // No operand predicates
     /* 315157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315163 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315179 */     GIR_RootConstrainSelectedInstOperands,
     /* 315180 */     // GIR_Coverage, 6138,
     /* 315180 */     GIR_EraseRootFromParent_Done,
     /* 315181 */   // Label 6252: @315181
     /* 315181 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(315266), // Rule ID 2463 //
     /* 315186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315210 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315224 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315236 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315264 */     GIR_RootConstrainSelectedInstOperands,
     /* 315265 */     // GIR_Coverage, 2463,
     /* 315265 */     GIR_EraseRootFromParent_Done,
     /* 315266 */   // Label 6253: @315266
     /* 315266 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(315351), // Rule ID 2461 //
     /* 315271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315299 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315309 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315349 */     GIR_RootConstrainSelectedInstOperands,
     /* 315350 */     // GIR_Coverage, 2461,
     /* 315350 */     GIR_EraseRootFromParent_Done,
     /* 315351 */   // Label 6254: @315351
     /* 315351 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(315420), // Rule ID 2548 //
     /* 315356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315392 */     // MIs[2] Operand 1
     /* 315392 */     // No operand predicates
     /* 315392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315402 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 315405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315418 */     GIR_RootConstrainSelectedInstOperands,
     /* 315419 */     // GIR_Coverage, 2548,
     /* 315419 */     GIR_EraseRootFromParent_Done,
     /* 315420 */   // Label 6255: @315420
     /* 315420 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(315489), // Rule ID 6106 //
     /* 315425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315465 */     // MIs[2] Operand 1
     /* 315465 */     // No operand predicates
     /* 315465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315471 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 315474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315487 */     GIR_RootConstrainSelectedInstOperands,
     /* 315488 */     // GIR_Coverage, 6106,
     /* 315488 */     GIR_EraseRootFromParent_Done,
     /* 315489 */   // Label 6256: @315489
     /* 315489 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(315551), // Rule ID 4922 //
     /* 315494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315534 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 315537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315549 */     GIR_RootConstrainSelectedInstOperands,
     /* 315550 */     // GIR_Coverage, 4922,
     /* 315550 */     GIR_EraseRootFromParent_Done,
     /* 315551 */   // Label 6257: @315551
     /* 315551 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(315613), // Rule ID 13975 //
     /* 315556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315596 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 315599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 315607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315611 */     GIR_RootConstrainSelectedInstOperands,
     /* 315612 */     // GIR_Coverage, 13975,
     /* 315612 */     GIR_EraseRootFromParent_Done,
     /* 315613 */   // Label 6258: @315613
     /* 315613 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(315660), // Rule ID 4919 //
     /* 315618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315645 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315658 */     GIR_RootConstrainSelectedInstOperands,
     /* 315659 */     // GIR_Coverage, 4919,
     /* 315659 */     GIR_EraseRootFromParent_Done,
     /* 315660 */   // Label 6259: @315660
     /* 315660 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(315710), // Rule ID 13392 //
     /* 315665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315695 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315708 */     GIR_RootConstrainSelectedInstOperands,
     /* 315709 */     // GIR_Coverage, 13392,
     /* 315709 */     GIR_EraseRootFromParent_Done,
     /* 315710 */   // Label 6260: @315710
     /* 315710 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(315760), // Rule ID 646 //
     /* 315715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315745 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315758 */     GIR_RootConstrainSelectedInstOperands,
     /* 315759 */     // GIR_Coverage, 646,
     /* 315759 */     GIR_EraseRootFromParent_Done,
     /* 315760 */   // Label 6261: @315760
     /* 315760 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(315807), // Rule ID 13972 //
     /* 315765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315792 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 315803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315805 */     GIR_RootConstrainSelectedInstOperands,
     /* 315806 */     // GIR_Coverage, 13972,
     /* 315806 */     GIR_EraseRootFromParent_Done,
     /* 315807 */   // Label 6262: @315807
     /* 315807 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(315857), // Rule ID 658 //
     /* 315812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 315827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315842 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 315845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 315855 */     GIR_RootConstrainSelectedInstOperands,
     /* 315856 */     // GIR_Coverage, 658,
     /* 315856 */     GIR_EraseRootFromParent_Done,
     /* 315857 */   // Label 6263: @315857
     /* 315857 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(315888), // Rule ID 640 //
     /* 315862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315877 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315882 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315886 */     GIR_RootConstrainSelectedInstOperands,
     /* 315887 */     // GIR_Coverage, 640,
     /* 315887 */     GIR_Done,
     /* 315888 */   // Label 6264: @315888
     /* 315888 */   GIM_Reject,
     /* 315889 */ // Label 6230: @315889
     /* 315889 */ GIM_Reject,
     /* 315890 */ // Label 6190: @315890
     /* 315890 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(319037),
     /* 315895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 315904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315908 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(316058), // Rule ID 4917 //
     /* 315913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315962 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 315970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 315978 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315985 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315985 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315988 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315992 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315997 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316025 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 316056 */     GIR_RootConstrainSelectedInstOperands,
     /* 316057 */     // GIR_Coverage, 4917,
     /* 316057 */     GIR_EraseRootFromParent_Done,
     /* 316058 */   // Label 6266: @316058
     /* 316058 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(316205), // Rule ID 4881 //
     /* 316063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316087 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316115 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316119 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316124 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316134 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316146 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316203 */     GIR_RootConstrainSelectedInstOperands,
     /* 316204 */     // GIR_Coverage, 4881,
     /* 316204 */     GIR_EraseRootFromParent_Done,
     /* 316205 */   // Label 6267: @316205
     /* 316205 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(316352), // Rule ID 13970 //
     /* 316210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316266 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316271 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316281 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316293 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316350 */     GIR_RootConstrainSelectedInstOperands,
     /* 316351 */     // GIR_Coverage, 13970,
     /* 316351 */     GIR_EraseRootFromParent_Done,
     /* 316352 */   // Label 6268: @316352
     /* 316352 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(316483), // Rule ID 6144 //
     /* 316357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316381 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316405 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316409 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316413 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316418 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 316422 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316426 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316430 */     // MIs[4] Operand 1
     /* 316430 */     // No operand predicates
     /* 316430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316436 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 316478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 316481 */     GIR_RootConstrainSelectedInstOperands,
     /* 316482 */     // GIR_Coverage, 6144,
     /* 316482 */     GIR_EraseRootFromParent_Done,
     /* 316483 */   // Label 6269: @316483
     /* 316483 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(316614), // Rule ID 6176 //
     /* 316488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316520 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316524 */     // MIs[2] Operand 1
     /* 316524 */     // No operand predicates
     /* 316524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 316536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 316540 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316544 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316548 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 316552 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316557 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 316561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316565 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316567 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316612 */     GIR_RootConstrainSelectedInstOperands,
     /* 316613 */     // GIR_Coverage, 6176,
     /* 316613 */     GIR_EraseRootFromParent_Done,
     /* 316614 */   // Label 6270: @316614
     /* 316614 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(316745), // Rule ID 6240 //
     /* 316619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316655 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316680 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 316684 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316688 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316692 */     // MIs[4] Operand 1
     /* 316692 */     // No operand predicates
     /* 316692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316698 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 316740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 316743 */     GIR_RootConstrainSelectedInstOperands,
     /* 316744 */     // GIR_Coverage, 6240,
     /* 316744 */     GIR_EraseRootFromParent_Done,
     /* 316745 */   // Label 6271: @316745
     /* 316745 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(316876), // Rule ID 6208 //
     /* 316750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316794 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316798 */     // MIs[3] Operand 1
     /* 316798 */     // No operand predicates
     /* 316798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 316802 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316806 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316810 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 316814 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316819 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 316823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316827 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316829 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316874 */     GIR_RootConstrainSelectedInstOperands,
     /* 316875 */     // GIR_Coverage, 6208,
     /* 316875 */     GIR_EraseRootFromParent_Done,
     /* 316876 */   // Label 6272: @316876
     /* 316876 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(317011), // Rule ID 2471 //
     /* 316881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316905 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316930 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316940 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316952 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 316999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 317007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317009 */     GIR_RootConstrainSelectedInstOperands,
     /* 317010 */     // GIR_Coverage, 2471,
     /* 317010 */     GIR_EraseRootFromParent_Done,
     /* 317011 */   // Label 6273: @317011
     /* 317011 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(317130), // Rule ID 6112 //
     /* 317016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317040 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317073 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317077 */     // MIs[3] Operand 1
     /* 317077 */     // No operand predicates
     /* 317077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317083 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317095 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317128 */     GIR_RootConstrainSelectedInstOperands,
     /* 317129 */     // GIR_Coverage, 6112,
     /* 317129 */     GIR_EraseRootFromParent_Done,
     /* 317130 */   // Label 6274: @317130
     /* 317130 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(317249), // Rule ID 2554 //
     /* 317135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317167 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317171 */     // MIs[2] Operand 1
     /* 317171 */     // No operand predicates
     /* 317171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317192 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 317196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317202 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317214 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317247 */     GIR_RootConstrainSelectedInstOperands,
     /* 317248 */     // GIR_Coverage, 2554,
     /* 317248 */     GIR_EraseRootFromParent_Done,
     /* 317249 */   // Label 6275: @317249
     /* 317249 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(317349), // Rule ID 4879 //
     /* 317254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317278 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317305 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317347 */     GIR_RootConstrainSelectedInstOperands,
     /* 317348 */     // GIR_Coverage, 4879,
     /* 317348 */     GIR_EraseRootFromParent_Done,
     /* 317349 */   // Label 6276: @317349
     /* 317349 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(317449), // Rule ID 4915 //
     /* 317354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317378 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317405 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317417 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317447 */     GIR_RootConstrainSelectedInstOperands,
     /* 317448 */     // GIR_Coverage, 4915,
     /* 317448 */     GIR_EraseRootFromParent_Done,
     /* 317449 */   // Label 6277: @317449
     /* 317449 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(317546), // Rule ID 13966 //
     /* 317454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317490 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317504 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317544 */     GIR_RootConstrainSelectedInstOperands,
     /* 317545 */     // GIR_Coverage, 13966,
     /* 317545 */     GIR_EraseRootFromParent_Done,
     /* 317546 */   // Label 6278: @317546
     /* 317546 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(317646), // Rule ID 13968 //
     /* 317551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317602 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317614 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317644 */     GIR_RootConstrainSelectedInstOperands,
     /* 317645 */     // GIR_Coverage, 13968,
     /* 317645 */     GIR_EraseRootFromParent_Done,
     /* 317646 */   // Label 6279: @317646
     /* 317646 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(317746), // Rule ID 4913 //
     /* 317651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317702 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317714 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317744 */     GIR_RootConstrainSelectedInstOperands,
     /* 317745 */     // GIR_Coverage, 4913,
     /* 317745 */     GIR_EraseRootFromParent_Done,
     /* 317746 */   // Label 6280: @317746
     /* 317746 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(317843), // Rule ID 4877 //
     /* 317751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317801 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317813 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317841 */     GIR_RootConstrainSelectedInstOperands,
     /* 317842 */     // GIR_Coverage, 4877,
     /* 317842 */     GIR_EraseRootFromParent_Done,
     /* 317843 */   // Label 6281: @317843
     /* 317843 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(317921), // Rule ID 6262 //
     /* 317848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317889 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317893 */     // MIs[3] Operand 1
     /* 317893 */     // No operand predicates
     /* 317893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317903 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317919 */     GIR_RootConstrainSelectedInstOperands,
     /* 317920 */     // GIR_Coverage, 6262,
     /* 317920 */     GIR_EraseRootFromParent_Done,
     /* 317921 */   // Label 6282: @317921
     /* 317921 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(318005), // Rule ID 6174 //
     /* 317926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317962 */     // MIs[2] Operand 1
     /* 317962 */     // No operand predicates
     /* 317962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317970 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 317974 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317985 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 317996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318003 */     GIR_RootConstrainSelectedInstOperands,
     /* 318004 */     // GIR_Coverage, 6174,
     /* 318004 */     GIR_EraseRootFromParent_Done,
     /* 318005 */   // Label 6283: @318005
     /* 318005 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(318086), // Rule ID 6206 //
     /* 318010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318054 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318058 */     // MIs[3] Operand 1
     /* 318058 */     // No operand predicates
     /* 318058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318068 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318084 */     GIR_RootConstrainSelectedInstOperands,
     /* 318085 */     // GIR_Coverage, 6206,
     /* 318085 */     GIR_EraseRootFromParent_Done,
     /* 318086 */   // Label 6284: @318086
     /* 318086 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(318170), // Rule ID 6238 //
     /* 318091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318140 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318144 */     // MIs[3] Operand 1
     /* 318144 */     // No operand predicates
     /* 318144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318150 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318168 */     GIR_RootConstrainSelectedInstOperands,
     /* 318169 */     // GIR_Coverage, 6238,
     /* 318169 */     GIR_EraseRootFromParent_Done,
     /* 318170 */   // Label 6285: @318170
     /* 318170 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(318248), // Rule ID 6284 //
     /* 318175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318220 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318224 */     // MIs[3] Operand 1
     /* 318224 */     // No operand predicates
     /* 318224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318230 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318246 */     GIR_RootConstrainSelectedInstOperands,
     /* 318247 */     // GIR_Coverage, 6284,
     /* 318247 */     GIR_EraseRootFromParent_Done,
     /* 318248 */   // Label 6286: @318248
     /* 318248 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(318329), // Rule ID 6142 //
     /* 318253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318305 */     // MIs[3] Operand 1
     /* 318305 */     // No operand predicates
     /* 318305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318311 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318327 */     GIR_RootConstrainSelectedInstOperands,
     /* 318328 */     // GIR_Coverage, 6142,
     /* 318328 */     GIR_EraseRootFromParent_Done,
     /* 318329 */   // Label 6287: @318329
     /* 318329 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(318414), // Rule ID 2469 //
     /* 318334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318358 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318372 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318384 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318412 */     GIR_RootConstrainSelectedInstOperands,
     /* 318413 */     // GIR_Coverage, 2469,
     /* 318413 */     GIR_EraseRootFromParent_Done,
     /* 318414 */   // Label 6288: @318414
     /* 318414 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(318499), // Rule ID 2467 //
     /* 318419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318447 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318457 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318497 */     GIR_RootConstrainSelectedInstOperands,
     /* 318498 */     // GIR_Coverage, 2467,
     /* 318498 */     GIR_EraseRootFromParent_Done,
     /* 318499 */   // Label 6289: @318499
     /* 318499 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(318568), // Rule ID 2552 //
     /* 318504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318536 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318540 */     // MIs[2] Operand 1
     /* 318540 */     // No operand predicates
     /* 318540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318550 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 318553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318566 */     GIR_RootConstrainSelectedInstOperands,
     /* 318567 */     // GIR_Coverage, 2552,
     /* 318567 */     GIR_EraseRootFromParent_Done,
     /* 318568 */   // Label 6290: @318568
     /* 318568 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(318637), // Rule ID 6110 //
     /* 318573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318613 */     // MIs[2] Operand 1
     /* 318613 */     // No operand predicates
     /* 318613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318619 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 318622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318635 */     GIR_RootConstrainSelectedInstOperands,
     /* 318636 */     // GIR_Coverage, 6110,
     /* 318636 */     GIR_EraseRootFromParent_Done,
     /* 318637 */   // Label 6291: @318637
     /* 318637 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(318699), // Rule ID 4923 //
     /* 318642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 318667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318682 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 318685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 318697 */     GIR_RootConstrainSelectedInstOperands,
     /* 318698 */     // GIR_Coverage, 4923,
     /* 318698 */     GIR_EraseRootFromParent_Done,
     /* 318699 */   // Label 6292: @318699
     /* 318699 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(318761), // Rule ID 13976 //
     /* 318704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 318729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318744 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 318747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 318755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 318759 */     GIR_RootConstrainSelectedInstOperands,
     /* 318760 */     // GIR_Coverage, 13976,
     /* 318760 */     GIR_EraseRootFromParent_Done,
     /* 318761 */   // Label 6293: @318761
     /* 318761 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318808), // Rule ID 4920 //
     /* 318766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318793 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318806 */     GIR_RootConstrainSelectedInstOperands,
     /* 318807 */     // GIR_Coverage, 4920,
     /* 318807 */     GIR_EraseRootFromParent_Done,
     /* 318808 */   // Label 6294: @318808
     /* 318808 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318858), // Rule ID 13394 //
     /* 318813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318843 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318856 */     GIR_RootConstrainSelectedInstOperands,
     /* 318857 */     // GIR_Coverage, 13394,
     /* 318857 */     GIR_EraseRootFromParent_Done,
     /* 318858 */   // Label 6295: @318858
     /* 318858 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(318908), // Rule ID 648 //
     /* 318863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318893 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318898 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318906 */     GIR_RootConstrainSelectedInstOperands,
     /* 318907 */     // GIR_Coverage, 648,
     /* 318907 */     GIR_EraseRootFromParent_Done,
     /* 318908 */   // Label 6296: @318908
     /* 318908 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(318955), // Rule ID 13973 //
     /* 318913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318940 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 318951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318953 */     GIR_RootConstrainSelectedInstOperands,
     /* 318954 */     // GIR_Coverage, 13973,
     /* 318954 */     GIR_EraseRootFromParent_Done,
     /* 318955 */   // Label 6297: @318955
     /* 318955 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(319005), // Rule ID 660 //
     /* 318960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 318975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318990 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 318993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 319003 */     GIR_RootConstrainSelectedInstOperands,
     /* 319004 */     // GIR_Coverage, 660,
     /* 319004 */     GIR_EraseRootFromParent_Done,
     /* 319005 */   // Label 6298: @319005
     /* 319005 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(319036), // Rule ID 642 //
     /* 319010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319025 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 319030 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319034 */     GIR_RootConstrainSelectedInstOperands,
     /* 319035 */     // GIR_Coverage, 642,
     /* 319035 */     GIR_Done,
     /* 319036 */   // Label 6299: @319036
     /* 319036 */   GIM_Reject,
     /* 319037 */ // Label 6265: @319037
     /* 319037 */ GIM_Reject,
     /* 319038 */ // Label 6191: @319038
     /* 319038 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(320558),
     /* 319043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 319049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 319052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319056 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(319134), // Rule ID 6242 //
     /* 319061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319102 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319106 */     // MIs[3] Operand 1
     /* 319106 */     // No operand predicates
     /* 319106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319116 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319132 */     GIR_RootConstrainSelectedInstOperands,
     /* 319133 */     // GIR_Coverage, 6242,
     /* 319133 */     GIR_EraseRootFromParent_Done,
     /* 319134 */   // Label 6301: @319134
     /* 319134 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(319218), // Rule ID 6158 //
     /* 319139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319171 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319175 */     // MIs[2] Operand 1
     /* 319175 */     // No operand predicates
     /* 319175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 319179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319183 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319198 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 319209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319216 */     GIR_RootConstrainSelectedInstOperands,
     /* 319217 */     // GIR_Coverage, 6158,
     /* 319217 */     GIR_EraseRootFromParent_Done,
     /* 319218 */   // Label 6302: @319218
     /* 319218 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(319299), // Rule ID 6190 //
     /* 319223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319271 */     // MIs[3] Operand 1
     /* 319271 */     // No operand predicates
     /* 319271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319281 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319297 */     GIR_RootConstrainSelectedInstOperands,
     /* 319298 */     // GIR_Coverage, 6190,
     /* 319298 */     GIR_EraseRootFromParent_Done,
     /* 319299 */   // Label 6303: @319299
     /* 319299 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(319383), // Rule ID 6222 //
     /* 319304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319353 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319357 */     // MIs[3] Operand 1
     /* 319357 */     // No operand predicates
     /* 319357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319363 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319381 */     GIR_RootConstrainSelectedInstOperands,
     /* 319382 */     // GIR_Coverage, 6222,
     /* 319382 */     GIR_EraseRootFromParent_Done,
     /* 319383 */   // Label 6304: @319383
     /* 319383 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(319461), // Rule ID 6264 //
     /* 319388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319433 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319437 */     // MIs[3] Operand 1
     /* 319437 */     // No operand predicates
     /* 319437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319443 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319459 */     GIR_RootConstrainSelectedInstOperands,
     /* 319460 */     // GIR_Coverage, 6264,
     /* 319460 */     GIR_EraseRootFromParent_Done,
     /* 319461 */   // Label 6305: @319461
     /* 319461 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319542), // Rule ID 6126 //
     /* 319466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319514 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319518 */     // MIs[3] Operand 1
     /* 319518 */     // No operand predicates
     /* 319518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319524 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319540 */     GIR_RootConstrainSelectedInstOperands,
     /* 319541 */     // GIR_Coverage, 6126,
     /* 319541 */     GIR_EraseRootFromParent_Done,
     /* 319542 */   // Label 6306: @319542
     /* 319542 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319611), // Rule ID 2536 //
     /* 319547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319583 */     // MIs[2] Operand 1
     /* 319583 */     // No operand predicates
     /* 319583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319593 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319609 */     GIR_RootConstrainSelectedInstOperands,
     /* 319610 */     // GIR_Coverage, 2536,
     /* 319610 */     GIR_EraseRootFromParent_Done,
     /* 319611 */   // Label 6307: @319611
     /* 319611 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319680), // Rule ID 6094 //
     /* 319616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319656 */     // MIs[2] Operand 1
     /* 319656 */     // No operand predicates
     /* 319656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319662 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319678 */     GIR_RootConstrainSelectedInstOperands,
     /* 319679 */     // GIR_Coverage, 6094,
     /* 319679 */     GIR_EraseRootFromParent_Done,
     /* 319680 */   // Label 6308: @319680
     /* 319680 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319773), // Rule ID 6246 //
     /* 319685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319724 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319736 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319771 */     GIR_RootConstrainSelectedInstOperands,
     /* 319772 */     // GIR_Coverage, 6246,
     /* 319772 */     GIR_EraseRootFromParent_Done,
     /* 319773 */   // Label 6309: @319773
     /* 319773 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(319872), // Rule ID 6160 //
     /* 319778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319821 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319833 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319840 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 319864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319870 */     GIR_RootConstrainSelectedInstOperands,
     /* 319871 */     // GIR_Coverage, 6160,
     /* 319871 */     GIR_EraseRootFromParent_Done,
     /* 319872 */   // Label 6310: @319872
     /* 319872 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(319968), // Rule ID 6192 //
     /* 319877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319919 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319966 */     GIR_RootConstrainSelectedInstOperands,
     /* 319967 */     // GIR_Coverage, 6192,
     /* 319967 */     GIR_EraseRootFromParent_Done,
     /* 319968 */   // Label 6311: @319968
     /* 319968 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(320067), // Rule ID 6224 //
     /* 319973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320016 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320065 */     GIR_RootConstrainSelectedInstOperands,
     /* 320066 */     // GIR_Coverage, 6224,
     /* 320066 */     GIR_EraseRootFromParent_Done,
     /* 320067 */   // Label 6312: @320067
     /* 320067 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(320160), // Rule ID 6268 //
     /* 320072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320111 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320158 */     GIR_RootConstrainSelectedInstOperands,
     /* 320159 */     // GIR_Coverage, 6268,
     /* 320159 */     GIR_EraseRootFromParent_Done,
     /* 320160 */   // Label 6313: @320160
     /* 320160 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(320256), // Rule ID 6128 //
     /* 320165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320207 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320226 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320254 */     GIR_RootConstrainSelectedInstOperands,
     /* 320255 */     // GIR_Coverage, 6128,
     /* 320255 */     GIR_EraseRootFromParent_Done,
     /* 320256 */   // Label 6314: @320256
     /* 320256 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(320340), // Rule ID 2538 //
     /* 320261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320291 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320310 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320338 */     GIR_RootConstrainSelectedInstOperands,
     /* 320339 */     // GIR_Coverage, 2538,
     /* 320339 */     GIR_EraseRootFromParent_Done,
     /* 320340 */   // Label 6315: @320340
     /* 320340 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(320390), // Rule ID 13424 //
     /* 320345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320375 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 320378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320388 */     GIR_RootConstrainSelectedInstOperands,
     /* 320389 */     // GIR_Coverage, 13424,
     /* 320389 */     GIR_EraseRootFromParent_Done,
     /* 320390 */   // Label 6316: @320390
     /* 320390 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(320474), // Rule ID 6096 //
     /* 320395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320425 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320437 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320444 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320472 */     GIR_RootConstrainSelectedInstOperands,
     /* 320473 */     // GIR_Coverage, 6096,
     /* 320473 */     GIR_EraseRootFromParent_Done,
     /* 320474 */   // Label 6317: @320474
     /* 320474 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(320524), // Rule ID 1308 //
     /* 320479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320509 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 320512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320522 */     GIR_RootConstrainSelectedInstOperands,
     /* 320523 */     // GIR_Coverage, 1308,
     /* 320523 */     GIR_EraseRootFromParent_Done,
     /* 320524 */   // Label 6318: @320524
     /* 320524 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(320557), // Rule ID 1298 //
     /* 320529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320544 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 320547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 320555 */     GIR_RootConstrainSelectedInstOperands,
     /* 320556 */     // GIR_Coverage, 1298,
     /* 320556 */     GIR_EraseRootFromParent_Done,
     /* 320557 */   // Label 6319: @320557
     /* 320557 */   GIM_Reject,
     /* 320558 */ // Label 6300: @320558
     /* 320558 */ GIM_Reject,
     /* 320559 */ // Label 6192: @320559
     /* 320559 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(322079),
     /* 320564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 320570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 320573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320577 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320655), // Rule ID 6254 //
     /* 320582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 320619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320623 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320627 */     // MIs[3] Operand 1
     /* 320627 */     // No operand predicates
     /* 320627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320637 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320653 */     GIR_RootConstrainSelectedInstOperands,
     /* 320654 */     // GIR_Coverage, 6254,
     /* 320654 */     GIR_EraseRootFromParent_Done,
     /* 320655 */   // Label 6321: @320655
     /* 320655 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320739), // Rule ID 6166 //
     /* 320660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320696 */     // MIs[2] Operand 1
     /* 320696 */     // No operand predicates
     /* 320696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 320700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320708 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320719 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 320730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320737 */     GIR_RootConstrainSelectedInstOperands,
     /* 320738 */     // GIR_Coverage, 6166,
     /* 320738 */     GIR_EraseRootFromParent_Done,
     /* 320739 */   // Label 6322: @320739
     /* 320739 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320820), // Rule ID 6198 //
     /* 320744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320788 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320792 */     // MIs[3] Operand 1
     /* 320792 */     // No operand predicates
     /* 320792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320802 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320818 */     GIR_RootConstrainSelectedInstOperands,
     /* 320819 */     // GIR_Coverage, 6198,
     /* 320819 */     GIR_EraseRootFromParent_Done,
     /* 320820 */   // Label 6323: @320820
     /* 320820 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(320904), // Rule ID 6230 //
     /* 320825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320874 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320878 */     // MIs[3] Operand 1
     /* 320878 */     // No operand predicates
     /* 320878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320884 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320902 */     GIR_RootConstrainSelectedInstOperands,
     /* 320903 */     // GIR_Coverage, 6230,
     /* 320903 */     GIR_EraseRootFromParent_Done,
     /* 320904 */   // Label 6324: @320904
     /* 320904 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(320982), // Rule ID 6276 //
     /* 320909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 320950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320954 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320958 */     // MIs[3] Operand 1
     /* 320958 */     // No operand predicates
     /* 320958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320964 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320980 */     GIR_RootConstrainSelectedInstOperands,
     /* 320981 */     // GIR_Coverage, 6276,
     /* 320981 */     GIR_EraseRootFromParent_Done,
     /* 320982 */   // Label 6325: @320982
     /* 320982 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(321063), // Rule ID 6134 //
     /* 320987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321035 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321039 */     // MIs[3] Operand 1
     /* 321039 */     // No operand predicates
     /* 321039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321045 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321061 */     GIR_RootConstrainSelectedInstOperands,
     /* 321062 */     // GIR_Coverage, 6134,
     /* 321062 */     GIR_EraseRootFromParent_Done,
     /* 321063 */   // Label 6326: @321063
     /* 321063 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(321132), // Rule ID 2544 //
     /* 321068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321100 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321104 */     // MIs[2] Operand 1
     /* 321104 */     // No operand predicates
     /* 321104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321114 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321130 */     GIR_RootConstrainSelectedInstOperands,
     /* 321131 */     // GIR_Coverage, 2544,
     /* 321131 */     GIR_EraseRootFromParent_Done,
     /* 321132 */   // Label 6327: @321132
     /* 321132 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(321201), // Rule ID 6102 //
     /* 321137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321173 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321177 */     // MIs[2] Operand 1
     /* 321177 */     // No operand predicates
     /* 321177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321183 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321199 */     GIR_RootConstrainSelectedInstOperands,
     /* 321200 */     // GIR_Coverage, 6102,
     /* 321200 */     GIR_EraseRootFromParent_Done,
     /* 321201 */   // Label 6328: @321201
     /* 321201 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(321294), // Rule ID 6256 //
     /* 321206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321245 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321264 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321292 */     GIR_RootConstrainSelectedInstOperands,
     /* 321293 */     // GIR_Coverage, 6256,
     /* 321293 */     GIR_EraseRootFromParent_Done,
     /* 321294 */   // Label 6329: @321294
     /* 321294 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(321393), // Rule ID 6168 //
     /* 321299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321342 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321361 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 321385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321391 */     GIR_RootConstrainSelectedInstOperands,
     /* 321392 */     // GIR_Coverage, 6168,
     /* 321392 */     GIR_EraseRootFromParent_Done,
     /* 321393 */   // Label 6330: @321393
     /* 321393 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(321489), // Rule ID 6200 //
     /* 321398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321440 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321487 */     GIR_RootConstrainSelectedInstOperands,
     /* 321488 */     // GIR_Coverage, 6200,
     /* 321488 */     GIR_EraseRootFromParent_Done,
     /* 321489 */   // Label 6331: @321489
     /* 321489 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(321588), // Rule ID 6232 //
     /* 321494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321537 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321556 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321586 */     GIR_RootConstrainSelectedInstOperands,
     /* 321587 */     // GIR_Coverage, 6232,
     /* 321587 */     GIR_EraseRootFromParent_Done,
     /* 321588 */   // Label 6332: @321588
     /* 321588 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321681), // Rule ID 6278 //
     /* 321593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321632 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321644 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321647 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321651 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321679 */     GIR_RootConstrainSelectedInstOperands,
     /* 321680 */     // GIR_Coverage, 6278,
     /* 321680 */     GIR_EraseRootFromParent_Done,
     /* 321681 */   // Label 6333: @321681
     /* 321681 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(321777), // Rule ID 6136 //
     /* 321686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321728 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321775 */     GIR_RootConstrainSelectedInstOperands,
     /* 321776 */     // GIR_Coverage, 6136,
     /* 321776 */     GIR_EraseRootFromParent_Done,
     /* 321777 */   // Label 6334: @321777
     /* 321777 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321861), // Rule ID 2546 //
     /* 321782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321812 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321824 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321827 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321831 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321859 */     GIR_RootConstrainSelectedInstOperands,
     /* 321860 */     // GIR_Coverage, 2546,
     /* 321860 */     GIR_EraseRootFromParent_Done,
     /* 321861 */   // Label 6335: @321861
     /* 321861 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(321911), // Rule ID 13428 //
     /* 321866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321896 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 321899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321909 */     GIR_RootConstrainSelectedInstOperands,
     /* 321910 */     // GIR_Coverage, 13428,
     /* 321910 */     GIR_EraseRootFromParent_Done,
     /* 321911 */   // Label 6336: @321911
     /* 321911 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(321995), // Rule ID 6104 //
     /* 321916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321946 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321993 */     GIR_RootConstrainSelectedInstOperands,
     /* 321994 */     // GIR_Coverage, 6104,
     /* 321994 */     GIR_EraseRootFromParent_Done,
     /* 321995 */   // Label 6337: @321995
     /* 321995 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(322045), // Rule ID 1312 //
     /* 322000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322030 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 322033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322043 */     GIR_RootConstrainSelectedInstOperands,
     /* 322044 */     // GIR_Coverage, 1312,
     /* 322044 */     GIR_EraseRootFromParent_Done,
     /* 322045 */   // Label 6338: @322045
     /* 322045 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(322078), // Rule ID 1302 //
     /* 322050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322065 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 322068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 322076 */     GIR_RootConstrainSelectedInstOperands,
     /* 322077 */     // GIR_Coverage, 1302,
     /* 322077 */     GIR_EraseRootFromParent_Done,
     /* 322078 */   // Label 6339: @322078
     /* 322078 */   GIM_Reject,
     /* 322079 */ // Label 6320: @322079
     /* 322079 */ GIM_Reject,
     /* 322080 */ // Label 6193: @322080
     /* 322080 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(323258),
     /* 322085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 322094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322098 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(322182), // Rule ID 6150 //
     /* 322103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322139 */     // MIs[2] Operand 1
     /* 322139 */     // No operand predicates
     /* 322139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322151 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322162 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 322173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322180 */     GIR_RootConstrainSelectedInstOperands,
     /* 322181 */     // GIR_Coverage, 6150,
     /* 322181 */     GIR_EraseRootFromParent_Done,
     /* 322182 */   // Label 6341: @322182
     /* 322182 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(322263), // Rule ID 6182 //
     /* 322187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322235 */     // MIs[3] Operand 1
     /* 322235 */     // No operand predicates
     /* 322235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322245 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322261 */     GIR_RootConstrainSelectedInstOperands,
     /* 322262 */     // GIR_Coverage, 6182,
     /* 322262 */     GIR_EraseRootFromParent_Done,
     /* 322263 */   // Label 6342: @322263
     /* 322263 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(322347), // Rule ID 6214 //
     /* 322268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322317 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322321 */     // MIs[3] Operand 1
     /* 322321 */     // No operand predicates
     /* 322321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322327 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322345 */     GIR_RootConstrainSelectedInstOperands,
     /* 322346 */     // GIR_Coverage, 6214,
     /* 322346 */     GIR_EraseRootFromParent_Done,
     /* 322347 */   // Label 6343: @322347
     /* 322347 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(322428), // Rule ID 6118 //
     /* 322352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322400 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322404 */     // MIs[3] Operand 1
     /* 322404 */     // No operand predicates
     /* 322404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322410 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322426 */     GIR_RootConstrainSelectedInstOperands,
     /* 322427 */     // GIR_Coverage, 6118,
     /* 322427 */     GIR_EraseRootFromParent_Done,
     /* 322428 */   // Label 6344: @322428
     /* 322428 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(322497), // Rule ID 2528 //
     /* 322433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322465 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322469 */     // MIs[2] Operand 1
     /* 322469 */     // No operand predicates
     /* 322469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322479 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322495 */     GIR_RootConstrainSelectedInstOperands,
     /* 322496 */     // GIR_Coverage, 2528,
     /* 322496 */     GIR_EraseRootFromParent_Done,
     /* 322497 */   // Label 6345: @322497
     /* 322497 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(322566), // Rule ID 6086 //
     /* 322502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322542 */     // MIs[2] Operand 1
     /* 322542 */     // No operand predicates
     /* 322542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322548 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322564 */     GIR_RootConstrainSelectedInstOperands,
     /* 322565 */     // GIR_Coverage, 6086,
     /* 322565 */     GIR_EraseRootFromParent_Done,
     /* 322566 */   // Label 6346: @322566
     /* 322566 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322665), // Rule ID 6152 //
     /* 322571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322614 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322626 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322629 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 322657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322663 */     GIR_RootConstrainSelectedInstOperands,
     /* 322664 */     // GIR_Coverage, 6152,
     /* 322664 */     GIR_EraseRootFromParent_Done,
     /* 322665 */   // Label 6347: @322665
     /* 322665 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322761), // Rule ID 6184 //
     /* 322670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322712 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322759 */     GIR_RootConstrainSelectedInstOperands,
     /* 322760 */     // GIR_Coverage, 6184,
     /* 322760 */     GIR_EraseRootFromParent_Done,
     /* 322761 */   // Label 6348: @322761
     /* 322761 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322860), // Rule ID 6216 //
     /* 322766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322809 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322858 */     GIR_RootConstrainSelectedInstOperands,
     /* 322859 */     // GIR_Coverage, 6216,
     /* 322859 */     GIR_EraseRootFromParent_Done,
     /* 322860 */   // Label 6349: @322860
     /* 322860 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(322956), // Rule ID 6120 //
     /* 322865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322907 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322919 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322926 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322954 */     GIR_RootConstrainSelectedInstOperands,
     /* 322955 */     // GIR_Coverage, 6120,
     /* 322955 */     GIR_EraseRootFromParent_Done,
     /* 322956 */   // Label 6350: @322956
     /* 322956 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(323040), // Rule ID 2530 //
     /* 322961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322991 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323038 */     GIR_RootConstrainSelectedInstOperands,
     /* 323039 */     // GIR_Coverage, 2530,
     /* 323039 */     GIR_EraseRootFromParent_Done,
     /* 323040 */   // Label 6351: @323040
     /* 323040 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(323090), // Rule ID 13420 //
     /* 323045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323075 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 323078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323088 */     GIR_RootConstrainSelectedInstOperands,
     /* 323089 */     // GIR_Coverage, 13420,
     /* 323089 */     GIR_EraseRootFromParent_Done,
     /* 323090 */   // Label 6352: @323090
     /* 323090 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(323174), // Rule ID 6088 //
     /* 323095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323125 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323137 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323144 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323172 */     GIR_RootConstrainSelectedInstOperands,
     /* 323173 */     // GIR_Coverage, 6088,
     /* 323173 */     GIR_EraseRootFromParent_Done,
     /* 323174 */   // Label 6353: @323174
     /* 323174 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(323224), // Rule ID 1304 //
     /* 323179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323209 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 323212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323222 */     GIR_RootConstrainSelectedInstOperands,
     /* 323223 */     // GIR_Coverage, 1304,
     /* 323223 */     GIR_EraseRootFromParent_Done,
     /* 323224 */   // Label 6354: @323224
     /* 323224 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(323257), // Rule ID 1294 //
     /* 323229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323244 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 323247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 323255 */     GIR_RootConstrainSelectedInstOperands,
     /* 323256 */     // GIR_Coverage, 1294,
     /* 323256 */     GIR_EraseRootFromParent_Done,
     /* 323257 */   // Label 6355: @323257
     /* 323257 */   GIM_Reject,
     /* 323258 */ // Label 6340: @323258
     /* 323258 */ GIM_Reject,
     /* 323259 */ // Label 6194: @323259
     /* 323259 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(324779),
     /* 323264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323270 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 323273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323277 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(323355), // Rule ID 6248 //
     /* 323282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323323 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323327 */     // MIs[3] Operand 1
     /* 323327 */     // No operand predicates
     /* 323327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323337 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323353 */     GIR_RootConstrainSelectedInstOperands,
     /* 323354 */     // GIR_Coverage, 6248,
     /* 323354 */     GIR_EraseRootFromParent_Done,
     /* 323355 */   // Label 6357: @323355
     /* 323355 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(323439), // Rule ID 6162 //
     /* 323360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323396 */     // MIs[2] Operand 1
     /* 323396 */     // No operand predicates
     /* 323396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323404 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323419 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 323430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323437 */     GIR_RootConstrainSelectedInstOperands,
     /* 323438 */     // GIR_Coverage, 6162,
     /* 323438 */     GIR_EraseRootFromParent_Done,
     /* 323439 */   // Label 6358: @323439
     /* 323439 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(323520), // Rule ID 6194 //
     /* 323444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323488 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323492 */     // MIs[3] Operand 1
     /* 323492 */     // No operand predicates
     /* 323492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323502 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323518 */     GIR_RootConstrainSelectedInstOperands,
     /* 323519 */     // GIR_Coverage, 6194,
     /* 323519 */     GIR_EraseRootFromParent_Done,
     /* 323520 */   // Label 6359: @323520
     /* 323520 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(323604), // Rule ID 6226 //
     /* 323525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323574 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323578 */     // MIs[3] Operand 1
     /* 323578 */     // No operand predicates
     /* 323578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323584 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323602 */     GIR_RootConstrainSelectedInstOperands,
     /* 323603 */     // GIR_Coverage, 6226,
     /* 323603 */     GIR_EraseRootFromParent_Done,
     /* 323604 */   // Label 6360: @323604
     /* 323604 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323682), // Rule ID 6270 //
     /* 323609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323654 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323658 */     // MIs[3] Operand 1
     /* 323658 */     // No operand predicates
     /* 323658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323664 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323680 */     GIR_RootConstrainSelectedInstOperands,
     /* 323681 */     // GIR_Coverage, 6270,
     /* 323681 */     GIR_EraseRootFromParent_Done,
     /* 323682 */   // Label 6361: @323682
     /* 323682 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323763), // Rule ID 6130 //
     /* 323687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323739 */     // MIs[3] Operand 1
     /* 323739 */     // No operand predicates
     /* 323739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323745 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323761 */     GIR_RootConstrainSelectedInstOperands,
     /* 323762 */     // GIR_Coverage, 6130,
     /* 323762 */     GIR_EraseRootFromParent_Done,
     /* 323763 */   // Label 6362: @323763
     /* 323763 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(323832), // Rule ID 2540 //
     /* 323768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323800 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323804 */     // MIs[2] Operand 1
     /* 323804 */     // No operand predicates
     /* 323804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323814 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323830 */     GIR_RootConstrainSelectedInstOperands,
     /* 323831 */     // GIR_Coverage, 2540,
     /* 323831 */     GIR_EraseRootFromParent_Done,
     /* 323832 */   // Label 6363: @323832
     /* 323832 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(323901), // Rule ID 6098 //
     /* 323837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323877 */     // MIs[2] Operand 1
     /* 323877 */     // No operand predicates
     /* 323877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323883 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323899 */     GIR_RootConstrainSelectedInstOperands,
     /* 323900 */     // GIR_Coverage, 6098,
     /* 323900 */     GIR_EraseRootFromParent_Done,
     /* 323901 */   // Label 6364: @323901
     /* 323901 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(323994), // Rule ID 6252 //
     /* 323906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323945 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323992 */     GIR_RootConstrainSelectedInstOperands,
     /* 323993 */     // GIR_Coverage, 6252,
     /* 323993 */     GIR_EraseRootFromParent_Done,
     /* 323994 */   // Label 6365: @323994
     /* 323994 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(324093), // Rule ID 6164 //
     /* 323999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324042 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324061 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 324085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324091 */     GIR_RootConstrainSelectedInstOperands,
     /* 324092 */     // GIR_Coverage, 6164,
     /* 324092 */     GIR_EraseRootFromParent_Done,
     /* 324093 */   // Label 6366: @324093
     /* 324093 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(324189), // Rule ID 6196 //
     /* 324098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324140 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324187 */     GIR_RootConstrainSelectedInstOperands,
     /* 324188 */     // GIR_Coverage, 6196,
     /* 324188 */     GIR_EraseRootFromParent_Done,
     /* 324189 */   // Label 6367: @324189
     /* 324189 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(324288), // Rule ID 6228 //
     /* 324194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324237 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324286 */     GIR_RootConstrainSelectedInstOperands,
     /* 324287 */     // GIR_Coverage, 6228,
     /* 324287 */     GIR_EraseRootFromParent_Done,
     /* 324288 */   // Label 6368: @324288
     /* 324288 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(324381), // Rule ID 6274 //
     /* 324293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324332 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324379 */     GIR_RootConstrainSelectedInstOperands,
     /* 324380 */     // GIR_Coverage, 6274,
     /* 324380 */     GIR_EraseRootFromParent_Done,
     /* 324381 */   // Label 6369: @324381
     /* 324381 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(324477), // Rule ID 6132 //
     /* 324386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324428 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324447 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324475 */     GIR_RootConstrainSelectedInstOperands,
     /* 324476 */     // GIR_Coverage, 6132,
     /* 324476 */     GIR_EraseRootFromParent_Done,
     /* 324477 */   // Label 6370: @324477
     /* 324477 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(324561), // Rule ID 2542 //
     /* 324482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324512 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324524 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324531 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324559 */     GIR_RootConstrainSelectedInstOperands,
     /* 324560 */     // GIR_Coverage, 2542,
     /* 324560 */     GIR_EraseRootFromParent_Done,
     /* 324561 */   // Label 6371: @324561
     /* 324561 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(324611), // Rule ID 13426 //
     /* 324566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324596 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 324599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324609 */     GIR_RootConstrainSelectedInstOperands,
     /* 324610 */     // GIR_Coverage, 13426,
     /* 324610 */     GIR_EraseRootFromParent_Done,
     /* 324611 */   // Label 6372: @324611
     /* 324611 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(324695), // Rule ID 6100 //
     /* 324616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324646 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324693 */     GIR_RootConstrainSelectedInstOperands,
     /* 324694 */     // GIR_Coverage, 6100,
     /* 324694 */     GIR_EraseRootFromParent_Done,
     /* 324695 */   // Label 6373: @324695
     /* 324695 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(324745), // Rule ID 1310 //
     /* 324700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324730 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 324733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324743 */     GIR_RootConstrainSelectedInstOperands,
     /* 324744 */     // GIR_Coverage, 1310,
     /* 324744 */     GIR_EraseRootFromParent_Done,
     /* 324745 */   // Label 6374: @324745
     /* 324745 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(324778), // Rule ID 1300 //
     /* 324750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324765 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 324768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 324776 */     GIR_RootConstrainSelectedInstOperands,
     /* 324777 */     // GIR_Coverage, 1300,
     /* 324777 */     GIR_EraseRootFromParent_Done,
     /* 324778 */   // Label 6375: @324778
     /* 324778 */   GIM_Reject,
     /* 324779 */ // Label 6356: @324779
     /* 324779 */ GIM_Reject,
     /* 324780 */ // Label 6195: @324780
     /* 324780 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(325958),
     /* 324785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324791 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 324794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324798 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(324882), // Rule ID 6146 //
     /* 324803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324839 */     // MIs[2] Operand 1
     /* 324839 */     // No operand predicates
     /* 324839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324847 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324851 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324862 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 324873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324880 */     GIR_RootConstrainSelectedInstOperands,
     /* 324881 */     // GIR_Coverage, 6146,
     /* 324881 */     GIR_EraseRootFromParent_Done,
     /* 324882 */   // Label 6377: @324882
     /* 324882 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(324963), // Rule ID 6178 //
     /* 324887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324931 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324935 */     // MIs[3] Operand 1
     /* 324935 */     // No operand predicates
     /* 324935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324945 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324961 */     GIR_RootConstrainSelectedInstOperands,
     /* 324962 */     // GIR_Coverage, 6178,
     /* 324962 */     GIR_EraseRootFromParent_Done,
     /* 324963 */   // Label 6378: @324963
     /* 324963 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(325047), // Rule ID 6210 //
     /* 324968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 325013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325017 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325021 */     // MIs[3] Operand 1
     /* 325021 */     // No operand predicates
     /* 325021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325027 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325045 */     GIR_RootConstrainSelectedInstOperands,
     /* 325046 */     // GIR_Coverage, 6210,
     /* 325046 */     GIR_EraseRootFromParent_Done,
     /* 325047 */   // Label 6379: @325047
     /* 325047 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(325128), // Rule ID 6114 //
     /* 325052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 325096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325100 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325104 */     // MIs[3] Operand 1
     /* 325104 */     // No operand predicates
     /* 325104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325110 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325126 */     GIR_RootConstrainSelectedInstOperands,
     /* 325127 */     // GIR_Coverage, 6114,
     /* 325127 */     GIR_EraseRootFromParent_Done,
     /* 325128 */   // Label 6380: @325128
     /* 325128 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(325197), // Rule ID 2524 //
     /* 325133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325165 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325169 */     // MIs[2] Operand 1
     /* 325169 */     // No operand predicates
     /* 325169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325179 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325195 */     GIR_RootConstrainSelectedInstOperands,
     /* 325196 */     // GIR_Coverage, 2524,
     /* 325196 */     GIR_EraseRootFromParent_Done,
     /* 325197 */   // Label 6381: @325197
     /* 325197 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(325266), // Rule ID 6082 //
     /* 325202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325242 */     // MIs[2] Operand 1
     /* 325242 */     // No operand predicates
     /* 325242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325248 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325264 */     GIR_RootConstrainSelectedInstOperands,
     /* 325265 */     // GIR_Coverage, 6082,
     /* 325265 */     GIR_EraseRootFromParent_Done,
     /* 325266 */   // Label 6382: @325266
     /* 325266 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(325365), // Rule ID 6148 //
     /* 325271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325314 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325326 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325363 */     GIR_RootConstrainSelectedInstOperands,
     /* 325364 */     // GIR_Coverage, 6148,
     /* 325364 */     GIR_EraseRootFromParent_Done,
     /* 325365 */   // Label 6383: @325365
     /* 325365 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(325461), // Rule ID 6180 //
     /* 325370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325412 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325424 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325459 */     GIR_RootConstrainSelectedInstOperands,
     /* 325460 */     // GIR_Coverage, 6180,
     /* 325460 */     GIR_EraseRootFromParent_Done,
     /* 325461 */   // Label 6384: @325461
     /* 325461 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(325560), // Rule ID 6212 //
     /* 325466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325509 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325521 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325558 */     GIR_RootConstrainSelectedInstOperands,
     /* 325559 */     // GIR_Coverage, 6212,
     /* 325559 */     GIR_EraseRootFromParent_Done,
     /* 325560 */   // Label 6385: @325560
     /* 325560 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(325656), // Rule ID 6116 //
     /* 325565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325607 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325626 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325654 */     GIR_RootConstrainSelectedInstOperands,
     /* 325655 */     // GIR_Coverage, 6116,
     /* 325655 */     GIR_EraseRootFromParent_Done,
     /* 325656 */   // Label 6386: @325656
     /* 325656 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(325740), // Rule ID 2526 //
     /* 325661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325691 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325703 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325738 */     GIR_RootConstrainSelectedInstOperands,
     /* 325739 */     // GIR_Coverage, 2526,
     /* 325739 */     GIR_EraseRootFromParent_Done,
     /* 325740 */   // Label 6387: @325740
     /* 325740 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(325790), // Rule ID 13422 //
     /* 325745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325775 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 325778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325788 */     GIR_RootConstrainSelectedInstOperands,
     /* 325789 */     // GIR_Coverage, 13422,
     /* 325789 */     GIR_EraseRootFromParent_Done,
     /* 325790 */   // Label 6388: @325790
     /* 325790 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(325874), // Rule ID 6084 //
     /* 325795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325825 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325837 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325872 */     GIR_RootConstrainSelectedInstOperands,
     /* 325873 */     // GIR_Coverage, 6084,
     /* 325873 */     GIR_EraseRootFromParent_Done,
     /* 325874 */   // Label 6389: @325874
     /* 325874 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(325924), // Rule ID 1306 //
     /* 325879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325909 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 325912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325922 */     GIR_RootConstrainSelectedInstOperands,
     /* 325923 */     // GIR_Coverage, 1306,
     /* 325923 */     GIR_EraseRootFromParent_Done,
     /* 325924 */   // Label 6390: @325924
     /* 325924 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(325957), // Rule ID 1296 //
     /* 325929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325944 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 325947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 325955 */     GIR_RootConstrainSelectedInstOperands,
     /* 325956 */     // GIR_Coverage, 1296,
     /* 325956 */     GIR_EraseRootFromParent_Done,
     /* 325957 */   // Label 6391: @325957
     /* 325957 */   GIM_Reject,
     /* 325958 */ // Label 6376: @325958
     /* 325958 */ GIM_Reject,
     /* 325959 */ // Label 6196: @325959
     /* 325959 */ GIM_Reject,
     /* 325960 */ // Label 63: @325960
     /* 325960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6400*/ GIMT_Encode4(326575),
     /* 325971 */ /*GILLT_s16*//*Label 6392*/ GIMT_Encode4(326011),
     /* 325975 */ /*GILLT_s32*//*Label 6393*/ GIMT_Encode4(326049),
     /* 325979 */ /*GILLT_s64*//*Label 6394*/ GIMT_Encode4(326087), GIMT_Encode4(0),
     /* 325987 */ /*GILLT_v2s32*//*Label 6395*/ GIMT_Encode4(326125),
     /* 325991 */ /*GILLT_v2s64*//*Label 6396*/ GIMT_Encode4(326163),
     /* 325995 */ /*GILLT_v4s16*//*Label 6397*/ GIMT_Encode4(326201),
     /* 325999 */ /*GILLT_v4s32*//*Label 6398*/ GIMT_Encode4(326239), GIMT_Encode4(0),
     /* 326007 */ /*GILLT_v8s16*//*Label 6399*/ GIMT_Encode4(326277),
     /* 326011 */ // Label 6392: @326011
     /* 326011 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(326048), // Rule ID 590 //
     /* 326016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326037 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 326042 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326046 */   GIR_RootConstrainSelectedInstOperands,
     /* 326047 */   // GIR_Coverage, 590,
     /* 326047 */   GIR_Done,
     /* 326048 */ // Label 6401: @326048
     /* 326048 */ GIM_Reject,
     /* 326049 */ // Label 6393: @326049
     /* 326049 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(326086), // Rule ID 592 //
     /* 326054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326075 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 326075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 326080 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326084 */   GIR_RootConstrainSelectedInstOperands,
     /* 326085 */   // GIR_Coverage, 592,
     /* 326085 */   GIR_Done,
     /* 326086 */ // Label 6402: @326086
     /* 326086 */ GIM_Reject,
     /* 326087 */ // Label 6394: @326087
     /* 326087 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(326124), // Rule ID 594 //
     /* 326092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326113 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 326113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 326118 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326122 */   GIR_RootConstrainSelectedInstOperands,
     /* 326123 */   // GIR_Coverage, 594,
     /* 326123 */   GIR_Done,
     /* 326124 */ // Label 6403: @326124
     /* 326124 */ GIM_Reject,
     /* 326125 */ // Label 6395: @326125
     /* 326125 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(326162), // Rule ID 1228 //
     /* 326130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326151 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 326156 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326160 */   GIR_RootConstrainSelectedInstOperands,
     /* 326161 */   // GIR_Coverage, 1228,
     /* 326161 */   GIR_Done,
     /* 326162 */ // Label 6404: @326162
     /* 326162 */ GIM_Reject,
     /* 326163 */ // Label 6396: @326163
     /* 326163 */ GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(326200), // Rule ID 1232 //
     /* 326168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326189 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 326194 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326198 */   GIR_RootConstrainSelectedInstOperands,
     /* 326199 */   // GIR_Coverage, 1232,
     /* 326199 */   GIR_Done,
     /* 326200 */ // Label 6405: @326200
     /* 326200 */ GIM_Reject,
     /* 326201 */ // Label 6397: @326201
     /* 326201 */ GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(326238), // Rule ID 1224 //
     /* 326206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326227 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 326232 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326236 */   GIR_RootConstrainSelectedInstOperands,
     /* 326237 */   // GIR_Coverage, 1224,
     /* 326237 */   GIR_Done,
     /* 326238 */ // Label 6406: @326238
     /* 326238 */ GIM_Reject,
     /* 326239 */ // Label 6398: @326239
     /* 326239 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(326276), // Rule ID 1230 //
     /* 326244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326265 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326274 */   GIR_RootConstrainSelectedInstOperands,
     /* 326275 */   // GIR_Coverage, 1230,
     /* 326275 */   GIR_Done,
     /* 326276 */ // Label 6407: @326276
     /* 326276 */ GIM_Reject,
     /* 326277 */ // Label 6399: @326277
     /* 326277 */ GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(326574),
     /* 326282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326300 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(326319), // Rule ID 1226 //
     /* 326305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326308 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 326313 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326317 */     GIR_RootConstrainSelectedInstOperands,
     /* 326318 */     // GIR_Coverage, 1226,
     /* 326318 */     GIR_Done,
     /* 326319 */   // Label 6409: @326319
     /* 326319 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(326573), // Rule ID 7057 //
     /* 326324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 326327 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 326327 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 326330 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 326334 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326339 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 326345 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 326348 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 326352 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326357 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 326363 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 326366 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326370 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326375 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 326378 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 326381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 326383 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 326386 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326390 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326395 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 326401 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326406 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326411 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 326414 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 326418 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326423 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 326426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 326428 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 326431 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326435 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326440 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 326446 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326451 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326456 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 326459 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 326463 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326468 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 326471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326473 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 326476 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326480 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326485 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326488 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 326491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 326493 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 326496 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 326500 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326505 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 326508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326536 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326539 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 326542 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 326545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 326563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 326571 */     GIR_RootConstrainSelectedInstOperands,
     /* 326572 */     // GIR_Coverage, 7057,
     /* 326572 */     GIR_EraseRootFromParent_Done,
     /* 326573 */   // Label 6410: @326573
     /* 326573 */   GIM_Reject,
     /* 326574 */ // Label 6408: @326574
     /* 326574 */ GIM_Reject,
     /* 326575 */ // Label 6400: @326575
     /* 326575 */ GIM_Reject,
     /* 326576 */ // Label 64: @326576
     /* 326576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6419*/ GIMT_Encode4(330082),
     /* 326587 */ /*GILLT_s16*//*Label 6411*/ GIMT_Encode4(326627),
     /* 326591 */ /*GILLT_s32*//*Label 6412*/ GIMT_Encode4(327795),
     /* 326595 */ /*GILLT_s64*//*Label 6413*/ GIMT_Encode4(328818), GIMT_Encode4(0),
     /* 326603 */ /*GILLT_v2s32*//*Label 6414*/ GIMT_Encode4(329841),
     /* 326607 */ /*GILLT_v2s64*//*Label 6415*/ GIMT_Encode4(329868),
     /* 326611 */ /*GILLT_v4s16*//*Label 6416*/ GIMT_Encode4(329895),
     /* 326615 */ /*GILLT_v4s32*//*Label 6417*/ GIMT_Encode4(329975), GIMT_Encode4(0),
     /* 326623 */ /*GILLT_v8s16*//*Label 6418*/ GIMT_Encode4(330002),
     /* 326627 */ // Label 6411: @326627
     /* 326627 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(327794),
     /* 326632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326639 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(326797), // Rule ID 4887 //
     /* 326644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326663 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326688 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326704 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326708 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326713 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326724 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 326727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326736 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326742 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326764 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326795 */     GIR_RootConstrainSelectedInstOperands,
     /* 326796 */     // GIR_Coverage, 4887,
     /* 326796 */     GIR_EraseRootFromParent_Done,
     /* 326797 */   // Label 6421: @326797
     /* 326797 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(326955), // Rule ID 4886 //
     /* 326802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326821 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326846 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326862 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326866 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326871 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326882 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 326885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326894 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326922 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326953 */     GIR_RootConstrainSelectedInstOperands,
     /* 326954 */     // GIR_Coverage, 4886,
     /* 326954 */     GIR_EraseRootFromParent_Done,
     /* 326955 */   // Label 6422: @326955
     /* 326955 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(327066), // Rule ID 4885 //
     /* 326960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326979 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327004 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327020 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327064 */     GIR_RootConstrainSelectedInstOperands,
     /* 327065 */     // GIR_Coverage, 4885,
     /* 327065 */     GIR_EraseRootFromParent_Done,
     /* 327066 */   // Label 6423: @327066
     /* 327066 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(327177), // Rule ID 4883 //
     /* 327071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327090 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327120 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327131 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327143 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327175 */     GIR_RootConstrainSelectedInstOperands,
     /* 327176 */     // GIR_Coverage, 4883,
     /* 327176 */     GIR_EraseRootFromParent_Done,
     /* 327177 */   // Label 6424: @327177
     /* 327177 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(327288), // Rule ID 4884 //
     /* 327182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327201 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327226 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327242 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327254 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327286 */     GIR_RootConstrainSelectedInstOperands,
     /* 327287 */     // GIR_Coverage, 4884,
     /* 327287 */     GIR_EraseRootFromParent_Done,
     /* 327288 */   // Label 6425: @327288
     /* 327288 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(327399), // Rule ID 4882 //
     /* 327293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327312 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327342 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327353 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327365 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327397 */     GIR_RootConstrainSelectedInstOperands,
     /* 327398 */     // GIR_Coverage, 4882,
     /* 327398 */     GIR_EraseRootFromParent_Done,
     /* 327399 */   // Label 6426: @327399
     /* 327399 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(327463), // Rule ID 650 //
     /* 327404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327423 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327444 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327461 */     GIR_RootConstrainSelectedInstOperands,
     /* 327462 */     // GIR_Coverage, 650,
     /* 327462 */     GIR_EraseRootFromParent_Done,
     /* 327463 */   // Label 6427: @327463
     /* 327463 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(327527), // Rule ID 649 //
     /* 327468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327508 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327525 */     GIR_RootConstrainSelectedInstOperands,
     /* 327526 */     // GIR_Coverage, 649,
     /* 327526 */     GIR_EraseRootFromParent_Done,
     /* 327527 */   // Label 6428: @327527
     /* 327527 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(327578), // Rule ID 626 //
     /* 327532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 327543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327563 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 327566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327576 */     GIR_RootConstrainSelectedInstOperands,
     /* 327577 */     // GIR_Coverage, 626,
     /* 327577 */     GIR_EraseRootFromParent_Done,
     /* 327578 */   // Label 6429: @327578
     /* 327578 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(327629), // Rule ID 625 //
     /* 327583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 327594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327614 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 327617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327627 */     GIR_RootConstrainSelectedInstOperands,
     /* 327628 */     // GIR_Coverage, 625,
     /* 327628 */     GIR_EraseRootFromParent_Done,
     /* 327629 */   // Label 6430: @327629
     /* 327629 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(327648), // Rule ID 524 //
     /* 327634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327641 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 327641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 327646 */     GIR_RootConstrainSelectedInstOperands,
     /* 327647 */     // GIR_Coverage, 524,
     /* 327647 */     GIR_Done,
     /* 327648 */   // Label 6431: @327648
     /* 327648 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(327793), // Rule ID 6414 //
     /* 327653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327657 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 327657 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 327660 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 327664 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 327671 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 327674 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 327678 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327683 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 327686 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 327690 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 327693 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327698 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327703 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 327711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327720 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 327723 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327728 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327731 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 327735 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327740 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327743 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 327748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327775 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 327782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327792 */     // GIR_Coverage, 6414,
     /* 327792 */     GIR_EraseRootFromParent_Done,
     /* 327793 */   // Label 6432: @327793
     /* 327793 */   GIM_Reject,
     /* 327794 */ // Label 6420: @327794
     /* 327794 */ GIM_Reject,
     /* 327795 */ // Label 6412: @327795
     /* 327795 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(328817),
     /* 327800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327807 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(327965), // Rule ID 4893 //
     /* 327812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327831 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327856 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327868 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327872 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327881 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327892 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327892 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327895 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327899 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327904 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327915 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327932 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327963 */     GIR_RootConstrainSelectedInstOperands,
     /* 327964 */     // GIR_Coverage, 4893,
     /* 327964 */     GIR_EraseRootFromParent_Done,
     /* 327965 */   // Label 6434: @327965
     /* 327965 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(328123), // Rule ID 4892 //
     /* 327970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327989 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328030 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328034 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328039 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328050 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 328053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328062 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328068 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328090 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328121 */     GIR_RootConstrainSelectedInstOperands,
     /* 328122 */     // GIR_Coverage, 4892,
     /* 328122 */     GIR_EraseRootFromParent_Done,
     /* 328123 */   // Label 6435: @328123
     /* 328123 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(328234), // Rule ID 4891 //
     /* 328128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328188 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328200 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328232 */     GIR_RootConstrainSelectedInstOperands,
     /* 328233 */     // GIR_Coverage, 4891,
     /* 328233 */     GIR_EraseRootFromParent_Done,
     /* 328234 */   // Label 6436: @328234
     /* 328234 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(328345), // Rule ID 4889 //
     /* 328239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328258 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328299 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328311 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328343 */     GIR_RootConstrainSelectedInstOperands,
     /* 328344 */     // GIR_Coverage, 4889,
     /* 328344 */     GIR_EraseRootFromParent_Done,
     /* 328345 */   // Label 6437: @328345
     /* 328345 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(328456), // Rule ID 4890 //
     /* 328350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328394 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328410 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328422 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328454 */     GIR_RootConstrainSelectedInstOperands,
     /* 328455 */     // GIR_Coverage, 4890,
     /* 328455 */     GIR_EraseRootFromParent_Done,
     /* 328456 */   // Label 6438: @328456
     /* 328456 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(328567), // Rule ID 4888 //
     /* 328461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328510 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328521 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328533 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328565 */     GIR_RootConstrainSelectedInstOperands,
     /* 328566 */     // GIR_Coverage, 4888,
     /* 328566 */     GIR_EraseRootFromParent_Done,
     /* 328567 */   // Label 6439: @328567
     /* 328567 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(328631), // Rule ID 652 //
     /* 328572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328591 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328612 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328629 */     GIR_RootConstrainSelectedInstOperands,
     /* 328630 */     // GIR_Coverage, 652,
     /* 328630 */     GIR_EraseRootFromParent_Done,
     /* 328631 */   // Label 6440: @328631
     /* 328631 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(328695), // Rule ID 651 //
     /* 328636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328676 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328693 */     GIR_RootConstrainSelectedInstOperands,
     /* 328694 */     // GIR_Coverage, 651,
     /* 328694 */     GIR_EraseRootFromParent_Done,
     /* 328695 */   // Label 6441: @328695
     /* 328695 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(328746), // Rule ID 628 //
     /* 328700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328731 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 328731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 328734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328744 */     GIR_RootConstrainSelectedInstOperands,
     /* 328745 */     // GIR_Coverage, 628,
     /* 328745 */     GIR_EraseRootFromParent_Done,
     /* 328746 */   // Label 6442: @328746
     /* 328746 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(328797), // Rule ID 627 //
     /* 328751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328782 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 328782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 328785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328795 */     GIR_RootConstrainSelectedInstOperands,
     /* 328796 */     // GIR_Coverage, 627,
     /* 328796 */     GIR_EraseRootFromParent_Done,
     /* 328797 */   // Label 6443: @328797
     /* 328797 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(328816), // Rule ID 525 //
     /* 328802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328809 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 328809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 328814 */     GIR_RootConstrainSelectedInstOperands,
     /* 328815 */     // GIR_Coverage, 525,
     /* 328815 */     GIR_Done,
     /* 328816 */   // Label 6444: @328816
     /* 328816 */   GIM_Reject,
     /* 328817 */ // Label 6433: @328817
     /* 328817 */ GIM_Reject,
     /* 328818 */ // Label 6413: @328818
     /* 328818 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(329840),
     /* 328823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328830 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(328988), // Rule ID 4899 //
     /* 328835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328854 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328879 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328891 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328895 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328899 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328904 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328915 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328915 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 328918 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328922 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328927 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328986 */     GIR_RootConstrainSelectedInstOperands,
     /* 328987 */     // GIR_Coverage, 4899,
     /* 328987 */     GIR_EraseRootFromParent_Done,
     /* 328988 */   // Label 6446: @328988
     /* 328988 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(329146), // Rule ID 4898 //
     /* 328993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329012 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329037 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329049 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329053 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 329057 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329062 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 329066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329073 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329073 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 329076 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329080 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329085 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329113 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 329140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329144 */     GIR_RootConstrainSelectedInstOperands,
     /* 329145 */     // GIR_Coverage, 4898,
     /* 329145 */     GIR_EraseRootFromParent_Done,
     /* 329146 */   // Label 6447: @329146
     /* 329146 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(329257), // Rule ID 4897 //
     /* 329151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329170 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329195 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329211 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329223 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329255 */     GIR_RootConstrainSelectedInstOperands,
     /* 329256 */     // GIR_Coverage, 4897,
     /* 329256 */     GIR_EraseRootFromParent_Done,
     /* 329257 */   // Label 6448: @329257
     /* 329257 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(329368), // Rule ID 4895 //
     /* 329262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329281 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329311 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329322 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329366 */     GIR_RootConstrainSelectedInstOperands,
     /* 329367 */     // GIR_Coverage, 4895,
     /* 329367 */     GIR_EraseRootFromParent_Done,
     /* 329368 */   // Label 6449: @329368
     /* 329368 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(329479), // Rule ID 4896 //
     /* 329373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329417 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329433 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329477 */     GIR_RootConstrainSelectedInstOperands,
     /* 329478 */     // GIR_Coverage, 4896,
     /* 329478 */     GIR_EraseRootFromParent_Done,
     /* 329479 */   // Label 6450: @329479
     /* 329479 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(329590), // Rule ID 4894 //
     /* 329484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329503 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329533 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329544 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329588 */     GIR_RootConstrainSelectedInstOperands,
     /* 329589 */     // GIR_Coverage, 4894,
     /* 329589 */     GIR_EraseRootFromParent_Done,
     /* 329590 */   // Label 6451: @329590
     /* 329590 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(329654), // Rule ID 654 //
     /* 329595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329614 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329635 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329652 */     GIR_RootConstrainSelectedInstOperands,
     /* 329653 */     // GIR_Coverage, 654,
     /* 329653 */     GIR_EraseRootFromParent_Done,
     /* 329654 */   // Label 6452: @329654
     /* 329654 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(329718), // Rule ID 653 //
     /* 329659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329678 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329699 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329716 */     GIR_RootConstrainSelectedInstOperands,
     /* 329717 */     // GIR_Coverage, 653,
     /* 329717 */     GIR_EraseRootFromParent_Done,
     /* 329718 */   // Label 6453: @329718
     /* 329718 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(329769), // Rule ID 630 //
     /* 329723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 329734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329754 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 329754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 329757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329767 */     GIR_RootConstrainSelectedInstOperands,
     /* 329768 */     // GIR_Coverage, 630,
     /* 329768 */     GIR_EraseRootFromParent_Done,
     /* 329769 */   // Label 6454: @329769
     /* 329769 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(329820), // Rule ID 629 //
     /* 329774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 329785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329805 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 329805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 329808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329818 */     GIR_RootConstrainSelectedInstOperands,
     /* 329819 */     // GIR_Coverage, 629,
     /* 329819 */     GIR_EraseRootFromParent_Done,
     /* 329820 */   // Label 6455: @329820
     /* 329820 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(329839), // Rule ID 526 //
     /* 329825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329832 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 329832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 329837 */     GIR_RootConstrainSelectedInstOperands,
     /* 329838 */     // GIR_Coverage, 526,
     /* 329838 */     GIR_Done,
     /* 329839 */   // Label 6456: @329839
     /* 329839 */   GIM_Reject,
     /* 329840 */ // Label 6445: @329840
     /* 329840 */ GIM_Reject,
     /* 329841 */ // Label 6414: @329841
     /* 329841 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(329867), // Rule ID 860 //
     /* 329846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329860 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 329860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 329865 */   GIR_RootConstrainSelectedInstOperands,
     /* 329866 */   // GIR_Coverage, 860,
     /* 329866 */   GIR_Done,
     /* 329867 */ // Label 6457: @329867
     /* 329867 */ GIM_Reject,
     /* 329868 */ // Label 6415: @329868
     /* 329868 */ GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(329894), // Rule ID 862 //
     /* 329873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329887 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 329887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 329892 */   GIR_RootConstrainSelectedInstOperands,
     /* 329893 */   // GIR_Coverage, 862,
     /* 329893 */   GIR_Done,
     /* 329894 */ // Label 6458: @329894
     /* 329894 */ GIM_Reject,
     /* 329895 */ // Label 6416: @329895
     /* 329895 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(329974),
     /* 329900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329911 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(329926), // Rule ID 858 //
     /* 329916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329919 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 329919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 329924 */     GIR_RootConstrainSelectedInstOperands,
     /* 329925 */     // GIR_Coverage, 858,
     /* 329925 */     GIR_Done,
     /* 329926 */   // Label 6460: @329926
     /* 329926 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(329973), // Rule ID 6417 //
     /* 329931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329934 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 329934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 329941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329946 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 329956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 329964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329971 */     GIR_RootConstrainSelectedInstOperands,
     /* 329972 */     // GIR_Coverage, 6417,
     /* 329972 */     GIR_EraseRootFromParent_Done,
     /* 329973 */   // Label 6461: @329973
     /* 329973 */   GIM_Reject,
     /* 329974 */ // Label 6459: @329974
     /* 329974 */ GIM_Reject,
     /* 329975 */ // Label 6417: @329975
     /* 329975 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(330001), // Rule ID 861 //
     /* 329980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329994 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 329994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 329999 */   GIR_RootConstrainSelectedInstOperands,
     /* 330000 */   // GIR_Coverage, 861,
     /* 330000 */   GIR_Done,
     /* 330001 */ // Label 6462: @330001
     /* 330001 */ GIM_Reject,
     /* 330002 */ // Label 6418: @330002
     /* 330002 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(330081),
     /* 330007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330018 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(330033), // Rule ID 859 //
     /* 330023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330026 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 330026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 330031 */     GIR_RootConstrainSelectedInstOperands,
     /* 330032 */     // GIR_Coverage, 859,
     /* 330032 */     GIR_Done,
     /* 330033 */   // Label 6464: @330033
     /* 330033 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(330080), // Rule ID 6418 //
     /* 330038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330041 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 330041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 330048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330053 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 330063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 330071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 330075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330078 */     GIR_RootConstrainSelectedInstOperands,
     /* 330079 */     // GIR_Coverage, 6418,
     /* 330079 */     GIR_EraseRootFromParent_Done,
     /* 330080 */   // Label 6465: @330080
     /* 330080 */   GIM_Reject,
     /* 330081 */ // Label 6463: @330081
     /* 330081 */ GIM_Reject,
     /* 330082 */ // Label 6419: @330082
     /* 330082 */ GIM_Reject,
     /* 330083 */ // Label 65: @330083
     /* 330083 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6470*/ GIMT_Encode4(330330),
     /* 330094 */ /*GILLT_s32*//*Label 6466*/ GIMT_Encode4(330122),
     /* 330098 */ /*GILLT_s64*//*Label 6467*/ GIMT_Encode4(330153), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 330110 */ /*GILLT_v2s64*//*Label 6468*/ GIMT_Encode4(330214), GIMT_Encode4(0),
     /* 330118 */ /*GILLT_v4s32*//*Label 6469*/ GIMT_Encode4(330272),
     /* 330122 */ // Label 6466: @330122
     /* 330122 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(330152), // Rule ID 516 //
     /* 330127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330141 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 330141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 330146 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330150 */   GIR_RootConstrainSelectedInstOperands,
     /* 330151 */   // GIR_Coverage, 516,
     /* 330151 */   GIR_Done,
     /* 330152 */ // Label 6471: @330152
     /* 330152 */ GIM_Reject,
     /* 330153 */ // Label 6467: @330153
     /* 330153 */ GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(330183), // Rule ID 514 //
     /* 330158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330172 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 330172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 330177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330181 */   GIR_RootConstrainSelectedInstOperands,
     /* 330182 */   // GIR_Coverage, 514,
     /* 330182 */   GIR_Done,
     /* 330183 */ // Label 6472: @330183
     /* 330183 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(330213), // Rule ID 518 //
     /* 330188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330202 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 330202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 330207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330211 */   GIR_RootConstrainSelectedInstOperands,
     /* 330212 */   // GIR_Coverage, 518,
     /* 330212 */   GIR_Done,
     /* 330213 */ // Label 6473: @330213
     /* 330213 */ GIM_Reject,
     /* 330214 */ // Label 6468: @330214
     /* 330214 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(330271),
     /* 330219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330226 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(330250), // Rule ID 4942 //
     /* 330231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 330238 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 330238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 330241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330248 */     GIR_RootConstrainSelectedInstOperands,
     /* 330249 */     // GIR_Coverage, 4942,
     /* 330249 */     GIR_EraseRootFromParent_Done,
     /* 330250 */   // Label 6475: @330250
     /* 330250 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(330270), // Rule ID 4940 //
     /* 330255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330259 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 330259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 330264 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330268 */     GIR_RootConstrainSelectedInstOperands,
     /* 330269 */     // GIR_Coverage, 4940,
     /* 330269 */     GIR_Done,
     /* 330270 */   // Label 6476: @330270
     /* 330270 */   GIM_Reject,
     /* 330271 */ // Label 6474: @330271
     /* 330271 */ GIM_Reject,
     /* 330272 */ // Label 6469: @330272
     /* 330272 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(330329),
     /* 330277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330284 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(330308), // Rule ID 4946 //
     /* 330289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 330296 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 330296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 330299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330306 */     GIR_RootConstrainSelectedInstOperands,
     /* 330307 */     // GIR_Coverage, 4946,
     /* 330307 */     GIR_EraseRootFromParent_Done,
     /* 330308 */   // Label 6478: @330308
     /* 330308 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(330328), // Rule ID 4944 //
     /* 330313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330317 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 330317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 330322 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330326 */     GIR_RootConstrainSelectedInstOperands,
     /* 330327 */     // GIR_Coverage, 4944,
     /* 330327 */     GIR_Done,
     /* 330328 */   // Label 6479: @330328
     /* 330328 */   GIM_Reject,
     /* 330329 */ // Label 6477: @330329
     /* 330329 */ GIM_Reject,
     /* 330330 */ // Label 6470: @330330
     /* 330330 */ GIM_Reject,
     /* 330331 */ // Label 66: @330331
     /* 330331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6484*/ GIMT_Encode4(330518),
     /* 330342 */ /*GILLT_s16*//*Label 6480*/ GIMT_Encode4(330370),
     /* 330346 */ /*GILLT_s32*//*Label 6481*/ GIMT_Encode4(330431), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 330358 */ /*GILLT_v2s32*//*Label 6482*/ GIMT_Encode4(330462), GIMT_Encode4(0),
     /* 330366 */ /*GILLT_v4s16*//*Label 6483*/ GIMT_Encode4(330490),
     /* 330370 */ // Label 6480: @330370
     /* 330370 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(330400), // Rule ID 510 //
     /* 330375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330389 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 330389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 330394 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330398 */   GIR_RootConstrainSelectedInstOperands,
     /* 330399 */   // GIR_Coverage, 510,
     /* 330399 */   GIR_Done,
     /* 330400 */ // Label 6485: @330400
     /* 330400 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(330430), // Rule ID 520 //
     /* 330405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330419 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 330419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 330424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330428 */   GIR_RootConstrainSelectedInstOperands,
     /* 330429 */   // GIR_Coverage, 520,
     /* 330429 */   GIR_Done,
     /* 330430 */ // Label 6486: @330430
     /* 330430 */ GIM_Reject,
     /* 330431 */ // Label 6481: @330431
     /* 330431 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(330461), // Rule ID 512 //
     /* 330436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330450 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 330450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 330455 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330459 */   GIR_RootConstrainSelectedInstOperands,
     /* 330460 */   // GIR_Coverage, 512,
     /* 330460 */   GIR_Done,
     /* 330461 */ // Label 6487: @330461
     /* 330461 */ GIM_Reject,
     /* 330462 */ // Label 6482: @330462
     /* 330462 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(330489), // Rule ID 4950 //
     /* 330467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330478 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 330478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 330483 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330487 */   GIR_RootConstrainSelectedInstOperands,
     /* 330488 */   // GIR_Coverage, 4950,
     /* 330488 */   GIR_Done,
     /* 330489 */ // Label 6488: @330489
     /* 330489 */ GIM_Reject,
     /* 330490 */ // Label 6483: @330490
     /* 330490 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(330517), // Rule ID 4952 //
     /* 330495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330506 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 330506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 330511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330515 */   GIR_RootConstrainSelectedInstOperands,
     /* 330516 */   // GIR_Coverage, 4952,
     /* 330516 */   GIR_Done,
     /* 330517 */ // Label 6489: @330517
     /* 330517 */ GIM_Reject,
     /* 330518 */ // Label 6484: @330518
     /* 330518 */ GIM_Reject,
     /* 330519 */ // Label 67: @330519
     /* 330519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6497*/ GIMT_Encode4(331495),
     /* 330530 */ /*GILLT_s32*//*Label 6490*/ GIMT_Encode4(330566),
     /* 330534 */ /*GILLT_s64*//*Label 6491*/ GIMT_Encode4(330953), GIMT_Encode4(0),
     /* 330542 */ /*GILLT_v2s32*//*Label 6492*/ GIMT_Encode4(331340),
     /* 330546 */ /*GILLT_v2s64*//*Label 6493*/ GIMT_Encode4(331371),
     /* 330550 */ /*GILLT_v4s16*//*Label 6494*/ GIMT_Encode4(331402),
     /* 330554 */ /*GILLT_v4s32*//*Label 6495*/ GIMT_Encode4(331433), GIMT_Encode4(0),
     /* 330562 */ /*GILLT_v8s16*//*Label 6496*/ GIMT_Encode4(331464),
     /* 330566 */ // Label 6490: @330566
     /* 330566 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(330603), // Rule ID 4689 //
     /* 330571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330592 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 330595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330597 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330601 */   GIR_RootConstrainSelectedInstOperands,
     /* 330602 */   // GIR_Coverage, 4689,
     /* 330602 */   GIR_EraseRootFromParent_Done,
     /* 330603 */ // Label 6498: @330603
     /* 330603 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(330640), // Rule ID 4691 //
     /* 330608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330623 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330629 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 330632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330634 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330638 */   GIR_RootConstrainSelectedInstOperands,
     /* 330639 */   // GIR_Coverage, 4691,
     /* 330639 */   GIR_EraseRootFromParent_Done,
     /* 330640 */ // Label 6499: @330640
     /* 330640 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(330677), // Rule ID 4709 //
     /* 330645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330660 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330666 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 330669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330671 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330675 */   GIR_RootConstrainSelectedInstOperands,
     /* 330676 */   // GIR_Coverage, 4709,
     /* 330676 */   GIR_EraseRootFromParent_Done,
     /* 330677 */ // Label 6500: @330677
     /* 330677 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(330714), // Rule ID 4711 //
     /* 330682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330697 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330703 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 330706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330708 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330712 */   GIR_RootConstrainSelectedInstOperands,
     /* 330713 */   // GIR_Coverage, 4711,
     /* 330713 */   GIR_EraseRootFromParent_Done,
     /* 330714 */ // Label 6501: @330714
     /* 330714 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(330751), // Rule ID 4749 //
     /* 330719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330734 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330740 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 330743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330745 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330749 */   GIR_RootConstrainSelectedInstOperands,
     /* 330750 */   // GIR_Coverage, 4749,
     /* 330750 */   GIR_EraseRootFromParent_Done,
     /* 330751 */ // Label 6502: @330751
     /* 330751 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(330788), // Rule ID 4751 //
     /* 330756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330771 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330777 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 330780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330782 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330786 */   GIR_RootConstrainSelectedInstOperands,
     /* 330787 */   // GIR_Coverage, 4751,
     /* 330787 */   GIR_EraseRootFromParent_Done,
     /* 330788 */ // Label 6503: @330788
     /* 330788 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(330825), // Rule ID 4729 //
     /* 330793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330808 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330814 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 330817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330819 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330823 */   GIR_RootConstrainSelectedInstOperands,
     /* 330824 */   // GIR_Coverage, 4729,
     /* 330824 */   GIR_EraseRootFromParent_Done,
     /* 330825 */ // Label 6504: @330825
     /* 330825 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(330862), // Rule ID 4731 //
     /* 330830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330845 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330849 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330851 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 330854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330856 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330860 */   GIR_RootConstrainSelectedInstOperands,
     /* 330861 */   // GIR_Coverage, 4731,
     /* 330861 */   GIR_EraseRootFromParent_Done,
     /* 330862 */ // Label 6505: @330862
     /* 330862 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(330892), // Rule ID 395 //
     /* 330867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330881 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 330881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 330886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330890 */   GIR_RootConstrainSelectedInstOperands,
     /* 330891 */   // GIR_Coverage, 395,
     /* 330891 */   GIR_Done,
     /* 330892 */ // Label 6506: @330892
     /* 330892 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(330922), // Rule ID 399 //
     /* 330897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330911 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 330911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 330916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330920 */   GIR_RootConstrainSelectedInstOperands,
     /* 330921 */   // GIR_Coverage, 399,
     /* 330921 */   GIR_Done,
     /* 330922 */ // Label 6507: @330922
     /* 330922 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(330952), // Rule ID 403 //
     /* 330927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330941 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 330941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 330946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330950 */   GIR_RootConstrainSelectedInstOperands,
     /* 330951 */   // GIR_Coverage, 403,
     /* 330951 */   GIR_Done,
     /* 330952 */ // Label 6508: @330952
     /* 330952 */ GIM_Reject,
     /* 330953 */ // Label 6491: @330953
     /* 330953 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(330990), // Rule ID 4690 //
     /* 330958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330973 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330979 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 330982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330984 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330988 */   GIR_RootConstrainSelectedInstOperands,
     /* 330989 */   // GIR_Coverage, 4690,
     /* 330989 */   GIR_EraseRootFromParent_Done,
     /* 330990 */ // Label 6509: @330990
     /* 330990 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(331027), // Rule ID 4692 //
     /* 330995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331010 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331016 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 331019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331021 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331025 */   GIR_RootConstrainSelectedInstOperands,
     /* 331026 */   // GIR_Coverage, 4692,
     /* 331026 */   GIR_EraseRootFromParent_Done,
     /* 331027 */ // Label 6510: @331027
     /* 331027 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(331064), // Rule ID 4710 //
     /* 331032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331047 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331053 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 331056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331058 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331062 */   GIR_RootConstrainSelectedInstOperands,
     /* 331063 */   // GIR_Coverage, 4710,
     /* 331063 */   GIR_EraseRootFromParent_Done,
     /* 331064 */ // Label 6511: @331064
     /* 331064 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(331101), // Rule ID 4712 //
     /* 331069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331084 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331088 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331090 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 331093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331095 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331099 */   GIR_RootConstrainSelectedInstOperands,
     /* 331100 */   // GIR_Coverage, 4712,
     /* 331100 */   GIR_EraseRootFromParent_Done,
     /* 331101 */ // Label 6512: @331101
     /* 331101 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(331138), // Rule ID 4750 //
     /* 331106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331121 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331127 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 331130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331132 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331136 */   GIR_RootConstrainSelectedInstOperands,
     /* 331137 */   // GIR_Coverage, 4750,
     /* 331137 */   GIR_EraseRootFromParent_Done,
     /* 331138 */ // Label 6513: @331138
     /* 331138 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(331175), // Rule ID 4752 //
     /* 331143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331158 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331164 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 331167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331169 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331173 */   GIR_RootConstrainSelectedInstOperands,
     /* 331174 */   // GIR_Coverage, 4752,
     /* 331174 */   GIR_EraseRootFromParent_Done,
     /* 331175 */ // Label 6514: @331175
     /* 331175 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(331212), // Rule ID 4730 //
     /* 331180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331195 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331201 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 331204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331206 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331210 */   GIR_RootConstrainSelectedInstOperands,
     /* 331211 */   // GIR_Coverage, 4730,
     /* 331211 */   GIR_EraseRootFromParent_Done,
     /* 331212 */ // Label 6515: @331212
     /* 331212 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(331249), // Rule ID 4732 //
     /* 331217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331224 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331228 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331232 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331238 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 331241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331243 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331247 */   GIR_RootConstrainSelectedInstOperands,
     /* 331248 */   // GIR_Coverage, 4732,
     /* 331248 */   GIR_EraseRootFromParent_Done,
     /* 331249 */ // Label 6516: @331249
     /* 331249 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(331279), // Rule ID 397 //
     /* 331254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331268 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 331268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 331273 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331277 */   GIR_RootConstrainSelectedInstOperands,
     /* 331278 */   // GIR_Coverage, 397,
     /* 331278 */   GIR_Done,
     /* 331279 */ // Label 6517: @331279
     /* 331279 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(331309), // Rule ID 401 //
     /* 331284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331298 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 331298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 331303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331307 */   GIR_RootConstrainSelectedInstOperands,
     /* 331308 */   // GIR_Coverage, 401,
     /* 331308 */   GIR_Done,
     /* 331309 */ // Label 6518: @331309
     /* 331309 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(331339), // Rule ID 405 //
     /* 331314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331328 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 331328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 331333 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331337 */   GIR_RootConstrainSelectedInstOperands,
     /* 331338 */   // GIR_Coverage, 405,
     /* 331338 */   GIR_Done,
     /* 331339 */ // Label 6519: @331339
     /* 331339 */ GIM_Reject,
     /* 331340 */ // Label 6492: @331340
     /* 331340 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(331370), // Rule ID 843 //
     /* 331345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331359 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 331359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 331364 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331368 */   GIR_RootConstrainSelectedInstOperands,
     /* 331369 */   // GIR_Coverage, 843,
     /* 331369 */   GIR_Done,
     /* 331370 */ // Label 6520: @331370
     /* 331370 */ GIM_Reject,
     /* 331371 */ // Label 6493: @331371
     /* 331371 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(331401), // Rule ID 847 //
     /* 331376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331390 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 331390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 331395 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331399 */   GIR_RootConstrainSelectedInstOperands,
     /* 331400 */   // GIR_Coverage, 847,
     /* 331400 */   GIR_Done,
     /* 331401 */ // Label 6521: @331401
     /* 331401 */ GIM_Reject,
     /* 331402 */ // Label 6494: @331402
     /* 331402 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(331432), // Rule ID 839 //
     /* 331407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331421 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 331421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 331426 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331430 */   GIR_RootConstrainSelectedInstOperands,
     /* 331431 */   // GIR_Coverage, 839,
     /* 331431 */   GIR_Done,
     /* 331432 */ // Label 6522: @331432
     /* 331432 */ GIM_Reject,
     /* 331433 */ // Label 6495: @331433
     /* 331433 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(331463), // Rule ID 845 //
     /* 331438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331452 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 331452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 331457 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331461 */   GIR_RootConstrainSelectedInstOperands,
     /* 331462 */   // GIR_Coverage, 845,
     /* 331462 */   GIR_Done,
     /* 331463 */ // Label 6523: @331463
     /* 331463 */ GIM_Reject,
     /* 331464 */ // Label 6496: @331464
     /* 331464 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(331494), // Rule ID 841 //
     /* 331469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331483 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 331483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 331488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331492 */   GIR_RootConstrainSelectedInstOperands,
     /* 331493 */   // GIR_Coverage, 841,
     /* 331493 */   GIR_Done,
     /* 331494 */ // Label 6524: @331494
     /* 331494 */ GIM_Reject,
     /* 331495 */ // Label 6497: @331495
     /* 331495 */ GIM_Reject,
     /* 331496 */ // Label 68: @331496
     /* 331496 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6532*/ GIMT_Encode4(332472),
     /* 331507 */ /*GILLT_s32*//*Label 6525*/ GIMT_Encode4(331543),
     /* 331511 */ /*GILLT_s64*//*Label 6526*/ GIMT_Encode4(331930), GIMT_Encode4(0),
     /* 331519 */ /*GILLT_v2s32*//*Label 6527*/ GIMT_Encode4(332317),
     /* 331523 */ /*GILLT_v2s64*//*Label 6528*/ GIMT_Encode4(332348),
     /* 331527 */ /*GILLT_v4s16*//*Label 6529*/ GIMT_Encode4(332379),
     /* 331531 */ /*GILLT_v4s32*//*Label 6530*/ GIMT_Encode4(332410), GIMT_Encode4(0),
     /* 331539 */ /*GILLT_v8s16*//*Label 6531*/ GIMT_Encode4(332441),
     /* 331543 */ // Label 6525: @331543
     /* 331543 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(331580), // Rule ID 4699 //
     /* 331548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331563 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331569 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 331572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331578 */   GIR_RootConstrainSelectedInstOperands,
     /* 331579 */   // GIR_Coverage, 4699,
     /* 331579 */   GIR_EraseRootFromParent_Done,
     /* 331580 */ // Label 6533: @331580
     /* 331580 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(331617), // Rule ID 4701 //
     /* 331585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331606 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 331609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331611 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331615 */   GIR_RootConstrainSelectedInstOperands,
     /* 331616 */   // GIR_Coverage, 4701,
     /* 331616 */   GIR_EraseRootFromParent_Done,
     /* 331617 */ // Label 6534: @331617
     /* 331617 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(331654), // Rule ID 4719 //
     /* 331622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331637 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331643 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 331646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331648 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331652 */   GIR_RootConstrainSelectedInstOperands,
     /* 331653 */   // GIR_Coverage, 4719,
     /* 331653 */   GIR_EraseRootFromParent_Done,
     /* 331654 */ // Label 6535: @331654
     /* 331654 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(331691), // Rule ID 4721 //
     /* 331659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331666 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331670 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331674 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331680 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 331683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331685 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331689 */   GIR_RootConstrainSelectedInstOperands,
     /* 331690 */   // GIR_Coverage, 4721,
     /* 331690 */   GIR_EraseRootFromParent_Done,
     /* 331691 */ // Label 6536: @331691
     /* 331691 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(331728), // Rule ID 4759 //
     /* 331696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331703 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331711 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331717 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 331720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331722 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331726 */   GIR_RootConstrainSelectedInstOperands,
     /* 331727 */   // GIR_Coverage, 4759,
     /* 331727 */   GIR_EraseRootFromParent_Done,
     /* 331728 */ // Label 6537: @331728
     /* 331728 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(331765), // Rule ID 4761 //
     /* 331733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331748 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331754 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 331757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331759 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331763 */   GIR_RootConstrainSelectedInstOperands,
     /* 331764 */   // GIR_Coverage, 4761,
     /* 331764 */   GIR_EraseRootFromParent_Done,
     /* 331765 */ // Label 6538: @331765
     /* 331765 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(331802), // Rule ID 4739 //
     /* 331770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331791 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 331794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331796 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331800 */   GIR_RootConstrainSelectedInstOperands,
     /* 331801 */   // GIR_Coverage, 4739,
     /* 331801 */   GIR_EraseRootFromParent_Done,
     /* 331802 */ // Label 6539: @331802
     /* 331802 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(331839), // Rule ID 4741 //
     /* 331807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331822 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331828 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 331831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331833 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331837 */   GIR_RootConstrainSelectedInstOperands,
     /* 331838 */   // GIR_Coverage, 4741,
     /* 331838 */   GIR_EraseRootFromParent_Done,
     /* 331839 */ // Label 6540: @331839
     /* 331839 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(331869), // Rule ID 407 //
     /* 331844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331858 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 331858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 331863 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331867 */   GIR_RootConstrainSelectedInstOperands,
     /* 331868 */   // GIR_Coverage, 407,
     /* 331868 */   GIR_Done,
     /* 331869 */ // Label 6541: @331869
     /* 331869 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(331899), // Rule ID 411 //
     /* 331874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331888 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 331888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 331893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331897 */   GIR_RootConstrainSelectedInstOperands,
     /* 331898 */   // GIR_Coverage, 411,
     /* 331898 */   GIR_Done,
     /* 331899 */ // Label 6542: @331899
     /* 331899 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(331929), // Rule ID 415 //
     /* 331904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331918 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 331918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 331923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331927 */   GIR_RootConstrainSelectedInstOperands,
     /* 331928 */   // GIR_Coverage, 415,
     /* 331928 */   GIR_Done,
     /* 331929 */ // Label 6543: @331929
     /* 331929 */ GIM_Reject,
     /* 331930 */ // Label 6526: @331930
     /* 331930 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(331967), // Rule ID 4700 //
     /* 331935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331950 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331956 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 331959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331961 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331965 */   GIR_RootConstrainSelectedInstOperands,
     /* 331966 */   // GIR_Coverage, 4700,
     /* 331966 */   GIR_EraseRootFromParent_Done,
     /* 331967 */ // Label 6544: @331967
     /* 331967 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(332004), // Rule ID 4702 //
     /* 331972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331987 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331993 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 331996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331998 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332002 */   GIR_RootConstrainSelectedInstOperands,
     /* 332003 */   // GIR_Coverage, 4702,
     /* 332003 */   GIR_EraseRootFromParent_Done,
     /* 332004 */ // Label 6545: @332004
     /* 332004 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(332041), // Rule ID 4720 //
     /* 332009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332024 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332030 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 332033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332035 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332039 */   GIR_RootConstrainSelectedInstOperands,
     /* 332040 */   // GIR_Coverage, 4720,
     /* 332040 */   GIR_EraseRootFromParent_Done,
     /* 332041 */ // Label 6546: @332041
     /* 332041 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(332078), // Rule ID 4722 //
     /* 332046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332061 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332067 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 332070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332072 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332076 */   GIR_RootConstrainSelectedInstOperands,
     /* 332077 */   // GIR_Coverage, 4722,
     /* 332077 */   GIR_EraseRootFromParent_Done,
     /* 332078 */ // Label 6547: @332078
     /* 332078 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(332115), // Rule ID 4760 //
     /* 332083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332098 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332104 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 332107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332109 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332113 */   GIR_RootConstrainSelectedInstOperands,
     /* 332114 */   // GIR_Coverage, 4760,
     /* 332114 */   GIR_EraseRootFromParent_Done,
     /* 332115 */ // Label 6548: @332115
     /* 332115 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(332152), // Rule ID 4762 //
     /* 332120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332141 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 332144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332146 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332150 */   GIR_RootConstrainSelectedInstOperands,
     /* 332151 */   // GIR_Coverage, 4762,
     /* 332151 */   GIR_EraseRootFromParent_Done,
     /* 332152 */ // Label 6549: @332152
     /* 332152 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(332189), // Rule ID 4740 //
     /* 332157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332164 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332168 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332172 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332178 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 332181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332183 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332187 */   GIR_RootConstrainSelectedInstOperands,
     /* 332188 */   // GIR_Coverage, 4740,
     /* 332188 */   GIR_EraseRootFromParent_Done,
     /* 332189 */ // Label 6550: @332189
     /* 332189 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(332226), // Rule ID 4742 //
     /* 332194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332209 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332215 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 332218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332220 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332224 */   GIR_RootConstrainSelectedInstOperands,
     /* 332225 */   // GIR_Coverage, 4742,
     /* 332225 */   GIR_EraseRootFromParent_Done,
     /* 332226 */ // Label 6551: @332226
     /* 332226 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(332256), // Rule ID 409 //
     /* 332231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 332237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332245 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 332245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 332250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332254 */   GIR_RootConstrainSelectedInstOperands,
     /* 332255 */   // GIR_Coverage, 409,
     /* 332255 */   GIR_Done,
     /* 332256 */ // Label 6552: @332256
     /* 332256 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(332286), // Rule ID 413 //
     /* 332261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332275 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 332275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 332280 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332284 */   GIR_RootConstrainSelectedInstOperands,
     /* 332285 */   // GIR_Coverage, 413,
     /* 332285 */   GIR_Done,
     /* 332286 */ // Label 6553: @332286
     /* 332286 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(332316), // Rule ID 417 //
     /* 332291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332305 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 332305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 332310 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332314 */   GIR_RootConstrainSelectedInstOperands,
     /* 332315 */   // GIR_Coverage, 417,
     /* 332315 */   GIR_Done,
     /* 332316 */ // Label 6554: @332316
     /* 332316 */ GIM_Reject,
     /* 332317 */ // Label 6527: @332317
     /* 332317 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(332347), // Rule ID 853 //
     /* 332322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 332328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332336 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 332336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 332341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332345 */   GIR_RootConstrainSelectedInstOperands,
     /* 332346 */   // GIR_Coverage, 853,
     /* 332346 */   GIR_Done,
     /* 332347 */ // Label 6555: @332347
     /* 332347 */ GIM_Reject,
     /* 332348 */ // Label 6528: @332348
     /* 332348 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(332378), // Rule ID 857 //
     /* 332353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332367 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 332367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 332372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332376 */   GIR_RootConstrainSelectedInstOperands,
     /* 332377 */   // GIR_Coverage, 857,
     /* 332377 */   GIR_Done,
     /* 332378 */ // Label 6556: @332378
     /* 332378 */ GIM_Reject,
     /* 332379 */ // Label 6529: @332379
     /* 332379 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(332409), // Rule ID 849 //
     /* 332384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332398 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 332398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 332403 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332407 */   GIR_RootConstrainSelectedInstOperands,
     /* 332408 */   // GIR_Coverage, 849,
     /* 332408 */   GIR_Done,
     /* 332409 */ // Label 6557: @332409
     /* 332409 */ GIM_Reject,
     /* 332410 */ // Label 6530: @332410
     /* 332410 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(332440), // Rule ID 855 //
     /* 332415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332429 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 332429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 332434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332438 */   GIR_RootConstrainSelectedInstOperands,
     /* 332439 */   // GIR_Coverage, 855,
     /* 332439 */   GIR_Done,
     /* 332440 */ // Label 6558: @332440
     /* 332440 */ GIM_Reject,
     /* 332441 */ // Label 6531: @332441
     /* 332441 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(332471), // Rule ID 851 //
     /* 332446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332460 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 332460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 332465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332469 */   GIR_RootConstrainSelectedInstOperands,
     /* 332470 */   // GIR_Coverage, 851,
     /* 332470 */   GIR_Done,
     /* 332471 */ // Label 6559: @332471
     /* 332471 */ GIM_Reject,
     /* 332472 */ // Label 6532: @332472
     /* 332472 */ GIM_Reject,
     /* 332473 */ // Label 69: @332473
     /* 332473 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6568*/ GIMT_Encode4(337100),
     /* 332484 */ /*GILLT_s16*//*Label 6560*/ GIMT_Encode4(332524),
     /* 332488 */ /*GILLT_s32*//*Label 6561*/ GIMT_Encode4(332965),
     /* 332492 */ /*GILLT_s64*//*Label 6562*/ GIMT_Encode4(334961), GIMT_Encode4(0),
     /* 332500 */ /*GILLT_v2s32*//*Label 6563*/ GIMT_Encode4(336945),
     /* 332504 */ /*GILLT_v2s64*//*Label 6564*/ GIMT_Encode4(336976),
     /* 332508 */ /*GILLT_v4s16*//*Label 6565*/ GIMT_Encode4(337007),
     /* 332512 */ /*GILLT_v4s32*//*Label 6566*/ GIMT_Encode4(337038), GIMT_Encode4(0),
     /* 332520 */ /*GILLT_v8s16*//*Label 6567*/ GIMT_Encode4(337069),
     /* 332524 */ // Label 6560: @332524
     /* 332524 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(332627), // Rule ID 5342 //
     /* 332529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 332532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 332547 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332551 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332555 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332559 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332563 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 332567 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332572 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 332576 */   // MIs[1] Operand 2
     /* 332576 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 332587 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332589 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 332589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332601 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 332607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 332620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332625 */   GIR_RootConstrainSelectedInstOperands,
     /* 332626 */   // GIR_Coverage, 5342,
     /* 332626 */   GIR_EraseRootFromParent_Done,
     /* 332627 */ // Label 6569: @332627
     /* 332627 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(332707), // Rule ID 2447 //
     /* 332632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332650 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332654 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332658 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332663 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 332667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332669 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 332669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332681 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 332687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332692 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 332700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332705 */   GIR_RootConstrainSelectedInstOperands,
     /* 332706 */   // GIR_Coverage, 2447,
     /* 332706 */   GIR_EraseRootFromParent_Done,
     /* 332707 */ // Label 6570: @332707
     /* 332707 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(332787), // Rule ID 2451 //
     /* 332712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332730 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332734 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332738 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332743 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 332747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332749 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 332749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 332752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332761 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 332780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332785 */   GIR_RootConstrainSelectedInstOperands,
     /* 332786 */   // GIR_Coverage, 2451,
     /* 332786 */   GIR_EraseRootFromParent_Done,
     /* 332787 */ // Label 6571: @332787
     /* 332787 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(332844), // Rule ID 5333 //
     /* 332792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 332795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 332810 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332816 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 332816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 332823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332828 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 332837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332842 */   GIR_RootConstrainSelectedInstOperands,
     /* 332843 */   // GIR_Coverage, 5333,
     /* 332843 */   GIR_EraseRootFromParent_Done,
     /* 332844 */ // Label 6572: @332844
     /* 332844 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(332874), // Rule ID 443 //
     /* 332849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332863 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 332863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 332868 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332872 */   GIR_RootConstrainSelectedInstOperands,
     /* 332873 */   // GIR_Coverage, 443,
     /* 332873 */   GIR_Done,
     /* 332874 */ // Label 6573: @332874
     /* 332874 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(332904), // Rule ID 449 //
     /* 332879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332893 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 332893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 332898 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332902 */   GIR_RootConstrainSelectedInstOperands,
     /* 332903 */   // GIR_Coverage, 449,
     /* 332903 */   GIR_Done,
     /* 332904 */ // Label 6574: @332904
     /* 332904 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(332934), // Rule ID 491 //
     /* 332909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332923 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 332923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 332928 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332932 */   GIR_RootConstrainSelectedInstOperands,
     /* 332933 */   // GIR_Coverage, 491,
     /* 332933 */   GIR_Done,
     /* 332934 */ // Label 6575: @332934
     /* 332934 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(332964), // Rule ID 495 //
     /* 332939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332953 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 332953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 332958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332962 */   GIR_RootConstrainSelectedInstOperands,
     /* 332963 */   // GIR_Coverage, 495,
     /* 332963 */   GIR_Done,
     /* 332964 */ // Label 6576: @332964
     /* 332964 */ GIM_Reject,
     /* 332965 */ // Label 6561: @332965
     /* 332965 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(333203), // Rule ID 6419 //
     /* 332970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332988 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332991 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332998 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333002 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333004 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 333011 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333011 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333014 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 333018 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333038 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333045 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333048 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333052 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333059 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333062 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333066 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333071 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333074 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333077 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333080 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333085 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333090 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333095 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333098 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333102 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333107 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333110 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333115 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333118 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333122 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333127 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333134 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333139 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333144 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333147 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333151 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333156 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333159 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333176 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333183 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333188 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333201 */   GIR_RootConstrainSelectedInstOperands,
     /* 333202 */   // GIR_Coverage, 6419,
     /* 333202 */   GIR_EraseRootFromParent_Done,
     /* 333203 */ // Label 6577: @333203
     /* 333203 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(333441), // Rule ID 6420 //
     /* 333208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333218 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333222 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333226 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333229 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333236 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333242 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 333249 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333249 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333252 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 333256 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333276 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333283 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333286 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333290 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333297 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333300 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333304 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333309 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333312 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333315 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333318 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333323 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333328 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333333 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333336 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333340 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333345 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333348 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333353 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333356 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333360 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333365 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333372 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333377 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333382 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333385 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333389 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333394 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333397 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333414 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333439 */   GIR_RootConstrainSelectedInstOperands,
     /* 333440 */   // GIR_Coverage, 6420,
     /* 333440 */   GIR_EraseRootFromParent_Done,
     /* 333441 */ // Label 6578: @333441
     /* 333441 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(333630), // Rule ID 6423 //
     /* 333446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333464 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333467 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333474 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333478 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333480 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 333487 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333487 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333490 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 333494 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333514 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333521 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333524 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333528 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333535 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333538 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333542 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333547 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333550 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333553 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333556 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333561 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333566 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333571 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333574 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333578 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333583 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333586 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333603 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333610 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333628 */   GIR_RootConstrainSelectedInstOperands,
     /* 333629 */   // GIR_Coverage, 6423,
     /* 333629 */   GIR_EraseRootFromParent_Done,
     /* 333630 */ // Label 6579: @333630
     /* 333630 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(333819), // Rule ID 6424 //
     /* 333635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333645 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333653 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333656 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333663 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333669 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 333676 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333676 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333679 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 333683 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333703 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333710 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333713 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333717 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333724 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333727 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333731 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333736 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333739 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333742 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333745 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333750 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333755 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333772 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333775 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333792 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333804 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333817 */   GIR_RootConstrainSelectedInstOperands,
     /* 333818 */   // GIR_Coverage, 6424,
     /* 333818 */   GIR_EraseRootFromParent_Done,
     /* 333819 */ // Label 6580: @333819
     /* 333819 */ GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(334052), // Rule ID 6421 //
     /* 333824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333842 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333845 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333852 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333858 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 333865 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333865 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333868 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 333872 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333887 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333894 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333897 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333901 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333908 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333911 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333915 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333920 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333923 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333926 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333929 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333934 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333939 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333944 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333947 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333951 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333956 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333959 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333964 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333967 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333971 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333976 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333983 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333988 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333993 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333996 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334000 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334005 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334008 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334025 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334032 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334037 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334050 */   GIR_RootConstrainSelectedInstOperands,
     /* 334051 */   // GIR_Coverage, 6421,
     /* 334051 */   GIR_EraseRootFromParent_Done,
     /* 334052 */ // Label 6581: @334052
     /* 334052 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(334285), // Rule ID 6422 //
     /* 334057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334075 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334078 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 334085 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334089 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334091 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 334098 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334098 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 334101 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 334105 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334120 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334127 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334130 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334134 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334141 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334144 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334148 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334153 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334156 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334159 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 334162 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334167 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334172 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 334177 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334180 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 334184 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334189 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334192 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334197 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334200 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334204 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334209 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334216 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334221 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334226 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334229 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334233 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334238 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334241 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334258 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334283 */   GIR_RootConstrainSelectedInstOperands,
     /* 334284 */   // GIR_Coverage, 6422,
     /* 334284 */   GIR_EraseRootFromParent_Done,
     /* 334285 */ // Label 6582: @334285
     /* 334285 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(334469), // Rule ID 6425 //
     /* 334290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334308 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334311 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334318 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334324 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 334331 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334331 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334334 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 334338 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334353 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334360 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334363 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334367 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334374 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334377 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334381 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334386 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334389 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334392 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334395 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334400 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334405 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334410 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334413 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334417 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334422 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334425 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334442 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334454 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334467 */   GIR_RootConstrainSelectedInstOperands,
     /* 334468 */   // GIR_Coverage, 6425,
     /* 334468 */   GIR_EraseRootFromParent_Done,
     /* 334469 */ // Label 6583: @334469
     /* 334469 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(334653), // Rule ID 6426 //
     /* 334474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334484 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334488 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334492 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334495 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334502 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334506 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334508 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 334515 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334515 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334518 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 334522 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334537 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334544 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334547 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334551 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334558 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334561 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334565 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334570 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334573 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334576 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334579 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334584 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334589 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334594 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334597 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334601 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334606 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334609 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334626 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334638 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334648 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334651 */   GIR_RootConstrainSelectedInstOperands,
     /* 334652 */   // GIR_Coverage, 6426,
     /* 334652 */   GIR_EraseRootFromParent_Done,
     /* 334653 */ // Label 6584: @334653
     /* 334653 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(334733), // Rule ID 2453 //
     /* 334658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 334661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334668 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334672 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334676 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 334680 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334684 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334689 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 334693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334695 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 334695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334707 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 334713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 334726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334731 */   GIR_RootConstrainSelectedInstOperands,
     /* 334732 */   // GIR_Coverage, 2453,
     /* 334732 */   GIR_EraseRootFromParent_Done,
     /* 334733 */ // Label 6585: @334733
     /* 334733 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(334813), // Rule ID 5338 //
     /* 334738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 334741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334756 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 334760 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334764 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334769 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 334773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334775 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 334775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334787 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 334793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334811 */   GIR_RootConstrainSelectedInstOperands,
     /* 334812 */   // GIR_Coverage, 5338,
     /* 334812 */   GIR_EraseRootFromParent_Done,
     /* 334813 */ // Label 6586: @334813
     /* 334813 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(334870), // Rule ID 5321 //
     /* 334818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 334821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 334836 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 334840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334842 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 334842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 334849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334854 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334868 */   GIR_RootConstrainSelectedInstOperands,
     /* 334869 */   // GIR_Coverage, 5321,
     /* 334869 */   GIR_EraseRootFromParent_Done,
     /* 334870 */ // Label 6587: @334870
     /* 334870 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(334900), // Rule ID 445 //
     /* 334875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 334878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 334889 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 334889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 334894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334898 */   GIR_RootConstrainSelectedInstOperands,
     /* 334899 */   // GIR_Coverage, 445,
     /* 334899 */   GIR_Done,
     /* 334900 */ // Label 6588: @334900
     /* 334900 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(334930), // Rule ID 451 //
     /* 334905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 334908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334919 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 334919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 334924 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334928 */   GIR_RootConstrainSelectedInstOperands,
     /* 334929 */   // GIR_Coverage, 451,
     /* 334929 */   GIR_Done,
     /* 334930 */ // Label 6589: @334930
     /* 334930 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(334960), // Rule ID 497 //
     /* 334935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 334938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334949 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 334949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 334954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334958 */   GIR_RootConstrainSelectedInstOperands,
     /* 334959 */   // GIR_Coverage, 497,
     /* 334959 */   GIR_Done,
     /* 334960 */ // Label 6590: @334960
     /* 334960 */ GIM_Reject,
     /* 334961 */ // Label 6562: @334961
     /* 334961 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(335147), // Rule ID 6431 //
     /* 334966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334984 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334991 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334997 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335004 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335004 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335007 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335011 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335031 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335038 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335041 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335045 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335052 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335055 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335059 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335064 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335067 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335070 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335073 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335078 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335083 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335088 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335091 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335095 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335100 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335103 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335120 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335145 */   GIR_RootConstrainSelectedInstOperands,
     /* 335146 */   // GIR_Coverage, 6431,
     /* 335146 */   GIR_EraseRootFromParent_Done,
     /* 335147 */ // Label 6591: @335147
     /* 335147 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(335333), // Rule ID 6432 //
     /* 335152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335170 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335173 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335177 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335183 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335190 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335190 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335193 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335197 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335217 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335224 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335227 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335231 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335238 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335241 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335245 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335250 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335253 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335256 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335259 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335264 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335269 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335274 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335277 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335281 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335286 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335289 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335306 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335318 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335331 */   GIR_RootConstrainSelectedInstOperands,
     /* 335332 */   // GIR_Coverage, 6432,
     /* 335332 */   GIR_EraseRootFromParent_Done,
     /* 335333 */ // Label 6592: @335333
     /* 335333 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(335571), // Rule ID 6427 //
     /* 335338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335356 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335359 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335366 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335370 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335372 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 335379 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335379 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335382 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 335386 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335406 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335413 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335416 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335420 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335427 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335430 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335434 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335439 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335442 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335445 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335448 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335453 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335458 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335463 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335466 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335470 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335475 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335478 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335483 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335486 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335490 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335495 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335502 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335507 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335512 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335515 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335519 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335524 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335527 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335544 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335569 */   GIR_RootConstrainSelectedInstOperands,
     /* 335570 */   // GIR_Coverage, 6427,
     /* 335570 */   GIR_EraseRootFromParent_Done,
     /* 335571 */ // Label 6593: @335571
     /* 335571 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(335809), // Rule ID 6428 //
     /* 335576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335586 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335594 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335597 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335604 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335610 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 335617 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335617 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335620 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 335624 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335644 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335651 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335654 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335658 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335665 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335668 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335672 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335677 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335680 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335683 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335686 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335691 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335696 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335701 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335704 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335708 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335713 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335716 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335733 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335740 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335745 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335750 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335753 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335757 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335762 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335765 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335782 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335807 */   GIR_RootConstrainSelectedInstOperands,
     /* 335808 */   // GIR_Coverage, 6428,
     /* 335808 */   GIR_EraseRootFromParent_Done,
     /* 335809 */ // Label 6594: @335809
     /* 335809 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(335990), // Rule ID 6433 //
     /* 335814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335832 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335835 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335839 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335845 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335852 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335852 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335855 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335859 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335874 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335881 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335884 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335888 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335895 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335898 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335902 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335907 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335910 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335913 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335916 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335921 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335926 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335931 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335934 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335938 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335943 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335946 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335963 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335988 */   GIR_RootConstrainSelectedInstOperands,
     /* 335989 */   // GIR_Coverage, 6433,
     /* 335989 */   GIR_EraseRootFromParent_Done,
     /* 335990 */ // Label 6595: @335990
     /* 335990 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(336171), // Rule ID 6434 //
     /* 335995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336013 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336020 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336026 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 336033 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336033 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 336036 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 336040 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336055 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 336062 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 336065 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336069 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336076 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336079 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336083 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336088 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 336091 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 336094 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 336097 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336102 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336107 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336112 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336115 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336119 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336124 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336127 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336144 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336169 */   GIR_RootConstrainSelectedInstOperands,
     /* 336170 */   // GIR_Coverage, 6434,
     /* 336170 */   GIR_EraseRootFromParent_Done,
     /* 336171 */ // Label 6596: @336171
     /* 336171 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(336404), // Rule ID 6429 //
     /* 336176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336194 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336197 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336204 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336210 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 336217 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336217 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336220 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 336224 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336239 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336246 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336249 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336253 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336260 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336263 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336267 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336272 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336275 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336278 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336281 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336286 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336291 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336296 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336299 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336303 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336308 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336311 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336316 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336319 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336323 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336328 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336335 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336340 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336345 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336348 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336352 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336357 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336360 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336377 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336384 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336389 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336402 */   GIR_RootConstrainSelectedInstOperands,
     /* 336403 */   // GIR_Coverage, 6429,
     /* 336403 */   GIR_EraseRootFromParent_Done,
     /* 336404 */ // Label 6597: @336404
     /* 336404 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(336637), // Rule ID 6430 //
     /* 336409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336427 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336430 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336437 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336443 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 336450 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336450 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336453 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 336457 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336472 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336479 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336482 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336486 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336493 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336496 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336500 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336505 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336508 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336511 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336514 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336519 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336524 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336529 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336532 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336536 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336541 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336544 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336549 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336552 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336556 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336561 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336568 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336573 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336581 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336585 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336590 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336593 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336610 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336635 */   GIR_RootConstrainSelectedInstOperands,
     /* 336636 */   // GIR_Coverage, 6430,
     /* 336636 */   GIR_EraseRootFromParent_Done,
     /* 336637 */ // Label 6598: @336637
     /* 336637 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(336717), // Rule ID 2449 //
     /* 336642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336660 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336664 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336668 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336673 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336679 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 336679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336691 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 336697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 336710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336715 */   GIR_RootConstrainSelectedInstOperands,
     /* 336716 */   // GIR_Coverage, 2449,
     /* 336716 */   GIR_EraseRootFromParent_Done,
     /* 336717 */ // Label 6599: @336717
     /* 336717 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(336797), // Rule ID 5340 //
     /* 336722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336744 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336748 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336759 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 336759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336771 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 336777 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336782 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336795 */   GIR_RootConstrainSelectedInstOperands,
     /* 336796 */   // GIR_Coverage, 5340,
     /* 336796 */   GIR_EraseRootFromParent_Done,
     /* 336797 */ // Label 6600: @336797
     /* 336797 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(336854), // Rule ID 5317 //
     /* 336802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 336820 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 336824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336826 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 336826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 336833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336852 */   GIR_RootConstrainSelectedInstOperands,
     /* 336853 */   // GIR_Coverage, 5317,
     /* 336853 */   GIR_EraseRootFromParent_Done,
     /* 336854 */ // Label 6601: @336854
     /* 336854 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(336884), // Rule ID 447 //
     /* 336859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 336862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 336873 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 336873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 336878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336882 */   GIR_RootConstrainSelectedInstOperands,
     /* 336883 */   // GIR_Coverage, 447,
     /* 336883 */   GIR_Done,
     /* 336884 */ // Label 6602: @336884
     /* 336884 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(336914), // Rule ID 453 //
     /* 336889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 336892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 336903 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 336903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 336908 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336912 */   GIR_RootConstrainSelectedInstOperands,
     /* 336913 */   // GIR_Coverage, 453,
     /* 336913 */   GIR_Done,
     /* 336914 */ // Label 6603: @336914
     /* 336914 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(336944), // Rule ID 493 //
     /* 336919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336933 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 336933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 336938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336942 */   GIR_RootConstrainSelectedInstOperands,
     /* 336943 */   // GIR_Coverage, 493,
     /* 336943 */   GIR_Done,
     /* 336944 */ // Label 6604: @336944
     /* 336944 */ GIM_Reject,
     /* 336945 */ // Label 6563: @336945
     /* 336945 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(336975), // Rule ID 1017 //
     /* 336950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336964 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 336964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 336969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336973 */   GIR_RootConstrainSelectedInstOperands,
     /* 336974 */   // GIR_Coverage, 1017,
     /* 336974 */   GIR_Done,
     /* 336975 */ // Label 6605: @336975
     /* 336975 */ GIM_Reject,
     /* 336976 */ // Label 6564: @336976
     /* 336976 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(337006), // Rule ID 1021 //
     /* 336981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336995 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 336995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 337000 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337004 */   GIR_RootConstrainSelectedInstOperands,
     /* 337005 */   // GIR_Coverage, 1021,
     /* 337005 */   GIR_Done,
     /* 337006 */ // Label 6606: @337006
     /* 337006 */ GIM_Reject,
     /* 337007 */ // Label 6565: @337007
     /* 337007 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(337037), // Rule ID 1013 //
     /* 337012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 337015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 337018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337026 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 337026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 337031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337035 */   GIR_RootConstrainSelectedInstOperands,
     /* 337036 */   // GIR_Coverage, 1013,
     /* 337036 */   GIR_Done,
     /* 337037 */ // Label 6607: @337037
     /* 337037 */ GIM_Reject,
     /* 337038 */ // Label 6566: @337038
     /* 337038 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(337068), // Rule ID 1019 //
     /* 337043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337057 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 337057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 337062 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337066 */   GIR_RootConstrainSelectedInstOperands,
     /* 337067 */   // GIR_Coverage, 1019,
     /* 337067 */   GIR_Done,
     /* 337068 */ // Label 6608: @337068
     /* 337068 */ GIM_Reject,
     /* 337069 */ // Label 6567: @337069
     /* 337069 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(337099), // Rule ID 1015 //
     /* 337074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 337077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337088 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 337088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 337093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337097 */   GIR_RootConstrainSelectedInstOperands,
     /* 337098 */   // GIR_Coverage, 1015,
     /* 337098 */   GIR_Done,
     /* 337099 */ // Label 6609: @337099
     /* 337099 */ GIM_Reject,
     /* 337100 */ // Label 6568: @337100
     /* 337100 */ GIM_Reject,
     /* 337101 */ // Label 70: @337101
     /* 337101 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6618*/ GIMT_Encode4(341106),
     /* 337112 */ /*GILLT_s16*//*Label 6610*/ GIMT_Encode4(337152),
     /* 337116 */ /*GILLT_s32*//*Label 6611*/ GIMT_Encode4(337597),
     /* 337120 */ /*GILLT_s64*//*Label 6612*/ GIMT_Encode4(339005), GIMT_Encode4(0),
     /* 337128 */ /*GILLT_v2s32*//*Label 6613*/ GIMT_Encode4(340951),
     /* 337132 */ /*GILLT_v2s64*//*Label 6614*/ GIMT_Encode4(340982),
     /* 337136 */ /*GILLT_v4s16*//*Label 6615*/ GIMT_Encode4(341013),
     /* 337140 */ /*GILLT_v4s32*//*Label 6616*/ GIMT_Encode4(341044), GIMT_Encode4(0),
     /* 337148 */ /*GILLT_v8s16*//*Label 6617*/ GIMT_Encode4(341075),
     /* 337152 */ // Label 6610: @337152
     /* 337152 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(337259), // Rule ID 5343 //
     /* 337157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 337160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 337175 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337179 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 337183 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337187 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337191 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337195 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 337199 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337204 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 337208 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 337219 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337221 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 337221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337233 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 337239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 337252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337257 */   GIR_RootConstrainSelectedInstOperands,
     /* 337258 */   // GIR_Coverage, 5343,
     /* 337258 */   GIR_EraseRootFromParent_Done,
     /* 337259 */ // Label 6619: @337259
     /* 337259 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(337339), // Rule ID 4788 //
     /* 337264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337290 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337295 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337301 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337313 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 337332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337337 */   GIR_RootConstrainSelectedInstOperands,
     /* 337338 */   // GIR_Coverage, 4788,
     /* 337338 */   GIR_EraseRootFromParent_Done,
     /* 337339 */ // Label 6620: @337339
     /* 337339 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(337419), // Rule ID 4792 //
     /* 337344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337362 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337370 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337375 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337379 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337381 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337393 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337399 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337404 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 337412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337417 */   GIR_RootConstrainSelectedInstOperands,
     /* 337418 */   // GIR_Coverage, 4792,
     /* 337418 */   GIR_EraseRootFromParent_Done,
     /* 337419 */ // Label 6621: @337419
     /* 337419 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(337476), // Rule ID 5337 //
     /* 337424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 337427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 337442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337448 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 337448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 337455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337460 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 337469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337474 */   GIR_RootConstrainSelectedInstOperands,
     /* 337475 */   // GIR_Coverage, 5337,
     /* 337475 */   GIR_EraseRootFromParent_Done,
     /* 337476 */ // Label 6622: @337476
     /* 337476 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(337506), // Rule ID 467 //
     /* 337481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 337484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337495 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 337495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 337500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337504 */   GIR_RootConstrainSelectedInstOperands,
     /* 337505 */   // GIR_Coverage, 467,
     /* 337505 */   GIR_Done,
     /* 337506 */ // Label 6623: @337506
     /* 337506 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(337536), // Rule ID 473 //
     /* 337511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 337514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337525 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 337525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 337530 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337534 */   GIR_RootConstrainSelectedInstOperands,
     /* 337535 */   // GIR_Coverage, 473,
     /* 337535 */   GIR_Done,
     /* 337536 */ // Label 6624: @337536
     /* 337536 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(337566), // Rule ID 499 //
     /* 337541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337555 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 337555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 337560 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337564 */   GIR_RootConstrainSelectedInstOperands,
     /* 337565 */   // GIR_Coverage, 499,
     /* 337565 */   GIR_Done,
     /* 337566 */ // Label 6625: @337566
     /* 337566 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(337596), // Rule ID 503 //
     /* 337571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337585 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 337585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 337590 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337594 */   GIR_RootConstrainSelectedInstOperands,
     /* 337595 */   // GIR_Coverage, 503,
     /* 337595 */   GIR_Done,
     /* 337596 */ // Label 6626: @337596
     /* 337596 */ GIM_Reject,
     /* 337597 */ // Label 6611: @337597
     /* 337597 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(337737), // Rule ID 5344 //
     /* 337602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337612 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337620 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337623 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337630 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337636 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 337643 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337643 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337646 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 337650 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337670 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337677 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337680 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337684 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337703 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337706 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337709 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337735 */   GIR_RootConstrainSelectedInstOperands,
     /* 337736 */   // GIR_Coverage, 5344,
     /* 337736 */   GIR_EraseRootFromParent_Done,
     /* 337737 */ // Label 6627: @337737
     /* 337737 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(337877), // Rule ID 5345 //
     /* 337742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337760 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337763 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337770 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337776 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 337783 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337783 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337786 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 337790 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337810 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337817 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337820 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337824 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337843 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337846 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337849 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337852 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337857 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337862 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337875 */   GIR_RootConstrainSelectedInstOperands,
     /* 337876 */   // GIR_Coverage, 5345,
     /* 337876 */   GIR_EraseRootFromParent_Done,
     /* 337877 */ // Label 6628: @337877
     /* 337877 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(338017), // Rule ID 5348 //
     /* 337882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337892 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337896 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337900 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337903 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337910 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337914 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337916 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337923 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337923 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337926 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337930 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337950 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337957 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337960 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337964 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337983 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337986 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337989 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337997 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338015 */   GIR_RootConstrainSelectedInstOperands,
     /* 338016 */   // GIR_Coverage, 5348,
     /* 338016 */   GIR_EraseRootFromParent_Done,
     /* 338017 */ // Label 6629: @338017
     /* 338017 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(338157), // Rule ID 5349 //
     /* 338022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338040 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338043 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338050 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338056 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338063 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338063 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338066 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338070 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338090 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338097 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338100 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338104 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338123 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338126 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338129 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338137 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338155 */   GIR_RootConstrainSelectedInstOperands,
     /* 338156 */   // GIR_Coverage, 5349,
     /* 338156 */   GIR_EraseRootFromParent_Done,
     /* 338157 */ // Label 6630: @338157
     /* 338157 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(338292), // Rule ID 5346 //
     /* 338162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338180 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338183 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338190 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338196 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 338203 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 338203 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338206 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 338210 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338225 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338232 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338235 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338239 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338258 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338261 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338264 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338272 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338290 */   GIR_RootConstrainSelectedInstOperands,
     /* 338291 */   // GIR_Coverage, 5346,
     /* 338291 */   GIR_EraseRootFromParent_Done,
     /* 338292 */ // Label 6631: @338292
     /* 338292 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(338427), // Rule ID 5347 //
     /* 338297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338315 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338318 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338325 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338331 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 338338 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 338338 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338341 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 338345 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338360 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338367 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338370 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338374 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338393 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338396 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338399 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338425 */   GIR_RootConstrainSelectedInstOperands,
     /* 338426 */   // GIR_Coverage, 5347,
     /* 338426 */   GIR_EraseRootFromParent_Done,
     /* 338427 */ // Label 6632: @338427
     /* 338427 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(338562), // Rule ID 5350 //
     /* 338432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338450 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338453 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338460 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338464 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338466 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338473 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 338473 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338476 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338480 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338495 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338502 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338505 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338509 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338528 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338531 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338534 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338542 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338547 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338560 */   GIR_RootConstrainSelectedInstOperands,
     /* 338561 */   // GIR_Coverage, 5350,
     /* 338561 */   GIR_EraseRootFromParent_Done,
     /* 338562 */ // Label 6633: @338562
     /* 338562 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(338697), // Rule ID 5351 //
     /* 338567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338577 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338581 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338585 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338588 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338595 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338601 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338608 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 338608 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338611 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338615 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338630 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338637 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338640 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338644 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338663 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338666 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338669 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338677 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338695 */   GIR_RootConstrainSelectedInstOperands,
     /* 338696 */   // GIR_Coverage, 5351,
     /* 338696 */   GIR_EraseRootFromParent_Done,
     /* 338697 */ // Label 6634: @338697
     /* 338697 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(338777), // Rule ID 4794 //
     /* 338702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338712 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338720 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 338724 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338728 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338733 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338739 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 338739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338751 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 338757 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 338770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338775 */   GIR_RootConstrainSelectedInstOperands,
     /* 338776 */   // GIR_Coverage, 4794,
     /* 338776 */   GIR_EraseRootFromParent_Done,
     /* 338777 */ // Label 6635: @338777
     /* 338777 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(338857), // Rule ID 5339 //
     /* 338782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338792 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338800 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 338804 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338808 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338813 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338819 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 338819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338831 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 338837 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338855 */   GIR_RootConstrainSelectedInstOperands,
     /* 338856 */   // GIR_Coverage, 5339,
     /* 338856 */   GIR_EraseRootFromParent_Done,
     /* 338857 */ // Label 6636: @338857
     /* 338857 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(338914), // Rule ID 5329 //
     /* 338862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338872 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338876 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 338880 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 338884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338886 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 338886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 338893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338898 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338912 */   GIR_RootConstrainSelectedInstOperands,
     /* 338913 */   // GIR_Coverage, 5329,
     /* 338913 */   GIR_EraseRootFromParent_Done,
     /* 338914 */ // Label 6637: @338914
     /* 338914 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(338944), // Rule ID 469 //
     /* 338919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 338922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 338933 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 338933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 338938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338942 */   GIR_RootConstrainSelectedInstOperands,
     /* 338943 */   // GIR_Coverage, 469,
     /* 338943 */   GIR_Done,
     /* 338944 */ // Label 6638: @338944
     /* 338944 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(338974), // Rule ID 475 //
     /* 338949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 338952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 338963 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 338963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 338968 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338972 */   GIR_RootConstrainSelectedInstOperands,
     /* 338973 */   // GIR_Coverage, 475,
     /* 338973 */   GIR_Done,
     /* 338974 */ // Label 6639: @338974
     /* 338974 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(339004), // Rule ID 505 //
     /* 338979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338993 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 338993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 338998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339002 */   GIR_RootConstrainSelectedInstOperands,
     /* 339003 */   // GIR_Coverage, 505,
     /* 339003 */   GIR_Done,
     /* 339004 */ // Label 6640: @339004
     /* 339004 */ GIM_Reject,
     /* 339005 */ // Label 6612: @339005
     /* 339005 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(339142), // Rule ID 5360 //
     /* 339010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339028 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339031 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339035 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339041 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 339048 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 339048 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339051 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 339055 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339075 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339082 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339085 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339089 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339108 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339111 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339114 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339140 */   GIR_RootConstrainSelectedInstOperands,
     /* 339141 */   // GIR_Coverage, 5360,
     /* 339141 */   GIR_EraseRootFromParent_Done,
     /* 339142 */ // Label 6641: @339142
     /* 339142 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(339279), // Rule ID 5361 //
     /* 339147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339165 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339172 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339178 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 339185 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 339185 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339188 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 339192 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339212 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339219 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339222 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339226 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339254 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339277 */   GIR_RootConstrainSelectedInstOperands,
     /* 339278 */   // GIR_Coverage, 5361,
     /* 339278 */   GIR_EraseRootFromParent_Done,
     /* 339279 */ // Label 6642: @339279
     /* 339279 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(339419), // Rule ID 5352 //
     /* 339284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339302 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339305 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339312 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339316 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339318 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 339325 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 339325 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339328 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 339332 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339352 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339359 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339362 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339366 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339385 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339388 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339391 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339394 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339399 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339404 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339417 */   GIR_RootConstrainSelectedInstOperands,
     /* 339418 */   // GIR_Coverage, 5352,
     /* 339418 */   GIR_EraseRootFromParent_Done,
     /* 339419 */ // Label 6643: @339419
     /* 339419 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(339559), // Rule ID 5353 //
     /* 339424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339442 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339445 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339452 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339456 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339458 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 339465 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 339465 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339468 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 339472 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339492 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339499 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339502 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339506 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339525 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339528 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339531 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339534 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339539 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339544 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339557 */   GIR_RootConstrainSelectedInstOperands,
     /* 339558 */   // GIR_Coverage, 5353,
     /* 339558 */   GIR_EraseRootFromParent_Done,
     /* 339559 */ // Label 6644: @339559
     /* 339559 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(339699), // Rule ID 5356 //
     /* 339564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339582 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339585 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339592 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339596 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339598 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 339605 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 339605 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339608 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 339612 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339632 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339639 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339642 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339646 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339665 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339668 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339671 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339674 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339684 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339697 */   GIR_RootConstrainSelectedInstOperands,
     /* 339698 */   // GIR_Coverage, 5356,
     /* 339698 */   GIR_EraseRootFromParent_Done,
     /* 339699 */ // Label 6645: @339699
     /* 339699 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(339839), // Rule ID 5357 //
     /* 339704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339722 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339725 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339732 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339736 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339738 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 339745 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 339745 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339748 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 339752 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339772 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339779 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339782 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339786 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339805 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339808 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339811 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339814 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339819 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339837 */   GIR_RootConstrainSelectedInstOperands,
     /* 339838 */   // GIR_Coverage, 5357,
     /* 339838 */   GIR_EraseRootFromParent_Done,
     /* 339839 */ // Label 6646: @339839
     /* 339839 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(339971), // Rule ID 5362 //
     /* 339844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339862 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339865 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339869 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339875 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 339882 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 339882 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339885 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 339889 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339904 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339911 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339914 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339918 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339937 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339940 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339943 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339969 */   GIR_RootConstrainSelectedInstOperands,
     /* 339970 */   // GIR_Coverage, 5362,
     /* 339970 */   GIR_EraseRootFromParent_Done,
     /* 339971 */ // Label 6647: @339971
     /* 339971 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(340103), // Rule ID 5363 //
     /* 339976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339994 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339997 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340001 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340007 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 340014 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 340014 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340017 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 340021 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340036 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340043 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340046 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340050 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340069 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340072 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340075 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 340078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340088 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340101 */   GIR_RootConstrainSelectedInstOperands,
     /* 340102 */   // GIR_Coverage, 5363,
     /* 340102 */   GIR_EraseRootFromParent_Done,
     /* 340103 */ // Label 6648: @340103
     /* 340103 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(340238), // Rule ID 5354 //
     /* 340108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340126 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340129 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340136 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340142 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 340149 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 340149 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340152 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 340156 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340171 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340204 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340207 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340210 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340218 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340236 */   GIR_RootConstrainSelectedInstOperands,
     /* 340237 */   // GIR_Coverage, 5354,
     /* 340237 */   GIR_EraseRootFromParent_Done,
     /* 340238 */ // Label 6649: @340238
     /* 340238 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(340373), // Rule ID 5355 //
     /* 340243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340261 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340264 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340271 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340277 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 340284 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 340284 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340287 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 340291 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340306 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340313 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340316 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340320 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340339 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340342 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340345 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340348 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340358 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340371 */   GIR_RootConstrainSelectedInstOperands,
     /* 340372 */   // GIR_Coverage, 5355,
     /* 340372 */   GIR_EraseRootFromParent_Done,
     /* 340373 */ // Label 6650: @340373
     /* 340373 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(340508), // Rule ID 5358 //
     /* 340378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340396 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340399 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340406 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340410 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340412 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 340419 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 340419 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340422 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 340426 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340441 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340448 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340451 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340455 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340474 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340477 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340480 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340483 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340488 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340493 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340506 */   GIR_RootConstrainSelectedInstOperands,
     /* 340507 */   // GIR_Coverage, 5358,
     /* 340507 */   GIR_EraseRootFromParent_Done,
     /* 340508 */ // Label 6651: @340508
     /* 340508 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(340643), // Rule ID 5359 //
     /* 340513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340523 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340527 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340531 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340534 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340541 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340545 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340547 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 340554 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 340554 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340557 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 340561 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340576 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340583 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340586 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340590 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340609 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340612 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340615 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340618 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340623 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340641 */   GIR_RootConstrainSelectedInstOperands,
     /* 340642 */   // GIR_Coverage, 5359,
     /* 340642 */   GIR_EraseRootFromParent_Done,
     /* 340643 */ // Label 6652: @340643
     /* 340643 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(340723), // Rule ID 4790 //
     /* 340648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 340651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340666 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340670 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340674 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340679 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 340683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340685 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 340685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340697 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 340703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 340716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340721 */   GIR_RootConstrainSelectedInstOperands,
     /* 340722 */   // GIR_Coverage, 4790,
     /* 340722 */   GIR_EraseRootFromParent_Done,
     /* 340723 */ // Label 6653: @340723
     /* 340723 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(340803), // Rule ID 5341 //
     /* 340728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340746 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340759 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 340763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340765 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 340765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340777 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 340783 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340801 */   GIR_RootConstrainSelectedInstOperands,
     /* 340802 */   // GIR_Coverage, 5341,
     /* 340802 */   GIR_EraseRootFromParent_Done,
     /* 340803 */ // Label 6654: @340803
     /* 340803 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(340860), // Rule ID 5325 //
     /* 340808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 340826 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340832 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 340832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 340839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340844 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340858 */   GIR_RootConstrainSelectedInstOperands,
     /* 340859 */   // GIR_Coverage, 5325,
     /* 340859 */   GIR_EraseRootFromParent_Done,
     /* 340860 */ // Label 6655: @340860
     /* 340860 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(340890), // Rule ID 471 //
     /* 340865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340879 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 340879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 340884 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340888 */   GIR_RootConstrainSelectedInstOperands,
     /* 340889 */   // GIR_Coverage, 471,
     /* 340889 */   GIR_Done,
     /* 340890 */ // Label 6656: @340890
     /* 340890 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(340920), // Rule ID 477 //
     /* 340895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340909 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 340909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 340914 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340918 */   GIR_RootConstrainSelectedInstOperands,
     /* 340919 */   // GIR_Coverage, 477,
     /* 340919 */   GIR_Done,
     /* 340920 */ // Label 6657: @340920
     /* 340920 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(340950), // Rule ID 501 //
     /* 340925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 340928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340939 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 340939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 340944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340948 */   GIR_RootConstrainSelectedInstOperands,
     /* 340949 */   // GIR_Coverage, 501,
     /* 340949 */   GIR_Done,
     /* 340950 */ // Label 6658: @340950
     /* 340950 */ GIM_Reject,
     /* 340951 */ // Label 6613: @340951
     /* 340951 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(340981), // Rule ID 1078 //
     /* 340956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340970 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 340970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 340975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340979 */   GIR_RootConstrainSelectedInstOperands,
     /* 340980 */   // GIR_Coverage, 1078,
     /* 340980 */   GIR_Done,
     /* 340981 */ // Label 6659: @340981
     /* 340981 */ GIM_Reject,
     /* 340982 */ // Label 6614: @340982
     /* 340982 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(341012), // Rule ID 1082 //
     /* 340987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341001 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 341001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 341006 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341010 */   GIR_RootConstrainSelectedInstOperands,
     /* 341011 */   // GIR_Coverage, 1082,
     /* 341011 */   GIR_Done,
     /* 341012 */ // Label 6660: @341012
     /* 341012 */ GIM_Reject,
     /* 341013 */ // Label 6615: @341013
     /* 341013 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(341043), // Rule ID 1074 //
     /* 341018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341032 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 341032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 341037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341041 */   GIR_RootConstrainSelectedInstOperands,
     /* 341042 */   // GIR_Coverage, 1074,
     /* 341042 */   GIR_Done,
     /* 341043 */ // Label 6661: @341043
     /* 341043 */ GIM_Reject,
     /* 341044 */ // Label 6616: @341044
     /* 341044 */ GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(341074), // Rule ID 1080 //
     /* 341049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341063 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 341063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 341068 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341072 */   GIR_RootConstrainSelectedInstOperands,
     /* 341073 */   // GIR_Coverage, 1080,
     /* 341073 */   GIR_Done,
     /* 341074 */ // Label 6662: @341074
     /* 341074 */ GIM_Reject,
     /* 341075 */ // Label 6617: @341075
     /* 341075 */ GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(341105), // Rule ID 1076 //
     /* 341080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341094 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 341094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 341099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341103 */   GIR_RootConstrainSelectedInstOperands,
     /* 341104 */   // GIR_Coverage, 1076,
     /* 341104 */   GIR_Done,
     /* 341105 */ // Label 6663: @341105
     /* 341105 */ GIM_Reject,
     /* 341106 */ // Label 6618: @341106
     /* 341106 */ GIM_Reject,
     /* 341107 */ // Label 71: @341107
     /* 341107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6671*/ GIMT_Encode4(341426),
     /* 341118 */ /*GILLT_s32*//*Label 6664*/ GIMT_Encode4(341154),
     /* 341122 */ /*GILLT_s64*//*Label 6665*/ GIMT_Encode4(341227), GIMT_Encode4(0),
     /* 341130 */ /*GILLT_v2s32*//*Label 6666*/ GIMT_Encode4(341300),
     /* 341134 */ /*GILLT_v2s64*//*Label 6667*/ GIMT_Encode4(341324),
     /* 341138 */ /*GILLT_v4s16*//*Label 6668*/ GIMT_Encode4(341348),
     /* 341142 */ /*GILLT_v4s32*//*Label 6669*/ GIMT_Encode4(341375), GIMT_Encode4(0),
     /* 341150 */ /*GILLT_v8s16*//*Label 6670*/ GIMT_Encode4(341399),
     /* 341154 */ // Label 6664: @341154
     /* 341154 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(341180), // Rule ID 4623 //
     /* 341159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341169 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 341169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 341174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341178 */   GIR_RootConstrainSelectedInstOperands,
     /* 341179 */   // GIR_Coverage, 4623,
     /* 341179 */   GIR_Done,
     /* 341180 */ // Label 6672: @341180
     /* 341180 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(341203), // Rule ID 4625 //
     /* 341185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341192 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 341192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 341197 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341201 */   GIR_RootConstrainSelectedInstOperands,
     /* 341202 */   // GIR_Coverage, 4625,
     /* 341202 */   GIR_Done,
     /* 341203 */ // Label 6673: @341203
     /* 341203 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(341226), // Rule ID 4627 //
     /* 341208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341215 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 341215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 341220 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341224 */   GIR_RootConstrainSelectedInstOperands,
     /* 341225 */   // GIR_Coverage, 4627,
     /* 341225 */   GIR_Done,
     /* 341226 */ // Label 6674: @341226
     /* 341226 */ GIM_Reject,
     /* 341227 */ // Label 6665: @341227
     /* 341227 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(341253), // Rule ID 4624 //
     /* 341232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341242 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 341242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 341247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341251 */   GIR_RootConstrainSelectedInstOperands,
     /* 341252 */   // GIR_Coverage, 4624,
     /* 341252 */   GIR_Done,
     /* 341253 */ // Label 6675: @341253
     /* 341253 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(341276), // Rule ID 4626 //
     /* 341258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341265 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 341265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 341270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341274 */   GIR_RootConstrainSelectedInstOperands,
     /* 341275 */   // GIR_Coverage, 4626,
     /* 341275 */   GIR_Done,
     /* 341276 */ // Label 6676: @341276
     /* 341276 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(341299), // Rule ID 4628 //
     /* 341281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341288 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 341288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 341293 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341297 */   GIR_RootConstrainSelectedInstOperands,
     /* 341298 */   // GIR_Coverage, 4628,
     /* 341298 */   GIR_Done,
     /* 341299 */ // Label 6677: @341299
     /* 341299 */ GIM_Reject,
     /* 341300 */ // Label 6666: @341300
     /* 341300 */ GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(341323), // Rule ID 4964 //
     /* 341305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341312 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 341312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 341317 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341321 */   GIR_RootConstrainSelectedInstOperands,
     /* 341322 */   // GIR_Coverage, 4964,
     /* 341322 */   GIR_Done,
     /* 341323 */ // Label 6678: @341323
     /* 341323 */ GIM_Reject,
     /* 341324 */ // Label 6667: @341324
     /* 341324 */ GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(341347), // Rule ID 4966 //
     /* 341329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341336 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 341336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 341341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341345 */   GIR_RootConstrainSelectedInstOperands,
     /* 341346 */   // GIR_Coverage, 4966,
     /* 341346 */   GIR_Done,
     /* 341347 */ // Label 6679: @341347
     /* 341347 */ GIM_Reject,
     /* 341348 */ // Label 6668: @341348
     /* 341348 */ GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(341374), // Rule ID 4959 //
     /* 341353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341363 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 341363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 341368 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341372 */   GIR_RootConstrainSelectedInstOperands,
     /* 341373 */   // GIR_Coverage, 4959,
     /* 341373 */   GIR_Done,
     /* 341374 */ // Label 6680: @341374
     /* 341374 */ GIM_Reject,
     /* 341375 */ // Label 6669: @341375
     /* 341375 */ GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(341398), // Rule ID 4965 //
     /* 341380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341387 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 341387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 341392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341396 */   GIR_RootConstrainSelectedInstOperands,
     /* 341397 */   // GIR_Coverage, 4965,
     /* 341397 */   GIR_Done,
     /* 341398 */ // Label 6681: @341398
     /* 341398 */ GIM_Reject,
     /* 341399 */ // Label 6670: @341399
     /* 341399 */ GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(341425), // Rule ID 4960 //
     /* 341404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341414 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 341414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 341419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341423 */   GIR_RootConstrainSelectedInstOperands,
     /* 341424 */   // GIR_Coverage, 4960,
     /* 341424 */   GIR_Done,
     /* 341425 */ // Label 6682: @341425
     /* 341425 */ GIM_Reject,
     /* 341426 */ // Label 6671: @341426
     /* 341426 */ GIM_Reject,
     /* 341427 */ // Label 72: @341427
     /* 341427 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6690*/ GIMT_Encode4(341746),
     /* 341438 */ /*GILLT_s32*//*Label 6683*/ GIMT_Encode4(341474),
     /* 341442 */ /*GILLT_s64*//*Label 6684*/ GIMT_Encode4(341547), GIMT_Encode4(0),
     /* 341450 */ /*GILLT_v2s32*//*Label 6685*/ GIMT_Encode4(341620),
     /* 341454 */ /*GILLT_v2s64*//*Label 6686*/ GIMT_Encode4(341644),
     /* 341458 */ /*GILLT_v4s16*//*Label 6687*/ GIMT_Encode4(341668),
     /* 341462 */ /*GILLT_v4s32*//*Label 6688*/ GIMT_Encode4(341695), GIMT_Encode4(0),
     /* 341470 */ /*GILLT_v8s16*//*Label 6689*/ GIMT_Encode4(341719),
     /* 341474 */ // Label 6683: @341474
     /* 341474 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(341500), // Rule ID 4647 //
     /* 341479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341489 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 341489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 341494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341498 */   GIR_RootConstrainSelectedInstOperands,
     /* 341499 */   // GIR_Coverage, 4647,
     /* 341499 */   GIR_Done,
     /* 341500 */ // Label 6691: @341500
     /* 341500 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(341523), // Rule ID 4649 //
     /* 341505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341512 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 341512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 341517 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341521 */   GIR_RootConstrainSelectedInstOperands,
     /* 341522 */   // GIR_Coverage, 4649,
     /* 341522 */   GIR_Done,
     /* 341523 */ // Label 6692: @341523
     /* 341523 */ GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(341546), // Rule ID 4651 //
     /* 341528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341535 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 341535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 341540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341544 */   GIR_RootConstrainSelectedInstOperands,
     /* 341545 */   // GIR_Coverage, 4651,
     /* 341545 */   GIR_Done,
     /* 341546 */ // Label 6693: @341546
     /* 341546 */ GIM_Reject,
     /* 341547 */ // Label 6684: @341547
     /* 341547 */ GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(341573), // Rule ID 4648 //
     /* 341552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341562 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 341562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 341567 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341571 */   GIR_RootConstrainSelectedInstOperands,
     /* 341572 */   // GIR_Coverage, 4648,
     /* 341572 */   GIR_Done,
     /* 341573 */ // Label 6694: @341573
     /* 341573 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(341596), // Rule ID 4650 //
     /* 341578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341585 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 341585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 341590 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341594 */   GIR_RootConstrainSelectedInstOperands,
     /* 341595 */   // GIR_Coverage, 4650,
     /* 341595 */   GIR_Done,
     /* 341596 */ // Label 6695: @341596
     /* 341596 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(341619), // Rule ID 4652 //
     /* 341601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341608 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 341608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 341613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341617 */   GIR_RootConstrainSelectedInstOperands,
     /* 341618 */   // GIR_Coverage, 4652,
     /* 341618 */   GIR_Done,
     /* 341619 */ // Label 6696: @341619
     /* 341619 */ GIM_Reject,
     /* 341620 */ // Label 6685: @341620
     /* 341620 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(341643), // Rule ID 4974 //
     /* 341625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341632 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 341632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 341637 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341641 */   GIR_RootConstrainSelectedInstOperands,
     /* 341642 */   // GIR_Coverage, 4974,
     /* 341642 */   GIR_Done,
     /* 341643 */ // Label 6697: @341643
     /* 341643 */ GIM_Reject,
     /* 341644 */ // Label 6686: @341644
     /* 341644 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(341667), // Rule ID 4976 //
     /* 341649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341656 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 341656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 341661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341665 */   GIR_RootConstrainSelectedInstOperands,
     /* 341666 */   // GIR_Coverage, 4976,
     /* 341666 */   GIR_Done,
     /* 341667 */ // Label 6698: @341667
     /* 341667 */ GIM_Reject,
     /* 341668 */ // Label 6687: @341668
     /* 341668 */ GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(341694), // Rule ID 4969 //
     /* 341673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341683 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 341683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 341688 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341692 */   GIR_RootConstrainSelectedInstOperands,
     /* 341693 */   // GIR_Coverage, 4969,
     /* 341693 */   GIR_Done,
     /* 341694 */ // Label 6699: @341694
     /* 341694 */ GIM_Reject,
     /* 341695 */ // Label 6688: @341695
     /* 341695 */ GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(341718), // Rule ID 4975 //
     /* 341700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341707 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 341707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 341712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341716 */   GIR_RootConstrainSelectedInstOperands,
     /* 341717 */   // GIR_Coverage, 4975,
     /* 341717 */   GIR_Done,
     /* 341718 */ // Label 6700: @341718
     /* 341718 */ GIM_Reject,
     /* 341719 */ // Label 6689: @341719
     /* 341719 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(341745), // Rule ID 4970 //
     /* 341724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341734 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 341734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 341739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341743 */   GIR_RootConstrainSelectedInstOperands,
     /* 341744 */   // GIR_Coverage, 4970,
     /* 341744 */   GIR_Done,
     /* 341745 */ // Label 6701: @341745
     /* 341745 */ GIM_Reject,
     /* 341746 */ // Label 6690: @341746
     /* 341746 */ GIM_Reject,
     /* 341747 */ // Label 73: @341747
     /* 341747 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6710*/ GIMT_Encode4(342603),
     /* 341758 */ /*GILLT_s16*//*Label 6702*/ GIMT_Encode4(341798),
     /* 341762 */ /*GILLT_s32*//*Label 6703*/ GIMT_Encode4(342017),
     /* 341766 */ /*GILLT_s64*//*Label 6704*/ GIMT_Encode4(342091), GIMT_Encode4(0),
     /* 341774 */ /*GILLT_v2s32*//*Label 6705*/ GIMT_Encode4(342165),
     /* 341778 */ /*GILLT_v2s64*//*Label 6706*/ GIMT_Encode4(342239),
     /* 341782 */ /*GILLT_v4s16*//*Label 6707*/ GIMT_Encode4(342313),
     /* 341786 */ /*GILLT_v4s32*//*Label 6708*/ GIMT_Encode4(342421), GIMT_Encode4(0),
     /* 341794 */ /*GILLT_v8s16*//*Label 6709*/ GIMT_Encode4(342495),
     /* 341798 */ // Label 6702: @341798
     /* 341798 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(342016),
     /* 341803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341810 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(341851), // Rule ID 5227 //
     /* 341815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341836 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 341836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 341839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341849 */     GIR_RootConstrainSelectedInstOperands,
     /* 341850 */     // GIR_Coverage, 5227,
     /* 341850 */     GIR_EraseRootFromParent_Done,
     /* 341851 */   // Label 6712: @341851
     /* 341851 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(341870), // Rule ID 521 //
     /* 341856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341863 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 341863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 341868 */     GIR_RootConstrainSelectedInstOperands,
     /* 341869 */     // GIR_Coverage, 521,
     /* 341869 */     GIR_Done,
     /* 341870 */   // Label 6713: @341870
     /* 341870 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(342015), // Rule ID 6413 //
     /* 341875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341879 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 341879 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 341882 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341886 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 341893 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 341896 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341900 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341905 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 341908 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 341912 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 341915 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341920 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341925 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341930 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 341933 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341937 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341942 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 341945 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 341953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 341957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341962 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 341965 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 341970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341997 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 342004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342014 */     // GIR_Coverage, 6413,
     /* 342014 */     GIR_EraseRootFromParent_Done,
     /* 342015 */   // Label 6714: @342015
     /* 342015 */   GIM_Reject,
     /* 342016 */ // Label 6711: @342016
     /* 342016 */ GIM_Reject,
     /* 342017 */ // Label 6703: @342017
     /* 342017 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(342090),
     /* 342022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342029 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(342070), // Rule ID 5228 //
     /* 342034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 342049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 342053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342055 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 342055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 342058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342068 */     GIR_RootConstrainSelectedInstOperands,
     /* 342069 */     // GIR_Coverage, 5228,
     /* 342069 */     GIR_EraseRootFromParent_Done,
     /* 342070 */   // Label 6716: @342070
     /* 342070 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(342089), // Rule ID 522 //
     /* 342075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342082 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 342082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 342087 */     GIR_RootConstrainSelectedInstOperands,
     /* 342088 */     // GIR_Coverage, 522,
     /* 342088 */     GIR_Done,
     /* 342089 */   // Label 6717: @342089
     /* 342089 */   GIM_Reject,
     /* 342090 */ // Label 6715: @342090
     /* 342090 */ GIM_Reject,
     /* 342091 */ // Label 6704: @342091
     /* 342091 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(342164),
     /* 342096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342103 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(342144), // Rule ID 5229 //
     /* 342108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 342123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342129 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 342129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 342132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342142 */     GIR_RootConstrainSelectedInstOperands,
     /* 342143 */     // GIR_Coverage, 5229,
     /* 342143 */     GIR_EraseRootFromParent_Done,
     /* 342144 */   // Label 6719: @342144
     /* 342144 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(342163), // Rule ID 523 //
     /* 342149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342156 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 342156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 342161 */     GIR_RootConstrainSelectedInstOperands,
     /* 342162 */     // GIR_Coverage, 523,
     /* 342162 */     GIR_Done,
     /* 342163 */   // Label 6720: @342163
     /* 342163 */   GIM_Reject,
     /* 342164 */ // Label 6718: @342164
     /* 342164 */ GIM_Reject,
     /* 342165 */ // Label 6705: @342165
     /* 342165 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(342238),
     /* 342170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342177 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(342218), // Rule ID 5041 //
     /* 342182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342203 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 342203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 342206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342216 */     GIR_RootConstrainSelectedInstOperands,
     /* 342217 */     // GIR_Coverage, 5041,
     /* 342217 */     GIR_EraseRootFromParent_Done,
     /* 342218 */   // Label 6722: @342218
     /* 342218 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(342237), // Rule ID 768 //
     /* 342223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342230 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 342230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 342235 */     GIR_RootConstrainSelectedInstOperands,
     /* 342236 */     // GIR_Coverage, 768,
     /* 342236 */     GIR_Done,
     /* 342237 */   // Label 6723: @342237
     /* 342237 */   GIM_Reject,
     /* 342238 */ // Label 6721: @342238
     /* 342238 */ GIM_Reject,
     /* 342239 */ // Label 6706: @342239
     /* 342239 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(342312),
     /* 342244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342251 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(342292), // Rule ID 5043 //
     /* 342256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342277 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 342277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 342280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342290 */     GIR_RootConstrainSelectedInstOperands,
     /* 342291 */     // GIR_Coverage, 5043,
     /* 342291 */     GIR_EraseRootFromParent_Done,
     /* 342292 */   // Label 6725: @342292
     /* 342292 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(342311), // Rule ID 770 //
     /* 342297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342304 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 342304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 342309 */     GIR_RootConstrainSelectedInstOperands,
     /* 342310 */     // GIR_Coverage, 770,
     /* 342310 */     GIR_Done,
     /* 342311 */   // Label 6726: @342311
     /* 342311 */   GIM_Reject,
     /* 342312 */ // Label 6724: @342312
     /* 342312 */ GIM_Reject,
     /* 342313 */ // Label 6707: @342313
     /* 342313 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(342420),
     /* 342318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342325 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(342366), // Rule ID 5044 //
     /* 342330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342351 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 342351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 342354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342364 */     GIR_RootConstrainSelectedInstOperands,
     /* 342365 */     // GIR_Coverage, 5044,
     /* 342365 */     GIR_EraseRootFromParent_Done,
     /* 342366 */   // Label 6728: @342366
     /* 342366 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(342385), // Rule ID 766 //
     /* 342371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342378 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 342378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 342383 */     GIR_RootConstrainSelectedInstOperands,
     /* 342384 */     // GIR_Coverage, 766,
     /* 342384 */     GIR_Done,
     /* 342385 */   // Label 6729: @342385
     /* 342385 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(342419), // Rule ID 6415 //
     /* 342390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342397 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 342397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 342400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342404 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 342414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 342417 */     GIR_RootConstrainSelectedInstOperands,
     /* 342418 */     // GIR_Coverage, 6415,
     /* 342418 */     GIR_EraseRootFromParent_Done,
     /* 342419 */   // Label 6730: @342419
     /* 342419 */   GIM_Reject,
     /* 342420 */ // Label 6727: @342420
     /* 342420 */ GIM_Reject,
     /* 342421 */ // Label 6708: @342421
     /* 342421 */ GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(342494),
     /* 342426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342433 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(342474), // Rule ID 5042 //
     /* 342438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342459 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 342459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 342462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342472 */     GIR_RootConstrainSelectedInstOperands,
     /* 342473 */     // GIR_Coverage, 5042,
     /* 342473 */     GIR_EraseRootFromParent_Done,
     /* 342474 */   // Label 6732: @342474
     /* 342474 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(342493), // Rule ID 769 //
     /* 342479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342486 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 342486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 342491 */     GIR_RootConstrainSelectedInstOperands,
     /* 342492 */     // GIR_Coverage, 769,
     /* 342492 */     GIR_Done,
     /* 342493 */   // Label 6733: @342493
     /* 342493 */   GIM_Reject,
     /* 342494 */ // Label 6731: @342494
     /* 342494 */ GIM_Reject,
     /* 342495 */ // Label 6709: @342495
     /* 342495 */ GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(342602),
     /* 342500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342507 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(342548), // Rule ID 5045 //
     /* 342512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342533 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 342533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 342536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342546 */     GIR_RootConstrainSelectedInstOperands,
     /* 342547 */     // GIR_Coverage, 5045,
     /* 342547 */     GIR_EraseRootFromParent_Done,
     /* 342548 */   // Label 6735: @342548
     /* 342548 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(342567), // Rule ID 767 //
     /* 342553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342560 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 342560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 342565 */     GIR_RootConstrainSelectedInstOperands,
     /* 342566 */     // GIR_Coverage, 767,
     /* 342566 */     GIR_Done,
     /* 342567 */   // Label 6736: @342567
     /* 342567 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(342601), // Rule ID 6416 //
     /* 342572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342579 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 342579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 342582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342586 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 342596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 342599 */     GIR_RootConstrainSelectedInstOperands,
     /* 342600 */     // GIR_Coverage, 6416,
     /* 342600 */     GIR_EraseRootFromParent_Done,
     /* 342601 */   // Label 6737: @342601
     /* 342601 */   GIM_Reject,
     /* 342602 */ // Label 6734: @342602
     /* 342602 */ GIM_Reject,
     /* 342603 */ // Label 6710: @342603
     /* 342603 */ GIM_Reject,
     /* 342604 */ // Label 74: @342604
     /* 342604 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6746*/ GIMT_Encode4(342885),
     /* 342615 */ /*GILLT_s16*//*Label 6738*/ GIMT_Encode4(342655),
     /* 342619 */ /*GILLT_s32*//*Label 6739*/ GIMT_Encode4(342682),
     /* 342623 */ /*GILLT_s64*//*Label 6740*/ GIMT_Encode4(342706), GIMT_Encode4(0),
     /* 342631 */ /*GILLT_v2s32*//*Label 6741*/ GIMT_Encode4(342730),
     /* 342635 */ /*GILLT_v2s64*//*Label 6742*/ GIMT_Encode4(342761),
     /* 342639 */ /*GILLT_v4s16*//*Label 6743*/ GIMT_Encode4(342792),
     /* 342643 */ /*GILLT_v4s32*//*Label 6744*/ GIMT_Encode4(342823), GIMT_Encode4(0),
     /* 342651 */ /*GILLT_v8s16*//*Label 6745*/ GIMT_Encode4(342854),
     /* 342655 */ // Label 6738: @342655
     /* 342655 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(342681), // Rule ID 4863 //
     /* 342660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342670 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 342670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342675 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342677 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342679 */   GIR_RootConstrainSelectedInstOperands,
     /* 342680 */   // GIR_Coverage, 4863,
     /* 342680 */   GIR_EraseRootFromParent_Done,
     /* 342681 */ // Label 6747: @342681
     /* 342681 */ GIM_Reject,
     /* 342682 */ // Label 6739: @342682
     /* 342682 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(342705), // Rule ID 4860 //
     /* 342687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342694 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 342694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342699 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342701 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342703 */   GIR_RootConstrainSelectedInstOperands,
     /* 342704 */   // GIR_Coverage, 4860,
     /* 342704 */   GIR_EraseRootFromParent_Done,
     /* 342705 */ // Label 6748: @342705
     /* 342705 */ GIM_Reject,
     /* 342706 */ // Label 6740: @342706
     /* 342706 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(342729), // Rule ID 4857 //
     /* 342711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342718 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 342718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342723 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342725 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342727 */   GIR_RootConstrainSelectedInstOperands,
     /* 342728 */   // GIR_Coverage, 4857,
     /* 342728 */   GIR_EraseRootFromParent_Done,
     /* 342729 */ // Label 6749: @342729
     /* 342729 */ GIM_Reject,
     /* 342730 */ // Label 6741: @342730
     /* 342730 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(342760), // Rule ID 5054 //
     /* 342735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342749 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 342749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342754 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342758 */   GIR_RootConstrainSelectedInstOperands,
     /* 342759 */   // GIR_Coverage, 5054,
     /* 342759 */   GIR_EraseRootFromParent_Done,
     /* 342760 */ // Label 6750: @342760
     /* 342760 */ GIM_Reject,
     /* 342761 */ // Label 6742: @342761
     /* 342761 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(342791), // Rule ID 5048 //
     /* 342766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342780 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 342780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 342783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342785 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342787 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342789 */   GIR_RootConstrainSelectedInstOperands,
     /* 342790 */   // GIR_Coverage, 5048,
     /* 342790 */   GIR_EraseRootFromParent_Done,
     /* 342791 */ // Label 6751: @342791
     /* 342791 */ GIM_Reject,
     /* 342792 */ // Label 6743: @342792
     /* 342792 */ GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(342822), // Rule ID 5060 //
     /* 342797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342811 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 342811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342816 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342818 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342820 */   GIR_RootConstrainSelectedInstOperands,
     /* 342821 */   // GIR_Coverage, 5060,
     /* 342821 */   GIR_EraseRootFromParent_Done,
     /* 342822 */ // Label 6752: @342822
     /* 342822 */ GIM_Reject,
     /* 342823 */ // Label 6744: @342823
     /* 342823 */ GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(342853), // Rule ID 5051 //
     /* 342828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342842 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 342842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342847 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342849 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342851 */   GIR_RootConstrainSelectedInstOperands,
     /* 342852 */   // GIR_Coverage, 5051,
     /* 342852 */   GIR_EraseRootFromParent_Done,
     /* 342853 */ // Label 6753: @342853
     /* 342853 */ GIM_Reject,
     /* 342854 */ // Label 6745: @342854
     /* 342854 */ GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(342884), // Rule ID 5057 //
     /* 342859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342873 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 342873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342878 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342880 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342882 */   GIR_RootConstrainSelectedInstOperands,
     /* 342883 */   // GIR_Coverage, 5057,
     /* 342883 */   GIR_EraseRootFromParent_Done,
     /* 342884 */ // Label 6754: @342884
     /* 342884 */ GIM_Reject,
     /* 342885 */ // Label 6746: @342885
     /* 342885 */ GIM_Reject,
     /* 342886 */ // Label 75: @342886
     /* 342886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6763*/ GIMT_Encode4(343263),
     /* 342897 */ /*GILLT_s16*//*Label 6755*/ GIMT_Encode4(342937),
     /* 342901 */ /*GILLT_s32*//*Label 6756*/ GIMT_Encode4(342975),
     /* 342905 */ /*GILLT_s64*//*Label 6757*/ GIMT_Encode4(343013), GIMT_Encode4(0),
     /* 342913 */ /*GILLT_v2s32*//*Label 6758*/ GIMT_Encode4(343073),
     /* 342917 */ /*GILLT_v2s64*//*Label 6759*/ GIMT_Encode4(343111),
     /* 342921 */ /*GILLT_v4s16*//*Label 6760*/ GIMT_Encode4(343149),
     /* 342925 */ /*GILLT_v4s32*//*Label 6761*/ GIMT_Encode4(343187), GIMT_Encode4(0),
     /* 342933 */ /*GILLT_v8s16*//*Label 6762*/ GIMT_Encode4(343225),
     /* 342937 */ // Label 6755: @342937
     /* 342937 */ GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(342974), // Rule ID 608 //
     /* 342942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342963 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 342963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342968 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342972 */   GIR_RootConstrainSelectedInstOperands,
     /* 342973 */   // GIR_Coverage, 608,
     /* 342973 */   GIR_Done,
     /* 342974 */ // Label 6764: @342974
     /* 342974 */ GIM_Reject,
     /* 342975 */ // Label 6756: @342975
     /* 342975 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(343012), // Rule ID 610 //
     /* 342980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343001 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 343006 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343010 */   GIR_RootConstrainSelectedInstOperands,
     /* 343011 */   // GIR_Coverage, 610,
     /* 343011 */   GIR_Done,
     /* 343012 */ // Label 6765: @343012
     /* 343012 */ GIM_Reject,
     /* 343013 */ // Label 6757: @343013
     /* 343013 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(343072),
     /* 343018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343036 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(343055), // Rule ID 612 //
     /* 343041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343044 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343049 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343053 */     GIR_RootConstrainSelectedInstOperands,
     /* 343054 */     // GIR_Coverage, 612,
     /* 343054 */     GIR_Done,
     /* 343055 */   // Label 6767: @343055
     /* 343055 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(343071), // Rule ID 4854 //
     /* 343060 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343065 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343069 */     GIR_RootConstrainSelectedInstOperands,
     /* 343070 */     // GIR_Coverage, 4854,
     /* 343070 */     GIR_Done,
     /* 343071 */   // Label 6768: @343071
     /* 343071 */   GIM_Reject,
     /* 343072 */ // Label 6766: @343072
     /* 343072 */ GIM_Reject,
     /* 343073 */ // Label 6758: @343073
     /* 343073 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(343110), // Rule ID 1273 //
     /* 343078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343099 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 343104 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343108 */   GIR_RootConstrainSelectedInstOperands,
     /* 343109 */   // GIR_Coverage, 1273,
     /* 343109 */   GIR_Done,
     /* 343110 */ // Label 6769: @343110
     /* 343110 */ GIM_Reject,
     /* 343111 */ // Label 6759: @343111
     /* 343111 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(343148), // Rule ID 1277 //
     /* 343116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343137 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343146 */   GIR_RootConstrainSelectedInstOperands,
     /* 343147 */   // GIR_Coverage, 1277,
     /* 343147 */   GIR_Done,
     /* 343148 */ // Label 6770: @343148
     /* 343148 */ GIM_Reject,
     /* 343149 */ // Label 6760: @343149
     /* 343149 */ GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(343186), // Rule ID 1269 //
     /* 343154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343175 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343184 */   GIR_RootConstrainSelectedInstOperands,
     /* 343185 */   // GIR_Coverage, 1269,
     /* 343185 */   GIR_Done,
     /* 343186 */ // Label 6771: @343186
     /* 343186 */ GIM_Reject,
     /* 343187 */ // Label 6761: @343187
     /* 343187 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(343224), // Rule ID 1275 //
     /* 343192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343213 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343218 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343222 */   GIR_RootConstrainSelectedInstOperands,
     /* 343223 */   // GIR_Coverage, 1275,
     /* 343223 */   GIR_Done,
     /* 343224 */ // Label 6772: @343224
     /* 343224 */ GIM_Reject,
     /* 343225 */ // Label 6762: @343225
     /* 343225 */ GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(343262), // Rule ID 1271 //
     /* 343230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343251 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343256 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343260 */   GIR_RootConstrainSelectedInstOperands,
     /* 343261 */   // GIR_Coverage, 1271,
     /* 343261 */   GIR_Done,
     /* 343262 */ // Label 6773: @343262
     /* 343262 */ GIM_Reject,
     /* 343263 */ // Label 6763: @343263
     /* 343263 */ GIM_Reject,
     /* 343264 */ // Label 76: @343264
     /* 343264 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6782*/ GIMT_Encode4(343641),
     /* 343275 */ /*GILLT_s16*//*Label 6774*/ GIMT_Encode4(343315),
     /* 343279 */ /*GILLT_s32*//*Label 6775*/ GIMT_Encode4(343353),
     /* 343283 */ /*GILLT_s64*//*Label 6776*/ GIMT_Encode4(343391), GIMT_Encode4(0),
     /* 343291 */ /*GILLT_v2s32*//*Label 6777*/ GIMT_Encode4(343451),
     /* 343295 */ /*GILLT_v2s64*//*Label 6778*/ GIMT_Encode4(343489),
     /* 343299 */ /*GILLT_v4s16*//*Label 6779*/ GIMT_Encode4(343527),
     /* 343303 */ /*GILLT_v4s32*//*Label 6780*/ GIMT_Encode4(343565), GIMT_Encode4(0),
     /* 343311 */ /*GILLT_v8s16*//*Label 6781*/ GIMT_Encode4(343603),
     /* 343315 */ // Label 6774: @343315
     /* 343315 */ GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(343352), // Rule ID 596 //
     /* 343320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343341 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 343346 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343350 */   GIR_RootConstrainSelectedInstOperands,
     /* 343351 */   // GIR_Coverage, 596,
     /* 343351 */   GIR_Done,
     /* 343352 */ // Label 6783: @343352
     /* 343352 */ GIM_Reject,
     /* 343353 */ // Label 6775: @343353
     /* 343353 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(343390), // Rule ID 598 //
     /* 343358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343379 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 343384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343388 */   GIR_RootConstrainSelectedInstOperands,
     /* 343389 */   // GIR_Coverage, 598,
     /* 343389 */   GIR_Done,
     /* 343390 */ // Label 6784: @343390
     /* 343390 */ GIM_Reject,
     /* 343391 */ // Label 6776: @343391
     /* 343391 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(343450),
     /* 343396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343414 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(343433), // Rule ID 600 //
     /* 343419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343422 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343431 */     GIR_RootConstrainSelectedInstOperands,
     /* 343432 */     // GIR_Coverage, 600,
     /* 343432 */     GIR_Done,
     /* 343433 */   // Label 6786: @343433
     /* 343433 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(343449), // Rule ID 4853 //
     /* 343438 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343443 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343447 */     GIR_RootConstrainSelectedInstOperands,
     /* 343448 */     // GIR_Coverage, 4853,
     /* 343448 */     GIR_Done,
     /* 343449 */   // Label 6787: @343449
     /* 343449 */   GIM_Reject,
     /* 343450 */ // Label 6785: @343450
     /* 343450 */ GIM_Reject,
     /* 343451 */ // Label 6777: @343451
     /* 343451 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(343488), // Rule ID 1243 //
     /* 343456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343477 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 343482 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343486 */   GIR_RootConstrainSelectedInstOperands,
     /* 343487 */   // GIR_Coverage, 1243,
     /* 343487 */   GIR_Done,
     /* 343488 */ // Label 6788: @343488
     /* 343488 */ GIM_Reject,
     /* 343489 */ // Label 6778: @343489
     /* 343489 */ GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(343526), // Rule ID 1247 //
     /* 343494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343515 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 343520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343524 */   GIR_RootConstrainSelectedInstOperands,
     /* 343525 */   // GIR_Coverage, 1247,
     /* 343525 */   GIR_Done,
     /* 343526 */ // Label 6789: @343526
     /* 343526 */ GIM_Reject,
     /* 343527 */ // Label 6779: @343527
     /* 343527 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(343564), // Rule ID 1239 //
     /* 343532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343553 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 343558 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343562 */   GIR_RootConstrainSelectedInstOperands,
     /* 343563 */   // GIR_Coverage, 1239,
     /* 343563 */   GIR_Done,
     /* 343564 */ // Label 6790: @343564
     /* 343564 */ GIM_Reject,
     /* 343565 */ // Label 6780: @343565
     /* 343565 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(343602), // Rule ID 1245 //
     /* 343570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343591 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 343596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343600 */   GIR_RootConstrainSelectedInstOperands,
     /* 343601 */   // GIR_Coverage, 1245,
     /* 343601 */   GIR_Done,
     /* 343602 */ // Label 6791: @343602
     /* 343602 */ GIM_Reject,
     /* 343603 */ // Label 6781: @343603
     /* 343603 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(343640), // Rule ID 1241 //
     /* 343608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343629 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 343634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343638 */   GIR_RootConstrainSelectedInstOperands,
     /* 343639 */   // GIR_Coverage, 1241,
     /* 343639 */   GIR_Done,
     /* 343640 */ // Label 6792: @343640
     /* 343640 */ GIM_Reject,
     /* 343641 */ // Label 6782: @343641
     /* 343641 */ GIM_Reject,
     /* 343642 */ // Label 77: @343642
     /* 343642 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6801*/ GIMT_Encode4(343991),
     /* 343653 */ /*GILLT_s16*//*Label 6793*/ GIMT_Encode4(343693),
     /* 343657 */ /*GILLT_s32*//*Label 6794*/ GIMT_Encode4(343731),
     /* 343661 */ /*GILLT_s64*//*Label 6795*/ GIMT_Encode4(343766), GIMT_Encode4(0),
     /* 343669 */ /*GILLT_v2s32*//*Label 6796*/ GIMT_Encode4(343801),
     /* 343673 */ /*GILLT_v2s64*//*Label 6797*/ GIMT_Encode4(343839),
     /* 343677 */ /*GILLT_v4s16*//*Label 6798*/ GIMT_Encode4(343877),
     /* 343681 */ /*GILLT_v4s32*//*Label 6799*/ GIMT_Encode4(343915), GIMT_Encode4(0),
     /* 343689 */ /*GILLT_v8s16*//*Label 6800*/ GIMT_Encode4(343953),
     /* 343693 */ // Label 6793: @343693
     /* 343693 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(343730), // Rule ID 4861 //
     /* 343698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343719 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 343719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 343724 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343728 */   GIR_RootConstrainSelectedInstOperands,
     /* 343729 */   // GIR_Coverage, 4861,
     /* 343729 */   GIR_Done,
     /* 343730 */ // Label 6802: @343730
     /* 343730 */ GIM_Reject,
     /* 343731 */ // Label 6794: @343731
     /* 343731 */ GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(343765), // Rule ID 4858 //
     /* 343736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343754 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 343754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 343759 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343763 */   GIR_RootConstrainSelectedInstOperands,
     /* 343764 */   // GIR_Coverage, 4858,
     /* 343764 */   GIR_Done,
     /* 343765 */ // Label 6803: @343765
     /* 343765 */ GIM_Reject,
     /* 343766 */ // Label 6795: @343766
     /* 343766 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(343800), // Rule ID 4855 //
     /* 343771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343789 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 343789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343794 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343798 */   GIR_RootConstrainSelectedInstOperands,
     /* 343799 */   // GIR_Coverage, 4855,
     /* 343799 */   GIR_Done,
     /* 343800 */ // Label 6804: @343800
     /* 343800 */ GIM_Reject,
     /* 343801 */ // Label 6796: @343801
     /* 343801 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(343838), // Rule ID 5052 //
     /* 343806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343827 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 343832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343836 */   GIR_RootConstrainSelectedInstOperands,
     /* 343837 */   // GIR_Coverage, 5052,
     /* 343837 */   GIR_Done,
     /* 343838 */ // Label 6805: @343838
     /* 343838 */ GIM_Reject,
     /* 343839 */ // Label 6797: @343839
     /* 343839 */ GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(343876), // Rule ID 5046 //
     /* 343844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343865 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343874 */   GIR_RootConstrainSelectedInstOperands,
     /* 343875 */   // GIR_Coverage, 5046,
     /* 343875 */   GIR_Done,
     /* 343876 */ // Label 6806: @343876
     /* 343876 */ GIM_Reject,
     /* 343877 */ // Label 6798: @343877
     /* 343877 */ GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(343914), // Rule ID 5058 //
     /* 343882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343903 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343908 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343912 */   GIR_RootConstrainSelectedInstOperands,
     /* 343913 */   // GIR_Coverage, 5058,
     /* 343913 */   GIR_Done,
     /* 343914 */ // Label 6807: @343914
     /* 343914 */ GIM_Reject,
     /* 343915 */ // Label 6799: @343915
     /* 343915 */ GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(343952), // Rule ID 5049 //
     /* 343920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343941 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343950 */   GIR_RootConstrainSelectedInstOperands,
     /* 343951 */   // GIR_Coverage, 5049,
     /* 343951 */   GIR_Done,
     /* 343952 */ // Label 6808: @343952
     /* 343952 */ GIM_Reject,
     /* 343953 */ // Label 6800: @343953
     /* 343953 */ GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(343990), // Rule ID 5055 //
     /* 343958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343979 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343979 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343984 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343988 */   GIR_RootConstrainSelectedInstOperands,
     /* 343989 */   // GIR_Coverage, 5055,
     /* 343989 */   GIR_Done,
     /* 343990 */ // Label 6809: @343990
     /* 343990 */ GIM_Reject,
     /* 343991 */ // Label 6801: @343991
     /* 343991 */ GIM_Reject,
     /* 343992 */ // Label 78: @343992
     /* 343992 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6818*/ GIMT_Encode4(344341),
     /* 344003 */ /*GILLT_s16*//*Label 6810*/ GIMT_Encode4(344043),
     /* 344007 */ /*GILLT_s32*//*Label 6811*/ GIMT_Encode4(344081),
     /* 344011 */ /*GILLT_s64*//*Label 6812*/ GIMT_Encode4(344116), GIMT_Encode4(0),
     /* 344019 */ /*GILLT_v2s32*//*Label 6813*/ GIMT_Encode4(344151),
     /* 344023 */ /*GILLT_v2s64*//*Label 6814*/ GIMT_Encode4(344189),
     /* 344027 */ /*GILLT_v4s16*//*Label 6815*/ GIMT_Encode4(344227),
     /* 344031 */ /*GILLT_v4s32*//*Label 6816*/ GIMT_Encode4(344265), GIMT_Encode4(0),
     /* 344039 */ /*GILLT_v8s16*//*Label 6817*/ GIMT_Encode4(344303),
     /* 344043 */ // Label 6810: @344043
     /* 344043 */ GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(344080), // Rule ID 4862 //
     /* 344048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344069 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 344069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 344074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344078 */   GIR_RootConstrainSelectedInstOperands,
     /* 344079 */   // GIR_Coverage, 4862,
     /* 344079 */   GIR_Done,
     /* 344080 */ // Label 6819: @344080
     /* 344080 */ GIM_Reject,
     /* 344081 */ // Label 6811: @344081
     /* 344081 */ GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(344115), // Rule ID 4859 //
     /* 344086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344104 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 344104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 344109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344113 */   GIR_RootConstrainSelectedInstOperands,
     /* 344114 */   // GIR_Coverage, 4859,
     /* 344114 */   GIR_Done,
     /* 344115 */ // Label 6820: @344115
     /* 344115 */ GIM_Reject,
     /* 344116 */ // Label 6812: @344116
     /* 344116 */ GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(344150), // Rule ID 4856 //
     /* 344121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344139 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 344139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 344144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344148 */   GIR_RootConstrainSelectedInstOperands,
     /* 344149 */   // GIR_Coverage, 4856,
     /* 344149 */   GIR_Done,
     /* 344150 */ // Label 6821: @344150
     /* 344150 */ GIM_Reject,
     /* 344151 */ // Label 6813: @344151
     /* 344151 */ GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(344188), // Rule ID 5053 //
     /* 344156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344177 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 344182 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344186 */   GIR_RootConstrainSelectedInstOperands,
     /* 344187 */   // GIR_Coverage, 5053,
     /* 344187 */   GIR_Done,
     /* 344188 */ // Label 6822: @344188
     /* 344188 */ GIM_Reject,
     /* 344189 */ // Label 6814: @344189
     /* 344189 */ GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(344226), // Rule ID 5047 //
     /* 344194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344215 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 344220 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344224 */   GIR_RootConstrainSelectedInstOperands,
     /* 344225 */   // GIR_Coverage, 5047,
     /* 344225 */   GIR_Done,
     /* 344226 */ // Label 6823: @344226
     /* 344226 */ GIM_Reject,
     /* 344227 */ // Label 6815: @344227
     /* 344227 */ GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(344264), // Rule ID 5059 //
     /* 344232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344253 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 344258 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344262 */   GIR_RootConstrainSelectedInstOperands,
     /* 344263 */   // GIR_Coverage, 5059,
     /* 344263 */   GIR_Done,
     /* 344264 */ // Label 6824: @344264
     /* 344264 */ GIM_Reject,
     /* 344265 */ // Label 6816: @344265
     /* 344265 */ GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(344302), // Rule ID 5050 //
     /* 344270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344291 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 344296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344300 */   GIR_RootConstrainSelectedInstOperands,
     /* 344301 */   // GIR_Coverage, 5050,
     /* 344301 */   GIR_Done,
     /* 344302 */ // Label 6825: @344302
     /* 344302 */ GIM_Reject,
     /* 344303 */ // Label 6817: @344303
     /* 344303 */ GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(344340), // Rule ID 5056 //
     /* 344308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344329 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 344334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344338 */   GIR_RootConstrainSelectedInstOperands,
     /* 344339 */   // GIR_Coverage, 5056,
     /* 344339 */   GIR_Done,
     /* 344340 */ // Label 6826: @344340
     /* 344340 */ GIM_Reject,
     /* 344341 */ // Label 6818: @344341
     /* 344341 */ GIM_Reject,
     /* 344342 */ // Label 79: @344342
     /* 344342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6835*/ GIMT_Encode4(345044),
     /* 344353 */ /*GILLT_s16*//*Label 6827*/ GIMT_Encode4(344393),
     /* 344357 */ /*GILLT_s32*//*Label 6828*/ GIMT_Encode4(344431),
     /* 344361 */ /*GILLT_s64*//*Label 6829*/ GIMT_Encode4(344469), GIMT_Encode4(0),
     /* 344369 */ /*GILLT_v2s32*//*Label 6830*/ GIMT_Encode4(344529),
     /* 344373 */ /*GILLT_v2s64*//*Label 6831*/ GIMT_Encode4(344632),
     /* 344377 */ /*GILLT_v4s16*//*Label 6832*/ GIMT_Encode4(344735),
     /* 344381 */ /*GILLT_v4s32*//*Label 6833*/ GIMT_Encode4(344838), GIMT_Encode4(0),
     /* 344389 */ /*GILLT_v8s16*//*Label 6834*/ GIMT_Encode4(344941),
     /* 344393 */ // Label 6827: @344393
     /* 344393 */ GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(344430), // Rule ID 614 //
     /* 344398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344419 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 344419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 344424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344428 */   GIR_RootConstrainSelectedInstOperands,
     /* 344429 */   // GIR_Coverage, 614,
     /* 344429 */   GIR_Done,
     /* 344430 */ // Label 6836: @344430
     /* 344430 */ GIM_Reject,
     /* 344431 */ // Label 6828: @344431
     /* 344431 */ GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(344468), // Rule ID 616 //
     /* 344436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344457 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 344457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 344462 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344466 */   GIR_RootConstrainSelectedInstOperands,
     /* 344467 */   // GIR_Coverage, 616,
     /* 344467 */   GIR_Done,
     /* 344468 */ // Label 6837: @344468
     /* 344468 */ GIM_Reject,
     /* 344469 */ // Label 6829: @344469
     /* 344469 */ GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(344528),
     /* 344474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344492 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(344511), // Rule ID 618 //
     /* 344497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344500 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 344500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 344505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344509 */     GIR_RootConstrainSelectedInstOperands,
     /* 344510 */     // GIR_Coverage, 618,
     /* 344510 */     GIR_Done,
     /* 344511 */   // Label 6839: @344511
     /* 344511 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(344527), // Rule ID 4852 //
     /* 344516 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 344516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 344521 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344525 */     GIR_RootConstrainSelectedInstOperands,
     /* 344526 */     // GIR_Coverage, 4852,
     /* 344526 */     GIR_Done,
     /* 344527 */   // Label 6840: @344527
     /* 344527 */   GIM_Reject,
     /* 344528 */ // Label 6838: @344528
     /* 344528 */ GIM_Reject,
     /* 344529 */ // Label 6830: @344529
     /* 344529 */ GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(344631),
     /* 344534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344544 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(344603), // Rule ID 2366 //
     /* 344549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344588 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 344591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344601 */     GIR_RootConstrainSelectedInstOperands,
     /* 344602 */     // GIR_Coverage, 2366,
     /* 344602 */     GIR_EraseRootFromParent_Done,
     /* 344603 */   // Label 6842: @344603
     /* 344603 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(344630), // Rule ID 1288 //
     /* 344608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344619 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 344624 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344628 */     GIR_RootConstrainSelectedInstOperands,
     /* 344629 */     // GIR_Coverage, 1288,
     /* 344629 */     GIR_Done,
     /* 344630 */   // Label 6843: @344630
     /* 344630 */   GIM_Reject,
     /* 344631 */ // Label 6841: @344631
     /* 344631 */ GIM_Reject,
     /* 344632 */ // Label 6831: @344632
     /* 344632 */ GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(344734),
     /* 344637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344647 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(344706), // Rule ID 2372 //
     /* 344652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344691 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 344694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344704 */     GIR_RootConstrainSelectedInstOperands,
     /* 344705 */     // GIR_Coverage, 2372,
     /* 344705 */     GIR_EraseRootFromParent_Done,
     /* 344706 */   // Label 6845: @344706
     /* 344706 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(344733), // Rule ID 1292 //
     /* 344711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344722 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 344727 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344731 */     GIR_RootConstrainSelectedInstOperands,
     /* 344732 */     // GIR_Coverage, 1292,
     /* 344732 */     GIR_Done,
     /* 344733 */   // Label 6846: @344733
     /* 344733 */   GIM_Reject,
     /* 344734 */ // Label 6844: @344734
     /* 344734 */ GIM_Reject,
     /* 344735 */ // Label 6832: @344735
     /* 344735 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(344837),
     /* 344740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344750 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(344809), // Rule ID 2360 //
     /* 344755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344794 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 344797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344807 */     GIR_RootConstrainSelectedInstOperands,
     /* 344808 */     // GIR_Coverage, 2360,
     /* 344808 */     GIR_EraseRootFromParent_Done,
     /* 344809 */   // Label 6848: @344809
     /* 344809 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(344836), // Rule ID 1284 //
     /* 344814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344825 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 344830 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344834 */     GIR_RootConstrainSelectedInstOperands,
     /* 344835 */     // GIR_Coverage, 1284,
     /* 344835 */     GIR_Done,
     /* 344836 */   // Label 6849: @344836
     /* 344836 */   GIM_Reject,
     /* 344837 */ // Label 6847: @344837
     /* 344837 */ GIM_Reject,
     /* 344838 */ // Label 6833: @344838
     /* 344838 */ GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(344940),
     /* 344843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344853 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(344912), // Rule ID 2369 //
     /* 344858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344897 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 344900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344910 */     GIR_RootConstrainSelectedInstOperands,
     /* 344911 */     // GIR_Coverage, 2369,
     /* 344911 */     GIR_EraseRootFromParent_Done,
     /* 344912 */   // Label 6851: @344912
     /* 344912 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(344939), // Rule ID 1290 //
     /* 344917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344928 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 344933 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344937 */     GIR_RootConstrainSelectedInstOperands,
     /* 344938 */     // GIR_Coverage, 1290,
     /* 344938 */     GIR_Done,
     /* 344939 */   // Label 6852: @344939
     /* 344939 */   GIM_Reject,
     /* 344940 */ // Label 6850: @344940
     /* 344940 */ GIM_Reject,
     /* 344941 */ // Label 6834: @344941
     /* 344941 */ GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(345043),
     /* 344946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344956 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(345015), // Rule ID 2363 //
     /* 344961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345000 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 345003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345013 */     GIR_RootConstrainSelectedInstOperands,
     /* 345014 */     // GIR_Coverage, 2363,
     /* 345014 */     GIR_EraseRootFromParent_Done,
     /* 345015 */   // Label 6854: @345015
     /* 345015 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(345042), // Rule ID 1286 //
     /* 345020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345031 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 345036 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345040 */     GIR_RootConstrainSelectedInstOperands,
     /* 345041 */     // GIR_Coverage, 1286,
     /* 345041 */     GIR_Done,
     /* 345042 */   // Label 6855: @345042
     /* 345042 */   GIM_Reject,
     /* 345043 */ // Label 6853: @345043
     /* 345043 */ GIM_Reject,
     /* 345044 */ // Label 6835: @345044
     /* 345044 */ GIM_Reject,
     /* 345045 */ // Label 80: @345045
     /* 345045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6864*/ GIMT_Encode4(345747),
     /* 345056 */ /*GILLT_s16*//*Label 6856*/ GIMT_Encode4(345096),
     /* 345060 */ /*GILLT_s32*//*Label 6857*/ GIMT_Encode4(345134),
     /* 345064 */ /*GILLT_s64*//*Label 6858*/ GIMT_Encode4(345172), GIMT_Encode4(0),
     /* 345072 */ /*GILLT_v2s32*//*Label 6859*/ GIMT_Encode4(345232),
     /* 345076 */ /*GILLT_v2s64*//*Label 6860*/ GIMT_Encode4(345335),
     /* 345080 */ /*GILLT_v4s16*//*Label 6861*/ GIMT_Encode4(345438),
     /* 345084 */ /*GILLT_v4s32*//*Label 6862*/ GIMT_Encode4(345541), GIMT_Encode4(0),
     /* 345092 */ /*GILLT_v8s16*//*Label 6863*/ GIMT_Encode4(345644),
     /* 345096 */ // Label 6856: @345096
     /* 345096 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(345133), // Rule ID 602 //
     /* 345101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 345104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 345107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345122 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 345122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 345127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345131 */   GIR_RootConstrainSelectedInstOperands,
     /* 345132 */   // GIR_Coverage, 602,
     /* 345132 */   GIR_Done,
     /* 345133 */ // Label 6865: @345133
     /* 345133 */ GIM_Reject,
     /* 345134 */ // Label 6857: @345134
     /* 345134 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(345171), // Rule ID 604 //
     /* 345139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345160 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 345160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 345165 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345169 */   GIR_RootConstrainSelectedInstOperands,
     /* 345170 */   // GIR_Coverage, 604,
     /* 345170 */   GIR_Done,
     /* 345171 */ // Label 6866: @345171
     /* 345171 */ GIM_Reject,
     /* 345172 */ // Label 6858: @345172
     /* 345172 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(345231),
     /* 345177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345195 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(345214), // Rule ID 606 //
     /* 345200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345203 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 345203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 345208 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345212 */     GIR_RootConstrainSelectedInstOperands,
     /* 345213 */     // GIR_Coverage, 606,
     /* 345213 */     GIR_Done,
     /* 345214 */   // Label 6868: @345214
     /* 345214 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(345230), // Rule ID 4851 //
     /* 345219 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 345219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 345224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345228 */     GIR_RootConstrainSelectedInstOperands,
     /* 345229 */     // GIR_Coverage, 4851,
     /* 345229 */     GIR_Done,
     /* 345230 */   // Label 6869: @345230
     /* 345230 */   GIM_Reject,
     /* 345231 */ // Label 6867: @345231
     /* 345231 */ GIM_Reject,
     /* 345232 */ // Label 6859: @345232
     /* 345232 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(345334),
     /* 345237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345247 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(345306), // Rule ID 2351 //
     /* 345252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345291 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 345294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345304 */     GIR_RootConstrainSelectedInstOperands,
     /* 345305 */     // GIR_Coverage, 2351,
     /* 345305 */     GIR_EraseRootFromParent_Done,
     /* 345306 */   // Label 6871: @345306
     /* 345306 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(345333), // Rule ID 1258 //
     /* 345311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345322 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 345327 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345331 */     GIR_RootConstrainSelectedInstOperands,
     /* 345332 */     // GIR_Coverage, 1258,
     /* 345332 */     GIR_Done,
     /* 345333 */   // Label 6872: @345333
     /* 345333 */   GIM_Reject,
     /* 345334 */ // Label 6870: @345334
     /* 345334 */ GIM_Reject,
     /* 345335 */ // Label 6860: @345335
     /* 345335 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(345437),
     /* 345340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345350 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(345409), // Rule ID 2357 //
     /* 345355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345394 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 345397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345407 */     GIR_RootConstrainSelectedInstOperands,
     /* 345408 */     // GIR_Coverage, 2357,
     /* 345408 */     GIR_EraseRootFromParent_Done,
     /* 345409 */   // Label 6874: @345409
     /* 345409 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(345436), // Rule ID 1262 //
     /* 345414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345425 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 345430 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345434 */     GIR_RootConstrainSelectedInstOperands,
     /* 345435 */     // GIR_Coverage, 1262,
     /* 345435 */     GIR_Done,
     /* 345436 */   // Label 6875: @345436
     /* 345436 */   GIM_Reject,
     /* 345437 */ // Label 6873: @345437
     /* 345437 */ GIM_Reject,
     /* 345438 */ // Label 6861: @345438
     /* 345438 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(345540),
     /* 345443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345453 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(345512), // Rule ID 2345 //
     /* 345458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345497 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 345500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345510 */     GIR_RootConstrainSelectedInstOperands,
     /* 345511 */     // GIR_Coverage, 2345,
     /* 345511 */     GIR_EraseRootFromParent_Done,
     /* 345512 */   // Label 6877: @345512
     /* 345512 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(345539), // Rule ID 1254 //
     /* 345517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345528 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 345533 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345537 */     GIR_RootConstrainSelectedInstOperands,
     /* 345538 */     // GIR_Coverage, 1254,
     /* 345538 */     GIR_Done,
     /* 345539 */   // Label 6878: @345539
     /* 345539 */   GIM_Reject,
     /* 345540 */ // Label 6876: @345540
     /* 345540 */ GIM_Reject,
     /* 345541 */ // Label 6862: @345541
     /* 345541 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(345643),
     /* 345546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345556 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(345615), // Rule ID 2354 //
     /* 345561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345600 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 345603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345613 */     GIR_RootConstrainSelectedInstOperands,
     /* 345614 */     // GIR_Coverage, 2354,
     /* 345614 */     GIR_EraseRootFromParent_Done,
     /* 345615 */   // Label 6880: @345615
     /* 345615 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(345642), // Rule ID 1260 //
     /* 345620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345631 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 345636 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345640 */     GIR_RootConstrainSelectedInstOperands,
     /* 345641 */     // GIR_Coverage, 1260,
     /* 345641 */     GIR_Done,
     /* 345642 */   // Label 6881: @345642
     /* 345642 */   GIM_Reject,
     /* 345643 */ // Label 6879: @345643
     /* 345643 */ GIM_Reject,
     /* 345644 */ // Label 6863: @345644
     /* 345644 */ GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(345746),
     /* 345649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345659 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(345718), // Rule ID 2348 //
     /* 345664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345703 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 345706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345716 */     GIR_RootConstrainSelectedInstOperands,
     /* 345717 */     // GIR_Coverage, 2348,
     /* 345717 */     GIR_EraseRootFromParent_Done,
     /* 345718 */   // Label 6883: @345718
     /* 345718 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(345745), // Rule ID 1256 //
     /* 345723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345734 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 345739 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345743 */     GIR_RootConstrainSelectedInstOperands,
     /* 345744 */     // GIR_Coverage, 1256,
     /* 345744 */     GIR_Done,
     /* 345745 */   // Label 6884: @345745
     /* 345745 */   GIM_Reject,
     /* 345746 */ // Label 6882: @345746
     /* 345746 */ GIM_Reject,
     /* 345747 */ // Label 6864: @345747
     /* 345747 */ GIM_Reject,
     /* 345748 */ // Label 81: @345748
     /* 345748 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6893*/ GIMT_Encode4(346151),
     /* 345759 */ /*GILLT_s32*//*Label 6885*/ GIMT_Encode4(345799),
     /* 345763 */ /*GILLT_s64*//*Label 6886*/ GIMT_Encode4(345873), GIMT_Encode4(0),
     /* 345771 */ /*GILLT_v2s32*//*Label 6887*/ GIMT_Encode4(345947), GIMT_Encode4(0),
     /* 345779 */ /*GILLT_v4s16*//*Label 6888*/ GIMT_Encode4(345981),
     /* 345783 */ /*GILLT_v4s32*//*Label 6889*/ GIMT_Encode4(346015),
     /* 345787 */ /*GILLT_v8s8*//*Label 6890*/ GIMT_Encode4(346049),
     /* 345791 */ /*GILLT_v8s16*//*Label 6891*/ GIMT_Encode4(346083),
     /* 345795 */ /*GILLT_v16s8*//*Label 6892*/ GIMT_Encode4(346117),
     /* 345799 */ // Label 6885: @345799
     /* 345799 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(345872),
     /* 345804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345818 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(345852), // Rule ID 2328 //
     /* 345823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 345838 */     // MIs[1] Operand 1
     /* 345838 */     // No operand predicates
     /* 345838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345840 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 345843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345850 */     GIR_RootConstrainSelectedInstOperands,
     /* 345851 */     // GIR_Coverage, 2328,
     /* 345851 */     GIR_EraseRootFromParent_Done,
     /* 345852 */   // Label 6895: @345852
     /* 345852 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(345871), // Rule ID 2327 //
     /* 345857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345864 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 345869 */     GIR_RootConstrainSelectedInstOperands,
     /* 345870 */     // GIR_Coverage, 2327,
     /* 345870 */     GIR_Done,
     /* 345871 */   // Label 6896: @345871
     /* 345871 */   GIM_Reject,
     /* 345872 */ // Label 6894: @345872
     /* 345872 */ GIM_Reject,
     /* 345873 */ // Label 6886: @345873
     /* 345873 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(345946),
     /* 345878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345892 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(345926), // Rule ID 2330 //
     /* 345897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 345912 */     // MIs[1] Operand 1
     /* 345912 */     // No operand predicates
     /* 345912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345914 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 345917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345924 */     GIR_RootConstrainSelectedInstOperands,
     /* 345925 */     // GIR_Coverage, 2330,
     /* 345925 */     GIR_EraseRootFromParent_Done,
     /* 345926 */   // Label 6898: @345926
     /* 345926 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(345945), // Rule ID 2329 //
     /* 345931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345938 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 345943 */     GIR_RootConstrainSelectedInstOperands,
     /* 345944 */     // GIR_Coverage, 2329,
     /* 345944 */     GIR_Done,
     /* 345945 */   // Label 6899: @345945
     /* 345945 */   GIM_Reject,
     /* 345946 */ // Label 6897: @345946
     /* 345946 */ GIM_Reject,
     /* 345947 */ // Label 6887: @345947
     /* 345947 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(345980), // Rule ID 1414 //
     /* 345952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345973 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 345978 */   GIR_RootConstrainSelectedInstOperands,
     /* 345979 */   // GIR_Coverage, 1414,
     /* 345979 */   GIR_Done,
     /* 345980 */ // Label 6900: @345980
     /* 345980 */ GIM_Reject,
     /* 345981 */ // Label 6888: @345981
     /* 345981 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(346014), // Rule ID 1412 //
     /* 345986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346007 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 346012 */   GIR_RootConstrainSelectedInstOperands,
     /* 346013 */   // GIR_Coverage, 1412,
     /* 346013 */   GIR_Done,
     /* 346014 */ // Label 6901: @346014
     /* 346014 */ GIM_Reject,
     /* 346015 */ // Label 6889: @346015
     /* 346015 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(346048), // Rule ID 1415 //
     /* 346020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346041 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 346046 */   GIR_RootConstrainSelectedInstOperands,
     /* 346047 */   // GIR_Coverage, 1415,
     /* 346047 */   GIR_Done,
     /* 346048 */ // Label 6902: @346048
     /* 346048 */ GIM_Reject,
     /* 346049 */ // Label 6890: @346049
     /* 346049 */ GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(346082), // Rule ID 1410 //
     /* 346054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346075 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 346080 */   GIR_RootConstrainSelectedInstOperands,
     /* 346081 */   // GIR_Coverage, 1410,
     /* 346081 */   GIR_Done,
     /* 346082 */ // Label 6903: @346082
     /* 346082 */ GIM_Reject,
     /* 346083 */ // Label 6891: @346083
     /* 346083 */ GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(346116), // Rule ID 1413 //
     /* 346088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346109 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 346114 */   GIR_RootConstrainSelectedInstOperands,
     /* 346115 */   // GIR_Coverage, 1413,
     /* 346115 */   GIR_Done,
     /* 346116 */ // Label 6904: @346116
     /* 346116 */ GIM_Reject,
     /* 346117 */ // Label 6892: @346117
     /* 346117 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(346150), // Rule ID 1411 //
     /* 346122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346143 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 346148 */   GIR_RootConstrainSelectedInstOperands,
     /* 346149 */   // GIR_Coverage, 1411,
     /* 346149 */   GIR_Done,
     /* 346150 */ // Label 6905: @346150
     /* 346150 */ GIM_Reject,
     /* 346151 */ // Label 6893: @346151
     /* 346151 */ GIM_Reject,
     /* 346152 */ // Label 82: @346152
     /* 346152 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6914*/ GIMT_Encode4(346555),
     /* 346163 */ /*GILLT_s32*//*Label 6906*/ GIMT_Encode4(346203),
     /* 346167 */ /*GILLT_s64*//*Label 6907*/ GIMT_Encode4(346277), GIMT_Encode4(0),
     /* 346175 */ /*GILLT_v2s32*//*Label 6908*/ GIMT_Encode4(346351), GIMT_Encode4(0),
     /* 346183 */ /*GILLT_v4s16*//*Label 6909*/ GIMT_Encode4(346385),
     /* 346187 */ /*GILLT_v4s32*//*Label 6910*/ GIMT_Encode4(346419),
     /* 346191 */ /*GILLT_v8s8*//*Label 6911*/ GIMT_Encode4(346453),
     /* 346195 */ /*GILLT_v8s16*//*Label 6912*/ GIMT_Encode4(346487),
     /* 346199 */ /*GILLT_v16s8*//*Label 6913*/ GIMT_Encode4(346521),
     /* 346203 */ // Label 6906: @346203
     /* 346203 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(346276),
     /* 346208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346222 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(346256), // Rule ID 2324 //
     /* 346227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 346242 */     // MIs[1] Operand 1
     /* 346242 */     // No operand predicates
     /* 346242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346244 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 346247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346254 */     GIR_RootConstrainSelectedInstOperands,
     /* 346255 */     // GIR_Coverage, 2324,
     /* 346255 */     GIR_EraseRootFromParent_Done,
     /* 346256 */   // Label 6916: @346256
     /* 346256 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(346275), // Rule ID 2323 //
     /* 346261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346268 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 346273 */     GIR_RootConstrainSelectedInstOperands,
     /* 346274 */     // GIR_Coverage, 2323,
     /* 346274 */     GIR_Done,
     /* 346275 */   // Label 6917: @346275
     /* 346275 */   GIM_Reject,
     /* 346276 */ // Label 6915: @346276
     /* 346276 */ GIM_Reject,
     /* 346277 */ // Label 6907: @346277
     /* 346277 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(346350),
     /* 346282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346296 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(346330), // Rule ID 2326 //
     /* 346301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 346316 */     // MIs[1] Operand 1
     /* 346316 */     // No operand predicates
     /* 346316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346318 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 346318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 346321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346328 */     GIR_RootConstrainSelectedInstOperands,
     /* 346329 */     // GIR_Coverage, 2326,
     /* 346329 */     GIR_EraseRootFromParent_Done,
     /* 346330 */   // Label 6919: @346330
     /* 346330 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(346349), // Rule ID 2325 //
     /* 346335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346342 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 346342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 346347 */     GIR_RootConstrainSelectedInstOperands,
     /* 346348 */     // GIR_Coverage, 2325,
     /* 346348 */     GIR_Done,
     /* 346349 */   // Label 6920: @346349
     /* 346349 */   GIM_Reject,
     /* 346350 */ // Label 6918: @346350
     /* 346350 */ GIM_Reject,
     /* 346351 */ // Label 6908: @346351
     /* 346351 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(346384), // Rule ID 1402 //
     /* 346356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346377 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 346377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 346382 */   GIR_RootConstrainSelectedInstOperands,
     /* 346383 */   // GIR_Coverage, 1402,
     /* 346383 */   GIR_Done,
     /* 346384 */ // Label 6921: @346384
     /* 346384 */ GIM_Reject,
     /* 346385 */ // Label 6909: @346385
     /* 346385 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(346418), // Rule ID 1400 //
     /* 346390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 346399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346411 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 346416 */   GIR_RootConstrainSelectedInstOperands,
     /* 346417 */   // GIR_Coverage, 1400,
     /* 346417 */   GIR_Done,
     /* 346418 */ // Label 6922: @346418
     /* 346418 */ GIM_Reject,
     /* 346419 */ // Label 6910: @346419
     /* 346419 */ GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(346452), // Rule ID 1403 //
     /* 346424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346445 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 346450 */   GIR_RootConstrainSelectedInstOperands,
     /* 346451 */   // GIR_Coverage, 1403,
     /* 346451 */   GIR_Done,
     /* 346452 */ // Label 6923: @346452
     /* 346452 */ GIM_Reject,
     /* 346453 */ // Label 6911: @346453
     /* 346453 */ GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(346486), // Rule ID 1398 //
     /* 346458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346479 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 346484 */   GIR_RootConstrainSelectedInstOperands,
     /* 346485 */   // GIR_Coverage, 1398,
     /* 346485 */   GIR_Done,
     /* 346486 */ // Label 6924: @346486
     /* 346486 */ GIM_Reject,
     /* 346487 */ // Label 6912: @346487
     /* 346487 */ GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(346520), // Rule ID 1401 //
     /* 346492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346513 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 346518 */   GIR_RootConstrainSelectedInstOperands,
     /* 346519 */   // GIR_Coverage, 1401,
     /* 346519 */   GIR_Done,
     /* 346520 */ // Label 6925: @346520
     /* 346520 */ GIM_Reject,
     /* 346521 */ // Label 6913: @346521
     /* 346521 */ GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(346554), // Rule ID 1399 //
     /* 346526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346547 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 346552 */   GIR_RootConstrainSelectedInstOperands,
     /* 346553 */   // GIR_Coverage, 1399,
     /* 346553 */   GIR_Done,
     /* 346554 */ // Label 6926: @346554
     /* 346554 */ GIM_Reject,
     /* 346555 */ // Label 6914: @346555
     /* 346555 */ GIM_Reject,
     /* 346556 */ // Label 83: @346556
     /* 346556 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6935*/ GIMT_Encode4(346959),
     /* 346567 */ /*GILLT_s32*//*Label 6927*/ GIMT_Encode4(346607),
     /* 346571 */ /*GILLT_s64*//*Label 6928*/ GIMT_Encode4(346681), GIMT_Encode4(0),
     /* 346579 */ /*GILLT_v2s32*//*Label 6929*/ GIMT_Encode4(346755), GIMT_Encode4(0),
     /* 346587 */ /*GILLT_v4s16*//*Label 6930*/ GIMT_Encode4(346789),
     /* 346591 */ /*GILLT_v4s32*//*Label 6931*/ GIMT_Encode4(346823),
     /* 346595 */ /*GILLT_v8s8*//*Label 6932*/ GIMT_Encode4(346857),
     /* 346599 */ /*GILLT_v8s16*//*Label 6933*/ GIMT_Encode4(346891),
     /* 346603 */ /*GILLT_v16s8*//*Label 6934*/ GIMT_Encode4(346925),
     /* 346607 */ // Label 6927: @346607
     /* 346607 */ GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(346680),
     /* 346612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346626 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(346660), // Rule ID 2336 //
     /* 346631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 346646 */     // MIs[1] Operand 1
     /* 346646 */     // No operand predicates
     /* 346646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346648 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 346651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346658 */     GIR_RootConstrainSelectedInstOperands,
     /* 346659 */     // GIR_Coverage, 2336,
     /* 346659 */     GIR_EraseRootFromParent_Done,
     /* 346660 */   // Label 6937: @346660
     /* 346660 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(346679), // Rule ID 2335 //
     /* 346665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346672 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 346677 */     GIR_RootConstrainSelectedInstOperands,
     /* 346678 */     // GIR_Coverage, 2335,
     /* 346678 */     GIR_Done,
     /* 346679 */   // Label 6938: @346679
     /* 346679 */   GIM_Reject,
     /* 346680 */ // Label 6936: @346680
     /* 346680 */ GIM_Reject,
     /* 346681 */ // Label 6928: @346681
     /* 346681 */ GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(346754),
     /* 346686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346700 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(346734), // Rule ID 2338 //
     /* 346705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 346720 */     // MIs[1] Operand 1
     /* 346720 */     // No operand predicates
     /* 346720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346722 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 346722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 346725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346732 */     GIR_RootConstrainSelectedInstOperands,
     /* 346733 */     // GIR_Coverage, 2338,
     /* 346733 */     GIR_EraseRootFromParent_Done,
     /* 346734 */   // Label 6940: @346734
     /* 346734 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(346753), // Rule ID 2337 //
     /* 346739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346746 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 346746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 346751 */     GIR_RootConstrainSelectedInstOperands,
     /* 346752 */     // GIR_Coverage, 2337,
     /* 346752 */     GIR_Done,
     /* 346753 */   // Label 6941: @346753
     /* 346753 */   GIM_Reject,
     /* 346754 */ // Label 6939: @346754
     /* 346754 */ GIM_Reject,
     /* 346755 */ // Label 6929: @346755
     /* 346755 */ GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(346788), // Rule ID 1537 //
     /* 346760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346781 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 346781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 346786 */   GIR_RootConstrainSelectedInstOperands,
     /* 346787 */   // GIR_Coverage, 1537,
     /* 346787 */   GIR_Done,
     /* 346788 */ // Label 6942: @346788
     /* 346788 */ GIM_Reject,
     /* 346789 */ // Label 6930: @346789
     /* 346789 */ GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(346822), // Rule ID 1535 //
     /* 346794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 346803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346815 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 346820 */   GIR_RootConstrainSelectedInstOperands,
     /* 346821 */   // GIR_Coverage, 1535,
     /* 346821 */   GIR_Done,
     /* 346822 */ // Label 6943: @346822
     /* 346822 */ GIM_Reject,
     /* 346823 */ // Label 6931: @346823
     /* 346823 */ GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(346856), // Rule ID 1538 //
     /* 346828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346849 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 346854 */   GIR_RootConstrainSelectedInstOperands,
     /* 346855 */   // GIR_Coverage, 1538,
     /* 346855 */   GIR_Done,
     /* 346856 */ // Label 6944: @346856
     /* 346856 */ GIM_Reject,
     /* 346857 */ // Label 6932: @346857
     /* 346857 */ GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(346890), // Rule ID 1533 //
     /* 346862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346883 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 346888 */   GIR_RootConstrainSelectedInstOperands,
     /* 346889 */   // GIR_Coverage, 1533,
     /* 346889 */   GIR_Done,
     /* 346890 */ // Label 6945: @346890
     /* 346890 */ GIM_Reject,
     /* 346891 */ // Label 6933: @346891
     /* 346891 */ GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(346924), // Rule ID 1536 //
     /* 346896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346917 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 346922 */   GIR_RootConstrainSelectedInstOperands,
     /* 346923 */   // GIR_Coverage, 1536,
     /* 346923 */   GIR_Done,
     /* 346924 */ // Label 6946: @346924
     /* 346924 */ GIM_Reject,
     /* 346925 */ // Label 6934: @346925
     /* 346925 */ GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(346958), // Rule ID 1534 //
     /* 346930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346951 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 346956 */   GIR_RootConstrainSelectedInstOperands,
     /* 346957 */   // GIR_Coverage, 1534,
     /* 346957 */   GIR_Done,
     /* 346958 */ // Label 6947: @346958
     /* 346958 */ GIM_Reject,
     /* 346959 */ // Label 6935: @346959
     /* 346959 */ GIM_Reject,
     /* 346960 */ // Label 84: @346960
     /* 346960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6956*/ GIMT_Encode4(347363),
     /* 346971 */ /*GILLT_s32*//*Label 6948*/ GIMT_Encode4(347011),
     /* 346975 */ /*GILLT_s64*//*Label 6949*/ GIMT_Encode4(347085), GIMT_Encode4(0),
     /* 346983 */ /*GILLT_v2s32*//*Label 6950*/ GIMT_Encode4(347159), GIMT_Encode4(0),
     /* 346991 */ /*GILLT_v4s16*//*Label 6951*/ GIMT_Encode4(347193),
     /* 346995 */ /*GILLT_v4s32*//*Label 6952*/ GIMT_Encode4(347227),
     /* 346999 */ /*GILLT_v8s8*//*Label 6953*/ GIMT_Encode4(347261),
     /* 347003 */ /*GILLT_v8s16*//*Label 6954*/ GIMT_Encode4(347295),
     /* 347007 */ /*GILLT_v16s8*//*Label 6955*/ GIMT_Encode4(347329),
     /* 347011 */ // Label 6948: @347011
     /* 347011 */ GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(347084),
     /* 347016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347030 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(347064), // Rule ID 2332 //
     /* 347035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 347050 */     // MIs[1] Operand 1
     /* 347050 */     // No operand predicates
     /* 347050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347052 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 347052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 347055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347062 */     GIR_RootConstrainSelectedInstOperands,
     /* 347063 */     // GIR_Coverage, 2332,
     /* 347063 */     GIR_EraseRootFromParent_Done,
     /* 347064 */   // Label 6958: @347064
     /* 347064 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(347083), // Rule ID 2331 //
     /* 347069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347076 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 347076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 347081 */     GIR_RootConstrainSelectedInstOperands,
     /* 347082 */     // GIR_Coverage, 2331,
     /* 347082 */     GIR_Done,
     /* 347083 */   // Label 6959: @347083
     /* 347083 */   GIM_Reject,
     /* 347084 */ // Label 6957: @347084
     /* 347084 */ GIM_Reject,
     /* 347085 */ // Label 6949: @347085
     /* 347085 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(347158),
     /* 347090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 347096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347104 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(347138), // Rule ID 2334 //
     /* 347109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 347124 */     // MIs[1] Operand 1
     /* 347124 */     // No operand predicates
     /* 347124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347126 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 347126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 347129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347136 */     GIR_RootConstrainSelectedInstOperands,
     /* 347137 */     // GIR_Coverage, 2334,
     /* 347137 */     GIR_EraseRootFromParent_Done,
     /* 347138 */   // Label 6961: @347138
     /* 347138 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(347157), // Rule ID 2333 //
     /* 347143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347150 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 347150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 347155 */     GIR_RootConstrainSelectedInstOperands,
     /* 347156 */     // GIR_Coverage, 2333,
     /* 347156 */     GIR_Done,
     /* 347157 */   // Label 6962: @347157
     /* 347157 */   GIM_Reject,
     /* 347158 */ // Label 6960: @347158
     /* 347158 */ GIM_Reject,
     /* 347159 */ // Label 6950: @347159
     /* 347159 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(347192), // Rule ID 1525 //
     /* 347164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 347173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347185 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 347185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 347190 */   GIR_RootConstrainSelectedInstOperands,
     /* 347191 */   // GIR_Coverage, 1525,
     /* 347191 */   GIR_Done,
     /* 347192 */ // Label 6963: @347192
     /* 347192 */ GIM_Reject,
     /* 347193 */ // Label 6951: @347193
     /* 347193 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(347226), // Rule ID 1523 //
     /* 347198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 347207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347219 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 347219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 347224 */   GIR_RootConstrainSelectedInstOperands,
     /* 347225 */   // GIR_Coverage, 1523,
     /* 347225 */   GIR_Done,
     /* 347226 */ // Label 6964: @347226
     /* 347226 */ GIM_Reject,
     /* 347227 */ // Label 6952: @347227
     /* 347227 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(347260), // Rule ID 1526 //
     /* 347232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347253 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 347253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 347258 */   GIR_RootConstrainSelectedInstOperands,
     /* 347259 */   // GIR_Coverage, 1526,
     /* 347259 */   GIR_Done,
     /* 347260 */ // Label 6965: @347260
     /* 347260 */ GIM_Reject,
     /* 347261 */ // Label 6953: @347261
     /* 347261 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(347294), // Rule ID 1521 //
     /* 347266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 347275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347287 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 347287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 347292 */   GIR_RootConstrainSelectedInstOperands,
     /* 347293 */   // GIR_Coverage, 1521,
     /* 347293 */   GIR_Done,
     /* 347294 */ // Label 6966: @347294
     /* 347294 */ GIM_Reject,
     /* 347295 */ // Label 6954: @347295
     /* 347295 */ GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(347328), // Rule ID 1524 //
     /* 347300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347321 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 347321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 347326 */   GIR_RootConstrainSelectedInstOperands,
     /* 347327 */   // GIR_Coverage, 1524,
     /* 347327 */   GIR_Done,
     /* 347328 */ // Label 6967: @347328
     /* 347328 */ GIM_Reject,
     /* 347329 */ // Label 6955: @347329
     /* 347329 */ GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(347362), // Rule ID 1522 //
     /* 347334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 347343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347355 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 347355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 347360 */   GIR_RootConstrainSelectedInstOperands,
     /* 347361 */   // GIR_Coverage, 1522,
     /* 347361 */   GIR_Done,
     /* 347362 */ // Label 6968: @347362
     /* 347362 */ GIM_Reject,
     /* 347363 */ // Label 6956: @347363
     /* 347363 */ GIM_Reject,
     /* 347364 */ // Label 85: @347364
     /* 347364 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6978*/ GIMT_Encode4(348178),
     /* 347375 */ /*GILLT_s32*//*Label 6969*/ GIMT_Encode4(347415),
     /* 347379 */ /*GILLT_s64*//*Label 6970*/ GIMT_Encode4(347442), GIMT_Encode4(0),
     /* 347387 */ /*GILLT_v2s32*//*Label 6971*/ GIMT_Encode4(347521),
     /* 347391 */ /*GILLT_v2s64*//*Label 6972*/ GIMT_Encode4(347548),
     /* 347395 */ /*GILLT_v4s16*//*Label 6973*/ GIMT_Encode4(347731),
     /* 347399 */ /*GILLT_v4s32*//*Label 6974*/ GIMT_Encode4(347758),
     /* 347403 */ /*GILLT_v8s8*//*Label 6975*/ GIMT_Encode4(347941),
     /* 347407 */ /*GILLT_v8s16*//*Label 6976*/ GIMT_Encode4(347968),
     /* 347411 */ /*GILLT_v16s8*//*Label 6977*/ GIMT_Encode4(348151),
     /* 347415 */ // Label 6969: @347415
     /* 347415 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(347441), // Rule ID 2317 //
     /* 347420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347434 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 347434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 347439 */   GIR_RootConstrainSelectedInstOperands,
     /* 347440 */   // GIR_Coverage, 2317,
     /* 347440 */   GIR_Done,
     /* 347441 */ // Label 6979: @347441
     /* 347441 */ GIM_Reject,
     /* 347442 */ // Label 6970: @347442
     /* 347442 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(347520),
     /* 347447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347450 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(347473), // Rule ID 1652 //
     /* 347455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347466 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 347466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 347471 */     GIR_RootConstrainSelectedInstOperands,
     /* 347472 */     // GIR_Coverage, 1652,
     /* 347472 */     GIR_Done,
     /* 347473 */   // Label 6981: @347473
     /* 347473 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(347496), // Rule ID 2318 //
     /* 347478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347489 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 347489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 347494 */     GIR_RootConstrainSelectedInstOperands,
     /* 347495 */     // GIR_Coverage, 2318,
     /* 347495 */     GIR_Done,
     /* 347496 */   // Label 6982: @347496
     /* 347496 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(347519), // Rule ID 2510 //
     /* 347501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 347504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347512 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 347512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 347517 */     GIR_RootConstrainSelectedInstOperands,
     /* 347518 */     // GIR_Coverage, 2510,
     /* 347518 */     GIR_Done,
     /* 347519 */   // Label 6983: @347519
     /* 347519 */   GIM_Reject,
     /* 347520 */ // Label 6980: @347520
     /* 347520 */ GIM_Reject,
     /* 347521 */ // Label 6971: @347521
     /* 347521 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(347547), // Rule ID 707 //
     /* 347526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347540 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 347540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 347545 */   GIR_RootConstrainSelectedInstOperands,
     /* 347546 */   // GIR_Coverage, 707,
     /* 347546 */   GIR_Done,
     /* 347547 */ // Label 6984: @347547
     /* 347547 */ GIM_Reject,
     /* 347548 */ // Label 6972: @347548
     /* 347548 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(347730),
     /* 347553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347560 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(347638), // Rule ID 4929 //
     /* 347565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 347581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347601 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 347614 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 347621 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 347621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 347624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347636 */     GIR_RootConstrainSelectedInstOperands,
     /* 347637 */     // GIR_Coverage, 4929,
     /* 347637 */     GIR_EraseRootFromParent_Done,
     /* 347638 */   // Label 6986: @347638
     /* 347638 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(347710), // Rule ID 4928 //
     /* 347643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 347659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347684 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347688 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347695 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 347695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 347698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 347704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 347708 */     GIR_RootConstrainSelectedInstOperands,
     /* 347709 */     // GIR_Coverage, 4928,
     /* 347709 */     GIR_EraseRootFromParent_Done,
     /* 347710 */   // Label 6987: @347710
     /* 347710 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(347729), // Rule ID 709 //
     /* 347715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347722 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 347722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 347727 */     GIR_RootConstrainSelectedInstOperands,
     /* 347728 */     // GIR_Coverage, 709,
     /* 347728 */     GIR_Done,
     /* 347729 */   // Label 6988: @347729
     /* 347729 */   GIM_Reject,
     /* 347730 */ // Label 6985: @347730
     /* 347730 */ GIM_Reject,
     /* 347731 */ // Label 6973: @347731
     /* 347731 */ GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(347757), // Rule ID 705 //
     /* 347736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347750 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 347750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 347755 */   GIR_RootConstrainSelectedInstOperands,
     /* 347756 */   // GIR_Coverage, 705,
     /* 347756 */   GIR_Done,
     /* 347757 */ // Label 6989: @347757
     /* 347757 */ GIM_Reject,
     /* 347758 */ // Label 6974: @347758
     /* 347758 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(347940),
     /* 347763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347770 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(347848), // Rule ID 4927 //
     /* 347775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347811 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 347824 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 347831 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 347831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 347834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347846 */     GIR_RootConstrainSelectedInstOperands,
     /* 347847 */     // GIR_Coverage, 4927,
     /* 347847 */     GIR_EraseRootFromParent_Done,
     /* 347848 */   // Label 6991: @347848
     /* 347848 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(347920), // Rule ID 4926 //
     /* 347853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347898 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347905 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 347905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 347908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 347914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 347918 */     GIR_RootConstrainSelectedInstOperands,
     /* 347919 */     // GIR_Coverage, 4926,
     /* 347919 */     GIR_EraseRootFromParent_Done,
     /* 347920 */   // Label 6992: @347920
     /* 347920 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(347939), // Rule ID 708 //
     /* 347925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347932 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 347932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 347937 */     GIR_RootConstrainSelectedInstOperands,
     /* 347938 */     // GIR_Coverage, 708,
     /* 347938 */     GIR_Done,
     /* 347939 */   // Label 6993: @347939
     /* 347939 */   GIM_Reject,
     /* 347940 */ // Label 6990: @347940
     /* 347940 */ GIM_Reject,
     /* 347941 */ // Label 6975: @347941
     /* 347941 */ GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(347967), // Rule ID 703 //
     /* 347946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347960 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 347960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 347965 */   GIR_RootConstrainSelectedInstOperands,
     /* 347966 */   // GIR_Coverage, 703,
     /* 347966 */   GIR_Done,
     /* 347967 */ // Label 6994: @347967
     /* 347967 */ GIM_Reject,
     /* 347968 */ // Label 6976: @347968
     /* 347968 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(348150),
     /* 347973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347980 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(348058), // Rule ID 4925 //
     /* 347985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 348001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 348005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 348017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 348034 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 348041 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 348041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 348044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 348051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 348056 */     GIR_RootConstrainSelectedInstOperands,
     /* 348057 */     // GIR_Coverage, 4925,
     /* 348057 */     GIR_EraseRootFromParent_Done,
     /* 348058 */   // Label 6996: @348058
     /* 348058 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(348130), // Rule ID 4924 //
     /* 348063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 348071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 348079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 348083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 348100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348104 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348108 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348115 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 348115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 348118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 348124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 348128 */     GIR_RootConstrainSelectedInstOperands,
     /* 348129 */     // GIR_Coverage, 4924,
     /* 348129 */     GIR_EraseRootFromParent_Done,
     /* 348130 */   // Label 6997: @348130
     /* 348130 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(348149), // Rule ID 706 //
     /* 348135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348142 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 348142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 348147 */     GIR_RootConstrainSelectedInstOperands,
     /* 348148 */     // GIR_Coverage, 706,
     /* 348148 */     GIR_Done,
     /* 348149 */   // Label 6998: @348149
     /* 348149 */   GIM_Reject,
     /* 348150 */ // Label 6995: @348150
     /* 348150 */ GIM_Reject,
     /* 348151 */ // Label 6977: @348151
     /* 348151 */ GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(348177), // Rule ID 704 //
     /* 348156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348170 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 348170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 348175 */   GIR_RootConstrainSelectedInstOperands,
     /* 348176 */   // GIR_Coverage, 704,
     /* 348176 */   GIR_Done,
     /* 348177 */ // Label 6999: @348177
     /* 348177 */ GIM_Reject,
     /* 348178 */ // Label 6978: @348178
     /* 348178 */ GIM_Reject,
     /* 348179 */ // Label 86: @348179
     /* 348179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7002*/ GIMT_Encode4(348344),
     /* 348190 */ /*GILLT_s32*//*Label 7000*/ GIMT_Encode4(348198),
     /* 348194 */ /*GILLT_s64*//*Label 7001*/ GIMT_Encode4(348271),
     /* 348198 */ // Label 7000: @348198
     /* 348198 */ GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(348224), // Rule ID 4770 //
     /* 348203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 348206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 348209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348213 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 348213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 348218 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348222 */   GIR_RootConstrainSelectedInstOperands,
     /* 348223 */   // GIR_Coverage, 4770,
     /* 348223 */   GIR_Done,
     /* 348224 */ // Label 7003: @348224
     /* 348224 */ GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(348247), // Rule ID 4776 //
     /* 348229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348236 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 348236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 348241 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348245 */   GIR_RootConstrainSelectedInstOperands,
     /* 348246 */   // GIR_Coverage, 4776,
     /* 348246 */   GIR_Done,
     /* 348247 */ // Label 7004: @348247
     /* 348247 */ GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(348270), // Rule ID 4778 //
     /* 348252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348259 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 348259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 348264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348268 */   GIR_RootConstrainSelectedInstOperands,
     /* 348269 */   // GIR_Coverage, 4778,
     /* 348269 */   GIR_Done,
     /* 348270 */ // Label 7005: @348270
     /* 348270 */ GIM_Reject,
     /* 348271 */ // Label 7001: @348271
     /* 348271 */ GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(348297), // Rule ID 4772 //
     /* 348276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 348279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 348282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348286 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 348286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 348291 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348295 */   GIR_RootConstrainSelectedInstOperands,
     /* 348296 */   // GIR_Coverage, 4772,
     /* 348296 */   GIR_Done,
     /* 348297 */ // Label 7006: @348297
     /* 348297 */ GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(348320), // Rule ID 4780 //
     /* 348302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348309 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 348309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 348314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348318 */   GIR_RootConstrainSelectedInstOperands,
     /* 348319 */   // GIR_Coverage, 4780,
     /* 348319 */   GIR_Done,
     /* 348320 */ // Label 7007: @348320
     /* 348320 */ GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(348343), // Rule ID 4782 //
     /* 348325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348332 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 348332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 348337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348341 */   GIR_RootConstrainSelectedInstOperands,
     /* 348342 */   // GIR_Coverage, 4782,
     /* 348342 */   GIR_Done,
     /* 348343 */ // Label 7008: @348343
     /* 348343 */ GIM_Reject,
     /* 348344 */ // Label 7002: @348344
     /* 348344 */ GIM_Reject,
     /* 348345 */ // Label 87: @348345
     /* 348345 */ GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(348443),
     /* 348350 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 348353 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7013*/ GIMT_Encode4(348442),
     /* 348364 */   /*GILLT_s16*//*Label 7010*/ GIMT_Encode4(348376),
     /* 348368 */   /*GILLT_s32*//*Label 7011*/ GIMT_Encode4(348400),
     /* 348372 */   /*GILLT_s64*//*Label 7012*/ GIMT_Encode4(348421),
     /* 348376 */   // Label 7010: @348376
     /* 348376 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(348399), // Rule ID 4774 //
     /* 348381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 348384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348388 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 348388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 348393 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348397 */     GIR_RootConstrainSelectedInstOperands,
     /* 348398 */     // GIR_Coverage, 4774,
     /* 348398 */     GIR_Done,
     /* 348399 */   // Label 7014: @348399
     /* 348399 */   GIM_Reject,
     /* 348400 */   // Label 7011: @348400
     /* 348400 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(348420), // Rule ID 4784 //
     /* 348405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348409 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 348409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 348414 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348418 */     GIR_RootConstrainSelectedInstOperands,
     /* 348419 */     // GIR_Coverage, 4784,
     /* 348419 */     GIR_Done,
     /* 348420 */   // Label 7015: @348420
     /* 348420 */   GIM_Reject,
     /* 348421 */   // Label 7012: @348421
     /* 348421 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(348441), // Rule ID 4786 //
     /* 348426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348430 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 348430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 348435 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348439 */     GIR_RootConstrainSelectedInstOperands,
     /* 348440 */     // GIR_Coverage, 4786,
     /* 348440 */     GIR_Done,
     /* 348441 */   // Label 7016: @348441
     /* 348441 */   GIM_Reject,
     /* 348442 */   // Label 7013: @348442
     /* 348442 */   GIM_Reject,
     /* 348443 */ // Label 7009: @348443
     /* 348443 */ GIM_Reject,
     /* 348444 */ // Label 88: @348444
     /* 348444 */ GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(348459), // Rule ID 225 //
     /* 348449 */   // MIs[0] addr
     /* 348449 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 348452 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 348452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 348457 */   GIR_RootConstrainSelectedInstOperands,
     /* 348458 */   // GIR_Coverage, 225,
     /* 348458 */   GIR_Done,
     /* 348459 */ // Label 7017: @348459
     /* 348459 */ GIM_Reject,
     /* 348460 */ // Label 89: @348460
     /* 348460 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7029*/ GIMT_Encode4(353831),
     /* 348471 */ /*GILLT_s64*//*Label 7018*/ GIMT_Encode4(348543), GIMT_Encode4(0),
     /* 348479 */ /*GILLT_v2s32*//*Label 7019*/ GIMT_Encode4(348945), GIMT_Encode4(0),
     /* 348487 */ /*GILLT_v4s16*//*Label 7020*/ GIMT_Encode4(349347), GIMT_Encode4(0),
     /* 348495 */ /*GILLT_v8s8*//*Label 7021*/ GIMT_Encode4(349749), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 348507 */ /*GILLT_nxv1s1*//*Label 7022*/ GIMT_Encode4(349929),
     /* 348511 */ /*GILLT_nxv2s1*//*Label 7023*/ GIMT_Encode4(352192),
     /* 348515 */ /*GILLT_nxv2s16*//*Label 7024*/ GIMT_Encode4(353047),
     /* 348519 */ /*GILLT_nxv2s32*//*Label 7025*/ GIMT_Encode4(353334), GIMT_Encode4(0),
     /* 348527 */ /*GILLT_nxv4s1*//*Label 7026*/ GIMT_Encode4(353404),
     /* 348531 */ /*GILLT_nxv4s16*//*Label 7027*/ GIMT_Encode4(353691), GIMT_Encode4(0),
     /* 348539 */ /*GILLT_nxv8s1*//*Label 7028*/ GIMT_Encode4(353761),
     /* 348543 */ // Label 7018: @348543
     /* 348543 */ GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(348944),
     /* 348548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 348551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348555 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(348607), // Rule ID 5599 //
     /* 348560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348572 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348579 */     // MIs[0] Operand 2
     /* 348579 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348592 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 348592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 348595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348605 */     GIR_RootConstrainSelectedInstOperands,
     /* 348606 */     // GIR_Coverage, 5599,
     /* 348606 */     GIR_EraseRootFromParent_Done,
     /* 348607 */   // Label 7031: @348607
     /* 348607 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(348659), // Rule ID 5602 //
     /* 348612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348624 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348631 */     // MIs[0] Operand 2
     /* 348631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348644 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 348644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 348647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348657 */     GIR_RootConstrainSelectedInstOperands,
     /* 348658 */     // GIR_Coverage, 5602,
     /* 348658 */     GIR_EraseRootFromParent_Done,
     /* 348659 */   // Label 7032: @348659
     /* 348659 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(348727), // Rule ID 5478 //
     /* 348664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348668 */     // MIs[0] Operand 2
     /* 348668 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348679 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348709 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348726 */     // GIR_Coverage, 5478,
     /* 348726 */     GIR_EraseRootFromParent_Done,
     /* 348727 */   // Label 7033: @348727
     /* 348727 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(348795), // Rule ID 5483 //
     /* 348732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348736 */     // MIs[0] Operand 2
     /* 348736 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348747 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348767 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348777 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348794 */     // GIR_Coverage, 5483,
     /* 348794 */     GIR_EraseRootFromParent_Done,
     /* 348795 */   // Label 7034: @348795
     /* 348795 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(348837), // Rule ID 6940 //
     /* 348800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348804 */     // MIs[0] Operand 2
     /* 348804 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348815 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 348815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348820 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348836 */     // GIR_Coverage, 6940,
     /* 348836 */     GIR_EraseRootFromParent_Done,
     /* 348837 */   // Label 7035: @348837
     /* 348837 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(348879), // Rule ID 6941 //
     /* 348842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348846 */     // MIs[0] Operand 2
     /* 348846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348857 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 348857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348862 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348878 */     // GIR_Coverage, 6941,
     /* 348878 */     GIR_EraseRootFromParent_Done,
     /* 348879 */   // Label 7036: @348879
     /* 348879 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(348943), // Rule ID 6945 //
     /* 348884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348888 */     // MIs[0] Operand 2
     /* 348888 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348899 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348915 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348942 */     // GIR_Coverage, 6945,
     /* 348942 */     GIR_EraseRootFromParent_Done,
     /* 348943 */   // Label 7037: @348943
     /* 348943 */   GIM_Reject,
     /* 348944 */ // Label 7030: @348944
     /* 348944 */ GIM_Reject,
     /* 348945 */ // Label 7019: @348945
     /* 348945 */ GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(349346),
     /* 348950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348957 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(349009), // Rule ID 5598 //
     /* 348962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348974 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348981 */     // MIs[0] Operand 2
     /* 348981 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348994 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 348994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 348997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349007 */     GIR_RootConstrainSelectedInstOperands,
     /* 349008 */     // GIR_Coverage, 5598,
     /* 349008 */     GIR_EraseRootFromParent_Done,
     /* 349009 */   // Label 7039: @349009
     /* 349009 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(349061), // Rule ID 5601 //
     /* 349014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 349026 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349033 */     // MIs[0] Operand 2
     /* 349033 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349046 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 349046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 349049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349059 */     GIR_RootConstrainSelectedInstOperands,
     /* 349060 */     // GIR_Coverage, 5601,
     /* 349060 */     GIR_EraseRootFromParent_Done,
     /* 349061 */   // Label 7040: @349061
     /* 349061 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(349129), // Rule ID 5468 //
     /* 349066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349070 */     // MIs[0] Operand 2
     /* 349070 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349081 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349101 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349111 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349128 */     // GIR_Coverage, 5468,
     /* 349128 */     GIR_EraseRootFromParent_Done,
     /* 349129 */   // Label 7041: @349129
     /* 349129 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(349197), // Rule ID 5473 //
     /* 349134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349138 */     // MIs[0] Operand 2
     /* 349138 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349149 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349169 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349179 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349196 */     // GIR_Coverage, 5473,
     /* 349196 */     GIR_EraseRootFromParent_Done,
     /* 349197 */   // Label 7042: @349197
     /* 349197 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(349239), // Rule ID 6937 //
     /* 349202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349206 */     // MIs[0] Operand 2
     /* 349206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349217 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 349217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349222 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349238 */     // GIR_Coverage, 6937,
     /* 349238 */     GIR_EraseRootFromParent_Done,
     /* 349239 */   // Label 7043: @349239
     /* 349239 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(349281), // Rule ID 6939 //
     /* 349244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349248 */     // MIs[0] Operand 2
     /* 349248 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349259 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 349259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349264 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349280 */     // GIR_Coverage, 6939,
     /* 349280 */     GIR_EraseRootFromParent_Done,
     /* 349281 */   // Label 7044: @349281
     /* 349281 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(349345), // Rule ID 6944 //
     /* 349286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349290 */     // MIs[0] Operand 2
     /* 349290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349301 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349313 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349317 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349327 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349344 */     // GIR_Coverage, 6944,
     /* 349344 */     GIR_EraseRootFromParent_Done,
     /* 349345 */   // Label 7045: @349345
     /* 349345 */   GIM_Reject,
     /* 349346 */ // Label 7038: @349346
     /* 349346 */ GIM_Reject,
     /* 349347 */ // Label 7020: @349347
     /* 349347 */ GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(349748),
     /* 349352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349359 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(349411), // Rule ID 5597 //
     /* 349364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349376 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349383 */     // MIs[0] Operand 2
     /* 349383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349396 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 349396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 349399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349409 */     GIR_RootConstrainSelectedInstOperands,
     /* 349410 */     // GIR_Coverage, 5597,
     /* 349410 */     GIR_EraseRootFromParent_Done,
     /* 349411 */   // Label 7047: @349411
     /* 349411 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(349463), // Rule ID 5600 //
     /* 349416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349428 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349435 */     // MIs[0] Operand 2
     /* 349435 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349448 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 349448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 349451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349461 */     GIR_RootConstrainSelectedInstOperands,
     /* 349462 */     // GIR_Coverage, 5600,
     /* 349462 */     GIR_EraseRootFromParent_Done,
     /* 349463 */   // Label 7048: @349463
     /* 349463 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(349531), // Rule ID 5458 //
     /* 349468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349472 */     // MIs[0] Operand 2
     /* 349472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349483 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349503 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349530 */     // GIR_Coverage, 5458,
     /* 349530 */     GIR_EraseRootFromParent_Done,
     /* 349531 */   // Label 7049: @349531
     /* 349531 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(349599), // Rule ID 5463 //
     /* 349536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349540 */     // MIs[0] Operand 2
     /* 349540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349551 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349581 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349598 */     // GIR_Coverage, 5463,
     /* 349598 */     GIR_EraseRootFromParent_Done,
     /* 349599 */   // Label 7050: @349599
     /* 349599 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(349641), // Rule ID 6935 //
     /* 349604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349608 */     // MIs[0] Operand 2
     /* 349608 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349619 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 349619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349624 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349640 */     // GIR_Coverage, 6935,
     /* 349640 */     GIR_EraseRootFromParent_Done,
     /* 349641 */   // Label 7051: @349641
     /* 349641 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(349683), // Rule ID 6938 //
     /* 349646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349650 */     // MIs[0] Operand 2
     /* 349650 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349661 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 349661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349666 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349682 */     // GIR_Coverage, 6938,
     /* 349682 */     GIR_EraseRootFromParent_Done,
     /* 349683 */   // Label 7052: @349683
     /* 349683 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(349747), // Rule ID 6943 //
     /* 349688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349692 */     // MIs[0] Operand 2
     /* 349692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349703 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349729 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349746 */     // GIR_Coverage, 6943,
     /* 349746 */     GIR_EraseRootFromParent_Done,
     /* 349747 */   // Label 7053: @349747
     /* 349747 */   GIM_Reject,
     /* 349748 */ // Label 7046: @349748
     /* 349748 */ GIM_Reject,
     /* 349749 */ // Label 7021: @349749
     /* 349749 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(349928),
     /* 349754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 349757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349765 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(349829), // Rule ID 5453 //
     /* 349770 */     // MIs[0] Operand 2
     /* 349770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 349781 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349793 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349811 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349828 */     // GIR_Coverage, 5453,
     /* 349828 */     GIR_EraseRootFromParent_Done,
     /* 349829 */   // Label 7055: @349829
     /* 349829 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349867), // Rule ID 6936 //
     /* 349834 */     // MIs[0] Operand 2
     /* 349834 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349845 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 349845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349850 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349866 */     // GIR_Coverage, 6936,
     /* 349866 */     GIR_EraseRootFromParent_Done,
     /* 349867 */   // Label 7056: @349867
     /* 349867 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(349927), // Rule ID 6942 //
     /* 349872 */     // MIs[0] Operand 2
     /* 349872 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349883 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349926 */     // GIR_Coverage, 6942,
     /* 349926 */     GIR_EraseRootFromParent_Done,
     /* 349927 */   // Label 7057: @349927
     /* 349927 */   GIM_Reject,
     /* 349928 */ // Label 7054: @349928
     /* 349928 */ GIM_Reject,
     /* 349929 */ // Label 7022: @349929
     /* 349929 */ GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(349964), // Rule ID 9034 //
     /* 349934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 349940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349944 */   // MIs[0] Operand 2
     /* 349944 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349955 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 349955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349960 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 349962 */   GIR_RootConstrainSelectedInstOperands,
     /* 349963 */   // GIR_Coverage, 9034,
     /* 349963 */   GIR_EraseRootFromParent_Done,
     /* 349964 */ // Label 7058: @349964
     /* 349964 */ GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(349999), // Rule ID 9035 //
     /* 349969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 349975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349979 */   // MIs[0] Operand 2
     /* 349979 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349990 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 349990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349995 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 349997 */   GIR_RootConstrainSelectedInstOperands,
     /* 349998 */   // GIR_Coverage, 9035,
     /* 349998 */   GIR_EraseRootFromParent_Done,
     /* 349999 */ // Label 7059: @349999
     /* 349999 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(350053), // Rule ID 9042 //
     /* 350004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350014 */   // MIs[0] Operand 2
     /* 350014 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350025 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 350025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350037 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350051 */   GIR_RootConstrainSelectedInstOperands,
     /* 350052 */   // GIR_Coverage, 9042,
     /* 350052 */   GIR_EraseRootFromParent_Done,
     /* 350053 */ // Label 7060: @350053
     /* 350053 */ GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(350107), // Rule ID 9043 //
     /* 350058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350068 */   // MIs[0] Operand 2
     /* 350068 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350079 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 350079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350091 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350105 */   GIR_RootConstrainSelectedInstOperands,
     /* 350106 */   // GIR_Coverage, 9043,
     /* 350106 */   GIR_EraseRootFromParent_Done,
     /* 350107 */ // Label 7061: @350107
     /* 350107 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(350161), // Rule ID 9044 //
     /* 350112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350122 */   // MIs[0] Operand 2
     /* 350122 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350133 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 350133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350145 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350159 */   GIR_RootConstrainSelectedInstOperands,
     /* 350160 */   // GIR_Coverage, 9044,
     /* 350160 */   GIR_EraseRootFromParent_Done,
     /* 350161 */ // Label 7062: @350161
     /* 350161 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(350215), // Rule ID 9045 //
     /* 350166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350176 */   // MIs[0] Operand 2
     /* 350176 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 350187 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 350187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350199 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350213 */   GIR_RootConstrainSelectedInstOperands,
     /* 350214 */   // GIR_Coverage, 9045,
     /* 350214 */   GIR_EraseRootFromParent_Done,
     /* 350215 */ // Label 7063: @350215
     /* 350215 */ GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(350286), // Rule ID 9054 //
     /* 350220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350230 */   // MIs[0] Operand 2
     /* 350230 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350241 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350241 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350244 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350248 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350253 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350271 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350284 */   GIR_RootConstrainSelectedInstOperands,
     /* 350285 */   // GIR_Coverage, 9054,
     /* 350285 */   GIR_EraseRootFromParent_Done,
     /* 350286 */ // Label 7064: @350286
     /* 350286 */ GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(350357), // Rule ID 9055 //
     /* 350291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350301 */   // MIs[0] Operand 2
     /* 350301 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350312 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350312 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350315 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350319 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350324 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350342 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350355 */   GIR_RootConstrainSelectedInstOperands,
     /* 350356 */   // GIR_Coverage, 9055,
     /* 350356 */   GIR_EraseRootFromParent_Done,
     /* 350357 */ // Label 7065: @350357
     /* 350357 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(350428), // Rule ID 9056 //
     /* 350362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350372 */   // MIs[0] Operand 2
     /* 350372 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350383 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350383 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350386 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350390 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350395 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350413 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350426 */   GIR_RootConstrainSelectedInstOperands,
     /* 350427 */   // GIR_Coverage, 9056,
     /* 350427 */   GIR_EraseRootFromParent_Done,
     /* 350428 */ // Label 7066: @350428
     /* 350428 */ GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(350499), // Rule ID 9057 //
     /* 350433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350443 */   // MIs[0] Operand 2
     /* 350443 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 350454 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350454 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350457 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350461 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350466 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350484 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350497 */   GIR_RootConstrainSelectedInstOperands,
     /* 350498 */   // GIR_Coverage, 9057,
     /* 350498 */   GIR_EraseRootFromParent_Done,
     /* 350499 */ // Label 7067: @350499
     /* 350499 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350570), // Rule ID 9058 //
     /* 350504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350514 */   // MIs[0] Operand 2
     /* 350514 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350525 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350525 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350528 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350532 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350537 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350555 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350568 */   GIR_RootConstrainSelectedInstOperands,
     /* 350569 */   // GIR_Coverage, 9058,
     /* 350569 */   GIR_EraseRootFromParent_Done,
     /* 350570 */ // Label 7068: @350570
     /* 350570 */ GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350641), // Rule ID 9059 //
     /* 350575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350585 */   // MIs[0] Operand 2
     /* 350585 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 350596 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350596 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350599 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350603 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350608 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350626 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350639 */   GIR_RootConstrainSelectedInstOperands,
     /* 350640 */   // GIR_Coverage, 9059,
     /* 350640 */   GIR_EraseRootFromParent_Done,
     /* 350641 */ // Label 7069: @350641
     /* 350641 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350712), // Rule ID 9060 //
     /* 350646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350656 */   // MIs[0] Operand 2
     /* 350656 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 350667 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350667 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350670 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350674 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350679 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350697 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350710 */   GIR_RootConstrainSelectedInstOperands,
     /* 350711 */   // GIR_Coverage, 9060,
     /* 350711 */   GIR_EraseRootFromParent_Done,
     /* 350712 */ // Label 7070: @350712
     /* 350712 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350783), // Rule ID 9061 //
     /* 350717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350727 */   // MIs[0] Operand 2
     /* 350727 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 350738 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350738 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350741 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350745 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350750 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350768 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350781 */   GIR_RootConstrainSelectedInstOperands,
     /* 350782 */   // GIR_Coverage, 9061,
     /* 350782 */   GIR_EraseRootFromParent_Done,
     /* 350783 */ // Label 7071: @350783
     /* 350783 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(350871), // Rule ID 9070 //
     /* 350788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350798 */   // MIs[0] Operand 2
     /* 350798 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350809 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350809 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350812 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350816 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350821 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350839 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350856 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350869 */   GIR_RootConstrainSelectedInstOperands,
     /* 350870 */   // GIR_Coverage, 9070,
     /* 350870 */   GIR_EraseRootFromParent_Done,
     /* 350871 */ // Label 7072: @350871
     /* 350871 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(350959), // Rule ID 9071 //
     /* 350876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350886 */   // MIs[0] Operand 2
     /* 350886 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350897 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350897 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350900 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350904 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350909 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350915 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350918 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350922 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350927 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350944 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350957 */   GIR_RootConstrainSelectedInstOperands,
     /* 350958 */   // GIR_Coverage, 9071,
     /* 350958 */   GIR_EraseRootFromParent_Done,
     /* 350959 */ // Label 7073: @350959
     /* 350959 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(351047), // Rule ID 9072 //
     /* 350964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350974 */   // MIs[0] Operand 2
     /* 350974 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350985 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350985 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350988 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350992 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350997 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351015 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351032 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351045 */   GIR_RootConstrainSelectedInstOperands,
     /* 351046 */   // GIR_Coverage, 9072,
     /* 351046 */   GIR_EraseRootFromParent_Done,
     /* 351047 */ // Label 7074: @351047
     /* 351047 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(351135), // Rule ID 9073 //
     /* 351052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351062 */   // MIs[0] Operand 2
     /* 351062 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 351073 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351073 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351076 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351080 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351085 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351091 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351094 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351098 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351103 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351120 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351133 */   GIR_RootConstrainSelectedInstOperands,
     /* 351134 */   // GIR_Coverage, 9073,
     /* 351134 */   GIR_EraseRootFromParent_Done,
     /* 351135 */ // Label 7075: @351135
     /* 351135 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(351223), // Rule ID 9074 //
     /* 351140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351150 */   // MIs[0] Operand 2
     /* 351150 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351161 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351161 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351164 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351168 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351173 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351179 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351182 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351186 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351191 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351208 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351221 */   GIR_RootConstrainSelectedInstOperands,
     /* 351222 */   // GIR_Coverage, 9074,
     /* 351222 */   GIR_EraseRootFromParent_Done,
     /* 351223 */ // Label 7076: @351223
     /* 351223 */ GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(351311), // Rule ID 9075 //
     /* 351228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351238 */   // MIs[0] Operand 2
     /* 351238 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 351249 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351249 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351252 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351256 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351261 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351267 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351270 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351274 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351279 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351296 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351309 */   GIR_RootConstrainSelectedInstOperands,
     /* 351310 */   // GIR_Coverage, 9075,
     /* 351310 */   GIR_EraseRootFromParent_Done,
     /* 351311 */ // Label 7077: @351311
     /* 351311 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(351399), // Rule ID 9076 //
     /* 351316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351326 */   // MIs[0] Operand 2
     /* 351326 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351337 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351337 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351340 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351344 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351349 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351355 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351358 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351362 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351367 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351384 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351397 */   GIR_RootConstrainSelectedInstOperands,
     /* 351398 */   // GIR_Coverage, 9076,
     /* 351398 */   GIR_EraseRootFromParent_Done,
     /* 351399 */ // Label 7078: @351399
     /* 351399 */ GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(351487), // Rule ID 9077 //
     /* 351404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351414 */   // MIs[0] Operand 2
     /* 351414 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 351425 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351425 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351428 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351432 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351437 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351443 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351446 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351450 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351455 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351472 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351485 */   GIR_RootConstrainSelectedInstOperands,
     /* 351486 */   // GIR_Coverage, 9077,
     /* 351486 */   GIR_EraseRootFromParent_Done,
     /* 351487 */ // Label 7079: @351487
     /* 351487 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351575), // Rule ID 9078 //
     /* 351492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351502 */   // MIs[0] Operand 2
     /* 351502 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351513 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351513 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351516 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351520 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351525 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351531 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351534 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351538 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351543 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351560 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351573 */   GIR_RootConstrainSelectedInstOperands,
     /* 351574 */   // GIR_Coverage, 9078,
     /* 351574 */   GIR_EraseRootFromParent_Done,
     /* 351575 */ // Label 7080: @351575
     /* 351575 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(351663), // Rule ID 9079 //
     /* 351580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351590 */   // MIs[0] Operand 2
     /* 351590 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 351601 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351601 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351604 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351608 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351613 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351619 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351622 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351626 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351631 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351636 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351639 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351643 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351648 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351661 */   GIR_RootConstrainSelectedInstOperands,
     /* 351662 */   // GIR_Coverage, 9079,
     /* 351662 */   GIR_EraseRootFromParent_Done,
     /* 351663 */ // Label 7081: @351663
     /* 351663 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(351751), // Rule ID 9080 //
     /* 351668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351678 */   // MIs[0] Operand 2
     /* 351678 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 351689 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351689 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351692 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351696 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351701 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351707 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351710 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351714 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351719 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351736 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351749 */   GIR_RootConstrainSelectedInstOperands,
     /* 351750 */   // GIR_Coverage, 9080,
     /* 351750 */   GIR_EraseRootFromParent_Done,
     /* 351751 */ // Label 7082: @351751
     /* 351751 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351839), // Rule ID 9081 //
     /* 351756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351766 */   // MIs[0] Operand 2
     /* 351766 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 351777 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351777 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351780 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351784 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351789 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351795 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351798 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351802 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351807 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351824 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351837 */   GIR_RootConstrainSelectedInstOperands,
     /* 351838 */   // GIR_Coverage, 9081,
     /* 351838 */   GIR_EraseRootFromParent_Done,
     /* 351839 */ // Label 7083: @351839
     /* 351839 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(351927), // Rule ID 9082 //
     /* 351844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351854 */   // MIs[0] Operand 2
     /* 351854 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351865 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351865 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351868 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351872 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351877 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351883 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351886 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351890 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351895 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351912 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351925 */   GIR_RootConstrainSelectedInstOperands,
     /* 351926 */   // GIR_Coverage, 9082,
     /* 351926 */   GIR_EraseRootFromParent_Done,
     /* 351927 */ // Label 7084: @351927
     /* 351927 */ GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(352015), // Rule ID 9083 //
     /* 351932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351942 */   // MIs[0] Operand 2
     /* 351942 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 351953 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351953 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351956 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351960 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351965 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351971 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351974 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351978 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351983 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352000 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352013 */   GIR_RootConstrainSelectedInstOperands,
     /* 352014 */   // GIR_Coverage, 9083,
     /* 352014 */   GIR_EraseRootFromParent_Done,
     /* 352015 */ // Label 7085: @352015
     /* 352015 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(352103), // Rule ID 9084 //
     /* 352020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352030 */   // MIs[0] Operand 2
     /* 352030 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 352041 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352041 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352044 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352048 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352053 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352059 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352062 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352066 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352071 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352088 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352101 */   GIR_RootConstrainSelectedInstOperands,
     /* 352102 */   // GIR_Coverage, 9084,
     /* 352102 */   GIR_EraseRootFromParent_Done,
     /* 352103 */ // Label 7086: @352103
     /* 352103 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(352191), // Rule ID 9085 //
     /* 352108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352118 */   // MIs[0] Operand 2
     /* 352118 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 352129 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352129 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352132 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352136 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352141 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352147 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352150 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352154 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352159 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352176 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352189 */   GIR_RootConstrainSelectedInstOperands,
     /* 352190 */   // GIR_Coverage, 9085,
     /* 352190 */   GIR_EraseRootFromParent_Done,
     /* 352191 */ // Label 7087: @352191
     /* 352191 */ GIM_Reject,
     /* 352192 */ // Label 7023: @352192
     /* 352192 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(352227), // Rule ID 9036 //
     /* 352197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 352203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352207 */   // MIs[0] Operand 2
     /* 352207 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352218 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 352218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352223 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352225 */   GIR_RootConstrainSelectedInstOperands,
     /* 352226 */   // GIR_Coverage, 9036,
     /* 352226 */   GIR_EraseRootFromParent_Done,
     /* 352227 */ // Label 7088: @352227
     /* 352227 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(352262), // Rule ID 9037 //
     /* 352232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 352238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352242 */   // MIs[0] Operand 2
     /* 352242 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352253 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 352253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352258 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352260 */   GIR_RootConstrainSelectedInstOperands,
     /* 352261 */   // GIR_Coverage, 9037,
     /* 352261 */   GIR_EraseRootFromParent_Done,
     /* 352262 */ // Label 7089: @352262
     /* 352262 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(352316), // Rule ID 9046 //
     /* 352267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352277 */   // MIs[0] Operand 2
     /* 352277 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352288 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352300 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352314 */   GIR_RootConstrainSelectedInstOperands,
     /* 352315 */   // GIR_Coverage, 9046,
     /* 352315 */   GIR_EraseRootFromParent_Done,
     /* 352316 */ // Label 7090: @352316
     /* 352316 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(352370), // Rule ID 9047 //
     /* 352321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352331 */   // MIs[0] Operand 2
     /* 352331 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352342 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352368 */   GIR_RootConstrainSelectedInstOperands,
     /* 352369 */   // GIR_Coverage, 9047,
     /* 352369 */   GIR_EraseRootFromParent_Done,
     /* 352370 */ // Label 7091: @352370
     /* 352370 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(352424), // Rule ID 9048 //
     /* 352375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352385 */   // MIs[0] Operand 2
     /* 352385 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352396 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352408 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352422 */   GIR_RootConstrainSelectedInstOperands,
     /* 352423 */   // GIR_Coverage, 9048,
     /* 352423 */   GIR_EraseRootFromParent_Done,
     /* 352424 */ // Label 7092: @352424
     /* 352424 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(352478), // Rule ID 9049 //
     /* 352429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352439 */   // MIs[0] Operand 2
     /* 352439 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352450 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352462 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352476 */   GIR_RootConstrainSelectedInstOperands,
     /* 352477 */   // GIR_Coverage, 9049,
     /* 352477 */   GIR_EraseRootFromParent_Done,
     /* 352478 */ // Label 7093: @352478
     /* 352478 */ GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(352549), // Rule ID 9062 //
     /* 352483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352493 */   // MIs[0] Operand 2
     /* 352493 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352504 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352504 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352507 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352511 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352516 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352534 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352547 */   GIR_RootConstrainSelectedInstOperands,
     /* 352548 */   // GIR_Coverage, 9062,
     /* 352548 */   GIR_EraseRootFromParent_Done,
     /* 352549 */ // Label 7094: @352549
     /* 352549 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(352620), // Rule ID 9063 //
     /* 352554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352564 */   // MIs[0] Operand 2
     /* 352564 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352575 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352575 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352578 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352582 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352587 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352593 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352596 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352600 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352605 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352615 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352618 */   GIR_RootConstrainSelectedInstOperands,
     /* 352619 */   // GIR_Coverage, 9063,
     /* 352619 */   GIR_EraseRootFromParent_Done,
     /* 352620 */ // Label 7095: @352620
     /* 352620 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(352691), // Rule ID 9064 //
     /* 352625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352635 */   // MIs[0] Operand 2
     /* 352635 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352646 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352646 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352649 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352653 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352658 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352676 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352689 */   GIR_RootConstrainSelectedInstOperands,
     /* 352690 */   // GIR_Coverage, 9064,
     /* 352690 */   GIR_EraseRootFromParent_Done,
     /* 352691 */ // Label 7096: @352691
     /* 352691 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(352762), // Rule ID 9065 //
     /* 352696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352706 */   // MIs[0] Operand 2
     /* 352706 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352717 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352717 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352720 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352724 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352729 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352747 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352760 */   GIR_RootConstrainSelectedInstOperands,
     /* 352761 */   // GIR_Coverage, 9065,
     /* 352761 */   GIR_EraseRootFromParent_Done,
     /* 352762 */ // Label 7097: @352762
     /* 352762 */ GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352833), // Rule ID 9066 //
     /* 352767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352777 */   // MIs[0] Operand 2
     /* 352777 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352788 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352788 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352791 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352795 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352800 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352818 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352831 */   GIR_RootConstrainSelectedInstOperands,
     /* 352832 */   // GIR_Coverage, 9066,
     /* 352832 */   GIR_EraseRootFromParent_Done,
     /* 352833 */ // Label 7098: @352833
     /* 352833 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352904), // Rule ID 9067 //
     /* 352838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352848 */   // MIs[0] Operand 2
     /* 352848 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 352859 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352859 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352862 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352866 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352871 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352889 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352902 */   GIR_RootConstrainSelectedInstOperands,
     /* 352903 */   // GIR_Coverage, 9067,
     /* 352903 */   GIR_EraseRootFromParent_Done,
     /* 352904 */ // Label 7099: @352904
     /* 352904 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(352975), // Rule ID 9068 //
     /* 352909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352919 */   // MIs[0] Operand 2
     /* 352919 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 352930 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352930 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352933 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352937 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352942 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352960 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352973 */   GIR_RootConstrainSelectedInstOperands,
     /* 352974 */   // GIR_Coverage, 9068,
     /* 352974 */   GIR_EraseRootFromParent_Done,
     /* 352975 */ // Label 7100: @352975
     /* 352975 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(353046), // Rule ID 9069 //
     /* 352980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352990 */   // MIs[0] Operand 2
     /* 352990 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 353001 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353013 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353044 */   GIR_RootConstrainSelectedInstOperands,
     /* 353045 */   // GIR_Coverage, 9069,
     /* 353045 */   GIR_EraseRootFromParent_Done,
     /* 353046 */ // Label 7101: @353046
     /* 353046 */ GIM_Reject,
     /* 353047 */ // Label 7024: @353047
     /* 353047 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(353082), // Rule ID 9086 //
     /* 353052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 353058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353062 */   // MIs[0] Operand 2
     /* 353062 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353073 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 353073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 353076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353078 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353080 */   GIR_RootConstrainSelectedInstOperands,
     /* 353081 */   // GIR_Coverage, 9086,
     /* 353081 */   GIR_EraseRootFromParent_Done,
     /* 353082 */ // Label 7102: @353082
     /* 353082 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(353117), // Rule ID 9087 //
     /* 353087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 353093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353097 */   // MIs[0] Operand 2
     /* 353097 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353108 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 353108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353113 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353115 */   GIR_RootConstrainSelectedInstOperands,
     /* 353116 */   // GIR_Coverage, 9087,
     /* 353116 */   GIR_EraseRootFromParent_Done,
     /* 353117 */ // Label 7103: @353117
     /* 353117 */ GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(353171), // Rule ID 9092 //
     /* 353122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353132 */   // MIs[0] Operand 2
     /* 353132 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353143 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 353150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353155 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 353164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353169 */   GIR_RootConstrainSelectedInstOperands,
     /* 353170 */   // GIR_Coverage, 9092,
     /* 353170 */   GIR_EraseRootFromParent_Done,
     /* 353171 */ // Label 7104: @353171
     /* 353171 */ GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(353225), // Rule ID 9093 //
     /* 353176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353186 */   // MIs[0] Operand 2
     /* 353186 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353197 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 353204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353209 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353223 */   GIR_RootConstrainSelectedInstOperands,
     /* 353224 */   // GIR_Coverage, 9093,
     /* 353224 */   GIR_EraseRootFromParent_Done,
     /* 353225 */ // Label 7105: @353225
     /* 353225 */ GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(353279), // Rule ID 9094 //
     /* 353230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353240 */   // MIs[0] Operand 2
     /* 353240 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353251 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 353258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353263 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 353272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353277 */   GIR_RootConstrainSelectedInstOperands,
     /* 353278 */   // GIR_Coverage, 9094,
     /* 353278 */   GIR_EraseRootFromParent_Done,
     /* 353279 */ // Label 7106: @353279
     /* 353279 */ GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(353333), // Rule ID 9095 //
     /* 353284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353294 */   // MIs[0] Operand 2
     /* 353294 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 353305 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 353312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353317 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353331 */   GIR_RootConstrainSelectedInstOperands,
     /* 353332 */   // GIR_Coverage, 9095,
     /* 353332 */   GIR_EraseRootFromParent_Done,
     /* 353333 */ // Label 7107: @353333
     /* 353333 */ GIM_Reject,
     /* 353334 */ // Label 7025: @353334
     /* 353334 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(353403),
     /* 353339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353346 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(353374), // Rule ID 9090 //
     /* 353351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353354 */     // MIs[0] Operand 2
     /* 353354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353365 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 353365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 353368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353372 */     GIR_RootConstrainSelectedInstOperands,
     /* 353373 */     // GIR_Coverage, 9090,
     /* 353373 */     GIR_EraseRootFromParent_Done,
     /* 353374 */   // Label 7109: @353374
     /* 353374 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(353402), // Rule ID 9091 //
     /* 353379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353382 */     // MIs[0] Operand 2
     /* 353382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353393 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 353393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353400 */     GIR_RootConstrainSelectedInstOperands,
     /* 353401 */     // GIR_Coverage, 9091,
     /* 353401 */     GIR_EraseRootFromParent_Done,
     /* 353402 */   // Label 7110: @353402
     /* 353402 */   GIM_Reject,
     /* 353403 */ // Label 7108: @353403
     /* 353403 */ GIM_Reject,
     /* 353404 */ // Label 7026: @353404
     /* 353404 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(353439), // Rule ID 9038 //
     /* 353409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353419 */   // MIs[0] Operand 2
     /* 353419 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353430 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 353430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353435 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353437 */   GIR_RootConstrainSelectedInstOperands,
     /* 353438 */   // GIR_Coverage, 9038,
     /* 353438 */   GIR_EraseRootFromParent_Done,
     /* 353439 */ // Label 7111: @353439
     /* 353439 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(353474), // Rule ID 9039 //
     /* 353444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353454 */   // MIs[0] Operand 2
     /* 353454 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353465 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 353465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353470 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353472 */   GIR_RootConstrainSelectedInstOperands,
     /* 353473 */   // GIR_Coverage, 9039,
     /* 353473 */   GIR_EraseRootFromParent_Done,
     /* 353474 */ // Label 7112: @353474
     /* 353474 */ GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(353528), // Rule ID 9050 //
     /* 353479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353489 */   // MIs[0] Operand 2
     /* 353489 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353500 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353512 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353526 */   GIR_RootConstrainSelectedInstOperands,
     /* 353527 */   // GIR_Coverage, 9050,
     /* 353527 */   GIR_EraseRootFromParent_Done,
     /* 353528 */ // Label 7113: @353528
     /* 353528 */ GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(353582), // Rule ID 9051 //
     /* 353533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353543 */   // MIs[0] Operand 2
     /* 353543 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353554 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353566 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353580 */   GIR_RootConstrainSelectedInstOperands,
     /* 353581 */   // GIR_Coverage, 9051,
     /* 353581 */   GIR_EraseRootFromParent_Done,
     /* 353582 */ // Label 7114: @353582
     /* 353582 */ GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(353636), // Rule ID 9052 //
     /* 353587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353597 */   // MIs[0] Operand 2
     /* 353597 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 353608 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353620 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353634 */   GIR_RootConstrainSelectedInstOperands,
     /* 353635 */   // GIR_Coverage, 9052,
     /* 353635 */   GIR_EraseRootFromParent_Done,
     /* 353636 */ // Label 7115: @353636
     /* 353636 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353690), // Rule ID 9053 //
     /* 353641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353651 */   // MIs[0] Operand 2
     /* 353651 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 353662 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353674 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353688 */   GIR_RootConstrainSelectedInstOperands,
     /* 353689 */   // GIR_Coverage, 9053,
     /* 353689 */   GIR_EraseRootFromParent_Done,
     /* 353690 */ // Label 7116: @353690
     /* 353690 */ GIM_Reject,
     /* 353691 */ // Label 7027: @353691
     /* 353691 */ GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(353760),
     /* 353696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353703 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(353731), // Rule ID 9088 //
     /* 353708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353711 */     // MIs[0] Operand 2
     /* 353711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353722 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 353722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 353725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353729 */     GIR_RootConstrainSelectedInstOperands,
     /* 353730 */     // GIR_Coverage, 9088,
     /* 353730 */     GIR_EraseRootFromParent_Done,
     /* 353731 */   // Label 7118: @353731
     /* 353731 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(353759), // Rule ID 9089 //
     /* 353736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353739 */     // MIs[0] Operand 2
     /* 353739 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353750 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 353750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 353753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353757 */     GIR_RootConstrainSelectedInstOperands,
     /* 353758 */     // GIR_Coverage, 9089,
     /* 353758 */     GIR_EraseRootFromParent_Done,
     /* 353759 */   // Label 7119: @353759
     /* 353759 */   GIM_Reject,
     /* 353760 */ // Label 7117: @353760
     /* 353760 */ GIM_Reject,
     /* 353761 */ // Label 7028: @353761
     /* 353761 */ GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(353830),
     /* 353766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353773 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(353801), // Rule ID 9040 //
     /* 353778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353781 */     // MIs[0] Operand 2
     /* 353781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353792 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 353792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353799 */     GIR_RootConstrainSelectedInstOperands,
     /* 353800 */     // GIR_Coverage, 9040,
     /* 353800 */     GIR_EraseRootFromParent_Done,
     /* 353801 */   // Label 7121: @353801
     /* 353801 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(353829), // Rule ID 9041 //
     /* 353806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353809 */     // MIs[0] Operand 2
     /* 353809 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 353820 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 353820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353827 */     GIR_RootConstrainSelectedInstOperands,
     /* 353828 */     // GIR_Coverage, 9041,
     /* 353828 */     GIR_EraseRootFromParent_Done,
     /* 353829 */   // Label 7122: @353829
     /* 353829 */   GIM_Reject,
     /* 353830 */ // Label 7120: @353830
     /* 353830 */ GIM_Reject,
     /* 353831 */ // Label 7029: @353831
     /* 353831 */ GIM_Reject,
     /* 353832 */ // Label 90: @353832
     /* 353832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7138*/ GIMT_Encode4(386753),
     /* 353843 */ /*GILLT_s64*//*Label 7123*/ GIMT_Encode4(353927), GIMT_Encode4(0),
     /* 353851 */ /*GILLT_v2s32*//*Label 7124*/ GIMT_Encode4(354637),
     /* 353855 */ /*GILLT_v2s64*//*Label 7125*/ GIMT_Encode4(358168),
     /* 353859 */ /*GILLT_v4s16*//*Label 7126*/ GIMT_Encode4(361409),
     /* 353863 */ /*GILLT_v4s32*//*Label 7127*/ GIMT_Encode4(365049),
     /* 353867 */ /*GILLT_v8s8*//*Label 7128*/ GIMT_Encode4(368117),
     /* 353871 */ /*GILLT_v8s16*//*Label 7129*/ GIMT_Encode4(371330),
     /* 353875 */ /*GILLT_v16s8*//*Label 7130*/ GIMT_Encode4(374749), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 353887 */ /*GILLT_nxv2s16*//*Label 7131*/ GIMT_Encode4(377953),
     /* 353891 */ /*GILLT_nxv2s32*//*Label 7132*/ GIMT_Encode4(378078),
     /* 353895 */ /*GILLT_nxv2s64*//*Label 7133*/ GIMT_Encode4(378203), GIMT_Encode4(0),
     /* 353903 */ /*GILLT_nxv4s16*//*Label 7134*/ GIMT_Encode4(380181),
     /* 353907 */ /*GILLT_nxv4s32*//*Label 7135*/ GIMT_Encode4(380333), GIMT_Encode4(0),
     /* 353915 */ /*GILLT_nxv8s16*//*Label 7136*/ GIMT_Encode4(382365), GIMT_Encode4(0),
     /* 353923 */ /*GILLT_nxv16s8*//*Label 7137*/ GIMT_Encode4(384633),
     /* 353927 */ // Label 7123: @353927
     /* 353927 */ GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(354636),
     /* 353932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 353935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353945 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(354075), // Rule ID 5755 //
     /* 353950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 353966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353983 */     // MIs[2] Operand 1
     /* 353983 */     // No operand predicates
     /* 353983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353991 */     // MIs[3] Operand 1
     /* 353991 */     // No operand predicates
     /* 353991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353993 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 353996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354005 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354008 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354012 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 354032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354074 */     // GIR_Coverage, 5755,
     /* 354074 */     GIR_EraseRootFromParent_Done,
     /* 354075 */   // Label 7140: @354075
     /* 354075 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354236), // Rule ID 5756 //
     /* 354080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 354096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354113 */     // MIs[2] Operand 1
     /* 354113 */     // No operand predicates
     /* 354113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354121 */     // MIs[3] Operand 1
     /* 354121 */     // No operand predicates
     /* 354121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354123 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354123 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 354126 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354130 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354135 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 354138 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354142 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 354145 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354150 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354155 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 354158 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354162 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354167 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354174 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354177 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354182 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 354194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354218 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354235 */     // GIR_Coverage, 5756,
     /* 354235 */     GIR_EraseRootFromParent_Done,
     /* 354236 */   // Label 7141: @354236
     /* 354236 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(354366), // Rule ID 5795 //
     /* 354241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 354257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354274 */     // MIs[2] Operand 1
     /* 354274 */     // No operand predicates
     /* 354274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354282 */     // MIs[3] Operand 1
     /* 354282 */     // No operand predicates
     /* 354282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354284 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 354287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354303 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354306 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354311 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 354323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354348 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354365 */     // GIR_Coverage, 5795,
     /* 354365 */     GIR_EraseRootFromParent_Done,
     /* 354366 */   // Label 7142: @354366
     /* 354366 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(354527), // Rule ID 5796 //
     /* 354371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 354387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354404 */     // MIs[2] Operand 1
     /* 354404 */     // No operand predicates
     /* 354404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354412 */     // MIs[3] Operand 1
     /* 354412 */     // No operand predicates
     /* 354412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354414 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354414 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 354417 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354421 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354426 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 354429 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354433 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 354436 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354441 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 354449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354458 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354461 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354465 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 354485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354496 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354526 */     // GIR_Coverage, 5796,
     /* 354526 */     GIR_EraseRootFromParent_Done,
     /* 354527 */   // Label 7143: @354527
     /* 354527 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(354563), // Rule ID 6716 //
     /* 354532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354550 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 354550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 354557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354562 */     // GIR_Coverage, 6716,
     /* 354562 */     GIR_EraseRootFromParent_Done,
     /* 354563 */   // Label 7144: @354563
     /* 354563 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(354599), // Rule ID 6718 //
     /* 354568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354586 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 354586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 354593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354598 */     // GIR_Coverage, 6718,
     /* 354598 */     GIR_EraseRootFromParent_Done,
     /* 354599 */   // Label 7145: @354599
     /* 354599 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(354635), // Rule ID 6720 //
     /* 354604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354622 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 354622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354625 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 354627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 354629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354634 */     // GIR_Coverage, 6720,
     /* 354634 */     GIR_EraseRootFromParent_Done,
     /* 354635 */   // Label 7146: @354635
     /* 354635 */   GIM_Reject,
     /* 354636 */ // Label 7139: @354636
     /* 354636 */ GIM_Reject,
     /* 354637 */ // Label 7124: @354637
     /* 354637 */ GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(358167),
     /* 354642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 354645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354655 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(354764), // Rule ID 4312 //
     /* 354660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354670 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354680 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354687 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354704 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354731 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354763 */     // GIR_Coverage, 4312,
     /* 354763 */     GIR_EraseRootFromParent_Done,
     /* 354764 */   // Label 7148: @354764
     /* 354764 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(354873), // Rule ID 4313 //
     /* 354769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354773 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354779 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354789 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354796 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354813 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354872 */     // GIR_Coverage, 4313,
     /* 354872 */     GIR_EraseRootFromParent_Done,
     /* 354873 */   // Label 7149: @354873
     /* 354873 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(354982), // Rule ID 4420 //
     /* 354878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354882 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354888 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354898 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354905 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354922 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354949 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354981 */     // GIR_Coverage, 4420,
     /* 354981 */     GIR_EraseRootFromParent_Done,
     /* 354982 */   // Label 7150: @354982
     /* 354982 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(355091), // Rule ID 4421 //
     /* 354987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354991 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354997 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355007 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355031 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355058 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355090 */     // GIR_Coverage, 4421,
     /* 355090 */     GIR_EraseRootFromParent_Done,
     /* 355091 */   // Label 7151: @355091
     /* 355091 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(355196), // Rule ID 4318 //
     /* 355096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355112 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355119 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355136 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355163 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355195 */     // GIR_Coverage, 4318,
     /* 355195 */     GIR_EraseRootFromParent_Done,
     /* 355196 */   // Label 7152: @355196
     /* 355196 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(355301), // Rule ID 4320 //
     /* 355201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355217 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355220 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355224 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355241 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355268 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355300 */     // GIR_Coverage, 4320,
     /* 355300 */     GIR_EraseRootFromParent_Done,
     /* 355301 */   // Label 7153: @355301
     /* 355301 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(355406), // Rule ID 4426 //
     /* 355306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355322 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355329 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355346 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355373 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355405 */     // GIR_Coverage, 4426,
     /* 355405 */     GIR_EraseRootFromParent_Done,
     /* 355406 */   // Label 7154: @355406
     /* 355406 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(355511), // Rule ID 4428 //
     /* 355411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355427 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355451 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355478 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355510 */     // GIR_Coverage, 4428,
     /* 355510 */     GIR_EraseRootFromParent_Done,
     /* 355511 */   // Label 7155: @355511
     /* 355511 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(355615), // Rule ID 4310 //
     /* 355516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355526 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355536 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355543 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355560 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355582 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355614 */     // GIR_Coverage, 4310,
     /* 355614 */     GIR_EraseRootFromParent_Done,
     /* 355615 */   // Label 7156: @355615
     /* 355615 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(355719), // Rule ID 4311 //
     /* 355620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355624 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355630 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355640 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355647 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355664 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355686 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355718 */     // GIR_Coverage, 4311,
     /* 355718 */     GIR_EraseRootFromParent_Done,
     /* 355719 */   // Label 7157: @355719
     /* 355719 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(355823), // Rule ID 4418 //
     /* 355724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355728 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355734 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355744 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355751 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355768 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355790 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355822 */     // GIR_Coverage, 4418,
     /* 355822 */     GIR_EraseRootFromParent_Done,
     /* 355823 */   // Label 7158: @355823
     /* 355823 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(355927), // Rule ID 4419 //
     /* 355828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355832 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355838 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355848 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355855 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355872 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355894 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355926 */     // GIR_Coverage, 4419,
     /* 355926 */     GIR_EraseRootFromParent_Done,
     /* 355927 */   // Label 7159: @355927
     /* 355927 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(356027), // Rule ID 4314 //
     /* 355932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355948 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355955 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355972 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356026 */     // GIR_Coverage, 4314,
     /* 356026 */     GIR_EraseRootFromParent_Done,
     /* 356027 */   // Label 7160: @356027
     /* 356027 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(356127), // Rule ID 4316 //
     /* 356032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356072 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356094 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356126 */     // GIR_Coverage, 4316,
     /* 356126 */     GIR_EraseRootFromParent_Done,
     /* 356127 */   // Label 7161: @356127
     /* 356127 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(356227), // Rule ID 4422 //
     /* 356132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356148 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356172 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356226 */     // GIR_Coverage, 4422,
     /* 356226 */     GIR_EraseRootFromParent_Done,
     /* 356227 */   // Label 7162: @356227
     /* 356227 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(356327), // Rule ID 4424 //
     /* 356232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356248 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356272 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356326 */     // GIR_Coverage, 4424,
     /* 356326 */     GIR_EraseRootFromParent_Done,
     /* 356327 */   // Label 7163: @356327
     /* 356327 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(356447), // Rule ID 6494 //
     /* 356332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356351 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356354 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356358 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 356365 */     // MIs[2] Rn
     /* 356365 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 356369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356380 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 356383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 356401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356406 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356409 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 356416 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356446 */     // GIR_Coverage, 6494,
     /* 356446 */     GIR_EraseRootFromParent_Done,
     /* 356447 */   // Label 7164: @356447
     /* 356447 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(356567), // Rule ID 6496 //
     /* 356452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356471 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356474 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356478 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356485 */     // MIs[2] Rn
     /* 356485 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 356489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356500 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356500 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 356503 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356507 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 356521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 356536 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356549 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356566 */     // GIR_Coverage, 6496,
     /* 356566 */     GIR_EraseRootFromParent_Done,
     /* 356567 */   // Label 7165: @356567
     /* 356567 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(356697), // Rule ID 5747 //
     /* 356572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356605 */     // MIs[2] Operand 1
     /* 356605 */     // No operand predicates
     /* 356605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356613 */     // MIs[3] Operand 1
     /* 356613 */     // No operand predicates
     /* 356613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356615 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356627 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356634 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356696 */     // GIR_Coverage, 5747,
     /* 356696 */     GIR_EraseRootFromParent_Done,
     /* 356697 */   // Label 7166: @356697
     /* 356697 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(356858), // Rule ID 5748 //
     /* 356702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356735 */     // MIs[2] Operand 1
     /* 356735 */     // No operand predicates
     /* 356735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356743 */     // MIs[3] Operand 1
     /* 356743 */     // No operand predicates
     /* 356743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356745 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356745 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 356748 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356752 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356757 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356760 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356764 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 356767 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356772 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356789 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356792 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356796 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356821 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356840 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356857 */     // GIR_Coverage, 5748,
     /* 356857 */     GIR_EraseRootFromParent_Done,
     /* 356858 */   // Label 7167: @356858
     /* 356858 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(356988), // Rule ID 5787 //
     /* 356863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356896 */     // MIs[2] Operand 1
     /* 356896 */     // No operand predicates
     /* 356896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356904 */     // MIs[3] Operand 1
     /* 356904 */     // No operand predicates
     /* 356904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356906 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356918 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356921 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356925 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356970 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356987 */     // GIR_Coverage, 5787,
     /* 356987 */     GIR_EraseRootFromParent_Done,
     /* 356988 */   // Label 7168: @356988
     /* 356988 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(357149), // Rule ID 5788 //
     /* 356993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357026 */     // MIs[2] Operand 1
     /* 357026 */     // No operand predicates
     /* 357026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357034 */     // MIs[3] Operand 1
     /* 357034 */     // No operand predicates
     /* 357034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357036 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 357036 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 357039 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357043 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357048 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357051 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357055 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 357058 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357063 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357080 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 357087 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 357118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 357124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357131 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357148 */     // GIR_Coverage, 5788,
     /* 357148 */     GIR_EraseRootFromParent_Done,
     /* 357149 */   // Label 7169: @357149
     /* 357149 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(357215), // Rule ID 5694 //
     /* 357154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357172 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 357172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 357175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 357196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357214 */     // GIR_Coverage, 5694,
     /* 357214 */     GIR_EraseRootFromParent_Done,
     /* 357215 */   // Label 7170: @357215
     /* 357215 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(357281), // Rule ID 5710 //
     /* 357220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357238 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 357238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 357241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 357262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357280 */     // GIR_Coverage, 5710,
     /* 357280 */     GIR_EraseRootFromParent_Done,
     /* 357281 */   // Label 7171: @357281
     /* 357281 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(357416), // Rule ID 5718 //
     /* 357286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 357298 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 357302 */     // MIs[1] Operand 1
     /* 357302 */     // No operand predicates
     /* 357302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357314 */     // MIs[2] Operand 1
     /* 357314 */     // No operand predicates
     /* 357314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357316 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 357316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357342 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357345 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357349 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 357374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 357385 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 357391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357398 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357415 */     // GIR_Coverage, 5718,
     /* 357415 */     GIR_EraseRootFromParent_Done,
     /* 357416 */   // Label 7172: @357416
     /* 357416 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(357548), // Rule ID 6503 //
     /* 357421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 357440 */     // MIs[1] Rn
     /* 357440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 357444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357457 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357461 */     // MIs[2] Operand 1
     /* 357461 */     // No operand predicates
     /* 357461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357463 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357463 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357466 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357470 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357475 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357478 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 357482 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357485 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357490 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 357502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357507 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 357513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357517 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357530 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357547 */     // GIR_Coverage, 6503,
     /* 357547 */     GIR_EraseRootFromParent_Done,
     /* 357548 */   // Label 7173: @357548
     /* 357548 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(357680), // Rule ID 6504 //
     /* 357553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357565 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 357572 */     // MIs[1] Rn
     /* 357572 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 357576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357593 */     // MIs[2] Operand 1
     /* 357593 */     // No operand predicates
     /* 357593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357595 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357595 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357598 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357602 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357607 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 357614 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 357634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 357645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357649 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357662 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357679 */     // GIR_Coverage, 6504,
     /* 357679 */     GIR_EraseRootFromParent_Done,
     /* 357680 */   // Label 7174: @357680
     /* 357680 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(357863), // Rule ID 5798 //
     /* 357685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 357693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 357697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357710 */     // MIs[2] Operand 1
     /* 357710 */     // No operand predicates
     /* 357710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357712 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 357712 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 357715 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357719 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357726 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 357729 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357733 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357738 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357741 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 357745 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 357748 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357753 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357758 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357763 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357766 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357770 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357789 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357792 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 357796 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357826 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 357832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357845 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357862 */     // GIR_Coverage, 5798,
     /* 357862 */     GIR_EraseRootFromParent_Done,
     /* 357863 */   // Label 7175: @357863
     /* 357863 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358041), // Rule ID 5721 //
     /* 357868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357888 */     // MIs[1] Operand 1
     /* 357888 */     // No operand predicates
     /* 357888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357890 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 357890 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357893 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357897 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357904 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357907 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357911 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357916 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357919 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 357923 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 357926 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357931 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357936 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357941 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357944 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357948 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357967 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357974 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357977 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 358010 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358013 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 358016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358023 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358040 */     // GIR_Coverage, 5721,
     /* 358040 */     GIR_EraseRootFromParent_Done,
     /* 358041 */   // Label 7176: @358041
     /* 358041 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(358166), // Rule ID 5724 //
     /* 358046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 358058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358066 */     // MIs[1] Operand 1
     /* 358066 */     // No operand predicates
     /* 358066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358068 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 358068 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 358071 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358075 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 358085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358094 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 358097 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 358101 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 358126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358131 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 358137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 358141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358148 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358165 */     // GIR_Coverage, 5724,
     /* 358165 */     GIR_EraseRootFromParent_Done,
     /* 358166 */   // Label 7177: @358166
     /* 358166 */   GIM_Reject,
     /* 358167 */ // Label 7147: @358167
     /* 358167 */ GIM_Reject,
     /* 358168 */ // Label 7125: @358168
     /* 358168 */ GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(361408),
     /* 358173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358186 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(358295), // Rule ID 4336 //
     /* 358191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358195 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358201 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358211 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358214 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358218 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358235 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358262 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358294 */     // GIR_Coverage, 4336,
     /* 358294 */     GIR_EraseRootFromParent_Done,
     /* 358295 */   // Label 7179: @358295
     /* 358295 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(358404), // Rule ID 4337 //
     /* 358300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358320 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358327 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358344 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358371 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358403 */     // GIR_Coverage, 4337,
     /* 358403 */     GIR_EraseRootFromParent_Done,
     /* 358404 */   // Label 7180: @358404
     /* 358404 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(358513), // Rule ID 4444 //
     /* 358409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358413 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358419 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358429 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358436 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358453 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358480 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358512 */     // GIR_Coverage, 4444,
     /* 358512 */     GIR_EraseRootFromParent_Done,
     /* 358513 */   // Label 7181: @358513
     /* 358513 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(358622), // Rule ID 4445 //
     /* 358518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358522 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358528 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358538 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358545 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358562 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358589 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358621 */     // GIR_Coverage, 4445,
     /* 358621 */     GIR_EraseRootFromParent_Done,
     /* 358622 */   // Label 7182: @358622
     /* 358622 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(358727), // Rule ID 4342 //
     /* 358627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358650 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358667 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358694 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358726 */     // GIR_Coverage, 4342,
     /* 358726 */     GIR_EraseRootFromParent_Done,
     /* 358727 */   // Label 7183: @358727
     /* 358727 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(358832), // Rule ID 4344 //
     /* 358732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358748 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358755 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358772 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358799 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358831 */     // GIR_Coverage, 4344,
     /* 358831 */     GIR_EraseRootFromParent_Done,
     /* 358832 */   // Label 7184: @358832
     /* 358832 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(358937), // Rule ID 4450 //
     /* 358837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358853 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358860 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358877 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358904 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358936 */     // GIR_Coverage, 4450,
     /* 358936 */     GIR_EraseRootFromParent_Done,
     /* 358937 */   // Label 7185: @358937
     /* 358937 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(359042), // Rule ID 4452 //
     /* 358942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358958 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358965 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358982 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359009 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359041 */     // GIR_Coverage, 4452,
     /* 359041 */     GIR_EraseRootFromParent_Done,
     /* 359042 */   // Label 7186: @359042
     /* 359042 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(359146), // Rule ID 4334 //
     /* 359047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359051 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359057 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359067 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359074 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359091 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359113 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359145 */     // GIR_Coverage, 4334,
     /* 359145 */     GIR_EraseRootFromParent_Done,
     /* 359146 */   // Label 7187: @359146
     /* 359146 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(359250), // Rule ID 4335 //
     /* 359151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359155 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359161 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359171 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359178 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359195 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359217 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359249 */     // GIR_Coverage, 4335,
     /* 359249 */     GIR_EraseRootFromParent_Done,
     /* 359250 */   // Label 7188: @359250
     /* 359250 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(359354), // Rule ID 4442 //
     /* 359255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359259 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359265 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359275 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359282 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359299 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359321 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359353 */     // GIR_Coverage, 4442,
     /* 359353 */     GIR_EraseRootFromParent_Done,
     /* 359354 */   // Label 7189: @359354
     /* 359354 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(359458), // Rule ID 4443 //
     /* 359359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359363 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359369 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359379 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359386 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359403 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359457 */     // GIR_Coverage, 4443,
     /* 359457 */     GIR_EraseRootFromParent_Done,
     /* 359458 */   // Label 7190: @359458
     /* 359458 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(359558), // Rule ID 4338 //
     /* 359463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359479 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359486 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359503 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359525 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359557 */     // GIR_Coverage, 4338,
     /* 359557 */     GIR_EraseRootFromParent_Done,
     /* 359558 */   // Label 7191: @359558
     /* 359558 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(359658), // Rule ID 4340 //
     /* 359563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359579 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359582 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359586 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359603 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359625 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359657 */     // GIR_Coverage, 4340,
     /* 359657 */     GIR_EraseRootFromParent_Done,
     /* 359658 */   // Label 7192: @359658
     /* 359658 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(359758), // Rule ID 4446 //
     /* 359663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359679 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359682 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359686 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359703 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359757 */     // GIR_Coverage, 4446,
     /* 359757 */     GIR_EraseRootFromParent_Done,
     /* 359758 */   // Label 7193: @359758
     /* 359758 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(359858), // Rule ID 4448 //
     /* 359763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359779 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359786 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359803 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359825 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359857 */     // GIR_Coverage, 4448,
     /* 359857 */     GIR_EraseRootFromParent_Done,
     /* 359858 */   // Label 7194: @359858
     /* 359858 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(359971), // Rule ID 5753 //
     /* 359863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 359896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359900 */     // MIs[3] Operand 1
     /* 359900 */     // No operand predicates
     /* 359900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359906 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 359906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 359909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 359913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359918 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 359925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 359952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359970 */     // GIR_Coverage, 5753,
     /* 359970 */     GIR_EraseRootFromParent_Done,
     /* 359971 */   // Label 7195: @359971
     /* 359971 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(360084), // Rule ID 5793 //
     /* 359976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360013 */     // MIs[3] Operand 1
     /* 360013 */     // No operand predicates
     /* 360013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360019 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 360019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 360022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 360026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 360035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 360038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 360065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360083 */     // GIR_Coverage, 5793,
     /* 360083 */     GIR_EraseRootFromParent_Done,
     /* 360084 */   // Label 7196: @360084
     /* 360084 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(360162), // Rule ID 1941 //
     /* 360089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360129 */     // MIs[2] Operand 1
     /* 360129 */     // No operand predicates
     /* 360129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360137 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360141 */     // MIs[3] Operand 1
     /* 360141 */     // No operand predicates
     /* 360141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360143 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 360143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 360160 */     GIR_RootConstrainSelectedInstOperands,
     /* 360161 */     // GIR_Coverage, 1941,
     /* 360161 */     GIR_EraseRootFromParent_Done,
     /* 360162 */   // Label 7197: @360162
     /* 360162 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(360257), // Rule ID 7483 //
     /* 360167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 360170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 360182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360194 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 360197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360201 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 360208 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 360211 */     // MIs[2] Rn
     /* 360211 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 360215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360228 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360232 */     // MIs[3] Operand 1
     /* 360232 */     // No operand predicates
     /* 360232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360234 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15852>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 360237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 360248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 360255 */     GIR_RootConstrainSelectedInstOperands,
     /* 360256 */     // GIR_Coverage, 7483,
     /* 360256 */     GIR_EraseRootFromParent_Done,
     /* 360257 */   // Label 7198: @360257
     /* 360257 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(360346), // Rule ID 5750 //
     /* 360262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 360274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360286 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360290 */     // MIs[2] Operand 1
     /* 360290 */     // No operand predicates
     /* 360290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360298 */     // MIs[3] Operand 1
     /* 360298 */     // No operand predicates
     /* 360298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360300 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 360300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360312 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 360318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360344 */     GIR_RootConstrainSelectedInstOperands,
     /* 360345 */     // GIR_Coverage, 5750,
     /* 360345 */     GIR_EraseRootFromParent_Done,
     /* 360346 */   // Label 7199: @360346
     /* 360346 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(360435), // Rule ID 5790 //
     /* 360351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 360363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360375 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360379 */     // MIs[2] Operand 1
     /* 360379 */     // No operand predicates
     /* 360379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360387 */     // MIs[3] Operand 1
     /* 360387 */     // No operand predicates
     /* 360387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360389 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 360389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360401 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 360407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360433 */     GIR_RootConstrainSelectedInstOperands,
     /* 360434 */     // GIR_Coverage, 5790,
     /* 360434 */     GIR_EraseRootFromParent_Done,
     /* 360435 */   // Label 7200: @360435
     /* 360435 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(360502), // Rule ID 5752 //
     /* 360440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360473 */     // MIs[2] Operand 1
     /* 360473 */     // No operand predicates
     /* 360473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360481 */     // MIs[3] Operand 1
     /* 360481 */     // No operand predicates
     /* 360481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360483 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 360483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360500 */     GIR_RootConstrainSelectedInstOperands,
     /* 360501 */     // GIR_Coverage, 5752,
     /* 360501 */     GIR_EraseRootFromParent_Done,
     /* 360502 */   // Label 7201: @360502
     /* 360502 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(360600), // Rule ID 5754 //
     /* 360507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360540 */     // MIs[2] Operand 1
     /* 360540 */     // No operand predicates
     /* 360540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360548 */     // MIs[3] Operand 1
     /* 360548 */     // No operand predicates
     /* 360548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360550 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 360550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360562 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 360565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360569 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360598 */     GIR_RootConstrainSelectedInstOperands,
     /* 360599 */     // GIR_Coverage, 5754,
     /* 360599 */     GIR_EraseRootFromParent_Done,
     /* 360600 */   // Label 7202: @360600
     /* 360600 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(360667), // Rule ID 5792 //
     /* 360605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360638 */     // MIs[2] Operand 1
     /* 360638 */     // No operand predicates
     /* 360638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360646 */     // MIs[3] Operand 1
     /* 360646 */     // No operand predicates
     /* 360646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360648 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 360648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360665 */     GIR_RootConstrainSelectedInstOperands,
     /* 360666 */     // GIR_Coverage, 5792,
     /* 360666 */     GIR_EraseRootFromParent_Done,
     /* 360667 */   // Label 7203: @360667
     /* 360667 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(360765), // Rule ID 5794 //
     /* 360672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360705 */     // MIs[2] Operand 1
     /* 360705 */     // No operand predicates
     /* 360705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360713 */     // MIs[3] Operand 1
     /* 360713 */     // No operand predicates
     /* 360713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360715 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 360715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360727 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 360730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360763 */     GIR_RootConstrainSelectedInstOperands,
     /* 360764 */     // GIR_Coverage, 5794,
     /* 360764 */     GIR_EraseRootFromParent_Done,
     /* 360765 */   // Label 7204: @360765
     /* 360765 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(360831), // Rule ID 5698 //
     /* 360770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360788 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 360788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360830 */     // GIR_Coverage, 5698,
     /* 360830 */     GIR_EraseRootFromParent_Done,
     /* 360831 */   // Label 7205: @360831
     /* 360831 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(360897), // Rule ID 5712 //
     /* 360836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360854 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 360854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360896 */     // GIR_Coverage, 5712,
     /* 360896 */     GIR_EraseRootFromParent_Done,
     /* 360897 */   // Label 7206: @360897
     /* 360897 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(360966), // Rule ID 6485 //
     /* 360902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360914 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360917 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360921 */     // MIs[1] Rn
     /* 360921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360938 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360942 */     // MIs[2] Operand 1
     /* 360942 */     // No operand predicates
     /* 360942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360944 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 360947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360964 */     GIR_RootConstrainSelectedInstOperands,
     /* 360965 */     // GIR_Coverage, 6485,
     /* 360965 */     GIR_EraseRootFromParent_Done,
     /* 360966 */   // Label 7207: @360966
     /* 360966 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(361035), // Rule ID 6486 //
     /* 360971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360990 */     // MIs[1] Rn
     /* 360990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 361003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361007 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361011 */     // MIs[2] Operand 1
     /* 361011 */     // No operand predicates
     /* 361011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361013 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 361013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 361016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361033 */     GIR_RootConstrainSelectedInstOperands,
     /* 361034 */     // GIR_Coverage, 6486,
     /* 361034 */     GIR_EraseRootFromParent_Done,
     /* 361035 */   // Label 7208: @361035
     /* 361035 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(361117), // Rule ID 7482 //
     /* 361040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 361043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361055 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 361058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 361062 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 361069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 361072 */     // MIs[1] Rn
     /* 361072 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 361076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 361081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 361085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361089 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361093 */     // MIs[2] Operand 1
     /* 361093 */     // No operand predicates
     /* 361093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361095 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15852>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 361095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 361098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361115 */     GIR_RootConstrainSelectedInstOperands,
     /* 361116 */     // GIR_Coverage, 7482,
     /* 361116 */     GIR_EraseRootFromParent_Done,
     /* 361117 */   // Label 7209: @361117
     /* 361117 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(361166), // Rule ID 5719 //
     /* 361122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 361130 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 361134 */     // MIs[1] Operand 1
     /* 361134 */     // No operand predicates
     /* 361134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 361138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361146 */     // MIs[2] Operand 1
     /* 361146 */     // No operand predicates
     /* 361146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361148 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 361148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 361151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 361158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361164 */     GIR_RootConstrainSelectedInstOperands,
     /* 361165 */     // GIR_Coverage, 5719,
     /* 361165 */     GIR_EraseRootFromParent_Done,
     /* 361166 */   // Label 7210: @361166
     /* 361166 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(361267), // Rule ID 5799 //
     /* 361171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 361179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 361183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 361192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361196 */     // MIs[2] Operand 1
     /* 361196 */     // No operand predicates
     /* 361196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361198 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 361201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361224 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 361231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 361259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361265 */     GIR_RootConstrainSelectedInstOperands,
     /* 361266 */     // GIR_Coverage, 5799,
     /* 361266 */     GIR_EraseRootFromParent_Done,
     /* 361267 */   // Label 7211: @361267
     /* 361267 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(361311), // Rule ID 1937 //
     /* 361272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 361287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361295 */     // MIs[1] Operand 1
     /* 361295 */     // No operand predicates
     /* 361295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361297 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 361297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 361300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 361307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361309 */     GIR_RootConstrainSelectedInstOperands,
     /* 361310 */     // GIR_Coverage, 1937,
     /* 361310 */     GIR_EraseRootFromParent_Done,
     /* 361311 */   // Label 7212: @361311
     /* 361311 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(361407), // Rule ID 5723 //
     /* 361316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 361328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361336 */     // MIs[1] Operand 1
     /* 361336 */     // No operand predicates
     /* 361336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361338 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361338 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 361341 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361345 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361367 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 361371 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 361399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361405 */     GIR_RootConstrainSelectedInstOperands,
     /* 361406 */     // GIR_Coverage, 5723,
     /* 361406 */     GIR_EraseRootFromParent_Done,
     /* 361407 */   // Label 7213: @361407
     /* 361407 */   GIM_Reject,
     /* 361408 */ // Label 7178: @361408
     /* 361408 */ GIM_Reject,
     /* 361409 */ // Label 7126: @361409
     /* 361409 */ GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(365048),
     /* 361414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 361417 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(361543), // Rule ID 4276 //
     /* 361422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361436 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361442 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361452 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361455 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361459 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361466 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361483 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361510 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361542 */     // GIR_Coverage, 4276,
     /* 361542 */     GIR_EraseRootFromParent_Done,
     /* 361543 */   // Label 7215: @361543
     /* 361543 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(361669), // Rule ID 4277 //
     /* 361548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361581 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361585 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361592 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361609 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361636 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361668 */     // GIR_Coverage, 4277,
     /* 361668 */     GIR_EraseRootFromParent_Done,
     /* 361669 */   // Label 7216: @361669
     /* 361669 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(361788), // Rule ID 4384 //
     /* 361674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361688 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361694 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361704 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361711 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361728 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361755 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361787 */     // GIR_Coverage, 4384,
     /* 361787 */     GIR_EraseRootFromParent_Done,
     /* 361788 */   // Label 7217: @361788
     /* 361788 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(361907), // Rule ID 4385 //
     /* 361793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361823 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361830 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361847 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361874 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361906 */     // GIR_Coverage, 4385,
     /* 361906 */     GIR_EraseRootFromParent_Done,
     /* 361907 */   // Label 7218: @361907
     /* 361907 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362029), // Rule ID 4282 //
     /* 361912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361938 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361941 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361945 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361952 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361969 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361996 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362028 */     // GIR_Coverage, 4282,
     /* 362028 */     GIR_EraseRootFromParent_Done,
     /* 362029 */   // Label 7219: @362029
     /* 362029 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362151), // Rule ID 4284 //
     /* 362034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362060 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362063 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362067 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362074 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362091 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362118 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362150 */     // GIR_Coverage, 4284,
     /* 362150 */     GIR_EraseRootFromParent_Done,
     /* 362151 */   // Label 7220: @362151
     /* 362151 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(362266), // Rule ID 4390 //
     /* 362156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362206 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362233 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362265 */     // GIR_Coverage, 4390,
     /* 362265 */     GIR_EraseRootFromParent_Done,
     /* 362266 */   // Label 7221: @362266
     /* 362266 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362381), // Rule ID 4392 //
     /* 362271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362297 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362304 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362321 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362348 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362380 */     // GIR_Coverage, 4392,
     /* 362380 */     GIR_EraseRootFromParent_Done,
     /* 362381 */   // Label 7222: @362381
     /* 362381 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362502), // Rule ID 4274 //
     /* 362386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362400 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362406 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362416 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362419 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362423 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362430 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362447 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362469 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362501 */     // GIR_Coverage, 4274,
     /* 362501 */     GIR_EraseRootFromParent_Done,
     /* 362502 */   // Label 7223: @362502
     /* 362502 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362623), // Rule ID 4275 //
     /* 362507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362537 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362540 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362544 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362551 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362568 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362590 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362622 */     // GIR_Coverage, 4275,
     /* 362622 */     GIR_EraseRootFromParent_Done,
     /* 362623 */   // Label 7224: @362623
     /* 362623 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(362737), // Rule ID 4382 //
     /* 362628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362642 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362648 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362658 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362665 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362682 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362704 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362736 */     // GIR_Coverage, 4382,
     /* 362736 */     GIR_EraseRootFromParent_Done,
     /* 362737 */   // Label 7225: @362737
     /* 362737 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(362851), // Rule ID 4383 //
     /* 362742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362756 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362762 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362772 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362779 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362796 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362818 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362850 */     // GIR_Coverage, 4383,
     /* 362850 */     GIR_EraseRootFromParent_Done,
     /* 362851 */   // Label 7226: @362851
     /* 362851 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(362968), // Rule ID 4278 //
     /* 362856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362882 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362885 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362889 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362896 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362913 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362935 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362967 */     // GIR_Coverage, 4278,
     /* 362967 */     GIR_EraseRootFromParent_Done,
     /* 362968 */   // Label 7227: @362968
     /* 362968 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(363085), // Rule ID 4280 //
     /* 362973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362999 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363002 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363006 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363013 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363030 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363052 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363084 */     // GIR_Coverage, 4280,
     /* 363084 */     GIR_EraseRootFromParent_Done,
     /* 363085 */   // Label 7228: @363085
     /* 363085 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(363195), // Rule ID 4386 //
     /* 363090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363116 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363123 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363140 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363162 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363194 */     // GIR_Coverage, 4386,
     /* 363194 */     GIR_EraseRootFromParent_Done,
     /* 363195 */   // Label 7229: @363195
     /* 363195 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(363305), // Rule ID 4388 //
     /* 363200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363226 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363233 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363250 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363272 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363304 */     // GIR_Coverage, 4388,
     /* 363304 */     GIR_EraseRootFromParent_Done,
     /* 363305 */   // Label 7230: @363305
     /* 363305 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(363435), // Rule ID 6498 //
     /* 363310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363339 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363342 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363346 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363353 */     // MIs[2] Rn
     /* 363353 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 363357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 363362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363368 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 363368 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 363371 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363375 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 363389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363397 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 363404 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363434 */     // GIR_Coverage, 6498,
     /* 363434 */     GIR_EraseRootFromParent_Done,
     /* 363435 */   // Label 7231: @363435
     /* 363435 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(363575), // Rule ID 5739 //
     /* 363440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363483 */     // MIs[2] Operand 1
     /* 363483 */     // No operand predicates
     /* 363483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363491 */     // MIs[3] Operand 1
     /* 363491 */     // No operand predicates
     /* 363491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363493 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363493 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363496 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363500 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363505 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363508 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363512 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363515 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363557 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363574 */     // GIR_Coverage, 5739,
     /* 363574 */     GIR_EraseRootFromParent_Done,
     /* 363575 */   // Label 7232: @363575
     /* 363575 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(363746), // Rule ID 5740 //
     /* 363580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363623 */     // MIs[2] Operand 1
     /* 363623 */     // No operand predicates
     /* 363623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363631 */     // MIs[3] Operand 1
     /* 363631 */     // No operand predicates
     /* 363631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363633 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363633 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 363636 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363640 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363645 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 363648 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363652 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 363655 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363660 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363677 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363680 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363684 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363745 */     // GIR_Coverage, 5740,
     /* 363745 */     GIR_EraseRootFromParent_Done,
     /* 363746 */   // Label 7233: @363746
     /* 363746 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(363886), // Rule ID 5779 //
     /* 363751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363794 */     // MIs[2] Operand 1
     /* 363794 */     // No operand predicates
     /* 363794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363802 */     // MIs[3] Operand 1
     /* 363802 */     // No operand predicates
     /* 363802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363804 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363816 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363868 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363885 */     // GIR_Coverage, 5779,
     /* 363885 */     GIR_EraseRootFromParent_Done,
     /* 363886 */   // Label 7234: @363886
     /* 363886 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(364057), // Rule ID 5780 //
     /* 363891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363934 */     // MIs[2] Operand 1
     /* 363934 */     // No operand predicates
     /* 363934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363942 */     // MIs[3] Operand 1
     /* 363942 */     // No operand predicates
     /* 363942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363944 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363944 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 363947 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363951 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363956 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 363959 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363963 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 363966 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363971 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363995 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 364026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 364032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364039 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364056 */     // GIR_Coverage, 5780,
     /* 364056 */     GIR_EraseRootFromParent_Done,
     /* 364057 */   // Label 7235: @364057
     /* 364057 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364136), // Rule ID 5692 //
     /* 364062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364090 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 364090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 364106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364135 */     // GIR_Coverage, 5692,
     /* 364135 */     GIR_EraseRootFromParent_Done,
     /* 364136 */   // Label 7236: @364136
     /* 364136 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(364212), // Rule ID 5700 //
     /* 364141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364169 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 364169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 364172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364211 */     // GIR_Coverage, 5700,
     /* 364211 */     GIR_EraseRootFromParent_Done,
     /* 364212 */   // Label 7237: @364212
     /* 364212 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(364288), // Rule ID 5704 //
     /* 364217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364245 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 364245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 364248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364287 */     // GIR_Coverage, 5704,
     /* 364287 */     GIR_EraseRootFromParent_Done,
     /* 364288 */   // Label 7238: @364288
     /* 364288 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(364433), // Rule ID 5716 //
     /* 364293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364315 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364319 */     // MIs[1] Operand 1
     /* 364319 */     // No operand predicates
     /* 364319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 364323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364331 */     // MIs[2] Operand 1
     /* 364331 */     // No operand predicates
     /* 364331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364333 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 364333 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364336 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364340 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364359 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 364391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 364402 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364415 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364432 */     // GIR_Coverage, 5716,
     /* 364432 */     GIR_EraseRootFromParent_Done,
     /* 364433 */   // Label 7239: @364433
     /* 364433 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(364582), // Rule ID 6502 //
     /* 364438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364463 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 364467 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 364474 */     // MIs[1] Rn
     /* 364474 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 364478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 364487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364495 */     // MIs[2] Operand 1
     /* 364495 */     // No operand predicates
     /* 364495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364497 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 364497 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364500 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364504 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364509 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364512 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 364516 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364519 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 364536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364541 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 364547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364551 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364564 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364581 */     // GIR_Coverage, 6502,
     /* 364581 */     GIR_EraseRootFromParent_Done,
     /* 364582 */   // Label 7240: @364582
     /* 364582 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(364724), // Rule ID 6505 //
     /* 364587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 364616 */     // MIs[1] Rn
     /* 364616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 364620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 364629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364637 */     // MIs[2] Operand 1
     /* 364637 */     // No operand predicates
     /* 364637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364639 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 364639 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364642 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364646 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364651 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364654 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 364658 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 364678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 364689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364693 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364706 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364723 */     // GIR_Coverage, 6505,
     /* 364723 */     GIR_EraseRootFromParent_Done,
     /* 364724 */   // Label 7241: @364724
     /* 364724 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(364912), // Rule ID 5714 //
     /* 364729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 364751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 364759 */     // MIs[1] Operand 1
     /* 364759 */     // No operand predicates
     /* 364759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364761 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 364761 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 364764 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364768 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 364775 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 364778 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364782 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364787 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364790 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364794 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 364797 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364802 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364807 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364812 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364815 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364819 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364838 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364841 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364845 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364848 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 364881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364894 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364911 */     // GIR_Coverage, 5714,
     /* 364911 */     GIR_EraseRootFromParent_Done,
     /* 364912 */   // Label 7242: @364912
     /* 364912 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(365047), // Rule ID 5725 //
     /* 364917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 364939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364947 */     // MIs[1] Operand 1
     /* 364947 */     // No operand predicates
     /* 364947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364949 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 364949 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364952 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364956 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364975 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364978 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364982 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 365007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 365018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 365022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365046 */     // GIR_Coverage, 5725,
     /* 365046 */     GIR_EraseRootFromParent_Done,
     /* 365047 */   // Label 7243: @365047
     /* 365047 */   GIM_Reject,
     /* 365048 */ // Label 7214: @365048
     /* 365048 */ GIM_Reject,
     /* 365049 */ // Label 7127: @365049
     /* 365049 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(368116),
     /* 365054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365067 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(365176), // Rule ID 4300 //
     /* 365072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365076 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365082 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365092 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365099 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365116 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365143 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365175 */     // GIR_Coverage, 4300,
     /* 365175 */     GIR_EraseRootFromParent_Done,
     /* 365176 */   // Label 7245: @365176
     /* 365176 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(365285), // Rule ID 4301 //
     /* 365181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365185 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365191 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365201 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365208 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365225 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365252 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365284 */     // GIR_Coverage, 4301,
     /* 365284 */     GIR_EraseRootFromParent_Done,
     /* 365285 */   // Label 7246: @365285
     /* 365285 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(365394), // Rule ID 4408 //
     /* 365290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365294 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365300 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365310 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365317 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365334 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365361 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365393 */     // GIR_Coverage, 4408,
     /* 365393 */     GIR_EraseRootFromParent_Done,
     /* 365394 */   // Label 7247: @365394
     /* 365394 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(365503), // Rule ID 4409 //
     /* 365399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365403 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365409 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365419 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365422 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365426 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365443 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365470 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365502 */     // GIR_Coverage, 4409,
     /* 365502 */     GIR_EraseRootFromParent_Done,
     /* 365503 */   // Label 7248: @365503
     /* 365503 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(365608), // Rule ID 4306 //
     /* 365508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365524 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365531 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365548 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365575 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365607 */     // GIR_Coverage, 4306,
     /* 365607 */     GIR_EraseRootFromParent_Done,
     /* 365608 */   // Label 7249: @365608
     /* 365608 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(365713), // Rule ID 4308 //
     /* 365613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365629 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365636 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365653 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365712 */     // GIR_Coverage, 4308,
     /* 365712 */     GIR_EraseRootFromParent_Done,
     /* 365713 */   // Label 7250: @365713
     /* 365713 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(365818), // Rule ID 4414 //
     /* 365718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365734 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365741 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365758 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365817 */     // GIR_Coverage, 4414,
     /* 365817 */     GIR_EraseRootFromParent_Done,
     /* 365818 */   // Label 7251: @365818
     /* 365818 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(365923), // Rule ID 4416 //
     /* 365823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365839 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365846 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365863 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365890 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365922 */     // GIR_Coverage, 4416,
     /* 365922 */     GIR_EraseRootFromParent_Done,
     /* 365923 */   // Label 7252: @365923
     /* 365923 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(366027), // Rule ID 4298 //
     /* 365928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365938 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365948 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365955 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365972 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366026 */     // GIR_Coverage, 4298,
     /* 366026 */     GIR_EraseRootFromParent_Done,
     /* 366027 */   // Label 7253: @366027
     /* 366027 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(366131), // Rule ID 4299 //
     /* 366032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366036 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366042 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366052 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366059 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 366076 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 366076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 366083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366098 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366130 */     // GIR_Coverage, 4299,
     /* 366130 */     GIR_EraseRootFromParent_Done,
     /* 366131 */   // Label 7254: @366131
     /* 366131 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(366235), // Rule ID 4406 //
     /* 366136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366140 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366146 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366156 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366163 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 366180 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 366180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 366187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366202 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366234 */     // GIR_Coverage, 4406,
     /* 366234 */     GIR_EraseRootFromParent_Done,
     /* 366235 */   // Label 7255: @366235
     /* 366235 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(366339), // Rule ID 4407 //
     /* 366240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366244 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366250 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366260 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366267 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 366284 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 366284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 366291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366306 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366338 */     // GIR_Coverage, 4407,
     /* 366338 */     GIR_EraseRootFromParent_Done,
     /* 366339 */   // Label 7256: @366339
     /* 366339 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(366439), // Rule ID 4302 //
     /* 366344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366360 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366367 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 366384 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 366384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 366391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366406 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366438 */     // GIR_Coverage, 4302,
     /* 366438 */     GIR_EraseRootFromParent_Done,
     /* 366439 */   // Label 7257: @366439
     /* 366439 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(366539), // Rule ID 4304 //
     /* 366444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366460 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366467 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 366484 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 366484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 366491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366506 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366538 */     // GIR_Coverage, 4304,
     /* 366538 */     GIR_EraseRootFromParent_Done,
     /* 366539 */   // Label 7258: @366539
     /* 366539 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(366639), // Rule ID 4410 //
     /* 366544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366560 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366567 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 366584 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 366584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 366591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366638 */     // GIR_Coverage, 4410,
     /* 366638 */     GIR_EraseRootFromParent_Done,
     /* 366639 */   // Label 7259: @366639
     /* 366639 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(366739), // Rule ID 4412 //
     /* 366644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 366684 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 366684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 366691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366738 */     // GIR_Coverage, 4412,
     /* 366738 */     GIR_EraseRootFromParent_Done,
     /* 366739 */   // Label 7260: @366739
     /* 366739 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(366852), // Rule ID 5745 //
     /* 366744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366781 */     // MIs[3] Operand 1
     /* 366781 */     // No operand predicates
     /* 366781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366787 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 366787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 366790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 366794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 366803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 366806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 366833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366851 */     // GIR_Coverage, 5745,
     /* 366851 */     GIR_EraseRootFromParent_Done,
     /* 366852 */   // Label 7261: @366852
     /* 366852 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(366965), // Rule ID 5785 //
     /* 366857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366894 */     // MIs[3] Operand 1
     /* 366894 */     // No operand predicates
     /* 366894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366900 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 366900 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 366903 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 366907 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366912 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 366916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 366919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 366946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366964 */     // GIR_Coverage, 5785,
     /* 366964 */     GIR_EraseRootFromParent_Done,
     /* 366965 */   // Label 7262: @366965
     /* 366965 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(367043), // Rule ID 1940 //
     /* 366970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367010 */     // MIs[2] Operand 1
     /* 367010 */     // No operand predicates
     /* 367010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367018 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367022 */     // MIs[3] Operand 1
     /* 367022 */     // No operand predicates
     /* 367022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367024 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 367024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 367034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 367041 */     GIR_RootConstrainSelectedInstOperands,
     /* 367042 */     // GIR_Coverage, 1940,
     /* 367042 */     GIR_EraseRootFromParent_Done,
     /* 367043 */   // Label 7263: @367043
     /* 367043 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(367132), // Rule ID 5742 //
     /* 367048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367076 */     // MIs[2] Operand 1
     /* 367076 */     // No operand predicates
     /* 367076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367084 */     // MIs[3] Operand 1
     /* 367084 */     // No operand predicates
     /* 367084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367086 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 367086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367098 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 367104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367130 */     GIR_RootConstrainSelectedInstOperands,
     /* 367131 */     // GIR_Coverage, 5742,
     /* 367131 */     GIR_EraseRootFromParent_Done,
     /* 367132 */   // Label 7264: @367132
     /* 367132 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(367221), // Rule ID 5782 //
     /* 367137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367165 */     // MIs[2] Operand 1
     /* 367165 */     // No operand predicates
     /* 367165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367173 */     // MIs[3] Operand 1
     /* 367173 */     // No operand predicates
     /* 367173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367175 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 367175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367187 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 367193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367219 */     GIR_RootConstrainSelectedInstOperands,
     /* 367220 */     // GIR_Coverage, 5782,
     /* 367220 */     GIR_EraseRootFromParent_Done,
     /* 367221 */   // Label 7265: @367221
     /* 367221 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(367288), // Rule ID 5744 //
     /* 367226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367259 */     // MIs[2] Operand 1
     /* 367259 */     // No operand predicates
     /* 367259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367267 */     // MIs[3] Operand 1
     /* 367267 */     // No operand predicates
     /* 367267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367269 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 367269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367286 */     GIR_RootConstrainSelectedInstOperands,
     /* 367287 */     // GIR_Coverage, 5744,
     /* 367287 */     GIR_EraseRootFromParent_Done,
     /* 367288 */   // Label 7266: @367288
     /* 367288 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(367386), // Rule ID 5746 //
     /* 367293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367326 */     // MIs[2] Operand 1
     /* 367326 */     // No operand predicates
     /* 367326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367334 */     // MIs[3] Operand 1
     /* 367334 */     // No operand predicates
     /* 367334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367336 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 367336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367355 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 367358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367373 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367384 */     GIR_RootConstrainSelectedInstOperands,
     /* 367385 */     // GIR_Coverage, 5746,
     /* 367385 */     GIR_EraseRootFromParent_Done,
     /* 367386 */   // Label 7267: @367386
     /* 367386 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(367453), // Rule ID 5784 //
     /* 367391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367424 */     // MIs[2] Operand 1
     /* 367424 */     // No operand predicates
     /* 367424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367432 */     // MIs[3] Operand 1
     /* 367432 */     // No operand predicates
     /* 367432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367434 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 367434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367451 */     GIR_RootConstrainSelectedInstOperands,
     /* 367452 */     // GIR_Coverage, 5784,
     /* 367452 */     GIR_EraseRootFromParent_Done,
     /* 367453 */   // Label 7268: @367453
     /* 367453 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(367551), // Rule ID 5786 //
     /* 367458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367491 */     // MIs[2] Operand 1
     /* 367491 */     // No operand predicates
     /* 367491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367499 */     // MIs[3] Operand 1
     /* 367499 */     // No operand predicates
     /* 367499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367501 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 367501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367513 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367520 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 367523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367538 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367549 */     GIR_RootConstrainSelectedInstOperands,
     /* 367550 */     // GIR_Coverage, 5786,
     /* 367550 */     GIR_EraseRootFromParent_Done,
     /* 367551 */   // Label 7269: @367551
     /* 367551 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(367617), // Rule ID 5696 //
     /* 367556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367574 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 367574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367616 */     // GIR_Coverage, 5696,
     /* 367616 */     GIR_EraseRootFromParent_Done,
     /* 367617 */   // Label 7270: @367617
     /* 367617 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(367683), // Rule ID 5708 //
     /* 367622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367640 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 367640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367682 */     // GIR_Coverage, 5708,
     /* 367682 */     GIR_EraseRootFromParent_Done,
     /* 367683 */   // Label 7271: @367683
     /* 367683 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(367736), // Rule ID 5717 //
     /* 367688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 367700 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 367704 */     // MIs[1] Operand 1
     /* 367704 */     // No operand predicates
     /* 367704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367716 */     // MIs[2] Operand 1
     /* 367716 */     // No operand predicates
     /* 367716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367718 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 367718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 367721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 367728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367734 */     GIR_RootConstrainSelectedInstOperands,
     /* 367735 */     // GIR_Coverage, 5717,
     /* 367735 */     GIR_EraseRootFromParent_Done,
     /* 367736 */   // Label 7272: @367736
     /* 367736 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(367805), // Rule ID 6483 //
     /* 367741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 367760 */     // MIs[1] Rn
     /* 367760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 367764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 367769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367781 */     // MIs[2] Operand 1
     /* 367781 */     // No operand predicates
     /* 367781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367783 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 367783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 367786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367803 */     GIR_RootConstrainSelectedInstOperands,
     /* 367804 */     // GIR_Coverage, 6483,
     /* 367804 */     GIR_EraseRootFromParent_Done,
     /* 367805 */   // Label 7273: @367805
     /* 367805 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(367874), // Rule ID 6484 //
     /* 367810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 367829 */     // MIs[1] Rn
     /* 367829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 367833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 367838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367846 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367850 */     // MIs[2] Operand 1
     /* 367850 */     // No operand predicates
     /* 367850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367852 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 367852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 367855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367872 */     GIR_RootConstrainSelectedInstOperands,
     /* 367873 */     // GIR_Coverage, 6484,
     /* 367873 */     GIR_EraseRootFromParent_Done,
     /* 367874 */   // Label 7274: @367874
     /* 367874 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(367975), // Rule ID 5797 //
     /* 367879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 367887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367904 */     // MIs[2] Operand 1
     /* 367904 */     // No operand predicates
     /* 367904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367906 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 367909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367932 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 367939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 367942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 367967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367973 */     GIR_RootConstrainSelectedInstOperands,
     /* 367974 */     // GIR_Coverage, 5797,
     /* 367974 */     GIR_EraseRootFromParent_Done,
     /* 367975 */   // Label 7275: @367975
     /* 367975 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(368019), // Rule ID 1936 //
     /* 367980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368003 */     // MIs[1] Operand 1
     /* 368003 */     // No operand predicates
     /* 368003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368005 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 368005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 368008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 368012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 368015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368017 */     GIR_RootConstrainSelectedInstOperands,
     /* 368018 */     // GIR_Coverage, 1936,
     /* 368018 */     GIR_EraseRootFromParent_Done,
     /* 368019 */   // Label 7276: @368019
     /* 368019 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(368115), // Rule ID 5722 //
     /* 368024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 368036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368044 */     // MIs[1] Operand 1
     /* 368044 */     // No operand predicates
     /* 368044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368046 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 368046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 368049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368072 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 368079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 368082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 368107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368113 */     GIR_RootConstrainSelectedInstOperands,
     /* 368114 */     // GIR_Coverage, 5722,
     /* 368114 */     GIR_EraseRootFromParent_Done,
     /* 368115 */   // Label 7277: @368115
     /* 368115 */   GIM_Reject,
     /* 368116 */ // Label 7244: @368116
     /* 368116 */ GIM_Reject,
     /* 368117 */ // Label 7128: @368117
     /* 368117 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(371329),
     /* 368122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368125 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(368244), // Rule ID 4204 //
     /* 368130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368160 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368167 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368184 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368211 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368243 */     // GIR_Coverage, 4204,
     /* 368243 */     GIR_EraseRootFromParent_Done,
     /* 368244 */   // Label 7279: @368244
     /* 368244 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(368363), // Rule ID 4205 //
     /* 368249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368269 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368279 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368303 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368330 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368362 */     // GIR_Coverage, 4205,
     /* 368362 */     GIR_EraseRootFromParent_Done,
     /* 368363 */   // Label 7280: @368363
     /* 368363 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(368489), // Rule ID 4240 //
     /* 368368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368382 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368388 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368398 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368401 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368405 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368412 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368429 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368456 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368488 */     // GIR_Coverage, 4240,
     /* 368488 */     GIR_EraseRootFromParent_Done,
     /* 368489 */   // Label 7281: @368489
     /* 368489 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(368615), // Rule ID 4241 //
     /* 368494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368508 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368514 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368524 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368527 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368531 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368538 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368555 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368582 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368614 */     // GIR_Coverage, 4241,
     /* 368614 */     GIR_EraseRootFromParent_Done,
     /* 368615 */   // Label 7282: @368615
     /* 368615 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(368730), // Rule ID 4210 //
     /* 368620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368646 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368653 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368670 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368697 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368729 */     // GIR_Coverage, 4210,
     /* 368729 */     GIR_EraseRootFromParent_Done,
     /* 368730 */   // Label 7283: @368730
     /* 368730 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(368845), // Rule ID 4212 //
     /* 368735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368761 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368768 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368785 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368812 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368844 */     // GIR_Coverage, 4212,
     /* 368844 */     GIR_EraseRootFromParent_Done,
     /* 368845 */   // Label 7284: @368845
     /* 368845 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(368967), // Rule ID 4246 //
     /* 368850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368876 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368879 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368883 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368890 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368907 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368934 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368966 */     // GIR_Coverage, 4246,
     /* 368966 */     GIR_EraseRootFromParent_Done,
     /* 368967 */   // Label 7285: @368967
     /* 368967 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(369089), // Rule ID 4248 //
     /* 368972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368998 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369001 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369005 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369012 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 369029 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 369036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369056 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369088 */     // GIR_Coverage, 4248,
     /* 369088 */     GIR_EraseRootFromParent_Done,
     /* 369089 */   // Label 7286: @369089
     /* 369089 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(369203), // Rule ID 4202 //
     /* 369094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369108 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369114 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369124 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369131 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369148 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369170 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369202 */     // GIR_Coverage, 4202,
     /* 369202 */     GIR_EraseRootFromParent_Done,
     /* 369203 */   // Label 7287: @369203
     /* 369203 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(369317), // Rule ID 4203 //
     /* 369208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369222 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369228 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369238 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369245 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369262 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369284 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369316 */     // GIR_Coverage, 4203,
     /* 369316 */     GIR_EraseRootFromParent_Done,
     /* 369317 */   // Label 7288: @369317
     /* 369317 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(369438), // Rule ID 4238 //
     /* 369322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369355 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369359 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369366 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369383 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369405 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369437 */     // GIR_Coverage, 4238,
     /* 369437 */     GIR_EraseRootFromParent_Done,
     /* 369438 */   // Label 7289: @369438
     /* 369438 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(369559), // Rule ID 4239 //
     /* 369443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369463 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369476 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369480 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369487 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369504 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369526 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369558 */     // GIR_Coverage, 4239,
     /* 369558 */     GIR_EraseRootFromParent_Done,
     /* 369559 */   // Label 7290: @369559
     /* 369559 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(369669), // Rule ID 4206 //
     /* 369564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369590 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369597 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369614 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369636 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369668 */     // GIR_Coverage, 4206,
     /* 369668 */     GIR_EraseRootFromParent_Done,
     /* 369669 */   // Label 7291: @369669
     /* 369669 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(369779), // Rule ID 4208 //
     /* 369674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369700 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369707 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369724 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369746 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369778 */     // GIR_Coverage, 4208,
     /* 369778 */     GIR_EraseRootFromParent_Done,
     /* 369779 */   // Label 7292: @369779
     /* 369779 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(369896), // Rule ID 4242 //
     /* 369784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369810 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369813 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369817 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369824 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369841 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369863 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369895 */     // GIR_Coverage, 4242,
     /* 369895 */     GIR_EraseRootFromParent_Done,
     /* 369896 */   // Label 7293: @369896
     /* 369896 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(370013), // Rule ID 4244 //
     /* 369901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369927 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369930 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369934 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369941 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369958 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369980 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370012 */     // GIR_Coverage, 4244,
     /* 370012 */     GIR_EraseRootFromParent_Done,
     /* 370013 */   // Label 7294: @370013
     /* 370013 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(370153), // Rule ID 5763 //
     /* 370018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 370044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370061 */     // MIs[2] Operand 1
     /* 370061 */     // No operand predicates
     /* 370061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370069 */     // MIs[3] Operand 1
     /* 370069 */     // No operand predicates
     /* 370069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370071 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 370071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370083 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370090 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370135 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370152 */     // GIR_Coverage, 5763,
     /* 370152 */     GIR_EraseRootFromParent_Done,
     /* 370153 */   // Label 7295: @370153
     /* 370153 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(370324), // Rule ID 5764 //
     /* 370158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 370184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370201 */     // MIs[2] Operand 1
     /* 370201 */     // No operand predicates
     /* 370201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370209 */     // MIs[3] Operand 1
     /* 370209 */     // No operand predicates
     /* 370209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370211 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 370211 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 370214 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370218 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370223 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 370226 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370230 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 370233 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370238 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370255 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370258 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370262 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370265 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370293 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370306 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370323 */     // GIR_Coverage, 5764,
     /* 370323 */     GIR_EraseRootFromParent_Done,
     /* 370324 */   // Label 7296: @370324
     /* 370324 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(370464), // Rule ID 5771 //
     /* 370329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 370355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370372 */     // MIs[2] Operand 1
     /* 370372 */     // No operand predicates
     /* 370372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370380 */     // MIs[3] Operand 1
     /* 370380 */     // No operand predicates
     /* 370380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370382 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 370382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370394 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370401 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370426 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370446 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370463 */     // GIR_Coverage, 5771,
     /* 370463 */     GIR_EraseRootFromParent_Done,
     /* 370464 */   // Label 7297: @370464
     /* 370464 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(370635), // Rule ID 5772 //
     /* 370469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 370495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370512 */     // MIs[2] Operand 1
     /* 370512 */     // No operand predicates
     /* 370512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370520 */     // MIs[3] Operand 1
     /* 370520 */     // No operand predicates
     /* 370520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370522 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 370522 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 370525 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370529 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370534 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 370537 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370541 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 370544 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370549 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370566 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370634 */     // GIR_Coverage, 5772,
     /* 370634 */     GIR_EraseRootFromParent_Done,
     /* 370635 */   // Label 7298: @370635
     /* 370635 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(370714), // Rule ID 5687 //
     /* 370640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370668 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 370668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 370684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 370703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370713 */     // GIR_Coverage, 5687,
     /* 370713 */     GIR_EraseRootFromParent_Done,
     /* 370714 */   // Label 7299: @370714
     /* 370714 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(370856), // Rule ID 6500 //
     /* 370719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370741 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370744 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 370748 */     // MIs[1] Rn
     /* 370748 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 370752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 370757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 370761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370769 */     // MIs[2] Operand 1
     /* 370769 */     // No operand predicates
     /* 370769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370771 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 370771 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370774 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370778 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370783 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 370790 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 370810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 370821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370825 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370838 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370855 */     // GIR_Coverage, 6500,
     /* 370855 */     GIR_EraseRootFromParent_Done,
     /* 370856 */   // Label 7300: @370856
     /* 370856 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(371005), // Rule ID 6501 //
     /* 370861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370886 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 370890 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370897 */     // MIs[1] Rn
     /* 370897 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 370901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 370906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 370910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370918 */     // MIs[2] Operand 1
     /* 370918 */     // No operand predicates
     /* 370918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370920 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 370920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370932 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 370939 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370942 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 370959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370964 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 370970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370974 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370987 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371004 */     // GIR_Coverage, 6501,
     /* 371004 */     GIR_EraseRootFromParent_Done,
     /* 371005 */   // Label 7301: @371005
     /* 371005 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(371140), // Rule ID 5726 //
     /* 371010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 371032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 371040 */     // MIs[1] Operand 1
     /* 371040 */     // No operand predicates
     /* 371040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 371042 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 371042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 371045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 371059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371068 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 371071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371075 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 371100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371105 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 371111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371122 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371139 */     // GIR_Coverage, 5726,
     /* 371139 */     GIR_EraseRootFromParent_Done,
     /* 371140 */   // Label 7302: @371140
     /* 371140 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(371328), // Rule ID 5727 //
     /* 371145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 371167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 371175 */     // MIs[1] Operand 1
     /* 371175 */     // No operand predicates
     /* 371175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 371177 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 371177 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 371180 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371184 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371191 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 371194 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371198 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371203 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371206 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371210 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 371213 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371218 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371223 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 371231 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371235 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 371245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371254 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 371257 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371261 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 371297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 371300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 371303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371310 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371327 */     // GIR_Coverage, 5727,
     /* 371327 */     GIR_EraseRootFromParent_Done,
     /* 371328 */   // Label 7303: @371328
     /* 371328 */   GIM_Reject,
     /* 371329 */ // Label 7278: @371329
     /* 371329 */ GIM_Reject,
     /* 371330 */ // Label 7129: @371330
     /* 371330 */ GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(374748),
     /* 371335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371338 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(371464), // Rule ID 4264 //
     /* 371343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371357 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371363 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371373 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371376 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371380 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371387 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371404 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371431 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371463 */     // GIR_Coverage, 4264,
     /* 371463 */     GIR_EraseRootFromParent_Done,
     /* 371464 */   // Label 7305: @371464
     /* 371464 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(371590), // Rule ID 4265 //
     /* 371469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371489 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371499 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371502 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371506 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371513 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371530 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371557 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371589 */     // GIR_Coverage, 4265,
     /* 371589 */     GIR_EraseRootFromParent_Done,
     /* 371590 */   // Label 7306: @371590
     /* 371590 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(371709), // Rule ID 4372 //
     /* 371595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371609 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371615 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371625 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371628 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371632 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371649 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371676 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371708 */     // GIR_Coverage, 4372,
     /* 371708 */     GIR_EraseRootFromParent_Done,
     /* 371709 */   // Label 7307: @371709
     /* 371709 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(371828), // Rule ID 4373 //
     /* 371714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371728 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371734 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371744 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371751 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371768 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371795 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371827 */     // GIR_Coverage, 4373,
     /* 371827 */     GIR_EraseRootFromParent_Done,
     /* 371828 */   // Label 7308: @371828
     /* 371828 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(371950), // Rule ID 4270 //
     /* 371833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371859 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371862 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371866 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371873 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371890 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371917 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371949 */     // GIR_Coverage, 4270,
     /* 371949 */     GIR_EraseRootFromParent_Done,
     /* 371950 */   // Label 7309: @371950
     /* 371950 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(372072), // Rule ID 4272 //
     /* 371955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371981 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371984 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371988 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371995 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 372012 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 372019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372039 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372071 */     // GIR_Coverage, 4272,
     /* 372071 */     GIR_EraseRootFromParent_Done,
     /* 372072 */   // Label 7310: @372072
     /* 372072 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(372187), // Rule ID 4378 //
     /* 372077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372103 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372110 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 372127 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 372134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372154 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372186 */     // GIR_Coverage, 4378,
     /* 372186 */     GIR_EraseRootFromParent_Done,
     /* 372187 */   // Label 7311: @372187
     /* 372187 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(372302), // Rule ID 4380 //
     /* 372192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372218 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372225 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 372242 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 372249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372301 */     // GIR_Coverage, 4380,
     /* 372301 */     GIR_EraseRootFromParent_Done,
     /* 372302 */   // Label 7312: @372302
     /* 372302 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(372423), // Rule ID 4262 //
     /* 372307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372337 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372340 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372344 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372351 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372368 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372390 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372422 */     // GIR_Coverage, 4262,
     /* 372422 */     GIR_EraseRootFromParent_Done,
     /* 372423 */   // Label 7313: @372423
     /* 372423 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(372544), // Rule ID 4263 //
     /* 372428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372442 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372448 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372458 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372461 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372465 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372472 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372489 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372511 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372543 */     // GIR_Coverage, 4263,
     /* 372543 */     GIR_EraseRootFromParent_Done,
     /* 372544 */   // Label 7314: @372544
     /* 372544 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(372658), // Rule ID 4370 //
     /* 372549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372563 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372569 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372579 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372582 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372586 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372603 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372625 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372657 */     // GIR_Coverage, 4370,
     /* 372657 */     GIR_EraseRootFromParent_Done,
     /* 372658 */   // Label 7315: @372658
     /* 372658 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(372772), // Rule ID 4371 //
     /* 372663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372677 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372683 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372693 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372700 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372717 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372739 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372771 */     // GIR_Coverage, 4371,
     /* 372771 */     GIR_EraseRootFromParent_Done,
     /* 372772 */   // Label 7316: @372772
     /* 372772 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(372889), // Rule ID 4266 //
     /* 372777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372806 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372810 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372834 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372856 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372888 */     // GIR_Coverage, 4266,
     /* 372888 */     GIR_EraseRootFromParent_Done,
     /* 372889 */   // Label 7317: @372889
     /* 372889 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(373006), // Rule ID 4268 //
     /* 372894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372923 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372927 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372934 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372951 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372973 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373005 */     // GIR_Coverage, 4268,
     /* 373005 */     GIR_EraseRootFromParent_Done,
     /* 373006 */   // Label 7318: @373006
     /* 373006 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(373116), // Rule ID 4374 //
     /* 373011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373037 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373044 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 373061 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 373061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 373068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373083 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373115 */     // GIR_Coverage, 4374,
     /* 373115 */     GIR_EraseRootFromParent_Done,
     /* 373116 */   // Label 7319: @373116
     /* 373116 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(373226), // Rule ID 4376 //
     /* 373121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373147 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373154 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 373171 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 373171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 373178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373193 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373225 */     // GIR_Coverage, 4376,
     /* 373225 */     GIR_EraseRootFromParent_Done,
     /* 373226 */   // Label 7320: @373226
     /* 373226 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(373349), // Rule ID 5737 //
     /* 373231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373278 */     // MIs[3] Operand 1
     /* 373278 */     // No operand predicates
     /* 373278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373284 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 373284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 373287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 373291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373296 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 373300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 373303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 373330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373348 */     // GIR_Coverage, 5737,
     /* 373348 */     GIR_EraseRootFromParent_Done,
     /* 373349 */   // Label 7321: @373349
     /* 373349 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(373472), // Rule ID 5777 //
     /* 373354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373401 */     // MIs[3] Operand 1
     /* 373401 */     // No operand predicates
     /* 373401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373407 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 373407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 373410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 373414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 373423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 373426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 373453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373471 */     // GIR_Coverage, 5777,
     /* 373471 */     GIR_EraseRootFromParent_Done,
     /* 373472 */   // Label 7322: @373472
     /* 373472 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(373560), // Rule ID 1939 //
     /* 373477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373527 */     // MIs[2] Operand 1
     /* 373527 */     // No operand predicates
     /* 373527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373535 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373539 */     // MIs[3] Operand 1
     /* 373539 */     // No operand predicates
     /* 373539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373541 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 373541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 373558 */     GIR_RootConstrainSelectedInstOperands,
     /* 373559 */     // GIR_Coverage, 1939,
     /* 373559 */     GIR_EraseRootFromParent_Done,
     /* 373560 */   // Label 7323: @373560
     /* 373560 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(373659), // Rule ID 5734 //
     /* 373565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 373587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373599 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373603 */     // MIs[2] Operand 1
     /* 373603 */     // No operand predicates
     /* 373603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373611 */     // MIs[3] Operand 1
     /* 373611 */     // No operand predicates
     /* 373611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373613 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 373613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373625 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 373631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 373641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373657 */     GIR_RootConstrainSelectedInstOperands,
     /* 373658 */     // GIR_Coverage, 5734,
     /* 373658 */     GIR_EraseRootFromParent_Done,
     /* 373659 */   // Label 7324: @373659
     /* 373659 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(373758), // Rule ID 5774 //
     /* 373664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 373686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373702 */     // MIs[2] Operand 1
     /* 373702 */     // No operand predicates
     /* 373702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373710 */     // MIs[3] Operand 1
     /* 373710 */     // No operand predicates
     /* 373710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373712 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 373712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373724 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 373730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 373740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373756 */     GIR_RootConstrainSelectedInstOperands,
     /* 373757 */     // GIR_Coverage, 5774,
     /* 373757 */     GIR_EraseRootFromParent_Done,
     /* 373758 */   // Label 7325: @373758
     /* 373758 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(373835), // Rule ID 5736 //
     /* 373763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373806 */     // MIs[2] Operand 1
     /* 373806 */     // No operand predicates
     /* 373806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373814 */     // MIs[3] Operand 1
     /* 373814 */     // No operand predicates
     /* 373814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373816 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 373816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373833 */     GIR_RootConstrainSelectedInstOperands,
     /* 373834 */     // GIR_Coverage, 5736,
     /* 373834 */     GIR_EraseRootFromParent_Done,
     /* 373835 */   // Label 7326: @373835
     /* 373835 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(373943), // Rule ID 5738 //
     /* 373840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373883 */     // MIs[2] Operand 1
     /* 373883 */     // No operand predicates
     /* 373883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373891 */     // MIs[3] Operand 1
     /* 373891 */     // No operand predicates
     /* 373891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373893 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 373893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373941 */     GIR_RootConstrainSelectedInstOperands,
     /* 373942 */     // GIR_Coverage, 5738,
     /* 373942 */     GIR_EraseRootFromParent_Done,
     /* 373943 */   // Label 7327: @373943
     /* 373943 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(374020), // Rule ID 5776 //
     /* 373948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373991 */     // MIs[2] Operand 1
     /* 373991 */     // No operand predicates
     /* 373991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373999 */     // MIs[3] Operand 1
     /* 373999 */     // No operand predicates
     /* 373999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374001 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 374001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 374008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 374011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 374018 */     GIR_RootConstrainSelectedInstOperands,
     /* 374019 */     // GIR_Coverage, 5776,
     /* 374019 */     GIR_EraseRootFromParent_Done,
     /* 374020 */   // Label 7328: @374020
     /* 374020 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(374128), // Rule ID 5778 //
     /* 374025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 374051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374068 */     // MIs[2] Operand 1
     /* 374068 */     // No operand predicates
     /* 374068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374076 */     // MIs[3] Operand 1
     /* 374076 */     // No operand predicates
     /* 374076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374078 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 374078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 374117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 374120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 374126 */     GIR_RootConstrainSelectedInstOperands,
     /* 374127 */     // GIR_Coverage, 5778,
     /* 374127 */     GIR_EraseRootFromParent_Done,
     /* 374128 */   // Label 7329: @374128
     /* 374128 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(374207), // Rule ID 5690 //
     /* 374133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 374155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374161 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 374161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 374164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 374177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 374196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374206 */     // GIR_Coverage, 5690,
     /* 374206 */     GIR_EraseRootFromParent_Done,
     /* 374207 */   // Label 7330: @374207
     /* 374207 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(374283), // Rule ID 5702 //
     /* 374212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374240 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 374240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374282 */     // GIR_Coverage, 5702,
     /* 374282 */     GIR_EraseRootFromParent_Done,
     /* 374283 */   // Label 7331: @374283
     /* 374283 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(374359), // Rule ID 5706 //
     /* 374288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374316 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 374316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374358 */     // GIR_Coverage, 5706,
     /* 374358 */     GIR_EraseRootFromParent_Done,
     /* 374359 */   // Label 7332: @374359
     /* 374359 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(374422), // Rule ID 5715 //
     /* 374364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 374386 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 374390 */     // MIs[1] Operand 1
     /* 374390 */     // No operand predicates
     /* 374390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374398 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374402 */     // MIs[2] Operand 1
     /* 374402 */     // No operand predicates
     /* 374402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374404 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 374404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 374407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 374414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 374420 */     GIR_RootConstrainSelectedInstOperands,
     /* 374421 */     // GIR_Coverage, 5715,
     /* 374421 */     GIR_EraseRootFromParent_Done,
     /* 374422 */   // Label 7333: @374422
     /* 374422 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(374508), // Rule ID 6482 //
     /* 374427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374452 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 374456 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 374463 */     // MIs[1] Rn
     /* 374463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 374467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 374472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374484 */     // MIs[2] Operand 1
     /* 374484 */     // No operand predicates
     /* 374484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374486 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 374486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 374489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374506 */     GIR_RootConstrainSelectedInstOperands,
     /* 374507 */     // GIR_Coverage, 6482,
     /* 374507 */     GIR_EraseRootFromParent_Done,
     /* 374508 */   // Label 7334: @374508
     /* 374508 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(374587), // Rule ID 6487 //
     /* 374513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374535 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 374542 */     // MIs[1] Rn
     /* 374542 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 374546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 374551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374559 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374563 */     // MIs[2] Operand 1
     /* 374563 */     // No operand predicates
     /* 374563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374565 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 374565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 374568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374585 */     GIR_RootConstrainSelectedInstOperands,
     /* 374586 */     // GIR_Coverage, 6487,
     /* 374586 */     GIR_EraseRootFromParent_Done,
     /* 374587 */   // Label 7335: @374587
     /* 374587 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(374641), // Rule ID 1935 //
     /* 374592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 374613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 374617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374625 */     // MIs[1] Operand 1
     /* 374625 */     // No operand predicates
     /* 374625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374627 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 374627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 374630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 374637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374639 */     GIR_RootConstrainSelectedInstOperands,
     /* 374640 */     // GIR_Coverage, 1935,
     /* 374640 */     GIR_EraseRootFromParent_Done,
     /* 374641 */   // Label 7336: @374641
     /* 374641 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(374747), // Rule ID 5720 //
     /* 374646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 374668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374676 */     // MIs[1] Operand 1
     /* 374676 */     // No operand predicates
     /* 374676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374678 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374678 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 374681 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374685 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 374711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 374714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 374739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374745 */     GIR_RootConstrainSelectedInstOperands,
     /* 374746 */     // GIR_Coverage, 5720,
     /* 374746 */     GIR_EraseRootFromParent_Done,
     /* 374747 */   // Label 7337: @374747
     /* 374747 */   GIM_Reject,
     /* 374748 */ // Label 7304: @374748
     /* 374748 */ GIM_Reject,
     /* 374749 */ // Label 7130: @374749
     /* 374749 */ GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(377952),
     /* 374754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 374757 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(374876), // Rule ID 4192 //
     /* 374762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374776 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374782 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374799 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374816 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374875 */     // GIR_Coverage, 4192,
     /* 374875 */     GIR_EraseRootFromParent_Done,
     /* 374876 */   // Label 7339: @374876
     /* 374876 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(374995), // Rule ID 4193 //
     /* 374881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374895 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374901 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374911 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374918 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374935 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374962 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374994 */     // GIR_Coverage, 4193,
     /* 374994 */     GIR_EraseRootFromParent_Done,
     /* 374995 */   // Label 7340: @374995
     /* 374995 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(375121), // Rule ID 4228 //
     /* 375000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375014 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375020 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375030 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375033 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375037 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375044 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 375061 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 375068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375088 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375120 */     // GIR_Coverage, 4228,
     /* 375120 */     GIR_EraseRootFromParent_Done,
     /* 375121 */   // Label 7341: @375121
     /* 375121 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(375247), // Rule ID 4229 //
     /* 375126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375140 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375146 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375156 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375159 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375163 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375170 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 375187 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 375194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375214 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375246 */     // GIR_Coverage, 4229,
     /* 375246 */     GIR_EraseRootFromParent_Done,
     /* 375247 */   // Label 7342: @375247
     /* 375247 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(375362), // Rule ID 4198 //
     /* 375252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375278 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375285 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375295 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 375302 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 375309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375361 */     // GIR_Coverage, 4198,
     /* 375361 */     GIR_EraseRootFromParent_Done,
     /* 375362 */   // Label 7343: @375362
     /* 375362 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(375477), // Rule ID 4200 //
     /* 375367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375393 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375396 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375400 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 375417 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 375424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375444 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375476 */     // GIR_Coverage, 4200,
     /* 375476 */     GIR_EraseRootFromParent_Done,
     /* 375477 */   // Label 7344: @375477
     /* 375477 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(375599), // Rule ID 4234 //
     /* 375482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375508 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375511 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375515 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375522 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 375539 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 375546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375566 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375598 */     // GIR_Coverage, 4234,
     /* 375598 */     GIR_EraseRootFromParent_Done,
     /* 375599 */   // Label 7345: @375599
     /* 375599 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(375721), // Rule ID 4236 //
     /* 375604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375630 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375633 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375637 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375644 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 375661 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 375668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375688 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375720 */     // GIR_Coverage, 4236,
     /* 375720 */     GIR_EraseRootFromParent_Done,
     /* 375721 */   // Label 7346: @375721
     /* 375721 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(375835), // Rule ID 4190 //
     /* 375726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375740 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375746 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375756 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375780 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375802 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375834 */     // GIR_Coverage, 4190,
     /* 375834 */     GIR_EraseRootFromParent_Done,
     /* 375835 */   // Label 7347: @375835
     /* 375835 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(375949), // Rule ID 4191 //
     /* 375840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375854 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375870 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375877 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375894 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375916 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375948 */     // GIR_Coverage, 4191,
     /* 375948 */     GIR_EraseRootFromParent_Done,
     /* 375949 */   // Label 7348: @375949
     /* 375949 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(376070), // Rule ID 4226 //
     /* 375954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375974 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375984 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375987 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375991 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375998 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 376015 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 376015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 376022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376037 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376069 */     // GIR_Coverage, 4226,
     /* 376069 */     GIR_EraseRootFromParent_Done,
     /* 376070 */   // Label 7349: @376070
     /* 376070 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(376191), // Rule ID 4227 //
     /* 376075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376108 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376112 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376119 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 376136 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 376136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 376143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376158 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376190 */     // GIR_Coverage, 4227,
     /* 376190 */     GIR_EraseRootFromParent_Done,
     /* 376191 */   // Label 7350: @376191
     /* 376191 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(376301), // Rule ID 4194 //
     /* 376196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376222 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376229 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 376246 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 376246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 376253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376268 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376300 */     // GIR_Coverage, 4194,
     /* 376300 */     GIR_EraseRootFromParent_Done,
     /* 376301 */   // Label 7351: @376301
     /* 376301 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(376411), // Rule ID 4196 //
     /* 376306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376332 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376339 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 376356 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 376356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 376363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376378 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376410 */     // GIR_Coverage, 4196,
     /* 376410 */     GIR_EraseRootFromParent_Done,
     /* 376411 */   // Label 7352: @376411
     /* 376411 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(376528), // Rule ID 4230 //
     /* 376416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376442 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376445 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376449 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376456 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 376473 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 376473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 376480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376495 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376527 */     // GIR_Coverage, 4230,
     /* 376527 */     GIR_EraseRootFromParent_Done,
     /* 376528 */   // Label 7353: @376528
     /* 376528 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(376645), // Rule ID 4232 //
     /* 376533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376559 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376562 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376566 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376573 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 376590 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 376590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 376597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376612 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376644 */     // GIR_Coverage, 4232,
     /* 376644 */     GIR_EraseRootFromParent_Done,
     /* 376645 */   // Label 7354: @376645
     /* 376645 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(376768), // Rule ID 5761 //
     /* 376650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376697 */     // MIs[3] Operand 1
     /* 376697 */     // No operand predicates
     /* 376697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376703 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 376703 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 376706 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 376710 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 376722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376767 */     // GIR_Coverage, 5761,
     /* 376767 */     GIR_EraseRootFromParent_Done,
     /* 376768 */   // Label 7355: @376768
     /* 376768 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(376891), // Rule ID 5769 //
     /* 376773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376820 */     // MIs[3] Operand 1
     /* 376820 */     // No operand predicates
     /* 376820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376826 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 376826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 376829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 376833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 376845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376890 */     // GIR_Coverage, 5769,
     /* 376890 */     GIR_EraseRootFromParent_Done,
     /* 376891 */   // Label 7356: @376891
     /* 376891 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(376979), // Rule ID 1938 //
     /* 376896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376942 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376946 */     // MIs[2] Operand 1
     /* 376946 */     // No operand predicates
     /* 376946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376954 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376958 */     // MIs[3] Operand 1
     /* 376958 */     // No operand predicates
     /* 376958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376960 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 376960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 376977 */     GIR_RootConstrainSelectedInstOperands,
     /* 376978 */     // GIR_Coverage, 1938,
     /* 376978 */     GIR_EraseRootFromParent_Done,
     /* 376979 */   // Label 7357: @376979
     /* 376979 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(377078), // Rule ID 5758 //
     /* 376984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 377006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377018 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377022 */     // MIs[2] Operand 1
     /* 377022 */     // No operand predicates
     /* 377022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377030 */     // MIs[3] Operand 1
     /* 377030 */     // No operand predicates
     /* 377030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377032 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 377032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377044 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 377050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377076 */     GIR_RootConstrainSelectedInstOperands,
     /* 377077 */     // GIR_Coverage, 5758,
     /* 377077 */     GIR_EraseRootFromParent_Done,
     /* 377078 */   // Label 7358: @377078
     /* 377078 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(377177), // Rule ID 5766 //
     /* 377083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 377105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377117 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377121 */     // MIs[2] Operand 1
     /* 377121 */     // No operand predicates
     /* 377121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377129 */     // MIs[3] Operand 1
     /* 377129 */     // No operand predicates
     /* 377129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377131 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 377131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377143 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 377149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377175 */     GIR_RootConstrainSelectedInstOperands,
     /* 377176 */     // GIR_Coverage, 5766,
     /* 377176 */     GIR_EraseRootFromParent_Done,
     /* 377177 */   // Label 7359: @377177
     /* 377177 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(377254), // Rule ID 5760 //
     /* 377182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 377208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377225 */     // MIs[2] Operand 1
     /* 377225 */     // No operand predicates
     /* 377225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377233 */     // MIs[3] Operand 1
     /* 377233 */     // No operand predicates
     /* 377233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377235 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 377235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377240 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377252 */     GIR_RootConstrainSelectedInstOperands,
     /* 377253 */     // GIR_Coverage, 5760,
     /* 377253 */     GIR_EraseRootFromParent_Done,
     /* 377254 */   // Label 7360: @377254
     /* 377254 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(377362), // Rule ID 5762 //
     /* 377259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 377285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377302 */     // MIs[2] Operand 1
     /* 377302 */     // No operand predicates
     /* 377302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377310 */     // MIs[3] Operand 1
     /* 377310 */     // No operand predicates
     /* 377310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377312 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 377312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377331 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 377334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377360 */     GIR_RootConstrainSelectedInstOperands,
     /* 377361 */     // GIR_Coverage, 5762,
     /* 377361 */     GIR_EraseRootFromParent_Done,
     /* 377362 */   // Label 7361: @377362
     /* 377362 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(377439), // Rule ID 5768 //
     /* 377367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 377393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377410 */     // MIs[2] Operand 1
     /* 377410 */     // No operand predicates
     /* 377410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377418 */     // MIs[3] Operand 1
     /* 377418 */     // No operand predicates
     /* 377418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377420 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 377420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377425 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377437 */     GIR_RootConstrainSelectedInstOperands,
     /* 377438 */     // GIR_Coverage, 5768,
     /* 377438 */     GIR_EraseRootFromParent_Done,
     /* 377439 */   // Label 7362: @377439
     /* 377439 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(377547), // Rule ID 5770 //
     /* 377444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 377470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377487 */     // MIs[2] Operand 1
     /* 377487 */     // No operand predicates
     /* 377487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377495 */     // MIs[3] Operand 1
     /* 377495 */     // No operand predicates
     /* 377495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377497 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 377497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377509 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377516 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 377519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377545 */     GIR_RootConstrainSelectedInstOperands,
     /* 377546 */     // GIR_Coverage, 5770,
     /* 377546 */     GIR_EraseRootFromParent_Done,
     /* 377547 */   // Label 7363: @377547
     /* 377547 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(377626), // Rule ID 5685 //
     /* 377552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 377574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377580 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 377580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 377596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 377615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377625 */     // GIR_Coverage, 5685,
     /* 377625 */     GIR_EraseRootFromParent_Done,
     /* 377626 */   // Label 7364: @377626
     /* 377626 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(377705), // Rule ID 6480 //
     /* 377631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 377660 */     // MIs[1] Rn
     /* 377660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 377664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 377669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377681 */     // MIs[2] Operand 1
     /* 377681 */     // No operand predicates
     /* 377681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377683 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 377683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 377686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377703 */     GIR_RootConstrainSelectedInstOperands,
     /* 377704 */     // GIR_Coverage, 6480,
     /* 377704 */     GIR_EraseRootFromParent_Done,
     /* 377705 */   // Label 7365: @377705
     /* 377705 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(377791), // Rule ID 6481 //
     /* 377710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377735 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 377739 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377746 */     // MIs[1] Rn
     /* 377746 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 377750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 377755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377767 */     // MIs[2] Operand 1
     /* 377767 */     // No operand predicates
     /* 377767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377769 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 377769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 377772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377789 */     GIR_RootConstrainSelectedInstOperands,
     /* 377790 */     // GIR_Coverage, 6481,
     /* 377790 */     GIR_EraseRootFromParent_Done,
     /* 377791 */   // Label 7366: @377791
     /* 377791 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(377845), // Rule ID 1934 //
     /* 377796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 377817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 377821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377829 */     // MIs[1] Operand 1
     /* 377829 */     // No operand predicates
     /* 377829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377831 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 377831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 377834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 377841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377843 */     GIR_RootConstrainSelectedInstOperands,
     /* 377844 */     // GIR_Coverage, 1934,
     /* 377844 */     GIR_EraseRootFromParent_Done,
     /* 377845 */   // Label 7367: @377845
     /* 377845 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(377951), // Rule ID 5728 //
     /* 377850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 377872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377880 */     // MIs[1] Operand 1
     /* 377880 */     // No operand predicates
     /* 377880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377882 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 377885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377908 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 377915 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 377918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 377943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377949 */     GIR_RootConstrainSelectedInstOperands,
     /* 377950 */     // GIR_Coverage, 5728,
     /* 377950 */     GIR_EraseRootFromParent_Done,
     /* 377951 */   // Label 7368: @377951
     /* 377951 */   GIM_Reject,
     /* 377952 */ // Label 7338: @377952
     /* 377952 */ GIM_Reject,
     /* 377953 */ // Label 7131: @377953
     /* 377953 */ GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(378077), // Rule ID 11255 //
     /* 377958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 377961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 377964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 377967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377978 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 377982 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 377982 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 377985 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 377989 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377994 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 377998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378012 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378015 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378020 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378023 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378027 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378032 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 378044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378049 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378055 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378058 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 378066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378068 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378073 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378075 */   GIR_RootConstrainSelectedInstOperands,
     /* 378076 */   // GIR_Coverage, 11255,
     /* 378076 */   GIR_EraseRootFromParent_Done,
     /* 378077 */ // Label 7369: @378077
     /* 378077 */ GIM_Reject,
     /* 378078 */ // Label 7132: @378078
     /* 378078 */ GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(378202), // Rule ID 11258 //
     /* 378083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 378089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378092 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378103 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 378107 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 378107 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 378110 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 378114 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378119 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 378123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378125 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378128 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378132 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378137 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378140 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378145 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378148 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378152 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378157 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 378169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378174 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378177 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378180 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378183 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 378191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378193 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378198 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378200 */   GIR_RootConstrainSelectedInstOperands,
     /* 378201 */   // GIR_Coverage, 11258,
     /* 378201 */   GIR_EraseRootFromParent_Done,
     /* 378202 */ // Label 7370: @378202
     /* 378202 */ GIM_Reject,
     /* 378203 */ // Label 7133: @378203
     /* 378203 */ GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(380180),
     /* 378208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 378211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 378214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378221 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(378330), // Rule ID 4360 //
     /* 378226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378230 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378236 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378246 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378253 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378270 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378297 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378329 */     // GIR_Coverage, 4360,
     /* 378329 */     GIR_EraseRootFromParent_Done,
     /* 378330 */   // Label 7372: @378330
     /* 378330 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(378439), // Rule ID 4361 //
     /* 378335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378339 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378345 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378355 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378362 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378379 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378406 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378438 */     // GIR_Coverage, 4361,
     /* 378438 */     GIR_EraseRootFromParent_Done,
     /* 378439 */   // Label 7373: @378439
     /* 378439 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(378548), // Rule ID 4468 //
     /* 378444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378448 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378454 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378464 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378471 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378488 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378515 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378547 */     // GIR_Coverage, 4468,
     /* 378547 */     GIR_EraseRootFromParent_Done,
     /* 378548 */   // Label 7374: @378548
     /* 378548 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(378657), // Rule ID 4469 //
     /* 378553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378557 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378563 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378573 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378580 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378597 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378624 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378656 */     // GIR_Coverage, 4469,
     /* 378656 */     GIR_EraseRootFromParent_Done,
     /* 378657 */   // Label 7375: @378657
     /* 378657 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(378762), // Rule ID 4366 //
     /* 378662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378678 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378685 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378702 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378729 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378761 */     // GIR_Coverage, 4366,
     /* 378761 */     GIR_EraseRootFromParent_Done,
     /* 378762 */   // Label 7376: @378762
     /* 378762 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(378867), // Rule ID 4368 //
     /* 378767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378783 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378807 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378834 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378866 */     // GIR_Coverage, 4368,
     /* 378866 */     GIR_EraseRootFromParent_Done,
     /* 378867 */   // Label 7377: @378867
     /* 378867 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(378972), // Rule ID 4474 //
     /* 378872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378888 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378895 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378912 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378939 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378971 */     // GIR_Coverage, 4474,
     /* 378971 */     GIR_EraseRootFromParent_Done,
     /* 378972 */   // Label 7378: @378972
     /* 378972 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(379077), // Rule ID 4476 //
     /* 378977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378993 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379000 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 379017 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 379024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379044 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379076 */     // GIR_Coverage, 4476,
     /* 379076 */     GIR_EraseRootFromParent_Done,
     /* 379077 */   // Label 7379: @379077
     /* 379077 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(379181), // Rule ID 4358 //
     /* 379082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379086 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379092 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379102 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379109 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379126 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379148 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379180 */     // GIR_Coverage, 4358,
     /* 379180 */     GIR_EraseRootFromParent_Done,
     /* 379181 */   // Label 7380: @379181
     /* 379181 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(379285), // Rule ID 4359 //
     /* 379186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379190 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379196 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379206 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379213 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379230 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379252 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379284 */     // GIR_Coverage, 4359,
     /* 379284 */     GIR_EraseRootFromParent_Done,
     /* 379285 */   // Label 7381: @379285
     /* 379285 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(379389), // Rule ID 4466 //
     /* 379290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379294 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379300 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379310 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379317 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379334 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379356 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379388 */     // GIR_Coverage, 4466,
     /* 379388 */     GIR_EraseRootFromParent_Done,
     /* 379389 */   // Label 7382: @379389
     /* 379389 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(379493), // Rule ID 4467 //
     /* 379394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379398 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379404 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379414 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379421 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379438 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379460 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379492 */     // GIR_Coverage, 4467,
     /* 379492 */     GIR_EraseRootFromParent_Done,
     /* 379493 */   // Label 7383: @379493
     /* 379493 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(379593), // Rule ID 4362 //
     /* 379498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379514 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379521 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379538 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379560 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379592 */     // GIR_Coverage, 4362,
     /* 379592 */     GIR_EraseRootFromParent_Done,
     /* 379593 */   // Label 7384: @379593
     /* 379593 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(379693), // Rule ID 4364 //
     /* 379598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379614 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379621 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379638 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379660 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379692 */     // GIR_Coverage, 4364,
     /* 379692 */     GIR_EraseRootFromParent_Done,
     /* 379693 */   // Label 7385: @379693
     /* 379693 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(379793), // Rule ID 4470 //
     /* 379698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379714 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379721 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379738 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379760 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379792 */     // GIR_Coverage, 4470,
     /* 379792 */     GIR_EraseRootFromParent_Done,
     /* 379793 */   // Label 7386: @379793
     /* 379793 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(379893), // Rule ID 4472 //
     /* 379798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379814 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379821 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379838 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379860 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379892 */     // GIR_Coverage, 4472,
     /* 379892 */     GIR_EraseRootFromParent_Done,
     /* 379893 */   // Label 7387: @379893
     /* 379893 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(379957), // Rule ID 11313 //
     /* 379898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 379921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379933 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 379937 */     // MIs[3] Operand 1
     /* 379937 */     // No operand predicates
     /* 379937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379943 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 379943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 379946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 379952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 379955 */     GIR_RootConstrainSelectedInstOperands,
     /* 379956 */     // GIR_Coverage, 11313,
     /* 379956 */     GIR_EraseRootFromParent_Done,
     /* 379957 */   // Label 7388: @379957
     /* 379957 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(380068), // Rule ID 11254 //
     /* 379962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379973 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 379973 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379976 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379980 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379985 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379991 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379994 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379998 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380003 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380006 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 380018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380023 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 380035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380049 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 380057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380059 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380066 */     GIR_RootConstrainSelectedInstOperands,
     /* 380067 */     // GIR_Coverage, 11254,
     /* 380067 */     GIR_EraseRootFromParent_Done,
     /* 380068 */   // Label 7389: @380068
     /* 380068 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(380179), // Rule ID 11260 //
     /* 380073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380084 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 380084 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380087 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 380091 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380096 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 380100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380102 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 380105 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 380109 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380114 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380117 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 380129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380134 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 380146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380154 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380160 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 380168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380170 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380175 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380177 */     GIR_RootConstrainSelectedInstOperands,
     /* 380178 */     // GIR_Coverage, 11260,
     /* 380178 */     GIR_EraseRootFromParent_Done,
     /* 380179 */   // Label 7390: @380179
     /* 380179 */   GIM_Reject,
     /* 380180 */ // Label 7371: @380180
     /* 380180 */ GIM_Reject,
     /* 380181 */ // Label 7134: @380181
     /* 380181 */ GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(380332), // Rule ID 11256 //
     /* 380186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 380192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380206 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380210 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 380210 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 380213 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380217 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380222 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 380228 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380233 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380238 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380241 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 380245 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380250 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380255 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 380258 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 380262 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380267 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380270 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380275 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380278 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 380282 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380287 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 380299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380304 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380307 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380310 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380313 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 380321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380323 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380328 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380330 */   GIR_RootConstrainSelectedInstOperands,
     /* 380331 */   // GIR_Coverage, 11256,
     /* 380331 */   GIR_EraseRootFromParent_Done,
     /* 380332 */ // Label 7391: @380332
     /* 380332 */ GIM_Reject,
     /* 380333 */ // Label 7135: @380333
     /* 380333 */ GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(382364),
     /* 380338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 380341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380351 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(380460), // Rule ID 4324 //
     /* 380356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380360 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380366 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380376 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380383 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380400 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380427 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380459 */     // GIR_Coverage, 4324,
     /* 380459 */     GIR_EraseRootFromParent_Done,
     /* 380460 */   // Label 7393: @380460
     /* 380460 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(380569), // Rule ID 4325 //
     /* 380465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380469 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380475 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380485 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380492 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380509 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380536 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380568 */     // GIR_Coverage, 4325,
     /* 380568 */     GIR_EraseRootFromParent_Done,
     /* 380569 */   // Label 7394: @380569
     /* 380569 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(380678), // Rule ID 4432 //
     /* 380574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380578 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380584 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380594 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380601 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380618 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380645 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380677 */     // GIR_Coverage, 4432,
     /* 380677 */     GIR_EraseRootFromParent_Done,
     /* 380678 */   // Label 7395: @380678
     /* 380678 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(380787), // Rule ID 4433 //
     /* 380683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380687 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380693 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380703 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380710 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380727 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380754 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380786 */     // GIR_Coverage, 4433,
     /* 380786 */     GIR_EraseRootFromParent_Done,
     /* 380787 */   // Label 7396: @380787
     /* 380787 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(380892), // Rule ID 4330 //
     /* 380792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380808 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380815 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380832 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380859 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380891 */     // GIR_Coverage, 4330,
     /* 380891 */     GIR_EraseRootFromParent_Done,
     /* 380892 */   // Label 7397: @380892
     /* 380892 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(380997), // Rule ID 4332 //
     /* 380897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380913 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380920 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380937 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380964 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380996 */     // GIR_Coverage, 4332,
     /* 380996 */     GIR_EraseRootFromParent_Done,
     /* 380997 */   // Label 7398: @380997
     /* 380997 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(381102), // Rule ID 4438 //
     /* 381002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381025 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 381042 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 381049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381069 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381101 */     // GIR_Coverage, 4438,
     /* 381101 */     GIR_EraseRootFromParent_Done,
     /* 381102 */   // Label 7399: @381102
     /* 381102 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(381207), // Rule ID 4440 //
     /* 381107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381123 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381126 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381130 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 381147 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 381154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381174 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381206 */     // GIR_Coverage, 4440,
     /* 381206 */     GIR_EraseRootFromParent_Done,
     /* 381207 */   // Label 7400: @381207
     /* 381207 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(381311), // Rule ID 4322 //
     /* 381212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381216 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381222 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381232 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381239 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381256 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381278 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381310 */     // GIR_Coverage, 4322,
     /* 381310 */     GIR_EraseRootFromParent_Done,
     /* 381311 */   // Label 7401: @381311
     /* 381311 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(381415), // Rule ID 4323 //
     /* 381316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381320 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381326 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381336 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381343 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381360 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381382 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381414 */     // GIR_Coverage, 4323,
     /* 381414 */     GIR_EraseRootFromParent_Done,
     /* 381415 */   // Label 7402: @381415
     /* 381415 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(381519), // Rule ID 4430 //
     /* 381420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381430 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381440 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381447 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381464 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381486 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381518 */     // GIR_Coverage, 4430,
     /* 381518 */     GIR_EraseRootFromParent_Done,
     /* 381519 */   // Label 7403: @381519
     /* 381519 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(381623), // Rule ID 4431 //
     /* 381524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381528 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381534 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381544 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381551 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381568 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381590 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381622 */     // GIR_Coverage, 4431,
     /* 381622 */     GIR_EraseRootFromParent_Done,
     /* 381623 */   // Label 7404: @381623
     /* 381623 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(381723), // Rule ID 4326 //
     /* 381628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381644 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381651 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381668 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381690 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381722 */     // GIR_Coverage, 4326,
     /* 381722 */     GIR_EraseRootFromParent_Done,
     /* 381723 */   // Label 7405: @381723
     /* 381723 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(381823), // Rule ID 4328 //
     /* 381728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381744 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381751 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381768 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381790 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381822 */     // GIR_Coverage, 4328,
     /* 381822 */     GIR_EraseRootFromParent_Done,
     /* 381823 */   // Label 7406: @381823
     /* 381823 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(381923), // Rule ID 4434 //
     /* 381828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381844 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381851 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381868 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381890 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381922 */     // GIR_Coverage, 4434,
     /* 381922 */     GIR_EraseRootFromParent_Done,
     /* 381923 */   // Label 7407: @381923
     /* 381923 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(382023), // Rule ID 4436 //
     /* 381928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381944 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381951 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381968 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381990 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382022 */     // GIR_Coverage, 4436,
     /* 382022 */     GIR_EraseRootFromParent_Done,
     /* 382023 */   // Label 7408: @382023
     /* 382023 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(382087), // Rule ID 11311 //
     /* 382028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 382051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382063 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 382067 */     // MIs[3] Operand 1
     /* 382067 */     // No operand predicates
     /* 382067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382073 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 382073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 382076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 382082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 382085 */     GIR_RootConstrainSelectedInstOperands,
     /* 382086 */     // GIR_Coverage, 11311,
     /* 382086 */     GIR_EraseRootFromParent_Done,
     /* 382087 */   // Label 7409: @382087
     /* 382087 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(382225), // Rule ID 11253 //
     /* 382092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382103 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 382103 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 382106 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382110 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382115 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382121 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382126 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382131 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382134 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 382138 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382143 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382148 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382151 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 382155 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382160 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382163 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382168 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382171 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 382175 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382180 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 382192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382200 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382206 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 382214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382216 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382221 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382223 */     GIR_RootConstrainSelectedInstOperands,
     /* 382224 */     // GIR_Coverage, 11253,
     /* 382224 */     GIR_EraseRootFromParent_Done,
     /* 382225 */   // Label 7410: @382225
     /* 382225 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(382363), // Rule ID 11259 //
     /* 382230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382241 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 382241 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 382244 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382248 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382253 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382259 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382264 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382269 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382272 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 382276 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382281 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382286 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382289 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 382293 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382298 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382301 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 382313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382318 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 382330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382338 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382344 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 382352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382354 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382361 */     GIR_RootConstrainSelectedInstOperands,
     /* 382362 */     // GIR_Coverage, 11259,
     /* 382362 */     GIR_EraseRootFromParent_Done,
     /* 382363 */   // Label 7411: @382363
     /* 382363 */   GIM_Reject,
     /* 382364 */ // Label 7392: @382364
     /* 382364 */ GIM_Reject,
     /* 382365 */ // Label 7136: @382365
     /* 382365 */ GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(384632),
     /* 382370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 382373 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(382499), // Rule ID 4288 //
     /* 382378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382408 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382411 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382415 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382422 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382439 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382466 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382498 */     // GIR_Coverage, 4288,
     /* 382498 */     GIR_EraseRootFromParent_Done,
     /* 382499 */   // Label 7413: @382499
     /* 382499 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(382625), // Rule ID 4289 //
     /* 382504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382518 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382524 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382534 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382537 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382541 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382548 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382565 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382592 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382624 */     // GIR_Coverage, 4289,
     /* 382624 */     GIR_EraseRootFromParent_Done,
     /* 382625 */   // Label 7414: @382625
     /* 382625 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(382744), // Rule ID 4396 //
     /* 382630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382684 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382711 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382743 */     // GIR_Coverage, 4396,
     /* 382743 */     GIR_EraseRootFromParent_Done,
     /* 382744 */   // Label 7415: @382744
     /* 382744 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(382863), // Rule ID 4397 //
     /* 382749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382763 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382769 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382779 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382786 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382803 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382830 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382862 */     // GIR_Coverage, 4397,
     /* 382862 */     GIR_EraseRootFromParent_Done,
     /* 382863 */   // Label 7416: @382863
     /* 382863 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(382985), // Rule ID 4294 //
     /* 382868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382894 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382897 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382901 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382908 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382925 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382952 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382984 */     // GIR_Coverage, 4294,
     /* 382984 */     GIR_EraseRootFromParent_Done,
     /* 382985 */   // Label 7417: @382985
     /* 382985 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(383107), // Rule ID 4296 //
     /* 382990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383016 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383019 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383023 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383030 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 383047 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 383054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383074 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383106 */     // GIR_Coverage, 4296,
     /* 383106 */     GIR_EraseRootFromParent_Done,
     /* 383107 */   // Label 7418: @383107
     /* 383107 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(383222), // Rule ID 4402 //
     /* 383112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383138 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383145 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 383162 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 383169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383189 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383221 */     // GIR_Coverage, 4402,
     /* 383221 */     GIR_EraseRootFromParent_Done,
     /* 383222 */   // Label 7419: @383222
     /* 383222 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(383337), // Rule ID 4404 //
     /* 383227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383253 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383260 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 383277 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 383284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383336 */     // GIR_Coverage, 4404,
     /* 383336 */     GIR_EraseRootFromParent_Done,
     /* 383337 */   // Label 7420: @383337
     /* 383337 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(383458), // Rule ID 4286 //
     /* 383342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383372 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383375 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383379 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383386 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383403 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383457 */     // GIR_Coverage, 4286,
     /* 383457 */     GIR_EraseRootFromParent_Done,
     /* 383458 */   // Label 7421: @383458
     /* 383458 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(383579), // Rule ID 4287 //
     /* 383463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383483 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383493 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383496 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383500 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383507 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383524 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383546 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383578 */     // GIR_Coverage, 4287,
     /* 383578 */     GIR_EraseRootFromParent_Done,
     /* 383579 */   // Label 7422: @383579
     /* 383579 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(383693), // Rule ID 4394 //
     /* 383584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383598 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383604 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383614 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383621 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383638 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383660 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383692 */     // GIR_Coverage, 4394,
     /* 383692 */     GIR_EraseRootFromParent_Done,
     /* 383693 */   // Label 7423: @383693
     /* 383693 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(383807), // Rule ID 4395 //
     /* 383698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383712 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383718 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383728 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383735 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383752 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383806 */     // GIR_Coverage, 4395,
     /* 383806 */     GIR_EraseRootFromParent_Done,
     /* 383807 */   // Label 7424: @383807
     /* 383807 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(383924), // Rule ID 4290 //
     /* 383812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383838 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383841 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383845 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383852 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383869 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383891 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383923 */     // GIR_Coverage, 4290,
     /* 383923 */     GIR_EraseRootFromParent_Done,
     /* 383924 */   // Label 7425: @383924
     /* 383924 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(384041), // Rule ID 4292 //
     /* 383929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383955 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383958 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383962 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383969 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383986 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384008 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384040 */     // GIR_Coverage, 4292,
     /* 384040 */     GIR_EraseRootFromParent_Done,
     /* 384041 */   // Label 7426: @384041
     /* 384041 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(384151), // Rule ID 4398 //
     /* 384046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384072 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384079 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 384096 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 384096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 384103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384118 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384150 */     // GIR_Coverage, 4398,
     /* 384150 */     GIR_EraseRootFromParent_Done,
     /* 384151 */   // Label 7427: @384151
     /* 384151 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(384261), // Rule ID 4400 //
     /* 384156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 384206 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 384206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 384213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384228 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384260 */     // GIR_Coverage, 4400,
     /* 384260 */     GIR_EraseRootFromParent_Done,
     /* 384261 */   // Label 7428: @384261
     /* 384261 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(384335), // Rule ID 11309 //
     /* 384266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 384299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384311 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 384315 */     // MIs[3] Operand 1
     /* 384315 */     // No operand predicates
     /* 384315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384321 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 384321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 384324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 384330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 384333 */     GIR_RootConstrainSelectedInstOperands,
     /* 384334 */     // GIR_Coverage, 11309,
     /* 384334 */     GIR_EraseRootFromParent_Done,
     /* 384335 */   // Label 7429: @384335
     /* 384335 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(384483), // Rule ID 11252 //
     /* 384340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384361 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 384361 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 384364 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384368 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384373 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 384379 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384384 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384389 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 384392 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 384396 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384401 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 384404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 384406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 384409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 384413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384418 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 384421 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 384424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 384426 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 384429 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 384433 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384438 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 384441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 384446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 384450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384458 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 384461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 384464 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 384467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 384472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384474 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 384476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384479 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 384481 */     GIR_RootConstrainSelectedInstOperands,
     /* 384482 */     // GIR_Coverage, 11252,
     /* 384482 */     GIR_EraseRootFromParent_Done,
     /* 384483 */   // Label 7430: @384483
     /* 384483 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(384631), // Rule ID 11257 //
     /* 384488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384509 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 384509 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 384512 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384516 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384521 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 384527 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384532 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384537 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 384540 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 384544 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384549 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 384552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 384554 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 384557 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 384561 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384566 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 384569 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 384572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 384574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 384577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 384581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384586 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 384589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 384594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 384598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 384609 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 384612 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 384615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 384620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384622 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 384624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384627 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 384629 */     GIR_RootConstrainSelectedInstOperands,
     /* 384630 */     // GIR_Coverage, 11257,
     /* 384630 */     GIR_EraseRootFromParent_Done,
     /* 384631 */   // Label 7431: @384631
     /* 384631 */   GIM_Reject,
     /* 384632 */ // Label 7412: @384632
     /* 384632 */ GIM_Reject,
     /* 384633 */ // Label 7137: @384633
     /* 384633 */ GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(386752),
     /* 384638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 384641 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(384760), // Rule ID 4216 //
     /* 384646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384660 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384666 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384676 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384683 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384700 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384727 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384759 */     // GIR_Coverage, 4216,
     /* 384759 */     GIR_EraseRootFromParent_Done,
     /* 384760 */   // Label 7433: @384760
     /* 384760 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(384879), // Rule ID 4217 //
     /* 384765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384779 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384785 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384802 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384819 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384846 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384878 */     // GIR_Coverage, 4217,
     /* 384878 */     GIR_EraseRootFromParent_Done,
     /* 384879 */   // Label 7434: @384879
     /* 384879 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(385005), // Rule ID 4252 //
     /* 384884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384914 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384917 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384921 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384928 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384945 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384972 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385004 */     // GIR_Coverage, 4252,
     /* 385004 */     GIR_EraseRootFromParent_Done,
     /* 385005 */   // Label 7435: @385005
     /* 385005 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(385131), // Rule ID 4253 //
     /* 385010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385024 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385030 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385040 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385043 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385047 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385054 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 385071 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 385078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385098 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385130 */     // GIR_Coverage, 4253,
     /* 385130 */     GIR_EraseRootFromParent_Done,
     /* 385131 */   // Label 7436: @385131
     /* 385131 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(385246), // Rule ID 4222 //
     /* 385136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385162 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385169 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 385186 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 385193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385213 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385245 */     // GIR_Coverage, 4222,
     /* 385245 */     GIR_EraseRootFromParent_Done,
     /* 385246 */   // Label 7437: @385246
     /* 385246 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(385361), // Rule ID 4224 //
     /* 385251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385277 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385284 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 385301 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 385308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385328 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385360 */     // GIR_Coverage, 4224,
     /* 385360 */     GIR_EraseRootFromParent_Done,
     /* 385361 */   // Label 7438: @385361
     /* 385361 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(385483), // Rule ID 4258 //
     /* 385366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385392 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385395 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385399 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385406 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 385423 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 385430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385450 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385482 */     // GIR_Coverage, 4258,
     /* 385482 */     GIR_EraseRootFromParent_Done,
     /* 385483 */   // Label 7439: @385483
     /* 385483 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(385605), // Rule ID 4260 //
     /* 385488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385514 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385517 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385521 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385528 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 385545 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 385552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385572 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385604 */     // GIR_Coverage, 4260,
     /* 385604 */     GIR_EraseRootFromParent_Done,
     /* 385605 */   // Label 7440: @385605
     /* 385605 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(385719), // Rule ID 4214 //
     /* 385610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385624 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385630 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385640 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385647 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385664 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385686 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385718 */     // GIR_Coverage, 4214,
     /* 385718 */     GIR_EraseRootFromParent_Done,
     /* 385719 */   // Label 7441: @385719
     /* 385719 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(385833), // Rule ID 4215 //
     /* 385724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385738 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385744 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385761 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385778 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385800 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385832 */     // GIR_Coverage, 4215,
     /* 385832 */     GIR_EraseRootFromParent_Done,
     /* 385833 */   // Label 7442: @385833
     /* 385833 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(385954), // Rule ID 4250 //
     /* 385838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385868 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385871 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385875 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385882 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385899 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385921 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385953 */     // GIR_Coverage, 4250,
     /* 385953 */     GIR_EraseRootFromParent_Done,
     /* 385954 */   // Label 7443: @385954
     /* 385954 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(386075), // Rule ID 4251 //
     /* 385959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385973 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385979 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385989 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385992 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385996 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386003 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 386020 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 386020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 386027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386042 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386074 */     // GIR_Coverage, 4251,
     /* 386074 */     GIR_EraseRootFromParent_Done,
     /* 386075 */   // Label 7444: @386075
     /* 386075 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(386185), // Rule ID 4218 //
     /* 386080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386106 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386113 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 386130 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 386130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 386137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386152 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386184 */     // GIR_Coverage, 4218,
     /* 386184 */     GIR_EraseRootFromParent_Done,
     /* 386185 */   // Label 7445: @386185
     /* 386185 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(386295), // Rule ID 4220 //
     /* 386190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386216 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386223 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 386240 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 386240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 386247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386262 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386294 */     // GIR_Coverage, 4220,
     /* 386294 */     GIR_EraseRootFromParent_Done,
     /* 386295 */   // Label 7446: @386295
     /* 386295 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(386412), // Rule ID 4254 //
     /* 386300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386326 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386329 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386333 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386340 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 386357 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 386357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 386364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386379 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386411 */     // GIR_Coverage, 4254,
     /* 386411 */     GIR_EraseRootFromParent_Done,
     /* 386412 */   // Label 7447: @386412
     /* 386412 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(386529), // Rule ID 4256 //
     /* 386417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386443 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386446 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386450 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386457 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 386474 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 386474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 386481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386496 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386528 */     // GIR_Coverage, 4256,
     /* 386528 */     GIR_EraseRootFromParent_Done,
     /* 386529 */   // Label 7448: @386529
     /* 386529 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(386603), // Rule ID 11307 //
     /* 386534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 386583 */     // MIs[3] Operand 1
     /* 386583 */     // No operand predicates
     /* 386583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386589 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 386589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 386592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 386594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 386598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 386601 */     GIR_RootConstrainSelectedInstOperands,
     /* 386602 */     // GIR_Coverage, 11307,
     /* 386602 */     GIR_EraseRootFromParent_Done,
     /* 386603 */   // Label 7449: @386603
     /* 386603 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(386751), // Rule ID 11251 //
     /* 386608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386629 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 386629 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 386632 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386636 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386641 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 386647 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386652 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386657 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 386660 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 386664 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386669 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 386672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 386674 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 386677 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 386681 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386686 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 386689 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 386692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 386694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 386697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 386701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386706 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 386709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 386711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 386718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 386726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 386729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 386732 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 386740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 386742 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 386749 */     GIR_RootConstrainSelectedInstOperands,
     /* 386750 */     // GIR_Coverage, 11251,
     /* 386750 */     GIR_EraseRootFromParent_Done,
     /* 386751 */   // Label 7450: @386751
     /* 386751 */   GIM_Reject,
     /* 386752 */ // Label 7432: @386752
     /* 386752 */ GIM_Reject,
     /* 386753 */ // Label 7138: @386753
     /* 386753 */ GIM_Reject,
     /* 386754 */ // Label 91: @386754
     /* 386754 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7454*/ GIMT_Encode4(389671),
     /* 386765 */ /*GILLT_s16*//*Label 7451*/ GIMT_Encode4(386777),
     /* 386769 */ /*GILLT_s32*//*Label 7452*/ GIMT_Encode4(387411),
     /* 386773 */ /*GILLT_s64*//*Label 7453*/ GIMT_Encode4(389004),
     /* 386777 */ // Label 7451: @386777
     /* 386777 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(386821), // Rule ID 11300 //
     /* 386782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386795 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386799 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 386799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386804 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386820 */   // GIR_Coverage, 11300,
     /* 386820 */   GIR_EraseRootFromParent_Done,
     /* 386821 */ // Label 7455: @386821
     /* 386821 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(386865), // Rule ID 11301 //
     /* 386826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386839 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386843 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 386843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386848 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386864 */   // GIR_Coverage, 11301,
     /* 386864 */   GIR_EraseRootFromParent_Done,
     /* 386865 */ // Label 7456: @386865
     /* 386865 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(386909), // Rule ID 11302 //
     /* 386870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 386876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386883 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386887 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 386887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386892 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386908 */   // GIR_Coverage, 11302,
     /* 386908 */   GIR_EraseRootFromParent_Done,
     /* 386909 */ // Label 7457: @386909
     /* 386909 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(386954), // Rule ID 5822 //
     /* 386914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386928 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386932 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 386932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386937 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 386943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386948 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386953 */   // GIR_Coverage, 5822,
     /* 386953 */   GIR_EraseRootFromParent_Done,
     /* 386954 */ // Label 7458: @386954
     /* 386954 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(386999), // Rule ID 5825 //
     /* 386959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386981 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386985 */   // MIs[1] Operand 1
     /* 386985 */   // No operand predicates
     /* 386985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386987 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 386990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386992 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386994 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386997 */   GIR_RootConstrainSelectedInstOperands,
     /* 386998 */   // GIR_Coverage, 5825,
     /* 386998 */   GIR_EraseRootFromParent_Done,
     /* 386999 */ // Label 7459: @386999
     /* 386999 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(387075), // Rule ID 11275 //
     /* 387004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387025 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 387029 */   // MIs[1] Operand 1
     /* 387029 */   // No operand predicates
     /* 387029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387031 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 387031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 387038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387047 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387057 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 387064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387074 */   // GIR_Coverage, 11275,
     /* 387074 */   GIR_EraseRootFromParent_Done,
     /* 387075 */ // Label 7460: @387075
     /* 387075 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(387151), // Rule ID 11276 //
     /* 387080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 387086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387101 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 387105 */   // MIs[1] Operand 1
     /* 387105 */   // No operand predicates
     /* 387105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387107 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 387107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 387114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387119 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387123 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387133 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 387140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387150 */   // GIR_Coverage, 11276,
     /* 387150 */   GIR_EraseRootFromParent_Done,
     /* 387151 */ // Label 7461: @387151
     /* 387151 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(387227), // Rule ID 11277 //
     /* 387156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 387162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387177 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387181 */   // MIs[1] Operand 1
     /* 387181 */   // No operand predicates
     /* 387181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387183 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 387183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387195 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387199 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387209 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 387216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387226 */   // GIR_Coverage, 11277,
     /* 387226 */   GIR_EraseRootFromParent_Done,
     /* 387227 */ // Label 7462: @387227
     /* 387227 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(387288), // Rule ID 11265 //
     /* 387232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387249 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 387249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 387256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387261 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387267 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387271 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 387279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387284 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387286 */   GIR_RootConstrainSelectedInstOperands,
     /* 387287 */   // GIR_Coverage, 11265,
     /* 387287 */   GIR_EraseRootFromParent_Done,
     /* 387288 */ // Label 7463: @387288
     /* 387288 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(387349), // Rule ID 11266 //
     /* 387293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 387299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387310 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 387310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387322 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387328 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387332 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 387340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387345 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387347 */   GIR_RootConstrainSelectedInstOperands,
     /* 387348 */   // GIR_Coverage, 11266,
     /* 387348 */   GIR_EraseRootFromParent_Done,
     /* 387349 */ // Label 7464: @387349
     /* 387349 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(387410), // Rule ID 11267 //
     /* 387354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 387360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387371 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 387371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387383 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387389 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387393 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 387401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387406 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387408 */   GIR_RootConstrainSelectedInstOperands,
     /* 387409 */   // GIR_Coverage, 11267,
     /* 387409 */   GIR_EraseRootFromParent_Done,
     /* 387410 */ // Label 7465: @387410
     /* 387410 */ GIM_Reject,
     /* 387411 */ // Label 7452: @387411
     /* 387411 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(387456), // Rule ID 7009 //
     /* 387416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387430 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387434 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 387434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387439 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 387445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387450 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387455 */   // GIR_Coverage, 7009,
     /* 387455 */   GIR_EraseRootFromParent_Done,
     /* 387456 */ // Label 7466: @387456
     /* 387456 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(387501), // Rule ID 7010 //
     /* 387461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387475 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387479 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 387479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387484 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 387490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387500 */   // GIR_Coverage, 7010,
     /* 387500 */   GIR_EraseRootFromParent_Done,
     /* 387501 */ // Label 7467: @387501
     /* 387501 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(387545), // Rule ID 11296 //
     /* 387506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387519 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387523 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 387523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387528 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387544 */   // GIR_Coverage, 11296,
     /* 387544 */   GIR_EraseRootFromParent_Done,
     /* 387545 */ // Label 7468: @387545
     /* 387545 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(387589), // Rule ID 11297 //
     /* 387550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387563 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387567 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 387567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387572 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387588 */   // GIR_Coverage, 11297,
     /* 387588 */   GIR_EraseRootFromParent_Done,
     /* 387589 */ // Label 7469: @387589
     /* 387589 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387633), // Rule ID 11298 //
     /* 387594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387607 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387611 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 387611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387616 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387632 */   // GIR_Coverage, 11298,
     /* 387632 */   GIR_EraseRootFromParent_Done,
     /* 387633 */ // Label 7470: @387633
     /* 387633 */ GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387677), // Rule ID 11303 //
     /* 387638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387651 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387655 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 387655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387660 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387676 */   // GIR_Coverage, 11303,
     /* 387676 */   GIR_EraseRootFromParent_Done,
     /* 387677 */ // Label 7471: @387677
     /* 387677 */ GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387721), // Rule ID 11304 //
     /* 387682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 387688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387695 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387699 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 387699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387704 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387720 */   // GIR_Coverage, 11304,
     /* 387720 */   GIR_EraseRootFromParent_Done,
     /* 387721 */ // Label 7472: @387721
     /* 387721 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387766), // Rule ID 5821 //
     /* 387726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387740 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387744 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 387744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387749 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 387755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387765 */   // GIR_Coverage, 5821,
     /* 387765 */   GIR_EraseRootFromParent_Done,
     /* 387766 */ // Label 7473: @387766
     /* 387766 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387839), // Rule ID 11281 //
     /* 387771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387784 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387788 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387792 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 387796 */   // MIs[1] Operand 1
     /* 387796 */   // No operand predicates
     /* 387796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387798 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 387798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 387801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387810 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387816 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387821 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 387829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387834 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387837 */   GIR_RootConstrainSelectedInstOperands,
     /* 387838 */   // GIR_Coverage, 11281,
     /* 387838 */   GIR_EraseRootFromParent_Done,
     /* 387839 */ // Label 7474: @387839
     /* 387839 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(387912), // Rule ID 11282 //
     /* 387844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387865 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387869 */   // MIs[1] Operand 1
     /* 387869 */   // No operand predicates
     /* 387869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387871 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 387871 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 387874 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387878 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387883 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 387902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387907 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387910 */   GIR_RootConstrainSelectedInstOperands,
     /* 387911 */   // GIR_Coverage, 11282,
     /* 387911 */   GIR_EraseRootFromParent_Done,
     /* 387912 */ // Label 7475: @387912
     /* 387912 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(387985), // Rule ID 11283 //
     /* 387917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387930 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387934 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387938 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387942 */   // MIs[1] Operand 1
     /* 387942 */   // No operand predicates
     /* 387942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387944 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 387944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 387947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387956 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387962 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 387975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387980 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387983 */   GIR_RootConstrainSelectedInstOperands,
     /* 387984 */   // GIR_Coverage, 11283,
     /* 387984 */   GIR_EraseRootFromParent_Done,
     /* 387985 */ // Label 7476: @387985
     /* 387985 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(388033), // Rule ID 1926 //
     /* 387990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 387996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388015 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 388019 */   // MIs[1] Operand 1
     /* 388019 */   // No operand predicates
     /* 388019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388021 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 388024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388026 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388028 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388031 */   GIR_RootConstrainSelectedInstOperands,
     /* 388032 */   // GIR_Coverage, 1926,
     /* 388032 */   GIR_EraseRootFromParent_Done,
     /* 388033 */ // Label 7477: @388033
     /* 388033 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(388081), // Rule ID 1927 //
     /* 388038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 388041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388063 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 388067 */   // MIs[1] Operand 1
     /* 388067 */   // No operand predicates
     /* 388067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388069 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 388072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388074 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388076 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388079 */   GIR_RootConstrainSelectedInstOperands,
     /* 388080 */   // GIR_Coverage, 1927,
     /* 388080 */   GIR_EraseRootFromParent_Done,
     /* 388081 */ // Label 7478: @388081
     /* 388081 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(388129), // Rule ID 1928 //
     /* 388086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 388089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388111 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 388115 */   // MIs[1] Operand 1
     /* 388115 */   // No operand predicates
     /* 388115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388117 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 388120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388122 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388124 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388127 */   GIR_RootConstrainSelectedInstOperands,
     /* 388128 */   // GIR_Coverage, 1928,
     /* 388128 */   GIR_EraseRootFromParent_Done,
     /* 388129 */ // Label 7479: @388129
     /* 388129 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(388177), // Rule ID 1930 //
     /* 388134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388159 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 388163 */   // MIs[1] Operand 1
     /* 388163 */   // No operand predicates
     /* 388163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388165 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 388168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388170 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388172 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388175 */   GIR_RootConstrainSelectedInstOperands,
     /* 388176 */   // GIR_Coverage, 1930,
     /* 388176 */   GIR_EraseRootFromParent_Done,
     /* 388177 */ // Label 7480: @388177
     /* 388177 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(388225), // Rule ID 1931 //
     /* 388182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388199 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388207 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388211 */   // MIs[1] Operand 1
     /* 388211 */   // No operand predicates
     /* 388211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388213 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 388216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388218 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388220 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388223 */   GIR_RootConstrainSelectedInstOperands,
     /* 388224 */   // GIR_Coverage, 1931,
     /* 388224 */   GIR_EraseRootFromParent_Done,
     /* 388225 */ // Label 7481: @388225
     /* 388225 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(388273), // Rule ID 1932 //
     /* 388230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388247 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388251 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388255 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388259 */   // MIs[1] Operand 1
     /* 388259 */   // No operand predicates
     /* 388259 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388261 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 388264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388266 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388268 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388271 */   GIR_RootConstrainSelectedInstOperands,
     /* 388272 */   // GIR_Coverage, 1932,
     /* 388272 */   GIR_EraseRootFromParent_Done,
     /* 388273 */ // Label 7482: @388273
     /* 388273 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(388318), // Rule ID 5824 //
     /* 388278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388300 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388304 */   // MIs[1] Operand 1
     /* 388304 */   // No operand predicates
     /* 388304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388306 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 388309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388313 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388316 */   GIR_RootConstrainSelectedInstOperands,
     /* 388317 */   // GIR_Coverage, 5824,
     /* 388317 */   GIR_EraseRootFromParent_Done,
     /* 388318 */ // Label 7483: @388318
     /* 388318 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(388394), // Rule ID 11271 //
     /* 388323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388344 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 388348 */   // MIs[1] Operand 1
     /* 388348 */   // No operand predicates
     /* 388348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388350 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 388350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 388357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388362 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388366 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388376 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388393 */   // GIR_Coverage, 11271,
     /* 388393 */   GIR_EraseRootFromParent_Done,
     /* 388394 */ // Label 7484: @388394
     /* 388394 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(388470), // Rule ID 11272 //
     /* 388399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388420 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 388424 */   // MIs[1] Operand 1
     /* 388424 */   // No operand predicates
     /* 388424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388426 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 388426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388438 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388442 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388452 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388469 */   // GIR_Coverage, 11272,
     /* 388469 */   GIR_EraseRootFromParent_Done,
     /* 388470 */ // Label 7485: @388470
     /* 388470 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(388546), // Rule ID 11273 //
     /* 388475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388496 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388500 */   // MIs[1] Operand 1
     /* 388500 */   // No operand predicates
     /* 388500 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388502 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 388502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388514 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388518 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388528 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388540 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388545 */   // GIR_Coverage, 11273,
     /* 388545 */   GIR_EraseRootFromParent_Done,
     /* 388546 */ // Label 7486: @388546
     /* 388546 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(388622), // Rule ID 11278 //
     /* 388551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388572 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388576 */   // MIs[1] Operand 1
     /* 388576 */   // No operand predicates
     /* 388576 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388578 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 388578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388590 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388594 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388604 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388621 */   // GIR_Coverage, 11278,
     /* 388621 */   GIR_EraseRootFromParent_Done,
     /* 388622 */ // Label 7487: @388622
     /* 388622 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(388698), // Rule ID 11279 //
     /* 388627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388640 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388644 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388648 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388652 */   // MIs[1] Operand 1
     /* 388652 */   // No operand predicates
     /* 388652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388654 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 388654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388666 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388670 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388680 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388697 */   // GIR_Coverage, 11279,
     /* 388697 */   GIR_EraseRootFromParent_Done,
     /* 388698 */ // Label 7488: @388698
     /* 388698 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(388759), // Rule ID 11261 //
     /* 388703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388720 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 388720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 388727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388732 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388738 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388742 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 388750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388755 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388757 */   GIR_RootConstrainSelectedInstOperands,
     /* 388758 */   // GIR_Coverage, 11261,
     /* 388758 */   GIR_EraseRootFromParent_Done,
     /* 388759 */ // Label 7489: @388759
     /* 388759 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(388820), // Rule ID 11262 //
     /* 388764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388781 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 388781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 388788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388793 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388803 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 388811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388816 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388818 */   GIR_RootConstrainSelectedInstOperands,
     /* 388819 */   // GIR_Coverage, 11262,
     /* 388819 */   GIR_EraseRootFromParent_Done,
     /* 388820 */ // Label 7490: @388820
     /* 388820 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(388881), // Rule ID 11263 //
     /* 388825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388842 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 388842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388854 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388860 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388864 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 388872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388877 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388879 */   GIR_RootConstrainSelectedInstOperands,
     /* 388880 */   // GIR_Coverage, 11263,
     /* 388880 */   GIR_EraseRootFromParent_Done,
     /* 388881 */ // Label 7491: @388881
     /* 388881 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(388942), // Rule ID 11268 //
     /* 388886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388903 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 388903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388915 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388921 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388925 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 388933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388938 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388940 */   GIR_RootConstrainSelectedInstOperands,
     /* 388941 */   // GIR_Coverage, 11268,
     /* 388941 */   GIR_EraseRootFromParent_Done,
     /* 388942 */ // Label 7492: @388942
     /* 388942 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(389003), // Rule ID 11269 //
     /* 388947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388964 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 388964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388976 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388982 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388986 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 388994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388999 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389001 */   GIR_RootConstrainSelectedInstOperands,
     /* 389002 */   // GIR_Coverage, 11269,
     /* 389002 */   GIR_EraseRootFromParent_Done,
     /* 389003 */ // Label 7493: @389003
     /* 389003 */ GIM_Reject,
     /* 389004 */ // Label 7453: @389004
     /* 389004 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(389049), // Rule ID 7008 //
     /* 389009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389023 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389027 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 389027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389032 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 389038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389048 */   // GIR_Coverage, 7008,
     /* 389048 */   GIR_EraseRootFromParent_Done,
     /* 389049 */ // Label 7494: @389049
     /* 389049 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(389093), // Rule ID 11299 //
     /* 389054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389067 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389071 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 389071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389076 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 389082 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389087 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389092 */   // GIR_Coverage, 11299,
     /* 389092 */   GIR_EraseRootFromParent_Done,
     /* 389093 */ // Label 7495: @389093
     /* 389093 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(389137), // Rule ID 11305 //
     /* 389098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389111 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389115 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 389115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389120 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 389126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389136 */   // GIR_Coverage, 11305,
     /* 389136 */   GIR_EraseRootFromParent_Done,
     /* 389137 */ // Label 7496: @389137
     /* 389137 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(389182), // Rule ID 5820 //
     /* 389142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389156 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389160 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 389160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389165 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 389171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389181 */   // GIR_Coverage, 5820,
     /* 389181 */   GIR_EraseRootFromParent_Done,
     /* 389182 */ // Label 7497: @389182
     /* 389182 */ GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(389255), // Rule ID 11284 //
     /* 389187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389208 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389212 */   // MIs[1] Operand 1
     /* 389212 */   // No operand predicates
     /* 389212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389214 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 389214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 389217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389226 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 389232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 389245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389250 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 389253 */   GIR_RootConstrainSelectedInstOperands,
     /* 389254 */   // GIR_Coverage, 11284,
     /* 389254 */   GIR_EraseRootFromParent_Done,
     /* 389255 */ // Label 7498: @389255
     /* 389255 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(389303), // Rule ID 1929 //
     /* 389260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389277 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389281 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389285 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389289 */   // MIs[1] Operand 1
     /* 389289 */   // No operand predicates
     /* 389289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389291 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 389294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389296 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389298 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389301 */   GIR_RootConstrainSelectedInstOperands,
     /* 389302 */   // GIR_Coverage, 1929,
     /* 389302 */   GIR_EraseRootFromParent_Done,
     /* 389303 */ // Label 7499: @389303
     /* 389303 */ GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(389351), // Rule ID 1933 //
     /* 389308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389325 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389329 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389333 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389337 */   // MIs[1] Operand 1
     /* 389337 */   // No operand predicates
     /* 389337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389339 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 389342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389344 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389346 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389349 */   GIR_RootConstrainSelectedInstOperands,
     /* 389350 */   // GIR_Coverage, 1933,
     /* 389350 */   GIR_EraseRootFromParent_Done,
     /* 389351 */ // Label 7500: @389351
     /* 389351 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(389396), // Rule ID 5823 //
     /* 389356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389378 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389382 */   // MIs[1] Operand 1
     /* 389382 */   // No operand predicates
     /* 389382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389384 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 389384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 389387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389389 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389391 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389394 */   GIR_RootConstrainSelectedInstOperands,
     /* 389395 */   // GIR_Coverage, 5823,
     /* 389395 */   GIR_EraseRootFromParent_Done,
     /* 389396 */ // Label 7501: @389396
     /* 389396 */ GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(389472), // Rule ID 11274 //
     /* 389401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389422 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389426 */   // MIs[1] Operand 1
     /* 389426 */   // No operand predicates
     /* 389426 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389428 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 389428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389440 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389444 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389454 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 389461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389471 */   // GIR_Coverage, 11274,
     /* 389471 */   GIR_EraseRootFromParent_Done,
     /* 389472 */ // Label 7502: @389472
     /* 389472 */ GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(389548), // Rule ID 11280 //
     /* 389477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389498 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389502 */   // MIs[1] Operand 1
     /* 389502 */   // No operand predicates
     /* 389502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389504 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 389504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389516 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389520 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389530 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 389537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389542 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389547 */   // GIR_Coverage, 11280,
     /* 389547 */   GIR_EraseRootFromParent_Done,
     /* 389548 */ // Label 7503: @389548
     /* 389548 */ GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(389609), // Rule ID 11264 //
     /* 389553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389570 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 389570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 389577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389582 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389588 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389592 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 389600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389605 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389607 */   GIR_RootConstrainSelectedInstOperands,
     /* 389608 */   // GIR_Coverage, 11264,
     /* 389608 */   GIR_EraseRootFromParent_Done,
     /* 389609 */ // Label 7504: @389609
     /* 389609 */ GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(389670), // Rule ID 11270 //
     /* 389614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389631 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 389631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 389638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389643 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389649 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389653 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 389661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 389663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389666 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389668 */   GIR_RootConstrainSelectedInstOperands,
     /* 389669 */   // GIR_Coverage, 11270,
     /* 389669 */   GIR_EraseRootFromParent_Done,
     /* 389670 */ // Label 7505: @389670
     /* 389670 */ GIM_Reject,
     /* 389671 */ // Label 7454: @389671
     /* 389671 */ GIM_Reject,
     /* 389672 */ // Label 92: @389672
     /* 389672 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7513*/ GIMT_Encode4(391991),
     /* 389683 */ /*GILLT_nxv2s16*//*Label 7506*/ GIMT_Encode4(389723),
     /* 389687 */ /*GILLT_nxv2s32*//*Label 7507*/ GIMT_Encode4(390082),
     /* 389691 */ /*GILLT_nxv2s64*//*Label 7508*/ GIMT_Encode4(390384), GIMT_Encode4(0),
     /* 389699 */ /*GILLT_nxv4s16*//*Label 7509*/ GIMT_Encode4(390759),
     /* 389703 */ /*GILLT_nxv4s32*//*Label 7510*/ GIMT_Encode4(391061), GIMT_Encode4(0),
     /* 389711 */ /*GILLT_nxv8s16*//*Label 7511*/ GIMT_Encode4(391436), GIMT_Encode4(0),
     /* 389719 */ /*GILLT_nxv16s8*//*Label 7512*/ GIMT_Encode4(391847),
     /* 389723 */ // Label 7506: @389723
     /* 389723 */ GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(390081),
     /* 389728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389735 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389799), // Rule ID 6054 //
     /* 389740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389751 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389755 */     // MIs[1] Operand 1
     /* 389755 */     // No operand predicates
     /* 389755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389757 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389798 */     // GIR_Coverage, 6054,
     /* 389798 */     GIR_EraseRootFromParent_Done,
     /* 389799 */   // Label 7515: @389799
     /* 389799 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389856), // Rule ID 2671 //
     /* 389804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 389819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389840 */     // MIs[2] Operand 1
     /* 389840 */     // No operand predicates
     /* 389840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389842 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389854 */     GIR_RootConstrainSelectedInstOperands,
     /* 389855 */     // GIR_Coverage, 2671,
     /* 389855 */     GIR_EraseRootFromParent_Done,
     /* 389856 */   // Label 7516: @389856
     /* 389856 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(389913), // Rule ID 2673 //
     /* 389861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 389876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389893 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389897 */     // MIs[2] Operand 1
     /* 389897 */     // No operand predicates
     /* 389897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389899 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389911 */     GIR_RootConstrainSelectedInstOperands,
     /* 389912 */     // GIR_Coverage, 2673,
     /* 389912 */     GIR_EraseRootFromParent_Done,
     /* 389913 */   // Label 7517: @389913
     /* 389913 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(389970), // Rule ID 8404 //
     /* 389918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389954 */     // MIs[2] Operand 1
     /* 389954 */     // No operand predicates
     /* 389954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389956 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389968 */     GIR_RootConstrainSelectedInstOperands,
     /* 389969 */     // GIR_Coverage, 8404,
     /* 389969 */     GIR_EraseRootFromParent_Done,
     /* 389970 */   // Label 7518: @389970
     /* 389970 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(390004), // Rule ID 8447 //
     /* 389975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389986 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 389990 */     // MIs[1] Operand 1
     /* 389990 */     // No operand predicates
     /* 389990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389992 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 389992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 389995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389997 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390002 */     GIR_RootConstrainSelectedInstOperands,
     /* 390003 */     // GIR_Coverage, 8447,
     /* 390003 */     GIR_EraseRootFromParent_Done,
     /* 390004 */   // Label 7519: @390004
     /* 390004 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(390080), // Rule ID 8425 //
     /* 390009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390016 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390042 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390049 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390078 */     GIR_RootConstrainSelectedInstOperands,
     /* 390079 */     // GIR_Coverage, 8425,
     /* 390079 */     GIR_EraseRootFromParent_Done,
     /* 390080 */   // Label 7520: @390080
     /* 390080 */   GIM_Reject,
     /* 390081 */ // Label 7514: @390081
     /* 390081 */ GIM_Reject,
     /* 390082 */ // Label 7507: @390082
     /* 390082 */ GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(390383),
     /* 390087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390094 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(390158), // Rule ID 6052 //
     /* 390099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390110 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390114 */     // MIs[1] Operand 1
     /* 390114 */     // No operand predicates
     /* 390114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390116 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390128 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390157 */     // GIR_Coverage, 6052,
     /* 390157 */     GIR_EraseRootFromParent_Done,
     /* 390158 */   // Label 7522: @390158
     /* 390158 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(390215), // Rule ID 8413 //
     /* 390163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390199 */     // MIs[2] Operand 1
     /* 390199 */     // No operand predicates
     /* 390199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390201 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390213 */     GIR_RootConstrainSelectedInstOperands,
     /* 390214 */     // GIR_Coverage, 8413,
     /* 390214 */     GIR_EraseRootFromParent_Done,
     /* 390215 */   // Label 7523: @390215
     /* 390215 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(390272), // Rule ID 8422 //
     /* 390220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 390235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390252 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390256 */     // MIs[2] Operand 1
     /* 390256 */     // No operand predicates
     /* 390256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390258 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 390258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390270 */     GIR_RootConstrainSelectedInstOperands,
     /* 390271 */     // GIR_Coverage, 8422,
     /* 390271 */     GIR_EraseRootFromParent_Done,
     /* 390272 */   // Label 7524: @390272
     /* 390272 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(390306), // Rule ID 8449 //
     /* 390277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390288 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 390292 */     // MIs[1] Operand 1
     /* 390292 */     // No operand predicates
     /* 390292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390294 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 390294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 390297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390299 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 390304 */     GIR_RootConstrainSelectedInstOperands,
     /* 390305 */     // GIR_Coverage, 8449,
     /* 390305 */     GIR_EraseRootFromParent_Done,
     /* 390306 */   // Label 7525: @390306
     /* 390306 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(390382), // Rule ID 8427 //
     /* 390311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390318 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390380 */     GIR_RootConstrainSelectedInstOperands,
     /* 390381 */     // GIR_Coverage, 8427,
     /* 390381 */     GIR_EraseRootFromParent_Done,
     /* 390382 */   // Label 7526: @390382
     /* 390382 */   GIM_Reject,
     /* 390383 */ // Label 7521: @390383
     /* 390383 */ GIM_Reject,
     /* 390384 */ // Label 7508: @390384
     /* 390384 */ GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(390758),
     /* 390389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390396 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(390450), // Rule ID 6047 //
     /* 390401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390408 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390420 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390449 */     // GIR_Coverage, 6047,
     /* 390449 */     GIR_EraseRootFromParent_Done,
     /* 390450 */   // Label 7528: @390450
     /* 390450 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(390514), // Rule ID 6051 //
     /* 390455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390466 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390470 */     // MIs[1] Operand 1
     /* 390470 */     // No operand predicates
     /* 390470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390472 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390513 */     // GIR_Coverage, 6051,
     /* 390513 */     GIR_EraseRootFromParent_Done,
     /* 390514 */   // Label 7529: @390514
     /* 390514 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(390571), // Rule ID 2668 //
     /* 390519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390551 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390555 */     // MIs[2] Operand 1
     /* 390555 */     // No operand predicates
     /* 390555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390557 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 390557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390569 */     GIR_RootConstrainSelectedInstOperands,
     /* 390570 */     // GIR_Coverage, 2668,
     /* 390570 */     GIR_EraseRootFromParent_Done,
     /* 390571 */   // Label 7530: @390571
     /* 390571 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(390628), // Rule ID 8419 //
     /* 390576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390612 */     // MIs[2] Operand 1
     /* 390612 */     // No operand predicates
     /* 390612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390614 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 390614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390626 */     GIR_RootConstrainSelectedInstOperands,
     /* 390627 */     // GIR_Coverage, 8419,
     /* 390627 */     GIR_EraseRootFromParent_Done,
     /* 390628 */   // Label 7531: @390628
     /* 390628 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(390662), // Rule ID 8450 //
     /* 390633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390644 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 390648 */     // MIs[1] Operand 1
     /* 390648 */     // No operand predicates
     /* 390648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390650 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 390650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 390653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390655 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 390660 */     GIR_RootConstrainSelectedInstOperands,
     /* 390661 */     // GIR_Coverage, 8450,
     /* 390661 */     GIR_EraseRootFromParent_Done,
     /* 390662 */   // Label 7532: @390662
     /* 390662 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390681), // Rule ID 2391 //
     /* 390667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 390674 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 390674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 390679 */     GIR_RootConstrainSelectedInstOperands,
     /* 390680 */     // GIR_Coverage, 2391,
     /* 390680 */     GIR_Done,
     /* 390681 */   // Label 7533: @390681
     /* 390681 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(390757), // Rule ID 8428 //
     /* 390686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390693 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390693 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390696 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390700 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390755 */     GIR_RootConstrainSelectedInstOperands,
     /* 390756 */     // GIR_Coverage, 8428,
     /* 390756 */     GIR_EraseRootFromParent_Done,
     /* 390757 */   // Label 7534: @390757
     /* 390757 */   GIM_Reject,
     /* 390758 */ // Label 7527: @390758
     /* 390758 */ GIM_Reject,
     /* 390759 */ // Label 7509: @390759
     /* 390759 */ GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(391060),
     /* 390764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390771 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(390835), // Rule ID 6055 //
     /* 390776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390787 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390791 */     // MIs[1] Operand 1
     /* 390791 */     // No operand predicates
     /* 390791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390793 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390805 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390834 */     // GIR_Coverage, 6055,
     /* 390834 */     GIR_EraseRootFromParent_Done,
     /* 390835 */   // Label 7536: @390835
     /* 390835 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(390892), // Rule ID 2672 //
     /* 390840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 390855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390876 */     // MIs[2] Operand 1
     /* 390876 */     // No operand predicates
     /* 390876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390878 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390890 */     GIR_RootConstrainSelectedInstOperands,
     /* 390891 */     // GIR_Coverage, 2672,
     /* 390891 */     GIR_EraseRootFromParent_Done,
     /* 390892 */   // Label 7537: @390892
     /* 390892 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(390949), // Rule ID 8407 //
     /* 390897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390933 */     // MIs[2] Operand 1
     /* 390933 */     // No operand predicates
     /* 390933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390935 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390947 */     GIR_RootConstrainSelectedInstOperands,
     /* 390948 */     // GIR_Coverage, 8407,
     /* 390948 */     GIR_EraseRootFromParent_Done,
     /* 390949 */   // Label 7538: @390949
     /* 390949 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(390983), // Rule ID 8446 //
     /* 390954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390965 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 390969 */     // MIs[1] Operand 1
     /* 390969 */     // No operand predicates
     /* 390969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390971 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 390971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 390974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390976 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390981 */     GIR_RootConstrainSelectedInstOperands,
     /* 390982 */     // GIR_Coverage, 8446,
     /* 390982 */     GIR_EraseRootFromParent_Done,
     /* 390983 */   // Label 7539: @390983
     /* 390983 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(391059), // Rule ID 8424 //
     /* 390988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390995 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391021 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391057 */     GIR_RootConstrainSelectedInstOperands,
     /* 391058 */     // GIR_Coverage, 8424,
     /* 391058 */     GIR_EraseRootFromParent_Done,
     /* 391059 */   // Label 7540: @391059
     /* 391059 */   GIM_Reject,
     /* 391060 */ // Label 7535: @391060
     /* 391060 */ GIM_Reject,
     /* 391061 */ // Label 7510: @391061
     /* 391061 */ GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(391435),
     /* 391066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391073 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(391127), // Rule ID 6048 //
     /* 391078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391085 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391126 */     // GIR_Coverage, 6048,
     /* 391126 */     GIR_EraseRootFromParent_Done,
     /* 391127 */   // Label 7542: @391127
     /* 391127 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(391191), // Rule ID 6053 //
     /* 391132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391143 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391147 */     // MIs[1] Operand 1
     /* 391147 */     // No operand predicates
     /* 391147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391149 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391161 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391190 */     // GIR_Coverage, 6053,
     /* 391190 */     GIR_EraseRootFromParent_Done,
     /* 391191 */   // Label 7543: @391191
     /* 391191 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(391248), // Rule ID 2665 //
     /* 391196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 391211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391232 */     // MIs[2] Operand 1
     /* 391232 */     // No operand predicates
     /* 391232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391234 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391246 */     GIR_RootConstrainSelectedInstOperands,
     /* 391247 */     // GIR_Coverage, 2665,
     /* 391247 */     GIR_EraseRootFromParent_Done,
     /* 391248 */   // Label 7544: @391248
     /* 391248 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(391305), // Rule ID 8416 //
     /* 391253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 391268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391289 */     // MIs[2] Operand 1
     /* 391289 */     // No operand predicates
     /* 391289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391291 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391303 */     GIR_RootConstrainSelectedInstOperands,
     /* 391304 */     // GIR_Coverage, 8416,
     /* 391304 */     GIR_EraseRootFromParent_Done,
     /* 391305 */   // Label 7545: @391305
     /* 391305 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(391339), // Rule ID 8448 //
     /* 391310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391321 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 391325 */     // MIs[1] Operand 1
     /* 391325 */     // No operand predicates
     /* 391325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391327 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 391327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 391330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391332 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 391337 */     GIR_RootConstrainSelectedInstOperands,
     /* 391338 */     // GIR_Coverage, 8448,
     /* 391338 */     GIR_EraseRootFromParent_Done,
     /* 391339 */   // Label 7546: @391339
     /* 391339 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(391358), // Rule ID 2390 //
     /* 391344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 391351 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 391351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 391356 */     GIR_RootConstrainSelectedInstOperands,
     /* 391357 */     // GIR_Coverage, 2390,
     /* 391357 */     GIR_Done,
     /* 391358 */   // Label 7547: @391358
     /* 391358 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(391434), // Rule ID 8426 //
     /* 391363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391370 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391432 */     GIR_RootConstrainSelectedInstOperands,
     /* 391433 */     // GIR_Coverage, 8426,
     /* 391433 */     GIR_EraseRootFromParent_Done,
     /* 391434 */   // Label 7548: @391434
     /* 391434 */   GIM_Reject,
     /* 391435 */ // Label 7541: @391435
     /* 391435 */ GIM_Reject,
     /* 391436 */ // Label 7511: @391436
     /* 391436 */ GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(391497), // Rule ID 6049 //
     /* 391441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391451 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391455 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391467 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391496 */   // GIR_Coverage, 6049,
     /* 391496 */   GIR_EraseRootFromParent_Done,
     /* 391497 */ // Label 7549: @391497
     /* 391497 */ GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(391568), // Rule ID 6056 //
     /* 391502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391520 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391524 */   // MIs[1] Operand 1
     /* 391524 */   // No operand predicates
     /* 391524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391526 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391538 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391567 */   // GIR_Coverage, 6056,
     /* 391567 */   GIR_EraseRootFromParent_Done,
     /* 391568 */ // Label 7550: @391568
     /* 391568 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(391632), // Rule ID 2662 //
     /* 391573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 391595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391599 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391604 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391608 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391612 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 391616 */   // MIs[2] Operand 1
     /* 391616 */   // No operand predicates
     /* 391616 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391618 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 391618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391623 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391627 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391630 */   GIR_RootConstrainSelectedInstOperands,
     /* 391631 */   // GIR_Coverage, 2662,
     /* 391631 */   GIR_EraseRootFromParent_Done,
     /* 391632 */ // Label 7551: @391632
     /* 391632 */ GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(391696), // Rule ID 8410 //
     /* 391637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391655 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 391659 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391663 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391668 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391672 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391676 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 391680 */   // MIs[2] Operand 1
     /* 391680 */   // No operand predicates
     /* 391680 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391682 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 391682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391687 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391691 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391694 */   GIR_RootConstrainSelectedInstOperands,
     /* 391695 */   // GIR_Coverage, 8410,
     /* 391695 */   GIR_EraseRootFromParent_Done,
     /* 391696 */ // Label 7552: @391696
     /* 391696 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(391737), // Rule ID 8445 //
     /* 391701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391719 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 391723 */   // MIs[1] Operand 1
     /* 391723 */   // No operand predicates
     /* 391723 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391725 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 391725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 391728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391730 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 391735 */   GIR_RootConstrainSelectedInstOperands,
     /* 391736 */   // GIR_Coverage, 8445,
     /* 391736 */   GIR_EraseRootFromParent_Done,
     /* 391737 */ // Label 7553: @391737
     /* 391737 */ GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(391763), // Rule ID 2389 //
     /* 391742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 391756 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 391756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 391761 */   GIR_RootConstrainSelectedInstOperands,
     /* 391762 */   // GIR_Coverage, 2389,
     /* 391762 */   GIR_Done,
     /* 391763 */ // Label 7554: @391763
     /* 391763 */ GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(391846), // Rule ID 8423 //
     /* 391768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391782 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391782 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391789 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391808 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391815 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391818 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391844 */   GIR_RootConstrainSelectedInstOperands,
     /* 391845 */   // GIR_Coverage, 8423,
     /* 391845 */   GIR_EraseRootFromParent_Done,
     /* 391846 */ // Label 7555: @391846
     /* 391846 */ GIM_Reject,
     /* 391847 */ // Label 7512: @391847
     /* 391847 */ GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(391990),
     /* 391852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391859 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(391913), // Rule ID 6050 //
     /* 391864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391871 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391883 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391912 */     // GIR_Coverage, 6050,
     /* 391912 */     GIR_EraseRootFromParent_Done,
     /* 391913 */   // Label 7557: @391913
     /* 391913 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(391970), // Rule ID 2659 //
     /* 391918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 391933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 391954 */     // MIs[2] Operand 1
     /* 391954 */     // No operand predicates
     /* 391954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391956 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 391956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 391959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391968 */     GIR_RootConstrainSelectedInstOperands,
     /* 391969 */     // GIR_Coverage, 2659,
     /* 391969 */     GIR_EraseRootFromParent_Done,
     /* 391970 */   // Label 7558: @391970
     /* 391970 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(391989), // Rule ID 2388 //
     /* 391975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 391982 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 391982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 391987 */     GIR_RootConstrainSelectedInstOperands,
     /* 391988 */     // GIR_Coverage, 2388,
     /* 391988 */     GIR_Done,
     /* 391989 */   // Label 7559: @391989
     /* 391989 */   GIM_Reject,
     /* 391990 */ // Label 7556: @391990
     /* 391990 */ GIM_Reject,
     /* 391991 */ // Label 7513: @391991
     /* 391991 */ GIM_Reject,
     /* 391992 */ // Label 93: @391992
     /* 391992 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7562*/ GIMT_Encode4(392143),
     /* 392003 */ /*GILLT_s32*//*Label 7560*/ GIMT_Encode4(392011),
     /* 392007 */ /*GILLT_s64*//*Label 7561*/ GIMT_Encode4(392077),
     /* 392011 */ // Label 7560: @392011
     /* 392011 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(392076),
     /* 392016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392027 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(392042), // Rule ID 2321 //
     /* 392032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392035 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 392040 */     GIR_RootConstrainSelectedInstOperands,
     /* 392041 */     // GIR_Coverage, 2321,
     /* 392041 */     GIR_Done,
     /* 392042 */   // Label 7564: @392042
     /* 392042 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(392075), // Rule ID 4009 //
     /* 392047 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 392047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 392050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 392054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 392068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392073 */     GIR_RootConstrainSelectedInstOperands,
     /* 392074 */     // GIR_Coverage, 4009,
     /* 392074 */     GIR_EraseRootFromParent_Done,
     /* 392075 */   // Label 7565: @392075
     /* 392075 */   GIM_Reject,
     /* 392076 */ // Label 7563: @392076
     /* 392076 */ GIM_Reject,
     /* 392077 */ // Label 7561: @392077
     /* 392077 */ GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(392142),
     /* 392082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392093 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(392108), // Rule ID 2322 //
     /* 392098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392101 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 392106 */     GIR_RootConstrainSelectedInstOperands,
     /* 392107 */     // GIR_Coverage, 2322,
     /* 392107 */     GIR_Done,
     /* 392108 */   // Label 7567: @392108
     /* 392108 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(392141), // Rule ID 4010 //
     /* 392113 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 392113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 392120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 392134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392139 */     GIR_RootConstrainSelectedInstOperands,
     /* 392140 */     // GIR_Coverage, 4010,
     /* 392140 */     GIR_EraseRootFromParent_Done,
     /* 392141 */   // Label 7568: @392141
     /* 392141 */   GIM_Reject,
     /* 392142 */ // Label 7566: @392142
     /* 392142 */ GIM_Reject,
     /* 392143 */ // Label 7562: @392143
     /* 392143 */ GIM_Reject,
     /* 392144 */ // Label 94: @392144
     /* 392144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7577*/ GIMT_Encode4(392817),
     /* 392155 */ /*GILLT_s32*//*Label 7569*/ GIMT_Encode4(392195),
     /* 392159 */ /*GILLT_s64*//*Label 7570*/ GIMT_Encode4(392425), GIMT_Encode4(0),
     /* 392167 */ /*GILLT_v2s32*//*Label 7571*/ GIMT_Encode4(392655), GIMT_Encode4(0),
     /* 392175 */ /*GILLT_v4s16*//*Label 7572*/ GIMT_Encode4(392682),
     /* 392179 */ /*GILLT_v4s32*//*Label 7573*/ GIMT_Encode4(392709),
     /* 392183 */ /*GILLT_v8s8*//*Label 7574*/ GIMT_Encode4(392736),
     /* 392187 */ /*GILLT_v8s16*//*Label 7575*/ GIMT_Encode4(392763),
     /* 392191 */ /*GILLT_v16s8*//*Label 7576*/ GIMT_Encode4(392790),
     /* 392195 */ // Label 7569: @392195
     /* 392195 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(392424),
     /* 392200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392207 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(392307), // Rule ID 4011 //
     /* 392212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 392228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 392240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 392256 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 392260 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392264 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 392268 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392272 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392277 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 392281 */     // MIs[3] Rn
     /* 392281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 392286 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392294 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392296 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 392299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 392305 */     GIR_RootConstrainSelectedInstOperands,
     /* 392306 */     // GIR_Coverage, 4011,
     /* 392306 */     GIR_EraseRootFromParent_Done,
     /* 392307 */   // Label 7579: @392307
     /* 392307 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(392407), // Rule ID 13895 //
     /* 392312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 392328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 392340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392352 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 392356 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 392360 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 392369 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392373 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392377 */     // MIs[4] Rn
     /* 392377 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 392382 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 392386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392390 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392396 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 392399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 392405 */     GIR_RootConstrainSelectedInstOperands,
     /* 392406 */     // GIR_Coverage, 13895,
     /* 392406 */     GIR_EraseRootFromParent_Done,
     /* 392407 */   // Label 7580: @392407
     /* 392407 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(392423), // Rule ID 180 //
     /* 392412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392416 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 392421 */     GIR_RootConstrainSelectedInstOperands,
     /* 392422 */     // GIR_Coverage, 180,
     /* 392422 */     GIR_Done,
     /* 392423 */   // Label 7581: @392423
     /* 392423 */   GIM_Reject,
     /* 392424 */ // Label 7578: @392424
     /* 392424 */ GIM_Reject,
     /* 392425 */ // Label 7570: @392425
     /* 392425 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(392654),
     /* 392430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392437 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(392537), // Rule ID 4012 //
     /* 392442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392482 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 392486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 392490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392494 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 392498 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392502 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392507 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 392511 */     // MIs[3] Rn
     /* 392511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 392516 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392526 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 392529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 392535 */     GIR_RootConstrainSelectedInstOperands,
     /* 392536 */     // GIR_Coverage, 4012,
     /* 392536 */     GIR_EraseRootFromParent_Done,
     /* 392537 */   // Label 7583: @392537
     /* 392537 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(392637), // Rule ID 13896 //
     /* 392542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 392586 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 392590 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 392599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392603 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392607 */     // MIs[4] Rn
     /* 392607 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 392612 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 392616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392624 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392626 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 392629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 392635 */     GIR_RootConstrainSelectedInstOperands,
     /* 392636 */     // GIR_Coverage, 13896,
     /* 392636 */     GIR_EraseRootFromParent_Done,
     /* 392637 */   // Label 7584: @392637
     /* 392637 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(392653), // Rule ID 181 //
     /* 392642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392646 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 392651 */     GIR_RootConstrainSelectedInstOperands,
     /* 392652 */     // GIR_Coverage, 181,
     /* 392652 */     GIR_Done,
     /* 392653 */   // Label 7585: @392653
     /* 392653 */   GIM_Reject,
     /* 392654 */ // Label 7582: @392654
     /* 392654 */ GIM_Reject,
     /* 392655 */ // Label 7571: @392655
     /* 392655 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(392681), // Rule ID 720 //
     /* 392660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392674 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 392674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 392679 */   GIR_RootConstrainSelectedInstOperands,
     /* 392680 */   // GIR_Coverage, 720,
     /* 392680 */   GIR_Done,
     /* 392681 */ // Label 7586: @392681
     /* 392681 */ GIM_Reject,
     /* 392682 */ // Label 7572: @392682
     /* 392682 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(392708), // Rule ID 718 //
     /* 392687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392701 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 392701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 392706 */   GIR_RootConstrainSelectedInstOperands,
     /* 392707 */   // GIR_Coverage, 718,
     /* 392707 */   GIR_Done,
     /* 392708 */ // Label 7587: @392708
     /* 392708 */ GIM_Reject,
     /* 392709 */ // Label 7573: @392709
     /* 392709 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(392735), // Rule ID 721 //
     /* 392714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392728 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 392728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 392733 */   GIR_RootConstrainSelectedInstOperands,
     /* 392734 */   // GIR_Coverage, 721,
     /* 392734 */   GIR_Done,
     /* 392735 */ // Label 7588: @392735
     /* 392735 */ GIM_Reject,
     /* 392736 */ // Label 7574: @392736
     /* 392736 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(392762), // Rule ID 716 //
     /* 392741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392755 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 392760 */   GIR_RootConstrainSelectedInstOperands,
     /* 392761 */   // GIR_Coverage, 716,
     /* 392761 */   GIR_Done,
     /* 392762 */ // Label 7589: @392762
     /* 392762 */ GIM_Reject,
     /* 392763 */ // Label 7575: @392763
     /* 392763 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(392789), // Rule ID 719 //
     /* 392768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392782 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 392782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 392787 */   GIR_RootConstrainSelectedInstOperands,
     /* 392788 */   // GIR_Coverage, 719,
     /* 392788 */   GIR_Done,
     /* 392789 */ // Label 7590: @392789
     /* 392789 */ GIM_Reject,
     /* 392790 */ // Label 7576: @392790
     /* 392790 */ GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(392816), // Rule ID 717 //
     /* 392795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392809 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 392814 */   GIR_RootConstrainSelectedInstOperands,
     /* 392815 */   // GIR_Coverage, 717,
     /* 392815 */   GIR_Done,
     /* 392816 */ // Label 7591: @392816
     /* 392816 */ GIM_Reject,
     /* 392817 */ // Label 7577: @392817
     /* 392817 */ GIM_Reject,
     /* 392818 */ // Label 95: @392818
     /* 392818 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7596*/ GIMT_Encode4(392977),
     /* 392829 */ /*GILLT_s32*//*Label 7592*/ GIMT_Encode4(392869),
     /* 392833 */ /*GILLT_s64*//*Label 7593*/ GIMT_Encode4(392896), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392857 */ /*GILLT_v8s8*//*Label 7594*/ GIMT_Encode4(392923), GIMT_Encode4(0),
     /* 392865 */ /*GILLT_v16s8*//*Label 7595*/ GIMT_Encode4(392950),
     /* 392869 */ // Label 7592: @392869
     /* 392869 */ GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(392895), // Rule ID 2319 //
     /* 392874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392888 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 392893 */   GIR_RootConstrainSelectedInstOperands,
     /* 392894 */   // GIR_Coverage, 2319,
     /* 392894 */   GIR_Done,
     /* 392895 */ // Label 7597: @392895
     /* 392895 */ GIM_Reject,
     /* 392896 */ // Label 7593: @392896
     /* 392896 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(392922), // Rule ID 2320 //
     /* 392901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392915 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 392920 */   GIR_RootConstrainSelectedInstOperands,
     /* 392921 */   // GIR_Coverage, 2320,
     /* 392921 */   GIR_Done,
     /* 392922 */ // Label 7598: @392922
     /* 392922 */ GIM_Reject,
     /* 392923 */ // Label 7594: @392923
     /* 392923 */ GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(392949), // Rule ID 764 //
     /* 392928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392942 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 392947 */   GIR_RootConstrainSelectedInstOperands,
     /* 392948 */   // GIR_Coverage, 764,
     /* 392948 */   GIR_Done,
     /* 392949 */ // Label 7599: @392949
     /* 392949 */ GIM_Reject,
     /* 392950 */ // Label 7595: @392950
     /* 392950 */ GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(392976), // Rule ID 765 //
     /* 392955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392969 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 392974 */   GIR_RootConstrainSelectedInstOperands,
     /* 392975 */   // GIR_Coverage, 765,
     /* 392975 */   GIR_Done,
     /* 392976 */ // Label 7600: @392976
     /* 392976 */ GIM_Reject,
     /* 392977 */ // Label 7596: @392977
     /* 392977 */ GIM_Reject,
     /* 392978 */ // Label 96: @392978
     /* 392978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7608*/ GIMT_Encode4(393291),
     /* 392989 */ /*GILLT_s32*//*Label 7601*/ GIMT_Encode4(393025),
     /* 392993 */ /*GILLT_s64*//*Label 7602*/ GIMT_Encode4(393098), GIMT_Encode4(0),
     /* 393001 */ /*GILLT_v2s32*//*Label 7603*/ GIMT_Encode4(393171),
     /* 393005 */ /*GILLT_v2s64*//*Label 7604*/ GIMT_Encode4(393195),
     /* 393009 */ /*GILLT_v4s16*//*Label 7605*/ GIMT_Encode4(393219),
     /* 393013 */ /*GILLT_v4s32*//*Label 7606*/ GIMT_Encode4(393243), GIMT_Encode4(0),
     /* 393021 */ /*GILLT_v8s16*//*Label 7607*/ GIMT_Encode4(393267),
     /* 393025 */ // Label 7601: @393025
     /* 393025 */ GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(393097),
     /* 393030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393037 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(393080), // Rule ID 4015 //
     /* 393042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 393050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393063 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 393067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393069 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 393072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393078 */     GIR_RootConstrainSelectedInstOperands,
     /* 393079 */     // GIR_Coverage, 4015,
     /* 393079 */     GIR_EraseRootFromParent_Done,
     /* 393080 */   // Label 7610: @393080
     /* 393080 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(393096), // Rule ID 185 //
     /* 393085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393089 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 393094 */     GIR_RootConstrainSelectedInstOperands,
     /* 393095 */     // GIR_Coverage, 185,
     /* 393095 */     GIR_Done,
     /* 393096 */   // Label 7611: @393096
     /* 393096 */   GIM_Reject,
     /* 393097 */ // Label 7609: @393097
     /* 393097 */ GIM_Reject,
     /* 393098 */ // Label 7602: @393098
     /* 393098 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(393170),
     /* 393103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393110 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(393153), // Rule ID 4016 //
     /* 393115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 393123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 393127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393136 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 393140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393142 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 393145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393151 */     GIR_RootConstrainSelectedInstOperands,
     /* 393152 */     // GIR_Coverage, 4016,
     /* 393152 */     GIR_EraseRootFromParent_Done,
     /* 393153 */   // Label 7613: @393153
     /* 393153 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(393169), // Rule ID 186 //
     /* 393158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393162 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 393167 */     GIR_RootConstrainSelectedInstOperands,
     /* 393168 */     // GIR_Coverage, 186,
     /* 393168 */     GIR_Done,
     /* 393169 */   // Label 7614: @393169
     /* 393169 */   GIM_Reject,
     /* 393170 */ // Label 7612: @393170
     /* 393170 */ GIM_Reject,
     /* 393171 */ // Label 7603: @393171
     /* 393171 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(393194), // Rule ID 5028 //
     /* 393176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393187 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 393187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 393192 */   GIR_RootConstrainSelectedInstOperands,
     /* 393193 */   // GIR_Coverage, 5028,
     /* 393193 */   GIR_Done,
     /* 393194 */ // Label 7615: @393194
     /* 393194 */ GIM_Reject,
     /* 393195 */ // Label 7604: @393195
     /* 393195 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(393218), // Rule ID 5030 //
     /* 393200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393211 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 393211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 393216 */   GIR_RootConstrainSelectedInstOperands,
     /* 393217 */   // GIR_Coverage, 5030,
     /* 393217 */   GIR_Done,
     /* 393218 */ // Label 7616: @393218
     /* 393218 */ GIM_Reject,
     /* 393219 */ // Label 7605: @393219
     /* 393219 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(393242), // Rule ID 5026 //
     /* 393224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393235 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 393235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 393240 */   GIR_RootConstrainSelectedInstOperands,
     /* 393241 */   // GIR_Coverage, 5026,
     /* 393241 */   GIR_Done,
     /* 393242 */ // Label 7617: @393242
     /* 393242 */ GIM_Reject,
     /* 393243 */ // Label 7606: @393243
     /* 393243 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(393266), // Rule ID 5029 //
     /* 393248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393259 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 393259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 393264 */   GIR_RootConstrainSelectedInstOperands,
     /* 393265 */   // GIR_Coverage, 5029,
     /* 393265 */   GIR_Done,
     /* 393266 */ // Label 7618: @393266
     /* 393266 */ GIM_Reject,
     /* 393267 */ // Label 7607: @393267
     /* 393267 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(393290), // Rule ID 5027 //
     /* 393272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393283 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 393283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 393288 */   GIR_RootConstrainSelectedInstOperands,
     /* 393289 */   // GIR_Coverage, 5027,
     /* 393289 */   GIR_Done,
     /* 393290 */ // Label 7619: @393290
     /* 393290 */ GIM_Reject,
     /* 393291 */ // Label 7608: @393291
     /* 393291 */ GIM_Reject,
     /* 393292 */ // Label 97: @393292
     /* 393292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7624*/ GIMT_Encode4(393445),
     /* 393303 */ /*GILLT_s32*//*Label 7620*/ GIMT_Encode4(393343),
     /* 393307 */ /*GILLT_s64*//*Label 7621*/ GIMT_Encode4(393367), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 393331 */ /*GILLT_v8s8*//*Label 7622*/ GIMT_Encode4(393391), GIMT_Encode4(0),
     /* 393339 */ /*GILLT_v16s8*//*Label 7623*/ GIMT_Encode4(393418),
     /* 393343 */ // Label 7620: @393343
     /* 393343 */ GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(393366), // Rule ID 182 //
     /* 393348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393359 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 393364 */   GIR_RootConstrainSelectedInstOperands,
     /* 393365 */   // GIR_Coverage, 182,
     /* 393365 */   GIR_Done,
     /* 393366 */ // Label 7625: @393366
     /* 393366 */ GIM_Reject,
     /* 393367 */ // Label 7621: @393367
     /* 393367 */ GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(393390), // Rule ID 183 //
     /* 393372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393383 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 393388 */   GIR_RootConstrainSelectedInstOperands,
     /* 393389 */   // GIR_Coverage, 183,
     /* 393389 */   GIR_Done,
     /* 393390 */ // Label 7626: @393390
     /* 393390 */ GIM_Reject,
     /* 393391 */ // Label 7622: @393391
     /* 393391 */ GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(393417), // Rule ID 974 //
     /* 393396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393410 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 393410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 393415 */   GIR_RootConstrainSelectedInstOperands,
     /* 393416 */   // GIR_Coverage, 974,
     /* 393416 */   GIR_Done,
     /* 393417 */ // Label 7627: @393417
     /* 393417 */ GIM_Reject,
     /* 393418 */ // Label 7623: @393418
     /* 393418 */ GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(393444), // Rule ID 975 //
     /* 393423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393437 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 393437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 393442 */   GIR_RootConstrainSelectedInstOperands,
     /* 393443 */   // GIR_Coverage, 975,
     /* 393443 */   GIR_Done,
     /* 393444 */ // Label 7628: @393444
     /* 393444 */ GIM_Reject,
     /* 393445 */ // Label 7624: @393445
     /* 393445 */ GIM_Reject,
     /* 393446 */ // Label 98: @393446
     /* 393446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7637*/ GIMT_Encode4(393936),
     /* 393457 */ /*GILLT_s16*//*Label 7629*/ GIMT_Encode4(393497),
     /* 393461 */ /*GILLT_s32*//*Label 7630*/ GIMT_Encode4(393528),
     /* 393465 */ /*GILLT_s64*//*Label 7631*/ GIMT_Encode4(393559), GIMT_Encode4(0),
     /* 393473 */ /*GILLT_v2s32*//*Label 7632*/ GIMT_Encode4(393590),
     /* 393477 */ /*GILLT_v2s64*//*Label 7633*/ GIMT_Encode4(393621),
     /* 393481 */ /*GILLT_v4s16*//*Label 7634*/ GIMT_Encode4(393652),
     /* 393485 */ /*GILLT_v4s32*//*Label 7635*/ GIMT_Encode4(393683), GIMT_Encode4(0),
     /* 393493 */ /*GILLT_v8s16*//*Label 7636*/ GIMT_Encode4(393714),
     /* 393497 */ // Label 7629: @393497
     /* 393497 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(393527), // Rule ID 552 //
     /* 393502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393516 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 393521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393525 */   GIR_RootConstrainSelectedInstOperands,
     /* 393526 */   // GIR_Coverage, 552,
     /* 393526 */   GIR_Done,
     /* 393527 */ // Label 7638: @393527
     /* 393527 */ GIM_Reject,
     /* 393528 */ // Label 7630: @393528
     /* 393528 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(393558), // Rule ID 554 //
     /* 393533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393547 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 393552 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393556 */   GIR_RootConstrainSelectedInstOperands,
     /* 393557 */   // GIR_Coverage, 554,
     /* 393557 */   GIR_Done,
     /* 393558 */ // Label 7639: @393558
     /* 393558 */ GIM_Reject,
     /* 393559 */ // Label 7631: @393559
     /* 393559 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(393589), // Rule ID 556 //
     /* 393564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393578 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 393583 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393587 */   GIR_RootConstrainSelectedInstOperands,
     /* 393588 */   // GIR_Coverage, 556,
     /* 393588 */   GIR_Done,
     /* 393589 */ // Label 7640: @393589
     /* 393589 */ GIM_Reject,
     /* 393590 */ // Label 7632: @393590
     /* 393590 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(393620), // Rule ID 913 //
     /* 393595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393609 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 393614 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393618 */   GIR_RootConstrainSelectedInstOperands,
     /* 393619 */   // GIR_Coverage, 913,
     /* 393619 */   GIR_Done,
     /* 393620 */ // Label 7641: @393620
     /* 393620 */ GIM_Reject,
     /* 393621 */ // Label 7633: @393621
     /* 393621 */ GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(393651), // Rule ID 917 //
     /* 393626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393640 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 393645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393649 */   GIR_RootConstrainSelectedInstOperands,
     /* 393650 */   // GIR_Coverage, 917,
     /* 393650 */   GIR_Done,
     /* 393651 */ // Label 7642: @393651
     /* 393651 */ GIM_Reject,
     /* 393652 */ // Label 7634: @393652
     /* 393652 */ GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(393682), // Rule ID 909 //
     /* 393657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393671 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 393676 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393680 */   GIR_RootConstrainSelectedInstOperands,
     /* 393681 */   // GIR_Coverage, 909,
     /* 393681 */   GIR_Done,
     /* 393682 */ // Label 7643: @393682
     /* 393682 */ GIM_Reject,
     /* 393683 */ // Label 7635: @393683
     /* 393683 */ GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(393713), // Rule ID 915 //
     /* 393688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393702 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 393707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393711 */   GIR_RootConstrainSelectedInstOperands,
     /* 393712 */   // GIR_Coverage, 915,
     /* 393712 */   GIR_Done,
     /* 393713 */ // Label 7644: @393713
     /* 393713 */ GIM_Reject,
     /* 393714 */ // Label 7636: @393714
     /* 393714 */ GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(393935),
     /* 393719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393730 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(393749), // Rule ID 911 //
     /* 393735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393738 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 393743 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393747 */     GIR_RootConstrainSelectedInstOperands,
     /* 393748 */     // GIR_Coverage, 911,
     /* 393748 */     GIR_Done,
     /* 393749 */   // Label 7646: @393749
     /* 393749 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(393934), // Rule ID 7041 //
     /* 393754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393757 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393757 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393760 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393764 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393769 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393775 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393778 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 393782 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393787 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393792 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393795 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393799 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393804 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393810 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393815 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393820 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393823 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393827 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393832 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393837 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393840 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 393844 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393849 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393854 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393857 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393861 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393866 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393932 */     GIR_RootConstrainSelectedInstOperands,
     /* 393933 */     // GIR_Coverage, 7041,
     /* 393933 */     GIR_EraseRootFromParent_Done,
     /* 393934 */   // Label 7647: @393934
     /* 393934 */   GIM_Reject,
     /* 393935 */ // Label 7645: @393935
     /* 393935 */ GIM_Reject,
     /* 393936 */ // Label 7637: @393936
     /* 393936 */ GIM_Reject,
     /* 393937 */ // Label 99: @393937
     /* 393937 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7656*/ GIMT_Encode4(394236),
     /* 393948 */ /*GILLT_s16*//*Label 7648*/ GIMT_Encode4(393988),
     /* 393952 */ /*GILLT_s32*//*Label 7649*/ GIMT_Encode4(394019),
     /* 393956 */ /*GILLT_s64*//*Label 7650*/ GIMT_Encode4(394050), GIMT_Encode4(0),
     /* 393964 */ /*GILLT_v2s32*//*Label 7651*/ GIMT_Encode4(394081),
     /* 393968 */ /*GILLT_v2s64*//*Label 7652*/ GIMT_Encode4(394112),
     /* 393972 */ /*GILLT_v4s16*//*Label 7653*/ GIMT_Encode4(394143),
     /* 393976 */ /*GILLT_v4s32*//*Label 7654*/ GIMT_Encode4(394174), GIMT_Encode4(0),
     /* 393984 */ /*GILLT_v8s16*//*Label 7655*/ GIMT_Encode4(394205),
     /* 393988 */ // Label 7648: @393988
     /* 393988 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(394018), // Rule ID 570 //
     /* 393993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394007 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 394012 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394016 */   GIR_RootConstrainSelectedInstOperands,
     /* 394017 */   // GIR_Coverage, 570,
     /* 394017 */   GIR_Done,
     /* 394018 */ // Label 7657: @394018
     /* 394018 */ GIM_Reject,
     /* 394019 */ // Label 7649: @394019
     /* 394019 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(394049), // Rule ID 572 //
     /* 394024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394038 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 394043 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394047 */   GIR_RootConstrainSelectedInstOperands,
     /* 394048 */   // GIR_Coverage, 572,
     /* 394048 */   GIR_Done,
     /* 394049 */ // Label 7658: @394049
     /* 394049 */ GIM_Reject,
     /* 394050 */ // Label 7650: @394050
     /* 394050 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(394080), // Rule ID 574 //
     /* 394055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394069 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 394074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394078 */   GIR_RootConstrainSelectedInstOperands,
     /* 394079 */   // GIR_Coverage, 574,
     /* 394079 */   GIR_Done,
     /* 394080 */ // Label 7659: @394080
     /* 394080 */ GIM_Reject,
     /* 394081 */ // Label 7651: @394081
     /* 394081 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(394111), // Rule ID 960 //
     /* 394086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394100 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 394105 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394109 */   GIR_RootConstrainSelectedInstOperands,
     /* 394110 */   // GIR_Coverage, 960,
     /* 394110 */   GIR_Done,
     /* 394111 */ // Label 7660: @394111
     /* 394111 */ GIM_Reject,
     /* 394112 */ // Label 7652: @394112
     /* 394112 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(394142), // Rule ID 964 //
     /* 394117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394131 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 394136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394140 */   GIR_RootConstrainSelectedInstOperands,
     /* 394141 */   // GIR_Coverage, 964,
     /* 394141 */   GIR_Done,
     /* 394142 */ // Label 7661: @394142
     /* 394142 */ GIM_Reject,
     /* 394143 */ // Label 7653: @394143
     /* 394143 */ GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(394173), // Rule ID 956 //
     /* 394148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394162 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 394167 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394171 */   GIR_RootConstrainSelectedInstOperands,
     /* 394172 */   // GIR_Coverage, 956,
     /* 394172 */   GIR_Done,
     /* 394173 */ // Label 7662: @394173
     /* 394173 */ GIM_Reject,
     /* 394174 */ // Label 7654: @394174
     /* 394174 */ GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(394204), // Rule ID 962 //
     /* 394179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394193 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 394198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394202 */   GIR_RootConstrainSelectedInstOperands,
     /* 394203 */   // GIR_Coverage, 962,
     /* 394203 */   GIR_Done,
     /* 394204 */ // Label 7663: @394204
     /* 394204 */ GIM_Reject,
     /* 394205 */ // Label 7655: @394205
     /* 394205 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(394235), // Rule ID 958 //
     /* 394210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394224 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 394229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394233 */   GIR_RootConstrainSelectedInstOperands,
     /* 394234 */   // GIR_Coverage, 958,
     /* 394234 */   GIR_Done,
     /* 394235 */ // Label 7664: @394235
     /* 394235 */ GIM_Reject,
     /* 394236 */ // Label 7656: @394236
     /* 394236 */ GIM_Reject,
     /* 394237 */ // Label 100: @394237
     /* 394237 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7673*/ GIMT_Encode4(394727),
     /* 394248 */ /*GILLT_s16*//*Label 7665*/ GIMT_Encode4(394288),
     /* 394252 */ /*GILLT_s32*//*Label 7666*/ GIMT_Encode4(394319),
     /* 394256 */ /*GILLT_s64*//*Label 7667*/ GIMT_Encode4(394350), GIMT_Encode4(0),
     /* 394264 */ /*GILLT_v2s32*//*Label 7668*/ GIMT_Encode4(394381),
     /* 394268 */ /*GILLT_v2s64*//*Label 7669*/ GIMT_Encode4(394412),
     /* 394272 */ /*GILLT_v4s16*//*Label 7670*/ GIMT_Encode4(394443),
     /* 394276 */ /*GILLT_v4s32*//*Label 7671*/ GIMT_Encode4(394474), GIMT_Encode4(0),
     /* 394284 */ /*GILLT_v8s16*//*Label 7672*/ GIMT_Encode4(394505),
     /* 394288 */ // Label 7665: @394288
     /* 394288 */ GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(394318), // Rule ID 540 //
     /* 394293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394307 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 394312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394316 */   GIR_RootConstrainSelectedInstOperands,
     /* 394317 */   // GIR_Coverage, 540,
     /* 394317 */   GIR_Done,
     /* 394318 */ // Label 7674: @394318
     /* 394318 */ GIM_Reject,
     /* 394319 */ // Label 7666: @394319
     /* 394319 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(394349), // Rule ID 542 //
     /* 394324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394338 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 394343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394347 */   GIR_RootConstrainSelectedInstOperands,
     /* 394348 */   // GIR_Coverage, 542,
     /* 394348 */   GIR_Done,
     /* 394349 */ // Label 7675: @394349
     /* 394349 */ GIM_Reject,
     /* 394350 */ // Label 7667: @394350
     /* 394350 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(394380), // Rule ID 544 //
     /* 394355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394369 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 394374 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394378 */   GIR_RootConstrainSelectedInstOperands,
     /* 394379 */   // GIR_Coverage, 544,
     /* 394379 */   GIR_Done,
     /* 394380 */ // Label 7676: @394380
     /* 394380 */ GIM_Reject,
     /* 394381 */ // Label 7668: @394381
     /* 394381 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(394411), // Rule ID 893 //
     /* 394386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394400 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 394405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394409 */   GIR_RootConstrainSelectedInstOperands,
     /* 394410 */   // GIR_Coverage, 893,
     /* 394410 */   GIR_Done,
     /* 394411 */ // Label 7677: @394411
     /* 394411 */ GIM_Reject,
     /* 394412 */ // Label 7669: @394412
     /* 394412 */ GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(394442), // Rule ID 897 //
     /* 394417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394431 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 394436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394440 */   GIR_RootConstrainSelectedInstOperands,
     /* 394441 */   // GIR_Coverage, 897,
     /* 394441 */   GIR_Done,
     /* 394442 */ // Label 7678: @394442
     /* 394442 */ GIM_Reject,
     /* 394443 */ // Label 7670: @394443
     /* 394443 */ GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(394473), // Rule ID 889 //
     /* 394448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394462 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 394467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394471 */   GIR_RootConstrainSelectedInstOperands,
     /* 394472 */   // GIR_Coverage, 889,
     /* 394472 */   GIR_Done,
     /* 394473 */ // Label 7679: @394473
     /* 394473 */ GIM_Reject,
     /* 394474 */ // Label 7671: @394474
     /* 394474 */ GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(394504), // Rule ID 895 //
     /* 394479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394493 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 394498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394502 */   GIR_RootConstrainSelectedInstOperands,
     /* 394503 */   // GIR_Coverage, 895,
     /* 394503 */   GIR_Done,
     /* 394504 */ // Label 7680: @394504
     /* 394504 */ GIM_Reject,
     /* 394505 */ // Label 7672: @394505
     /* 394505 */ GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(394726),
     /* 394510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394521 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(394540), // Rule ID 891 //
     /* 394526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394529 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 394534 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394538 */     GIR_RootConstrainSelectedInstOperands,
     /* 394539 */     // GIR_Coverage, 891,
     /* 394539 */     GIR_Done,
     /* 394540 */   // Label 7682: @394540
     /* 394540 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(394725), // Rule ID 7043 //
     /* 394545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394548 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394548 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394551 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394555 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394560 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394566 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394569 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 394573 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394578 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394583 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394586 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394590 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394595 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394601 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394606 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394611 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394614 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394618 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394623 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 394626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 394628 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 394631 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 394635 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394640 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 394643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 394645 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 394648 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 394652 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394657 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 394660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 394662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 394665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394688 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 394691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 394694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 394697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 394715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 394723 */     GIR_RootConstrainSelectedInstOperands,
     /* 394724 */     // GIR_Coverage, 7043,
     /* 394724 */     GIR_EraseRootFromParent_Done,
     /* 394725 */   // Label 7683: @394725
     /* 394725 */   GIM_Reject,
     /* 394726 */ // Label 7681: @394726
     /* 394726 */ GIM_Reject,
     /* 394727 */ // Label 7673: @394727
     /* 394727 */ GIM_Reject,
     /* 394728 */ // Label 101: @394728
     /* 394728 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7692*/ GIMT_Encode4(395218),
     /* 394739 */ /*GILLT_s16*//*Label 7684*/ GIMT_Encode4(394779),
     /* 394743 */ /*GILLT_s32*//*Label 7685*/ GIMT_Encode4(394810),
     /* 394747 */ /*GILLT_s64*//*Label 7686*/ GIMT_Encode4(394841), GIMT_Encode4(0),
     /* 394755 */ /*GILLT_v2s32*//*Label 7687*/ GIMT_Encode4(394872),
     /* 394759 */ /*GILLT_v2s64*//*Label 7688*/ GIMT_Encode4(394903),
     /* 394763 */ /*GILLT_v4s16*//*Label 7689*/ GIMT_Encode4(394934),
     /* 394767 */ /*GILLT_v4s32*//*Label 7690*/ GIMT_Encode4(394965), GIMT_Encode4(0),
     /* 394775 */ /*GILLT_v8s16*//*Label 7691*/ GIMT_Encode4(394996),
     /* 394779 */ // Label 7684: @394779
     /* 394779 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(394809), // Rule ID 558 //
     /* 394784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394798 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 394803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394807 */   GIR_RootConstrainSelectedInstOperands,
     /* 394808 */   // GIR_Coverage, 558,
     /* 394808 */   GIR_Done,
     /* 394809 */ // Label 7693: @394809
     /* 394809 */ GIM_Reject,
     /* 394810 */ // Label 7685: @394810
     /* 394810 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(394840), // Rule ID 560 //
     /* 394815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394829 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 394834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394838 */   GIR_RootConstrainSelectedInstOperands,
     /* 394839 */   // GIR_Coverage, 560,
     /* 394839 */   GIR_Done,
     /* 394840 */ // Label 7694: @394840
     /* 394840 */ GIM_Reject,
     /* 394841 */ // Label 7686: @394841
     /* 394841 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(394871), // Rule ID 562 //
     /* 394846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394860 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 394865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394869 */   GIR_RootConstrainSelectedInstOperands,
     /* 394870 */   // GIR_Coverage, 562,
     /* 394870 */   GIR_Done,
     /* 394871 */ // Label 7695: @394871
     /* 394871 */ GIM_Reject,
     /* 394872 */ // Label 7687: @394872
     /* 394872 */ GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(394902), // Rule ID 923 //
     /* 394877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394891 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 394896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394900 */   GIR_RootConstrainSelectedInstOperands,
     /* 394901 */   // GIR_Coverage, 923,
     /* 394901 */   GIR_Done,
     /* 394902 */ // Label 7696: @394902
     /* 394902 */ GIM_Reject,
     /* 394903 */ // Label 7688: @394903
     /* 394903 */ GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(394933), // Rule ID 927 //
     /* 394908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394922 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 394927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394931 */   GIR_RootConstrainSelectedInstOperands,
     /* 394932 */   // GIR_Coverage, 927,
     /* 394932 */   GIR_Done,
     /* 394933 */ // Label 7697: @394933
     /* 394933 */ GIM_Reject,
     /* 394934 */ // Label 7689: @394934
     /* 394934 */ GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(394964), // Rule ID 919 //
     /* 394939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394953 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 394958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394962 */   GIR_RootConstrainSelectedInstOperands,
     /* 394963 */   // GIR_Coverage, 919,
     /* 394963 */   GIR_Done,
     /* 394964 */ // Label 7698: @394964
     /* 394964 */ GIM_Reject,
     /* 394965 */ // Label 7690: @394965
     /* 394965 */ GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(394995), // Rule ID 925 //
     /* 394970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394984 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394989 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394993 */   GIR_RootConstrainSelectedInstOperands,
     /* 394994 */   // GIR_Coverage, 925,
     /* 394994 */   GIR_Done,
     /* 394995 */ // Label 7699: @394995
     /* 394995 */ GIM_Reject,
     /* 394996 */ // Label 7691: @394996
     /* 394996 */ GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(395217),
     /* 395001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395012 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(395031), // Rule ID 921 //
     /* 395017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395020 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 395025 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395029 */     GIR_RootConstrainSelectedInstOperands,
     /* 395030 */     // GIR_Coverage, 921,
     /* 395030 */     GIR_Done,
     /* 395031 */   // Label 7701: @395031
     /* 395031 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(395216), // Rule ID 7051 //
     /* 395036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395039 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 395039 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 395042 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395046 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395051 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 395057 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395060 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 395064 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395069 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395074 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395077 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395081 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395086 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395092 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395097 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395102 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395105 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395109 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395114 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395119 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395122 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 395126 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395131 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395136 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395139 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395143 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395148 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395153 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395156 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395160 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395182 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395185 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 395214 */     GIR_RootConstrainSelectedInstOperands,
     /* 395215 */     // GIR_Coverage, 7051,
     /* 395215 */     GIR_EraseRootFromParent_Done,
     /* 395216 */   // Label 7702: @395216
     /* 395216 */   GIM_Reject,
     /* 395217 */ // Label 7700: @395217
     /* 395217 */ GIM_Reject,
     /* 395218 */ // Label 7692: @395218
     /* 395218 */ GIM_Reject,
     /* 395219 */ // Label 102: @395219
     /* 395219 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7711*/ GIMT_Encode4(395709),
     /* 395230 */ /*GILLT_s16*//*Label 7703*/ GIMT_Encode4(395270),
     /* 395234 */ /*GILLT_s32*//*Label 7704*/ GIMT_Encode4(395301),
     /* 395238 */ /*GILLT_s64*//*Label 7705*/ GIMT_Encode4(395332), GIMT_Encode4(0),
     /* 395246 */ /*GILLT_v2s32*//*Label 7706*/ GIMT_Encode4(395363),
     /* 395250 */ /*GILLT_v2s64*//*Label 7707*/ GIMT_Encode4(395394),
     /* 395254 */ /*GILLT_v4s16*//*Label 7708*/ GIMT_Encode4(395425),
     /* 395258 */ /*GILLT_v4s32*//*Label 7709*/ GIMT_Encode4(395456), GIMT_Encode4(0),
     /* 395266 */ /*GILLT_v8s16*//*Label 7710*/ GIMT_Encode4(395487),
     /* 395270 */ // Label 7703: @395270
     /* 395270 */ GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(395300), // Rule ID 534 //
     /* 395275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395289 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 395294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395298 */   GIR_RootConstrainSelectedInstOperands,
     /* 395299 */   // GIR_Coverage, 534,
     /* 395299 */   GIR_Done,
     /* 395300 */ // Label 7712: @395300
     /* 395300 */ GIM_Reject,
     /* 395301 */ // Label 7704: @395301
     /* 395301 */ GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(395331), // Rule ID 536 //
     /* 395306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395320 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 395325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395329 */   GIR_RootConstrainSelectedInstOperands,
     /* 395330 */   // GIR_Coverage, 536,
     /* 395330 */   GIR_Done,
     /* 395331 */ // Label 7713: @395331
     /* 395331 */ GIM_Reject,
     /* 395332 */ // Label 7705: @395332
     /* 395332 */ GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(395362), // Rule ID 538 //
     /* 395337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395351 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 395356 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395360 */   GIR_RootConstrainSelectedInstOperands,
     /* 395361 */   // GIR_Coverage, 538,
     /* 395361 */   GIR_Done,
     /* 395362 */ // Label 7714: @395362
     /* 395362 */ GIM_Reject,
     /* 395363 */ // Label 7706: @395363
     /* 395363 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(395393), // Rule ID 883 //
     /* 395368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395382 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 395387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395391 */   GIR_RootConstrainSelectedInstOperands,
     /* 395392 */   // GIR_Coverage, 883,
     /* 395392 */   GIR_Done,
     /* 395393 */ // Label 7715: @395393
     /* 395393 */ GIM_Reject,
     /* 395394 */ // Label 7707: @395394
     /* 395394 */ GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(395424), // Rule ID 887 //
     /* 395399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395413 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 395418 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395422 */   GIR_RootConstrainSelectedInstOperands,
     /* 395423 */   // GIR_Coverage, 887,
     /* 395423 */   GIR_Done,
     /* 395424 */ // Label 7716: @395424
     /* 395424 */ GIM_Reject,
     /* 395425 */ // Label 7708: @395425
     /* 395425 */ GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(395455), // Rule ID 879 //
     /* 395430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395444 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 395449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395453 */   GIR_RootConstrainSelectedInstOperands,
     /* 395454 */   // GIR_Coverage, 879,
     /* 395454 */   GIR_Done,
     /* 395455 */ // Label 7717: @395455
     /* 395455 */ GIM_Reject,
     /* 395456 */ // Label 7709: @395456
     /* 395456 */ GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(395486), // Rule ID 885 //
     /* 395461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395475 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 395480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395484 */   GIR_RootConstrainSelectedInstOperands,
     /* 395485 */   // GIR_Coverage, 885,
     /* 395485 */   GIR_Done,
     /* 395486 */ // Label 7718: @395486
     /* 395486 */ GIM_Reject,
     /* 395487 */ // Label 7710: @395487
     /* 395487 */ GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(395708),
     /* 395492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395503 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(395522), // Rule ID 881 //
     /* 395508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395511 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 395516 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395520 */     GIR_RootConstrainSelectedInstOperands,
     /* 395521 */     // GIR_Coverage, 881,
     /* 395521 */     GIR_Done,
     /* 395522 */   // Label 7720: @395522
     /* 395522 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(395707), // Rule ID 7045 //
     /* 395527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395530 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 395530 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 395533 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395537 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395542 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 395548 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395551 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 395555 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395560 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395565 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395568 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395572 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395577 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395583 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395588 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395593 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395596 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395600 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395605 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395610 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395613 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 395617 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395622 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395627 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395630 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395634 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395639 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395673 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395676 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 395705 */     GIR_RootConstrainSelectedInstOperands,
     /* 395706 */     // GIR_Coverage, 7045,
     /* 395706 */     GIR_EraseRootFromParent_Done,
     /* 395707 */   // Label 7721: @395707
     /* 395707 */   GIM_Reject,
     /* 395708 */ // Label 7719: @395708
     /* 395708 */ GIM_Reject,
     /* 395709 */ // Label 7711: @395709
     /* 395709 */ GIM_Reject,
     /* 395710 */ // Label 103: @395710
     /* 395710 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7730*/ GIMT_Encode4(396835),
     /* 395721 */ /*GILLT_s16*//*Label 7722*/ GIMT_Encode4(395761),
     /* 395725 */ /*GILLT_s32*//*Label 7723*/ GIMT_Encode4(395987),
     /* 395729 */ /*GILLT_s64*//*Label 7724*/ GIMT_Encode4(396213), GIMT_Encode4(0),
     /* 395737 */ /*GILLT_v2s32*//*Label 7725*/ GIMT_Encode4(396385),
     /* 395741 */ /*GILLT_v2s64*//*Label 7726*/ GIMT_Encode4(396423),
     /* 395745 */ /*GILLT_v4s16*//*Label 7727*/ GIMT_Encode4(396461),
     /* 395749 */ /*GILLT_v4s32*//*Label 7728*/ GIMT_Encode4(396499), GIMT_Encode4(0),
     /* 395757 */ /*GILLT_v8s16*//*Label 7729*/ GIMT_Encode4(396537),
     /* 395761 */ // Label 7722: @395761
     /* 395761 */ GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(395986),
     /* 395766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 395772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395776 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(395867), // Rule ID 6965 //
     /* 395781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395802 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395818 */     // MIs[2] Rn
     /* 395818 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395829 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 395829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395865 */     GIR_RootConstrainSelectedInstOperands,
     /* 395866 */     // GIR_Coverage, 6965,
     /* 395866 */     GIR_EraseRootFromParent_Done,
     /* 395867 */   // Label 7732: @395867
     /* 395867 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(395958), // Rule ID 14033 //
     /* 395872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395893 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 395897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395909 */     // MIs[2] Rn
     /* 395909 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395914 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 395918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395920 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 395920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395932 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395956 */     GIR_RootConstrainSelectedInstOperands,
     /* 395957 */     // GIR_Coverage, 14033,
     /* 395957 */     GIR_EraseRootFromParent_Done,
     /* 395958 */   // Label 7733: @395958
     /* 395958 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(395985), // Rule ID 583 //
     /* 395963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395974 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 395974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 395979 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395983 */     GIR_RootConstrainSelectedInstOperands,
     /* 395984 */     // GIR_Coverage, 583,
     /* 395984 */     GIR_Done,
     /* 395985 */   // Label 7734: @395985
     /* 395985 */   GIM_Reject,
     /* 395986 */ // Label 7731: @395986
     /* 395986 */ GIM_Reject,
     /* 395987 */ // Label 7723: @395987
     /* 395987 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(396212),
     /* 395992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396002 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(396093), // Rule ID 6963 //
     /* 396007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396044 */     // MIs[2] Rn
     /* 396044 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396049 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 396053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396055 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 396055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 396086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396091 */     GIR_RootConstrainSelectedInstOperands,
     /* 396092 */     // GIR_Coverage, 6963,
     /* 396092 */     GIR_EraseRootFromParent_Done,
     /* 396093 */   // Label 7736: @396093
     /* 396093 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(396184), // Rule ID 14031 //
     /* 396098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 396123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396135 */     // MIs[2] Rn
     /* 396135 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396140 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 396144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396146 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 396146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396158 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 396177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396182 */     GIR_RootConstrainSelectedInstOperands,
     /* 396183 */     // GIR_Coverage, 14031,
     /* 396183 */     GIR_EraseRootFromParent_Done,
     /* 396184 */   // Label 7737: @396184
     /* 396184 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(396211), // Rule ID 585 //
     /* 396189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396200 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 396205 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396209 */     GIR_RootConstrainSelectedInstOperands,
     /* 396210 */     // GIR_Coverage, 585,
     /* 396210 */     GIR_Done,
     /* 396211 */   // Label 7738: @396211
     /* 396211 */   GIM_Reject,
     /* 396212 */ // Label 7735: @396212
     /* 396212 */ GIM_Reject,
     /* 396213 */ // Label 7724: @396213
     /* 396213 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(396384),
     /* 396218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396228 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(396292), // Rule ID 6961 //
     /* 396233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396254 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396270 */     // MIs[2] Rn
     /* 396270 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396275 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 396279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396281 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 396281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 396284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396290 */     GIR_RootConstrainSelectedInstOperands,
     /* 396291 */     // GIR_Coverage, 6961,
     /* 396291 */     GIR_EraseRootFromParent_Done,
     /* 396292 */   // Label 7740: @396292
     /* 396292 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(396356), // Rule ID 14029 //
     /* 396297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396318 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 396322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396334 */     // MIs[2] Rn
     /* 396334 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396339 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 396343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396345 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 396345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 396348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396354 */     GIR_RootConstrainSelectedInstOperands,
     /* 396355 */     // GIR_Coverage, 14029,
     /* 396355 */     GIR_EraseRootFromParent_Done,
     /* 396356 */   // Label 7741: @396356
     /* 396356 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(396383), // Rule ID 587 //
     /* 396361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396372 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 396372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 396377 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396381 */     GIR_RootConstrainSelectedInstOperands,
     /* 396382 */     // GIR_Coverage, 587,
     /* 396382 */     GIR_Done,
     /* 396383 */   // Label 7742: @396383
     /* 396383 */   GIM_Reject,
     /* 396384 */ // Label 7739: @396384
     /* 396384 */ GIM_Reject,
     /* 396385 */ // Label 7725: @396385
     /* 396385 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(396422), // Rule ID 1202 //
     /* 396390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396411 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 396416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396420 */   GIR_RootConstrainSelectedInstOperands,
     /* 396421 */   // GIR_Coverage, 1202,
     /* 396421 */   GIR_Done,
     /* 396422 */ // Label 7743: @396422
     /* 396422 */ GIM_Reject,
     /* 396423 */ // Label 7726: @396423
     /* 396423 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(396460), // Rule ID 1206 //
     /* 396428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396449 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 396454 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396458 */   GIR_RootConstrainSelectedInstOperands,
     /* 396459 */   // GIR_Coverage, 1206,
     /* 396459 */   GIR_Done,
     /* 396460 */ // Label 7744: @396460
     /* 396460 */ GIM_Reject,
     /* 396461 */ // Label 7727: @396461
     /* 396461 */ GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(396498), // Rule ID 1198 //
     /* 396466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396487 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 396487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 396492 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396496 */   GIR_RootConstrainSelectedInstOperands,
     /* 396497 */   // GIR_Coverage, 1198,
     /* 396497 */   GIR_Done,
     /* 396498 */ // Label 7745: @396498
     /* 396498 */ GIM_Reject,
     /* 396499 */ // Label 7728: @396499
     /* 396499 */ GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(396536), // Rule ID 1204 //
     /* 396504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 396513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396525 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 396525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 396530 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396534 */   GIR_RootConstrainSelectedInstOperands,
     /* 396535 */   // GIR_Coverage, 1204,
     /* 396535 */   GIR_Done,
     /* 396536 */ // Label 7746: @396536
     /* 396536 */ GIM_Reject,
     /* 396537 */ // Label 7729: @396537
     /* 396537 */ GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(396834),
     /* 396542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396560 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(396579), // Rule ID 1200 //
     /* 396565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396568 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 396573 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396577 */     GIR_RootConstrainSelectedInstOperands,
     /* 396578 */     // GIR_Coverage, 1200,
     /* 396578 */     GIR_Done,
     /* 396579 */   // Label 7748: @396579
     /* 396579 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(396833), // Rule ID 7054 //
     /* 396584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396587 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 396587 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 396590 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396594 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396599 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 396603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 396605 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 396608 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396612 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396617 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 396623 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 396626 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 396630 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396635 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 396638 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 396641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 396643 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 396646 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396650 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396655 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 396661 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396666 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396671 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396674 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396678 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396683 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396688 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396691 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396695 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396700 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396706 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396711 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396716 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396719 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396723 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396728 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396733 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396736 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 396740 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396745 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396748 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 396751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396753 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396756 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396760 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396765 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 396831 */     GIR_RootConstrainSelectedInstOperands,
     /* 396832 */     // GIR_Coverage, 7054,
     /* 396832 */     GIR_EraseRootFromParent_Done,
     /* 396833 */   // Label 7749: @396833
     /* 396833 */   GIM_Reject,
     /* 396834 */ // Label 7747: @396834
     /* 396834 */ GIM_Reject,
     /* 396835 */ // Label 7730: @396835
     /* 396835 */ GIM_Reject,
     /* 396836 */ // Label 104: @396836
     /* 396836 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7758*/ GIMT_Encode4(397451),
     /* 396847 */ /*GILLT_s16*//*Label 7750*/ GIMT_Encode4(396887),
     /* 396851 */ /*GILLT_s32*//*Label 7751*/ GIMT_Encode4(396925),
     /* 396855 */ /*GILLT_s64*//*Label 7752*/ GIMT_Encode4(396963), GIMT_Encode4(0),
     /* 396863 */ /*GILLT_v2s32*//*Label 7753*/ GIMT_Encode4(397001),
     /* 396867 */ /*GILLT_v2s64*//*Label 7754*/ GIMT_Encode4(397039),
     /* 396871 */ /*GILLT_v4s16*//*Label 7755*/ GIMT_Encode4(397077),
     /* 396875 */ /*GILLT_v4s32*//*Label 7756*/ GIMT_Encode4(397115), GIMT_Encode4(0),
     /* 396883 */ /*GILLT_v8s16*//*Label 7757*/ GIMT_Encode4(397153),
     /* 396887 */ // Label 7750: @396887
     /* 396887 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(396924), // Rule ID 631 //
     /* 396892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 396901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396913 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 396913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 396918 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396922 */   GIR_RootConstrainSelectedInstOperands,
     /* 396923 */   // GIR_Coverage, 631,
     /* 396923 */   GIR_Done,
     /* 396924 */ // Label 7759: @396924
     /* 396924 */ GIM_Reject,
     /* 396925 */ // Label 7751: @396925
     /* 396925 */ GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(396962), // Rule ID 633 //
     /* 396930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 396939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396951 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 396956 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396960 */   GIR_RootConstrainSelectedInstOperands,
     /* 396961 */   // GIR_Coverage, 633,
     /* 396961 */   GIR_Done,
     /* 396962 */ // Label 7760: @396962
     /* 396962 */ GIM_Reject,
     /* 396963 */ // Label 7752: @396963
     /* 396963 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(397000), // Rule ID 635 //
     /* 396968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396989 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 396989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 396994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396998 */   GIR_RootConstrainSelectedInstOperands,
     /* 396999 */   // GIR_Coverage, 635,
     /* 396999 */   GIR_Done,
     /* 397000 */ // Label 7761: @397000
     /* 397000 */ GIM_Reject,
     /* 397001 */ // Label 7753: @397001
     /* 397001 */ GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(397038), // Rule ID 1342 //
     /* 397006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397027 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 397027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 397032 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397036 */   GIR_RootConstrainSelectedInstOperands,
     /* 397037 */   // GIR_Coverage, 1342,
     /* 397037 */   GIR_Done,
     /* 397038 */ // Label 7762: @397038
     /* 397038 */ GIM_Reject,
     /* 397039 */ // Label 7754: @397039
     /* 397039 */ GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(397076), // Rule ID 1346 //
     /* 397044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 397053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397065 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 397065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 397070 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397074 */   GIR_RootConstrainSelectedInstOperands,
     /* 397075 */   // GIR_Coverage, 1346,
     /* 397075 */   GIR_Done,
     /* 397076 */ // Label 7763: @397076
     /* 397076 */ GIM_Reject,
     /* 397077 */ // Label 7755: @397077
     /* 397077 */ GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(397114), // Rule ID 1338 //
     /* 397082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397103 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 397103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 397108 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397112 */   GIR_RootConstrainSelectedInstOperands,
     /* 397113 */   // GIR_Coverage, 1338,
     /* 397113 */   GIR_Done,
     /* 397114 */ // Label 7764: @397114
     /* 397114 */ GIM_Reject,
     /* 397115 */ // Label 7756: @397115
     /* 397115 */ GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(397152), // Rule ID 1344 //
     /* 397120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397141 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 397146 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397150 */   GIR_RootConstrainSelectedInstOperands,
     /* 397151 */   // GIR_Coverage, 1344,
     /* 397151 */   GIR_Done,
     /* 397152 */ // Label 7765: @397152
     /* 397152 */ GIM_Reject,
     /* 397153 */ // Label 7757: @397153
     /* 397153 */ GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(397450),
     /* 397158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 397164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397176 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(397195), // Rule ID 1340 //
     /* 397181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397184 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 397189 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397193 */     GIR_RootConstrainSelectedInstOperands,
     /* 397194 */     // GIR_Coverage, 1340,
     /* 397194 */     GIR_Done,
     /* 397195 */   // Label 7767: @397195
     /* 397195 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(397449), // Rule ID 7060 //
     /* 397200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 397203 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 397203 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 397206 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 397210 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397215 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 397219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 397221 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 397224 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 397228 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397233 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 397239 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 397242 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 397246 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397251 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 397254 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 397257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 397259 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 397262 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397266 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397271 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397277 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397282 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397287 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 397290 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 397294 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397299 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 397302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 397304 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 397307 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397311 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397316 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397322 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397327 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397332 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 397335 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 397339 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397344 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 397347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 397349 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 397352 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 397356 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397361 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 397364 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 397367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 397369 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 397372 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 397376 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397381 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 397384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 397386 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 397389 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397393 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 397403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397412 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 397418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 397421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 397439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 397447 */     GIR_RootConstrainSelectedInstOperands,
     /* 397448 */     // GIR_Coverage, 7060,
     /* 397448 */     GIR_EraseRootFromParent_Done,
     /* 397449 */   // Label 7768: @397449
     /* 397449 */   GIM_Reject,
     /* 397450 */ // Label 7766: @397450
     /* 397450 */ GIM_Reject,
     /* 397451 */ // Label 7758: @397451
     /* 397451 */ GIM_Reject,
     /* 397452 */ // Label 105: @397452
     /* 397452 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7777*/ GIMT_Encode4(401173),
     /* 397463 */ /*GILLT_s16*//*Label 7769*/ GIMT_Encode4(397503),
     /* 397467 */ /*GILLT_s32*//*Label 7770*/ GIMT_Encode4(398057),
     /* 397471 */ /*GILLT_s64*//*Label 7771*/ GIMT_Encode4(398605), GIMT_Encode4(0),
     /* 397479 */ /*GILLT_v2s32*//*Label 7772*/ GIMT_Encode4(399153),
     /* 397483 */ /*GILLT_v2s64*//*Label 7773*/ GIMT_Encode4(399683),
     /* 397487 */ /*GILLT_v4s16*//*Label 7774*/ GIMT_Encode4(400041),
     /* 397491 */ /*GILLT_v4s32*//*Label 7775*/ GIMT_Encode4(400383), GIMT_Encode4(0),
     /* 397499 */ /*GILLT_v8s16*//*Label 7776*/ GIMT_Encode4(400741),
     /* 397503 */ // Label 7769: @397503
     /* 397503 */ GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(398056),
     /* 397508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 397514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397518 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(397631), // Rule ID 6285 //
     /* 397523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397547 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397580 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397584 */     // MIs[3] Operand 1
     /* 397584 */     // No operand predicates
     /* 397584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397586 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 397586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397598 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 397604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397629 */     GIR_RootConstrainSelectedInstOperands,
     /* 397630 */     // GIR_Coverage, 6285,
     /* 397630 */     GIR_EraseRootFromParent_Done,
     /* 397631 */   // Label 7779: @397631
     /* 397631 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(397744), // Rule ID 14010 //
     /* 397636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397672 */     // MIs[2] Operand 1
     /* 397672 */     // No operand predicates
     /* 397672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397684 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397688 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397693 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397699 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 397699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397711 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 397717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397742 */     GIR_RootConstrainSelectedInstOperands,
     /* 397743 */     // GIR_Coverage, 14010,
     /* 397743 */     GIR_EraseRootFromParent_Done,
     /* 397744 */   // Label 7780: @397744
     /* 397744 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(397823), // Rule ID 13944 //
     /* 397749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397773 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397783 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 397783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397795 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 397801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397821 */     GIR_RootConstrainSelectedInstOperands,
     /* 397822 */     // GIR_Coverage, 13944,
     /* 397822 */     GIR_EraseRootFromParent_Done,
     /* 397823 */   // Label 7781: @397823
     /* 397823 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(397902), // Rule ID 4842 //
     /* 397828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397856 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397862 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 397862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397874 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 397880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397900 */     GIR_RootConstrainSelectedInstOperands,
     /* 397901 */     // GIR_Coverage, 4842,
     /* 397901 */     GIR_EraseRootFromParent_Done,
     /* 397902 */   // Label 7782: @397902
     /* 397902 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(397965), // Rule ID 13553 //
     /* 397907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397939 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397943 */     // MIs[2] Operand 1
     /* 397943 */     // No operand predicates
     /* 397943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397949 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397963 */     GIR_RootConstrainSelectedInstOperands,
     /* 397964 */     // GIR_Coverage, 13553,
     /* 397964 */     GIR_EraseRootFromParent_Done,
     /* 397965 */   // Label 7783: @397965
     /* 397965 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(398028), // Rule ID 2011 //
     /* 397970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398010 */     // MIs[2] Operand 1
     /* 398010 */     // No operand predicates
     /* 398010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398012 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 398015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398026 */     GIR_RootConstrainSelectedInstOperands,
     /* 398027 */     // GIR_Coverage, 2011,
     /* 398027 */     GIR_EraseRootFromParent_Done,
     /* 398028 */   // Label 7784: @398028
     /* 398028 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(398055), // Rule ID 619 //
     /* 398033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 398036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398044 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 398044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 398049 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398053 */     GIR_RootConstrainSelectedInstOperands,
     /* 398054 */     // GIR_Coverage, 619,
     /* 398054 */     GIR_Done,
     /* 398055 */   // Label 7785: @398055
     /* 398055 */   GIM_Reject,
     /* 398056 */ // Label 7778: @398056
     /* 398056 */ GIM_Reject,
     /* 398057 */ // Label 7770: @398057
     /* 398057 */ GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(398604),
     /* 398062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 398065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 398068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398072 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(398185), // Rule ID 6287 //
     /* 398077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398101 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398134 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398138 */     // MIs[3] Operand 1
     /* 398138 */     // No operand predicates
     /* 398138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398140 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 398140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398152 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 398158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398183 */     GIR_RootConstrainSelectedInstOperands,
     /* 398184 */     // GIR_Coverage, 6287,
     /* 398184 */     GIR_EraseRootFromParent_Done,
     /* 398185 */   // Label 7787: @398185
     /* 398185 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(398298), // Rule ID 14012 //
     /* 398190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398226 */     // MIs[2] Operand 1
     /* 398226 */     // No operand predicates
     /* 398226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 398242 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398247 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 398251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398253 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 398253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398265 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 398271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398296 */     GIR_RootConstrainSelectedInstOperands,
     /* 398297 */     // GIR_Coverage, 14012,
     /* 398297 */     GIR_EraseRootFromParent_Done,
     /* 398298 */   // Label 7788: @398298
     /* 398298 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(398374), // Rule ID 13946 //
     /* 398303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398334 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 398334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 398352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 398365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398372 */     GIR_RootConstrainSelectedInstOperands,
     /* 398373 */     // GIR_Coverage, 13946,
     /* 398373 */     GIR_EraseRootFromParent_Done,
     /* 398374 */   // Label 7789: @398374
     /* 398374 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398450), // Rule ID 4844 //
     /* 398379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398404 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398410 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 398410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398422 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 398428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 398441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398448 */     GIR_RootConstrainSelectedInstOperands,
     /* 398449 */     // GIR_Coverage, 4844,
     /* 398449 */     GIR_EraseRootFromParent_Done,
     /* 398450 */   // Label 7790: @398450
     /* 398450 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(398513), // Rule ID 13555 //
     /* 398455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398487 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398491 */     // MIs[2] Operand 1
     /* 398491 */     // No operand predicates
     /* 398491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398497 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398511 */     GIR_RootConstrainSelectedInstOperands,
     /* 398512 */     // GIR_Coverage, 13555,
     /* 398512 */     GIR_EraseRootFromParent_Done,
     /* 398513 */   // Label 7791: @398513
     /* 398513 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398576), // Rule ID 2013 //
     /* 398518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398558 */     // MIs[2] Operand 1
     /* 398558 */     // No operand predicates
     /* 398558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398560 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398574 */     GIR_RootConstrainSelectedInstOperands,
     /* 398575 */     // GIR_Coverage, 2013,
     /* 398575 */     GIR_EraseRootFromParent_Done,
     /* 398576 */   // Label 7792: @398576
     /* 398576 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(398603), // Rule ID 621 //
     /* 398581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 398584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398592 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 398592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 398597 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398601 */     GIR_RootConstrainSelectedInstOperands,
     /* 398602 */     // GIR_Coverage, 621,
     /* 398602 */     GIR_Done,
     /* 398603 */   // Label 7793: @398603
     /* 398603 */   GIM_Reject,
     /* 398604 */ // Label 7786: @398604
     /* 398604 */ GIM_Reject,
     /* 398605 */ // Label 7771: @398605
     /* 398605 */ GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(399152),
     /* 398610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398620 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(398733), // Rule ID 6289 //
     /* 398625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398649 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398682 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398686 */     // MIs[3] Operand 1
     /* 398686 */     // No operand predicates
     /* 398686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398688 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 398688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398700 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398731 */     GIR_RootConstrainSelectedInstOperands,
     /* 398732 */     // GIR_Coverage, 6289,
     /* 398732 */     GIR_EraseRootFromParent_Done,
     /* 398733 */   // Label 7795: @398733
     /* 398733 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(398846), // Rule ID 14014 //
     /* 398738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398770 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398774 */     // MIs[2] Operand 1
     /* 398774 */     // No operand predicates
     /* 398774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398782 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398786 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 398790 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398795 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 398799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398801 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 398801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398813 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398844 */     GIR_RootConstrainSelectedInstOperands,
     /* 398845 */     // GIR_Coverage, 14014,
     /* 398845 */     GIR_EraseRootFromParent_Done,
     /* 398846 */   // Label 7796: @398846
     /* 398846 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(398922), // Rule ID 13948 //
     /* 398851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398872 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398882 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 398882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398894 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398920 */     GIR_RootConstrainSelectedInstOperands,
     /* 398921 */     // GIR_Coverage, 13948,
     /* 398921 */     GIR_EraseRootFromParent_Done,
     /* 398922 */   // Label 7797: @398922
     /* 398922 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(398998), // Rule ID 4846 //
     /* 398927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398952 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398958 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 398958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398970 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398996 */     GIR_RootConstrainSelectedInstOperands,
     /* 398997 */     // GIR_Coverage, 4846,
     /* 398997 */     GIR_EraseRootFromParent_Done,
     /* 398998 */   // Label 7798: @398998
     /* 398998 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(399061), // Rule ID 13557 //
     /* 399003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399039 */     // MIs[2] Operand 1
     /* 399039 */     // No operand predicates
     /* 399039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399045 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 399048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399059 */     GIR_RootConstrainSelectedInstOperands,
     /* 399060 */     // GIR_Coverage, 13557,
     /* 399060 */     GIR_EraseRootFromParent_Done,
     /* 399061 */   // Label 7799: @399061
     /* 399061 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(399124), // Rule ID 2015 //
     /* 399066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399102 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399106 */     // MIs[2] Operand 1
     /* 399106 */     // No operand predicates
     /* 399106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399108 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 399111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399122 */     GIR_RootConstrainSelectedInstOperands,
     /* 399123 */     // GIR_Coverage, 2015,
     /* 399123 */     GIR_EraseRootFromParent_Done,
     /* 399124 */   // Label 7800: @399124
     /* 399124 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(399151), // Rule ID 623 //
     /* 399129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399140 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 399140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 399145 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399149 */     GIR_RootConstrainSelectedInstOperands,
     /* 399150 */     // GIR_Coverage, 623,
     /* 399150 */     GIR_Done,
     /* 399151 */   // Label 7801: @399151
     /* 399151 */   GIM_Reject,
     /* 399152 */ // Label 7794: @399152
     /* 399152 */ GIM_Reject,
     /* 399153 */ // Label 7772: @399153
     /* 399153 */ GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(399682),
     /* 399158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399168 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(399254), // Rule ID 13545 //
     /* 399173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399217 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399221 */     // MIs[3] Operand 1
     /* 399221 */     // No operand predicates
     /* 399221 */     // MIs[1] Operand 2
     /* 399221 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399238 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399252 */     GIR_RootConstrainSelectedInstOperands,
     /* 399253 */     // GIR_Coverage, 13545,
     /* 399253 */     GIR_EraseRootFromParent_Done,
     /* 399254 */   // Label 7803: @399254
     /* 399254 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(399340), // Rule ID 2003 //
     /* 399259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399307 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399311 */     // MIs[3] Operand 1
     /* 399311 */     // No operand predicates
     /* 399311 */     // MIs[1] Operand 2
     /* 399311 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399324 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399338 */     GIR_RootConstrainSelectedInstOperands,
     /* 399339 */     // GIR_Coverage, 2003,
     /* 399339 */     GIR_EraseRootFromParent_Done,
     /* 399340 */   // Label 7804: @399340
     /* 399340 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(399403), // Rule ID 13546 //
     /* 399345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399381 */     // MIs[2] Operand 1
     /* 399381 */     // No operand predicates
     /* 399381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399387 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399401 */     GIR_RootConstrainSelectedInstOperands,
     /* 399402 */     // GIR_Coverage, 13546,
     /* 399402 */     GIR_EraseRootFromParent_Done,
     /* 399403 */   // Label 7805: @399403
     /* 399403 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(399466), // Rule ID 2004 //
     /* 399408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399448 */     // MIs[2] Operand 1
     /* 399448 */     // No operand predicates
     /* 399448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399450 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399464 */     GIR_RootConstrainSelectedInstOperands,
     /* 399465 */     // GIR_Coverage, 2004,
     /* 399465 */     GIR_EraseRootFromParent_Done,
     /* 399466 */   // Label 7806: @399466
     /* 399466 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(399560), // Rule ID 14016 //
     /* 399471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399494 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399520 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399527 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399558 */     GIR_RootConstrainSelectedInstOperands,
     /* 399559 */     // GIR_Coverage, 14016,
     /* 399559 */     GIR_EraseRootFromParent_Done,
     /* 399560 */   // Label 7807: @399560
     /* 399560 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399654), // Rule ID 6291 //
     /* 399565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399588 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399652 */     GIR_RootConstrainSelectedInstOperands,
     /* 399653 */     // GIR_Coverage, 6291,
     /* 399653 */     GIR_EraseRootFromParent_Done,
     /* 399654 */   // Label 7808: @399654
     /* 399654 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(399681), // Rule ID 1322 //
     /* 399659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399670 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 399675 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399679 */     GIR_RootConstrainSelectedInstOperands,
     /* 399680 */     // GIR_Coverage, 1322,
     /* 399680 */     GIR_Done,
     /* 399681 */   // Label 7809: @399681
     /* 399681 */   GIM_Reject,
     /* 399682 */ // Label 7802: @399682
     /* 399682 */ GIM_Reject,
     /* 399683 */ // Label 7773: @399683
     /* 399683 */ GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(400040),
     /* 399688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399698 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(399761), // Rule ID 13551 //
     /* 399703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 399714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399739 */     // MIs[2] Operand 1
     /* 399739 */     // No operand predicates
     /* 399739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399745 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399759 */     GIR_RootConstrainSelectedInstOperands,
     /* 399760 */     // GIR_Coverage, 13551,
     /* 399760 */     GIR_EraseRootFromParent_Done,
     /* 399761 */   // Label 7811: @399761
     /* 399761 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(399824), // Rule ID 2009 //
     /* 399766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 399781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399802 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399806 */     // MIs[2] Operand 1
     /* 399806 */     // No operand predicates
     /* 399806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399808 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399822 */     GIR_RootConstrainSelectedInstOperands,
     /* 399823 */     // GIR_Coverage, 2009,
     /* 399823 */     GIR_EraseRootFromParent_Done,
     /* 399824 */   // Label 7812: @399824
     /* 399824 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(399918), // Rule ID 14020 //
     /* 399829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 399841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399852 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399916 */     GIR_RootConstrainSelectedInstOperands,
     /* 399917 */     // GIR_Coverage, 14020,
     /* 399917 */     GIR_EraseRootFromParent_Done,
     /* 399918 */   // Label 7813: @399918
     /* 399918 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(400012), // Rule ID 6295 //
     /* 399923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 399939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399946 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399972 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 400000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400010 */     GIR_RootConstrainSelectedInstOperands,
     /* 400011 */     // GIR_Coverage, 6295,
     /* 400011 */     GIR_EraseRootFromParent_Done,
     /* 400012 */   // Label 7814: @400012
     /* 400012 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(400039), // Rule ID 1326 //
     /* 400017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400028 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 400033 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400037 */     GIR_RootConstrainSelectedInstOperands,
     /* 400038 */     // GIR_Coverage, 1326,
     /* 400038 */     GIR_Done,
     /* 400039 */   // Label 7815: @400039
     /* 400039 */   GIM_Reject,
     /* 400040 */ // Label 7810: @400040
     /* 400040 */ GIM_Reject,
     /* 400041 */ // Label 7774: @400041
     /* 400041 */ GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(400382),
     /* 400046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400056 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(400142), // Rule ID 13539 //
     /* 400061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400105 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400109 */     // MIs[3] Operand 1
     /* 400109 */     // No operand predicates
     /* 400109 */     // MIs[1] Operand 2
     /* 400109 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400126 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400140 */     GIR_RootConstrainSelectedInstOperands,
     /* 400141 */     // GIR_Coverage, 13539,
     /* 400141 */     GIR_EraseRootFromParent_Done,
     /* 400142 */   // Label 7817: @400142
     /* 400142 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(400228), // Rule ID 1997 //
     /* 400147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400195 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400199 */     // MIs[3] Operand 1
     /* 400199 */     // No operand predicates
     /* 400199 */     // MIs[1] Operand 2
     /* 400199 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400212 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400226 */     GIR_RootConstrainSelectedInstOperands,
     /* 400227 */     // GIR_Coverage, 1997,
     /* 400227 */     GIR_EraseRootFromParent_Done,
     /* 400228 */   // Label 7818: @400228
     /* 400228 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(400291), // Rule ID 13540 //
     /* 400233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400265 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400269 */     // MIs[2] Operand 1
     /* 400269 */     // No operand predicates
     /* 400269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400275 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400289 */     GIR_RootConstrainSelectedInstOperands,
     /* 400290 */     // GIR_Coverage, 13540,
     /* 400290 */     GIR_EraseRootFromParent_Done,
     /* 400291 */   // Label 7819: @400291
     /* 400291 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(400354), // Rule ID 1998 //
     /* 400296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400332 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400336 */     // MIs[2] Operand 1
     /* 400336 */     // No operand predicates
     /* 400336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400338 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400352 */     GIR_RootConstrainSelectedInstOperands,
     /* 400353 */     // GIR_Coverage, 1998,
     /* 400353 */     GIR_EraseRootFromParent_Done,
     /* 400354 */   // Label 7820: @400354
     /* 400354 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(400381), // Rule ID 1318 //
     /* 400359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400370 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 400375 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400379 */     GIR_RootConstrainSelectedInstOperands,
     /* 400380 */     // GIR_Coverage, 1318,
     /* 400380 */     GIR_Done,
     /* 400381 */   // Label 7821: @400381
     /* 400381 */   GIM_Reject,
     /* 400382 */ // Label 7816: @400382
     /* 400382 */ GIM_Reject,
     /* 400383 */ // Label 7775: @400383
     /* 400383 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(400740),
     /* 400388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400398 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(400461), // Rule ID 13549 //
     /* 400403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400435 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400439 */     // MIs[2] Operand 1
     /* 400439 */     // No operand predicates
     /* 400439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400445 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400459 */     GIR_RootConstrainSelectedInstOperands,
     /* 400460 */     // GIR_Coverage, 13549,
     /* 400460 */     GIR_EraseRootFromParent_Done,
     /* 400461 */   // Label 7823: @400461
     /* 400461 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(400524), // Rule ID 2007 //
     /* 400466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400506 */     // MIs[2] Operand 1
     /* 400506 */     // No operand predicates
     /* 400506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400508 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400522 */     GIR_RootConstrainSelectedInstOperands,
     /* 400523 */     // GIR_Coverage, 2007,
     /* 400523 */     GIR_EraseRootFromParent_Done,
     /* 400524 */   // Label 7824: @400524
     /* 400524 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(400618), // Rule ID 14018 //
     /* 400529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400552 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400585 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400616 */     GIR_RootConstrainSelectedInstOperands,
     /* 400617 */     // GIR_Coverage, 14018,
     /* 400617 */     GIR_EraseRootFromParent_Done,
     /* 400618 */   // Label 7825: @400618
     /* 400618 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(400712), // Rule ID 6293 //
     /* 400623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400646 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400710 */     GIR_RootConstrainSelectedInstOperands,
     /* 400711 */     // GIR_Coverage, 6293,
     /* 400711 */     GIR_EraseRootFromParent_Done,
     /* 400712 */   // Label 7826: @400712
     /* 400712 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(400739), // Rule ID 1324 //
     /* 400717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400728 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400733 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400737 */     GIR_RootConstrainSelectedInstOperands,
     /* 400738 */     // GIR_Coverage, 1324,
     /* 400738 */     GIR_Done,
     /* 400739 */   // Label 7827: @400739
     /* 400739 */   GIM_Reject,
     /* 400740 */ // Label 7822: @400740
     /* 400740 */ GIM_Reject,
     /* 400741 */ // Label 7776: @400741
     /* 400741 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(401172),
     /* 400746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400756 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(400819), // Rule ID 13543 //
     /* 400761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400797 */     // MIs[2] Operand 1
     /* 400797 */     // No operand predicates
     /* 400797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400803 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 400806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400817 */     GIR_RootConstrainSelectedInstOperands,
     /* 400818 */     // GIR_Coverage, 13543,
     /* 400818 */     GIR_EraseRootFromParent_Done,
     /* 400819 */   // Label 7829: @400819
     /* 400819 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(400882), // Rule ID 2001 //
     /* 400824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400860 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400864 */     // MIs[2] Operand 1
     /* 400864 */     // No operand predicates
     /* 400864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400866 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 400869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400880 */     GIR_RootConstrainSelectedInstOperands,
     /* 400881 */     // GIR_Coverage, 2001,
     /* 400881 */     GIR_EraseRootFromParent_Done,
     /* 400882 */   // Label 7830: @400882
     /* 400882 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(400909), // Rule ID 1320 //
     /* 400887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400898 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 400903 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400907 */     GIR_RootConstrainSelectedInstOperands,
     /* 400908 */     // GIR_Coverage, 1320,
     /* 400908 */     GIR_Done,
     /* 400909 */   // Label 7831: @400909
     /* 400909 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(401171), // Rule ID 7058 //
     /* 400914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 400917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400925 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 400925 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 400928 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400932 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400937 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 400941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 400943 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 400946 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400950 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400955 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 400961 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 400964 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400968 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400973 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 400976 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 400979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 400981 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 400984 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400988 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400993 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 400999 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401004 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401009 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 401012 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 401016 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401021 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 401024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 401026 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 401029 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401033 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401038 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 401044 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401049 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401054 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 401057 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 401061 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401066 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 401069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 401071 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 401074 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 401078 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401083 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 401086 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 401089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 401091 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 401094 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 401098 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401103 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 401106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 401108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 401111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 401125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401137 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 401140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 401161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 401169 */     GIR_RootConstrainSelectedInstOperands,
     /* 401170 */     // GIR_Coverage, 7058,
     /* 401170 */     GIR_EraseRootFromParent_Done,
     /* 401171 */   // Label 7832: @401171
     /* 401171 */   GIM_Reject,
     /* 401172 */ // Label 7828: @401172
     /* 401172 */ GIM_Reject,
     /* 401173 */ // Label 7777: @401173
     /* 401173 */ GIM_Reject,
     /* 401174 */ // Label 106: @401174
     /* 401174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7841*/ GIMT_Encode4(401789),
     /* 401185 */ /*GILLT_s16*//*Label 7833*/ GIMT_Encode4(401225),
     /* 401189 */ /*GILLT_s32*//*Label 7834*/ GIMT_Encode4(401263),
     /* 401193 */ /*GILLT_s64*//*Label 7835*/ GIMT_Encode4(401301), GIMT_Encode4(0),
     /* 401201 */ /*GILLT_v2s32*//*Label 7836*/ GIMT_Encode4(401339),
     /* 401205 */ /*GILLT_v2s64*//*Label 7837*/ GIMT_Encode4(401377),
     /* 401209 */ /*GILLT_v4s16*//*Label 7838*/ GIMT_Encode4(401415),
     /* 401213 */ /*GILLT_v4s32*//*Label 7839*/ GIMT_Encode4(401453), GIMT_Encode4(0),
     /* 401221 */ /*GILLT_v8s16*//*Label 7840*/ GIMT_Encode4(401491),
     /* 401225 */ // Label 7833: @401225
     /* 401225 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(401262), // Rule ID 589 //
     /* 401230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 401239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401251 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 401251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 401256 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401260 */   GIR_RootConstrainSelectedInstOperands,
     /* 401261 */   // GIR_Coverage, 589,
     /* 401261 */   GIR_Done,
     /* 401262 */ // Label 7842: @401262
     /* 401262 */ GIM_Reject,
     /* 401263 */ // Label 7834: @401263
     /* 401263 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(401300), // Rule ID 591 //
     /* 401268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 401271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 401277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401289 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 401289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 401294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401298 */   GIR_RootConstrainSelectedInstOperands,
     /* 401299 */   // GIR_Coverage, 591,
     /* 401299 */   GIR_Done,
     /* 401300 */ // Label 7843: @401300
     /* 401300 */ GIM_Reject,
     /* 401301 */ // Label 7835: @401301
     /* 401301 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(401338), // Rule ID 593 //
     /* 401306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 401309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401327 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 401327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 401332 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401336 */   GIR_RootConstrainSelectedInstOperands,
     /* 401337 */   // GIR_Coverage, 593,
     /* 401337 */   GIR_Done,
     /* 401338 */ // Label 7844: @401338
     /* 401338 */ GIM_Reject,
     /* 401339 */ // Label 7836: @401339
     /* 401339 */ GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(401376), // Rule ID 1227 //
     /* 401344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401365 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 401370 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401374 */   GIR_RootConstrainSelectedInstOperands,
     /* 401375 */   // GIR_Coverage, 1227,
     /* 401375 */   GIR_Done,
     /* 401376 */ // Label 7845: @401376
     /* 401376 */ GIM_Reject,
     /* 401377 */ // Label 7837: @401377
     /* 401377 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(401414), // Rule ID 1231 //
     /* 401382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401403 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 401408 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401412 */   GIR_RootConstrainSelectedInstOperands,
     /* 401413 */   // GIR_Coverage, 1231,
     /* 401413 */   GIR_Done,
     /* 401414 */ // Label 7846: @401414
     /* 401414 */ GIM_Reject,
     /* 401415 */ // Label 7838: @401415
     /* 401415 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(401452), // Rule ID 1223 //
     /* 401420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401441 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 401446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401450 */   GIR_RootConstrainSelectedInstOperands,
     /* 401451 */   // GIR_Coverage, 1223,
     /* 401451 */   GIR_Done,
     /* 401452 */ // Label 7847: @401452
     /* 401452 */ GIM_Reject,
     /* 401453 */ // Label 7839: @401453
     /* 401453 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(401490), // Rule ID 1229 //
     /* 401458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401479 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 401484 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401488 */   GIR_RootConstrainSelectedInstOperands,
     /* 401489 */   // GIR_Coverage, 1229,
     /* 401489 */   GIR_Done,
     /* 401490 */ // Label 7848: @401490
     /* 401490 */ GIM_Reject,
     /* 401491 */ // Label 7840: @401491
     /* 401491 */ GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(401788),
     /* 401496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401514 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(401533), // Rule ID 1225 //
     /* 401519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401522 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 401527 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401531 */     GIR_RootConstrainSelectedInstOperands,
     /* 401532 */     // GIR_Coverage, 1225,
     /* 401532 */     GIR_Done,
     /* 401533 */   // Label 7850: @401533
     /* 401533 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(401787), // Rule ID 7056 //
     /* 401538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 401541 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 401541 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 401544 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 401548 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401553 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 401557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 401559 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 401562 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 401566 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401571 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 401577 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 401580 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 401584 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401589 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 401592 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 401595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 401597 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 401600 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401604 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401609 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 401615 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401620 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401625 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 401628 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 401632 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401637 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 401640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 401642 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 401645 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401649 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401654 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 401660 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401665 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401670 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 401673 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 401677 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401682 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 401685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 401687 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 401690 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 401694 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401699 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 401702 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 401705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 401707 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 401710 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 401714 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401719 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 401722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 401724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 401727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 401741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401750 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 401756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 401777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 401785 */     GIR_RootConstrainSelectedInstOperands,
     /* 401786 */     // GIR_Coverage, 7056,
     /* 401786 */     GIR_EraseRootFromParent_Done,
     /* 401787 */   // Label 7851: @401787
     /* 401787 */   GIM_Reject,
     /* 401788 */ // Label 7849: @401788
     /* 401788 */ GIM_Reject,
     /* 401789 */ // Label 7841: @401789
     /* 401789 */ GIM_Reject,
     /* 401790 */ // Label 107: @401790
     /* 401790 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7860*/ GIMT_Encode4(417396),
     /* 401801 */ /*GILLT_s16*//*Label 7852*/ GIMT_Encode4(401841),
     /* 401805 */ /*GILLT_s32*//*Label 7853*/ GIMT_Encode4(404615),
     /* 401809 */ /*GILLT_s64*//*Label 7854*/ GIMT_Encode4(407545), GIMT_Encode4(0),
     /* 401817 */ /*GILLT_v2s32*//*Label 7855*/ GIMT_Encode4(410475),
     /* 401821 */ /*GILLT_v2s64*//*Label 7856*/ GIMT_Encode4(411996),
     /* 401825 */ /*GILLT_v4s16*//*Label 7857*/ GIMT_Encode4(413517),
     /* 401829 */ /*GILLT_v4s32*//*Label 7858*/ GIMT_Encode4(414696), GIMT_Encode4(0),
     /* 401837 */ /*GILLT_v8s16*//*Label 7859*/ GIMT_Encode4(416217),
     /* 401841 */ // Label 7852: @401841
     /* 401841 */ GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(404614),
     /* 401846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 401852 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 401855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401859 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(402009), // Rule ID 4904 //
     /* 401864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401888 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401913 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 401921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 401929 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401936 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401948 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401976 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 401995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 402007 */     GIR_RootConstrainSelectedInstOperands,
     /* 402008 */     // GIR_Coverage, 4904,
     /* 402008 */     GIR_EraseRootFromParent_Done,
     /* 402009 */   // Label 7862: @402009
     /* 402009 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(402156), // Rule ID 4868 //
     /* 402014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402038 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 402058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402075 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 402079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402085 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 402088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402097 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402108 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402125 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402154 */     GIR_RootConstrainSelectedInstOperands,
     /* 402155 */     // GIR_Coverage, 4868,
     /* 402155 */     GIR_EraseRootFromParent_Done,
     /* 402156 */   // Label 7863: @402156
     /* 402156 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(402303), // Rule ID 13957 //
     /* 402161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402197 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402209 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402213 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402217 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402222 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 402226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402232 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402232 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 402235 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402239 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402244 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402272 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402301 */     GIR_RootConstrainSelectedInstOperands,
     /* 402302 */     // GIR_Coverage, 13957,
     /* 402302 */     GIR_EraseRootFromParent_Done,
     /* 402303 */   // Label 7864: @402303
     /* 402303 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(402434), // Rule ID 6123 //
     /* 402308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402332 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 402352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402360 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402364 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402369 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 402373 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402377 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402381 */     // MIs[4] Operand 1
     /* 402381 */     // No operand predicates
     /* 402381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402385 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402387 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402399 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 402429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 402432 */     GIR_RootConstrainSelectedInstOperands,
     /* 402433 */     // GIR_Coverage, 6123,
     /* 402433 */     GIR_EraseRootFromParent_Done,
     /* 402434 */   // Label 7865: @402434
     /* 402434 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(402565), // Rule ID 6155 //
     /* 402439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402475 */     // MIs[2] Operand 1
     /* 402475 */     // No operand predicates
     /* 402475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402483 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 402487 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 402491 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402495 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402499 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 402503 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402508 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 402512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402518 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402530 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402563 */     GIR_RootConstrainSelectedInstOperands,
     /* 402564 */     // GIR_Coverage, 6155,
     /* 402564 */     GIR_EraseRootFromParent_Done,
     /* 402565 */   // Label 7866: @402565
     /* 402565 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(402696), // Rule ID 6219 //
     /* 402570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402606 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402622 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402626 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402631 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 402635 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402639 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402643 */     // MIs[4] Operand 1
     /* 402643 */     // No operand predicates
     /* 402643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402647 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402649 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 402691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 402694 */     GIR_RootConstrainSelectedInstOperands,
     /* 402695 */     // GIR_Coverage, 6219,
     /* 402695 */     GIR_EraseRootFromParent_Done,
     /* 402696 */   // Label 7867: @402696
     /* 402696 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(402827), // Rule ID 6187 //
     /* 402701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402745 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402749 */     // MIs[3] Operand 1
     /* 402749 */     // No operand predicates
     /* 402749 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 402753 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402757 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402761 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 402765 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402770 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 402774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402780 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402792 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402825 */     GIR_RootConstrainSelectedInstOperands,
     /* 402826 */     // GIR_Coverage, 6187,
     /* 402826 */     GIR_EraseRootFromParent_Done,
     /* 402827 */   // Label 7868: @402827
     /* 402827 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(402962), // Rule ID 2458 //
     /* 402832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402856 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402881 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402891 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402891 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 402894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402898 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402903 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402931 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402960 */     GIR_RootConstrainSelectedInstOperands,
     /* 402961 */     // GIR_Coverage, 2458,
     /* 402961 */     GIR_EraseRootFromParent_Done,
     /* 402962 */   // Label 7869: @402962
     /* 402962 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(403081), // Rule ID 6091 //
     /* 402967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403024 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403028 */     // MIs[3] Operand 1
     /* 403028 */     // No operand predicates
     /* 403028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403034 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403046 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 403065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403079 */     GIR_RootConstrainSelectedInstOperands,
     /* 403080 */     // GIR_Coverage, 6091,
     /* 403080 */     GIR_EraseRootFromParent_Done,
     /* 403081 */   // Label 7870: @403081
     /* 403081 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(403200), // Rule ID 2533 //
     /* 403086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403122 */     // MIs[2] Operand 1
     /* 403122 */     // No operand predicates
     /* 403122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403134 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403138 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403143 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403153 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 403184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403198 */     GIR_RootConstrainSelectedInstOperands,
     /* 403199 */     // GIR_Coverage, 2533,
     /* 403199 */     GIR_EraseRootFromParent_Done,
     /* 403200 */   // Label 7871: @403200
     /* 403200 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(403300), // Rule ID 4866 //
     /* 403205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403229 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403256 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403268 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403298 */     GIR_RootConstrainSelectedInstOperands,
     /* 403299 */     // GIR_Coverage, 4866,
     /* 403299 */     GIR_EraseRootFromParent_Done,
     /* 403300 */   // Label 7872: @403300
     /* 403300 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(403400), // Rule ID 4902 //
     /* 403305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403329 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 403341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403356 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403368 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 403398 */     GIR_RootConstrainSelectedInstOperands,
     /* 403399 */     // GIR_Coverage, 4902,
     /* 403399 */     GIR_EraseRootFromParent_Done,
     /* 403400 */   // Label 7873: @403400
     /* 403400 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(403497), // Rule ID 13953 //
     /* 403405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403441 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403455 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403467 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403495 */     GIR_RootConstrainSelectedInstOperands,
     /* 403496 */     // GIR_Coverage, 13953,
     /* 403496 */     GIR_EraseRootFromParent_Done,
     /* 403497 */   // Label 7874: @403497
     /* 403497 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(403597), // Rule ID 13955 //
     /* 403502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403543 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403553 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403595 */     GIR_RootConstrainSelectedInstOperands,
     /* 403596 */     // GIR_Coverage, 13955,
     /* 403596 */     GIR_EraseRootFromParent_Done,
     /* 403597 */   // Label 7875: @403597
     /* 403597 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(403697), // Rule ID 4900 //
     /* 403602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403630 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 403638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403653 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403665 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 403695 */     GIR_RootConstrainSelectedInstOperands,
     /* 403696 */     // GIR_Coverage, 4900,
     /* 403696 */     GIR_EraseRootFromParent_Done,
     /* 403697 */   // Label 7876: @403697
     /* 403697 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(403794), // Rule ID 4864 //
     /* 403702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403742 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403752 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403764 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403792 */     GIR_RootConstrainSelectedInstOperands,
     /* 403793 */     // GIR_Coverage, 4864,
     /* 403793 */     GIR_EraseRootFromParent_Done,
     /* 403794 */   // Label 7877: @403794
     /* 403794 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(403878), // Rule ID 6153 //
     /* 403799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403831 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403835 */     // MIs[2] Operand 1
     /* 403835 */     // No operand predicates
     /* 403835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403843 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 403847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403858 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 403869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403876 */     GIR_RootConstrainSelectedInstOperands,
     /* 403877 */     // GIR_Coverage, 6153,
     /* 403877 */     GIR_EraseRootFromParent_Done,
     /* 403878 */   // Label 7878: @403878
     /* 403878 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(403959), // Rule ID 6185 //
     /* 403883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403927 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403931 */     // MIs[3] Operand 1
     /* 403931 */     // No operand predicates
     /* 403931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403941 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403957 */     GIR_RootConstrainSelectedInstOperands,
     /* 403958 */     // GIR_Coverage, 6185,
     /* 403958 */     GIR_EraseRootFromParent_Done,
     /* 403959 */   // Label 7879: @403959
     /* 403959 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(404043), // Rule ID 6217 //
     /* 403964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404013 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404017 */     // MIs[3] Operand 1
     /* 404017 */     // No operand predicates
     /* 404017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404023 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 404026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404041 */     GIR_RootConstrainSelectedInstOperands,
     /* 404042 */     // GIR_Coverage, 6217,
     /* 404042 */     GIR_EraseRootFromParent_Done,
     /* 404043 */   // Label 7880: @404043
     /* 404043 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(404124), // Rule ID 6121 //
     /* 404048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404096 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404100 */     // MIs[3] Operand 1
     /* 404100 */     // No operand predicates
     /* 404100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404106 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 404109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404122 */     GIR_RootConstrainSelectedInstOperands,
     /* 404123 */     // GIR_Coverage, 6121,
     /* 404123 */     GIR_EraseRootFromParent_Done,
     /* 404124 */   // Label 7881: @404124
     /* 404124 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(404209), // Rule ID 2456 //
     /* 404129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404153 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404167 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404179 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 404198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404207 */     GIR_RootConstrainSelectedInstOperands,
     /* 404208 */     // GIR_Coverage, 2456,
     /* 404208 */     GIR_EraseRootFromParent_Done,
     /* 404209 */   // Label 7882: @404209
     /* 404209 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(404294), // Rule ID 2454 //
     /* 404214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404252 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 404252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404264 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 404270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 404283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404292 */     GIR_RootConstrainSelectedInstOperands,
     /* 404293 */     // GIR_Coverage, 2454,
     /* 404293 */     GIR_EraseRootFromParent_Done,
     /* 404294 */   // Label 7883: @404294
     /* 404294 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(404363), // Rule ID 2531 //
     /* 404299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404331 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404335 */     // MIs[2] Operand 1
     /* 404335 */     // No operand predicates
     /* 404335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404345 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404361 */     GIR_RootConstrainSelectedInstOperands,
     /* 404362 */     // GIR_Coverage, 2531,
     /* 404362 */     GIR_EraseRootFromParent_Done,
     /* 404363 */   // Label 7884: @404363
     /* 404363 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(404432), // Rule ID 6089 //
     /* 404368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404408 */     // MIs[2] Operand 1
     /* 404408 */     // No operand predicates
     /* 404408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404414 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404430 */     GIR_RootConstrainSelectedInstOperands,
     /* 404431 */     // GIR_Coverage, 6089,
     /* 404431 */     GIR_EraseRootFromParent_Done,
     /* 404432 */   // Label 7885: @404432
     /* 404432 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(404482), // Rule ID 13389 //
     /* 404437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404467 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404480 */     GIR_RootConstrainSelectedInstOperands,
     /* 404481 */     // GIR_Coverage, 13389,
     /* 404481 */     GIR_EraseRootFromParent_Done,
     /* 404482 */   // Label 7886: @404482
     /* 404482 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(404532), // Rule ID 643 //
     /* 404487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404517 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404530 */     GIR_RootConstrainSelectedInstOperands,
     /* 404531 */     // GIR_Coverage, 643,
     /* 404531 */     GIR_EraseRootFromParent_Done,
     /* 404532 */   // Label 7887: @404532
     /* 404532 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(404582), // Rule ID 655 //
     /* 404537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404567 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 404570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 404580 */     GIR_RootConstrainSelectedInstOperands,
     /* 404581 */     // GIR_Coverage, 655,
     /* 404581 */     GIR_EraseRootFromParent_Done,
     /* 404582 */   // Label 7888: @404582
     /* 404582 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(404613), // Rule ID 637 //
     /* 404587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404602 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 404607 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404611 */     GIR_RootConstrainSelectedInstOperands,
     /* 404612 */     // GIR_Coverage, 637,
     /* 404612 */     GIR_Done,
     /* 404613 */   // Label 7889: @404613
     /* 404613 */   GIM_Reject,
     /* 404614 */ // Label 7861: @404614
     /* 404614 */ GIM_Reject,
     /* 404615 */ // Label 7853: @404615
     /* 404615 */ GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(407544),
     /* 404620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 404626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 404629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404633 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(404783), // Rule ID 4910 //
     /* 404638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404687 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 404695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 404703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404710 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404722 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404750 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 404769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 404781 */     GIR_RootConstrainSelectedInstOperands,
     /* 404782 */     // GIR_Coverage, 4910,
     /* 404782 */     GIR_EraseRootFromParent_Done,
     /* 404783 */   // Label 7891: @404783
     /* 404783 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(404930), // Rule ID 4874 //
     /* 404788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404812 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 404832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404840 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404844 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404849 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404859 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404871 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404877 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404899 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404928 */     GIR_RootConstrainSelectedInstOperands,
     /* 404929 */     // GIR_Coverage, 4874,
     /* 404929 */     GIR_EraseRootFromParent_Done,
     /* 404930 */   // Label 7892: @404930
     /* 404930 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(405077), // Rule ID 13963 //
     /* 404935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404971 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404983 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404987 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404991 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404996 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 405000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405006 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 405009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405018 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405029 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405046 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 405073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405075 */     GIR_RootConstrainSelectedInstOperands,
     /* 405076 */     // GIR_Coverage, 13963,
     /* 405076 */     GIR_EraseRootFromParent_Done,
     /* 405077 */   // Label 7893: @405077
     /* 405077 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(405208), // Rule ID 6139 //
     /* 405082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405106 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 405126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405134 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405138 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405143 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 405147 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405151 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405155 */     // MIs[4] Operand 1
     /* 405155 */     // No operand predicates
     /* 405155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405159 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405161 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405173 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 405203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 405206 */     GIR_RootConstrainSelectedInstOperands,
     /* 405207 */     // GIR_Coverage, 6139,
     /* 405207 */     GIR_EraseRootFromParent_Done,
     /* 405208 */   // Label 7894: @405208
     /* 405208 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(405339), // Rule ID 6171 //
     /* 405213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405249 */     // MIs[2] Operand 1
     /* 405249 */     // No operand predicates
     /* 405249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405257 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 405261 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 405265 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405269 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405273 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 405277 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405282 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 405286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405290 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405292 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405337 */     GIR_RootConstrainSelectedInstOperands,
     /* 405338 */     // GIR_Coverage, 6171,
     /* 405338 */     GIR_EraseRootFromParent_Done,
     /* 405339 */   // Label 7895: @405339
     /* 405339 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(405470), // Rule ID 6235 //
     /* 405344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405380 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405400 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405405 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 405409 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405413 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405417 */     // MIs[4] Operand 1
     /* 405417 */     // No operand predicates
     /* 405417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405421 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405423 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405435 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 405465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 405468 */     GIR_RootConstrainSelectedInstOperands,
     /* 405469 */     // GIR_Coverage, 6235,
     /* 405469 */     GIR_EraseRootFromParent_Done,
     /* 405470 */   // Label 7896: @405470
     /* 405470 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(405601), // Rule ID 6203 //
     /* 405475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405519 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405523 */     // MIs[3] Operand 1
     /* 405523 */     // No operand predicates
     /* 405523 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 405527 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405531 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405535 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 405539 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405544 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 405548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405552 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405554 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405566 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405599 */     GIR_RootConstrainSelectedInstOperands,
     /* 405600 */     // GIR_Coverage, 6203,
     /* 405600 */     GIR_EraseRootFromParent_Done,
     /* 405601 */   // Label 7897: @405601
     /* 405601 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(405736), // Rule ID 2464 //
     /* 405606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405630 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405655 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405665 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 405668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405677 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 405732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405734 */     GIR_RootConstrainSelectedInstOperands,
     /* 405735 */     // GIR_Coverage, 2464,
     /* 405735 */     GIR_EraseRootFromParent_Done,
     /* 405736 */   // Label 7898: @405736
     /* 405736 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(405855), // Rule ID 6107 //
     /* 405741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405765 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405802 */     // MIs[3] Operand 1
     /* 405802 */     // No operand predicates
     /* 405802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405808 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405853 */     GIR_RootConstrainSelectedInstOperands,
     /* 405854 */     // GIR_Coverage, 6107,
     /* 405854 */     GIR_EraseRootFromParent_Done,
     /* 405855 */   // Label 7899: @405855
     /* 405855 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(405974), // Rule ID 2549 //
     /* 405860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405896 */     // MIs[2] Operand 1
     /* 405896 */     // No operand predicates
     /* 405896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405917 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 405921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405927 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405939 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405972 */     GIR_RootConstrainSelectedInstOperands,
     /* 405973 */     // GIR_Coverage, 2549,
     /* 405973 */     GIR_EraseRootFromParent_Done,
     /* 405974 */   // Label 7900: @405974
     /* 405974 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(406074), // Rule ID 4872 //
     /* 405979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406030 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406042 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406072 */     GIR_RootConstrainSelectedInstOperands,
     /* 406073 */     // GIR_Coverage, 4872,
     /* 406073 */     GIR_EraseRootFromParent_Done,
     /* 406074 */   // Label 7901: @406074
     /* 406074 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(406174), // Rule ID 4908 //
     /* 406079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406103 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 406115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406130 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406142 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 406161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 406168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 406172 */     GIR_RootConstrainSelectedInstOperands,
     /* 406173 */     // GIR_Coverage, 4908,
     /* 406173 */     GIR_EraseRootFromParent_Done,
     /* 406174 */   // Label 7902: @406174
     /* 406174 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(406271), // Rule ID 13959 //
     /* 406179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406215 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406229 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406241 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406269 */     GIR_RootConstrainSelectedInstOperands,
     /* 406270 */     // GIR_Coverage, 13959,
     /* 406270 */     GIR_EraseRootFromParent_Done,
     /* 406271 */   // Label 7903: @406271
     /* 406271 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(406371), // Rule ID 13961 //
     /* 406276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406317 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406327 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406339 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406369 */     GIR_RootConstrainSelectedInstOperands,
     /* 406370 */     // GIR_Coverage, 13961,
     /* 406370 */     GIR_EraseRootFromParent_Done,
     /* 406371 */   // Label 7904: @406371
     /* 406371 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(406471), // Rule ID 4906 //
     /* 406376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406404 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 406412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406427 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 406458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 406469 */     GIR_RootConstrainSelectedInstOperands,
     /* 406470 */     // GIR_Coverage, 4906,
     /* 406470 */     GIR_EraseRootFromParent_Done,
     /* 406471 */   // Label 7905: @406471
     /* 406471 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(406568), // Rule ID 4870 //
     /* 406476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406516 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406526 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406538 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406566 */     GIR_RootConstrainSelectedInstOperands,
     /* 406567 */     // GIR_Coverage, 4870,
     /* 406567 */     GIR_EraseRootFromParent_Done,
     /* 406568 */   // Label 7906: @406568
     /* 406568 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(406646), // Rule ID 6257 //
     /* 406573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 406610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406614 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406618 */     // MIs[3] Operand 1
     /* 406618 */     // No operand predicates
     /* 406618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406628 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406644 */     GIR_RootConstrainSelectedInstOperands,
     /* 406645 */     // GIR_Coverage, 6257,
     /* 406645 */     GIR_EraseRootFromParent_Done,
     /* 406646 */   // Label 7907: @406646
     /* 406646 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(406730), // Rule ID 6169 //
     /* 406651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406683 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406687 */     // MIs[2] Operand 1
     /* 406687 */     // No operand predicates
     /* 406687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 406699 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406710 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 406721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406728 */     GIR_RootConstrainSelectedInstOperands,
     /* 406729 */     // GIR_Coverage, 6169,
     /* 406729 */     GIR_EraseRootFromParent_Done,
     /* 406730 */   // Label 7908: @406730
     /* 406730 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(406811), // Rule ID 6201 //
     /* 406735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406783 */     // MIs[3] Operand 1
     /* 406783 */     // No operand predicates
     /* 406783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406793 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406809 */     GIR_RootConstrainSelectedInstOperands,
     /* 406810 */     // GIR_Coverage, 6201,
     /* 406810 */     GIR_EraseRootFromParent_Done,
     /* 406811 */   // Label 7909: @406811
     /* 406811 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(406895), // Rule ID 6233 //
     /* 406816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406865 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406869 */     // MIs[3] Operand 1
     /* 406869 */     // No operand predicates
     /* 406869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406875 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406893 */     GIR_RootConstrainSelectedInstOperands,
     /* 406894 */     // GIR_Coverage, 6233,
     /* 406894 */     GIR_EraseRootFromParent_Done,
     /* 406895 */   // Label 7910: @406895
     /* 406895 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(406973), // Rule ID 6279 //
     /* 406900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 406941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406945 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406949 */     // MIs[3] Operand 1
     /* 406949 */     // No operand predicates
     /* 406949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406955 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406971 */     GIR_RootConstrainSelectedInstOperands,
     /* 406972 */     // GIR_Coverage, 6279,
     /* 406972 */     GIR_EraseRootFromParent_Done,
     /* 406973 */   // Label 7911: @406973
     /* 406973 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(407054), // Rule ID 6137 //
     /* 406978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407026 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407030 */     // MIs[3] Operand 1
     /* 407030 */     // No operand predicates
     /* 407030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407036 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 407039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407052 */     GIR_RootConstrainSelectedInstOperands,
     /* 407053 */     // GIR_Coverage, 6137,
     /* 407053 */     GIR_EraseRootFromParent_Done,
     /* 407054 */   // Label 7912: @407054
     /* 407054 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(407139), // Rule ID 2462 //
     /* 407059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407097 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407109 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 407128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407137 */     GIR_RootConstrainSelectedInstOperands,
     /* 407138 */     // GIR_Coverage, 2462,
     /* 407138 */     GIR_EraseRootFromParent_Done,
     /* 407139 */   // Label 7913: @407139
     /* 407139 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(407224), // Rule ID 2460 //
     /* 407144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407172 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407182 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407194 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 407213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407222 */     GIR_RootConstrainSelectedInstOperands,
     /* 407223 */     // GIR_Coverage, 2460,
     /* 407223 */     GIR_EraseRootFromParent_Done,
     /* 407224 */   // Label 7914: @407224
     /* 407224 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(407293), // Rule ID 2547 //
     /* 407229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407261 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407265 */     // MIs[2] Operand 1
     /* 407265 */     // No operand predicates
     /* 407265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407275 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 407278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407291 */     GIR_RootConstrainSelectedInstOperands,
     /* 407292 */     // GIR_Coverage, 2547,
     /* 407292 */     GIR_EraseRootFromParent_Done,
     /* 407293 */   // Label 7915: @407293
     /* 407293 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(407362), // Rule ID 6105 //
     /* 407298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407334 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407338 */     // MIs[2] Operand 1
     /* 407338 */     // No operand predicates
     /* 407338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407344 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 407347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407360 */     GIR_RootConstrainSelectedInstOperands,
     /* 407361 */     // GIR_Coverage, 6105,
     /* 407361 */     GIR_EraseRootFromParent_Done,
     /* 407362 */   // Label 7916: @407362
     /* 407362 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(407412), // Rule ID 13391 //
     /* 407367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407397 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407410 */     GIR_RootConstrainSelectedInstOperands,
     /* 407411 */     // GIR_Coverage, 13391,
     /* 407411 */     GIR_EraseRootFromParent_Done,
     /* 407412 */   // Label 7917: @407412
     /* 407412 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(407462), // Rule ID 645 //
     /* 407417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407447 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407460 */     GIR_RootConstrainSelectedInstOperands,
     /* 407461 */     // GIR_Coverage, 645,
     /* 407461 */     GIR_EraseRootFromParent_Done,
     /* 407462 */   // Label 7918: @407462
     /* 407462 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(407512), // Rule ID 657 //
     /* 407467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 407482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407497 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 407500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 407510 */     GIR_RootConstrainSelectedInstOperands,
     /* 407511 */     // GIR_Coverage, 657,
     /* 407511 */     GIR_EraseRootFromParent_Done,
     /* 407512 */   // Label 7919: @407512
     /* 407512 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(407543), // Rule ID 639 //
     /* 407517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407532 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 407537 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407541 */     GIR_RootConstrainSelectedInstOperands,
     /* 407542 */     // GIR_Coverage, 639,
     /* 407542 */     GIR_Done,
     /* 407543 */   // Label 7920: @407543
     /* 407543 */   GIM_Reject,
     /* 407544 */ // Label 7890: @407544
     /* 407544 */ GIM_Reject,
     /* 407545 */ // Label 7854: @407545
     /* 407545 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(410474),
     /* 407550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 407553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 407556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 407559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407563 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(407713), // Rule ID 4916 //
     /* 407568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407592 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407617 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 407625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407629 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 407633 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407640 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407652 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407680 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 407699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 407711 */     GIR_RootConstrainSelectedInstOperands,
     /* 407712 */     // GIR_Coverage, 4916,
     /* 407712 */     GIR_EraseRootFromParent_Done,
     /* 407713 */   // Label 7922: @407713
     /* 407713 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(407860), // Rule ID 4880 //
     /* 407718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407742 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 407762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407774 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407779 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407789 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407801 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407829 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407858 */     GIR_RootConstrainSelectedInstOperands,
     /* 407859 */     // GIR_Coverage, 4880,
     /* 407859 */     GIR_EraseRootFromParent_Done,
     /* 407860 */   // Label 7923: @407860
     /* 407860 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(408007), // Rule ID 13969 //
     /* 407865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407901 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407926 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407936 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407948 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407976 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408005 */     GIR_RootConstrainSelectedInstOperands,
     /* 408006 */     // GIR_Coverage, 13969,
     /* 408006 */     GIR_EraseRootFromParent_Done,
     /* 408007 */   // Label 7924: @408007
     /* 408007 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(408138), // Rule ID 6143 //
     /* 408012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408036 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 408056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408064 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408073 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 408077 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408081 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408085 */     // MIs[4] Operand 1
     /* 408085 */     // No operand predicates
     /* 408085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408089 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 408091 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408103 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 408133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 408136 */     GIR_RootConstrainSelectedInstOperands,
     /* 408137 */     // GIR_Coverage, 6143,
     /* 408137 */     GIR_EraseRootFromParent_Done,
     /* 408138 */   // Label 7925: @408138
     /* 408138 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(408269), // Rule ID 6175 //
     /* 408143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408175 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408179 */     // MIs[2] Operand 1
     /* 408179 */     // No operand predicates
     /* 408179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 408191 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 408195 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408199 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408203 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 408207 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408212 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 408216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408220 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 408222 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408267 */     GIR_RootConstrainSelectedInstOperands,
     /* 408268 */     // GIR_Coverage, 6175,
     /* 408268 */     GIR_EraseRootFromParent_Done,
     /* 408269 */   // Label 7926: @408269
     /* 408269 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(408400), // Rule ID 6239 //
     /* 408274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408310 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408326 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408330 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408335 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 408339 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408343 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408347 */     // MIs[4] Operand 1
     /* 408347 */     // No operand predicates
     /* 408347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408351 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 408353 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408365 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 408395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 408398 */     GIR_RootConstrainSelectedInstOperands,
     /* 408399 */     // GIR_Coverage, 6239,
     /* 408399 */     GIR_EraseRootFromParent_Done,
     /* 408400 */   // Label 7927: @408400
     /* 408400 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(408531), // Rule ID 6207 //
     /* 408405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408449 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408453 */     // MIs[3] Operand 1
     /* 408453 */     // No operand predicates
     /* 408453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 408457 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408461 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408465 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 408469 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408474 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 408478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408482 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 408484 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408496 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408529 */     GIR_RootConstrainSelectedInstOperands,
     /* 408530 */     // GIR_Coverage, 6207,
     /* 408530 */     GIR_EraseRootFromParent_Done,
     /* 408531 */   // Label 7928: @408531
     /* 408531 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(408666), // Rule ID 2470 //
     /* 408536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408560 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408585 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408595 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408595 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408598 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408602 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408607 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408618 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408635 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408664 */     GIR_RootConstrainSelectedInstOperands,
     /* 408665 */     // GIR_Coverage, 2470,
     /* 408665 */     GIR_EraseRootFromParent_Done,
     /* 408666 */   // Label 7929: @408666
     /* 408666 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(408785), // Rule ID 6111 //
     /* 408671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408728 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408732 */     // MIs[3] Operand 1
     /* 408732 */     // No operand predicates
     /* 408732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408738 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408750 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408783 */     GIR_RootConstrainSelectedInstOperands,
     /* 408784 */     // GIR_Coverage, 6111,
     /* 408784 */     GIR_EraseRootFromParent_Done,
     /* 408785 */   // Label 7930: @408785
     /* 408785 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(408904), // Rule ID 2553 //
     /* 408790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408826 */     // MIs[2] Operand 1
     /* 408826 */     // No operand predicates
     /* 408826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408834 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408838 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408847 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 408851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408857 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408869 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408902 */     GIR_RootConstrainSelectedInstOperands,
     /* 408903 */     // GIR_Coverage, 2553,
     /* 408903 */     GIR_EraseRootFromParent_Done,
     /* 408904 */   // Label 7931: @408904
     /* 408904 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(409004), // Rule ID 4878 //
     /* 408909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408960 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408972 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409002 */     GIR_RootConstrainSelectedInstOperands,
     /* 409003 */     // GIR_Coverage, 4878,
     /* 409003 */     GIR_EraseRootFromParent_Done,
     /* 409004 */   // Label 7932: @409004
     /* 409004 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(409104), // Rule ID 4914 //
     /* 409009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 409045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 409053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409060 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 409091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 409098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 409102 */     GIR_RootConstrainSelectedInstOperands,
     /* 409103 */     // GIR_Coverage, 4914,
     /* 409103 */     GIR_EraseRootFromParent_Done,
     /* 409104 */   // Label 7933: @409104
     /* 409104 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(409201), // Rule ID 13965 //
     /* 409109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409145 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409159 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409171 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409199 */     GIR_RootConstrainSelectedInstOperands,
     /* 409200 */     // GIR_Coverage, 13965,
     /* 409200 */     GIR_EraseRootFromParent_Done,
     /* 409201 */   // Label 7934: @409201
     /* 409201 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(409301), // Rule ID 13967 //
     /* 409206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409247 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409257 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409269 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409299 */     GIR_RootConstrainSelectedInstOperands,
     /* 409300 */     // GIR_Coverage, 13967,
     /* 409300 */     GIR_EraseRootFromParent_Done,
     /* 409301 */   // Label 7935: @409301
     /* 409301 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(409401), // Rule ID 4912 //
     /* 409306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409334 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 409342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 409350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409357 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 409388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 409399 */     GIR_RootConstrainSelectedInstOperands,
     /* 409400 */     // GIR_Coverage, 4912,
     /* 409400 */     GIR_EraseRootFromParent_Done,
     /* 409401 */   // Label 7936: @409401
     /* 409401 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(409498), // Rule ID 4876 //
     /* 409406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409446 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409456 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409468 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409496 */     GIR_RootConstrainSelectedInstOperands,
     /* 409497 */     // GIR_Coverage, 4876,
     /* 409497 */     GIR_EraseRootFromParent_Done,
     /* 409498 */   // Label 7937: @409498
     /* 409498 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(409576), // Rule ID 6261 //
     /* 409503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409544 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409548 */     // MIs[3] Operand 1
     /* 409548 */     // No operand predicates
     /* 409548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409558 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409574 */     GIR_RootConstrainSelectedInstOperands,
     /* 409575 */     // GIR_Coverage, 6261,
     /* 409575 */     GIR_EraseRootFromParent_Done,
     /* 409576 */   // Label 7938: @409576
     /* 409576 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(409660), // Rule ID 6173 //
     /* 409581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409617 */     // MIs[2] Operand 1
     /* 409617 */     // No operand predicates
     /* 409617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409625 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 409629 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409640 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 409651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409658 */     GIR_RootConstrainSelectedInstOperands,
     /* 409659 */     // GIR_Coverage, 6173,
     /* 409659 */     GIR_EraseRootFromParent_Done,
     /* 409660 */   // Label 7939: @409660
     /* 409660 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(409741), // Rule ID 6205 //
     /* 409665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409709 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409713 */     // MIs[3] Operand 1
     /* 409713 */     // No operand predicates
     /* 409713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409723 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409739 */     GIR_RootConstrainSelectedInstOperands,
     /* 409740 */     // GIR_Coverage, 6205,
     /* 409740 */     GIR_EraseRootFromParent_Done,
     /* 409741 */   // Label 7940: @409741
     /* 409741 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(409825), // Rule ID 6237 //
     /* 409746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409795 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409799 */     // MIs[3] Operand 1
     /* 409799 */     // No operand predicates
     /* 409799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409805 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409823 */     GIR_RootConstrainSelectedInstOperands,
     /* 409824 */     // GIR_Coverage, 6237,
     /* 409824 */     GIR_EraseRootFromParent_Done,
     /* 409825 */   // Label 7941: @409825
     /* 409825 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(409903), // Rule ID 6283 //
     /* 409830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409875 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409879 */     // MIs[3] Operand 1
     /* 409879 */     // No operand predicates
     /* 409879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409885 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409901 */     GIR_RootConstrainSelectedInstOperands,
     /* 409902 */     // GIR_Coverage, 6283,
     /* 409902 */     GIR_EraseRootFromParent_Done,
     /* 409903 */   // Label 7942: @409903
     /* 409903 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(409984), // Rule ID 6141 //
     /* 409908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409956 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409960 */     // MIs[3] Operand 1
     /* 409960 */     // No operand predicates
     /* 409960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409966 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409982 */     GIR_RootConstrainSelectedInstOperands,
     /* 409983 */     // GIR_Coverage, 6141,
     /* 409983 */     GIR_EraseRootFromParent_Done,
     /* 409984 */   // Label 7943: @409984
     /* 409984 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(410069), // Rule ID 2468 //
     /* 409989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410027 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410039 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 410058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 410065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410067 */     GIR_RootConstrainSelectedInstOperands,
     /* 410068 */     // GIR_Coverage, 2468,
     /* 410068 */     GIR_EraseRootFromParent_Done,
     /* 410069 */   // Label 7944: @410069
     /* 410069 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(410154), // Rule ID 2466 //
     /* 410074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410112 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410124 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 410143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410152 */     GIR_RootConstrainSelectedInstOperands,
     /* 410153 */     // GIR_Coverage, 2466,
     /* 410153 */     GIR_EraseRootFromParent_Done,
     /* 410154 */   // Label 7945: @410154
     /* 410154 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(410223), // Rule ID 2551 //
     /* 410159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410191 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410195 */     // MIs[2] Operand 1
     /* 410195 */     // No operand predicates
     /* 410195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410205 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 410208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410221 */     GIR_RootConstrainSelectedInstOperands,
     /* 410222 */     // GIR_Coverage, 2551,
     /* 410222 */     GIR_EraseRootFromParent_Done,
     /* 410223 */   // Label 7946: @410223
     /* 410223 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(410292), // Rule ID 6109 //
     /* 410228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410268 */     // MIs[2] Operand 1
     /* 410268 */     // No operand predicates
     /* 410268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410274 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 410277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410290 */     GIR_RootConstrainSelectedInstOperands,
     /* 410291 */     // GIR_Coverage, 6109,
     /* 410291 */     GIR_EraseRootFromParent_Done,
     /* 410292 */   // Label 7947: @410292
     /* 410292 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(410342), // Rule ID 13393 //
     /* 410297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410327 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410340 */     GIR_RootConstrainSelectedInstOperands,
     /* 410341 */     // GIR_Coverage, 13393,
     /* 410341 */     GIR_EraseRootFromParent_Done,
     /* 410342 */   // Label 7948: @410342
     /* 410342 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(410392), // Rule ID 647 //
     /* 410347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410377 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410390 */     GIR_RootConstrainSelectedInstOperands,
     /* 410391 */     // GIR_Coverage, 647,
     /* 410391 */     GIR_EraseRootFromParent_Done,
     /* 410392 */   // Label 7949: @410392
     /* 410392 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(410442), // Rule ID 659 //
     /* 410397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 410412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410427 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 410430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 410436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 410440 */     GIR_RootConstrainSelectedInstOperands,
     /* 410441 */     // GIR_Coverage, 659,
     /* 410441 */     GIR_EraseRootFromParent_Done,
     /* 410442 */   // Label 7950: @410442
     /* 410442 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(410473), // Rule ID 641 //
     /* 410447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410462 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 410467 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 410471 */     GIR_RootConstrainSelectedInstOperands,
     /* 410472 */     // GIR_Coverage, 641,
     /* 410472 */     GIR_Done,
     /* 410473 */   // Label 7951: @410473
     /* 410473 */   GIM_Reject,
     /* 410474 */ // Label 7921: @410474
     /* 410474 */ GIM_Reject,
     /* 410475 */ // Label 7855: @410475
     /* 410475 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(411995),
     /* 410480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410486 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 410489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410493 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(410571), // Rule ID 6241 //
     /* 410498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410539 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410543 */     // MIs[3] Operand 1
     /* 410543 */     // No operand predicates
     /* 410543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410553 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410569 */     GIR_RootConstrainSelectedInstOperands,
     /* 410570 */     // GIR_Coverage, 6241,
     /* 410570 */     GIR_EraseRootFromParent_Done,
     /* 410571 */   // Label 7953: @410571
     /* 410571 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(410655), // Rule ID 6157 //
     /* 410576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410612 */     // MIs[2] Operand 1
     /* 410612 */     // No operand predicates
     /* 410612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410620 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410635 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 410646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410653 */     GIR_RootConstrainSelectedInstOperands,
     /* 410654 */     // GIR_Coverage, 6157,
     /* 410654 */     GIR_EraseRootFromParent_Done,
     /* 410655 */   // Label 7954: @410655
     /* 410655 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(410736), // Rule ID 6189 //
     /* 410660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410704 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410708 */     // MIs[3] Operand 1
     /* 410708 */     // No operand predicates
     /* 410708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410718 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410734 */     GIR_RootConstrainSelectedInstOperands,
     /* 410735 */     // GIR_Coverage, 6189,
     /* 410735 */     GIR_EraseRootFromParent_Done,
     /* 410736 */   // Label 7955: @410736
     /* 410736 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(410820), // Rule ID 6221 //
     /* 410741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410790 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410794 */     // MIs[3] Operand 1
     /* 410794 */     // No operand predicates
     /* 410794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410800 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410818 */     GIR_RootConstrainSelectedInstOperands,
     /* 410819 */     // GIR_Coverage, 6221,
     /* 410819 */     GIR_EraseRootFromParent_Done,
     /* 410820 */   // Label 7956: @410820
     /* 410820 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(410898), // Rule ID 6263 //
     /* 410825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410870 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410874 */     // MIs[3] Operand 1
     /* 410874 */     // No operand predicates
     /* 410874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410880 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410896 */     GIR_RootConstrainSelectedInstOperands,
     /* 410897 */     // GIR_Coverage, 6263,
     /* 410897 */     GIR_EraseRootFromParent_Done,
     /* 410898 */   // Label 7957: @410898
     /* 410898 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(410979), // Rule ID 6125 //
     /* 410903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410951 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410955 */     // MIs[3] Operand 1
     /* 410955 */     // No operand predicates
     /* 410955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410961 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410977 */     GIR_RootConstrainSelectedInstOperands,
     /* 410978 */     // GIR_Coverage, 6125,
     /* 410978 */     GIR_EraseRootFromParent_Done,
     /* 410979 */   // Label 7958: @410979
     /* 410979 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(411048), // Rule ID 2535 //
     /* 410984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411020 */     // MIs[2] Operand 1
     /* 411020 */     // No operand predicates
     /* 411020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411030 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 411033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411046 */     GIR_RootConstrainSelectedInstOperands,
     /* 411047 */     // GIR_Coverage, 2535,
     /* 411047 */     GIR_EraseRootFromParent_Done,
     /* 411048 */   // Label 7959: @411048
     /* 411048 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(411117), // Rule ID 6093 //
     /* 411053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411089 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411093 */     // MIs[2] Operand 1
     /* 411093 */     // No operand predicates
     /* 411093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411099 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 411102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411115 */     GIR_RootConstrainSelectedInstOperands,
     /* 411116 */     // GIR_Coverage, 6093,
     /* 411116 */     GIR_EraseRootFromParent_Done,
     /* 411117 */   // Label 7960: @411117
     /* 411117 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(411210), // Rule ID 6245 //
     /* 411122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411161 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411173 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411180 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411208 */     GIR_RootConstrainSelectedInstOperands,
     /* 411209 */     // GIR_Coverage, 6245,
     /* 411209 */     GIR_EraseRootFromParent_Done,
     /* 411210 */   // Label 7961: @411210
     /* 411210 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(411309), // Rule ID 6159 //
     /* 411215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411258 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411277 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 411301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411307 */     GIR_RootConstrainSelectedInstOperands,
     /* 411308 */     // GIR_Coverage, 6159,
     /* 411308 */     GIR_EraseRootFromParent_Done,
     /* 411309 */   // Label 7962: @411309
     /* 411309 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(411405), // Rule ID 6191 //
     /* 411314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411356 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411375 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411403 */     GIR_RootConstrainSelectedInstOperands,
     /* 411404 */     // GIR_Coverage, 6191,
     /* 411404 */     GIR_EraseRootFromParent_Done,
     /* 411405 */   // Label 7963: @411405
     /* 411405 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(411504), // Rule ID 6223 //
     /* 411410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411453 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411472 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411502 */     GIR_RootConstrainSelectedInstOperands,
     /* 411503 */     // GIR_Coverage, 6223,
     /* 411503 */     GIR_EraseRootFromParent_Done,
     /* 411504 */   // Label 7964: @411504
     /* 411504 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(411597), // Rule ID 6267 //
     /* 411509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411548 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411595 */     GIR_RootConstrainSelectedInstOperands,
     /* 411596 */     // GIR_Coverage, 6267,
     /* 411596 */     GIR_EraseRootFromParent_Done,
     /* 411597 */   // Label 7965: @411597
     /* 411597 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(411693), // Rule ID 6127 //
     /* 411602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411644 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411656 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411663 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411691 */     GIR_RootConstrainSelectedInstOperands,
     /* 411692 */     // GIR_Coverage, 6127,
     /* 411692 */     GIR_EraseRootFromParent_Done,
     /* 411693 */   // Label 7966: @411693
     /* 411693 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(411777), // Rule ID 2537 //
     /* 411698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411728 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 411763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411775 */     GIR_RootConstrainSelectedInstOperands,
     /* 411776 */     // GIR_Coverage, 2537,
     /* 411776 */     GIR_EraseRootFromParent_Done,
     /* 411777 */   // Label 7967: @411777
     /* 411777 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(411827), // Rule ID 13423 //
     /* 411782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411812 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 411815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411825 */     GIR_RootConstrainSelectedInstOperands,
     /* 411826 */     // GIR_Coverage, 13423,
     /* 411826 */     GIR_EraseRootFromParent_Done,
     /* 411827 */   // Label 7968: @411827
     /* 411827 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(411911), // Rule ID 6095 //
     /* 411832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411862 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 411897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411909 */     GIR_RootConstrainSelectedInstOperands,
     /* 411910 */     // GIR_Coverage, 6095,
     /* 411910 */     GIR_EraseRootFromParent_Done,
     /* 411911 */   // Label 7969: @411911
     /* 411911 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411961), // Rule ID 1307 //
     /* 411916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411946 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 411949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411959 */     GIR_RootConstrainSelectedInstOperands,
     /* 411960 */     // GIR_Coverage, 1307,
     /* 411960 */     GIR_EraseRootFromParent_Done,
     /* 411961 */   // Label 7970: @411961
     /* 411961 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(411994), // Rule ID 1297 //
     /* 411966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411981 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 411984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 411992 */     GIR_RootConstrainSelectedInstOperands,
     /* 411993 */     // GIR_Coverage, 1297,
     /* 411993 */     GIR_EraseRootFromParent_Done,
     /* 411994 */   // Label 7971: @411994
     /* 411994 */   GIM_Reject,
     /* 411995 */ // Label 7952: @411995
     /* 411995 */ GIM_Reject,
     /* 411996 */ // Label 7856: @411996
     /* 411996 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(413516),
     /* 412001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 412007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 412010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412014 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(412092), // Rule ID 6253 //
     /* 412019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 412056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412060 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412064 */     // MIs[3] Operand 1
     /* 412064 */     // No operand predicates
     /* 412064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412074 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412090 */     GIR_RootConstrainSelectedInstOperands,
     /* 412091 */     // GIR_Coverage, 6253,
     /* 412091 */     GIR_EraseRootFromParent_Done,
     /* 412092 */   // Label 7973: @412092
     /* 412092 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(412176), // Rule ID 6165 //
     /* 412097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412129 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412133 */     // MIs[2] Operand 1
     /* 412133 */     // No operand predicates
     /* 412133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 412137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412156 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 412167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412174 */     GIR_RootConstrainSelectedInstOperands,
     /* 412175 */     // GIR_Coverage, 6165,
     /* 412175 */     GIR_EraseRootFromParent_Done,
     /* 412176 */   // Label 7974: @412176
     /* 412176 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(412257), // Rule ID 6197 //
     /* 412181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412225 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412229 */     // MIs[3] Operand 1
     /* 412229 */     // No operand predicates
     /* 412229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412239 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412255 */     GIR_RootConstrainSelectedInstOperands,
     /* 412256 */     // GIR_Coverage, 6197,
     /* 412256 */     GIR_EraseRootFromParent_Done,
     /* 412257 */   // Label 7975: @412257
     /* 412257 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(412341), // Rule ID 6229 //
     /* 412262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412311 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412315 */     // MIs[3] Operand 1
     /* 412315 */     // No operand predicates
     /* 412315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412321 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412339 */     GIR_RootConstrainSelectedInstOperands,
     /* 412340 */     // GIR_Coverage, 6229,
     /* 412340 */     GIR_EraseRootFromParent_Done,
     /* 412341 */   // Label 7976: @412341
     /* 412341 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(412419), // Rule ID 6275 //
     /* 412346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 412387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412391 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412395 */     // MIs[3] Operand 1
     /* 412395 */     // No operand predicates
     /* 412395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412401 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412417 */     GIR_RootConstrainSelectedInstOperands,
     /* 412418 */     // GIR_Coverage, 6275,
     /* 412418 */     GIR_EraseRootFromParent_Done,
     /* 412419 */   // Label 7977: @412419
     /* 412419 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(412500), // Rule ID 6133 //
     /* 412424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412472 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412476 */     // MIs[3] Operand 1
     /* 412476 */     // No operand predicates
     /* 412476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412482 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412498 */     GIR_RootConstrainSelectedInstOperands,
     /* 412499 */     // GIR_Coverage, 6133,
     /* 412499 */     GIR_EraseRootFromParent_Done,
     /* 412500 */   // Label 7978: @412500
     /* 412500 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(412569), // Rule ID 2543 //
     /* 412505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412537 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412541 */     // MIs[2] Operand 1
     /* 412541 */     // No operand predicates
     /* 412541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412551 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412567 */     GIR_RootConstrainSelectedInstOperands,
     /* 412568 */     // GIR_Coverage, 2543,
     /* 412568 */     GIR_EraseRootFromParent_Done,
     /* 412569 */   // Label 7979: @412569
     /* 412569 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(412638), // Rule ID 6101 //
     /* 412574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412614 */     // MIs[2] Operand 1
     /* 412614 */     // No operand predicates
     /* 412614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412620 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412636 */     GIR_RootConstrainSelectedInstOperands,
     /* 412637 */     // GIR_Coverage, 6101,
     /* 412637 */     GIR_EraseRootFromParent_Done,
     /* 412638 */   // Label 7980: @412638
     /* 412638 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(412731), // Rule ID 6255 //
     /* 412643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412682 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412729 */     GIR_RootConstrainSelectedInstOperands,
     /* 412730 */     // GIR_Coverage, 6255,
     /* 412730 */     GIR_EraseRootFromParent_Done,
     /* 412731 */   // Label 7981: @412731
     /* 412731 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(412830), // Rule ID 6167 //
     /* 412736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412779 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 412822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412828 */     GIR_RootConstrainSelectedInstOperands,
     /* 412829 */     // GIR_Coverage, 6167,
     /* 412829 */     GIR_EraseRootFromParent_Done,
     /* 412830 */   // Label 7982: @412830
     /* 412830 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(412926), // Rule ID 6199 //
     /* 412835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412877 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412896 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412924 */     GIR_RootConstrainSelectedInstOperands,
     /* 412925 */     // GIR_Coverage, 6199,
     /* 412925 */     GIR_EraseRootFromParent_Done,
     /* 412926 */   // Label 7983: @412926
     /* 412926 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(413025), // Rule ID 6231 //
     /* 412931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412974 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413023 */     GIR_RootConstrainSelectedInstOperands,
     /* 413024 */     // GIR_Coverage, 6231,
     /* 413024 */     GIR_EraseRootFromParent_Done,
     /* 413025 */   // Label 7984: @413025
     /* 413025 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(413118), // Rule ID 6277 //
     /* 413030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 413046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 413058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413069 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413116 */     GIR_RootConstrainSelectedInstOperands,
     /* 413117 */     // GIR_Coverage, 6277,
     /* 413117 */     GIR_EraseRootFromParent_Done,
     /* 413118 */   // Label 7985: @413118
     /* 413118 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(413214), // Rule ID 6135 //
     /* 413123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 413154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413165 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413212 */     GIR_RootConstrainSelectedInstOperands,
     /* 413213 */     // GIR_Coverage, 6135,
     /* 413213 */     GIR_EraseRootFromParent_Done,
     /* 413214 */   // Label 7986: @413214
     /* 413214 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(413298), // Rule ID 2545 //
     /* 413219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 413234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413249 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413261 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413268 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 413284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413296 */     GIR_RootConstrainSelectedInstOperands,
     /* 413297 */     // GIR_Coverage, 2545,
     /* 413297 */     GIR_EraseRootFromParent_Done,
     /* 413298 */   // Label 7987: @413298
     /* 413298 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(413348), // Rule ID 13427 //
     /* 413303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413333 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 413336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413346 */     GIR_RootConstrainSelectedInstOperands,
     /* 413347 */     // GIR_Coverage, 13427,
     /* 413347 */     GIR_EraseRootFromParent_Done,
     /* 413348 */   // Label 7988: @413348
     /* 413348 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(413432), // Rule ID 6103 //
     /* 413353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 413372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413383 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 413418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413430 */     GIR_RootConstrainSelectedInstOperands,
     /* 413431 */     // GIR_Coverage, 6103,
     /* 413431 */     GIR_EraseRootFromParent_Done,
     /* 413432 */   // Label 7989: @413432
     /* 413432 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(413482), // Rule ID 1311 //
     /* 413437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413467 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 413470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413480 */     GIR_RootConstrainSelectedInstOperands,
     /* 413481 */     // GIR_Coverage, 1311,
     /* 413481 */     GIR_EraseRootFromParent_Done,
     /* 413482 */   // Label 7990: @413482
     /* 413482 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(413515), // Rule ID 1301 //
     /* 413487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413502 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 413505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 413513 */     GIR_RootConstrainSelectedInstOperands,
     /* 413514 */     // GIR_Coverage, 1301,
     /* 413514 */     GIR_EraseRootFromParent_Done,
     /* 413515 */   // Label 7991: @413515
     /* 413515 */   GIM_Reject,
     /* 413516 */ // Label 7972: @413516
     /* 413516 */ GIM_Reject,
     /* 413517 */ // Label 7857: @413517
     /* 413517 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(414695),
     /* 413522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 413528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 413531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413535 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(413619), // Rule ID 6149 //
     /* 413540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413576 */     // MIs[2] Operand 1
     /* 413576 */     // No operand predicates
     /* 413576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 413580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413588 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413599 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 413610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413617 */     GIR_RootConstrainSelectedInstOperands,
     /* 413618 */     // GIR_Coverage, 6149,
     /* 413618 */     GIR_EraseRootFromParent_Done,
     /* 413619 */   // Label 7993: @413619
     /* 413619 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(413700), // Rule ID 6181 //
     /* 413624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413668 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413672 */     // MIs[3] Operand 1
     /* 413672 */     // No operand predicates
     /* 413672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413682 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413698 */     GIR_RootConstrainSelectedInstOperands,
     /* 413699 */     // GIR_Coverage, 6181,
     /* 413699 */     GIR_EraseRootFromParent_Done,
     /* 413700 */   // Label 7994: @413700
     /* 413700 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413784), // Rule ID 6213 //
     /* 413705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413754 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413758 */     // MIs[3] Operand 1
     /* 413758 */     // No operand predicates
     /* 413758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413764 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413782 */     GIR_RootConstrainSelectedInstOperands,
     /* 413783 */     // GIR_Coverage, 6213,
     /* 413783 */     GIR_EraseRootFromParent_Done,
     /* 413784 */   // Label 7995: @413784
     /* 413784 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(413865), // Rule ID 6117 //
     /* 413789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413841 */     // MIs[3] Operand 1
     /* 413841 */     // No operand predicates
     /* 413841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413847 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413863 */     GIR_RootConstrainSelectedInstOperands,
     /* 413864 */     // GIR_Coverage, 6117,
     /* 413864 */     GIR_EraseRootFromParent_Done,
     /* 413865 */   // Label 7996: @413865
     /* 413865 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(413934), // Rule ID 2527 //
     /* 413870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413906 */     // MIs[2] Operand 1
     /* 413906 */     // No operand predicates
     /* 413906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413916 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413932 */     GIR_RootConstrainSelectedInstOperands,
     /* 413933 */     // GIR_Coverage, 2527,
     /* 413933 */     GIR_EraseRootFromParent_Done,
     /* 413934 */   // Label 7997: @413934
     /* 413934 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(414003), // Rule ID 6085 //
     /* 413939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413975 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413979 */     // MIs[2] Operand 1
     /* 413979 */     // No operand predicates
     /* 413979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413985 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414001 */     GIR_RootConstrainSelectedInstOperands,
     /* 414002 */     // GIR_Coverage, 6085,
     /* 414002 */     GIR_EraseRootFromParent_Done,
     /* 414003 */   // Label 7998: @414003
     /* 414003 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(414102), // Rule ID 6151 //
     /* 414008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414051 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 414094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414100 */     GIR_RootConstrainSelectedInstOperands,
     /* 414101 */     // GIR_Coverage, 6151,
     /* 414101 */     GIR_EraseRootFromParent_Done,
     /* 414102 */   // Label 7999: @414102
     /* 414102 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(414198), // Rule ID 6183 //
     /* 414107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414149 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414161 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414196 */     GIR_RootConstrainSelectedInstOperands,
     /* 414197 */     // GIR_Coverage, 6183,
     /* 414197 */     GIR_EraseRootFromParent_Done,
     /* 414198 */   // Label 8000: @414198
     /* 414198 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(414297), // Rule ID 6215 //
     /* 414203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414246 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414295 */     GIR_RootConstrainSelectedInstOperands,
     /* 414296 */     // GIR_Coverage, 6215,
     /* 414296 */     GIR_EraseRootFromParent_Done,
     /* 414297 */   // Label 8001: @414297
     /* 414297 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(414393), // Rule ID 6119 //
     /* 414302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414344 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414391 */     GIR_RootConstrainSelectedInstOperands,
     /* 414392 */     // GIR_Coverage, 6119,
     /* 414392 */     GIR_EraseRootFromParent_Done,
     /* 414393 */   // Label 8002: @414393
     /* 414393 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(414477), // Rule ID 2529 //
     /* 414398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414428 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414447 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 414463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414475 */     GIR_RootConstrainSelectedInstOperands,
     /* 414476 */     // GIR_Coverage, 2529,
     /* 414476 */     GIR_EraseRootFromParent_Done,
     /* 414477 */   // Label 8003: @414477
     /* 414477 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(414527), // Rule ID 13419 //
     /* 414482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414512 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 414515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414525 */     GIR_RootConstrainSelectedInstOperands,
     /* 414526 */     // GIR_Coverage, 13419,
     /* 414526 */     GIR_EraseRootFromParent_Done,
     /* 414527 */   // Label 8004: @414527
     /* 414527 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(414611), // Rule ID 6087 //
     /* 414532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414562 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414574 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 414597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414609 */     GIR_RootConstrainSelectedInstOperands,
     /* 414610 */     // GIR_Coverage, 6087,
     /* 414610 */     GIR_EraseRootFromParent_Done,
     /* 414611 */   // Label 8005: @414611
     /* 414611 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(414661), // Rule ID 1303 //
     /* 414616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414646 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 414649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414659 */     GIR_RootConstrainSelectedInstOperands,
     /* 414660 */     // GIR_Coverage, 1303,
     /* 414660 */     GIR_EraseRootFromParent_Done,
     /* 414661 */   // Label 8006: @414661
     /* 414661 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(414694), // Rule ID 1293 //
     /* 414666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414681 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 414684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 414692 */     GIR_RootConstrainSelectedInstOperands,
     /* 414693 */     // GIR_Coverage, 1293,
     /* 414693 */     GIR_EraseRootFromParent_Done,
     /* 414694 */   // Label 8007: @414694
     /* 414694 */   GIM_Reject,
     /* 414695 */ // Label 7992: @414695
     /* 414695 */ GIM_Reject,
     /* 414696 */ // Label 7858: @414696
     /* 414696 */ GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(416216),
     /* 414701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 414707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 414710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414714 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(414792), // Rule ID 6247 //
     /* 414719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 414756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414760 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414764 */     // MIs[3] Operand 1
     /* 414764 */     // No operand predicates
     /* 414764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414774 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414790 */     GIR_RootConstrainSelectedInstOperands,
     /* 414791 */     // GIR_Coverage, 6247,
     /* 414791 */     GIR_EraseRootFromParent_Done,
     /* 414792 */   // Label 8009: @414792
     /* 414792 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(414876), // Rule ID 6161 //
     /* 414797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414829 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414833 */     // MIs[2] Operand 1
     /* 414833 */     // No operand predicates
     /* 414833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 414837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414841 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414845 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414856 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 414867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414874 */     GIR_RootConstrainSelectedInstOperands,
     /* 414875 */     // GIR_Coverage, 6161,
     /* 414875 */     GIR_EraseRootFromParent_Done,
     /* 414876 */   // Label 8010: @414876
     /* 414876 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(414957), // Rule ID 6193 //
     /* 414881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414925 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414929 */     // MIs[3] Operand 1
     /* 414929 */     // No operand predicates
     /* 414929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414939 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414955 */     GIR_RootConstrainSelectedInstOperands,
     /* 414956 */     // GIR_Coverage, 6193,
     /* 414956 */     GIR_EraseRootFromParent_Done,
     /* 414957 */   // Label 8011: @414957
     /* 414957 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(415041), // Rule ID 6225 //
     /* 414962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415011 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415015 */     // MIs[3] Operand 1
     /* 415015 */     // No operand predicates
     /* 415015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415021 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415039 */     GIR_RootConstrainSelectedInstOperands,
     /* 415040 */     // GIR_Coverage, 6225,
     /* 415040 */     GIR_EraseRootFromParent_Done,
     /* 415041 */   // Label 8012: @415041
     /* 415041 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(415119), // Rule ID 6269 //
     /* 415046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 415087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415091 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415095 */     // MIs[3] Operand 1
     /* 415095 */     // No operand predicates
     /* 415095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415101 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415117 */     GIR_RootConstrainSelectedInstOperands,
     /* 415118 */     // GIR_Coverage, 6269,
     /* 415118 */     GIR_EraseRootFromParent_Done,
     /* 415119 */   // Label 8013: @415119
     /* 415119 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(415200), // Rule ID 6129 //
     /* 415124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415172 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415176 */     // MIs[3] Operand 1
     /* 415176 */     // No operand predicates
     /* 415176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415182 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415198 */     GIR_RootConstrainSelectedInstOperands,
     /* 415199 */     // GIR_Coverage, 6129,
     /* 415199 */     GIR_EraseRootFromParent_Done,
     /* 415200 */   // Label 8014: @415200
     /* 415200 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(415269), // Rule ID 2539 //
     /* 415205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415241 */     // MIs[2] Operand 1
     /* 415241 */     // No operand predicates
     /* 415241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415251 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415267 */     GIR_RootConstrainSelectedInstOperands,
     /* 415268 */     // GIR_Coverage, 2539,
     /* 415268 */     GIR_EraseRootFromParent_Done,
     /* 415269 */   // Label 8015: @415269
     /* 415269 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(415338), // Rule ID 6097 //
     /* 415274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415314 */     // MIs[2] Operand 1
     /* 415314 */     // No operand predicates
     /* 415314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415320 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415336 */     GIR_RootConstrainSelectedInstOperands,
     /* 415337 */     // GIR_Coverage, 6097,
     /* 415337 */     GIR_EraseRootFromParent_Done,
     /* 415338 */   // Label 8016: @415338
     /* 415338 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(415431), // Rule ID 6251 //
     /* 415343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415382 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415394 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415401 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415429 */     GIR_RootConstrainSelectedInstOperands,
     /* 415430 */     // GIR_Coverage, 6251,
     /* 415430 */     GIR_EraseRootFromParent_Done,
     /* 415431 */   // Label 8017: @415431
     /* 415431 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(415530), // Rule ID 6163 //
     /* 415436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415479 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415528 */     GIR_RootConstrainSelectedInstOperands,
     /* 415529 */     // GIR_Coverage, 6163,
     /* 415529 */     GIR_EraseRootFromParent_Done,
     /* 415530 */   // Label 8018: @415530
     /* 415530 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(415626), // Rule ID 6195 //
     /* 415535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415577 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415624 */     GIR_RootConstrainSelectedInstOperands,
     /* 415625 */     // GIR_Coverage, 6195,
     /* 415625 */     GIR_EraseRootFromParent_Done,
     /* 415626 */   // Label 8019: @415626
     /* 415626 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(415725), // Rule ID 6227 //
     /* 415631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415674 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415723 */     GIR_RootConstrainSelectedInstOperands,
     /* 415724 */     // GIR_Coverage, 6227,
     /* 415724 */     GIR_EraseRootFromParent_Done,
     /* 415725 */   // Label 8020: @415725
     /* 415725 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(415818), // Rule ID 6273 //
     /* 415730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415769 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415781 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415816 */     GIR_RootConstrainSelectedInstOperands,
     /* 415817 */     // GIR_Coverage, 6273,
     /* 415817 */     GIR_EraseRootFromParent_Done,
     /* 415818 */   // Label 8021: @415818
     /* 415818 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(415914), // Rule ID 6131 //
     /* 415823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415865 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415912 */     GIR_RootConstrainSelectedInstOperands,
     /* 415913 */     // GIR_Coverage, 6131,
     /* 415913 */     GIR_EraseRootFromParent_Done,
     /* 415914 */   // Label 8022: @415914
     /* 415914 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(415998), // Rule ID 2541 //
     /* 415919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415949 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415996 */     GIR_RootConstrainSelectedInstOperands,
     /* 415997 */     // GIR_Coverage, 2541,
     /* 415997 */     GIR_EraseRootFromParent_Done,
     /* 415998 */   // Label 8023: @415998
     /* 415998 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(416048), // Rule ID 13425 //
     /* 416003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416033 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 416033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 416036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416046 */     GIR_RootConstrainSelectedInstOperands,
     /* 416047 */     // GIR_Coverage, 13425,
     /* 416047 */     GIR_EraseRootFromParent_Done,
     /* 416048 */   // Label 8024: @416048
     /* 416048 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(416132), // Rule ID 6099 //
     /* 416053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 416072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416083 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416102 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 416118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416130 */     GIR_RootConstrainSelectedInstOperands,
     /* 416131 */     // GIR_Coverage, 6099,
     /* 416131 */     GIR_EraseRootFromParent_Done,
     /* 416132 */   // Label 8025: @416132
     /* 416132 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(416182), // Rule ID 1309 //
     /* 416137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416167 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 416167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 416170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416180 */     GIR_RootConstrainSelectedInstOperands,
     /* 416181 */     // GIR_Coverage, 1309,
     /* 416181 */     GIR_EraseRootFromParent_Done,
     /* 416182 */   // Label 8026: @416182
     /* 416182 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(416215), // Rule ID 1299 //
     /* 416187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416202 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 416202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 416205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 416213 */     GIR_RootConstrainSelectedInstOperands,
     /* 416214 */     // GIR_Coverage, 1299,
     /* 416214 */     GIR_EraseRootFromParent_Done,
     /* 416215 */   // Label 8027: @416215
     /* 416215 */   GIM_Reject,
     /* 416216 */ // Label 8008: @416216
     /* 416216 */ GIM_Reject,
     /* 416217 */ // Label 7859: @416217
     /* 416217 */ GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(417395),
     /* 416222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 416228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 416231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416235 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(416319), // Rule ID 6145 //
     /* 416240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416276 */     // MIs[2] Operand 1
     /* 416276 */     // No operand predicates
     /* 416276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 416280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416288 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416299 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 416310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416317 */     GIR_RootConstrainSelectedInstOperands,
     /* 416318 */     // GIR_Coverage, 6145,
     /* 416318 */     GIR_EraseRootFromParent_Done,
     /* 416319 */   // Label 8029: @416319
     /* 416319 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(416400), // Rule ID 6177 //
     /* 416324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416368 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416372 */     // MIs[3] Operand 1
     /* 416372 */     // No operand predicates
     /* 416372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416382 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416398 */     GIR_RootConstrainSelectedInstOperands,
     /* 416399 */     // GIR_Coverage, 6177,
     /* 416399 */     GIR_EraseRootFromParent_Done,
     /* 416400 */   // Label 8030: @416400
     /* 416400 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(416484), // Rule ID 6209 //
     /* 416405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416454 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416458 */     // MIs[3] Operand 1
     /* 416458 */     // No operand predicates
     /* 416458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416464 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416482 */     GIR_RootConstrainSelectedInstOperands,
     /* 416483 */     // GIR_Coverage, 6209,
     /* 416483 */     GIR_EraseRootFromParent_Done,
     /* 416484 */   // Label 8031: @416484
     /* 416484 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(416565), // Rule ID 6113 //
     /* 416489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416537 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416541 */     // MIs[3] Operand 1
     /* 416541 */     // No operand predicates
     /* 416541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416547 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416563 */     GIR_RootConstrainSelectedInstOperands,
     /* 416564 */     // GIR_Coverage, 6113,
     /* 416564 */     GIR_EraseRootFromParent_Done,
     /* 416565 */   // Label 8032: @416565
     /* 416565 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(416634), // Rule ID 2523 //
     /* 416570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416602 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416606 */     // MIs[2] Operand 1
     /* 416606 */     // No operand predicates
     /* 416606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416616 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416632 */     GIR_RootConstrainSelectedInstOperands,
     /* 416633 */     // GIR_Coverage, 2523,
     /* 416633 */     GIR_EraseRootFromParent_Done,
     /* 416634 */   // Label 8033: @416634
     /* 416634 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(416703), // Rule ID 6081 //
     /* 416639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416679 */     // MIs[2] Operand 1
     /* 416679 */     // No operand predicates
     /* 416679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416685 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416701 */     GIR_RootConstrainSelectedInstOperands,
     /* 416702 */     // GIR_Coverage, 6081,
     /* 416702 */     GIR_EraseRootFromParent_Done,
     /* 416703 */   // Label 8034: @416703
     /* 416703 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(416802), // Rule ID 6147 //
     /* 416708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416751 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 416794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416800 */     GIR_RootConstrainSelectedInstOperands,
     /* 416801 */     // GIR_Coverage, 6147,
     /* 416801 */     GIR_EraseRootFromParent_Done,
     /* 416802 */   // Label 8035: @416802
     /* 416802 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(416898), // Rule ID 6179 //
     /* 416807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416849 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416896 */     GIR_RootConstrainSelectedInstOperands,
     /* 416897 */     // GIR_Coverage, 6179,
     /* 416897 */     GIR_EraseRootFromParent_Done,
     /* 416898 */   // Label 8036: @416898
     /* 416898 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(416997), // Rule ID 6211 //
     /* 416903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416946 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416995 */     GIR_RootConstrainSelectedInstOperands,
     /* 416996 */     // GIR_Coverage, 6211,
     /* 416996 */     GIR_EraseRootFromParent_Done,
     /* 416997 */   // Label 8037: @416997
     /* 416997 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(417093), // Rule ID 6115 //
     /* 417002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 417029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417044 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417091 */     GIR_RootConstrainSelectedInstOperands,
     /* 417092 */     // GIR_Coverage, 6115,
     /* 417092 */     GIR_EraseRootFromParent_Done,
     /* 417093 */   // Label 8038: @417093
     /* 417093 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(417177), // Rule ID 2525 //
     /* 417098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417128 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 417163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417175 */     GIR_RootConstrainSelectedInstOperands,
     /* 417176 */     // GIR_Coverage, 2525,
     /* 417176 */     GIR_EraseRootFromParent_Done,
     /* 417177 */   // Label 8039: @417177
     /* 417177 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(417227), // Rule ID 13421 //
     /* 417182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417212 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 417215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417225 */     GIR_RootConstrainSelectedInstOperands,
     /* 417226 */     // GIR_Coverage, 13421,
     /* 417226 */     GIR_EraseRootFromParent_Done,
     /* 417227 */   // Label 8040: @417227
     /* 417227 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(417311), // Rule ID 6083 //
     /* 417232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417262 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417274 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 417297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417309 */     GIR_RootConstrainSelectedInstOperands,
     /* 417310 */     // GIR_Coverage, 6083,
     /* 417310 */     GIR_EraseRootFromParent_Done,
     /* 417311 */   // Label 8041: @417311
     /* 417311 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(417361), // Rule ID 1305 //
     /* 417316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417346 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 417349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417359 */     GIR_RootConstrainSelectedInstOperands,
     /* 417360 */     // GIR_Coverage, 1305,
     /* 417360 */     GIR_EraseRootFromParent_Done,
     /* 417361 */   // Label 8042: @417361
     /* 417361 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(417394), // Rule ID 1295 //
     /* 417366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417381 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 417384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 417392 */     GIR_RootConstrainSelectedInstOperands,
     /* 417393 */     // GIR_Coverage, 1295,
     /* 417393 */     GIR_EraseRootFromParent_Done,
     /* 417394 */   // Label 8043: @417394
     /* 417394 */   GIM_Reject,
     /* 417395 */ // Label 8028: @417395
     /* 417395 */ GIM_Reject,
     /* 417396 */ // Label 7860: @417396
     /* 417396 */ GIM_Reject,
     /* 417397 */ // Label 108: @417397
     /* 417397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8052*/ GIMT_Encode4(417696),
     /* 417408 */ /*GILLT_s16*//*Label 8044*/ GIMT_Encode4(417448),
     /* 417412 */ /*GILLT_s32*//*Label 8045*/ GIMT_Encode4(417479),
     /* 417416 */ /*GILLT_s64*//*Label 8046*/ GIMT_Encode4(417510), GIMT_Encode4(0),
     /* 417424 */ /*GILLT_v2s32*//*Label 8047*/ GIMT_Encode4(417541),
     /* 417428 */ /*GILLT_v2s64*//*Label 8048*/ GIMT_Encode4(417572),
     /* 417432 */ /*GILLT_v4s16*//*Label 8049*/ GIMT_Encode4(417603),
     /* 417436 */ /*GILLT_v4s32*//*Label 8050*/ GIMT_Encode4(417634), GIMT_Encode4(0),
     /* 417444 */ /*GILLT_v8s16*//*Label 8051*/ GIMT_Encode4(417665),
     /* 417448 */ // Label 8044: @417448
     /* 417448 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(417478), // Rule ID 569 //
     /* 417453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 417456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 417459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417467 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 417467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 417472 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417476 */   GIR_RootConstrainSelectedInstOperands,
     /* 417477 */   // GIR_Coverage, 569,
     /* 417477 */   GIR_Done,
     /* 417478 */ // Label 8053: @417478
     /* 417478 */ GIM_Reject,
     /* 417479 */ // Label 8045: @417479
     /* 417479 */ GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(417509), // Rule ID 571 //
     /* 417484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 417487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 417490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417498 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 417498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 417503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417507 */   GIR_RootConstrainSelectedInstOperands,
     /* 417508 */   // GIR_Coverage, 571,
     /* 417508 */   GIR_Done,
     /* 417509 */ // Label 8054: @417509
     /* 417509 */ GIM_Reject,
     /* 417510 */ // Label 8046: @417510
     /* 417510 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(417540), // Rule ID 573 //
     /* 417515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 417518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 417521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417529 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 417529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 417534 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417538 */   GIR_RootConstrainSelectedInstOperands,
     /* 417539 */   // GIR_Coverage, 573,
     /* 417539 */   GIR_Done,
     /* 417540 */ // Label 8055: @417540
     /* 417540 */ GIM_Reject,
     /* 417541 */ // Label 8047: @417541
     /* 417541 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(417571), // Rule ID 959 //
     /* 417546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417560 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 417565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417569 */   GIR_RootConstrainSelectedInstOperands,
     /* 417570 */   // GIR_Coverage, 959,
     /* 417570 */   GIR_Done,
     /* 417571 */ // Label 8056: @417571
     /* 417571 */ GIM_Reject,
     /* 417572 */ // Label 8048: @417572
     /* 417572 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(417602), // Rule ID 963 //
     /* 417577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417591 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 417596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417600 */   GIR_RootConstrainSelectedInstOperands,
     /* 417601 */   // GIR_Coverage, 963,
     /* 417601 */   GIR_Done,
     /* 417602 */ // Label 8057: @417602
     /* 417602 */ GIM_Reject,
     /* 417603 */ // Label 8049: @417603
     /* 417603 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(417633), // Rule ID 955 //
     /* 417608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417622 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 417627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417631 */   GIR_RootConstrainSelectedInstOperands,
     /* 417632 */   // GIR_Coverage, 955,
     /* 417632 */   GIR_Done,
     /* 417633 */ // Label 8058: @417633
     /* 417633 */ GIM_Reject,
     /* 417634 */ // Label 8050: @417634
     /* 417634 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(417664), // Rule ID 961 //
     /* 417639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417653 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 417658 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417662 */   GIR_RootConstrainSelectedInstOperands,
     /* 417663 */   // GIR_Coverage, 961,
     /* 417663 */   GIR_Done,
     /* 417664 */ // Label 8059: @417664
     /* 417664 */ GIM_Reject,
     /* 417665 */ // Label 8051: @417665
     /* 417665 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(417695), // Rule ID 957 //
     /* 417670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417684 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 417689 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417693 */   GIR_RootConstrainSelectedInstOperands,
     /* 417694 */   // GIR_Coverage, 957,
     /* 417694 */   GIR_Done,
     /* 417695 */ // Label 8060: @417695
     /* 417695 */ GIM_Reject,
     /* 417696 */ // Label 8052: @417696
     /* 417696 */ GIM_Reject,
     /* 417697 */ // Label 109: @417697
     /* 417697 */ GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(417710), // Rule ID 6570 //
     /* 417702 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 417702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 417705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 417708 */   GIR_RootConstrainSelectedInstOperands,
     /* 417709 */   // GIR_Coverage, 6570,
     /* 417709 */   GIR_EraseRootFromParent_Done,
     /* 417710 */ // Label 8061: @417710
     /* 417710 */ GIM_Reject,
     /* 417711 */ // Label 110: @417711
     /* 417711 */ GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(417731), // Rule ID 6571 //
     /* 417716 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 417716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 417719 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 417729 */   GIR_RootConstrainSelectedInstOperands,
     /* 417730 */   // GIR_Coverage, 6571,
     /* 417730 */   GIR_EraseRootFromParent_Done,
     /* 417731 */ // Label 8062: @417731
     /* 417731 */ GIM_Reject,
     /* 417732 */ // Label 111: @417732
     /* 417732 */ GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(417756), // Rule ID 6572 //
     /* 417737 */   // MIs[0] kind
     /* 417737 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 417740 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 417745 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 417745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 417748 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 417754 */   GIR_RootConstrainSelectedInstOperands,
     /* 417755 */   // GIR_Coverage, 6572,
     /* 417755 */   GIR_EraseRootFromParent_Done,
     /* 417756 */ // Label 8063: @417756
     /* 417756 */ GIM_Reject,
     /* 417757 */ // Label 112: @417757
     /* 417757 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8067*/ GIMT_Encode4(418066),
     /* 417768 */ /*GILLT_s16*//*Label 8064*/ GIMT_Encode4(417780),
     /* 417772 */ /*GILLT_s32*//*Label 8065*/ GIMT_Encode4(417933),
     /* 417776 */ /*GILLT_s64*//*Label 8066*/ GIMT_Encode4(418038),
     /* 417780 */ // Label 8064: @417780
     /* 417780 */ GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(417881), // Rule ID 5625 //
     /* 417785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 417788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417799 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 417799 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 417802 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 417806 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417811 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417815 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 417821 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 417824 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 417828 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417833 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 417836 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 417842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417854 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 417861 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 417874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417879 */   GIR_RootConstrainSelectedInstOperands,
     /* 417880 */   // GIR_Coverage, 5625,
     /* 417880 */   GIR_EraseRootFromParent_Done,
     /* 417881 */ // Label 8068: @417881
     /* 417881 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(417932), // Rule ID 5626 //
     /* 417886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 417889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417900 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 417900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 417907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417912 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417916 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 417922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 417925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417930 */   GIR_RootConstrainSelectedInstOperands,
     /* 417931 */   // GIR_Coverage, 5626,
     /* 417931 */   GIR_EraseRootFromParent_Done,
     /* 417932 */ // Label 8069: @417932
     /* 417932 */ GIM_Reject,
     /* 417933 */ // Label 8065: @417933
     /* 417933 */ GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(418010), // Rule ID 5627 //
     /* 417938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417949 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 417949 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 417952 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 417956 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417961 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417965 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 417971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417983 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 417990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 418003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418008 */   GIR_RootConstrainSelectedInstOperands,
     /* 418009 */   // GIR_Coverage, 5627,
     /* 418009 */   GIR_EraseRootFromParent_Done,
     /* 418010 */ // Label 8070: @418010
     /* 418010 */ GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(418037), // Rule ID 5628 //
     /* 418015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418026 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 418031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418035 */   GIR_RootConstrainSelectedInstOperands,
     /* 418036 */   // GIR_Coverage, 5628,
     /* 418036 */   GIR_Done,
     /* 418037 */ // Label 8071: @418037
     /* 418037 */ GIM_Reject,
     /* 418038 */ // Label 8066: @418038
     /* 418038 */ GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(418065), // Rule ID 5629 //
     /* 418043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418054 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 418059 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418063 */   GIR_RootConstrainSelectedInstOperands,
     /* 418064 */   // GIR_Coverage, 5629,
     /* 418064 */   GIR_Done,
     /* 418065 */ // Label 8072: @418065
     /* 418065 */ GIM_Reject,
     /* 418066 */ // Label 8067: @418066
     /* 418066 */ GIM_Reject,
     /* 418067 */ // Label 113: @418067
     /* 418067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8076*/ GIMT_Encode4(418237),
     /* 418078 */ /*GILLT_s16*//*Label 8073*/ GIMT_Encode4(418090),
     /* 418082 */ /*GILLT_s32*//*Label 8074*/ GIMT_Encode4(418151),
     /* 418086 */ /*GILLT_s64*//*Label 8075*/ GIMT_Encode4(418209),
     /* 418090 */ // Label 8073: @418090
     /* 418090 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(418120), // Rule ID 1942 //
     /* 418095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418109 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 418114 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418118 */   GIR_RootConstrainSelectedInstOperands,
     /* 418119 */   // GIR_Coverage, 1942,
     /* 418119 */   GIR_Done,
     /* 418120 */ // Label 8077: @418120
     /* 418120 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(418150), // Rule ID 1944 //
     /* 418125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418139 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 418144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418148 */   GIR_RootConstrainSelectedInstOperands,
     /* 418149 */   // GIR_Coverage, 1944,
     /* 418149 */   GIR_Done,
     /* 418150 */ // Label 8078: @418150
     /* 418150 */ GIM_Reject,
     /* 418151 */ // Label 8074: @418151
     /* 418151 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(418181), // Rule ID 1946 //
     /* 418156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418170 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 418175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418179 */   GIR_RootConstrainSelectedInstOperands,
     /* 418180 */   // GIR_Coverage, 1946,
     /* 418180 */   GIR_Done,
     /* 418181 */ // Label 8079: @418181
     /* 418181 */ GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(418208), // Rule ID 5635 //
     /* 418186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418197 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 418202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418206 */   GIR_RootConstrainSelectedInstOperands,
     /* 418207 */   // GIR_Coverage, 5635,
     /* 418207 */   GIR_Done,
     /* 418208 */ // Label 8080: @418208
     /* 418208 */ GIM_Reject,
     /* 418209 */ // Label 8075: @418209
     /* 418209 */ GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(418236), // Rule ID 5637 //
     /* 418214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418225 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 418230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418234 */   GIR_RootConstrainSelectedInstOperands,
     /* 418235 */   // GIR_Coverage, 5637,
     /* 418235 */   GIR_Done,
     /* 418236 */ // Label 8081: @418236
     /* 418236 */ GIM_Reject,
     /* 418237 */ // Label 8076: @418237
     /* 418237 */ GIM_Reject,
     /* 418238 */ // Label 114: @418238
     /* 418238 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8085*/ GIMT_Encode4(418408),
     /* 418249 */ /*GILLT_s16*//*Label 8082*/ GIMT_Encode4(418261),
     /* 418253 */ /*GILLT_s32*//*Label 8083*/ GIMT_Encode4(418322),
     /* 418257 */ /*GILLT_s64*//*Label 8084*/ GIMT_Encode4(418380),
     /* 418261 */ // Label 8082: @418261
     /* 418261 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(418291), // Rule ID 1954 //
     /* 418266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418280 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 418285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418289 */   GIR_RootConstrainSelectedInstOperands,
     /* 418290 */   // GIR_Coverage, 1954,
     /* 418290 */   GIR_Done,
     /* 418291 */ // Label 8086: @418291
     /* 418291 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(418321), // Rule ID 1956 //
     /* 418296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418310 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 418315 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418319 */   GIR_RootConstrainSelectedInstOperands,
     /* 418320 */   // GIR_Coverage, 1956,
     /* 418320 */   GIR_Done,
     /* 418321 */ // Label 8087: @418321
     /* 418321 */ GIM_Reject,
     /* 418322 */ // Label 8083: @418322
     /* 418322 */ GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(418352), // Rule ID 1958 //
     /* 418327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418341 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 418346 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418350 */   GIR_RootConstrainSelectedInstOperands,
     /* 418351 */   // GIR_Coverage, 1958,
     /* 418351 */   GIR_Done,
     /* 418352 */ // Label 8088: @418352
     /* 418352 */ GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(418379), // Rule ID 5643 //
     /* 418357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418368 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 418373 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418377 */   GIR_RootConstrainSelectedInstOperands,
     /* 418378 */   // GIR_Coverage, 5643,
     /* 418378 */   GIR_Done,
     /* 418379 */ // Label 8089: @418379
     /* 418379 */ GIM_Reject,
     /* 418380 */ // Label 8084: @418380
     /* 418380 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(418407), // Rule ID 5645 //
     /* 418385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418396 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 418401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418405 */   GIR_RootConstrainSelectedInstOperands,
     /* 418406 */   // GIR_Coverage, 5645,
     /* 418406 */   GIR_Done,
     /* 418407 */ // Label 8090: @418407
     /* 418407 */ GIM_Reject,
     /* 418408 */ // Label 8085: @418408
     /* 418408 */ GIM_Reject,
     /* 418409 */ // Label 115: @418409
     /* 418409 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8094*/ GIMT_Encode4(418579),
     /* 418420 */ /*GILLT_s16*//*Label 8091*/ GIMT_Encode4(418432),
     /* 418424 */ /*GILLT_s32*//*Label 8092*/ GIMT_Encode4(418493),
     /* 418428 */ /*GILLT_s64*//*Label 8093*/ GIMT_Encode4(418551),
     /* 418432 */ // Label 8091: @418432
     /* 418432 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(418462), // Rule ID 1948 //
     /* 418437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418451 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 418456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418460 */   GIR_RootConstrainSelectedInstOperands,
     /* 418461 */   // GIR_Coverage, 1948,
     /* 418461 */   GIR_Done,
     /* 418462 */ // Label 8095: @418462
     /* 418462 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(418492), // Rule ID 1950 //
     /* 418467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418481 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 418486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418490 */   GIR_RootConstrainSelectedInstOperands,
     /* 418491 */   // GIR_Coverage, 1950,
     /* 418491 */   GIR_Done,
     /* 418492 */ // Label 8096: @418492
     /* 418492 */ GIM_Reject,
     /* 418493 */ // Label 8092: @418493
     /* 418493 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(418523), // Rule ID 1952 //
     /* 418498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418512 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 418517 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418521 */   GIR_RootConstrainSelectedInstOperands,
     /* 418522 */   // GIR_Coverage, 1952,
     /* 418522 */   GIR_Done,
     /* 418523 */ // Label 8097: @418523
     /* 418523 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(418550), // Rule ID 5639 //
     /* 418528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418539 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 418544 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418548 */   GIR_RootConstrainSelectedInstOperands,
     /* 418549 */   // GIR_Coverage, 5639,
     /* 418549 */   GIR_Done,
     /* 418550 */ // Label 8098: @418550
     /* 418550 */ GIM_Reject,
     /* 418551 */ // Label 8093: @418551
     /* 418551 */ GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(418578), // Rule ID 5641 //
     /* 418556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418567 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 418572 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418576 */   GIR_RootConstrainSelectedInstOperands,
     /* 418577 */   // GIR_Coverage, 5641,
     /* 418577 */   GIR_Done,
     /* 418578 */ // Label 8099: @418578
     /* 418578 */ GIM_Reject,
     /* 418579 */ // Label 8094: @418579
     /* 418579 */ GIM_Reject,
     /* 418580 */ // Label 116: @418580
     /* 418580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8103*/ GIMT_Encode4(418750),
     /* 418591 */ /*GILLT_s16*//*Label 8100*/ GIMT_Encode4(418603),
     /* 418595 */ /*GILLT_s32*//*Label 8101*/ GIMT_Encode4(418664),
     /* 418599 */ /*GILLT_s64*//*Label 8102*/ GIMT_Encode4(418722),
     /* 418603 */ // Label 8100: @418603
     /* 418603 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(418633), // Rule ID 1960 //
     /* 418608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418622 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 418627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418631 */   GIR_RootConstrainSelectedInstOperands,
     /* 418632 */   // GIR_Coverage, 1960,
     /* 418632 */   GIR_Done,
     /* 418633 */ // Label 8104: @418633
     /* 418633 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(418663), // Rule ID 1962 //
     /* 418638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418652 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 418657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418661 */   GIR_RootConstrainSelectedInstOperands,
     /* 418662 */   // GIR_Coverage, 1962,
     /* 418662 */   GIR_Done,
     /* 418663 */ // Label 8105: @418663
     /* 418663 */ GIM_Reject,
     /* 418664 */ // Label 8101: @418664
     /* 418664 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(418694), // Rule ID 1964 //
     /* 418669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418683 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 418688 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418692 */   GIR_RootConstrainSelectedInstOperands,
     /* 418693 */   // GIR_Coverage, 1964,
     /* 418693 */   GIR_Done,
     /* 418694 */ // Label 8106: @418694
     /* 418694 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(418721), // Rule ID 5647 //
     /* 418699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418710 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 418715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418719 */   GIR_RootConstrainSelectedInstOperands,
     /* 418720 */   // GIR_Coverage, 5647,
     /* 418720 */   GIR_Done,
     /* 418721 */ // Label 8107: @418721
     /* 418721 */ GIM_Reject,
     /* 418722 */ // Label 8102: @418722
     /* 418722 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(418749), // Rule ID 5649 //
     /* 418727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418738 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 418743 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418747 */   GIR_RootConstrainSelectedInstOperands,
     /* 418748 */   // GIR_Coverage, 5649,
     /* 418748 */   GIR_Done,
     /* 418749 */ // Label 8108: @418749
     /* 418749 */ GIM_Reject,
     /* 418750 */ // Label 8103: @418750
     /* 418750 */ GIM_Reject,
     /* 418751 */ // Label 117: @418751
     /* 418751 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8113*/ GIMT_Encode4(419879),
     /* 418762 */ /*GILLT_s8*//*Label 8109*/ GIMT_Encode4(418778),
     /* 418766 */ /*GILLT_s16*//*Label 8110*/ GIMT_Encode4(418825),
     /* 418770 */ /*GILLT_s32*//*Label 8111*/ GIMT_Encode4(419240),
     /* 418774 */ /*GILLT_s64*//*Label 8112*/ GIMT_Encode4(419693),
     /* 418778 */ // Label 8109: @418778
     /* 418778 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(418801), // Rule ID 5934 //
     /* 418783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418794 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 418794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 418799 */   GIR_RootConstrainSelectedInstOperands,
     /* 418800 */   // GIR_Coverage, 5934,
     /* 418800 */   GIR_Done,
     /* 418801 */ // Label 8114: @418801
     /* 418801 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(418824), // Rule ID 5935 //
     /* 418806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418817 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 418817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 418822 */   GIR_RootConstrainSelectedInstOperands,
     /* 418823 */   // GIR_Coverage, 5935,
     /* 418823 */   GIR_Done,
     /* 418824 */ // Label 8115: @418824
     /* 418824 */ GIM_Reject,
     /* 418825 */ // Label 8110: @418825
     /* 418825 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(418875), // Rule ID 5881 //
     /* 418830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418845 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418848 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418853 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418857 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418864 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 418867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418869 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418873 */   GIR_RootConstrainSelectedInstOperands,
     /* 418874 */   // GIR_Coverage, 5881,
     /* 418874 */   GIR_EraseRootFromParent_Done,
     /* 418875 */ // Label 8116: @418875
     /* 418875 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(418925), // Rule ID 5883 //
     /* 418880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418887 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418895 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418898 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 418907 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418914 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 418917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418919 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418923 */   GIR_RootConstrainSelectedInstOperands,
     /* 418924 */   // GIR_Coverage, 5883,
     /* 418924 */   GIR_EraseRootFromParent_Done,
     /* 418925 */ // Label 8117: @418925
     /* 418925 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(418975), // Rule ID 5891 //
     /* 418930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418945 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418948 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418953 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418957 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418964 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 418967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418969 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418973 */   GIR_RootConstrainSelectedInstOperands,
     /* 418974 */   // GIR_Coverage, 5891,
     /* 418974 */   GIR_EraseRootFromParent_Done,
     /* 418975 */ // Label 8118: @418975
     /* 418975 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(419025), // Rule ID 5893 //
     /* 418980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418987 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418991 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418995 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418998 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 419007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419014 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 419014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 419017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419019 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419023 */   GIR_RootConstrainSelectedInstOperands,
     /* 419024 */   // GIR_Coverage, 5893,
     /* 419024 */   GIR_EraseRootFromParent_Done,
     /* 419025 */ // Label 8119: @419025
     /* 419025 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(419067), // Rule ID 5890 //
     /* 419030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419045 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419049 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419056 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 419056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 419059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419061 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419065 */   GIR_RootConstrainSelectedInstOperands,
     /* 419066 */   // GIR_Coverage, 5890,
     /* 419066 */   GIR_EraseRootFromParent_Done,
     /* 419067 */ // Label 8120: @419067
     /* 419067 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(419109), // Rule ID 5892 //
     /* 419072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419087 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419091 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419098 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 419098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 419101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419103 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419107 */   GIR_RootConstrainSelectedInstOperands,
     /* 419108 */   // GIR_Coverage, 5892,
     /* 419108 */   GIR_EraseRootFromParent_Done,
     /* 419109 */ // Label 8121: @419109
     /* 419109 */ GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(419151), // Rule ID 5880 //
     /* 419114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419129 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419133 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419138 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419140 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 419140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 419143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419145 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419149 */   GIR_RootConstrainSelectedInstOperands,
     /* 419150 */   // GIR_Coverage, 5880,
     /* 419150 */   GIR_EraseRootFromParent_Done,
     /* 419151 */ // Label 8122: @419151
     /* 419151 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(419193), // Rule ID 5882 //
     /* 419156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419171 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419175 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419182 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 419182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 419185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419187 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419191 */   GIR_RootConstrainSelectedInstOperands,
     /* 419192 */   // GIR_Coverage, 5882,
     /* 419192 */   GIR_EraseRootFromParent_Done,
     /* 419193 */ // Label 8123: @419193
     /* 419193 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(419216), // Rule ID 5936 //
     /* 419198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419209 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 419209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 419214 */   GIR_RootConstrainSelectedInstOperands,
     /* 419215 */   // GIR_Coverage, 5936,
     /* 419215 */   GIR_Done,
     /* 419216 */ // Label 8124: @419216
     /* 419216 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(419239), // Rule ID 5937 //
     /* 419221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419232 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 419232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 419237 */   GIR_RootConstrainSelectedInstOperands,
     /* 419238 */   // GIR_Coverage, 5937,
     /* 419238 */   GIR_Done,
     /* 419239 */ // Label 8125: @419239
     /* 419239 */ GIM_Reject,
     /* 419240 */ // Label 8111: @419240
     /* 419240 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(419290), // Rule ID 5885 //
     /* 419245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419260 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419263 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419268 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 419272 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419279 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 419282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419284 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419288 */   GIR_RootConstrainSelectedInstOperands,
     /* 419289 */   // GIR_Coverage, 5885,
     /* 419289 */   GIR_EraseRootFromParent_Done,
     /* 419290 */ // Label 8126: @419290
     /* 419290 */ GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(419340), // Rule ID 5887 //
     /* 419295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419310 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419313 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419318 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 419322 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419329 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 419332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419334 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419338 */   GIR_RootConstrainSelectedInstOperands,
     /* 419339 */   // GIR_Coverage, 5887,
     /* 419339 */   GIR_EraseRootFromParent_Done,
     /* 419340 */ // Label 8127: @419340
     /* 419340 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(419390), // Rule ID 5895 //
     /* 419345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419360 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419363 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419368 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 419372 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419377 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419379 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 419382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419384 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419388 */   GIR_RootConstrainSelectedInstOperands,
     /* 419389 */   // GIR_Coverage, 5895,
     /* 419389 */   GIR_EraseRootFromParent_Done,
     /* 419390 */ // Label 8128: @419390
     /* 419390 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(419440), // Rule ID 5897 //
     /* 419395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419410 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419413 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419418 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 419422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419429 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 419432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419434 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419438 */   GIR_RootConstrainSelectedInstOperands,
     /* 419439 */   // GIR_Coverage, 5897,
     /* 419439 */   GIR_EraseRootFromParent_Done,
     /* 419440 */ // Label 8129: @419440
     /* 419440 */ GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(419482), // Rule ID 5894 //
     /* 419445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419452 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419456 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419460 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419464 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419471 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 419474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419476 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419480 */   GIR_RootConstrainSelectedInstOperands,
     /* 419481 */   // GIR_Coverage, 5894,
     /* 419481 */   GIR_EraseRootFromParent_Done,
     /* 419482 */ // Label 8130: @419482
     /* 419482 */ GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(419524), // Rule ID 5896 //
     /* 419487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419502 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419506 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419513 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 419516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419518 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419522 */   GIR_RootConstrainSelectedInstOperands,
     /* 419523 */   // GIR_Coverage, 5896,
     /* 419523 */   GIR_EraseRootFromParent_Done,
     /* 419524 */ // Label 8131: @419524
     /* 419524 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(419566), // Rule ID 5884 //
     /* 419529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419544 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419548 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419555 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 419558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419560 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419564 */   GIR_RootConstrainSelectedInstOperands,
     /* 419565 */   // GIR_Coverage, 5884,
     /* 419565 */   GIR_EraseRootFromParent_Done,
     /* 419566 */ // Label 8132: @419566
     /* 419566 */ GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(419608), // Rule ID 5886 //
     /* 419571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419590 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419597 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 419600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419602 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419606 */   GIR_RootConstrainSelectedInstOperands,
     /* 419607 */   // GIR_Coverage, 5886,
     /* 419607 */   GIR_EraseRootFromParent_Done,
     /* 419608 */ // Label 8133: @419608
     /* 419608 */ GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(419669), // Rule ID 5938 //
     /* 419613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419624 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 419631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419636 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419640 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419651 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419668 */   // GIR_Coverage, 5938,
     /* 419668 */   GIR_EraseRootFromParent_Done,
     /* 419669 */ // Label 8134: @419669
     /* 419669 */ GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(419692), // Rule ID 5939 //
     /* 419674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419685 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 419690 */   GIR_RootConstrainSelectedInstOperands,
     /* 419691 */   // GIR_Coverage, 5939,
     /* 419691 */   GIR_Done,
     /* 419692 */ // Label 8135: @419692
     /* 419692 */ GIM_Reject,
     /* 419693 */ // Label 8112: @419693
     /* 419693 */ GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(419878),
     /* 419698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419705 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(419748), // Rule ID 5889 //
     /* 419710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419718 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419721 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 419730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419737 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 419740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419746 */     GIR_RootConstrainSelectedInstOperands,
     /* 419747 */     // GIR_Coverage, 5889,
     /* 419747 */     GIR_EraseRootFromParent_Done,
     /* 419748 */   // Label 8137: @419748
     /* 419748 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(419791), // Rule ID 5899 //
     /* 419753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419761 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419764 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 419773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419780 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 419783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419789 */     GIR_RootConstrainSelectedInstOperands,
     /* 419790 */     // GIR_Coverage, 5899,
     /* 419790 */     GIR_EraseRootFromParent_Done,
     /* 419791 */   // Label 8138: @419791
     /* 419791 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(419826), // Rule ID 5898 //
     /* 419796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419815 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 419818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419824 */     GIR_RootConstrainSelectedInstOperands,
     /* 419825 */     // GIR_Coverage, 5898,
     /* 419825 */     GIR_EraseRootFromParent_Done,
     /* 419826 */   // Label 8139: @419826
     /* 419826 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(419861), // Rule ID 5888 //
     /* 419831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419850 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 419853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419859 */     GIR_RootConstrainSelectedInstOperands,
     /* 419860 */     // GIR_Coverage, 5888,
     /* 419860 */     GIR_EraseRootFromParent_Done,
     /* 419861 */   // Label 8140: @419861
     /* 419861 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(419877), // Rule ID 5940 //
     /* 419866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419870 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 419870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 419875 */     GIR_RootConstrainSelectedInstOperands,
     /* 419876 */     // GIR_Coverage, 5940,
     /* 419876 */     GIR_Done,
     /* 419877 */   // Label 8141: @419877
     /* 419877 */   GIM_Reject,
     /* 419878 */ // Label 8136: @419878
     /* 419878 */ GIM_Reject,
     /* 419879 */ // Label 8113: @419879
     /* 419879 */ GIM_Reject,
     /* 419880 */ // Label 118: @419880
     /* 419880 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8145*/ GIMT_Encode4(420082),
     /* 419891 */ /*GILLT_s8*//*Label 8142*/ GIMT_Encode4(419903),
     /* 419895 */ /*GILLT_s16*//*Label 8143*/ GIMT_Encode4(419950),
     /* 419899 */ /*GILLT_s32*//*Label 8144*/ GIMT_Encode4(419997),
     /* 419903 */ // Label 8142: @419903
     /* 419903 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(419926), // Rule ID 6031 //
     /* 419908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419919 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 419924 */   GIR_RootConstrainSelectedInstOperands,
     /* 419925 */   // GIR_Coverage, 6031,
     /* 419925 */   GIR_Done,
     /* 419926 */ // Label 8146: @419926
     /* 419926 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(419949), // Rule ID 6032 //
     /* 419931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419942 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 419947 */   GIR_RootConstrainSelectedInstOperands,
     /* 419948 */   // GIR_Coverage, 6032,
     /* 419948 */   GIR_Done,
     /* 419949 */ // Label 8147: @419949
     /* 419949 */ GIM_Reject,
     /* 419950 */ // Label 8143: @419950
     /* 419950 */ GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(419973), // Rule ID 6033 //
     /* 419955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419966 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 419971 */   GIR_RootConstrainSelectedInstOperands,
     /* 419972 */   // GIR_Coverage, 6033,
     /* 419972 */   GIR_Done,
     /* 419973 */ // Label 8148: @419973
     /* 419973 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(419996), // Rule ID 6034 //
     /* 419978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419989 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 419994 */   GIR_RootConstrainSelectedInstOperands,
     /* 419995 */   // GIR_Coverage, 6034,
     /* 419995 */   GIR_Done,
     /* 419996 */ // Label 8149: @419996
     /* 419996 */ GIM_Reject,
     /* 419997 */ // Label 8144: @419997
     /* 419997 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(420020), // Rule ID 6035 //
     /* 420002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420013 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 420018 */   GIR_RootConstrainSelectedInstOperands,
     /* 420019 */   // GIR_Coverage, 6035,
     /* 420019 */   GIR_Done,
     /* 420020 */ // Label 8150: @420020
     /* 420020 */ GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(420081), // Rule ID 6036 //
     /* 420025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420036 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 420043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420048 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420052 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420063 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420080 */   // GIR_Coverage, 6036,
     /* 420080 */   GIR_EraseRootFromParent_Done,
     /* 420081 */ // Label 8151: @420081
     /* 420081 */ GIM_Reject,
     /* 420082 */ // Label 8145: @420082
     /* 420082 */ GIM_Reject,
     /* 420083 */ // Label 119: @420083
     /* 420083 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8155*/ GIMT_Encode4(420285),
     /* 420094 */ /*GILLT_s8*//*Label 8152*/ GIMT_Encode4(420106),
     /* 420098 */ /*GILLT_s16*//*Label 8153*/ GIMT_Encode4(420153),
     /* 420102 */ /*GILLT_s32*//*Label 8154*/ GIMT_Encode4(420200),
     /* 420106 */ // Label 8152: @420106
     /* 420106 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(420129), // Rule ID 6025 //
     /* 420111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420122 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 420122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 420127 */   GIR_RootConstrainSelectedInstOperands,
     /* 420128 */   // GIR_Coverage, 6025,
     /* 420128 */   GIR_Done,
     /* 420129 */ // Label 8156: @420129
     /* 420129 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(420152), // Rule ID 6026 //
     /* 420134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420145 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 420145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 420150 */   GIR_RootConstrainSelectedInstOperands,
     /* 420151 */   // GIR_Coverage, 6026,
     /* 420151 */   GIR_Done,
     /* 420152 */ // Label 8157: @420152
     /* 420152 */ GIM_Reject,
     /* 420153 */ // Label 8153: @420153
     /* 420153 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(420176), // Rule ID 6027 //
     /* 420158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420169 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 420169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 420174 */   GIR_RootConstrainSelectedInstOperands,
     /* 420175 */   // GIR_Coverage, 6027,
     /* 420175 */   GIR_Done,
     /* 420176 */ // Label 8158: @420176
     /* 420176 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(420199), // Rule ID 6028 //
     /* 420181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420192 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 420192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 420197 */   GIR_RootConstrainSelectedInstOperands,
     /* 420198 */   // GIR_Coverage, 6028,
     /* 420198 */   GIR_Done,
     /* 420199 */ // Label 8159: @420199
     /* 420199 */ GIM_Reject,
     /* 420200 */ // Label 8154: @420200
     /* 420200 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(420223), // Rule ID 6029 //
     /* 420205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420216 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 420221 */   GIR_RootConstrainSelectedInstOperands,
     /* 420222 */   // GIR_Coverage, 6029,
     /* 420222 */   GIR_Done,
     /* 420223 */ // Label 8160: @420223
     /* 420223 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(420284), // Rule ID 6030 //
     /* 420228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420239 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 420246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420251 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420255 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420266 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420283 */   // GIR_Coverage, 6030,
     /* 420283 */   GIR_EraseRootFromParent_Done,
     /* 420284 */ // Label 8161: @420284
     /* 420284 */ GIM_Reject,
     /* 420285 */ // Label 8155: @420285
     /* 420285 */ GIM_Reject,
     /* 420286 */ // Label 120: @420286
     /* 420286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8165*/ GIMT_Encode4(420488),
     /* 420297 */ /*GILLT_s8*//*Label 8162*/ GIMT_Encode4(420309),
     /* 420301 */ /*GILLT_s16*//*Label 8163*/ GIMT_Encode4(420356),
     /* 420305 */ /*GILLT_s32*//*Label 8164*/ GIMT_Encode4(420403),
     /* 420309 */ // Label 8162: @420309
     /* 420309 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(420332), // Rule ID 6019 //
     /* 420314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420325 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 420325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 420330 */   GIR_RootConstrainSelectedInstOperands,
     /* 420331 */   // GIR_Coverage, 6019,
     /* 420331 */   GIR_Done,
     /* 420332 */ // Label 8166: @420332
     /* 420332 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(420355), // Rule ID 6020 //
     /* 420337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420348 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 420348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 420353 */   GIR_RootConstrainSelectedInstOperands,
     /* 420354 */   // GIR_Coverage, 6020,
     /* 420354 */   GIR_Done,
     /* 420355 */ // Label 8167: @420355
     /* 420355 */ GIM_Reject,
     /* 420356 */ // Label 8163: @420356
     /* 420356 */ GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(420379), // Rule ID 6021 //
     /* 420361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420372 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 420372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 420377 */   GIR_RootConstrainSelectedInstOperands,
     /* 420378 */   // GIR_Coverage, 6021,
     /* 420378 */   GIR_Done,
     /* 420379 */ // Label 8168: @420379
     /* 420379 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(420402), // Rule ID 6022 //
     /* 420384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420395 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 420395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 420400 */   GIR_RootConstrainSelectedInstOperands,
     /* 420401 */   // GIR_Coverage, 6022,
     /* 420401 */   GIR_Done,
     /* 420402 */ // Label 8169: @420402
     /* 420402 */ GIM_Reject,
     /* 420403 */ // Label 8164: @420403
     /* 420403 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(420426), // Rule ID 6023 //
     /* 420408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420419 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 420424 */   GIR_RootConstrainSelectedInstOperands,
     /* 420425 */   // GIR_Coverage, 6023,
     /* 420425 */   GIR_Done,
     /* 420426 */ // Label 8170: @420426
     /* 420426 */ GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(420487), // Rule ID 6024 //
     /* 420431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420442 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 420449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420458 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420469 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420486 */   // GIR_Coverage, 6024,
     /* 420486 */   GIR_EraseRootFromParent_Done,
     /* 420487 */ // Label 8171: @420487
     /* 420487 */ GIM_Reject,
     /* 420488 */ // Label 8165: @420488
     /* 420488 */ GIM_Reject,
     /* 420489 */ // Label 121: @420489
     /* 420489 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8175*/ GIMT_Encode4(420691),
     /* 420500 */ /*GILLT_s8*//*Label 8172*/ GIMT_Encode4(420512),
     /* 420504 */ /*GILLT_s16*//*Label 8173*/ GIMT_Encode4(420559),
     /* 420508 */ /*GILLT_s32*//*Label 8174*/ GIMT_Encode4(420606),
     /* 420512 */ // Label 8172: @420512
     /* 420512 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(420535), // Rule ID 6013 //
     /* 420517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420528 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 420528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 420533 */   GIR_RootConstrainSelectedInstOperands,
     /* 420534 */   // GIR_Coverage, 6013,
     /* 420534 */   GIR_Done,
     /* 420535 */ // Label 8176: @420535
     /* 420535 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(420558), // Rule ID 6014 //
     /* 420540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420551 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 420551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 420556 */   GIR_RootConstrainSelectedInstOperands,
     /* 420557 */   // GIR_Coverage, 6014,
     /* 420557 */   GIR_Done,
     /* 420558 */ // Label 8177: @420558
     /* 420558 */ GIM_Reject,
     /* 420559 */ // Label 8173: @420559
     /* 420559 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(420582), // Rule ID 6015 //
     /* 420564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420575 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 420575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 420580 */   GIR_RootConstrainSelectedInstOperands,
     /* 420581 */   // GIR_Coverage, 6015,
     /* 420581 */   GIR_Done,
     /* 420582 */ // Label 8178: @420582
     /* 420582 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(420605), // Rule ID 6016 //
     /* 420587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420598 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 420598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 420603 */   GIR_RootConstrainSelectedInstOperands,
     /* 420604 */   // GIR_Coverage, 6016,
     /* 420604 */   GIR_Done,
     /* 420605 */ // Label 8179: @420605
     /* 420605 */ GIM_Reject,
     /* 420606 */ // Label 8174: @420606
     /* 420606 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(420629), // Rule ID 6017 //
     /* 420611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420622 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 420627 */   GIR_RootConstrainSelectedInstOperands,
     /* 420628 */   // GIR_Coverage, 6017,
     /* 420628 */   GIR_Done,
     /* 420629 */ // Label 8180: @420629
     /* 420629 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(420690), // Rule ID 6018 //
     /* 420634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420645 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 420652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420657 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420661 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420672 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420684 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420689 */   // GIR_Coverage, 6018,
     /* 420689 */   GIR_EraseRootFromParent_Done,
     /* 420690 */ // Label 8181: @420690
     /* 420690 */ GIM_Reject,
     /* 420691 */ // Label 8175: @420691
     /* 420691 */ GIM_Reject,
     /* 420692 */ // Label 122: @420692
     /* 420692 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(420831),
     /* 420697 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 420700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 420704 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(420738), // Rule ID 257 //
     /* 420709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 420716 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 420716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 420719 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 420731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 420736 */     GIR_RootConstrainSelectedInstOperands,
     /* 420737 */     // GIR_Coverage, 257,
     /* 420737 */     GIR_EraseRootFromParent_Done,
     /* 420738 */   // Label 8183: @420738
     /* 420738 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(420772), // Rule ID 258 //
     /* 420743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 420750 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 420750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 420753 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 420765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 420770 */     GIR_RootConstrainSelectedInstOperands,
     /* 420771 */     // GIR_Coverage, 258,
     /* 420771 */     GIR_EraseRootFromParent_Done,
     /* 420772 */   // Label 8184: @420772
     /* 420772 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(420801), // Rule ID 273 //
     /* 420777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 420784 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 420784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 420787 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 420799 */     GIR_RootConstrainSelectedInstOperands,
     /* 420800 */     // GIR_Coverage, 273,
     /* 420800 */     GIR_EraseRootFromParent_Done,
     /* 420801 */   // Label 8185: @420801
     /* 420801 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(420830), // Rule ID 294 //
     /* 420806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 420813 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 420813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 420816 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 420828 */     GIR_RootConstrainSelectedInstOperands,
     /* 420829 */     // GIR_Coverage, 294,
     /* 420829 */     GIR_EraseRootFromParent_Done,
     /* 420830 */   // Label 8186: @420830
     /* 420830 */   GIM_Reject,
     /* 420831 */ // Label 8182: @420831
     /* 420831 */ GIM_Reject,
     /* 420832 */ // Label 123: @420832
     /* 420832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8199*/ GIMT_Encode4(421819),
     /* 420843 */ /*GILLT_s64*//*Label 8187*/ GIMT_Encode4(420927), GIMT_Encode4(0),
     /* 420851 */ /*GILLT_v2s32*//*Label 8188*/ GIMT_Encode4(420965),
     /* 420855 */ /*GILLT_v2s64*//*Label 8189*/ GIMT_Encode4(421003),
     /* 420859 */ /*GILLT_v4s16*//*Label 8190*/ GIMT_Encode4(421041),
     /* 420863 */ /*GILLT_v4s32*//*Label 8191*/ GIMT_Encode4(421079),
     /* 420867 */ /*GILLT_v8s8*//*Label 8192*/ GIMT_Encode4(421117),
     /* 420871 */ /*GILLT_v8s16*//*Label 8193*/ GIMT_Encode4(421155),
     /* 420875 */ /*GILLT_v16s8*//*Label 8194*/ GIMT_Encode4(421193), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 420895 */ /*GILLT_nxv2s64*//*Label 8195*/ GIMT_Encode4(421231), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 420907 */ /*GILLT_nxv4s32*//*Label 8196*/ GIMT_Encode4(421378), GIMT_Encode4(0),
     /* 420915 */ /*GILLT_nxv8s16*//*Label 8197*/ GIMT_Encode4(421525), GIMT_Encode4(0),
     /* 420923 */ /*GILLT_nxv16s8*//*Label 8198*/ GIMT_Encode4(421672),
     /* 420927 */ // Label 8187: @420927
     /* 420927 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(420964), // Rule ID 5088 //
     /* 420932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 420938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 420941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420957 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 420957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420962 */   GIR_RootConstrainSelectedInstOperands,
     /* 420963 */   // GIR_Coverage, 5088,
     /* 420963 */   GIR_Done,
     /* 420964 */ // Label 8200: @420964
     /* 420964 */ GIM_Reject,
     /* 420965 */ // Label 8188: @420965
     /* 420965 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(421002), // Rule ID 5087 //
     /* 420970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 420976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 420979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420995 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 420995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 421000 */   GIR_RootConstrainSelectedInstOperands,
     /* 421001 */   // GIR_Coverage, 5087,
     /* 421001 */   GIR_Done,
     /* 421002 */ // Label 8201: @421002
     /* 421002 */ GIM_Reject,
     /* 421003 */ // Label 8189: @421003
     /* 421003 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(421040), // Rule ID 5092 //
     /* 421008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 421011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 421014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 421017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421029 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421033 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 421033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 421038 */   GIR_RootConstrainSelectedInstOperands,
     /* 421039 */   // GIR_Coverage, 5092,
     /* 421039 */   GIR_Done,
     /* 421040 */ // Label 8202: @421040
     /* 421040 */ GIM_Reject,
     /* 421041 */ // Label 8190: @421041
     /* 421041 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(421078), // Rule ID 5086 //
     /* 421046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 421052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 421055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421071 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 421071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 421076 */   GIR_RootConstrainSelectedInstOperands,
     /* 421077 */   // GIR_Coverage, 5086,
     /* 421077 */   GIR_Done,
     /* 421078 */ // Label 8203: @421078
     /* 421078 */ GIM_Reject,
     /* 421079 */ // Label 8191: @421079
     /* 421079 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(421116), // Rule ID 5091 //
     /* 421084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 421090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 421093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421109 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 421109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 421114 */   GIR_RootConstrainSelectedInstOperands,
     /* 421115 */   // GIR_Coverage, 5091,
     /* 421115 */   GIR_Done,
     /* 421116 */ // Label 8204: @421116
     /* 421116 */ GIM_Reject,
     /* 421117 */ // Label 8192: @421117
     /* 421117 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(421154), // Rule ID 5085 //
     /* 421122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 421128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 421131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421143 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421147 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 421147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 421152 */   GIR_RootConstrainSelectedInstOperands,
     /* 421153 */   // GIR_Coverage, 5085,
     /* 421153 */   GIR_Done,
     /* 421154 */ // Label 8205: @421154
     /* 421154 */ GIM_Reject,
     /* 421155 */ // Label 8193: @421155
     /* 421155 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(421192), // Rule ID 5090 //
     /* 421160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 421166 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 421169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421181 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421185 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 421185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 421190 */   GIR_RootConstrainSelectedInstOperands,
     /* 421191 */   // GIR_Coverage, 5090,
     /* 421191 */   GIR_Done,
     /* 421192 */ // Label 8206: @421192
     /* 421192 */ GIM_Reject,
     /* 421193 */ // Label 8194: @421193
     /* 421193 */ GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(421230), // Rule ID 5089 //
     /* 421198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 421204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 421207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421219 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421223 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 421223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 421228 */   GIR_RootConstrainSelectedInstOperands,
     /* 421229 */   // GIR_Coverage, 5089,
     /* 421229 */   GIR_Done,
     /* 421230 */ // Label 8207: @421230
     /* 421230 */ GIM_Reject,
     /* 421231 */ // Label 8195: @421231
     /* 421231 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(421377),
     /* 421236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 421239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 421242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 421245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421249 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(421302), // Rule ID 11964 //
     /* 421254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 421269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 421273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421277 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421287 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 421287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421300 */     GIR_RootConstrainSelectedInstOperands,
     /* 421301 */     // GIR_Coverage, 11964,
     /* 421301 */     GIR_EraseRootFromParent_Done,
     /* 421302 */   // Label 8209: @421302
     /* 421302 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(421355), // Rule ID 11975 //
     /* 421307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 421322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 421326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421330 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421340 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 421340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421353 */     GIR_RootConstrainSelectedInstOperands,
     /* 421354 */     // GIR_Coverage, 11975,
     /* 421354 */     GIR_EraseRootFromParent_Done,
     /* 421355 */   // Label 8210: @421355
     /* 421355 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(421376), // Rule ID 11956 //
     /* 421360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421363 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 421363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421374 */     GIR_RootConstrainSelectedInstOperands,
     /* 421375 */     // GIR_Coverage, 11956,
     /* 421375 */     GIR_EraseRootFromParent_Done,
     /* 421376 */   // Label 8211: @421376
     /* 421376 */   GIM_Reject,
     /* 421377 */ // Label 8208: @421377
     /* 421377 */ GIM_Reject,
     /* 421378 */ // Label 8196: @421378
     /* 421378 */ GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(421524),
     /* 421383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 421386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 421389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 421392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421396 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(421449), // Rule ID 11962 //
     /* 421401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 421416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 421420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421424 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421434 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 421434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421447 */     GIR_RootConstrainSelectedInstOperands,
     /* 421448 */     // GIR_Coverage, 11962,
     /* 421448 */     GIR_EraseRootFromParent_Done,
     /* 421449 */   // Label 8213: @421449
     /* 421449 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(421502), // Rule ID 11972 //
     /* 421454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 421469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 421473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421477 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421483 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421487 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 421487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421500 */     GIR_RootConstrainSelectedInstOperands,
     /* 421501 */     // GIR_Coverage, 11972,
     /* 421501 */     GIR_EraseRootFromParent_Done,
     /* 421502 */   // Label 8214: @421502
     /* 421502 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(421523), // Rule ID 11954 //
     /* 421507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421510 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 421510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421521 */     GIR_RootConstrainSelectedInstOperands,
     /* 421522 */     // GIR_Coverage, 11954,
     /* 421522 */     GIR_EraseRootFromParent_Done,
     /* 421523 */   // Label 8215: @421523
     /* 421523 */   GIM_Reject,
     /* 421524 */ // Label 8212: @421524
     /* 421524 */ GIM_Reject,
     /* 421525 */ // Label 8197: @421525
     /* 421525 */ GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(421671),
     /* 421530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 421533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 421536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 421539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421543 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(421596), // Rule ID 11960 //
     /* 421548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 421563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 421567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421571 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421581 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 421581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421594 */     GIR_RootConstrainSelectedInstOperands,
     /* 421595 */     // GIR_Coverage, 11960,
     /* 421595 */     GIR_EraseRootFromParent_Done,
     /* 421596 */   // Label 8217: @421596
     /* 421596 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(421649), // Rule ID 11969 //
     /* 421601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 421616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 421620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421624 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421630 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421634 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 421634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421647 */     GIR_RootConstrainSelectedInstOperands,
     /* 421648 */     // GIR_Coverage, 11969,
     /* 421648 */     GIR_EraseRootFromParent_Done,
     /* 421649 */   // Label 8218: @421649
     /* 421649 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(421670), // Rule ID 11952 //
     /* 421654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421657 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 421657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421668 */     GIR_RootConstrainSelectedInstOperands,
     /* 421669 */     // GIR_Coverage, 11952,
     /* 421669 */     GIR_EraseRootFromParent_Done,
     /* 421670 */   // Label 8219: @421670
     /* 421670 */   GIM_Reject,
     /* 421671 */ // Label 8216: @421671
     /* 421671 */ GIM_Reject,
     /* 421672 */ // Label 8198: @421672
     /* 421672 */ GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(421818),
     /* 421677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 421680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 421683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 421686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421690 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(421743), // Rule ID 11958 //
     /* 421695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 421710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 421714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421728 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 421728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421741 */     GIR_RootConstrainSelectedInstOperands,
     /* 421742 */     // GIR_Coverage, 11958,
     /* 421742 */     GIR_EraseRootFromParent_Done,
     /* 421743 */   // Label 8221: @421743
     /* 421743 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(421796), // Rule ID 11966 //
     /* 421748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 421763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 421767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421771 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421781 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 421781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421794 */     GIR_RootConstrainSelectedInstOperands,
     /* 421795 */     // GIR_Coverage, 11966,
     /* 421795 */     GIR_EraseRootFromParent_Done,
     /* 421796 */   // Label 8222: @421796
     /* 421796 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(421817), // Rule ID 11950 //
     /* 421801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421804 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 421804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421815 */     GIR_RootConstrainSelectedInstOperands,
     /* 421816 */     // GIR_Coverage, 11950,
     /* 421816 */     GIR_EraseRootFromParent_Done,
     /* 421817 */   // Label 8223: @421817
     /* 421817 */   GIM_Reject,
     /* 421818 */ // Label 8220: @421818
     /* 421818 */ GIM_Reject,
     /* 421819 */ // Label 8199: @421819
     /* 421819 */ GIM_Reject,
     /* 421820 */ // Label 124: @421820
     /* 421820 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8232*/ GIMT_Encode4(423802),
     /* 421831 */ /*GILLT_s64*//*Label 8224*/ GIMT_Encode4(421867), GIMT_Encode4(0),
     /* 421839 */ /*GILLT_v2s32*//*Label 8225*/ GIMT_Encode4(422062),
     /* 421843 */ /*GILLT_v2s64*//*Label 8226*/ GIMT_Encode4(422309),
     /* 421847 */ /*GILLT_v4s16*//*Label 8227*/ GIMT_Encode4(422556),
     /* 421851 */ /*GILLT_v4s32*//*Label 8228*/ GIMT_Encode4(422832),
     /* 421855 */ /*GILLT_v8s8*//*Label 8229*/ GIMT_Encode4(423079),
     /* 421859 */ /*GILLT_v8s16*//*Label 8230*/ GIMT_Encode4(423304),
     /* 421863 */ /*GILLT_v16s8*//*Label 8231*/ GIMT_Encode4(423580),
     /* 421867 */ // Label 8224: @421867
     /* 421867 */ GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(422061),
     /* 421872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 421875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421879 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(421926), // Rule ID 6466 //
     /* 421884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421899 */     // MIs[1] Rn
     /* 421899 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421910 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421924 */     GIR_RootConstrainSelectedInstOperands,
     /* 421925 */     // GIR_Coverage, 6466,
     /* 421925 */     GIR_EraseRootFromParent_Done,
     /* 421926 */   // Label 8234: @421926
     /* 421926 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(421973), // Rule ID 6477 //
     /* 421931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421946 */     // MIs[1] Rn
     /* 421946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421957 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421971 */     GIR_RootConstrainSelectedInstOperands,
     /* 421972 */     // GIR_Coverage, 6477,
     /* 421972 */     GIR_EraseRootFromParent_Done,
     /* 421973 */   // Label 8235: @421973
     /* 421973 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(422020), // Rule ID 13292 //
     /* 421978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421993 */     // MIs[1] Rn
     /* 421993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422004 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 422007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422018 */     GIR_RootConstrainSelectedInstOperands,
     /* 422019 */     // GIR_Coverage, 13292,
     /* 422019 */     GIR_EraseRootFromParent_Done,
     /* 422020 */   // Label 8236: @422020
     /* 422020 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(422040), // Rule ID 5651 //
     /* 422025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 422029 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 422029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 422034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422039 */     // GIR_Coverage, 5651,
     /* 422039 */     GIR_Done,
     /* 422040 */   // Label 8237: @422040
     /* 422040 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(422060), // Rule ID 5652 //
     /* 422045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422049 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 422049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 422054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422059 */     // GIR_Coverage, 5652,
     /* 422059 */     GIR_Done,
     /* 422060 */   // Label 8238: @422060
     /* 422060 */   GIM_Reject,
     /* 422061 */ // Label 8233: @422061
     /* 422061 */ GIM_Reject,
     /* 422062 */ // Label 8225: @422062
     /* 422062 */ GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(422308),
     /* 422067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422074 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(422121), // Rule ID 6463 //
     /* 422079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422094 */     // MIs[1] Rn
     /* 422094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422105 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 422108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422119 */     GIR_RootConstrainSelectedInstOperands,
     /* 422120 */     // GIR_Coverage, 6463,
     /* 422120 */     GIR_EraseRootFromParent_Done,
     /* 422121 */   // Label 8240: @422121
     /* 422121 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(422168), // Rule ID 6474 //
     /* 422126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422141 */     // MIs[1] Rn
     /* 422141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422152 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 422155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422166 */     GIR_RootConstrainSelectedInstOperands,
     /* 422167 */     // GIR_Coverage, 6474,
     /* 422167 */     GIR_EraseRootFromParent_Done,
     /* 422168 */   // Label 8241: @422168
     /* 422168 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(422215), // Rule ID 13289 //
     /* 422173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422188 */     // MIs[1] Rn
     /* 422188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422199 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 422202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422213 */     GIR_RootConstrainSelectedInstOperands,
     /* 422214 */     // GIR_Coverage, 13289,
     /* 422214 */     GIR_EraseRootFromParent_Done,
     /* 422215 */   // Label 8242: @422215
     /* 422215 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(422234), // Rule ID 1916 //
     /* 422220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422227 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 422227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 422232 */     GIR_RootConstrainSelectedInstOperands,
     /* 422233 */     // GIR_Coverage, 1916,
     /* 422233 */     GIR_Done,
     /* 422234 */   // Label 8243: @422234
     /* 422234 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(422307), // Rule ID 5653 //
     /* 422239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422243 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 422246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 422260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 422279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422305 */     GIR_RootConstrainSelectedInstOperands,
     /* 422306 */     // GIR_Coverage, 5653,
     /* 422306 */     GIR_EraseRootFromParent_Done,
     /* 422307 */   // Label 8244: @422307
     /* 422307 */   GIM_Reject,
     /* 422308 */ // Label 8239: @422308
     /* 422308 */ GIM_Reject,
     /* 422309 */ // Label 8226: @422309
     /* 422309 */ GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(422555),
     /* 422314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 422317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422321 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(422368), // Rule ID 6465 //
     /* 422326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422341 */     // MIs[1] Rn
     /* 422341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422352 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422366 */     GIR_RootConstrainSelectedInstOperands,
     /* 422367 */     // GIR_Coverage, 6465,
     /* 422367 */     GIR_EraseRootFromParent_Done,
     /* 422368 */   // Label 8246: @422368
     /* 422368 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(422415), // Rule ID 6476 //
     /* 422373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422388 */     // MIs[1] Rn
     /* 422388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422399 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422413 */     GIR_RootConstrainSelectedInstOperands,
     /* 422414 */     // GIR_Coverage, 6476,
     /* 422414 */     GIR_EraseRootFromParent_Done,
     /* 422415 */   // Label 8247: @422415
     /* 422415 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(422462), // Rule ID 13291 //
     /* 422420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422435 */     // MIs[1] Rn
     /* 422435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422446 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422460 */     GIR_RootConstrainSelectedInstOperands,
     /* 422461 */     // GIR_Coverage, 13291,
     /* 422461 */     GIR_EraseRootFromParent_Done,
     /* 422462 */   // Label 8248: @422462
     /* 422462 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(422481), // Rule ID 1918 //
     /* 422467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 422474 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 422474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 422479 */     GIR_RootConstrainSelectedInstOperands,
     /* 422480 */     // GIR_Coverage, 1918,
     /* 422480 */     GIR_Done,
     /* 422481 */   // Label 8249: @422481
     /* 422481 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(422554), // Rule ID 5655 //
     /* 422486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422490 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 422493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 422507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422516 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 422526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 422544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422552 */     GIR_RootConstrainSelectedInstOperands,
     /* 422553 */     // GIR_Coverage, 5655,
     /* 422553 */     GIR_EraseRootFromParent_Done,
     /* 422554 */   // Label 8250: @422554
     /* 422554 */   GIM_Reject,
     /* 422555 */ // Label 8245: @422555
     /* 422555 */ GIM_Reject,
     /* 422556 */ // Label 8227: @422556
     /* 422556 */ GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(422617), // Rule ID 6461 //
     /* 422561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422576 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422579 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422583 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 422590 */   // MIs[1] Rn
     /* 422590 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422601 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 422604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422606 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422610 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422615 */   GIR_RootConstrainSelectedInstOperands,
     /* 422616 */   // GIR_Coverage, 6461,
     /* 422616 */   GIR_EraseRootFromParent_Done,
     /* 422617 */ // Label 8251: @422617
     /* 422617 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(422671), // Rule ID 6478 //
     /* 422622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422637 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422644 */   // MIs[1] Rn
     /* 422644 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422653 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422655 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 422658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422660 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422669 */   GIR_RootConstrainSelectedInstOperands,
     /* 422670 */   // GIR_Coverage, 6478,
     /* 422670 */   GIR_EraseRootFromParent_Done,
     /* 422671 */ // Label 8252: @422671
     /* 422671 */ GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(422725), // Rule ID 13287 //
     /* 422676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422691 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422698 */   // MIs[1] Rn
     /* 422698 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422702 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422707 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422709 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 422712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422714 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422723 */   GIR_RootConstrainSelectedInstOperands,
     /* 422724 */   // GIR_Coverage, 13287,
     /* 422724 */   GIR_EraseRootFromParent_Done,
     /* 422725 */ // Label 8253: @422725
     /* 422725 */ GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(422751), // Rule ID 1914 //
     /* 422730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422744 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 422744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 422749 */   GIR_RootConstrainSelectedInstOperands,
     /* 422750 */   // GIR_Coverage, 1914,
     /* 422750 */   GIR_Done,
     /* 422751 */ // Label 8254: @422751
     /* 422751 */ GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(422831), // Rule ID 5656 //
     /* 422756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422767 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422767 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 422770 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422774 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 422784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422793 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422796 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422800 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 422803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422829 */   GIR_RootConstrainSelectedInstOperands,
     /* 422830 */   // GIR_Coverage, 5656,
     /* 422830 */   GIR_EraseRootFromParent_Done,
     /* 422831 */ // Label 8255: @422831
     /* 422831 */ GIM_Reject,
     /* 422832 */ // Label 8228: @422832
     /* 422832 */ GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(423078),
     /* 422837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422844 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(422891), // Rule ID 6464 //
     /* 422849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422864 */     // MIs[1] Rn
     /* 422864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422875 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422889 */     GIR_RootConstrainSelectedInstOperands,
     /* 422890 */     // GIR_Coverage, 6464,
     /* 422890 */     GIR_EraseRootFromParent_Done,
     /* 422891 */   // Label 8257: @422891
     /* 422891 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(422938), // Rule ID 6475 //
     /* 422896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422911 */     // MIs[1] Rn
     /* 422911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422922 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422936 */     GIR_RootConstrainSelectedInstOperands,
     /* 422937 */     // GIR_Coverage, 6475,
     /* 422937 */     GIR_EraseRootFromParent_Done,
     /* 422938 */   // Label 8258: @422938
     /* 422938 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(422985), // Rule ID 13290 //
     /* 422943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422958 */     // MIs[1] Rn
     /* 422958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422969 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422983 */     GIR_RootConstrainSelectedInstOperands,
     /* 422984 */     // GIR_Coverage, 13290,
     /* 422984 */     GIR_EraseRootFromParent_Done,
     /* 422985 */   // Label 8259: @422985
     /* 422985 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(423004), // Rule ID 1917 //
     /* 422990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422997 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 422997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 423002 */     GIR_RootConstrainSelectedInstOperands,
     /* 423003 */     // GIR_Coverage, 1917,
     /* 423003 */     GIR_Done,
     /* 423004 */   // Label 8260: @423004
     /* 423004 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(423077), // Rule ID 5654 //
     /* 423009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 423013 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423013 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 423016 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423020 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 423030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 423049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 423064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 423067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423075 */     GIR_RootConstrainSelectedInstOperands,
     /* 423076 */     // GIR_Coverage, 5654,
     /* 423076 */     GIR_EraseRootFromParent_Done,
     /* 423077 */   // Label 8261: @423077
     /* 423077 */   GIM_Reject,
     /* 423078 */ // Label 8256: @423078
     /* 423078 */ GIM_Reject,
     /* 423079 */ // Label 8229: @423079
     /* 423079 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(423136), // Rule ID 13285 //
     /* 423084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 423087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423099 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423106 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 423110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423112 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 423119 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 423122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 423129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423134 */   GIR_RootConstrainSelectedInstOperands,
     /* 423135 */   // GIR_Coverage, 13285,
     /* 423135 */   GIR_EraseRootFromParent_Done,
     /* 423136 */ // Label 8262: @423136
     /* 423136 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(423197), // Rule ID 6459 //
     /* 423141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423156 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423159 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423163 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 423170 */   // MIs[1] Rn
     /* 423170 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423174 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423181 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 423184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423186 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423195 */   GIR_RootConstrainSelectedInstOperands,
     /* 423196 */   // GIR_Coverage, 6459,
     /* 423196 */   GIR_EraseRootFromParent_Done,
     /* 423197 */ // Label 8263: @423197
     /* 423197 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(423223), // Rule ID 1912 //
     /* 423202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423216 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 423216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 423221 */   GIR_RootConstrainSelectedInstOperands,
     /* 423222 */   // GIR_Coverage, 1912,
     /* 423222 */   GIR_Done,
     /* 423223 */ // Label 8264: @423223
     /* 423223 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(423303), // Rule ID 5658 //
     /* 423228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 423231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423239 */   // (AArch64dup:{ *:[v8i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv8i8lane:{ *:[v8i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423239 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 423242 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423246 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 423256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423265 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423268 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423272 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 423275 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423280 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423285 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 423293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423301 */   GIR_RootConstrainSelectedInstOperands,
     /* 423302 */   // GIR_Coverage, 5658,
     /* 423302 */   GIR_EraseRootFromParent_Done,
     /* 423303 */ // Label 8265: @423303
     /* 423303 */ GIM_Reject,
     /* 423304 */ // Label 8230: @423304
     /* 423304 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(423365), // Rule ID 6462 //
     /* 423309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423324 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423327 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423331 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 423338 */   // MIs[1] Rn
     /* 423338 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423342 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423349 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423358 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423363 */   GIR_RootConstrainSelectedInstOperands,
     /* 423364 */   // GIR_Coverage, 6462,
     /* 423364 */   GIR_EraseRootFromParent_Done,
     /* 423365 */ // Label 8266: @423365
     /* 423365 */ GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(423419), // Rule ID 6479 //
     /* 423370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423377 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423381 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423385 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423392 */   // MIs[1] Rn
     /* 423392 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423396 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423401 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423403 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423408 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423417 */   GIR_RootConstrainSelectedInstOperands,
     /* 423418 */   // GIR_Coverage, 6479,
     /* 423418 */   GIR_EraseRootFromParent_Done,
     /* 423419 */ // Label 8267: @423419
     /* 423419 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(423473), // Rule ID 13288 //
     /* 423424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423439 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423442 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423446 */   // MIs[1] Rn
     /* 423446 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423450 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423457 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423462 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423471 */   GIR_RootConstrainSelectedInstOperands,
     /* 423472 */   // GIR_Coverage, 13288,
     /* 423472 */   GIR_EraseRootFromParent_Done,
     /* 423473 */ // Label 8268: @423473
     /* 423473 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(423499), // Rule ID 1915 //
     /* 423478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423492 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 423492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 423497 */   GIR_RootConstrainSelectedInstOperands,
     /* 423498 */   // GIR_Coverage, 1915,
     /* 423498 */   GIR_Done,
     /* 423499 */ // Label 8269: @423499
     /* 423499 */ GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(423579), // Rule ID 5657 //
     /* 423504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 423515 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423515 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 423518 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423522 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423529 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 423532 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423536 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423541 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423544 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423548 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 423551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423561 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 423566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 423569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423577 */   GIR_RootConstrainSelectedInstOperands,
     /* 423578 */   // GIR_Coverage, 5657,
     /* 423578 */   GIR_EraseRootFromParent_Done,
     /* 423579 */ // Label 8270: @423579
     /* 423579 */ GIM_Reject,
     /* 423580 */ // Label 8231: @423580
     /* 423580 */ GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(423641), // Rule ID 6460 //
     /* 423585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423600 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423603 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423607 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 423614 */   // MIs[1] Rn
     /* 423614 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423618 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423625 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 423628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423630 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423639 */   GIR_RootConstrainSelectedInstOperands,
     /* 423640 */   // GIR_Coverage, 6460,
     /* 423640 */   GIR_EraseRootFromParent_Done,
     /* 423641 */ // Label 8271: @423641
     /* 423641 */ GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(423695), // Rule ID 13286 //
     /* 423646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 423649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423661 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423664 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423668 */   // MIs[1] Rn
     /* 423668 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423672 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423679 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 423682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423684 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423688 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423693 */   GIR_RootConstrainSelectedInstOperands,
     /* 423694 */   // GIR_Coverage, 13286,
     /* 423694 */   GIR_EraseRootFromParent_Done,
     /* 423695 */ // Label 8272: @423695
     /* 423695 */ GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(423721), // Rule ID 1913 //
     /* 423700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423714 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 423714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 423719 */   GIR_RootConstrainSelectedInstOperands,
     /* 423720 */   // GIR_Coverage, 1913,
     /* 423720 */   GIR_Done,
     /* 423721 */ // Label 8273: @423721
     /* 423721 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(423801), // Rule ID 5659 //
     /* 423726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 423729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423737 */   // (AArch64dup:{ *:[v16i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv16i8lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423737 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 423740 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423744 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 423754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423763 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423766 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423770 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 423773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423783 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 423791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423799 */   GIR_RootConstrainSelectedInstOperands,
     /* 423800 */   // GIR_Coverage, 5659,
     /* 423800 */   GIR_EraseRootFromParent_Done,
     /* 423801 */ // Label 8274: @423801
     /* 423801 */ GIM_Reject,
     /* 423802 */ // Label 8232: @423802
     /* 423802 */ GIM_Reject,
     /* 423803 */ // Label 125: @423803
     /* 423803 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8277*/ GIMT_Encode4(424057),
     /* 423814 */ /*GILLT_v4s16*//*Label 8275*/ GIMT_Encode4(423830), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 423826 */ /*GILLT_v8s16*//*Label 8276*/ GIMT_Encode4(423916),
     /* 423830 */ // Label 8275: @423830
     /* 423830 */ GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(423915),
     /* 423835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423849 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(423883), // Rule ID 1922 //
     /* 423854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423869 */     // MIs[1] Operand 1
     /* 423869 */     // No operand predicates
     /* 423869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423871 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 423874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423881 */     GIR_RootConstrainSelectedInstOperands,
     /* 423882 */     // GIR_Coverage, 1922,
     /* 423882 */     GIR_EraseRootFromParent_Done,
     /* 423883 */   // Label 8279: @423883
     /* 423883 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(423914), // Rule ID 5660 //
     /* 423888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423900 */     // MIs[1] Operand 1
     /* 423900 */     // No operand predicates
     /* 423900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423902 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 423902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 423905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423912 */     GIR_RootConstrainSelectedInstOperands,
     /* 423913 */     // GIR_Coverage, 5660,
     /* 423913 */     GIR_EraseRootFromParent_Done,
     /* 423914 */   // Label 8280: @423914
     /* 423914 */   GIM_Reject,
     /* 423915 */ // Label 8278: @423915
     /* 423915 */ GIM_Reject,
     /* 423916 */ // Label 8276: @423916
     /* 423916 */ GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(424056),
     /* 423921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423931 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(423982), // Rule ID 6470 //
     /* 423936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423951 */     // MIs[1] Rn
     /* 423951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423966 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423980 */     GIR_RootConstrainSelectedInstOperands,
     /* 423981 */     // GIR_Coverage, 6470,
     /* 423981 */     GIR_EraseRootFromParent_Done,
     /* 423982 */   // Label 8282: @423982
     /* 423982 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(424020), // Rule ID 1923 //
     /* 423987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 424006 */     // MIs[1] Operand 1
     /* 424006 */     // No operand predicates
     /* 424006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424008 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 424011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424018 */     GIR_RootConstrainSelectedInstOperands,
     /* 424019 */     // GIR_Coverage, 1923,
     /* 424019 */     GIR_EraseRootFromParent_Done,
     /* 424020 */   // Label 8283: @424020
     /* 424020 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(424055), // Rule ID 5661 //
     /* 424025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 424041 */     // MIs[1] Operand 1
     /* 424041 */     // No operand predicates
     /* 424041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424043 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 424043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 424046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424053 */     GIR_RootConstrainSelectedInstOperands,
     /* 424054 */     // GIR_Coverage, 5661,
     /* 424054 */     GIR_EraseRootFromParent_Done,
     /* 424055 */   // Label 8284: @424055
     /* 424055 */   GIM_Reject,
     /* 424056 */ // Label 8281: @424056
     /* 424056 */ GIM_Reject,
     /* 424057 */ // Label 8277: @424057
     /* 424057 */ GIM_Reject,
     /* 424058 */ // Label 126: @424058
     /* 424058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8287*/ GIMT_Encode4(424312),
     /* 424069 */ /*GILLT_v2s32*//*Label 8285*/ GIMT_Encode4(424085), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 424081 */ /*GILLT_v4s32*//*Label 8286*/ GIMT_Encode4(424171),
     /* 424085 */ // Label 8285: @424085
     /* 424085 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(424170),
     /* 424090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424104 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(424138), // Rule ID 1920 //
     /* 424109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424124 */     // MIs[1] Operand 1
     /* 424124 */     // No operand predicates
     /* 424124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424126 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 424129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424136 */     GIR_RootConstrainSelectedInstOperands,
     /* 424137 */     // GIR_Coverage, 1920,
     /* 424137 */     GIR_EraseRootFromParent_Done,
     /* 424138 */   // Label 8289: @424138
     /* 424138 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(424169), // Rule ID 5662 //
     /* 424143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424155 */     // MIs[1] Operand 1
     /* 424155 */     // No operand predicates
     /* 424155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424157 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 424157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 424160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424167 */     GIR_RootConstrainSelectedInstOperands,
     /* 424168 */     // GIR_Coverage, 5662,
     /* 424168 */     GIR_EraseRootFromParent_Done,
     /* 424169 */   // Label 8290: @424169
     /* 424169 */   GIM_Reject,
     /* 424170 */ // Label 8288: @424170
     /* 424170 */ GIM_Reject,
     /* 424171 */ // Label 8286: @424171
     /* 424171 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(424311),
     /* 424176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424186 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(424237), // Rule ID 6472 //
     /* 424191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424199 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424206 */     // MIs[1] Rn
     /* 424206 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 424219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424221 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 424224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424235 */     GIR_RootConstrainSelectedInstOperands,
     /* 424236 */     // GIR_Coverage, 6472,
     /* 424236 */     GIR_EraseRootFromParent_Done,
     /* 424237 */   // Label 8292: @424237
     /* 424237 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(424275), // Rule ID 1921 //
     /* 424242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424261 */     // MIs[1] Operand 1
     /* 424261 */     // No operand predicates
     /* 424261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424263 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 424266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424273 */     GIR_RootConstrainSelectedInstOperands,
     /* 424274 */     // GIR_Coverage, 1921,
     /* 424274 */     GIR_EraseRootFromParent_Done,
     /* 424275 */   // Label 8293: @424275
     /* 424275 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(424310), // Rule ID 5663 //
     /* 424280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424296 */     // MIs[1] Operand 1
     /* 424296 */     // No operand predicates
     /* 424296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424298 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 424298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 424301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424308 */     GIR_RootConstrainSelectedInstOperands,
     /* 424309 */     // GIR_Coverage, 5663,
     /* 424309 */     GIR_EraseRootFromParent_Done,
     /* 424310 */   // Label 8294: @424310
     /* 424310 */   GIM_Reject,
     /* 424311 */ // Label 8291: @424311
     /* 424311 */ GIM_Reject,
     /* 424312 */ // Label 8287: @424312
     /* 424312 */ GIM_Reject,
     /* 424313 */ // Label 127: @424313
     /* 424313 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(424458),
     /* 424318 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 424321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424331 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(424382), // Rule ID 6473 //
     /* 424336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424351 */     // MIs[1] Rn
     /* 424351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 424364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424366 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 424369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424380 */     GIR_RootConstrainSelectedInstOperands,
     /* 424381 */     // GIR_Coverage, 6473,
     /* 424381 */     GIR_EraseRootFromParent_Done,
     /* 424382 */   // Label 8296: @424382
     /* 424382 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(424457),
     /* 424387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424391 */     GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(424425), // Rule ID 1919 //
     /* 424396 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424399 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424403 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424407 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 424411 */       // MIs[1] Operand 1
     /* 424411 */       // No operand predicates
     /* 424411 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424413 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424413 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 424416 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424418 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424420 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424423 */       GIR_RootConstrainSelectedInstOperands,
     /* 424424 */       // GIR_Coverage, 1919,
     /* 424424 */       GIR_EraseRootFromParent_Done,
     /* 424425 */     // Label 8298: @424425
     /* 424425 */     GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(424456), // Rule ID 5664 //
     /* 424430 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424434 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424438 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 424442 */       // MIs[1] Operand 1
     /* 424442 */       // No operand predicates
     /* 424442 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424444 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 424444 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 424447 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424449 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424451 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424454 */       GIR_RootConstrainSelectedInstOperands,
     /* 424455 */       // GIR_Coverage, 5664,
     /* 424455 */       GIR_EraseRootFromParent_Done,
     /* 424456 */     // Label 8299: @424456
     /* 424456 */     GIM_Reject,
     /* 424457 */   // Label 8297: @424457
     /* 424457 */   GIM_Reject,
     /* 424458 */ // Label 8295: @424458
     /* 424458 */ GIM_Reject,
     /* 424459 */ // Label 128: @424459
     /* 424459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8302*/ GIMT_Encode4(424637),
     /* 424470 */ /*GILLT_v8s8*//*Label 8300*/ GIMT_Encode4(424482), GIMT_Encode4(0),
     /* 424478 */ /*GILLT_v16s8*//*Label 8301*/ GIMT_Encode4(424531),
     /* 424482 */ // Label 8300: @424482
     /* 424482 */ GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(424530), // Rule ID 1924 //
     /* 424487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424512 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 424516 */   // MIs[1] Operand 1
     /* 424516 */   // No operand predicates
     /* 424516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424518 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 424521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424523 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424525 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424528 */   GIR_RootConstrainSelectedInstOperands,
     /* 424529 */   // GIR_Coverage, 1924,
     /* 424529 */   GIR_EraseRootFromParent_Done,
     /* 424530 */ // Label 8303: @424530
     /* 424530 */ GIM_Reject,
     /* 424531 */ // Label 8301: @424531
     /* 424531 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(424636),
     /* 424536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424546 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(424597), // Rule ID 6468 //
     /* 424551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424559 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424562 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424566 */     // MIs[1] Rn
     /* 424566 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 424579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424581 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 424584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424595 */     GIR_RootConstrainSelectedInstOperands,
     /* 424596 */     // GIR_Coverage, 6468,
     /* 424596 */     GIR_EraseRootFromParent_Done,
     /* 424597 */   // Label 8305: @424597
     /* 424597 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(424635), // Rule ID 1925 //
     /* 424602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 424621 */     // MIs[1] Operand 1
     /* 424621 */     // No operand predicates
     /* 424621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424623 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 424626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424633 */     GIR_RootConstrainSelectedInstOperands,
     /* 424634 */     // GIR_Coverage, 1925,
     /* 424634 */     GIR_EraseRootFromParent_Done,
     /* 424635 */   // Label 8306: @424635
     /* 424635 */   GIM_Reject,
     /* 424636 */ // Label 8304: @424636
     /* 424636 */ GIM_Reject,
     /* 424637 */ // Label 8302: @424637
     /* 424637 */ GIM_Reject,
     /* 424638 */ // Label 129: @424638
     /* 424638 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8316*/ GIMT_Encode4(426287),
     /* 424649 */ /*GILLT_s64*//*Label 8307*/ GIMT_Encode4(424733), GIMT_Encode4(0),
     /* 424657 */ /*GILLT_v2s32*//*Label 8308*/ GIMT_Encode4(425054),
     /* 424661 */ /*GILLT_v2s64*//*Label 8309*/ GIMT_Encode4(425375),
     /* 424665 */ /*GILLT_v4s16*//*Label 8310*/ GIMT_Encode4(425458),
     /* 424669 */ /*GILLT_v4s32*//*Label 8311*/ GIMT_Encode4(425779),
     /* 424673 */ /*GILLT_v8s8*//*Label 8312*/ GIMT_Encode4(425862),
     /* 424677 */ /*GILLT_v8s16*//*Label 8313*/ GIMT_Encode4(426071),
     /* 424681 */ /*GILLT_v16s8*//*Label 8314*/ GIMT_Encode4(426154), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 424729 */ /*GILLT_nxv16s8*//*Label 8315*/ GIMT_Encode4(426240),
     /* 424733 */ // Label 8307: @424733
     /* 424733 */ GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(425053),
     /* 424738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 424741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424748 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(424863), // Rule ID 5479 //
     /* 424753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424770 */     // MIs[1] Operand 2
     /* 424770 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424789 */     // MIs[2] Rn
     /* 424789 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424794 */     // MIs[2] Operand 2
     /* 424794 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 424805 */     // MIs[0] imm
     /* 424805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424813 */     // MIs[3] Operand 1
     /* 424813 */     // No operand predicates
     /* 424813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424815 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424827 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424845 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424862 */     // GIR_Coverage, 5479,
     /* 424862 */     GIR_EraseRootFromParent_Done,
     /* 424863 */   // Label 8318: @424863
     /* 424863 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(424978), // Rule ID 5484 //
     /* 424868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424885 */     // MIs[1] Operand 2
     /* 424885 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424904 */     // MIs[2] Rn
     /* 424904 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424909 */     // MIs[2] Operand 2
     /* 424909 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 424920 */     // MIs[0] imm
     /* 424920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424928 */     // MIs[3] Operand 1
     /* 424928 */     // No operand predicates
     /* 424928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424930 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424960 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424977 */     // GIR_Coverage, 5484,
     /* 424977 */     GIR_EraseRootFromParent_Done,
     /* 424978 */   // Label 8319: @424978
     /* 424978 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(425015), // Rule ID 5476 //
     /* 424983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424991 */     // MIs[0] imm
     /* 424991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424999 */     // MIs[1] Operand 1
     /* 424999 */     // No operand predicates
     /* 424999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425001 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425013 */     GIR_RootConstrainSelectedInstOperands,
     /* 425014 */     // GIR_Coverage, 5476,
     /* 425014 */     GIR_EraseRootFromParent_Done,
     /* 425015 */   // Label 8320: @425015
     /* 425015 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(425052), // Rule ID 5481 //
     /* 425020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425028 */     // MIs[0] imm
     /* 425028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425036 */     // MIs[1] Operand 1
     /* 425036 */     // No operand predicates
     /* 425036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425038 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425050 */     GIR_RootConstrainSelectedInstOperands,
     /* 425051 */     // GIR_Coverage, 5481,
     /* 425051 */     GIR_EraseRootFromParent_Done,
     /* 425052 */   // Label 8321: @425052
     /* 425052 */   GIM_Reject,
     /* 425053 */ // Label 8317: @425053
     /* 425053 */ GIM_Reject,
     /* 425054 */ // Label 8308: @425054
     /* 425054 */ GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(425374),
     /* 425059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 425065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425069 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(425184), // Rule ID 5469 //
     /* 425074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425091 */     // MIs[1] Operand 2
     /* 425091 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425110 */     // MIs[2] Rn
     /* 425110 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425115 */     // MIs[2] Operand 2
     /* 425115 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 425126 */     // MIs[0] imm
     /* 425126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425134 */     // MIs[3] Operand 1
     /* 425134 */     // No operand predicates
     /* 425134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425136 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425166 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425183 */     // GIR_Coverage, 5469,
     /* 425183 */     GIR_EraseRootFromParent_Done,
     /* 425184 */   // Label 8323: @425184
     /* 425184 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(425299), // Rule ID 5474 //
     /* 425189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425206 */     // MIs[1] Operand 2
     /* 425206 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425225 */     // MIs[2] Rn
     /* 425225 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425230 */     // MIs[2] Operand 2
     /* 425230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 425241 */     // MIs[0] imm
     /* 425241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425249 */     // MIs[3] Operand 1
     /* 425249 */     // No operand predicates
     /* 425249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425251 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425281 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425298 */     // GIR_Coverage, 5474,
     /* 425298 */     GIR_EraseRootFromParent_Done,
     /* 425299 */   // Label 8324: @425299
     /* 425299 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(425336), // Rule ID 5466 //
     /* 425304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425312 */     // MIs[0] imm
     /* 425312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425320 */     // MIs[1] Operand 1
     /* 425320 */     // No operand predicates
     /* 425320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425322 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425334 */     GIR_RootConstrainSelectedInstOperands,
     /* 425335 */     // GIR_Coverage, 5466,
     /* 425335 */     GIR_EraseRootFromParent_Done,
     /* 425336 */   // Label 8325: @425336
     /* 425336 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(425373), // Rule ID 5471 //
     /* 425341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425349 */     // MIs[0] imm
     /* 425349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425357 */     // MIs[1] Operand 1
     /* 425357 */     // No operand predicates
     /* 425357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425359 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425371 */     GIR_RootConstrainSelectedInstOperands,
     /* 425372 */     // GIR_Coverage, 5471,
     /* 425372 */     GIR_EraseRootFromParent_Done,
     /* 425373 */   // Label 8326: @425373
     /* 425373 */   GIM_Reject,
     /* 425374 */ // Label 8322: @425374
     /* 425374 */ GIM_Reject,
     /* 425375 */ // Label 8309: @425375
     /* 425375 */ GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(425457),
     /* 425380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 425386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425398 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(425427), // Rule ID 5477 //
     /* 425403 */     // MIs[0] imm
     /* 425403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425411 */     // MIs[1] Operand 1
     /* 425411 */     // No operand predicates
     /* 425411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425413 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425425 */     GIR_RootConstrainSelectedInstOperands,
     /* 425426 */     // GIR_Coverage, 5477,
     /* 425426 */     GIR_EraseRootFromParent_Done,
     /* 425427 */   // Label 8328: @425427
     /* 425427 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(425456), // Rule ID 5482 //
     /* 425432 */     // MIs[0] imm
     /* 425432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425440 */     // MIs[1] Operand 1
     /* 425440 */     // No operand predicates
     /* 425440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425442 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425454 */     GIR_RootConstrainSelectedInstOperands,
     /* 425455 */     // GIR_Coverage, 5482,
     /* 425455 */     GIR_EraseRootFromParent_Done,
     /* 425456 */   // Label 8329: @425456
     /* 425456 */   GIM_Reject,
     /* 425457 */ // Label 8327: @425457
     /* 425457 */ GIM_Reject,
     /* 425458 */ // Label 8310: @425458
     /* 425458 */ GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(425778),
     /* 425463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 425469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425473 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(425588), // Rule ID 5459 //
     /* 425478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425495 */     // MIs[1] Operand 2
     /* 425495 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425514 */     // MIs[2] Rn
     /* 425514 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425519 */     // MIs[2] Operand 2
     /* 425519 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 425530 */     // MIs[0] imm
     /* 425530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425538 */     // MIs[3] Operand 1
     /* 425538 */     // No operand predicates
     /* 425538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425540 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425570 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425587 */     // GIR_Coverage, 5459,
     /* 425587 */     GIR_EraseRootFromParent_Done,
     /* 425588 */   // Label 8331: @425588
     /* 425588 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(425703), // Rule ID 5464 //
     /* 425593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425610 */     // MIs[1] Operand 2
     /* 425610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425629 */     // MIs[2] Rn
     /* 425629 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425634 */     // MIs[2] Operand 2
     /* 425634 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 425645 */     // MIs[0] imm
     /* 425645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425653 */     // MIs[3] Operand 1
     /* 425653 */     // No operand predicates
     /* 425653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425655 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425685 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425702 */     // GIR_Coverage, 5464,
     /* 425702 */     GIR_EraseRootFromParent_Done,
     /* 425703 */   // Label 8332: @425703
     /* 425703 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(425740), // Rule ID 5456 //
     /* 425708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425716 */     // MIs[0] imm
     /* 425716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425724 */     // MIs[1] Operand 1
     /* 425724 */     // No operand predicates
     /* 425724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425726 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425738 */     GIR_RootConstrainSelectedInstOperands,
     /* 425739 */     // GIR_Coverage, 5456,
     /* 425739 */     GIR_EraseRootFromParent_Done,
     /* 425740 */   // Label 8333: @425740
     /* 425740 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(425777), // Rule ID 5461 //
     /* 425745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425753 */     // MIs[0] imm
     /* 425753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425761 */     // MIs[1] Operand 1
     /* 425761 */     // No operand predicates
     /* 425761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425763 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425775 */     GIR_RootConstrainSelectedInstOperands,
     /* 425776 */     // GIR_Coverage, 5461,
     /* 425776 */     GIR_EraseRootFromParent_Done,
     /* 425777 */   // Label 8334: @425777
     /* 425777 */   GIM_Reject,
     /* 425778 */ // Label 8330: @425778
     /* 425778 */ GIM_Reject,
     /* 425779 */ // Label 8311: @425779
     /* 425779 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(425861),
     /* 425784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 425790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425802 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(425831), // Rule ID 5467 //
     /* 425807 */     // MIs[0] imm
     /* 425807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425815 */     // MIs[1] Operand 1
     /* 425815 */     // No operand predicates
     /* 425815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425817 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425829 */     GIR_RootConstrainSelectedInstOperands,
     /* 425830 */     // GIR_Coverage, 5467,
     /* 425830 */     GIR_EraseRootFromParent_Done,
     /* 425831 */   // Label 8336: @425831
     /* 425831 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(425860), // Rule ID 5472 //
     /* 425836 */     // MIs[0] imm
     /* 425836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425844 */     // MIs[1] Operand 1
     /* 425844 */     // No operand predicates
     /* 425844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425846 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425858 */     GIR_RootConstrainSelectedInstOperands,
     /* 425859 */     // GIR_Coverage, 5472,
     /* 425859 */     GIR_EraseRootFromParent_Done,
     /* 425860 */   // Label 8337: @425860
     /* 425860 */   GIM_Reject,
     /* 425861 */ // Label 8335: @425861
     /* 425861 */ GIM_Reject,
     /* 425862 */ // Label 8312: @425862
     /* 425862 */ GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(426070),
     /* 425867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 425870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 425873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425877 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(425992), // Rule ID 5454 //
     /* 425882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 425894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425899 */     // MIs[1] Operand 2
     /* 425899 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425918 */     // MIs[2] Rn
     /* 425918 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425923 */     // MIs[2] Operand 2
     /* 425923 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 425934 */     // MIs[0] imm
     /* 425934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425942 */     // MIs[3] Operand 1
     /* 425942 */     // No operand predicates
     /* 425942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425944 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425974 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425991 */     // GIR_Coverage, 5454,
     /* 425991 */     GIR_EraseRootFromParent_Done,
     /* 425992 */   // Label 8339: @425992
     /* 425992 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(426032), // Rule ID 1868 //
     /* 425997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426008 */     // MIs[0] imm
     /* 426008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426016 */     // MIs[1] Operand 1
     /* 426016 */     // No operand predicates
     /* 426016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426018 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426030 */     GIR_RootConstrainSelectedInstOperands,
     /* 426031 */     // GIR_Coverage, 1868,
     /* 426031 */     GIR_EraseRootFromParent_Done,
     /* 426032 */   // Label 8340: @426032
     /* 426032 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(426069), // Rule ID 5451 //
     /* 426037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426045 */     // MIs[0] imm
     /* 426045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426053 */     // MIs[1] Operand 1
     /* 426053 */     // No operand predicates
     /* 426053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426055 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426067 */     GIR_RootConstrainSelectedInstOperands,
     /* 426068 */     // GIR_Coverage, 5451,
     /* 426068 */     GIR_EraseRootFromParent_Done,
     /* 426069 */   // Label 8341: @426069
     /* 426069 */   GIM_Reject,
     /* 426070 */ // Label 8338: @426070
     /* 426070 */ GIM_Reject,
     /* 426071 */ // Label 8313: @426071
     /* 426071 */ GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(426153),
     /* 426076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 426082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426094 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(426123), // Rule ID 5457 //
     /* 426099 */     // MIs[0] imm
     /* 426099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426107 */     // MIs[1] Operand 1
     /* 426107 */     // No operand predicates
     /* 426107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426109 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426121 */     GIR_RootConstrainSelectedInstOperands,
     /* 426122 */     // GIR_Coverage, 5457,
     /* 426122 */     GIR_EraseRootFromParent_Done,
     /* 426123 */   // Label 8343: @426123
     /* 426123 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(426152), // Rule ID 5462 //
     /* 426128 */     // MIs[0] imm
     /* 426128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426136 */     // MIs[1] Operand 1
     /* 426136 */     // No operand predicates
     /* 426136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426138 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426150 */     GIR_RootConstrainSelectedInstOperands,
     /* 426151 */     // GIR_Coverage, 5462,
     /* 426151 */     GIR_EraseRootFromParent_Done,
     /* 426152 */   // Label 8344: @426152
     /* 426152 */   GIM_Reject,
     /* 426153 */ // Label 8342: @426153
     /* 426153 */ GIM_Reject,
     /* 426154 */ // Label 8314: @426154
     /* 426154 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(426239),
     /* 426159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 426162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 426165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426177 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(426209), // Rule ID 1869 //
     /* 426182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426185 */     // MIs[0] imm
     /* 426185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426193 */     // MIs[1] Operand 1
     /* 426193 */     // No operand predicates
     /* 426193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426195 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426207 */     GIR_RootConstrainSelectedInstOperands,
     /* 426208 */     // GIR_Coverage, 1869,
     /* 426208 */     GIR_EraseRootFromParent_Done,
     /* 426209 */   // Label 8346: @426209
     /* 426209 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(426238), // Rule ID 5452 //
     /* 426214 */     // MIs[0] imm
     /* 426214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426222 */     // MIs[1] Operand 1
     /* 426222 */     // No operand predicates
     /* 426222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426224 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426236 */     GIR_RootConstrainSelectedInstOperands,
     /* 426237 */     // GIR_Coverage, 5452,
     /* 426237 */     GIR_EraseRootFromParent_Done,
     /* 426238 */   // Label 8347: @426238
     /* 426238 */   GIM_Reject,
     /* 426239 */ // Label 8345: @426239
     /* 426239 */ GIM_Reject,
     /* 426240 */ // Label 8315: @426240
     /* 426240 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(426286), // Rule ID 2729 //
     /* 426245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 426248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 426251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 426254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 426258 */   // MIs[0] Op3
     /* 426258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426266 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 426270 */   // MIs[1] Operand 1
     /* 426270 */   // No operand predicates
     /* 426270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426272 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 426272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 426275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 426277 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 426279 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 426281 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 426284 */   GIR_RootConstrainSelectedInstOperands,
     /* 426285 */   // GIR_Coverage, 2729,
     /* 426285 */   GIR_EraseRootFromParent_Done,
     /* 426286 */ // Label 8348: @426286
     /* 426286 */ GIM_Reject,
     /* 426287 */ // Label 8316: @426287
     /* 426287 */ GIM_Reject,
     /* 426288 */ // Label 130: @426288
     /* 426288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8356*/ GIMT_Encode4(426846),
     /* 426299 */ /*GILLT_s32*//*Label 8349*/ GIMT_Encode4(426335),
     /* 426303 */ /*GILLT_s64*//*Label 8350*/ GIMT_Encode4(426373), GIMT_Encode4(0),
     /* 426311 */ /*GILLT_v2s32*//*Label 8351*/ GIMT_Encode4(426471),
     /* 426315 */ /*GILLT_v2s64*//*Label 8352*/ GIMT_Encode4(426546),
     /* 426319 */ /*GILLT_v4s16*//*Label 8353*/ GIMT_Encode4(426621),
     /* 426323 */ /*GILLT_v4s32*//*Label 8354*/ GIMT_Encode4(426696), GIMT_Encode4(0),
     /* 426331 */ /*GILLT_v8s16*//*Label 8355*/ GIMT_Encode4(426771),
     /* 426335 */ // Label 8349: @426335
     /* 426335 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(426372), // Rule ID 1622 //
     /* 426340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 426346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 426349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426361 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 426361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 426366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426370 */   GIR_RootConstrainSelectedInstOperands,
     /* 426371 */   // GIR_Coverage, 1622,
     /* 426371 */   GIR_Done,
     /* 426372 */ // Label 8357: @426372
     /* 426372 */ GIM_Reject,
     /* 426373 */ // Label 8350: @426373
     /* 426373 */ GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(426470),
     /* 426378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426392 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(426423), // Rule ID 2509 //
     /* 426397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426404 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426410 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426414 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 426417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426421 */     GIR_RootConstrainSelectedInstOperands,
     /* 426422 */     // GIR_Coverage, 2509,
     /* 426422 */     GIR_EraseRootFromParent_Done,
     /* 426423 */   // Label 8359: @426423
     /* 426423 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(426446), // Rule ID 1621 //
     /* 426428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426435 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 426435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 426440 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426444 */     GIR_RootConstrainSelectedInstOperands,
     /* 426445 */     // GIR_Coverage, 1621,
     /* 426445 */     GIR_Done,
     /* 426446 */   // Label 8360: @426446
     /* 426446 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(426469), // Rule ID 5231 //
     /* 426451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426458 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 426458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 426463 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426467 */     GIR_RootConstrainSelectedInstOperands,
     /* 426468 */     // GIR_Coverage, 5231,
     /* 426468 */     GIR_Done,
     /* 426469 */   // Label 8361: @426469
     /* 426469 */   GIM_Reject,
     /* 426470 */ // Label 8358: @426470
     /* 426470 */ GIM_Reject,
     /* 426471 */ // Label 8351: @426471
     /* 426471 */ GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(426545),
     /* 426476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426490 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(426521), // Rule ID 773 //
     /* 426495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426502 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426508 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426512 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 426515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426519 */     GIR_RootConstrainSelectedInstOperands,
     /* 426520 */     // GIR_Coverage, 773,
     /* 426520 */     GIR_EraseRootFromParent_Done,
     /* 426521 */   // Label 8363: @426521
     /* 426521 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(426544), // Rule ID 1210 //
     /* 426526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426533 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 426538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426542 */     GIR_RootConstrainSelectedInstOperands,
     /* 426543 */     // GIR_Coverage, 1210,
     /* 426543 */     GIR_Done,
     /* 426544 */   // Label 8364: @426544
     /* 426544 */   GIM_Reject,
     /* 426545 */ // Label 8362: @426545
     /* 426545 */ GIM_Reject,
     /* 426546 */ // Label 8352: @426546
     /* 426546 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(426620),
     /* 426551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426565 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(426596), // Rule ID 775 //
     /* 426570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426587 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 426590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426594 */     GIR_RootConstrainSelectedInstOperands,
     /* 426595 */     // GIR_Coverage, 775,
     /* 426595 */     GIR_EraseRootFromParent_Done,
     /* 426596 */   // Label 8366: @426596
     /* 426596 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(426619), // Rule ID 1212 //
     /* 426601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426608 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 426613 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426617 */     GIR_RootConstrainSelectedInstOperands,
     /* 426618 */     // GIR_Coverage, 1212,
     /* 426618 */     GIR_Done,
     /* 426619 */   // Label 8367: @426619
     /* 426619 */   GIM_Reject,
     /* 426620 */ // Label 8365: @426620
     /* 426620 */ GIM_Reject,
     /* 426621 */ // Label 8353: @426621
     /* 426621 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(426695),
     /* 426626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426640 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(426671), // Rule ID 771 //
     /* 426645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426662 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 426665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426669 */     GIR_RootConstrainSelectedInstOperands,
     /* 426670 */     // GIR_Coverage, 771,
     /* 426670 */     GIR_EraseRootFromParent_Done,
     /* 426671 */   // Label 8369: @426671
     /* 426671 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(426694), // Rule ID 1208 //
     /* 426676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426683 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 426688 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426692 */     GIR_RootConstrainSelectedInstOperands,
     /* 426693 */     // GIR_Coverage, 1208,
     /* 426693 */     GIR_Done,
     /* 426694 */   // Label 8370: @426694
     /* 426694 */   GIM_Reject,
     /* 426695 */ // Label 8368: @426695
     /* 426695 */ GIM_Reject,
     /* 426696 */ // Label 8354: @426696
     /* 426696 */ GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(426770),
     /* 426701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 426707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426715 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(426746), // Rule ID 774 //
     /* 426720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426737 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 426740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426744 */     GIR_RootConstrainSelectedInstOperands,
     /* 426745 */     // GIR_Coverage, 774,
     /* 426745 */     GIR_EraseRootFromParent_Done,
     /* 426746 */   // Label 8372: @426746
     /* 426746 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(426769), // Rule ID 1211 //
     /* 426751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426758 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 426763 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426767 */     GIR_RootConstrainSelectedInstOperands,
     /* 426768 */     // GIR_Coverage, 1211,
     /* 426768 */     GIR_Done,
     /* 426769 */   // Label 8373: @426769
     /* 426769 */   GIM_Reject,
     /* 426770 */ // Label 8371: @426770
     /* 426770 */ GIM_Reject,
     /* 426771 */ // Label 8355: @426771
     /* 426771 */ GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(426845),
     /* 426776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 426782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426790 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(426821), // Rule ID 772 //
     /* 426795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426802 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426808 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426812 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 426815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426819 */     GIR_RootConstrainSelectedInstOperands,
     /* 426820 */     // GIR_Coverage, 772,
     /* 426820 */     GIR_EraseRootFromParent_Done,
     /* 426821 */   // Label 8375: @426821
     /* 426821 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(426844), // Rule ID 1209 //
     /* 426826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426833 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 426838 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426842 */     GIR_RootConstrainSelectedInstOperands,
     /* 426843 */     // GIR_Coverage, 1209,
     /* 426843 */     GIR_Done,
     /* 426844 */   // Label 8376: @426844
     /* 426844 */   GIM_Reject,
     /* 426845 */ // Label 8374: @426845
     /* 426845 */ GIM_Reject,
     /* 426846 */ // Label 8356: @426846
     /* 426846 */ GIM_Reject,
     /* 426847 */ // Label 131: @426847
     /* 426847 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8384*/ GIMT_Encode4(427938),
     /* 426858 */ /*GILLT_s32*//*Label 8377*/ GIMT_Encode4(426894),
     /* 426862 */ /*GILLT_s64*//*Label 8378*/ GIMT_Encode4(426932), GIMT_Encode4(0),
     /* 426870 */ /*GILLT_v2s32*//*Label 8379*/ GIMT_Encode4(427073),
     /* 426874 */ /*GILLT_v2s64*//*Label 8380*/ GIMT_Encode4(427246),
     /* 426878 */ /*GILLT_v4s16*//*Label 8381*/ GIMT_Encode4(427419),
     /* 426882 */ /*GILLT_v4s32*//*Label 8382*/ GIMT_Encode4(427592), GIMT_Encode4(0),
     /* 426890 */ /*GILLT_v8s16*//*Label 8383*/ GIMT_Encode4(427765),
     /* 426894 */ // Label 8377: @426894
     /* 426894 */ GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(426931), // Rule ID 1624 //
     /* 426899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 426905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 426908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426920 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 426920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 426925 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426929 */   GIR_RootConstrainSelectedInstOperands,
     /* 426930 */   // GIR_Coverage, 1624,
     /* 426930 */   GIR_Done,
     /* 426931 */ // Label 8385: @426931
     /* 426931 */ GIM_Reject,
     /* 426932 */ // Label 8378: @426932
     /* 426932 */ GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(427072),
     /* 426937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426947 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(426982), // Rule ID 5265 //
     /* 426952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426959 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426965 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426973 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 426976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426980 */     GIR_RootConstrainSelectedInstOperands,
     /* 426981 */     // GIR_Coverage, 5265,
     /* 426981 */     GIR_EraseRootFromParent_Done,
     /* 426982 */   // Label 8387: @426982
     /* 426982 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(427017), // Rule ID 5263 //
     /* 426987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426998 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427004 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427008 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 427011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427015 */     GIR_RootConstrainSelectedInstOperands,
     /* 427016 */     // GIR_Coverage, 5263,
     /* 427016 */     GIR_EraseRootFromParent_Done,
     /* 427017 */   // Label 8388: @427017
     /* 427017 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(427044), // Rule ID 1623 //
     /* 427022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427033 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 427033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 427038 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427042 */     GIR_RootConstrainSelectedInstOperands,
     /* 427043 */     // GIR_Coverage, 1623,
     /* 427043 */     GIR_Done,
     /* 427044 */   // Label 8389: @427044
     /* 427044 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(427071), // Rule ID 5232 //
     /* 427049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427060 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 427060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 427065 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427069 */     GIR_RootConstrainSelectedInstOperands,
     /* 427070 */     // GIR_Coverage, 5232,
     /* 427070 */     GIR_Done,
     /* 427071 */   // Label 8390: @427071
     /* 427071 */   GIM_Reject,
     /* 427072 */ // Label 8386: @427072
     /* 427072 */ GIM_Reject,
     /* 427073 */ // Label 8379: @427073
     /* 427073 */ GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(427245),
     /* 427078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 427084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427088 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(427147), // Rule ID 1172 //
     /* 427093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427132 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 427135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427145 */     GIR_RootConstrainSelectedInstOperands,
     /* 427146 */     // GIR_Coverage, 1172,
     /* 427146 */     GIR_EraseRootFromParent_Done,
     /* 427147 */   // Label 8392: @427147
     /* 427147 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(427182), // Rule ID 788 //
     /* 427152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427173 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 427176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427180 */     GIR_RootConstrainSelectedInstOperands,
     /* 427181 */     // GIR_Coverage, 788,
     /* 427181 */     GIR_EraseRootFromParent_Done,
     /* 427182 */   // Label 8393: @427182
     /* 427182 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(427217), // Rule ID 778 //
     /* 427187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427198 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427204 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427208 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 427211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427215 */     GIR_RootConstrainSelectedInstOperands,
     /* 427216 */     // GIR_Coverage, 778,
     /* 427216 */     GIR_EraseRootFromParent_Done,
     /* 427217 */   // Label 8394: @427217
     /* 427217 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(427244), // Rule ID 1215 //
     /* 427222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427233 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 427238 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427242 */     GIR_RootConstrainSelectedInstOperands,
     /* 427243 */     // GIR_Coverage, 1215,
     /* 427243 */     GIR_Done,
     /* 427244 */   // Label 8395: @427244
     /* 427244 */   GIM_Reject,
     /* 427245 */ // Label 8391: @427245
     /* 427245 */ GIM_Reject,
     /* 427246 */ // Label 8380: @427246
     /* 427246 */ GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(427418),
     /* 427251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 427257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427261 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(427320), // Rule ID 1176 //
     /* 427266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427305 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 427308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427318 */     GIR_RootConstrainSelectedInstOperands,
     /* 427319 */     // GIR_Coverage, 1176,
     /* 427319 */     GIR_EraseRootFromParent_Done,
     /* 427320 */   // Label 8397: @427320
     /* 427320 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(427355), // Rule ID 790 //
     /* 427325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427332 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427338 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427346 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 427349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427353 */     GIR_RootConstrainSelectedInstOperands,
     /* 427354 */     // GIR_Coverage, 790,
     /* 427354 */     GIR_EraseRootFromParent_Done,
     /* 427355 */   // Label 8398: @427355
     /* 427355 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(427390), // Rule ID 780 //
     /* 427360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427381 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 427384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427388 */     GIR_RootConstrainSelectedInstOperands,
     /* 427389 */     // GIR_Coverage, 780,
     /* 427389 */     GIR_EraseRootFromParent_Done,
     /* 427390 */   // Label 8399: @427390
     /* 427390 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(427417), // Rule ID 1217 //
     /* 427395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427406 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 427411 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427415 */     GIR_RootConstrainSelectedInstOperands,
     /* 427416 */     // GIR_Coverage, 1217,
     /* 427416 */     GIR_Done,
     /* 427417 */   // Label 8400: @427417
     /* 427417 */   GIM_Reject,
     /* 427418 */ // Label 8396: @427418
     /* 427418 */ GIM_Reject,
     /* 427419 */ // Label 8381: @427419
     /* 427419 */ GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(427591),
     /* 427424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 427430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427434 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(427493), // Rule ID 1168 //
     /* 427439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427478 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 427481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427491 */     GIR_RootConstrainSelectedInstOperands,
     /* 427492 */     // GIR_Coverage, 1168,
     /* 427492 */     GIR_EraseRootFromParent_Done,
     /* 427493 */   // Label 8402: @427493
     /* 427493 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(427528), // Rule ID 786 //
     /* 427498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427505 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427511 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427519 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 427522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427526 */     GIR_RootConstrainSelectedInstOperands,
     /* 427527 */     // GIR_Coverage, 786,
     /* 427527 */     GIR_EraseRootFromParent_Done,
     /* 427528 */   // Label 8403: @427528
     /* 427528 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(427563), // Rule ID 776 //
     /* 427533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427554 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 427557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427561 */     GIR_RootConstrainSelectedInstOperands,
     /* 427562 */     // GIR_Coverage, 776,
     /* 427562 */     GIR_EraseRootFromParent_Done,
     /* 427563 */   // Label 8404: @427563
     /* 427563 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(427590), // Rule ID 1213 //
     /* 427568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427579 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 427584 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427588 */     GIR_RootConstrainSelectedInstOperands,
     /* 427589 */     // GIR_Coverage, 1213,
     /* 427589 */     GIR_Done,
     /* 427590 */   // Label 8405: @427590
     /* 427590 */   GIM_Reject,
     /* 427591 */ // Label 8401: @427591
     /* 427591 */ GIM_Reject,
     /* 427592 */ // Label 8382: @427592
     /* 427592 */ GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(427764),
     /* 427597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 427603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427607 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(427666), // Rule ID 1174 //
     /* 427612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427651 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 427654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427664 */     GIR_RootConstrainSelectedInstOperands,
     /* 427665 */     // GIR_Coverage, 1174,
     /* 427665 */     GIR_EraseRootFromParent_Done,
     /* 427666 */   // Label 8407: @427666
     /* 427666 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(427701), // Rule ID 789 //
     /* 427671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427678 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427684 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427692 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 427695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427699 */     GIR_RootConstrainSelectedInstOperands,
     /* 427700 */     // GIR_Coverage, 789,
     /* 427700 */     GIR_EraseRootFromParent_Done,
     /* 427701 */   // Label 8408: @427701
     /* 427701 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(427736), // Rule ID 779 //
     /* 427706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427717 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427727 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 427730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427734 */     GIR_RootConstrainSelectedInstOperands,
     /* 427735 */     // GIR_Coverage, 779,
     /* 427735 */     GIR_EraseRootFromParent_Done,
     /* 427736 */   // Label 8409: @427736
     /* 427736 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(427763), // Rule ID 1216 //
     /* 427741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427752 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 427757 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427761 */     GIR_RootConstrainSelectedInstOperands,
     /* 427762 */     // GIR_Coverage, 1216,
     /* 427762 */     GIR_Done,
     /* 427763 */   // Label 8410: @427763
     /* 427763 */   GIM_Reject,
     /* 427764 */ // Label 8406: @427764
     /* 427764 */ GIM_Reject,
     /* 427765 */ // Label 8383: @427765
     /* 427765 */ GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(427937),
     /* 427770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427780 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(427839), // Rule ID 1170 //
     /* 427785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427824 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 427827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427837 */     GIR_RootConstrainSelectedInstOperands,
     /* 427838 */     // GIR_Coverage, 1170,
     /* 427838 */     GIR_EraseRootFromParent_Done,
     /* 427839 */   // Label 8412: @427839
     /* 427839 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(427874), // Rule ID 787 //
     /* 427844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427851 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427857 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427865 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 427868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427872 */     GIR_RootConstrainSelectedInstOperands,
     /* 427873 */     // GIR_Coverage, 787,
     /* 427873 */     GIR_EraseRootFromParent_Done,
     /* 427874 */   // Label 8413: @427874
     /* 427874 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(427909), // Rule ID 777 //
     /* 427879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427890 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427896 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427900 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 427903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427907 */     GIR_RootConstrainSelectedInstOperands,
     /* 427908 */     // GIR_Coverage, 777,
     /* 427908 */     GIR_EraseRootFromParent_Done,
     /* 427909 */   // Label 8414: @427909
     /* 427909 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(427936), // Rule ID 1214 //
     /* 427914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427925 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 427930 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427934 */     GIR_RootConstrainSelectedInstOperands,
     /* 427935 */     // GIR_Coverage, 1214,
     /* 427935 */     GIR_Done,
     /* 427936 */   // Label 8415: @427936
     /* 427936 */   GIM_Reject,
     /* 427937 */ // Label 8411: @427937
     /* 427937 */ GIM_Reject,
     /* 427938 */ // Label 8384: @427938
     /* 427938 */ GIM_Reject,
     /* 427939 */ // Label 132: @427939
     /* 427939 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8423*/ GIMT_Encode4(429030),
     /* 427950 */ /*GILLT_s32*//*Label 8416*/ GIMT_Encode4(427986),
     /* 427954 */ /*GILLT_s64*//*Label 8417*/ GIMT_Encode4(428024), GIMT_Encode4(0),
     /* 427962 */ /*GILLT_v2s32*//*Label 8418*/ GIMT_Encode4(428165),
     /* 427966 */ /*GILLT_v2s64*//*Label 8419*/ GIMT_Encode4(428338),
     /* 427970 */ /*GILLT_v4s16*//*Label 8420*/ GIMT_Encode4(428511),
     /* 427974 */ /*GILLT_v4s32*//*Label 8421*/ GIMT_Encode4(428684), GIMT_Encode4(0),
     /* 427982 */ /*GILLT_v8s16*//*Label 8422*/ GIMT_Encode4(428857),
     /* 427986 */ // Label 8416: @427986
     /* 427986 */ GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(428023), // Rule ID 1626 //
     /* 427991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 428000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 428012 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 428012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 428017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428021 */   GIR_RootConstrainSelectedInstOperands,
     /* 428022 */   // GIR_Coverage, 1626,
     /* 428022 */   GIR_Done,
     /* 428023 */ // Label 8424: @428023
     /* 428023 */ GIM_Reject,
     /* 428024 */ // Label 8417: @428024
     /* 428024 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(428164),
     /* 428029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 428032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 428035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428039 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(428074), // Rule ID 5266 //
     /* 428044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428051 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428057 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428065 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 428065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 428068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428072 */     GIR_RootConstrainSelectedInstOperands,
     /* 428073 */     // GIR_Coverage, 5266,
     /* 428073 */     GIR_EraseRootFromParent_Done,
     /* 428074 */   // Label 8426: @428074
     /* 428074 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(428109), // Rule ID 5264 //
     /* 428079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428090 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428096 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428100 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 428100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 428103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428107 */     GIR_RootConstrainSelectedInstOperands,
     /* 428108 */     // GIR_Coverage, 5264,
     /* 428108 */     GIR_EraseRootFromParent_Done,
     /* 428109 */   // Label 8427: @428109
     /* 428109 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(428136), // Rule ID 1625 //
     /* 428114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428125 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 428125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 428130 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428134 */     GIR_RootConstrainSelectedInstOperands,
     /* 428135 */     // GIR_Coverage, 1625,
     /* 428135 */     GIR_Done,
     /* 428136 */   // Label 8428: @428136
     /* 428136 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(428163), // Rule ID 5233 //
     /* 428141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428152 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 428152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 428157 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428161 */     GIR_RootConstrainSelectedInstOperands,
     /* 428162 */     // GIR_Coverage, 5233,
     /* 428162 */     GIR_Done,
     /* 428163 */   // Label 8429: @428163
     /* 428163 */   GIM_Reject,
     /* 428164 */ // Label 8425: @428164
     /* 428164 */ GIM_Reject,
     /* 428165 */ // Label 8418: @428165
     /* 428165 */ GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(428337),
     /* 428170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 428176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428180 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(428239), // Rule ID 1182 //
     /* 428185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428224 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 428227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428237 */     GIR_RootConstrainSelectedInstOperands,
     /* 428238 */     // GIR_Coverage, 1182,
     /* 428238 */     GIR_EraseRootFromParent_Done,
     /* 428239 */   // Label 8431: @428239
     /* 428239 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(428274), // Rule ID 793 //
     /* 428244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428251 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428257 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428265 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 428268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428272 */     GIR_RootConstrainSelectedInstOperands,
     /* 428273 */     // GIR_Coverage, 793,
     /* 428273 */     GIR_EraseRootFromParent_Done,
     /* 428274 */   // Label 8432: @428274
     /* 428274 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(428309), // Rule ID 783 //
     /* 428279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428290 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428296 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428300 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 428303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428307 */     GIR_RootConstrainSelectedInstOperands,
     /* 428308 */     // GIR_Coverage, 783,
     /* 428308 */     GIR_EraseRootFromParent_Done,
     /* 428309 */   // Label 8433: @428309
     /* 428309 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(428336), // Rule ID 1220 //
     /* 428314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428325 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 428330 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428334 */     GIR_RootConstrainSelectedInstOperands,
     /* 428335 */     // GIR_Coverage, 1220,
     /* 428335 */     GIR_Done,
     /* 428336 */   // Label 8434: @428336
     /* 428336 */   GIM_Reject,
     /* 428337 */ // Label 8430: @428337
     /* 428337 */ GIM_Reject,
     /* 428338 */ // Label 8419: @428338
     /* 428338 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(428510),
     /* 428343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 428349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428353 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(428412), // Rule ID 1186 //
     /* 428358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428397 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 428400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428410 */     GIR_RootConstrainSelectedInstOperands,
     /* 428411 */     // GIR_Coverage, 1186,
     /* 428411 */     GIR_EraseRootFromParent_Done,
     /* 428412 */   // Label 8436: @428412
     /* 428412 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(428447), // Rule ID 795 //
     /* 428417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428430 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428438 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 428441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428445 */     GIR_RootConstrainSelectedInstOperands,
     /* 428446 */     // GIR_Coverage, 795,
     /* 428446 */     GIR_EraseRootFromParent_Done,
     /* 428447 */   // Label 8437: @428447
     /* 428447 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(428482), // Rule ID 785 //
     /* 428452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428463 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428469 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428473 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 428476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428480 */     GIR_RootConstrainSelectedInstOperands,
     /* 428481 */     // GIR_Coverage, 785,
     /* 428481 */     GIR_EraseRootFromParent_Done,
     /* 428482 */   // Label 8438: @428482
     /* 428482 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(428509), // Rule ID 1222 //
     /* 428487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428498 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 428503 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428507 */     GIR_RootConstrainSelectedInstOperands,
     /* 428508 */     // GIR_Coverage, 1222,
     /* 428508 */     GIR_Done,
     /* 428509 */   // Label 8439: @428509
     /* 428509 */   GIM_Reject,
     /* 428510 */ // Label 8435: @428510
     /* 428510 */ GIM_Reject,
     /* 428511 */ // Label 8420: @428511
     /* 428511 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(428683),
     /* 428516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 428522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428526 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(428585), // Rule ID 1178 //
     /* 428531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428570 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 428573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428583 */     GIR_RootConstrainSelectedInstOperands,
     /* 428584 */     // GIR_Coverage, 1178,
     /* 428584 */     GIR_EraseRootFromParent_Done,
     /* 428585 */   // Label 8441: @428585
     /* 428585 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(428620), // Rule ID 791 //
     /* 428590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428611 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 428614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428618 */     GIR_RootConstrainSelectedInstOperands,
     /* 428619 */     // GIR_Coverage, 791,
     /* 428619 */     GIR_EraseRootFromParent_Done,
     /* 428620 */   // Label 8442: @428620
     /* 428620 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(428655), // Rule ID 781 //
     /* 428625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428636 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428642 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428646 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 428649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428653 */     GIR_RootConstrainSelectedInstOperands,
     /* 428654 */     // GIR_Coverage, 781,
     /* 428654 */     GIR_EraseRootFromParent_Done,
     /* 428655 */   // Label 8443: @428655
     /* 428655 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(428682), // Rule ID 1218 //
     /* 428660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428671 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 428676 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428680 */     GIR_RootConstrainSelectedInstOperands,
     /* 428681 */     // GIR_Coverage, 1218,
     /* 428681 */     GIR_Done,
     /* 428682 */   // Label 8444: @428682
     /* 428682 */   GIM_Reject,
     /* 428683 */ // Label 8440: @428683
     /* 428683 */ GIM_Reject,
     /* 428684 */ // Label 8421: @428684
     /* 428684 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(428856),
     /* 428689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 428695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428699 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(428758), // Rule ID 1184 //
     /* 428704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428743 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 428743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 428746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428756 */     GIR_RootConstrainSelectedInstOperands,
     /* 428757 */     // GIR_Coverage, 1184,
     /* 428757 */     GIR_EraseRootFromParent_Done,
     /* 428758 */   // Label 8446: @428758
     /* 428758 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(428793), // Rule ID 794 //
     /* 428763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428770 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428776 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428784 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 428784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 428787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428791 */     GIR_RootConstrainSelectedInstOperands,
     /* 428792 */     // GIR_Coverage, 794,
     /* 428792 */     GIR_EraseRootFromParent_Done,
     /* 428793 */   // Label 8447: @428793
     /* 428793 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(428828), // Rule ID 784 //
     /* 428798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428809 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428815 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428819 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 428819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 428822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428826 */     GIR_RootConstrainSelectedInstOperands,
     /* 428827 */     // GIR_Coverage, 784,
     /* 428827 */     GIR_EraseRootFromParent_Done,
     /* 428828 */   // Label 8448: @428828
     /* 428828 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(428855), // Rule ID 1221 //
     /* 428833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428844 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 428844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 428849 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428853 */     GIR_RootConstrainSelectedInstOperands,
     /* 428854 */     // GIR_Coverage, 1221,
     /* 428854 */     GIR_Done,
     /* 428855 */   // Label 8449: @428855
     /* 428855 */   GIM_Reject,
     /* 428856 */ // Label 8445: @428856
     /* 428856 */ GIM_Reject,
     /* 428857 */ // Label 8422: @428857
     /* 428857 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(429029),
     /* 428862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 428868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428872 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(428931), // Rule ID 1180 //
     /* 428877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428916 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 428916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 428919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428929 */     GIR_RootConstrainSelectedInstOperands,
     /* 428930 */     // GIR_Coverage, 1180,
     /* 428930 */     GIR_EraseRootFromParent_Done,
     /* 428931 */   // Label 8451: @428931
     /* 428931 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(428966), // Rule ID 792 //
     /* 428936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428949 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428957 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 428960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428964 */     GIR_RootConstrainSelectedInstOperands,
     /* 428965 */     // GIR_Coverage, 792,
     /* 428965 */     GIR_EraseRootFromParent_Done,
     /* 428966 */   // Label 8452: @428966
     /* 428966 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(429001), // Rule ID 782 //
     /* 428971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428982 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428988 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428992 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 428995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428999 */     GIR_RootConstrainSelectedInstOperands,
     /* 429000 */     // GIR_Coverage, 782,
     /* 429000 */     GIR_EraseRootFromParent_Done,
     /* 429001 */   // Label 8453: @429001
     /* 429001 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(429028), // Rule ID 1219 //
     /* 429006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429017 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 429017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 429022 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429026 */     GIR_RootConstrainSelectedInstOperands,
     /* 429027 */     // GIR_Coverage, 1219,
     /* 429027 */     GIR_Done,
     /* 429028 */   // Label 8454: @429028
     /* 429028 */   GIM_Reject,
     /* 429029 */ // Label 8450: @429029
     /* 429029 */ GIM_Reject,
     /* 429030 */ // Label 8423: @429030
     /* 429030 */ GIM_Reject,
     /* 429031 */ // Label 133: @429031
     /* 429031 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8459*/ GIMT_Encode4(429184),
     /* 429042 */ /*GILLT_s32*//*Label 8455*/ GIMT_Encode4(429082),
     /* 429046 */ /*GILLT_s64*//*Label 8456*/ GIMT_Encode4(429106), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 429070 */ /*GILLT_v8s8*//*Label 8457*/ GIMT_Encode4(429130), GIMT_Encode4(0),
     /* 429078 */ /*GILLT_v16s8*//*Label 8458*/ GIMT_Encode4(429157),
     /* 429082 */ // Label 8455: @429082
     /* 429082 */ GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(429105), // Rule ID 4019 //
     /* 429087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 429090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 429094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 429098 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 429098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 429103 */   GIR_RootConstrainSelectedInstOperands,
     /* 429104 */   // GIR_Coverage, 4019,
     /* 429104 */   GIR_Done,
     /* 429105 */ // Label 8460: @429105
     /* 429105 */ GIM_Reject,
     /* 429106 */ // Label 8456: @429106
     /* 429106 */ GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(429129), // Rule ID 4020 //
     /* 429111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 429114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 429118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 429122 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 429122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 429127 */   GIR_RootConstrainSelectedInstOperands,
     /* 429128 */   // GIR_Coverage, 4020,
     /* 429128 */   GIR_Done,
     /* 429129 */ // Label 8461: @429129
     /* 429129 */ GIM_Reject,
     /* 429130 */ // Label 8457: @429130
     /* 429130 */ GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(429156), // Rule ID 976 //
     /* 429135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429149 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 429149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 429154 */   GIR_RootConstrainSelectedInstOperands,
     /* 429155 */   // GIR_Coverage, 976,
     /* 429155 */   GIR_Done,
     /* 429156 */ // Label 8462: @429156
     /* 429156 */ GIM_Reject,
     /* 429157 */ // Label 8458: @429157
     /* 429157 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(429183), // Rule ID 977 //
     /* 429162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429176 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 429176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 429181 */   GIR_RootConstrainSelectedInstOperands,
     /* 429182 */   // GIR_Coverage, 977,
     /* 429182 */   GIR_Done,
     /* 429183 */ // Label 8463: @429183
     /* 429183 */ GIM_Reject,
     /* 429184 */ // Label 8459: @429184
     /* 429184 */ GIM_Reject,
     /* 429185 */ // Label 134: @429185
     /* 429185 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8468*/ GIMT_Encode4(429360),
     /* 429196 */ /*GILLT_v4s16*//*Label 8464*/ GIMT_Encode4(429216), GIMT_Encode4(0),
     /* 429204 */ /*GILLT_v8s8*//*Label 8465*/ GIMT_Encode4(429261),
     /* 429208 */ /*GILLT_v8s16*//*Label 8466*/ GIMT_Encode4(429288),
     /* 429212 */ /*GILLT_v16s8*//*Label 8467*/ GIMT_Encode4(429333),
     /* 429216 */ // Label 8464: @429216
     /* 429216 */ GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(429260),
     /* 429221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429232 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(429247), // Rule ID 980 //
     /* 429237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429240 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 429240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 429245 */     GIR_RootConstrainSelectedInstOperands,
     /* 429246 */     // GIR_Coverage, 980,
     /* 429246 */     GIR_Done,
     /* 429247 */   // Label 8470: @429247
     /* 429247 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(429259), // Rule ID 5002 //
     /* 429252 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 429252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 429257 */     GIR_RootConstrainSelectedInstOperands,
     /* 429258 */     // GIR_Coverage, 5002,
     /* 429258 */     GIR_Done,
     /* 429259 */   // Label 8471: @429259
     /* 429259 */   GIM_Reject,
     /* 429260 */ // Label 8469: @429260
     /* 429260 */ GIM_Reject,
     /* 429261 */ // Label 8465: @429261
     /* 429261 */ GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(429287), // Rule ID 978 //
     /* 429266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429280 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 429280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 429285 */   GIR_RootConstrainSelectedInstOperands,
     /* 429286 */   // GIR_Coverage, 978,
     /* 429286 */   GIR_Done,
     /* 429287 */ // Label 8472: @429287
     /* 429287 */ GIM_Reject,
     /* 429288 */ // Label 8466: @429288
     /* 429288 */ GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(429332),
     /* 429293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429304 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(429319), // Rule ID 981 //
     /* 429309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429312 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 429312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 429317 */     GIR_RootConstrainSelectedInstOperands,
     /* 429318 */     // GIR_Coverage, 981,
     /* 429318 */     GIR_Done,
     /* 429319 */   // Label 8474: @429319
     /* 429319 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(429331), // Rule ID 5004 //
     /* 429324 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 429324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 429329 */     GIR_RootConstrainSelectedInstOperands,
     /* 429330 */     // GIR_Coverage, 5004,
     /* 429330 */     GIR_Done,
     /* 429331 */   // Label 8475: @429331
     /* 429331 */   GIM_Reject,
     /* 429332 */ // Label 8473: @429332
     /* 429332 */ GIM_Reject,
     /* 429333 */ // Label 8467: @429333
     /* 429333 */ GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(429359), // Rule ID 979 //
     /* 429338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429352 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 429352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 429357 */   GIR_RootConstrainSelectedInstOperands,
     /* 429358 */   // GIR_Coverage, 979,
     /* 429358 */   GIR_Done,
     /* 429359 */ // Label 8476: @429359
     /* 429359 */ GIM_Reject,
     /* 429360 */ // Label 8468: @429360
     /* 429360 */ GIM_Reject,
     /* 429361 */ // Label 135: @429361
     /* 429361 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8483*/ GIMT_Encode4(429634),
     /* 429372 */ /*GILLT_v2s32*//*Label 8477*/ GIMT_Encode4(429400), GIMT_Encode4(0),
     /* 429380 */ /*GILLT_v4s16*//*Label 8478*/ GIMT_Encode4(429445),
     /* 429384 */ /*GILLT_v4s32*//*Label 8479*/ GIMT_Encode4(429490),
     /* 429388 */ /*GILLT_v8s8*//*Label 8480*/ GIMT_Encode4(429535),
     /* 429392 */ /*GILLT_v8s16*//*Label 8481*/ GIMT_Encode4(429562),
     /* 429396 */ /*GILLT_v16s8*//*Label 8482*/ GIMT_Encode4(429607),
     /* 429400 */ // Label 8477: @429400
     /* 429400 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(429444),
     /* 429405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429416 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(429431), // Rule ID 986 //
     /* 429421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429424 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 429424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 429429 */     GIR_RootConstrainSelectedInstOperands,
     /* 429430 */     // GIR_Coverage, 986,
     /* 429430 */     GIR_Done,
     /* 429431 */   // Label 8485: @429431
     /* 429431 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(429443), // Rule ID 5006 //
     /* 429436 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 429436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 429441 */     GIR_RootConstrainSelectedInstOperands,
     /* 429442 */     // GIR_Coverage, 5006,
     /* 429442 */     GIR_Done,
     /* 429443 */   // Label 8486: @429443
     /* 429443 */   GIM_Reject,
     /* 429444 */ // Label 8484: @429444
     /* 429444 */ GIM_Reject,
     /* 429445 */ // Label 8478: @429445
     /* 429445 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(429489),
     /* 429450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429461 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(429476), // Rule ID 984 //
     /* 429466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429469 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 429469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 429474 */     GIR_RootConstrainSelectedInstOperands,
     /* 429475 */     // GIR_Coverage, 984,
     /* 429475 */     GIR_Done,
     /* 429476 */   // Label 8488: @429476
     /* 429476 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(429488), // Rule ID 5003 //
     /* 429481 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 429481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 429486 */     GIR_RootConstrainSelectedInstOperands,
     /* 429487 */     // GIR_Coverage, 5003,
     /* 429487 */     GIR_Done,
     /* 429488 */   // Label 8489: @429488
     /* 429488 */   GIM_Reject,
     /* 429489 */ // Label 8487: @429489
     /* 429489 */ GIM_Reject,
     /* 429490 */ // Label 8479: @429490
     /* 429490 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(429534),
     /* 429495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429506 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(429521), // Rule ID 987 //
     /* 429511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429514 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 429514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 429519 */     GIR_RootConstrainSelectedInstOperands,
     /* 429520 */     // GIR_Coverage, 987,
     /* 429520 */     GIR_Done,
     /* 429521 */   // Label 8491: @429521
     /* 429521 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(429533), // Rule ID 5007 //
     /* 429526 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 429526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 429531 */     GIR_RootConstrainSelectedInstOperands,
     /* 429532 */     // GIR_Coverage, 5007,
     /* 429532 */     GIR_Done,
     /* 429533 */   // Label 8492: @429533
     /* 429533 */   GIM_Reject,
     /* 429534 */ // Label 8490: @429534
     /* 429534 */ GIM_Reject,
     /* 429535 */ // Label 8480: @429535
     /* 429535 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(429561), // Rule ID 982 //
     /* 429540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429554 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 429554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 429559 */   GIR_RootConstrainSelectedInstOperands,
     /* 429560 */   // GIR_Coverage, 982,
     /* 429560 */   GIR_Done,
     /* 429561 */ // Label 8493: @429561
     /* 429561 */ GIM_Reject,
     /* 429562 */ // Label 8481: @429562
     /* 429562 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(429606),
     /* 429567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429578 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(429593), // Rule ID 985 //
     /* 429583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429586 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 429586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 429591 */     GIR_RootConstrainSelectedInstOperands,
     /* 429592 */     // GIR_Coverage, 985,
     /* 429592 */     GIR_Done,
     /* 429593 */   // Label 8495: @429593
     /* 429593 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(429605), // Rule ID 5005 //
     /* 429598 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 429598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 429603 */     GIR_RootConstrainSelectedInstOperands,
     /* 429604 */     // GIR_Coverage, 5005,
     /* 429604 */     GIR_Done,
     /* 429605 */   // Label 8496: @429605
     /* 429605 */   GIM_Reject,
     /* 429606 */ // Label 8494: @429606
     /* 429606 */ GIM_Reject,
     /* 429607 */ // Label 8482: @429607
     /* 429607 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(429633), // Rule ID 983 //
     /* 429612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429626 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 429626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 429631 */   GIR_RootConstrainSelectedInstOperands,
     /* 429632 */   // GIR_Coverage, 983,
     /* 429632 */   GIR_Done,
     /* 429633 */ // Label 8497: @429633
     /* 429633 */ GIM_Reject,
     /* 429634 */ // Label 8483: @429634
     /* 429634 */ GIM_Reject,
     /* 429635 */ // Label 136: @429635
     /* 429635 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8504*/ GIMT_Encode4(429840),
     /* 429646 */ /*GILLT_s64*//*Label 8498*/ GIMT_Encode4(429678), GIMT_Encode4(0),
     /* 429654 */ /*GILLT_v2s32*//*Label 8499*/ GIMT_Encode4(429705),
     /* 429658 */ /*GILLT_v2s64*//*Label 8500*/ GIMT_Encode4(429732),
     /* 429662 */ /*GILLT_v4s16*//*Label 8501*/ GIMT_Encode4(429759),
     /* 429666 */ /*GILLT_v4s32*//*Label 8502*/ GIMT_Encode4(429786), GIMT_Encode4(0),
     /* 429674 */ /*GILLT_v8s16*//*Label 8503*/ GIMT_Encode4(429813),
     /* 429678 */ // Label 8498: @429678
     /* 429678 */ GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(429704), // Rule ID 1008 //
     /* 429683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429697 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 429697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 429702 */   GIR_RootConstrainSelectedInstOperands,
     /* 429703 */   // GIR_Coverage, 1008,
     /* 429703 */   GIR_Done,
     /* 429704 */ // Label 8505: @429704
     /* 429704 */ GIM_Reject,
     /* 429705 */ // Label 8499: @429705
     /* 429705 */ GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(429731), // Rule ID 1004 //
     /* 429710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429724 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 429724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 429729 */   GIR_RootConstrainSelectedInstOperands,
     /* 429730 */   // GIR_Coverage, 1004,
     /* 429730 */   GIR_Done,
     /* 429731 */ // Label 8506: @429731
     /* 429731 */ GIM_Reject,
     /* 429732 */ // Label 8500: @429732
     /* 429732 */ GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(429758), // Rule ID 1010 //
     /* 429737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429751 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 429751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 429756 */   GIR_RootConstrainSelectedInstOperands,
     /* 429757 */   // GIR_Coverage, 1010,
     /* 429757 */   GIR_Done,
     /* 429758 */ // Label 8507: @429758
     /* 429758 */ GIM_Reject,
     /* 429759 */ // Label 8501: @429759
     /* 429759 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(429785), // Rule ID 1000 //
     /* 429764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429778 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 429778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 429783 */   GIR_RootConstrainSelectedInstOperands,
     /* 429784 */   // GIR_Coverage, 1000,
     /* 429784 */   GIR_Done,
     /* 429785 */ // Label 8508: @429785
     /* 429785 */ GIM_Reject,
     /* 429786 */ // Label 8502: @429786
     /* 429786 */ GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(429812), // Rule ID 1006 //
     /* 429791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429805 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 429805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 429810 */   GIR_RootConstrainSelectedInstOperands,
     /* 429811 */   // GIR_Coverage, 1006,
     /* 429811 */   GIR_Done,
     /* 429812 */ // Label 8509: @429812
     /* 429812 */ GIM_Reject,
     /* 429813 */ // Label 8503: @429813
     /* 429813 */ GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(429839), // Rule ID 1002 //
     /* 429818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429832 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 429832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 429837 */   GIR_RootConstrainSelectedInstOperands,
     /* 429838 */   // GIR_Coverage, 1002,
     /* 429838 */   GIR_Done,
     /* 429839 */ // Label 8510: @429839
     /* 429839 */ GIM_Reject,
     /* 429840 */ // Label 8504: @429840
     /* 429840 */ GIM_Reject,
     /* 429841 */ // Label 137: @429841
     /* 429841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8513*/ GIMT_Encode4(430239),
     /* 429852 */ /*GILLT_v2s64*//*Label 8511*/ GIMT_Encode4(429864), GIMT_Encode4(0),
     /* 429860 */ /*GILLT_v4s32*//*Label 8512*/ GIMT_Encode4(430002),
     /* 429864 */ // Label 8511: @429864
     /* 429864 */ GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(429923), // Rule ID 5915 //
     /* 429869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429880 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 429880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 429883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 429887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429892 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 429912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429917 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429922 */   // GIR_Coverage, 5915,
     /* 429922 */   GIR_EraseRootFromParent_Done,
     /* 429923 */ // Label 8514: @429923
     /* 429923 */ GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(430001), // Rule ID 6037 //
     /* 429928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429939 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 429939 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 429942 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 429946 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429951 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 429957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 429960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 429964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 429974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 429982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 429985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430000 */   // GIR_Coverage, 6037,
     /* 430000 */   GIR_EraseRootFromParent_Done,
     /* 430001 */ // Label 8515: @430001
     /* 430001 */ GIM_Reject,
     /* 430002 */ // Label 8512: @430002
     /* 430002 */ GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(430061), // Rule ID 5911 //
     /* 430007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430018 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 430018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 430021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 430025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430030 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 430039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 430050 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 430060 */   // GIR_Coverage, 5911,
     /* 430060 */   GIR_EraseRootFromParent_Done,
     /* 430061 */ // Label 8516: @430061
     /* 430061 */ GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(430120), // Rule ID 5912 //
     /* 430066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430077 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 430077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 430080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 430084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430089 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 430098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 430109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430119 */   // GIR_Coverage, 5912,
     /* 430119 */   GIR_EraseRootFromParent_Done,
     /* 430120 */ // Label 8517: @430120
     /* 430120 */ GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(430179), // Rule ID 5913 //
     /* 430125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430136 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 430136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 430139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 430143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430148 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 430157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 430168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 430178 */   // GIR_Coverage, 5913,
     /* 430178 */   GIR_EraseRootFromParent_Done,
     /* 430179 */ // Label 8518: @430179
     /* 430179 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(430238), // Rule ID 5914 //
     /* 430184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430195 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 430195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 430198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 430202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 430216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 430227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430237 */   // GIR_Coverage, 5914,
     /* 430237 */   GIR_EraseRootFromParent_Done,
     /* 430238 */ // Label 8519: @430238
     /* 430238 */ GIM_Reject,
     /* 430239 */ // Label 8513: @430239
     /* 430239 */ GIM_Reject,
     /* 430240 */ // Label 138: @430240
     /* 430240 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8524*/ GIMT_Encode4(430609),
     /* 430251 */ /*GILLT_v2s32*//*Label 8520*/ GIMT_Encode4(430311), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430263 */ /*GILLT_v4s32*//*Label 8521*/ GIMT_Encode4(430431), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430295 */ /*GILLT_nxv2s64*//*Label 8522*/ GIMT_Encode4(430551), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430307 */ /*GILLT_nxv4s32*//*Label 8523*/ GIMT_Encode4(430580),
     /* 430311 */ // Label 8520: @430311
     /* 430311 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(430430),
     /* 430316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 430325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430337 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(430410), // Rule ID 26 //
     /* 430342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 430349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 430353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430386 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430390 */     // MIs[3] Operand 1
     /* 430390 */     // No operand predicates
     /* 430390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430392 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 430395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 430399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430408 */     GIR_RootConstrainSelectedInstOperands,
     /* 430409 */     // GIR_Coverage, 26,
     /* 430409 */     GIR_EraseRootFromParent_Done,
     /* 430410 */   // Label 8526: @430410
     /* 430410 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(430429), // Rule ID 22 //
     /* 430415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430422 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 430427 */     GIR_RootConstrainSelectedInstOperands,
     /* 430428 */     // GIR_Coverage, 22,
     /* 430428 */     GIR_Done,
     /* 430429 */   // Label 8527: @430429
     /* 430429 */   GIM_Reject,
     /* 430430 */ // Label 8525: @430430
     /* 430430 */ GIM_Reject,
     /* 430431 */ // Label 8521: @430431
     /* 430431 */ GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(430550),
     /* 430436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 430442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 430445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430457 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(430530), // Rule ID 27 //
     /* 430462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 430469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 430473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430506 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430510 */     // MIs[3] Operand 1
     /* 430510 */     // No operand predicates
     /* 430510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430512 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 430515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 430519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430528 */     GIR_RootConstrainSelectedInstOperands,
     /* 430529 */     // GIR_Coverage, 27,
     /* 430529 */     GIR_EraseRootFromParent_Done,
     /* 430530 */   // Label 8529: @430530
     /* 430530 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(430549), // Rule ID 23 //
     /* 430535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430542 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 430547 */     GIR_RootConstrainSelectedInstOperands,
     /* 430548 */     // GIR_Coverage, 23,
     /* 430548 */     GIR_Done,
     /* 430549 */   // Label 8530: @430549
     /* 430549 */   GIM_Reject,
     /* 430550 */ // Label 8528: @430550
     /* 430550 */ GIM_Reject,
     /* 430551 */ // Label 8522: @430551
     /* 430551 */ GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(430579), // Rule ID 2982 //
     /* 430556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 430562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 430565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 430568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430572 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 430572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 430577 */   GIR_RootConstrainSelectedInstOperands,
     /* 430578 */   // GIR_Coverage, 2982,
     /* 430578 */   GIR_Done,
     /* 430579 */ // Label 8531: @430579
     /* 430579 */ GIM_Reject,
     /* 430580 */ // Label 8523: @430580
     /* 430580 */ GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(430608), // Rule ID 2981 //
     /* 430585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 430591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 430594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 430597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430601 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 430601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 430606 */   GIR_RootConstrainSelectedInstOperands,
     /* 430607 */   // GIR_Coverage, 2981,
     /* 430607 */   GIR_Done,
     /* 430608 */ // Label 8532: @430608
     /* 430608 */ GIM_Reject,
     /* 430609 */ // Label 8524: @430609
     /* 430609 */ GIM_Reject,
     /* 430610 */ // Label 139: @430610
     /* 430610 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8536*/ GIMT_Encode4(430726),
     /* 430621 */ /*GILLT_s16*//*Label 8533*/ GIMT_Encode4(430633),
     /* 430625 */ /*GILLT_s32*//*Label 8534*/ GIMT_Encode4(430664),
     /* 430629 */ /*GILLT_s64*//*Label 8535*/ GIMT_Encode4(430695),
     /* 430633 */ // Label 8533: @430633
     /* 430633 */ GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(430663), // Rule ID 1658 //
     /* 430638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 430641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 430644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 430648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 430652 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 430652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 430657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430661 */   GIR_RootConstrainSelectedInstOperands,
     /* 430662 */   // GIR_Coverage, 1658,
     /* 430662 */   GIR_Done,
     /* 430663 */ // Label 8537: @430663
     /* 430663 */ GIM_Reject,
     /* 430664 */ // Label 8534: @430664
     /* 430664 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(430694), // Rule ID 1657 //
     /* 430669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 430672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 430675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430683 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 430683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 430688 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430692 */   GIR_RootConstrainSelectedInstOperands,
     /* 430693 */   // GIR_Coverage, 1657,
     /* 430693 */   GIR_Done,
     /* 430694 */ // Label 8538: @430694
     /* 430694 */ GIM_Reject,
     /* 430695 */ // Label 8535: @430695
     /* 430695 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(430725), // Rule ID 1656 //
     /* 430700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 430703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 430706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430714 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 430714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 430719 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430723 */   GIR_RootConstrainSelectedInstOperands,
     /* 430724 */   // GIR_Coverage, 1656,
     /* 430724 */   GIR_Done,
     /* 430725 */ // Label 8539: @430725
     /* 430725 */ GIM_Reject,
     /* 430726 */ // Label 8536: @430726
     /* 430726 */ GIM_Reject,
     /* 430727 */ // Label 140: @430727
     /* 430727 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8543*/ GIMT_Encode4(431959),
     /* 430738 */ /*GILLT_v2s64*//*Label 8540*/ GIMT_Encode4(430758), GIMT_Encode4(0),
     /* 430746 */ /*GILLT_v4s32*//*Label 8541*/ GIMT_Encode4(431319), GIMT_Encode4(0),
     /* 430754 */ /*GILLT_v8s16*//*Label 8542*/ GIMT_Encode4(431880),
     /* 430758 */ // Label 8540: @430758
     /* 430758 */ GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(431318),
     /* 430763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 430769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430773 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(430865), // Rule ID 2054 //
     /* 430778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430822 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430826 */     // MIs[3] Operand 1
     /* 430826 */     // No operand predicates
     /* 430826 */     // MIs[1] Operand 2
     /* 430826 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 430837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 430846 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 430849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430863 */     GIR_RootConstrainSelectedInstOperands,
     /* 430864 */     // GIR_Coverage, 2054,
     /* 430864 */     GIR_EraseRootFromParent_Done,
     /* 430865 */   // Label 8545: @430865
     /* 430865 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(430957), // Rule ID 13594 //
     /* 430870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430914 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430918 */     // MIs[3] Operand 1
     /* 430918 */     // No operand predicates
     /* 430918 */     // MIs[1] Operand 2
     /* 430918 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 430929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 430938 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 430941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430955 */     GIR_RootConstrainSelectedInstOperands,
     /* 430956 */     // GIR_Coverage, 13594,
     /* 430956 */     GIR_EraseRootFromParent_Done,
     /* 430957 */   // Label 8546: @430957
     /* 430957 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(431043), // Rule ID 13592 //
     /* 430962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431006 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431010 */     // MIs[3] Operand 1
     /* 431010 */     // No operand predicates
     /* 431010 */     // MIs[1] Operand 2
     /* 431010 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 431021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431027 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 431030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431041 */     GIR_RootConstrainSelectedInstOperands,
     /* 431042 */     // GIR_Coverage, 13592,
     /* 431042 */     GIR_EraseRootFromParent_Done,
     /* 431043 */   // Label 8547: @431043
     /* 431043 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(431129), // Rule ID 2052 //
     /* 431048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431096 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431100 */     // MIs[3] Operand 1
     /* 431100 */     // No operand predicates
     /* 431100 */     // MIs[1] Operand 2
     /* 431100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 431111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431113 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 431116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431127 */     GIR_RootConstrainSelectedInstOperands,
     /* 431128 */     // GIR_Coverage, 2052,
     /* 431128 */     GIR_EraseRootFromParent_Done,
     /* 431129 */   // Label 8548: @431129
     /* 431129 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(431168), // Rule ID 1741 //
     /* 431134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 431144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 431151 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 431151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 431154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 431166 */     GIR_RootConstrainSelectedInstOperands,
     /* 431167 */     // GIR_Coverage, 1741,
     /* 431167 */     GIR_EraseRootFromParent_Done,
     /* 431168 */   // Label 8549: @431168
     /* 431168 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(431231), // Rule ID 13593 //
     /* 431173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431205 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431209 */     // MIs[2] Operand 1
     /* 431209 */     // No operand predicates
     /* 431209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431215 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 431218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431229 */     GIR_RootConstrainSelectedInstOperands,
     /* 431230 */     // GIR_Coverage, 13593,
     /* 431230 */     GIR_EraseRootFromParent_Done,
     /* 431231 */   // Label 8550: @431231
     /* 431231 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(431294), // Rule ID 2053 //
     /* 431236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431276 */     // MIs[2] Operand 1
     /* 431276 */     // No operand predicates
     /* 431276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431278 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 431281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431292 */     GIR_RootConstrainSelectedInstOperands,
     /* 431293 */     // GIR_Coverage, 2053,
     /* 431293 */     GIR_EraseRootFromParent_Done,
     /* 431294 */   // Label 8551: @431294
     /* 431294 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(431317), // Rule ID 1740 //
     /* 431299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431310 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 431310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 431315 */     GIR_RootConstrainSelectedInstOperands,
     /* 431316 */     // GIR_Coverage, 1740,
     /* 431316 */     GIR_Done,
     /* 431317 */   // Label 8552: @431317
     /* 431317 */   GIM_Reject,
     /* 431318 */ // Label 8544: @431318
     /* 431318 */ GIM_Reject,
     /* 431319 */ // Label 8541: @431319
     /* 431319 */ GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(431879),
     /* 431324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 431330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431334 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(431426), // Rule ID 2051 //
     /* 431339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431383 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431387 */     // MIs[3] Operand 1
     /* 431387 */     // No operand predicates
     /* 431387 */     // MIs[1] Operand 2
     /* 431387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 431398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431407 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 431410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431424 */     GIR_RootConstrainSelectedInstOperands,
     /* 431425 */     // GIR_Coverage, 2051,
     /* 431425 */     GIR_EraseRootFromParent_Done,
     /* 431426 */   // Label 8554: @431426
     /* 431426 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(431518), // Rule ID 13591 //
     /* 431431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431475 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431479 */     // MIs[3] Operand 1
     /* 431479 */     // No operand predicates
     /* 431479 */     // MIs[1] Operand 2
     /* 431479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 431490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431499 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 431502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431516 */     GIR_RootConstrainSelectedInstOperands,
     /* 431517 */     // GIR_Coverage, 13591,
     /* 431517 */     GIR_EraseRootFromParent_Done,
     /* 431518 */   // Label 8555: @431518
     /* 431518 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(431604), // Rule ID 13589 //
     /* 431523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431567 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431571 */     // MIs[3] Operand 1
     /* 431571 */     // No operand predicates
     /* 431571 */     // MIs[1] Operand 2
     /* 431571 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 431582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431588 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431602 */     GIR_RootConstrainSelectedInstOperands,
     /* 431603 */     // GIR_Coverage, 13589,
     /* 431603 */     GIR_EraseRootFromParent_Done,
     /* 431604 */   // Label 8556: @431604
     /* 431604 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(431690), // Rule ID 2049 //
     /* 431609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431657 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431661 */     // MIs[3] Operand 1
     /* 431661 */     // No operand predicates
     /* 431661 */     // MIs[1] Operand 2
     /* 431661 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 431672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431674 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431688 */     GIR_RootConstrainSelectedInstOperands,
     /* 431689 */     // GIR_Coverage, 2049,
     /* 431689 */     GIR_EraseRootFromParent_Done,
     /* 431690 */   // Label 8557: @431690
     /* 431690 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(431729), // Rule ID 1739 //
     /* 431695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431712 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 431712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 431715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 431727 */     GIR_RootConstrainSelectedInstOperands,
     /* 431728 */     // GIR_Coverage, 1739,
     /* 431728 */     GIR_EraseRootFromParent_Done,
     /* 431729 */   // Label 8558: @431729
     /* 431729 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(431792), // Rule ID 13590 //
     /* 431734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431766 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431770 */     // MIs[2] Operand 1
     /* 431770 */     // No operand predicates
     /* 431770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431776 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431790 */     GIR_RootConstrainSelectedInstOperands,
     /* 431791 */     // GIR_Coverage, 13590,
     /* 431791 */     GIR_EraseRootFromParent_Done,
     /* 431792 */   // Label 8559: @431792
     /* 431792 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(431855), // Rule ID 2050 //
     /* 431797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431837 */     // MIs[2] Operand 1
     /* 431837 */     // No operand predicates
     /* 431837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431839 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431853 */     GIR_RootConstrainSelectedInstOperands,
     /* 431854 */     // GIR_Coverage, 2050,
     /* 431854 */     GIR_EraseRootFromParent_Done,
     /* 431855 */   // Label 8560: @431855
     /* 431855 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(431878), // Rule ID 1738 //
     /* 431860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431871 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 431871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 431876 */     GIR_RootConstrainSelectedInstOperands,
     /* 431877 */     // GIR_Coverage, 1738,
     /* 431877 */     GIR_Done,
     /* 431878 */   // Label 8561: @431878
     /* 431878 */   GIM_Reject,
     /* 431879 */ // Label 8553: @431879
     /* 431879 */ GIM_Reject,
     /* 431880 */ // Label 8542: @431880
     /* 431880 */ GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(431958),
     /* 431885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431895 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(431934), // Rule ID 1737 //
     /* 431900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 431910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 431917 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 431920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 431932 */     GIR_RootConstrainSelectedInstOperands,
     /* 431933 */     // GIR_Coverage, 1737,
     /* 431933 */     GIR_EraseRootFromParent_Done,
     /* 431934 */   // Label 8563: @431934
     /* 431934 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(431957), // Rule ID 1736 //
     /* 431939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431950 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 431955 */     GIR_RootConstrainSelectedInstOperands,
     /* 431956 */     // GIR_Coverage, 1736,
     /* 431956 */     GIR_Done,
     /* 431957 */   // Label 8564: @431957
     /* 431957 */   GIM_Reject,
     /* 431958 */ // Label 8562: @431958
     /* 431958 */ GIM_Reject,
     /* 431959 */ // Label 8543: @431959
     /* 431959 */ GIM_Reject,
     /* 431960 */ // Label 141: @431960
     /* 431960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8583*/ GIMT_Encode4(432739),
     /* 431971 */ /*GILLT_v2s32*//*Label 8565*/ GIMT_Encode4(432047),
     /* 431975 */ /*GILLT_v2s64*//*Label 8566*/ GIMT_Encode4(432102),
     /* 431979 */ /*GILLT_v4s16*//*Label 8567*/ GIMT_Encode4(432157),
     /* 431983 */ /*GILLT_v4s32*//*Label 8568*/ GIMT_Encode4(432212),
     /* 431987 */ /*GILLT_v8s8*//*Label 8569*/ GIMT_Encode4(432267),
     /* 431991 */ /*GILLT_v8s16*//*Label 8570*/ GIMT_Encode4(432301),
     /* 431995 */ /*GILLT_v16s8*//*Label 8571*/ GIMT_Encode4(432356), GIMT_Encode4(0),
     /* 432003 */ /*GILLT_nxv2s1*//*Label 8572*/ GIMT_Encode4(432390),
     /* 432007 */ /*GILLT_nxv2s16*//*Label 8573*/ GIMT_Encode4(432416),
     /* 432011 */ /*GILLT_nxv2s32*//*Label 8574*/ GIMT_Encode4(432442),
     /* 432015 */ /*GILLT_nxv2s64*//*Label 8575*/ GIMT_Encode4(432468),
     /* 432019 */ /*GILLT_nxv4s1*//*Label 8576*/ GIMT_Encode4(432515),
     /* 432023 */ /*GILLT_nxv4s16*//*Label 8577*/ GIMT_Encode4(432541),
     /* 432027 */ /*GILLT_nxv4s32*//*Label 8578*/ GIMT_Encode4(432567),
     /* 432031 */ /*GILLT_nxv8s1*//*Label 8579*/ GIMT_Encode4(432614),
     /* 432035 */ /*GILLT_nxv8s16*//*Label 8580*/ GIMT_Encode4(432640),
     /* 432039 */ /*GILLT_nxv16s1*//*Label 8581*/ GIMT_Encode4(432687),
     /* 432043 */ /*GILLT_nxv16s8*//*Label 8582*/ GIMT_Encode4(432713),
     /* 432047 */ // Label 8565: @432047
     /* 432047 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(432101),
     /* 432052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 432058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432070 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(432085), // Rule ID 1874 //
     /* 432075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432078 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 432078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 432083 */     GIR_RootConstrainSelectedInstOperands,
     /* 432084 */     // GIR_Coverage, 1874,
     /* 432084 */     GIR_Done,
     /* 432085 */   // Label 8585: @432085
     /* 432085 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(432100), // Rule ID 2501 //
     /* 432090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432093 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 432093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 432098 */     GIR_RootConstrainSelectedInstOperands,
     /* 432099 */     // GIR_Coverage, 2501,
     /* 432099 */     GIR_Done,
     /* 432100 */   // Label 8586: @432100
     /* 432100 */   GIM_Reject,
     /* 432101 */ // Label 8584: @432101
     /* 432101 */ GIM_Reject,
     /* 432102 */ // Label 8566: @432102
     /* 432102 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(432156),
     /* 432107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 432110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 432113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432125 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(432140), // Rule ID 1876 //
     /* 432130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432133 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 432133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 432138 */     GIR_RootConstrainSelectedInstOperands,
     /* 432139 */     // GIR_Coverage, 1876,
     /* 432139 */     GIR_Done,
     /* 432140 */   // Label 8588: @432140
     /* 432140 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(432155), // Rule ID 2503 //
     /* 432145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432148 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 432148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 432153 */     GIR_RootConstrainSelectedInstOperands,
     /* 432154 */     // GIR_Coverage, 2503,
     /* 432154 */     GIR_Done,
     /* 432155 */   // Label 8589: @432155
     /* 432155 */   GIM_Reject,
     /* 432156 */ // Label 8587: @432156
     /* 432156 */ GIM_Reject,
     /* 432157 */ // Label 8567: @432157
     /* 432157 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(432211),
     /* 432162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 432168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432180 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(432195), // Rule ID 1872 //
     /* 432185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432188 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 432188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 432193 */     GIR_RootConstrainSelectedInstOperands,
     /* 432194 */     // GIR_Coverage, 1872,
     /* 432194 */     GIR_Done,
     /* 432195 */   // Label 8591: @432195
     /* 432195 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(432210), // Rule ID 2499 //
     /* 432200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432203 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 432203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 432208 */     GIR_RootConstrainSelectedInstOperands,
     /* 432209 */     // GIR_Coverage, 2499,
     /* 432209 */     GIR_Done,
     /* 432210 */   // Label 8592: @432210
     /* 432210 */   GIM_Reject,
     /* 432211 */ // Label 8590: @432211
     /* 432211 */ GIM_Reject,
     /* 432212 */ // Label 8568: @432212
     /* 432212 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(432266),
     /* 432217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 432223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432235 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(432250), // Rule ID 1875 //
     /* 432240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432243 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 432243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 432248 */     GIR_RootConstrainSelectedInstOperands,
     /* 432249 */     // GIR_Coverage, 1875,
     /* 432249 */     GIR_Done,
     /* 432250 */   // Label 8594: @432250
     /* 432250 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(432265), // Rule ID 2502 //
     /* 432255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432258 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 432258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 432263 */     GIR_RootConstrainSelectedInstOperands,
     /* 432264 */     // GIR_Coverage, 2502,
     /* 432264 */     GIR_Done,
     /* 432265 */   // Label 8595: @432265
     /* 432265 */   GIM_Reject,
     /* 432266 */ // Label 8593: @432266
     /* 432266 */ GIM_Reject,
     /* 432267 */ // Label 8569: @432267
     /* 432267 */ GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(432300), // Rule ID 1870 //
     /* 432272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432293 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 432293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 432298 */   GIR_RootConstrainSelectedInstOperands,
     /* 432299 */   // GIR_Coverage, 1870,
     /* 432299 */   GIR_Done,
     /* 432300 */ // Label 8596: @432300
     /* 432300 */ GIM_Reject,
     /* 432301 */ // Label 8570: @432301
     /* 432301 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(432355),
     /* 432306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 432312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432324 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(432339), // Rule ID 1873 //
     /* 432329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432332 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 432332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 432337 */     GIR_RootConstrainSelectedInstOperands,
     /* 432338 */     // GIR_Coverage, 1873,
     /* 432338 */     GIR_Done,
     /* 432339 */   // Label 8598: @432339
     /* 432339 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(432354), // Rule ID 2500 //
     /* 432344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432347 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 432347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 432352 */     GIR_RootConstrainSelectedInstOperands,
     /* 432353 */     // GIR_Coverage, 2500,
     /* 432353 */     GIR_Done,
     /* 432354 */   // Label 8599: @432354
     /* 432354 */   GIM_Reject,
     /* 432355 */ // Label 8597: @432355
     /* 432355 */ GIM_Reject,
     /* 432356 */ // Label 8571: @432356
     /* 432356 */ GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(432389), // Rule ID 1871 //
     /* 432361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 432370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432382 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 432382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 432387 */   GIR_RootConstrainSelectedInstOperands,
     /* 432388 */   // GIR_Coverage, 1871,
     /* 432388 */   GIR_Done,
     /* 432389 */ // Label 8600: @432389
     /* 432389 */ GIM_Reject,
     /* 432390 */ // Label 8572: @432390
     /* 432390 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(432415), // Rule ID 9030 //
     /* 432395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 432401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 432404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432408 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 432408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 432413 */   GIR_RootConstrainSelectedInstOperands,
     /* 432414 */   // GIR_Coverage, 9030,
     /* 432414 */   GIR_Done,
     /* 432415 */ // Label 8601: @432415
     /* 432415 */ GIM_Reject,
     /* 432416 */ // Label 8573: @432416
     /* 432416 */ GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(432441), // Rule ID 9006 //
     /* 432421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 432427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 432430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432434 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 432434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432439 */   GIR_RootConstrainSelectedInstOperands,
     /* 432440 */   // GIR_Coverage, 9006,
     /* 432440 */   GIR_Done,
     /* 432441 */ // Label 8602: @432441
     /* 432441 */ GIM_Reject,
     /* 432442 */ // Label 8574: @432442
     /* 432442 */ GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(432467), // Rule ID 9007 //
     /* 432447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 432453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 432456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432460 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 432460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432465 */   GIR_RootConstrainSelectedInstOperands,
     /* 432466 */   // GIR_Coverage, 9007,
     /* 432466 */   GIR_Done,
     /* 432467 */ // Label 8603: @432467
     /* 432467 */ GIM_Reject,
     /* 432468 */ // Label 8575: @432468
     /* 432468 */ GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(432514),
     /* 432473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 432476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 432479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432483 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(432498), // Rule ID 9002 //
     /* 432488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432491 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 432491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432496 */     GIR_RootConstrainSelectedInstOperands,
     /* 432497 */     // GIR_Coverage, 9002,
     /* 432497 */     GIR_Done,
     /* 432498 */   // Label 8605: @432498
     /* 432498 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(432513), // Rule ID 9008 //
     /* 432503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432506 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 432506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432511 */     GIR_RootConstrainSelectedInstOperands,
     /* 432512 */     // GIR_Coverage, 9008,
     /* 432512 */     GIR_Done,
     /* 432513 */   // Label 8606: @432513
     /* 432513 */   GIM_Reject,
     /* 432514 */ // Label 8604: @432514
     /* 432514 */ GIM_Reject,
     /* 432515 */ // Label 8576: @432515
     /* 432515 */ GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(432540), // Rule ID 9029 //
     /* 432520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 432526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 432529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432533 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 432533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 432538 */   GIR_RootConstrainSelectedInstOperands,
     /* 432539 */   // GIR_Coverage, 9029,
     /* 432539 */   GIR_Done,
     /* 432540 */ // Label 8607: @432540
     /* 432540 */ GIM_Reject,
     /* 432541 */ // Label 8577: @432541
     /* 432541 */ GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(432566), // Rule ID 9004 //
     /* 432546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 432552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 432555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432559 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 432559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 432564 */   GIR_RootConstrainSelectedInstOperands,
     /* 432565 */   // GIR_Coverage, 9004,
     /* 432565 */   GIR_Done,
     /* 432566 */ // Label 8608: @432566
     /* 432566 */ GIM_Reject,
     /* 432567 */ // Label 8578: @432567
     /* 432567 */ GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(432613),
     /* 432572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 432575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 432578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432582 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(432597), // Rule ID 9001 //
     /* 432587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432590 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 432590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 432595 */     GIR_RootConstrainSelectedInstOperands,
     /* 432596 */     // GIR_Coverage, 9001,
     /* 432596 */     GIR_Done,
     /* 432597 */   // Label 8610: @432597
     /* 432597 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(432612), // Rule ID 9005 //
     /* 432602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432605 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 432605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 432610 */     GIR_RootConstrainSelectedInstOperands,
     /* 432611 */     // GIR_Coverage, 9005,
     /* 432611 */     GIR_Done,
     /* 432612 */   // Label 8611: @432612
     /* 432612 */   GIM_Reject,
     /* 432613 */ // Label 8609: @432613
     /* 432613 */ GIM_Reject,
     /* 432614 */ // Label 8579: @432614
     /* 432614 */ GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(432639), // Rule ID 9028 //
     /* 432619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 432625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 432628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432632 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 432632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 432637 */   GIR_RootConstrainSelectedInstOperands,
     /* 432638 */   // GIR_Coverage, 9028,
     /* 432638 */   GIR_Done,
     /* 432639 */ // Label 8612: @432639
     /* 432639 */ GIM_Reject,
     /* 432640 */ // Label 8580: @432640
     /* 432640 */ GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(432686),
     /* 432645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 432648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 432651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432655 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(432670), // Rule ID 9000 //
     /* 432660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432663 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 432663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 432668 */     GIR_RootConstrainSelectedInstOperands,
     /* 432669 */     // GIR_Coverage, 9000,
     /* 432669 */     GIR_Done,
     /* 432670 */   // Label 8614: @432670
     /* 432670 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(432685), // Rule ID 9003 //
     /* 432675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432678 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 432678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 432683 */     GIR_RootConstrainSelectedInstOperands,
     /* 432684 */     // GIR_Coverage, 9003,
     /* 432684 */     GIR_Done,
     /* 432685 */   // Label 8615: @432685
     /* 432685 */   GIM_Reject,
     /* 432686 */ // Label 8613: @432686
     /* 432686 */ GIM_Reject,
     /* 432687 */ // Label 8581: @432687
     /* 432687 */ GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(432712), // Rule ID 2414 //
     /* 432692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 432698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 432701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432705 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 432705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 432710 */   GIR_RootConstrainSelectedInstOperands,
     /* 432711 */   // GIR_Coverage, 2414,
     /* 432711 */   GIR_Done,
     /* 432712 */ // Label 8616: @432712
     /* 432712 */ GIM_Reject,
     /* 432713 */ // Label 8582: @432713
     /* 432713 */ GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(432738), // Rule ID 8999 //
     /* 432718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 432724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 432727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432731 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 432731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 432736 */   GIR_RootConstrainSelectedInstOperands,
     /* 432737 */   // GIR_Coverage, 8999,
     /* 432737 */   GIR_Done,
     /* 432738 */ // Label 8617: @432738
     /* 432738 */ GIM_Reject,
     /* 432739 */ // Label 8583: @432739
     /* 432739 */ GIM_Reject,
     /* 432740 */ // Label 142: @432740
     /* 432740 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8636*/ GIMT_Encode4(433519),
     /* 432751 */ /*GILLT_v2s32*//*Label 8618*/ GIMT_Encode4(432827),
     /* 432755 */ /*GILLT_v2s64*//*Label 8619*/ GIMT_Encode4(432882),
     /* 432759 */ /*GILLT_v4s16*//*Label 8620*/ GIMT_Encode4(432937),
     /* 432763 */ /*GILLT_v4s32*//*Label 8621*/ GIMT_Encode4(432992),
     /* 432767 */ /*GILLT_v8s8*//*Label 8622*/ GIMT_Encode4(433047),
     /* 432771 */ /*GILLT_v8s16*//*Label 8623*/ GIMT_Encode4(433081),
     /* 432775 */ /*GILLT_v16s8*//*Label 8624*/ GIMT_Encode4(433136), GIMT_Encode4(0),
     /* 432783 */ /*GILLT_nxv2s1*//*Label 8625*/ GIMT_Encode4(433170),
     /* 432787 */ /*GILLT_nxv2s16*//*Label 8626*/ GIMT_Encode4(433196),
     /* 432791 */ /*GILLT_nxv2s32*//*Label 8627*/ GIMT_Encode4(433222),
     /* 432795 */ /*GILLT_nxv2s64*//*Label 8628*/ GIMT_Encode4(433248),
     /* 432799 */ /*GILLT_nxv4s1*//*Label 8629*/ GIMT_Encode4(433295),
     /* 432803 */ /*GILLT_nxv4s16*//*Label 8630*/ GIMT_Encode4(433321),
     /* 432807 */ /*GILLT_nxv4s32*//*Label 8631*/ GIMT_Encode4(433347),
     /* 432811 */ /*GILLT_nxv8s1*//*Label 8632*/ GIMT_Encode4(433394),
     /* 432815 */ /*GILLT_nxv8s16*//*Label 8633*/ GIMT_Encode4(433420),
     /* 432819 */ /*GILLT_nxv16s1*//*Label 8634*/ GIMT_Encode4(433467),
     /* 432823 */ /*GILLT_nxv16s8*//*Label 8635*/ GIMT_Encode4(433493),
     /* 432827 */ // Label 8618: @432827
     /* 432827 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(432881),
     /* 432832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 432838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432850 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(432865), // Rule ID 1881 //
     /* 432855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432858 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 432858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 432863 */     GIR_RootConstrainSelectedInstOperands,
     /* 432864 */     // GIR_Coverage, 1881,
     /* 432864 */     GIR_Done,
     /* 432865 */   // Label 8638: @432865
     /* 432865 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(432880), // Rule ID 5488 //
     /* 432870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432873 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 432873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 432878 */     GIR_RootConstrainSelectedInstOperands,
     /* 432879 */     // GIR_Coverage, 5488,
     /* 432879 */     GIR_Done,
     /* 432880 */   // Label 8639: @432880
     /* 432880 */   GIM_Reject,
     /* 432881 */ // Label 8637: @432881
     /* 432881 */ GIM_Reject,
     /* 432882 */ // Label 8619: @432882
     /* 432882 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(432936),
     /* 432887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 432890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 432893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432905 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(432920), // Rule ID 1883 //
     /* 432910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432913 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 432913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 432918 */     GIR_RootConstrainSelectedInstOperands,
     /* 432919 */     // GIR_Coverage, 1883,
     /* 432919 */     GIR_Done,
     /* 432920 */   // Label 8641: @432920
     /* 432920 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(432935), // Rule ID 5490 //
     /* 432925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432928 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 432928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 432933 */     GIR_RootConstrainSelectedInstOperands,
     /* 432934 */     // GIR_Coverage, 5490,
     /* 432934 */     GIR_Done,
     /* 432935 */   // Label 8642: @432935
     /* 432935 */   GIM_Reject,
     /* 432936 */ // Label 8640: @432936
     /* 432936 */ GIM_Reject,
     /* 432937 */ // Label 8620: @432937
     /* 432937 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(432991),
     /* 432942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 432948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432960 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(432975), // Rule ID 1879 //
     /* 432965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432968 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 432968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 432973 */     GIR_RootConstrainSelectedInstOperands,
     /* 432974 */     // GIR_Coverage, 1879,
     /* 432974 */     GIR_Done,
     /* 432975 */   // Label 8644: @432975
     /* 432975 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(432990), // Rule ID 5486 //
     /* 432980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432983 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 432983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 432988 */     GIR_RootConstrainSelectedInstOperands,
     /* 432989 */     // GIR_Coverage, 5486,
     /* 432989 */     GIR_Done,
     /* 432990 */   // Label 8645: @432990
     /* 432990 */   GIM_Reject,
     /* 432991 */ // Label 8643: @432991
     /* 432991 */ GIM_Reject,
     /* 432992 */ // Label 8621: @432992
     /* 432992 */ GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(433046),
     /* 432997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 433003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433015 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(433030), // Rule ID 1882 //
     /* 433020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433023 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 433023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 433028 */     GIR_RootConstrainSelectedInstOperands,
     /* 433029 */     // GIR_Coverage, 1882,
     /* 433029 */     GIR_Done,
     /* 433030 */   // Label 8647: @433030
     /* 433030 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(433045), // Rule ID 5489 //
     /* 433035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433038 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 433038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 433043 */     GIR_RootConstrainSelectedInstOperands,
     /* 433044 */     // GIR_Coverage, 5489,
     /* 433044 */     GIR_Done,
     /* 433045 */   // Label 8648: @433045
     /* 433045 */   GIM_Reject,
     /* 433046 */ // Label 8646: @433046
     /* 433046 */ GIM_Reject,
     /* 433047 */ // Label 8622: @433047
     /* 433047 */ GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(433080), // Rule ID 1877 //
     /* 433052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 433061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433073 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 433073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 433078 */   GIR_RootConstrainSelectedInstOperands,
     /* 433079 */   // GIR_Coverage, 1877,
     /* 433079 */   GIR_Done,
     /* 433080 */ // Label 8649: @433080
     /* 433080 */ GIM_Reject,
     /* 433081 */ // Label 8623: @433081
     /* 433081 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(433135),
     /* 433086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 433092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433104 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(433119), // Rule ID 1880 //
     /* 433109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433112 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 433112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 433117 */     GIR_RootConstrainSelectedInstOperands,
     /* 433118 */     // GIR_Coverage, 1880,
     /* 433118 */     GIR_Done,
     /* 433119 */   // Label 8651: @433119
     /* 433119 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(433134), // Rule ID 5487 //
     /* 433124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433127 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 433127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 433132 */     GIR_RootConstrainSelectedInstOperands,
     /* 433133 */     // GIR_Coverage, 5487,
     /* 433133 */     GIR_Done,
     /* 433134 */   // Label 8652: @433134
     /* 433134 */   GIM_Reject,
     /* 433135 */ // Label 8650: @433135
     /* 433135 */ GIM_Reject,
     /* 433136 */ // Label 8624: @433136
     /* 433136 */ GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(433169), // Rule ID 1878 //
     /* 433141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433162 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 433167 */   GIR_RootConstrainSelectedInstOperands,
     /* 433168 */   // GIR_Coverage, 1878,
     /* 433168 */   GIR_Done,
     /* 433169 */ // Label 8653: @433169
     /* 433169 */ GIM_Reject,
     /* 433170 */ // Label 8625: @433170
     /* 433170 */ GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(433195), // Rule ID 9033 //
     /* 433175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 433181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 433184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433188 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 433188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 433193 */   GIR_RootConstrainSelectedInstOperands,
     /* 433194 */   // GIR_Coverage, 9033,
     /* 433194 */   GIR_Done,
     /* 433195 */ // Label 8654: @433195
     /* 433195 */ GIM_Reject,
     /* 433196 */ // Label 8626: @433196
     /* 433196 */ GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(433221), // Rule ID 9016 //
     /* 433201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 433207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 433210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433214 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 433214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433219 */   GIR_RootConstrainSelectedInstOperands,
     /* 433220 */   // GIR_Coverage, 9016,
     /* 433220 */   GIR_Done,
     /* 433221 */ // Label 8655: @433221
     /* 433221 */ GIM_Reject,
     /* 433222 */ // Label 8627: @433222
     /* 433222 */ GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(433247), // Rule ID 9017 //
     /* 433227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 433233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 433236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433240 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 433240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433245 */   GIR_RootConstrainSelectedInstOperands,
     /* 433246 */   // GIR_Coverage, 9017,
     /* 433246 */   GIR_Done,
     /* 433247 */ // Label 8656: @433247
     /* 433247 */ GIM_Reject,
     /* 433248 */ // Label 8628: @433248
     /* 433248 */ GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(433294),
     /* 433253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 433259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433263 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(433278), // Rule ID 9012 //
     /* 433268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433271 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 433271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433276 */     GIR_RootConstrainSelectedInstOperands,
     /* 433277 */     // GIR_Coverage, 9012,
     /* 433277 */     GIR_Done,
     /* 433278 */   // Label 8658: @433278
     /* 433278 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(433293), // Rule ID 9018 //
     /* 433283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433286 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 433286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433291 */     GIR_RootConstrainSelectedInstOperands,
     /* 433292 */     // GIR_Coverage, 9018,
     /* 433292 */     GIR_Done,
     /* 433293 */   // Label 8659: @433293
     /* 433293 */   GIM_Reject,
     /* 433294 */ // Label 8657: @433294
     /* 433294 */ GIM_Reject,
     /* 433295 */ // Label 8629: @433295
     /* 433295 */ GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(433320), // Rule ID 9032 //
     /* 433300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 433306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 433309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433313 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 433313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 433318 */   GIR_RootConstrainSelectedInstOperands,
     /* 433319 */   // GIR_Coverage, 9032,
     /* 433319 */   GIR_Done,
     /* 433320 */ // Label 8660: @433320
     /* 433320 */ GIM_Reject,
     /* 433321 */ // Label 8630: @433321
     /* 433321 */ GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(433346), // Rule ID 9014 //
     /* 433326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 433332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 433335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433339 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 433339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 433344 */   GIR_RootConstrainSelectedInstOperands,
     /* 433345 */   // GIR_Coverage, 9014,
     /* 433345 */   GIR_Done,
     /* 433346 */ // Label 8661: @433346
     /* 433346 */ GIM_Reject,
     /* 433347 */ // Label 8631: @433347
     /* 433347 */ GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(433393),
     /* 433352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 433358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433362 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(433377), // Rule ID 9011 //
     /* 433367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433370 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 433370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 433375 */     GIR_RootConstrainSelectedInstOperands,
     /* 433376 */     // GIR_Coverage, 9011,
     /* 433376 */     GIR_Done,
     /* 433377 */   // Label 8663: @433377
     /* 433377 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(433392), // Rule ID 9015 //
     /* 433382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433385 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 433385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 433390 */     GIR_RootConstrainSelectedInstOperands,
     /* 433391 */     // GIR_Coverage, 9015,
     /* 433391 */     GIR_Done,
     /* 433392 */   // Label 8664: @433392
     /* 433392 */   GIM_Reject,
     /* 433393 */ // Label 8662: @433393
     /* 433393 */ GIM_Reject,
     /* 433394 */ // Label 8632: @433394
     /* 433394 */ GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(433419), // Rule ID 9031 //
     /* 433399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 433405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 433408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433412 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 433412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 433417 */   GIR_RootConstrainSelectedInstOperands,
     /* 433418 */   // GIR_Coverage, 9031,
     /* 433418 */   GIR_Done,
     /* 433419 */ // Label 8665: @433419
     /* 433419 */ GIM_Reject,
     /* 433420 */ // Label 8633: @433420
     /* 433420 */ GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(433466),
     /* 433425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 433428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 433431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433435 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(433450), // Rule ID 9010 //
     /* 433440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433443 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 433443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 433448 */     GIR_RootConstrainSelectedInstOperands,
     /* 433449 */     // GIR_Coverage, 9010,
     /* 433449 */     GIR_Done,
     /* 433450 */   // Label 8667: @433450
     /* 433450 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(433465), // Rule ID 9013 //
     /* 433455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433458 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 433458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 433463 */     GIR_RootConstrainSelectedInstOperands,
     /* 433464 */     // GIR_Coverage, 9013,
     /* 433464 */     GIR_Done,
     /* 433465 */   // Label 8668: @433465
     /* 433465 */   GIM_Reject,
     /* 433466 */ // Label 8666: @433466
     /* 433466 */ GIM_Reject,
     /* 433467 */ // Label 8634: @433467
     /* 433467 */ GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(433492), // Rule ID 2418 //
     /* 433472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 433478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 433481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433485 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 433485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 433490 */   GIR_RootConstrainSelectedInstOperands,
     /* 433491 */   // GIR_Coverage, 2418,
     /* 433491 */   GIR_Done,
     /* 433492 */ // Label 8669: @433492
     /* 433492 */ GIM_Reject,
     /* 433493 */ // Label 8635: @433493
     /* 433493 */ GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(433518), // Rule ID 9009 //
     /* 433498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 433504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 433507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433511 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 433511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 433516 */   GIR_RootConstrainSelectedInstOperands,
     /* 433517 */   // GIR_Coverage, 9009,
     /* 433517 */   GIR_Done,
     /* 433518 */ // Label 8670: @433518
     /* 433518 */ GIM_Reject,
     /* 433519 */ // Label 8636: @433519
     /* 433519 */ GIM_Reject,
     /* 433520 */ // Label 143: @433520
     /* 433520 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8677*/ GIMT_Encode4(433725),
     /* 433531 */ /*GILLT_s64*//*Label 8671*/ GIMT_Encode4(433563), GIMT_Encode4(0),
     /* 433539 */ /*GILLT_v2s32*//*Label 8672*/ GIMT_Encode4(433590),
     /* 433543 */ /*GILLT_v2s64*//*Label 8673*/ GIMT_Encode4(433617),
     /* 433547 */ /*GILLT_v4s16*//*Label 8674*/ GIMT_Encode4(433644),
     /* 433551 */ /*GILLT_v4s32*//*Label 8675*/ GIMT_Encode4(433671), GIMT_Encode4(0),
     /* 433559 */ /*GILLT_v8s16*//*Label 8676*/ GIMT_Encode4(433698),
     /* 433563 */ // Label 8671: @433563
     /* 433563 */ GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(433589), // Rule ID 1069 //
     /* 433568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433582 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 433582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 433587 */   GIR_RootConstrainSelectedInstOperands,
     /* 433588 */   // GIR_Coverage, 1069,
     /* 433588 */   GIR_Done,
     /* 433589 */ // Label 8678: @433589
     /* 433589 */ GIM_Reject,
     /* 433590 */ // Label 8672: @433590
     /* 433590 */ GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(433616), // Rule ID 1065 //
     /* 433595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433609 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 433609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 433614 */   GIR_RootConstrainSelectedInstOperands,
     /* 433615 */   // GIR_Coverage, 1065,
     /* 433615 */   GIR_Done,
     /* 433616 */ // Label 8679: @433616
     /* 433616 */ GIM_Reject,
     /* 433617 */ // Label 8673: @433617
     /* 433617 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(433643), // Rule ID 1071 //
     /* 433622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433636 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 433636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 433641 */   GIR_RootConstrainSelectedInstOperands,
     /* 433642 */   // GIR_Coverage, 1071,
     /* 433642 */   GIR_Done,
     /* 433643 */ // Label 8680: @433643
     /* 433643 */ GIM_Reject,
     /* 433644 */ // Label 8674: @433644
     /* 433644 */ GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(433670), // Rule ID 1061 //
     /* 433649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433663 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 433663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 433668 */   GIR_RootConstrainSelectedInstOperands,
     /* 433669 */   // GIR_Coverage, 1061,
     /* 433669 */   GIR_Done,
     /* 433670 */ // Label 8681: @433670
     /* 433670 */ GIM_Reject,
     /* 433671 */ // Label 8675: @433671
     /* 433671 */ GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(433697), // Rule ID 1067 //
     /* 433676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433690 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 433690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 433695 */   GIR_RootConstrainSelectedInstOperands,
     /* 433696 */   // GIR_Coverage, 1067,
     /* 433696 */   GIR_Done,
     /* 433697 */ // Label 8682: @433697
     /* 433697 */ GIM_Reject,
     /* 433698 */ // Label 8676: @433698
     /* 433698 */ GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(433724), // Rule ID 1063 //
     /* 433703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433717 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 433717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 433722 */   GIR_RootConstrainSelectedInstOperands,
     /* 433723 */   // GIR_Coverage, 1063,
     /* 433723 */   GIR_Done,
     /* 433724 */ // Label 8683: @433724
     /* 433724 */ GIM_Reject,
     /* 433725 */ // Label 8677: @433725
     /* 433725 */ GIM_Reject,
     /* 433726 */ // Label 144: @433726
     /* 433726 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8686*/ GIMT_Encode4(434592),
     /* 433737 */ /*GILLT_v2s64*//*Label 8684*/ GIMT_Encode4(433749), GIMT_Encode4(0),
     /* 433745 */ /*GILLT_v4s32*//*Label 8685*/ GIMT_Encode4(434043),
     /* 433749 */ // Label 8684: @433749
     /* 433749 */ GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(433831), // Rule ID 5901 //
     /* 433754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 433769 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 433772 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 433777 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 433781 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433788 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 433788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 433795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433800 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 433804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433830 */   // GIR_Coverage, 5901,
     /* 433830 */   GIR_EraseRootFromParent_Done,
     /* 433831 */ // Label 8687: @433831
     /* 433831 */ GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(433905), // Rule ID 5900 //
     /* 433836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 433851 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433855 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433862 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 433862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 433869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433874 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 433878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433904 */   // GIR_Coverage, 5900,
     /* 433904 */   GIR_EraseRootFromParent_Done,
     /* 433905 */ // Label 8688: @433905
     /* 433905 */ GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(433964), // Rule ID 5910 //
     /* 433910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433921 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 433921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 433924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 433928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433933 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 433953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433963 */   // GIR_Coverage, 5910,
     /* 433963 */   GIR_EraseRootFromParent_Done,
     /* 433964 */ // Label 8689: @433964
     /* 433964 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(434042), // Rule ID 6038 //
     /* 433969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433980 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 433980 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 433983 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 433987 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433992 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 433998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 434001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 434005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 434015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 434023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 434026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434041 */   // GIR_Coverage, 6038,
     /* 434041 */   GIR_EraseRootFromParent_Done,
     /* 434042 */ // Label 8690: @434042
     /* 434042 */ GIM_Reject,
     /* 434043 */ // Label 8685: @434043
     /* 434043 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(434125), // Rule ID 5903 //
     /* 434048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434055 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434059 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 434063 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 434066 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 434071 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 434075 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434082 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 434082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 434089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434094 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 434098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434119 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434124 */   // GIR_Coverage, 5903,
     /* 434124 */   GIR_EraseRootFromParent_Done,
     /* 434125 */ // Label 8691: @434125
     /* 434125 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(434207), // Rule ID 5905 //
     /* 434130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 434145 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 434148 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 434153 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434164 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 434164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 434171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 434180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434206 */   // GIR_Coverage, 5905,
     /* 434206 */   GIR_EraseRootFromParent_Done,
     /* 434207 */ // Label 8692: @434207
     /* 434207 */ GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(434281), // Rule ID 5902 //
     /* 434212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 434227 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434231 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434238 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 434238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 434245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434250 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 434254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434275 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434280 */   // GIR_Coverage, 5902,
     /* 434280 */   GIR_EraseRootFromParent_Done,
     /* 434281 */ // Label 8693: @434281
     /* 434281 */ GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(434355), // Rule ID 5904 //
     /* 434286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 434301 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434305 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434312 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 434312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 434319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434324 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 434328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434344 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434354 */   // GIR_Coverage, 5904,
     /* 434354 */   GIR_EraseRootFromParent_Done,
     /* 434355 */ // Label 8694: @434355
     /* 434355 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(434414), // Rule ID 5906 //
     /* 434360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434371 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 434371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 434378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434383 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434413 */   // GIR_Coverage, 5906,
     /* 434413 */   GIR_EraseRootFromParent_Done,
     /* 434414 */ // Label 8695: @434414
     /* 434414 */ GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(434473), // Rule ID 5907 //
     /* 434419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434430 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 434430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 434433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 434437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434442 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 434462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434467 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434472 */   // GIR_Coverage, 5907,
     /* 434472 */   GIR_EraseRootFromParent_Done,
     /* 434473 */ // Label 8696: @434473
     /* 434473 */ GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(434532), // Rule ID 5908 //
     /* 434478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434489 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 434489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 434496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434531 */   // GIR_Coverage, 5908,
     /* 434531 */   GIR_EraseRootFromParent_Done,
     /* 434532 */ // Label 8697: @434532
     /* 434532 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(434591), // Rule ID 5909 //
     /* 434537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434548 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 434548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 434551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 434555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 434580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434590 */   // GIR_Coverage, 5909,
     /* 434590 */   GIR_EraseRootFromParent_Done,
     /* 434591 */ // Label 8698: @434591
     /* 434591 */ GIM_Reject,
     /* 434592 */ // Label 8686: @434592
     /* 434592 */ GIM_Reject,
     /* 434593 */ // Label 145: @434593
     /* 434593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8703*/ GIMT_Encode4(434962),
     /* 434604 */ /*GILLT_v2s32*//*Label 8699*/ GIMT_Encode4(434664), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 434616 */ /*GILLT_v4s32*//*Label 8700*/ GIMT_Encode4(434784), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 434648 */ /*GILLT_nxv2s64*//*Label 8701*/ GIMT_Encode4(434904), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 434660 */ /*GILLT_nxv4s32*//*Label 8702*/ GIMT_Encode4(434933),
     /* 434664 */ // Label 8699: @434664
     /* 434664 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(434783),
     /* 434669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 434678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434690 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(434763), // Rule ID 28 //
     /* 434695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 434702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 434706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434739 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434743 */     // MIs[3] Operand 1
     /* 434743 */     // No operand predicates
     /* 434743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434745 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 434748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 434752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434761 */     GIR_RootConstrainSelectedInstOperands,
     /* 434762 */     // GIR_Coverage, 28,
     /* 434762 */     GIR_EraseRootFromParent_Done,
     /* 434763 */   // Label 8705: @434763
     /* 434763 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(434782), // Rule ID 24 //
     /* 434768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434775 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 434780 */     GIR_RootConstrainSelectedInstOperands,
     /* 434781 */     // GIR_Coverage, 24,
     /* 434781 */     GIR_Done,
     /* 434782 */   // Label 8706: @434782
     /* 434782 */   GIM_Reject,
     /* 434783 */ // Label 8704: @434783
     /* 434783 */ GIM_Reject,
     /* 434784 */ // Label 8700: @434784
     /* 434784 */ GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(434903),
     /* 434789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 434795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 434798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434810 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(434883), // Rule ID 29 //
     /* 434815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 434822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 434826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434863 */     // MIs[3] Operand 1
     /* 434863 */     // No operand predicates
     /* 434863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434865 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 434868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 434872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434881 */     GIR_RootConstrainSelectedInstOperands,
     /* 434882 */     // GIR_Coverage, 29,
     /* 434882 */     GIR_EraseRootFromParent_Done,
     /* 434883 */   // Label 8708: @434883
     /* 434883 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(434902), // Rule ID 25 //
     /* 434888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434895 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 434895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 434900 */     GIR_RootConstrainSelectedInstOperands,
     /* 434901 */     // GIR_Coverage, 25,
     /* 434901 */     GIR_Done,
     /* 434902 */   // Label 8709: @434902
     /* 434902 */   GIM_Reject,
     /* 434903 */ // Label 8707: @434903
     /* 434903 */ GIM_Reject,
     /* 434904 */ // Label 8701: @434904
     /* 434904 */ GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(434932), // Rule ID 7716 //
     /* 434909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 434915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 434918 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 434921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434925 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 434925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 434930 */   GIR_RootConstrainSelectedInstOperands,
     /* 434931 */   // GIR_Coverage, 7716,
     /* 434931 */   GIR_Done,
     /* 434932 */ // Label 8710: @434932
     /* 434932 */ GIM_Reject,
     /* 434933 */ // Label 8702: @434933
     /* 434933 */ GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(434961), // Rule ID 7715 //
     /* 434938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 434944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 434947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 434950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434954 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 434954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 434959 */   GIR_RootConstrainSelectedInstOperands,
     /* 434960 */   // GIR_Coverage, 7715,
     /* 434960 */   GIR_Done,
     /* 434961 */ // Label 8711: @434961
     /* 434961 */ GIM_Reject,
     /* 434962 */ // Label 8703: @434962
     /* 434962 */ GIM_Reject,
     /* 434963 */ // Label 146: @434963
     /* 434963 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8715*/ GIMT_Encode4(435079),
     /* 434974 */ /*GILLT_s16*//*Label 8712*/ GIMT_Encode4(434986),
     /* 434978 */ /*GILLT_s32*//*Label 8713*/ GIMT_Encode4(435017),
     /* 434982 */ /*GILLT_s64*//*Label 8714*/ GIMT_Encode4(435048),
     /* 434986 */ // Label 8712: @434986
     /* 434986 */ GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(435016), // Rule ID 1669 //
     /* 434991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 434994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 434997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435005 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 435005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 435010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 435014 */   GIR_RootConstrainSelectedInstOperands,
     /* 435015 */   // GIR_Coverage, 1669,
     /* 435015 */   GIR_Done,
     /* 435016 */ // Label 8716: @435016
     /* 435016 */ GIM_Reject,
     /* 435017 */ // Label 8713: @435017
     /* 435017 */ GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(435047), // Rule ID 1668 //
     /* 435022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 435025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 435028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435036 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 435036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 435041 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 435045 */   GIR_RootConstrainSelectedInstOperands,
     /* 435046 */   // GIR_Coverage, 1668,
     /* 435046 */   GIR_Done,
     /* 435047 */ // Label 8717: @435047
     /* 435047 */ GIM_Reject,
     /* 435048 */ // Label 8714: @435048
     /* 435048 */ GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(435078), // Rule ID 1667 //
     /* 435053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 435056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 435059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435067 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 435067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 435072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 435076 */   GIR_RootConstrainSelectedInstOperands,
     /* 435077 */   // GIR_Coverage, 1667,
     /* 435077 */   GIR_Done,
     /* 435078 */ // Label 8718: @435078
     /* 435078 */ GIM_Reject,
     /* 435079 */ // Label 8715: @435079
     /* 435079 */ GIM_Reject,
     /* 435080 */ // Label 147: @435080
     /* 435080 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8722*/ GIMT_Encode4(436312),
     /* 435091 */ /*GILLT_v2s64*//*Label 8719*/ GIMT_Encode4(435111), GIMT_Encode4(0),
     /* 435099 */ /*GILLT_v4s32*//*Label 8720*/ GIMT_Encode4(435672), GIMT_Encode4(0),
     /* 435107 */ /*GILLT_v8s16*//*Label 8721*/ GIMT_Encode4(436233),
     /* 435111 */ // Label 8719: @435111
     /* 435111 */ GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(435671),
     /* 435116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 435122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435126 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(435218), // Rule ID 2106 //
     /* 435131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435175 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435179 */     // MIs[3] Operand 1
     /* 435179 */     // No operand predicates
     /* 435179 */     // MIs[1] Operand 2
     /* 435179 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 435190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435199 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 435202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435216 */     GIR_RootConstrainSelectedInstOperands,
     /* 435217 */     // GIR_Coverage, 2106,
     /* 435217 */     GIR_EraseRootFromParent_Done,
     /* 435218 */   // Label 8724: @435218
     /* 435218 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(435310), // Rule ID 13630 //
     /* 435223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435271 */     // MIs[3] Operand 1
     /* 435271 */     // No operand predicates
     /* 435271 */     // MIs[1] Operand 2
     /* 435271 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 435282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435291 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 435294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435308 */     GIR_RootConstrainSelectedInstOperands,
     /* 435309 */     // GIR_Coverage, 13630,
     /* 435309 */     GIR_EraseRootFromParent_Done,
     /* 435310 */   // Label 8725: @435310
     /* 435310 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(435396), // Rule ID 13628 //
     /* 435315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435359 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435363 */     // MIs[3] Operand 1
     /* 435363 */     // No operand predicates
     /* 435363 */     // MIs[1] Operand 2
     /* 435363 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435380 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435394 */     GIR_RootConstrainSelectedInstOperands,
     /* 435395 */     // GIR_Coverage, 13628,
     /* 435395 */     GIR_EraseRootFromParent_Done,
     /* 435396 */   // Label 8726: @435396
     /* 435396 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(435482), // Rule ID 2104 //
     /* 435401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435449 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435453 */     // MIs[3] Operand 1
     /* 435453 */     // No operand predicates
     /* 435453 */     // MIs[1] Operand 2
     /* 435453 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435466 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435480 */     GIR_RootConstrainSelectedInstOperands,
     /* 435481 */     // GIR_Coverage, 2104,
     /* 435481 */     GIR_EraseRootFromParent_Done,
     /* 435482 */   // Label 8727: @435482
     /* 435482 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(435521), // Rule ID 1831 //
     /* 435487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435504 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 435504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 435507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 435519 */     GIR_RootConstrainSelectedInstOperands,
     /* 435520 */     // GIR_Coverage, 1831,
     /* 435520 */     GIR_EraseRootFromParent_Done,
     /* 435521 */   // Label 8728: @435521
     /* 435521 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(435584), // Rule ID 13629 //
     /* 435526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 435545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 435554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435558 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435562 */     // MIs[2] Operand 1
     /* 435562 */     // No operand predicates
     /* 435562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 435568 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 435579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 435582 */     GIR_RootConstrainSelectedInstOperands,
     /* 435583 */     // GIR_Coverage, 13629,
     /* 435583 */     GIR_EraseRootFromParent_Done,
     /* 435584 */   // Label 8729: @435584
     /* 435584 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(435647), // Rule ID 2105 //
     /* 435589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 435612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 435621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435629 */     // MIs[2] Operand 1
     /* 435629 */     // No operand predicates
     /* 435629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 435631 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 435642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 435645 */     GIR_RootConstrainSelectedInstOperands,
     /* 435646 */     // GIR_Coverage, 2105,
     /* 435646 */     GIR_EraseRootFromParent_Done,
     /* 435647 */   // Label 8730: @435647
     /* 435647 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(435670), // Rule ID 1830 //
     /* 435652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435663 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 435663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 435668 */     GIR_RootConstrainSelectedInstOperands,
     /* 435669 */     // GIR_Coverage, 1830,
     /* 435669 */     GIR_Done,
     /* 435670 */   // Label 8731: @435670
     /* 435670 */   GIM_Reject,
     /* 435671 */ // Label 8723: @435671
     /* 435671 */ GIM_Reject,
     /* 435672 */ // Label 8720: @435672
     /* 435672 */ GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(436232),
     /* 435677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 435683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435687 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(435779), // Rule ID 2103 //
     /* 435692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435736 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435740 */     // MIs[3] Operand 1
     /* 435740 */     // No operand predicates
     /* 435740 */     // MIs[1] Operand 2
     /* 435740 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 435751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435760 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 435763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435777 */     GIR_RootConstrainSelectedInstOperands,
     /* 435778 */     // GIR_Coverage, 2103,
     /* 435778 */     GIR_EraseRootFromParent_Done,
     /* 435779 */   // Label 8733: @435779
     /* 435779 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(435871), // Rule ID 13627 //
     /* 435784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435832 */     // MIs[3] Operand 1
     /* 435832 */     // No operand predicates
     /* 435832 */     // MIs[1] Operand 2
     /* 435832 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 435843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435852 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 435855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435869 */     GIR_RootConstrainSelectedInstOperands,
     /* 435870 */     // GIR_Coverage, 13627,
     /* 435870 */     GIR_EraseRootFromParent_Done,
     /* 435871 */   // Label 8734: @435871
     /* 435871 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(435957), // Rule ID 13625 //
     /* 435876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435920 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435924 */     // MIs[3] Operand 1
     /* 435924 */     // No operand predicates
     /* 435924 */     // MIs[1] Operand 2
     /* 435924 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435941 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 435944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435955 */     GIR_RootConstrainSelectedInstOperands,
     /* 435956 */     // GIR_Coverage, 13625,
     /* 435956 */     GIR_EraseRootFromParent_Done,
     /* 435957 */   // Label 8735: @435957
     /* 435957 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(436043), // Rule ID 2101 //
     /* 435962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436010 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436014 */     // MIs[3] Operand 1
     /* 436014 */     // No operand predicates
     /* 436014 */     // MIs[1] Operand 2
     /* 436014 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 436025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436027 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 436030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436041 */     GIR_RootConstrainSelectedInstOperands,
     /* 436042 */     // GIR_Coverage, 2101,
     /* 436042 */     GIR_EraseRootFromParent_Done,
     /* 436043 */   // Label 8736: @436043
     /* 436043 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(436082), // Rule ID 1829 //
     /* 436048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 436058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 436065 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 436065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 436068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 436080 */     GIR_RootConstrainSelectedInstOperands,
     /* 436081 */     // GIR_Coverage, 1829,
     /* 436081 */     GIR_EraseRootFromParent_Done,
     /* 436082 */   // Label 8737: @436082
     /* 436082 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(436145), // Rule ID 13626 //
     /* 436087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 436098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 436106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 436115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436123 */     // MIs[2] Operand 1
     /* 436123 */     // No operand predicates
     /* 436123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436129 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 436132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 436140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 436143 */     GIR_RootConstrainSelectedInstOperands,
     /* 436144 */     // GIR_Coverage, 13626,
     /* 436144 */     GIR_EraseRootFromParent_Done,
     /* 436145 */   // Label 8738: @436145
     /* 436145 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(436208), // Rule ID 2102 //
     /* 436150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 436165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 436173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 436182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436186 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436190 */     // MIs[2] Operand 1
     /* 436190 */     // No operand predicates
     /* 436190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436192 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 436195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 436203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 436206 */     GIR_RootConstrainSelectedInstOperands,
     /* 436207 */     // GIR_Coverage, 2102,
     /* 436207 */     GIR_EraseRootFromParent_Done,
     /* 436208 */   // Label 8739: @436208
     /* 436208 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(436231), // Rule ID 1828 //
     /* 436213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436224 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 436224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 436229 */     GIR_RootConstrainSelectedInstOperands,
     /* 436230 */     // GIR_Coverage, 1828,
     /* 436230 */     GIR_Done,
     /* 436231 */   // Label 8740: @436231
     /* 436231 */   GIM_Reject,
     /* 436232 */ // Label 8732: @436232
     /* 436232 */ GIM_Reject,
     /* 436233 */ // Label 8721: @436233
     /* 436233 */ GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(436311),
     /* 436238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 436244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436248 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(436287), // Rule ID 1827 //
     /* 436253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 436263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 436270 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 436270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 436273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 436285 */     GIR_RootConstrainSelectedInstOperands,
     /* 436286 */     // GIR_Coverage, 1827,
     /* 436286 */     GIR_EraseRootFromParent_Done,
     /* 436287 */   // Label 8742: @436287
     /* 436287 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(436310), // Rule ID 1826 //
     /* 436292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436303 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 436303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 436308 */     GIR_RootConstrainSelectedInstOperands,
     /* 436309 */     // GIR_Coverage, 1826,
     /* 436309 */     GIR_Done,
     /* 436310 */   // Label 8743: @436310
     /* 436310 */   GIM_Reject,
     /* 436311 */ // Label 8741: @436311
     /* 436311 */ GIM_Reject,
     /* 436312 */ // Label 8722: @436312
     /* 436312 */ GIM_Reject,
     /* 436313 */ // Label 148: @436313
     /* 436313 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8762*/ GIMT_Encode4(437092),
     /* 436324 */ /*GILLT_v2s32*//*Label 8744*/ GIMT_Encode4(436400),
     /* 436328 */ /*GILLT_v2s64*//*Label 8745*/ GIMT_Encode4(436455),
     /* 436332 */ /*GILLT_v4s16*//*Label 8746*/ GIMT_Encode4(436510),
     /* 436336 */ /*GILLT_v4s32*//*Label 8747*/ GIMT_Encode4(436565),
     /* 436340 */ /*GILLT_v8s8*//*Label 8748*/ GIMT_Encode4(436620),
     /* 436344 */ /*GILLT_v8s16*//*Label 8749*/ GIMT_Encode4(436654),
     /* 436348 */ /*GILLT_v16s8*//*Label 8750*/ GIMT_Encode4(436709), GIMT_Encode4(0),
     /* 436356 */ /*GILLT_nxv2s1*//*Label 8751*/ GIMT_Encode4(436743),
     /* 436360 */ /*GILLT_nxv2s16*//*Label 8752*/ GIMT_Encode4(436769),
     /* 436364 */ /*GILLT_nxv2s32*//*Label 8753*/ GIMT_Encode4(436795),
     /* 436368 */ /*GILLT_nxv2s64*//*Label 8754*/ GIMT_Encode4(436821),
     /* 436372 */ /*GILLT_nxv4s1*//*Label 8755*/ GIMT_Encode4(436868),
     /* 436376 */ /*GILLT_nxv4s16*//*Label 8756*/ GIMT_Encode4(436894),
     /* 436380 */ /*GILLT_nxv4s32*//*Label 8757*/ GIMT_Encode4(436920),
     /* 436384 */ /*GILLT_nxv8s1*//*Label 8758*/ GIMT_Encode4(436967),
     /* 436388 */ /*GILLT_nxv8s16*//*Label 8759*/ GIMT_Encode4(436993),
     /* 436392 */ /*GILLT_nxv16s1*//*Label 8760*/ GIMT_Encode4(437040),
     /* 436396 */ /*GILLT_nxv16s8*//*Label 8761*/ GIMT_Encode4(437066),
     /* 436400 */ // Label 8744: @436400
     /* 436400 */ GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(436454),
     /* 436405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 436411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436423 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(436438), // Rule ID 1888 //
     /* 436428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436431 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 436431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 436436 */     GIR_RootConstrainSelectedInstOperands,
     /* 436437 */     // GIR_Coverage, 1888,
     /* 436437 */     GIR_Done,
     /* 436438 */   // Label 8764: @436438
     /* 436438 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(436453), // Rule ID 5493 //
     /* 436443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436446 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 436446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 436451 */     GIR_RootConstrainSelectedInstOperands,
     /* 436452 */     // GIR_Coverage, 5493,
     /* 436452 */     GIR_Done,
     /* 436453 */   // Label 8765: @436453
     /* 436453 */   GIM_Reject,
     /* 436454 */ // Label 8763: @436454
     /* 436454 */ GIM_Reject,
     /* 436455 */ // Label 8745: @436455
     /* 436455 */ GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(436509),
     /* 436460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 436466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436478 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(436493), // Rule ID 1890 //
     /* 436483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436486 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 436486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 436491 */     GIR_RootConstrainSelectedInstOperands,
     /* 436492 */     // GIR_Coverage, 1890,
     /* 436492 */     GIR_Done,
     /* 436493 */   // Label 8767: @436493
     /* 436493 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(436508), // Rule ID 5495 //
     /* 436498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436501 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 436501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 436506 */     GIR_RootConstrainSelectedInstOperands,
     /* 436507 */     // GIR_Coverage, 5495,
     /* 436507 */     GIR_Done,
     /* 436508 */   // Label 8768: @436508
     /* 436508 */   GIM_Reject,
     /* 436509 */ // Label 8766: @436509
     /* 436509 */ GIM_Reject,
     /* 436510 */ // Label 8746: @436510
     /* 436510 */ GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(436564),
     /* 436515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 436521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436533 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(436548), // Rule ID 1886 //
     /* 436538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436541 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 436541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 436546 */     GIR_RootConstrainSelectedInstOperands,
     /* 436547 */     // GIR_Coverage, 1886,
     /* 436547 */     GIR_Done,
     /* 436548 */   // Label 8770: @436548
     /* 436548 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(436563), // Rule ID 5491 //
     /* 436553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436556 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 436556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 436561 */     GIR_RootConstrainSelectedInstOperands,
     /* 436562 */     // GIR_Coverage, 5491,
     /* 436562 */     GIR_Done,
     /* 436563 */   // Label 8771: @436563
     /* 436563 */   GIM_Reject,
     /* 436564 */ // Label 8769: @436564
     /* 436564 */ GIM_Reject,
     /* 436565 */ // Label 8747: @436565
     /* 436565 */ GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(436619),
     /* 436570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 436576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436588 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(436603), // Rule ID 1889 //
     /* 436593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436596 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 436596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 436601 */     GIR_RootConstrainSelectedInstOperands,
     /* 436602 */     // GIR_Coverage, 1889,
     /* 436602 */     GIR_Done,
     /* 436603 */   // Label 8773: @436603
     /* 436603 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(436618), // Rule ID 5494 //
     /* 436608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436611 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 436611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 436616 */     GIR_RootConstrainSelectedInstOperands,
     /* 436617 */     // GIR_Coverage, 5494,
     /* 436617 */     GIR_Done,
     /* 436618 */   // Label 8774: @436618
     /* 436618 */   GIM_Reject,
     /* 436619 */ // Label 8772: @436619
     /* 436619 */ GIM_Reject,
     /* 436620 */ // Label 8748: @436620
     /* 436620 */ GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(436653), // Rule ID 1884 //
     /* 436625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 436634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436646 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 436646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 436651 */   GIR_RootConstrainSelectedInstOperands,
     /* 436652 */   // GIR_Coverage, 1884,
     /* 436652 */   GIR_Done,
     /* 436653 */ // Label 8775: @436653
     /* 436653 */ GIM_Reject,
     /* 436654 */ // Label 8749: @436654
     /* 436654 */ GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(436708),
     /* 436659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 436665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436677 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(436692), // Rule ID 1887 //
     /* 436682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436685 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 436685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 436690 */     GIR_RootConstrainSelectedInstOperands,
     /* 436691 */     // GIR_Coverage, 1887,
     /* 436691 */     GIR_Done,
     /* 436692 */   // Label 8777: @436692
     /* 436692 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(436707), // Rule ID 5492 //
     /* 436697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436700 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 436700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 436705 */     GIR_RootConstrainSelectedInstOperands,
     /* 436706 */     // GIR_Coverage, 5492,
     /* 436706 */     GIR_Done,
     /* 436707 */   // Label 8778: @436707
     /* 436707 */   GIM_Reject,
     /* 436708 */ // Label 8776: @436708
     /* 436708 */ GIM_Reject,
     /* 436709 */ // Label 8750: @436709
     /* 436709 */ GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(436742), // Rule ID 1885 //
     /* 436714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 436720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 436723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436735 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 436735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 436740 */   GIR_RootConstrainSelectedInstOperands,
     /* 436741 */   // GIR_Coverage, 1885,
     /* 436741 */   GIR_Done,
     /* 436742 */ // Label 8779: @436742
     /* 436742 */ GIM_Reject,
     /* 436743 */ // Label 8751: @436743
     /* 436743 */ GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(436768), // Rule ID 9024 //
     /* 436748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 436754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 436757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436761 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 436761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 436766 */   GIR_RootConstrainSelectedInstOperands,
     /* 436767 */   // GIR_Coverage, 9024,
     /* 436767 */   GIR_Done,
     /* 436768 */ // Label 8780: @436768
     /* 436768 */ GIM_Reject,
     /* 436769 */ // Label 8752: @436769
     /* 436769 */ GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(436794), // Rule ID 8986 //
     /* 436774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 436780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 436783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436787 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 436787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436792 */   GIR_RootConstrainSelectedInstOperands,
     /* 436793 */   // GIR_Coverage, 8986,
     /* 436793 */   GIR_Done,
     /* 436794 */ // Label 8781: @436794
     /* 436794 */ GIM_Reject,
     /* 436795 */ // Label 8753: @436795
     /* 436795 */ GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(436820), // Rule ID 8987 //
     /* 436800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 436806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 436809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436813 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 436813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436818 */   GIR_RootConstrainSelectedInstOperands,
     /* 436819 */   // GIR_Coverage, 8987,
     /* 436819 */   GIR_Done,
     /* 436820 */ // Label 8782: @436820
     /* 436820 */ GIM_Reject,
     /* 436821 */ // Label 8754: @436821
     /* 436821 */ GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(436867),
     /* 436826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 436829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 436832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436836 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(436851), // Rule ID 8982 //
     /* 436841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436844 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 436844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436849 */     GIR_RootConstrainSelectedInstOperands,
     /* 436850 */     // GIR_Coverage, 8982,
     /* 436850 */     GIR_Done,
     /* 436851 */   // Label 8784: @436851
     /* 436851 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(436866), // Rule ID 8988 //
     /* 436856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436859 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 436859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436864 */     GIR_RootConstrainSelectedInstOperands,
     /* 436865 */     // GIR_Coverage, 8988,
     /* 436865 */     GIR_Done,
     /* 436866 */   // Label 8785: @436866
     /* 436866 */   GIM_Reject,
     /* 436867 */ // Label 8783: @436867
     /* 436867 */ GIM_Reject,
     /* 436868 */ // Label 8755: @436868
     /* 436868 */ GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(436893), // Rule ID 9023 //
     /* 436873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 436879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 436882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436886 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 436886 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 436891 */   GIR_RootConstrainSelectedInstOperands,
     /* 436892 */   // GIR_Coverage, 9023,
     /* 436892 */   GIR_Done,
     /* 436893 */ // Label 8786: @436893
     /* 436893 */ GIM_Reject,
     /* 436894 */ // Label 8756: @436894
     /* 436894 */ GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(436919), // Rule ID 8984 //
     /* 436899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 436905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 436908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436912 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 436912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 436917 */   GIR_RootConstrainSelectedInstOperands,
     /* 436918 */   // GIR_Coverage, 8984,
     /* 436918 */   GIR_Done,
     /* 436919 */ // Label 8787: @436919
     /* 436919 */ GIM_Reject,
     /* 436920 */ // Label 8757: @436920
     /* 436920 */ GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(436966),
     /* 436925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 436928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 436931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436935 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(436950), // Rule ID 8981 //
     /* 436940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436943 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 436943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 436948 */     GIR_RootConstrainSelectedInstOperands,
     /* 436949 */     // GIR_Coverage, 8981,
     /* 436949 */     GIR_Done,
     /* 436950 */   // Label 8789: @436950
     /* 436950 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(436965), // Rule ID 8985 //
     /* 436955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436958 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 436958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 436963 */     GIR_RootConstrainSelectedInstOperands,
     /* 436964 */     // GIR_Coverage, 8985,
     /* 436964 */     GIR_Done,
     /* 436965 */   // Label 8790: @436965
     /* 436965 */   GIM_Reject,
     /* 436966 */ // Label 8788: @436966
     /* 436966 */ GIM_Reject,
     /* 436967 */ // Label 8758: @436967
     /* 436967 */ GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(436992), // Rule ID 9022 //
     /* 436972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 436978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 436981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436985 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 436985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 436990 */   GIR_RootConstrainSelectedInstOperands,
     /* 436991 */   // GIR_Coverage, 9022,
     /* 436991 */   GIR_Done,
     /* 436992 */ // Label 8791: @436992
     /* 436992 */ GIM_Reject,
     /* 436993 */ // Label 8759: @436993
     /* 436993 */ GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(437039),
     /* 436998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 437001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 437004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437008 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(437023), // Rule ID 8980 //
     /* 437013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437016 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 437016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 437021 */     GIR_RootConstrainSelectedInstOperands,
     /* 437022 */     // GIR_Coverage, 8980,
     /* 437022 */     GIR_Done,
     /* 437023 */   // Label 8793: @437023
     /* 437023 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(437038), // Rule ID 8983 //
     /* 437028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437031 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 437031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 437036 */     GIR_RootConstrainSelectedInstOperands,
     /* 437037 */     // GIR_Coverage, 8983,
     /* 437037 */     GIR_Done,
     /* 437038 */   // Label 8794: @437038
     /* 437038 */   GIM_Reject,
     /* 437039 */ // Label 8792: @437039
     /* 437039 */ GIM_Reject,
     /* 437040 */ // Label 8760: @437040
     /* 437040 */ GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(437065), // Rule ID 2406 //
     /* 437045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 437051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 437054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437058 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 437058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 437063 */   GIR_RootConstrainSelectedInstOperands,
     /* 437064 */   // GIR_Coverage, 2406,
     /* 437064 */   GIR_Done,
     /* 437065 */ // Label 8795: @437065
     /* 437065 */ GIM_Reject,
     /* 437066 */ // Label 8761: @437066
     /* 437066 */ GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(437091), // Rule ID 8979 //
     /* 437071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 437077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 437080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437084 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 437084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 437089 */   GIR_RootConstrainSelectedInstOperands,
     /* 437090 */   // GIR_Coverage, 8979,
     /* 437090 */   GIR_Done,
     /* 437091 */ // Label 8796: @437091
     /* 437091 */ GIM_Reject,
     /* 437092 */ // Label 8762: @437092
     /* 437092 */ GIM_Reject,
     /* 437093 */ // Label 149: @437093
     /* 437093 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8815*/ GIMT_Encode4(437872),
     /* 437104 */ /*GILLT_v2s32*//*Label 8797*/ GIMT_Encode4(437180),
     /* 437108 */ /*GILLT_v2s64*//*Label 8798*/ GIMT_Encode4(437235),
     /* 437112 */ /*GILLT_v4s16*//*Label 8799*/ GIMT_Encode4(437290),
     /* 437116 */ /*GILLT_v4s32*//*Label 8800*/ GIMT_Encode4(437345),
     /* 437120 */ /*GILLT_v8s8*//*Label 8801*/ GIMT_Encode4(437400),
     /* 437124 */ /*GILLT_v8s16*//*Label 8802*/ GIMT_Encode4(437434),
     /* 437128 */ /*GILLT_v16s8*//*Label 8803*/ GIMT_Encode4(437489), GIMT_Encode4(0),
     /* 437136 */ /*GILLT_nxv2s1*//*Label 8804*/ GIMT_Encode4(437523),
     /* 437140 */ /*GILLT_nxv2s16*//*Label 8805*/ GIMT_Encode4(437549),
     /* 437144 */ /*GILLT_nxv2s32*//*Label 8806*/ GIMT_Encode4(437575),
     /* 437148 */ /*GILLT_nxv2s64*//*Label 8807*/ GIMT_Encode4(437601),
     /* 437152 */ /*GILLT_nxv4s1*//*Label 8808*/ GIMT_Encode4(437648),
     /* 437156 */ /*GILLT_nxv4s16*//*Label 8809*/ GIMT_Encode4(437674),
     /* 437160 */ /*GILLT_nxv4s32*//*Label 8810*/ GIMT_Encode4(437700),
     /* 437164 */ /*GILLT_nxv8s1*//*Label 8811*/ GIMT_Encode4(437747),
     /* 437168 */ /*GILLT_nxv8s16*//*Label 8812*/ GIMT_Encode4(437773),
     /* 437172 */ /*GILLT_nxv16s1*//*Label 8813*/ GIMT_Encode4(437820),
     /* 437176 */ /*GILLT_nxv16s8*//*Label 8814*/ GIMT_Encode4(437846),
     /* 437180 */ // Label 8797: @437180
     /* 437180 */ GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(437234),
     /* 437185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 437191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437203 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(437218), // Rule ID 1895 //
     /* 437208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437211 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 437216 */     GIR_RootConstrainSelectedInstOperands,
     /* 437217 */     // GIR_Coverage, 1895,
     /* 437217 */     GIR_Done,
     /* 437218 */   // Label 8817: @437218
     /* 437218 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(437233), // Rule ID 5498 //
     /* 437223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437226 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 437226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 437231 */     GIR_RootConstrainSelectedInstOperands,
     /* 437232 */     // GIR_Coverage, 5498,
     /* 437232 */     GIR_Done,
     /* 437233 */   // Label 8818: @437233
     /* 437233 */   GIM_Reject,
     /* 437234 */ // Label 8816: @437234
     /* 437234 */ GIM_Reject,
     /* 437235 */ // Label 8798: @437235
     /* 437235 */ GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(437289),
     /* 437240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 437246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437258 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(437273), // Rule ID 1897 //
     /* 437263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437266 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 437266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 437271 */     GIR_RootConstrainSelectedInstOperands,
     /* 437272 */     // GIR_Coverage, 1897,
     /* 437272 */     GIR_Done,
     /* 437273 */   // Label 8820: @437273
     /* 437273 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(437288), // Rule ID 5500 //
     /* 437278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437281 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 437281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 437286 */     GIR_RootConstrainSelectedInstOperands,
     /* 437287 */     // GIR_Coverage, 5500,
     /* 437287 */     GIR_Done,
     /* 437288 */   // Label 8821: @437288
     /* 437288 */   GIM_Reject,
     /* 437289 */ // Label 8819: @437289
     /* 437289 */ GIM_Reject,
     /* 437290 */ // Label 8799: @437290
     /* 437290 */ GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(437344),
     /* 437295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 437301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437313 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(437328), // Rule ID 1893 //
     /* 437318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437321 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 437326 */     GIR_RootConstrainSelectedInstOperands,
     /* 437327 */     // GIR_Coverage, 1893,
     /* 437327 */     GIR_Done,
     /* 437328 */   // Label 8823: @437328
     /* 437328 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(437343), // Rule ID 5496 //
     /* 437333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437336 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 437336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 437341 */     GIR_RootConstrainSelectedInstOperands,
     /* 437342 */     // GIR_Coverage, 5496,
     /* 437342 */     GIR_Done,
     /* 437343 */   // Label 8824: @437343
     /* 437343 */   GIM_Reject,
     /* 437344 */ // Label 8822: @437344
     /* 437344 */ GIM_Reject,
     /* 437345 */ // Label 8800: @437345
     /* 437345 */ GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(437399),
     /* 437350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 437356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437368 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(437383), // Rule ID 1896 //
     /* 437373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437376 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 437376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 437381 */     GIR_RootConstrainSelectedInstOperands,
     /* 437382 */     // GIR_Coverage, 1896,
     /* 437382 */     GIR_Done,
     /* 437383 */   // Label 8826: @437383
     /* 437383 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(437398), // Rule ID 5499 //
     /* 437388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437391 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 437391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 437396 */     GIR_RootConstrainSelectedInstOperands,
     /* 437397 */     // GIR_Coverage, 5499,
     /* 437397 */     GIR_Done,
     /* 437398 */   // Label 8827: @437398
     /* 437398 */   GIM_Reject,
     /* 437399 */ // Label 8825: @437399
     /* 437399 */ GIM_Reject,
     /* 437400 */ // Label 8801: @437400
     /* 437400 */ GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(437433), // Rule ID 1891 //
     /* 437405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 437414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437426 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 437426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 437431 */   GIR_RootConstrainSelectedInstOperands,
     /* 437432 */   // GIR_Coverage, 1891,
     /* 437432 */   GIR_Done,
     /* 437433 */ // Label 8828: @437433
     /* 437433 */ GIM_Reject,
     /* 437434 */ // Label 8802: @437434
     /* 437434 */ GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(437488),
     /* 437439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 437445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437457 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(437472), // Rule ID 1894 //
     /* 437462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437465 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 437465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 437470 */     GIR_RootConstrainSelectedInstOperands,
     /* 437471 */     // GIR_Coverage, 1894,
     /* 437471 */     GIR_Done,
     /* 437472 */   // Label 8830: @437472
     /* 437472 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(437487), // Rule ID 5497 //
     /* 437477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437480 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 437480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 437485 */     GIR_RootConstrainSelectedInstOperands,
     /* 437486 */     // GIR_Coverage, 5497,
     /* 437486 */     GIR_Done,
     /* 437487 */   // Label 8831: @437487
     /* 437487 */   GIM_Reject,
     /* 437488 */ // Label 8829: @437488
     /* 437488 */ GIM_Reject,
     /* 437489 */ // Label 8803: @437489
     /* 437489 */ GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(437522), // Rule ID 1892 //
     /* 437494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 437503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437515 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 437515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 437520 */   GIR_RootConstrainSelectedInstOperands,
     /* 437521 */   // GIR_Coverage, 1892,
     /* 437521 */   GIR_Done,
     /* 437522 */ // Label 8832: @437522
     /* 437522 */ GIM_Reject,
     /* 437523 */ // Label 8804: @437523
     /* 437523 */ GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(437548), // Rule ID 9027 //
     /* 437528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 437534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 437537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437541 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 437541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 437546 */   GIR_RootConstrainSelectedInstOperands,
     /* 437547 */   // GIR_Coverage, 9027,
     /* 437547 */   GIR_Done,
     /* 437548 */ // Label 8833: @437548
     /* 437548 */ GIM_Reject,
     /* 437549 */ // Label 8805: @437549
     /* 437549 */ GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(437574), // Rule ID 8996 //
     /* 437554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 437560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 437563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437567 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 437567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437572 */   GIR_RootConstrainSelectedInstOperands,
     /* 437573 */   // GIR_Coverage, 8996,
     /* 437573 */   GIR_Done,
     /* 437574 */ // Label 8834: @437574
     /* 437574 */ GIM_Reject,
     /* 437575 */ // Label 8806: @437575
     /* 437575 */ GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(437600), // Rule ID 8997 //
     /* 437580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 437586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 437589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437593 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 437593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437598 */   GIR_RootConstrainSelectedInstOperands,
     /* 437599 */   // GIR_Coverage, 8997,
     /* 437599 */   GIR_Done,
     /* 437600 */ // Label 8835: @437600
     /* 437600 */ GIM_Reject,
     /* 437601 */ // Label 8807: @437601
     /* 437601 */ GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(437647),
     /* 437606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 437609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 437612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437616 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(437631), // Rule ID 8992 //
     /* 437621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437624 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 437624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437629 */     GIR_RootConstrainSelectedInstOperands,
     /* 437630 */     // GIR_Coverage, 8992,
     /* 437630 */     GIR_Done,
     /* 437631 */   // Label 8837: @437631
     /* 437631 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(437646), // Rule ID 8998 //
     /* 437636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437639 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 437639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437644 */     GIR_RootConstrainSelectedInstOperands,
     /* 437645 */     // GIR_Coverage, 8998,
     /* 437645 */     GIR_Done,
     /* 437646 */   // Label 8838: @437646
     /* 437646 */   GIM_Reject,
     /* 437647 */ // Label 8836: @437647
     /* 437647 */ GIM_Reject,
     /* 437648 */ // Label 8808: @437648
     /* 437648 */ GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(437673), // Rule ID 9026 //
     /* 437653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 437659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 437662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437666 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 437666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 437671 */   GIR_RootConstrainSelectedInstOperands,
     /* 437672 */   // GIR_Coverage, 9026,
     /* 437672 */   GIR_Done,
     /* 437673 */ // Label 8839: @437673
     /* 437673 */ GIM_Reject,
     /* 437674 */ // Label 8809: @437674
     /* 437674 */ GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(437699), // Rule ID 8994 //
     /* 437679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 437685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 437688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437692 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 437692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 437697 */   GIR_RootConstrainSelectedInstOperands,
     /* 437698 */   // GIR_Coverage, 8994,
     /* 437698 */   GIR_Done,
     /* 437699 */ // Label 8840: @437699
     /* 437699 */ GIM_Reject,
     /* 437700 */ // Label 8810: @437700
     /* 437700 */ GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(437746),
     /* 437705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 437708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 437711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437715 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(437730), // Rule ID 8991 //
     /* 437720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437723 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 437723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 437728 */     GIR_RootConstrainSelectedInstOperands,
     /* 437729 */     // GIR_Coverage, 8991,
     /* 437729 */     GIR_Done,
     /* 437730 */   // Label 8842: @437730
     /* 437730 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(437745), // Rule ID 8995 //
     /* 437735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437738 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 437738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 437743 */     GIR_RootConstrainSelectedInstOperands,
     /* 437744 */     // GIR_Coverage, 8995,
     /* 437744 */     GIR_Done,
     /* 437745 */   // Label 8843: @437745
     /* 437745 */   GIM_Reject,
     /* 437746 */ // Label 8841: @437746
     /* 437746 */ GIM_Reject,
     /* 437747 */ // Label 8811: @437747
     /* 437747 */ GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(437772), // Rule ID 9025 //
     /* 437752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 437758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 437761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437765 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 437765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 437770 */   GIR_RootConstrainSelectedInstOperands,
     /* 437771 */   // GIR_Coverage, 9025,
     /* 437771 */   GIR_Done,
     /* 437772 */ // Label 8844: @437772
     /* 437772 */ GIM_Reject,
     /* 437773 */ // Label 8812: @437773
     /* 437773 */ GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(437819),
     /* 437778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 437781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 437784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437788 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(437803), // Rule ID 8990 //
     /* 437793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437796 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 437796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 437801 */     GIR_RootConstrainSelectedInstOperands,
     /* 437802 */     // GIR_Coverage, 8990,
     /* 437802 */     GIR_Done,
     /* 437803 */   // Label 8846: @437803
     /* 437803 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(437818), // Rule ID 8993 //
     /* 437808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437811 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 437811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 437816 */     GIR_RootConstrainSelectedInstOperands,
     /* 437817 */     // GIR_Coverage, 8993,
     /* 437817 */     GIR_Done,
     /* 437818 */   // Label 8847: @437818
     /* 437818 */   GIM_Reject,
     /* 437819 */ // Label 8845: @437819
     /* 437819 */ GIM_Reject,
     /* 437820 */ // Label 8813: @437820
     /* 437820 */ GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(437845), // Rule ID 2410 //
     /* 437825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 437831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 437834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437838 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 437838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 437843 */   GIR_RootConstrainSelectedInstOperands,
     /* 437844 */   // GIR_Coverage, 2410,
     /* 437844 */   GIR_Done,
     /* 437845 */ // Label 8848: @437845
     /* 437845 */ GIM_Reject,
     /* 437846 */ // Label 8814: @437846
     /* 437846 */ GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(437871), // Rule ID 8989 //
     /* 437851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 437857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 437860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437864 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 437864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 437869 */   GIR_RootConstrainSelectedInstOperands,
     /* 437870 */   // GIR_Coverage, 8989,
     /* 437870 */   GIR_Done,
     /* 437871 */ // Label 8849: @437871
     /* 437871 */ GIM_Reject,
     /* 437872 */ // Label 8815: @437872
     /* 437872 */ GIM_Reject,
     /* 437873 */ // Label 150: @437873
     /* 437873 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8858*/ GIMT_Encode4(438570),
     /* 437884 */ /*GILLT_s64*//*Label 8850*/ GIMT_Encode4(437920), GIMT_Encode4(0),
     /* 437892 */ /*GILLT_v2s32*//*Label 8851*/ GIMT_Encode4(438031),
     /* 437896 */ /*GILLT_v2s64*//*Label 8852*/ GIMT_Encode4(438108),
     /* 437900 */ /*GILLT_v4s16*//*Label 8853*/ GIMT_Encode4(438185),
     /* 437904 */ /*GILLT_v4s32*//*Label 8854*/ GIMT_Encode4(438262),
     /* 437908 */ /*GILLT_v8s8*//*Label 8855*/ GIMT_Encode4(438339),
     /* 437912 */ /*GILLT_v8s16*//*Label 8856*/ GIMT_Encode4(438416),
     /* 437916 */ /*GILLT_v16s8*//*Label 8857*/ GIMT_Encode4(438493),
     /* 437920 */ // Label 8850: @437920
     /* 437920 */ GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(438030),
     /* 437925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 437928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437936 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(437961), // Rule ID 5270 //
     /* 437941 */     // MIs[0] Operand 2
     /* 437941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 437952 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 437952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 437955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437959 */     GIR_RootConstrainSelectedInstOperands,
     /* 437960 */     // GIR_Coverage, 5270,
     /* 437960 */     GIR_EraseRootFromParent_Done,
     /* 437961 */   // Label 8860: @437961
     /* 437961 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(437995), // Rule ID 2120 //
     /* 437966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437969 */     // MIs[0] imm
     /* 437969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437981 */     // MIs[1] Operand 1
     /* 437981 */     // No operand predicates
     /* 437981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437983 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 437986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437993 */     GIR_RootConstrainSelectedInstOperands,
     /* 437994 */     // GIR_Coverage, 2120,
     /* 437994 */     GIR_EraseRootFromParent_Done,
     /* 437995 */   // Label 8861: @437995
     /* 437995 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(438029), // Rule ID 6334 //
     /* 438000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438003 */     // MIs[0] imm
     /* 438003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438015 */     // MIs[1] Operand 1
     /* 438015 */     // No operand predicates
     /* 438015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438017 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 438017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 438020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438027 */     GIR_RootConstrainSelectedInstOperands,
     /* 438028 */     // GIR_Coverage, 6334,
     /* 438028 */     GIR_EraseRootFromParent_Done,
     /* 438029 */   // Label 8862: @438029
     /* 438029 */   GIM_Reject,
     /* 438030 */ // Label 8859: @438030
     /* 438030 */ GIM_Reject,
     /* 438031 */ // Label 8851: @438031
     /* 438031 */ GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(438107),
     /* 438036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438047 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(438072), // Rule ID 4932 //
     /* 438052 */     // MIs[0] Operand 2
     /* 438052 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 438063 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 438063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 438066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438070 */     GIR_RootConstrainSelectedInstOperands,
     /* 438071 */     // GIR_Coverage, 4932,
     /* 438071 */     GIR_EraseRootFromParent_Done,
     /* 438072 */   // Label 8864: @438072
     /* 438072 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(438106), // Rule ID 2227 //
     /* 438077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438080 */     // MIs[0] imm
     /* 438080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 438092 */     // MIs[1] Operand 1
     /* 438092 */     // No operand predicates
     /* 438092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438094 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 438097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438104 */     GIR_RootConstrainSelectedInstOperands,
     /* 438105 */     // GIR_Coverage, 2227,
     /* 438105 */     GIR_EraseRootFromParent_Done,
     /* 438106 */   // Label 8865: @438106
     /* 438106 */   GIM_Reject,
     /* 438107 */ // Label 8863: @438107
     /* 438107 */ GIM_Reject,
     /* 438108 */ // Label 8852: @438108
     /* 438108 */ GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(438184),
     /* 438113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438124 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(438149), // Rule ID 4936 //
     /* 438129 */     // MIs[0] Operand 2
     /* 438129 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 438140 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 438140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 438143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438147 */     GIR_RootConstrainSelectedInstOperands,
     /* 438148 */     // GIR_Coverage, 4936,
     /* 438148 */     GIR_EraseRootFromParent_Done,
     /* 438149 */   // Label 8867: @438149
     /* 438149 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(438183), // Rule ID 2229 //
     /* 438154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438157 */     // MIs[0] imm
     /* 438157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438169 */     // MIs[1] Operand 1
     /* 438169 */     // No operand predicates
     /* 438169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438171 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 438174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438181 */     GIR_RootConstrainSelectedInstOperands,
     /* 438182 */     // GIR_Coverage, 2229,
     /* 438182 */     GIR_EraseRootFromParent_Done,
     /* 438183 */   // Label 8868: @438183
     /* 438183 */   GIM_Reject,
     /* 438184 */ // Label 8866: @438184
     /* 438184 */ GIM_Reject,
     /* 438185 */ // Label 8853: @438185
     /* 438185 */ GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(438261),
     /* 438190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438201 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(438226), // Rule ID 4931 //
     /* 438206 */     // MIs[0] Operand 2
     /* 438206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 438217 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 438217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 438220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438224 */     GIR_RootConstrainSelectedInstOperands,
     /* 438225 */     // GIR_Coverage, 4931,
     /* 438225 */     GIR_EraseRootFromParent_Done,
     /* 438226 */   // Label 8870: @438226
     /* 438226 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(438260), // Rule ID 2225 //
     /* 438231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438234 */     // MIs[0] imm
     /* 438234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438246 */     // MIs[1] Operand 1
     /* 438246 */     // No operand predicates
     /* 438246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438248 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 438251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438258 */     GIR_RootConstrainSelectedInstOperands,
     /* 438259 */     // GIR_Coverage, 2225,
     /* 438259 */     GIR_EraseRootFromParent_Done,
     /* 438260 */   // Label 8871: @438260
     /* 438260 */   GIM_Reject,
     /* 438261 */ // Label 8869: @438261
     /* 438261 */ GIM_Reject,
     /* 438262 */ // Label 8854: @438262
     /* 438262 */ GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(438338),
     /* 438267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438278 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(438303), // Rule ID 4935 //
     /* 438283 */     // MIs[0] Operand 2
     /* 438283 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 438294 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 438294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 438297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438301 */     GIR_RootConstrainSelectedInstOperands,
     /* 438302 */     // GIR_Coverage, 4935,
     /* 438302 */     GIR_EraseRootFromParent_Done,
     /* 438303 */   // Label 8873: @438303
     /* 438303 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(438337), // Rule ID 2228 //
     /* 438308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438311 */     // MIs[0] imm
     /* 438311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 438323 */     // MIs[1] Operand 1
     /* 438323 */     // No operand predicates
     /* 438323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438325 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 438328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438335 */     GIR_RootConstrainSelectedInstOperands,
     /* 438336 */     // GIR_Coverage, 2228,
     /* 438336 */     GIR_EraseRootFromParent_Done,
     /* 438337 */   // Label 8874: @438337
     /* 438337 */   GIM_Reject,
     /* 438338 */ // Label 8872: @438338
     /* 438338 */ GIM_Reject,
     /* 438339 */ // Label 8855: @438339
     /* 438339 */ GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(438415),
     /* 438344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438355 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(438380), // Rule ID 4930 //
     /* 438360 */     // MIs[0] Operand 2
     /* 438360 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 438371 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 438371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 438374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438378 */     GIR_RootConstrainSelectedInstOperands,
     /* 438379 */     // GIR_Coverage, 4930,
     /* 438379 */     GIR_EraseRootFromParent_Done,
     /* 438380 */   // Label 8876: @438380
     /* 438380 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(438414), // Rule ID 2223 //
     /* 438385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438388 */     // MIs[0] imm
     /* 438388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438400 */     // MIs[1] Operand 1
     /* 438400 */     // No operand predicates
     /* 438400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438402 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 438405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438412 */     GIR_RootConstrainSelectedInstOperands,
     /* 438413 */     // GIR_Coverage, 2223,
     /* 438413 */     GIR_EraseRootFromParent_Done,
     /* 438414 */   // Label 8877: @438414
     /* 438414 */   GIM_Reject,
     /* 438415 */ // Label 8875: @438415
     /* 438415 */ GIM_Reject,
     /* 438416 */ // Label 8856: @438416
     /* 438416 */ GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(438492),
     /* 438421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438432 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(438457), // Rule ID 4934 //
     /* 438437 */     // MIs[0] Operand 2
     /* 438437 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 438448 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 438448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 438451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438455 */     GIR_RootConstrainSelectedInstOperands,
     /* 438456 */     // GIR_Coverage, 4934,
     /* 438456 */     GIR_EraseRootFromParent_Done,
     /* 438457 */   // Label 8879: @438457
     /* 438457 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(438491), // Rule ID 2226 //
     /* 438462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438465 */     // MIs[0] imm
     /* 438465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438477 */     // MIs[1] Operand 1
     /* 438477 */     // No operand predicates
     /* 438477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438479 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 438482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438489 */     GIR_RootConstrainSelectedInstOperands,
     /* 438490 */     // GIR_Coverage, 2226,
     /* 438490 */     GIR_EraseRootFromParent_Done,
     /* 438491 */   // Label 8880: @438491
     /* 438491 */   GIM_Reject,
     /* 438492 */ // Label 8878: @438492
     /* 438492 */ GIM_Reject,
     /* 438493 */ // Label 8857: @438493
     /* 438493 */ GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(438569),
     /* 438498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438509 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(438534), // Rule ID 4933 //
     /* 438514 */     // MIs[0] Operand 2
     /* 438514 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 438525 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 438525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 438528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438532 */     GIR_RootConstrainSelectedInstOperands,
     /* 438533 */     // GIR_Coverage, 4933,
     /* 438533 */     GIR_EraseRootFromParent_Done,
     /* 438534 */   // Label 8882: @438534
     /* 438534 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(438568), // Rule ID 2224 //
     /* 438539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438542 */     // MIs[0] imm
     /* 438542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438554 */     // MIs[1] Operand 1
     /* 438554 */     // No operand predicates
     /* 438554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438556 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 438559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438566 */     GIR_RootConstrainSelectedInstOperands,
     /* 438567 */     // GIR_Coverage, 2224,
     /* 438567 */     GIR_EraseRootFromParent_Done,
     /* 438568 */   // Label 8883: @438568
     /* 438568 */   GIM_Reject,
     /* 438569 */ // Label 8881: @438569
     /* 438569 */ GIM_Reject,
     /* 438570 */ // Label 8858: @438570
     /* 438570 */ GIM_Reject,
     /* 438571 */ // Label 151: @438571
     /* 438571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8892*/ GIMT_Encode4(439026),
     /* 438582 */ /*GILLT_s64*//*Label 8884*/ GIMT_Encode4(438618), GIMT_Encode4(0),
     /* 438590 */ /*GILLT_v2s32*//*Label 8885*/ GIMT_Encode4(438704),
     /* 438594 */ /*GILLT_v2s64*//*Label 8886*/ GIMT_Encode4(438750),
     /* 438598 */ /*GILLT_v4s16*//*Label 8887*/ GIMT_Encode4(438796),
     /* 438602 */ /*GILLT_v4s32*//*Label 8888*/ GIMT_Encode4(438842),
     /* 438606 */ /*GILLT_v8s8*//*Label 8889*/ GIMT_Encode4(438888),
     /* 438610 */ /*GILLT_v8s16*//*Label 8890*/ GIMT_Encode4(438934),
     /* 438614 */ /*GILLT_v16s8*//*Label 8891*/ GIMT_Encode4(438980),
     /* 438618 */ // Label 8884: @438618
     /* 438618 */ GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(438703),
     /* 438623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 438626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438634 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(438668), // Rule ID 2129 //
     /* 438639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438642 */     // MIs[0] imm
     /* 438642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438654 */     // MIs[1] Operand 1
     /* 438654 */     // No operand predicates
     /* 438654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438656 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 438659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438666 */     GIR_RootConstrainSelectedInstOperands,
     /* 438667 */     // GIR_Coverage, 2129,
     /* 438667 */     GIR_EraseRootFromParent_Done,
     /* 438668 */   // Label 8894: @438668
     /* 438668 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(438702), // Rule ID 6337 //
     /* 438673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438676 */     // MIs[0] imm
     /* 438676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438688 */     // MIs[1] Operand 1
     /* 438688 */     // No operand predicates
     /* 438688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438690 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 438690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 438693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438700 */     GIR_RootConstrainSelectedInstOperands,
     /* 438701 */     // GIR_Coverage, 6337,
     /* 438701 */     GIR_EraseRootFromParent_Done,
     /* 438702 */   // Label 8895: @438702
     /* 438702 */   GIM_Reject,
     /* 438703 */ // Label 8893: @438703
     /* 438703 */ GIM_Reject,
     /* 438704 */ // Label 8885: @438704
     /* 438704 */ GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(438749), // Rule ID 2286 //
     /* 438709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438723 */   // MIs[0] imm
     /* 438723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438731 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 438735 */   // MIs[1] Operand 1
     /* 438735 */   // No operand predicates
     /* 438735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438737 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 438740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438742 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438744 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438747 */   GIR_RootConstrainSelectedInstOperands,
     /* 438748 */   // GIR_Coverage, 2286,
     /* 438748 */   GIR_EraseRootFromParent_Done,
     /* 438749 */ // Label 8896: @438749
     /* 438749 */ GIM_Reject,
     /* 438750 */ // Label 8886: @438750
     /* 438750 */ GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(438795), // Rule ID 2288 //
     /* 438755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438769 */   // MIs[0] imm
     /* 438769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438777 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438781 */   // MIs[1] Operand 1
     /* 438781 */   // No operand predicates
     /* 438781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438783 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 438786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438788 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438790 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438793 */   GIR_RootConstrainSelectedInstOperands,
     /* 438794 */   // GIR_Coverage, 2288,
     /* 438794 */   GIR_EraseRootFromParent_Done,
     /* 438795 */ // Label 8897: @438795
     /* 438795 */ GIM_Reject,
     /* 438796 */ // Label 8887: @438796
     /* 438796 */ GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(438841), // Rule ID 2284 //
     /* 438801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438815 */   // MIs[0] imm
     /* 438815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438823 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438827 */   // MIs[1] Operand 1
     /* 438827 */   // No operand predicates
     /* 438827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438829 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 438832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438834 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438836 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438839 */   GIR_RootConstrainSelectedInstOperands,
     /* 438840 */   // GIR_Coverage, 2284,
     /* 438840 */   GIR_EraseRootFromParent_Done,
     /* 438841 */ // Label 8898: @438841
     /* 438841 */ GIM_Reject,
     /* 438842 */ // Label 8888: @438842
     /* 438842 */ GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(438887), // Rule ID 2287 //
     /* 438847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438861 */   // MIs[0] imm
     /* 438861 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438865 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438869 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 438873 */   // MIs[1] Operand 1
     /* 438873 */   // No operand predicates
     /* 438873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438875 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 438878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438880 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438882 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438885 */   GIR_RootConstrainSelectedInstOperands,
     /* 438886 */   // GIR_Coverage, 2287,
     /* 438886 */   GIR_EraseRootFromParent_Done,
     /* 438887 */ // Label 8899: @438887
     /* 438887 */ GIM_Reject,
     /* 438888 */ // Label 8889: @438888
     /* 438888 */ GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(438933), // Rule ID 2282 //
     /* 438893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438907 */   // MIs[0] imm
     /* 438907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438915 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438919 */   // MIs[1] Operand 1
     /* 438919 */   // No operand predicates
     /* 438919 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438921 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 438924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438926 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438928 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438931 */   GIR_RootConstrainSelectedInstOperands,
     /* 438932 */   // GIR_Coverage, 2282,
     /* 438932 */   GIR_EraseRootFromParent_Done,
     /* 438933 */ // Label 8900: @438933
     /* 438933 */ GIM_Reject,
     /* 438934 */ // Label 8890: @438934
     /* 438934 */ GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(438979), // Rule ID 2285 //
     /* 438939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438953 */   // MIs[0] imm
     /* 438953 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438961 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438965 */   // MIs[1] Operand 1
     /* 438965 */   // No operand predicates
     /* 438965 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438967 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 438970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438972 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438974 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438977 */   GIR_RootConstrainSelectedInstOperands,
     /* 438978 */   // GIR_Coverage, 2285,
     /* 438978 */   GIR_EraseRootFromParent_Done,
     /* 438979 */ // Label 8901: @438979
     /* 438979 */ GIM_Reject,
     /* 438980 */ // Label 8891: @438980
     /* 438980 */ GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(439025), // Rule ID 2283 //
     /* 438985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438999 */   // MIs[0] imm
     /* 438999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439007 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 439011 */   // MIs[1] Operand 1
     /* 439011 */   // No operand predicates
     /* 439011 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439013 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 439016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439018 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439020 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439023 */   GIR_RootConstrainSelectedInstOperands,
     /* 439024 */   // GIR_Coverage, 2283,
     /* 439024 */   GIR_EraseRootFromParent_Done,
     /* 439025 */ // Label 8902: @439025
     /* 439025 */ GIM_Reject,
     /* 439026 */ // Label 8892: @439026
     /* 439026 */ GIM_Reject,
     /* 439027 */ // Label 152: @439027
     /* 439027 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8921*/ GIMT_Encode4(439806),
     /* 439038 */ /*GILLT_v2s32*//*Label 8903*/ GIMT_Encode4(439114),
     /* 439042 */ /*GILLT_v2s64*//*Label 8904*/ GIMT_Encode4(439169),
     /* 439046 */ /*GILLT_v4s16*//*Label 8905*/ GIMT_Encode4(439224),
     /* 439050 */ /*GILLT_v4s32*//*Label 8906*/ GIMT_Encode4(439279),
     /* 439054 */ /*GILLT_v8s8*//*Label 8907*/ GIMT_Encode4(439334),
     /* 439058 */ /*GILLT_v8s16*//*Label 8908*/ GIMT_Encode4(439368),
     /* 439062 */ /*GILLT_v16s8*//*Label 8909*/ GIMT_Encode4(439423), GIMT_Encode4(0),
     /* 439070 */ /*GILLT_nxv2s1*//*Label 8910*/ GIMT_Encode4(439457),
     /* 439074 */ /*GILLT_nxv2s16*//*Label 8911*/ GIMT_Encode4(439483),
     /* 439078 */ /*GILLT_nxv2s32*//*Label 8912*/ GIMT_Encode4(439509),
     /* 439082 */ /*GILLT_nxv2s64*//*Label 8913*/ GIMT_Encode4(439535),
     /* 439086 */ /*GILLT_nxv4s1*//*Label 8914*/ GIMT_Encode4(439582),
     /* 439090 */ /*GILLT_nxv4s16*//*Label 8915*/ GIMT_Encode4(439608),
     /* 439094 */ /*GILLT_nxv4s32*//*Label 8916*/ GIMT_Encode4(439634),
     /* 439098 */ /*GILLT_nxv8s1*//*Label 8917*/ GIMT_Encode4(439681),
     /* 439102 */ /*GILLT_nxv8s16*//*Label 8918*/ GIMT_Encode4(439707),
     /* 439106 */ /*GILLT_nxv16s1*//*Label 8919*/ GIMT_Encode4(439754),
     /* 439110 */ /*GILLT_nxv16s8*//*Label 8920*/ GIMT_Encode4(439780),
     /* 439114 */ // Label 8903: @439114
     /* 439114 */ GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(439168),
     /* 439119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 439122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 439125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439137 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(439152), // Rule ID 1902 //
     /* 439142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439145 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 439145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 439150 */     GIR_RootConstrainSelectedInstOperands,
     /* 439151 */     // GIR_Coverage, 1902,
     /* 439151 */     GIR_Done,
     /* 439152 */   // Label 8923: @439152
     /* 439152 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(439167), // Rule ID 5503 //
     /* 439157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439160 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 439160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 439165 */     GIR_RootConstrainSelectedInstOperands,
     /* 439166 */     // GIR_Coverage, 5503,
     /* 439166 */     GIR_Done,
     /* 439167 */   // Label 8924: @439167
     /* 439167 */   GIM_Reject,
     /* 439168 */ // Label 8922: @439168
     /* 439168 */ GIM_Reject,
     /* 439169 */ // Label 8904: @439169
     /* 439169 */ GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(439223),
     /* 439174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 439177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 439180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439192 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(439207), // Rule ID 1904 //
     /* 439197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439200 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 439200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 439205 */     GIR_RootConstrainSelectedInstOperands,
     /* 439206 */     // GIR_Coverage, 1904,
     /* 439206 */     GIR_Done,
     /* 439207 */   // Label 8926: @439207
     /* 439207 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(439222), // Rule ID 5505 //
     /* 439212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439215 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 439215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 439220 */     GIR_RootConstrainSelectedInstOperands,
     /* 439221 */     // GIR_Coverage, 5505,
     /* 439221 */     GIR_Done,
     /* 439222 */   // Label 8927: @439222
     /* 439222 */   GIM_Reject,
     /* 439223 */ // Label 8925: @439223
     /* 439223 */ GIM_Reject,
     /* 439224 */ // Label 8905: @439224
     /* 439224 */ GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(439278),
     /* 439229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 439232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 439235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439247 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(439262), // Rule ID 1900 //
     /* 439252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439255 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 439255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 439260 */     GIR_RootConstrainSelectedInstOperands,
     /* 439261 */     // GIR_Coverage, 1900,
     /* 439261 */     GIR_Done,
     /* 439262 */   // Label 8929: @439262
     /* 439262 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(439277), // Rule ID 5501 //
     /* 439267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439270 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 439270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 439275 */     GIR_RootConstrainSelectedInstOperands,
     /* 439276 */     // GIR_Coverage, 5501,
     /* 439276 */     GIR_Done,
     /* 439277 */   // Label 8930: @439277
     /* 439277 */   GIM_Reject,
     /* 439278 */ // Label 8928: @439278
     /* 439278 */ GIM_Reject,
     /* 439279 */ // Label 8906: @439279
     /* 439279 */ GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(439333),
     /* 439284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 439287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 439290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439302 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(439317), // Rule ID 1903 //
     /* 439307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439310 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 439310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 439315 */     GIR_RootConstrainSelectedInstOperands,
     /* 439316 */     // GIR_Coverage, 1903,
     /* 439316 */     GIR_Done,
     /* 439317 */   // Label 8932: @439317
     /* 439317 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(439332), // Rule ID 5504 //
     /* 439322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439325 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 439325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 439330 */     GIR_RootConstrainSelectedInstOperands,
     /* 439331 */     // GIR_Coverage, 5504,
     /* 439331 */     GIR_Done,
     /* 439332 */   // Label 8933: @439332
     /* 439332 */   GIM_Reject,
     /* 439333 */ // Label 8931: @439333
     /* 439333 */ GIM_Reject,
     /* 439334 */ // Label 8907: @439334
     /* 439334 */ GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(439367), // Rule ID 1898 //
     /* 439339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 439345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 439348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439360 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 439360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 439365 */   GIR_RootConstrainSelectedInstOperands,
     /* 439366 */   // GIR_Coverage, 1898,
     /* 439366 */   GIR_Done,
     /* 439367 */ // Label 8934: @439367
     /* 439367 */ GIM_Reject,
     /* 439368 */ // Label 8908: @439368
     /* 439368 */ GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(439422),
     /* 439373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 439376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 439379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439391 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(439406), // Rule ID 1901 //
     /* 439396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439399 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 439399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 439404 */     GIR_RootConstrainSelectedInstOperands,
     /* 439405 */     // GIR_Coverage, 1901,
     /* 439405 */     GIR_Done,
     /* 439406 */   // Label 8936: @439406
     /* 439406 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(439421), // Rule ID 5502 //
     /* 439411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439414 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 439414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 439419 */     GIR_RootConstrainSelectedInstOperands,
     /* 439420 */     // GIR_Coverage, 5502,
     /* 439420 */     GIR_Done,
     /* 439421 */   // Label 8937: @439421
     /* 439421 */   GIM_Reject,
     /* 439422 */ // Label 8935: @439422
     /* 439422 */ GIM_Reject,
     /* 439423 */ // Label 8909: @439423
     /* 439423 */ GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(439456), // Rule ID 1899 //
     /* 439428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 439434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 439437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439449 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 439449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 439454 */   GIR_RootConstrainSelectedInstOperands,
     /* 439455 */   // GIR_Coverage, 1899,
     /* 439455 */   GIR_Done,
     /* 439456 */ // Label 8938: @439456
     /* 439456 */ GIM_Reject,
     /* 439457 */ // Label 8910: @439457
     /* 439457 */ GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(439482), // Rule ID 3344 //
     /* 439462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 439468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 439471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439475 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 439475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 439480 */   GIR_RootConstrainSelectedInstOperands,
     /* 439481 */   // GIR_Coverage, 3344,
     /* 439481 */   GIR_Done,
     /* 439482 */ // Label 8939: @439482
     /* 439482 */ GIM_Reject,
     /* 439483 */ // Label 8911: @439483
     /* 439483 */ GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(439508), // Rule ID 2875 //
     /* 439488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 439494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 439497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439501 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 439501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439506 */   GIR_RootConstrainSelectedInstOperands,
     /* 439507 */   // GIR_Coverage, 2875,
     /* 439507 */   GIR_Done,
     /* 439508 */ // Label 8940: @439508
     /* 439508 */ GIM_Reject,
     /* 439509 */ // Label 8912: @439509
     /* 439509 */ GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(439534), // Rule ID 2876 //
     /* 439514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 439520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 439523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439527 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 439527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439532 */   GIR_RootConstrainSelectedInstOperands,
     /* 439533 */   // GIR_Coverage, 2876,
     /* 439533 */   GIR_Done,
     /* 439534 */ // Label 8941: @439534
     /* 439534 */ GIM_Reject,
     /* 439535 */ // Label 8913: @439535
     /* 439535 */ GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(439581),
     /* 439540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 439543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 439546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439550 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(439565), // Rule ID 2871 //
     /* 439555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439558 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 439558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439563 */     GIR_RootConstrainSelectedInstOperands,
     /* 439564 */     // GIR_Coverage, 2871,
     /* 439564 */     GIR_Done,
     /* 439565 */   // Label 8943: @439565
     /* 439565 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(439580), // Rule ID 2877 //
     /* 439570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439573 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 439573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439578 */     GIR_RootConstrainSelectedInstOperands,
     /* 439579 */     // GIR_Coverage, 2877,
     /* 439579 */     GIR_Done,
     /* 439580 */   // Label 8944: @439580
     /* 439580 */   GIM_Reject,
     /* 439581 */ // Label 8942: @439581
     /* 439581 */ GIM_Reject,
     /* 439582 */ // Label 8914: @439582
     /* 439582 */ GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(439607), // Rule ID 3343 //
     /* 439587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 439593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 439596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439600 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 439600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 439605 */   GIR_RootConstrainSelectedInstOperands,
     /* 439606 */   // GIR_Coverage, 3343,
     /* 439606 */   GIR_Done,
     /* 439607 */ // Label 8945: @439607
     /* 439607 */ GIM_Reject,
     /* 439608 */ // Label 8915: @439608
     /* 439608 */ GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(439633), // Rule ID 2873 //
     /* 439613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 439619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 439622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439626 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 439626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 439631 */   GIR_RootConstrainSelectedInstOperands,
     /* 439632 */   // GIR_Coverage, 2873,
     /* 439632 */   GIR_Done,
     /* 439633 */ // Label 8946: @439633
     /* 439633 */ GIM_Reject,
     /* 439634 */ // Label 8916: @439634
     /* 439634 */ GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(439680),
     /* 439639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 439642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 439645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439649 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(439664), // Rule ID 2870 //
     /* 439654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439657 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 439657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 439662 */     GIR_RootConstrainSelectedInstOperands,
     /* 439663 */     // GIR_Coverage, 2870,
     /* 439663 */     GIR_Done,
     /* 439664 */   // Label 8948: @439664
     /* 439664 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(439679), // Rule ID 2874 //
     /* 439669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439672 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 439672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 439677 */     GIR_RootConstrainSelectedInstOperands,
     /* 439678 */     // GIR_Coverage, 2874,
     /* 439678 */     GIR_Done,
     /* 439679 */   // Label 8949: @439679
     /* 439679 */   GIM_Reject,
     /* 439680 */ // Label 8947: @439680
     /* 439680 */ GIM_Reject,
     /* 439681 */ // Label 8917: @439681
     /* 439681 */ GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(439706), // Rule ID 3342 //
     /* 439686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 439692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 439695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439699 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 439699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 439704 */   GIR_RootConstrainSelectedInstOperands,
     /* 439705 */   // GIR_Coverage, 3342,
     /* 439705 */   GIR_Done,
     /* 439706 */ // Label 8950: @439706
     /* 439706 */ GIM_Reject,
     /* 439707 */ // Label 8918: @439707
     /* 439707 */ GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(439753),
     /* 439712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 439715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 439718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439722 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(439737), // Rule ID 2869 //
     /* 439727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439730 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 439730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 439735 */     GIR_RootConstrainSelectedInstOperands,
     /* 439736 */     // GIR_Coverage, 2869,
     /* 439736 */     GIR_Done,
     /* 439737 */   // Label 8952: @439737
     /* 439737 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(439752), // Rule ID 2872 //
     /* 439742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439745 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 439745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 439750 */     GIR_RootConstrainSelectedInstOperands,
     /* 439751 */     // GIR_Coverage, 2872,
     /* 439751 */     GIR_Done,
     /* 439752 */   // Label 8953: @439752
     /* 439752 */   GIM_Reject,
     /* 439753 */ // Label 8951: @439753
     /* 439753 */ GIM_Reject,
     /* 439754 */ // Label 8919: @439754
     /* 439754 */ GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(439779), // Rule ID 2398 //
     /* 439759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 439765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 439768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439772 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 439772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 439777 */   GIR_RootConstrainSelectedInstOperands,
     /* 439778 */   // GIR_Coverage, 2398,
     /* 439778 */   GIR_Done,
     /* 439779 */ // Label 8954: @439779
     /* 439779 */ GIM_Reject,
     /* 439780 */ // Label 8920: @439780
     /* 439780 */ GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(439805), // Rule ID 2868 //
     /* 439785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 439791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 439794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439798 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 439798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 439803 */   GIR_RootConstrainSelectedInstOperands,
     /* 439804 */   // GIR_Coverage, 2868,
     /* 439804 */   GIR_Done,
     /* 439805 */ // Label 8955: @439805
     /* 439805 */ GIM_Reject,
     /* 439806 */ // Label 8921: @439806
     /* 439806 */ GIM_Reject,
     /* 439807 */ // Label 153: @439807
     /* 439807 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8974*/ GIMT_Encode4(440586),
     /* 439818 */ /*GILLT_v2s32*//*Label 8956*/ GIMT_Encode4(439894),
     /* 439822 */ /*GILLT_v2s64*//*Label 8957*/ GIMT_Encode4(439949),
     /* 439826 */ /*GILLT_v4s16*//*Label 8958*/ GIMT_Encode4(440004),
     /* 439830 */ /*GILLT_v4s32*//*Label 8959*/ GIMT_Encode4(440059),
     /* 439834 */ /*GILLT_v8s8*//*Label 8960*/ GIMT_Encode4(440114),
     /* 439838 */ /*GILLT_v8s16*//*Label 8961*/ GIMT_Encode4(440148),
     /* 439842 */ /*GILLT_v16s8*//*Label 8962*/ GIMT_Encode4(440203), GIMT_Encode4(0),
     /* 439850 */ /*GILLT_nxv2s1*//*Label 8963*/ GIMT_Encode4(440237),
     /* 439854 */ /*GILLT_nxv2s16*//*Label 8964*/ GIMT_Encode4(440263),
     /* 439858 */ /*GILLT_nxv2s32*//*Label 8965*/ GIMT_Encode4(440289),
     /* 439862 */ /*GILLT_nxv2s64*//*Label 8966*/ GIMT_Encode4(440315),
     /* 439866 */ /*GILLT_nxv4s1*//*Label 8967*/ GIMT_Encode4(440362),
     /* 439870 */ /*GILLT_nxv4s16*//*Label 8968*/ GIMT_Encode4(440388),
     /* 439874 */ /*GILLT_nxv4s32*//*Label 8969*/ GIMT_Encode4(440414),
     /* 439878 */ /*GILLT_nxv8s1*//*Label 8970*/ GIMT_Encode4(440461),
     /* 439882 */ /*GILLT_nxv8s16*//*Label 8971*/ GIMT_Encode4(440487),
     /* 439886 */ /*GILLT_nxv16s1*//*Label 8972*/ GIMT_Encode4(440534),
     /* 439890 */ /*GILLT_nxv16s8*//*Label 8973*/ GIMT_Encode4(440560),
     /* 439894 */ // Label 8956: @439894
     /* 439894 */ GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(439948),
     /* 439899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 439902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 439905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439917 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(439932), // Rule ID 1909 //
     /* 439922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439925 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 439925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 439930 */     GIR_RootConstrainSelectedInstOperands,
     /* 439931 */     // GIR_Coverage, 1909,
     /* 439931 */     GIR_Done,
     /* 439932 */   // Label 8976: @439932
     /* 439932 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(439947), // Rule ID 5508 //
     /* 439937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439940 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 439940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 439945 */     GIR_RootConstrainSelectedInstOperands,
     /* 439946 */     // GIR_Coverage, 5508,
     /* 439946 */     GIR_Done,
     /* 439947 */   // Label 8977: @439947
     /* 439947 */   GIM_Reject,
     /* 439948 */ // Label 8975: @439948
     /* 439948 */ GIM_Reject,
     /* 439949 */ // Label 8957: @439949
     /* 439949 */ GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(440003),
     /* 439954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 439957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 439960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439972 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(439987), // Rule ID 1911 //
     /* 439977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439980 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 439980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 439985 */     GIR_RootConstrainSelectedInstOperands,
     /* 439986 */     // GIR_Coverage, 1911,
     /* 439986 */     GIR_Done,
     /* 439987 */   // Label 8979: @439987
     /* 439987 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(440002), // Rule ID 5510 //
     /* 439992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439995 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 439995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 440000 */     GIR_RootConstrainSelectedInstOperands,
     /* 440001 */     // GIR_Coverage, 5510,
     /* 440001 */     GIR_Done,
     /* 440002 */   // Label 8980: @440002
     /* 440002 */   GIM_Reject,
     /* 440003 */ // Label 8978: @440003
     /* 440003 */ GIM_Reject,
     /* 440004 */ // Label 8958: @440004
     /* 440004 */ GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(440058),
     /* 440009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 440012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 440015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440027 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(440042), // Rule ID 1907 //
     /* 440032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440035 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 440035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 440040 */     GIR_RootConstrainSelectedInstOperands,
     /* 440041 */     // GIR_Coverage, 1907,
     /* 440041 */     GIR_Done,
     /* 440042 */   // Label 8982: @440042
     /* 440042 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(440057), // Rule ID 5506 //
     /* 440047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440050 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 440050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 440055 */     GIR_RootConstrainSelectedInstOperands,
     /* 440056 */     // GIR_Coverage, 5506,
     /* 440056 */     GIR_Done,
     /* 440057 */   // Label 8983: @440057
     /* 440057 */   GIM_Reject,
     /* 440058 */ // Label 8981: @440058
     /* 440058 */ GIM_Reject,
     /* 440059 */ // Label 8959: @440059
     /* 440059 */ GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(440113),
     /* 440064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 440067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 440070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440082 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(440097), // Rule ID 1910 //
     /* 440087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440090 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 440090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 440095 */     GIR_RootConstrainSelectedInstOperands,
     /* 440096 */     // GIR_Coverage, 1910,
     /* 440096 */     GIR_Done,
     /* 440097 */   // Label 8985: @440097
     /* 440097 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(440112), // Rule ID 5509 //
     /* 440102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440105 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 440105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 440110 */     GIR_RootConstrainSelectedInstOperands,
     /* 440111 */     // GIR_Coverage, 5509,
     /* 440111 */     GIR_Done,
     /* 440112 */   // Label 8986: @440112
     /* 440112 */   GIM_Reject,
     /* 440113 */ // Label 8984: @440113
     /* 440113 */ GIM_Reject,
     /* 440114 */ // Label 8960: @440114
     /* 440114 */ GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(440147), // Rule ID 1905 //
     /* 440119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 440125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 440128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440140 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 440140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 440145 */   GIR_RootConstrainSelectedInstOperands,
     /* 440146 */   // GIR_Coverage, 1905,
     /* 440146 */   GIR_Done,
     /* 440147 */ // Label 8987: @440147
     /* 440147 */ GIM_Reject,
     /* 440148 */ // Label 8961: @440148
     /* 440148 */ GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(440202),
     /* 440153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 440156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 440159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440171 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(440186), // Rule ID 1908 //
     /* 440176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440179 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 440179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 440184 */     GIR_RootConstrainSelectedInstOperands,
     /* 440185 */     // GIR_Coverage, 1908,
     /* 440185 */     GIR_Done,
     /* 440186 */   // Label 8989: @440186
     /* 440186 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(440201), // Rule ID 5507 //
     /* 440191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440194 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 440194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 440199 */     GIR_RootConstrainSelectedInstOperands,
     /* 440200 */     // GIR_Coverage, 5507,
     /* 440200 */     GIR_Done,
     /* 440201 */   // Label 8990: @440201
     /* 440201 */   GIM_Reject,
     /* 440202 */ // Label 8988: @440202
     /* 440202 */ GIM_Reject,
     /* 440203 */ // Label 8962: @440203
     /* 440203 */ GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(440236), // Rule ID 1906 //
     /* 440208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 440214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 440217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440229 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 440229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 440234 */   GIR_RootConstrainSelectedInstOperands,
     /* 440235 */   // GIR_Coverage, 1906,
     /* 440235 */   GIR_Done,
     /* 440236 */ // Label 8991: @440236
     /* 440236 */ GIM_Reject,
     /* 440237 */ // Label 8963: @440237
     /* 440237 */ GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(440262), // Rule ID 9021 //
     /* 440242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 440248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 440251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440255 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 440255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 440260 */   GIR_RootConstrainSelectedInstOperands,
     /* 440261 */   // GIR_Coverage, 9021,
     /* 440261 */   GIR_Done,
     /* 440262 */ // Label 8992: @440262
     /* 440262 */ GIM_Reject,
     /* 440263 */ // Label 8964: @440263
     /* 440263 */ GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(440288), // Rule ID 8976 //
     /* 440268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 440274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 440277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440281 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 440281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440286 */   GIR_RootConstrainSelectedInstOperands,
     /* 440287 */   // GIR_Coverage, 8976,
     /* 440287 */   GIR_Done,
     /* 440288 */ // Label 8993: @440288
     /* 440288 */ GIM_Reject,
     /* 440289 */ // Label 8965: @440289
     /* 440289 */ GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(440314), // Rule ID 8977 //
     /* 440294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 440300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 440303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440307 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 440307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440312 */   GIR_RootConstrainSelectedInstOperands,
     /* 440313 */   // GIR_Coverage, 8977,
     /* 440313 */   GIR_Done,
     /* 440314 */ // Label 8994: @440314
     /* 440314 */ GIM_Reject,
     /* 440315 */ // Label 8966: @440315
     /* 440315 */ GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(440361),
     /* 440320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 440323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 440326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440330 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(440345), // Rule ID 8972 //
     /* 440335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440338 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 440338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440343 */     GIR_RootConstrainSelectedInstOperands,
     /* 440344 */     // GIR_Coverage, 8972,
     /* 440344 */     GIR_Done,
     /* 440345 */   // Label 8996: @440345
     /* 440345 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(440360), // Rule ID 8978 //
     /* 440350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440353 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 440353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440358 */     GIR_RootConstrainSelectedInstOperands,
     /* 440359 */     // GIR_Coverage, 8978,
     /* 440359 */     GIR_Done,
     /* 440360 */   // Label 8997: @440360
     /* 440360 */   GIM_Reject,
     /* 440361 */ // Label 8995: @440361
     /* 440361 */ GIM_Reject,
     /* 440362 */ // Label 8967: @440362
     /* 440362 */ GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(440387), // Rule ID 9020 //
     /* 440367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 440373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 440376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440380 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 440380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 440385 */   GIR_RootConstrainSelectedInstOperands,
     /* 440386 */   // GIR_Coverage, 9020,
     /* 440386 */   GIR_Done,
     /* 440387 */ // Label 8998: @440387
     /* 440387 */ GIM_Reject,
     /* 440388 */ // Label 8968: @440388
     /* 440388 */ GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(440413), // Rule ID 8974 //
     /* 440393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 440399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 440402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440406 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 440406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 440411 */   GIR_RootConstrainSelectedInstOperands,
     /* 440412 */   // GIR_Coverage, 8974,
     /* 440412 */   GIR_Done,
     /* 440413 */ // Label 8999: @440413
     /* 440413 */ GIM_Reject,
     /* 440414 */ // Label 8969: @440414
     /* 440414 */ GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(440460),
     /* 440419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 440422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 440425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440429 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(440444), // Rule ID 8971 //
     /* 440434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440437 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 440437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 440442 */     GIR_RootConstrainSelectedInstOperands,
     /* 440443 */     // GIR_Coverage, 8971,
     /* 440443 */     GIR_Done,
     /* 440444 */   // Label 9001: @440444
     /* 440444 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(440459), // Rule ID 8975 //
     /* 440449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440452 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 440452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 440457 */     GIR_RootConstrainSelectedInstOperands,
     /* 440458 */     // GIR_Coverage, 8975,
     /* 440458 */     GIR_Done,
     /* 440459 */   // Label 9002: @440459
     /* 440459 */   GIM_Reject,
     /* 440460 */ // Label 9000: @440460
     /* 440460 */ GIM_Reject,
     /* 440461 */ // Label 8970: @440461
     /* 440461 */ GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(440486), // Rule ID 9019 //
     /* 440466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 440472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 440475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440479 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 440479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 440484 */   GIR_RootConstrainSelectedInstOperands,
     /* 440485 */   // GIR_Coverage, 9019,
     /* 440485 */   GIR_Done,
     /* 440486 */ // Label 9003: @440486
     /* 440486 */ GIM_Reject,
     /* 440487 */ // Label 8971: @440487
     /* 440487 */ GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(440533),
     /* 440492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 440495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 440498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440502 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(440517), // Rule ID 8970 //
     /* 440507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440510 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 440510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 440515 */     GIR_RootConstrainSelectedInstOperands,
     /* 440516 */     // GIR_Coverage, 8970,
     /* 440516 */     GIR_Done,
     /* 440517 */   // Label 9005: @440517
     /* 440517 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(440532), // Rule ID 8973 //
     /* 440522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440525 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 440525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 440530 */     GIR_RootConstrainSelectedInstOperands,
     /* 440531 */     // GIR_Coverage, 8973,
     /* 440531 */     GIR_Done,
     /* 440532 */   // Label 9006: @440532
     /* 440532 */   GIM_Reject,
     /* 440533 */ // Label 9004: @440533
     /* 440533 */ GIM_Reject,
     /* 440534 */ // Label 8972: @440534
     /* 440534 */ GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(440559), // Rule ID 2402 //
     /* 440539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 440545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 440548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440552 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 440552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 440557 */   GIR_RootConstrainSelectedInstOperands,
     /* 440558 */   // GIR_Coverage, 2402,
     /* 440558 */   GIR_Done,
     /* 440559 */ // Label 9007: @440559
     /* 440559 */ GIM_Reject,
     /* 440560 */ // Label 8973: @440560
     /* 440560 */ GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(440585), // Rule ID 8969 //
     /* 440565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 440571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 440574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440578 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 440578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 440583 */   GIR_RootConstrainSelectedInstOperands,
     /* 440584 */   // GIR_Coverage, 8969,
     /* 440584 */   GIR_Done,
     /* 440585 */ // Label 9008: @440585
     /* 440585 */ GIM_Reject,
     /* 440586 */ // Label 8974: @440586
     /* 440586 */ GIM_Reject,
     /* 440587 */ // Label 154: @440587
     /* 440587 */ GIM_Reject,
     /* 440588 */ }; // Size: 440588 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
